#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 10
#define STATE_COUNT 2612
#define SYMBOL_COUNT 298
#define ALIAS_COUNT 8
#define TOKEN_COUNT 140
#define EXTERNAL_TOKEN_COUNT 2
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 9

enum {
  sym_identifier = 1,
  sym_hash_bang_line = 2,
  anon_sym_export = 3,
  anon_sym_STAR = 4,
  anon_sym_default = 5,
  anon_sym_EQ = 6,
  anon_sym_as = 7,
  anon_sym_namespace = 8,
  anon_sym_LBRACE = 9,
  anon_sym_COMMA = 10,
  anon_sym_RBRACE = 11,
  anon_sym_type = 12,
  anon_sym_typeof = 13,
  anon_sym_import = 14,
  anon_sym_from = 15,
  anon_sym_var = 16,
  anon_sym_let = 17,
  anon_sym_const = 18,
  anon_sym_if = 19,
  anon_sym_else = 20,
  anon_sym_switch = 21,
  anon_sym_for = 22,
  anon_sym_LPAREN = 23,
  anon_sym_RPAREN = 24,
  anon_sym_in = 25,
  anon_sym_await = 26,
  anon_sym_of = 27,
  anon_sym_while = 28,
  anon_sym_do = 29,
  anon_sym_try = 30,
  anon_sym_with = 31,
  anon_sym_break = 32,
  anon_sym_continue = 33,
  anon_sym_debugger = 34,
  anon_sym_return = 35,
  anon_sym_throw = 36,
  anon_sym_SEMI = 37,
  anon_sym_COLON = 38,
  anon_sym_case = 39,
  anon_sym_catch = 40,
  anon_sym_finally = 41,
  anon_sym_yield = 42,
  anon_sym_LBRACK = 43,
  anon_sym_RBRACK = 44,
  anon_sym_LT = 45,
  anon_sym_GT = 46,
  anon_sym_SLASH = 47,
  anon_sym_DOT = 48,
  anon_sym_class = 49,
  anon_sym_async = 50,
  anon_sym_function = 51,
  anon_sym_EQ_GT = 52,
  anon_sym_new = 53,
  anon_sym_PLUS_EQ = 54,
  anon_sym_DASH_EQ = 55,
  anon_sym_STAR_EQ = 56,
  anon_sym_SLASH_EQ = 57,
  anon_sym_PERCENT_EQ = 58,
  anon_sym_CARET_EQ = 59,
  anon_sym_AMP_EQ = 60,
  anon_sym_PIPE_EQ = 61,
  anon_sym_GT_GT_EQ = 62,
  anon_sym_GT_GT_GT_EQ = 63,
  anon_sym_LT_LT_EQ = 64,
  anon_sym_STAR_STAR_EQ = 65,
  anon_sym_DOT_DOT_DOT = 66,
  anon_sym_QMARK = 67,
  anon_sym_AMP_AMP = 68,
  anon_sym_PIPE_PIPE = 69,
  anon_sym_GT_GT = 70,
  anon_sym_GT_GT_GT = 71,
  anon_sym_LT_LT = 72,
  anon_sym_AMP = 73,
  anon_sym_CARET = 74,
  anon_sym_PIPE = 75,
  anon_sym_PLUS = 76,
  anon_sym_DASH = 77,
  anon_sym_PERCENT = 78,
  anon_sym_STAR_STAR = 79,
  anon_sym_LT_EQ = 80,
  anon_sym_EQ_EQ = 81,
  anon_sym_EQ_EQ_EQ = 82,
  anon_sym_BANG_EQ = 83,
  anon_sym_BANG_EQ_EQ = 84,
  anon_sym_GT_EQ = 85,
  anon_sym_instanceof = 86,
  anon_sym_BANG = 87,
  anon_sym_TILDE = 88,
  anon_sym_void = 89,
  anon_sym_delete = 90,
  anon_sym_PLUS_PLUS = 91,
  anon_sym_DASH_DASH = 92,
  anon_sym_DQUOTE = 93,
  aux_sym_string_token1 = 94,
  anon_sym_SQUOTE = 95,
  aux_sym_string_token2 = 96,
  sym_escape_sequence = 97,
  sym_comment = 98,
  anon_sym_BQUOTE = 99,
  anon_sym_DOLLAR_LBRACE = 100,
  anon_sym_SLASH2 = 101,
  sym_regex_pattern = 102,
  sym_regex_flags = 103,
  sym_number = 104,
  anon_sym_target = 105,
  anon_sym_this = 106,
  sym_super = 107,
  sym_true = 108,
  sym_false = 109,
  sym_null = 110,
  sym_undefined = 111,
  anon_sym_AT = 112,
  anon_sym_static = 113,
  anon_sym_abstract = 114,
  anon_sym_get = 115,
  anon_sym_set = 116,
  anon_sym_declare = 117,
  anon_sym_public = 118,
  anon_sym_private = 119,
  anon_sym_protected = 120,
  anon_sym_module = 121,
  anon_sym_any = 122,
  anon_sym_number = 123,
  anon_sym_boolean = 124,
  anon_sym_string = 125,
  anon_sym_symbol = 126,
  anon_sym_require = 127,
  anon_sym_implements = 128,
  anon_sym_global = 129,
  anon_sym_interface = 130,
  anon_sym_extends = 131,
  anon_sym_enum = 132,
  sym_readonly = 133,
  anon_sym_is = 134,
  anon_sym_keyof = 135,
  anon_sym_LBRACE_PIPE = 136,
  anon_sym_PIPE_RBRACE = 137,
  sym__automatic_semicolon = 138,
  sym__template_chars = 139,
  sym_program = 140,
  sym_export_statement = 141,
  sym_export_clause = 142,
  sym__import_export_specifier = 143,
  sym__declaration = 144,
  sym_import_statement = 145,
  sym_import_clause = 146,
  sym__from_clause = 147,
  sym_namespace_import = 148,
  sym_named_imports = 149,
  sym_expression_statement = 150,
  sym_variable_declaration = 151,
  sym_lexical_declaration = 152,
  sym_variable_declarator = 153,
  sym_statement_block = 154,
  sym_if_statement = 155,
  sym_switch_statement = 156,
  sym_for_statement = 157,
  sym_for_in_statement = 158,
  sym_for_of_statement = 159,
  sym_while_statement = 160,
  sym_do_statement = 161,
  sym_try_statement = 162,
  sym_with_statement = 163,
  sym_break_statement = 164,
  sym_continue_statement = 165,
  sym_debugger_statement = 166,
  sym_return_statement = 167,
  sym_throw_statement = 168,
  sym_empty_statement = 169,
  sym_labeled_statement = 170,
  sym_switch_body = 171,
  sym_switch_case = 172,
  sym_switch_default = 173,
  sym_catch_clause = 174,
  sym_finally_clause = 175,
  sym_parenthesized_expression = 176,
  sym__expression = 177,
  sym_yield_expression = 178,
  sym_object = 179,
  sym_assignment_pattern = 180,
  sym_array = 181,
  sym_nested_identifier = 182,
  sym_anonymous_class = 183,
  sym_class = 184,
  sym_class_heritage = 185,
  sym_function = 186,
  sym_arrow_function = 187,
  sym_generator_function = 188,
  sym_call_expression = 189,
  sym_new_expression = 190,
  sym_await_expression = 191,
  sym_member_expression = 192,
  sym_subscript_expression = 193,
  sym_assignment_expression = 194,
  sym_augmented_assignment_expression = 195,
  sym__initializer = 196,
  sym_spread_element = 197,
  sym_ternary_expression = 198,
  sym_binary_expression = 199,
  sym_unary_expression = 200,
  sym_update_expression = 201,
  sym_sequence_expression = 202,
  sym_string = 203,
  sym_template_string = 204,
  sym_template_substitution = 205,
  sym_regex = 206,
  sym_meta_property = 207,
  sym_this = 208,
  sym_arguments = 209,
  sym_decorator = 210,
  sym__identifier_reference = 211,
  sym_decorator_member_expression = 212,
  sym_decorator_call_expression = 213,
  sym_class_body = 214,
  sym_public_field_definition = 215,
  sym_formal_parameters = 216,
  sym_rest_parameter = 217,
  sym_method_definition = 218,
  sym_pair = 219,
  sym__property_name = 220,
  sym_computed_property_name = 221,
  sym_non_null_expression = 222,
  sym_method_signature = 223,
  sym_abstract_method_signature = 224,
  sym_function_signature = 225,
  sym_type_assertion = 226,
  sym_as_expression = 227,
  sym_import_require_clause = 228,
  sym_implements_clause = 229,
  sym_ambient_declaration = 230,
  sym_abstract_class = 231,
  sym_module = 232,
  sym_internal_module = 233,
  sym__module = 234,
  sym_import_alias = 235,
  sym_nested_type_identifier = 236,
  sym_interface_declaration = 237,
  sym__type_reference = 238,
  sym_extends_clause = 239,
  sym_enum_declaration = 240,
  sym_enum_body = 241,
  sym__enum_member = 242,
  sym_enum_assignment = 243,
  sym_type_alias_declaration = 244,
  sym_accessibility_modifier = 245,
  sym_required_parameter = 246,
  sym_optional_parameter = 247,
  sym_type_annotation = 248,
  sym__type = 249,
  sym_constructor_type = 250,
  sym__primary_type = 251,
  sym_generic_type = 252,
  sym_type_predicate = 253,
  sym_type_query = 254,
  sym_index_type_query = 255,
  sym_lookup_type = 256,
  sym_mapped_type = 257,
  sym_literal_type = 258,
  sym__number = 259,
  sym_existential_type = 260,
  sym_this_type = 261,
  sym_flow_maybe_type = 262,
  sym_parenthesized_type = 263,
  sym_predefined_type = 264,
  sym_type_arguments = 265,
  sym_object_type = 266,
  sym_property_signature = 267,
  sym_call_signature = 268,
  sym_type_parameters = 269,
  sym_type_parameter = 270,
  sym_default_type = 271,
  sym_constraint = 272,
  sym_construct_signature = 273,
  sym_index_signature = 274,
  sym_array_type = 275,
  sym_tuple_type = 276,
  sym_union_type = 277,
  sym_intersection_type = 278,
  sym_function_type = 279,
  aux_sym_program_repeat1 = 280,
  aux_sym_export_statement_repeat1 = 281,
  aux_sym_export_clause_repeat1 = 282,
  aux_sym_named_imports_repeat1 = 283,
  aux_sym_variable_declaration_repeat1 = 284,
  aux_sym_switch_body_repeat1 = 285,
  aux_sym_object_repeat1 = 286,
  aux_sym_array_repeat1 = 287,
  aux_sym_string_repeat1 = 288,
  aux_sym_string_repeat2 = 289,
  aux_sym_template_string_repeat1 = 290,
  aux_sym_class_body_repeat1 = 291,
  aux_sym_formal_parameters_repeat1 = 292,
  aux_sym_implements_clause_repeat1 = 293,
  aux_sym_extends_clause_repeat1 = 294,
  aux_sym_enum_body_repeat1 = 295,
  aux_sym_object_type_repeat1 = 296,
  aux_sym_type_parameters_repeat1 = 297,
  alias_sym_type_identifier = 298,
  alias_sym_array_pattern = 299,
  alias_sym_shorthand_property_identifier = 300,
  alias_sym_property_identifier = 301,
  alias_sym_object_pattern = 302,
  alias_sym_import_specifier = 303,
  alias_sym_export_specifier = 304,
  alias_sym_statement_identifier = 305,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_identifier] = "identifier",
  [sym_hash_bang_line] = "hash_bang_line",
  [anon_sym_export] = "export",
  [anon_sym_STAR] = "*",
  [anon_sym_default] = "default",
  [anon_sym_EQ] = "=",
  [anon_sym_as] = "as",
  [anon_sym_namespace] = "namespace",
  [anon_sym_LBRACE] = "{",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_type] = "type",
  [anon_sym_typeof] = "typeof",
  [anon_sym_import] = "import",
  [anon_sym_from] = "from",
  [anon_sym_var] = "var",
  [anon_sym_let] = "let",
  [anon_sym_const] = "const",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_switch] = "switch",
  [anon_sym_for] = "for",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_in] = "in",
  [anon_sym_await] = "await",
  [anon_sym_of] = "of",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_try] = "try",
  [anon_sym_with] = "with",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_debugger] = "debugger",
  [anon_sym_return] = "return",
  [anon_sym_throw] = "throw",
  [anon_sym_SEMI] = ";",
  [anon_sym_COLON] = ":",
  [anon_sym_case] = "case",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_SLASH] = "/",
  [anon_sym_DOT] = ".",
  [anon_sym_class] = "class",
  [anon_sym_async] = "async",
  [anon_sym_function] = "function",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_new] = "new",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_GT_GT_GT_EQ] = ">>>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_QMARK] = "?",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_GT_GT_GT] = ">>>",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_BANG_EQ_EQ] = "!==",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_instanceof] = "instanceof",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_void] = "void",
  [anon_sym_delete] = "delete",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_string_token1] = "string_token1",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_string_token2] = "string_token2",
  [sym_escape_sequence] = "escape_sequence",
  [sym_comment] = "comment",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH2] = "/",
  [sym_regex_pattern] = "regex_pattern",
  [sym_regex_flags] = "regex_flags",
  [sym_number] = "number",
  [anon_sym_target] = "target",
  [anon_sym_this] = "this",
  [sym_super] = "super",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_null] = "null",
  [sym_undefined] = "undefined",
  [anon_sym_AT] = "@",
  [anon_sym_static] = "static",
  [anon_sym_abstract] = "abstract",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_declare] = "declare",
  [anon_sym_public] = "public",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_module] = "module",
  [anon_sym_any] = "any",
  [anon_sym_number] = "number",
  [anon_sym_boolean] = "boolean",
  [anon_sym_string] = "string",
  [anon_sym_symbol] = "symbol",
  [anon_sym_require] = "require",
  [anon_sym_implements] = "implements",
  [anon_sym_global] = "global",
  [anon_sym_interface] = "interface",
  [anon_sym_extends] = "extends",
  [anon_sym_enum] = "enum",
  [sym_readonly] = "readonly",
  [anon_sym_is] = "is",
  [anon_sym_keyof] = "keyof",
  [anon_sym_LBRACE_PIPE] = "{|",
  [anon_sym_PIPE_RBRACE] = "|}",
  [sym__automatic_semicolon] = "_automatic_semicolon",
  [sym__template_chars] = "_template_chars",
  [sym_program] = "program",
  [sym_export_statement] = "export_statement",
  [sym_export_clause] = "export_clause",
  [sym__import_export_specifier] = "_import_export_specifier",
  [sym__declaration] = "_declaration",
  [sym_import_statement] = "import_statement",
  [sym_import_clause] = "import_clause",
  [sym__from_clause] = "_from_clause",
  [sym_namespace_import] = "namespace_import",
  [sym_named_imports] = "named_imports",
  [sym_expression_statement] = "expression_statement",
  [sym_variable_declaration] = "variable_declaration",
  [sym_lexical_declaration] = "lexical_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_statement_block] = "statement_block",
  [sym_if_statement] = "if_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_in_statement] = "for_in_statement",
  [sym_for_of_statement] = "for_of_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_statement] = "do_statement",
  [sym_try_statement] = "try_statement",
  [sym_with_statement] = "with_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_debugger_statement] = "debugger_statement",
  [sym_return_statement] = "return_statement",
  [sym_throw_statement] = "throw_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_case] = "switch_case",
  [sym_switch_default] = "switch_default",
  [sym_catch_clause] = "catch_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym__expression] = "_expression",
  [sym_yield_expression] = "yield_expression",
  [sym_object] = "object",
  [sym_assignment_pattern] = "assignment_pattern",
  [sym_array] = "array",
  [sym_nested_identifier] = "nested_identifier",
  [sym_anonymous_class] = "anonymous_class",
  [sym_class] = "class",
  [sym_class_heritage] = "class_heritage",
  [sym_function] = "function",
  [sym_arrow_function] = "arrow_function",
  [sym_generator_function] = "generator_function",
  [sym_call_expression] = "call_expression",
  [sym_new_expression] = "new_expression",
  [sym_await_expression] = "await_expression",
  [sym_member_expression] = "member_expression",
  [sym_subscript_expression] = "subscript_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_augmented_assignment_expression] = "augmented_assignment_expression",
  [sym__initializer] = "_initializer",
  [sym_spread_element] = "spread_element",
  [sym_ternary_expression] = "ternary_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_update_expression] = "update_expression",
  [sym_sequence_expression] = "sequence_expression",
  [sym_string] = "string",
  [sym_template_string] = "template_string",
  [sym_template_substitution] = "template_substitution",
  [sym_regex] = "regex",
  [sym_meta_property] = "meta_property",
  [sym_this] = "this",
  [sym_arguments] = "arguments",
  [sym_decorator] = "decorator",
  [sym__identifier_reference] = "_identifier_reference",
  [sym_decorator_member_expression] = "member_expression",
  [sym_decorator_call_expression] = "call_expression",
  [sym_class_body] = "class_body",
  [sym_public_field_definition] = "public_field_definition",
  [sym_formal_parameters] = "formal_parameters",
  [sym_rest_parameter] = "rest_parameter",
  [sym_method_definition] = "method_definition",
  [sym_pair] = "pair",
  [sym__property_name] = "_property_name",
  [sym_computed_property_name] = "computed_property_name",
  [sym_non_null_expression] = "non_null_expression",
  [sym_method_signature] = "method_signature",
  [sym_abstract_method_signature] = "abstract_method_signature",
  [sym_function_signature] = "function_signature",
  [sym_type_assertion] = "type_assertion",
  [sym_as_expression] = "as_expression",
  [sym_import_require_clause] = "import_require_clause",
  [sym_implements_clause] = "implements_clause",
  [sym_ambient_declaration] = "ambient_declaration",
  [sym_abstract_class] = "abstract_class",
  [sym_module] = "module",
  [sym_internal_module] = "internal_module",
  [sym__module] = "_module",
  [sym_import_alias] = "import_alias",
  [sym_nested_type_identifier] = "nested_type_identifier",
  [sym_interface_declaration] = "interface_declaration",
  [sym__type_reference] = "_type_reference",
  [sym_extends_clause] = "extends_clause",
  [sym_enum_declaration] = "enum_declaration",
  [sym_enum_body] = "enum_body",
  [sym__enum_member] = "_enum_member",
  [sym_enum_assignment] = "enum_assignment",
  [sym_type_alias_declaration] = "type_alias_declaration",
  [sym_accessibility_modifier] = "accessibility_modifier",
  [sym_required_parameter] = "required_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym_type_annotation] = "type_annotation",
  [sym__type] = "_type",
  [sym_constructor_type] = "constructor_type",
  [sym__primary_type] = "_primary_type",
  [sym_generic_type] = "generic_type",
  [sym_type_predicate] = "type_predicate",
  [sym_type_query] = "type_query",
  [sym_index_type_query] = "index_type_query",
  [sym_lookup_type] = "lookup_type",
  [sym_mapped_type] = "mapped_type",
  [sym_literal_type] = "literal_type",
  [sym__number] = "unary_expression",
  [sym_existential_type] = "existential_type",
  [sym_this_type] = "this_type",
  [sym_flow_maybe_type] = "flow_maybe_type",
  [sym_parenthesized_type] = "parenthesized_type",
  [sym_predefined_type] = "predefined_type",
  [sym_type_arguments] = "type_arguments",
  [sym_object_type] = "object_type",
  [sym_property_signature] = "property_signature",
  [sym_call_signature] = "call_signature",
  [sym_type_parameters] = "type_parameters",
  [sym_type_parameter] = "type_parameter",
  [sym_default_type] = "default_type",
  [sym_constraint] = "constraint",
  [sym_construct_signature] = "construct_signature",
  [sym_index_signature] = "index_signature",
  [sym_array_type] = "array_type",
  [sym_tuple_type] = "tuple_type",
  [sym_union_type] = "union_type",
  [sym_intersection_type] = "intersection_type",
  [sym_function_type] = "function_type",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_export_statement_repeat1] = "export_statement_repeat1",
  [aux_sym_export_clause_repeat1] = "export_clause_repeat1",
  [aux_sym_named_imports_repeat1] = "named_imports_repeat1",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_object_repeat1] = "object_repeat1",
  [aux_sym_array_repeat1] = "array_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_string_repeat2] = "string_repeat2",
  [aux_sym_template_string_repeat1] = "template_string_repeat1",
  [aux_sym_class_body_repeat1] = "class_body_repeat1",
  [aux_sym_formal_parameters_repeat1] = "formal_parameters_repeat1",
  [aux_sym_implements_clause_repeat1] = "implements_clause_repeat1",
  [aux_sym_extends_clause_repeat1] = "extends_clause_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_object_type_repeat1] = "object_type_repeat1",
  [aux_sym_type_parameters_repeat1] = "type_parameters_repeat1",
  [alias_sym_type_identifier] = "type_identifier",
  [alias_sym_array_pattern] = "array_pattern",
  [alias_sym_shorthand_property_identifier] = "shorthand_property_identifier",
  [alias_sym_property_identifier] = "property_identifier",
  [alias_sym_object_pattern] = "object_pattern",
  [alias_sym_import_specifier] = "import_specifier",
  [alias_sym_export_specifier] = "export_specifier",
  [alias_sym_statement_identifier] = "statement_identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_bang_line] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_of] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_debugger] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_instanceof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_void] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delete] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_string_token2] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH2] = {
    .visible = true,
    .named = false,
  },
  [sym_regex_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_regex_flags] = {
    .visible = true,
    .named = true,
  },
  [sym_number] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_target] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_this] = {
    .visible = true,
    .named = false,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_null] = {
    .visible = true,
    .named = true,
  },
  [sym_undefined] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_any] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_number] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_boolean] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_string] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_symbol] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_require] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implements] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_extends] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [sym_readonly] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_keyof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__automatic_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__template_chars] = {
    .visible = false,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym_export_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_export_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__import_export_specifier] = {
    .visible = false,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__from_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_import] = {
    .visible = true,
    .named = true,
  },
  [sym_named_imports] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_lexical_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_statement_block] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_of_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_debugger_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_case] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_default] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_yield_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_heritage] = {
    .visible = true,
    .named = true,
  },
  [sym_function] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_function] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_function] = {
    .visible = true,
    .named = true,
  },
  [sym_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_new_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__initializer] = {
    .visible = false,
    .named = true,
  },
  [sym_spread_element] = {
    .visible = true,
    .named = true,
  },
  [sym_ternary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_update_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_sequence_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_string] = {
    .visible = true,
    .named = true,
  },
  [sym_template_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_meta_property] = {
    .visible = true,
    .named = true,
  },
  [sym_this] = {
    .visible = true,
    .named = true,
  },
  [sym_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier_reference] = {
    .visible = false,
    .named = true,
  },
  [sym_decorator_member_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator_call_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_class_body] = {
    .visible = true,
    .named = true,
  },
  [sym_public_field_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_formal_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_method_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym__property_name] = {
    .visible = false,
    .named = true,
  },
  [sym_computed_property_name] = {
    .visible = true,
    .named = true,
  },
  [sym_non_null_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_method_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_function_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_import_require_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_implements_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_ambient_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_abstract_class] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_internal_module] = {
    .visible = true,
    .named = true,
  },
  [sym__module] = {
    .visible = false,
    .named = true,
  },
  [sym_import_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_nested_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__type_reference] = {
    .visible = false,
    .named = true,
  },
  [sym_extends_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym__enum_member] = {
    .visible = false,
    .named = true,
  },
  [sym_enum_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_type_alias_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessibility_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_required_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type_annotation] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_type] = {
    .visible = true,
    .named = true,
  },
  [sym__primary_type] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_predicate] = {
    .visible = true,
    .named = true,
  },
  [sym_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_index_type_query] = {
    .visible = true,
    .named = true,
  },
  [sym_lookup_type] = {
    .visible = true,
    .named = true,
  },
  [sym_mapped_type] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_type] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = true,
    .named = true,
  },
  [sym_existential_type] = {
    .visible = true,
    .named = true,
  },
  [sym_this_type] = {
    .visible = true,
    .named = true,
  },
  [sym_flow_maybe_type] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_arguments] = {
    .visible = true,
    .named = true,
  },
  [sym_object_type] = {
    .visible = true,
    .named = true,
  },
  [sym_property_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_call_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_default_type] = {
    .visible = true,
    .named = true,
  },
  [sym_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_construct_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_index_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_union_type] = {
    .visible = true,
    .named = true,
  },
  [sym_intersection_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_type] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_export_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_named_imports_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_template_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_class_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_formal_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_implements_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_extends_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_object_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_type_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_array_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_shorthand_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_property_identifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_object_pattern] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_import_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_export_specifier] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_statement_identifier] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[27][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = sym_identifier,
  },
  [2] = {
    [0] = alias_sym_property_identifier,
  },
  [3] = {
    [0] = alias_sym_object_pattern,
  },
  [4] = {
    [0] = alias_sym_array_pattern,
  },
  [5] = {
    [0] = alias_sym_type_identifier,
  },
  [6] = {
    [1] = sym_identifier,
  },
  [7] = {
    [0] = alias_sym_statement_identifier,
  },
  [8] = {
    [2] = alias_sym_property_identifier,
  },
  [9] = {
    [0] = sym_identifier,
    [2] = alias_sym_property_identifier,
  },
  [10] = {
    [1] = alias_sym_statement_identifier,
  },
  [11] = {
    [1] = alias_sym_type_identifier,
  },
  [12] = {
    [1] = alias_sym_shorthand_property_identifier,
  },
  [13] = {
    [0] = alias_sym_shorthand_property_identifier,
  },
  [14] = {
    [1] = alias_sym_array_pattern,
  },
  [15] = {
    [1] = alias_sym_object_pattern,
  },
  [16] = {
    [2] = alias_sym_type_identifier,
  },
  [17] = {
    [1] = alias_sym_import_specifier,
  },
  [18] = {
    [2] = sym_identifier,
  },
  [19] = {
    [2] = alias_sym_array_pattern,
  },
  [20] = {
    [2] = alias_sym_object_pattern,
  },
  [21] = {
    [1] = alias_sym_export_specifier,
  },
  [22] = {
    [3] = alias_sym_property_identifier,
  },
  [23] = {
    [3] = alias_sym_array_pattern,
  },
  [24] = {
    [3] = alias_sym_object_pattern,
  },
  [25] = {
    [4] = alias_sym_array_pattern,
  },
  [26] = {
    [4] = alias_sym_object_pattern,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(15);
      if (lookahead == '/')
        ADVANCE(16);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '\\')
        ADVANCE(26);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(34);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0)
        ADVANCE(36);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(37);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 4:
      if (lookahead == '!')
        ADVANCE(38);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '{')
        ADVANCE(39);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '|' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279)
        ADVANCE(36);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(40);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(41);
      if (lookahead == '=')
        ADVANCE(42);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(43);
      if (lookahead == '=')
        ADVANCE(44);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(45);
      if (lookahead == '=')
        ADVANCE(46);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(47);
      if (lookahead == '=')
        ADVANCE(48);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(50);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_SLASH2);
      if (lookahead == '*')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(52);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.')
        ADVANCE(50);
      if (lookahead == '0')
        ADVANCE(53);
      if (lookahead == 'B' ||
          lookahead == 'b')
        ADVANCE(54);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(55);
      if (lookahead == 'O' ||
          lookahead == 'o')
        ADVANCE(56);
      if (lookahead == 'X' ||
          lookahead == 'x')
        ADVANCE(57);
      if (lookahead == 'n')
        ADVANCE(58);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '=')
        ADVANCE(60);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(61);
      if (lookahead == '>')
        ADVANCE(62);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(64);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 26:
      if (lookahead == 'u')
        ADVANCE(65);
      if (lookahead == 'x')
        ADVANCE(66);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(67);
      if (lookahead != 0)
        ADVANCE(68);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(69);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '|')
        ADVANCE(70);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(71);
      if (lookahead == '|')
        ADVANCE(72);
      if (lookahead == '}')
        ADVANCE(73);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 34:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(15);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(34);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\\')
        ADVANCE(36);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '.')
        ADVANCE(50);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(55);
      if (lookahead == 'n')
        ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279)
        ADVANCE(36);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '=')
        ADVANCE(75);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_hash_bang_line);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(38);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=')
        ADVANCE(76);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 49:
      if (lookahead == '.')
        ADVANCE(77);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(55);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(50);
      END_STATE();
    case 51:
      if (lookahead == '*')
        ADVANCE(78);
      if (lookahead != 0)
        ADVANCE(51);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(52);
      END_STATE();
    case 53:
      if (lookahead == 'n')
        ADVANCE(58);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(53);
      END_STATE();
    case 54:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(79);
      END_STATE();
    case 55:
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(81);
      END_STATE();
    case 56:
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(82);
      END_STATE();
    case 57:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(83);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_number);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(84);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=')
        ADVANCE(85);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(86);
      if (lookahead == '>')
        ADVANCE(87);
      END_STATE();
    case 65:
      if (lookahead == '{')
        ADVANCE(88);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(89);
      END_STATE();
    case 66:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(90);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(91);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_LBRACE_PIPE);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_PIPE_RBRACE);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(52);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_BANG_EQ_EQ);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 78:
      if (lookahead == '*')
        ADVANCE(78);
      if (lookahead == '/')
        ADVANCE(92);
      if (lookahead != 0)
        ADVANCE(51);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_number);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(79);
      END_STATE();
    case 80:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(81);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(81);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(82);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_number);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(83);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      if (lookahead == '=')
        ADVANCE(93);
      END_STATE();
    case 88:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(94);
      END_STATE();
    case 89:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(66);
      END_STATE();
    case 90:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(68);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(68);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT_EQ);
      END_STATE();
    case 94:
      if (lookahead == '}')
        ADVANCE(68);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(94);
      END_STATE();
    case 95:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(99);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(95);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(45);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(47);
      END_STATE();
    case 99:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(50);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 102:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(105);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(102);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '\\' &&
          lookahead != ']')
        ADVANCE(36);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(50);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(52);
      if (lookahead == '=')
        ADVANCE(106);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(71);
      if (lookahead == '|')
        ADVANCE(72);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 107:
      if (lookahead == '$')
        ADVANCE(108);
      if (lookahead == '/')
        ADVANCE(109);
      if (lookahead == '\\')
        ADVANCE(26);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(110);
      END_STATE();
    case 108:
      if (lookahead == '{')
        ADVANCE(39);
      END_STATE();
    case 109:
      if (lookahead == '*')
        ADVANCE(51);
      if (lookahead == '/')
        ADVANCE(52);
      END_STATE();
    case 110:
      if (lookahead == '$')
        ADVANCE(108);
      if (lookahead == '/')
        ADVANCE(109);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(110);
      END_STATE();
    case 111:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(112);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(114);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(115);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(116);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(117);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(118);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(111);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '\\' &&
          lookahead != ']')
        ADVANCE(36);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(41);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(119);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(120);
      if (lookahead == '=')
        ADVANCE(60);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(121);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(72);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '>')
        ADVANCE(122);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_GT_GT_GT);
      END_STATE();
    case 123:
      if (lookahead == '\n')
        SKIP(124);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '/')
        ADVANCE(125);
      if (lookahead == '\\')
        ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(126);
      if (lookahead != 0)
        ADVANCE(127);
      END_STATE();
    case 124:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '/')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(124);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*')
        ADVANCE(128);
      if (lookahead == '/')
        ADVANCE(127);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(127);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '/')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(126);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(127);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(127);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*')
        ADVANCE(129);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(128);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead == '*')
        ADVANCE(129);
      if (lookahead == '/')
        ADVANCE(130);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(128);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(aux_sym_string_token1);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\')
        ADVANCE(127);
      END_STATE();
    case 131:
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(132);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(133);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(15);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(134);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(131);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 135:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(132);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(133);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(137);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(134);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(135);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != '%' &&
          (lookahead < '\\' || '^' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>')
        ADVANCE(62);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 138:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(132);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(133);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(15);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(139);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(138);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '}')
        ADVANCE(73);
      END_STATE();
    case 140:
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(132);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(133);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(141);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(134);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(140);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 141:
      if (lookahead == '.')
        ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(50);
      END_STATE();
    case 142:
      if (lookahead == '\n')
        SKIP(143);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '/')
        ADVANCE(144);
      if (lookahead == '\\')
        ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(145);
      if (lookahead != 0)
        ADVANCE(146);
      END_STATE();
    case 143:
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '/')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*')
        ADVANCE(147);
      if (lookahead == '/')
        ADVANCE(146);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(146);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '/')
        ADVANCE(144);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(145);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(146);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(146);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*')
        ADVANCE(148);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(147);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead == '*')
        ADVANCE(148);
      if (lookahead == '/')
        ADVANCE(149);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(147);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(aux_sym_string_token2);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\'' &&
          lookahead != '\\')
        ADVANCE(146);
      END_STATE();
    case 150:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(132);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(133);
      if (lookahead == '+')
        ADVANCE(151);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '.')
        ADVANCE(141);
      if (lookahead == '/')
        ADVANCE(109);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(134);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(150);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '>' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 153:
      if (lookahead == '\n')
        SKIP(154);
      if (lookahead == '/')
        ADVANCE(109);
      if (lookahead == '[')
        ADVANCE(155);
      if (lookahead == '\\')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(157);
      if (lookahead != 0)
        ADVANCE(158);
      END_STATE();
    case 154:
      if (lookahead == '/')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(154);
      END_STATE();
    case 155:
      if (lookahead == '\\')
        ADVANCE(159);
      if (lookahead == ']')
        ADVANCE(158);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(155);
      END_STATE();
    case 156:
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(158);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '/')
        ADVANCE(109);
      if (lookahead == '[')
        ADVANCE(155);
      if (lookahead == '\\')
        ADVANCE(156);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        ADVANCE(157);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(158);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_regex_pattern);
      if (lookahead == '[')
        ADVANCE(155);
      if (lookahead == '\\')
        ADVANCE(156);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '/')
        ADVANCE(158);
      END_STATE();
    case 159:
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(155);
      END_STATE();
    case 160:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(112);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(114);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(115);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(116);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(117);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(162);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(160);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != ')' &&
          lookahead != '\\' &&
          lookahead != ']')
        ADVANCE(36);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(61);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(72);
      if (lookahead == '}')
        ADVANCE(73);
      END_STATE();
    case 163:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(112);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(114);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(164);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(115);
      if (lookahead == '=')
        ADVANCE(165);
      if (lookahead == '>')
        ADVANCE(116);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(117);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(162);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(163);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != ']' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 165:
      if (lookahead == '=')
        ADVANCE(61);
      END_STATE();
    case 166:
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(141);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(166);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '|' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 167:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(112);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(114);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(115);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(116);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(117);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(118);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(167);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 168:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(168);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != ')' &&
          lookahead != '\\' &&
          lookahead != ']')
        ADVANCE(36);
      END_STATE();
    case 169:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(105);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(169);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != ';' &&
          lookahead != '\\' &&
          lookahead != ']' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 170:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(112);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(114);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(164);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(115);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(116);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(117);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '|')
        ADVANCE(118);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(170);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != ']' &&
          (lookahead < '{' || '~' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 171:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(132);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(137);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(134);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(171);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '*' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 172:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(132);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(133);
      if (lookahead == '+')
        ADVANCE(151);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(152);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(109);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(137);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(134);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(172);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 173:
      if (lookahead == '/')
        ADVANCE(16);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(154);
      END_STATE();
    case 174:
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(132);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(133);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(109);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(175);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(139);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(174);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '>' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 176:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(112);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(114);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(115);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(116);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(117);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(118);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(176);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != ';' &&
          lookahead != '\\')
        ADVANCE(36);
      END_STATE();
    case 177:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(112);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(114);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(115);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(116);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(117);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(118);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(177);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != ';' &&
          lookahead != '\\' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 178:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(96);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '&')
        ADVANCE(132);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(99);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(136);
      if (lookahead == '>')
        ADVANCE(137);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(134);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(178);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < '%' || '?' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead))
        ADVANCE(36);
      END_STATE();
    case 179:
      if (lookahead == '&')
        ADVANCE(132);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '.')
        ADVANCE(164);
      if (lookahead == '/')
        ADVANCE(109);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(100);
      if (lookahead == '=')
        ADVANCE(136);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(134);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(179);
      if (lookahead != 0 &&
          (lookahead < '!' || '#' < lookahead) &&
          (lookahead < '%' || '@' < lookahead) &&
          (lookahead < '\\' || '^' < lookahead) &&
          lookahead != '`' &&
          lookahead != '}' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 180:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(112);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(114);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(164);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(115);
      if (lookahead == '=')
        ADVANCE(165);
      if (lookahead == '>')
        ADVANCE(116);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(117);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(118);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(181);
      if (('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != ']' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 181:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(112);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(114);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(164);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ';')
        ADVANCE(19);
      if (lookahead == '<')
        ADVANCE(115);
      if (lookahead == '=')
        ADVANCE(165);
      if (lookahead == '>')
        ADVANCE(116);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == '^')
        ADVANCE(117);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(118);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(181);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != ']' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_regex_flags);
      if (('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || '#' < lookahead) &&
          (lookahead < '%' || '/' < lookahead) &&
          (lookahead < ':' || '@' < lookahead) &&
          (lookahead < '[' || '^' < lookahead) &&
          (lookahead < '`' || '~' < lookahead) &&
          lookahead != 160 &&
          lookahead != 8203 &&
          lookahead != 8288 &&
          lookahead != 65279)
        ADVANCE(36);
      END_STATE();
    case 183:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(105);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(183);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          (lookahead < ')' || ';' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    case 184:
      if (lookahead == '&')
        ADVANCE(132);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(109);
      if (lookahead == '>')
        ADVANCE(137);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(134);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(184);
      END_STATE();
    case 185:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(105);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(185);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != ';' &&
          lookahead != '\\')
        ADVANCE(36);
      END_STATE();
    case 186:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(112);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(114);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(164);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(115);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(116);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(117);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(118);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(186);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || ';' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 187:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(164);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(105);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(187);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 188:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(112);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(114);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(164);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(115);
      if (lookahead == '=')
        ADVANCE(165);
      if (lookahead == '>')
        ADVANCE(116);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(117);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(118);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(189);
      if (('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(182);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 189:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '%')
        ADVANCE(112);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(114);
      if (lookahead == '+')
        ADVANCE(97);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(98);
      if (lookahead == '.')
        ADVANCE(164);
      if (lookahead == '/')
        ADVANCE(74);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(115);
      if (lookahead == '=')
        ADVANCE(165);
      if (lookahead == '>')
        ADVANCE(116);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(117);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(118);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(189);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '#' &&
          (lookahead < '\'' || '@' < lookahead) &&
          lookahead != '\\' &&
          lookahead != '~')
        ADVANCE(36);
      END_STATE();
    case 190:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == ',')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(14);
      if (lookahead == '.')
        ADVANCE(103);
      if (lookahead == '/')
        ADVANCE(104);
      if (lookahead == '0')
        ADVANCE(17);
      if (lookahead == ':')
        ADVANCE(18);
      if (lookahead == '<')
        ADVANCE(20);
      if (lookahead == '=')
        ADVANCE(21);
      if (lookahead == '>')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(23);
      if (lookahead == '@')
        ADVANCE(24);
      if (lookahead == '[')
        ADVANCE(25);
      if (lookahead == ']')
        ADVANCE(27);
      if (lookahead == '^')
        ADVANCE(28);
      if (lookahead == '`')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(101);
      if (lookahead == '|')
        ADVANCE(105);
      if (lookahead == '~')
        ADVANCE(33);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(190);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '#' &&
          lookahead != ';' &&
          lookahead != '\\' &&
          lookahead != '}')
        ADVANCE(36);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'a')
        ADVANCE(1);
      if (lookahead == 'b')
        ADVANCE(2);
      if (lookahead == 'c')
        ADVANCE(3);
      if (lookahead == 'd')
        ADVANCE(4);
      if (lookahead == 'e')
        ADVANCE(5);
      if (lookahead == 'f')
        ADVANCE(6);
      if (lookahead == 'g')
        ADVANCE(7);
      if (lookahead == 'i')
        ADVANCE(8);
      if (lookahead == 'k')
        ADVANCE(9);
      if (lookahead == 'l')
        ADVANCE(10);
      if (lookahead == 'm')
        ADVANCE(11);
      if (lookahead == 'n')
        ADVANCE(12);
      if (lookahead == 'o')
        ADVANCE(13);
      if (lookahead == 'p')
        ADVANCE(14);
      if (lookahead == 'r')
        ADVANCE(15);
      if (lookahead == 's')
        ADVANCE(16);
      if (lookahead == 't')
        ADVANCE(17);
      if (lookahead == 'u')
        ADVANCE(18);
      if (lookahead == 'v')
        ADVANCE(19);
      if (lookahead == 'w')
        ADVANCE(20);
      if (lookahead == 'y')
        ADVANCE(21);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == 'b')
        ADVANCE(22);
      if (lookahead == 'n')
        ADVANCE(23);
      if (lookahead == 's')
        ADVANCE(24);
      if (lookahead == 'w')
        ADVANCE(25);
      END_STATE();
    case 2:
      if (lookahead == 'o')
        ADVANCE(26);
      if (lookahead == 'r')
        ADVANCE(27);
      END_STATE();
    case 3:
      if (lookahead == 'a')
        ADVANCE(28);
      if (lookahead == 'l')
        ADVANCE(29);
      if (lookahead == 'o')
        ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'e')
        ADVANCE(31);
      if (lookahead == 'o')
        ADVANCE(32);
      END_STATE();
    case 5:
      if (lookahead == 'l')
        ADVANCE(33);
      if (lookahead == 'n')
        ADVANCE(34);
      if (lookahead == 'x')
        ADVANCE(35);
      END_STATE();
    case 6:
      if (lookahead == 'a')
        ADVANCE(36);
      if (lookahead == 'i')
        ADVANCE(37);
      if (lookahead == 'o')
        ADVANCE(38);
      if (lookahead == 'r')
        ADVANCE(39);
      if (lookahead == 'u')
        ADVANCE(40);
      END_STATE();
    case 7:
      if (lookahead == 'e')
        ADVANCE(41);
      if (lookahead == 'l')
        ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'f')
        ADVANCE(43);
      if (lookahead == 'm')
        ADVANCE(44);
      if (lookahead == 'n')
        ADVANCE(45);
      if (lookahead == 's')
        ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e')
        ADVANCE(47);
      END_STATE();
    case 10:
      if (lookahead == 'e')
        ADVANCE(48);
      END_STATE();
    case 11:
      if (lookahead == 'o')
        ADVANCE(49);
      END_STATE();
    case 12:
      if (lookahead == 'a')
        ADVANCE(50);
      if (lookahead == 'e')
        ADVANCE(51);
      if (lookahead == 'u')
        ADVANCE(52);
      END_STATE();
    case 13:
      if (lookahead == 'f')
        ADVANCE(53);
      END_STATE();
    case 14:
      if (lookahead == 'r')
        ADVANCE(54);
      if (lookahead == 'u')
        ADVANCE(55);
      END_STATE();
    case 15:
      if (lookahead == 'e')
        ADVANCE(56);
      END_STATE();
    case 16:
      if (lookahead == 'e')
        ADVANCE(57);
      if (lookahead == 't')
        ADVANCE(58);
      if (lookahead == 'u')
        ADVANCE(59);
      if (lookahead == 'w')
        ADVANCE(60);
      if (lookahead == 'y')
        ADVANCE(61);
      END_STATE();
    case 17:
      if (lookahead == 'a')
        ADVANCE(62);
      if (lookahead == 'h')
        ADVANCE(63);
      if (lookahead == 'r')
        ADVANCE(64);
      if (lookahead == 'y')
        ADVANCE(65);
      END_STATE();
    case 18:
      if (lookahead == 'n')
        ADVANCE(66);
      END_STATE();
    case 19:
      if (lookahead == 'a')
        ADVANCE(67);
      if (lookahead == 'o')
        ADVANCE(68);
      END_STATE();
    case 20:
      if (lookahead == 'h')
        ADVANCE(69);
      if (lookahead == 'i')
        ADVANCE(70);
      END_STATE();
    case 21:
      if (lookahead == 'i')
        ADVANCE(71);
      END_STATE();
    case 22:
      if (lookahead == 's')
        ADVANCE(72);
      END_STATE();
    case 23:
      if (lookahead == 'y')
        ADVANCE(73);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'y')
        ADVANCE(74);
      END_STATE();
    case 25:
      if (lookahead == 'a')
        ADVANCE(75);
      END_STATE();
    case 26:
      if (lookahead == 'o')
        ADVANCE(76);
      END_STATE();
    case 27:
      if (lookahead == 'e')
        ADVANCE(77);
      END_STATE();
    case 28:
      if (lookahead == 's')
        ADVANCE(78);
      if (lookahead == 't')
        ADVANCE(79);
      END_STATE();
    case 29:
      if (lookahead == 'a')
        ADVANCE(80);
      END_STATE();
    case 30:
      if (lookahead == 'n')
        ADVANCE(81);
      END_STATE();
    case 31:
      if (lookahead == 'b')
        ADVANCE(82);
      if (lookahead == 'c')
        ADVANCE(83);
      if (lookahead == 'f')
        ADVANCE(84);
      if (lookahead == 'l')
        ADVANCE(85);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 33:
      if (lookahead == 's')
        ADVANCE(86);
      END_STATE();
    case 34:
      if (lookahead == 'u')
        ADVANCE(87);
      END_STATE();
    case 35:
      if (lookahead == 'p')
        ADVANCE(88);
      if (lookahead == 't')
        ADVANCE(89);
      END_STATE();
    case 36:
      if (lookahead == 'l')
        ADVANCE(90);
      END_STATE();
    case 37:
      if (lookahead == 'n')
        ADVANCE(91);
      END_STATE();
    case 38:
      if (lookahead == 'r')
        ADVANCE(92);
      END_STATE();
    case 39:
      if (lookahead == 'o')
        ADVANCE(93);
      END_STATE();
    case 40:
      if (lookahead == 'n')
        ADVANCE(94);
      END_STATE();
    case 41:
      if (lookahead == 't')
        ADVANCE(95);
      END_STATE();
    case 42:
      if (lookahead == 'o')
        ADVANCE(96);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 44:
      if (lookahead == 'p')
        ADVANCE(97);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 's')
        ADVANCE(98);
      if (lookahead == 't')
        ADVANCE(99);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 47:
      if (lookahead == 'y')
        ADVANCE(100);
      END_STATE();
    case 48:
      if (lookahead == 't')
        ADVANCE(101);
      END_STATE();
    case 49:
      if (lookahead == 'd')
        ADVANCE(102);
      END_STATE();
    case 50:
      if (lookahead == 'm')
        ADVANCE(103);
      END_STATE();
    case 51:
      if (lookahead == 'w')
        ADVANCE(104);
      END_STATE();
    case 52:
      if (lookahead == 'l')
        ADVANCE(105);
      if (lookahead == 'm')
        ADVANCE(106);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_of);
      END_STATE();
    case 54:
      if (lookahead == 'i')
        ADVANCE(107);
      if (lookahead == 'o')
        ADVANCE(108);
      END_STATE();
    case 55:
      if (lookahead == 'b')
        ADVANCE(109);
      END_STATE();
    case 56:
      if (lookahead == 'a')
        ADVANCE(110);
      if (lookahead == 'q')
        ADVANCE(111);
      if (lookahead == 't')
        ADVANCE(112);
      END_STATE();
    case 57:
      if (lookahead == 't')
        ADVANCE(113);
      END_STATE();
    case 58:
      if (lookahead == 'a')
        ADVANCE(114);
      if (lookahead == 'r')
        ADVANCE(115);
      END_STATE();
    case 59:
      if (lookahead == 'p')
        ADVANCE(116);
      END_STATE();
    case 60:
      if (lookahead == 'i')
        ADVANCE(117);
      END_STATE();
    case 61:
      if (lookahead == 'm')
        ADVANCE(118);
      END_STATE();
    case 62:
      if (lookahead == 'r')
        ADVANCE(119);
      END_STATE();
    case 63:
      if (lookahead == 'i')
        ADVANCE(120);
      if (lookahead == 'r')
        ADVANCE(121);
      END_STATE();
    case 64:
      if (lookahead == 'u')
        ADVANCE(122);
      if (lookahead == 'y')
        ADVANCE(123);
      END_STATE();
    case 65:
      if (lookahead == 'p')
        ADVANCE(124);
      END_STATE();
    case 66:
      if (lookahead == 'd')
        ADVANCE(125);
      END_STATE();
    case 67:
      if (lookahead == 'r')
        ADVANCE(126);
      END_STATE();
    case 68:
      if (lookahead == 'i')
        ADVANCE(127);
      END_STATE();
    case 69:
      if (lookahead == 'i')
        ADVANCE(128);
      END_STATE();
    case 70:
      if (lookahead == 't')
        ADVANCE(129);
      END_STATE();
    case 71:
      if (lookahead == 'e')
        ADVANCE(130);
      END_STATE();
    case 72:
      if (lookahead == 't')
        ADVANCE(131);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_any);
      END_STATE();
    case 74:
      if (lookahead == 'n')
        ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'i')
        ADVANCE(133);
      END_STATE();
    case 76:
      if (lookahead == 'l')
        ADVANCE(134);
      END_STATE();
    case 77:
      if (lookahead == 'a')
        ADVANCE(135);
      END_STATE();
    case 78:
      if (lookahead == 'e')
        ADVANCE(136);
      END_STATE();
    case 79:
      if (lookahead == 'c')
        ADVANCE(137);
      END_STATE();
    case 80:
      if (lookahead == 's')
        ADVANCE(138);
      END_STATE();
    case 81:
      if (lookahead == 's')
        ADVANCE(139);
      if (lookahead == 't')
        ADVANCE(140);
      END_STATE();
    case 82:
      if (lookahead == 'u')
        ADVANCE(141);
      END_STATE();
    case 83:
      if (lookahead == 'l')
        ADVANCE(142);
      END_STATE();
    case 84:
      if (lookahead == 'a')
        ADVANCE(143);
      END_STATE();
    case 85:
      if (lookahead == 'e')
        ADVANCE(144);
      END_STATE();
    case 86:
      if (lookahead == 'e')
        ADVANCE(145);
      END_STATE();
    case 87:
      if (lookahead == 'm')
        ADVANCE(146);
      END_STATE();
    case 88:
      if (lookahead == 'o')
        ADVANCE(147);
      END_STATE();
    case 89:
      if (lookahead == 'e')
        ADVANCE(148);
      END_STATE();
    case 90:
      if (lookahead == 's')
        ADVANCE(149);
      END_STATE();
    case 91:
      if (lookahead == 'a')
        ADVANCE(150);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 93:
      if (lookahead == 'm')
        ADVANCE(151);
      END_STATE();
    case 94:
      if (lookahead == 'c')
        ADVANCE(152);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 96:
      if (lookahead == 'b')
        ADVANCE(153);
      END_STATE();
    case 97:
      if (lookahead == 'l')
        ADVANCE(154);
      if (lookahead == 'o')
        ADVANCE(155);
      END_STATE();
    case 98:
      if (lookahead == 't')
        ADVANCE(156);
      END_STATE();
    case 99:
      if (lookahead == 'e')
        ADVANCE(157);
      END_STATE();
    case 100:
      if (lookahead == 'o')
        ADVANCE(158);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 102:
      if (lookahead == 'u')
        ADVANCE(159);
      END_STATE();
    case 103:
      if (lookahead == 'e')
        ADVANCE(160);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 105:
      if (lookahead == 'l')
        ADVANCE(161);
      END_STATE();
    case 106:
      if (lookahead == 'b')
        ADVANCE(162);
      END_STATE();
    case 107:
      if (lookahead == 'v')
        ADVANCE(163);
      END_STATE();
    case 108:
      if (lookahead == 't')
        ADVANCE(164);
      END_STATE();
    case 109:
      if (lookahead == 'l')
        ADVANCE(165);
      END_STATE();
    case 110:
      if (lookahead == 'd')
        ADVANCE(166);
      END_STATE();
    case 111:
      if (lookahead == 'u')
        ADVANCE(167);
      END_STATE();
    case 112:
      if (lookahead == 'u')
        ADVANCE(168);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 114:
      if (lookahead == 't')
        ADVANCE(169);
      END_STATE();
    case 115:
      if (lookahead == 'i')
        ADVANCE(170);
      END_STATE();
    case 116:
      if (lookahead == 'e')
        ADVANCE(171);
      END_STATE();
    case 117:
      if (lookahead == 't')
        ADVANCE(172);
      END_STATE();
    case 118:
      if (lookahead == 'b')
        ADVANCE(173);
      END_STATE();
    case 119:
      if (lookahead == 'g')
        ADVANCE(174);
      END_STATE();
    case 120:
      if (lookahead == 's')
        ADVANCE(175);
      END_STATE();
    case 121:
      if (lookahead == 'o')
        ADVANCE(176);
      END_STATE();
    case 122:
      if (lookahead == 'e')
        ADVANCE(177);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 124:
      if (lookahead == 'e')
        ADVANCE(178);
      END_STATE();
    case 125:
      if (lookahead == 'e')
        ADVANCE(179);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 127:
      if (lookahead == 'd')
        ADVANCE(180);
      END_STATE();
    case 128:
      if (lookahead == 'l')
        ADVANCE(181);
      END_STATE();
    case 129:
      if (lookahead == 'h')
        ADVANCE(182);
      END_STATE();
    case 130:
      if (lookahead == 'l')
        ADVANCE(183);
      END_STATE();
    case 131:
      if (lookahead == 'r')
        ADVANCE(184);
      END_STATE();
    case 132:
      if (lookahead == 'c')
        ADVANCE(185);
      END_STATE();
    case 133:
      if (lookahead == 't')
        ADVANCE(186);
      END_STATE();
    case 134:
      if (lookahead == 'e')
        ADVANCE(187);
      END_STATE();
    case 135:
      if (lookahead == 'k')
        ADVANCE(188);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 137:
      if (lookahead == 'h')
        ADVANCE(189);
      END_STATE();
    case 138:
      if (lookahead == 's')
        ADVANCE(190);
      END_STATE();
    case 139:
      if (lookahead == 't')
        ADVANCE(191);
      END_STATE();
    case 140:
      if (lookahead == 'i')
        ADVANCE(192);
      END_STATE();
    case 141:
      if (lookahead == 'g')
        ADVANCE(193);
      END_STATE();
    case 142:
      if (lookahead == 'a')
        ADVANCE(194);
      END_STATE();
    case 143:
      if (lookahead == 'u')
        ADVANCE(195);
      END_STATE();
    case 144:
      if (lookahead == 't')
        ADVANCE(196);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 147:
      if (lookahead == 'r')
        ADVANCE(197);
      END_STATE();
    case 148:
      if (lookahead == 'n')
        ADVANCE(198);
      END_STATE();
    case 149:
      if (lookahead == 'e')
        ADVANCE(199);
      END_STATE();
    case 150:
      if (lookahead == 'l')
        ADVANCE(200);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 152:
      if (lookahead == 't')
        ADVANCE(201);
      END_STATE();
    case 153:
      if (lookahead == 'a')
        ADVANCE(202);
      END_STATE();
    case 154:
      if (lookahead == 'e')
        ADVANCE(203);
      END_STATE();
    case 155:
      if (lookahead == 'r')
        ADVANCE(204);
      END_STATE();
    case 156:
      if (lookahead == 'a')
        ADVANCE(205);
      END_STATE();
    case 157:
      if (lookahead == 'r')
        ADVANCE(206);
      END_STATE();
    case 158:
      if (lookahead == 'f')
        ADVANCE(207);
      END_STATE();
    case 159:
      if (lookahead == 'l')
        ADVANCE(208);
      END_STATE();
    case 160:
      if (lookahead == 's')
        ADVANCE(209);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_null);
      END_STATE();
    case 162:
      if (lookahead == 'e')
        ADVANCE(210);
      END_STATE();
    case 163:
      if (lookahead == 'a')
        ADVANCE(211);
      END_STATE();
    case 164:
      if (lookahead == 'e')
        ADVANCE(212);
      END_STATE();
    case 165:
      if (lookahead == 'i')
        ADVANCE(213);
      END_STATE();
    case 166:
      if (lookahead == 'o')
        ADVANCE(214);
      END_STATE();
    case 167:
      if (lookahead == 'i')
        ADVANCE(215);
      END_STATE();
    case 168:
      if (lookahead == 'r')
        ADVANCE(216);
      END_STATE();
    case 169:
      if (lookahead == 'i')
        ADVANCE(217);
      END_STATE();
    case 170:
      if (lookahead == 'n')
        ADVANCE(218);
      END_STATE();
    case 171:
      if (lookahead == 'r')
        ADVANCE(219);
      END_STATE();
    case 172:
      if (lookahead == 'c')
        ADVANCE(220);
      END_STATE();
    case 173:
      if (lookahead == 'o')
        ADVANCE(221);
      END_STATE();
    case 174:
      if (lookahead == 'e')
        ADVANCE(222);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_this);
      END_STATE();
    case 176:
      if (lookahead == 'w')
        ADVANCE(223);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o')
        ADVANCE(224);
      END_STATE();
    case 179:
      if (lookahead == 'f')
        ADVANCE(225);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_void);
      END_STATE();
    case 181:
      if (lookahead == 'e')
        ADVANCE(226);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 183:
      if (lookahead == 'd')
        ADVANCE(227);
      END_STATE();
    case 184:
      if (lookahead == 'a')
        ADVANCE(228);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 187:
      if (lookahead == 'a')
        ADVANCE(229);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 192:
      if (lookahead == 'n')
        ADVANCE(230);
      END_STATE();
    case 193:
      if (lookahead == 'g')
        ADVANCE(231);
      END_STATE();
    case 194:
      if (lookahead == 'r')
        ADVANCE(232);
      END_STATE();
    case 195:
      if (lookahead == 'l')
        ADVANCE(233);
      END_STATE();
    case 196:
      if (lookahead == 'e')
        ADVANCE(234);
      END_STATE();
    case 197:
      if (lookahead == 't')
        ADVANCE(235);
      END_STATE();
    case 198:
      if (lookahead == 'd')
        ADVANCE(236);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 200:
      if (lookahead == 'l')
        ADVANCE(237);
      END_STATE();
    case 201:
      if (lookahead == 'i')
        ADVANCE(238);
      END_STATE();
    case 202:
      if (lookahead == 'l')
        ADVANCE(239);
      END_STATE();
    case 203:
      if (lookahead == 'm')
        ADVANCE(240);
      END_STATE();
    case 204:
      if (lookahead == 't')
        ADVANCE(241);
      END_STATE();
    case 205:
      if (lookahead == 'n')
        ADVANCE(242);
      END_STATE();
    case 206:
      if (lookahead == 'f')
        ADVANCE(243);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_keyof);
      END_STATE();
    case 208:
      if (lookahead == 'e')
        ADVANCE(244);
      END_STATE();
    case 209:
      if (lookahead == 'p')
        ADVANCE(245);
      END_STATE();
    case 210:
      if (lookahead == 'r')
        ADVANCE(246);
      END_STATE();
    case 211:
      if (lookahead == 't')
        ADVANCE(247);
      END_STATE();
    case 212:
      if (lookahead == 'c')
        ADVANCE(248);
      END_STATE();
    case 213:
      if (lookahead == 'c')
        ADVANCE(249);
      END_STATE();
    case 214:
      if (lookahead == 'n')
        ADVANCE(250);
      END_STATE();
    case 215:
      if (lookahead == 'r')
        ADVANCE(251);
      END_STATE();
    case 216:
      if (lookahead == 'n')
        ADVANCE(252);
      END_STATE();
    case 217:
      if (lookahead == 'c')
        ADVANCE(253);
      END_STATE();
    case 218:
      if (lookahead == 'g')
        ADVANCE(254);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 220:
      if (lookahead == 'h')
        ADVANCE(255);
      END_STATE();
    case 221:
      if (lookahead == 'l')
        ADVANCE(256);
      END_STATE();
    case 222:
      if (lookahead == 't')
        ADVANCE(257);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 224:
      if (lookahead == 'f')
        ADVANCE(258);
      END_STATE();
    case 225:
      if (lookahead == 'i')
        ADVANCE(259);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 228:
      if (lookahead == 'c')
        ADVANCE(260);
      END_STATE();
    case 229:
      if (lookahead == 'n')
        ADVANCE(261);
      END_STATE();
    case 230:
      if (lookahead == 'u')
        ADVANCE(262);
      END_STATE();
    case 231:
      if (lookahead == 'e')
        ADVANCE(263);
      END_STATE();
    case 232:
      if (lookahead == 'e')
        ADVANCE(264);
      END_STATE();
    case 233:
      if (lookahead == 't')
        ADVANCE(265);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_delete);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 236:
      if (lookahead == 's')
        ADVANCE(266);
      END_STATE();
    case 237:
      if (lookahead == 'y')
        ADVANCE(267);
      END_STATE();
    case 238:
      if (lookahead == 'o')
        ADVANCE(268);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 240:
      if (lookahead == 'e')
        ADVANCE(269);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 242:
      if (lookahead == 'c')
        ADVANCE(270);
      END_STATE();
    case 243:
      if (lookahead == 'a')
        ADVANCE(271);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 245:
      if (lookahead == 'a')
        ADVANCE(272);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_number);
      END_STATE();
    case 247:
      if (lookahead == 'e')
        ADVANCE(273);
      END_STATE();
    case 248:
      if (lookahead == 't')
        ADVANCE(274);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 250:
      if (lookahead == 'l')
        ADVANCE(275);
      END_STATE();
    case 251:
      if (lookahead == 'e')
        ADVANCE(276);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_string);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(anon_sym_symbol);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(anon_sym_target);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 259:
      if (lookahead == 'n')
        ADVANCE(277);
      END_STATE();
    case 260:
      if (lookahead == 't')
        ADVANCE(278);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_boolean);
      END_STATE();
    case 262:
      if (lookahead == 'e')
        ADVANCE(279);
      END_STATE();
    case 263:
      if (lookahead == 'r')
        ADVANCE(280);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(anon_sym_extends);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 268:
      if (lookahead == 'n')
        ADVANCE(281);
      END_STATE();
    case 269:
      if (lookahead == 'n')
        ADVANCE(282);
      END_STATE();
    case 270:
      if (lookahead == 'e')
        ADVANCE(283);
      END_STATE();
    case 271:
      if (lookahead == 'c')
        ADVANCE(284);
      END_STATE();
    case 272:
      if (lookahead == 'c')
        ADVANCE(285);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 274:
      if (lookahead == 'e')
        ADVANCE(286);
      END_STATE();
    case 275:
      if (lookahead == 'y')
        ADVANCE(287);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(anon_sym_require);
      END_STATE();
    case 277:
      if (lookahead == 'e')
        ADVANCE(288);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(anon_sym_debugger);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 282:
      if (lookahead == 't')
        ADVANCE(289);
      END_STATE();
    case 283:
      if (lookahead == 'o')
        ADVANCE(290);
      END_STATE();
    case 284:
      if (lookahead == 'e')
        ADVANCE(291);
      END_STATE();
    case 285:
      if (lookahead == 'e')
        ADVANCE(292);
      END_STATE();
    case 286:
      if (lookahead == 'd')
        ADVANCE(293);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_readonly);
      END_STATE();
    case 288:
      if (lookahead == 'd')
        ADVANCE(294);
      END_STATE();
    case 289:
      if (lookahead == 's')
        ADVANCE(295);
      END_STATE();
    case 290:
      if (lookahead == 'f')
        ADVANCE(296);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_undefined);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_implements);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_instanceof);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 95},
  [2] = {.lex_state = 102, .external_lex_state = 2},
  [3] = {.lex_state = 107, .external_lex_state = 3},
  [4] = {.lex_state = 95, .external_lex_state = 2},
  [5] = {.lex_state = 102, .external_lex_state = 2},
  [6] = {.lex_state = 95},
  [7] = {.lex_state = 95},
  [8] = {.lex_state = 102, .external_lex_state = 2},
  [9] = {.lex_state = 95, .external_lex_state = 2},
  [10] = {.lex_state = 95},
  [11] = {.lex_state = 111, .external_lex_state = 2},
  [12] = {.lex_state = 95, .external_lex_state = 2},
  [13] = {.lex_state = 95},
  [14] = {.lex_state = 95},
  [15] = {.lex_state = 95},
  [16] = {.lex_state = 95, .external_lex_state = 2},
  [17] = {.lex_state = 95},
  [18] = {.lex_state = 95},
  [19] = {.lex_state = 111, .external_lex_state = 2},
  [20] = {.lex_state = 111, .external_lex_state = 2},
  [21] = {.lex_state = 95},
  [22] = {.lex_state = 95},
  [23] = {.lex_state = 102, .external_lex_state = 2},
  [24] = {.lex_state = 102, .external_lex_state = 2},
  [25] = {.lex_state = 102, .external_lex_state = 2},
  [26] = {.lex_state = 95},
  [27] = {.lex_state = 123},
  [28] = {.lex_state = 95},
  [29] = {.lex_state = 95},
  [30] = {.lex_state = 131},
  [31] = {.lex_state = 135},
  [32] = {.lex_state = 102, .external_lex_state = 2},
  [33] = {.lex_state = 95},
  [34] = {.lex_state = 102, .external_lex_state = 2},
  [35] = {.lex_state = 138},
  [36] = {.lex_state = 95},
  [37] = {.lex_state = 140},
  [38] = {.lex_state = 102, .external_lex_state = 2},
  [39] = {.lex_state = 95},
  [40] = {.lex_state = 95},
  [41] = {.lex_state = 95},
  [42] = {.lex_state = 142},
  [43] = {.lex_state = 95},
  [44] = {.lex_state = 150},
  [45] = {.lex_state = 153},
  [46] = {.lex_state = 131},
  [47] = {.lex_state = 131},
  [48] = {.lex_state = 95},
  [49] = {.lex_state = 102, .external_lex_state = 2},
  [50] = {.lex_state = 95},
  [51] = {.lex_state = 95},
  [52] = {.lex_state = 102},
  [53] = {.lex_state = 160, .external_lex_state = 2},
  [54] = {.lex_state = 102, .external_lex_state = 2},
  [55] = {.lex_state = 95},
  [56] = {.lex_state = 95},
  [57] = {.lex_state = 111, .external_lex_state = 2},
  [58] = {.lex_state = 102},
  [59] = {.lex_state = 111, .external_lex_state = 2},
  [60] = {.lex_state = 160, .external_lex_state = 2},
  [61] = {.lex_state = 0},
  [62] = {.lex_state = 95, .external_lex_state = 2},
  [63] = {.lex_state = 95},
  [64] = {.lex_state = 95},
  [65] = {.lex_state = 111, .external_lex_state = 2},
  [66] = {.lex_state = 95},
  [67] = {.lex_state = 95},
  [68] = {.lex_state = 95},
  [69] = {.lex_state = 95},
  [70] = {.lex_state = 95},
  [71] = {.lex_state = 95},
  [72] = {.lex_state = 111, .external_lex_state = 2},
  [73] = {.lex_state = 95},
  [74] = {.lex_state = 111, .external_lex_state = 2},
  [75] = {.lex_state = 107, .external_lex_state = 3},
  [76] = {.lex_state = 138},
  [77] = {.lex_state = 95},
  [78] = {.lex_state = 95},
  [79] = {.lex_state = 95},
  [80] = {.lex_state = 111, .external_lex_state = 2},
  [81] = {.lex_state = 138},
  [82] = {.lex_state = 102},
  [83] = {.lex_state = 138},
  [84] = {.lex_state = 102, .external_lex_state = 2},
  [85] = {.lex_state = 138},
  [86] = {.lex_state = 102, .external_lex_state = 2},
  [87] = {.lex_state = 131},
  [88] = {.lex_state = 111, .external_lex_state = 2},
  [89] = {.lex_state = 111, .external_lex_state = 2},
  [90] = {.lex_state = 95},
  [91] = {.lex_state = 111, .external_lex_state = 2},
  [92] = {.lex_state = 138},
  [93] = {.lex_state = 95, .external_lex_state = 2},
  [94] = {.lex_state = 102, .external_lex_state = 2},
  [95] = {.lex_state = 95},
  [96] = {.lex_state = 102, .external_lex_state = 2},
  [97] = {.lex_state = 102},
  [98] = {.lex_state = 102},
  [99] = {.lex_state = 95},
  [100] = {.lex_state = 150},
  [101] = {.lex_state = 140},
  [102] = {.lex_state = 111, .external_lex_state = 2},
  [103] = {.lex_state = 95},
  [104] = {.lex_state = 138},
  [105] = {.lex_state = 111, .external_lex_state = 2},
  [106] = {.lex_state = 95, .external_lex_state = 2},
  [107] = {.lex_state = 131},
  [108] = {.lex_state = 95},
  [109] = {.lex_state = 138},
  [110] = {.lex_state = 95, .external_lex_state = 2},
  [111] = {.lex_state = 111, .external_lex_state = 2},
  [112] = {.lex_state = 95},
  [113] = {.lex_state = 95},
  [114] = {.lex_state = 111, .external_lex_state = 2},
  [115] = {.lex_state = 111, .external_lex_state = 2},
  [116] = {.lex_state = 95, .external_lex_state = 2},
  [117] = {.lex_state = 95},
  [118] = {.lex_state = 135},
  [119] = {.lex_state = 102},
  [120] = {.lex_state = 131},
  [121] = {.lex_state = 95},
  [122] = {.lex_state = 138},
  [123] = {.lex_state = 95, .external_lex_state = 2},
  [124] = {.lex_state = 95},
  [125] = {.lex_state = 95},
  [126] = {.lex_state = 160, .external_lex_state = 2},
  [127] = {.lex_state = 160, .external_lex_state = 2},
  [128] = {.lex_state = 160, .external_lex_state = 2},
  [129] = {.lex_state = 111, .external_lex_state = 2},
  [130] = {.lex_state = 163, .external_lex_state = 2},
  [131] = {.lex_state = 123},
  [132] = {.lex_state = 111, .external_lex_state = 2},
  [133] = {.lex_state = 95},
  [134] = {.lex_state = 95},
  [135] = {.lex_state = 95},
  [136] = {.lex_state = 166},
  [137] = {.lex_state = 111, .external_lex_state = 2},
  [138] = {.lex_state = 167},
  [139] = {.lex_state = 131},
  [140] = {.lex_state = 131},
  [141] = {.lex_state = 138},
  [142] = {.lex_state = 95},
  [143] = {.lex_state = 150},
  [144] = {.lex_state = 95},
  [145] = {.lex_state = 138},
  [146] = {.lex_state = 95},
  [147] = {.lex_state = 95},
  [148] = {.lex_state = 95},
  [149] = {.lex_state = 111, .external_lex_state = 2},
  [150] = {.lex_state = 102},
  [151] = {.lex_state = 95},
  [152] = {.lex_state = 95},
  [153] = {.lex_state = 95},
  [154] = {.lex_state = 95},
  [155] = {.lex_state = 95},
  [156] = {.lex_state = 95},
  [157] = {.lex_state = 135},
  [158] = {.lex_state = 95},
  [159] = {.lex_state = 95},
  [160] = {.lex_state = 138},
  [161] = {.lex_state = 168, .external_lex_state = 2},
  [162] = {.lex_state = 168, .external_lex_state = 2},
  [163] = {.lex_state = 138},
  [164] = {.lex_state = 95},
  [165] = {.lex_state = 168, .external_lex_state = 2},
  [166] = {.lex_state = 168, .external_lex_state = 2},
  [167] = {.lex_state = 131},
  [168] = {.lex_state = 168, .external_lex_state = 2},
  [169] = {.lex_state = 160, .external_lex_state = 2},
  [170] = {.lex_state = 168, .external_lex_state = 2},
  [171] = {.lex_state = 168, .external_lex_state = 2},
  [172] = {.lex_state = 168, .external_lex_state = 2},
  [173] = {.lex_state = 131},
  [174] = {.lex_state = 131},
  [175] = {.lex_state = 168, .external_lex_state = 2},
  [176] = {.lex_state = 168, .external_lex_state = 2},
  [177] = {.lex_state = 168, .external_lex_state = 2},
  [178] = {.lex_state = 111, .external_lex_state = 2},
  [179] = {.lex_state = 168, .external_lex_state = 2},
  [180] = {.lex_state = 131},
  [181] = {.lex_state = 138},
  [182] = {.lex_state = 138},
  [183] = {.lex_state = 135},
  [184] = {.lex_state = 111, .external_lex_state = 2},
  [185] = {.lex_state = 138},
  [186] = {.lex_state = 131},
  [187] = {.lex_state = 111, .external_lex_state = 2},
  [188] = {.lex_state = 95},
  [189] = {.lex_state = 169},
  [190] = {.lex_state = 95},
  [191] = {.lex_state = 169},
  [192] = {.lex_state = 95},
  [193] = {.lex_state = 169},
  [194] = {.lex_state = 169},
  [195] = {.lex_state = 169},
  [196] = {.lex_state = 102},
  [197] = {.lex_state = 169},
  [198] = {.lex_state = 140},
  [199] = {.lex_state = 170},
  [200] = {.lex_state = 95},
  [201] = {.lex_state = 140},
  [202] = {.lex_state = 170},
  [203] = {.lex_state = 131},
  [204] = {.lex_state = 170},
  [205] = {.lex_state = 170},
  [206] = {.lex_state = 102},
  [207] = {.lex_state = 102},
  [208] = {.lex_state = 140},
  [209] = {.lex_state = 95},
  [210] = {.lex_state = 95},
  [211] = {.lex_state = 102, .external_lex_state = 2},
  [212] = {.lex_state = 95},
  [213] = {.lex_state = 95},
  [214] = {.lex_state = 142},
  [215] = {.lex_state = 138},
  [216] = {.lex_state = 138},
  [217] = {.lex_state = 135},
  [218] = {.lex_state = 171},
  [219] = {.lex_state = 150},
  [220] = {.lex_state = 138},
  [221] = {.lex_state = 150},
  [222] = {.lex_state = 150},
  [223] = {.lex_state = 171},
  [224] = {.lex_state = 171},
  [225] = {.lex_state = 95},
  [226] = {.lex_state = 95},
  [227] = {.lex_state = 171},
  [228] = {.lex_state = 95},
  [229] = {.lex_state = 95},
  [230] = {.lex_state = 150},
  [231] = {.lex_state = 150},
  [232] = {.lex_state = 135},
  [233] = {.lex_state = 95},
  [234] = {.lex_state = 172},
  [235] = {.lex_state = 102},
  [236] = {.lex_state = 102},
  [237] = {.lex_state = 171},
  [238] = {.lex_state = 102},
  [239] = {.lex_state = 173},
  [240] = {.lex_state = 95},
  [241] = {.lex_state = 95},
  [242] = {.lex_state = 95},
  [243] = {.lex_state = 102, .external_lex_state = 2},
  [244] = {.lex_state = 111, .external_lex_state = 2},
  [245] = {.lex_state = 95},
  [246] = {.lex_state = 102, .external_lex_state = 2},
  [247] = {.lex_state = 102, .external_lex_state = 2},
  [248] = {.lex_state = 102, .external_lex_state = 2},
  [249] = {.lex_state = 102, .external_lex_state = 2},
  [250] = {.lex_state = 111},
  [251] = {.lex_state = 111, .external_lex_state = 2},
  [252] = {.lex_state = 102, .external_lex_state = 2},
  [253] = {.lex_state = 111, .external_lex_state = 2},
  [254] = {.lex_state = 111, .external_lex_state = 2},
  [255] = {.lex_state = 95},
  [256] = {.lex_state = 95},
  [257] = {.lex_state = 138},
  [258] = {.lex_state = 95},
  [259] = {.lex_state = 95},
  [260] = {.lex_state = 95},
  [261] = {.lex_state = 138},
  [262] = {.lex_state = 95, .external_lex_state = 2},
  [263] = {.lex_state = 95},
  [264] = {.lex_state = 95},
  [265] = {.lex_state = 102},
  [266] = {.lex_state = 138},
  [267] = {.lex_state = 111, .external_lex_state = 2},
  [268] = {.lex_state = 150},
  [269] = {.lex_state = 102},
  [270] = {.lex_state = 135},
  [271] = {.lex_state = 111, .external_lex_state = 2},
  [272] = {.lex_state = 95},
  [273] = {.lex_state = 95},
  [274] = {.lex_state = 95},
  [275] = {.lex_state = 95},
  [276] = {.lex_state = 95},
  [277] = {.lex_state = 95},
  [278] = {.lex_state = 150},
  [279] = {.lex_state = 111, .external_lex_state = 2},
  [280] = {.lex_state = 131},
  [281] = {.lex_state = 95},
  [282] = {.lex_state = 95},
  [283] = {.lex_state = 95},
  [284] = {.lex_state = 95},
  [285] = {.lex_state = 111, .external_lex_state = 2},
  [286] = {.lex_state = 111, .external_lex_state = 2},
  [287] = {.lex_state = 111, .external_lex_state = 2},
  [288] = {.lex_state = 111, .external_lex_state = 2},
  [289] = {.lex_state = 111, .external_lex_state = 2},
  [290] = {.lex_state = 111, .external_lex_state = 2},
  [291] = {.lex_state = 111, .external_lex_state = 2},
  [292] = {.lex_state = 138},
  [293] = {.lex_state = 102, .external_lex_state = 2},
  [294] = {.lex_state = 160},
  [295] = {.lex_state = 138},
  [296] = {.lex_state = 111, .external_lex_state = 2},
  [297] = {.lex_state = 107, .external_lex_state = 3},
  [298] = {.lex_state = 111, .external_lex_state = 2},
  [299] = {.lex_state = 111, .external_lex_state = 2},
  [300] = {.lex_state = 111, .external_lex_state = 2},
  [301] = {.lex_state = 102, .external_lex_state = 2},
  [302] = {.lex_state = 95},
  [303] = {.lex_state = 138},
  [304] = {.lex_state = 174},
  [305] = {.lex_state = 174},
  [306] = {.lex_state = 174},
  [307] = {.lex_state = 174},
  [308] = {.lex_state = 174},
  [309] = {.lex_state = 111, .external_lex_state = 2},
  [310] = {.lex_state = 102},
  [311] = {.lex_state = 131},
  [312] = {.lex_state = 102},
  [313] = {.lex_state = 95},
  [314] = {.lex_state = 95},
  [315] = {.lex_state = 138},
  [316] = {.lex_state = 102, .external_lex_state = 2},
  [317] = {.lex_state = 102, .external_lex_state = 2},
  [318] = {.lex_state = 95},
  [319] = {.lex_state = 95},
  [320] = {.lex_state = 138},
  [321] = {.lex_state = 102, .external_lex_state = 2},
  [322] = {.lex_state = 102, .external_lex_state = 2},
  [323] = {.lex_state = 102},
  [324] = {.lex_state = 102, .external_lex_state = 2},
  [325] = {.lex_state = 102},
  [326] = {.lex_state = 167},
  [327] = {.lex_state = 131},
  [328] = {.lex_state = 172},
  [329] = {.lex_state = 111, .external_lex_state = 2},
  [330] = {.lex_state = 170},
  [331] = {.lex_state = 140},
  [332] = {.lex_state = 140},
  [333] = {.lex_state = 111, .external_lex_state = 2},
  [334] = {.lex_state = 138},
  [335] = {.lex_state = 131},
  [336] = {.lex_state = 138},
  [337] = {.lex_state = 131},
  [338] = {.lex_state = 138},
  [339] = {.lex_state = 138},
  [340] = {.lex_state = 138},
  [341] = {.lex_state = 138},
  [342] = {.lex_state = 138},
  [343] = {.lex_state = 95},
  [344] = {.lex_state = 150},
  [345] = {.lex_state = 102},
  [346] = {.lex_state = 131},
  [347] = {.lex_state = 95},
  [348] = {.lex_state = 102},
  [349] = {.lex_state = 95, .external_lex_state = 2},
  [350] = {.lex_state = 95},
  [351] = {.lex_state = 95},
  [352] = {.lex_state = 138},
  [353] = {.lex_state = 95},
  [354] = {.lex_state = 95},
  [355] = {.lex_state = 138},
  [356] = {.lex_state = 138},
  [357] = {.lex_state = 138},
  [358] = {.lex_state = 95},
  [359] = {.lex_state = 95},
  [360] = {.lex_state = 160, .external_lex_state = 2},
  [361] = {.lex_state = 163, .external_lex_state = 2},
  [362] = {.lex_state = 123},
  [363] = {.lex_state = 95},
  [364] = {.lex_state = 102, .external_lex_state = 2},
  [365] = {.lex_state = 95},
  [366] = {.lex_state = 95},
  [367] = {.lex_state = 95},
  [368] = {.lex_state = 111, .external_lex_state = 2},
  [369] = {.lex_state = 111, .external_lex_state = 2},
  [370] = {.lex_state = 176},
  [371] = {.lex_state = 177},
  [372] = {.lex_state = 166},
  [373] = {.lex_state = 111, .external_lex_state = 2},
  [374] = {.lex_state = 131},
  [375] = {.lex_state = 166},
  [376] = {.lex_state = 102},
  [377] = {.lex_state = 111},
  [378] = {.lex_state = 131},
  [379] = {.lex_state = 102},
  [380] = {.lex_state = 131},
  [381] = {.lex_state = 95},
  [382] = {.lex_state = 95},
  [383] = {.lex_state = 160, .external_lex_state = 2},
  [384] = {.lex_state = 174, .external_lex_state = 2},
  [385] = {.lex_state = 95},
  [386] = {.lex_state = 95},
  [387] = {.lex_state = 174, .external_lex_state = 2},
  [388] = {.lex_state = 135, .external_lex_state = 2},
  [389] = {.lex_state = 135, .external_lex_state = 2},
  [390] = {.lex_state = 131},
  [391] = {.lex_state = 163, .external_lex_state = 2},
  [392] = {.lex_state = 131},
  [393] = {.lex_state = 131},
  [394] = {.lex_state = 102, .external_lex_state = 2},
  [395] = {.lex_state = 135, .external_lex_state = 2},
  [396] = {.lex_state = 131},
  [397] = {.lex_state = 138},
  [398] = {.lex_state = 138, .external_lex_state = 2},
  [399] = {.lex_state = 111, .external_lex_state = 2},
  [400] = {.lex_state = 95},
  [401] = {.lex_state = 95},
  [402] = {.lex_state = 138},
  [403] = {.lex_state = 102},
  [404] = {.lex_state = 95},
  [405] = {.lex_state = 95},
  [406] = {.lex_state = 111, .external_lex_state = 2},
  [407] = {.lex_state = 160, .external_lex_state = 2},
  [408] = {.lex_state = 138},
  [409] = {.lex_state = 174},
  [410] = {.lex_state = 174},
  [411] = {.lex_state = 174},
  [412] = {.lex_state = 174},
  [413] = {.lex_state = 174},
  [414] = {.lex_state = 138},
  [415] = {.lex_state = 131},
  [416] = {.lex_state = 95},
  [417] = {.lex_state = 131},
  [418] = {.lex_state = 131},
  [419] = {.lex_state = 131},
  [420] = {.lex_state = 95},
  [421] = {.lex_state = 131},
  [422] = {.lex_state = 167},
  [423] = {.lex_state = 135},
  [424] = {.lex_state = 135},
  [425] = {.lex_state = 135},
  [426] = {.lex_state = 131},
  [427] = {.lex_state = 111, .external_lex_state = 2},
  [428] = {.lex_state = 138},
  [429] = {.lex_state = 138},
  [430] = {.lex_state = 95},
  [431] = {.lex_state = 95},
  [432] = {.lex_state = 95},
  [433] = {.lex_state = 160, .external_lex_state = 2},
  [434] = {.lex_state = 138},
  [435] = {.lex_state = 131},
  [436] = {.lex_state = 131},
  [437] = {.lex_state = 131},
  [438] = {.lex_state = 138},
  [439] = {.lex_state = 131},
  [440] = {.lex_state = 160, .external_lex_state = 2},
  [441] = {.lex_state = 138},
  [442] = {.lex_state = 138},
  [443] = {.lex_state = 169},
  [444] = {.lex_state = 170},
  [445] = {.lex_state = 169},
  [446] = {.lex_state = 169},
  [447] = {.lex_state = 169},
  [448] = {.lex_state = 169},
  [449] = {.lex_state = 169},
  [450] = {.lex_state = 169},
  [451] = {.lex_state = 169},
  [452] = {.lex_state = 170},
  [453] = {.lex_state = 169},
  [454] = {.lex_state = 169},
  [455] = {.lex_state = 140},
  [456] = {.lex_state = 102},
  [457] = {.lex_state = 140},
  [458] = {.lex_state = 111, .external_lex_state = 2},
  [459] = {.lex_state = 140},
  [460] = {.lex_state = 95},
  [461] = {.lex_state = 140},
  [462] = {.lex_state = 169},
  [463] = {.lex_state = 169},
  [464] = {.lex_state = 169},
  [465] = {.lex_state = 169},
  [466] = {.lex_state = 140},
  [467] = {.lex_state = 169},
  [468] = {.lex_state = 169},
  [469] = {.lex_state = 169},
  [470] = {.lex_state = 170},
  [471] = {.lex_state = 169},
  [472] = {.lex_state = 169},
  [473] = {.lex_state = 170},
  [474] = {.lex_state = 169},
  [475] = {.lex_state = 95},
  [476] = {.lex_state = 95},
  [477] = {.lex_state = 131},
  [478] = {.lex_state = 102},
  [479] = {.lex_state = 95},
  [480] = {.lex_state = 95},
  [481] = {.lex_state = 138},
  [482] = {.lex_state = 102, .external_lex_state = 2},
  [483] = {.lex_state = 138},
  [484] = {.lex_state = 142},
  [485] = {.lex_state = 138},
  [486] = {.lex_state = 95},
  [487] = {.lex_state = 95},
  [488] = {.lex_state = 138},
  [489] = {.lex_state = 138},
  [490] = {.lex_state = 150},
  [491] = {.lex_state = 150},
  [492] = {.lex_state = 150},
  [493] = {.lex_state = 95},
  [494] = {.lex_state = 150},
  [495] = {.lex_state = 150},
  [496] = {.lex_state = 102},
  [497] = {.lex_state = 178},
  [498] = {.lex_state = 102},
  [499] = {.lex_state = 150},
  [500] = {.lex_state = 171},
  [501] = {.lex_state = 131},
  [502] = {.lex_state = 95},
  [503] = {.lex_state = 131},
  [504] = {.lex_state = 174, .external_lex_state = 2},
  [505] = {.lex_state = 174, .external_lex_state = 2},
  [506] = {.lex_state = 171},
  [507] = {.lex_state = 95},
  [508] = {.lex_state = 174, .external_lex_state = 2},
  [509] = {.lex_state = 131},
  [510] = {.lex_state = 95},
  [511] = {.lex_state = 174, .external_lex_state = 2},
  [512] = {.lex_state = 131},
  [513] = {.lex_state = 138, .external_lex_state = 2},
  [514] = {.lex_state = 131},
  [515] = {.lex_state = 171},
  [516] = {.lex_state = 171},
  [517] = {.lex_state = 171},
  [518] = {.lex_state = 172},
  [519] = {.lex_state = 171},
  [520] = {.lex_state = 102},
  [521] = {.lex_state = 95},
  [522] = {.lex_state = 131},
  [523] = {.lex_state = 179},
  [524] = {.lex_state = 179},
  [525] = {.lex_state = 138},
  [526] = {.lex_state = 179},
  [527] = {.lex_state = 140},
  [528] = {.lex_state = 171},
  [529] = {.lex_state = 178},
  [530] = {.lex_state = 150},
  [531] = {.lex_state = 150},
  [532] = {.lex_state = 172},
  [533] = {.lex_state = 102},
  [534] = {.lex_state = 102},
  [535] = {.lex_state = 150},
  [536] = {.lex_state = 150},
  [537] = {.lex_state = 178},
  [538] = {.lex_state = 102},
  [539] = {.lex_state = 167},
  [540] = {.lex_state = 102},
  [541] = {.lex_state = 131},
  [542] = {.lex_state = 150},
  [543] = {.lex_state = 180, .external_lex_state = 2},
  [544] = {.lex_state = 95, .external_lex_state = 2},
  [545] = {.lex_state = 95},
  [546] = {.lex_state = 95},
  [547] = {.lex_state = 160, .external_lex_state = 2},
  [548] = {.lex_state = 111, .external_lex_state = 2},
  [549] = {.lex_state = 111, .external_lex_state = 2},
  [550] = {.lex_state = 111, .external_lex_state = 2},
  [551] = {.lex_state = 111, .external_lex_state = 2},
  [552] = {.lex_state = 95, .external_lex_state = 2},
  [553] = {.lex_state = 95, .external_lex_state = 2},
  [554] = {.lex_state = 138},
  [555] = {.lex_state = 138},
  [556] = {.lex_state = 102, .external_lex_state = 2},
  [557] = {.lex_state = 111, .external_lex_state = 2},
  [558] = {.lex_state = 95},
  [559] = {.lex_state = 138},
  [560] = {.lex_state = 95},
  [561] = {.lex_state = 138},
  [562] = {.lex_state = 102},
  [563] = {.lex_state = 179},
  [564] = {.lex_state = 111, .external_lex_state = 2},
  [565] = {.lex_state = 111, .external_lex_state = 2},
  [566] = {.lex_state = 111, .external_lex_state = 2},
  [567] = {.lex_state = 111, .external_lex_state = 2},
  [568] = {.lex_state = 111, .external_lex_state = 2},
  [569] = {.lex_state = 95, .external_lex_state = 2},
  [570] = {.lex_state = 111},
  [571] = {.lex_state = 111, .external_lex_state = 2},
  [572] = {.lex_state = 111, .external_lex_state = 2},
  [573] = {.lex_state = 102, .external_lex_state = 2},
  [574] = {.lex_state = 111, .external_lex_state = 2},
  [575] = {.lex_state = 102, .external_lex_state = 2},
  [576] = {.lex_state = 95},
  [577] = {.lex_state = 95},
  [578] = {.lex_state = 102, .external_lex_state = 2},
  [579] = {.lex_state = 140},
  [580] = {.lex_state = 131},
  [581] = {.lex_state = 95},
  [582] = {.lex_state = 102},
  [583] = {.lex_state = 111, .external_lex_state = 2},
  [584] = {.lex_state = 95},
  [585] = {.lex_state = 95},
  [586] = {.lex_state = 95},
  [587] = {.lex_state = 107, .external_lex_state = 3},
  [588] = {.lex_state = 138},
  [589] = {.lex_state = 138},
  [590] = {.lex_state = 138},
  [591] = {.lex_state = 138},
  [592] = {.lex_state = 95},
  [593] = {.lex_state = 102, .external_lex_state = 2},
  [594] = {.lex_state = 138},
  [595] = {.lex_state = 102, .external_lex_state = 2},
  [596] = {.lex_state = 138},
  [597] = {.lex_state = 102, .external_lex_state = 2},
  [598] = {.lex_state = 102, .external_lex_state = 2},
  [599] = {.lex_state = 102, .external_lex_state = 2},
  [600] = {.lex_state = 102, .external_lex_state = 2},
  [601] = {.lex_state = 111, .external_lex_state = 2},
  [602] = {.lex_state = 140},
  [603] = {.lex_state = 138},
  [604] = {.lex_state = 131},
  [605] = {.lex_state = 138},
  [606] = {.lex_state = 160},
  [607] = {.lex_state = 138},
  [608] = {.lex_state = 95},
  [609] = {.lex_state = 95},
  [610] = {.lex_state = 95},
  [611] = {.lex_state = 138},
  [612] = {.lex_state = 135, .external_lex_state = 2},
  [613] = {.lex_state = 150},
  [614] = {.lex_state = 95},
  [615] = {.lex_state = 95},
  [616] = {.lex_state = 102, .external_lex_state = 2},
  [617] = {.lex_state = 95},
  [618] = {.lex_state = 138},
  [619] = {.lex_state = 95, .external_lex_state = 2},
  [620] = {.lex_state = 95},
  [621] = {.lex_state = 95},
  [622] = {.lex_state = 138},
  [623] = {.lex_state = 95},
  [624] = {.lex_state = 138},
  [625] = {.lex_state = 95},
  [626] = {.lex_state = 138},
  [627] = {.lex_state = 95, .external_lex_state = 2},
  [628] = {.lex_state = 160, .external_lex_state = 2},
  [629] = {.lex_state = 95},
  [630] = {.lex_state = 95},
  [631] = {.lex_state = 95},
  [632] = {.lex_state = 95},
  [633] = {.lex_state = 95},
  [634] = {.lex_state = 95},
  [635] = {.lex_state = 102, .external_lex_state = 2},
  [636] = {.lex_state = 102},
  [637] = {.lex_state = 102},
  [638] = {.lex_state = 140},
  [639] = {.lex_state = 95},
  [640] = {.lex_state = 95},
  [641] = {.lex_state = 95},
  [642] = {.lex_state = 95},
  [643] = {.lex_state = 111, .external_lex_state = 2},
  [644] = {.lex_state = 95},
  [645] = {.lex_state = 95},
  [646] = {.lex_state = 102},
  [647] = {.lex_state = 150},
  [648] = {.lex_state = 102},
  [649] = {.lex_state = 160, .external_lex_state = 2},
  [650] = {.lex_state = 95},
  [651] = {.lex_state = 183},
  [652] = {.lex_state = 183},
  [653] = {.lex_state = 183},
  [654] = {.lex_state = 183},
  [655] = {.lex_state = 183},
  [656] = {.lex_state = 167},
  [657] = {.lex_state = 131},
  [658] = {.lex_state = 95},
  [659] = {.lex_state = 131},
  [660] = {.lex_state = 131},
  [661] = {.lex_state = 95},
  [662] = {.lex_state = 131},
  [663] = {.lex_state = 135, .external_lex_state = 2},
  [664] = {.lex_state = 135, .external_lex_state = 2},
  [665] = {.lex_state = 135, .external_lex_state = 2},
  [666] = {.lex_state = 95},
  [667] = {.lex_state = 95},
  [668] = {.lex_state = 135, .external_lex_state = 2},
  [669] = {.lex_state = 138},
  [670] = {.lex_state = 135, .external_lex_state = 2},
  [671] = {.lex_state = 102, .external_lex_state = 2},
  [672] = {.lex_state = 102, .external_lex_state = 2},
  [673] = {.lex_state = 102, .external_lex_state = 2},
  [674] = {.lex_state = 102, .external_lex_state = 2},
  [675] = {.lex_state = 131},
  [676] = {.lex_state = 131},
  [677] = {.lex_state = 131},
  [678] = {.lex_state = 163, .external_lex_state = 2},
  [679] = {.lex_state = 138},
  [680] = {.lex_state = 102},
  [681] = {.lex_state = 95},
  [682] = {.lex_state = 111, .external_lex_state = 2},
  [683] = {.lex_state = 138},
  [684] = {.lex_state = 95},
  [685] = {.lex_state = 95},
  [686] = {.lex_state = 131},
  [687] = {.lex_state = 131},
  [688] = {.lex_state = 95},
  [689] = {.lex_state = 131},
  [690] = {.lex_state = 111, .external_lex_state = 2},
  [691] = {.lex_state = 131},
  [692] = {.lex_state = 111, .external_lex_state = 2},
  [693] = {.lex_state = 160},
  [694] = {.lex_state = 138},
  [695] = {.lex_state = 138},
  [696] = {.lex_state = 95},
  [697] = {.lex_state = 138},
  [698] = {.lex_state = 102},
  [699] = {.lex_state = 138},
  [700] = {.lex_state = 140},
  [701] = {.lex_state = 169},
  [702] = {.lex_state = 140},
  [703] = {.lex_state = 169},
  [704] = {.lex_state = 140},
  [705] = {.lex_state = 169},
  [706] = {.lex_state = 169},
  [707] = {.lex_state = 169},
  [708] = {.lex_state = 169},
  [709] = {.lex_state = 140},
  [710] = {.lex_state = 169},
  [711] = {.lex_state = 169},
  [712] = {.lex_state = 140},
  [713] = {.lex_state = 169},
  [714] = {.lex_state = 140},
  [715] = {.lex_state = 169},
  [716] = {.lex_state = 140},
  [717] = {.lex_state = 140},
  [718] = {.lex_state = 102},
  [719] = {.lex_state = 131},
  [720] = {.lex_state = 140},
  [721] = {.lex_state = 140},
  [722] = {.lex_state = 140},
  [723] = {.lex_state = 111, .external_lex_state = 2},
  [724] = {.lex_state = 169},
  [725] = {.lex_state = 169},
  [726] = {.lex_state = 169},
  [727] = {.lex_state = 169},
  [728] = {.lex_state = 169},
  [729] = {.lex_state = 140},
  [730] = {.lex_state = 140},
  [731] = {.lex_state = 140},
  [732] = {.lex_state = 140},
  [733] = {.lex_state = 140},
  [734] = {.lex_state = 169},
  [735] = {.lex_state = 140},
  [736] = {.lex_state = 140},
  [737] = {.lex_state = 169},
  [738] = {.lex_state = 140},
  [739] = {.lex_state = 111, .external_lex_state = 2},
  [740] = {.lex_state = 111, .external_lex_state = 2},
  [741] = {.lex_state = 111, .external_lex_state = 2},
  [742] = {.lex_state = 111, .external_lex_state = 2},
  [743] = {.lex_state = 95, .external_lex_state = 2},
  [744] = {.lex_state = 160, .external_lex_state = 2},
  [745] = {.lex_state = 138},
  [746] = {.lex_state = 95},
  [747] = {.lex_state = 138},
  [748] = {.lex_state = 138},
  [749] = {.lex_state = 138},
  [750] = {.lex_state = 135},
  [751] = {.lex_state = 135},
  [752] = {.lex_state = 131},
  [753] = {.lex_state = 172},
  [754] = {.lex_state = 172},
  [755] = {.lex_state = 172},
  [756] = {.lex_state = 102},
  [757] = {.lex_state = 138, .external_lex_state = 2},
  [758] = {.lex_state = 131},
  [759] = {.lex_state = 174, .external_lex_state = 2},
  [760] = {.lex_state = 131},
  [761] = {.lex_state = 95},
  [762] = {.lex_state = 174, .external_lex_state = 2},
  [763] = {.lex_state = 174, .external_lex_state = 2},
  [764] = {.lex_state = 160, .external_lex_state = 2},
  [765] = {.lex_state = 95},
  [766] = {.lex_state = 174, .external_lex_state = 2},
  [767] = {.lex_state = 138, .external_lex_state = 2},
  [768] = {.lex_state = 138, .external_lex_state = 2},
  [769] = {.lex_state = 131},
  [770] = {.lex_state = 138},
  [771] = {.lex_state = 171},
  [772] = {.lex_state = 138, .external_lex_state = 2},
  [773] = {.lex_state = 171},
  [774] = {.lex_state = 131},
  [775] = {.lex_state = 150},
  [776] = {.lex_state = 102},
  [777] = {.lex_state = 131},
  [778] = {.lex_state = 138},
  [779] = {.lex_state = 174, .external_lex_state = 2},
  [780] = {.lex_state = 174, .external_lex_state = 2},
  [781] = {.lex_state = 131},
  [782] = {.lex_state = 179},
  [783] = {.lex_state = 174, .external_lex_state = 2},
  [784] = {.lex_state = 131},
  [785] = {.lex_state = 131},
  [786] = {.lex_state = 174, .external_lex_state = 2},
  [787] = {.lex_state = 131},
  [788] = {.lex_state = 171},
  [789] = {.lex_state = 171},
  [790] = {.lex_state = 171},
  [791] = {.lex_state = 178},
  [792] = {.lex_state = 184},
  [793] = {.lex_state = 172},
  [794] = {.lex_state = 167},
  [795] = {.lex_state = 150},
  [796] = {.lex_state = 172},
  [797] = {.lex_state = 131},
  [798] = {.lex_state = 167},
  [799] = {.lex_state = 102},
  [800] = {.lex_state = 102},
  [801] = {.lex_state = 102},
  [802] = {.lex_state = 171},
  [803] = {.lex_state = 172},
  [804] = {.lex_state = 111, .external_lex_state = 2},
  [805] = {.lex_state = 138},
  [806] = {.lex_state = 95},
  [807] = {.lex_state = 160, .external_lex_state = 2},
  [808] = {.lex_state = 95},
  [809] = {.lex_state = 111, .external_lex_state = 2},
  [810] = {.lex_state = 170},
  [811] = {.lex_state = 138},
  [812] = {.lex_state = 95, .external_lex_state = 2},
  [813] = {.lex_state = 138},
  [814] = {.lex_state = 95, .external_lex_state = 2},
  [815] = {.lex_state = 138},
  [816] = {.lex_state = 95, .external_lex_state = 2},
  [817] = {.lex_state = 95, .external_lex_state = 2},
  [818] = {.lex_state = 95},
  [819] = {.lex_state = 131},
  [820] = {.lex_state = 102, .external_lex_state = 2},
  [821] = {.lex_state = 111, .external_lex_state = 2},
  [822] = {.lex_state = 169},
  [823] = {.lex_state = 169},
  [824] = {.lex_state = 169},
  [825] = {.lex_state = 95},
  [826] = {.lex_state = 102},
  [827] = {.lex_state = 102},
  [828] = {.lex_state = 111, .external_lex_state = 2},
  [829] = {.lex_state = 95},
  [830] = {.lex_state = 95},
  [831] = {.lex_state = 160, .external_lex_state = 2},
  [832] = {.lex_state = 111, .external_lex_state = 2},
  [833] = {.lex_state = 95},
  [834] = {.lex_state = 111, .external_lex_state = 2},
  [835] = {.lex_state = 138},
  [836] = {.lex_state = 138},
  [837] = {.lex_state = 138},
  [838] = {.lex_state = 138},
  [839] = {.lex_state = 138},
  [840] = {.lex_state = 138},
  [841] = {.lex_state = 138},
  [842] = {.lex_state = 95},
  [843] = {.lex_state = 138},
  [844] = {.lex_state = 135, .external_lex_state = 2},
  [845] = {.lex_state = 95},
  [846] = {.lex_state = 138},
  [847] = {.lex_state = 138},
  [848] = {.lex_state = 138},
  [849] = {.lex_state = 95},
  [850] = {.lex_state = 95},
  [851] = {.lex_state = 138},
  [852] = {.lex_state = 138},
  [853] = {.lex_state = 138},
  [854] = {.lex_state = 95},
  [855] = {.lex_state = 95},
  [856] = {.lex_state = 95},
  [857] = {.lex_state = 95},
  [858] = {.lex_state = 95},
  [859] = {.lex_state = 95},
  [860] = {.lex_state = 170, .external_lex_state = 2},
  [861] = {.lex_state = 140},
  [862] = {.lex_state = 170},
  [863] = {.lex_state = 95},
  [864] = {.lex_state = 95},
  [865] = {.lex_state = 95},
  [866] = {.lex_state = 95},
  [867] = {.lex_state = 170},
  [868] = {.lex_state = 140},
  [869] = {.lex_state = 170},
  [870] = {.lex_state = 170, .external_lex_state = 2},
  [871] = {.lex_state = 140},
  [872] = {.lex_state = 170},
  [873] = {.lex_state = 170, .external_lex_state = 2},
  [874] = {.lex_state = 140},
  [875] = {.lex_state = 169},
  [876] = {.lex_state = 111},
  [877] = {.lex_state = 131},
  [878] = {.lex_state = 102},
  [879] = {.lex_state = 160, .external_lex_state = 2},
  [880] = {.lex_state = 95},
  [881] = {.lex_state = 95},
  [882] = {.lex_state = 174, .external_lex_state = 2},
  [883] = {.lex_state = 102},
  [884] = {.lex_state = 95},
  [885] = {.lex_state = 102, .external_lex_state = 2},
  [886] = {.lex_state = 131},
  [887] = {.lex_state = 135, .external_lex_state = 2},
  [888] = {.lex_state = 95},
  [889] = {.lex_state = 135, .external_lex_state = 2},
  [890] = {.lex_state = 135, .external_lex_state = 2},
  [891] = {.lex_state = 135, .external_lex_state = 2},
  [892] = {.lex_state = 102, .external_lex_state = 2},
  [893] = {.lex_state = 102, .external_lex_state = 2},
  [894] = {.lex_state = 102, .external_lex_state = 2},
  [895] = {.lex_state = 131},
  [896] = {.lex_state = 135, .external_lex_state = 2},
  [897] = {.lex_state = 135, .external_lex_state = 2},
  [898] = {.lex_state = 102, .external_lex_state = 2},
  [899] = {.lex_state = 131},
  [900] = {.lex_state = 95},
  [901] = {.lex_state = 135, .external_lex_state = 2},
  [902] = {.lex_state = 95},
  [903] = {.lex_state = 135, .external_lex_state = 2},
  [904] = {.lex_state = 150},
  [905] = {.lex_state = 95},
  [906] = {.lex_state = 138},
  [907] = {.lex_state = 95},
  [908] = {.lex_state = 131},
  [909] = {.lex_state = 131},
  [910] = {.lex_state = 95},
  [911] = {.lex_state = 131},
  [912] = {.lex_state = 111, .external_lex_state = 2},
  [913] = {.lex_state = 111},
  [914] = {.lex_state = 102},
  [915] = {.lex_state = 138},
  [916] = {.lex_state = 138},
  [917] = {.lex_state = 138},
  [918] = {.lex_state = 140},
  [919] = {.lex_state = 140},
  [920] = {.lex_state = 169},
  [921] = {.lex_state = 140},
  [922] = {.lex_state = 169},
  [923] = {.lex_state = 140},
  [924] = {.lex_state = 140},
  [925] = {.lex_state = 169},
  [926] = {.lex_state = 140},
  [927] = {.lex_state = 140},
  [928] = {.lex_state = 169},
  [929] = {.lex_state = 140},
  [930] = {.lex_state = 140},
  [931] = {.lex_state = 140},
  [932] = {.lex_state = 102},
  [933] = {.lex_state = 131},
  [934] = {.lex_state = 169},
  [935] = {.lex_state = 140},
  [936] = {.lex_state = 169},
  [937] = {.lex_state = 169},
  [938] = {.lex_state = 169},
  [939] = {.lex_state = 169},
  [940] = {.lex_state = 140},
  [941] = {.lex_state = 169},
  [942] = {.lex_state = 169},
  [943] = {.lex_state = 140},
  [944] = {.lex_state = 169},
  [945] = {.lex_state = 140},
  [946] = {.lex_state = 140},
  [947] = {.lex_state = 140},
  [948] = {.lex_state = 138},
  [949] = {.lex_state = 160, .external_lex_state = 2},
  [950] = {.lex_state = 140},
  [951] = {.lex_state = 171},
  [952] = {.lex_state = 138},
  [953] = {.lex_state = 171},
  [954] = {.lex_state = 138, .external_lex_state = 2},
  [955] = {.lex_state = 95},
  [956] = {.lex_state = 138, .external_lex_state = 2},
  [957] = {.lex_state = 131},
  [958] = {.lex_state = 174, .external_lex_state = 2},
  [959] = {.lex_state = 95},
  [960] = {.lex_state = 174, .external_lex_state = 2},
  [961] = {.lex_state = 174, .external_lex_state = 2},
  [962] = {.lex_state = 174, .external_lex_state = 2},
  [963] = {.lex_state = 138, .external_lex_state = 2},
  [964] = {.lex_state = 138, .external_lex_state = 2},
  [965] = {.lex_state = 160, .external_lex_state = 2},
  [966] = {.lex_state = 131},
  [967] = {.lex_state = 138, .external_lex_state = 2},
  [968] = {.lex_state = 138, .external_lex_state = 2},
  [969] = {.lex_state = 171},
  [970] = {.lex_state = 172},
  [971] = {.lex_state = 150},
  [972] = {.lex_state = 174, .external_lex_state = 2},
  [973] = {.lex_state = 174, .external_lex_state = 2},
  [974] = {.lex_state = 174, .external_lex_state = 2},
  [975] = {.lex_state = 131},
  [976] = {.lex_state = 131},
  [977] = {.lex_state = 174, .external_lex_state = 2},
  [978] = {.lex_state = 131},
  [979] = {.lex_state = 174, .external_lex_state = 2},
  [980] = {.lex_state = 131},
  [981] = {.lex_state = 178},
  [982] = {.lex_state = 172},
  [983] = {.lex_state = 171},
  [984] = {.lex_state = 167},
  [985] = {.lex_state = 95},
  [986] = {.lex_state = 160, .external_lex_state = 2},
  [987] = {.lex_state = 169},
  [988] = {.lex_state = 140},
  [989] = {.lex_state = 111, .external_lex_state = 2},
  [990] = {.lex_state = 95, .external_lex_state = 2},
  [991] = {.lex_state = 138},
  [992] = {.lex_state = 138},
  [993] = {.lex_state = 138},
  [994] = {.lex_state = 138},
  [995] = {.lex_state = 138},
  [996] = {.lex_state = 111, .external_lex_state = 2},
  [997] = {.lex_state = 95},
  [998] = {.lex_state = 102},
  [999] = {.lex_state = 160, .external_lex_state = 2},
  [1000] = {.lex_state = 95},
  [1001] = {.lex_state = 138},
  [1002] = {.lex_state = 138},
  [1003] = {.lex_state = 138},
  [1004] = {.lex_state = 138},
  [1005] = {.lex_state = 138},
  [1006] = {.lex_state = 138},
  [1007] = {.lex_state = 140},
  [1008] = {.lex_state = 138},
  [1009] = {.lex_state = 95},
  [1010] = {.lex_state = 95},
  [1011] = {.lex_state = 95},
  [1012] = {.lex_state = 95},
  [1013] = {.lex_state = 95},
  [1014] = {.lex_state = 170},
  [1015] = {.lex_state = 170},
  [1016] = {.lex_state = 170},
  [1017] = {.lex_state = 95},
  [1018] = {.lex_state = 95},
  [1019] = {.lex_state = 170},
  [1020] = {.lex_state = 140},
  [1021] = {.lex_state = 170},
  [1022] = {.lex_state = 140},
  [1023] = {.lex_state = 170},
  [1024] = {.lex_state = 140},
  [1025] = {.lex_state = 138},
  [1026] = {.lex_state = 95},
  [1027] = {.lex_state = 95},
  [1028] = {.lex_state = 95},
  [1029] = {.lex_state = 95},
  [1030] = {.lex_state = 95},
  [1031] = {.lex_state = 131},
  [1032] = {.lex_state = 131},
  [1033] = {.lex_state = 138, .external_lex_state = 2},
  [1034] = {.lex_state = 102, .external_lex_state = 2},
  [1035] = {.lex_state = 95},
  [1036] = {.lex_state = 131},
  [1037] = {.lex_state = 131},
  [1038] = {.lex_state = 95},
  [1039] = {.lex_state = 135, .external_lex_state = 2},
  [1040] = {.lex_state = 102, .external_lex_state = 2},
  [1041] = {.lex_state = 102, .external_lex_state = 2},
  [1042] = {.lex_state = 102, .external_lex_state = 2},
  [1043] = {.lex_state = 95},
  [1044] = {.lex_state = 102, .external_lex_state = 2},
  [1045] = {.lex_state = 135, .external_lex_state = 2},
  [1046] = {.lex_state = 135, .external_lex_state = 2},
  [1047] = {.lex_state = 135, .external_lex_state = 2},
  [1048] = {.lex_state = 131},
  [1049] = {.lex_state = 135, .external_lex_state = 2},
  [1050] = {.lex_state = 138},
  [1051] = {.lex_state = 138},
  [1052] = {.lex_state = 95},
  [1053] = {.lex_state = 95},
  [1054] = {.lex_state = 131},
  [1055] = {.lex_state = 131},
  [1056] = {.lex_state = 95},
  [1057] = {.lex_state = 138},
  [1058] = {.lex_state = 138},
  [1059] = {.lex_state = 140},
  [1060] = {.lex_state = 140},
  [1061] = {.lex_state = 140},
  [1062] = {.lex_state = 140},
  [1063] = {.lex_state = 140},
  [1064] = {.lex_state = 169},
  [1065] = {.lex_state = 140},
  [1066] = {.lex_state = 169},
  [1067] = {.lex_state = 140},
  [1068] = {.lex_state = 140},
  [1069] = {.lex_state = 169},
  [1070] = {.lex_state = 140},
  [1071] = {.lex_state = 140},
  [1072] = {.lex_state = 169},
  [1073] = {.lex_state = 140},
  [1074] = {.lex_state = 102},
  [1075] = {.lex_state = 95},
  [1076] = {.lex_state = 171},
  [1077] = {.lex_state = 138},
  [1078] = {.lex_state = 138, .external_lex_state = 2},
  [1079] = {.lex_state = 95},
  [1080] = {.lex_state = 131},
  [1081] = {.lex_state = 131},
  [1082] = {.lex_state = 95},
  [1083] = {.lex_state = 174, .external_lex_state = 2},
  [1084] = {.lex_state = 138, .external_lex_state = 2},
  [1085] = {.lex_state = 138, .external_lex_state = 2},
  [1086] = {.lex_state = 174, .external_lex_state = 2},
  [1087] = {.lex_state = 174, .external_lex_state = 2},
  [1088] = {.lex_state = 131},
  [1089] = {.lex_state = 172},
  [1090] = {.lex_state = 174, .external_lex_state = 2},
  [1091] = {.lex_state = 174, .external_lex_state = 2},
  [1092] = {.lex_state = 131},
  [1093] = {.lex_state = 170},
  [1094] = {.lex_state = 95, .external_lex_state = 2},
  [1095] = {.lex_state = 95},
  [1096] = {.lex_state = 102, .external_lex_state = 2},
  [1097] = {.lex_state = 160, .external_lex_state = 2},
  [1098] = {.lex_state = 138},
  [1099] = {.lex_state = 95},
  [1100] = {.lex_state = 95, .external_lex_state = 2},
  [1101] = {.lex_state = 170},
  [1102] = {.lex_state = 170},
  [1103] = {.lex_state = 170},
  [1104] = {.lex_state = 95},
  [1105] = {.lex_state = 95},
  [1106] = {.lex_state = 95},
  [1107] = {.lex_state = 138},
  [1108] = {.lex_state = 138},
  [1109] = {.lex_state = 95},
  [1110] = {.lex_state = 95},
  [1111] = {.lex_state = 95},
  [1112] = {.lex_state = 138},
  [1113] = {.lex_state = 138},
  [1114] = {.lex_state = 138},
  [1115] = {.lex_state = 138},
  [1116] = {.lex_state = 138},
  [1117] = {.lex_state = 102},
  [1118] = {.lex_state = 102},
  [1119] = {.lex_state = 102, .external_lex_state = 2},
  [1120] = {.lex_state = 95},
  [1121] = {.lex_state = 131},
  [1122] = {.lex_state = 102, .external_lex_state = 2},
  [1123] = {.lex_state = 102, .external_lex_state = 2},
  [1124] = {.lex_state = 102, .external_lex_state = 2},
  [1125] = {.lex_state = 131},
  [1126] = {.lex_state = 95},
  [1127] = {.lex_state = 135, .external_lex_state = 2},
  [1128] = {.lex_state = 102, .external_lex_state = 2},
  [1129] = {.lex_state = 95},
  [1130] = {.lex_state = 138},
  [1131] = {.lex_state = 95},
  [1132] = {.lex_state = 95},
  [1133] = {.lex_state = 131},
  [1134] = {.lex_state = 138},
  [1135] = {.lex_state = 140},
  [1136] = {.lex_state = 140},
  [1137] = {.lex_state = 140},
  [1138] = {.lex_state = 140},
  [1139] = {.lex_state = 138},
  [1140] = {.lex_state = 171},
  [1141] = {.lex_state = 138, .external_lex_state = 2},
  [1142] = {.lex_state = 95},
  [1143] = {.lex_state = 131},
  [1144] = {.lex_state = 138, .external_lex_state = 2},
  [1145] = {.lex_state = 131},
  [1146] = {.lex_state = 95},
  [1147] = {.lex_state = 174, .external_lex_state = 2},
  [1148] = {.lex_state = 174, .external_lex_state = 2},
  [1149] = {.lex_state = 174, .external_lex_state = 2},
  [1150] = {.lex_state = 95},
  [1151] = {.lex_state = 95},
  [1152] = {.lex_state = 95},
  [1153] = {.lex_state = 138},
  [1154] = {.lex_state = 138},
  [1155] = {.lex_state = 138},
  [1156] = {.lex_state = 138},
  [1157] = {.lex_state = 138},
  [1158] = {.lex_state = 138},
  [1159] = {.lex_state = 138, .external_lex_state = 2},
  [1160] = {.lex_state = 138, .external_lex_state = 2},
  [1161] = {.lex_state = 102, .external_lex_state = 2},
  [1162] = {.lex_state = 95},
  [1163] = {.lex_state = 102, .external_lex_state = 2},
  [1164] = {.lex_state = 131},
  [1165] = {.lex_state = 102, .external_lex_state = 2},
  [1166] = {.lex_state = 102, .external_lex_state = 2},
  [1167] = {.lex_state = 138},
  [1168] = {.lex_state = 95},
  [1169] = {.lex_state = 95},
  [1170] = {.lex_state = 138, .external_lex_state = 2},
  [1171] = {.lex_state = 95},
  [1172] = {.lex_state = 131},
  [1173] = {.lex_state = 138, .external_lex_state = 2},
  [1174] = {.lex_state = 174, .external_lex_state = 2},
  [1175] = {.lex_state = 138},
  [1176] = {.lex_state = 138},
  [1177] = {.lex_state = 138},
  [1178] = {.lex_state = 102, .external_lex_state = 2},
  [1179] = {.lex_state = 95},
  [1180] = {.lex_state = 102, .external_lex_state = 2},
  [1181] = {.lex_state = 138},
  [1182] = {.lex_state = 95},
  [1183] = {.lex_state = 138, .external_lex_state = 2},
  [1184] = {.lex_state = 95},
  [1185] = {.lex_state = 102, .external_lex_state = 2},
  [1186] = {.lex_state = 138},
  [1187] = {.lex_state = 138, .external_lex_state = 2},
  [1188] = {.lex_state = 185},
  [1189] = {.lex_state = 95},
  [1190] = {.lex_state = 185},
  [1191] = {.lex_state = 186},
  [1192] = {.lex_state = 95},
  [1193] = {.lex_state = 95},
  [1194] = {.lex_state = 186},
  [1195] = {.lex_state = 176},
  [1196] = {.lex_state = 185},
  [1197] = {.lex_state = 95},
  [1198] = {.lex_state = 95},
  [1199] = {.lex_state = 131},
  [1200] = {.lex_state = 111, .external_lex_state = 2},
  [1201] = {.lex_state = 185},
  [1202] = {.lex_state = 176},
  [1203] = {.lex_state = 160, .external_lex_state = 2},
  [1204] = {.lex_state = 111, .external_lex_state = 2},
  [1205] = {.lex_state = 95},
  [1206] = {.lex_state = 176},
  [1207] = {.lex_state = 95},
  [1208] = {.lex_state = 95},
  [1209] = {.lex_state = 95},
  [1210] = {.lex_state = 95},
  [1211] = {.lex_state = 186},
  [1212] = {.lex_state = 186},
  [1213] = {.lex_state = 95},
  [1214] = {.lex_state = 95},
  [1215] = {.lex_state = 186},
  [1216] = {.lex_state = 185},
  [1217] = {.lex_state = 185},
  [1218] = {.lex_state = 176},
  [1219] = {.lex_state = 186},
  [1220] = {.lex_state = 176},
  [1221] = {.lex_state = 186},
  [1222] = {.lex_state = 186},
  [1223] = {.lex_state = 176},
  [1224] = {.lex_state = 138},
  [1225] = {.lex_state = 111, .external_lex_state = 2},
  [1226] = {.lex_state = 138},
  [1227] = {.lex_state = 176},
  [1228] = {.lex_state = 160, .external_lex_state = 2},
  [1229] = {.lex_state = 176},
  [1230] = {.lex_state = 186},
  [1231] = {.lex_state = 138, .external_lex_state = 2},
  [1232] = {.lex_state = 186},
  [1233] = {.lex_state = 102},
  [1234] = {.lex_state = 95},
  [1235] = {.lex_state = 135},
  [1236] = {.lex_state = 95},
  [1237] = {.lex_state = 138, .external_lex_state = 2},
  [1238] = {.lex_state = 111, .external_lex_state = 2},
  [1239] = {.lex_state = 131},
  [1240] = {.lex_state = 169},
  [1241] = {.lex_state = 169},
  [1242] = {.lex_state = 169},
  [1243] = {.lex_state = 169},
  [1244] = {.lex_state = 169},
  [1245] = {.lex_state = 160, .external_lex_state = 2},
  [1246] = {.lex_state = 169},
  [1247] = {.lex_state = 170},
  [1248] = {.lex_state = 170},
  [1249] = {.lex_state = 170},
  [1250] = {.lex_state = 140},
  [1251] = {.lex_state = 111, .external_lex_state = 2},
  [1252] = {.lex_state = 150},
  [1253] = {.lex_state = 150},
  [1254] = {.lex_state = 111, .external_lex_state = 2},
  [1255] = {.lex_state = 111, .external_lex_state = 2},
  [1256] = {.lex_state = 111, .external_lex_state = 2},
  [1257] = {.lex_state = 150},
  [1258] = {.lex_state = 111, .external_lex_state = 2},
  [1259] = {.lex_state = 111, .external_lex_state = 2},
  [1260] = {.lex_state = 185},
  [1261] = {.lex_state = 186},
  [1262] = {.lex_state = 185},
  [1263] = {.lex_state = 185},
  [1264] = {.lex_state = 185},
  [1265] = {.lex_state = 185},
  [1266] = {.lex_state = 186},
  [1267] = {.lex_state = 187},
  [1268] = {.lex_state = 186},
  [1269] = {.lex_state = 186},
  [1270] = {.lex_state = 95},
  [1271] = {.lex_state = 138, .external_lex_state = 2},
  [1272] = {.lex_state = 160, .external_lex_state = 2},
  [1273] = {.lex_state = 186},
  [1274] = {.lex_state = 150},
  [1275] = {.lex_state = 138, .external_lex_state = 2},
  [1276] = {.lex_state = 186},
  [1277] = {.lex_state = 95},
  [1278] = {.lex_state = 95},
  [1279] = {.lex_state = 95},
  [1280] = {.lex_state = 95},
  [1281] = {.lex_state = 95},
  [1282] = {.lex_state = 186},
  [1283] = {.lex_state = 131},
  [1284] = {.lex_state = 95},
  [1285] = {.lex_state = 95},
  [1286] = {.lex_state = 186},
  [1287] = {.lex_state = 186},
  [1288] = {.lex_state = 186},
  [1289] = {.lex_state = 176},
  [1290] = {.lex_state = 176},
  [1291] = {.lex_state = 176},
  [1292] = {.lex_state = 176},
  [1293] = {.lex_state = 187},
  [1294] = {.lex_state = 186},
  [1295] = {.lex_state = 186},
  [1296] = {.lex_state = 176},
  [1297] = {.lex_state = 176},
  [1298] = {.lex_state = 187},
  [1299] = {.lex_state = 174, .external_lex_state = 2},
  [1300] = {.lex_state = 174, .external_lex_state = 2},
  [1301] = {.lex_state = 174, .external_lex_state = 2},
  [1302] = {.lex_state = 186},
  [1303] = {.lex_state = 138, .external_lex_state = 2},
  [1304] = {.lex_state = 111, .external_lex_state = 2},
  [1305] = {.lex_state = 186},
  [1306] = {.lex_state = 186},
  [1307] = {.lex_state = 138, .external_lex_state = 2},
  [1308] = {.lex_state = 138, .external_lex_state = 2},
  [1309] = {.lex_state = 138},
  [1310] = {.lex_state = 160, .external_lex_state = 2},
  [1311] = {.lex_state = 186},
  [1312] = {.lex_state = 111, .external_lex_state = 2},
  [1313] = {.lex_state = 174},
  [1314] = {.lex_state = 131},
  [1315] = {.lex_state = 186},
  [1316] = {.lex_state = 186},
  [1317] = {.lex_state = 138, .external_lex_state = 2},
  [1318] = {.lex_state = 186},
  [1319] = {.lex_state = 174, .external_lex_state = 2},
  [1320] = {.lex_state = 174, .external_lex_state = 2},
  [1321] = {.lex_state = 174, .external_lex_state = 2},
  [1322] = {.lex_state = 186},
  [1323] = {.lex_state = 163, .external_lex_state = 2},
  [1324] = {.lex_state = 131},
  [1325] = {.lex_state = 160, .external_lex_state = 2},
  [1326] = {.lex_state = 95},
  [1327] = {.lex_state = 95},
  [1328] = {.lex_state = 95},
  [1329] = {.lex_state = 138, .external_lex_state = 2},
  [1330] = {.lex_state = 160, .external_lex_state = 2},
  [1331] = {.lex_state = 150},
  [1332] = {.lex_state = 150},
  [1333] = {.lex_state = 111, .external_lex_state = 2},
  [1334] = {.lex_state = 111, .external_lex_state = 2},
  [1335] = {.lex_state = 163, .external_lex_state = 2},
  [1336] = {.lex_state = 111, .external_lex_state = 2},
  [1337] = {.lex_state = 111, .external_lex_state = 2},
  [1338] = {.lex_state = 111, .external_lex_state = 2},
  [1339] = {.lex_state = 111, .external_lex_state = 2},
  [1340] = {.lex_state = 111, .external_lex_state = 2},
  [1341] = {.lex_state = 131},
  [1342] = {.lex_state = 138},
  [1343] = {.lex_state = 111, .external_lex_state = 2},
  [1344] = {.lex_state = 111, .external_lex_state = 2},
  [1345] = {.lex_state = 111, .external_lex_state = 2},
  [1346] = {.lex_state = 150},
  [1347] = {.lex_state = 150},
  [1348] = {.lex_state = 150},
  [1349] = {.lex_state = 111, .external_lex_state = 2},
  [1350] = {.lex_state = 150},
  [1351] = {.lex_state = 188},
  [1352] = {.lex_state = 111, .external_lex_state = 2},
  [1353] = {.lex_state = 186},
  [1354] = {.lex_state = 186},
  [1355] = {.lex_state = 186},
  [1356] = {.lex_state = 186},
  [1357] = {.lex_state = 138, .external_lex_state = 2},
  [1358] = {.lex_state = 138, .external_lex_state = 2},
  [1359] = {.lex_state = 174, .external_lex_state = 2},
  [1360] = {.lex_state = 176},
  [1361] = {.lex_state = 176},
  [1362] = {.lex_state = 176},
  [1363] = {.lex_state = 176},
  [1364] = {.lex_state = 176},
  [1365] = {.lex_state = 176},
  [1366] = {.lex_state = 186},
  [1367] = {.lex_state = 186},
  [1368] = {.lex_state = 185},
  [1369] = {.lex_state = 186},
  [1370] = {.lex_state = 185},
  [1371] = {.lex_state = 95},
  [1372] = {.lex_state = 95},
  [1373] = {.lex_state = 185},
  [1374] = {.lex_state = 131},
  [1375] = {.lex_state = 102},
  [1376] = {.lex_state = 176},
  [1377] = {.lex_state = 138, .external_lex_state = 2},
  [1378] = {.lex_state = 138, .external_lex_state = 2},
  [1379] = {.lex_state = 187},
  [1380] = {.lex_state = 186},
  [1381] = {.lex_state = 138, .external_lex_state = 2},
  [1382] = {.lex_state = 138, .external_lex_state = 2},
  [1383] = {.lex_state = 138, .external_lex_state = 2},
  [1384] = {.lex_state = 171},
  [1385] = {.lex_state = 186},
  [1386] = {.lex_state = 111, .external_lex_state = 2},
  [1387] = {.lex_state = 135, .external_lex_state = 2},
  [1388] = {.lex_state = 186},
  [1389] = {.lex_state = 186},
  [1390] = {.lex_state = 135},
  [1391] = {.lex_state = 186},
  [1392] = {.lex_state = 138, .external_lex_state = 2},
  [1393] = {.lex_state = 160, .external_lex_state = 2},
  [1394] = {.lex_state = 95},
  [1395] = {.lex_state = 186},
  [1396] = {.lex_state = 176},
  [1397] = {.lex_state = 186},
  [1398] = {.lex_state = 176},
  [1399] = {.lex_state = 111, .external_lex_state = 2},
  [1400] = {.lex_state = 138, .external_lex_state = 2},
  [1401] = {.lex_state = 111, .external_lex_state = 2},
  [1402] = {.lex_state = 111, .external_lex_state = 2},
  [1403] = {.lex_state = 111, .external_lex_state = 2},
  [1404] = {.lex_state = 131},
  [1405] = {.lex_state = 163, .external_lex_state = 2},
  [1406] = {.lex_state = 111, .external_lex_state = 2},
  [1407] = {.lex_state = 150},
  [1408] = {.lex_state = 174, .external_lex_state = 2},
  [1409] = {.lex_state = 174, .external_lex_state = 2},
  [1410] = {.lex_state = 111, .external_lex_state = 2},
  [1411] = {.lex_state = 174, .external_lex_state = 2},
  [1412] = {.lex_state = 111, .external_lex_state = 2},
  [1413] = {.lex_state = 111, .external_lex_state = 2},
  [1414] = {.lex_state = 111, .external_lex_state = 2},
  [1415] = {.lex_state = 111, .external_lex_state = 2},
  [1416] = {.lex_state = 150},
  [1417] = {.lex_state = 111, .external_lex_state = 2},
  [1418] = {.lex_state = 111, .external_lex_state = 2},
  [1419] = {.lex_state = 111, .external_lex_state = 2},
  [1420] = {.lex_state = 186},
  [1421] = {.lex_state = 138, .external_lex_state = 2},
  [1422] = {.lex_state = 111, .external_lex_state = 2},
  [1423] = {.lex_state = 186},
  [1424] = {.lex_state = 138, .external_lex_state = 2},
  [1425] = {.lex_state = 95},
  [1426] = {.lex_state = 131},
  [1427] = {.lex_state = 185},
  [1428] = {.lex_state = 186},
  [1429] = {.lex_state = 102},
  [1430] = {.lex_state = 102},
  [1431] = {.lex_state = 111, .external_lex_state = 2},
  [1432] = {.lex_state = 186},
  [1433] = {.lex_state = 186},
  [1434] = {.lex_state = 138, .external_lex_state = 2},
  [1435] = {.lex_state = 138, .external_lex_state = 2},
  [1436] = {.lex_state = 138, .external_lex_state = 2},
  [1437] = {.lex_state = 138, .external_lex_state = 2},
  [1438] = {.lex_state = 138, .external_lex_state = 2},
  [1439] = {.lex_state = 102, .external_lex_state = 2},
  [1440] = {.lex_state = 111, .external_lex_state = 2},
  [1441] = {.lex_state = 174},
  [1442] = {.lex_state = 131},
  [1443] = {.lex_state = 150},
  [1444] = {.lex_state = 138, .external_lex_state = 2},
  [1445] = {.lex_state = 186},
  [1446] = {.lex_state = 160, .external_lex_state = 2},
  [1447] = {.lex_state = 138, .external_lex_state = 2},
  [1448] = {.lex_state = 111, .external_lex_state = 2},
  [1449] = {.lex_state = 111, .external_lex_state = 2},
  [1450] = {.lex_state = 163, .external_lex_state = 2},
  [1451] = {.lex_state = 131},
  [1452] = {.lex_state = 111, .external_lex_state = 2},
  [1453] = {.lex_state = 111, .external_lex_state = 2},
  [1454] = {.lex_state = 150},
  [1455] = {.lex_state = 111, .external_lex_state = 2},
  [1456] = {.lex_state = 111, .external_lex_state = 2},
  [1457] = {.lex_state = 111, .external_lex_state = 2},
  [1458] = {.lex_state = 111, .external_lex_state = 2},
  [1459] = {.lex_state = 186},
  [1460] = {.lex_state = 138, .external_lex_state = 2},
  [1461] = {.lex_state = 176},
  [1462] = {.lex_state = 102},
  [1463] = {.lex_state = 111, .external_lex_state = 2},
  [1464] = {.lex_state = 138, .external_lex_state = 2},
  [1465] = {.lex_state = 138, .external_lex_state = 2},
  [1466] = {.lex_state = 138, .external_lex_state = 2},
  [1467] = {.lex_state = 135, .external_lex_state = 2},
  [1468] = {.lex_state = 131},
  [1469] = {.lex_state = 138, .external_lex_state = 2},
  [1470] = {.lex_state = 160, .external_lex_state = 2},
  [1471] = {.lex_state = 163, .external_lex_state = 2},
  [1472] = {.lex_state = 174, .external_lex_state = 2},
  [1473] = {.lex_state = 111, .external_lex_state = 2},
  [1474] = {.lex_state = 187},
  [1475] = {.lex_state = 111, .external_lex_state = 2},
  [1476] = {.lex_state = 138, .external_lex_state = 2},
  [1477] = {.lex_state = 138, .external_lex_state = 2},
  [1478] = {.lex_state = 163, .external_lex_state = 2},
  [1479] = {.lex_state = 138, .external_lex_state = 2},
  [1480] = {.lex_state = 138, .external_lex_state = 2},
  [1481] = {.lex_state = 138, .external_lex_state = 2},
  [1482] = {.lex_state = 111, .external_lex_state = 2},
  [1483] = {.lex_state = 186},
  [1484] = {.lex_state = 111, .external_lex_state = 2},
  [1485] = {.lex_state = 186},
  [1486] = {.lex_state = 102},
  [1487] = {.lex_state = 186},
  [1488] = {.lex_state = 174, .external_lex_state = 2},
  [1489] = {.lex_state = 150},
  [1490] = {.lex_state = 150},
  [1491] = {.lex_state = 174, .external_lex_state = 2},
  [1492] = {.lex_state = 174, .external_lex_state = 2},
  [1493] = {.lex_state = 174, .external_lex_state = 2},
  [1494] = {.lex_state = 150},
  [1495] = {.lex_state = 174, .external_lex_state = 2},
  [1496] = {.lex_state = 174, .external_lex_state = 2},
  [1497] = {.lex_state = 102},
  [1498] = {.lex_state = 174, .external_lex_state = 2},
  [1499] = {.lex_state = 174, .external_lex_state = 2},
  [1500] = {.lex_state = 174, .external_lex_state = 2},
  [1501] = {.lex_state = 102},
  [1502] = {.lex_state = 174, .external_lex_state = 2},
  [1503] = {.lex_state = 138},
  [1504] = {.lex_state = 111, .external_lex_state = 2},
  [1505] = {.lex_state = 186},
  [1506] = {.lex_state = 102},
  [1507] = {.lex_state = 186},
  [1508] = {.lex_state = 160, .external_lex_state = 2},
  [1509] = {.lex_state = 102},
  [1510] = {.lex_state = 102},
  [1511] = {.lex_state = 160, .external_lex_state = 2},
  [1512] = {.lex_state = 186},
  [1513] = {.lex_state = 111, .external_lex_state = 2},
  [1514] = {.lex_state = 150},
  [1515] = {.lex_state = 150},
  [1516] = {.lex_state = 174, .external_lex_state = 2},
  [1517] = {.lex_state = 174, .external_lex_state = 2},
  [1518] = {.lex_state = 174, .external_lex_state = 2},
  [1519] = {.lex_state = 174, .external_lex_state = 2},
  [1520] = {.lex_state = 174, .external_lex_state = 2},
  [1521] = {.lex_state = 174, .external_lex_state = 2},
  [1522] = {.lex_state = 174, .external_lex_state = 2},
  [1523] = {.lex_state = 174, .external_lex_state = 2},
  [1524] = {.lex_state = 186},
  [1525] = {.lex_state = 174, .external_lex_state = 2},
  [1526] = {.lex_state = 174, .external_lex_state = 2},
  [1527] = {.lex_state = 150},
  [1528] = {.lex_state = 150},
  [1529] = {.lex_state = 150},
  [1530] = {.lex_state = 174, .external_lex_state = 2},
  [1531] = {.lex_state = 150},
  [1532] = {.lex_state = 180},
  [1533] = {.lex_state = 186},
  [1534] = {.lex_state = 183},
  [1535] = {.lex_state = 167},
  [1536] = {.lex_state = 183},
  [1537] = {.lex_state = 183},
  [1538] = {.lex_state = 131},
  [1539] = {.lex_state = 138},
  [1540] = {.lex_state = 111, .external_lex_state = 2},
  [1541] = {.lex_state = 102},
  [1542] = {.lex_state = 186},
  [1543] = {.lex_state = 160, .external_lex_state = 2},
  [1544] = {.lex_state = 102},
  [1545] = {.lex_state = 174, .external_lex_state = 2},
  [1546] = {.lex_state = 102},
  [1547] = {.lex_state = 186},
  [1548] = {.lex_state = 186},
  [1549] = {.lex_state = 174, .external_lex_state = 2},
  [1550] = {.lex_state = 174, .external_lex_state = 2},
  [1551] = {.lex_state = 174, .external_lex_state = 2},
  [1552] = {.lex_state = 174, .external_lex_state = 2},
  [1553] = {.lex_state = 174, .external_lex_state = 2},
  [1554] = {.lex_state = 150},
  [1555] = {.lex_state = 186},
  [1556] = {.lex_state = 174, .external_lex_state = 2},
  [1557] = {.lex_state = 174, .external_lex_state = 2},
  [1558] = {.lex_state = 174, .external_lex_state = 2},
  [1559] = {.lex_state = 174, .external_lex_state = 2},
  [1560] = {.lex_state = 150},
  [1561] = {.lex_state = 174, .external_lex_state = 2},
  [1562] = {.lex_state = 174, .external_lex_state = 2},
  [1563] = {.lex_state = 174, .external_lex_state = 2},
  [1564] = {.lex_state = 186},
  [1565] = {.lex_state = 170},
  [1566] = {.lex_state = 131},
  [1567] = {.lex_state = 183},
  [1568] = {.lex_state = 167},
  [1569] = {.lex_state = 186},
  [1570] = {.lex_state = 138},
  [1571] = {.lex_state = 187},
  [1572] = {.lex_state = 186},
  [1573] = {.lex_state = 150},
  [1574] = {.lex_state = 102},
  [1575] = {.lex_state = 186},
  [1576] = {.lex_state = 174, .external_lex_state = 2},
  [1577] = {.lex_state = 174, .external_lex_state = 2},
  [1578] = {.lex_state = 174, .external_lex_state = 2},
  [1579] = {.lex_state = 174, .external_lex_state = 2},
  [1580] = {.lex_state = 150},
  [1581] = {.lex_state = 174, .external_lex_state = 2},
  [1582] = {.lex_state = 174, .external_lex_state = 2},
  [1583] = {.lex_state = 174, .external_lex_state = 2},
  [1584] = {.lex_state = 186},
  [1585] = {.lex_state = 186},
  [1586] = {.lex_state = 138, .external_lex_state = 2},
  [1587] = {.lex_state = 174, .external_lex_state = 2},
  [1588] = {.lex_state = 174, .external_lex_state = 2},
  [1589] = {.lex_state = 183},
  [1590] = {.lex_state = 186},
  [1591] = {.lex_state = 174, .external_lex_state = 2},
  [1592] = {.lex_state = 186},
  [1593] = {.lex_state = 138},
  [1594] = {.lex_state = 186},
  [1595] = {.lex_state = 171},
  [1596] = {.lex_state = 186},
  [1597] = {.lex_state = 150},
  [1598] = {.lex_state = 150},
  [1599] = {.lex_state = 186},
  [1600] = {.lex_state = 186},
  [1601] = {.lex_state = 186},
  [1602] = {.lex_state = 150},
  [1603] = {.lex_state = 186},
  [1604] = {.lex_state = 186},
  [1605] = {.lex_state = 186},
  [1606] = {.lex_state = 186},
  [1607] = {.lex_state = 171},
  [1608] = {.lex_state = 138},
  [1609] = {.lex_state = 138},
  [1610] = {.lex_state = 186},
  [1611] = {.lex_state = 186},
  [1612] = {.lex_state = 150},
  [1613] = {.lex_state = 150},
  [1614] = {.lex_state = 186},
  [1615] = {.lex_state = 186},
  [1616] = {.lex_state = 186},
  [1617] = {.lex_state = 186},
  [1618] = {.lex_state = 186},
  [1619] = {.lex_state = 186},
  [1620] = {.lex_state = 186},
  [1621] = {.lex_state = 186},
  [1622] = {.lex_state = 167},
  [1623] = {.lex_state = 186},
  [1624] = {.lex_state = 186},
  [1625] = {.lex_state = 150},
  [1626] = {.lex_state = 150},
  [1627] = {.lex_state = 150},
  [1628] = {.lex_state = 186},
  [1629] = {.lex_state = 150},
  [1630] = {.lex_state = 138},
  [1631] = {.lex_state = 190},
  [1632] = {.lex_state = 177},
  [1633] = {.lex_state = 190},
  [1634] = {.lex_state = 190},
  [1635] = {.lex_state = 186},
  [1636] = {.lex_state = 138},
  [1637] = {.lex_state = 138},
  [1638] = {.lex_state = 138},
  [1639] = {.lex_state = 186},
  [1640] = {.lex_state = 186},
  [1641] = {.lex_state = 186},
  [1642] = {.lex_state = 186},
  [1643] = {.lex_state = 186},
  [1644] = {.lex_state = 150},
  [1645] = {.lex_state = 177},
  [1646] = {.lex_state = 186},
  [1647] = {.lex_state = 186},
  [1648] = {.lex_state = 186},
  [1649] = {.lex_state = 186},
  [1650] = {.lex_state = 150},
  [1651] = {.lex_state = 186},
  [1652] = {.lex_state = 186},
  [1653] = {.lex_state = 186},
  [1654] = {.lex_state = 138},
  [1655] = {.lex_state = 131},
  [1656] = {.lex_state = 190},
  [1657] = {.lex_state = 177},
  [1658] = {.lex_state = 138},
  [1659] = {.lex_state = 183},
  [1660] = {.lex_state = 138},
  [1661] = {.lex_state = 138},
  [1662] = {.lex_state = 186},
  [1663] = {.lex_state = 186},
  [1664] = {.lex_state = 186},
  [1665] = {.lex_state = 186},
  [1666] = {.lex_state = 150},
  [1667] = {.lex_state = 186},
  [1668] = {.lex_state = 186},
  [1669] = {.lex_state = 186},
  [1670] = {.lex_state = 138},
  [1671] = {.lex_state = 138},
  [1672] = {.lex_state = 186},
  [1673] = {.lex_state = 186},
  [1674] = {.lex_state = 190},
  [1675] = {.lex_state = 138},
  [1676] = {.lex_state = 186},
  [1677] = {.lex_state = 174, .external_lex_state = 2},
  [1678] = {.lex_state = 138},
  [1679] = {.lex_state = 138},
  [1680] = {.lex_state = 174, .external_lex_state = 2},
  [1681] = {.lex_state = 138, .external_lex_state = 2},
  [1682] = {.lex_state = 138, .external_lex_state = 2},
  [1683] = {.lex_state = 150},
  [1684] = {.lex_state = 150},
  [1685] = {.lex_state = 177},
  [1686] = {.lex_state = 150},
  [1687] = {.lex_state = 150},
  [1688] = {.lex_state = 150},
  [1689] = {.lex_state = 150},
  [1690] = {.lex_state = 102, .external_lex_state = 2},
  [1691] = {.lex_state = 177},
  [1692] = {.lex_state = 102, .external_lex_state = 2},
  [1693] = {.lex_state = 102, .external_lex_state = 2},
  [1694] = {.lex_state = 174, .external_lex_state = 2},
  [1695] = {.lex_state = 138},
  [1696] = {.lex_state = 138},
  [1697] = {.lex_state = 138},
  [1698] = {.lex_state = 150},
  [1699] = {.lex_state = 111, .external_lex_state = 2},
  [1700] = {.lex_state = 150},
  [1701] = {.lex_state = 138},
  [1702] = {.lex_state = 138},
  [1703] = {.lex_state = 131},
  [1704] = {.lex_state = 168, .external_lex_state = 2},
  [1705] = {.lex_state = 160, .external_lex_state = 2},
  [1706] = {.lex_state = 183},
  [1707] = {.lex_state = 138},
  [1708] = {.lex_state = 150},
  [1709] = {.lex_state = 138},
  [1710] = {.lex_state = 138},
  [1711] = {.lex_state = 190},
  [1712] = {.lex_state = 177},
  [1713] = {.lex_state = 168, .external_lex_state = 2},
  [1714] = {.lex_state = 111, .external_lex_state = 2},
  [1715] = {.lex_state = 168, .external_lex_state = 2},
  [1716] = {.lex_state = 168, .external_lex_state = 2},
  [1717] = {.lex_state = 160, .external_lex_state = 2},
  [1718] = {.lex_state = 131},
  [1719] = {.lex_state = 190},
  [1720] = {.lex_state = 102, .external_lex_state = 2},
  [1721] = {.lex_state = 111, .external_lex_state = 2},
  [1722] = {.lex_state = 190},
  [1723] = {.lex_state = 160, .external_lex_state = 2},
  [1724] = {.lex_state = 190},
  [1725] = {.lex_state = 190},
  [1726] = {.lex_state = 131},
  [1727] = {.lex_state = 190},
  [1728] = {.lex_state = 168, .external_lex_state = 2},
  [1729] = {.lex_state = 160, .external_lex_state = 2},
  [1730] = {.lex_state = 131},
  [1731] = {.lex_state = 102, .external_lex_state = 2},
  [1732] = {.lex_state = 168, .external_lex_state = 2},
  [1733] = {.lex_state = 107, .external_lex_state = 3},
  [1734] = {.lex_state = 102, .external_lex_state = 2},
  [1735] = {.lex_state = 123},
  [1736] = {.lex_state = 131},
  [1737] = {.lex_state = 95},
  [1738] = {.lex_state = 138},
  [1739] = {.lex_state = 142},
  [1740] = {.lex_state = 102},
  [1741] = {.lex_state = 95},
  [1742] = {.lex_state = 95},
  [1743] = {.lex_state = 95},
  [1744] = {.lex_state = 107, .external_lex_state = 3},
  [1745] = {.lex_state = 95},
  [1746] = {.lex_state = 138},
  [1747] = {.lex_state = 102, .external_lex_state = 2},
  [1748] = {.lex_state = 140},
  [1749] = {.lex_state = 95},
  [1750] = {.lex_state = 131},
  [1751] = {.lex_state = 95},
  [1752] = {.lex_state = 95},
  [1753] = {.lex_state = 123},
  [1754] = {.lex_state = 167},
  [1755] = {.lex_state = 131},
  [1756] = {.lex_state = 131},
  [1757] = {.lex_state = 95},
  [1758] = {.lex_state = 138},
  [1759] = {.lex_state = 95},
  [1760] = {.lex_state = 95},
  [1761] = {.lex_state = 95},
  [1762] = {.lex_state = 95},
  [1763] = {.lex_state = 95},
  [1764] = {.lex_state = 168, .external_lex_state = 2},
  [1765] = {.lex_state = 168, .external_lex_state = 2},
  [1766] = {.lex_state = 168, .external_lex_state = 2},
  [1767] = {.lex_state = 168, .external_lex_state = 2},
  [1768] = {.lex_state = 168, .external_lex_state = 2},
  [1769] = {.lex_state = 168, .external_lex_state = 2},
  [1770] = {.lex_state = 168, .external_lex_state = 2},
  [1771] = {.lex_state = 168, .external_lex_state = 2},
  [1772] = {.lex_state = 168, .external_lex_state = 2},
  [1773] = {.lex_state = 168, .external_lex_state = 2},
  [1774] = {.lex_state = 168, .external_lex_state = 2},
  [1775] = {.lex_state = 168, .external_lex_state = 2},
  [1776] = {.lex_state = 138},
  [1777] = {.lex_state = 138},
  [1778] = {.lex_state = 138},
  [1779] = {.lex_state = 140},
  [1780] = {.lex_state = 170},
  [1781] = {.lex_state = 140},
  [1782] = {.lex_state = 102},
  [1783] = {.lex_state = 102},
  [1784] = {.lex_state = 102, .external_lex_state = 2},
  [1785] = {.lex_state = 95},
  [1786] = {.lex_state = 142},
  [1787] = {.lex_state = 138},
  [1788] = {.lex_state = 150},
  [1789] = {.lex_state = 138},
  [1790] = {.lex_state = 150},
  [1791] = {.lex_state = 95},
  [1792] = {.lex_state = 95},
  [1793] = {.lex_state = 95},
  [1794] = {.lex_state = 150},
  [1795] = {.lex_state = 135},
  [1796] = {.lex_state = 102},
  [1797] = {.lex_state = 173},
  [1798] = {.lex_state = 95},
  [1799] = {.lex_state = 95},
  [1800] = {.lex_state = 111},
  [1801] = {.lex_state = 95, .external_lex_state = 2},
  [1802] = {.lex_state = 95},
  [1803] = {.lex_state = 150},
  [1804] = {.lex_state = 131},
  [1805] = {.lex_state = 95},
  [1806] = {.lex_state = 95},
  [1807] = {.lex_state = 111, .external_lex_state = 2},
  [1808] = {.lex_state = 111, .external_lex_state = 2},
  [1809] = {.lex_state = 111, .external_lex_state = 2},
  [1810] = {.lex_state = 111, .external_lex_state = 2},
  [1811] = {.lex_state = 111, .external_lex_state = 2},
  [1812] = {.lex_state = 111, .external_lex_state = 2},
  [1813] = {.lex_state = 174},
  [1814] = {.lex_state = 174},
  [1815] = {.lex_state = 174},
  [1816] = {.lex_state = 174},
  [1817] = {.lex_state = 174},
  [1818] = {.lex_state = 95},
  [1819] = {.lex_state = 102, .external_lex_state = 2},
  [1820] = {.lex_state = 167},
  [1821] = {.lex_state = 131},
  [1822] = {.lex_state = 170},
  [1823] = {.lex_state = 140},
  [1824] = {.lex_state = 140},
  [1825] = {.lex_state = 131},
  [1826] = {.lex_state = 131},
  [1827] = {.lex_state = 138},
  [1828] = {.lex_state = 95},
  [1829] = {.lex_state = 95},
  [1830] = {.lex_state = 131},
  [1831] = {.lex_state = 95},
  [1832] = {.lex_state = 95},
  [1833] = {.lex_state = 138},
  [1834] = {.lex_state = 138},
  [1835] = {.lex_state = 167},
  [1836] = {.lex_state = 138},
  [1837] = {.lex_state = 138},
  [1838] = {.lex_state = 140},
  [1839] = {.lex_state = 140},
  [1840] = {.lex_state = 140},
  [1841] = {.lex_state = 140},
  [1842] = {.lex_state = 131},
  [1843] = {.lex_state = 95},
  [1844] = {.lex_state = 102, .external_lex_state = 2},
  [1845] = {.lex_state = 95},
  [1846] = {.lex_state = 138, .external_lex_state = 2},
  [1847] = {.lex_state = 131},
  [1848] = {.lex_state = 138},
  [1849] = {.lex_state = 102},
  [1850] = {.lex_state = 131},
  [1851] = {.lex_state = 138},
  [1852] = {.lex_state = 140},
  [1853] = {.lex_state = 172},
  [1854] = {.lex_state = 102},
  [1855] = {.lex_state = 102},
  [1856] = {.lex_state = 131},
  [1857] = {.lex_state = 95, .external_lex_state = 2},
  [1858] = {.lex_state = 95},
  [1859] = {.lex_state = 95, .external_lex_state = 2},
  [1860] = {.lex_state = 111, .external_lex_state = 2},
  [1861] = {.lex_state = 111, .external_lex_state = 2},
  [1862] = {.lex_state = 111, .external_lex_state = 2},
  [1863] = {.lex_state = 111, .external_lex_state = 2},
  [1864] = {.lex_state = 111, .external_lex_state = 2},
  [1865] = {.lex_state = 111},
  [1866] = {.lex_state = 140},
  [1867] = {.lex_state = 95},
  [1868] = {.lex_state = 111, .external_lex_state = 2},
  [1869] = {.lex_state = 95},
  [1870] = {.lex_state = 95},
  [1871] = {.lex_state = 140},
  [1872] = {.lex_state = 131},
  [1873] = {.lex_state = 138},
  [1874] = {.lex_state = 95},
  [1875] = {.lex_state = 95},
  [1876] = {.lex_state = 95},
  [1877] = {.lex_state = 135, .external_lex_state = 2},
  [1878] = {.lex_state = 102, .external_lex_state = 2},
  [1879] = {.lex_state = 95},
  [1880] = {.lex_state = 95},
  [1881] = {.lex_state = 183},
  [1882] = {.lex_state = 167},
  [1883] = {.lex_state = 138, .external_lex_state = 2},
  [1884] = {.lex_state = 102},
  [1885] = {.lex_state = 95},
  [1886] = {.lex_state = 138},
  [1887] = {.lex_state = 140},
  [1888] = {.lex_state = 140},
  [1889] = {.lex_state = 111, .external_lex_state = 2},
  [1890] = {.lex_state = 111, .external_lex_state = 2},
  [1891] = {.lex_state = 95, .external_lex_state = 2},
  [1892] = {.lex_state = 131},
  [1893] = {.lex_state = 138, .external_lex_state = 2},
  [1894] = {.lex_state = 138},
  [1895] = {.lex_state = 138, .external_lex_state = 2},
  [1896] = {.lex_state = 131},
  [1897] = {.lex_state = 102},
  [1898] = {.lex_state = 138},
  [1899] = {.lex_state = 131},
  [1900] = {.lex_state = 172},
  [1901] = {.lex_state = 131},
  [1902] = {.lex_state = 95},
  [1903] = {.lex_state = 170},
  [1904] = {.lex_state = 95, .external_lex_state = 2},
  [1905] = {.lex_state = 95},
  [1906] = {.lex_state = 111, .external_lex_state = 2},
  [1907] = {.lex_state = 95},
  [1908] = {.lex_state = 95},
  [1909] = {.lex_state = 95},
  [1910] = {.lex_state = 138},
  [1911] = {.lex_state = 138},
  [1912] = {.lex_state = 95},
  [1913] = {.lex_state = 135, .external_lex_state = 2},
  [1914] = {.lex_state = 95},
  [1915] = {.lex_state = 138, .external_lex_state = 2},
  [1916] = {.lex_state = 140},
  [1917] = {.lex_state = 138},
  [1918] = {.lex_state = 138, .external_lex_state = 2},
  [1919] = {.lex_state = 111, .external_lex_state = 2},
  [1920] = {.lex_state = 95},
  [1921] = {.lex_state = 95},
  [1922] = {.lex_state = 138},
  [1923] = {.lex_state = 95},
  [1924] = {.lex_state = 95},
  [1925] = {.lex_state = 95},
  [1926] = {.lex_state = 95},
  [1927] = {.lex_state = 95},
  [1928] = {.lex_state = 95},
  [1929] = {.lex_state = 95},
  [1930] = {.lex_state = 138, .external_lex_state = 2},
  [1931] = {.lex_state = 138},
  [1932] = {.lex_state = 95},
  [1933] = {.lex_state = 95},
  [1934] = {.lex_state = 95},
  [1935] = {.lex_state = 95},
  [1936] = {.lex_state = 95},
  [1937] = {.lex_state = 95},
  [1938] = {.lex_state = 138, .external_lex_state = 2},
  [1939] = {.lex_state = 95},
  [1940] = {.lex_state = 95},
  [1941] = {.lex_state = 95},
  [1942] = {.lex_state = 138, .external_lex_state = 2},
  [1943] = {.lex_state = 138, .external_lex_state = 2},
  [1944] = {.lex_state = 138, .external_lex_state = 2},
  [1945] = {.lex_state = 111},
  [1946] = {.lex_state = 131},
  [1947] = {.lex_state = 95},
  [1948] = {.lex_state = 95},
  [1949] = {.lex_state = 95},
  [1950] = {.lex_state = 95},
  [1951] = {.lex_state = 95},
  [1952] = {.lex_state = 95},
  [1953] = {.lex_state = 95},
  [1954] = {.lex_state = 102},
  [1955] = {.lex_state = 102},
  [1956] = {.lex_state = 111},
  [1957] = {.lex_state = 111},
  [1958] = {.lex_state = 102},
  [1959] = {.lex_state = 102},
  [1960] = {.lex_state = 102},
  [1961] = {.lex_state = 102},
  [1962] = {.lex_state = 95},
  [1963] = {.lex_state = 95},
  [1964] = {.lex_state = 95},
  [1965] = {.lex_state = 95},
  [1966] = {.lex_state = 131},
  [1967] = {.lex_state = 95},
  [1968] = {.lex_state = 111},
  [1969] = {.lex_state = 177},
  [1970] = {.lex_state = 177},
  [1971] = {.lex_state = 177},
  [1972] = {.lex_state = 111},
  [1973] = {.lex_state = 177},
  [1974] = {.lex_state = 95},
  [1975] = {.lex_state = 95},
  [1976] = {.lex_state = 177},
  [1977] = {.lex_state = 177},
  [1978] = {.lex_state = 177},
  [1979] = {.lex_state = 177},
  [1980] = {.lex_state = 102},
  [1981] = {.lex_state = 102},
  [1982] = {.lex_state = 95},
  [1983] = {.lex_state = 95},
  [1984] = {.lex_state = 102},
  [1985] = {.lex_state = 131},
  [1986] = {.lex_state = 177},
  [1987] = {.lex_state = 111},
  [1988] = {.lex_state = 111},
  [1989] = {.lex_state = 95},
  [1990] = {.lex_state = 102},
  [1991] = {.lex_state = 177},
  [1992] = {.lex_state = 131},
  [1993] = {.lex_state = 123},
  [1994] = {.lex_state = 131},
  [1995] = {.lex_state = 138},
  [1996] = {.lex_state = 142},
  [1997] = {.lex_state = 102},
  [1998] = {.lex_state = 138},
  [1999] = {.lex_state = 140},
  [2000] = {.lex_state = 123},
  [2001] = {.lex_state = 167},
  [2002] = {.lex_state = 131},
  [2003] = {.lex_state = 131},
  [2004] = {.lex_state = 95},
  [2005] = {.lex_state = 138},
  [2006] = {.lex_state = 138},
  [2007] = {.lex_state = 138},
  [2008] = {.lex_state = 138},
  [2009] = {.lex_state = 170},
  [2010] = {.lex_state = 140},
  [2011] = {.lex_state = 102},
  [2012] = {.lex_state = 102},
  [2013] = {.lex_state = 142},
  [2014] = {.lex_state = 138},
  [2015] = {.lex_state = 138},
  [2016] = {.lex_state = 95},
  [2017] = {.lex_state = 95},
  [2018] = {.lex_state = 95},
  [2019] = {.lex_state = 135},
  [2020] = {.lex_state = 102},
  [2021] = {.lex_state = 173},
  [2022] = {.lex_state = 95},
  [2023] = {.lex_state = 174},
  [2024] = {.lex_state = 174},
  [2025] = {.lex_state = 174},
  [2026] = {.lex_state = 174},
  [2027] = {.lex_state = 174},
  [2028] = {.lex_state = 170},
  [2029] = {.lex_state = 140},
  [2030] = {.lex_state = 140},
  [2031] = {.lex_state = 95},
  [2032] = {.lex_state = 131},
  [2033] = {.lex_state = 95},
  [2034] = {.lex_state = 95},
  [2035] = {.lex_state = 138},
  [2036] = {.lex_state = 138},
  [2037] = {.lex_state = 167},
  [2038] = {.lex_state = 138},
  [2039] = {.lex_state = 138},
  [2040] = {.lex_state = 140},
  [2041] = {.lex_state = 95},
  [2042] = {.lex_state = 95},
  [2043] = {.lex_state = 138, .external_lex_state = 2},
  [2044] = {.lex_state = 131},
  [2045] = {.lex_state = 102},
  [2046] = {.lex_state = 138},
  [2047] = {.lex_state = 140},
  [2048] = {.lex_state = 172},
  [2049] = {.lex_state = 102},
  [2050] = {.lex_state = 102},
  [2051] = {.lex_state = 131},
  [2052] = {.lex_state = 95, .external_lex_state = 2},
  [2053] = {.lex_state = 95},
  [2054] = {.lex_state = 111},
  [2055] = {.lex_state = 140},
  [2056] = {.lex_state = 95},
  [2057] = {.lex_state = 140},
  [2058] = {.lex_state = 95},
  [2059] = {.lex_state = 95},
  [2060] = {.lex_state = 102},
  [2061] = {.lex_state = 138},
  [2062] = {.lex_state = 95, .external_lex_state = 2},
  [2063] = {.lex_state = 131},
  [2064] = {.lex_state = 138, .external_lex_state = 2},
  [2065] = {.lex_state = 138},
  [2066] = {.lex_state = 138, .external_lex_state = 2},
  [2067] = {.lex_state = 131},
  [2068] = {.lex_state = 102},
  [2069] = {.lex_state = 172},
  [2070] = {.lex_state = 131},
  [2071] = {.lex_state = 95},
  [2072] = {.lex_state = 95},
  [2073] = {.lex_state = 95},
  [2074] = {.lex_state = 138},
  [2075] = {.lex_state = 138, .external_lex_state = 2},
  [2076] = {.lex_state = 95},
  [2077] = {.lex_state = 95},
  [2078] = {.lex_state = 138},
  [2079] = {.lex_state = 131},
  [2080] = {.lex_state = 177},
  [2081] = {.lex_state = 111},
  [2082] = {.lex_state = 111},
  [2083] = {.lex_state = 111},
  [2084] = {.lex_state = 177},
  [2085] = {.lex_state = 111},
  [2086] = {.lex_state = 111},
  [2087] = {.lex_state = 111},
  [2088] = {.lex_state = 111},
  [2089] = {.lex_state = 111},
  [2090] = {.lex_state = 95},
  [2091] = {.lex_state = 95},
  [2092] = {.lex_state = 111},
  [2093] = {.lex_state = 177},
  [2094] = {.lex_state = 177},
  [2095] = {.lex_state = 111},
  [2096] = {.lex_state = 123},
  [2097] = {.lex_state = 138},
  [2098] = {.lex_state = 142},
  [2099] = {.lex_state = 123},
  [2100] = {.lex_state = 95},
  [2101] = {.lex_state = 138},
  [2102] = {.lex_state = 138},
  [2103] = {.lex_state = 142},
  [2104] = {.lex_state = 138},
  [2105] = {.lex_state = 138},
  [2106] = {.lex_state = 95},
  [2107] = {.lex_state = 95},
  [2108] = {.lex_state = 95},
  [2109] = {.lex_state = 135},
  [2110] = {.lex_state = 102},
  [2111] = {.lex_state = 95},
  [2112] = {.lex_state = 95},
  [2113] = {.lex_state = 95},
  [2114] = {.lex_state = 95},
  [2115] = {.lex_state = 138},
  [2116] = {.lex_state = 95},
  [2117] = {.lex_state = 95},
  [2118] = {.lex_state = 138, .external_lex_state = 2},
  [2119] = {.lex_state = 131},
  [2120] = {.lex_state = 102},
  [2121] = {.lex_state = 138},
  [2122] = {.lex_state = 140},
  [2123] = {.lex_state = 172},
  [2124] = {.lex_state = 102},
  [2125] = {.lex_state = 102},
  [2126] = {.lex_state = 131},
  [2127] = {.lex_state = 95, .external_lex_state = 2},
  [2128] = {.lex_state = 95},
  [2129] = {.lex_state = 95},
  [2130] = {.lex_state = 95},
  [2131] = {.lex_state = 95},
  [2132] = {.lex_state = 95, .external_lex_state = 2},
  [2133] = {.lex_state = 131},
  [2134] = {.lex_state = 138, .external_lex_state = 2},
  [2135] = {.lex_state = 138},
  [2136] = {.lex_state = 138, .external_lex_state = 2},
  [2137] = {.lex_state = 131},
  [2138] = {.lex_state = 102},
  [2139] = {.lex_state = 172},
  [2140] = {.lex_state = 131},
  [2141] = {.lex_state = 95},
  [2142] = {.lex_state = 95},
  [2143] = {.lex_state = 95},
  [2144] = {.lex_state = 138},
  [2145] = {.lex_state = 138, .external_lex_state = 2},
  [2146] = {.lex_state = 95},
  [2147] = {.lex_state = 95},
  [2148] = {.lex_state = 138},
  [2149] = {.lex_state = 95},
  [2150] = {.lex_state = 95},
  [2151] = {.lex_state = 123},
  [2152] = {.lex_state = 142},
  [2153] = {.lex_state = 123},
  [2154] = {.lex_state = 138},
  [2155] = {.lex_state = 142},
  [2156] = {.lex_state = 138},
  [2157] = {.lex_state = 102},
  [2158] = {.lex_state = 95},
  [2159] = {.lex_state = 95},
  [2160] = {.lex_state = 95},
  [2161] = {.lex_state = 95},
  [2162] = {.lex_state = 95},
  [2163] = {.lex_state = 95},
  [2164] = {.lex_state = 102},
  [2165] = {.lex_state = 138},
  [2166] = {.lex_state = 102},
  [2167] = {.lex_state = 95, .external_lex_state = 2},
  [2168] = {.lex_state = 95},
  [2169] = {.lex_state = 95},
  [2170] = {.lex_state = 95},
  [2171] = {.lex_state = 95},
  [2172] = {.lex_state = 95, .external_lex_state = 2},
  [2173] = {.lex_state = 102},
  [2174] = {.lex_state = 95},
  [2175] = {.lex_state = 95},
  [2176] = {.lex_state = 95},
  [2177] = {.lex_state = 95},
  [2178] = {.lex_state = 95},
  [2179] = {.lex_state = 95},
  [2180] = {.lex_state = 95},
  [2181] = {.lex_state = 138},
  [2182] = {.lex_state = 95},
  [2183] = {.lex_state = 95},
  [2184] = {.lex_state = 95},
  [2185] = {.lex_state = 95},
  [2186] = {.lex_state = 95},
  [2187] = {.lex_state = 95},
  [2188] = {.lex_state = 102, .external_lex_state = 2},
  [2189] = {.lex_state = 95},
  [2190] = {.lex_state = 95},
  [2191] = {.lex_state = 95},
  [2192] = {.lex_state = 95},
  [2193] = {.lex_state = 102, .external_lex_state = 2},
  [2194] = {.lex_state = 95},
  [2195] = {.lex_state = 102, .external_lex_state = 2},
  [2196] = {.lex_state = 140},
  [2197] = {.lex_state = 95},
  [2198] = {.lex_state = 95},
  [2199] = {.lex_state = 153},
  [2200] = {.lex_state = 131},
  [2201] = {.lex_state = 95},
  [2202] = {.lex_state = 102, .external_lex_state = 2},
  [2203] = {.lex_state = 95},
  [2204] = {.lex_state = 95},
  [2205] = {.lex_state = 95},
  [2206] = {.lex_state = 95},
  [2207] = {.lex_state = 95},
  [2208] = {.lex_state = 95},
  [2209] = {.lex_state = 95},
  [2210] = {.lex_state = 95},
  [2211] = {.lex_state = 138},
  [2212] = {.lex_state = 102, .external_lex_state = 2},
  [2213] = {.lex_state = 102, .external_lex_state = 2},
  [2214] = {.lex_state = 131},
  [2215] = {.lex_state = 111, .external_lex_state = 2},
  [2216] = {.lex_state = 95},
  [2217] = {.lex_state = 111, .external_lex_state = 2},
  [2218] = {.lex_state = 95},
  [2219] = {.lex_state = 95},
  [2220] = {.lex_state = 150},
  [2221] = {.lex_state = 95},
  [2222] = {.lex_state = 111, .external_lex_state = 2},
  [2223] = {.lex_state = 95},
  [2224] = {.lex_state = 138, .external_lex_state = 2},
  [2225] = {.lex_state = 138, .external_lex_state = 2},
  [2226] = {.lex_state = 111, .external_lex_state = 2},
  [2227] = {.lex_state = 111, .external_lex_state = 2},
  [2228] = {.lex_state = 95},
  [2229] = {.lex_state = 102},
  [2230] = {.lex_state = 95},
  [2231] = {.lex_state = 95},
  [2232] = {.lex_state = 135},
  [2233] = {.lex_state = 95},
  [2234] = {.lex_state = 131},
  [2235] = {.lex_state = 95},
  [2236] = {.lex_state = 150},
  [2237] = {.lex_state = 95},
  [2238] = {.lex_state = 95},
  [2239] = {.lex_state = 150},
  [2240] = {.lex_state = 95},
  [2241] = {.lex_state = 102},
  [2242] = {.lex_state = 95},
  [2243] = {.lex_state = 95},
  [2244] = {.lex_state = 95},
  [2245] = {.lex_state = 102, .external_lex_state = 2},
  [2246] = {.lex_state = 102, .external_lex_state = 2},
  [2247] = {.lex_state = 102, .external_lex_state = 2},
  [2248] = {.lex_state = 102, .external_lex_state = 2},
  [2249] = {.lex_state = 102, .external_lex_state = 2},
  [2250] = {.lex_state = 95},
  [2251] = {.lex_state = 95},
  [2252] = {.lex_state = 95},
  [2253] = {.lex_state = 95},
  [2254] = {.lex_state = 95},
  [2255] = {.lex_state = 95},
  [2256] = {.lex_state = 95},
  [2257] = {.lex_state = 95},
  [2258] = {.lex_state = 95},
  [2259] = {.lex_state = 95},
  [2260] = {.lex_state = 131},
  [2261] = {.lex_state = 95},
  [2262] = {.lex_state = 95},
  [2263] = {.lex_state = 95},
  [2264] = {.lex_state = 95},
  [2265] = {.lex_state = 150},
  [2266] = {.lex_state = 95},
  [2267] = {.lex_state = 102},
  [2268] = {.lex_state = 95},
  [2269] = {.lex_state = 95},
  [2270] = {.lex_state = 95},
  [2271] = {.lex_state = 95},
  [2272] = {.lex_state = 95},
  [2273] = {.lex_state = 95},
  [2274] = {.lex_state = 95},
  [2275] = {.lex_state = 150},
  [2276] = {.lex_state = 150},
  [2277] = {.lex_state = 131},
  [2278] = {.lex_state = 95},
  [2279] = {.lex_state = 150},
  [2280] = {.lex_state = 95},
  [2281] = {.lex_state = 95},
  [2282] = {.lex_state = 95},
  [2283] = {.lex_state = 95},
  [2284] = {.lex_state = 95},
  [2285] = {.lex_state = 131},
  [2286] = {.lex_state = 95},
  [2287] = {.lex_state = 95},
  [2288] = {.lex_state = 95},
  [2289] = {.lex_state = 95},
  [2290] = {.lex_state = 150},
  [2291] = {.lex_state = 140},
  [2292] = {.lex_state = 131},
  [2293] = {.lex_state = 95},
  [2294] = {.lex_state = 95},
  [2295] = {.lex_state = 102, .external_lex_state = 2},
  [2296] = {.lex_state = 95},
  [2297] = {.lex_state = 170, .external_lex_state = 2},
  [2298] = {.lex_state = 140},
  [2299] = {.lex_state = 170},
  [2300] = {.lex_state = 170},
  [2301] = {.lex_state = 140},
  [2302] = {.lex_state = 170},
  [2303] = {.lex_state = 170, .external_lex_state = 2},
  [2304] = {.lex_state = 140},
  [2305] = {.lex_state = 170},
  [2306] = {.lex_state = 170, .external_lex_state = 2},
  [2307] = {.lex_state = 140},
  [2308] = {.lex_state = 95},
  [2309] = {.lex_state = 131},
  [2310] = {.lex_state = 170},
  [2311] = {.lex_state = 170},
  [2312] = {.lex_state = 170},
  [2313] = {.lex_state = 170},
  [2314] = {.lex_state = 140},
  [2315] = {.lex_state = 170},
  [2316] = {.lex_state = 140},
  [2317] = {.lex_state = 170},
  [2318] = {.lex_state = 140},
  [2319] = {.lex_state = 95},
  [2320] = {.lex_state = 131},
  [2321] = {.lex_state = 170},
  [2322] = {.lex_state = 170},
  [2323] = {.lex_state = 170},
  [2324] = {.lex_state = 95},
  [2325] = {.lex_state = 131},
  [2326] = {.lex_state = 95},
  [2327] = {.lex_state = 131},
  [2328] = {.lex_state = 95},
  [2329] = {.lex_state = 102},
  [2330] = {.lex_state = 95},
  [2331] = {.lex_state = 102},
  [2332] = {.lex_state = 95},
  [2333] = {.lex_state = 95},
  [2334] = {.lex_state = 111},
  [2335] = {.lex_state = 102},
  [2336] = {.lex_state = 95},
  [2337] = {.lex_state = 95},
  [2338] = {.lex_state = 102},
  [2339] = {.lex_state = 111},
  [2340] = {.lex_state = 111},
  [2341] = {.lex_state = 95},
  [2342] = {.lex_state = 95},
  [2343] = {.lex_state = 95},
  [2344] = {.lex_state = 95},
  [2345] = {.lex_state = 95},
  [2346] = {.lex_state = 95},
  [2347] = {.lex_state = 190},
  [2348] = {.lex_state = 190},
  [2349] = {.lex_state = 177},
  [2350] = {.lex_state = 177},
  [2351] = {.lex_state = 177},
  [2352] = {.lex_state = 177},
  [2353] = {.lex_state = 177},
  [2354] = {.lex_state = 190},
  [2355] = {.lex_state = 190},
  [2356] = {.lex_state = 190},
  [2357] = {.lex_state = 190},
  [2358] = {.lex_state = 190},
  [2359] = {.lex_state = 95},
  [2360] = {.lex_state = 95},
  [2361] = {.lex_state = 95},
  [2362] = {.lex_state = 95},
  [2363] = {.lex_state = 95},
  [2364] = {.lex_state = 95},
  [2365] = {.lex_state = 95},
  [2366] = {.lex_state = 95},
  [2367] = {.lex_state = 95},
  [2368] = {.lex_state = 131},
  [2369] = {.lex_state = 174, .external_lex_state = 2},
  [2370] = {.lex_state = 95},
  [2371] = {.lex_state = 190},
  [2372] = {.lex_state = 131},
  [2373] = {.lex_state = 174, .external_lex_state = 2},
  [2374] = {.lex_state = 183},
  [2375] = {.lex_state = 183},
  [2376] = {.lex_state = 183},
  [2377] = {.lex_state = 183},
  [2378] = {.lex_state = 102, .external_lex_state = 2},
  [2379] = {.lex_state = 102},
  [2380] = {.lex_state = 102},
  [2381] = {.lex_state = 102},
  [2382] = {.lex_state = 111},
  [2383] = {.lex_state = 95},
  [2384] = {.lex_state = 95},
  [2385] = {.lex_state = 153},
  [2386] = {.lex_state = 131},
  [2387] = {.lex_state = 150},
  [2388] = {.lex_state = 95},
  [2389] = {.lex_state = 150},
  [2390] = {.lex_state = 95},
  [2391] = {.lex_state = 150},
  [2392] = {.lex_state = 95},
  [2393] = {.lex_state = 102},
  [2394] = {.lex_state = 95},
  [2395] = {.lex_state = 95},
  [2396] = {.lex_state = 95},
  [2397] = {.lex_state = 131},
  [2398] = {.lex_state = 95},
  [2399] = {.lex_state = 95},
  [2400] = {.lex_state = 95},
  [2401] = {.lex_state = 150},
  [2402] = {.lex_state = 150},
  [2403] = {.lex_state = 131},
  [2404] = {.lex_state = 95},
  [2405] = {.lex_state = 150},
  [2406] = {.lex_state = 95},
  [2407] = {.lex_state = 95},
  [2408] = {.lex_state = 169},
  [2409] = {.lex_state = 95},
  [2410] = {.lex_state = 95},
  [2411] = {.lex_state = 167},
  [2412] = {.lex_state = 95},
  [2413] = {.lex_state = 95},
  [2414] = {.lex_state = 111},
  [2415] = {.lex_state = 111},
  [2416] = {.lex_state = 111},
  [2417] = {.lex_state = 131},
  [2418] = {.lex_state = 150},
  [2419] = {.lex_state = 95},
  [2420] = {.lex_state = 150},
  [2421] = {.lex_state = 95},
  [2422] = {.lex_state = 150},
  [2423] = {.lex_state = 95},
  [2424] = {.lex_state = 102},
  [2425] = {.lex_state = 95},
  [2426] = {.lex_state = 95},
  [2427] = {.lex_state = 95},
  [2428] = {.lex_state = 95},
  [2429] = {.lex_state = 150},
  [2430] = {.lex_state = 150},
  [2431] = {.lex_state = 131},
  [2432] = {.lex_state = 95},
  [2433] = {.lex_state = 150},
  [2434] = {.lex_state = 95},
  [2435] = {.lex_state = 95},
  [2436] = {.lex_state = 95},
  [2437] = {.lex_state = 102},
  [2438] = {.lex_state = 95},
  [2439] = {.lex_state = 95},
  [2440] = {.lex_state = 95},
  [2441] = {.lex_state = 95},
  [2442] = {.lex_state = 95},
  [2443] = {.lex_state = 102, .external_lex_state = 2},
  [2444] = {.lex_state = 95},
  [2445] = {.lex_state = 95},
  [2446] = {.lex_state = 102, .external_lex_state = 2},
  [2447] = {.lex_state = 95},
  [2448] = {.lex_state = 95},
  [2449] = {.lex_state = 111, .external_lex_state = 2},
  [2450] = {.lex_state = 95},
  [2451] = {.lex_state = 95},
  [2452] = {.lex_state = 95},
  [2453] = {.lex_state = 102, .external_lex_state = 2},
  [2454] = {.lex_state = 131},
  [2455] = {.lex_state = 131},
  [2456] = {.lex_state = 102},
  [2457] = {.lex_state = 102, .external_lex_state = 2},
  [2458] = {.lex_state = 111, .external_lex_state = 2},
  [2459] = {.lex_state = 95},
  [2460] = {.lex_state = 111, .external_lex_state = 2},
  [2461] = {.lex_state = 95},
  [2462] = {.lex_state = 135},
  [2463] = {.lex_state = 95},
  [2464] = {.lex_state = 95},
  [2465] = {.lex_state = 95},
  [2466] = {.lex_state = 95},
  [2467] = {.lex_state = 102},
  [2468] = {.lex_state = 102},
  [2469] = {.lex_state = 95},
  [2470] = {.lex_state = 95},
  [2471] = {.lex_state = 95},
  [2472] = {.lex_state = 131},
  [2473] = {.lex_state = 102},
  [2474] = {.lex_state = 95},
  [2475] = {.lex_state = 95},
  [2476] = {.lex_state = 95},
  [2477] = {.lex_state = 111},
  [2478] = {.lex_state = 95},
  [2479] = {.lex_state = 95},
  [2480] = {.lex_state = 95},
  [2481] = {.lex_state = 95},
  [2482] = {.lex_state = 95},
  [2483] = {.lex_state = 95},
  [2484] = {.lex_state = 95},
  [2485] = {.lex_state = 131},
  [2486] = {.lex_state = 183},
  [2487] = {.lex_state = 183},
  [2488] = {.lex_state = 183},
  [2489] = {.lex_state = 183},
  [2490] = {.lex_state = 131},
  [2491] = {.lex_state = 95},
  [2492] = {.lex_state = 174, .external_lex_state = 2},
  [2493] = {.lex_state = 95},
  [2494] = {.lex_state = 95},
  [2495] = {.lex_state = 95},
  [2496] = {.lex_state = 95},
  [2497] = {.lex_state = 95},
  [2498] = {.lex_state = 95},
  [2499] = {.lex_state = 131},
  [2500] = {.lex_state = 174, .external_lex_state = 2},
  [2501] = {.lex_state = 95},
  [2502] = {.lex_state = 174, .external_lex_state = 2},
  [2503] = {.lex_state = 95},
  [2504] = {.lex_state = 95},
  [2505] = {.lex_state = 95},
  [2506] = {.lex_state = 131},
  [2507] = {.lex_state = 95},
  [2508] = {.lex_state = 174, .external_lex_state = 2},
  [2509] = {.lex_state = 131},
  [2510] = {.lex_state = 95},
  [2511] = {.lex_state = 190},
  [2512] = {.lex_state = 95},
  [2513] = {.lex_state = 190},
  [2514] = {.lex_state = 95},
  [2515] = {.lex_state = 95},
  [2516] = {.lex_state = 177},
  [2517] = {.lex_state = 190},
  [2518] = {.lex_state = 95},
  [2519] = {.lex_state = 95},
  [2520] = {.lex_state = 131},
  [2521] = {.lex_state = 190},
  [2522] = {.lex_state = 177},
  [2523] = {.lex_state = 95},
  [2524] = {.lex_state = 177},
  [2525] = {.lex_state = 131},
  [2526] = {.lex_state = 131},
  [2527] = {.lex_state = 131},
  [2528] = {.lex_state = 95},
  [2529] = {.lex_state = 95},
  [2530] = {.lex_state = 95},
  [2531] = {.lex_state = 95},
  [2532] = {.lex_state = 95},
  [2533] = {.lex_state = 95},
  [2534] = {.lex_state = 95},
  [2535] = {.lex_state = 169},
  [2536] = {.lex_state = 169},
  [2537] = {.lex_state = 167},
  [2538] = {.lex_state = 167},
  [2539] = {.lex_state = 169},
  [2540] = {.lex_state = 169},
  [2541] = {.lex_state = 169},
  [2542] = {.lex_state = 169},
  [2543] = {.lex_state = 95},
  [2544] = {.lex_state = 95},
  [2545] = {.lex_state = 95},
  [2546] = {.lex_state = 95},
  [2547] = {.lex_state = 95},
  [2548] = {.lex_state = 167},
  [2549] = {.lex_state = 167},
  [2550] = {.lex_state = 95},
  [2551] = {.lex_state = 95},
  [2552] = {.lex_state = 169},
  [2553] = {.lex_state = 169},
  [2554] = {.lex_state = 169},
  [2555] = {.lex_state = 167},
  [2556] = {.lex_state = 167},
  [2557] = {.lex_state = 95},
  [2558] = {.lex_state = 169},
  [2559] = {.lex_state = 102},
  [2560] = {.lex_state = 102},
  [2561] = {.lex_state = 102},
  [2562] = {.lex_state = 111},
  [2563] = {.lex_state = 131},
  [2564] = {.lex_state = 167},
  [2565] = {.lex_state = 167},
  [2566] = {.lex_state = 167},
  [2567] = {.lex_state = 167},
  [2568] = {.lex_state = 167},
  [2569] = {.lex_state = 167},
  [2570] = {.lex_state = 167},
  [2571] = {.lex_state = 167},
  [2572] = {.lex_state = 167},
  [2573] = {.lex_state = 167},
  [2574] = {.lex_state = 95},
  [2575] = {.lex_state = 95},
  [2576] = {.lex_state = 169},
  [2577] = {.lex_state = 169},
  [2578] = {.lex_state = 169},
  [2579] = {.lex_state = 167},
  [2580] = {.lex_state = 167},
  [2581] = {.lex_state = 167},
  [2582] = {.lex_state = 167},
  [2583] = {.lex_state = 167},
  [2584] = {.lex_state = 95},
  [2585] = {.lex_state = 95},
  [2586] = {.lex_state = 95},
  [2587] = {.lex_state = 95},
  [2588] = {.lex_state = 95},
  [2589] = {.lex_state = 102, .external_lex_state = 2},
  [2590] = {.lex_state = 111, .external_lex_state = 2},
  [2591] = {.lex_state = 111, .external_lex_state = 2},
  [2592] = {.lex_state = 169},
  [2593] = {.lex_state = 167},
  [2594] = {.lex_state = 131},
  [2595] = {.lex_state = 95},
  [2596] = {.lex_state = 95},
  [2597] = {.lex_state = 95},
  [2598] = {.lex_state = 102, .external_lex_state = 2},
  [2599] = {.lex_state = 102},
  [2600] = {.lex_state = 102},
  [2601] = {.lex_state = 95},
  [2602] = {.lex_state = 95},
  [2603] = {.lex_state = 95},
  [2604] = {.lex_state = 167},
  [2605] = {.lex_state = 169},
  [2606] = {.lex_state = 95},
  [2607] = {.lex_state = 95},
  [2608] = {.lex_state = 95},
  [2609] = {.lex_state = 95},
  [2610] = {.lex_state = 95},
  [2611] = {.lex_state = 95},
};

enum {
  ts_external_token__automatic_semicolon = 0,
  ts_external_token__template_chars = 1,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__automatic_semicolon] = sym__automatic_semicolon,
  [ts_external_token__template_chars] = sym__template_chars,
};

static bool ts_external_scanner_states[4][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__automatic_semicolon] = true,
    [ts_external_token__template_chars] = true,
  },
  [2] = {
    [ts_external_token__automatic_semicolon] = true,
  },
  [3] = {
    [ts_external_token__template_chars] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1),
    [sym__automatic_semicolon] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_symbol] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_keyof] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_GT_GT_GT] = ACTIONS(1),
    [anon_sym_extends] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_target] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_delete] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_instanceof] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [sym_true] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [sym_readonly] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_number] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym_null] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_any] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_require] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [sym_identifier] = ACTIONS(1),
    [anon_sym_debugger] = ACTIONS(1),
    [anon_sym_SLASH2] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_void] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [sym__template_chars] = ACTIONS(1),
    [sym_super] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_this] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_STAR_STAR] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [sym_false] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym_of] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_boolean] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [sym_hash_bang_line] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [sym_number] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [sym_undefined] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_implements] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
  },
  [1] = {
    [sym_type_alias_declaration] = STATE(56),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(56),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(56),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(56),
    [sym_return_statement] = STATE(56),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(56),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(56),
    [sym_switch_statement] = STATE(56),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(56),
    [sym_throw_statement] = STATE(56),
    [aux_sym_program_repeat1] = STATE(56),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(56),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(56),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(56),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(56),
    [sym_abstract_class] = STATE(56),
    [sym_interface_declaration] = STATE(56),
    [sym_statement_block] = STATE(56),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(56),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(56),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(56),
    [sym_function] = STATE(60),
    [sym_program] = STATE(61),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(56),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(56),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(56),
    [sym_empty_statement] = STATE(56),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(56),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(56),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(56),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(56),
    [sym_break_statement] = STATE(56),
    [sym_labeled_statement] = STATE(56),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(56),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [sym_hash_bang_line] = ACTIONS(83),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(97),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [2] = {
    [sym__initializer] = STATE(72),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(113),
    [anon_sym_AMP_EQ] = ACTIONS(113),
    [anon_sym_PLUS_EQ] = ACTIONS(113),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(113),
    [anon_sym_PIPE_EQ] = ACTIONS(113),
    [anon_sym_DASH_EQ] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(113),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(113),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [3] = {
    [aux_sym_template_string_repeat1] = STATE(75),
    [sym_template_substitution] = STATE(75),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(129),
    [sym__template_chars] = ACTIONS(131),
    [sym_escape_sequence] = ACTIONS(131),
    [sym_comment] = ACTIONS(3),
  },
  [4] = {
    [sym__automatic_semicolon] = ACTIONS(133),
    [anon_sym_SEMI] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
  },
  [5] = {
    [sym__initializer] = STATE(80),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [6] = {
    [sym_decorator_member_expression] = STATE(82),
    [sym_decorator_call_expression] = STATE(83),
    [sym__identifier_reference] = STATE(82),
    [sym_identifier] = ACTIONS(145),
    [anon_sym_module] = ACTIONS(147),
    [anon_sym_symbol] = ACTIONS(147),
    [anon_sym_number] = ACTIONS(147),
    [anon_sym_declare] = ACTIONS(147),
    [anon_sym_void] = ACTIONS(147),
    [anon_sym_any] = ACTIONS(147),
    [anon_sym_private] = ACTIONS(147),
    [anon_sym_boolean] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(147),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_get] = ACTIONS(147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(147),
    [anon_sym_string] = ACTIONS(147),
    [anon_sym_set] = ACTIONS(147),
    [anon_sym_type] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_export] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(147),
  },
  [7] = {
    [sym_new_expression] = STATE(88),
    [sym_augmented_assignment_expression] = STATE(88),
    [sym_unary_expression] = STATE(88),
    [sym_update_expression] = STATE(88),
    [sym_regex] = STATE(88),
    [sym_meta_property] = STATE(88),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(88),
    [sym_yield_expression] = STATE(88),
    [sym_as_expression] = STATE(88),
    [sym_non_null_expression] = STATE(88),
    [sym_internal_module] = STATE(88),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(88),
    [sym_await_expression] = STATE(88),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(88),
    [sym_this] = STATE(88),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(88),
    [sym_generator_function] = STATE(88),
    [sym_call_expression] = STATE(88),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(88),
    [sym_ternary_expression] = STATE(88),
    [sym_binary_expression] = STATE(88),
    [sym_template_string] = STATE(88),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(88),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(88),
    [sym_class] = STATE(88),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(151),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(151),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(151),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(161),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [8] = {
    [sym_new_expression] = STATE(91),
    [sym_augmented_assignment_expression] = STATE(91),
    [sym__initializer] = STATE(80),
    [sym_unary_expression] = STATE(91),
    [sym_update_expression] = STATE(91),
    [sym_regex] = STATE(91),
    [sym_meta_property] = STATE(91),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(91),
    [sym_yield_expression] = STATE(91),
    [sym_as_expression] = STATE(91),
    [sym_non_null_expression] = STATE(91),
    [sym_internal_module] = STATE(91),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(91),
    [sym_await_expression] = STATE(91),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(91),
    [sym_this] = STATE(91),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(91),
    [sym_generator_function] = STATE(91),
    [sym_call_expression] = STATE(91),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(91),
    [sym_ternary_expression] = STATE(91),
    [sym_binary_expression] = STATE(91),
    [sym_template_string] = STATE(91),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(91),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(91),
    [sym_class] = STATE(91),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(165),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [sym_null] = ACTIONS(165),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(165),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(77),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(139),
  },
  [9] = {
    [sym__automatic_semicolon] = ACTIONS(175),
    [sym_identifier] = ACTIONS(177),
    [anon_sym_SEMI] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_variable_declarator] = STATE(96),
    [sym_array] = STATE(97),
    [sym_object] = STATE(98),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_enum] = ACTIONS(183),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(185),
  },
  [11] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [12] = {
    [sym_new_expression] = STATE(105),
    [sym_augmented_assignment_expression] = STATE(105),
    [sym_unary_expression] = STATE(105),
    [sym_update_expression] = STATE(105),
    [sym_regex] = STATE(105),
    [sym_meta_property] = STATE(105),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(105),
    [sym_yield_expression] = STATE(105),
    [sym_as_expression] = STATE(105),
    [sym_non_null_expression] = STATE(105),
    [sym_internal_module] = STATE(105),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(105),
    [sym_await_expression] = STATE(105),
    [sym_member_expression] = STATE(54),
    [sym_sequence_expression] = STATE(106),
    [sym_string] = STATE(105),
    [sym_this] = STATE(105),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(105),
    [sym_generator_function] = STATE(105),
    [sym_call_expression] = STATE(105),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(105),
    [sym_ternary_expression] = STATE(105),
    [sym_binary_expression] = STATE(105),
    [sym_template_string] = STATE(105),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(105),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(105),
    [sym_class] = STATE(105),
    [sym__automatic_semicolon] = ACTIONS(193),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(195),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(193),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(195),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(197),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(195),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [13] = {
    [sym_identifier] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
  },
  [14] = {
    [sym_identifier] = ACTIONS(201),
    [sym_comment] = ACTIONS(3),
  },
  [15] = {
    [sym_new_expression] = STATE(91),
    [sym_augmented_assignment_expression] = STATE(91),
    [sym_unary_expression] = STATE(91),
    [sym_update_expression] = STATE(91),
    [sym_regex] = STATE(91),
    [sym_meta_property] = STATE(91),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(91),
    [sym_yield_expression] = STATE(91),
    [sym_as_expression] = STATE(91),
    [sym_non_null_expression] = STATE(91),
    [sym_internal_module] = STATE(91),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(91),
    [sym_await_expression] = STATE(91),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(91),
    [sym_this] = STATE(91),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(91),
    [sym_generator_function] = STATE(91),
    [sym_call_expression] = STATE(91),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(91),
    [sym_ternary_expression] = STATE(91),
    [sym_binary_expression] = STATE(91),
    [sym_template_string] = STATE(91),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(91),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(91),
    [sym_class] = STATE(91),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(165),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(165),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(165),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(165),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [16] = {
    [sym__automatic_semicolon] = ACTIONS(203),
    [sym_identifier] = ACTIONS(205),
    [anon_sym_SEMI] = ACTIONS(203),
    [sym_comment] = ACTIONS(3),
  },
  [17] = {
    [sym_new_expression] = STATE(111),
    [sym_augmented_assignment_expression] = STATE(111),
    [sym_unary_expression] = STATE(111),
    [sym_update_expression] = STATE(111),
    [sym_regex] = STATE(111),
    [sym_meta_property] = STATE(111),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(111),
    [sym_yield_expression] = STATE(111),
    [sym_as_expression] = STATE(111),
    [sym_non_null_expression] = STATE(111),
    [sym_internal_module] = STATE(111),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(111),
    [sym_await_expression] = STATE(111),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(111),
    [sym_this] = STATE(111),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(111),
    [sym_generator_function] = STATE(111),
    [sym_call_expression] = STATE(111),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(111),
    [sym_ternary_expression] = STATE(111),
    [sym_binary_expression] = STATE(111),
    [sym_template_string] = STATE(111),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(111),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(111),
    [sym_class] = STATE(111),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(207),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(207),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(207),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(209),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(207),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [18] = {
    [sym_parenthesized_expression] = STATE(113),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [19] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [sym__automatic_semicolon] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(213),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COMMA] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [anon_sym_RBRACE] = ACTIONS(213),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_DASH_DASH] = ACTIONS(213),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_PLUS_PLUS] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_SEMI] = ACTIONS(213),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(213),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_AMP] = ACTIONS(215),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_RPAREN] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_SLASH] = ACTIONS(215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(215),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(215),
  },
  [20] = {
    [sym_new_expression] = STATE(114),
    [sym_augmented_assignment_expression] = STATE(114),
    [sym_unary_expression] = STATE(114),
    [sym_update_expression] = STATE(114),
    [sym_regex] = STATE(114),
    [sym_meta_property] = STATE(114),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(114),
    [sym_yield_expression] = STATE(114),
    [sym_as_expression] = STATE(114),
    [sym_non_null_expression] = STATE(114),
    [sym_internal_module] = STATE(114),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(114),
    [sym_await_expression] = STATE(114),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(114),
    [sym_this] = STATE(114),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(114),
    [sym_generator_function] = STATE(114),
    [sym_call_expression] = STATE(114),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(114),
    [sym_ternary_expression] = STATE(114),
    [sym_binary_expression] = STATE(114),
    [sym_template_string] = STATE(114),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(114),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(114),
    [sym_class] = STATE(114),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(217),
    [sym__automatic_semicolon] = ACTIONS(217),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT_GT_GT] = ACTIONS(217),
    [anon_sym_BANG_EQ] = ACTIONS(219),
    [anon_sym_RBRACE] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(217),
    [anon_sym_as] = ACTIONS(219),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(221),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(219),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(217),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [sym_null] = ACTIONS(221),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_QMARK] = ACTIONS(217),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_RPAREN] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(217),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(217),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_STAR_STAR] = ACTIONS(217),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(221),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(77),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(217),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(223),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(219),
  },
  [21] = {
    [sym_new_expression] = STATE(115),
    [sym_augmented_assignment_expression] = STATE(115),
    [sym_unary_expression] = STATE(115),
    [sym_update_expression] = STATE(115),
    [sym_regex] = STATE(115),
    [sym_meta_property] = STATE(115),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(115),
    [sym_yield_expression] = STATE(115),
    [sym_as_expression] = STATE(115),
    [sym_non_null_expression] = STATE(115),
    [sym_internal_module] = STATE(115),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(115),
    [sym_await_expression] = STATE(115),
    [sym_member_expression] = STATE(54),
    [sym_sequence_expression] = STATE(116),
    [sym_string] = STATE(115),
    [sym_this] = STATE(115),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(115),
    [sym_generator_function] = STATE(115),
    [sym_call_expression] = STATE(115),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(115),
    [sym_ternary_expression] = STATE(115),
    [sym_binary_expression] = STATE(115),
    [sym_template_string] = STATE(115),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(115),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(115),
    [sym_class] = STATE(115),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(225),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(225),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(225),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(227),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(225),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [22] = {
    [anon_sym_class] = ACTIONS(229),
    [sym_comment] = ACTIONS(3),
  },
  [23] = {
    [sym__initializer] = STATE(80),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [24] = {
    [sym_import_require_clause] = STATE(123),
    [sym_named_imports] = STATE(125),
    [sym__initializer] = STATE(80),
    [sym_import_clause] = STATE(124),
    [sym_string] = STATE(123),
    [sym_namespace_import] = STATE(125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_type] = ACTIONS(238),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(238),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [25] = {
    [sym_nested_identifier] = STATE(126),
    [sym__module] = STATE(127),
    [sym_string] = STATE(128),
    [sym__initializer] = STATE(80),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(242),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(244),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(246),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [26] = {
    [sym_new_expression] = STATE(129),
    [sym_augmented_assignment_expression] = STATE(129),
    [sym_unary_expression] = STATE(129),
    [sym_update_expression] = STATE(129),
    [sym_regex] = STATE(129),
    [sym_meta_property] = STATE(129),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(129),
    [sym_yield_expression] = STATE(129),
    [sym_as_expression] = STATE(129),
    [sym_non_null_expression] = STATE(129),
    [sym_internal_module] = STATE(129),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(129),
    [sym_await_expression] = STATE(129),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(129),
    [sym_this] = STATE(129),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(129),
    [sym_generator_function] = STATE(129),
    [sym_call_expression] = STATE(129),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(129),
    [sym_ternary_expression] = STATE(129),
    [sym_binary_expression] = STATE(129),
    [sym_template_string] = STATE(129),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(129),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(129),
    [sym_class] = STATE(129),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(248),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(248),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(248),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(250),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(248),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [27] = {
    [aux_sym_string_repeat1] = STATE(131),
    [sym_escape_sequence] = ACTIONS(252),
    [aux_sym_string_token1] = ACTIONS(252),
    [anon_sym_DQUOTE] = ACTIONS(254),
    [sym_comment] = ACTIONS(256),
  },
  [28] = {
    [sym_new_expression] = STATE(132),
    [sym_augmented_assignment_expression] = STATE(132),
    [sym_unary_expression] = STATE(132),
    [sym_update_expression] = STATE(132),
    [sym_regex] = STATE(132),
    [sym_meta_property] = STATE(132),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(132),
    [sym_yield_expression] = STATE(132),
    [sym_as_expression] = STATE(132),
    [sym_non_null_expression] = STATE(132),
    [sym_internal_module] = STATE(132),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(132),
    [sym_await_expression] = STATE(132),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(132),
    [sym_this] = STATE(132),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(132),
    [sym_generator_function] = STATE(132),
    [sym_call_expression] = STATE(132),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(132),
    [sym_ternary_expression] = STATE(132),
    [sym_binary_expression] = STATE(132),
    [sym_template_string] = STATE(132),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(132),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(132),
    [sym_class] = STATE(132),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(258),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(258),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(258),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(260),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(258),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [29] = {
    [anon_sym_await] = ACTIONS(262),
    [anon_sym_LPAREN] = ACTIONS(264),
    [sym_comment] = ACTIONS(3),
  },
  [30] = {
    [sym_new_expression] = STATE(138),
    [sym_augmented_assignment_expression] = STATE(138),
    [sym_unary_expression] = STATE(138),
    [sym_regex] = STATE(138),
    [sym_call_signature] = STATE(1740),
    [sym_yield_expression] = STATE(138),
    [sym_as_expression] = STATE(138),
    [sym_internal_module] = STATE(138),
    [sym_arrow_function] = STATE(138),
    [sym_member_expression] = STATE(1201),
    [sym_spread_element] = STATE(139),
    [sym_string] = STATE(138),
    [sym_type_parameters] = STATE(55),
    [sym_object] = STATE(1202),
    [sym_generator_function] = STATE(138),
    [sym_subscript_expression] = STATE(1201),
    [sym_ternary_expression] = STATE(138),
    [sym_template_string] = STATE(138),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_update_expression] = STATE(138),
    [sym_meta_property] = STATE(138),
    [sym__expression] = STATE(138),
    [sym_non_null_expression] = STATE(138),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(138),
    [sym_this] = STATE(138),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [aux_sym_array_repeat1] = STATE(140),
    [sym_anonymous_class] = STATE(138),
    [sym_call_expression] = STATE(138),
    [sym_assignment_expression] = STATE(138),
    [sym_binary_expression] = STATE(138),
    [sym_type_arguments] = STATE(1205),
    [sym_parenthesized_expression] = STATE(138),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(138),
    [sym_class] = STATE(138),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(288),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(288),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_RBRACK] = ACTIONS(304),
    [sym_null] = ACTIONS(288),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(310),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(288),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [31] = {
    [sym_identifier] = ACTIONS(318),
    [anon_sym_BQUOTE] = ACTIONS(320),
    [anon_sym_debugger] = ACTIONS(318),
    [anon_sym_symbol] = ACTIONS(318),
    [anon_sym_AT] = ACTIONS(320),
    [anon_sym_DASH] = ACTIONS(318),
    [anon_sym_void] = ACTIONS(318),
    [anon_sym_break] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [sym_super] = ACTIONS(318),
    [anon_sym_return] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_get] = ACTIONS(318),
    [anon_sym_RBRACE] = ACTIONS(320),
    [anon_sym_interface] = ACTIONS(318),
    [anon_sym_default] = ACTIONS(318),
    [anon_sym_enum] = ACTIONS(318),
    [anon_sym_delete] = ACTIONS(318),
    [anon_sym_continue] = ACTIONS(318),
    [anon_sym_DASH_DASH] = ACTIONS(320),
    [anon_sym_if] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(318),
    [anon_sym_yield] = ACTIONS(318),
    [sym_true] = ACTIONS(318),
    [anon_sym_throw] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_set] = ACTIONS(318),
    [anon_sym_type] = ACTIONS(318),
    [anon_sym_import] = ACTIONS(318),
    [anon_sym_namespace] = ACTIONS(318),
    [anon_sym_PLUS_PLUS] = ACTIONS(320),
    [anon_sym_await] = ACTIONS(318),
    [anon_sym_DQUOTE] = ACTIONS(320),
    [anon_sym_else] = ACTIONS(318),
    [anon_sym_BANG] = ACTIONS(320),
    [anon_sym_for] = ACTIONS(318),
    [anon_sym_LBRACK] = ACTIONS(320),
    [sym_false] = ACTIONS(318),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_case] = ACTIONS(318),
    [anon_sym_module] = ACTIONS(318),
    [anon_sym_number] = ACTIONS(318),
    [anon_sym_class] = ACTIONS(318),
    [anon_sym_declare] = ACTIONS(318),
    [anon_sym_typeof] = ACTIONS(318),
    [anon_sym_LBRACE] = ACTIONS(320),
    [anon_sym_switch] = ACTIONS(318),
    [anon_sym_LPAREN] = ACTIONS(320),
    [sym_null] = ACTIONS(318),
    [anon_sym_any] = ACTIONS(318),
    [anon_sym_boolean] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_var] = ACTIONS(318),
    [anon_sym_while] = ACTIONS(318),
    [anon_sym_SQUOTE] = ACTIONS(320),
    [anon_sym_try] = ACTIONS(318),
    [anon_sym_RPAREN] = ACTIONS(320),
    [anon_sym_LT] = ACTIONS(320),
    [sym_number] = ACTIONS(320),
    [anon_sym_SLASH] = ACTIONS(318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(318),
    [anon_sym_function] = ACTIONS(318),
    [sym_undefined] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [ts_builtin_sym_end] = ACTIONS(320),
    [anon_sym_let] = ACTIONS(318),
    [anon_sym_PLUS] = ACTIONS(318),
    [anon_sym_export] = ACTIONS(318),
    [anon_sym_do] = ACTIONS(318),
    [anon_sym_TILDE] = ACTIONS(320),
    [anon_sym_with] = ACTIONS(318),
  },
  [32] = {
    [sym_nested_identifier] = STATE(1224),
    [sym__module] = STATE(141),
    [sym_string] = STATE(1226),
    [sym__initializer] = STATE(80),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(322),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [33] = {
    [sym_class_heritage] = STATE(146),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(149),
    [anon_sym_extends] = ACTIONS(328),
    [sym_identifier] = ACTIONS(330),
    [anon_sym_implements] = ACTIONS(332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [34] = {
    [sym_type_alias_declaration] = STATE(160),
    [sym__declaration] = STATE(160),
    [sym__initializer] = STATE(80),
    [sym_internal_module] = STATE(160),
    [sym_enum_declaration] = STATE(160),
    [sym_function] = STATE(160),
    [sym_variable_declaration] = STATE(160),
    [aux_sym_export_statement_repeat1] = STATE(159),
    [sym_ambient_declaration] = STATE(160),
    [sym_import_alias] = STATE(160),
    [sym_export_statement] = STATE(160),
    [sym_generator_function] = STATE(160),
    [sym_lexical_declaration] = STATE(160),
    [sym_decorator] = STATE(159),
    [sym_function_signature] = STATE(160),
    [sym_abstract_class] = STATE(160),
    [sym_module] = STATE(160),
    [sym_interface_declaration] = STATE(160),
    [sym_class] = STATE(160),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_global] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_const] = ACTIONS(338),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_interface] = ACTIONS(340),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_abstract] = ACTIONS(344),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(352),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(354),
    [anon_sym_declare] = ACTIONS(356),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_async] = ACTIONS(358),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_var] = ACTIONS(360),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_function] = ACTIONS(362),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_let] = ACTIONS(364),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(366),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [35] = {
    [sym_new_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_do_statement] = STATE(182),
    [sym_internal_module] = STATE(53),
    [sym_accessibility_modifier] = STATE(180),
    [sym_import_statement] = STATE(182),
    [sym_member_expression] = STATE(54),
    [sym_switch_statement] = STATE(182),
    [sym_string] = STATE(178),
    [sym_type_parameters] = STATE(55),
    [sym_throw_statement] = STATE(182),
    [aux_sym_program_repeat1] = STATE(182),
    [sym_object] = STATE(184),
    [sym_generator_function] = STATE(53),
    [sym_ternary_expression] = STATE(59),
    [sym_for_of_statement] = STATE(182),
    [sym_decorator] = STATE(186),
    [sym_computed_property_name] = STATE(183),
    [sym_abstract_class] = STATE(182),
    [sym_statement_block] = STATE(182),
    [sym_update_expression] = STATE(59),
    [sym_debugger_statement] = STATE(182),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_function] = STATE(60),
    [sym_for_statement] = STATE(182),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(182),
    [sym_pair] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(186),
    [sym_assignment_pattern] = STATE(181),
    [sym_export_statement] = STATE(182),
    [sym_call_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(182),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_break_statement] = STATE(182),
    [sym_parenthesized_expression] = STATE(59),
    [sym_module] = STATE(182),
    [sym_class] = STATE(53),
    [sym_type_alias_declaration] = STATE(182),
    [sym__declaration] = STATE(182),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_if_statement] = STATE(182),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_return_statement] = STATE(182),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_arrow_function] = STATE(59),
    [sym_expression_statement] = STATE(182),
    [sym_spread_element] = STATE(181),
    [sym_try_statement] = STATE(182),
    [sym__property_name] = STATE(183),
    [aux_sym_object_repeat1] = STATE(185),
    [sym_ambient_declaration] = STATE(182),
    [sym_subscript_expression] = STATE(54),
    [sym_template_string] = STATE(59),
    [sym_continue_statement] = STATE(182),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(182),
    [sym_interface_declaration] = STATE(182),
    [sym_while_statement] = STATE(182),
    [sym_meta_property] = STATE(59),
    [sym_method_definition] = STATE(181),
    [sym_enum_declaration] = STATE(182),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(182),
    [sym_sequence_expression] = STATE(62),
    [sym_with_statement] = STATE(182),
    [sym_import_alias] = STATE(182),
    [sym_anonymous_class] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_for_in_statement] = STATE(182),
    [sym_labeled_statement] = STATE(182),
    [sym_array] = STATE(187),
    [sym_type_assertion] = STATE(59),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(370),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_void] = ACTIONS(378),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_get] = ACTIONS(384),
    [anon_sym_RBRACE] = ACTIONS(386),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(384),
    [anon_sym_type] = ACTIONS(388),
    [anon_sym_import] = ACTIONS(390),
    [anon_sym_namespace] = ACTIONS(392),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(396),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(398),
    [anon_sym_number] = ACTIONS(370),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(400),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(370),
    [anon_sym_boolean] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(402),
    [anon_sym_public] = ACTIONS(380),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(404),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(370),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(406),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [36] = {
    [sym_parenthesized_expression] = STATE(188),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [37] = {
    [sym_new_expression] = STATE(199),
    [sym_augmented_assignment_expression] = STATE(199),
    [sym_unary_expression] = STATE(199),
    [sym_regex] = STATE(199),
    [sym_call_signature] = STATE(1740),
    [sym_rest_parameter] = STATE(198),
    [sym_yield_expression] = STATE(199),
    [sym_as_expression] = STATE(199),
    [sym_internal_module] = STATE(199),
    [sym_accessibility_modifier] = STATE(200),
    [sym_arrow_function] = STATE(199),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(199),
    [sym_type_parameters] = STATE(55),
    [sym_object] = STATE(204),
    [sym_generator_function] = STATE(199),
    [sym_subscript_expression] = STATE(1201),
    [sym_ternary_expression] = STATE(199),
    [sym_template_string] = STATE(199),
    [sym_decorator] = STATE(203),
    [sym_formal_parameters] = STATE(58),
    [sym_update_expression] = STATE(199),
    [sym_meta_property] = STATE(199),
    [sym__expression] = STATE(199),
    [sym_non_null_expression] = STATE(199),
    [sym_function] = STATE(1219),
    [sym_required_parameter] = STATE(198),
    [sym_await_expression] = STATE(199),
    [sym_sequence_expression] = STATE(201),
    [sym_this] = STATE(202),
    [aux_sym_export_statement_repeat1] = STATE(203),
    [sym_anonymous_class] = STATE(199),
    [sym_optional_parameter] = STATE(198),
    [sym_call_expression] = STATE(199),
    [sym_assignment_expression] = STATE(199),
    [sym_binary_expression] = STATE(199),
    [sym_type_arguments] = STATE(1205),
    [sym_parenthesized_expression] = STATE(199),
    [sym_array] = STATE(205),
    [sym_type_assertion] = STATE(199),
    [sym_class] = STATE(199),
    [sym_identifier] = ACTIONS(408),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(412),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(414),
    [anon_sym_get] = ACTIONS(410),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(416),
    [anon_sym_protected] = ACTIONS(414),
    [anon_sym_set] = ACTIONS(410),
    [anon_sym_type] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(410),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_namespace] = ACTIONS(420),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(416),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_number] = ACTIONS(410),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(410),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(416),
    [anon_sym_any] = ACTIONS(410),
    [anon_sym_boolean] = ACTIONS(410),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_public] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(428),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(410),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(416),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(410),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [38] = {
    [sym_call_signature] = STATE(206),
    [sym__initializer] = STATE(80),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(432),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(432),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_private] = ACTIONS(432),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_get] = ACTIONS(432),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(432),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_set] = ACTIONS(432),
    [anon_sym_type] = ACTIONS(432),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(432),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(432),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(432),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(432),
    [anon_sym_declare] = ACTIONS(432),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(432),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(432),
    [anon_sym_async] = ACTIONS(432),
    [anon_sym_public] = ACTIONS(432),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(432),
    [anon_sym_function] = ACTIONS(440),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(432),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [39] = {
    [sym_variable_declarator] = STATE(211),
    [sym_array] = STATE(97),
    [sym_object] = STATE(98),
    [sym_identifier] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(185),
  },
  [40] = {
    [sym_type_alias_declaration] = STATE(212),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(212),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(212),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(212),
    [sym_return_statement] = STATE(212),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(212),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(212),
    [sym_switch_statement] = STATE(212),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(212),
    [sym_throw_statement] = STATE(212),
    [aux_sym_program_repeat1] = STATE(212),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(212),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(212),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(212),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(212),
    [sym_abstract_class] = STATE(212),
    [sym_interface_declaration] = STATE(212),
    [sym_statement_block] = STATE(212),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(212),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(212),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(212),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(212),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(212),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(212),
    [sym_empty_statement] = STATE(212),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(212),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(212),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(212),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(212),
    [sym_break_statement] = STATE(212),
    [sym_labeled_statement] = STATE(212),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(212),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(444),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [41] = {
    [sym_parenthesized_expression] = STATE(213),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [42] = {
    [aux_sym_string_repeat2] = STATE(214),
    [sym_escape_sequence] = ACTIONS(446),
    [aux_sym_string_token2] = ACTIONS(446),
    [sym_comment] = ACTIONS(256),
    [anon_sym_SQUOTE] = ACTIONS(254),
  },
  [43] = {
    [sym_statement_block] = STATE(216),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [44] = {
    [sym_tuple_type] = STATE(237),
    [sym__type] = STATE(232),
    [sym_constructor_type] = STATE(232),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_formal_parameters] = STATE(238),
    [sym_nested_type_identifier] = STATE(234),
    [sym_array_type] = STATE(237),
    [sym_function_type] = STATE(232),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_nested_identifier] = STATE(236),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(232),
    [sym_intersection_type] = STATE(232),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_type_parameter] = STATE(235),
    [sym_string] = STATE(218),
    [sym_identifier] = ACTIONS(450),
    [sym_false] = ACTIONS(452),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_this] = ACTIONS(464),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_keyof] = ACTIONS(472),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_boolean] = ACTIONS(462),
  },
  [45] = {
    [sym_regex_pattern] = ACTIONS(486),
    [sym_comment] = ACTIONS(256),
  },
  [46] = {
    [sym_call_signature] = STATE(242),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(488),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_STAR] = ACTIONS(492),
    [sym_comment] = ACTIONS(3),
  },
  [47] = {
    [sym_new_expression] = STATE(244),
    [sym_augmented_assignment_expression] = STATE(250),
    [sym_unary_expression] = STATE(250),
    [sym_update_expression] = STATE(250),
    [sym_regex] = STATE(244),
    [sym_meta_property] = STATE(244),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(250),
    [sym_yield_expression] = STATE(250),
    [sym_as_expression] = STATE(250),
    [sym_non_null_expression] = STATE(250),
    [sym_internal_module] = STATE(250),
    [sym_function] = STATE(251),
    [sym_arrow_function] = STATE(244),
    [sym_await_expression] = STATE(250),
    [sym_member_expression] = STATE(252),
    [sym_string] = STATE(244),
    [sym_this] = STATE(244),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(253),
    [sym_anonymous_class] = STATE(244),
    [sym_generator_function] = STATE(244),
    [sym_call_expression] = STATE(250),
    [sym_subscript_expression] = STATE(252),
    [sym_assignment_expression] = STATE(250),
    [sym_ternary_expression] = STATE(250),
    [sym_binary_expression] = STATE(250),
    [sym_template_string] = STATE(244),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(244),
    [sym_array] = STATE(254),
    [sym_type_assertion] = STATE(250),
    [sym_class] = STATE(244),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(500),
    [sym_super] = ACTIONS(502),
    [anon_sym_private] = ACTIONS(496),
    [anon_sym_get] = ACTIONS(496),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(496),
    [anon_sym_DOT] = ACTIONS(512),
    [anon_sym_set] = ACTIONS(496),
    [anon_sym_type] = ACTIONS(496),
    [anon_sym_import] = ACTIONS(496),
    [anon_sym_namespace] = ACTIONS(514),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(496),
    [anon_sym_number] = ACTIONS(496),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(496),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(496),
    [anon_sym_boolean] = ACTIONS(496),
    [anon_sym_async] = ACTIONS(520),
    [anon_sym_public] = ACTIONS(496),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(522),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(496),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(496),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [48] = {
    [sym_variable_declarator] = STATE(96),
    [sym_array] = STATE(97),
    [sym_object] = STATE(98),
    [sym_identifier] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(185),
  },
  [49] = {
    [sym_type_alias_declaration] = STATE(261),
    [sym__declaration] = STATE(261),
    [sym__initializer] = STATE(80),
    [sym_internal_module] = STATE(261),
    [sym_enum_declaration] = STATE(261),
    [sym_function] = STATE(261),
    [sym_variable_declaration] = STATE(261),
    [aux_sym_export_statement_repeat1] = STATE(159),
    [sym_ambient_declaration] = STATE(261),
    [sym_import_alias] = STATE(261),
    [sym_export_statement] = STATE(261),
    [sym_generator_function] = STATE(261),
    [sym_export_clause] = STATE(262),
    [sym_lexical_declaration] = STATE(261),
    [sym_decorator] = STATE(159),
    [sym_function_signature] = STATE(261),
    [sym_abstract_class] = STATE(261),
    [sym_module] = STATE(261),
    [sym_interface_declaration] = STATE(261),
    [sym_class] = STATE(261),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(524),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(527),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_const] = ACTIONS(338),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_interface] = ACTIONS(340),
    [anon_sym_default] = ACTIONS(529),
    [anon_sym_as] = ACTIONS(531),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_abstract] = ACTIONS(344),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(534),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(354),
    [anon_sym_declare] = ACTIONS(356),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_async] = ACTIONS(358),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_var] = ACTIONS(360),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_function] = ACTIONS(362),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_let] = ACTIONS(364),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(366),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [50] = {
    [sym_type_alias_declaration] = STATE(263),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(263),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(263),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(263),
    [sym_return_statement] = STATE(263),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(263),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(263),
    [sym_switch_statement] = STATE(263),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(263),
    [sym_throw_statement] = STATE(263),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(263),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(263),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(263),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(263),
    [sym_abstract_class] = STATE(263),
    [sym_interface_declaration] = STATE(263),
    [sym_statement_block] = STATE(263),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(263),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(263),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(263),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(263),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(263),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(263),
    [sym_empty_statement] = STATE(263),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(263),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(263),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(263),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(263),
    [sym_break_statement] = STATE(263),
    [sym_labeled_statement] = STATE(263),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(263),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [51] = {
    [sym_parenthesized_expression] = STATE(264),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [52] = {
    [anon_sym_EQ_GT] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
  },
  [53] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(562),
    [anon_sym_symbol] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_break] = ACTIONS(564),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_return] = ACTIONS(564),
    [anon_sym_RBRACE] = ACTIONS(562),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_interface] = ACTIONS(564),
    [anon_sym_as] = ACTIONS(115),
    [anon_sym_delete] = ACTIONS(564),
    [anon_sym_if] = ACTIONS(564),
    [anon_sym_instanceof] = ACTIONS(115),
    [anon_sym_yield] = ACTIONS(564),
    [sym_true] = ACTIONS(564),
    [anon_sym_protected] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_set] = ACTIONS(564),
    [anon_sym_import] = ACTIONS(564),
    [anon_sym_await] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_SEMI] = ACTIONS(562),
    [anon_sym_number] = ACTIONS(564),
    [anon_sym_typeof] = ACTIONS(564),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_switch] = ACTIONS(564),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [sym_null] = ACTIONS(564),
    [anon_sym_any] = ACTIONS(564),
    [anon_sym_async] = ACTIONS(564),
    [anon_sym_public] = ACTIONS(564),
    [anon_sym_var] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(564),
    [anon_sym_SQUOTE] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(564),
    [anon_sym_new] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_export] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_with] = ACTIONS(564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_debugger] = ACTIONS(564),
    [anon_sym_AT] = ACTIONS(562),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(564),
    [anon_sym_const] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [sym_super] = ACTIONS(564),
    [anon_sym_private] = ACTIONS(564),
    [anon_sym_get] = ACTIONS(564),
    [anon_sym_default] = ACTIONS(564),
    [anon_sym_enum] = ACTIONS(564),
    [anon_sym_continue] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(562),
    [anon_sym_this] = ACTIONS(564),
    [anon_sym_throw] = ACTIONS(564),
    [anon_sym_abstract] = ACTIONS(564),
    [anon_sym_type] = ACTIONS(564),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(564),
    [anon_sym_PLUS_PLUS] = ACTIONS(562),
    [anon_sym_else] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LBRACK] = ACTIONS(562),
    [sym_false] = ACTIONS(564),
    [anon_sym_case] = ACTIONS(564),
    [anon_sym_module] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(564),
    [anon_sym_declare] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(562),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_boolean] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(564),
    [sym_number] = ACTIONS(562),
    [ts_builtin_sym_end] = ACTIONS(562),
    [anon_sym_function] = ACTIONS(564),
    [sym_undefined] = ACTIONS(564),
    [anon_sym_let] = ACTIONS(564),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_do] = ACTIONS(564),
    [anon_sym_TILDE] = ACTIONS(562),
    [anon_sym_in] = ACTIONS(115),
  },
  [54] = {
    [sym__initializer] = STATE(72),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(113),
    [anon_sym_AMP_EQ] = ACTIONS(113),
    [anon_sym_PLUS_EQ] = ACTIONS(113),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(113),
    [anon_sym_PIPE_EQ] = ACTIONS(113),
    [anon_sym_DASH_EQ] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(113),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(113),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [55] = {
    [sym_formal_parameters] = STATE(265),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [56] = {
    [sym_type_alias_declaration] = STATE(266),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(266),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(266),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(266),
    [sym_return_statement] = STATE(266),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(266),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(266),
    [sym_switch_statement] = STATE(266),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(266),
    [sym_throw_statement] = STATE(266),
    [aux_sym_program_repeat1] = STATE(266),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(266),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(266),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(266),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(266),
    [sym_abstract_class] = STATE(266),
    [sym_interface_declaration] = STATE(266),
    [sym_statement_block] = STATE(266),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(266),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(266),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(266),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(266),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(266),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(266),
    [sym_empty_statement] = STATE(266),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(266),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(266),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(266),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(266),
    [sym_break_statement] = STATE(266),
    [sym_labeled_statement] = STATE(266),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(266),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(444),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [57] = {
    [sym__initializer] = STATE(267),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [58] = {
    [sym_type_annotation] = STATE(269),
    [anon_sym_EQ_GT] = ACTIONS(566),
    [anon_sym_COLON] = ACTIONS(568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(566),
  },
  [59] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [sym__automatic_semicolon] = ACTIONS(570),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(570),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_BANG] = ACTIONS(600),
  },
  [60] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(564),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_break] = ACTIONS(564),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_return] = ACTIONS(564),
    [anon_sym_RBRACE] = ACTIONS(562),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_interface] = ACTIONS(564),
    [anon_sym_as] = ACTIONS(115),
    [anon_sym_delete] = ACTIONS(564),
    [anon_sym_if] = ACTIONS(564),
    [anon_sym_instanceof] = ACTIONS(115),
    [anon_sym_yield] = ACTIONS(564),
    [sym_true] = ACTIONS(564),
    [anon_sym_protected] = ACTIONS(564),
    [anon_sym_DOT] = ACTIONS(115),
    [anon_sym_set] = ACTIONS(564),
    [anon_sym_import] = ACTIONS(564),
    [anon_sym_await] = ACTIONS(564),
    [anon_sym_DQUOTE] = ACTIONS(562),
    [anon_sym_for] = ACTIONS(564),
    [anon_sym_SEMI] = ACTIONS(562),
    [anon_sym_number] = ACTIONS(564),
    [anon_sym_typeof] = ACTIONS(564),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(562),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_switch] = ACTIONS(564),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [sym_null] = ACTIONS(564),
    [anon_sym_any] = ACTIONS(564),
    [anon_sym_async] = ACTIONS(564),
    [anon_sym_public] = ACTIONS(564),
    [anon_sym_var] = ACTIONS(564),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(564),
    [anon_sym_SQUOTE] = ACTIONS(562),
    [anon_sym_SLASH] = ACTIONS(564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(564),
    [anon_sym_new] = ACTIONS(564),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_export] = ACTIONS(564),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_with] = ACTIONS(564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [sym_identifier] = ACTIONS(564),
    [anon_sym_debugger] = ACTIONS(564),
    [anon_sym_AT] = ACTIONS(562),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(564),
    [anon_sym_void] = ACTIONS(564),
    [anon_sym_const] = ACTIONS(564),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [sym_super] = ACTIONS(564),
    [anon_sym_private] = ACTIONS(564),
    [anon_sym_get] = ACTIONS(564),
    [anon_sym_default] = ACTIONS(564),
    [anon_sym_enum] = ACTIONS(564),
    [anon_sym_continue] = ACTIONS(564),
    [anon_sym_DASH_DASH] = ACTIONS(562),
    [anon_sym_this] = ACTIONS(564),
    [anon_sym_throw] = ACTIONS(564),
    [anon_sym_abstract] = ACTIONS(564),
    [anon_sym_type] = ACTIONS(564),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_namespace] = ACTIONS(564),
    [anon_sym_PLUS_PLUS] = ACTIONS(562),
    [anon_sym_else] = ACTIONS(564),
    [anon_sym_BANG] = ACTIONS(564),
    [anon_sym_LBRACK] = ACTIONS(562),
    [sym_false] = ACTIONS(564),
    [anon_sym_case] = ACTIONS(564),
    [anon_sym_module] = ACTIONS(564),
    [anon_sym_class] = ACTIONS(564),
    [anon_sym_declare] = ACTIONS(564),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_boolean] = ACTIONS(564),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_try] = ACTIONS(564),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(191),
    [sym_number] = ACTIONS(562),
    [ts_builtin_sym_end] = ACTIONS(562),
    [anon_sym_function] = ACTIONS(564),
    [sym_undefined] = ACTIONS(564),
    [anon_sym_let] = ACTIONS(564),
    [anon_sym_PLUS] = ACTIONS(564),
    [anon_sym_do] = ACTIONS(564),
    [anon_sym_TILDE] = ACTIONS(562),
    [anon_sym_in] = ACTIONS(115),
  },
  [61] = {
    [ts_builtin_sym_end] = ACTIONS(602),
    [sym_comment] = ACTIONS(3),
  },
  [62] = {
    [sym__automatic_semicolon] = ACTIONS(570),
    [anon_sym_SEMI] = ACTIONS(570),
    [sym_comment] = ACTIONS(3),
  },
  [63] = {
    [aux_sym_export_statement_repeat1] = STATE(284),
    [sym_decorator] = STATE(284),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(604),
    [anon_sym_class] = ACTIONS(606),
    [sym_comment] = ACTIONS(3),
  },
  [64] = {
    [sym_new_expression] = STATE(285),
    [sym_augmented_assignment_expression] = STATE(285),
    [sym_unary_expression] = STATE(285),
    [sym_update_expression] = STATE(285),
    [sym_regex] = STATE(285),
    [sym_meta_property] = STATE(285),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(285),
    [sym_yield_expression] = STATE(285),
    [sym_as_expression] = STATE(285),
    [sym_non_null_expression] = STATE(285),
    [sym_internal_module] = STATE(285),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(285),
    [sym_await_expression] = STATE(285),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(285),
    [sym_this] = STATE(285),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(285),
    [sym_generator_function] = STATE(285),
    [sym_call_expression] = STATE(285),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(285),
    [sym_ternary_expression] = STATE(285),
    [sym_binary_expression] = STATE(285),
    [sym_template_string] = STATE(285),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(285),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(285),
    [sym_class] = STATE(285),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(608),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(608),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(608),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(610),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(608),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [65] = {
    [sym__initializer] = STATE(286),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [66] = {
    [sym_new_expression] = STATE(288),
    [sym_augmented_assignment_expression] = STATE(288),
    [sym_unary_expression] = STATE(288),
    [sym_update_expression] = STATE(288),
    [sym_regex] = STATE(288),
    [sym_meta_property] = STATE(288),
    [sym_call_signature] = STATE(52),
    [sym_statement_block] = STATE(287),
    [sym__expression] = STATE(288),
    [sym_yield_expression] = STATE(288),
    [sym_as_expression] = STATE(288),
    [sym_non_null_expression] = STATE(288),
    [sym_internal_module] = STATE(288),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(288),
    [sym_await_expression] = STATE(288),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(288),
    [sym_this] = STATE(288),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(288),
    [sym_generator_function] = STATE(288),
    [sym_call_expression] = STATE(288),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(288),
    [sym_ternary_expression] = STATE(288),
    [sym_binary_expression] = STATE(288),
    [sym_template_string] = STATE(288),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(288),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(288),
    [sym_class] = STATE(288),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(612),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(612),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(614),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(612),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(616),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(612),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [67] = {
    [sym_new_expression] = STATE(289),
    [sym_augmented_assignment_expression] = STATE(289),
    [sym_unary_expression] = STATE(289),
    [sym_update_expression] = STATE(289),
    [sym_regex] = STATE(289),
    [sym_meta_property] = STATE(289),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(289),
    [sym_yield_expression] = STATE(289),
    [sym_as_expression] = STATE(289),
    [sym_non_null_expression] = STATE(289),
    [sym_internal_module] = STATE(289),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(289),
    [sym_await_expression] = STATE(289),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(289),
    [sym_this] = STATE(289),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(289),
    [sym_generator_function] = STATE(289),
    [sym_call_expression] = STATE(289),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(289),
    [sym_ternary_expression] = STATE(289),
    [sym_binary_expression] = STATE(289),
    [sym_template_string] = STATE(289),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(289),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(289),
    [sym_class] = STATE(289),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(618),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(618),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(618),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(620),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(618),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [68] = {
    [sym_new_expression] = STATE(290),
    [sym_augmented_assignment_expression] = STATE(290),
    [sym_unary_expression] = STATE(290),
    [sym_update_expression] = STATE(290),
    [sym_regex] = STATE(290),
    [sym_meta_property] = STATE(290),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(290),
    [sym_yield_expression] = STATE(290),
    [sym_as_expression] = STATE(290),
    [sym_non_null_expression] = STATE(290),
    [sym_internal_module] = STATE(290),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(290),
    [sym_await_expression] = STATE(290),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(290),
    [sym_this] = STATE(290),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(290),
    [sym_generator_function] = STATE(290),
    [sym_call_expression] = STATE(290),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(290),
    [sym_ternary_expression] = STATE(290),
    [sym_binary_expression] = STATE(290),
    [sym_template_string] = STATE(290),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(290),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(290),
    [sym_class] = STATE(290),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(622),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(622),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(622),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(624),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(622),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [69] = {
    [sym_new_expression] = STATE(291),
    [sym_augmented_assignment_expression] = STATE(291),
    [sym_unary_expression] = STATE(291),
    [sym_update_expression] = STATE(291),
    [sym_regex] = STATE(291),
    [sym_meta_property] = STATE(291),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(291),
    [sym_yield_expression] = STATE(291),
    [sym_as_expression] = STATE(291),
    [sym_non_null_expression] = STATE(291),
    [sym_internal_module] = STATE(291),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(291),
    [sym_await_expression] = STATE(291),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(291),
    [sym_this] = STATE(291),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(291),
    [sym_generator_function] = STATE(291),
    [sym_call_expression] = STATE(291),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(291),
    [sym_ternary_expression] = STATE(291),
    [sym_binary_expression] = STATE(291),
    [sym_template_string] = STATE(291),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(291),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(291),
    [sym_class] = STATE(291),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(626),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(626),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(626),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(628),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [70] = {
    [sym_type_alias_declaration] = STATE(292),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(292),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(292),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(292),
    [sym_return_statement] = STATE(292),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(292),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(292),
    [sym_switch_statement] = STATE(292),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(292),
    [sym_throw_statement] = STATE(292),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(292),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(292),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(292),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(292),
    [sym_abstract_class] = STATE(292),
    [sym_interface_declaration] = STATE(292),
    [sym_statement_block] = STATE(292),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(292),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(292),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(292),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(292),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(292),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(292),
    [sym_empty_statement] = STATE(292),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(292),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(292),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(292),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(292),
    [sym_break_statement] = STATE(292),
    [sym_labeled_statement] = STATE(292),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(292),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [71] = {
    [sym_identifier] = ACTIONS(630),
    [sym_comment] = ACTIONS(3),
  },
  [72] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(632),
    [sym__automatic_semicolon] = ACTIONS(632),
    [anon_sym_BQUOTE] = ACTIONS(632),
    [anon_sym_PIPE] = ACTIONS(634),
    [anon_sym_COMMA] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_STAR] = ACTIONS(634),
    [anon_sym_GT_GT_GT] = ACTIONS(632),
    [anon_sym_BANG_EQ] = ACTIONS(634),
    [anon_sym_GT_EQ] = ACTIONS(632),
    [anon_sym_RBRACE] = ACTIONS(632),
    [anon_sym_PERCENT] = ACTIONS(632),
    [anon_sym_as] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_instanceof] = ACTIONS(632),
    [anon_sym_DOT] = ACTIONS(632),
    [anon_sym_STAR_STAR] = ACTIONS(632),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(632),
    [anon_sym_SEMI] = ACTIONS(632),
    [anon_sym_LT_LT] = ACTIONS(632),
    [anon_sym_AMP_AMP] = ACTIONS(632),
    [anon_sym_LT_EQ] = ACTIONS(632),
    [anon_sym_LPAREN] = ACTIONS(632),
    [anon_sym_GT] = ACTIONS(634),
    [anon_sym_AMP] = ACTIONS(634),
    [anon_sym_QMARK] = ACTIONS(632),
    [anon_sym_PIPE_PIPE] = ACTIONS(632),
    [anon_sym_EQ_EQ] = ACTIONS(634),
    [anon_sym_RPAREN] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(634),
    [anon_sym_SLASH] = ACTIONS(634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(632),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_GT_GT] = ACTIONS(634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(632),
    [anon_sym_in] = ACTIONS(634),
  },
  [73] = {
    [sym_new_expression] = STATE(294),
    [sym_augmented_assignment_expression] = STATE(294),
    [sym_unary_expression] = STATE(294),
    [sym_update_expression] = STATE(294),
    [sym_regex] = STATE(294),
    [sym_meta_property] = STATE(294),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(294),
    [sym_yield_expression] = STATE(294),
    [sym_as_expression] = STATE(294),
    [sym_non_null_expression] = STATE(294),
    [sym_internal_module] = STATE(294),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(294),
    [sym_await_expression] = STATE(294),
    [sym_member_expression] = STATE(1201),
    [sym_sequence_expression] = STATE(295),
    [sym_string] = STATE(294),
    [sym_this] = STATE(294),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(294),
    [sym_generator_function] = STATE(294),
    [sym_call_expression] = STATE(294),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(294),
    [sym_ternary_expression] = STATE(294),
    [sym_binary_expression] = STATE(294),
    [sym_template_string] = STATE(294),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(294),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(294),
    [sym_class] = STATE(294),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(266),
    [sym_false] = ACTIONS(636),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(636),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(638),
    [sym_true] = ACTIONS(636),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(636),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [74] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(640),
    [sym__automatic_semicolon] = ACTIONS(640),
    [anon_sym_BQUOTE] = ACTIONS(640),
    [anon_sym_PIPE] = ACTIONS(642),
    [anon_sym_COMMA] = ACTIONS(640),
    [anon_sym_DASH] = ACTIONS(642),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_GT_GT_GT] = ACTIONS(640),
    [anon_sym_BANG_EQ] = ACTIONS(642),
    [anon_sym_GT_EQ] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(640),
    [anon_sym_PERCENT] = ACTIONS(640),
    [anon_sym_as] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_instanceof] = ACTIONS(640),
    [anon_sym_DOT] = ACTIONS(640),
    [anon_sym_STAR_STAR] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(640),
    [anon_sym_LT_LT] = ACTIONS(640),
    [anon_sym_AMP_AMP] = ACTIONS(640),
    [anon_sym_LT_EQ] = ACTIONS(640),
    [anon_sym_LPAREN] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP] = ACTIONS(642),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_PIPE_PIPE] = ACTIONS(640),
    [anon_sym_EQ_EQ] = ACTIONS(642),
    [anon_sym_RPAREN] = ACTIONS(640),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_SLASH] = ACTIONS(642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(642),
    [anon_sym_GT_GT] = ACTIONS(642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(640),
    [anon_sym_in] = ACTIONS(642),
  },
  [75] = {
    [aux_sym_template_string_repeat1] = STATE(297),
    [sym_template_substitution] = STATE(297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [sym__template_chars] = ACTIONS(646),
    [sym_escape_sequence] = ACTIONS(646),
    [sym_comment] = ACTIONS(3),
  },
  [76] = {
    [sym_identifier] = ACTIONS(648),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_debugger] = ACTIONS(648),
    [anon_sym_symbol] = ACTIONS(648),
    [anon_sym_AT] = ACTIONS(650),
    [anon_sym_DASH] = ACTIONS(648),
    [anon_sym_void] = ACTIONS(648),
    [anon_sym_break] = ACTIONS(648),
    [anon_sym_const] = ACTIONS(648),
    [sym_super] = ACTIONS(648),
    [anon_sym_return] = ACTIONS(648),
    [anon_sym_private] = ACTIONS(648),
    [anon_sym_get] = ACTIONS(648),
    [anon_sym_RBRACE] = ACTIONS(650),
    [anon_sym_interface] = ACTIONS(648),
    [anon_sym_default] = ACTIONS(648),
    [anon_sym_enum] = ACTIONS(648),
    [anon_sym_delete] = ACTIONS(648),
    [anon_sym_continue] = ACTIONS(648),
    [anon_sym_DASH_DASH] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(648),
    [anon_sym_this] = ACTIONS(648),
    [anon_sym_yield] = ACTIONS(648),
    [sym_true] = ACTIONS(648),
    [anon_sym_throw] = ACTIONS(648),
    [anon_sym_protected] = ACTIONS(648),
    [anon_sym_abstract] = ACTIONS(648),
    [anon_sym_set] = ACTIONS(648),
    [anon_sym_type] = ACTIONS(648),
    [anon_sym_import] = ACTIONS(648),
    [anon_sym_namespace] = ACTIONS(648),
    [anon_sym_PLUS_PLUS] = ACTIONS(650),
    [anon_sym_await] = ACTIONS(648),
    [anon_sym_DQUOTE] = ACTIONS(650),
    [anon_sym_else] = ACTIONS(648),
    [anon_sym_BANG] = ACTIONS(650),
    [anon_sym_for] = ACTIONS(648),
    [anon_sym_LBRACK] = ACTIONS(650),
    [sym_false] = ACTIONS(648),
    [anon_sym_SEMI] = ACTIONS(650),
    [anon_sym_case] = ACTIONS(648),
    [anon_sym_module] = ACTIONS(648),
    [anon_sym_number] = ACTIONS(648),
    [anon_sym_class] = ACTIONS(648),
    [anon_sym_declare] = ACTIONS(648),
    [anon_sym_typeof] = ACTIONS(648),
    [anon_sym_LBRACE] = ACTIONS(650),
    [anon_sym_switch] = ACTIONS(648),
    [anon_sym_LPAREN] = ACTIONS(650),
    [sym_null] = ACTIONS(648),
    [anon_sym_any] = ACTIONS(648),
    [anon_sym_boolean] = ACTIONS(648),
    [anon_sym_async] = ACTIONS(648),
    [anon_sym_public] = ACTIONS(648),
    [anon_sym_var] = ACTIONS(648),
    [anon_sym_while] = ACTIONS(648),
    [anon_sym_SQUOTE] = ACTIONS(650),
    [anon_sym_try] = ACTIONS(648),
    [anon_sym_LT] = ACTIONS(650),
    [sym_number] = ACTIONS(650),
    [anon_sym_SLASH] = ACTIONS(648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(648),
    [anon_sym_function] = ACTIONS(648),
    [sym_undefined] = ACTIONS(648),
    [anon_sym_new] = ACTIONS(648),
    [ts_builtin_sym_end] = ACTIONS(650),
    [anon_sym_let] = ACTIONS(648),
    [anon_sym_PLUS] = ACTIONS(648),
    [anon_sym_export] = ACTIONS(648),
    [anon_sym_do] = ACTIONS(648),
    [anon_sym_TILDE] = ACTIONS(650),
    [anon_sym_with] = ACTIONS(648),
  },
  [77] = {
    [sym_new_expression] = STATE(299),
    [sym_augmented_assignment_expression] = STATE(299),
    [sym_unary_expression] = STATE(299),
    [sym_update_expression] = STATE(299),
    [sym_regex] = STATE(299),
    [sym_meta_property] = STATE(299),
    [sym_call_signature] = STATE(52),
    [sym_statement_block] = STATE(298),
    [sym__expression] = STATE(299),
    [sym_yield_expression] = STATE(299),
    [sym_as_expression] = STATE(299),
    [sym_non_null_expression] = STATE(299),
    [sym_internal_module] = STATE(299),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(299),
    [sym_await_expression] = STATE(299),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(299),
    [sym_this] = STATE(299),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(299),
    [sym_generator_function] = STATE(299),
    [sym_call_expression] = STATE(299),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(299),
    [sym_ternary_expression] = STATE(299),
    [sym_binary_expression] = STATE(299),
    [sym_template_string] = STATE(299),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(299),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(299),
    [sym_class] = STATE(299),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(652),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(652),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(614),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(652),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(654),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(652),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [78] = {
    [sym_new_expression] = STATE(300),
    [sym_augmented_assignment_expression] = STATE(300),
    [sym_unary_expression] = STATE(300),
    [sym_update_expression] = STATE(300),
    [sym_regex] = STATE(300),
    [sym_meta_property] = STATE(300),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(300),
    [sym_yield_expression] = STATE(300),
    [sym_as_expression] = STATE(300),
    [sym_non_null_expression] = STATE(300),
    [sym_internal_module] = STATE(300),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(300),
    [sym_await_expression] = STATE(300),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(300),
    [sym_this] = STATE(300),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(300),
    [sym_generator_function] = STATE(300),
    [sym_call_expression] = STATE(300),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(300),
    [sym_ternary_expression] = STATE(300),
    [sym_binary_expression] = STATE(300),
    [sym_template_string] = STATE(300),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(300),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(300),
    [sym_class] = STATE(300),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(656),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(656),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(656),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(658),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(656),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [79] = {
    [sym_identifier] = ACTIONS(660),
    [sym_comment] = ACTIONS(3),
  },
  [80] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(662),
    [sym__automatic_semicolon] = ACTIONS(662),
    [anon_sym_BQUOTE] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_COMMA] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(664),
    [anon_sym_GT_GT_GT] = ACTIONS(662),
    [anon_sym_BANG_EQ] = ACTIONS(664),
    [anon_sym_GT_EQ] = ACTIONS(662),
    [anon_sym_RBRACE] = ACTIONS(662),
    [anon_sym_PERCENT] = ACTIONS(662),
    [anon_sym_as] = ACTIONS(662),
    [anon_sym_DASH_DASH] = ACTIONS(662),
    [anon_sym_instanceof] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(662),
    [anon_sym_STAR_STAR] = ACTIONS(662),
    [anon_sym_PLUS_PLUS] = ACTIONS(662),
    [anon_sym_BANG] = ACTIONS(664),
    [anon_sym_LBRACK] = ACTIONS(662),
    [anon_sym_SEMI] = ACTIONS(662),
    [anon_sym_LT_LT] = ACTIONS(662),
    [anon_sym_AMP_AMP] = ACTIONS(662),
    [anon_sym_LT_EQ] = ACTIONS(662),
    [anon_sym_LPAREN] = ACTIONS(662),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_QMARK] = ACTIONS(662),
    [anon_sym_PIPE_PIPE] = ACTIONS(662),
    [anon_sym_EQ_EQ] = ACTIONS(664),
    [anon_sym_RPAREN] = ACTIONS(662),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_SLASH] = ACTIONS(664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(662),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(662),
    [anon_sym_in] = ACTIONS(664),
  },
  [81] = {
    [anon_sym_LBRACK] = ACTIONS(666),
    [sym_identifier] = ACTIONS(668),
    [anon_sym_module] = ACTIONS(668),
    [anon_sym_symbol] = ACTIONS(668),
    [anon_sym_number] = ACTIONS(668),
    [anon_sym_class] = ACTIONS(668),
    [anon_sym_AT] = ACTIONS(666),
    [anon_sym_declare] = ACTIONS(668),
    [anon_sym_STAR] = ACTIONS(666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(666),
    [anon_sym_LBRACE] = ACTIONS(666),
    [anon_sym_void] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(666),
    [anon_sym_any] = ACTIONS(668),
    [anon_sym_private] = ACTIONS(668),
    [anon_sym_boolean] = ACTIONS(668),
    [anon_sym_static] = ACTIONS(668),
    [anon_sym_async] = ACTIONS(668),
    [anon_sym_get] = ACTIONS(668),
    [anon_sym_public] = ACTIONS(668),
    [anon_sym_RBRACE] = ACTIONS(666),
    [anon_sym_SQUOTE] = ACTIONS(666),
    [anon_sym_this] = ACTIONS(668),
    [sym_number] = ACTIONS(666),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(668),
    [anon_sym_string] = ACTIONS(668),
    [anon_sym_abstract] = ACTIONS(668),
    [anon_sym_DOT] = ACTIONS(668),
    [anon_sym_set] = ACTIONS(668),
    [anon_sym_type] = ACTIONS(668),
    [anon_sym_import] = ACTIONS(668),
    [anon_sym_export] = ACTIONS(668),
    [anon_sym_namespace] = ACTIONS(668),
    [sym_readonly] = ACTIONS(668),
    [anon_sym_DQUOTE] = ACTIONS(666),
  },
  [82] = {
    [sym_arguments] = STATE(303),
    [anon_sym_DOT] = ACTIONS(670),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_export] = ACTIONS(674),
    [anon_sym_class] = ACTIONS(674),
    [anon_sym_AT] = ACTIONS(674),
    [sym_comment] = ACTIONS(3),
  },
  [83] = {
    [anon_sym_LBRACK] = ACTIONS(674),
    [sym_identifier] = ACTIONS(676),
    [anon_sym_module] = ACTIONS(676),
    [anon_sym_symbol] = ACTIONS(676),
    [anon_sym_number] = ACTIONS(676),
    [anon_sym_class] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(674),
    [anon_sym_declare] = ACTIONS(676),
    [anon_sym_STAR] = ACTIONS(674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(674),
    [anon_sym_LBRACE] = ACTIONS(674),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_any] = ACTIONS(676),
    [anon_sym_private] = ACTIONS(676),
    [anon_sym_boolean] = ACTIONS(676),
    [anon_sym_static] = ACTIONS(676),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_get] = ACTIONS(676),
    [anon_sym_public] = ACTIONS(676),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_SQUOTE] = ACTIONS(674),
    [anon_sym_this] = ACTIONS(676),
    [sym_number] = ACTIONS(674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(676),
    [anon_sym_string] = ACTIONS(676),
    [anon_sym_abstract] = ACTIONS(676),
    [anon_sym_set] = ACTIONS(676),
    [anon_sym_type] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(676),
    [anon_sym_export] = ACTIONS(676),
    [anon_sym_namespace] = ACTIONS(676),
    [sym_readonly] = ACTIONS(676),
    [anon_sym_DQUOTE] = ACTIONS(674),
  },
  [84] = {
    [sym__initializer] = STATE(72),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(113),
    [anon_sym_AMP_EQ] = ACTIONS(113),
    [anon_sym_PLUS_EQ] = ACTIONS(113),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(113),
    [anon_sym_PIPE_EQ] = ACTIONS(113),
    [anon_sym_DASH_EQ] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(113),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(113),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [85] = {
    [sym_pair] = STATE(181),
    [sym__property_name] = STATE(183),
    [sym_object] = STATE(310),
    [aux_sym_export_statement_repeat1] = STATE(311),
    [aux_sym_object_repeat1] = STATE(185),
    [sym_assignment_pattern] = STATE(181),
    [sym_method_definition] = STATE(181),
    [sym_decorator] = STATE(311),
    [sym_accessibility_modifier] = STATE(180),
    [sym_computed_property_name] = STATE(183),
    [sym_array] = STATE(312),
    [sym_spread_element] = STATE(181),
    [sym_string] = STATE(183),
    [sym_identifier] = ACTIONS(678),
    [anon_sym_LBRACK] = ACTIONS(680),
    [anon_sym_module] = ACTIONS(682),
    [anon_sym_symbol] = ACTIONS(682),
    [anon_sym_number] = ACTIONS(682),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(682),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_void] = ACTIONS(682),
    [anon_sym_any] = ACTIONS(682),
    [anon_sym_private] = ACTIONS(684),
    [anon_sym_boolean] = ACTIONS(682),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_async] = ACTIONS(686),
    [anon_sym_get] = ACTIONS(688),
    [anon_sym_RBRACE] = ACTIONS(690),
    [anon_sym_public] = ACTIONS(684),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [sym_number] = ACTIONS(692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(684),
    [anon_sym_string] = ACTIONS(682),
    [anon_sym_set] = ACTIONS(688),
    [anon_sym_type] = ACTIONS(682),
    [anon_sym_import] = ACTIONS(682),
    [anon_sym_export] = ACTIONS(682),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_namespace] = ACTIONS(682),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [86] = {
    [sym_call_signature] = STATE(206),
    [sym__initializer] = STATE(80),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(432),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(432),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_private] = ACTIONS(432),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_get] = ACTIONS(432),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(432),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_set] = ACTIONS(432),
    [anon_sym_type] = ACTIONS(432),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(432),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(432),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(432),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(432),
    [anon_sym_declare] = ACTIONS(432),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(432),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(432),
    [anon_sym_async] = ACTIONS(432),
    [anon_sym_public] = ACTIONS(432),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(432),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(432),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [87] = {
    [sym_call_signature] = STATE(1798),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(696),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_STAR] = ACTIONS(698),
    [sym_comment] = ACTIONS(3),
  },
  [88] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [sym__automatic_semicolon] = ACTIONS(700),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_COMMA] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_RBRACE] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(700),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_RPAREN] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(704),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [89] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [90] = {
    [aux_sym_export_statement_repeat1] = STATE(284),
    [sym_decorator] = STATE(284),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(707),
    [sym_comment] = ACTIONS(3),
  },
  [91] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [sym__automatic_semicolon] = ACTIONS(700),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_COMMA] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_RBRACE] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(700),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_RPAREN] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(704),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [92] = {
    [sym_identifier] = ACTIONS(709),
    [anon_sym_BQUOTE] = ACTIONS(711),
    [anon_sym_debugger] = ACTIONS(709),
    [anon_sym_symbol] = ACTIONS(709),
    [anon_sym_AT] = ACTIONS(711),
    [anon_sym_DASH] = ACTIONS(709),
    [anon_sym_void] = ACTIONS(709),
    [anon_sym_break] = ACTIONS(709),
    [anon_sym_const] = ACTIONS(709),
    [sym_super] = ACTIONS(709),
    [anon_sym_return] = ACTIONS(709),
    [anon_sym_private] = ACTIONS(709),
    [anon_sym_get] = ACTIONS(709),
    [anon_sym_RBRACE] = ACTIONS(711),
    [anon_sym_interface] = ACTIONS(709),
    [anon_sym_default] = ACTIONS(709),
    [anon_sym_enum] = ACTIONS(709),
    [anon_sym_delete] = ACTIONS(709),
    [anon_sym_continue] = ACTIONS(709),
    [anon_sym_DASH_DASH] = ACTIONS(711),
    [anon_sym_if] = ACTIONS(709),
    [anon_sym_this] = ACTIONS(709),
    [anon_sym_yield] = ACTIONS(709),
    [sym_true] = ACTIONS(709),
    [anon_sym_throw] = ACTIONS(709),
    [anon_sym_protected] = ACTIONS(709),
    [anon_sym_abstract] = ACTIONS(709),
    [anon_sym_set] = ACTIONS(709),
    [anon_sym_type] = ACTIONS(709),
    [anon_sym_import] = ACTIONS(709),
    [anon_sym_namespace] = ACTIONS(709),
    [anon_sym_PLUS_PLUS] = ACTIONS(711),
    [anon_sym_await] = ACTIONS(709),
    [anon_sym_DQUOTE] = ACTIONS(711),
    [anon_sym_else] = ACTIONS(709),
    [anon_sym_BANG] = ACTIONS(711),
    [anon_sym_for] = ACTIONS(709),
    [anon_sym_LBRACK] = ACTIONS(711),
    [sym_false] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(711),
    [anon_sym_case] = ACTIONS(709),
    [anon_sym_module] = ACTIONS(709),
    [anon_sym_number] = ACTIONS(709),
    [anon_sym_class] = ACTIONS(709),
    [anon_sym_declare] = ACTIONS(709),
    [anon_sym_typeof] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(711),
    [anon_sym_switch] = ACTIONS(709),
    [anon_sym_LPAREN] = ACTIONS(711),
    [sym_null] = ACTIONS(709),
    [anon_sym_any] = ACTIONS(709),
    [anon_sym_boolean] = ACTIONS(709),
    [anon_sym_async] = ACTIONS(709),
    [anon_sym_public] = ACTIONS(709),
    [anon_sym_var] = ACTIONS(709),
    [anon_sym_while] = ACTIONS(709),
    [anon_sym_SQUOTE] = ACTIONS(711),
    [anon_sym_try] = ACTIONS(709),
    [anon_sym_LT] = ACTIONS(711),
    [sym_number] = ACTIONS(711),
    [anon_sym_SLASH] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(709),
    [anon_sym_function] = ACTIONS(709),
    [sym_undefined] = ACTIONS(709),
    [anon_sym_new] = ACTIONS(709),
    [ts_builtin_sym_end] = ACTIONS(711),
    [anon_sym_let] = ACTIONS(709),
    [anon_sym_PLUS] = ACTIONS(709),
    [anon_sym_export] = ACTIONS(709),
    [anon_sym_do] = ACTIONS(709),
    [anon_sym_TILDE] = ACTIONS(711),
    [anon_sym_with] = ACTIONS(709),
  },
  [93] = {
    [sym__automatic_semicolon] = ACTIONS(713),
    [anon_sym_SEMI] = ACTIONS(713),
    [sym_comment] = ACTIONS(3),
  },
  [94] = {
    [sym__initializer] = STATE(316),
    [sym_type_annotation] = STATE(317),
    [sym__automatic_semicolon] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym_COMMA] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
  },
  [95] = {
    [sym_identifier] = ACTIONS(721),
    [sym_comment] = ACTIONS(3),
  },
  [96] = {
    [aux_sym_variable_declaration_repeat1] = STATE(321),
    [sym__automatic_semicolon] = ACTIONS(723),
    [anon_sym_SEMI] = ACTIONS(723),
    [anon_sym_COMMA] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
  },
  [97] = {
    [sym__initializer] = STATE(322),
    [sym_type_annotation] = STATE(323),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(568),
    [sym_comment] = ACTIONS(3),
  },
  [98] = {
    [sym__initializer] = STATE(324),
    [sym_type_annotation] = STATE(325),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(568),
    [sym_comment] = ACTIONS(3),
  },
  [99] = {
    [sym_new_expression] = STATE(326),
    [sym_augmented_assignment_expression] = STATE(326),
    [sym_unary_expression] = STATE(326),
    [sym_update_expression] = STATE(326),
    [sym_regex] = STATE(326),
    [sym_meta_property] = STATE(326),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(326),
    [sym_yield_expression] = STATE(326),
    [sym_as_expression] = STATE(326),
    [sym_non_null_expression] = STATE(326),
    [sym_internal_module] = STATE(326),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(326),
    [sym_await_expression] = STATE(326),
    [sym_member_expression] = STATE(1201),
    [sym_sequence_expression] = STATE(327),
    [sym_string] = STATE(326),
    [sym_this] = STATE(326),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(326),
    [sym_generator_function] = STATE(326),
    [sym_call_expression] = STATE(326),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(326),
    [sym_ternary_expression] = STATE(326),
    [sym_binary_expression] = STATE(326),
    [sym_template_string] = STATE(326),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(326),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(326),
    [sym_class] = STATE(326),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(727),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(727),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(727),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(729),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(727),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [100] = {
    [sym__type] = STATE(232),
    [sym_constructor_type] = STATE(232),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(232),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(232),
    [sym_intersection_type] = STATE(232),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [101] = {
    [sym_new_expression] = STATE(330),
    [sym_augmented_assignment_expression] = STATE(330),
    [sym_unary_expression] = STATE(330),
    [sym_regex] = STATE(330),
    [sym_call_signature] = STATE(1740),
    [sym_yield_expression] = STATE(330),
    [sym_as_expression] = STATE(330),
    [sym_internal_module] = STATE(330),
    [sym_arrow_function] = STATE(330),
    [sym_member_expression] = STATE(1201),
    [sym_spread_element] = STATE(331),
    [sym_string] = STATE(330),
    [sym_type_parameters] = STATE(55),
    [sym_object] = STATE(1202),
    [sym_generator_function] = STATE(330),
    [sym_subscript_expression] = STATE(1201),
    [sym_ternary_expression] = STATE(330),
    [sym_template_string] = STATE(330),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_update_expression] = STATE(330),
    [sym_meta_property] = STATE(330),
    [sym__expression] = STATE(330),
    [sym_non_null_expression] = STATE(330),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(330),
    [sym_this] = STATE(330),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [aux_sym_array_repeat1] = STATE(332),
    [sym_anonymous_class] = STATE(330),
    [sym_call_expression] = STATE(330),
    [sym_assignment_expression] = STATE(330),
    [sym_binary_expression] = STATE(330),
    [sym_type_arguments] = STATE(1205),
    [sym_parenthesized_expression] = STATE(330),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(330),
    [sym_class] = STATE(330),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(733),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(733),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(733),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(735),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(737),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(733),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [102] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(739),
    [sym__automatic_semicolon] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_COMMA] = ACTIONS(739),
    [anon_sym_DASH] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_GT_GT_GT] = ACTIONS(739),
    [anon_sym_BANG_EQ] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(739),
    [anon_sym_RBRACE] = ACTIONS(739),
    [anon_sym_PERCENT] = ACTIONS(739),
    [anon_sym_as] = ACTIONS(739),
    [anon_sym_DASH_DASH] = ACTIONS(739),
    [anon_sym_instanceof] = ACTIONS(739),
    [anon_sym_DOT] = ACTIONS(739),
    [anon_sym_STAR_STAR] = ACTIONS(739),
    [anon_sym_PLUS_PLUS] = ACTIONS(739),
    [anon_sym_BANG] = ACTIONS(741),
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_SEMI] = ACTIONS(739),
    [anon_sym_LT_LT] = ACTIONS(739),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_LT_EQ] = ACTIONS(739),
    [anon_sym_LPAREN] = ACTIONS(739),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_RPAREN] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(739),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(739),
    [anon_sym_in] = ACTIONS(741),
  },
  [103] = {
    [sym_template_string] = STATE(333),
    [sym_arguments] = STATE(333),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LPAREN] = ACTIONS(189),
    [sym_comment] = ACTIONS(3),
  },
  [104] = {
    [sym_identifier] = ACTIONS(743),
    [anon_sym_BQUOTE] = ACTIONS(745),
    [anon_sym_debugger] = ACTIONS(743),
    [anon_sym_symbol] = ACTIONS(743),
    [anon_sym_AT] = ACTIONS(745),
    [anon_sym_DASH] = ACTIONS(743),
    [anon_sym_void] = ACTIONS(743),
    [anon_sym_break] = ACTIONS(743),
    [anon_sym_const] = ACTIONS(743),
    [sym_super] = ACTIONS(743),
    [anon_sym_return] = ACTIONS(743),
    [anon_sym_private] = ACTIONS(743),
    [anon_sym_get] = ACTIONS(743),
    [anon_sym_RBRACE] = ACTIONS(745),
    [anon_sym_interface] = ACTIONS(743),
    [anon_sym_default] = ACTIONS(743),
    [anon_sym_enum] = ACTIONS(743),
    [anon_sym_delete] = ACTIONS(743),
    [anon_sym_continue] = ACTIONS(743),
    [anon_sym_DASH_DASH] = ACTIONS(745),
    [anon_sym_if] = ACTIONS(743),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_yield] = ACTIONS(743),
    [sym_true] = ACTIONS(743),
    [anon_sym_throw] = ACTIONS(743),
    [anon_sym_protected] = ACTIONS(743),
    [anon_sym_abstract] = ACTIONS(743),
    [anon_sym_set] = ACTIONS(743),
    [anon_sym_type] = ACTIONS(743),
    [anon_sym_import] = ACTIONS(743),
    [anon_sym_namespace] = ACTIONS(743),
    [anon_sym_PLUS_PLUS] = ACTIONS(745),
    [anon_sym_await] = ACTIONS(743),
    [anon_sym_DQUOTE] = ACTIONS(745),
    [anon_sym_else] = ACTIONS(743),
    [anon_sym_BANG] = ACTIONS(745),
    [anon_sym_for] = ACTIONS(743),
    [anon_sym_LBRACK] = ACTIONS(745),
    [sym_false] = ACTIONS(743),
    [anon_sym_SEMI] = ACTIONS(745),
    [anon_sym_case] = ACTIONS(743),
    [anon_sym_module] = ACTIONS(743),
    [anon_sym_number] = ACTIONS(743),
    [anon_sym_class] = ACTIONS(743),
    [anon_sym_declare] = ACTIONS(743),
    [anon_sym_typeof] = ACTIONS(743),
    [anon_sym_LBRACE] = ACTIONS(745),
    [anon_sym_switch] = ACTIONS(743),
    [anon_sym_LPAREN] = ACTIONS(745),
    [sym_null] = ACTIONS(743),
    [anon_sym_any] = ACTIONS(743),
    [anon_sym_boolean] = ACTIONS(743),
    [anon_sym_async] = ACTIONS(743),
    [anon_sym_public] = ACTIONS(743),
    [anon_sym_var] = ACTIONS(743),
    [anon_sym_while] = ACTIONS(743),
    [anon_sym_SQUOTE] = ACTIONS(745),
    [anon_sym_try] = ACTIONS(743),
    [anon_sym_LT] = ACTIONS(745),
    [sym_number] = ACTIONS(745),
    [anon_sym_SLASH] = ACTIONS(743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(743),
    [anon_sym_function] = ACTIONS(743),
    [sym_undefined] = ACTIONS(743),
    [anon_sym_new] = ACTIONS(743),
    [ts_builtin_sym_end] = ACTIONS(745),
    [anon_sym_let] = ACTIONS(743),
    [anon_sym_PLUS] = ACTIONS(743),
    [anon_sym_export] = ACTIONS(743),
    [anon_sym_do] = ACTIONS(743),
    [anon_sym_TILDE] = ACTIONS(745),
    [anon_sym_with] = ACTIONS(743),
  },
  [105] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(747),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(747),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_BANG] = ACTIONS(600),
  },
  [106] = {
    [sym__automatic_semicolon] = ACTIONS(747),
    [anon_sym_SEMI] = ACTIONS(747),
    [sym_comment] = ACTIONS(3),
  },
  [107] = {
    [sym_object_type] = STATE(336),
    [sym_extends_clause] = STATE(337),
    [sym_type_parameters] = STATE(335),
    [anon_sym_extends] = ACTIONS(749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(476),
  },
  [108] = {
    [sym_enum_body] = STATE(339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(751),
  },
  [109] = {
    [sym_identifier] = ACTIONS(753),
    [anon_sym_BQUOTE] = ACTIONS(755),
    [anon_sym_debugger] = ACTIONS(753),
    [anon_sym_symbol] = ACTIONS(753),
    [anon_sym_AT] = ACTIONS(755),
    [anon_sym_DASH] = ACTIONS(753),
    [anon_sym_void] = ACTIONS(753),
    [anon_sym_break] = ACTIONS(753),
    [anon_sym_const] = ACTIONS(753),
    [sym_super] = ACTIONS(753),
    [anon_sym_return] = ACTIONS(753),
    [anon_sym_private] = ACTIONS(753),
    [anon_sym_get] = ACTIONS(753),
    [anon_sym_RBRACE] = ACTIONS(755),
    [anon_sym_interface] = ACTIONS(753),
    [anon_sym_default] = ACTIONS(753),
    [anon_sym_enum] = ACTIONS(753),
    [anon_sym_delete] = ACTIONS(753),
    [anon_sym_continue] = ACTIONS(753),
    [anon_sym_DASH_DASH] = ACTIONS(755),
    [anon_sym_if] = ACTIONS(753),
    [anon_sym_this] = ACTIONS(753),
    [anon_sym_yield] = ACTIONS(753),
    [sym_true] = ACTIONS(753),
    [anon_sym_throw] = ACTIONS(753),
    [anon_sym_protected] = ACTIONS(753),
    [anon_sym_abstract] = ACTIONS(753),
    [anon_sym_set] = ACTIONS(753),
    [anon_sym_type] = ACTIONS(753),
    [anon_sym_import] = ACTIONS(753),
    [anon_sym_namespace] = ACTIONS(753),
    [anon_sym_PLUS_PLUS] = ACTIONS(755),
    [anon_sym_await] = ACTIONS(753),
    [anon_sym_DQUOTE] = ACTIONS(755),
    [anon_sym_else] = ACTIONS(753),
    [anon_sym_BANG] = ACTIONS(755),
    [anon_sym_for] = ACTIONS(753),
    [anon_sym_LBRACK] = ACTIONS(755),
    [sym_false] = ACTIONS(753),
    [anon_sym_SEMI] = ACTIONS(755),
    [anon_sym_case] = ACTIONS(753),
    [anon_sym_module] = ACTIONS(753),
    [anon_sym_number] = ACTIONS(753),
    [anon_sym_class] = ACTIONS(753),
    [anon_sym_declare] = ACTIONS(753),
    [anon_sym_typeof] = ACTIONS(753),
    [anon_sym_LBRACE] = ACTIONS(755),
    [anon_sym_switch] = ACTIONS(753),
    [anon_sym_LPAREN] = ACTIONS(755),
    [sym_null] = ACTIONS(753),
    [anon_sym_any] = ACTIONS(753),
    [anon_sym_boolean] = ACTIONS(753),
    [anon_sym_async] = ACTIONS(753),
    [anon_sym_public] = ACTIONS(753),
    [anon_sym_var] = ACTIONS(753),
    [anon_sym_while] = ACTIONS(753),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_try] = ACTIONS(753),
    [anon_sym_LT] = ACTIONS(755),
    [sym_number] = ACTIONS(755),
    [anon_sym_SLASH] = ACTIONS(753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(753),
    [anon_sym_function] = ACTIONS(753),
    [sym_undefined] = ACTIONS(753),
    [anon_sym_new] = ACTIONS(753),
    [ts_builtin_sym_end] = ACTIONS(755),
    [anon_sym_let] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(753),
    [anon_sym_export] = ACTIONS(753),
    [anon_sym_do] = ACTIONS(753),
    [anon_sym_TILDE] = ACTIONS(755),
    [anon_sym_with] = ACTIONS(753),
  },
  [110] = {
    [sym__automatic_semicolon] = ACTIONS(757),
    [anon_sym_SEMI] = ACTIONS(757),
    [sym_comment] = ACTIONS(3),
  },
  [111] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(759),
    [sym__automatic_semicolon] = ACTIONS(759),
    [anon_sym_BQUOTE] = ACTIONS(759),
    [anon_sym_PIPE] = ACTIONS(761),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_DASH] = ACTIONS(761),
    [anon_sym_STAR] = ACTIONS(761),
    [anon_sym_GT_GT_GT] = ACTIONS(759),
    [anon_sym_BANG_EQ] = ACTIONS(761),
    [anon_sym_GT_EQ] = ACTIONS(759),
    [anon_sym_RBRACE] = ACTIONS(759),
    [anon_sym_PERCENT] = ACTIONS(759),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(759),
    [anon_sym_instanceof] = ACTIONS(759),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(759),
    [anon_sym_PLUS_PLUS] = ACTIONS(759),
    [anon_sym_BANG] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(759),
    [anon_sym_LT_LT] = ACTIONS(759),
    [anon_sym_AMP_AMP] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_GT] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(759),
    [anon_sym_EQ_EQ] = ACTIONS(761),
    [anon_sym_RPAREN] = ACTIONS(759),
    [anon_sym_LT] = ACTIONS(761),
    [anon_sym_SLASH] = ACTIONS(761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(759),
    [anon_sym_PLUS] = ACTIONS(761),
    [anon_sym_GT_GT] = ACTIONS(761),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(759),
    [anon_sym_in] = ACTIONS(761),
  },
  [112] = {
    [sym_new_expression] = STATE(1780),
    [sym_augmented_assignment_expression] = STATE(1780),
    [sym_unary_expression] = STATE(1780),
    [sym_update_expression] = STATE(1780),
    [sym_regex] = STATE(1780),
    [sym_meta_property] = STATE(1780),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1780),
    [sym_yield_expression] = STATE(1780),
    [sym_as_expression] = STATE(1780),
    [sym_non_null_expression] = STATE(1780),
    [sym_internal_module] = STATE(1780),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1780),
    [sym_await_expression] = STATE(1780),
    [sym_member_expression] = STATE(1201),
    [sym_sequence_expression] = STATE(1781),
    [sym_string] = STATE(1780),
    [sym_this] = STATE(1780),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1780),
    [sym_generator_function] = STATE(1780),
    [sym_call_expression] = STATE(1780),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1780),
    [sym_ternary_expression] = STATE(1780),
    [sym_binary_expression] = STATE(1780),
    [sym_template_string] = STATE(1780),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1780),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1780),
    [sym_class] = STATE(1780),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(763),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(763),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(763),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(765),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(763),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [113] = {
    [sym_type_alias_declaration] = STATE(341),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(341),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(341),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(341),
    [sym_return_statement] = STATE(341),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(341),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(341),
    [sym_switch_statement] = STATE(341),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(341),
    [sym_throw_statement] = STATE(341),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(341),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(341),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(341),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(341),
    [sym_abstract_class] = STATE(341),
    [sym_interface_declaration] = STATE(341),
    [sym_statement_block] = STATE(341),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(341),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(341),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(341),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(341),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(341),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(341),
    [sym_empty_statement] = STATE(341),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(341),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(341),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(341),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(341),
    [sym_break_statement] = STATE(341),
    [sym_labeled_statement] = STATE(341),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(341),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [114] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [sym__automatic_semicolon] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(590),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_RPAREN] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_in] = ACTIONS(125),
  },
  [115] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(769),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(769),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_BANG] = ACTIONS(600),
  },
  [116] = {
    [sym__automatic_semicolon] = ACTIONS(769),
    [anon_sym_SEMI] = ACTIONS(769),
    [sym_comment] = ACTIONS(3),
  },
  [117] = {
    [sym_identifier] = ACTIONS(771),
    [sym_comment] = ACTIONS(3),
  },
  [118] = {
    [sym_type_parameters] = STATE(345),
    [anon_sym_EQ] = ACTIONS(773),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
  },
  [119] = {
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_from] = ACTIONS(779),
    [sym_comment] = ACTIONS(3),
  },
  [120] = {
    [sym_import_require_clause] = STATE(349),
    [sym_named_imports] = STATE(125),
    [sym_import_clause] = STATE(350),
    [sym_string] = STATE(349),
    [sym_namespace_import] = STATE(125),
    [anon_sym_STAR] = ACTIONS(781),
    [sym_identifier] = ACTIONS(783),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(240),
  },
  [121] = {
    [anon_sym_as] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
  },
  [122] = {
    [sym__import_export_specifier] = STATE(356),
    [sym_identifier] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(789),
    [anon_sym_typeof] = ACTIONS(791),
    [anon_sym_COMMA] = ACTIONS(793),
    [anon_sym_type] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
  },
  [123] = {
    [sym__automatic_semicolon] = ACTIONS(795),
    [anon_sym_SEMI] = ACTIONS(795),
    [sym_comment] = ACTIONS(3),
  },
  [124] = {
    [sym__from_clause] = STATE(349),
    [anon_sym_from] = ACTIONS(797),
    [sym_comment] = ACTIONS(3),
  },
  [125] = {
    [anon_sym_from] = ACTIONS(779),
    [sym_comment] = ACTIONS(3),
  },
  [126] = {
    [sym_statement_block] = STATE(360),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(799),
    [sym__automatic_semicolon] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(799),
    [anon_sym_symbol] = ACTIONS(801),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_GT_GT_GT] = ACTIONS(799),
    [anon_sym_break] = ACTIONS(801),
    [anon_sym_BANG_EQ] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(799),
    [anon_sym_PERCENT] = ACTIONS(799),
    [anon_sym_interface] = ACTIONS(801),
    [anon_sym_as] = ACTIONS(801),
    [anon_sym_delete] = ACTIONS(801),
    [anon_sym_if] = ACTIONS(801),
    [anon_sym_instanceof] = ACTIONS(801),
    [anon_sym_yield] = ACTIONS(801),
    [sym_true] = ACTIONS(801),
    [anon_sym_protected] = ACTIONS(801),
    [anon_sym_DOT] = ACTIONS(803),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_import] = ACTIONS(801),
    [anon_sym_await] = ACTIONS(801),
    [anon_sym_DQUOTE] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_SEMI] = ACTIONS(799),
    [anon_sym_number] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(801),
    [anon_sym_LT_LT] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(799),
    [anon_sym_switch] = ACTIONS(801),
    [anon_sym_LT_EQ] = ACTIONS(799),
    [sym_null] = ACTIONS(801),
    [anon_sym_any] = ACTIONS(801),
    [anon_sym_async] = ACTIONS(801),
    [anon_sym_public] = ACTIONS(801),
    [anon_sym_var] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_while] = ACTIONS(801),
    [anon_sym_SQUOTE] = ACTIONS(799),
    [anon_sym_SLASH] = ACTIONS(801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(801),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_with] = ACTIONS(801),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(799),
    [sym_identifier] = ACTIONS(801),
    [anon_sym_debugger] = ACTIONS(801),
    [anon_sym_AT] = ACTIONS(799),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_const] = ACTIONS(801),
    [anon_sym_GT_EQ] = ACTIONS(799),
    [sym_super] = ACTIONS(801),
    [anon_sym_private] = ACTIONS(801),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_default] = ACTIONS(801),
    [anon_sym_enum] = ACTIONS(801),
    [anon_sym_continue] = ACTIONS(801),
    [anon_sym_DASH_DASH] = ACTIONS(799),
    [anon_sym_this] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(801),
    [anon_sym_abstract] = ACTIONS(801),
    [anon_sym_type] = ACTIONS(801),
    [anon_sym_STAR_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(799),
    [anon_sym_else] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(799),
    [sym_false] = ACTIONS(801),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_module] = ACTIONS(801),
    [anon_sym_class] = ACTIONS(801),
    [anon_sym_declare] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(799),
    [anon_sym_GT] = ACTIONS(801),
    [anon_sym_boolean] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_PIPE_PIPE] = ACTIONS(799),
    [anon_sym_try] = ACTIONS(801),
    [anon_sym_EQ_EQ] = ACTIONS(801),
    [anon_sym_LT] = ACTIONS(801),
    [sym_number] = ACTIONS(799),
    [ts_builtin_sym_end] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [sym_undefined] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(801),
    [anon_sym_do] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(799),
    [anon_sym_in] = ACTIONS(801),
  },
  [127] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(807),
    [sym__automatic_semicolon] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_symbol] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(809),
    [anon_sym_GT_GT_GT] = ACTIONS(807),
    [anon_sym_break] = ACTIONS(809),
    [anon_sym_BANG_EQ] = ACTIONS(809),
    [anon_sym_return] = ACTIONS(809),
    [anon_sym_RBRACE] = ACTIONS(807),
    [anon_sym_PERCENT] = ACTIONS(807),
    [anon_sym_interface] = ACTIONS(809),
    [anon_sym_as] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_if] = ACTIONS(809),
    [anon_sym_instanceof] = ACTIONS(809),
    [anon_sym_yield] = ACTIONS(809),
    [sym_true] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_DOT] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_PIPE_RBRACE] = ACTIONS(807),
    [anon_sym_import] = ACTIONS(809),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_for] = ACTIONS(809),
    [anon_sym_SEMI] = ACTIONS(807),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_LT_LT] = ACTIONS(807),
    [anon_sym_LBRACE] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_switch] = ACTIONS(809),
    [anon_sym_LT_EQ] = ACTIONS(807),
    [sym_null] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_var] = ACTIONS(809),
    [anon_sym_QMARK] = ACTIONS(807),
    [anon_sym_while] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(807),
    [anon_sym_SLASH] = ACTIONS(809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_new] = ACTIONS(809),
    [anon_sym_CARET] = ACTIONS(807),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(809),
    [anon_sym_with] = ACTIONS(809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(807),
    [sym_identifier] = ACTIONS(809),
    [anon_sym_debugger] = ACTIONS(809),
    [anon_sym_AT] = ACTIONS(807),
    [anon_sym_COMMA] = ACTIONS(807),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_const] = ACTIONS(809),
    [anon_sym_GT_EQ] = ACTIONS(807),
    [sym_super] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(809),
    [anon_sym_enum] = ACTIONS(809),
    [anon_sym_continue] = ACTIONS(809),
    [anon_sym_DASH_DASH] = ACTIONS(807),
    [anon_sym_this] = ACTIONS(809),
    [anon_sym_throw] = ACTIONS(809),
    [anon_sym_abstract] = ACTIONS(809),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_STAR_STAR] = ACTIONS(807),
    [anon_sym_namespace] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(807),
    [anon_sym_else] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(807),
    [sym_false] = ACTIONS(809),
    [anon_sym_case] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(809),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_GT] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_AMP] = ACTIONS(809),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [anon_sym_try] = ACTIONS(809),
    [anon_sym_EQ_EQ] = ACTIONS(809),
    [anon_sym_LT] = ACTIONS(809),
    [sym_number] = ACTIONS(807),
    [ts_builtin_sym_end] = ACTIONS(807),
    [anon_sym_function] = ACTIONS(809),
    [sym_undefined] = ACTIONS(809),
    [anon_sym_let] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_do] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_in] = ACTIONS(809),
  },
  [128] = {
    [sym_statement_block] = STATE(360),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(799),
    [sym__automatic_semicolon] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(799),
    [anon_sym_symbol] = ACTIONS(801),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_GT_GT_GT] = ACTIONS(799),
    [anon_sym_break] = ACTIONS(801),
    [anon_sym_BANG_EQ] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(799),
    [anon_sym_PERCENT] = ACTIONS(799),
    [anon_sym_interface] = ACTIONS(801),
    [anon_sym_as] = ACTIONS(801),
    [anon_sym_delete] = ACTIONS(801),
    [anon_sym_if] = ACTIONS(801),
    [anon_sym_instanceof] = ACTIONS(801),
    [anon_sym_yield] = ACTIONS(801),
    [sym_true] = ACTIONS(801),
    [anon_sym_protected] = ACTIONS(801),
    [anon_sym_DOT] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_import] = ACTIONS(801),
    [anon_sym_await] = ACTIONS(801),
    [anon_sym_DQUOTE] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_SEMI] = ACTIONS(799),
    [anon_sym_number] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(801),
    [anon_sym_LT_LT] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(805),
    [anon_sym_AMP_AMP] = ACTIONS(799),
    [anon_sym_switch] = ACTIONS(801),
    [anon_sym_LT_EQ] = ACTIONS(799),
    [sym_null] = ACTIONS(801),
    [anon_sym_any] = ACTIONS(801),
    [anon_sym_async] = ACTIONS(801),
    [anon_sym_public] = ACTIONS(801),
    [anon_sym_var] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_while] = ACTIONS(801),
    [anon_sym_SQUOTE] = ACTIONS(799),
    [anon_sym_SLASH] = ACTIONS(801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(801),
    [anon_sym_CARET] = ACTIONS(799),
    [anon_sym_export] = ACTIONS(801),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_with] = ACTIONS(801),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(799),
    [sym_identifier] = ACTIONS(801),
    [anon_sym_debugger] = ACTIONS(801),
    [anon_sym_AT] = ACTIONS(799),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_const] = ACTIONS(801),
    [anon_sym_GT_EQ] = ACTIONS(799),
    [sym_super] = ACTIONS(801),
    [anon_sym_private] = ACTIONS(801),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_default] = ACTIONS(801),
    [anon_sym_enum] = ACTIONS(801),
    [anon_sym_continue] = ACTIONS(801),
    [anon_sym_DASH_DASH] = ACTIONS(799),
    [anon_sym_this] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(801),
    [anon_sym_abstract] = ACTIONS(801),
    [anon_sym_type] = ACTIONS(801),
    [anon_sym_STAR_STAR] = ACTIONS(799),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(799),
    [anon_sym_else] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(799),
    [sym_false] = ACTIONS(801),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_module] = ACTIONS(801),
    [anon_sym_class] = ACTIONS(801),
    [anon_sym_declare] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(799),
    [anon_sym_GT] = ACTIONS(801),
    [anon_sym_boolean] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_PIPE_PIPE] = ACTIONS(799),
    [anon_sym_try] = ACTIONS(801),
    [anon_sym_EQ_EQ] = ACTIONS(801),
    [anon_sym_LT] = ACTIONS(801),
    [sym_number] = ACTIONS(799),
    [ts_builtin_sym_end] = ACTIONS(799),
    [anon_sym_function] = ACTIONS(801),
    [sym_undefined] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(801),
    [anon_sym_do] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(799),
    [anon_sym_in] = ACTIONS(801),
  },
  [129] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [sym__automatic_semicolon] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(811),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(811),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(590),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_in] = ACTIONS(125),
  },
  [130] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [sym__automatic_semicolon] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(813),
    [anon_sym_DOT] = ACTIONS(813),
    [anon_sym_PIPE_RBRACE] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_else] = ACTIONS(813),
    [anon_sym_BANG] = ACTIONS(815),
    [anon_sym_LBRACK] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(813),
    [anon_sym_GT] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_while] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_RPAREN] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_in] = ACTIONS(815),
  },
  [131] = {
    [aux_sym_string_repeat1] = STATE(362),
    [sym_escape_sequence] = ACTIONS(817),
    [aux_sym_string_token1] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(819),
    [sym_comment] = ACTIONS(256),
  },
  [132] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [sym__automatic_semicolon] = ACTIONS(700),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_COMMA] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_RBRACE] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(700),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_RPAREN] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(704),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [133] = {
    [anon_sym_LPAREN] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
  },
  [134] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_arrow_function] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(367),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_object] = STATE(368),
    [sym_generator_function] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_update_expression] = STATE(59),
    [sym_meta_property] = STATE(59),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_function] = STATE(89),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(367),
    [sym_sequence_expression] = STATE(62),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(367),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_anonymous_class] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(367),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(369),
    [sym_type_assertion] = STATE(59),
    [sym_class] = STATE(59),
    [sym_identifier] = ACTIONS(823),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(825),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(827),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(825),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [135] = {
    [sym_new_expression] = STATE(370),
    [sym_augmented_assignment_expression] = STATE(370),
    [sym_unary_expression] = STATE(370),
    [sym_update_expression] = STATE(370),
    [sym_regex] = STATE(370),
    [sym_meta_property] = STATE(370),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(370),
    [sym_yield_expression] = STATE(370),
    [sym_as_expression] = STATE(370),
    [sym_non_null_expression] = STATE(370),
    [sym_internal_module] = STATE(370),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(370),
    [sym_await_expression] = STATE(370),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(370),
    [sym_this] = STATE(370),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(370),
    [sym_generator_function] = STATE(370),
    [sym_call_expression] = STATE(370),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(370),
    [sym_ternary_expression] = STATE(370),
    [sym_binary_expression] = STATE(370),
    [sym_template_string] = STATE(370),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(370),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(370),
    [sym_class] = STATE(370),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(829),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(829),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(829),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(831),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(829),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [136] = {
    [sym_new_expression] = STATE(371),
    [sym_augmented_assignment_expression] = STATE(371),
    [sym_unary_expression] = STATE(371),
    [sym_update_expression] = STATE(371),
    [sym_regex] = STATE(371),
    [sym_meta_property] = STATE(371),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(371),
    [sym_yield_expression] = STATE(371),
    [sym_as_expression] = STATE(371),
    [sym_non_null_expression] = STATE(371),
    [sym_internal_module] = STATE(371),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(371),
    [sym_await_expression] = STATE(371),
    [sym_member_expression] = STATE(1201),
    [sym_spread_element] = STATE(372),
    [sym_string] = STATE(371),
    [sym_this] = STATE(371),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(371),
    [sym_generator_function] = STATE(371),
    [sym_call_expression] = STATE(371),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(371),
    [sym_ternary_expression] = STATE(371),
    [sym_binary_expression] = STATE(371),
    [sym_template_string] = STATE(371),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(371),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(371),
    [sym_class] = STATE(371),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(833),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(835),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(835),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_RBRACK] = ACTIONS(833),
    [sym_null] = ACTIONS(835),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(833),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(835),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [137] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [sym__automatic_semicolon] = ACTIONS(839),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_RBRACE] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(839),
    [anon_sym_SEMI] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_of] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [138] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [aux_sym_array_repeat1] = STATE(374),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACK] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [139] = {
    [aux_sym_array_repeat1] = STATE(374),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_RBRACK] = ACTIONS(859),
    [sym_comment] = ACTIONS(3),
  },
  [140] = {
    [aux_sym_array_repeat1] = STATE(375),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_RBRACK] = ACTIONS(859),
    [sym_comment] = ACTIONS(3),
  },
  [141] = {
    [sym_identifier] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(881),
    [anon_sym_debugger] = ACTIONS(879),
    [anon_sym_symbol] = ACTIONS(879),
    [anon_sym_AT] = ACTIONS(881),
    [anon_sym_DASH] = ACTIONS(879),
    [anon_sym_void] = ACTIONS(879),
    [anon_sym_break] = ACTIONS(879),
    [anon_sym_const] = ACTIONS(879),
    [sym_super] = ACTIONS(879),
    [anon_sym_return] = ACTIONS(879),
    [anon_sym_private] = ACTIONS(879),
    [anon_sym_get] = ACTIONS(879),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_interface] = ACTIONS(879),
    [anon_sym_default] = ACTIONS(879),
    [anon_sym_enum] = ACTIONS(879),
    [anon_sym_delete] = ACTIONS(879),
    [anon_sym_continue] = ACTIONS(879),
    [anon_sym_DASH_DASH] = ACTIONS(881),
    [anon_sym_if] = ACTIONS(879),
    [anon_sym_this] = ACTIONS(879),
    [anon_sym_yield] = ACTIONS(879),
    [sym_true] = ACTIONS(879),
    [anon_sym_throw] = ACTIONS(879),
    [anon_sym_protected] = ACTIONS(879),
    [anon_sym_abstract] = ACTIONS(879),
    [anon_sym_set] = ACTIONS(879),
    [anon_sym_type] = ACTIONS(879),
    [anon_sym_import] = ACTIONS(879),
    [anon_sym_namespace] = ACTIONS(879),
    [anon_sym_PLUS_PLUS] = ACTIONS(881),
    [anon_sym_await] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(881),
    [anon_sym_else] = ACTIONS(879),
    [anon_sym_BANG] = ACTIONS(881),
    [anon_sym_for] = ACTIONS(879),
    [anon_sym_LBRACK] = ACTIONS(881),
    [sym_false] = ACTIONS(879),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_case] = ACTIONS(879),
    [anon_sym_module] = ACTIONS(879),
    [anon_sym_number] = ACTIONS(879),
    [anon_sym_class] = ACTIONS(879),
    [anon_sym_declare] = ACTIONS(879),
    [anon_sym_typeof] = ACTIONS(879),
    [anon_sym_LBRACE] = ACTIONS(881),
    [anon_sym_switch] = ACTIONS(879),
    [anon_sym_LPAREN] = ACTIONS(881),
    [sym_null] = ACTIONS(879),
    [anon_sym_any] = ACTIONS(879),
    [anon_sym_boolean] = ACTIONS(879),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_public] = ACTIONS(879),
    [anon_sym_var] = ACTIONS(879),
    [anon_sym_while] = ACTIONS(879),
    [anon_sym_SQUOTE] = ACTIONS(881),
    [anon_sym_try] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(881),
    [sym_number] = ACTIONS(881),
    [anon_sym_SLASH] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(879),
    [anon_sym_function] = ACTIONS(879),
    [sym_undefined] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(879),
    [ts_builtin_sym_end] = ACTIONS(881),
    [anon_sym_let] = ACTIONS(879),
    [anon_sym_PLUS] = ACTIONS(879),
    [anon_sym_export] = ACTIONS(879),
    [anon_sym_do] = ACTIONS(879),
    [anon_sym_TILDE] = ACTIONS(881),
    [anon_sym_with] = ACTIONS(879),
  },
  [142] = {
    [sym_new_expression] = STATE(377),
    [sym_augmented_assignment_expression] = STATE(377),
    [sym_unary_expression] = STATE(377),
    [sym_update_expression] = STATE(377),
    [sym_regex] = STATE(377),
    [sym_meta_property] = STATE(377),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(377),
    [sym_yield_expression] = STATE(377),
    [sym_as_expression] = STATE(377),
    [sym_non_null_expression] = STATE(377),
    [sym_internal_module] = STATE(377),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(377),
    [sym_await_expression] = STATE(377),
    [sym_member_expression] = STATE(2338),
    [sym_generic_type] = STATE(379),
    [sym_string] = STATE(377),
    [sym_this] = STATE(377),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_nested_type_identifier] = STATE(378),
    [sym_anonymous_class] = STATE(377),
    [sym_generator_function] = STATE(377),
    [sym_call_expression] = STATE(377),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(377),
    [sym_ternary_expression] = STATE(377),
    [sym_binary_expression] = STATE(377),
    [sym_template_string] = STATE(377),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(377),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(377),
    [sym__type_reference] = STATE(379),
    [sym_class] = STATE(377),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(885),
    [sym_false] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(887),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(901),
    [sym_true] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(887),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [143] = {
    [sym_tuple_type] = STATE(237),
    [sym__type] = STATE(380),
    [sym_constructor_type] = STATE(380),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_array_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_function_type] = STATE(380),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_nested_identifier] = STATE(236),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(380),
    [sym_intersection_type] = STATE(380),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_this] = ACTIONS(464),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_keyof] = ACTIONS(472),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_boolean] = ACTIONS(462),
  },
  [144] = {
    [sym_class_heritage] = STATE(381),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_type_parameters] = STATE(382),
    [sym_class_body] = STATE(383),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(917),
  },
  [145] = {
    [sym_public_field_definition] = STATE(394),
    [sym__property_name] = STATE(395),
    [sym_method_signature] = STATE(394),
    [sym_abstract_method_signature] = STATE(394),
    [aux_sym_class_body_repeat1] = STATE(397),
    [sym_index_signature] = STATE(394),
    [sym_method_definition] = STATE(398),
    [sym_decorator] = STATE(397),
    [sym_accessibility_modifier] = STATE(396),
    [sym_computed_property_name] = STATE(395),
    [sym_string] = STATE(395),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(923),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(931),
    [anon_sym_RBRACE] = ACTIONS(933),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [sym_number] = ACTIONS(937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_abstract] = ACTIONS(939),
    [anon_sym_set] = ACTIONS(931),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [sym_readonly] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [146] = {
    [sym_class_body] = STATE(399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [147] = {
    [sym_implements_clause] = STATE(400),
    [anon_sym_implements] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(945),
  },
  [148] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(945),
  },
  [149] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(947),
    [sym__automatic_semicolon] = ACTIONS(947),
    [anon_sym_BQUOTE] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_STAR] = ACTIONS(949),
    [anon_sym_GT_GT_GT] = ACTIONS(947),
    [anon_sym_BANG_EQ] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_as] = ACTIONS(947),
    [anon_sym_DASH_DASH] = ACTIONS(947),
    [anon_sym_instanceof] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_STAR_STAR] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_SEMI] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_SLASH] = ACTIONS(949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_GT_GT] = ACTIONS(949),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_in] = ACTIONS(949),
  },
  [150] = {
    [sym_nested_identifier] = STATE(1224),
    [sym__module] = STATE(141),
    [sym_string] = STATE(1226),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(953),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [sym_comment] = ACTIONS(3),
  },
  [151] = {
    [sym_identifier] = ACTIONS(955),
    [sym_comment] = ACTIONS(3),
  },
  [152] = {
    [sym_type_alias_declaration] = STATE(160),
    [aux_sym_export_statement_repeat1] = STATE(159),
    [sym__declaration] = STATE(160),
    [sym_ambient_declaration] = STATE(160),
    [sym_import_alias] = STATE(160),
    [sym_export_statement] = STATE(160),
    [sym_generator_function] = STATE(160),
    [sym_lexical_declaration] = STATE(160),
    [sym_internal_module] = STATE(160),
    [sym_decorator] = STATE(159),
    [sym_enum_declaration] = STATE(160),
    [sym_function] = STATE(160),
    [sym_function_signature] = STATE(160),
    [sym_variable_declaration] = STATE(160),
    [sym_abstract_class] = STATE(160),
    [sym_module] = STATE(160),
    [sym_interface_declaration] = STATE(160),
    [sym_class] = STATE(160),
    [anon_sym_var] = ACTIONS(360),
    [anon_sym_interface] = ACTIONS(340),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_module] = ACTIONS(352),
    [anon_sym_class] = ACTIONS(354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(356),
    [anon_sym_global] = ACTIONS(336),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(362),
    [anon_sym_const] = ACTIONS(338),
    [anon_sym_abstract] = ACTIONS(344),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_let] = ACTIONS(364),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_export] = ACTIONS(366),
    [anon_sym_namespace] = ACTIONS(350),
    [anon_sym_async] = ACTIONS(358),
  },
  [153] = {
    [sym_statement_block] = STATE(402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [154] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(957),
  },
  [155] = {
    [sym_identifier] = ACTIONS(959),
    [sym_comment] = ACTIONS(3),
  },
  [156] = {
    [sym_identifier] = ACTIONS(961),
    [sym_comment] = ACTIONS(3),
  },
  [157] = {
    [sym_type_alias_declaration] = STATE(261),
    [sym__declaration] = STATE(261),
    [sym_internal_module] = STATE(261),
    [sym_enum_declaration] = STATE(261),
    [sym_function] = STATE(261),
    [sym_variable_declaration] = STATE(261),
    [aux_sym_export_statement_repeat1] = STATE(159),
    [sym_ambient_declaration] = STATE(261),
    [sym_import_alias] = STATE(261),
    [sym_export_statement] = STATE(261),
    [sym_generator_function] = STATE(261),
    [sym_export_clause] = STATE(262),
    [sym_lexical_declaration] = STATE(261),
    [sym_decorator] = STATE(159),
    [sym_function_signature] = STATE(261),
    [sym_abstract_class] = STATE(261),
    [sym_module] = STATE(261),
    [sym_interface_declaration] = STATE(261),
    [sym_class] = STATE(261),
    [anon_sym_module] = ACTIONS(534),
    [anon_sym_class] = ACTIONS(354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(356),
    [anon_sym_STAR] = ACTIONS(963),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_EQ] = ACTIONS(965),
    [anon_sym_const] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(358),
    [anon_sym_var] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(529),
    [anon_sym_interface] = ACTIONS(340),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_as] = ACTIONS(967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(362),
    [anon_sym_abstract] = ACTIONS(344),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_let] = ACTIONS(364),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_export] = ACTIONS(366),
    [anon_sym_namespace] = ACTIONS(350),
  },
  [158] = {
    [sym_nested_identifier] = STATE(1224),
    [sym__module] = STATE(1593),
    [sym_string] = STATE(1226),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(326),
  },
  [159] = {
    [aux_sym_export_statement_repeat1] = STATE(284),
    [sym_decorator] = STATE(284),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(604),
    [anon_sym_class] = ACTIONS(969),
    [sym_comment] = ACTIONS(3),
  },
  [160] = {
    [sym_identifier] = ACTIONS(971),
    [anon_sym_BQUOTE] = ACTIONS(973),
    [anon_sym_debugger] = ACTIONS(971),
    [anon_sym_symbol] = ACTIONS(971),
    [anon_sym_AT] = ACTIONS(973),
    [anon_sym_DASH] = ACTIONS(971),
    [anon_sym_void] = ACTIONS(971),
    [anon_sym_break] = ACTIONS(971),
    [anon_sym_const] = ACTIONS(971),
    [sym_super] = ACTIONS(971),
    [anon_sym_return] = ACTIONS(971),
    [anon_sym_private] = ACTIONS(971),
    [anon_sym_get] = ACTIONS(971),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_interface] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(971),
    [anon_sym_enum] = ACTIONS(971),
    [anon_sym_delete] = ACTIONS(971),
    [anon_sym_continue] = ACTIONS(971),
    [anon_sym_DASH_DASH] = ACTIONS(973),
    [anon_sym_if] = ACTIONS(971),
    [anon_sym_this] = ACTIONS(971),
    [anon_sym_yield] = ACTIONS(971),
    [sym_true] = ACTIONS(971),
    [anon_sym_throw] = ACTIONS(971),
    [anon_sym_protected] = ACTIONS(971),
    [anon_sym_abstract] = ACTIONS(971),
    [anon_sym_set] = ACTIONS(971),
    [anon_sym_type] = ACTIONS(971),
    [anon_sym_import] = ACTIONS(971),
    [anon_sym_namespace] = ACTIONS(971),
    [anon_sym_PLUS_PLUS] = ACTIONS(973),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_DQUOTE] = ACTIONS(973),
    [anon_sym_else] = ACTIONS(971),
    [anon_sym_BANG] = ACTIONS(973),
    [anon_sym_for] = ACTIONS(971),
    [anon_sym_LBRACK] = ACTIONS(973),
    [sym_false] = ACTIONS(971),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_case] = ACTIONS(971),
    [anon_sym_module] = ACTIONS(971),
    [anon_sym_number] = ACTIONS(971),
    [anon_sym_class] = ACTIONS(971),
    [anon_sym_declare] = ACTIONS(971),
    [anon_sym_typeof] = ACTIONS(971),
    [anon_sym_LBRACE] = ACTIONS(973),
    [anon_sym_switch] = ACTIONS(971),
    [anon_sym_LPAREN] = ACTIONS(973),
    [sym_null] = ACTIONS(971),
    [anon_sym_any] = ACTIONS(971),
    [anon_sym_boolean] = ACTIONS(971),
    [anon_sym_async] = ACTIONS(971),
    [anon_sym_public] = ACTIONS(971),
    [anon_sym_var] = ACTIONS(971),
    [anon_sym_while] = ACTIONS(971),
    [anon_sym_SQUOTE] = ACTIONS(973),
    [anon_sym_try] = ACTIONS(971),
    [anon_sym_LT] = ACTIONS(973),
    [sym_number] = ACTIONS(973),
    [anon_sym_SLASH] = ACTIONS(971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(971),
    [anon_sym_function] = ACTIONS(971),
    [sym_undefined] = ACTIONS(971),
    [anon_sym_new] = ACTIONS(971),
    [ts_builtin_sym_end] = ACTIONS(973),
    [anon_sym_let] = ACTIONS(971),
    [anon_sym_PLUS] = ACTIONS(971),
    [anon_sym_export] = ACTIONS(971),
    [anon_sym_do] = ACTIONS(971),
    [anon_sym_TILDE] = ACTIONS(973),
    [anon_sym_with] = ACTIONS(971),
  },
  [161] = {
    [sym__initializer] = STATE(407),
    [aux_sym_object_repeat1] = STATE(408),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(113),
    [anon_sym_AMP_EQ] = ACTIONS(113),
    [anon_sym_PLUS_EQ] = ACTIONS(113),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(113),
    [anon_sym_PIPE_EQ] = ACTIONS(113),
    [anon_sym_DASH_EQ] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(977),
    [anon_sym_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(980),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(113),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(980),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(113),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [162] = {
    [sym__initializer] = STATE(80),
    [aux_sym_object_repeat1] = STATE(408),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [163] = {
    [sym_pair] = STATE(414),
    [sym__property_name] = STATE(183),
    [sym_object] = STATE(310),
    [sym_decorator] = STATE(415),
    [sym_accessibility_modifier] = STATE(180),
    [aux_sym_export_statement_repeat1] = STATE(415),
    [sym_computed_property_name] = STATE(183),
    [sym_assignment_pattern] = STATE(414),
    [sym_array] = STATE(312),
    [sym_spread_element] = STATE(414),
    [sym_string] = STATE(183),
    [sym_method_definition] = STATE(414),
    [sym_identifier] = ACTIONS(994),
    [anon_sym_LBRACK] = ACTIONS(680),
    [anon_sym_module] = ACTIONS(996),
    [anon_sym_symbol] = ACTIONS(996),
    [anon_sym_number] = ACTIONS(996),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(996),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_void] = ACTIONS(996),
    [anon_sym_any] = ACTIONS(996),
    [anon_sym_private] = ACTIONS(1000),
    [anon_sym_boolean] = ACTIONS(996),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_async] = ACTIONS(1002),
    [anon_sym_get] = ACTIONS(1004),
    [anon_sym_RBRACE] = ACTIONS(998),
    [anon_sym_public] = ACTIONS(1000),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [sym_number] = ACTIONS(692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1000),
    [anon_sym_string] = ACTIONS(996),
    [anon_sym_set] = ACTIONS(1004),
    [anon_sym_type] = ACTIONS(996),
    [anon_sym_import] = ACTIONS(996),
    [anon_sym_export] = ACTIONS(996),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_namespace] = ACTIONS(996),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [164] = {
    [sym_string] = STATE(417),
    [sym__property_name] = STATE(417),
    [sym_computed_property_name] = STATE(417),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [165] = {
    [sym_new_expression] = STATE(91),
    [sym_augmented_assignment_expression] = STATE(91),
    [sym_unary_expression] = STATE(91),
    [sym_regex] = STATE(91),
    [sym_call_signature] = STATE(52),
    [sym_yield_expression] = STATE(91),
    [sym_as_expression] = STATE(91),
    [sym_internal_module] = STATE(91),
    [sym_arrow_function] = STATE(91),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(91),
    [sym_type_parameters] = STATE(55),
    [sym_object] = STATE(57),
    [aux_sym_object_repeat1] = STATE(408),
    [sym_generator_function] = STATE(91),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(91),
    [sym_template_string] = STATE(91),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym__initializer] = STATE(80),
    [sym_update_expression] = STATE(91),
    [sym_meta_property] = STATE(91),
    [sym__expression] = STATE(91),
    [sym_non_null_expression] = STATE(91),
    [sym_function] = STATE(89),
    [sym_await_expression] = STATE(91),
    [sym_this] = STATE(91),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_anonymous_class] = STATE(91),
    [sym_call_expression] = STATE(91),
    [sym_assignment_expression] = STATE(91),
    [sym_binary_expression] = STATE(91),
    [sym_type_arguments] = STATE(64),
    [sym_parenthesized_expression] = STATE(91),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(91),
    [sym_class] = STATE(91),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [sym_null] = ACTIONS(165),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(165),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(77),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(139),
  },
  [166] = {
    [sym__initializer] = STATE(80),
    [aux_sym_object_repeat1] = STATE(408),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(1012),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(1012),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_DOT] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [sym_readonly] = ACTIONS(1012),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1014),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [sym_number] = ACTIONS(1014),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_in] = ACTIONS(139),
  },
  [167] = {
    [sym_string] = STATE(417),
    [sym__property_name] = STATE(417),
    [sym_computed_property_name] = STATE(417),
    [anon_sym_get] = ACTIONS(1016),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_async] = ACTIONS(1018),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(1010),
    [anon_sym_STAR] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [sym_readonly] = ACTIONS(1022),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [168] = {
    [sym__property_name] = STATE(417),
    [aux_sym_object_repeat1] = STATE(408),
    [sym__initializer] = STATE(80),
    [sym_computed_property_name] = STATE(417),
    [sym_string] = STATE(417),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_DOT] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [sym_number] = ACTIONS(1010),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_in] = ACTIONS(139),
  },
  [169] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [sym__automatic_semicolon] = ACTIONS(1027),
    [anon_sym_BQUOTE] = ACTIONS(1027),
    [anon_sym_symbol] = ACTIONS(1029),
    [anon_sym_PIPE] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1031),
    [anon_sym_GT_GT_GT] = ACTIONS(1027),
    [anon_sym_break] = ACTIONS(1029),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_interface] = ACTIONS(1029),
    [anon_sym_as] = ACTIONS(1031),
    [anon_sym_delete] = ACTIONS(1029),
    [anon_sym_if] = ACTIONS(1029),
    [anon_sym_instanceof] = ACTIONS(1031),
    [anon_sym_yield] = ACTIONS(1029),
    [sym_true] = ACTIONS(1029),
    [anon_sym_protected] = ACTIONS(1029),
    [anon_sym_DOT] = ACTIONS(1031),
    [anon_sym_set] = ACTIONS(1029),
    [anon_sym_import] = ACTIONS(1029),
    [anon_sym_await] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(1033),
    [anon_sym_for] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1027),
    [anon_sym_number] = ACTIONS(1029),
    [anon_sym_typeof] = ACTIONS(1029),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_switch] = ACTIONS(1029),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [sym_null] = ACTIONS(1029),
    [anon_sym_any] = ACTIONS(1029),
    [anon_sym_async] = ACTIONS(1029),
    [anon_sym_public] = ACTIONS(1029),
    [anon_sym_var] = ACTIONS(1029),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_while] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(1033),
    [anon_sym_SLASH] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1029),
    [anon_sym_new] = ACTIONS(1029),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_export] = ACTIONS(1029),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_with] = ACTIONS(1029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [sym_identifier] = ACTIONS(1029),
    [anon_sym_debugger] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(1033),
    [anon_sym_COMMA] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_EQ] = ACTIONS(1031),
    [anon_sym_void] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1029),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [sym_super] = ACTIONS(1029),
    [anon_sym_private] = ACTIONS(1029),
    [anon_sym_get] = ACTIONS(1029),
    [anon_sym_default] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(1029),
    [anon_sym_continue] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_this] = ACTIONS(1029),
    [anon_sym_throw] = ACTIONS(1029),
    [anon_sym_abstract] = ACTIONS(1029),
    [anon_sym_type] = ACTIONS(1029),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_else] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [sym_false] = ACTIONS(1029),
    [anon_sym_case] = ACTIONS(1029),
    [anon_sym_module] = ACTIONS(1029),
    [anon_sym_class] = ACTIONS(1029),
    [anon_sym_declare] = ACTIONS(1029),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1031),
    [anon_sym_boolean] = ACTIONS(1029),
    [anon_sym_AMP] = ACTIONS(1031),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_LT] = ACTIONS(1031),
    [sym_number] = ACTIONS(1033),
    [ts_builtin_sym_end] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1029),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_let] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_do] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(1033),
    [anon_sym_in] = ACTIONS(1031),
  },
  [170] = {
    [sym__initializer] = STATE(80),
    [aux_sym_object_repeat1] = STATE(408),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [171] = {
    [sym_import_require_clause] = STATE(123),
    [aux_sym_object_repeat1] = STATE(408),
    [sym_named_imports] = STATE(125),
    [sym__initializer] = STATE(80),
    [sym_import_clause] = STATE(124),
    [sym_string] = STATE(123),
    [sym_namespace_import] = STATE(125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_type] = ACTIONS(238),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(238),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [172] = {
    [sym_nested_identifier] = STATE(126),
    [sym__module] = STATE(127),
    [aux_sym_object_repeat1] = STATE(408),
    [sym__initializer] = STATE(80),
    [sym_string] = STATE(128),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(242),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(244),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(246),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [173] = {
    [sym_string] = STATE(417),
    [sym__property_name] = STATE(417),
    [sym_computed_property_name] = STATE(417),
    [anon_sym_get] = ACTIONS(1016),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(1010),
    [anon_sym_STAR] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1018),
  },
  [174] = {
    [sym_new_expression] = STATE(422),
    [sym_augmented_assignment_expression] = STATE(422),
    [sym_unary_expression] = STATE(422),
    [sym_update_expression] = STATE(422),
    [sym_regex] = STATE(422),
    [sym_meta_property] = STATE(422),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(422),
    [sym_yield_expression] = STATE(422),
    [sym_as_expression] = STATE(422),
    [sym_non_null_expression] = STATE(422),
    [sym_internal_module] = STATE(422),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(422),
    [sym_await_expression] = STATE(422),
    [sym_member_expression] = STATE(1201),
    [sym_spread_element] = STATE(139),
    [sym_string] = STATE(422),
    [sym_this] = STATE(422),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [aux_sym_array_repeat1] = STATE(140),
    [sym_anonymous_class] = STATE(422),
    [sym_generator_function] = STATE(422),
    [sym_call_expression] = STATE(422),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(422),
    [sym_ternary_expression] = STATE(422),
    [sym_binary_expression] = STATE(422),
    [sym_template_string] = STATE(422),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(422),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(422),
    [sym_class] = STATE(422),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(266),
    [sym_false] = ACTIONS(1035),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_RBRACK] = ACTIONS(304),
    [sym_null] = ACTIONS(1035),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(1037),
    [sym_true] = ACTIONS(1035),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1035),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [175] = {
    [sym_nested_identifier] = STATE(1224),
    [sym__module] = STATE(141),
    [aux_sym_object_repeat1] = STATE(408),
    [sym__initializer] = STATE(80),
    [sym_string] = STATE(1226),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(322),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [176] = {
    [sym_type_alias_declaration] = STATE(160),
    [sym__declaration] = STATE(160),
    [sym__initializer] = STATE(80),
    [sym_internal_module] = STATE(160),
    [sym_enum_declaration] = STATE(160),
    [sym_function] = STATE(160),
    [sym_variable_declaration] = STATE(160),
    [aux_sym_export_statement_repeat1] = STATE(159),
    [aux_sym_object_repeat1] = STATE(408),
    [sym_ambient_declaration] = STATE(160),
    [sym_import_alias] = STATE(160),
    [sym_export_statement] = STATE(160),
    [sym_generator_function] = STATE(160),
    [sym_lexical_declaration] = STATE(160),
    [sym_decorator] = STATE(159),
    [sym_function_signature] = STATE(160),
    [sym_abstract_class] = STATE(160),
    [sym_module] = STATE(160),
    [sym_interface_declaration] = STATE(160),
    [sym_class] = STATE(160),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_global] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_const] = ACTIONS(338),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_interface] = ACTIONS(340),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_abstract] = ACTIONS(344),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(352),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(354),
    [anon_sym_declare] = ACTIONS(356),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_async] = ACTIONS(358),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_var] = ACTIONS(360),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_function] = ACTIONS(362),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_let] = ACTIONS(364),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(366),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [177] = {
    [sym__property_name] = STATE(417),
    [aux_sym_object_repeat1] = STATE(408),
    [sym__initializer] = STATE(80),
    [sym_formal_parameters] = STATE(58),
    [sym_computed_property_name] = STATE(417),
    [sym_call_signature] = STATE(206),
    [sym_string] = STATE(417),
    [sym_type_parameters] = STATE(55),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(1039),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_DOT] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(1044),
    [anon_sym_import] = ACTIONS(1039),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(1039),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1039),
    [anon_sym_public] = ACTIONS(1039),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_get] = ACTIONS(1044),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1039),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_module] = ACTIONS(1039),
    [anon_sym_declare] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(1039),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(1052),
    [sym_number] = ACTIONS(1010),
    [anon_sym_function] = ACTIONS(440),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_in] = ACTIONS(139),
  },
  [178] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(1056),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(1056),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1059),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1062),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [179] = {
    [sym_type_alias_declaration] = STATE(261),
    [sym__declaration] = STATE(261),
    [sym__initializer] = STATE(80),
    [sym_internal_module] = STATE(261),
    [sym_enum_declaration] = STATE(261),
    [sym_function] = STATE(261),
    [sym_variable_declaration] = STATE(261),
    [aux_sym_export_statement_repeat1] = STATE(159),
    [aux_sym_object_repeat1] = STATE(408),
    [sym_ambient_declaration] = STATE(261),
    [sym_import_alias] = STATE(261),
    [sym_export_statement] = STATE(261),
    [sym_generator_function] = STATE(261),
    [sym_export_clause] = STATE(262),
    [sym_lexical_declaration] = STATE(261),
    [sym_decorator] = STATE(159),
    [sym_function_signature] = STATE(261),
    [sym_abstract_class] = STATE(261),
    [sym_module] = STATE(261),
    [sym_interface_declaration] = STATE(261),
    [sym_class] = STATE(261),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(524),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(527),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_const] = ACTIONS(338),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_interface] = ACTIONS(340),
    [anon_sym_default] = ACTIONS(529),
    [anon_sym_as] = ACTIONS(531),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_abstract] = ACTIONS(344),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(534),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(354),
    [anon_sym_declare] = ACTIONS(356),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_async] = ACTIONS(358),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_var] = ACTIONS(360),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_function] = ACTIONS(362),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_let] = ACTIONS(364),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(366),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [180] = {
    [sym_string] = STATE(417),
    [sym__property_name] = STATE(417),
    [sym_computed_property_name] = STATE(417),
    [anon_sym_get] = ACTIONS(1016),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1018),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(1010),
    [anon_sym_STAR] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [sym_readonly] = ACTIONS(1022),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_static] = ACTIONS(1064),
    [anon_sym_private] = ACTIONS(1006),
  },
  [181] = {
    [aux_sym_object_repeat1] = STATE(428),
    [anon_sym_RBRACE] = ACTIONS(1066),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [182] = {
    [sym_type_alias_declaration] = STATE(266),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(266),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(266),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(266),
    [sym_return_statement] = STATE(266),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(266),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(266),
    [sym_switch_statement] = STATE(266),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(266),
    [sym_throw_statement] = STATE(266),
    [aux_sym_program_repeat1] = STATE(266),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(266),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(266),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(266),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(266),
    [sym_abstract_class] = STATE(266),
    [sym_interface_declaration] = STATE(266),
    [sym_statement_block] = STATE(266),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(266),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(266),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(266),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(266),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(266),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(266),
    [sym_empty_statement] = STATE(266),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(266),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(266),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(266),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(266),
    [sym_break_statement] = STATE(266),
    [sym_labeled_statement] = STATE(266),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(266),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(1068),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [183] = {
    [sym_call_signature] = STATE(432),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_COLON] = ACTIONS(1070),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [184] = {
    [sym__initializer] = STATE(433),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [185] = {
    [aux_sym_object_repeat1] = STATE(434),
    [anon_sym_RBRACE] = ACTIONS(1066),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [186] = {
    [sym__property_name] = STATE(439),
    [sym_decorator] = STATE(2472),
    [aux_sym_export_statement_repeat1] = STATE(2472),
    [sym_accessibility_modifier] = STATE(180),
    [sym_computed_property_name] = STATE(439),
    [sym_method_definition] = STATE(438),
    [sym_string] = STATE(439),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_class] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_get] = ACTIONS(1080),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [sym_number] = ACTIONS(1082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1084),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [187] = {
    [sym__initializer] = STATE(440),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [188] = {
    [sym_switch_body] = STATE(442),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1086),
  },
  [189] = {
    [sym__initializer] = STATE(444),
    [sym_type_annotation] = STATE(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_AMP_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_EQ] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(1090),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(1088),
    [anon_sym_STAR_EQ] = ACTIONS(1088),
    [anon_sym_PIPE_EQ] = ACTIONS(1088),
    [anon_sym_DASH_EQ] = ACTIONS(1088),
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_LT_LT_EQ] = ACTIONS(1088),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(1090),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1100),
    [anon_sym_SLASH_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(847),
  },
  [190] = {
    [sym_array] = STATE(448),
    [sym_this] = STATE(449),
    [sym_object] = STATE(450),
    [anon_sym_get] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_module] = ACTIONS(1103),
    [anon_sym_symbol] = ACTIONS(1103),
    [anon_sym_number] = ACTIONS(1103),
    [anon_sym_declare] = ACTIONS(1103),
    [anon_sym_this] = ACTIONS(284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_protected] = ACTIONS(1103),
    [anon_sym_string] = ACTIONS(1103),
    [anon_sym_set] = ACTIONS(1103),
    [anon_sym_type] = ACTIONS(1103),
    [anon_sym_import] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1103),
    [anon_sym_namespace] = ACTIONS(1103),
    [anon_sym_any] = ACTIONS(1103),
    [anon_sym_private] = ACTIONS(1103),
    [anon_sym_boolean] = ACTIONS(1103),
    [anon_sym_async] = ACTIONS(1103),
    [anon_sym_public] = ACTIONS(1103),
  },
  [191] = {
    [sym__initializer] = STATE(452),
    [sym_type_annotation] = STATE(453),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(1114),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [192] = {
    [sym_identifier] = ACTIONS(1122),
    [sym_comment] = ACTIONS(3),
  },
  [193] = {
    [sym_new_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym__initializer] = STATE(452),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_non_null_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1220),
    [sym_this] = STATE(1220),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1220),
    [sym_generator_function] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_type_annotation] = STATE(453),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1220),
    [sym_class] = STATE(1220),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(1124),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(1124),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(1130),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [194] = {
    [sym__initializer] = STATE(452),
    [sym_type_annotation] = STATE(453),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(1012),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_this] = ACTIONS(1012),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_namespace] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [sym_readonly] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1014),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [195] = {
    [sym_call_signature] = STATE(1782),
    [sym__initializer] = STATE(452),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_type_annotation] = STATE(453),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1132),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(1134),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(1134),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_private] = ACTIONS(1134),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_get] = ACTIONS(1134),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_protected] = ACTIONS(1134),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_set] = ACTIONS(1134),
    [anon_sym_type] = ACTIONS(1134),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(1134),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_namespace] = ACTIONS(1134),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1134),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(1134),
    [anon_sym_declare] = ACTIONS(1134),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(1134),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(1134),
    [anon_sym_async] = ACTIONS(1134),
    [anon_sym_public] = ACTIONS(1134),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(1134),
    [anon_sym_function] = ACTIONS(1136),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(1134),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [196] = {
    [anon_sym_COLON] = ACTIONS(1138),
    [anon_sym_EQ_GT] = ACTIONS(1138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1138),
  },
  [197] = {
    [sym_nested_identifier] = STATE(1592),
    [sym__module] = STATE(1483),
    [sym_string] = STATE(1594),
    [sym__initializer] = STATE(452),
    [sym_type_annotation] = STATE(453),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(1114),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [198] = {
    [aux_sym_formal_parameters_repeat1] = STATE(457),
    [anon_sym_RPAREN] = ACTIONS(1142),
    [anon_sym_COMMA] = ACTIONS(1144),
    [sym_comment] = ACTIONS(3),
  },
  [199] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_type_annotation] = STATE(459),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(1148),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [200] = {
    [sym_array] = STATE(448),
    [sym_this] = STATE(449),
    [sym_object] = STATE(450),
    [anon_sym_get] = ACTIONS(1103),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1105),
    [anon_sym_public] = ACTIONS(1103),
    [anon_sym_module] = ACTIONS(1103),
    [anon_sym_symbol] = ACTIONS(1103),
    [anon_sym_number] = ACTIONS(1103),
    [anon_sym_declare] = ACTIONS(1103),
    [anon_sym_this] = ACTIONS(284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1103),
    [anon_sym_protected] = ACTIONS(1103),
    [anon_sym_string] = ACTIONS(1103),
    [anon_sym_set] = ACTIONS(1103),
    [anon_sym_type] = ACTIONS(1103),
    [anon_sym_import] = ACTIONS(1103),
    [anon_sym_export] = ACTIONS(1103),
    [sym_readonly] = ACTIONS(1150),
    [anon_sym_namespace] = ACTIONS(1103),
    [anon_sym_any] = ACTIONS(1103),
    [anon_sym_private] = ACTIONS(1103),
    [anon_sym_boolean] = ACTIONS(1103),
    [anon_sym_async] = ACTIONS(1103),
  },
  [201] = {
    [anon_sym_RPAREN] = ACTIONS(1148),
    [sym_comment] = ACTIONS(3),
  },
  [202] = {
    [sym__initializer] = STATE(461),
    [sym_type_annotation] = STATE(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(1090),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(1090),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1100),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [203] = {
    [aux_sym_export_statement_repeat1] = STATE(2472),
    [sym_decorator] = STATE(2472),
    [sym_object] = STATE(465),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(466),
    [sym_array] = STATE(467),
    [sym_rest_parameter] = STATE(466),
    [sym_optional_parameter] = STATE(466),
    [sym_this] = STATE(468),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_symbol] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_class] = ACTIONS(1156),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1154),
    [anon_sym_any] = ACTIONS(1154),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_boolean] = ACTIONS(1154),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_this] = ACTIONS(284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_string] = ACTIONS(1154),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [anon_sym_export] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
  },
  [204] = {
    [sym__initializer] = STATE(470),
    [sym_type_annotation] = STATE(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(1160),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(1160),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1100),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(847),
  },
  [205] = {
    [sym__initializer] = STATE(473),
    [sym_type_annotation] = STATE(474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(1166),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(1166),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1100),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(847),
  },
  [206] = {
    [anon_sym_EQ_GT] = ACTIONS(1172),
    [sym_comment] = ACTIONS(3),
  },
  [207] = {
    [anon_sym_EQ_GT] = ACTIONS(1174),
    [sym_comment] = ACTIONS(3),
  },
  [208] = {
    [aux_sym_export_statement_repeat1] = STATE(477),
    [sym_decorator] = STATE(477),
    [sym_object] = STATE(465),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(198),
    [sym_array] = STATE(467),
    [sym_rest_parameter] = STATE(198),
    [sym_optional_parameter] = STATE(198),
    [sym_this] = STATE(468),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_symbol] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1154),
    [anon_sym_any] = ACTIONS(1154),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_boolean] = ACTIONS(1154),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_this] = ACTIONS(284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_string] = ACTIONS(1154),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [anon_sym_export] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
  },
  [209] = {
    [sym_type_parameter] = STATE(235),
    [sym_identifier] = ACTIONS(1176),
    [sym_comment] = ACTIONS(3),
  },
  [210] = {
    [sym_call_signature] = STATE(480),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(1178),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [211] = {
    [aux_sym_variable_declaration_repeat1] = STATE(482),
    [sym__automatic_semicolon] = ACTIONS(1180),
    [anon_sym_SEMI] = ACTIONS(1180),
    [anon_sym_COMMA] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
  },
  [212] = {
    [sym_type_alias_declaration] = STATE(266),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(266),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(266),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(266),
    [sym_return_statement] = STATE(266),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(266),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(266),
    [sym_switch_statement] = STATE(266),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(266),
    [sym_throw_statement] = STATE(266),
    [aux_sym_program_repeat1] = STATE(266),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(266),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(266),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(266),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(266),
    [sym_abstract_class] = STATE(266),
    [sym_interface_declaration] = STATE(266),
    [sym_statement_block] = STATE(266),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(266),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(266),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(266),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(266),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(266),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(266),
    [sym_empty_statement] = STATE(266),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(266),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(266),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(266),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(266),
    [sym_break_statement] = STATE(266),
    [sym_labeled_statement] = STATE(266),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(266),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(1182),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [213] = {
    [sym_type_alias_declaration] = STATE(483),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(483),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(483),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(483),
    [sym_return_statement] = STATE(483),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(483),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(483),
    [sym_switch_statement] = STATE(483),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(483),
    [sym_throw_statement] = STATE(483),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(483),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(483),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(483),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(483),
    [sym_abstract_class] = STATE(483),
    [sym_interface_declaration] = STATE(483),
    [sym_statement_block] = STATE(483),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(483),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(483),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(483),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(483),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(483),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(483),
    [sym_empty_statement] = STATE(483),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(483),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(483),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(483),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(483),
    [sym_break_statement] = STATE(483),
    [sym_labeled_statement] = STATE(483),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(483),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [214] = {
    [aux_sym_string_repeat2] = STATE(484),
    [sym_escape_sequence] = ACTIONS(1184),
    [aux_sym_string_token2] = ACTIONS(1184),
    [sym_comment] = ACTIONS(256),
    [anon_sym_SQUOTE] = ACTIONS(819),
  },
  [215] = {
    [sym_type_alias_declaration] = STATE(182),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(182),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(182),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(182),
    [sym_return_statement] = STATE(182),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(182),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(182),
    [sym_switch_statement] = STATE(182),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(182),
    [sym_throw_statement] = STATE(182),
    [aux_sym_program_repeat1] = STATE(182),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(182),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(182),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(182),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(182),
    [sym_abstract_class] = STATE(182),
    [sym_interface_declaration] = STATE(182),
    [sym_statement_block] = STATE(182),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(182),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(182),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(182),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(182),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(182),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(182),
    [sym_empty_statement] = STATE(182),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(182),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(182),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(182),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(182),
    [sym_break_statement] = STATE(182),
    [sym_labeled_statement] = STATE(182),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(182),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(1186),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [216] = {
    [sym_catch_clause] = STATE(488),
    [sym_finally_clause] = STATE(489),
    [sym_identifier] = ACTIONS(1188),
    [anon_sym_BQUOTE] = ACTIONS(1190),
    [anon_sym_debugger] = ACTIONS(1188),
    [anon_sym_symbol] = ACTIONS(1188),
    [anon_sym_AT] = ACTIONS(1190),
    [anon_sym_DASH] = ACTIONS(1188),
    [anon_sym_void] = ACTIONS(1188),
    [anon_sym_break] = ACTIONS(1188),
    [anon_sym_const] = ACTIONS(1188),
    [sym_super] = ACTIONS(1188),
    [anon_sym_return] = ACTIONS(1188),
    [anon_sym_private] = ACTIONS(1188),
    [anon_sym_get] = ACTIONS(1188),
    [anon_sym_RBRACE] = ACTIONS(1190),
    [anon_sym_interface] = ACTIONS(1188),
    [anon_sym_default] = ACTIONS(1188),
    [anon_sym_enum] = ACTIONS(1188),
    [anon_sym_delete] = ACTIONS(1188),
    [anon_sym_continue] = ACTIONS(1188),
    [anon_sym_DASH_DASH] = ACTIONS(1190),
    [anon_sym_if] = ACTIONS(1188),
    [anon_sym_this] = ACTIONS(1188),
    [anon_sym_yield] = ACTIONS(1188),
    [sym_true] = ACTIONS(1188),
    [anon_sym_throw] = ACTIONS(1188),
    [anon_sym_protected] = ACTIONS(1188),
    [anon_sym_abstract] = ACTIONS(1188),
    [anon_sym_set] = ACTIONS(1188),
    [anon_sym_type] = ACTIONS(1188),
    [anon_sym_import] = ACTIONS(1188),
    [anon_sym_namespace] = ACTIONS(1188),
    [anon_sym_PLUS_PLUS] = ACTIONS(1190),
    [anon_sym_await] = ACTIONS(1188),
    [anon_sym_DQUOTE] = ACTIONS(1190),
    [anon_sym_else] = ACTIONS(1188),
    [anon_sym_BANG] = ACTIONS(1190),
    [anon_sym_for] = ACTIONS(1188),
    [anon_sym_LBRACK] = ACTIONS(1190),
    [sym_false] = ACTIONS(1188),
    [anon_sym_SEMI] = ACTIONS(1190),
    [anon_sym_case] = ACTIONS(1188),
    [anon_sym_module] = ACTIONS(1188),
    [anon_sym_number] = ACTIONS(1188),
    [anon_sym_class] = ACTIONS(1188),
    [anon_sym_declare] = ACTIONS(1188),
    [anon_sym_typeof] = ACTIONS(1188),
    [anon_sym_LBRACE] = ACTIONS(1190),
    [anon_sym_switch] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [sym_null] = ACTIONS(1188),
    [anon_sym_catch] = ACTIONS(1192),
    [anon_sym_any] = ACTIONS(1188),
    [anon_sym_boolean] = ACTIONS(1188),
    [anon_sym_async] = ACTIONS(1188),
    [anon_sym_public] = ACTIONS(1188),
    [anon_sym_var] = ACTIONS(1188),
    [anon_sym_while] = ACTIONS(1188),
    [anon_sym_SQUOTE] = ACTIONS(1190),
    [anon_sym_try] = ACTIONS(1188),
    [anon_sym_LT] = ACTIONS(1190),
    [sym_number] = ACTIONS(1190),
    [anon_sym_SLASH] = ACTIONS(1188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(1194),
    [anon_sym_string] = ACTIONS(1188),
    [anon_sym_function] = ACTIONS(1188),
    [sym_undefined] = ACTIONS(1188),
    [anon_sym_new] = ACTIONS(1188),
    [ts_builtin_sym_end] = ACTIONS(1190),
    [anon_sym_let] = ACTIONS(1188),
    [anon_sym_PLUS] = ACTIONS(1188),
    [anon_sym_export] = ACTIONS(1188),
    [anon_sym_do] = ACTIONS(1188),
    [anon_sym_TILDE] = ACTIONS(1190),
    [anon_sym_with] = ACTIONS(1188),
  },
  [217] = {
    [sym_constraint] = STATE(496),
    [sym_type_arguments] = STATE(497),
    [sym_default_type] = STATE(498),
    [anon_sym_EQ] = ACTIONS(1196),
    [anon_sym_LBRACK] = ACTIONS(1198),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_COLON] = ACTIONS(1203),
    [anon_sym_extends] = ACTIONS(1203),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_is] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(1209),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_COMMA] = ACTIONS(1209),
    [anon_sym_LT] = ACTIONS(1212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(1214),
  },
  [218] = {
    [anon_sym_BQUOTE] = ACTIONS(1216),
    [anon_sym_symbol] = ACTIONS(1218),
    [anon_sym_PIPE] = ACTIONS(1216),
    [anon_sym_break] = ACTIONS(1218),
    [anon_sym_return] = ACTIONS(1218),
    [anon_sym_RBRACE] = ACTIONS(1216),
    [anon_sym_interface] = ACTIONS(1218),
    [anon_sym_delete] = ACTIONS(1218),
    [anon_sym_if] = ACTIONS(1218),
    [anon_sym_yield] = ACTIONS(1218),
    [sym_true] = ACTIONS(1218),
    [anon_sym_protected] = ACTIONS(1218),
    [anon_sym_set] = ACTIONS(1218),
    [anon_sym_import] = ACTIONS(1218),
    [anon_sym_await] = ACTIONS(1218),
    [anon_sym_DQUOTE] = ACTIONS(1216),
    [anon_sym_for] = ACTIONS(1218),
    [anon_sym_SEMI] = ACTIONS(1216),
    [anon_sym_number] = ACTIONS(1218),
    [anon_sym_typeof] = ACTIONS(1218),
    [anon_sym_LBRACE] = ACTIONS(1216),
    [anon_sym_switch] = ACTIONS(1218),
    [anon_sym_RBRACK] = ACTIONS(1216),
    [sym_null] = ACTIONS(1218),
    [anon_sym_any] = ACTIONS(1218),
    [anon_sym_async] = ACTIONS(1218),
    [anon_sym_public] = ACTIONS(1218),
    [anon_sym_var] = ACTIONS(1218),
    [anon_sym_while] = ACTIONS(1218),
    [anon_sym_SQUOTE] = ACTIONS(1216),
    [anon_sym_RPAREN] = ACTIONS(1216),
    [anon_sym_SLASH] = ACTIONS(1218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1218),
    [anon_sym_new] = ACTIONS(1218),
    [anon_sym_export] = ACTIONS(1218),
    [anon_sym_with] = ACTIONS(1218),
    [sym_identifier] = ACTIONS(1218),
    [anon_sym_debugger] = ACTIONS(1218),
    [anon_sym_AT] = ACTIONS(1216),
    [anon_sym_COMMA] = ACTIONS(1216),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_EQ] = ACTIONS(1218),
    [anon_sym_void] = ACTIONS(1218),
    [anon_sym_const] = ACTIONS(1218),
    [sym_super] = ACTIONS(1218),
    [anon_sym_private] = ACTIONS(1218),
    [anon_sym_get] = ACTIONS(1218),
    [anon_sym_default] = ACTIONS(1218),
    [anon_sym_enum] = ACTIONS(1218),
    [anon_sym_continue] = ACTIONS(1218),
    [anon_sym_DASH_DASH] = ACTIONS(1216),
    [anon_sym_this] = ACTIONS(1218),
    [anon_sym_throw] = ACTIONS(1218),
    [anon_sym_abstract] = ACTIONS(1218),
    [anon_sym_type] = ACTIONS(1218),
    [anon_sym_namespace] = ACTIONS(1218),
    [anon_sym_PLUS_PLUS] = ACTIONS(1216),
    [anon_sym_else] = ACTIONS(1218),
    [anon_sym_BANG] = ACTIONS(1216),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [sym_false] = ACTIONS(1218),
    [anon_sym_case] = ACTIONS(1218),
    [anon_sym_module] = ACTIONS(1218),
    [anon_sym_class] = ACTIONS(1218),
    [anon_sym_declare] = ACTIONS(1218),
    [anon_sym_LPAREN] = ACTIONS(1216),
    [anon_sym_GT] = ACTIONS(1216),
    [anon_sym_boolean] = ACTIONS(1218),
    [anon_sym_EQ_GT] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(1216),
    [anon_sym_try] = ACTIONS(1218),
    [anon_sym_LT] = ACTIONS(1216),
    [sym_number] = ACTIONS(1216),
    [ts_builtin_sym_end] = ACTIONS(1216),
    [anon_sym_function] = ACTIONS(1218),
    [sym_undefined] = ACTIONS(1218),
    [anon_sym_let] = ACTIONS(1218),
    [anon_sym_PLUS] = ACTIONS(1218),
    [anon_sym_do] = ACTIONS(1218),
    [anon_sym_TILDE] = ACTIONS(1216),
  },
  [219] = {
    [sym_index_type_query] = STATE(500),
    [sym_lookup_type] = STATE(500),
    [sym_this_type] = STATE(500),
    [sym_flow_maybe_type] = STATE(500),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(500),
    [sym_generic_type] = STATE(500),
    [sym_mapped_type] = STATE(500),
    [sym_literal_type] = STATE(500),
    [sym_parenthesized_type] = STATE(500),
    [sym_predefined_type] = STATE(500),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(500),
    [sym_tuple_type] = STATE(500),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(500),
    [sym_type_query] = STATE(500),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(500),
    [sym_object_type] = STATE(500),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(1220),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [220] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(513),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(513),
    [sym_call_signature] = STATE(513),
    [sym_construct_signature] = STATE(513),
    [sym_index_signature] = STATE(513),
    [sym_export_statement] = STATE(513),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(1222),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_COMMA] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(1232),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [221] = {
    [sym__type] = STATE(514),
    [sym_constructor_type] = STATE(514),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(514),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(514),
    [sym_intersection_type] = STATE(514),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [222] = {
    [sym__type] = STATE(515),
    [sym_constructor_type] = STATE(515),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(515),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(515),
    [sym_intersection_type] = STATE(515),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [223] = {
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [anon_sym_symbol] = ACTIONS(1246),
    [anon_sym_PIPE] = ACTIONS(1244),
    [anon_sym_break] = ACTIONS(1246),
    [anon_sym_return] = ACTIONS(1246),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_interface] = ACTIONS(1246),
    [anon_sym_delete] = ACTIONS(1246),
    [anon_sym_if] = ACTIONS(1246),
    [anon_sym_yield] = ACTIONS(1246),
    [sym_true] = ACTIONS(1246),
    [anon_sym_protected] = ACTIONS(1246),
    [anon_sym_set] = ACTIONS(1246),
    [anon_sym_import] = ACTIONS(1246),
    [anon_sym_await] = ACTIONS(1246),
    [anon_sym_DQUOTE] = ACTIONS(1244),
    [anon_sym_for] = ACTIONS(1246),
    [anon_sym_SEMI] = ACTIONS(1244),
    [anon_sym_number] = ACTIONS(1246),
    [anon_sym_typeof] = ACTIONS(1246),
    [anon_sym_LBRACE] = ACTIONS(1244),
    [anon_sym_switch] = ACTIONS(1246),
    [anon_sym_RBRACK] = ACTIONS(1244),
    [sym_null] = ACTIONS(1246),
    [anon_sym_any] = ACTIONS(1246),
    [anon_sym_async] = ACTIONS(1246),
    [anon_sym_public] = ACTIONS(1246),
    [anon_sym_var] = ACTIONS(1246),
    [anon_sym_while] = ACTIONS(1246),
    [anon_sym_SQUOTE] = ACTIONS(1244),
    [anon_sym_RPAREN] = ACTIONS(1244),
    [anon_sym_SLASH] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1246),
    [anon_sym_new] = ACTIONS(1246),
    [anon_sym_export] = ACTIONS(1246),
    [anon_sym_with] = ACTIONS(1246),
    [sym_identifier] = ACTIONS(1246),
    [anon_sym_debugger] = ACTIONS(1246),
    [anon_sym_AT] = ACTIONS(1244),
    [anon_sym_COMMA] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_EQ] = ACTIONS(1246),
    [anon_sym_void] = ACTIONS(1246),
    [anon_sym_const] = ACTIONS(1246),
    [sym_super] = ACTIONS(1246),
    [anon_sym_private] = ACTIONS(1246),
    [anon_sym_get] = ACTIONS(1246),
    [anon_sym_default] = ACTIONS(1246),
    [anon_sym_enum] = ACTIONS(1246),
    [anon_sym_continue] = ACTIONS(1246),
    [anon_sym_DASH_DASH] = ACTIONS(1244),
    [anon_sym_this] = ACTIONS(1246),
    [anon_sym_throw] = ACTIONS(1246),
    [anon_sym_abstract] = ACTIONS(1246),
    [anon_sym_type] = ACTIONS(1246),
    [anon_sym_namespace] = ACTIONS(1246),
    [anon_sym_PLUS_PLUS] = ACTIONS(1244),
    [anon_sym_else] = ACTIONS(1246),
    [anon_sym_BANG] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [sym_false] = ACTIONS(1246),
    [anon_sym_case] = ACTIONS(1246),
    [anon_sym_module] = ACTIONS(1246),
    [anon_sym_class] = ACTIONS(1246),
    [anon_sym_declare] = ACTIONS(1246),
    [anon_sym_LPAREN] = ACTIONS(1244),
    [anon_sym_GT] = ACTIONS(1244),
    [anon_sym_boolean] = ACTIONS(1246),
    [anon_sym_EQ_GT] = ACTIONS(1244),
    [anon_sym_AMP] = ACTIONS(1244),
    [anon_sym_try] = ACTIONS(1246),
    [anon_sym_LT] = ACTIONS(1244),
    [sym_number] = ACTIONS(1244),
    [ts_builtin_sym_end] = ACTIONS(1244),
    [anon_sym_function] = ACTIONS(1246),
    [sym_undefined] = ACTIONS(1246),
    [anon_sym_let] = ACTIONS(1246),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_do] = ACTIONS(1246),
    [anon_sym_TILDE] = ACTIONS(1244),
  },
  [224] = {
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [anon_sym_symbol] = ACTIONS(1250),
    [anon_sym_PIPE] = ACTIONS(1248),
    [anon_sym_break] = ACTIONS(1250),
    [anon_sym_return] = ACTIONS(1250),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_interface] = ACTIONS(1250),
    [anon_sym_delete] = ACTIONS(1250),
    [anon_sym_if] = ACTIONS(1250),
    [anon_sym_yield] = ACTIONS(1250),
    [sym_true] = ACTIONS(1250),
    [anon_sym_protected] = ACTIONS(1250),
    [anon_sym_set] = ACTIONS(1250),
    [anon_sym_import] = ACTIONS(1250),
    [anon_sym_await] = ACTIONS(1250),
    [anon_sym_DQUOTE] = ACTIONS(1248),
    [anon_sym_for] = ACTIONS(1250),
    [anon_sym_SEMI] = ACTIONS(1248),
    [anon_sym_number] = ACTIONS(1250),
    [anon_sym_typeof] = ACTIONS(1250),
    [anon_sym_LBRACE] = ACTIONS(1248),
    [anon_sym_switch] = ACTIONS(1250),
    [anon_sym_RBRACK] = ACTIONS(1248),
    [sym_null] = ACTIONS(1250),
    [anon_sym_any] = ACTIONS(1250),
    [anon_sym_async] = ACTIONS(1250),
    [anon_sym_public] = ACTIONS(1250),
    [anon_sym_var] = ACTIONS(1250),
    [anon_sym_while] = ACTIONS(1250),
    [anon_sym_SQUOTE] = ACTIONS(1248),
    [anon_sym_RPAREN] = ACTIONS(1248),
    [anon_sym_SLASH] = ACTIONS(1250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1250),
    [anon_sym_new] = ACTIONS(1250),
    [anon_sym_export] = ACTIONS(1250),
    [anon_sym_with] = ACTIONS(1250),
    [sym_identifier] = ACTIONS(1250),
    [anon_sym_debugger] = ACTIONS(1250),
    [anon_sym_AT] = ACTIONS(1248),
    [anon_sym_COMMA] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_EQ] = ACTIONS(1250),
    [anon_sym_void] = ACTIONS(1250),
    [anon_sym_const] = ACTIONS(1250),
    [sym_super] = ACTIONS(1250),
    [anon_sym_private] = ACTIONS(1250),
    [anon_sym_get] = ACTIONS(1250),
    [anon_sym_default] = ACTIONS(1250),
    [anon_sym_enum] = ACTIONS(1250),
    [anon_sym_continue] = ACTIONS(1250),
    [anon_sym_DASH_DASH] = ACTIONS(1248),
    [anon_sym_this] = ACTIONS(1250),
    [anon_sym_throw] = ACTIONS(1250),
    [anon_sym_abstract] = ACTIONS(1250),
    [anon_sym_type] = ACTIONS(1250),
    [anon_sym_namespace] = ACTIONS(1250),
    [anon_sym_PLUS_PLUS] = ACTIONS(1248),
    [anon_sym_else] = ACTIONS(1250),
    [anon_sym_BANG] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [sym_false] = ACTIONS(1250),
    [anon_sym_case] = ACTIONS(1250),
    [anon_sym_module] = ACTIONS(1250),
    [anon_sym_class] = ACTIONS(1250),
    [anon_sym_declare] = ACTIONS(1250),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [anon_sym_GT] = ACTIONS(1248),
    [anon_sym_boolean] = ACTIONS(1250),
    [anon_sym_EQ_GT] = ACTIONS(1248),
    [anon_sym_AMP] = ACTIONS(1248),
    [anon_sym_try] = ACTIONS(1250),
    [anon_sym_LT] = ACTIONS(1248),
    [sym_number] = ACTIONS(1248),
    [ts_builtin_sym_end] = ACTIONS(1248),
    [anon_sym_function] = ACTIONS(1250),
    [sym_undefined] = ACTIONS(1250),
    [anon_sym_let] = ACTIONS(1250),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_do] = ACTIONS(1250),
    [anon_sym_TILDE] = ACTIONS(1248),
  },
  [225] = {
    [sym_nested_identifier] = STATE(516),
    [sym_identifier] = ACTIONS(1252),
    [sym_comment] = ACTIONS(3),
  },
  [226] = {
    [sym_number] = ACTIONS(1254),
    [sym_comment] = ACTIONS(3),
  },
  [227] = {
    [anon_sym_BQUOTE] = ACTIONS(1256),
    [anon_sym_symbol] = ACTIONS(1258),
    [anon_sym_PIPE] = ACTIONS(1256),
    [anon_sym_break] = ACTIONS(1258),
    [anon_sym_return] = ACTIONS(1258),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_interface] = ACTIONS(1258),
    [anon_sym_delete] = ACTIONS(1258),
    [anon_sym_if] = ACTIONS(1258),
    [anon_sym_yield] = ACTIONS(1258),
    [sym_true] = ACTIONS(1258),
    [anon_sym_protected] = ACTIONS(1258),
    [anon_sym_set] = ACTIONS(1258),
    [anon_sym_import] = ACTIONS(1258),
    [anon_sym_await] = ACTIONS(1258),
    [anon_sym_DQUOTE] = ACTIONS(1256),
    [anon_sym_for] = ACTIONS(1258),
    [anon_sym_SEMI] = ACTIONS(1256),
    [anon_sym_number] = ACTIONS(1258),
    [anon_sym_typeof] = ACTIONS(1258),
    [anon_sym_LBRACE] = ACTIONS(1256),
    [anon_sym_switch] = ACTIONS(1258),
    [anon_sym_RBRACK] = ACTIONS(1256),
    [sym_null] = ACTIONS(1258),
    [anon_sym_any] = ACTIONS(1258),
    [anon_sym_async] = ACTIONS(1258),
    [anon_sym_public] = ACTIONS(1258),
    [anon_sym_var] = ACTIONS(1258),
    [anon_sym_while] = ACTIONS(1258),
    [anon_sym_SQUOTE] = ACTIONS(1256),
    [anon_sym_RPAREN] = ACTIONS(1256),
    [anon_sym_SLASH] = ACTIONS(1258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1258),
    [anon_sym_new] = ACTIONS(1258),
    [anon_sym_export] = ACTIONS(1258),
    [anon_sym_with] = ACTIONS(1258),
    [sym_identifier] = ACTIONS(1258),
    [anon_sym_debugger] = ACTIONS(1258),
    [anon_sym_AT] = ACTIONS(1256),
    [anon_sym_COMMA] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1258),
    [anon_sym_EQ] = ACTIONS(1258),
    [anon_sym_void] = ACTIONS(1258),
    [anon_sym_const] = ACTIONS(1258),
    [sym_super] = ACTIONS(1258),
    [anon_sym_private] = ACTIONS(1258),
    [anon_sym_get] = ACTIONS(1258),
    [anon_sym_default] = ACTIONS(1258),
    [anon_sym_enum] = ACTIONS(1258),
    [anon_sym_continue] = ACTIONS(1258),
    [anon_sym_DASH_DASH] = ACTIONS(1256),
    [anon_sym_this] = ACTIONS(1258),
    [anon_sym_throw] = ACTIONS(1258),
    [anon_sym_abstract] = ACTIONS(1258),
    [anon_sym_type] = ACTIONS(1258),
    [anon_sym_namespace] = ACTIONS(1258),
    [anon_sym_PLUS_PLUS] = ACTIONS(1256),
    [anon_sym_else] = ACTIONS(1258),
    [anon_sym_BANG] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1256),
    [sym_false] = ACTIONS(1258),
    [anon_sym_case] = ACTIONS(1258),
    [anon_sym_module] = ACTIONS(1258),
    [anon_sym_class] = ACTIONS(1258),
    [anon_sym_declare] = ACTIONS(1258),
    [anon_sym_LPAREN] = ACTIONS(1256),
    [anon_sym_GT] = ACTIONS(1256),
    [anon_sym_boolean] = ACTIONS(1258),
    [anon_sym_EQ_GT] = ACTIONS(1256),
    [anon_sym_AMP] = ACTIONS(1256),
    [anon_sym_try] = ACTIONS(1258),
    [anon_sym_LT] = ACTIONS(1256),
    [sym_number] = ACTIONS(1256),
    [ts_builtin_sym_end] = ACTIONS(1256),
    [anon_sym_function] = ACTIONS(1258),
    [sym_undefined] = ACTIONS(1258),
    [anon_sym_let] = ACTIONS(1258),
    [anon_sym_PLUS] = ACTIONS(1258),
    [anon_sym_do] = ACTIONS(1258),
    [anon_sym_TILDE] = ACTIONS(1256),
  },
  [228] = {
    [sym_nested_type_identifier] = STATE(519),
    [sym_nested_identifier] = STATE(236),
    [sym_identifier] = ACTIONS(1260),
    [sym_comment] = ACTIONS(3),
  },
  [229] = {
    [sym_formal_parameters] = STATE(520),
    [sym_type_parameters] = STATE(521),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [230] = {
    [sym__type] = STATE(527),
    [sym_constructor_type] = STATE(527),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(527),
    [sym_rest_parameter] = STATE(198),
    [sym_nested_identifier] = STATE(236),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(198),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(218),
    [sym_type_parameters] = STATE(233),
    [sym_this] = STATE(468),
    [sym_predefined_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_array_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(477),
    [sym_object] = STATE(465),
    [sym_nested_type_identifier] = STATE(234),
    [sym_optional_parameter] = STATE(198),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(477),
    [sym_union_type] = STATE(527),
    [sym_intersection_type] = STATE(527),
    [sym_formal_parameters] = STATE(238),
    [sym_array] = STATE(467),
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_symbol] = ACTIONS(1264),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(1264),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_this] = ACTIONS(1266),
    [sym_true] = ACTIONS(452),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(452),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1264),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(1264),
    [anon_sym_boolean] = ACTIONS(1264),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1264),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_export] = ACTIONS(1154),
  },
  [231] = {
    [sym__type] = STATE(528),
    [sym_constructor_type] = STATE(528),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(528),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(528),
    [sym_intersection_type] = STATE(528),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [232] = {
    [aux_sym_implements_clause_repeat1] = STATE(533),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_GT] = ACTIONS(1274),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(1278),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym_formal_parameters] = STATE(534),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [234] = {
    [sym_type_arguments] = STATE(537),
    [anon_sym_EQ_GT] = ACTIONS(1280),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [anon_sym_AMP] = ACTIONS(1280),
    [anon_sym_while] = ACTIONS(1280),
    [anon_sym_RPAREN] = ACTIONS(1280),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_COMMA] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(1212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1280),
    [anon_sym_EQ] = ACTIONS(1285),
    [anon_sym_RBRACK] = ACTIONS(1280),
    [anon_sym_GT] = ACTIONS(1280),
    [anon_sym_else] = ACTIONS(1280),
    [anon_sym_in] = ACTIONS(1287),
  },
  [235] = {
    [aux_sym_type_parameters_repeat1] = STATE(540),
    [anon_sym_GT] = ACTIONS(1289),
    [anon_sym_COMMA] = ACTIONS(1291),
    [sym_comment] = ACTIONS(3),
  },
  [236] = {
    [anon_sym_DOT] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
  },
  [237] = {
    [anon_sym_BQUOTE] = ACTIONS(1293),
    [anon_sym_symbol] = ACTIONS(1295),
    [anon_sym_PIPE] = ACTIONS(1293),
    [anon_sym_break] = ACTIONS(1295),
    [anon_sym_return] = ACTIONS(1295),
    [anon_sym_RBRACE] = ACTIONS(1293),
    [anon_sym_interface] = ACTIONS(1295),
    [anon_sym_delete] = ACTIONS(1295),
    [anon_sym_if] = ACTIONS(1295),
    [anon_sym_yield] = ACTIONS(1295),
    [sym_true] = ACTIONS(1295),
    [anon_sym_protected] = ACTIONS(1295),
    [anon_sym_set] = ACTIONS(1295),
    [anon_sym_import] = ACTIONS(1295),
    [anon_sym_await] = ACTIONS(1295),
    [anon_sym_DQUOTE] = ACTIONS(1293),
    [anon_sym_for] = ACTIONS(1295),
    [anon_sym_SEMI] = ACTIONS(1293),
    [anon_sym_number] = ACTIONS(1295),
    [anon_sym_typeof] = ACTIONS(1295),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_switch] = ACTIONS(1295),
    [anon_sym_RBRACK] = ACTIONS(1293),
    [sym_null] = ACTIONS(1295),
    [anon_sym_any] = ACTIONS(1295),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_public] = ACTIONS(1295),
    [anon_sym_var] = ACTIONS(1295),
    [anon_sym_while] = ACTIONS(1295),
    [anon_sym_SQUOTE] = ACTIONS(1293),
    [anon_sym_RPAREN] = ACTIONS(1293),
    [anon_sym_SLASH] = ACTIONS(1295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(1295),
    [anon_sym_export] = ACTIONS(1295),
    [anon_sym_with] = ACTIONS(1295),
    [sym_identifier] = ACTIONS(1295),
    [anon_sym_debugger] = ACTIONS(1295),
    [anon_sym_AT] = ACTIONS(1293),
    [anon_sym_COMMA] = ACTIONS(1293),
    [anon_sym_DASH] = ACTIONS(1295),
    [anon_sym_EQ] = ACTIONS(1295),
    [anon_sym_void] = ACTIONS(1295),
    [anon_sym_const] = ACTIONS(1295),
    [sym_super] = ACTIONS(1295),
    [anon_sym_private] = ACTIONS(1295),
    [anon_sym_get] = ACTIONS(1295),
    [anon_sym_default] = ACTIONS(1295),
    [anon_sym_enum] = ACTIONS(1295),
    [anon_sym_continue] = ACTIONS(1295),
    [anon_sym_DASH_DASH] = ACTIONS(1293),
    [anon_sym_this] = ACTIONS(1295),
    [anon_sym_throw] = ACTIONS(1295),
    [anon_sym_abstract] = ACTIONS(1295),
    [anon_sym_type] = ACTIONS(1295),
    [anon_sym_namespace] = ACTIONS(1295),
    [anon_sym_PLUS_PLUS] = ACTIONS(1293),
    [anon_sym_else] = ACTIONS(1295),
    [anon_sym_BANG] = ACTIONS(1293),
    [anon_sym_LBRACK] = ACTIONS(1297),
    [sym_false] = ACTIONS(1295),
    [anon_sym_case] = ACTIONS(1295),
    [anon_sym_module] = ACTIONS(1295),
    [anon_sym_class] = ACTIONS(1295),
    [anon_sym_declare] = ACTIONS(1295),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1293),
    [anon_sym_boolean] = ACTIONS(1295),
    [anon_sym_EQ_GT] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_try] = ACTIONS(1295),
    [anon_sym_LT] = ACTIONS(1293),
    [sym_number] = ACTIONS(1293),
    [ts_builtin_sym_end] = ACTIONS(1293),
    [anon_sym_function] = ACTIONS(1295),
    [sym_undefined] = ACTIONS(1295),
    [anon_sym_let] = ACTIONS(1295),
    [anon_sym_PLUS] = ACTIONS(1295),
    [anon_sym_do] = ACTIONS(1295),
    [anon_sym_TILDE] = ACTIONS(1293),
  },
  [238] = {
    [anon_sym_EQ_GT] = ACTIONS(1299),
    [sym_comment] = ACTIONS(3),
  },
  [239] = {
    [anon_sym_SLASH2] = ACTIONS(1301),
    [sym_comment] = ACTIONS(3),
  },
  [240] = {
    [sym_call_signature] = STATE(544),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [241] = {
    [sym_call_signature] = STATE(546),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(1303),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [242] = {
    [sym_statement_block] = STATE(547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(805),
  },
  [243] = {
    [sym__initializer] = STATE(1211),
    [sym_arguments] = STATE(548),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [sym__automatic_semicolon] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_PERCENT_EQ] = ACTIONS(1307),
    [anon_sym_AMP_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_EQ] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_CARET_EQ] = ACTIONS(1307),
    [anon_sym_PIPE_EQ] = ACTIONS(1307),
    [anon_sym_DASH_EQ] = ACTIONS(1307),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_PERCENT] = ACTIONS(1309),
    [anon_sym_LT_LT_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(1309),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1305),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_LT_LT] = ACTIONS(1309),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_STAR_EQ] = ACTIONS(1307),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1307),
    [anon_sym_CARET] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [244] = {
    [sym_arguments] = STATE(548),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [sym__automatic_semicolon] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1305),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_PERCENT] = ACTIONS(1305),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1305),
    [anon_sym_STAR_STAR] = ACTIONS(1305),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1305),
    [anon_sym_LT_LT] = ACTIONS(1305),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [245] = {
    [anon_sym_target] = ACTIONS(1313),
    [sym_comment] = ACTIONS(3),
  },
  [246] = {
    [sym__initializer] = STATE(1215),
    [sym_arguments] = STATE(550),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [sym__automatic_semicolon] = ACTIONS(1315),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1315),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1315),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_instanceof] = ACTIONS(1315),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [247] = {
    [sym_new_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [sym_call_signature] = STATE(2379),
    [sym_yield_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_internal_module] = STATE(2350),
    [sym_arrow_function] = STATE(2350),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2350),
    [sym_type_parameters] = STATE(55),
    [sym_arguments] = STATE(550),
    [sym_object] = STATE(2522),
    [sym_generator_function] = STATE(2350),
    [sym_subscript_expression] = STATE(2521),
    [sym_ternary_expression] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym__initializer] = STATE(1215),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym__expression] = STATE(2350),
    [sym_non_null_expression] = STATE(2350),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(2350),
    [sym_this] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_type_arguments] = STATE(2523),
    [sym_parenthesized_expression] = STATE(2350),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [sym__automatic_semicolon] = ACTIONS(1315),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1315),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(1323),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_DOT] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [sym_null] = ACTIONS(1323),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [sym_false] = ACTIONS(1323),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_LT] = ACTIONS(1319),
    [sym_number] = ACTIONS(1335),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_in] = ACTIONS(1319),
  },
  [248] = {
    [sym__initializer] = STATE(1215),
    [sym_formal_parameters] = STATE(58),
    [sym_call_signature] = STATE(206),
    [sym_type_parameters] = STATE(55),
    [sym_arguments] = STATE(550),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [sym__automatic_semicolon] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(432),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(432),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(432),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(432),
    [anon_sym_RBRACE] = ACTIONS(1315),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_protected] = ACTIONS(432),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_set] = ACTIONS(432),
    [anon_sym_type] = ACTIONS(432),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_import] = ACTIONS(432),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_namespace] = ACTIONS(432),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_module] = ACTIONS(432),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(432),
    [anon_sym_declare] = ACTIONS(432),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_any] = ACTIONS(432),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(432),
    [anon_sym_async] = ACTIONS(432),
    [anon_sym_public] = ACTIONS(432),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(432),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_export] = ACTIONS(432),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [249] = {
    [sym_nested_identifier] = STATE(1592),
    [sym__module] = STATE(1483),
    [sym__initializer] = STATE(1215),
    [sym_string] = STATE(1594),
    [sym_arguments] = STATE(550),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [sym__automatic_semicolon] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1315),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [250] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [251] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(551),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [sym__automatic_semicolon] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1305),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_PERCENT] = ACTIONS(1305),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1305),
    [anon_sym_STAR_STAR] = ACTIONS(1305),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1305),
    [anon_sym_LT_LT] = ACTIONS(1305),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [252] = {
    [sym__initializer] = STATE(1211),
    [sym_arguments] = STATE(548),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [sym__automatic_semicolon] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_PERCENT_EQ] = ACTIONS(1307),
    [anon_sym_AMP_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_EQ] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_CARET_EQ] = ACTIONS(1307),
    [anon_sym_PIPE_EQ] = ACTIONS(1307),
    [anon_sym_DASH_EQ] = ACTIONS(1307),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_PERCENT] = ACTIONS(1309),
    [anon_sym_LT_LT_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(1305),
    [anon_sym_STAR_STAR] = ACTIONS(1309),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1305),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_LT_LT] = ACTIONS(1309),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_STAR_EQ] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1307),
    [anon_sym_CARET] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [253] = {
    [sym__initializer] = STATE(1273),
    [sym_arguments] = STATE(548),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [sym__automatic_semicolon] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1305),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_PERCENT] = ACTIONS(1305),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1305),
    [anon_sym_STAR_STAR] = ACTIONS(1305),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1305),
    [anon_sym_LT_LT] = ACTIONS(1305),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [254] = {
    [sym__initializer] = STATE(1287),
    [sym_arguments] = STATE(548),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [sym__automatic_semicolon] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1305),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_PERCENT] = ACTIONS(1305),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1305),
    [anon_sym_STAR_STAR] = ACTIONS(1305),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1305),
    [anon_sym_LT_LT] = ACTIONS(1305),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [255] = {
    [sym_nested_identifier] = STATE(1224),
    [sym__module] = STATE(141),
    [sym_string] = STATE(1226),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(326),
  },
  [256] = {
    [sym__from_clause] = STATE(552),
    [anon_sym_from] = ACTIONS(797),
    [sym_comment] = ACTIONS(3),
  },
  [257] = {
    [sym__import_export_specifier] = STATE(555),
    [sym_identifier] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(1361),
    [anon_sym_typeof] = ACTIONS(791),
    [anon_sym_COMMA] = ACTIONS(1363),
    [anon_sym_type] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
  },
  [258] = {
    [sym_new_expression] = STATE(291),
    [sym_augmented_assignment_expression] = STATE(291),
    [sym_unary_expression] = STATE(291),
    [sym_update_expression] = STATE(291),
    [sym_regex] = STATE(291),
    [sym_meta_property] = STATE(291),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(291),
    [sym_yield_expression] = STATE(291),
    [sym_as_expression] = STATE(291),
    [sym_non_null_expression] = STATE(291),
    [sym_internal_module] = STATE(291),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(291),
    [sym_await_expression] = STATE(291),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(291),
    [sym_this] = STATE(291),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(291),
    [sym_generator_function] = STATE(291),
    [sym_call_expression] = STATE(291),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(291),
    [sym_ternary_expression] = STATE(291),
    [sym_binary_expression] = STATE(291),
    [sym_template_string] = STATE(291),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(291),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(291),
    [sym_class] = STATE(291),
    [sym_identifier] = ACTIONS(1365),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(626),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(626),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(626),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(628),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(626),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [259] = {
    [sym_new_expression] = STATE(557),
    [sym_augmented_assignment_expression] = STATE(557),
    [sym_unary_expression] = STATE(557),
    [sym_update_expression] = STATE(557),
    [sym_regex] = STATE(557),
    [sym_meta_property] = STATE(557),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(557),
    [sym_yield_expression] = STATE(557),
    [sym_as_expression] = STATE(557),
    [sym_non_null_expression] = STATE(557),
    [sym_internal_module] = STATE(557),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(557),
    [sym_await_expression] = STATE(557),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(557),
    [sym_this] = STATE(557),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(557),
    [sym_generator_function] = STATE(557),
    [sym_call_expression] = STATE(557),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(557),
    [sym_ternary_expression] = STATE(557),
    [sym_binary_expression] = STATE(557),
    [sym_template_string] = STATE(557),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(557),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(557),
    [sym_class] = STATE(557),
    [sym_identifier] = ACTIONS(1367),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_void] = ACTIONS(1373),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(1379),
    [sym_true] = ACTIONS(1381),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(1381),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1381),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1391),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(1381),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1387),
  },
  [260] = {
    [anon_sym_namespace] = ACTIONS(1395),
    [sym_comment] = ACTIONS(3),
  },
  [261] = {
    [sym_identifier] = ACTIONS(1397),
    [anon_sym_BQUOTE] = ACTIONS(1399),
    [anon_sym_debugger] = ACTIONS(1397),
    [anon_sym_symbol] = ACTIONS(1397),
    [anon_sym_AT] = ACTIONS(1399),
    [anon_sym_DASH] = ACTIONS(1397),
    [anon_sym_void] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1397),
    [anon_sym_const] = ACTIONS(1397),
    [sym_super] = ACTIONS(1397),
    [anon_sym_return] = ACTIONS(1397),
    [anon_sym_private] = ACTIONS(1397),
    [anon_sym_get] = ACTIONS(1397),
    [anon_sym_RBRACE] = ACTIONS(1399),
    [anon_sym_interface] = ACTIONS(1397),
    [anon_sym_default] = ACTIONS(1397),
    [anon_sym_enum] = ACTIONS(1397),
    [anon_sym_delete] = ACTIONS(1397),
    [anon_sym_continue] = ACTIONS(1397),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_if] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1397),
    [anon_sym_yield] = ACTIONS(1397),
    [sym_true] = ACTIONS(1397),
    [anon_sym_throw] = ACTIONS(1397),
    [anon_sym_protected] = ACTIONS(1397),
    [anon_sym_abstract] = ACTIONS(1397),
    [anon_sym_set] = ACTIONS(1397),
    [anon_sym_type] = ACTIONS(1397),
    [anon_sym_import] = ACTIONS(1397),
    [anon_sym_namespace] = ACTIONS(1397),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_await] = ACTIONS(1397),
    [anon_sym_DQUOTE] = ACTIONS(1399),
    [anon_sym_else] = ACTIONS(1397),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_for] = ACTIONS(1397),
    [anon_sym_LBRACK] = ACTIONS(1399),
    [sym_false] = ACTIONS(1397),
    [anon_sym_SEMI] = ACTIONS(1399),
    [anon_sym_case] = ACTIONS(1397),
    [anon_sym_module] = ACTIONS(1397),
    [anon_sym_number] = ACTIONS(1397),
    [anon_sym_class] = ACTIONS(1397),
    [anon_sym_declare] = ACTIONS(1397),
    [anon_sym_typeof] = ACTIONS(1397),
    [anon_sym_LBRACE] = ACTIONS(1399),
    [anon_sym_switch] = ACTIONS(1397),
    [anon_sym_LPAREN] = ACTIONS(1399),
    [sym_null] = ACTIONS(1397),
    [anon_sym_any] = ACTIONS(1397),
    [anon_sym_boolean] = ACTIONS(1397),
    [anon_sym_async] = ACTIONS(1397),
    [anon_sym_public] = ACTIONS(1397),
    [anon_sym_var] = ACTIONS(1397),
    [anon_sym_while] = ACTIONS(1397),
    [anon_sym_SQUOTE] = ACTIONS(1399),
    [anon_sym_try] = ACTIONS(1397),
    [anon_sym_LT] = ACTIONS(1399),
    [sym_number] = ACTIONS(1399),
    [anon_sym_SLASH] = ACTIONS(1397),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1397),
    [anon_sym_function] = ACTIONS(1397),
    [sym_undefined] = ACTIONS(1397),
    [anon_sym_new] = ACTIONS(1397),
    [ts_builtin_sym_end] = ACTIONS(1399),
    [anon_sym_let] = ACTIONS(1397),
    [anon_sym_PLUS] = ACTIONS(1397),
    [anon_sym_export] = ACTIONS(1397),
    [anon_sym_do] = ACTIONS(1397),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_with] = ACTIONS(1397),
  },
  [262] = {
    [sym__from_clause] = STATE(552),
    [sym__automatic_semicolon] = ACTIONS(1401),
    [anon_sym_SEMI] = ACTIONS(1401),
    [anon_sym_from] = ACTIONS(797),
    [sym_comment] = ACTIONS(3),
  },
  [263] = {
    [anon_sym_while] = ACTIONS(1403),
    [sym_comment] = ACTIONS(3),
  },
  [264] = {
    [sym_type_alias_declaration] = STATE(561),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(561),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(561),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(561),
    [sym_return_statement] = STATE(561),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(561),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(561),
    [sym_switch_statement] = STATE(561),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(561),
    [sym_throw_statement] = STATE(561),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(561),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(561),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(561),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(561),
    [sym_abstract_class] = STATE(561),
    [sym_interface_declaration] = STATE(561),
    [sym_statement_block] = STATE(561),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(561),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(561),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(561),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(561),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(561),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(561),
    [sym_empty_statement] = STATE(561),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(561),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(561),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(561),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(561),
    [sym_break_statement] = STATE(561),
    [sym_labeled_statement] = STATE(561),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(561),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [265] = {
    [sym_type_annotation] = STATE(562),
    [anon_sym_EQ_GT] = ACTIONS(1405),
    [anon_sym_COLON] = ACTIONS(568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1405),
  },
  [266] = {
    [sym_type_alias_declaration] = STATE(266),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(266),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(266),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(266),
    [sym_return_statement] = STATE(266),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(266),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(266),
    [sym_switch_statement] = STATE(266),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(266),
    [sym_throw_statement] = STATE(266),
    [aux_sym_program_repeat1] = STATE(266),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(266),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(266),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(266),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(266),
    [sym_abstract_class] = STATE(266),
    [sym_interface_declaration] = STATE(266),
    [sym_statement_block] = STATE(266),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(266),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(266),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(266),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(266),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(266),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(266),
    [sym_empty_statement] = STATE(266),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(266),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(266),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(266),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(266),
    [sym_break_statement] = STATE(266),
    [sym_labeled_statement] = STATE(266),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(266),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1410),
    [anon_sym_debugger] = ACTIONS(1413),
    [anon_sym_symbol] = ACTIONS(1416),
    [anon_sym_AT] = ACTIONS(1419),
    [anon_sym_DASH] = ACTIONS(1422),
    [anon_sym_void] = ACTIONS(1425),
    [anon_sym_break] = ACTIONS(1428),
    [anon_sym_const] = ACTIONS(1431),
    [sym_super] = ACTIONS(1434),
    [anon_sym_return] = ACTIONS(1437),
    [anon_sym_private] = ACTIONS(1416),
    [anon_sym_get] = ACTIONS(1416),
    [anon_sym_RBRACE] = ACTIONS(1440),
    [anon_sym_interface] = ACTIONS(1442),
    [anon_sym_default] = ACTIONS(1445),
    [anon_sym_enum] = ACTIONS(1447),
    [anon_sym_delete] = ACTIONS(1450),
    [anon_sym_continue] = ACTIONS(1453),
    [anon_sym_DASH_DASH] = ACTIONS(1456),
    [anon_sym_if] = ACTIONS(1459),
    [anon_sym_this] = ACTIONS(1462),
    [anon_sym_yield] = ACTIONS(1465),
    [sym_true] = ACTIONS(1468),
    [anon_sym_throw] = ACTIONS(1471),
    [anon_sym_protected] = ACTIONS(1416),
    [anon_sym_abstract] = ACTIONS(1474),
    [anon_sym_set] = ACTIONS(1416),
    [anon_sym_type] = ACTIONS(1477),
    [anon_sym_import] = ACTIONS(1480),
    [anon_sym_namespace] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1456),
    [anon_sym_await] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(1489),
    [anon_sym_BANG] = ACTIONS(1492),
    [anon_sym_for] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1498),
    [sym_false] = ACTIONS(1468),
    [anon_sym_SEMI] = ACTIONS(1501),
    [anon_sym_case] = ACTIONS(1445),
    [anon_sym_module] = ACTIONS(1504),
    [anon_sym_number] = ACTIONS(1416),
    [anon_sym_class] = ACTIONS(1507),
    [anon_sym_declare] = ACTIONS(1510),
    [anon_sym_typeof] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(1513),
    [anon_sym_switch] = ACTIONS(1516),
    [anon_sym_LPAREN] = ACTIONS(1519),
    [sym_null] = ACTIONS(1468),
    [anon_sym_any] = ACTIONS(1416),
    [anon_sym_boolean] = ACTIONS(1416),
    [anon_sym_async] = ACTIONS(1522),
    [anon_sym_public] = ACTIONS(1416),
    [anon_sym_var] = ACTIONS(1525),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_SQUOTE] = ACTIONS(1531),
    [anon_sym_try] = ACTIONS(1534),
    [anon_sym_LT] = ACTIONS(1537),
    [sym_number] = ACTIONS(1540),
    [anon_sym_SLASH] = ACTIONS(1543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1416),
    [anon_sym_function] = ACTIONS(1546),
    [sym_undefined] = ACTIONS(1468),
    [anon_sym_new] = ACTIONS(1549),
    [ts_builtin_sym_end] = ACTIONS(1440),
    [anon_sym_let] = ACTIONS(1552),
    [anon_sym_PLUS] = ACTIONS(1422),
    [anon_sym_export] = ACTIONS(1555),
    [anon_sym_do] = ACTIONS(1558),
    [anon_sym_TILDE] = ACTIONS(1492),
    [anon_sym_with] = ACTIONS(1561),
  },
  [267] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1564),
    [sym__automatic_semicolon] = ACTIONS(1564),
    [anon_sym_BQUOTE] = ACTIONS(1564),
    [anon_sym_PIPE] = ACTIONS(1566),
    [anon_sym_COMMA] = ACTIONS(1564),
    [anon_sym_DASH] = ACTIONS(1566),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_GT_GT_GT] = ACTIONS(1564),
    [anon_sym_BANG_EQ] = ACTIONS(1566),
    [anon_sym_GT_EQ] = ACTIONS(1564),
    [anon_sym_RBRACE] = ACTIONS(1564),
    [anon_sym_PERCENT] = ACTIONS(1564),
    [anon_sym_as] = ACTIONS(1564),
    [anon_sym_DASH_DASH] = ACTIONS(1564),
    [anon_sym_instanceof] = ACTIONS(1564),
    [anon_sym_DOT] = ACTIONS(1564),
    [anon_sym_STAR_STAR] = ACTIONS(1564),
    [anon_sym_PLUS_PLUS] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(1566),
    [anon_sym_LBRACK] = ACTIONS(1564),
    [anon_sym_SEMI] = ACTIONS(1564),
    [anon_sym_LT_LT] = ACTIONS(1564),
    [anon_sym_AMP_AMP] = ACTIONS(1564),
    [anon_sym_LT_EQ] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_QMARK] = ACTIONS(1564),
    [anon_sym_PIPE_PIPE] = ACTIONS(1564),
    [anon_sym_EQ_EQ] = ACTIONS(1566),
    [anon_sym_RPAREN] = ACTIONS(1564),
    [anon_sym_LT] = ACTIONS(1566),
    [anon_sym_SLASH] = ACTIONS(1566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1564),
    [anon_sym_PLUS] = ACTIONS(1566),
    [anon_sym_GT_GT] = ACTIONS(1566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1564),
    [anon_sym_in] = ACTIONS(1566),
  },
  [268] = {
    [sym__type] = STATE(563),
    [sym_constructor_type] = STATE(563),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(563),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(563),
    [sym_intersection_type] = STATE(563),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [269] = {
    [anon_sym_EQ_GT] = ACTIONS(1405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1405),
  },
  [270] = {
    [sym_identifier] = ACTIONS(1568),
    [anon_sym_BQUOTE] = ACTIONS(1570),
    [anon_sym_debugger] = ACTIONS(1568),
    [anon_sym_symbol] = ACTIONS(1568),
    [anon_sym_AT] = ACTIONS(1570),
    [anon_sym_DASH] = ACTIONS(1568),
    [anon_sym_void] = ACTIONS(1568),
    [anon_sym_break] = ACTIONS(1568),
    [anon_sym_const] = ACTIONS(1568),
    [sym_super] = ACTIONS(1568),
    [anon_sym_return] = ACTIONS(1568),
    [anon_sym_private] = ACTIONS(1568),
    [anon_sym_get] = ACTIONS(1568),
    [anon_sym_RBRACE] = ACTIONS(1570),
    [anon_sym_interface] = ACTIONS(1568),
    [anon_sym_default] = ACTIONS(1568),
    [anon_sym_enum] = ACTIONS(1568),
    [anon_sym_delete] = ACTIONS(1568),
    [anon_sym_continue] = ACTIONS(1568),
    [anon_sym_DASH_DASH] = ACTIONS(1570),
    [anon_sym_if] = ACTIONS(1568),
    [anon_sym_this] = ACTIONS(1568),
    [anon_sym_yield] = ACTIONS(1568),
    [sym_true] = ACTIONS(1568),
    [anon_sym_throw] = ACTIONS(1568),
    [anon_sym_protected] = ACTIONS(1568),
    [anon_sym_abstract] = ACTIONS(1568),
    [anon_sym_set] = ACTIONS(1568),
    [anon_sym_type] = ACTIONS(1568),
    [anon_sym_import] = ACTIONS(1568),
    [anon_sym_namespace] = ACTIONS(1568),
    [anon_sym_PLUS_PLUS] = ACTIONS(1570),
    [anon_sym_await] = ACTIONS(1568),
    [anon_sym_DQUOTE] = ACTIONS(1570),
    [anon_sym_else] = ACTIONS(1568),
    [anon_sym_BANG] = ACTIONS(1570),
    [anon_sym_for] = ACTIONS(1568),
    [anon_sym_LBRACK] = ACTIONS(1570),
    [sym_false] = ACTIONS(1568),
    [anon_sym_SEMI] = ACTIONS(1570),
    [anon_sym_case] = ACTIONS(1568),
    [anon_sym_module] = ACTIONS(1568),
    [anon_sym_number] = ACTIONS(1568),
    [anon_sym_class] = ACTIONS(1568),
    [anon_sym_declare] = ACTIONS(1568),
    [anon_sym_typeof] = ACTIONS(1568),
    [anon_sym_LBRACE] = ACTIONS(1570),
    [anon_sym_switch] = ACTIONS(1568),
    [anon_sym_LPAREN] = ACTIONS(1570),
    [sym_null] = ACTIONS(1568),
    [anon_sym_any] = ACTIONS(1568),
    [anon_sym_boolean] = ACTIONS(1568),
    [anon_sym_async] = ACTIONS(1568),
    [anon_sym_public] = ACTIONS(1568),
    [anon_sym_var] = ACTIONS(1568),
    [anon_sym_while] = ACTIONS(1568),
    [anon_sym_SQUOTE] = ACTIONS(1570),
    [anon_sym_try] = ACTIONS(1568),
    [anon_sym_RPAREN] = ACTIONS(1570),
    [anon_sym_LT] = ACTIONS(1570),
    [sym_number] = ACTIONS(1570),
    [anon_sym_SLASH] = ACTIONS(1568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1568),
    [anon_sym_function] = ACTIONS(1568),
    [sym_undefined] = ACTIONS(1568),
    [anon_sym_new] = ACTIONS(1568),
    [ts_builtin_sym_end] = ACTIONS(1570),
    [anon_sym_let] = ACTIONS(1568),
    [anon_sym_PLUS] = ACTIONS(1568),
    [anon_sym_export] = ACTIONS(1568),
    [anon_sym_do] = ACTIONS(1568),
    [anon_sym_TILDE] = ACTIONS(1570),
    [anon_sym_with] = ACTIONS(1568),
  },
  [271] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1572),
    [sym__automatic_semicolon] = ACTIONS(1572),
    [anon_sym_BQUOTE] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_COMMA] = ACTIONS(1572),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1574),
    [anon_sym_GT_GT_GT] = ACTIONS(1572),
    [anon_sym_BANG_EQ] = ACTIONS(1574),
    [anon_sym_GT_EQ] = ACTIONS(1572),
    [anon_sym_RBRACE] = ACTIONS(1572),
    [anon_sym_PERCENT] = ACTIONS(1572),
    [anon_sym_as] = ACTIONS(1572),
    [anon_sym_DASH_DASH] = ACTIONS(1572),
    [anon_sym_instanceof] = ACTIONS(1572),
    [anon_sym_DOT] = ACTIONS(1572),
    [anon_sym_STAR_STAR] = ACTIONS(1572),
    [anon_sym_PLUS_PLUS] = ACTIONS(1572),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LBRACK] = ACTIONS(1572),
    [anon_sym_SEMI] = ACTIONS(1572),
    [anon_sym_LT_LT] = ACTIONS(1572),
    [anon_sym_AMP_AMP] = ACTIONS(1572),
    [anon_sym_LT_EQ] = ACTIONS(1572),
    [anon_sym_LPAREN] = ACTIONS(1572),
    [anon_sym_GT] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_QMARK] = ACTIONS(1572),
    [anon_sym_PIPE_PIPE] = ACTIONS(1572),
    [anon_sym_EQ_EQ] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(1572),
    [anon_sym_LT] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1574),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1572),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_GT_GT] = ACTIONS(1574),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1572),
    [anon_sym_in] = ACTIONS(1574),
  },
  [272] = {
    [sym_new_expression] = STATE(564),
    [sym_augmented_assignment_expression] = STATE(564),
    [sym_unary_expression] = STATE(564),
    [sym_update_expression] = STATE(564),
    [sym_regex] = STATE(564),
    [sym_meta_property] = STATE(564),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(564),
    [sym_yield_expression] = STATE(564),
    [sym_as_expression] = STATE(564),
    [sym_non_null_expression] = STATE(564),
    [sym_internal_module] = STATE(564),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(564),
    [sym_await_expression] = STATE(564),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(564),
    [sym_this] = STATE(564),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(564),
    [sym_generator_function] = STATE(564),
    [sym_call_expression] = STATE(564),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(564),
    [sym_ternary_expression] = STATE(564),
    [sym_binary_expression] = STATE(564),
    [sym_template_string] = STATE(564),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(564),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(564),
    [sym_class] = STATE(564),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1576),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(1576),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1576),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1578),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(1576),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [273] = {
    [sym_new_expression] = STATE(565),
    [sym_augmented_assignment_expression] = STATE(565),
    [sym_unary_expression] = STATE(565),
    [sym_update_expression] = STATE(565),
    [sym_regex] = STATE(565),
    [sym_meta_property] = STATE(565),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(565),
    [sym_yield_expression] = STATE(565),
    [sym_as_expression] = STATE(565),
    [sym_non_null_expression] = STATE(565),
    [sym_internal_module] = STATE(565),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(565),
    [sym_await_expression] = STATE(565),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(565),
    [sym_this] = STATE(565),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(565),
    [sym_generator_function] = STATE(565),
    [sym_call_expression] = STATE(565),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(565),
    [sym_ternary_expression] = STATE(565),
    [sym_binary_expression] = STATE(565),
    [sym_template_string] = STATE(565),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(565),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(565),
    [sym_class] = STATE(565),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1580),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(1580),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1580),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1582),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(1580),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [274] = {
    [sym_new_expression] = STATE(566),
    [sym_augmented_assignment_expression] = STATE(566),
    [sym_unary_expression] = STATE(566),
    [sym_update_expression] = STATE(566),
    [sym_regex] = STATE(566),
    [sym_meta_property] = STATE(566),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(566),
    [sym_yield_expression] = STATE(566),
    [sym_as_expression] = STATE(566),
    [sym_non_null_expression] = STATE(566),
    [sym_internal_module] = STATE(566),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(566),
    [sym_await_expression] = STATE(566),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(566),
    [sym_this] = STATE(566),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(566),
    [sym_generator_function] = STATE(566),
    [sym_call_expression] = STATE(566),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(566),
    [sym_ternary_expression] = STATE(566),
    [sym_binary_expression] = STATE(566),
    [sym_template_string] = STATE(566),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(566),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(566),
    [sym_class] = STATE(566),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1584),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(1584),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1584),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1586),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(1584),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [275] = {
    [sym_new_expression] = STATE(567),
    [sym_augmented_assignment_expression] = STATE(567),
    [sym_unary_expression] = STATE(567),
    [sym_update_expression] = STATE(567),
    [sym_regex] = STATE(567),
    [sym_meta_property] = STATE(567),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(567),
    [sym_yield_expression] = STATE(567),
    [sym_as_expression] = STATE(567),
    [sym_non_null_expression] = STATE(567),
    [sym_internal_module] = STATE(567),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(567),
    [sym_await_expression] = STATE(567),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(567),
    [sym_this] = STATE(567),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(567),
    [sym_generator_function] = STATE(567),
    [sym_call_expression] = STATE(567),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(567),
    [sym_ternary_expression] = STATE(567),
    [sym_binary_expression] = STATE(567),
    [sym_template_string] = STATE(567),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(567),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(567),
    [sym_class] = STATE(567),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1588),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(1588),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1588),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1590),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(1588),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [276] = {
    [sym_new_expression] = STATE(568),
    [sym_augmented_assignment_expression] = STATE(568),
    [sym_unary_expression] = STATE(568),
    [sym_update_expression] = STATE(568),
    [sym_regex] = STATE(568),
    [sym_meta_property] = STATE(568),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(568),
    [sym_yield_expression] = STATE(568),
    [sym_as_expression] = STATE(568),
    [sym_non_null_expression] = STATE(568),
    [sym_internal_module] = STATE(568),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(568),
    [sym_await_expression] = STATE(568),
    [sym_member_expression] = STATE(54),
    [sym_sequence_expression] = STATE(569),
    [sym_string] = STATE(568),
    [sym_this] = STATE(568),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(568),
    [sym_generator_function] = STATE(568),
    [sym_call_expression] = STATE(568),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(568),
    [sym_ternary_expression] = STATE(568),
    [sym_binary_expression] = STATE(568),
    [sym_template_string] = STATE(568),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(568),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(568),
    [sym_class] = STATE(568),
    [anon_sym_BANG] = ACTIONS(59),
    [sym_identifier] = ACTIONS(149),
    [sym_false] = ACTIONS(1592),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1592),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(1594),
    [sym_true] = ACTIONS(1592),
    [anon_sym_yield] = ACTIONS(41),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(1592),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
  },
  [277] = {
    [sym_new_expression] = STATE(570),
    [sym_augmented_assignment_expression] = STATE(570),
    [sym_unary_expression] = STATE(570),
    [sym_update_expression] = STATE(570),
    [sym_regex] = STATE(570),
    [sym_meta_property] = STATE(570),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(570),
    [sym_yield_expression] = STATE(570),
    [sym_as_expression] = STATE(570),
    [sym_non_null_expression] = STATE(570),
    [sym_internal_module] = STATE(570),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(570),
    [sym_await_expression] = STATE(570),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(570),
    [sym_this] = STATE(570),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(570),
    [sym_generator_function] = STATE(570),
    [sym_call_expression] = STATE(570),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(570),
    [sym_ternary_expression] = STATE(570),
    [sym_binary_expression] = STATE(570),
    [sym_template_string] = STATE(570),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(570),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(570),
    [sym_class] = STATE(570),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(1596),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1596),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(1596),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1598),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1596),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [278] = {
    [sym__type] = STATE(571),
    [sym_constructor_type] = STATE(571),
    [sym_index_type_query] = STATE(1259),
    [sym_lookup_type] = STATE(1259),
    [sym_this_type] = STATE(1259),
    [sym_flow_maybe_type] = STATE(1259),
    [sym_function_type] = STATE(571),
    [sym_nested_identifier] = STATE(2241),
    [sym__primary_type] = STATE(1259),
    [sym_generic_type] = STATE(1259),
    [sym_mapped_type] = STATE(1259),
    [sym_literal_type] = STATE(1259),
    [sym_parenthesized_type] = STATE(1259),
    [sym_predefined_type] = STATE(1259),
    [sym_type_parameters] = STATE(2240),
    [sym_string] = STATE(1251),
    [sym_array_type] = STATE(1259),
    [sym_tuple_type] = STATE(1259),
    [sym_nested_type_identifier] = STATE(1258),
    [sym_type_predicate] = STATE(1259),
    [sym_type_query] = STATE(1259),
    [sym__number] = STATE(1251),
    [sym_existential_type] = STATE(1259),
    [sym_template_string] = STATE(572),
    [sym_object_type] = STATE(1259),
    [sym_union_type] = STATE(571),
    [sym_intersection_type] = STATE(571),
    [sym_formal_parameters] = STATE(1796),
    [sym_identifier] = ACTIONS(1600),
    [sym_false] = ACTIONS(1602),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1606),
    [anon_sym_number] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_keyof] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_void] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_QMARK] = ACTIONS(1626),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1628),
    [sym_number] = ACTIONS(1630),
    [sym_true] = ACTIONS(1602),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_new] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [279] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(759),
    [sym__automatic_semicolon] = ACTIONS(759),
    [anon_sym_BQUOTE] = ACTIONS(759),
    [anon_sym_PIPE] = ACTIONS(761),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_DASH] = ACTIONS(761),
    [anon_sym_STAR] = ACTIONS(761),
    [anon_sym_GT_GT_GT] = ACTIONS(759),
    [anon_sym_BANG_EQ] = ACTIONS(761),
    [anon_sym_GT_EQ] = ACTIONS(759),
    [anon_sym_RBRACE] = ACTIONS(759),
    [anon_sym_PERCENT] = ACTIONS(759),
    [anon_sym_as] = ACTIONS(759),
    [anon_sym_DASH_DASH] = ACTIONS(759),
    [anon_sym_instanceof] = ACTIONS(759),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_STAR_STAR] = ACTIONS(759),
    [anon_sym_PLUS_PLUS] = ACTIONS(759),
    [anon_sym_BANG] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_SEMI] = ACTIONS(759),
    [anon_sym_LT_LT] = ACTIONS(759),
    [anon_sym_AMP_AMP] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_GT] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(759),
    [anon_sym_EQ_EQ] = ACTIONS(761),
    [anon_sym_RPAREN] = ACTIONS(759),
    [anon_sym_LT] = ACTIONS(761),
    [anon_sym_SLASH] = ACTIONS(761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(759),
    [anon_sym_PLUS] = ACTIONS(761),
    [anon_sym_GT_GT] = ACTIONS(761),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(759),
    [anon_sym_in] = ACTIONS(761),
  },
  [280] = {
    [sym_new_expression] = STATE(289),
    [sym_constructor_type] = STATE(232),
    [sym_augmented_assignment_expression] = STATE(289),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(289),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(289),
    [sym_call_signature] = STATE(52),
    [sym_yield_expression] = STATE(289),
    [sym_as_expression] = STATE(289),
    [sym_internal_module] = STATE(289),
    [sym_arrow_function] = STATE(289),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(54),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(574),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(57),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(289),
    [sym_subscript_expression] = STATE(54),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(289),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(289),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(232),
    [sym__type] = STATE(232),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(289),
    [sym_meta_property] = STATE(289),
    [sym_function_type] = STATE(232),
    [sym__expression] = STATE(289),
    [sym_non_null_expression] = STATE(289),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(89),
    [sym_await_expression] = STATE(289),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(289),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_anonymous_class] = STATE(289),
    [sym_call_expression] = STATE(289),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(289),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(289),
    [sym_type_arguments] = STATE(64),
    [sym_union_type] = STATE(232),
    [sym_parenthesized_expression] = STATE(289),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(289),
    [sym_class] = STATE(289),
    [sym_identifier] = ACTIONS(1634),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(1636),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(1638),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(1640),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1642),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1644),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [sym_false] = ACTIONS(1644),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1652),
    [sym_null] = ACTIONS(618),
    [anon_sym_any] = ACTIONS(1636),
    [anon_sym_boolean] = ACTIONS(1636),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1654),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1636),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(618),
    [anon_sym_new] = ACTIONS(1656),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [281] = {
    [sym_new_expression] = STATE(583),
    [sym_augmented_assignment_expression] = STATE(583),
    [sym_unary_expression] = STATE(583),
    [sym_update_expression] = STATE(583),
    [sym_regex] = STATE(583),
    [sym_meta_property] = STATE(583),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(583),
    [sym_yield_expression] = STATE(583),
    [sym_as_expression] = STATE(583),
    [sym_non_null_expression] = STATE(583),
    [sym_internal_module] = STATE(583),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(583),
    [sym_await_expression] = STATE(583),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(583),
    [sym_this] = STATE(583),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(583),
    [sym_generator_function] = STATE(583),
    [sym_call_expression] = STATE(583),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(583),
    [sym_ternary_expression] = STATE(583),
    [sym_binary_expression] = STATE(583),
    [sym_template_string] = STATE(583),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(583),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(583),
    [sym_class] = STATE(583),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1658),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(1658),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(1658),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1660),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(1658),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [282] = {
    [sym_type_alias_declaration] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(159),
    [sym__declaration] = STATE(559),
    [sym_ambient_declaration] = STATE(559),
    [sym_import_alias] = STATE(559),
    [sym_export_statement] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_lexical_declaration] = STATE(559),
    [sym_internal_module] = STATE(559),
    [sym_decorator] = STATE(159),
    [sym_enum_declaration] = STATE(559),
    [sym_function] = STATE(559),
    [sym_function_signature] = STATE(559),
    [sym_variable_declaration] = STATE(559),
    [sym_abstract_class] = STATE(559),
    [sym_module] = STATE(559),
    [sym_interface_declaration] = STATE(559),
    [sym_class] = STATE(559),
    [anon_sym_var] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(1662),
    [anon_sym_interface] = ACTIONS(340),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_module] = ACTIONS(534),
    [anon_sym_class] = ACTIONS(354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(362),
    [anon_sym_const] = ACTIONS(338),
    [anon_sym_abstract] = ACTIONS(344),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_let] = ACTIONS(364),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_export] = ACTIONS(366),
    [anon_sym_namespace] = ACTIONS(350),
    [anon_sym_async] = ACTIONS(358),
  },
  [283] = {
    [sym_class_heritage] = STATE(586),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(399),
    [anon_sym_extends] = ACTIONS(328),
    [sym_identifier] = ACTIONS(1664),
    [anon_sym_implements] = ACTIONS(332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [284] = {
    [aux_sym_export_statement_repeat1] = STATE(284),
    [sym_decorator] = STATE(284),
    [anon_sym_export] = ACTIONS(1666),
    [anon_sym_class] = ACTIONS(1666),
    [anon_sym_AT] = ACTIONS(1668),
    [sym_comment] = ACTIONS(3),
  },
  [285] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1671),
    [sym__automatic_semicolon] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1673),
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_STAR] = ACTIONS(1673),
    [anon_sym_GT_GT_GT] = ACTIONS(1671),
    [anon_sym_BANG_EQ] = ACTIONS(1673),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_RBRACE] = ACTIONS(1671),
    [anon_sym_PERCENT] = ACTIONS(1671),
    [anon_sym_as] = ACTIONS(1671),
    [anon_sym_DASH_DASH] = ACTIONS(1671),
    [anon_sym_instanceof] = ACTIONS(1671),
    [anon_sym_DOT] = ACTIONS(1671),
    [anon_sym_STAR_STAR] = ACTIONS(1671),
    [anon_sym_PLUS_PLUS] = ACTIONS(1671),
    [anon_sym_BANG] = ACTIONS(1673),
    [anon_sym_LBRACK] = ACTIONS(1671),
    [anon_sym_SEMI] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_LT_EQ] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(1671),
    [anon_sym_GT] = ACTIONS(1673),
    [anon_sym_AMP] = ACTIONS(1673),
    [anon_sym_QMARK] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [anon_sym_EQ_EQ] = ACTIONS(1673),
    [anon_sym_RPAREN] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1673),
    [anon_sym_SLASH] = ACTIONS(1673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1671),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_GT_GT] = ACTIONS(1673),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1671),
    [anon_sym_in] = ACTIONS(1673),
  },
  [286] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1675),
    [sym__automatic_semicolon] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(1675),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_STAR] = ACTIONS(1677),
    [anon_sym_GT_GT_GT] = ACTIONS(1675),
    [anon_sym_BANG_EQ] = ACTIONS(1677),
    [anon_sym_GT_EQ] = ACTIONS(1675),
    [anon_sym_RBRACE] = ACTIONS(1675),
    [anon_sym_PERCENT] = ACTIONS(1675),
    [anon_sym_as] = ACTIONS(1675),
    [anon_sym_DASH_DASH] = ACTIONS(1675),
    [anon_sym_instanceof] = ACTIONS(1675),
    [anon_sym_DOT] = ACTIONS(1675),
    [anon_sym_STAR_STAR] = ACTIONS(1675),
    [anon_sym_PLUS_PLUS] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_SEMI] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_LT_EQ] = ACTIONS(1675),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_GT] = ACTIONS(1677),
    [anon_sym_AMP] = ACTIONS(1677),
    [anon_sym_QMARK] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [anon_sym_EQ_EQ] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1677),
    [anon_sym_SLASH] = ACTIONS(1677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_GT_GT] = ACTIONS(1677),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1675),
    [anon_sym_in] = ACTIONS(1677),
  },
  [287] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1679),
    [sym__automatic_semicolon] = ACTIONS(1679),
    [anon_sym_BQUOTE] = ACTIONS(1679),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1681),
    [anon_sym_GT_GT_GT] = ACTIONS(1679),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(1679),
    [anon_sym_RBRACE] = ACTIONS(1679),
    [anon_sym_PERCENT] = ACTIONS(1679),
    [anon_sym_as] = ACTIONS(1679),
    [anon_sym_DASH_DASH] = ACTIONS(1679),
    [anon_sym_instanceof] = ACTIONS(1679),
    [anon_sym_DOT] = ACTIONS(1679),
    [anon_sym_STAR_STAR] = ACTIONS(1679),
    [anon_sym_PLUS_PLUS] = ACTIONS(1679),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1679),
    [anon_sym_SEMI] = ACTIONS(1679),
    [anon_sym_LT_LT] = ACTIONS(1679),
    [anon_sym_AMP_AMP] = ACTIONS(1679),
    [anon_sym_LT_EQ] = ACTIONS(1679),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1679),
    [anon_sym_PIPE_PIPE] = ACTIONS(1679),
    [anon_sym_EQ_EQ] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1679),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(1681),
  },
  [288] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [sym__automatic_semicolon] = ACTIONS(1679),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(1679),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1679),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(590),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_RPAREN] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_in] = ACTIONS(125),
  },
  [289] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [290] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [sym__automatic_semicolon] = ACTIONS(1687),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(1687),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(590),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_RPAREN] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_in] = ACTIONS(125),
  },
  [291] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [sym__automatic_semicolon] = ACTIONS(1689),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(1689),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(1689),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1689),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(590),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_RPAREN] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_in] = ACTIONS(125),
  },
  [292] = {
    [sym_identifier] = ACTIONS(1691),
    [anon_sym_BQUOTE] = ACTIONS(1693),
    [anon_sym_debugger] = ACTIONS(1691),
    [anon_sym_symbol] = ACTIONS(1691),
    [anon_sym_AT] = ACTIONS(1693),
    [anon_sym_DASH] = ACTIONS(1691),
    [anon_sym_void] = ACTIONS(1691),
    [anon_sym_break] = ACTIONS(1691),
    [anon_sym_const] = ACTIONS(1691),
    [sym_super] = ACTIONS(1691),
    [anon_sym_return] = ACTIONS(1691),
    [anon_sym_private] = ACTIONS(1691),
    [anon_sym_get] = ACTIONS(1691),
    [anon_sym_RBRACE] = ACTIONS(1693),
    [anon_sym_interface] = ACTIONS(1691),
    [anon_sym_default] = ACTIONS(1691),
    [anon_sym_enum] = ACTIONS(1691),
    [anon_sym_delete] = ACTIONS(1691),
    [anon_sym_continue] = ACTIONS(1691),
    [anon_sym_DASH_DASH] = ACTIONS(1693),
    [anon_sym_if] = ACTIONS(1691),
    [anon_sym_this] = ACTIONS(1691),
    [anon_sym_yield] = ACTIONS(1691),
    [sym_true] = ACTIONS(1691),
    [anon_sym_throw] = ACTIONS(1691),
    [anon_sym_protected] = ACTIONS(1691),
    [anon_sym_abstract] = ACTIONS(1691),
    [anon_sym_set] = ACTIONS(1691),
    [anon_sym_type] = ACTIONS(1691),
    [anon_sym_import] = ACTIONS(1691),
    [anon_sym_namespace] = ACTIONS(1691),
    [anon_sym_PLUS_PLUS] = ACTIONS(1693),
    [anon_sym_await] = ACTIONS(1691),
    [anon_sym_DQUOTE] = ACTIONS(1693),
    [anon_sym_else] = ACTIONS(1691),
    [anon_sym_BANG] = ACTIONS(1693),
    [anon_sym_for] = ACTIONS(1691),
    [anon_sym_LBRACK] = ACTIONS(1693),
    [sym_false] = ACTIONS(1691),
    [anon_sym_SEMI] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(1691),
    [anon_sym_module] = ACTIONS(1691),
    [anon_sym_number] = ACTIONS(1691),
    [anon_sym_class] = ACTIONS(1691),
    [anon_sym_declare] = ACTIONS(1691),
    [anon_sym_typeof] = ACTIONS(1691),
    [anon_sym_LBRACE] = ACTIONS(1693),
    [anon_sym_switch] = ACTIONS(1691),
    [anon_sym_LPAREN] = ACTIONS(1693),
    [sym_null] = ACTIONS(1691),
    [anon_sym_any] = ACTIONS(1691),
    [anon_sym_boolean] = ACTIONS(1691),
    [anon_sym_async] = ACTIONS(1691),
    [anon_sym_public] = ACTIONS(1691),
    [anon_sym_var] = ACTIONS(1691),
    [anon_sym_while] = ACTIONS(1691),
    [anon_sym_SQUOTE] = ACTIONS(1693),
    [anon_sym_try] = ACTIONS(1691),
    [anon_sym_LT] = ACTIONS(1693),
    [sym_number] = ACTIONS(1693),
    [anon_sym_SLASH] = ACTIONS(1691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1691),
    [anon_sym_function] = ACTIONS(1691),
    [sym_undefined] = ACTIONS(1691),
    [anon_sym_new] = ACTIONS(1691),
    [ts_builtin_sym_end] = ACTIONS(1693),
    [anon_sym_let] = ACTIONS(1691),
    [anon_sym_PLUS] = ACTIONS(1691),
    [anon_sym_export] = ACTIONS(1691),
    [anon_sym_do] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1693),
    [anon_sym_with] = ACTIONS(1691),
  },
  [293] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [sym__automatic_semicolon] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(1697),
    [anon_sym_COMMA] = ACTIONS(1695),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_RBRACE] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(1695),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1695),
    [anon_sym_SEMI] = ACTIONS(1695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_GT] = ACTIONS(1697),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(1697),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1697),
  },
  [294] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [295] = {
    [anon_sym_RBRACE] = ACTIONS(1699),
    [sym_comment] = ACTIONS(3),
  },
  [296] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1701),
    [sym__automatic_semicolon] = ACTIONS(1701),
    [anon_sym_BQUOTE] = ACTIONS(1701),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(1701),
    [anon_sym_DASH] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1703),
    [anon_sym_GT_GT_GT] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_GT_EQ] = ACTIONS(1701),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [anon_sym_as] = ACTIONS(1701),
    [anon_sym_DASH_DASH] = ACTIONS(1701),
    [anon_sym_instanceof] = ACTIONS(1701),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_STAR_STAR] = ACTIONS(1701),
    [anon_sym_PLUS_PLUS] = ACTIONS(1701),
    [anon_sym_BANG] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1701),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(1701),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_LPAREN] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE] = ACTIONS(1701),
    [anon_sym_EQ_EQ] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1701),
    [anon_sym_in] = ACTIONS(1703),
  },
  [297] = {
    [aux_sym_template_string_repeat1] = STATE(297),
    [sym_template_substitution] = STATE(297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1705),
    [sym_escape_sequence] = ACTIONS(1708),
    [anon_sym_BQUOTE] = ACTIONS(1711),
    [sym__template_chars] = ACTIONS(1708),
    [sym_comment] = ACTIONS(3),
  },
  [298] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1713),
    [sym__automatic_semicolon] = ACTIONS(1713),
    [anon_sym_BQUOTE] = ACTIONS(1713),
    [anon_sym_PIPE] = ACTIONS(1715),
    [anon_sym_COMMA] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1715),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1715),
    [anon_sym_GT_EQ] = ACTIONS(1713),
    [anon_sym_RBRACE] = ACTIONS(1713),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_as] = ACTIONS(1713),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_instanceof] = ACTIONS(1713),
    [anon_sym_DOT] = ACTIONS(1713),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_BANG] = ACTIONS(1715),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_SEMI] = ACTIONS(1713),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1713),
    [anon_sym_LT_EQ] = ACTIONS(1713),
    [anon_sym_LPAREN] = ACTIONS(1713),
    [anon_sym_GT] = ACTIONS(1715),
    [anon_sym_AMP] = ACTIONS(1715),
    [anon_sym_QMARK] = ACTIONS(1713),
    [anon_sym_PIPE_PIPE] = ACTIONS(1713),
    [anon_sym_EQ_EQ] = ACTIONS(1715),
    [anon_sym_RPAREN] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(1715),
    [anon_sym_SLASH] = ACTIONS(1715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_GT_GT] = ACTIONS(1715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1713),
    [anon_sym_in] = ACTIONS(1715),
  },
  [299] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [sym__automatic_semicolon] = ACTIONS(1713),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(1713),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1713),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(590),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_RPAREN] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_in] = ACTIONS(125),
  },
  [300] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [sym__automatic_semicolon] = ACTIONS(1717),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(1717),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(1717),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1717),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(590),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_RPAREN] = ACTIONS(1717),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_in] = ACTIONS(125),
  },
  [301] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1719),
    [sym__automatic_semicolon] = ACTIONS(1719),
    [anon_sym_BQUOTE] = ACTIONS(1719),
    [anon_sym_PERCENT_EQ] = ACTIONS(1719),
    [anon_sym_AMP_EQ] = ACTIONS(1719),
    [anon_sym_PLUS_EQ] = ACTIONS(1719),
    [anon_sym_PIPE] = ACTIONS(1721),
    [anon_sym_COMMA] = ACTIONS(1719),
    [anon_sym_DASH] = ACTIONS(1721),
    [anon_sym_STAR] = ACTIONS(1721),
    [anon_sym_GT_GT_GT] = ACTIONS(1721),
    [anon_sym_EQ] = ACTIONS(1721),
    [anon_sym_BANG_EQ] = ACTIONS(1721),
    [anon_sym_GT_EQ] = ACTIONS(1719),
    [anon_sym_CARET_EQ] = ACTIONS(1719),
    [anon_sym_PIPE_EQ] = ACTIONS(1719),
    [anon_sym_DASH_EQ] = ACTIONS(1719),
    [anon_sym_RBRACE] = ACTIONS(1719),
    [anon_sym_PERCENT] = ACTIONS(1721),
    [anon_sym_LT_LT_EQ] = ACTIONS(1719),
    [anon_sym_as] = ACTIONS(1719),
    [anon_sym_DASH_DASH] = ACTIONS(1719),
    [anon_sym_instanceof] = ACTIONS(1719),
    [anon_sym_GT_GT_EQ] = ACTIONS(1719),
    [anon_sym_DOT] = ACTIONS(1719),
    [anon_sym_STAR_STAR] = ACTIONS(1721),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1719),
    [anon_sym_PLUS_PLUS] = ACTIONS(1719),
    [anon_sym_BANG] = ACTIONS(1721),
    [anon_sym_LBRACK] = ACTIONS(1719),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1719),
    [anon_sym_LT_LT] = ACTIONS(1721),
    [anon_sym_AMP_AMP] = ACTIONS(1719),
    [anon_sym_LT_EQ] = ACTIONS(1719),
    [anon_sym_LPAREN] = ACTIONS(1719),
    [anon_sym_GT] = ACTIONS(1721),
    [anon_sym_STAR_EQ] = ACTIONS(1719),
    [anon_sym_AMP] = ACTIONS(1721),
    [anon_sym_QMARK] = ACTIONS(1719),
    [anon_sym_PIPE_PIPE] = ACTIONS(1719),
    [anon_sym_EQ_EQ] = ACTIONS(1721),
    [anon_sym_RPAREN] = ACTIONS(1719),
    [anon_sym_LT] = ACTIONS(1721),
    [anon_sym_SLASH] = ACTIONS(1721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1721),
    [anon_sym_PLUS] = ACTIONS(1721),
    [anon_sym_GT_GT] = ACTIONS(1721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1719),
    [anon_sym_in] = ACTIONS(1721),
  },
  [302] = {
    [sym_identifier] = ACTIONS(1723),
    [sym_comment] = ACTIONS(3),
  },
  [303] = {
    [anon_sym_LBRACK] = ACTIONS(1725),
    [sym_identifier] = ACTIONS(1727),
    [anon_sym_module] = ACTIONS(1727),
    [anon_sym_symbol] = ACTIONS(1727),
    [anon_sym_number] = ACTIONS(1727),
    [anon_sym_class] = ACTIONS(1727),
    [anon_sym_AT] = ACTIONS(1725),
    [anon_sym_declare] = ACTIONS(1727),
    [anon_sym_STAR] = ACTIONS(1725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1725),
    [anon_sym_LBRACE] = ACTIONS(1725),
    [anon_sym_void] = ACTIONS(1727),
    [anon_sym_any] = ACTIONS(1727),
    [anon_sym_private] = ACTIONS(1727),
    [anon_sym_boolean] = ACTIONS(1727),
    [anon_sym_static] = ACTIONS(1727),
    [anon_sym_async] = ACTIONS(1727),
    [anon_sym_get] = ACTIONS(1727),
    [anon_sym_public] = ACTIONS(1727),
    [anon_sym_RBRACE] = ACTIONS(1725),
    [anon_sym_SQUOTE] = ACTIONS(1725),
    [anon_sym_this] = ACTIONS(1727),
    [sym_number] = ACTIONS(1725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1727),
    [anon_sym_string] = ACTIONS(1727),
    [anon_sym_abstract] = ACTIONS(1727),
    [anon_sym_set] = ACTIONS(1727),
    [anon_sym_type] = ACTIONS(1727),
    [anon_sym_import] = ACTIONS(1727),
    [anon_sym_export] = ACTIONS(1727),
    [anon_sym_namespace] = ACTIONS(1727),
    [sym_readonly] = ACTIONS(1727),
    [anon_sym_DQUOTE] = ACTIONS(1725),
  },
  [304] = {
    [sym__initializer] = STATE(589),
    [aux_sym_object_repeat1] = STATE(408),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [305] = {
    [aux_sym_object_repeat1] = STATE(408),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [306] = {
    [aux_sym_object_repeat1] = STATE(408),
    [anon_sym_LBRACK] = ACTIONS(1014),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_symbol] = ACTIONS(1012),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_namespace] = ACTIONS(1012),
    [sym_readonly] = ACTIONS(1012),
    [anon_sym_DQUOTE] = ACTIONS(1014),
  },
  [307] = {
    [sym__property_name] = STATE(417),
    [aux_sym_object_repeat1] = STATE(408),
    [sym_string] = STATE(417),
    [sym_computed_property_name] = STATE(417),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(1020),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1016),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [308] = {
    [sym__property_name] = STATE(417),
    [aux_sym_object_repeat1] = STATE(408),
    [sym_string] = STATE(417),
    [sym_computed_property_name] = STATE(417),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [309] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [sym__automatic_semicolon] = ACTIONS(1027),
    [anon_sym_BQUOTE] = ACTIONS(1027),
    [anon_sym_PIPE] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1031),
    [anon_sym_GT_GT_GT] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1031),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [anon_sym_SEMI] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_of] = ACTIONS(1027),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1031),
    [anon_sym_AMP] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_RPAREN] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1031),
    [anon_sym_SLASH] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(1031),
  },
  [310] = {
    [sym__initializer] = STATE(590),
    [anon_sym_EQ] = ACTIONS(1729),
    [sym_comment] = ACTIONS(3),
  },
  [311] = {
    [sym__property_name] = STATE(439),
    [sym_decorator] = STATE(2472),
    [aux_sym_export_statement_repeat1] = STATE(2472),
    [sym_accessibility_modifier] = STATE(180),
    [sym_computed_property_name] = STATE(439),
    [sym_method_definition] = STATE(438),
    [sym_string] = STATE(439),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_get] = ACTIONS(1080),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [sym_number] = ACTIONS(1082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [312] = {
    [sym__initializer] = STATE(591),
    [anon_sym_EQ] = ACTIONS(1729),
    [sym_comment] = ACTIONS(3),
  },
  [313] = {
    [sym_call_signature] = STATE(1843),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(1731),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [314] = {
    [sym_call_signature] = STATE(1843),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [315] = {
    [sym_identifier] = ACTIONS(1733),
    [anon_sym_BQUOTE] = ACTIONS(1735),
    [anon_sym_debugger] = ACTIONS(1733),
    [anon_sym_symbol] = ACTIONS(1733),
    [anon_sym_AT] = ACTIONS(1735),
    [anon_sym_DASH] = ACTIONS(1733),
    [anon_sym_void] = ACTIONS(1733),
    [anon_sym_break] = ACTIONS(1733),
    [anon_sym_const] = ACTIONS(1733),
    [sym_super] = ACTIONS(1733),
    [anon_sym_return] = ACTIONS(1733),
    [anon_sym_private] = ACTIONS(1733),
    [anon_sym_get] = ACTIONS(1733),
    [anon_sym_RBRACE] = ACTIONS(1735),
    [anon_sym_interface] = ACTIONS(1733),
    [anon_sym_default] = ACTIONS(1733),
    [anon_sym_enum] = ACTIONS(1733),
    [anon_sym_delete] = ACTIONS(1733),
    [anon_sym_continue] = ACTIONS(1733),
    [anon_sym_DASH_DASH] = ACTIONS(1735),
    [anon_sym_if] = ACTIONS(1733),
    [anon_sym_this] = ACTIONS(1733),
    [anon_sym_yield] = ACTIONS(1733),
    [sym_true] = ACTIONS(1733),
    [anon_sym_throw] = ACTIONS(1733),
    [anon_sym_protected] = ACTIONS(1733),
    [anon_sym_abstract] = ACTIONS(1733),
    [anon_sym_set] = ACTIONS(1733),
    [anon_sym_type] = ACTIONS(1733),
    [anon_sym_import] = ACTIONS(1733),
    [anon_sym_namespace] = ACTIONS(1733),
    [anon_sym_PLUS_PLUS] = ACTIONS(1735),
    [anon_sym_await] = ACTIONS(1733),
    [anon_sym_DQUOTE] = ACTIONS(1735),
    [anon_sym_else] = ACTIONS(1733),
    [anon_sym_BANG] = ACTIONS(1735),
    [anon_sym_for] = ACTIONS(1733),
    [anon_sym_LBRACK] = ACTIONS(1735),
    [sym_false] = ACTIONS(1733),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_case] = ACTIONS(1733),
    [anon_sym_module] = ACTIONS(1733),
    [anon_sym_number] = ACTIONS(1733),
    [anon_sym_class] = ACTIONS(1733),
    [anon_sym_declare] = ACTIONS(1733),
    [anon_sym_typeof] = ACTIONS(1733),
    [anon_sym_LBRACE] = ACTIONS(1735),
    [anon_sym_switch] = ACTIONS(1733),
    [anon_sym_LPAREN] = ACTIONS(1735),
    [sym_null] = ACTIONS(1733),
    [anon_sym_any] = ACTIONS(1733),
    [anon_sym_boolean] = ACTIONS(1733),
    [anon_sym_async] = ACTIONS(1733),
    [anon_sym_public] = ACTIONS(1733),
    [anon_sym_var] = ACTIONS(1733),
    [anon_sym_while] = ACTIONS(1733),
    [anon_sym_SQUOTE] = ACTIONS(1735),
    [anon_sym_try] = ACTIONS(1733),
    [anon_sym_LT] = ACTIONS(1735),
    [sym_number] = ACTIONS(1735),
    [anon_sym_SLASH] = ACTIONS(1733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1733),
    [anon_sym_function] = ACTIONS(1733),
    [sym_undefined] = ACTIONS(1733),
    [anon_sym_new] = ACTIONS(1733),
    [ts_builtin_sym_end] = ACTIONS(1735),
    [anon_sym_let] = ACTIONS(1733),
    [anon_sym_PLUS] = ACTIONS(1733),
    [anon_sym_export] = ACTIONS(1733),
    [anon_sym_do] = ACTIONS(1733),
    [anon_sym_TILDE] = ACTIONS(1735),
    [anon_sym_with] = ACTIONS(1733),
  },
  [316] = {
    [sym__automatic_semicolon] = ACTIONS(1737),
    [anon_sym_SEMI] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1737),
    [sym_comment] = ACTIONS(3),
  },
  [317] = {
    [sym__initializer] = STATE(593),
    [sym__automatic_semicolon] = ACTIONS(1737),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(1737),
    [anon_sym_COMMA] = ACTIONS(1737),
    [sym_comment] = ACTIONS(3),
  },
  [318] = {
    [sym_enum_body] = STATE(594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(751),
  },
  [319] = {
    [sym_variable_declarator] = STATE(595),
    [sym_array] = STATE(97),
    [sym_object] = STATE(98),
    [sym_identifier] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(185),
  },
  [320] = {
    [sym_identifier] = ACTIONS(1739),
    [anon_sym_BQUOTE] = ACTIONS(1741),
    [anon_sym_debugger] = ACTIONS(1739),
    [anon_sym_symbol] = ACTIONS(1739),
    [anon_sym_AT] = ACTIONS(1741),
    [anon_sym_DASH] = ACTIONS(1739),
    [anon_sym_void] = ACTIONS(1739),
    [anon_sym_break] = ACTIONS(1739),
    [anon_sym_const] = ACTIONS(1739),
    [sym_super] = ACTIONS(1739),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_private] = ACTIONS(1739),
    [anon_sym_get] = ACTIONS(1739),
    [anon_sym_RBRACE] = ACTIONS(1741),
    [anon_sym_interface] = ACTIONS(1739),
    [anon_sym_default] = ACTIONS(1739),
    [anon_sym_enum] = ACTIONS(1739),
    [anon_sym_delete] = ACTIONS(1739),
    [anon_sym_continue] = ACTIONS(1739),
    [anon_sym_DASH_DASH] = ACTIONS(1741),
    [anon_sym_if] = ACTIONS(1739),
    [anon_sym_this] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1739),
    [sym_true] = ACTIONS(1739),
    [anon_sym_throw] = ACTIONS(1739),
    [anon_sym_protected] = ACTIONS(1739),
    [anon_sym_abstract] = ACTIONS(1739),
    [anon_sym_set] = ACTIONS(1739),
    [anon_sym_type] = ACTIONS(1739),
    [anon_sym_import] = ACTIONS(1739),
    [anon_sym_namespace] = ACTIONS(1739),
    [anon_sym_PLUS_PLUS] = ACTIONS(1741),
    [anon_sym_await] = ACTIONS(1739),
    [anon_sym_DQUOTE] = ACTIONS(1741),
    [anon_sym_else] = ACTIONS(1739),
    [anon_sym_BANG] = ACTIONS(1741),
    [anon_sym_for] = ACTIONS(1739),
    [anon_sym_LBRACK] = ACTIONS(1741),
    [sym_false] = ACTIONS(1739),
    [anon_sym_SEMI] = ACTIONS(1741),
    [anon_sym_case] = ACTIONS(1739),
    [anon_sym_module] = ACTIONS(1739),
    [anon_sym_number] = ACTIONS(1739),
    [anon_sym_class] = ACTIONS(1739),
    [anon_sym_declare] = ACTIONS(1739),
    [anon_sym_typeof] = ACTIONS(1739),
    [anon_sym_LBRACE] = ACTIONS(1741),
    [anon_sym_switch] = ACTIONS(1739),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [sym_null] = ACTIONS(1739),
    [anon_sym_any] = ACTIONS(1739),
    [anon_sym_boolean] = ACTIONS(1739),
    [anon_sym_async] = ACTIONS(1739),
    [anon_sym_public] = ACTIONS(1739),
    [anon_sym_var] = ACTIONS(1739),
    [anon_sym_while] = ACTIONS(1739),
    [anon_sym_SQUOTE] = ACTIONS(1741),
    [anon_sym_try] = ACTIONS(1739),
    [anon_sym_LT] = ACTIONS(1741),
    [sym_number] = ACTIONS(1741),
    [anon_sym_SLASH] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1739),
    [anon_sym_function] = ACTIONS(1739),
    [sym_undefined] = ACTIONS(1739),
    [anon_sym_new] = ACTIONS(1739),
    [ts_builtin_sym_end] = ACTIONS(1741),
    [anon_sym_let] = ACTIONS(1739),
    [anon_sym_PLUS] = ACTIONS(1739),
    [anon_sym_export] = ACTIONS(1739),
    [anon_sym_do] = ACTIONS(1739),
    [anon_sym_TILDE] = ACTIONS(1741),
    [anon_sym_with] = ACTIONS(1739),
  },
  [321] = {
    [aux_sym_variable_declaration_repeat1] = STATE(597),
    [sym__automatic_semicolon] = ACTIONS(1743),
    [anon_sym_SEMI] = ACTIONS(1743),
    [anon_sym_COMMA] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
  },
  [322] = {
    [sym__automatic_semicolon] = ACTIONS(1745),
    [anon_sym_SEMI] = ACTIONS(1745),
    [anon_sym_COMMA] = ACTIONS(1745),
    [sym_comment] = ACTIONS(3),
  },
  [323] = {
    [sym__initializer] = STATE(598),
    [anon_sym_EQ] = ACTIONS(717),
    [sym_comment] = ACTIONS(3),
  },
  [324] = {
    [sym__automatic_semicolon] = ACTIONS(1747),
    [anon_sym_SEMI] = ACTIONS(1747),
    [anon_sym_COMMA] = ACTIONS(1747),
    [sym_comment] = ACTIONS(3),
  },
  [325] = {
    [sym__initializer] = STATE(599),
    [anon_sym_EQ] = ACTIONS(717),
    [sym_comment] = ACTIONS(3),
  },
  [326] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACK] = ACTIONS(1749),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [327] = {
    [anon_sym_RBRACK] = ACTIONS(1749),
    [sym_comment] = ACTIONS(3),
  },
  [328] = {
    [sym_type_arguments] = STATE(497),
    [anon_sym_EQ_GT] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1198),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_while] = ACTIONS(1201),
    [anon_sym_RPAREN] = ACTIONS(1201),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_COMMA] = ACTIONS(1201),
    [anon_sym_LT] = ACTIONS(1212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(1207),
    [anon_sym_LBRACE] = ACTIONS(1201),
    [anon_sym_EQ] = ACTIONS(1751),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_RBRACK] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(1214),
  },
  [329] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1753),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [anon_sym_BQUOTE] = ACTIONS(1753),
    [anon_sym_PIPE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1755),
    [anon_sym_GT_GT_GT] = ACTIONS(1753),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_GT_EQ] = ACTIONS(1753),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_PERCENT] = ACTIONS(1753),
    [anon_sym_as] = ACTIONS(1753),
    [anon_sym_DASH_DASH] = ACTIONS(1753),
    [anon_sym_instanceof] = ACTIONS(1753),
    [anon_sym_DOT] = ACTIONS(1753),
    [anon_sym_STAR_STAR] = ACTIONS(1753),
    [anon_sym_PLUS_PLUS] = ACTIONS(1753),
    [anon_sym_BANG] = ACTIONS(1755),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_LT_LT] = ACTIONS(1753),
    [anon_sym_AMP_AMP] = ACTIONS(1753),
    [anon_sym_LT_EQ] = ACTIONS(1753),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_GT] = ACTIONS(1755),
    [anon_sym_AMP] = ACTIONS(1755),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_PIPE_PIPE] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_RPAREN] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_GT_GT] = ACTIONS(1755),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1753),
    [anon_sym_in] = ACTIONS(1755),
  },
  [330] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [aux_sym_array_repeat1] = STATE(602),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(1757),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [331] = {
    [aux_sym_array_repeat1] = STATE(602),
    [anon_sym_RPAREN] = ACTIONS(1757),
    [anon_sym_COMMA] = ACTIONS(272),
    [sym_comment] = ACTIONS(3),
  },
  [332] = {
    [aux_sym_array_repeat1] = STATE(375),
    [anon_sym_RPAREN] = ACTIONS(1757),
    [anon_sym_COMMA] = ACTIONS(272),
    [sym_comment] = ACTIONS(3),
  },
  [333] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1759),
    [sym__automatic_semicolon] = ACTIONS(1759),
    [anon_sym_BQUOTE] = ACTIONS(1759),
    [anon_sym_PIPE] = ACTIONS(1761),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1761),
    [anon_sym_GT_GT_GT] = ACTIONS(1759),
    [anon_sym_BANG_EQ] = ACTIONS(1761),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_RBRACE] = ACTIONS(1759),
    [anon_sym_PERCENT] = ACTIONS(1759),
    [anon_sym_as] = ACTIONS(1759),
    [anon_sym_DASH_DASH] = ACTIONS(1759),
    [anon_sym_instanceof] = ACTIONS(1759),
    [anon_sym_DOT] = ACTIONS(1759),
    [anon_sym_STAR_STAR] = ACTIONS(1759),
    [anon_sym_PLUS_PLUS] = ACTIONS(1759),
    [anon_sym_BANG] = ACTIONS(1761),
    [anon_sym_LBRACK] = ACTIONS(1759),
    [anon_sym_SEMI] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1759),
    [anon_sym_AMP_AMP] = ACTIONS(1759),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_PIPE_PIPE] = ACTIONS(1759),
    [anon_sym_EQ_EQ] = ACTIONS(1761),
    [anon_sym_RPAREN] = ACTIONS(1759),
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_SLASH] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1759),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1759),
    [anon_sym_in] = ACTIONS(1761),
  },
  [334] = {
    [sym_identifier] = ACTIONS(1763),
    [anon_sym_BQUOTE] = ACTIONS(1765),
    [anon_sym_debugger] = ACTIONS(1763),
    [anon_sym_symbol] = ACTIONS(1763),
    [anon_sym_AT] = ACTIONS(1765),
    [anon_sym_DASH] = ACTIONS(1763),
    [anon_sym_void] = ACTIONS(1763),
    [anon_sym_break] = ACTIONS(1763),
    [anon_sym_const] = ACTIONS(1763),
    [sym_super] = ACTIONS(1763),
    [anon_sym_return] = ACTIONS(1763),
    [anon_sym_private] = ACTIONS(1763),
    [anon_sym_get] = ACTIONS(1763),
    [anon_sym_RBRACE] = ACTIONS(1765),
    [anon_sym_interface] = ACTIONS(1763),
    [anon_sym_default] = ACTIONS(1763),
    [anon_sym_enum] = ACTIONS(1763),
    [anon_sym_delete] = ACTIONS(1763),
    [anon_sym_continue] = ACTIONS(1763),
    [anon_sym_DASH_DASH] = ACTIONS(1765),
    [anon_sym_if] = ACTIONS(1763),
    [anon_sym_this] = ACTIONS(1763),
    [anon_sym_yield] = ACTIONS(1763),
    [sym_true] = ACTIONS(1763),
    [anon_sym_throw] = ACTIONS(1763),
    [anon_sym_protected] = ACTIONS(1763),
    [anon_sym_abstract] = ACTIONS(1763),
    [anon_sym_set] = ACTIONS(1763),
    [anon_sym_type] = ACTIONS(1763),
    [anon_sym_import] = ACTIONS(1763),
    [anon_sym_namespace] = ACTIONS(1763),
    [anon_sym_PLUS_PLUS] = ACTIONS(1765),
    [anon_sym_await] = ACTIONS(1763),
    [anon_sym_DQUOTE] = ACTIONS(1765),
    [anon_sym_else] = ACTIONS(1763),
    [anon_sym_BANG] = ACTIONS(1765),
    [anon_sym_for] = ACTIONS(1763),
    [anon_sym_LBRACK] = ACTIONS(1765),
    [sym_false] = ACTIONS(1763),
    [anon_sym_SEMI] = ACTIONS(1765),
    [anon_sym_case] = ACTIONS(1763),
    [anon_sym_module] = ACTIONS(1763),
    [anon_sym_number] = ACTIONS(1763),
    [anon_sym_class] = ACTIONS(1763),
    [anon_sym_declare] = ACTIONS(1763),
    [anon_sym_typeof] = ACTIONS(1763),
    [anon_sym_LBRACE] = ACTIONS(1765),
    [anon_sym_switch] = ACTIONS(1763),
    [anon_sym_LPAREN] = ACTIONS(1765),
    [sym_null] = ACTIONS(1763),
    [anon_sym_any] = ACTIONS(1763),
    [anon_sym_boolean] = ACTIONS(1763),
    [anon_sym_async] = ACTIONS(1763),
    [anon_sym_public] = ACTIONS(1763),
    [anon_sym_var] = ACTIONS(1763),
    [anon_sym_while] = ACTIONS(1763),
    [anon_sym_SQUOTE] = ACTIONS(1765),
    [anon_sym_try] = ACTIONS(1763),
    [anon_sym_LT] = ACTIONS(1765),
    [sym_number] = ACTIONS(1765),
    [anon_sym_SLASH] = ACTIONS(1763),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1763),
    [anon_sym_function] = ACTIONS(1763),
    [sym_undefined] = ACTIONS(1763),
    [anon_sym_new] = ACTIONS(1763),
    [ts_builtin_sym_end] = ACTIONS(1765),
    [anon_sym_let] = ACTIONS(1763),
    [anon_sym_PLUS] = ACTIONS(1763),
    [anon_sym_export] = ACTIONS(1763),
    [anon_sym_do] = ACTIONS(1763),
    [anon_sym_TILDE] = ACTIONS(1765),
    [anon_sym_with] = ACTIONS(1763),
  },
  [335] = {
    [sym_object_type] = STATE(603),
    [sym_extends_clause] = STATE(604),
    [anon_sym_extends] = ACTIONS(749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(476),
  },
  [336] = {
    [sym_identifier] = ACTIONS(1767),
    [anon_sym_BQUOTE] = ACTIONS(1769),
    [anon_sym_debugger] = ACTIONS(1767),
    [anon_sym_symbol] = ACTIONS(1767),
    [anon_sym_AT] = ACTIONS(1769),
    [anon_sym_DASH] = ACTIONS(1767),
    [anon_sym_void] = ACTIONS(1767),
    [anon_sym_break] = ACTIONS(1767),
    [anon_sym_const] = ACTIONS(1767),
    [sym_super] = ACTIONS(1767),
    [anon_sym_return] = ACTIONS(1767),
    [anon_sym_private] = ACTIONS(1767),
    [anon_sym_get] = ACTIONS(1767),
    [anon_sym_RBRACE] = ACTIONS(1769),
    [anon_sym_interface] = ACTIONS(1767),
    [anon_sym_default] = ACTIONS(1767),
    [anon_sym_enum] = ACTIONS(1767),
    [anon_sym_delete] = ACTIONS(1767),
    [anon_sym_continue] = ACTIONS(1767),
    [anon_sym_DASH_DASH] = ACTIONS(1769),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_this] = ACTIONS(1767),
    [anon_sym_yield] = ACTIONS(1767),
    [sym_true] = ACTIONS(1767),
    [anon_sym_throw] = ACTIONS(1767),
    [anon_sym_protected] = ACTIONS(1767),
    [anon_sym_abstract] = ACTIONS(1767),
    [anon_sym_set] = ACTIONS(1767),
    [anon_sym_type] = ACTIONS(1767),
    [anon_sym_import] = ACTIONS(1767),
    [anon_sym_namespace] = ACTIONS(1767),
    [anon_sym_PLUS_PLUS] = ACTIONS(1769),
    [anon_sym_await] = ACTIONS(1767),
    [anon_sym_DQUOTE] = ACTIONS(1769),
    [anon_sym_else] = ACTIONS(1767),
    [anon_sym_BANG] = ACTIONS(1769),
    [anon_sym_for] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(1769),
    [sym_false] = ACTIONS(1767),
    [anon_sym_SEMI] = ACTIONS(1769),
    [anon_sym_case] = ACTIONS(1767),
    [anon_sym_module] = ACTIONS(1767),
    [anon_sym_number] = ACTIONS(1767),
    [anon_sym_class] = ACTIONS(1767),
    [anon_sym_declare] = ACTIONS(1767),
    [anon_sym_typeof] = ACTIONS(1767),
    [anon_sym_LBRACE] = ACTIONS(1769),
    [anon_sym_switch] = ACTIONS(1767),
    [anon_sym_LPAREN] = ACTIONS(1769),
    [sym_null] = ACTIONS(1767),
    [anon_sym_any] = ACTIONS(1767),
    [anon_sym_boolean] = ACTIONS(1767),
    [anon_sym_async] = ACTIONS(1767),
    [anon_sym_public] = ACTIONS(1767),
    [anon_sym_var] = ACTIONS(1767),
    [anon_sym_while] = ACTIONS(1767),
    [anon_sym_SQUOTE] = ACTIONS(1769),
    [anon_sym_try] = ACTIONS(1767),
    [anon_sym_LT] = ACTIONS(1769),
    [sym_number] = ACTIONS(1769),
    [anon_sym_SLASH] = ACTIONS(1767),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1767),
    [anon_sym_function] = ACTIONS(1767),
    [sym_undefined] = ACTIONS(1767),
    [anon_sym_new] = ACTIONS(1767),
    [ts_builtin_sym_end] = ACTIONS(1769),
    [anon_sym_let] = ACTIONS(1767),
    [anon_sym_PLUS] = ACTIONS(1767),
    [anon_sym_export] = ACTIONS(1767),
    [anon_sym_do] = ACTIONS(1767),
    [anon_sym_TILDE] = ACTIONS(1769),
    [anon_sym_with] = ACTIONS(1767),
  },
  [337] = {
    [sym_object_type] = STATE(603),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(476),
  },
  [338] = {
    [sym__property_name] = STATE(606),
    [sym_computed_property_name] = STATE(606),
    [sym__enum_member] = STATE(607),
    [sym_string] = STATE(606),
    [sym_enum_assignment] = STATE(607),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(1771),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [sym_number] = ACTIONS(1773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [339] = {
    [sym_identifier] = ACTIONS(1775),
    [anon_sym_BQUOTE] = ACTIONS(1777),
    [anon_sym_debugger] = ACTIONS(1775),
    [anon_sym_symbol] = ACTIONS(1775),
    [anon_sym_AT] = ACTIONS(1777),
    [anon_sym_DASH] = ACTIONS(1775),
    [anon_sym_void] = ACTIONS(1775),
    [anon_sym_break] = ACTIONS(1775),
    [anon_sym_const] = ACTIONS(1775),
    [sym_super] = ACTIONS(1775),
    [anon_sym_return] = ACTIONS(1775),
    [anon_sym_private] = ACTIONS(1775),
    [anon_sym_get] = ACTIONS(1775),
    [anon_sym_RBRACE] = ACTIONS(1777),
    [anon_sym_interface] = ACTIONS(1775),
    [anon_sym_default] = ACTIONS(1775),
    [anon_sym_enum] = ACTIONS(1775),
    [anon_sym_delete] = ACTIONS(1775),
    [anon_sym_continue] = ACTIONS(1775),
    [anon_sym_DASH_DASH] = ACTIONS(1777),
    [anon_sym_if] = ACTIONS(1775),
    [anon_sym_this] = ACTIONS(1775),
    [anon_sym_yield] = ACTIONS(1775),
    [sym_true] = ACTIONS(1775),
    [anon_sym_throw] = ACTIONS(1775),
    [anon_sym_protected] = ACTIONS(1775),
    [anon_sym_abstract] = ACTIONS(1775),
    [anon_sym_set] = ACTIONS(1775),
    [anon_sym_type] = ACTIONS(1775),
    [anon_sym_import] = ACTIONS(1775),
    [anon_sym_namespace] = ACTIONS(1775),
    [anon_sym_PLUS_PLUS] = ACTIONS(1777),
    [anon_sym_await] = ACTIONS(1775),
    [anon_sym_DQUOTE] = ACTIONS(1777),
    [anon_sym_else] = ACTIONS(1775),
    [anon_sym_BANG] = ACTIONS(1777),
    [anon_sym_for] = ACTIONS(1775),
    [anon_sym_LBRACK] = ACTIONS(1777),
    [sym_false] = ACTIONS(1775),
    [anon_sym_SEMI] = ACTIONS(1777),
    [anon_sym_case] = ACTIONS(1775),
    [anon_sym_module] = ACTIONS(1775),
    [anon_sym_number] = ACTIONS(1775),
    [anon_sym_class] = ACTIONS(1775),
    [anon_sym_declare] = ACTIONS(1775),
    [anon_sym_typeof] = ACTIONS(1775),
    [anon_sym_LBRACE] = ACTIONS(1777),
    [anon_sym_switch] = ACTIONS(1775),
    [anon_sym_LPAREN] = ACTIONS(1777),
    [sym_null] = ACTIONS(1775),
    [anon_sym_any] = ACTIONS(1775),
    [anon_sym_boolean] = ACTIONS(1775),
    [anon_sym_async] = ACTIONS(1775),
    [anon_sym_public] = ACTIONS(1775),
    [anon_sym_var] = ACTIONS(1775),
    [anon_sym_while] = ACTIONS(1775),
    [anon_sym_SQUOTE] = ACTIONS(1777),
    [anon_sym_try] = ACTIONS(1775),
    [anon_sym_LT] = ACTIONS(1777),
    [sym_number] = ACTIONS(1777),
    [anon_sym_SLASH] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1775),
    [anon_sym_function] = ACTIONS(1775),
    [sym_undefined] = ACTIONS(1775),
    [anon_sym_new] = ACTIONS(1775),
    [ts_builtin_sym_end] = ACTIONS(1777),
    [anon_sym_let] = ACTIONS(1775),
    [anon_sym_PLUS] = ACTIONS(1775),
    [anon_sym_export] = ACTIONS(1775),
    [anon_sym_do] = ACTIONS(1775),
    [anon_sym_TILDE] = ACTIONS(1777),
    [anon_sym_with] = ACTIONS(1775),
  },
  [340] = {
    [sym_identifier] = ACTIONS(1779),
    [anon_sym_BQUOTE] = ACTIONS(1781),
    [anon_sym_debugger] = ACTIONS(1779),
    [anon_sym_symbol] = ACTIONS(1779),
    [anon_sym_AT] = ACTIONS(1781),
    [anon_sym_DASH] = ACTIONS(1779),
    [anon_sym_void] = ACTIONS(1779),
    [anon_sym_break] = ACTIONS(1779),
    [anon_sym_const] = ACTIONS(1779),
    [sym_super] = ACTIONS(1779),
    [anon_sym_return] = ACTIONS(1779),
    [anon_sym_private] = ACTIONS(1779),
    [anon_sym_get] = ACTIONS(1779),
    [anon_sym_RBRACE] = ACTIONS(1781),
    [anon_sym_interface] = ACTIONS(1779),
    [anon_sym_default] = ACTIONS(1779),
    [anon_sym_enum] = ACTIONS(1779),
    [anon_sym_delete] = ACTIONS(1779),
    [anon_sym_continue] = ACTIONS(1779),
    [anon_sym_DASH_DASH] = ACTIONS(1781),
    [anon_sym_if] = ACTIONS(1779),
    [anon_sym_this] = ACTIONS(1779),
    [anon_sym_yield] = ACTIONS(1779),
    [sym_true] = ACTIONS(1779),
    [anon_sym_throw] = ACTIONS(1779),
    [anon_sym_protected] = ACTIONS(1779),
    [anon_sym_abstract] = ACTIONS(1779),
    [anon_sym_set] = ACTIONS(1779),
    [anon_sym_type] = ACTIONS(1779),
    [anon_sym_import] = ACTIONS(1779),
    [anon_sym_namespace] = ACTIONS(1779),
    [anon_sym_PLUS_PLUS] = ACTIONS(1781),
    [anon_sym_await] = ACTIONS(1779),
    [anon_sym_DQUOTE] = ACTIONS(1781),
    [anon_sym_else] = ACTIONS(1779),
    [anon_sym_BANG] = ACTIONS(1781),
    [anon_sym_for] = ACTIONS(1779),
    [anon_sym_LBRACK] = ACTIONS(1781),
    [sym_false] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1781),
    [anon_sym_case] = ACTIONS(1779),
    [anon_sym_module] = ACTIONS(1779),
    [anon_sym_number] = ACTIONS(1779),
    [anon_sym_class] = ACTIONS(1779),
    [anon_sym_declare] = ACTIONS(1779),
    [anon_sym_typeof] = ACTIONS(1779),
    [anon_sym_LBRACE] = ACTIONS(1781),
    [anon_sym_switch] = ACTIONS(1779),
    [anon_sym_LPAREN] = ACTIONS(1781),
    [sym_null] = ACTIONS(1779),
    [anon_sym_any] = ACTIONS(1779),
    [anon_sym_boolean] = ACTIONS(1779),
    [anon_sym_async] = ACTIONS(1779),
    [anon_sym_public] = ACTIONS(1779),
    [anon_sym_var] = ACTIONS(1779),
    [anon_sym_while] = ACTIONS(1779),
    [anon_sym_SQUOTE] = ACTIONS(1781),
    [anon_sym_try] = ACTIONS(1779),
    [anon_sym_LT] = ACTIONS(1781),
    [sym_number] = ACTIONS(1781),
    [anon_sym_SLASH] = ACTIONS(1779),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1779),
    [anon_sym_function] = ACTIONS(1779),
    [sym_undefined] = ACTIONS(1779),
    [anon_sym_new] = ACTIONS(1779),
    [ts_builtin_sym_end] = ACTIONS(1781),
    [anon_sym_let] = ACTIONS(1779),
    [anon_sym_PLUS] = ACTIONS(1779),
    [anon_sym_export] = ACTIONS(1779),
    [anon_sym_do] = ACTIONS(1779),
    [anon_sym_TILDE] = ACTIONS(1781),
    [anon_sym_with] = ACTIONS(1779),
  },
  [341] = {
    [sym_identifier] = ACTIONS(1783),
    [anon_sym_BQUOTE] = ACTIONS(1785),
    [anon_sym_debugger] = ACTIONS(1783),
    [anon_sym_symbol] = ACTIONS(1783),
    [anon_sym_AT] = ACTIONS(1785),
    [anon_sym_DASH] = ACTIONS(1783),
    [anon_sym_void] = ACTIONS(1783),
    [anon_sym_break] = ACTIONS(1783),
    [anon_sym_const] = ACTIONS(1783),
    [sym_super] = ACTIONS(1783),
    [anon_sym_return] = ACTIONS(1783),
    [anon_sym_private] = ACTIONS(1783),
    [anon_sym_get] = ACTIONS(1783),
    [anon_sym_RBRACE] = ACTIONS(1785),
    [anon_sym_interface] = ACTIONS(1783),
    [anon_sym_default] = ACTIONS(1783),
    [anon_sym_enum] = ACTIONS(1783),
    [anon_sym_delete] = ACTIONS(1783),
    [anon_sym_continue] = ACTIONS(1783),
    [anon_sym_DASH_DASH] = ACTIONS(1785),
    [anon_sym_if] = ACTIONS(1783),
    [anon_sym_this] = ACTIONS(1783),
    [anon_sym_yield] = ACTIONS(1783),
    [sym_true] = ACTIONS(1783),
    [anon_sym_throw] = ACTIONS(1783),
    [anon_sym_protected] = ACTIONS(1783),
    [anon_sym_abstract] = ACTIONS(1783),
    [anon_sym_set] = ACTIONS(1783),
    [anon_sym_type] = ACTIONS(1783),
    [anon_sym_import] = ACTIONS(1783),
    [anon_sym_namespace] = ACTIONS(1783),
    [anon_sym_PLUS_PLUS] = ACTIONS(1785),
    [anon_sym_await] = ACTIONS(1783),
    [anon_sym_DQUOTE] = ACTIONS(1785),
    [anon_sym_else] = ACTIONS(1787),
    [anon_sym_BANG] = ACTIONS(1785),
    [anon_sym_for] = ACTIONS(1783),
    [anon_sym_LBRACK] = ACTIONS(1785),
    [sym_false] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(1785),
    [anon_sym_case] = ACTIONS(1783),
    [anon_sym_module] = ACTIONS(1783),
    [anon_sym_number] = ACTIONS(1783),
    [anon_sym_class] = ACTIONS(1783),
    [anon_sym_declare] = ACTIONS(1783),
    [anon_sym_typeof] = ACTIONS(1783),
    [anon_sym_LBRACE] = ACTIONS(1785),
    [anon_sym_switch] = ACTIONS(1783),
    [anon_sym_LPAREN] = ACTIONS(1785),
    [sym_null] = ACTIONS(1783),
    [anon_sym_any] = ACTIONS(1783),
    [anon_sym_boolean] = ACTIONS(1783),
    [anon_sym_async] = ACTIONS(1783),
    [anon_sym_public] = ACTIONS(1783),
    [anon_sym_var] = ACTIONS(1783),
    [anon_sym_while] = ACTIONS(1783),
    [anon_sym_SQUOTE] = ACTIONS(1785),
    [anon_sym_try] = ACTIONS(1783),
    [anon_sym_LT] = ACTIONS(1785),
    [sym_number] = ACTIONS(1785),
    [anon_sym_SLASH] = ACTIONS(1783),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1783),
    [anon_sym_function] = ACTIONS(1783),
    [sym_undefined] = ACTIONS(1783),
    [anon_sym_new] = ACTIONS(1783),
    [ts_builtin_sym_end] = ACTIONS(1785),
    [anon_sym_let] = ACTIONS(1783),
    [anon_sym_PLUS] = ACTIONS(1783),
    [anon_sym_export] = ACTIONS(1783),
    [anon_sym_do] = ACTIONS(1783),
    [anon_sym_TILDE] = ACTIONS(1785),
    [anon_sym_with] = ACTIONS(1783),
  },
  [342] = {
    [sym_identifier] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1791),
    [anon_sym_debugger] = ACTIONS(1789),
    [anon_sym_symbol] = ACTIONS(1789),
    [anon_sym_AT] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1789),
    [anon_sym_void] = ACTIONS(1789),
    [anon_sym_break] = ACTIONS(1789),
    [anon_sym_const] = ACTIONS(1789),
    [sym_super] = ACTIONS(1789),
    [anon_sym_return] = ACTIONS(1789),
    [anon_sym_private] = ACTIONS(1789),
    [anon_sym_get] = ACTIONS(1789),
    [anon_sym_RBRACE] = ACTIONS(1791),
    [anon_sym_interface] = ACTIONS(1789),
    [anon_sym_default] = ACTIONS(1789),
    [anon_sym_enum] = ACTIONS(1789),
    [anon_sym_delete] = ACTIONS(1789),
    [anon_sym_continue] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1791),
    [anon_sym_if] = ACTIONS(1789),
    [anon_sym_this] = ACTIONS(1789),
    [anon_sym_yield] = ACTIONS(1789),
    [sym_true] = ACTIONS(1789),
    [anon_sym_throw] = ACTIONS(1789),
    [anon_sym_protected] = ACTIONS(1789),
    [anon_sym_abstract] = ACTIONS(1789),
    [anon_sym_set] = ACTIONS(1789),
    [anon_sym_type] = ACTIONS(1789),
    [anon_sym_import] = ACTIONS(1789),
    [anon_sym_namespace] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1791),
    [anon_sym_await] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1791),
    [anon_sym_else] = ACTIONS(1789),
    [anon_sym_BANG] = ACTIONS(1791),
    [anon_sym_for] = ACTIONS(1789),
    [anon_sym_LBRACK] = ACTIONS(1791),
    [sym_false] = ACTIONS(1789),
    [anon_sym_SEMI] = ACTIONS(1791),
    [anon_sym_case] = ACTIONS(1789),
    [anon_sym_module] = ACTIONS(1789),
    [anon_sym_number] = ACTIONS(1789),
    [anon_sym_class] = ACTIONS(1789),
    [anon_sym_declare] = ACTIONS(1789),
    [anon_sym_typeof] = ACTIONS(1789),
    [anon_sym_LBRACE] = ACTIONS(1791),
    [anon_sym_switch] = ACTIONS(1789),
    [anon_sym_LPAREN] = ACTIONS(1791),
    [sym_null] = ACTIONS(1789),
    [anon_sym_any] = ACTIONS(1789),
    [anon_sym_boolean] = ACTIONS(1789),
    [anon_sym_async] = ACTIONS(1789),
    [anon_sym_public] = ACTIONS(1789),
    [anon_sym_var] = ACTIONS(1789),
    [anon_sym_while] = ACTIONS(1789),
    [anon_sym_SQUOTE] = ACTIONS(1791),
    [anon_sym_try] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1791),
    [sym_number] = ACTIONS(1791),
    [anon_sym_SLASH] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1789),
    [anon_sym_function] = ACTIONS(1789),
    [sym_undefined] = ACTIONS(1789),
    [anon_sym_new] = ACTIONS(1789),
    [ts_builtin_sym_end] = ACTIONS(1791),
    [anon_sym_let] = ACTIONS(1789),
    [anon_sym_PLUS] = ACTIONS(1789),
    [anon_sym_export] = ACTIONS(1789),
    [anon_sym_do] = ACTIONS(1789),
    [anon_sym_TILDE] = ACTIONS(1791),
    [anon_sym_with] = ACTIONS(1789),
  },
  [343] = {
    [sym_class_heritage] = STATE(609),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_type_parameters] = STATE(610),
    [sym_class_body] = STATE(611),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1793),
  },
  [344] = {
    [sym__type] = STATE(612),
    [sym_constructor_type] = STATE(612),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_function_type] = STATE(612),
    [sym_nested_identifier] = STATE(2393),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_array_type] = STATE(1496),
    [sym_tuple_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(612),
    [sym_intersection_type] = STATE(612),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_this] = ACTIONS(1823),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [345] = {
    [anon_sym_EQ] = ACTIONS(1829),
    [sym_comment] = ACTIONS(3),
  },
  [346] = {
    [sym_namespace_import] = STATE(614),
    [sym_named_imports] = STATE(614),
    [sym_comment] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(781),
    [anon_sym_LBRACE] = ACTIONS(240),
  },
  [347] = {
    [sym_nested_identifier] = STATE(616),
    [sym_identifier] = ACTIONS(1831),
    [anon_sym_require] = ACTIONS(1833),
    [sym_comment] = ACTIONS(3),
  },
  [348] = {
    [anon_sym_EQ] = ACTIONS(1835),
    [anon_sym_COMMA] = ACTIONS(777),
    [anon_sym_from] = ACTIONS(779),
    [sym_comment] = ACTIONS(3),
  },
  [349] = {
    [sym__automatic_semicolon] = ACTIONS(1837),
    [anon_sym_SEMI] = ACTIONS(1837),
    [sym_comment] = ACTIONS(3),
  },
  [350] = {
    [sym__from_clause] = STATE(619),
    [anon_sym_from] = ACTIONS(797),
    [sym_comment] = ACTIONS(3),
  },
  [351] = {
    [sym_identifier] = ACTIONS(1839),
    [sym_comment] = ACTIONS(3),
  },
  [352] = {
    [anon_sym_RBRACE] = ACTIONS(1841),
    [anon_sym_COMMA] = ACTIONS(1841),
    [anon_sym_as] = ACTIONS(1843),
    [sym_comment] = ACTIONS(3),
  },
  [353] = {
    [anon_sym_from] = ACTIONS(1845),
    [sym_comment] = ACTIONS(3),
  },
  [354] = {
    [sym_identifier] = ACTIONS(1847),
    [sym_comment] = ACTIONS(3),
  },
  [355] = {
    [anon_sym_RBRACE] = ACTIONS(1849),
    [sym_comment] = ACTIONS(3),
  },
  [356] = {
    [aux_sym_named_imports_repeat1] = STATE(626),
    [anon_sym_COMMA] = ACTIONS(1851),
    [anon_sym_RBRACE] = ACTIONS(1853),
    [sym_comment] = ACTIONS(3),
  },
  [357] = {
    [sym_identifier] = ACTIONS(1855),
    [anon_sym_BQUOTE] = ACTIONS(1857),
    [anon_sym_debugger] = ACTIONS(1855),
    [anon_sym_symbol] = ACTIONS(1855),
    [anon_sym_AT] = ACTIONS(1857),
    [anon_sym_DASH] = ACTIONS(1855),
    [anon_sym_void] = ACTIONS(1855),
    [anon_sym_break] = ACTIONS(1855),
    [anon_sym_const] = ACTIONS(1855),
    [sym_super] = ACTIONS(1855),
    [anon_sym_return] = ACTIONS(1855),
    [anon_sym_private] = ACTIONS(1855),
    [anon_sym_get] = ACTIONS(1855),
    [anon_sym_RBRACE] = ACTIONS(1857),
    [anon_sym_interface] = ACTIONS(1855),
    [anon_sym_default] = ACTIONS(1855),
    [anon_sym_enum] = ACTIONS(1855),
    [anon_sym_delete] = ACTIONS(1855),
    [anon_sym_continue] = ACTIONS(1855),
    [anon_sym_DASH_DASH] = ACTIONS(1857),
    [anon_sym_if] = ACTIONS(1855),
    [anon_sym_this] = ACTIONS(1855),
    [anon_sym_yield] = ACTIONS(1855),
    [sym_true] = ACTIONS(1855),
    [anon_sym_throw] = ACTIONS(1855),
    [anon_sym_protected] = ACTIONS(1855),
    [anon_sym_abstract] = ACTIONS(1855),
    [anon_sym_set] = ACTIONS(1855),
    [anon_sym_type] = ACTIONS(1855),
    [anon_sym_import] = ACTIONS(1855),
    [anon_sym_namespace] = ACTIONS(1855),
    [anon_sym_PLUS_PLUS] = ACTIONS(1857),
    [anon_sym_await] = ACTIONS(1855),
    [anon_sym_DQUOTE] = ACTIONS(1857),
    [anon_sym_else] = ACTIONS(1855),
    [anon_sym_BANG] = ACTIONS(1857),
    [anon_sym_for] = ACTIONS(1855),
    [anon_sym_LBRACK] = ACTIONS(1857),
    [sym_false] = ACTIONS(1855),
    [anon_sym_SEMI] = ACTIONS(1857),
    [anon_sym_case] = ACTIONS(1855),
    [anon_sym_module] = ACTIONS(1855),
    [anon_sym_number] = ACTIONS(1855),
    [anon_sym_class] = ACTIONS(1855),
    [anon_sym_declare] = ACTIONS(1855),
    [anon_sym_typeof] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(1857),
    [anon_sym_switch] = ACTIONS(1855),
    [anon_sym_LPAREN] = ACTIONS(1857),
    [sym_null] = ACTIONS(1855),
    [anon_sym_any] = ACTIONS(1855),
    [anon_sym_boolean] = ACTIONS(1855),
    [anon_sym_async] = ACTIONS(1855),
    [anon_sym_public] = ACTIONS(1855),
    [anon_sym_var] = ACTIONS(1855),
    [anon_sym_while] = ACTIONS(1855),
    [anon_sym_SQUOTE] = ACTIONS(1857),
    [anon_sym_try] = ACTIONS(1855),
    [anon_sym_LT] = ACTIONS(1857),
    [sym_number] = ACTIONS(1857),
    [anon_sym_SLASH] = ACTIONS(1855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1855),
    [anon_sym_function] = ACTIONS(1855),
    [sym_undefined] = ACTIONS(1855),
    [anon_sym_new] = ACTIONS(1855),
    [ts_builtin_sym_end] = ACTIONS(1857),
    [anon_sym_let] = ACTIONS(1855),
    [anon_sym_PLUS] = ACTIONS(1855),
    [anon_sym_export] = ACTIONS(1855),
    [anon_sym_do] = ACTIONS(1855),
    [anon_sym_TILDE] = ACTIONS(1857),
    [anon_sym_with] = ACTIONS(1855),
  },
  [358] = {
    [sym_string] = STATE(627),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(87),
  },
  [359] = {
    [sym_identifier] = ACTIONS(1859),
    [sym_comment] = ACTIONS(3),
  },
  [360] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1861),
    [sym__automatic_semicolon] = ACTIONS(1861),
    [anon_sym_BQUOTE] = ACTIONS(1861),
    [anon_sym_symbol] = ACTIONS(1863),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_GT_GT_GT] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_BANG_EQ] = ACTIONS(1863),
    [anon_sym_return] = ACTIONS(1863),
    [anon_sym_RBRACE] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [anon_sym_interface] = ACTIONS(1863),
    [anon_sym_as] = ACTIONS(1863),
    [anon_sym_delete] = ACTIONS(1863),
    [anon_sym_if] = ACTIONS(1863),
    [anon_sym_instanceof] = ACTIONS(1863),
    [anon_sym_yield] = ACTIONS(1863),
    [sym_true] = ACTIONS(1863),
    [anon_sym_protected] = ACTIONS(1863),
    [anon_sym_DOT] = ACTIONS(1863),
    [anon_sym_set] = ACTIONS(1863),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1861),
    [anon_sym_import] = ACTIONS(1863),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DQUOTE] = ACTIONS(1861),
    [anon_sym_for] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(1861),
    [anon_sym_number] = ACTIONS(1863),
    [anon_sym_typeof] = ACTIONS(1863),
    [anon_sym_LT_LT] = ACTIONS(1861),
    [anon_sym_LBRACE] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1861),
    [anon_sym_switch] = ACTIONS(1863),
    [anon_sym_LT_EQ] = ACTIONS(1861),
    [sym_null] = ACTIONS(1863),
    [anon_sym_any] = ACTIONS(1863),
    [anon_sym_async] = ACTIONS(1863),
    [anon_sym_public] = ACTIONS(1863),
    [anon_sym_var] = ACTIONS(1863),
    [anon_sym_QMARK] = ACTIONS(1861),
    [anon_sym_while] = ACTIONS(1863),
    [anon_sym_SQUOTE] = ACTIONS(1861),
    [anon_sym_SLASH] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1863),
    [anon_sym_new] = ACTIONS(1863),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_export] = ACTIONS(1863),
    [anon_sym_GT_GT] = ACTIONS(1863),
    [anon_sym_with] = ACTIONS(1863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1861),
    [sym_identifier] = ACTIONS(1863),
    [anon_sym_debugger] = ACTIONS(1863),
    [anon_sym_AT] = ACTIONS(1861),
    [anon_sym_COMMA] = ACTIONS(1861),
    [anon_sym_DASH] = ACTIONS(1863),
    [anon_sym_void] = ACTIONS(1863),
    [anon_sym_const] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1861),
    [sym_super] = ACTIONS(1863),
    [anon_sym_private] = ACTIONS(1863),
    [anon_sym_get] = ACTIONS(1863),
    [anon_sym_default] = ACTIONS(1863),
    [anon_sym_enum] = ACTIONS(1863),
    [anon_sym_continue] = ACTIONS(1863),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_this] = ACTIONS(1863),
    [anon_sym_throw] = ACTIONS(1863),
    [anon_sym_abstract] = ACTIONS(1863),
    [anon_sym_type] = ACTIONS(1863),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_namespace] = ACTIONS(1863),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_else] = ACTIONS(1863),
    [anon_sym_BANG] = ACTIONS(1863),
    [anon_sym_LBRACK] = ACTIONS(1861),
    [sym_false] = ACTIONS(1863),
    [anon_sym_case] = ACTIONS(1863),
    [anon_sym_module] = ACTIONS(1863),
    [anon_sym_class] = ACTIONS(1863),
    [anon_sym_declare] = ACTIONS(1863),
    [anon_sym_LPAREN] = ACTIONS(1861),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_boolean] = ACTIONS(1863),
    [anon_sym_AMP] = ACTIONS(1863),
    [anon_sym_PIPE_PIPE] = ACTIONS(1861),
    [anon_sym_try] = ACTIONS(1863),
    [anon_sym_EQ_EQ] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1863),
    [sym_number] = ACTIONS(1861),
    [ts_builtin_sym_end] = ACTIONS(1861),
    [anon_sym_function] = ACTIONS(1863),
    [sym_undefined] = ACTIONS(1863),
    [anon_sym_let] = ACTIONS(1863),
    [anon_sym_PLUS] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(1863),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_in] = ACTIONS(1863),
  },
  [361] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1865),
    [sym__automatic_semicolon] = ACTIONS(1865),
    [anon_sym_BQUOTE] = ACTIONS(1865),
    [anon_sym_PIPE] = ACTIONS(1867),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_DASH] = ACTIONS(1867),
    [anon_sym_STAR] = ACTIONS(1867),
    [anon_sym_GT_GT_GT] = ACTIONS(1865),
    [anon_sym_BANG_EQ] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1865),
    [anon_sym_RBRACE] = ACTIONS(1865),
    [anon_sym_PERCENT] = ACTIONS(1865),
    [anon_sym_as] = ACTIONS(1865),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_instanceof] = ACTIONS(1865),
    [anon_sym_COLON] = ACTIONS(1865),
    [anon_sym_DOT] = ACTIONS(1865),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1865),
    [anon_sym_STAR_STAR] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_else] = ACTIONS(1865),
    [anon_sym_BANG] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_LT_LT] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1865),
    [anon_sym_AMP_AMP] = ACTIONS(1865),
    [anon_sym_LT_EQ] = ACTIONS(1865),
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_AMP] = ACTIONS(1867),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_PIPE_PIPE] = ACTIONS(1865),
    [anon_sym_while] = ACTIONS(1865),
    [anon_sym_EQ_EQ] = ACTIONS(1867),
    [anon_sym_RPAREN] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_SLASH] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1865),
    [anon_sym_PLUS] = ACTIONS(1867),
    [anon_sym_GT_GT] = ACTIONS(1867),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1865),
    [anon_sym_in] = ACTIONS(1867),
  },
  [362] = {
    [aux_sym_string_repeat1] = STATE(362),
    [sym_escape_sequence] = ACTIONS(1869),
    [aux_sym_string_token1] = ACTIONS(1869),
    [anon_sym_DQUOTE] = ACTIONS(1872),
    [sym_comment] = ACTIONS(256),
  },
  [363] = {
    [sym_array] = STATE(631),
    [sym_object] = STATE(632),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1874),
    [anon_sym_var] = ACTIONS(1876),
    [anon_sym_const] = ACTIONS(1876),
    [anon_sym_let] = ACTIONS(1876),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(185),
  },
  [364] = {
    [sym__initializer] = STATE(72),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(113),
    [anon_sym_AMP_EQ] = ACTIONS(113),
    [anon_sym_PLUS_EQ] = ACTIONS(113),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(113),
    [anon_sym_PIPE_EQ] = ACTIONS(113),
    [anon_sym_DASH_EQ] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(1878),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(113),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(113),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1880),
  },
  [365] = {
    [sym_variable_declarator] = STATE(96),
    [sym_array] = STATE(636),
    [sym_object] = STATE(637),
    [sym_identifier] = ACTIONS(1882),
    [anon_sym_LBRACK] = ACTIONS(1884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1886),
  },
  [366] = {
    [sym_variable_declarator] = STATE(211),
    [sym_array] = STATE(636),
    [sym_object] = STATE(637),
    [sym_identifier] = ACTIONS(1882),
    [anon_sym_LBRACK] = ACTIONS(1884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1886),
  },
  [367] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_arrow_function] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(638),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_object] = STATE(57),
    [sym_generator_function] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_update_expression] = STATE(59),
    [sym_meta_property] = STATE(59),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_function] = STATE(89),
    [sym_await_expression] = STATE(59),
    [sym_sequence_expression] = STATE(62),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(638),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_anonymous_class] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_class] = STATE(59),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [368] = {
    [sym__initializer] = STATE(267),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(1888),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1890),
  },
  [369] = {
    [sym__initializer] = STATE(286),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(1892),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1894),
  },
  [370] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1896),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1896),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_RBRACE] = ACTIONS(1896),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(1896),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [371] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1898),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1898),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(1898),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [372] = {
    [anon_sym_RPAREN] = ACTIONS(1898),
    [anon_sym_COMMA] = ACTIONS(1898),
    [anon_sym_RBRACK] = ACTIONS(1898),
    [sym_comment] = ACTIONS(3),
  },
  [373] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1900),
    [sym__automatic_semicolon] = ACTIONS(1900),
    [anon_sym_BQUOTE] = ACTIONS(1900),
    [anon_sym_PIPE] = ACTIONS(1902),
    [anon_sym_COMMA] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1902),
    [anon_sym_STAR] = ACTIONS(1902),
    [anon_sym_GT_GT_GT] = ACTIONS(1900),
    [anon_sym_EQ] = ACTIONS(1902),
    [anon_sym_BANG_EQ] = ACTIONS(1902),
    [anon_sym_GT_EQ] = ACTIONS(1900),
    [anon_sym_RBRACE] = ACTIONS(1900),
    [anon_sym_PERCENT] = ACTIONS(1900),
    [anon_sym_as] = ACTIONS(1900),
    [anon_sym_DASH_DASH] = ACTIONS(1900),
    [anon_sym_instanceof] = ACTIONS(1900),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_STAR_STAR] = ACTIONS(1900),
    [anon_sym_PLUS_PLUS] = ACTIONS(1900),
    [anon_sym_BANG] = ACTIONS(1902),
    [anon_sym_LBRACK] = ACTIONS(1900),
    [anon_sym_SEMI] = ACTIONS(1900),
    [anon_sym_LT_LT] = ACTIONS(1900),
    [anon_sym_AMP_AMP] = ACTIONS(1900),
    [anon_sym_of] = ACTIONS(1900),
    [anon_sym_LT_EQ] = ACTIONS(1900),
    [anon_sym_LPAREN] = ACTIONS(1900),
    [anon_sym_GT] = ACTIONS(1902),
    [anon_sym_AMP] = ACTIONS(1902),
    [anon_sym_QMARK] = ACTIONS(1900),
    [anon_sym_PIPE_PIPE] = ACTIONS(1900),
    [anon_sym_EQ_EQ] = ACTIONS(1902),
    [anon_sym_RPAREN] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_SLASH] = ACTIONS(1902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1900),
    [anon_sym_PLUS] = ACTIONS(1902),
    [anon_sym_GT_GT] = ACTIONS(1902),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1900),
    [anon_sym_in] = ACTIONS(1902),
  },
  [374] = {
    [aux_sym_array_repeat1] = STATE(375),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_RBRACK] = ACTIONS(1904),
    [sym_comment] = ACTIONS(3),
  },
  [375] = {
    [aux_sym_array_repeat1] = STATE(375),
    [anon_sym_RPAREN] = ACTIONS(1898),
    [anon_sym_COMMA] = ACTIONS(1906),
    [anon_sym_RBRACK] = ACTIONS(1898),
    [sym_comment] = ACTIONS(3),
  },
  [376] = {
    [sym__initializer] = STATE(1211),
    [sym_type_arguments] = STATE(497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1909),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1909),
    [anon_sym_AMP_EQ] = ACTIONS(1909),
    [anon_sym_PLUS_EQ] = ACTIONS(1909),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(1911),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(1911),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1913),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(1909),
    [anon_sym_STAR_EQ] = ACTIONS(1909),
    [anon_sym_PIPE_EQ] = ACTIONS(1909),
    [anon_sym_DASH_EQ] = ACTIONS(1909),
    [anon_sym_EQ_GT] = ACTIONS(1915),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1909),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1909),
    [anon_sym_GT_GT_EQ] = ACTIONS(1909),
    [anon_sym_DOT] = ACTIONS(1920),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_implements] = ACTIONS(1911),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1922),
  },
  [377] = {
    [aux_sym_extends_clause_repeat1] = STATE(646),
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1922),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_COMMA] = ACTIONS(1930),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_LBRACE] = ACTIONS(1934),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_BANG_EQ] = ACTIONS(1922),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_implements] = ACTIONS(1934),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1924),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [378] = {
    [sym_type_arguments] = STATE(537),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1950),
    [anon_sym_implements] = ACTIONS(1950),
    [anon_sym_LT] = ACTIONS(1212),
    [anon_sym_COMMA] = ACTIONS(1950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1952),
  },
  [379] = {
    [aux_sym_extends_clause_repeat1] = STATE(646),
    [anon_sym_implements] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(1930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1934),
  },
  [380] = {
    [aux_sym_implements_clause_repeat1] = STATE(648),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(1954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1956),
  },
  [381] = {
    [sym_class_body] = STATE(649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(917),
  },
  [382] = {
    [sym_class_heritage] = STATE(650),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(649),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(917),
  },
  [383] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1958),
    [sym__automatic_semicolon] = ACTIONS(1958),
    [anon_sym_BQUOTE] = ACTIONS(1958),
    [anon_sym_symbol] = ACTIONS(1960),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_GT_GT_GT] = ACTIONS(1958),
    [anon_sym_break] = ACTIONS(1960),
    [anon_sym_BANG_EQ] = ACTIONS(1960),
    [anon_sym_return] = ACTIONS(1960),
    [anon_sym_RBRACE] = ACTIONS(1958),
    [anon_sym_PERCENT] = ACTIONS(1958),
    [anon_sym_interface] = ACTIONS(1960),
    [anon_sym_as] = ACTIONS(1960),
    [anon_sym_delete] = ACTIONS(1960),
    [anon_sym_if] = ACTIONS(1960),
    [anon_sym_instanceof] = ACTIONS(1960),
    [anon_sym_yield] = ACTIONS(1960),
    [sym_true] = ACTIONS(1960),
    [anon_sym_protected] = ACTIONS(1960),
    [anon_sym_DOT] = ACTIONS(1960),
    [anon_sym_set] = ACTIONS(1960),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1958),
    [anon_sym_import] = ACTIONS(1960),
    [anon_sym_await] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1958),
    [anon_sym_for] = ACTIONS(1960),
    [anon_sym_SEMI] = ACTIONS(1958),
    [anon_sym_number] = ACTIONS(1960),
    [anon_sym_typeof] = ACTIONS(1960),
    [anon_sym_LT_LT] = ACTIONS(1958),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_AMP_AMP] = ACTIONS(1958),
    [anon_sym_switch] = ACTIONS(1960),
    [anon_sym_LT_EQ] = ACTIONS(1958),
    [sym_null] = ACTIONS(1960),
    [anon_sym_any] = ACTIONS(1960),
    [anon_sym_async] = ACTIONS(1960),
    [anon_sym_public] = ACTIONS(1960),
    [anon_sym_var] = ACTIONS(1960),
    [anon_sym_QMARK] = ACTIONS(1958),
    [anon_sym_while] = ACTIONS(1960),
    [anon_sym_SQUOTE] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1960),
    [anon_sym_new] = ACTIONS(1960),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_export] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [anon_sym_with] = ACTIONS(1960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1958),
    [sym_identifier] = ACTIONS(1960),
    [anon_sym_debugger] = ACTIONS(1960),
    [anon_sym_AT] = ACTIONS(1958),
    [anon_sym_COMMA] = ACTIONS(1958),
    [anon_sym_DASH] = ACTIONS(1960),
    [anon_sym_void] = ACTIONS(1960),
    [anon_sym_const] = ACTIONS(1960),
    [anon_sym_GT_EQ] = ACTIONS(1958),
    [sym_super] = ACTIONS(1960),
    [anon_sym_private] = ACTIONS(1960),
    [anon_sym_get] = ACTIONS(1960),
    [anon_sym_default] = ACTIONS(1960),
    [anon_sym_enum] = ACTIONS(1960),
    [anon_sym_continue] = ACTIONS(1960),
    [anon_sym_DASH_DASH] = ACTIONS(1958),
    [anon_sym_this] = ACTIONS(1960),
    [anon_sym_throw] = ACTIONS(1960),
    [anon_sym_abstract] = ACTIONS(1960),
    [anon_sym_type] = ACTIONS(1960),
    [anon_sym_STAR_STAR] = ACTIONS(1958),
    [anon_sym_namespace] = ACTIONS(1960),
    [anon_sym_PLUS_PLUS] = ACTIONS(1958),
    [anon_sym_else] = ACTIONS(1960),
    [anon_sym_BANG] = ACTIONS(1960),
    [anon_sym_LBRACK] = ACTIONS(1958),
    [sym_false] = ACTIONS(1960),
    [anon_sym_case] = ACTIONS(1960),
    [anon_sym_module] = ACTIONS(1960),
    [anon_sym_class] = ACTIONS(1960),
    [anon_sym_declare] = ACTIONS(1960),
    [anon_sym_LPAREN] = ACTIONS(1958),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_boolean] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_PIPE_PIPE] = ACTIONS(1958),
    [anon_sym_try] = ACTIONS(1960),
    [anon_sym_EQ_EQ] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1960),
    [sym_number] = ACTIONS(1958),
    [ts_builtin_sym_end] = ACTIONS(1958),
    [anon_sym_function] = ACTIONS(1960),
    [sym_undefined] = ACTIONS(1960),
    [anon_sym_let] = ACTIONS(1960),
    [anon_sym_PLUS] = ACTIONS(1960),
    [anon_sym_do] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1958),
    [anon_sym_in] = ACTIONS(1960),
  },
  [384] = {
    [sym__automatic_semicolon] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(986),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_BANG] = ACTIONS(986),
  },
  [385] = {
    [sym_new_expression] = STATE(656),
    [sym_augmented_assignment_expression] = STATE(656),
    [sym_unary_expression] = STATE(656),
    [sym_regex] = STATE(656),
    [sym_call_signature] = STATE(2379),
    [sym_yield_expression] = STATE(656),
    [sym_as_expression] = STATE(656),
    [sym_internal_module] = STATE(656),
    [sym_arrow_function] = STATE(656),
    [sym_member_expression] = STATE(2521),
    [sym_mapped_type] = STATE(657),
    [sym_string] = STATE(656),
    [sym_type_parameters] = STATE(55),
    [sym_object] = STATE(2522),
    [sym_nested_type_identifier] = STATE(658),
    [sym_generator_function] = STATE(656),
    [sym_subscript_expression] = STATE(2521),
    [sym_ternary_expression] = STATE(656),
    [sym_template_string] = STATE(656),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_update_expression] = STATE(656),
    [sym_meta_property] = STATE(656),
    [sym__expression] = STATE(656),
    [sym_non_null_expression] = STATE(656),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(656),
    [sym_this] = STATE(656),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(656),
    [sym_call_expression] = STATE(656),
    [sym_assignment_expression] = STATE(656),
    [sym_binary_expression] = STATE(656),
    [sym_type_arguments] = STATE(2523),
    [sym_parenthesized_expression] = STATE(656),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(656),
    [sym_class] = STATE(656),
    [sym_identifier] = ACTIONS(1962),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1964),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1966),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1964),
    [anon_sym_get] = ACTIONS(1964),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(1968),
    [anon_sym_protected] = ACTIONS(1964),
    [anon_sym_set] = ACTIONS(1964),
    [anon_sym_type] = ACTIONS(1964),
    [anon_sym_import] = ACTIONS(1964),
    [anon_sym_namespace] = ACTIONS(1970),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1968),
    [anon_sym_module] = ACTIONS(1964),
    [anon_sym_number] = ACTIONS(1964),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1964),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(1968),
    [anon_sym_any] = ACTIONS(1964),
    [anon_sym_boolean] = ACTIONS(1964),
    [anon_sym_async] = ACTIONS(1972),
    [anon_sym_public] = ACTIONS(1964),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1974),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1964),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1968),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1964),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [386] = {
    [sym_string] = STATE(659),
    [sym__property_name] = STATE(659),
    [sym_computed_property_name] = STATE(659),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [387] = {
    [sym__automatic_semicolon] = ACTIONS(986),
    [anon_sym_LBRACK] = ACTIONS(1014),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_symbol] = ACTIONS(1012),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_EQ] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_abstract] = ACTIONS(1012),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_namespace] = ACTIONS(1012),
    [sym_readonly] = ACTIONS(1012),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [anon_sym_BANG] = ACTIONS(986),
  },
  [388] = {
    [sym_string] = STATE(659),
    [sym__property_name] = STATE(659),
    [sym_computed_property_name] = STATE(659),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(1978),
    [anon_sym_EQ] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1980),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1980),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_BANG] = ACTIONS(986),
  },
  [389] = {
    [sym_string] = STATE(659),
    [sym__property_name] = STATE(659),
    [sym_computed_property_name] = STATE(659),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_EQ] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_BANG] = ACTIONS(986),
  },
  [390] = {
    [sym_string] = STATE(664),
    [sym__property_name] = STATE(664),
    [sym_computed_property_name] = STATE(664),
    [anon_sym_get] = ACTIONS(1982),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1986),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1982),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [sym_readonly] = ACTIONS(1990),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [391] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1992),
    [sym__automatic_semicolon] = ACTIONS(1992),
    [anon_sym_BQUOTE] = ACTIONS(1992),
    [anon_sym_PIPE] = ACTIONS(1994),
    [anon_sym_COMMA] = ACTIONS(1992),
    [anon_sym_DASH] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_GT_GT_GT] = ACTIONS(1992),
    [anon_sym_BANG_EQ] = ACTIONS(1994),
    [anon_sym_GT_EQ] = ACTIONS(1992),
    [anon_sym_RBRACE] = ACTIONS(1992),
    [anon_sym_PERCENT] = ACTIONS(1992),
    [anon_sym_as] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(1992),
    [anon_sym_instanceof] = ACTIONS(1992),
    [anon_sym_DOT] = ACTIONS(1992),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1992),
    [anon_sym_STAR_STAR] = ACTIONS(1992),
    [anon_sym_PLUS_PLUS] = ACTIONS(1992),
    [anon_sym_else] = ACTIONS(1992),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_LBRACK] = ACTIONS(1992),
    [anon_sym_SEMI] = ACTIONS(1992),
    [anon_sym_LT_LT] = ACTIONS(1992),
    [anon_sym_AMP_AMP] = ACTIONS(1992),
    [anon_sym_LT_EQ] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1992),
    [anon_sym_GT] = ACTIONS(1994),
    [anon_sym_AMP] = ACTIONS(1994),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_PIPE_PIPE] = ACTIONS(1992),
    [anon_sym_while] = ACTIONS(1992),
    [anon_sym_EQ_EQ] = ACTIONS(1994),
    [anon_sym_RPAREN] = ACTIONS(1992),
    [anon_sym_LT] = ACTIONS(1994),
    [anon_sym_SLASH] = ACTIONS(1994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1994),
    [anon_sym_GT_GT] = ACTIONS(1994),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1992),
    [anon_sym_in] = ACTIONS(1994),
  },
  [392] = {
    [sym_string] = STATE(668),
    [sym__property_name] = STATE(668),
    [sym_computed_property_name] = STATE(668),
    [anon_sym_get] = ACTIONS(1996),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(919),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(1998),
    [anon_sym_STAR] = ACTIONS(2000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1996),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [sym_readonly] = ACTIONS(2002),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [393] = {
    [sym_string] = STATE(664),
    [sym__property_name] = STATE(664),
    [sym_computed_property_name] = STATE(664),
    [anon_sym_get] = ACTIONS(1982),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_abstract] = ACTIONS(2002),
    [anon_sym_set] = ACTIONS(1982),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(1986),
  },
  [394] = {
    [sym__automatic_semicolon] = ACTIONS(2004),
    [anon_sym_SEMI] = ACTIONS(2004),
    [anon_sym_COMMA] = ACTIONS(2004),
    [sym_comment] = ACTIONS(3),
  },
  [395] = {
    [sym_call_signature] = STATE(672),
    [sym__initializer] = STATE(673),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym_type_annotation] = STATE(674),
    [sym__automatic_semicolon] = ACTIONS(2006),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(2006),
    [anon_sym_QMARK] = ACTIONS(2008),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(2006),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(2010),
  },
  [396] = {
    [sym_string] = STATE(664),
    [sym__property_name] = STATE(664),
    [sym_computed_property_name] = STATE(664),
    [anon_sym_get] = ACTIONS(1982),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(1986),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_abstract] = ACTIONS(2012),
    [anon_sym_set] = ACTIONS(1982),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [sym_readonly] = ACTIONS(2014),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(2016),
    [anon_sym_private] = ACTIONS(919),
  },
  [397] = {
    [sym_public_field_definition] = STATE(394),
    [sym__property_name] = STATE(395),
    [sym_method_signature] = STATE(394),
    [sym_abstract_method_signature] = STATE(394),
    [aux_sym_class_body_repeat1] = STATE(679),
    [sym_index_signature] = STATE(394),
    [sym_method_definition] = STATE(398),
    [sym_decorator] = STATE(679),
    [sym_accessibility_modifier] = STATE(396),
    [sym_computed_property_name] = STATE(395),
    [sym_string] = STATE(395),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(923),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(931),
    [anon_sym_RBRACE] = ACTIONS(2018),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [sym_number] = ACTIONS(937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_abstract] = ACTIONS(939),
    [anon_sym_set] = ACTIONS(931),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [sym_readonly] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [398] = {
    [sym__automatic_semicolon] = ACTIONS(2004),
    [anon_sym_LBRACK] = ACTIONS(2020),
    [sym_identifier] = ACTIONS(2022),
    [anon_sym_SEMI] = ACTIONS(2004),
    [anon_sym_module] = ACTIONS(2022),
    [anon_sym_symbol] = ACTIONS(2022),
    [anon_sym_number] = ACTIONS(2022),
    [anon_sym_AT] = ACTIONS(2020),
    [anon_sym_declare] = ACTIONS(2022),
    [anon_sym_STAR] = ACTIONS(2020),
    [anon_sym_void] = ACTIONS(2022),
    [anon_sym_any] = ACTIONS(2022),
    [anon_sym_private] = ACTIONS(2022),
    [anon_sym_boolean] = ACTIONS(2022),
    [anon_sym_async] = ACTIONS(2022),
    [anon_sym_public] = ACTIONS(2022),
    [anon_sym_get] = ACTIONS(2022),
    [anon_sym_RBRACE] = ACTIONS(2020),
    [anon_sym_static] = ACTIONS(2022),
    [anon_sym_SQUOTE] = ACTIONS(2020),
    [sym_number] = ACTIONS(2020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2022),
    [anon_sym_string] = ACTIONS(2022),
    [anon_sym_abstract] = ACTIONS(2022),
    [anon_sym_set] = ACTIONS(2022),
    [anon_sym_type] = ACTIONS(2022),
    [anon_sym_import] = ACTIONS(2022),
    [anon_sym_export] = ACTIONS(2022),
    [anon_sym_namespace] = ACTIONS(2022),
    [sym_readonly] = ACTIONS(2022),
    [anon_sym_DQUOTE] = ACTIONS(2020),
  },
  [399] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2024),
    [sym__automatic_semicolon] = ACTIONS(2024),
    [anon_sym_BQUOTE] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(2026),
    [anon_sym_COMMA] = ACTIONS(2024),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(2026),
    [anon_sym_GT_GT_GT] = ACTIONS(2024),
    [anon_sym_BANG_EQ] = ACTIONS(2026),
    [anon_sym_GT_EQ] = ACTIONS(2024),
    [anon_sym_RBRACE] = ACTIONS(2024),
    [anon_sym_PERCENT] = ACTIONS(2024),
    [anon_sym_as] = ACTIONS(2024),
    [anon_sym_DASH_DASH] = ACTIONS(2024),
    [anon_sym_instanceof] = ACTIONS(2024),
    [anon_sym_DOT] = ACTIONS(2024),
    [anon_sym_STAR_STAR] = ACTIONS(2024),
    [anon_sym_PLUS_PLUS] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2026),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_SEMI] = ACTIONS(2024),
    [anon_sym_LT_LT] = ACTIONS(2024),
    [anon_sym_AMP_AMP] = ACTIONS(2024),
    [anon_sym_LT_EQ] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(2024),
    [anon_sym_GT] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2026),
    [anon_sym_QMARK] = ACTIONS(2024),
    [anon_sym_PIPE_PIPE] = ACTIONS(2024),
    [anon_sym_EQ_EQ] = ACTIONS(2026),
    [anon_sym_RPAREN] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2026),
    [anon_sym_SLASH] = ACTIONS(2026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2024),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_GT_GT] = ACTIONS(2026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2024),
    [anon_sym_in] = ACTIONS(2026),
  },
  [400] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2028),
  },
  [401] = {
    [sym_identifier] = ACTIONS(2030),
    [sym_comment] = ACTIONS(3),
  },
  [402] = {
    [sym_identifier] = ACTIONS(2032),
    [anon_sym_BQUOTE] = ACTIONS(2034),
    [anon_sym_debugger] = ACTIONS(2032),
    [anon_sym_symbol] = ACTIONS(2032),
    [anon_sym_AT] = ACTIONS(2034),
    [anon_sym_DASH] = ACTIONS(2032),
    [anon_sym_void] = ACTIONS(2032),
    [anon_sym_break] = ACTIONS(2032),
    [anon_sym_const] = ACTIONS(2032),
    [sym_super] = ACTIONS(2032),
    [anon_sym_return] = ACTIONS(2032),
    [anon_sym_private] = ACTIONS(2032),
    [anon_sym_get] = ACTIONS(2032),
    [anon_sym_RBRACE] = ACTIONS(2034),
    [anon_sym_interface] = ACTIONS(2032),
    [anon_sym_default] = ACTIONS(2032),
    [anon_sym_enum] = ACTIONS(2032),
    [anon_sym_delete] = ACTIONS(2032),
    [anon_sym_continue] = ACTIONS(2032),
    [anon_sym_DASH_DASH] = ACTIONS(2034),
    [anon_sym_if] = ACTIONS(2032),
    [anon_sym_this] = ACTIONS(2032),
    [anon_sym_yield] = ACTIONS(2032),
    [sym_true] = ACTIONS(2032),
    [anon_sym_throw] = ACTIONS(2032),
    [anon_sym_protected] = ACTIONS(2032),
    [anon_sym_abstract] = ACTIONS(2032),
    [anon_sym_set] = ACTIONS(2032),
    [anon_sym_type] = ACTIONS(2032),
    [anon_sym_import] = ACTIONS(2032),
    [anon_sym_namespace] = ACTIONS(2032),
    [anon_sym_PLUS_PLUS] = ACTIONS(2034),
    [anon_sym_await] = ACTIONS(2032),
    [anon_sym_DQUOTE] = ACTIONS(2034),
    [anon_sym_else] = ACTIONS(2032),
    [anon_sym_BANG] = ACTIONS(2034),
    [anon_sym_for] = ACTIONS(2032),
    [anon_sym_LBRACK] = ACTIONS(2034),
    [sym_false] = ACTIONS(2032),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym_case] = ACTIONS(2032),
    [anon_sym_module] = ACTIONS(2032),
    [anon_sym_number] = ACTIONS(2032),
    [anon_sym_class] = ACTIONS(2032),
    [anon_sym_declare] = ACTIONS(2032),
    [anon_sym_typeof] = ACTIONS(2032),
    [anon_sym_LBRACE] = ACTIONS(2034),
    [anon_sym_switch] = ACTIONS(2032),
    [anon_sym_LPAREN] = ACTIONS(2034),
    [sym_null] = ACTIONS(2032),
    [anon_sym_any] = ACTIONS(2032),
    [anon_sym_boolean] = ACTIONS(2032),
    [anon_sym_async] = ACTIONS(2032),
    [anon_sym_public] = ACTIONS(2032),
    [anon_sym_var] = ACTIONS(2032),
    [anon_sym_while] = ACTIONS(2032),
    [anon_sym_SQUOTE] = ACTIONS(2034),
    [anon_sym_try] = ACTIONS(2032),
    [anon_sym_LT] = ACTIONS(2034),
    [sym_number] = ACTIONS(2034),
    [anon_sym_SLASH] = ACTIONS(2032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2032),
    [anon_sym_function] = ACTIONS(2032),
    [sym_undefined] = ACTIONS(2032),
    [anon_sym_new] = ACTIONS(2032),
    [ts_builtin_sym_end] = ACTIONS(2034),
    [anon_sym_let] = ACTIONS(2032),
    [anon_sym_PLUS] = ACTIONS(2032),
    [anon_sym_export] = ACTIONS(2032),
    [anon_sym_do] = ACTIONS(2032),
    [anon_sym_TILDE] = ACTIONS(2034),
    [anon_sym_with] = ACTIONS(2032),
  },
  [403] = {
    [anon_sym_EQ] = ACTIONS(2036),
    [sym_comment] = ACTIONS(3),
  },
  [404] = {
    [sym_identifier] = ACTIONS(2038),
    [sym_comment] = ACTIONS(3),
  },
  [405] = {
    [sym_identifier] = ACTIONS(2040),
    [sym_comment] = ACTIONS(3),
  },
  [406] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2042),
    [sym__automatic_semicolon] = ACTIONS(2042),
    [anon_sym_BQUOTE] = ACTIONS(2042),
    [anon_sym_PIPE] = ACTIONS(2044),
    [anon_sym_COMMA] = ACTIONS(2042),
    [anon_sym_DASH] = ACTIONS(2044),
    [anon_sym_STAR] = ACTIONS(2044),
    [anon_sym_GT_GT_GT] = ACTIONS(2042),
    [anon_sym_EQ] = ACTIONS(2044),
    [anon_sym_BANG_EQ] = ACTIONS(2044),
    [anon_sym_GT_EQ] = ACTIONS(2042),
    [anon_sym_RBRACE] = ACTIONS(2042),
    [anon_sym_PERCENT] = ACTIONS(2042),
    [anon_sym_as] = ACTIONS(2042),
    [anon_sym_DASH_DASH] = ACTIONS(2042),
    [anon_sym_instanceof] = ACTIONS(2042),
    [anon_sym_DOT] = ACTIONS(2042),
    [anon_sym_STAR_STAR] = ACTIONS(2042),
    [anon_sym_PLUS_PLUS] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(2042),
    [anon_sym_SEMI] = ACTIONS(2042),
    [anon_sym_LT_LT] = ACTIONS(2042),
    [anon_sym_AMP_AMP] = ACTIONS(2042),
    [anon_sym_of] = ACTIONS(2042),
    [anon_sym_LT_EQ] = ACTIONS(2042),
    [anon_sym_LPAREN] = ACTIONS(2042),
    [anon_sym_GT] = ACTIONS(2044),
    [anon_sym_AMP] = ACTIONS(2044),
    [anon_sym_QMARK] = ACTIONS(2042),
    [anon_sym_PIPE_PIPE] = ACTIONS(2042),
    [anon_sym_EQ_EQ] = ACTIONS(2044),
    [anon_sym_RPAREN] = ACTIONS(2042),
    [anon_sym_LT] = ACTIONS(2044),
    [anon_sym_SLASH] = ACTIONS(2044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2042),
    [anon_sym_PLUS] = ACTIONS(2044),
    [anon_sym_GT_GT] = ACTIONS(2044),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2042),
    [anon_sym_in] = ACTIONS(2044),
  },
  [407] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(632),
    [anon_sym_LBRACK] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(634),
    [anon_sym_SEMI] = ACTIONS(632),
    [anon_sym_BQUOTE] = ACTIONS(632),
    [sym__automatic_semicolon] = ACTIONS(632),
    [anon_sym_PIPE] = ACTIONS(634),
    [anon_sym_COMMA] = ACTIONS(2046),
    [anon_sym_LT_LT] = ACTIONS(632),
    [anon_sym_STAR] = ACTIONS(634),
    [anon_sym_GT_GT_GT] = ACTIONS(632),
    [anon_sym_AMP_AMP] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG_EQ] = ACTIONS(634),
    [anon_sym_LT_EQ] = ACTIONS(632),
    [anon_sym_LPAREN] = ACTIONS(632),
    [anon_sym_GT_EQ] = ACTIONS(632),
    [anon_sym_GT] = ACTIONS(634),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_AMP] = ACTIONS(634),
    [anon_sym_QMARK] = ACTIONS(632),
    [anon_sym_PERCENT] = ACTIONS(632),
    [anon_sym_as] = ACTIONS(632),
    [anon_sym_PIPE_PIPE] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_EQ_EQ] = ACTIONS(634),
    [anon_sym_instanceof] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(634),
    [anon_sym_SLASH] = ACTIONS(634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(632),
    [anon_sym_CARET] = ACTIONS(632),
    [anon_sym_STAR_STAR] = ACTIONS(632),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_GT_GT] = ACTIONS(634),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(632),
    [anon_sym_in] = ACTIONS(634),
  },
  [408] = {
    [aux_sym_object_repeat1] = STATE(434),
    [anon_sym_RBRACE] = ACTIONS(2051),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [409] = {
    [sym__initializer] = STATE(589),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
  },
  [410] = {
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
  },
  [411] = {
    [anon_sym_LBRACK] = ACTIONS(1014),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_symbol] = ACTIONS(1012),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_namespace] = ACTIONS(1012),
    [sym_readonly] = ACTIONS(1012),
    [anon_sym_DQUOTE] = ACTIONS(1014),
  },
  [412] = {
    [sym_string] = STATE(417),
    [sym__property_name] = STATE(417),
    [sym_computed_property_name] = STATE(417),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_STAR] = ACTIONS(1020),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1016),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [413] = {
    [sym_string] = STATE(417),
    [sym__property_name] = STATE(417),
    [sym_computed_property_name] = STATE(417),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(2053),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [414] = {
    [anon_sym_COMMA] = ACTIONS(2055),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [sym_comment] = ACTIONS(3),
  },
  [415] = {
    [sym_computed_property_name] = STATE(439),
    [sym__property_name] = STATE(439),
    [sym_decorator] = STATE(2472),
    [sym_method_definition] = STATE(683),
    [sym_string] = STATE(439),
    [sym_accessibility_modifier] = STATE(180),
    [aux_sym_export_statement_repeat1] = STATE(2472),
    [anon_sym_get] = ACTIONS(1080),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [sym_number] = ACTIONS(1082),
    [anon_sym_STAR] = ACTIONS(376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
  },
  [416] = {
    [sym_new_expression] = STATE(1882),
    [sym_augmented_assignment_expression] = STATE(1882),
    [sym_unary_expression] = STATE(1882),
    [sym_update_expression] = STATE(1882),
    [sym_regex] = STATE(1882),
    [sym_meta_property] = STATE(1882),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1882),
    [sym_yield_expression] = STATE(1882),
    [sym_as_expression] = STATE(1882),
    [sym_non_null_expression] = STATE(1882),
    [sym_internal_module] = STATE(1882),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1882),
    [sym_await_expression] = STATE(1882),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1882),
    [sym_this] = STATE(1882),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1882),
    [sym_generator_function] = STATE(1882),
    [sym_call_expression] = STATE(1882),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1882),
    [sym_ternary_expression] = STATE(1882),
    [sym_binary_expression] = STATE(1882),
    [sym_template_string] = STATE(1882),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1882),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1882),
    [sym_class] = STATE(1882),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(2057),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(2057),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(2057),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2059),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(2057),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [417] = {
    [sym_call_signature] = STATE(685),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(2061),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [418] = {
    [sym_string] = STATE(686),
    [sym__property_name] = STATE(686),
    [sym_computed_property_name] = STATE(686),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [419] = {
    [sym_string] = STATE(686),
    [sym__property_name] = STATE(686),
    [sym_computed_property_name] = STATE(686),
    [anon_sym_get] = ACTIONS(2065),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(2065),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(2069),
  },
  [420] = {
    [sym_string] = STATE(686),
    [sym__property_name] = STATE(686),
    [sym_computed_property_name] = STATE(686),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [421] = {
    [sym_string] = STATE(686),
    [sym__property_name] = STATE(686),
    [sym_computed_property_name] = STATE(686),
    [anon_sym_get] = ACTIONS(2065),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(2065),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [422] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [aux_sym_array_repeat1] = STATE(374),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACK] = ACTIONS(2071),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [423] = {
    [anon_sym_EQ_GT] = ACTIONS(1172),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
  },
  [424] = {
    [anon_sym_EQ_GT] = ACTIONS(1174),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
  },
  [425] = {
    [sym_string] = STATE(686),
    [sym__property_name] = STATE(686),
    [sym_computed_property_name] = STATE(686),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_EQ_GT] = ACTIONS(1174),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(2063),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [426] = {
    [sym_string] = STATE(686),
    [sym__property_name] = STATE(686),
    [sym_computed_property_name] = STATE(686),
    [anon_sym_get] = ACTIONS(2065),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_async] = ACTIONS(2069),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(2063),
    [anon_sym_STAR] = ACTIONS(2067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(2065),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [sym_readonly] = ACTIONS(2073),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [427] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2075),
    [sym__automatic_semicolon] = ACTIONS(2075),
    [anon_sym_BQUOTE] = ACTIONS(2075),
    [anon_sym_PIPE] = ACTIONS(2077),
    [anon_sym_COMMA] = ACTIONS(2075),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_STAR] = ACTIONS(2077),
    [anon_sym_GT_GT_GT] = ACTIONS(2075),
    [anon_sym_EQ] = ACTIONS(2077),
    [anon_sym_BANG_EQ] = ACTIONS(2077),
    [anon_sym_GT_EQ] = ACTIONS(2075),
    [anon_sym_RBRACE] = ACTIONS(2075),
    [anon_sym_PERCENT] = ACTIONS(2075),
    [anon_sym_as] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_instanceof] = ACTIONS(2075),
    [anon_sym_DOT] = ACTIONS(2075),
    [anon_sym_STAR_STAR] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_BANG] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(2075),
    [anon_sym_SEMI] = ACTIONS(2075),
    [anon_sym_LT_LT] = ACTIONS(2075),
    [anon_sym_AMP_AMP] = ACTIONS(2075),
    [anon_sym_of] = ACTIONS(2075),
    [anon_sym_LT_EQ] = ACTIONS(2075),
    [anon_sym_LPAREN] = ACTIONS(2075),
    [anon_sym_GT] = ACTIONS(2077),
    [anon_sym_AMP] = ACTIONS(2077),
    [anon_sym_QMARK] = ACTIONS(2075),
    [anon_sym_PIPE_PIPE] = ACTIONS(2075),
    [anon_sym_EQ_EQ] = ACTIONS(2077),
    [anon_sym_RPAREN] = ACTIONS(2075),
    [anon_sym_LT] = ACTIONS(2077),
    [anon_sym_SLASH] = ACTIONS(2077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_PLUS] = ACTIONS(2077),
    [anon_sym_GT_GT] = ACTIONS(2077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2075),
    [anon_sym_in] = ACTIONS(2077),
  },
  [428] = {
    [aux_sym_object_repeat1] = STATE(434),
    [anon_sym_RBRACE] = ACTIONS(2079),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [429] = {
    [anon_sym_BQUOTE] = ACTIONS(2081),
    [anon_sym_symbol] = ACTIONS(2083),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_RBRACE] = ACTIONS(2081),
    [anon_sym_interface] = ACTIONS(2083),
    [anon_sym_delete] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_import] = ACTIONS(2083),
    [anon_sym_await] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(2081),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2081),
    [anon_sym_number] = ACTIONS(2083),
    [anon_sym_typeof] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(2081),
    [anon_sym_switch] = ACTIONS(2083),
    [sym_null] = ACTIONS(2083),
    [anon_sym_catch] = ACTIONS(2083),
    [anon_sym_any] = ACTIONS(2083),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_var] = ACTIONS(2083),
    [anon_sym_while] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_new] = ACTIONS(2083),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_with] = ACTIONS(2083),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_debugger] = ACTIONS(2083),
    [anon_sym_AT] = ACTIONS(2081),
    [anon_sym_COMMA] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_void] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [sym_super] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_default] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2081),
    [anon_sym_this] = ACTIONS(2083),
    [anon_sym_throw] = ACTIONS(2083),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_namespace] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2081),
    [anon_sym_else] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [sym_false] = ACTIONS(2083),
    [anon_sym_case] = ACTIONS(2083),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_class] = ACTIONS(2083),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2081),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_try] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2081),
    [sym_number] = ACTIONS(2081),
    [anon_sym_finally] = ACTIONS(2083),
    [ts_builtin_sym_end] = ACTIONS(2081),
    [anon_sym_function] = ACTIONS(2083),
    [sym_undefined] = ACTIONS(2083),
    [anon_sym_let] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_do] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2081),
  },
  [430] = {
    [sym_new_expression] = STATE(693),
    [sym_augmented_assignment_expression] = STATE(693),
    [sym_unary_expression] = STATE(693),
    [sym_update_expression] = STATE(693),
    [sym_regex] = STATE(693),
    [sym_meta_property] = STATE(693),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(693),
    [sym_yield_expression] = STATE(693),
    [sym_as_expression] = STATE(693),
    [sym_non_null_expression] = STATE(693),
    [sym_internal_module] = STATE(693),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(693),
    [sym_await_expression] = STATE(693),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(693),
    [sym_this] = STATE(693),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(693),
    [sym_generator_function] = STATE(693),
    [sym_call_expression] = STATE(693),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(693),
    [sym_ternary_expression] = STATE(693),
    [sym_binary_expression] = STATE(693),
    [sym_template_string] = STATE(693),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(693),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(693),
    [sym_class] = STATE(693),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(266),
    [sym_false] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(2085),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(2087),
    [sym_true] = ACTIONS(2085),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(2085),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [431] = {
    [sym_call_signature] = STATE(685),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [432] = {
    [sym_statement_block] = STATE(694),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [433] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1564),
    [anon_sym_LBRACK] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(1566),
    [anon_sym_SEMI] = ACTIONS(1564),
    [anon_sym_BQUOTE] = ACTIONS(1564),
    [sym__automatic_semicolon] = ACTIONS(1564),
    [anon_sym_PIPE] = ACTIONS(1566),
    [anon_sym_COMMA] = ACTIONS(2089),
    [anon_sym_LT_LT] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_GT_GT_GT] = ACTIONS(1564),
    [anon_sym_AMP_AMP] = ACTIONS(1564),
    [anon_sym_DASH] = ACTIONS(1566),
    [anon_sym_BANG_EQ] = ACTIONS(1566),
    [anon_sym_LT_EQ] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(1564),
    [anon_sym_GT_EQ] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1566),
    [anon_sym_RBRACE] = ACTIONS(2092),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_QMARK] = ACTIONS(1564),
    [anon_sym_PERCENT] = ACTIONS(1564),
    [anon_sym_as] = ACTIONS(1564),
    [anon_sym_PIPE_PIPE] = ACTIONS(1564),
    [anon_sym_DASH_DASH] = ACTIONS(1564),
    [anon_sym_EQ_EQ] = ACTIONS(1566),
    [anon_sym_instanceof] = ACTIONS(1564),
    [anon_sym_LT] = ACTIONS(1566),
    [anon_sym_SLASH] = ACTIONS(1566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1564),
    [anon_sym_CARET] = ACTIONS(1564),
    [anon_sym_STAR_STAR] = ACTIONS(1564),
    [anon_sym_PLUS] = ACTIONS(1566),
    [anon_sym_GT_GT] = ACTIONS(1566),
    [anon_sym_PLUS_PLUS] = ACTIONS(1564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1564),
    [anon_sym_in] = ACTIONS(1566),
  },
  [434] = {
    [aux_sym_object_repeat1] = STATE(434),
    [anon_sym_COMMA] = ACTIONS(2094),
    [anon_sym_RBRACE] = ACTIONS(2055),
    [sym_comment] = ACTIONS(3),
  },
  [435] = {
    [sym_string] = STATE(417),
    [sym__property_name] = STATE(417),
    [sym_computed_property_name] = STATE(417),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [436] = {
    [sym_type_alias_declaration] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(159),
    [sym__declaration] = STATE(559),
    [sym_ambient_declaration] = STATE(559),
    [sym_import_alias] = STATE(559),
    [sym_export_statement] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_lexical_declaration] = STATE(559),
    [sym_internal_module] = STATE(559),
    [sym_decorator] = STATE(159),
    [sym_enum_declaration] = STATE(559),
    [sym_function] = STATE(559),
    [sym_function_signature] = STATE(559),
    [sym_variable_declaration] = STATE(559),
    [sym_abstract_class] = STATE(559),
    [sym_module] = STATE(559),
    [sym_interface_declaration] = STATE(559),
    [sym_class] = STATE(559),
    [anon_sym_var] = ACTIONS(360),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_interface] = ACTIONS(340),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_default] = ACTIONS(1662),
    [anon_sym_module] = ACTIONS(534),
    [anon_sym_class] = ACTIONS(354),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_declare] = ACTIONS(356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(362),
    [anon_sym_const] = ACTIONS(338),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_abstract] = ACTIONS(344),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_let] = ACTIONS(364),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_export] = ACTIONS(366),
    [anon_sym_namespace] = ACTIONS(350),
    [anon_sym_async] = ACTIONS(358),
  },
  [437] = {
    [sym_string] = STATE(417),
    [sym__property_name] = STATE(417),
    [sym_computed_property_name] = STATE(417),
    [anon_sym_get] = ACTIONS(1016),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1010),
    [anon_sym_STAR] = ACTIONS(1020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [438] = {
    [aux_sym_object_repeat1] = STATE(695),
    [anon_sym_RBRACE] = ACTIONS(2079),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [439] = {
    [sym_call_signature] = STATE(432),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(1072),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [440] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1675),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [sym__automatic_semicolon] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(2097),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_STAR] = ACTIONS(1677),
    [anon_sym_GT_GT_GT] = ACTIONS(1675),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_BANG_EQ] = ACTIONS(1677),
    [anon_sym_LT_EQ] = ACTIONS(1675),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_GT_EQ] = ACTIONS(1675),
    [anon_sym_GT] = ACTIONS(1677),
    [anon_sym_RBRACE] = ACTIONS(2100),
    [anon_sym_AMP] = ACTIONS(1677),
    [anon_sym_QMARK] = ACTIONS(1675),
    [anon_sym_PERCENT] = ACTIONS(1675),
    [anon_sym_as] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [anon_sym_DASH_DASH] = ACTIONS(1675),
    [anon_sym_EQ_EQ] = ACTIONS(1677),
    [anon_sym_instanceof] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1677),
    [anon_sym_SLASH] = ACTIONS(1677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1675),
    [anon_sym_CARET] = ACTIONS(1675),
    [anon_sym_STAR_STAR] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_GT_GT] = ACTIONS(1677),
    [anon_sym_PLUS_PLUS] = ACTIONS(1675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1675),
    [anon_sym_in] = ACTIONS(1677),
  },
  [441] = {
    [sym_switch_case] = STATE(699),
    [sym_switch_default] = STATE(699),
    [aux_sym_switch_body_repeat1] = STATE(699),
    [anon_sym_RBRACE] = ACTIONS(2102),
    [anon_sym_default] = ACTIONS(2104),
    [anon_sym_case] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
  },
  [442] = {
    [sym_identifier] = ACTIONS(2108),
    [anon_sym_BQUOTE] = ACTIONS(2110),
    [anon_sym_debugger] = ACTIONS(2108),
    [anon_sym_symbol] = ACTIONS(2108),
    [anon_sym_AT] = ACTIONS(2110),
    [anon_sym_DASH] = ACTIONS(2108),
    [anon_sym_void] = ACTIONS(2108),
    [anon_sym_break] = ACTIONS(2108),
    [anon_sym_const] = ACTIONS(2108),
    [sym_super] = ACTIONS(2108),
    [anon_sym_return] = ACTIONS(2108),
    [anon_sym_private] = ACTIONS(2108),
    [anon_sym_get] = ACTIONS(2108),
    [anon_sym_RBRACE] = ACTIONS(2110),
    [anon_sym_interface] = ACTIONS(2108),
    [anon_sym_default] = ACTIONS(2108),
    [anon_sym_enum] = ACTIONS(2108),
    [anon_sym_delete] = ACTIONS(2108),
    [anon_sym_continue] = ACTIONS(2108),
    [anon_sym_DASH_DASH] = ACTIONS(2110),
    [anon_sym_if] = ACTIONS(2108),
    [anon_sym_this] = ACTIONS(2108),
    [anon_sym_yield] = ACTIONS(2108),
    [sym_true] = ACTIONS(2108),
    [anon_sym_throw] = ACTIONS(2108),
    [anon_sym_protected] = ACTIONS(2108),
    [anon_sym_abstract] = ACTIONS(2108),
    [anon_sym_set] = ACTIONS(2108),
    [anon_sym_type] = ACTIONS(2108),
    [anon_sym_import] = ACTIONS(2108),
    [anon_sym_namespace] = ACTIONS(2108),
    [anon_sym_PLUS_PLUS] = ACTIONS(2110),
    [anon_sym_await] = ACTIONS(2108),
    [anon_sym_DQUOTE] = ACTIONS(2110),
    [anon_sym_else] = ACTIONS(2108),
    [anon_sym_BANG] = ACTIONS(2110),
    [anon_sym_for] = ACTIONS(2108),
    [anon_sym_LBRACK] = ACTIONS(2110),
    [sym_false] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(2110),
    [anon_sym_case] = ACTIONS(2108),
    [anon_sym_module] = ACTIONS(2108),
    [anon_sym_number] = ACTIONS(2108),
    [anon_sym_class] = ACTIONS(2108),
    [anon_sym_declare] = ACTIONS(2108),
    [anon_sym_typeof] = ACTIONS(2108),
    [anon_sym_LBRACE] = ACTIONS(2110),
    [anon_sym_switch] = ACTIONS(2108),
    [anon_sym_LPAREN] = ACTIONS(2110),
    [sym_null] = ACTIONS(2108),
    [anon_sym_any] = ACTIONS(2108),
    [anon_sym_boolean] = ACTIONS(2108),
    [anon_sym_async] = ACTIONS(2108),
    [anon_sym_public] = ACTIONS(2108),
    [anon_sym_var] = ACTIONS(2108),
    [anon_sym_while] = ACTIONS(2108),
    [anon_sym_SQUOTE] = ACTIONS(2110),
    [anon_sym_try] = ACTIONS(2108),
    [anon_sym_LT] = ACTIONS(2110),
    [sym_number] = ACTIONS(2110),
    [anon_sym_SLASH] = ACTIONS(2108),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2108),
    [anon_sym_function] = ACTIONS(2108),
    [sym_undefined] = ACTIONS(2108),
    [anon_sym_new] = ACTIONS(2108),
    [ts_builtin_sym_end] = ACTIONS(2110),
    [anon_sym_let] = ACTIONS(2108),
    [anon_sym_PLUS] = ACTIONS(2108),
    [anon_sym_export] = ACTIONS(2108),
    [anon_sym_do] = ACTIONS(2108),
    [anon_sym_TILDE] = ACTIONS(2110),
    [anon_sym_with] = ACTIONS(2108),
  },
  [443] = {
    [sym__initializer] = STATE(700),
    [sym_type_annotation] = STATE(701),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2112),
    [anon_sym_COMMA] = ACTIONS(2112),
    [sym_comment] = ACTIONS(3),
  },
  [444] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(632),
    [anon_sym_LBRACK] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(634),
    [anon_sym_BQUOTE] = ACTIONS(632),
    [anon_sym_PIPE] = ACTIONS(634),
    [anon_sym_COMMA] = ACTIONS(2114),
    [anon_sym_LT_LT] = ACTIONS(632),
    [anon_sym_STAR] = ACTIONS(634),
    [anon_sym_GT_GT_GT] = ACTIONS(632),
    [anon_sym_AMP_AMP] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_BANG_EQ] = ACTIONS(634),
    [anon_sym_LT_EQ] = ACTIONS(632),
    [anon_sym_LPAREN] = ACTIONS(632),
    [anon_sym_GT_EQ] = ACTIONS(632),
    [anon_sym_GT] = ACTIONS(634),
    [anon_sym_AMP] = ACTIONS(634),
    [anon_sym_PERCENT] = ACTIONS(632),
    [anon_sym_QMARK] = ACTIONS(632),
    [anon_sym_as] = ACTIONS(632),
    [anon_sym_PIPE_PIPE] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_EQ_EQ] = ACTIONS(634),
    [anon_sym_RPAREN] = ACTIONS(2114),
    [anon_sym_LT] = ACTIONS(634),
    [anon_sym_instanceof] = ACTIONS(632),
    [anon_sym_SLASH] = ACTIONS(634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(632),
    [anon_sym_DOT] = ACTIONS(632),
    [anon_sym_CARET] = ACTIONS(632),
    [anon_sym_STAR_STAR] = ACTIONS(632),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_GT_GT] = ACTIONS(634),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(632),
    [anon_sym_in] = ACTIONS(634),
  },
  [445] = {
    [sym__initializer] = STATE(702),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [sym_comment] = ACTIONS(3),
  },
  [446] = {
    [sym__initializer] = STATE(704),
    [sym_type_annotation] = STATE(705),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2119),
    [anon_sym_QMARK] = ACTIONS(2121),
    [anon_sym_COMMA] = ACTIONS(2119),
    [sym_comment] = ACTIONS(3),
  },
  [447] = {
    [sym__initializer] = STATE(702),
    [sym_type_annotation] = STATE(707),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2117),
    [anon_sym_QMARK] = ACTIONS(2123),
    [anon_sym_COMMA] = ACTIONS(2117),
    [sym_comment] = ACTIONS(3),
  },
  [448] = {
    [sym__initializer] = STATE(709),
    [sym_type_annotation] = STATE(710),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2125),
    [anon_sym_QMARK] = ACTIONS(2127),
    [anon_sym_COMMA] = ACTIONS(2125),
    [sym_comment] = ACTIONS(3),
  },
  [449] = {
    [sym__initializer] = STATE(702),
    [sym_type_annotation] = STATE(707),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2117),
    [anon_sym_COMMA] = ACTIONS(2117),
    [sym_comment] = ACTIONS(3),
  },
  [450] = {
    [sym__initializer] = STATE(712),
    [sym_type_annotation] = STATE(713),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2129),
    [anon_sym_QMARK] = ACTIONS(2131),
    [anon_sym_COMMA] = ACTIONS(2129),
    [sym_comment] = ACTIONS(3),
  },
  [451] = {
    [sym__initializer] = STATE(714),
    [sym_type_annotation] = STATE(715),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2133),
    [anon_sym_COMMA] = ACTIONS(2133),
    [sym_comment] = ACTIONS(3),
  },
  [452] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(662),
    [anon_sym_LBRACK] = ACTIONS(662),
    [anon_sym_BANG] = ACTIONS(664),
    [anon_sym_BQUOTE] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_COMMA] = ACTIONS(2135),
    [anon_sym_LT_LT] = ACTIONS(662),
    [anon_sym_STAR] = ACTIONS(664),
    [anon_sym_GT_GT_GT] = ACTIONS(662),
    [anon_sym_AMP_AMP] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_BANG_EQ] = ACTIONS(664),
    [anon_sym_LT_EQ] = ACTIONS(662),
    [anon_sym_LPAREN] = ACTIONS(662),
    [anon_sym_GT_EQ] = ACTIONS(662),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_PERCENT] = ACTIONS(662),
    [anon_sym_QMARK] = ACTIONS(662),
    [anon_sym_as] = ACTIONS(662),
    [anon_sym_PIPE_PIPE] = ACTIONS(662),
    [anon_sym_DASH_DASH] = ACTIONS(662),
    [anon_sym_EQ_EQ] = ACTIONS(664),
    [anon_sym_RPAREN] = ACTIONS(2135),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_instanceof] = ACTIONS(662),
    [anon_sym_SLASH] = ACTIONS(664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(662),
    [anon_sym_CARET] = ACTIONS(662),
    [anon_sym_STAR_STAR] = ACTIONS(662),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_PLUS_PLUS] = ACTIONS(662),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(662),
    [anon_sym_in] = ACTIONS(664),
  },
  [453] = {
    [sym__initializer] = STATE(716),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(2138),
    [anon_sym_COMMA] = ACTIONS(2138),
    [sym_comment] = ACTIONS(3),
  },
  [454] = {
    [sym_type_annotation] = STATE(717),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2140),
    [anon_sym_COMMA] = ACTIONS(2140),
    [sym_comment] = ACTIONS(3),
  },
  [455] = {
    [aux_sym_export_statement_repeat1] = STATE(719),
    [sym_decorator] = STATE(719),
    [sym_object] = STATE(465),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(720),
    [sym_array] = STATE(467),
    [sym_rest_parameter] = STATE(720),
    [sym_optional_parameter] = STATE(720),
    [sym_this] = STATE(468),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_symbol] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1154),
    [anon_sym_any] = ACTIONS(1154),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_boolean] = ACTIONS(1154),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_RPAREN] = ACTIONS(2142),
    [anon_sym_this] = ACTIONS(284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_string] = ACTIONS(1154),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [anon_sym_export] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
  },
  [456] = {
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_EQ_GT] = ACTIONS(2144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2144),
  },
  [457] = {
    [aux_sym_formal_parameters_repeat1] = STATE(722),
    [anon_sym_RPAREN] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2146),
    [sym_comment] = ACTIONS(3),
  },
  [458] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2148),
    [sym__automatic_semicolon] = ACTIONS(2148),
    [anon_sym_BQUOTE] = ACTIONS(2148),
    [anon_sym_PIPE] = ACTIONS(2150),
    [anon_sym_COMMA] = ACTIONS(2148),
    [anon_sym_DASH] = ACTIONS(2150),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_GT_GT_GT] = ACTIONS(2148),
    [anon_sym_BANG_EQ] = ACTIONS(2150),
    [anon_sym_GT_EQ] = ACTIONS(2148),
    [anon_sym_RBRACE] = ACTIONS(2148),
    [anon_sym_PERCENT] = ACTIONS(2148),
    [anon_sym_as] = ACTIONS(2148),
    [anon_sym_DASH_DASH] = ACTIONS(2148),
    [anon_sym_instanceof] = ACTIONS(2148),
    [anon_sym_DOT] = ACTIONS(2148),
    [anon_sym_STAR_STAR] = ACTIONS(2148),
    [anon_sym_PLUS_PLUS] = ACTIONS(2148),
    [anon_sym_BANG] = ACTIONS(2150),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [anon_sym_SEMI] = ACTIONS(2148),
    [anon_sym_LT_LT] = ACTIONS(2148),
    [anon_sym_AMP_AMP] = ACTIONS(2148),
    [anon_sym_LT_EQ] = ACTIONS(2148),
    [anon_sym_LPAREN] = ACTIONS(2148),
    [anon_sym_GT] = ACTIONS(2150),
    [anon_sym_AMP] = ACTIONS(2150),
    [anon_sym_QMARK] = ACTIONS(2148),
    [anon_sym_PIPE_PIPE] = ACTIONS(2148),
    [anon_sym_EQ_EQ] = ACTIONS(2150),
    [anon_sym_RPAREN] = ACTIONS(2148),
    [anon_sym_LT] = ACTIONS(2150),
    [anon_sym_SLASH] = ACTIONS(2150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2148),
    [anon_sym_PLUS] = ACTIONS(2150),
    [anon_sym_GT_GT] = ACTIONS(2150),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2148),
    [anon_sym_in] = ACTIONS(2150),
  },
  [459] = {
    [anon_sym_RPAREN] = ACTIONS(2152),
    [sym_comment] = ACTIONS(3),
  },
  [460] = {
    [sym_array] = STATE(726),
    [sym_this] = STATE(727),
    [sym_object] = STATE(728),
    [anon_sym_get] = ACTIONS(2154),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(2156),
    [anon_sym_module] = ACTIONS(2154),
    [anon_sym_symbol] = ACTIONS(2154),
    [anon_sym_number] = ACTIONS(2154),
    [anon_sym_declare] = ACTIONS(2154),
    [anon_sym_this] = ACTIONS(284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(2154),
    [anon_sym_protected] = ACTIONS(2154),
    [anon_sym_string] = ACTIONS(2154),
    [anon_sym_set] = ACTIONS(2154),
    [anon_sym_type] = ACTIONS(2154),
    [anon_sym_import] = ACTIONS(2154),
    [anon_sym_export] = ACTIONS(2154),
    [anon_sym_namespace] = ACTIONS(2154),
    [anon_sym_any] = ACTIONS(2154),
    [anon_sym_private] = ACTIONS(2154),
    [anon_sym_boolean] = ACTIONS(2154),
    [anon_sym_async] = ACTIONS(2154),
    [anon_sym_public] = ACTIONS(2154),
  },
  [461] = {
    [anon_sym_COMMA] = ACTIONS(2117),
    [anon_sym_RPAREN] = ACTIONS(2117),
    [sym_comment] = ACTIONS(3),
  },
  [462] = {
    [sym__initializer] = STATE(729),
    [sym_type_annotation] = STATE(453),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2158),
    [anon_sym_QMARK] = ACTIONS(2160),
    [anon_sym_COMMA] = ACTIONS(2158),
    [sym_comment] = ACTIONS(3),
  },
  [463] = {
    [sym__initializer] = STATE(461),
    [sym_type_annotation] = STATE(445),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2162),
    [anon_sym_QMARK] = ACTIONS(2164),
    [anon_sym_COMMA] = ACTIONS(2162),
    [sym_comment] = ACTIONS(3),
  },
  [464] = {
    [sym__initializer] = STATE(729),
    [sym_type_annotation] = STATE(453),
    [anon_sym_LBRACK] = ACTIONS(1014),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_symbol] = ACTIONS(1012),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_COMMA] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_QMARK] = ACTIONS(2160),
    [anon_sym_RPAREN] = ACTIONS(2158),
    [anon_sym_this] = ACTIONS(1012),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [sym_readonly] = ACTIONS(1012),
    [anon_sym_namespace] = ACTIONS(1012),
  },
  [465] = {
    [sym__initializer] = STATE(730),
    [sym_type_annotation] = STATE(471),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2166),
    [anon_sym_QMARK] = ACTIONS(2168),
    [anon_sym_COMMA] = ACTIONS(2166),
    [sym_comment] = ACTIONS(3),
  },
  [466] = {
    [aux_sym_formal_parameters_repeat1] = STATE(731),
    [anon_sym_RPAREN] = ACTIONS(2142),
    [anon_sym_COMMA] = ACTIONS(2146),
    [sym_comment] = ACTIONS(3),
  },
  [467] = {
    [sym__initializer] = STATE(732),
    [sym_type_annotation] = STATE(474),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2170),
    [anon_sym_QMARK] = ACTIONS(2172),
    [anon_sym_COMMA] = ACTIONS(2170),
    [sym_comment] = ACTIONS(3),
  },
  [468] = {
    [sym__initializer] = STATE(461),
    [sym_type_annotation] = STATE(445),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2162),
    [anon_sym_COMMA] = ACTIONS(2162),
    [sym_comment] = ACTIONS(3),
  },
  [469] = {
    [sym__initializer] = STATE(733),
    [sym_type_annotation] = STATE(734),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2174),
    [anon_sym_COMMA] = ACTIONS(2174),
    [sym_comment] = ACTIONS(3),
  },
  [470] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1564),
    [anon_sym_LBRACK] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(1566),
    [anon_sym_BQUOTE] = ACTIONS(1564),
    [anon_sym_PIPE] = ACTIONS(1566),
    [anon_sym_COMMA] = ACTIONS(2176),
    [anon_sym_LT_LT] = ACTIONS(1564),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_GT_GT_GT] = ACTIONS(1564),
    [anon_sym_AMP_AMP] = ACTIONS(1564),
    [anon_sym_DASH] = ACTIONS(1566),
    [anon_sym_BANG_EQ] = ACTIONS(1566),
    [anon_sym_LT_EQ] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(1564),
    [anon_sym_GT_EQ] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_PERCENT] = ACTIONS(1564),
    [anon_sym_QMARK] = ACTIONS(1564),
    [anon_sym_as] = ACTIONS(1564),
    [anon_sym_PIPE_PIPE] = ACTIONS(1564),
    [anon_sym_DASH_DASH] = ACTIONS(1564),
    [anon_sym_EQ_EQ] = ACTIONS(1566),
    [anon_sym_RPAREN] = ACTIONS(2176),
    [anon_sym_LT] = ACTIONS(1566),
    [anon_sym_instanceof] = ACTIONS(1564),
    [anon_sym_SLASH] = ACTIONS(1566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1564),
    [anon_sym_DOT] = ACTIONS(1564),
    [anon_sym_CARET] = ACTIONS(1564),
    [anon_sym_STAR_STAR] = ACTIONS(1564),
    [anon_sym_PLUS] = ACTIONS(1566),
    [anon_sym_GT_GT] = ACTIONS(1566),
    [anon_sym_PLUS_PLUS] = ACTIONS(1564),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1564),
    [anon_sym_in] = ACTIONS(1566),
  },
  [471] = {
    [sym__initializer] = STATE(735),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(2179),
    [anon_sym_COMMA] = ACTIONS(2179),
    [sym_comment] = ACTIONS(3),
  },
  [472] = {
    [sym__initializer] = STATE(736),
    [sym_type_annotation] = STATE(737),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2181),
    [anon_sym_COMMA] = ACTIONS(2181),
    [sym_comment] = ACTIONS(3),
  },
  [473] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1675),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1677),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(2183),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_STAR] = ACTIONS(1677),
    [anon_sym_GT_GT_GT] = ACTIONS(1675),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_BANG_EQ] = ACTIONS(1677),
    [anon_sym_LT_EQ] = ACTIONS(1675),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_GT_EQ] = ACTIONS(1675),
    [anon_sym_GT] = ACTIONS(1677),
    [anon_sym_AMP] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1675),
    [anon_sym_QMARK] = ACTIONS(1675),
    [anon_sym_as] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [anon_sym_DASH_DASH] = ACTIONS(1675),
    [anon_sym_EQ_EQ] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(2183),
    [anon_sym_LT] = ACTIONS(1677),
    [anon_sym_instanceof] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1675),
    [anon_sym_DOT] = ACTIONS(1675),
    [anon_sym_CARET] = ACTIONS(1675),
    [anon_sym_STAR_STAR] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_GT_GT] = ACTIONS(1677),
    [anon_sym_PLUS_PLUS] = ACTIONS(1675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1675),
    [anon_sym_in] = ACTIONS(1677),
  },
  [474] = {
    [sym__initializer] = STATE(738),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
  },
  [475] = {
    [sym_new_expression] = STATE(740),
    [sym_augmented_assignment_expression] = STATE(740),
    [sym_unary_expression] = STATE(740),
    [sym_update_expression] = STATE(740),
    [sym_regex] = STATE(740),
    [sym_meta_property] = STATE(740),
    [sym_call_signature] = STATE(52),
    [sym_statement_block] = STATE(739),
    [sym__expression] = STATE(740),
    [sym_yield_expression] = STATE(740),
    [sym_as_expression] = STATE(740),
    [sym_non_null_expression] = STATE(740),
    [sym_internal_module] = STATE(740),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(740),
    [sym_await_expression] = STATE(740),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(740),
    [sym_this] = STATE(740),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(740),
    [sym_generator_function] = STATE(740),
    [sym_call_expression] = STATE(740),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(740),
    [sym_ternary_expression] = STATE(740),
    [sym_binary_expression] = STATE(740),
    [sym_template_string] = STATE(740),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(740),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(740),
    [sym_class] = STATE(740),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(2188),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(2188),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(614),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(2188),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2190),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(2188),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [476] = {
    [sym_new_expression] = STATE(742),
    [sym_augmented_assignment_expression] = STATE(742),
    [sym_unary_expression] = STATE(742),
    [sym_update_expression] = STATE(742),
    [sym_regex] = STATE(742),
    [sym_meta_property] = STATE(742),
    [sym_call_signature] = STATE(52),
    [sym_statement_block] = STATE(741),
    [sym__expression] = STATE(742),
    [sym_yield_expression] = STATE(742),
    [sym_as_expression] = STATE(742),
    [sym_non_null_expression] = STATE(742),
    [sym_internal_module] = STATE(742),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(742),
    [sym_await_expression] = STATE(742),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(742),
    [sym_this] = STATE(742),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(742),
    [sym_generator_function] = STATE(742),
    [sym_call_expression] = STATE(742),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(742),
    [sym_ternary_expression] = STATE(742),
    [sym_binary_expression] = STATE(742),
    [sym_template_string] = STATE(742),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(742),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(742),
    [sym_class] = STATE(742),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(2192),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(2192),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(614),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(2192),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2194),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(2192),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [477] = {
    [aux_sym_export_statement_repeat1] = STATE(2472),
    [sym_decorator] = STATE(2472),
    [sym_object] = STATE(465),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(466),
    [sym_array] = STATE(467),
    [sym_rest_parameter] = STATE(466),
    [sym_optional_parameter] = STATE(466),
    [sym_this] = STATE(468),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_symbol] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1154),
    [anon_sym_any] = ACTIONS(1154),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_boolean] = ACTIONS(1154),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_this] = ACTIONS(284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_string] = ACTIONS(1154),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [anon_sym_export] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
  },
  [478] = {
    [sym_constraint] = STATE(496),
    [sym_default_type] = STATE(498),
    [anon_sym_GT] = ACTIONS(2196),
    [anon_sym_EQ] = ACTIONS(1196),
    [anon_sym_COLON] = ACTIONS(1203),
    [anon_sym_extends] = ACTIONS(1203),
    [anon_sym_COMMA] = ACTIONS(2196),
    [sym_comment] = ACTIONS(3),
  },
  [479] = {
    [sym_call_signature] = STATE(743),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [480] = {
    [sym_statement_block] = STATE(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(805),
  },
  [481] = {
    [sym_identifier] = ACTIONS(2198),
    [anon_sym_BQUOTE] = ACTIONS(2200),
    [anon_sym_debugger] = ACTIONS(2198),
    [anon_sym_symbol] = ACTIONS(2198),
    [anon_sym_AT] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_void] = ACTIONS(2198),
    [anon_sym_break] = ACTIONS(2198),
    [anon_sym_const] = ACTIONS(2198),
    [sym_super] = ACTIONS(2198),
    [anon_sym_return] = ACTIONS(2198),
    [anon_sym_private] = ACTIONS(2198),
    [anon_sym_get] = ACTIONS(2198),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_interface] = ACTIONS(2198),
    [anon_sym_default] = ACTIONS(2198),
    [anon_sym_enum] = ACTIONS(2198),
    [anon_sym_delete] = ACTIONS(2198),
    [anon_sym_continue] = ACTIONS(2198),
    [anon_sym_DASH_DASH] = ACTIONS(2200),
    [anon_sym_if] = ACTIONS(2198),
    [anon_sym_this] = ACTIONS(2198),
    [anon_sym_yield] = ACTIONS(2198),
    [sym_true] = ACTIONS(2198),
    [anon_sym_throw] = ACTIONS(2198),
    [anon_sym_protected] = ACTIONS(2198),
    [anon_sym_abstract] = ACTIONS(2198),
    [anon_sym_set] = ACTIONS(2198),
    [anon_sym_type] = ACTIONS(2198),
    [anon_sym_import] = ACTIONS(2198),
    [anon_sym_namespace] = ACTIONS(2198),
    [anon_sym_PLUS_PLUS] = ACTIONS(2200),
    [anon_sym_await] = ACTIONS(2198),
    [anon_sym_DQUOTE] = ACTIONS(2200),
    [anon_sym_else] = ACTIONS(2198),
    [anon_sym_BANG] = ACTIONS(2200),
    [anon_sym_for] = ACTIONS(2198),
    [anon_sym_LBRACK] = ACTIONS(2200),
    [sym_false] = ACTIONS(2198),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym_case] = ACTIONS(2198),
    [anon_sym_module] = ACTIONS(2198),
    [anon_sym_number] = ACTIONS(2198),
    [anon_sym_class] = ACTIONS(2198),
    [anon_sym_declare] = ACTIONS(2198),
    [anon_sym_typeof] = ACTIONS(2198),
    [anon_sym_LBRACE] = ACTIONS(2200),
    [anon_sym_switch] = ACTIONS(2198),
    [anon_sym_LPAREN] = ACTIONS(2200),
    [sym_null] = ACTIONS(2198),
    [anon_sym_any] = ACTIONS(2198),
    [anon_sym_boolean] = ACTIONS(2198),
    [anon_sym_async] = ACTIONS(2198),
    [anon_sym_public] = ACTIONS(2198),
    [anon_sym_var] = ACTIONS(2198),
    [anon_sym_while] = ACTIONS(2198),
    [anon_sym_SQUOTE] = ACTIONS(2200),
    [anon_sym_try] = ACTIONS(2198),
    [anon_sym_LT] = ACTIONS(2200),
    [sym_number] = ACTIONS(2200),
    [anon_sym_SLASH] = ACTIONS(2198),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2198),
    [anon_sym_function] = ACTIONS(2198),
    [sym_undefined] = ACTIONS(2198),
    [anon_sym_new] = ACTIONS(2198),
    [ts_builtin_sym_end] = ACTIONS(2200),
    [anon_sym_let] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2198),
    [anon_sym_export] = ACTIONS(2198),
    [anon_sym_do] = ACTIONS(2198),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_with] = ACTIONS(2198),
  },
  [482] = {
    [aux_sym_variable_declaration_repeat1] = STATE(597),
    [sym__automatic_semicolon] = ACTIONS(2202),
    [anon_sym_SEMI] = ACTIONS(2202),
    [anon_sym_COMMA] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
  },
  [483] = {
    [sym_identifier] = ACTIONS(2204),
    [anon_sym_BQUOTE] = ACTIONS(2206),
    [anon_sym_debugger] = ACTIONS(2204),
    [anon_sym_symbol] = ACTIONS(2204),
    [anon_sym_AT] = ACTIONS(2206),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_void] = ACTIONS(2204),
    [anon_sym_break] = ACTIONS(2204),
    [anon_sym_const] = ACTIONS(2204),
    [sym_super] = ACTIONS(2204),
    [anon_sym_return] = ACTIONS(2204),
    [anon_sym_private] = ACTIONS(2204),
    [anon_sym_get] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(2206),
    [anon_sym_interface] = ACTIONS(2204),
    [anon_sym_default] = ACTIONS(2204),
    [anon_sym_enum] = ACTIONS(2204),
    [anon_sym_delete] = ACTIONS(2204),
    [anon_sym_continue] = ACTIONS(2204),
    [anon_sym_DASH_DASH] = ACTIONS(2206),
    [anon_sym_if] = ACTIONS(2204),
    [anon_sym_this] = ACTIONS(2204),
    [anon_sym_yield] = ACTIONS(2204),
    [sym_true] = ACTIONS(2204),
    [anon_sym_throw] = ACTIONS(2204),
    [anon_sym_protected] = ACTIONS(2204),
    [anon_sym_abstract] = ACTIONS(2204),
    [anon_sym_set] = ACTIONS(2204),
    [anon_sym_type] = ACTIONS(2204),
    [anon_sym_import] = ACTIONS(2204),
    [anon_sym_namespace] = ACTIONS(2204),
    [anon_sym_PLUS_PLUS] = ACTIONS(2206),
    [anon_sym_await] = ACTIONS(2204),
    [anon_sym_DQUOTE] = ACTIONS(2206),
    [anon_sym_else] = ACTIONS(2204),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_for] = ACTIONS(2204),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [sym_false] = ACTIONS(2204),
    [anon_sym_SEMI] = ACTIONS(2206),
    [anon_sym_case] = ACTIONS(2204),
    [anon_sym_module] = ACTIONS(2204),
    [anon_sym_number] = ACTIONS(2204),
    [anon_sym_class] = ACTIONS(2204),
    [anon_sym_declare] = ACTIONS(2204),
    [anon_sym_typeof] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(2206),
    [anon_sym_switch] = ACTIONS(2204),
    [anon_sym_LPAREN] = ACTIONS(2206),
    [sym_null] = ACTIONS(2204),
    [anon_sym_any] = ACTIONS(2204),
    [anon_sym_boolean] = ACTIONS(2204),
    [anon_sym_async] = ACTIONS(2204),
    [anon_sym_public] = ACTIONS(2204),
    [anon_sym_var] = ACTIONS(2204),
    [anon_sym_while] = ACTIONS(2204),
    [anon_sym_SQUOTE] = ACTIONS(2206),
    [anon_sym_try] = ACTIONS(2204),
    [anon_sym_LT] = ACTIONS(2206),
    [sym_number] = ACTIONS(2206),
    [anon_sym_SLASH] = ACTIONS(2204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2204),
    [anon_sym_function] = ACTIONS(2204),
    [sym_undefined] = ACTIONS(2204),
    [anon_sym_new] = ACTIONS(2204),
    [ts_builtin_sym_end] = ACTIONS(2206),
    [anon_sym_let] = ACTIONS(2204),
    [anon_sym_PLUS] = ACTIONS(2204),
    [anon_sym_export] = ACTIONS(2204),
    [anon_sym_do] = ACTIONS(2204),
    [anon_sym_TILDE] = ACTIONS(2206),
    [anon_sym_with] = ACTIONS(2204),
  },
  [484] = {
    [aux_sym_string_repeat2] = STATE(484),
    [sym_escape_sequence] = ACTIONS(2208),
    [aux_sym_string_token2] = ACTIONS(2208),
    [sym_comment] = ACTIONS(256),
    [anon_sym_SQUOTE] = ACTIONS(2211),
  },
  [485] = {
    [anon_sym_BQUOTE] = ACTIONS(1033),
    [anon_sym_symbol] = ACTIONS(1029),
    [anon_sym_break] = ACTIONS(1029),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_interface] = ACTIONS(1029),
    [anon_sym_delete] = ACTIONS(1029),
    [anon_sym_if] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1029),
    [sym_true] = ACTIONS(1029),
    [anon_sym_protected] = ACTIONS(1029),
    [anon_sym_set] = ACTIONS(1029),
    [anon_sym_import] = ACTIONS(1029),
    [anon_sym_await] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(1033),
    [anon_sym_for] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1033),
    [anon_sym_number] = ACTIONS(1029),
    [anon_sym_typeof] = ACTIONS(1029),
    [anon_sym_LBRACE] = ACTIONS(1033),
    [anon_sym_switch] = ACTIONS(1029),
    [sym_null] = ACTIONS(1029),
    [anon_sym_catch] = ACTIONS(1029),
    [anon_sym_any] = ACTIONS(1029),
    [anon_sym_async] = ACTIONS(1029),
    [anon_sym_public] = ACTIONS(1029),
    [anon_sym_var] = ACTIONS(1029),
    [anon_sym_while] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(1033),
    [anon_sym_SLASH] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1029),
    [anon_sym_new] = ACTIONS(1029),
    [anon_sym_export] = ACTIONS(1029),
    [anon_sym_with] = ACTIONS(1029),
    [sym_identifier] = ACTIONS(1029),
    [anon_sym_debugger] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(1033),
    [anon_sym_COMMA] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1029),
    [anon_sym_void] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1029),
    [sym_super] = ACTIONS(1029),
    [anon_sym_private] = ACTIONS(1029),
    [anon_sym_get] = ACTIONS(1029),
    [anon_sym_default] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(1029),
    [anon_sym_continue] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1033),
    [anon_sym_this] = ACTIONS(1029),
    [anon_sym_throw] = ACTIONS(1029),
    [anon_sym_abstract] = ACTIONS(1029),
    [anon_sym_type] = ACTIONS(1029),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_else] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1033),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [sym_false] = ACTIONS(1029),
    [anon_sym_case] = ACTIONS(1029),
    [anon_sym_module] = ACTIONS(1029),
    [anon_sym_class] = ACTIONS(1029),
    [anon_sym_declare] = ACTIONS(1029),
    [anon_sym_LPAREN] = ACTIONS(1033),
    [anon_sym_boolean] = ACTIONS(1029),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_LT] = ACTIONS(1033),
    [sym_number] = ACTIONS(1033),
    [anon_sym_finally] = ACTIONS(1029),
    [ts_builtin_sym_end] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1029),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_let] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1029),
    [anon_sym_do] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(1033),
  },
  [486] = {
    [sym_statement_block] = STATE(747),
    [anon_sym_LPAREN] = ACTIONS(2213),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [487] = {
    [sym_statement_block] = STATE(748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [488] = {
    [sym_finally_clause] = STATE(749),
    [sym_identifier] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [anon_sym_debugger] = ACTIONS(2215),
    [anon_sym_symbol] = ACTIONS(2215),
    [anon_sym_AT] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2215),
    [anon_sym_void] = ACTIONS(2215),
    [anon_sym_break] = ACTIONS(2215),
    [anon_sym_const] = ACTIONS(2215),
    [sym_super] = ACTIONS(2215),
    [anon_sym_return] = ACTIONS(2215),
    [anon_sym_private] = ACTIONS(2215),
    [anon_sym_get] = ACTIONS(2215),
    [anon_sym_RBRACE] = ACTIONS(2217),
    [anon_sym_interface] = ACTIONS(2215),
    [anon_sym_default] = ACTIONS(2215),
    [anon_sym_enum] = ACTIONS(2215),
    [anon_sym_delete] = ACTIONS(2215),
    [anon_sym_continue] = ACTIONS(2215),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_if] = ACTIONS(2215),
    [anon_sym_this] = ACTIONS(2215),
    [anon_sym_yield] = ACTIONS(2215),
    [sym_true] = ACTIONS(2215),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_protected] = ACTIONS(2215),
    [anon_sym_abstract] = ACTIONS(2215),
    [anon_sym_set] = ACTIONS(2215),
    [anon_sym_type] = ACTIONS(2215),
    [anon_sym_import] = ACTIONS(2215),
    [anon_sym_namespace] = ACTIONS(2215),
    [anon_sym_PLUS_PLUS] = ACTIONS(2217),
    [anon_sym_await] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(2215),
    [anon_sym_BANG] = ACTIONS(2217),
    [anon_sym_for] = ACTIONS(2215),
    [anon_sym_LBRACK] = ACTIONS(2217),
    [sym_false] = ACTIONS(2215),
    [anon_sym_SEMI] = ACTIONS(2217),
    [anon_sym_case] = ACTIONS(2215),
    [anon_sym_module] = ACTIONS(2215),
    [anon_sym_number] = ACTIONS(2215),
    [anon_sym_class] = ACTIONS(2215),
    [anon_sym_declare] = ACTIONS(2215),
    [anon_sym_typeof] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_switch] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [sym_null] = ACTIONS(2215),
    [anon_sym_any] = ACTIONS(2215),
    [anon_sym_boolean] = ACTIONS(2215),
    [anon_sym_async] = ACTIONS(2215),
    [anon_sym_public] = ACTIONS(2215),
    [anon_sym_var] = ACTIONS(2215),
    [anon_sym_while] = ACTIONS(2215),
    [anon_sym_SQUOTE] = ACTIONS(2217),
    [anon_sym_try] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2217),
    [sym_number] = ACTIONS(2217),
    [anon_sym_SLASH] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(1194),
    [anon_sym_string] = ACTIONS(2215),
    [anon_sym_function] = ACTIONS(2215),
    [sym_undefined] = ACTIONS(2215),
    [anon_sym_new] = ACTIONS(2215),
    [ts_builtin_sym_end] = ACTIONS(2217),
    [anon_sym_let] = ACTIONS(2215),
    [anon_sym_PLUS] = ACTIONS(2215),
    [anon_sym_export] = ACTIONS(2215),
    [anon_sym_do] = ACTIONS(2215),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_with] = ACTIONS(2215),
  },
  [489] = {
    [sym_identifier] = ACTIONS(2215),
    [anon_sym_BQUOTE] = ACTIONS(2217),
    [anon_sym_debugger] = ACTIONS(2215),
    [anon_sym_symbol] = ACTIONS(2215),
    [anon_sym_AT] = ACTIONS(2217),
    [anon_sym_DASH] = ACTIONS(2215),
    [anon_sym_void] = ACTIONS(2215),
    [anon_sym_break] = ACTIONS(2215),
    [anon_sym_const] = ACTIONS(2215),
    [sym_super] = ACTIONS(2215),
    [anon_sym_return] = ACTIONS(2215),
    [anon_sym_private] = ACTIONS(2215),
    [anon_sym_get] = ACTIONS(2215),
    [anon_sym_RBRACE] = ACTIONS(2217),
    [anon_sym_interface] = ACTIONS(2215),
    [anon_sym_default] = ACTIONS(2215),
    [anon_sym_enum] = ACTIONS(2215),
    [anon_sym_delete] = ACTIONS(2215),
    [anon_sym_continue] = ACTIONS(2215),
    [anon_sym_DASH_DASH] = ACTIONS(2217),
    [anon_sym_if] = ACTIONS(2215),
    [anon_sym_this] = ACTIONS(2215),
    [anon_sym_yield] = ACTIONS(2215),
    [sym_true] = ACTIONS(2215),
    [anon_sym_throw] = ACTIONS(2215),
    [anon_sym_protected] = ACTIONS(2215),
    [anon_sym_abstract] = ACTIONS(2215),
    [anon_sym_set] = ACTIONS(2215),
    [anon_sym_type] = ACTIONS(2215),
    [anon_sym_import] = ACTIONS(2215),
    [anon_sym_namespace] = ACTIONS(2215),
    [anon_sym_PLUS_PLUS] = ACTIONS(2217),
    [anon_sym_await] = ACTIONS(2215),
    [anon_sym_DQUOTE] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(2215),
    [anon_sym_BANG] = ACTIONS(2217),
    [anon_sym_for] = ACTIONS(2215),
    [anon_sym_LBRACK] = ACTIONS(2217),
    [sym_false] = ACTIONS(2215),
    [anon_sym_SEMI] = ACTIONS(2217),
    [anon_sym_case] = ACTIONS(2215),
    [anon_sym_module] = ACTIONS(2215),
    [anon_sym_number] = ACTIONS(2215),
    [anon_sym_class] = ACTIONS(2215),
    [anon_sym_declare] = ACTIONS(2215),
    [anon_sym_typeof] = ACTIONS(2215),
    [anon_sym_LBRACE] = ACTIONS(2217),
    [anon_sym_switch] = ACTIONS(2215),
    [anon_sym_LPAREN] = ACTIONS(2217),
    [sym_null] = ACTIONS(2215),
    [anon_sym_any] = ACTIONS(2215),
    [anon_sym_boolean] = ACTIONS(2215),
    [anon_sym_async] = ACTIONS(2215),
    [anon_sym_public] = ACTIONS(2215),
    [anon_sym_var] = ACTIONS(2215),
    [anon_sym_while] = ACTIONS(2215),
    [anon_sym_SQUOTE] = ACTIONS(2217),
    [anon_sym_try] = ACTIONS(2215),
    [anon_sym_LT] = ACTIONS(2217),
    [sym_number] = ACTIONS(2217),
    [anon_sym_SLASH] = ACTIONS(2215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2215),
    [anon_sym_function] = ACTIONS(2215),
    [sym_undefined] = ACTIONS(2215),
    [anon_sym_new] = ACTIONS(2215),
    [ts_builtin_sym_end] = ACTIONS(2217),
    [anon_sym_let] = ACTIONS(2215),
    [anon_sym_PLUS] = ACTIONS(2215),
    [anon_sym_export] = ACTIONS(2215),
    [anon_sym_do] = ACTIONS(2215),
    [anon_sym_TILDE] = ACTIONS(2217),
    [anon_sym_with] = ACTIONS(2215),
  },
  [490] = {
    [sym_tuple_type] = STATE(237),
    [sym__type] = STATE(750),
    [sym_constructor_type] = STATE(750),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_array_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_function_type] = STATE(750),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_nested_identifier] = STATE(236),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(750),
    [sym_intersection_type] = STATE(750),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_this] = ACTIONS(464),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_keyof] = ACTIONS(472),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_boolean] = ACTIONS(462),
  },
  [491] = {
    [sym_tuple_type] = STATE(237),
    [sym__type] = STATE(751),
    [sym_constructor_type] = STATE(751),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_array_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_function_type] = STATE(751),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_nested_identifier] = STATE(236),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(751),
    [sym_intersection_type] = STATE(751),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_this] = ACTIONS(464),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_keyof] = ACTIONS(472),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_PIPE] = ACTIONS(484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_boolean] = ACTIONS(462),
  },
  [492] = {
    [sym__type] = STATE(752),
    [sym_constructor_type] = STATE(752),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(752),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(752),
    [sym_intersection_type] = STATE(752),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [493] = {
    [sym_identifier] = ACTIONS(2219),
    [sym_comment] = ACTIONS(3),
  },
  [494] = {
    [sym__type] = STATE(754),
    [sym_constructor_type] = STATE(754),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(754),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(754),
    [sym_intersection_type] = STATE(754),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [495] = {
    [sym__type] = STATE(755),
    [sym_constructor_type] = STATE(755),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(755),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(755),
    [sym_intersection_type] = STATE(755),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [496] = {
    [sym_default_type] = STATE(756),
    [anon_sym_GT] = ACTIONS(2221),
    [anon_sym_EQ] = ACTIONS(1196),
    [anon_sym_COMMA] = ACTIONS(2221),
    [sym_comment] = ACTIONS(3),
  },
  [497] = {
    [anon_sym_BQUOTE] = ACTIONS(2223),
    [anon_sym_symbol] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(2223),
    [anon_sym_break] = ACTIONS(2225),
    [anon_sym_return] = ACTIONS(2225),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_interface] = ACTIONS(2225),
    [anon_sym_delete] = ACTIONS(2225),
    [anon_sym_if] = ACTIONS(2225),
    [anon_sym_yield] = ACTIONS(2225),
    [sym_true] = ACTIONS(2225),
    [anon_sym_protected] = ACTIONS(2225),
    [anon_sym_set] = ACTIONS(2225),
    [anon_sym_import] = ACTIONS(2225),
    [anon_sym_await] = ACTIONS(2225),
    [anon_sym_DQUOTE] = ACTIONS(2223),
    [anon_sym_for] = ACTIONS(2225),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_number] = ACTIONS(2225),
    [anon_sym_typeof] = ACTIONS(2225),
    [anon_sym_LBRACE] = ACTIONS(2225),
    [anon_sym_switch] = ACTIONS(2225),
    [anon_sym_RBRACK] = ACTIONS(2223),
    [sym_null] = ACTIONS(2225),
    [anon_sym_any] = ACTIONS(2225),
    [anon_sym_async] = ACTIONS(2225),
    [anon_sym_public] = ACTIONS(2225),
    [anon_sym_var] = ACTIONS(2225),
    [anon_sym_while] = ACTIONS(2225),
    [anon_sym_SQUOTE] = ACTIONS(2223),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_SLASH] = ACTIONS(2225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2225),
    [anon_sym_new] = ACTIONS(2225),
    [anon_sym_export] = ACTIONS(2225),
    [anon_sym_with] = ACTIONS(2225),
    [sym_identifier] = ACTIONS(2225),
    [anon_sym_debugger] = ACTIONS(2225),
    [anon_sym_AT] = ACTIONS(2223),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_EQ] = ACTIONS(2225),
    [anon_sym_void] = ACTIONS(2225),
    [anon_sym_const] = ACTIONS(2225),
    [sym_super] = ACTIONS(2225),
    [anon_sym_private] = ACTIONS(2225),
    [anon_sym_get] = ACTIONS(2225),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2223),
    [anon_sym_default] = ACTIONS(2225),
    [anon_sym_enum] = ACTIONS(2225),
    [anon_sym_continue] = ACTIONS(2225),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_this] = ACTIONS(2225),
    [anon_sym_throw] = ACTIONS(2225),
    [anon_sym_abstract] = ACTIONS(2225),
    [anon_sym_type] = ACTIONS(2225),
    [anon_sym_namespace] = ACTIONS(2225),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_else] = ACTIONS(2225),
    [anon_sym_BANG] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [sym_false] = ACTIONS(2225),
    [anon_sym_case] = ACTIONS(2225),
    [anon_sym_module] = ACTIONS(2225),
    [anon_sym_class] = ACTIONS(2225),
    [anon_sym_declare] = ACTIONS(2225),
    [anon_sym_LPAREN] = ACTIONS(2223),
    [anon_sym_GT] = ACTIONS(2223),
    [anon_sym_boolean] = ACTIONS(2225),
    [anon_sym_EQ_GT] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_try] = ACTIONS(2225),
    [anon_sym_LT] = ACTIONS(2223),
    [sym_number] = ACTIONS(2223),
    [ts_builtin_sym_end] = ACTIONS(2223),
    [anon_sym_function] = ACTIONS(2225),
    [sym_undefined] = ACTIONS(2225),
    [anon_sym_let] = ACTIONS(2225),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_implements] = ACTIONS(2225),
    [anon_sym_do] = ACTIONS(2225),
    [anon_sym_TILDE] = ACTIONS(2223),
  },
  [498] = {
    [anon_sym_COMMA] = ACTIONS(2221),
    [anon_sym_GT] = ACTIONS(2221),
    [sym_comment] = ACTIONS(3),
  },
  [499] = {
    [sym__type] = STATE(527),
    [sym_constructor_type] = STATE(527),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(527),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(527),
    [sym_intersection_type] = STATE(527),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [500] = {
    [anon_sym_BQUOTE] = ACTIONS(2227),
    [anon_sym_symbol] = ACTIONS(2229),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_break] = ACTIONS(2229),
    [anon_sym_return] = ACTIONS(2229),
    [anon_sym_RBRACE] = ACTIONS(2227),
    [anon_sym_interface] = ACTIONS(2229),
    [anon_sym_delete] = ACTIONS(2229),
    [anon_sym_if] = ACTIONS(2229),
    [anon_sym_yield] = ACTIONS(2229),
    [sym_true] = ACTIONS(2229),
    [anon_sym_protected] = ACTIONS(2229),
    [anon_sym_set] = ACTIONS(2229),
    [anon_sym_import] = ACTIONS(2229),
    [anon_sym_await] = ACTIONS(2229),
    [anon_sym_DQUOTE] = ACTIONS(2227),
    [anon_sym_for] = ACTIONS(2229),
    [anon_sym_SEMI] = ACTIONS(2227),
    [anon_sym_number] = ACTIONS(2229),
    [anon_sym_typeof] = ACTIONS(2229),
    [anon_sym_LBRACE] = ACTIONS(2227),
    [anon_sym_switch] = ACTIONS(2229),
    [anon_sym_RBRACK] = ACTIONS(2227),
    [sym_null] = ACTIONS(2229),
    [anon_sym_any] = ACTIONS(2229),
    [anon_sym_async] = ACTIONS(2229),
    [anon_sym_public] = ACTIONS(2229),
    [anon_sym_var] = ACTIONS(2229),
    [anon_sym_while] = ACTIONS(2229),
    [anon_sym_SQUOTE] = ACTIONS(2227),
    [anon_sym_RPAREN] = ACTIONS(2227),
    [anon_sym_SLASH] = ACTIONS(2229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2229),
    [anon_sym_new] = ACTIONS(2229),
    [anon_sym_export] = ACTIONS(2229),
    [anon_sym_with] = ACTIONS(2229),
    [sym_identifier] = ACTIONS(2229),
    [anon_sym_debugger] = ACTIONS(2229),
    [anon_sym_AT] = ACTIONS(2227),
    [anon_sym_COMMA] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_EQ] = ACTIONS(2229),
    [anon_sym_void] = ACTIONS(2229),
    [anon_sym_const] = ACTIONS(2229),
    [sym_super] = ACTIONS(2229),
    [anon_sym_private] = ACTIONS(2229),
    [anon_sym_get] = ACTIONS(2229),
    [anon_sym_default] = ACTIONS(2229),
    [anon_sym_enum] = ACTIONS(2229),
    [anon_sym_continue] = ACTIONS(2229),
    [anon_sym_DASH_DASH] = ACTIONS(2227),
    [anon_sym_this] = ACTIONS(2229),
    [anon_sym_throw] = ACTIONS(2229),
    [anon_sym_abstract] = ACTIONS(2229),
    [anon_sym_type] = ACTIONS(2229),
    [anon_sym_namespace] = ACTIONS(2229),
    [anon_sym_PLUS_PLUS] = ACTIONS(2227),
    [anon_sym_else] = ACTIONS(2229),
    [anon_sym_BANG] = ACTIONS(2227),
    [anon_sym_LBRACK] = ACTIONS(1297),
    [sym_false] = ACTIONS(2229),
    [anon_sym_case] = ACTIONS(2229),
    [anon_sym_module] = ACTIONS(2229),
    [anon_sym_class] = ACTIONS(2229),
    [anon_sym_declare] = ACTIONS(2229),
    [anon_sym_LPAREN] = ACTIONS(2227),
    [anon_sym_GT] = ACTIONS(2227),
    [anon_sym_boolean] = ACTIONS(2229),
    [anon_sym_EQ_GT] = ACTIONS(2227),
    [anon_sym_AMP] = ACTIONS(2227),
    [anon_sym_try] = ACTIONS(2229),
    [anon_sym_LT] = ACTIONS(2227),
    [sym_number] = ACTIONS(2227),
    [ts_builtin_sym_end] = ACTIONS(2227),
    [anon_sym_function] = ACTIONS(2229),
    [sym_undefined] = ACTIONS(2229),
    [anon_sym_let] = ACTIONS(2229),
    [anon_sym_PLUS] = ACTIONS(2229),
    [anon_sym_do] = ACTIONS(2229),
    [anon_sym_TILDE] = ACTIONS(2227),
  },
  [501] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(757),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(757),
    [sym_call_signature] = STATE(757),
    [sym_construct_signature] = STATE(757),
    [sym_index_signature] = STATE(757),
    [sym_export_statement] = STATE(757),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [502] = {
    [sym_string] = STATE(758),
    [sym__property_name] = STATE(758),
    [sym_computed_property_name] = STATE(758),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [503] = {
    [sym_string] = STATE(763),
    [sym__property_name] = STATE(763),
    [sym_computed_property_name] = STATE(763),
    [anon_sym_get] = ACTIONS(2233),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(2235),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(2233),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [sym_readonly] = ACTIONS(2241),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [504] = {
    [sym_string] = STATE(758),
    [sym__property_name] = STATE(758),
    [sym_computed_property_name] = STATE(758),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(2239),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(2243),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(2243),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [505] = {
    [sym_string] = STATE(758),
    [sym__property_name] = STATE(758),
    [sym_computed_property_name] = STATE(758),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(2231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [506] = {
    [anon_sym_BQUOTE] = ACTIONS(2245),
    [anon_sym_symbol] = ACTIONS(2247),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(2247),
    [anon_sym_return] = ACTIONS(2247),
    [anon_sym_RBRACE] = ACTIONS(2245),
    [anon_sym_interface] = ACTIONS(2247),
    [anon_sym_delete] = ACTIONS(2247),
    [anon_sym_if] = ACTIONS(2247),
    [anon_sym_yield] = ACTIONS(2247),
    [sym_true] = ACTIONS(2247),
    [anon_sym_protected] = ACTIONS(2247),
    [anon_sym_set] = ACTIONS(2247),
    [anon_sym_import] = ACTIONS(2247),
    [anon_sym_await] = ACTIONS(2247),
    [anon_sym_DQUOTE] = ACTIONS(2245),
    [anon_sym_for] = ACTIONS(2247),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym_number] = ACTIONS(2247),
    [anon_sym_typeof] = ACTIONS(2247),
    [anon_sym_LBRACE] = ACTIONS(2245),
    [anon_sym_switch] = ACTIONS(2247),
    [anon_sym_RBRACK] = ACTIONS(2245),
    [sym_null] = ACTIONS(2247),
    [anon_sym_any] = ACTIONS(2247),
    [anon_sym_async] = ACTIONS(2247),
    [anon_sym_public] = ACTIONS(2247),
    [anon_sym_var] = ACTIONS(2247),
    [anon_sym_while] = ACTIONS(2247),
    [anon_sym_SQUOTE] = ACTIONS(2245),
    [anon_sym_RPAREN] = ACTIONS(2245),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2247),
    [anon_sym_new] = ACTIONS(2247),
    [anon_sym_export] = ACTIONS(2247),
    [anon_sym_with] = ACTIONS(2247),
    [sym_identifier] = ACTIONS(2247),
    [anon_sym_debugger] = ACTIONS(2247),
    [anon_sym_AT] = ACTIONS(2245),
    [anon_sym_COMMA] = ACTIONS(2245),
    [anon_sym_DASH] = ACTIONS(2247),
    [anon_sym_EQ] = ACTIONS(2247),
    [anon_sym_void] = ACTIONS(2247),
    [anon_sym_const] = ACTIONS(2247),
    [sym_super] = ACTIONS(2247),
    [anon_sym_private] = ACTIONS(2247),
    [anon_sym_get] = ACTIONS(2247),
    [anon_sym_default] = ACTIONS(2247),
    [anon_sym_enum] = ACTIONS(2247),
    [anon_sym_continue] = ACTIONS(2247),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_this] = ACTIONS(2247),
    [anon_sym_throw] = ACTIONS(2247),
    [anon_sym_abstract] = ACTIONS(2247),
    [anon_sym_type] = ACTIONS(2247),
    [anon_sym_namespace] = ACTIONS(2247),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_else] = ACTIONS(2247),
    [anon_sym_BANG] = ACTIONS(2245),
    [anon_sym_LBRACK] = ACTIONS(2245),
    [sym_false] = ACTIONS(2247),
    [anon_sym_case] = ACTIONS(2247),
    [anon_sym_module] = ACTIONS(2247),
    [anon_sym_class] = ACTIONS(2247),
    [anon_sym_declare] = ACTIONS(2247),
    [anon_sym_LPAREN] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2245),
    [anon_sym_boolean] = ACTIONS(2247),
    [anon_sym_EQ_GT] = ACTIONS(2245),
    [anon_sym_AMP] = ACTIONS(2245),
    [anon_sym_try] = ACTIONS(2247),
    [anon_sym_LT] = ACTIONS(2245),
    [sym_number] = ACTIONS(2245),
    [ts_builtin_sym_end] = ACTIONS(2245),
    [anon_sym_function] = ACTIONS(2247),
    [sym_undefined] = ACTIONS(2247),
    [anon_sym_let] = ACTIONS(2247),
    [anon_sym_PLUS] = ACTIONS(2247),
    [anon_sym_do] = ACTIONS(2247),
    [anon_sym_TILDE] = ACTIONS(2245),
  },
  [507] = {
    [sym_formal_parameters] = STATE(764),
    [sym_type_parameters] = STATE(765),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [508] = {
    [sym_type_alias_declaration] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(1763),
    [sym__declaration] = STATE(1271),
    [sym_ambient_declaration] = STATE(1271),
    [sym_import_alias] = STATE(1271),
    [sym_export_statement] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_export_clause] = STATE(1801),
    [sym_lexical_declaration] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_decorator] = STATE(1763),
    [sym_enum_declaration] = STATE(1271),
    [sym_function] = STATE(1271),
    [sym_function_signature] = STATE(1271),
    [sym_variable_declaration] = STATE(1271),
    [sym_abstract_class] = STATE(1271),
    [sym_module] = STATE(1271),
    [sym_interface_declaration] = STATE(1271),
    [sym_class] = STATE(1271),
    [sym__automatic_semicolon] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(2249),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2253),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_EQ] = ACTIONS(2257),
    [anon_sym_const] = ACTIONS(2259),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_async] = ACTIONS(2261),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_var] = ACTIONS(2263),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_interface] = ACTIONS(2265),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2269),
    [anon_sym_as] = ACTIONS(2271),
    [anon_sym_LT] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_abstract] = ACTIONS(2275),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(2277),
    [anon_sym_let] = ACTIONS(2279),
    [anon_sym_import] = ACTIONS(2281),
    [anon_sym_export] = ACTIONS(2283),
    [anon_sym_namespace] = ACTIONS(2285),
  },
  [509] = {
    [sym_string] = STATE(763),
    [sym__property_name] = STATE(763),
    [sym_computed_property_name] = STATE(763),
    [anon_sym_get] = ACTIONS(2233),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(2233),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(2235),
  },
  [510] = {
    [aux_sym_export_statement_repeat1] = STATE(284),
    [sym_decorator] = STATE(284),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(2287),
    [sym_comment] = ACTIONS(3),
  },
  [511] = {
    [sym_call_signature] = STATE(767),
    [sym_type_annotation] = STATE(768),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(2289),
    [anon_sym_RBRACE] = ACTIONS(2289),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(2289),
    [anon_sym_QMARK] = ACTIONS(2291),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2289),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(2289),
    [sym_comment] = ACTIONS(3),
  },
  [512] = {
    [sym_string] = STATE(763),
    [sym__property_name] = STATE(763),
    [sym_computed_property_name] = STATE(763),
    [anon_sym_get] = ACTIONS(2233),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(2235),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(2237),
    [anon_sym_STAR] = ACTIONS(2239),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(2233),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [sym_readonly] = ACTIONS(2241),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(2293),
    [anon_sym_private] = ACTIONS(919),
  },
  [513] = {
    [aux_sym_object_type_repeat1] = STATE(772),
    [sym__automatic_semicolon] = ACTIONS(2295),
    [anon_sym_RBRACE] = ACTIONS(2297),
    [anon_sym_SEMI] = ACTIONS(2295),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
  },
  [514] = {
    [aux_sym_implements_clause_repeat1] = STATE(774),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_RBRACK] = ACTIONS(2299),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(1954),
    [sym_comment] = ACTIONS(3),
  },
  [515] = {
    [anon_sym_BQUOTE] = ACTIONS(2301),
    [anon_sym_symbol] = ACTIONS(2303),
    [anon_sym_PIPE] = ACTIONS(2301),
    [anon_sym_break] = ACTIONS(2303),
    [anon_sym_return] = ACTIONS(2303),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_interface] = ACTIONS(2303),
    [anon_sym_delete] = ACTIONS(2303),
    [anon_sym_if] = ACTIONS(2303),
    [anon_sym_yield] = ACTIONS(2303),
    [sym_true] = ACTIONS(2303),
    [anon_sym_protected] = ACTIONS(2303),
    [anon_sym_set] = ACTIONS(2303),
    [anon_sym_import] = ACTIONS(2303),
    [anon_sym_await] = ACTIONS(2303),
    [anon_sym_DQUOTE] = ACTIONS(2301),
    [anon_sym_for] = ACTIONS(2303),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_number] = ACTIONS(2303),
    [anon_sym_typeof] = ACTIONS(2303),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [anon_sym_switch] = ACTIONS(2303),
    [anon_sym_RBRACK] = ACTIONS(2301),
    [sym_null] = ACTIONS(2303),
    [anon_sym_any] = ACTIONS(2303),
    [anon_sym_async] = ACTIONS(2303),
    [anon_sym_public] = ACTIONS(2303),
    [anon_sym_var] = ACTIONS(2303),
    [anon_sym_while] = ACTIONS(2303),
    [anon_sym_SQUOTE] = ACTIONS(2301),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_SLASH] = ACTIONS(2303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2303),
    [anon_sym_new] = ACTIONS(2303),
    [anon_sym_export] = ACTIONS(2303),
    [anon_sym_with] = ACTIONS(2303),
    [sym_identifier] = ACTIONS(2303),
    [anon_sym_debugger] = ACTIONS(2303),
    [anon_sym_AT] = ACTIONS(2301),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_DASH] = ACTIONS(2303),
    [anon_sym_EQ] = ACTIONS(2303),
    [anon_sym_void] = ACTIONS(2303),
    [anon_sym_const] = ACTIONS(2303),
    [sym_super] = ACTIONS(2303),
    [anon_sym_private] = ACTIONS(2303),
    [anon_sym_get] = ACTIONS(2303),
    [anon_sym_default] = ACTIONS(2303),
    [anon_sym_enum] = ACTIONS(2303),
    [anon_sym_continue] = ACTIONS(2303),
    [anon_sym_DASH_DASH] = ACTIONS(2301),
    [anon_sym_this] = ACTIONS(2303),
    [anon_sym_throw] = ACTIONS(2303),
    [anon_sym_abstract] = ACTIONS(2303),
    [anon_sym_type] = ACTIONS(2303),
    [anon_sym_namespace] = ACTIONS(2303),
    [anon_sym_PLUS_PLUS] = ACTIONS(2301),
    [anon_sym_else] = ACTIONS(2303),
    [anon_sym_BANG] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [sym_false] = ACTIONS(2303),
    [anon_sym_case] = ACTIONS(2303),
    [anon_sym_module] = ACTIONS(2303),
    [anon_sym_class] = ACTIONS(2303),
    [anon_sym_declare] = ACTIONS(2303),
    [anon_sym_LPAREN] = ACTIONS(2301),
    [anon_sym_GT] = ACTIONS(2301),
    [anon_sym_boolean] = ACTIONS(2303),
    [anon_sym_EQ_GT] = ACTIONS(2301),
    [anon_sym_AMP] = ACTIONS(2301),
    [anon_sym_try] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(2301),
    [sym_number] = ACTIONS(2301),
    [ts_builtin_sym_end] = ACTIONS(2301),
    [anon_sym_function] = ACTIONS(2303),
    [sym_undefined] = ACTIONS(2303),
    [anon_sym_let] = ACTIONS(2303),
    [anon_sym_PLUS] = ACTIONS(2303),
    [anon_sym_do] = ACTIONS(2303),
    [anon_sym_TILDE] = ACTIONS(2301),
  },
  [516] = {
    [anon_sym_BQUOTE] = ACTIONS(2305),
    [anon_sym_symbol] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2305),
    [anon_sym_break] = ACTIONS(2307),
    [anon_sym_return] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_interface] = ACTIONS(2307),
    [anon_sym_delete] = ACTIONS(2307),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_yield] = ACTIONS(2307),
    [sym_true] = ACTIONS(2307),
    [anon_sym_protected] = ACTIONS(2307),
    [anon_sym_DOT] = ACTIONS(2309),
    [anon_sym_set] = ACTIONS(2307),
    [anon_sym_import] = ACTIONS(2307),
    [anon_sym_await] = ACTIONS(2307),
    [anon_sym_DQUOTE] = ACTIONS(2305),
    [anon_sym_for] = ACTIONS(2307),
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_number] = ACTIONS(2307),
    [anon_sym_typeof] = ACTIONS(2307),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_switch] = ACTIONS(2307),
    [anon_sym_RBRACK] = ACTIONS(2305),
    [sym_null] = ACTIONS(2307),
    [anon_sym_any] = ACTIONS(2307),
    [anon_sym_async] = ACTIONS(2307),
    [anon_sym_public] = ACTIONS(2307),
    [anon_sym_var] = ACTIONS(2307),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_SQUOTE] = ACTIONS(2305),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_SLASH] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2307),
    [anon_sym_new] = ACTIONS(2307),
    [anon_sym_export] = ACTIONS(2307),
    [anon_sym_with] = ACTIONS(2307),
    [sym_identifier] = ACTIONS(2307),
    [anon_sym_debugger] = ACTIONS(2307),
    [anon_sym_AT] = ACTIONS(2305),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_EQ] = ACTIONS(2307),
    [anon_sym_void] = ACTIONS(2307),
    [anon_sym_const] = ACTIONS(2307),
    [sym_super] = ACTIONS(2307),
    [anon_sym_private] = ACTIONS(2307),
    [anon_sym_get] = ACTIONS(2307),
    [anon_sym_default] = ACTIONS(2307),
    [anon_sym_enum] = ACTIONS(2307),
    [anon_sym_continue] = ACTIONS(2307),
    [anon_sym_DASH_DASH] = ACTIONS(2305),
    [anon_sym_this] = ACTIONS(2307),
    [anon_sym_throw] = ACTIONS(2307),
    [anon_sym_abstract] = ACTIONS(2307),
    [anon_sym_type] = ACTIONS(2307),
    [anon_sym_namespace] = ACTIONS(2307),
    [anon_sym_PLUS_PLUS] = ACTIONS(2305),
    [anon_sym_else] = ACTIONS(2307),
    [anon_sym_BANG] = ACTIONS(2305),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [sym_false] = ACTIONS(2307),
    [anon_sym_case] = ACTIONS(2307),
    [anon_sym_module] = ACTIONS(2307),
    [anon_sym_class] = ACTIONS(2307),
    [anon_sym_declare] = ACTIONS(2307),
    [anon_sym_LPAREN] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2305),
    [anon_sym_boolean] = ACTIONS(2307),
    [anon_sym_EQ_GT] = ACTIONS(2305),
    [anon_sym_AMP] = ACTIONS(2305),
    [anon_sym_try] = ACTIONS(2307),
    [anon_sym_LT] = ACTIONS(2305),
    [sym_number] = ACTIONS(2305),
    [ts_builtin_sym_end] = ACTIONS(2305),
    [anon_sym_function] = ACTIONS(2307),
    [sym_undefined] = ACTIONS(2307),
    [anon_sym_let] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(2307),
    [anon_sym_TILDE] = ACTIONS(2305),
  },
  [517] = {
    [anon_sym_BQUOTE] = ACTIONS(2311),
    [anon_sym_symbol] = ACTIONS(2313),
    [anon_sym_PIPE] = ACTIONS(2311),
    [anon_sym_break] = ACTIONS(2313),
    [anon_sym_return] = ACTIONS(2313),
    [anon_sym_RBRACE] = ACTIONS(2311),
    [anon_sym_interface] = ACTIONS(2313),
    [anon_sym_delete] = ACTIONS(2313),
    [anon_sym_if] = ACTIONS(2313),
    [anon_sym_yield] = ACTIONS(2313),
    [sym_true] = ACTIONS(2313),
    [anon_sym_protected] = ACTIONS(2313),
    [anon_sym_set] = ACTIONS(2313),
    [anon_sym_import] = ACTIONS(2313),
    [anon_sym_await] = ACTIONS(2313),
    [anon_sym_DQUOTE] = ACTIONS(2311),
    [anon_sym_for] = ACTIONS(2313),
    [anon_sym_SEMI] = ACTIONS(2311),
    [anon_sym_number] = ACTIONS(2313),
    [anon_sym_typeof] = ACTIONS(2313),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_switch] = ACTIONS(2313),
    [anon_sym_RBRACK] = ACTIONS(2311),
    [sym_null] = ACTIONS(2313),
    [anon_sym_any] = ACTIONS(2313),
    [anon_sym_async] = ACTIONS(2313),
    [anon_sym_public] = ACTIONS(2313),
    [anon_sym_var] = ACTIONS(2313),
    [anon_sym_while] = ACTIONS(2313),
    [anon_sym_SQUOTE] = ACTIONS(2311),
    [anon_sym_RPAREN] = ACTIONS(2311),
    [anon_sym_SLASH] = ACTIONS(2313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2313),
    [anon_sym_new] = ACTIONS(2313),
    [anon_sym_export] = ACTIONS(2313),
    [anon_sym_with] = ACTIONS(2313),
    [sym_identifier] = ACTIONS(2313),
    [anon_sym_debugger] = ACTIONS(2313),
    [anon_sym_AT] = ACTIONS(2311),
    [anon_sym_COMMA] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_EQ] = ACTIONS(2313),
    [anon_sym_void] = ACTIONS(2313),
    [anon_sym_const] = ACTIONS(2313),
    [sym_super] = ACTIONS(2313),
    [anon_sym_private] = ACTIONS(2313),
    [anon_sym_get] = ACTIONS(2313),
    [anon_sym_default] = ACTIONS(2313),
    [anon_sym_enum] = ACTIONS(2313),
    [anon_sym_continue] = ACTIONS(2313),
    [anon_sym_DASH_DASH] = ACTIONS(2311),
    [anon_sym_this] = ACTIONS(2313),
    [anon_sym_throw] = ACTIONS(2313),
    [anon_sym_abstract] = ACTIONS(2313),
    [anon_sym_type] = ACTIONS(2313),
    [anon_sym_namespace] = ACTIONS(2313),
    [anon_sym_PLUS_PLUS] = ACTIONS(2311),
    [anon_sym_else] = ACTIONS(2313),
    [anon_sym_BANG] = ACTIONS(2311),
    [anon_sym_LBRACK] = ACTIONS(2311),
    [sym_false] = ACTIONS(2313),
    [anon_sym_case] = ACTIONS(2313),
    [anon_sym_module] = ACTIONS(2313),
    [anon_sym_class] = ACTIONS(2313),
    [anon_sym_declare] = ACTIONS(2313),
    [anon_sym_LPAREN] = ACTIONS(2311),
    [anon_sym_GT] = ACTIONS(2311),
    [anon_sym_boolean] = ACTIONS(2313),
    [anon_sym_EQ_GT] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2311),
    [anon_sym_try] = ACTIONS(2313),
    [anon_sym_LT] = ACTIONS(2311),
    [sym_number] = ACTIONS(2311),
    [ts_builtin_sym_end] = ACTIONS(2311),
    [anon_sym_function] = ACTIONS(2313),
    [sym_undefined] = ACTIONS(2313),
    [anon_sym_let] = ACTIONS(2313),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_do] = ACTIONS(2313),
    [anon_sym_TILDE] = ACTIONS(2311),
  },
  [518] = {
    [anon_sym_EQ_GT] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(2315),
    [anon_sym_while] = ACTIONS(2315),
    [anon_sym_RPAREN] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_COMMA] = ACTIONS(2315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2315),
    [anon_sym_EQ] = ACTIONS(2317),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_RBRACK] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2315),
    [anon_sym_else] = ACTIONS(2315),
  },
  [519] = {
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_symbol] = ACTIONS(2321),
    [anon_sym_PIPE] = ACTIONS(2319),
    [anon_sym_break] = ACTIONS(2321),
    [anon_sym_return] = ACTIONS(2321),
    [anon_sym_RBRACE] = ACTIONS(2319),
    [anon_sym_interface] = ACTIONS(2321),
    [anon_sym_delete] = ACTIONS(2321),
    [anon_sym_if] = ACTIONS(2321),
    [anon_sym_yield] = ACTIONS(2321),
    [sym_true] = ACTIONS(2321),
    [anon_sym_protected] = ACTIONS(2321),
    [anon_sym_set] = ACTIONS(2321),
    [anon_sym_import] = ACTIONS(2321),
    [anon_sym_await] = ACTIONS(2321),
    [anon_sym_DQUOTE] = ACTIONS(2319),
    [anon_sym_for] = ACTIONS(2321),
    [anon_sym_SEMI] = ACTIONS(2319),
    [anon_sym_number] = ACTIONS(2321),
    [anon_sym_typeof] = ACTIONS(2321),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [anon_sym_switch] = ACTIONS(2321),
    [anon_sym_RBRACK] = ACTIONS(2319),
    [sym_null] = ACTIONS(2321),
    [anon_sym_any] = ACTIONS(2321),
    [anon_sym_async] = ACTIONS(2321),
    [anon_sym_public] = ACTIONS(2321),
    [anon_sym_var] = ACTIONS(2321),
    [anon_sym_while] = ACTIONS(2321),
    [anon_sym_SQUOTE] = ACTIONS(2319),
    [anon_sym_RPAREN] = ACTIONS(2319),
    [anon_sym_SLASH] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2321),
    [anon_sym_new] = ACTIONS(2321),
    [anon_sym_export] = ACTIONS(2321),
    [anon_sym_with] = ACTIONS(2321),
    [sym_identifier] = ACTIONS(2321),
    [anon_sym_debugger] = ACTIONS(2321),
    [anon_sym_AT] = ACTIONS(2319),
    [anon_sym_COMMA] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_EQ] = ACTIONS(2321),
    [anon_sym_void] = ACTIONS(2321),
    [anon_sym_const] = ACTIONS(2321),
    [sym_super] = ACTIONS(2321),
    [anon_sym_private] = ACTIONS(2321),
    [anon_sym_get] = ACTIONS(2321),
    [anon_sym_default] = ACTIONS(2321),
    [anon_sym_enum] = ACTIONS(2321),
    [anon_sym_continue] = ACTIONS(2321),
    [anon_sym_DASH_DASH] = ACTIONS(2319),
    [anon_sym_this] = ACTIONS(2321),
    [anon_sym_throw] = ACTIONS(2321),
    [anon_sym_abstract] = ACTIONS(2321),
    [anon_sym_type] = ACTIONS(2321),
    [anon_sym_namespace] = ACTIONS(2321),
    [anon_sym_PLUS_PLUS] = ACTIONS(2319),
    [anon_sym_else] = ACTIONS(2321),
    [anon_sym_BANG] = ACTIONS(2319),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [sym_false] = ACTIONS(2321),
    [anon_sym_case] = ACTIONS(2321),
    [anon_sym_module] = ACTIONS(2321),
    [anon_sym_class] = ACTIONS(2321),
    [anon_sym_declare] = ACTIONS(2321),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_GT] = ACTIONS(2319),
    [anon_sym_boolean] = ACTIONS(2321),
    [anon_sym_EQ_GT] = ACTIONS(2319),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_try] = ACTIONS(2321),
    [anon_sym_LT] = ACTIONS(2319),
    [sym_number] = ACTIONS(2319),
    [ts_builtin_sym_end] = ACTIONS(2319),
    [anon_sym_function] = ACTIONS(2321),
    [sym_undefined] = ACTIONS(2321),
    [anon_sym_let] = ACTIONS(2321),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_do] = ACTIONS(2321),
    [anon_sym_TILDE] = ACTIONS(2319),
  },
  [520] = {
    [anon_sym_EQ_GT] = ACTIONS(2323),
    [sym_comment] = ACTIONS(3),
  },
  [521] = {
    [sym_formal_parameters] = STATE(776),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [522] = {
    [sym_new_expression] = STATE(1754),
    [sym_constructor_type] = STATE(514),
    [sym_augmented_assignment_expression] = STATE(1754),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(1754),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(1754),
    [sym_call_signature] = STATE(1740),
    [sym_yield_expression] = STATE(1754),
    [sym_as_expression] = STATE(1754),
    [sym_internal_module] = STATE(1754),
    [sym_arrow_function] = STATE(1754),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(1201),
    [sym_mapped_type] = STATE(237),
    [sym_spread_element] = STATE(1755),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1535),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(1202),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(1754),
    [sym_subscript_expression] = STATE(1201),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(1754),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(1754),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(514),
    [sym__type] = STATE(514),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(1754),
    [sym_meta_property] = STATE(1754),
    [sym_function_type] = STATE(514),
    [sym__expression] = STATE(1754),
    [sym_non_null_expression] = STATE(1754),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(1754),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(1754),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [aux_sym_array_repeat1] = STATE(1756),
    [sym_anonymous_class] = STATE(1754),
    [sym_call_expression] = STATE(1754),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(1754),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(1754),
    [sym_type_arguments] = STATE(1205),
    [sym_union_type] = STATE(514),
    [sym_parenthesized_expression] = STATE(1754),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1754),
    [sym_class] = STATE(1754),
    [sym_identifier] = ACTIONS(2325),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(2327),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(2329),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_void] = ACTIONS(2331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2333),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(2335),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(2335),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(2327),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_RBRACK] = ACTIONS(2343),
    [sym_null] = ACTIONS(2345),
    [anon_sym_any] = ACTIONS(2327),
    [anon_sym_boolean] = ACTIONS(2327),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2347),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2327),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(2345),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2329),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [523] = {
    [sym__initializer] = STATE(461),
    [sym_type_annotation] = STATE(445),
    [sym_type_arguments] = STATE(497),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_LBRACK] = ACTIONS(1198),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(2164),
    [anon_sym_DOT] = ACTIONS(1205),
    [anon_sym_is] = ACTIONS(1207),
    [anon_sym_RPAREN] = ACTIONS(2351),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_COMMA] = ACTIONS(2162),
    [anon_sym_LT] = ACTIONS(1212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(1214),
  },
  [524] = {
    [sym__initializer] = STATE(729),
    [sym_type_annotation] = STATE(453),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_AMP] = ACTIONS(1244),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_QMARK] = ACTIONS(2160),
    [anon_sym_RPAREN] = ACTIONS(2354),
    [anon_sym_PIPE] = ACTIONS(1244),
    [anon_sym_COMMA] = ACTIONS(2158),
    [sym_comment] = ACTIONS(3),
  },
  [525] = {
    [sym_pair] = STATE(1776),
    [aux_sym_export_statement_repeat1] = STATE(785),
    [sym_object] = STATE(310),
    [sym__property_name] = STATE(786),
    [aux_sym_object_repeat1] = STATE(1778),
    [sym_assignment_pattern] = STATE(1776),
    [sym_method_signature] = STATE(513),
    [sym_property_signature] = STATE(513),
    [sym_call_signature] = STATE(513),
    [sym_construct_signature] = STATE(513),
    [sym_export_statement] = STATE(513),
    [sym_method_definition] = STATE(1776),
    [sym_index_signature] = STATE(513),
    [sym_decorator] = STATE(785),
    [sym_accessibility_modifier] = STATE(787),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(786),
    [sym_array] = STATE(312),
    [sym_spread_element] = STATE(1776),
    [sym_string] = STATE(786),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(2357),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_SEMI] = ACTIONS(1222),
    [anon_sym_module] = ACTIONS(2361),
    [anon_sym_symbol] = ACTIONS(2361),
    [anon_sym_number] = ACTIONS(2361),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(2363),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_void] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(2361),
    [anon_sym_private] = ACTIONS(2367),
    [anon_sym_boolean] = ACTIONS(2361),
    [anon_sym_static] = ACTIONS(2369),
    [anon_sym_async] = ACTIONS(2371),
    [anon_sym_get] = ACTIONS(2373),
    [anon_sym_RBRACE] = ACTIONS(2375),
    [anon_sym_public] = ACTIONS(2367),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2367),
    [anon_sym_string] = ACTIONS(2361),
    [anon_sym_set] = ACTIONS(2373),
    [anon_sym_type] = ACTIONS(2361),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(2361),
    [anon_sym_export] = ACTIONS(2379),
    [sym_readonly] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(2361),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [526] = {
    [anon_sym_EQ] = ACTIONS(213),
    [anon_sym_COLON] = ACTIONS(213),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_AMP] = ACTIONS(1248),
    [anon_sym_RPAREN] = ACTIONS(2383),
    [anon_sym_PIPE] = ACTIONS(1248),
    [anon_sym_COMMA] = ACTIONS(213),
    [sym_comment] = ACTIONS(3),
  },
  [527] = {
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_RPAREN] = ACTIONS(2386),
    [anon_sym_PIPE] = ACTIONS(1276),
    [sym_comment] = ACTIONS(3),
  },
  [528] = {
    [anon_sym_BQUOTE] = ACTIONS(2388),
    [anon_sym_symbol] = ACTIONS(2390),
    [anon_sym_PIPE] = ACTIONS(2388),
    [anon_sym_break] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2390),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_interface] = ACTIONS(2390),
    [anon_sym_delete] = ACTIONS(2390),
    [anon_sym_if] = ACTIONS(2390),
    [anon_sym_yield] = ACTIONS(2390),
    [sym_true] = ACTIONS(2390),
    [anon_sym_protected] = ACTIONS(2390),
    [anon_sym_set] = ACTIONS(2390),
    [anon_sym_import] = ACTIONS(2390),
    [anon_sym_await] = ACTIONS(2390),
    [anon_sym_DQUOTE] = ACTIONS(2388),
    [anon_sym_for] = ACTIONS(2390),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym_number] = ACTIONS(2390),
    [anon_sym_typeof] = ACTIONS(2390),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_switch] = ACTIONS(2390),
    [anon_sym_RBRACK] = ACTIONS(2388),
    [sym_null] = ACTIONS(2390),
    [anon_sym_any] = ACTIONS(2390),
    [anon_sym_async] = ACTIONS(2390),
    [anon_sym_public] = ACTIONS(2390),
    [anon_sym_var] = ACTIONS(2390),
    [anon_sym_while] = ACTIONS(2390),
    [anon_sym_SQUOTE] = ACTIONS(2388),
    [anon_sym_RPAREN] = ACTIONS(2388),
    [anon_sym_SLASH] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2390),
    [anon_sym_new] = ACTIONS(2390),
    [anon_sym_export] = ACTIONS(2390),
    [anon_sym_with] = ACTIONS(2390),
    [sym_identifier] = ACTIONS(2390),
    [anon_sym_debugger] = ACTIONS(2390),
    [anon_sym_AT] = ACTIONS(2388),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_EQ] = ACTIONS(2390),
    [anon_sym_void] = ACTIONS(2390),
    [anon_sym_const] = ACTIONS(2390),
    [sym_super] = ACTIONS(2390),
    [anon_sym_private] = ACTIONS(2390),
    [anon_sym_get] = ACTIONS(2390),
    [anon_sym_default] = ACTIONS(2390),
    [anon_sym_enum] = ACTIONS(2390),
    [anon_sym_continue] = ACTIONS(2390),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [anon_sym_this] = ACTIONS(2390),
    [anon_sym_throw] = ACTIONS(2390),
    [anon_sym_abstract] = ACTIONS(2390),
    [anon_sym_type] = ACTIONS(2390),
    [anon_sym_namespace] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_else] = ACTIONS(2390),
    [anon_sym_BANG] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [sym_false] = ACTIONS(2390),
    [anon_sym_case] = ACTIONS(2390),
    [anon_sym_module] = ACTIONS(2390),
    [anon_sym_class] = ACTIONS(2390),
    [anon_sym_declare] = ACTIONS(2390),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_GT] = ACTIONS(2388),
    [anon_sym_boolean] = ACTIONS(2390),
    [anon_sym_EQ_GT] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym_try] = ACTIONS(2390),
    [anon_sym_LT] = ACTIONS(2388),
    [sym_number] = ACTIONS(2388),
    [ts_builtin_sym_end] = ACTIONS(2388),
    [anon_sym_function] = ACTIONS(2390),
    [sym_undefined] = ACTIONS(2390),
    [anon_sym_let] = ACTIONS(2390),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_do] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2388),
  },
  [529] = {
    [anon_sym_BQUOTE] = ACTIONS(2392),
    [anon_sym_symbol] = ACTIONS(2394),
    [anon_sym_PIPE] = ACTIONS(2392),
    [anon_sym_break] = ACTIONS(2394),
    [anon_sym_return] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_interface] = ACTIONS(2394),
    [anon_sym_delete] = ACTIONS(2394),
    [anon_sym_if] = ACTIONS(2394),
    [anon_sym_yield] = ACTIONS(2394),
    [sym_true] = ACTIONS(2394),
    [anon_sym_protected] = ACTIONS(2394),
    [anon_sym_set] = ACTIONS(2394),
    [anon_sym_import] = ACTIONS(2394),
    [anon_sym_await] = ACTIONS(2394),
    [anon_sym_DQUOTE] = ACTIONS(2392),
    [anon_sym_for] = ACTIONS(2394),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym_number] = ACTIONS(2394),
    [anon_sym_typeof] = ACTIONS(2394),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_switch] = ACTIONS(2394),
    [anon_sym_RBRACK] = ACTIONS(2392),
    [sym_null] = ACTIONS(2394),
    [anon_sym_any] = ACTIONS(2394),
    [anon_sym_async] = ACTIONS(2394),
    [anon_sym_public] = ACTIONS(2394),
    [anon_sym_var] = ACTIONS(2394),
    [anon_sym_while] = ACTIONS(2394),
    [anon_sym_SQUOTE] = ACTIONS(2392),
    [anon_sym_RPAREN] = ACTIONS(2392),
    [anon_sym_SLASH] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2394),
    [anon_sym_new] = ACTIONS(2394),
    [anon_sym_export] = ACTIONS(2394),
    [anon_sym_with] = ACTIONS(2394),
    [sym_identifier] = ACTIONS(2394),
    [anon_sym_debugger] = ACTIONS(2394),
    [anon_sym_AT] = ACTIONS(2392),
    [anon_sym_COMMA] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_EQ] = ACTIONS(2394),
    [anon_sym_void] = ACTIONS(2394),
    [anon_sym_const] = ACTIONS(2394),
    [sym_super] = ACTIONS(2394),
    [anon_sym_private] = ACTIONS(2394),
    [anon_sym_get] = ACTIONS(2394),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2392),
    [anon_sym_default] = ACTIONS(2394),
    [anon_sym_enum] = ACTIONS(2394),
    [anon_sym_continue] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [anon_sym_this] = ACTIONS(2394),
    [anon_sym_throw] = ACTIONS(2394),
    [anon_sym_abstract] = ACTIONS(2394),
    [anon_sym_type] = ACTIONS(2394),
    [anon_sym_namespace] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_else] = ACTIONS(2394),
    [anon_sym_BANG] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [sym_false] = ACTIONS(2394),
    [anon_sym_case] = ACTIONS(2394),
    [anon_sym_module] = ACTIONS(2394),
    [anon_sym_class] = ACTIONS(2394),
    [anon_sym_declare] = ACTIONS(2394),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_GT] = ACTIONS(2392),
    [anon_sym_boolean] = ACTIONS(2394),
    [anon_sym_EQ_GT] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym_try] = ACTIONS(2394),
    [anon_sym_LT] = ACTIONS(2392),
    [sym_number] = ACTIONS(2392),
    [ts_builtin_sym_end] = ACTIONS(2392),
    [anon_sym_function] = ACTIONS(2394),
    [sym_undefined] = ACTIONS(2394),
    [anon_sym_let] = ACTIONS(2394),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_implements] = ACTIONS(2394),
    [anon_sym_do] = ACTIONS(2394),
    [anon_sym_TILDE] = ACTIONS(2392),
  },
  [530] = {
    [sym__type] = STATE(789),
    [sym_constructor_type] = STATE(789),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(789),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(789),
    [sym_intersection_type] = STATE(789),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [531] = {
    [sym__type] = STATE(790),
    [sym_constructor_type] = STATE(790),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(790),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(790),
    [sym_intersection_type] = STATE(790),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [532] = {
    [sym__type] = STATE(792),
    [sym_constructor_type] = STATE(792),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(792),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(792),
    [sym_intersection_type] = STATE(792),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_GT] = ACTIONS(2396),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [533] = {
    [aux_sym_implements_clause_repeat1] = STATE(794),
    [anon_sym_GT] = ACTIONS(2396),
    [anon_sym_COMMA] = ACTIONS(2398),
    [sym_comment] = ACTIONS(3),
  },
  [534] = {
    [anon_sym_EQ_GT] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
  },
  [535] = {
    [sym__type] = STATE(796),
    [sym_constructor_type] = STATE(796),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(796),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(796),
    [sym_intersection_type] = STATE(796),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [536] = {
    [sym__type] = STATE(797),
    [sym_constructor_type] = STATE(797),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(797),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(797),
    [sym_intersection_type] = STATE(797),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [537] = {
    [anon_sym_BQUOTE] = ACTIONS(2402),
    [anon_sym_symbol] = ACTIONS(2404),
    [anon_sym_PIPE] = ACTIONS(2402),
    [anon_sym_break] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2404),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_interface] = ACTIONS(2404),
    [anon_sym_delete] = ACTIONS(2404),
    [anon_sym_if] = ACTIONS(2404),
    [anon_sym_yield] = ACTIONS(2404),
    [sym_true] = ACTIONS(2404),
    [anon_sym_protected] = ACTIONS(2404),
    [anon_sym_set] = ACTIONS(2404),
    [anon_sym_import] = ACTIONS(2404),
    [anon_sym_await] = ACTIONS(2404),
    [anon_sym_DQUOTE] = ACTIONS(2402),
    [anon_sym_for] = ACTIONS(2404),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym_number] = ACTIONS(2404),
    [anon_sym_typeof] = ACTIONS(2404),
    [anon_sym_LBRACE] = ACTIONS(2404),
    [anon_sym_switch] = ACTIONS(2404),
    [anon_sym_RBRACK] = ACTIONS(2402),
    [sym_null] = ACTIONS(2404),
    [anon_sym_any] = ACTIONS(2404),
    [anon_sym_async] = ACTIONS(2404),
    [anon_sym_public] = ACTIONS(2404),
    [anon_sym_var] = ACTIONS(2404),
    [anon_sym_while] = ACTIONS(2404),
    [anon_sym_SQUOTE] = ACTIONS(2402),
    [anon_sym_RPAREN] = ACTIONS(2402),
    [anon_sym_SLASH] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2404),
    [anon_sym_new] = ACTIONS(2404),
    [anon_sym_export] = ACTIONS(2404),
    [anon_sym_with] = ACTIONS(2404),
    [sym_identifier] = ACTIONS(2404),
    [anon_sym_debugger] = ACTIONS(2404),
    [anon_sym_AT] = ACTIONS(2402),
    [anon_sym_COMMA] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_EQ] = ACTIONS(2404),
    [anon_sym_void] = ACTIONS(2404),
    [anon_sym_const] = ACTIONS(2404),
    [sym_super] = ACTIONS(2404),
    [anon_sym_private] = ACTIONS(2404),
    [anon_sym_get] = ACTIONS(2404),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2402),
    [anon_sym_default] = ACTIONS(2404),
    [anon_sym_enum] = ACTIONS(2404),
    [anon_sym_continue] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_this] = ACTIONS(2404),
    [anon_sym_throw] = ACTIONS(2404),
    [anon_sym_abstract] = ACTIONS(2404),
    [anon_sym_type] = ACTIONS(2404),
    [anon_sym_namespace] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_else] = ACTIONS(2404),
    [anon_sym_BANG] = ACTIONS(2402),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [sym_false] = ACTIONS(2404),
    [anon_sym_case] = ACTIONS(2404),
    [anon_sym_module] = ACTIONS(2404),
    [anon_sym_class] = ACTIONS(2404),
    [anon_sym_declare] = ACTIONS(2404),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_GT] = ACTIONS(2402),
    [anon_sym_boolean] = ACTIONS(2404),
    [anon_sym_EQ_GT] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2402),
    [anon_sym_try] = ACTIONS(2404),
    [anon_sym_LT] = ACTIONS(2402),
    [sym_number] = ACTIONS(2402),
    [ts_builtin_sym_end] = ACTIONS(2402),
    [anon_sym_function] = ACTIONS(2404),
    [sym_undefined] = ACTIONS(2404),
    [anon_sym_let] = ACTIONS(2404),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_implements] = ACTIONS(2404),
    [anon_sym_do] = ACTIONS(2404),
    [anon_sym_TILDE] = ACTIONS(2402),
  },
  [538] = {
    [sym_type_parameter] = STATE(799),
    [anon_sym_GT] = ACTIONS(2406),
    [sym_identifier] = ACTIONS(1176),
    [sym_comment] = ACTIONS(3),
  },
  [539] = {
    [anon_sym_extends] = ACTIONS(2408),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2408),
    [anon_sym_EQ] = ACTIONS(2408),
    [anon_sym_LPAREN] = ACTIONS(2408),
    [anon_sym_implements] = ACTIONS(2408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2410),
  },
  [540] = {
    [aux_sym_type_parameters_repeat1] = STATE(801),
    [anon_sym_GT] = ACTIONS(2406),
    [anon_sym_COMMA] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
  },
  [541] = {
    [anon_sym_RBRACK] = ACTIONS(2414),
    [sym_comment] = ACTIONS(3),
  },
  [542] = {
    [sym__type] = STATE(803),
    [sym_constructor_type] = STATE(803),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(803),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(803),
    [sym_intersection_type] = STATE(803),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [543] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2416),
    [sym__automatic_semicolon] = ACTIONS(2416),
    [anon_sym_BQUOTE] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_GT_GT_GT] = ACTIONS(2416),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_GT_EQ] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_PERCENT] = ACTIONS(2416),
    [anon_sym_as] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_instanceof] = ACTIONS(2418),
    [sym_regex_flags] = ACTIONS(2420),
    [anon_sym_DOT] = ACTIONS(2416),
    [anon_sym_STAR_STAR] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym_LT_LT] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_LT_EQ] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_EQ_EQ] = ACTIONS(2418),
    [anon_sym_RPAREN] = ACTIONS(2416),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2416),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_GT_GT] = ACTIONS(2418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2416),
    [anon_sym_in] = ACTIONS(2418),
  },
  [544] = {
    [sym_statement_block] = STATE(744),
    [sym__automatic_semicolon] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(805),
  },
  [545] = {
    [sym_call_signature] = STATE(806),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [546] = {
    [sym_statement_block] = STATE(807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(805),
  },
  [547] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2424),
    [sym__automatic_semicolon] = ACTIONS(2424),
    [anon_sym_BQUOTE] = ACTIONS(2424),
    [anon_sym_symbol] = ACTIONS(2426),
    [anon_sym_PIPE] = ACTIONS(2426),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_GT_GT_GT] = ACTIONS(2424),
    [anon_sym_break] = ACTIONS(2426),
    [anon_sym_BANG_EQ] = ACTIONS(2426),
    [anon_sym_return] = ACTIONS(2426),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_PERCENT] = ACTIONS(2424),
    [anon_sym_interface] = ACTIONS(2426),
    [anon_sym_as] = ACTIONS(2426),
    [anon_sym_delete] = ACTIONS(2426),
    [anon_sym_if] = ACTIONS(2426),
    [anon_sym_instanceof] = ACTIONS(2426),
    [anon_sym_yield] = ACTIONS(2426),
    [sym_true] = ACTIONS(2426),
    [anon_sym_protected] = ACTIONS(2426),
    [anon_sym_DOT] = ACTIONS(2426),
    [anon_sym_set] = ACTIONS(2426),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2424),
    [anon_sym_import] = ACTIONS(2426),
    [anon_sym_await] = ACTIONS(2426),
    [anon_sym_DQUOTE] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2426),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_number] = ACTIONS(2426),
    [anon_sym_typeof] = ACTIONS(2426),
    [anon_sym_LT_LT] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [anon_sym_AMP_AMP] = ACTIONS(2424),
    [anon_sym_switch] = ACTIONS(2426),
    [anon_sym_LT_EQ] = ACTIONS(2424),
    [sym_null] = ACTIONS(2426),
    [anon_sym_any] = ACTIONS(2426),
    [anon_sym_async] = ACTIONS(2426),
    [anon_sym_public] = ACTIONS(2426),
    [anon_sym_var] = ACTIONS(2426),
    [anon_sym_QMARK] = ACTIONS(2424),
    [anon_sym_while] = ACTIONS(2426),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [anon_sym_SLASH] = ACTIONS(2426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2426),
    [anon_sym_new] = ACTIONS(2426),
    [anon_sym_CARET] = ACTIONS(2424),
    [anon_sym_export] = ACTIONS(2426),
    [anon_sym_GT_GT] = ACTIONS(2426),
    [anon_sym_with] = ACTIONS(2426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2424),
    [sym_identifier] = ACTIONS(2426),
    [anon_sym_debugger] = ACTIONS(2426),
    [anon_sym_AT] = ACTIONS(2424),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_void] = ACTIONS(2426),
    [anon_sym_const] = ACTIONS(2426),
    [anon_sym_GT_EQ] = ACTIONS(2424),
    [sym_super] = ACTIONS(2426),
    [anon_sym_private] = ACTIONS(2426),
    [anon_sym_get] = ACTIONS(2426),
    [anon_sym_default] = ACTIONS(2426),
    [anon_sym_enum] = ACTIONS(2426),
    [anon_sym_continue] = ACTIONS(2426),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [anon_sym_this] = ACTIONS(2426),
    [anon_sym_throw] = ACTIONS(2426),
    [anon_sym_abstract] = ACTIONS(2426),
    [anon_sym_type] = ACTIONS(2426),
    [anon_sym_STAR_STAR] = ACTIONS(2424),
    [anon_sym_namespace] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_else] = ACTIONS(2426),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [sym_false] = ACTIONS(2426),
    [anon_sym_case] = ACTIONS(2426),
    [anon_sym_module] = ACTIONS(2426),
    [anon_sym_class] = ACTIONS(2426),
    [anon_sym_declare] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_GT] = ACTIONS(2426),
    [anon_sym_boolean] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2426),
    [anon_sym_PIPE_PIPE] = ACTIONS(2424),
    [anon_sym_try] = ACTIONS(2426),
    [anon_sym_EQ_EQ] = ACTIONS(2426),
    [anon_sym_LT] = ACTIONS(2426),
    [sym_number] = ACTIONS(2424),
    [ts_builtin_sym_end] = ACTIONS(2424),
    [anon_sym_function] = ACTIONS(2426),
    [sym_undefined] = ACTIONS(2426),
    [anon_sym_let] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_do] = ACTIONS(2426),
    [anon_sym_TILDE] = ACTIONS(2424),
    [anon_sym_in] = ACTIONS(2426),
  },
  [548] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2428),
    [sym__automatic_semicolon] = ACTIONS(2428),
    [anon_sym_BQUOTE] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(2430),
    [anon_sym_GT_GT_GT] = ACTIONS(2428),
    [anon_sym_BANG_EQ] = ACTIONS(2430),
    [anon_sym_GT_EQ] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_as] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_instanceof] = ACTIONS(2428),
    [anon_sym_DOT] = ACTIONS(2428),
    [anon_sym_STAR_STAR] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_LT_LT] = ACTIONS(2428),
    [anon_sym_AMP_AMP] = ACTIONS(2428),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2428),
    [anon_sym_EQ_EQ] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(2430),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2430),
  },
  [549] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2432),
    [sym__automatic_semicolon] = ACTIONS(2432),
    [anon_sym_BQUOTE] = ACTIONS(2432),
    [anon_sym_PIPE] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(2434),
    [anon_sym_GT_GT_GT] = ACTIONS(2432),
    [anon_sym_BANG_EQ] = ACTIONS(2434),
    [anon_sym_GT_EQ] = ACTIONS(2432),
    [anon_sym_RBRACE] = ACTIONS(2432),
    [anon_sym_PERCENT] = ACTIONS(2432),
    [anon_sym_as] = ACTIONS(2432),
    [anon_sym_DASH_DASH] = ACTIONS(2432),
    [anon_sym_instanceof] = ACTIONS(2432),
    [anon_sym_DOT] = ACTIONS(2432),
    [anon_sym_STAR_STAR] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_LT_LT] = ACTIONS(2432),
    [anon_sym_AMP_AMP] = ACTIONS(2432),
    [anon_sym_LT_EQ] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(2432),
    [anon_sym_GT] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2434),
    [anon_sym_QMARK] = ACTIONS(2432),
    [anon_sym_PIPE_PIPE] = ACTIONS(2432),
    [anon_sym_EQ_EQ] = ACTIONS(2434),
    [anon_sym_RPAREN] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_SLASH] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2432),
    [anon_sym_PLUS] = ACTIONS(2434),
    [anon_sym_GT_GT] = ACTIONS(2434),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2432),
    [anon_sym_in] = ACTIONS(2434),
  },
  [550] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2436),
    [sym__automatic_semicolon] = ACTIONS(2436),
    [anon_sym_BQUOTE] = ACTIONS(2436),
    [anon_sym_PIPE] = ACTIONS(2438),
    [anon_sym_COMMA] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_GT_GT_GT] = ACTIONS(2436),
    [anon_sym_BANG_EQ] = ACTIONS(2438),
    [anon_sym_GT_EQ] = ACTIONS(2436),
    [anon_sym_RBRACE] = ACTIONS(2436),
    [anon_sym_PERCENT] = ACTIONS(2436),
    [anon_sym_as] = ACTIONS(2436),
    [anon_sym_DASH_DASH] = ACTIONS(2436),
    [anon_sym_instanceof] = ACTIONS(2436),
    [anon_sym_DOT] = ACTIONS(2436),
    [anon_sym_STAR_STAR] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2436),
    [anon_sym_BANG] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_SEMI] = ACTIONS(2436),
    [anon_sym_LT_LT] = ACTIONS(2436),
    [anon_sym_AMP_AMP] = ACTIONS(2436),
    [anon_sym_LT_EQ] = ACTIONS(2436),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_GT] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2438),
    [anon_sym_QMARK] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2436),
    [anon_sym_EQ_EQ] = ACTIONS(2438),
    [anon_sym_RPAREN] = ACTIONS(2436),
    [anon_sym_LT] = ACTIONS(2438),
    [anon_sym_SLASH] = ACTIONS(2438),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2438),
    [anon_sym_GT_GT] = ACTIONS(2438),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2436),
    [anon_sym_in] = ACTIONS(2438),
  },
  [551] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2428),
    [sym__automatic_semicolon] = ACTIONS(2428),
    [anon_sym_BQUOTE] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(2430),
    [anon_sym_GT_GT_GT] = ACTIONS(2428),
    [anon_sym_BANG_EQ] = ACTIONS(2430),
    [anon_sym_GT_EQ] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_as] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_instanceof] = ACTIONS(2428),
    [anon_sym_DOT] = ACTIONS(2428),
    [anon_sym_STAR_STAR] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_LT_LT] = ACTIONS(2428),
    [anon_sym_AMP_AMP] = ACTIONS(2428),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2428),
    [anon_sym_EQ_EQ] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_GT_GT] = ACTIONS(2430),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2430),
  },
  [552] = {
    [sym__automatic_semicolon] = ACTIONS(2440),
    [anon_sym_SEMI] = ACTIONS(2440),
    [sym_comment] = ACTIONS(3),
  },
  [553] = {
    [sym__automatic_semicolon] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2442),
    [anon_sym_from] = ACTIONS(2442),
    [sym_comment] = ACTIONS(3),
  },
  [554] = {
    [anon_sym_RBRACE] = ACTIONS(2444),
    [sym_comment] = ACTIONS(3),
  },
  [555] = {
    [aux_sym_export_clause_repeat1] = STATE(815),
    [anon_sym_COMMA] = ACTIONS(2446),
    [anon_sym_RBRACE] = ACTIONS(2448),
    [sym_comment] = ACTIONS(3),
  },
  [556] = {
    [sym__initializer] = STATE(72),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(2450),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(113),
    [anon_sym_AMP_EQ] = ACTIONS(113),
    [anon_sym_PLUS_EQ] = ACTIONS(113),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(113),
    [anon_sym_PIPE_EQ] = ACTIONS(113),
    [anon_sym_DASH_EQ] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(2450),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(113),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(113),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [557] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(2440),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(2440),
    [anon_sym_in] = ACTIONS(2455),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2469),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(600),
  },
  [558] = {
    [sym_identifier] = ACTIONS(2477),
    [sym_comment] = ACTIONS(3),
  },
  [559] = {
    [sym_identifier] = ACTIONS(2479),
    [anon_sym_BQUOTE] = ACTIONS(2481),
    [anon_sym_debugger] = ACTIONS(2479),
    [anon_sym_symbol] = ACTIONS(2479),
    [anon_sym_AT] = ACTIONS(2481),
    [anon_sym_DASH] = ACTIONS(2479),
    [anon_sym_void] = ACTIONS(2479),
    [anon_sym_break] = ACTIONS(2479),
    [anon_sym_const] = ACTIONS(2479),
    [sym_super] = ACTIONS(2479),
    [anon_sym_return] = ACTIONS(2479),
    [anon_sym_private] = ACTIONS(2479),
    [anon_sym_get] = ACTIONS(2479),
    [anon_sym_RBRACE] = ACTIONS(2481),
    [anon_sym_interface] = ACTIONS(2479),
    [anon_sym_default] = ACTIONS(2479),
    [anon_sym_enum] = ACTIONS(2479),
    [anon_sym_delete] = ACTIONS(2479),
    [anon_sym_continue] = ACTIONS(2479),
    [anon_sym_DASH_DASH] = ACTIONS(2481),
    [anon_sym_if] = ACTIONS(2479),
    [anon_sym_this] = ACTIONS(2479),
    [anon_sym_yield] = ACTIONS(2479),
    [sym_true] = ACTIONS(2479),
    [anon_sym_throw] = ACTIONS(2479),
    [anon_sym_protected] = ACTIONS(2479),
    [anon_sym_abstract] = ACTIONS(2479),
    [anon_sym_set] = ACTIONS(2479),
    [anon_sym_type] = ACTIONS(2479),
    [anon_sym_import] = ACTIONS(2479),
    [anon_sym_namespace] = ACTIONS(2479),
    [anon_sym_PLUS_PLUS] = ACTIONS(2481),
    [anon_sym_await] = ACTIONS(2479),
    [anon_sym_DQUOTE] = ACTIONS(2481),
    [anon_sym_else] = ACTIONS(2479),
    [anon_sym_BANG] = ACTIONS(2481),
    [anon_sym_for] = ACTIONS(2479),
    [anon_sym_LBRACK] = ACTIONS(2481),
    [sym_false] = ACTIONS(2479),
    [anon_sym_SEMI] = ACTIONS(2481),
    [anon_sym_case] = ACTIONS(2479),
    [anon_sym_module] = ACTIONS(2479),
    [anon_sym_number] = ACTIONS(2479),
    [anon_sym_class] = ACTIONS(2479),
    [anon_sym_declare] = ACTIONS(2479),
    [anon_sym_typeof] = ACTIONS(2479),
    [anon_sym_LBRACE] = ACTIONS(2481),
    [anon_sym_switch] = ACTIONS(2479),
    [anon_sym_LPAREN] = ACTIONS(2481),
    [sym_null] = ACTIONS(2479),
    [anon_sym_any] = ACTIONS(2479),
    [anon_sym_boolean] = ACTIONS(2479),
    [anon_sym_async] = ACTIONS(2479),
    [anon_sym_public] = ACTIONS(2479),
    [anon_sym_var] = ACTIONS(2479),
    [anon_sym_while] = ACTIONS(2479),
    [anon_sym_SQUOTE] = ACTIONS(2481),
    [anon_sym_try] = ACTIONS(2479),
    [anon_sym_LT] = ACTIONS(2481),
    [sym_number] = ACTIONS(2481),
    [anon_sym_SLASH] = ACTIONS(2479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2479),
    [anon_sym_function] = ACTIONS(2479),
    [sym_undefined] = ACTIONS(2479),
    [anon_sym_new] = ACTIONS(2479),
    [ts_builtin_sym_end] = ACTIONS(2481),
    [anon_sym_let] = ACTIONS(2479),
    [anon_sym_PLUS] = ACTIONS(2479),
    [anon_sym_export] = ACTIONS(2479),
    [anon_sym_do] = ACTIONS(2479),
    [anon_sym_TILDE] = ACTIONS(2481),
    [anon_sym_with] = ACTIONS(2479),
  },
  [560] = {
    [sym_parenthesized_expression] = STATE(817),
    [anon_sym_LPAREN] = ACTIONS(2483),
    [sym_comment] = ACTIONS(3),
  },
  [561] = {
    [sym_identifier] = ACTIONS(2485),
    [anon_sym_BQUOTE] = ACTIONS(2487),
    [anon_sym_debugger] = ACTIONS(2485),
    [anon_sym_symbol] = ACTIONS(2485),
    [anon_sym_AT] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2485),
    [anon_sym_void] = ACTIONS(2485),
    [anon_sym_break] = ACTIONS(2485),
    [anon_sym_const] = ACTIONS(2485),
    [sym_super] = ACTIONS(2485),
    [anon_sym_return] = ACTIONS(2485),
    [anon_sym_private] = ACTIONS(2485),
    [anon_sym_get] = ACTIONS(2485),
    [anon_sym_RBRACE] = ACTIONS(2487),
    [anon_sym_interface] = ACTIONS(2485),
    [anon_sym_default] = ACTIONS(2485),
    [anon_sym_enum] = ACTIONS(2485),
    [anon_sym_delete] = ACTIONS(2485),
    [anon_sym_continue] = ACTIONS(2485),
    [anon_sym_DASH_DASH] = ACTIONS(2487),
    [anon_sym_if] = ACTIONS(2485),
    [anon_sym_this] = ACTIONS(2485),
    [anon_sym_yield] = ACTIONS(2485),
    [sym_true] = ACTIONS(2485),
    [anon_sym_throw] = ACTIONS(2485),
    [anon_sym_protected] = ACTIONS(2485),
    [anon_sym_abstract] = ACTIONS(2485),
    [anon_sym_set] = ACTIONS(2485),
    [anon_sym_type] = ACTIONS(2485),
    [anon_sym_import] = ACTIONS(2485),
    [anon_sym_namespace] = ACTIONS(2485),
    [anon_sym_PLUS_PLUS] = ACTIONS(2487),
    [anon_sym_await] = ACTIONS(2485),
    [anon_sym_DQUOTE] = ACTIONS(2487),
    [anon_sym_else] = ACTIONS(2485),
    [anon_sym_BANG] = ACTIONS(2487),
    [anon_sym_for] = ACTIONS(2485),
    [anon_sym_LBRACK] = ACTIONS(2487),
    [sym_false] = ACTIONS(2485),
    [anon_sym_SEMI] = ACTIONS(2487),
    [anon_sym_case] = ACTIONS(2485),
    [anon_sym_module] = ACTIONS(2485),
    [anon_sym_number] = ACTIONS(2485),
    [anon_sym_class] = ACTIONS(2485),
    [anon_sym_declare] = ACTIONS(2485),
    [anon_sym_typeof] = ACTIONS(2485),
    [anon_sym_LBRACE] = ACTIONS(2487),
    [anon_sym_switch] = ACTIONS(2485),
    [anon_sym_LPAREN] = ACTIONS(2487),
    [sym_null] = ACTIONS(2485),
    [anon_sym_any] = ACTIONS(2485),
    [anon_sym_boolean] = ACTIONS(2485),
    [anon_sym_async] = ACTIONS(2485),
    [anon_sym_public] = ACTIONS(2485),
    [anon_sym_var] = ACTIONS(2485),
    [anon_sym_while] = ACTIONS(2485),
    [anon_sym_SQUOTE] = ACTIONS(2487),
    [anon_sym_try] = ACTIONS(2485),
    [anon_sym_LT] = ACTIONS(2487),
    [sym_number] = ACTIONS(2487),
    [anon_sym_SLASH] = ACTIONS(2485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2485),
    [anon_sym_function] = ACTIONS(2485),
    [sym_undefined] = ACTIONS(2485),
    [anon_sym_new] = ACTIONS(2485),
    [ts_builtin_sym_end] = ACTIONS(2487),
    [anon_sym_let] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2485),
    [anon_sym_export] = ACTIONS(2485),
    [anon_sym_do] = ACTIONS(2485),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_with] = ACTIONS(2485),
  },
  [562] = {
    [anon_sym_EQ_GT] = ACTIONS(2489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2489),
  },
  [563] = {
    [anon_sym_EQ_GT] = ACTIONS(2491),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_EQ] = ACTIONS(2493),
    [anon_sym_RPAREN] = ACTIONS(2491),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(2491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2491),
  },
  [564] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_in] = ACTIONS(125),
  },
  [565] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_GT_GT_GT] = ACTIONS(1683),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(2495),
    [anon_sym_SLASH] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [566] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(2495),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [567] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_in] = ACTIONS(125),
  },
  [568] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym__automatic_semicolon] = ACTIONS(2498),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(2498),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_in] = ACTIONS(125),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(590),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_BANG] = ACTIONS(600),
  },
  [569] = {
    [sym__automatic_semicolon] = ACTIONS(2498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(2498),
  },
  [570] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2500),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [571] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2502),
    [sym__automatic_semicolon] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_STAR] = ACTIONS(2504),
    [anon_sym_GT_GT_GT] = ACTIONS(2502),
    [anon_sym_BANG_EQ] = ACTIONS(2504),
    [anon_sym_GT_EQ] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_PERCENT] = ACTIONS(2502),
    [anon_sym_as] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_instanceof] = ACTIONS(2502),
    [anon_sym_DOT] = ACTIONS(2502),
    [anon_sym_STAR_STAR] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_LT_EQ] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_QMARK] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2504),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_SLASH] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2502),
    [anon_sym_in] = ACTIONS(2504),
  },
  [572] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2502),
    [sym__automatic_semicolon] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_STAR] = ACTIONS(2504),
    [anon_sym_GT_GT_GT] = ACTIONS(2502),
    [anon_sym_BANG_EQ] = ACTIONS(2504),
    [anon_sym_GT_EQ] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_PERCENT] = ACTIONS(2502),
    [anon_sym_as] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_instanceof] = ACTIONS(2502),
    [anon_sym_DOT] = ACTIONS(2502),
    [anon_sym_STAR_STAR] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_LT_EQ] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_QMARK] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2504),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_SLASH] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_GT_GT] = ACTIONS(2504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2502),
    [anon_sym_in] = ACTIONS(2504),
  },
  [573] = {
    [sym__initializer] = STATE(72),
    [sym_type_arguments] = STATE(497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(113),
    [anon_sym_AMP_EQ] = ACTIONS(113),
    [anon_sym_PLUS_EQ] = ACTIONS(113),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2509),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(113),
    [anon_sym_PIPE_EQ] = ACTIONS(113),
    [anon_sym_DASH_EQ] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(2512),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_is] = ACTIONS(1207),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_STAR_EQ] = ACTIONS(113),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(113),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2518),
  },
  [574] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(2520),
    [anon_sym_COMMA] = ACTIONS(2523),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [575] = {
    [sym__initializer] = STATE(80),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(2526),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [576] = {
    [sym_new_expression] = STATE(91),
    [sym_augmented_assignment_expression] = STATE(91),
    [sym_unary_expression] = STATE(91),
    [sym_update_expression] = STATE(91),
    [sym_regex] = STATE(91),
    [sym_meta_property] = STATE(91),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(91),
    [sym_yield_expression] = STATE(91),
    [sym_as_expression] = STATE(91),
    [sym_non_null_expression] = STATE(91),
    [sym_internal_module] = STATE(91),
    [sym_nested_identifier] = STATE(516),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(91),
    [sym_await_expression] = STATE(91),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(91),
    [sym_this] = STATE(91),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(91),
    [sym_generator_function] = STATE(91),
    [sym_call_expression] = STATE(91),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(91),
    [sym_ternary_expression] = STATE(91),
    [sym_binary_expression] = STATE(91),
    [sym_template_string] = STATE(91),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(91),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(91),
    [sym_class] = STATE(91),
    [sym_identifier] = ACTIONS(2532),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(165),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(165),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(165),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(173),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(165),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [577] = {
    [sym_new_expression] = STATE(88),
    [sym_augmented_assignment_expression] = STATE(88),
    [sym_unary_expression] = STATE(88),
    [sym_update_expression] = STATE(88),
    [sym_regex] = STATE(88),
    [sym_meta_property] = STATE(88),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(88),
    [sym_yield_expression] = STATE(88),
    [sym_as_expression] = STATE(88),
    [sym_non_null_expression] = STATE(88),
    [sym_internal_module] = STATE(88),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(88),
    [sym_await_expression] = STATE(88),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(88),
    [sym_this] = STATE(88),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(88),
    [sym_generator_function] = STATE(88),
    [sym_call_expression] = STATE(88),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(88),
    [sym_ternary_expression] = STATE(88),
    [sym_binary_expression] = STATE(88),
    [sym_template_string] = STATE(88),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(88),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(88),
    [sym_class] = STATE(88),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(151),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(151),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(151),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2534),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(151),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [578] = {
    [sym_new_expression] = STATE(91),
    [sym_augmented_assignment_expression] = STATE(91),
    [sym__initializer] = STATE(80),
    [sym_unary_expression] = STATE(91),
    [sym_update_expression] = STATE(91),
    [sym_regex] = STATE(91),
    [sym_meta_property] = STATE(91),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(91),
    [sym_yield_expression] = STATE(91),
    [sym_as_expression] = STATE(91),
    [sym_non_null_expression] = STATE(91),
    [sym_internal_module] = STATE(91),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(91),
    [sym_await_expression] = STATE(91),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(91),
    [sym_this] = STATE(91),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(91),
    [sym_generator_function] = STATE(91),
    [sym_call_expression] = STATE(91),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(91),
    [sym_ternary_expression] = STATE(91),
    [sym_binary_expression] = STATE(91),
    [sym_template_string] = STATE(91),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(91),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(91),
    [sym_class] = STATE(91),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(165),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [sym_null] = ACTIONS(165),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(165),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(77),
    [anon_sym_GT] = ACTIONS(2526),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(139),
  },
  [579] = {
    [sym_new_expression] = STATE(199),
    [sym_constructor_type] = STATE(527),
    [sym_augmented_assignment_expression] = STATE(199),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(199),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(199),
    [sym_call_signature] = STATE(1740),
    [sym_rest_parameter] = STATE(198),
    [sym_yield_expression] = STATE(199),
    [sym_as_expression] = STATE(199),
    [sym_internal_module] = STATE(199),
    [sym_accessibility_modifier] = STATE(200),
    [sym_arrow_function] = STATE(199),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(1201),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1691),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(204),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(199),
    [sym_subscript_expression] = STATE(1201),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(199),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(199),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(203),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(527),
    [sym__type] = STATE(527),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(199),
    [sym_meta_property] = STATE(199),
    [sym_function_type] = STATE(527),
    [sym__expression] = STATE(199),
    [sym_non_null_expression] = STATE(199),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_required_parameter] = STATE(198),
    [sym_await_expression] = STATE(199),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_sequence_expression] = STATE(201),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(202),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(203),
    [sym_anonymous_class] = STATE(199),
    [sym_optional_parameter] = STATE(198),
    [sym_call_expression] = STATE(199),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(199),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(199),
    [sym_type_arguments] = STATE(1205),
    [sym_union_type] = STATE(527),
    [sym_parenthesized_expression] = STATE(199),
    [sym_array] = STATE(205),
    [sym_type_assertion] = STATE(199),
    [sym_class] = STATE(199),
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(2538),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(2542),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(414),
    [anon_sym_get] = ACTIONS(410),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(2546),
    [anon_sym_protected] = ACTIONS(414),
    [anon_sym_set] = ACTIONS(410),
    [anon_sym_type] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(410),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(420),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(2546),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_number] = ACTIONS(2538),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(410),
    [anon_sym_typeof] = ACTIONS(2548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [sym_null] = ACTIONS(416),
    [anon_sym_any] = ACTIONS(2538),
    [anon_sym_boolean] = ACTIONS(2538),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_public] = ACTIONS(414),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2550),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2538),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(416),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2540),
    [anon_sym_export] = ACTIONS(410),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [580] = {
    [sym_new_expression] = STATE(244),
    [sym_augmented_assignment_expression] = STATE(250),
    [sym_unary_expression] = STATE(250),
    [sym_update_expression] = STATE(250),
    [sym_regex] = STATE(244),
    [sym_meta_property] = STATE(244),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(250),
    [sym_yield_expression] = STATE(250),
    [sym_as_expression] = STATE(250),
    [sym_non_null_expression] = STATE(250),
    [sym_internal_module] = STATE(250),
    [sym_function] = STATE(251),
    [sym_arrow_function] = STATE(244),
    [sym_await_expression] = STATE(250),
    [sym_member_expression] = STATE(252),
    [sym_string] = STATE(244),
    [sym_this] = STATE(244),
    [sym_type_parameters] = STATE(825),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(253),
    [sym_anonymous_class] = STATE(244),
    [sym_generator_function] = STATE(244),
    [sym_call_expression] = STATE(250),
    [sym_subscript_expression] = STATE(252),
    [sym_assignment_expression] = STATE(250),
    [sym_ternary_expression] = STATE(250),
    [sym_binary_expression] = STATE(250),
    [sym_template_string] = STATE(244),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(826),
    [sym_parenthesized_expression] = STATE(244),
    [sym_array] = STATE(254),
    [sym_type_assertion] = STATE(250),
    [sym_class] = STATE(244),
    [sym_identifier] = ACTIONS(494),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(496),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(500),
    [sym_super] = ACTIONS(502),
    [anon_sym_private] = ACTIONS(496),
    [anon_sym_get] = ACTIONS(496),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(496),
    [anon_sym_DOT] = ACTIONS(512),
    [anon_sym_set] = ACTIONS(496),
    [anon_sym_type] = ACTIONS(496),
    [anon_sym_import] = ACTIONS(496),
    [anon_sym_namespace] = ACTIONS(514),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(496),
    [anon_sym_number] = ACTIONS(496),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(496),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(496),
    [anon_sym_boolean] = ACTIONS(496),
    [anon_sym_async] = ACTIONS(520),
    [anon_sym_public] = ACTIONS(496),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(522),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(496),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(496),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [581] = {
    [sym_formal_parameters] = STATE(827),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [582] = {
    [sym_type_annotation] = STATE(269),
    [anon_sym_EQ_GT] = ACTIONS(2552),
    [anon_sym_COLON] = ACTIONS(568),
    [sym_comment] = ACTIONS(3),
  },
  [583] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_GT_GT_GT] = ACTIONS(1683),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(2495),
    [anon_sym_SLASH] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [584] = {
    [sym_new_expression] = STATE(828),
    [sym_augmented_assignment_expression] = STATE(828),
    [sym_unary_expression] = STATE(828),
    [sym_update_expression] = STATE(828),
    [sym_regex] = STATE(828),
    [sym_meta_property] = STATE(828),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(828),
    [sym_yield_expression] = STATE(828),
    [sym_as_expression] = STATE(828),
    [sym_non_null_expression] = STATE(828),
    [sym_internal_module] = STATE(828),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(828),
    [sym_await_expression] = STATE(828),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(828),
    [sym_this] = STATE(828),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(828),
    [sym_generator_function] = STATE(828),
    [sym_call_expression] = STATE(828),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(828),
    [sym_ternary_expression] = STATE(828),
    [sym_binary_expression] = STATE(828),
    [sym_template_string] = STATE(828),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(828),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(828),
    [sym_class] = STATE(828),
    [sym_identifier] = ACTIONS(1367),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_void] = ACTIONS(1373),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(1379),
    [sym_true] = ACTIONS(2555),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(1387),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(2555),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(2555),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2557),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(2555),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_TILDE] = ACTIONS(1387),
  },
  [585] = {
    [sym_class_heritage] = STATE(829),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_type_parameters] = STATE(830),
    [sym_class_body] = STATE(831),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(917),
  },
  [586] = {
    [sym_class_body] = STATE(832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [587] = {
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2559),
    [sym_escape_sequence] = ACTIONS(2559),
    [anon_sym_BQUOTE] = ACTIONS(2559),
    [sym__template_chars] = ACTIONS(2559),
    [sym_comment] = ACTIONS(3),
  },
  [588] = {
    [anon_sym_LBRACK] = ACTIONS(2561),
    [sym_identifier] = ACTIONS(2563),
    [anon_sym_module] = ACTIONS(2563),
    [anon_sym_symbol] = ACTIONS(2563),
    [anon_sym_number] = ACTIONS(2563),
    [anon_sym_class] = ACTIONS(2563),
    [anon_sym_AT] = ACTIONS(2561),
    [anon_sym_declare] = ACTIONS(2563),
    [anon_sym_STAR] = ACTIONS(2561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2561),
    [anon_sym_LBRACE] = ACTIONS(2561),
    [anon_sym_void] = ACTIONS(2563),
    [anon_sym_LPAREN] = ACTIONS(2561),
    [anon_sym_any] = ACTIONS(2563),
    [anon_sym_private] = ACTIONS(2563),
    [anon_sym_boolean] = ACTIONS(2563),
    [anon_sym_static] = ACTIONS(2563),
    [anon_sym_async] = ACTIONS(2563),
    [anon_sym_get] = ACTIONS(2563),
    [anon_sym_public] = ACTIONS(2563),
    [anon_sym_RBRACE] = ACTIONS(2561),
    [anon_sym_SQUOTE] = ACTIONS(2561),
    [anon_sym_this] = ACTIONS(2563),
    [sym_number] = ACTIONS(2561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2563),
    [anon_sym_string] = ACTIONS(2563),
    [anon_sym_abstract] = ACTIONS(2563),
    [anon_sym_DOT] = ACTIONS(2563),
    [anon_sym_set] = ACTIONS(2563),
    [anon_sym_type] = ACTIONS(2563),
    [anon_sym_import] = ACTIONS(2563),
    [anon_sym_export] = ACTIONS(2563),
    [anon_sym_namespace] = ACTIONS(2563),
    [sym_readonly] = ACTIONS(2563),
    [anon_sym_DQUOTE] = ACTIONS(2561),
  },
  [589] = {
    [anon_sym_COMMA] = ACTIONS(2049),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [sym_comment] = ACTIONS(3),
  },
  [590] = {
    [anon_sym_COMMA] = ACTIONS(2092),
    [anon_sym_RBRACE] = ACTIONS(2092),
    [sym_comment] = ACTIONS(3),
  },
  [591] = {
    [anon_sym_COMMA] = ACTIONS(2100),
    [anon_sym_RBRACE] = ACTIONS(2100),
    [sym_comment] = ACTIONS(3),
  },
  [592] = {
    [sym_call_signature] = STATE(833),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [593] = {
    [sym__automatic_semicolon] = ACTIONS(2565),
    [anon_sym_SEMI] = ACTIONS(2565),
    [anon_sym_COMMA] = ACTIONS(2565),
    [sym_comment] = ACTIONS(3),
  },
  [594] = {
    [sym_identifier] = ACTIONS(2567),
    [anon_sym_BQUOTE] = ACTIONS(2569),
    [anon_sym_debugger] = ACTIONS(2567),
    [anon_sym_symbol] = ACTIONS(2567),
    [anon_sym_AT] = ACTIONS(2569),
    [anon_sym_DASH] = ACTIONS(2567),
    [anon_sym_void] = ACTIONS(2567),
    [anon_sym_break] = ACTIONS(2567),
    [anon_sym_const] = ACTIONS(2567),
    [sym_super] = ACTIONS(2567),
    [anon_sym_return] = ACTIONS(2567),
    [anon_sym_private] = ACTIONS(2567),
    [anon_sym_get] = ACTIONS(2567),
    [anon_sym_RBRACE] = ACTIONS(2569),
    [anon_sym_interface] = ACTIONS(2567),
    [anon_sym_default] = ACTIONS(2567),
    [anon_sym_enum] = ACTIONS(2567),
    [anon_sym_delete] = ACTIONS(2567),
    [anon_sym_continue] = ACTIONS(2567),
    [anon_sym_DASH_DASH] = ACTIONS(2569),
    [anon_sym_if] = ACTIONS(2567),
    [anon_sym_this] = ACTIONS(2567),
    [anon_sym_yield] = ACTIONS(2567),
    [sym_true] = ACTIONS(2567),
    [anon_sym_throw] = ACTIONS(2567),
    [anon_sym_protected] = ACTIONS(2567),
    [anon_sym_abstract] = ACTIONS(2567),
    [anon_sym_set] = ACTIONS(2567),
    [anon_sym_type] = ACTIONS(2567),
    [anon_sym_import] = ACTIONS(2567),
    [anon_sym_namespace] = ACTIONS(2567),
    [anon_sym_PLUS_PLUS] = ACTIONS(2569),
    [anon_sym_await] = ACTIONS(2567),
    [anon_sym_DQUOTE] = ACTIONS(2569),
    [anon_sym_else] = ACTIONS(2567),
    [anon_sym_BANG] = ACTIONS(2569),
    [anon_sym_for] = ACTIONS(2567),
    [anon_sym_LBRACK] = ACTIONS(2569),
    [sym_false] = ACTIONS(2567),
    [anon_sym_SEMI] = ACTIONS(2569),
    [anon_sym_case] = ACTIONS(2567),
    [anon_sym_module] = ACTIONS(2567),
    [anon_sym_number] = ACTIONS(2567),
    [anon_sym_class] = ACTIONS(2567),
    [anon_sym_declare] = ACTIONS(2567),
    [anon_sym_typeof] = ACTIONS(2567),
    [anon_sym_LBRACE] = ACTIONS(2569),
    [anon_sym_switch] = ACTIONS(2567),
    [anon_sym_LPAREN] = ACTIONS(2569),
    [sym_null] = ACTIONS(2567),
    [anon_sym_any] = ACTIONS(2567),
    [anon_sym_boolean] = ACTIONS(2567),
    [anon_sym_async] = ACTIONS(2567),
    [anon_sym_public] = ACTIONS(2567),
    [anon_sym_var] = ACTIONS(2567),
    [anon_sym_while] = ACTIONS(2567),
    [anon_sym_SQUOTE] = ACTIONS(2569),
    [anon_sym_try] = ACTIONS(2567),
    [anon_sym_LT] = ACTIONS(2569),
    [sym_number] = ACTIONS(2569),
    [anon_sym_SLASH] = ACTIONS(2567),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2567),
    [anon_sym_function] = ACTIONS(2567),
    [sym_undefined] = ACTIONS(2567),
    [anon_sym_new] = ACTIONS(2567),
    [ts_builtin_sym_end] = ACTIONS(2569),
    [anon_sym_let] = ACTIONS(2567),
    [anon_sym_PLUS] = ACTIONS(2567),
    [anon_sym_export] = ACTIONS(2567),
    [anon_sym_do] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2569),
    [anon_sym_with] = ACTIONS(2567),
  },
  [595] = {
    [sym__automatic_semicolon] = ACTIONS(2571),
    [anon_sym_SEMI] = ACTIONS(2571),
    [anon_sym_COMMA] = ACTIONS(2571),
    [sym_comment] = ACTIONS(3),
  },
  [596] = {
    [sym_identifier] = ACTIONS(2573),
    [anon_sym_BQUOTE] = ACTIONS(2575),
    [anon_sym_debugger] = ACTIONS(2573),
    [anon_sym_symbol] = ACTIONS(2573),
    [anon_sym_AT] = ACTIONS(2575),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_void] = ACTIONS(2573),
    [anon_sym_break] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [sym_super] = ACTIONS(2573),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_private] = ACTIONS(2573),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_RBRACE] = ACTIONS(2575),
    [anon_sym_interface] = ACTIONS(2573),
    [anon_sym_default] = ACTIONS(2573),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_delete] = ACTIONS(2573),
    [anon_sym_continue] = ACTIONS(2573),
    [anon_sym_DASH_DASH] = ACTIONS(2575),
    [anon_sym_if] = ACTIONS(2573),
    [anon_sym_this] = ACTIONS(2573),
    [anon_sym_yield] = ACTIONS(2573),
    [sym_true] = ACTIONS(2573),
    [anon_sym_throw] = ACTIONS(2573),
    [anon_sym_protected] = ACTIONS(2573),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_type] = ACTIONS(2573),
    [anon_sym_import] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_PLUS_PLUS] = ACTIONS(2575),
    [anon_sym_await] = ACTIONS(2573),
    [anon_sym_DQUOTE] = ACTIONS(2575),
    [anon_sym_else] = ACTIONS(2573),
    [anon_sym_BANG] = ACTIONS(2575),
    [anon_sym_for] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2575),
    [sym_false] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(2575),
    [anon_sym_case] = ACTIONS(2573),
    [anon_sym_module] = ACTIONS(2573),
    [anon_sym_number] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_declare] = ACTIONS(2573),
    [anon_sym_typeof] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_switch] = ACTIONS(2573),
    [anon_sym_LPAREN] = ACTIONS(2575),
    [sym_null] = ACTIONS(2573),
    [anon_sym_any] = ACTIONS(2573),
    [anon_sym_boolean] = ACTIONS(2573),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2573),
    [anon_sym_var] = ACTIONS(2573),
    [anon_sym_while] = ACTIONS(2573),
    [anon_sym_SQUOTE] = ACTIONS(2575),
    [anon_sym_try] = ACTIONS(2573),
    [anon_sym_LT] = ACTIONS(2575),
    [sym_number] = ACTIONS(2575),
    [anon_sym_SLASH] = ACTIONS(2573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2573),
    [anon_sym_function] = ACTIONS(2573),
    [sym_undefined] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2573),
    [ts_builtin_sym_end] = ACTIONS(2575),
    [anon_sym_let] = ACTIONS(2573),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_export] = ACTIONS(2573),
    [anon_sym_do] = ACTIONS(2573),
    [anon_sym_TILDE] = ACTIONS(2575),
    [anon_sym_with] = ACTIONS(2573),
  },
  [597] = {
    [aux_sym_variable_declaration_repeat1] = STATE(597),
    [sym__automatic_semicolon] = ACTIONS(2571),
    [anon_sym_SEMI] = ACTIONS(2571),
    [anon_sym_COMMA] = ACTIONS(2577),
    [sym_comment] = ACTIONS(3),
  },
  [598] = {
    [sym__automatic_semicolon] = ACTIONS(2580),
    [anon_sym_SEMI] = ACTIONS(2580),
    [anon_sym_COMMA] = ACTIONS(2580),
    [sym_comment] = ACTIONS(3),
  },
  [599] = {
    [sym__automatic_semicolon] = ACTIONS(2582),
    [anon_sym_SEMI] = ACTIONS(2582),
    [anon_sym_COMMA] = ACTIONS(2582),
    [sym_comment] = ACTIONS(3),
  },
  [600] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2584),
    [sym__automatic_semicolon] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_PERCENT_EQ] = ACTIONS(2584),
    [anon_sym_AMP_EQ] = ACTIONS(2584),
    [anon_sym_PLUS_EQ] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_DASH] = ACTIONS(2586),
    [anon_sym_STAR] = ACTIONS(2586),
    [anon_sym_GT_GT_GT] = ACTIONS(2586),
    [anon_sym_EQ] = ACTIONS(2586),
    [anon_sym_BANG_EQ] = ACTIONS(2586),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_CARET_EQ] = ACTIONS(2584),
    [anon_sym_PIPE_EQ] = ACTIONS(2584),
    [anon_sym_DASH_EQ] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2586),
    [anon_sym_LT_LT_EQ] = ACTIONS(2584),
    [anon_sym_as] = ACTIONS(2584),
    [anon_sym_DASH_DASH] = ACTIONS(2584),
    [anon_sym_instanceof] = ACTIONS(2584),
    [anon_sym_GT_GT_EQ] = ACTIONS(2584),
    [anon_sym_DOT] = ACTIONS(2584),
    [anon_sym_STAR_STAR] = ACTIONS(2586),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2584),
    [anon_sym_PLUS_PLUS] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_SEMI] = ACTIONS(2584),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2584),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_STAR_EQ] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
    [anon_sym_QMARK] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2586),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_SLASH] = ACTIONS(2586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2584),
    [anon_sym_CARET] = ACTIONS(2586),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_GT_GT] = ACTIONS(2586),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(2586),
  },
  [601] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2588),
    [sym__automatic_semicolon] = ACTIONS(2588),
    [anon_sym_BQUOTE] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_DASH] = ACTIONS(2590),
    [anon_sym_STAR] = ACTIONS(2590),
    [anon_sym_GT_GT_GT] = ACTIONS(2588),
    [anon_sym_BANG_EQ] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2588),
    [anon_sym_PERCENT] = ACTIONS(2588),
    [anon_sym_as] = ACTIONS(2588),
    [anon_sym_DASH_DASH] = ACTIONS(2588),
    [anon_sym_instanceof] = ACTIONS(2588),
    [anon_sym_DOT] = ACTIONS(2588),
    [anon_sym_STAR_STAR] = ACTIONS(2588),
    [anon_sym_PLUS_PLUS] = ACTIONS(2588),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_LT_EQ] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2590),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_SLASH] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2588),
    [anon_sym_in] = ACTIONS(2590),
  },
  [602] = {
    [aux_sym_array_repeat1] = STATE(375),
    [anon_sym_RPAREN] = ACTIONS(2592),
    [anon_sym_COMMA] = ACTIONS(272),
    [sym_comment] = ACTIONS(3),
  },
  [603] = {
    [sym_identifier] = ACTIONS(2594),
    [anon_sym_BQUOTE] = ACTIONS(2596),
    [anon_sym_debugger] = ACTIONS(2594),
    [anon_sym_symbol] = ACTIONS(2594),
    [anon_sym_AT] = ACTIONS(2596),
    [anon_sym_DASH] = ACTIONS(2594),
    [anon_sym_void] = ACTIONS(2594),
    [anon_sym_break] = ACTIONS(2594),
    [anon_sym_const] = ACTIONS(2594),
    [sym_super] = ACTIONS(2594),
    [anon_sym_return] = ACTIONS(2594),
    [anon_sym_private] = ACTIONS(2594),
    [anon_sym_get] = ACTIONS(2594),
    [anon_sym_RBRACE] = ACTIONS(2596),
    [anon_sym_interface] = ACTIONS(2594),
    [anon_sym_default] = ACTIONS(2594),
    [anon_sym_enum] = ACTIONS(2594),
    [anon_sym_delete] = ACTIONS(2594),
    [anon_sym_continue] = ACTIONS(2594),
    [anon_sym_DASH_DASH] = ACTIONS(2596),
    [anon_sym_if] = ACTIONS(2594),
    [anon_sym_this] = ACTIONS(2594),
    [anon_sym_yield] = ACTIONS(2594),
    [sym_true] = ACTIONS(2594),
    [anon_sym_throw] = ACTIONS(2594),
    [anon_sym_protected] = ACTIONS(2594),
    [anon_sym_abstract] = ACTIONS(2594),
    [anon_sym_set] = ACTIONS(2594),
    [anon_sym_type] = ACTIONS(2594),
    [anon_sym_import] = ACTIONS(2594),
    [anon_sym_namespace] = ACTIONS(2594),
    [anon_sym_PLUS_PLUS] = ACTIONS(2596),
    [anon_sym_await] = ACTIONS(2594),
    [anon_sym_DQUOTE] = ACTIONS(2596),
    [anon_sym_else] = ACTIONS(2594),
    [anon_sym_BANG] = ACTIONS(2596),
    [anon_sym_for] = ACTIONS(2594),
    [anon_sym_LBRACK] = ACTIONS(2596),
    [sym_false] = ACTIONS(2594),
    [anon_sym_SEMI] = ACTIONS(2596),
    [anon_sym_case] = ACTIONS(2594),
    [anon_sym_module] = ACTIONS(2594),
    [anon_sym_number] = ACTIONS(2594),
    [anon_sym_class] = ACTIONS(2594),
    [anon_sym_declare] = ACTIONS(2594),
    [anon_sym_typeof] = ACTIONS(2594),
    [anon_sym_LBRACE] = ACTIONS(2596),
    [anon_sym_switch] = ACTIONS(2594),
    [anon_sym_LPAREN] = ACTIONS(2596),
    [sym_null] = ACTIONS(2594),
    [anon_sym_any] = ACTIONS(2594),
    [anon_sym_boolean] = ACTIONS(2594),
    [anon_sym_async] = ACTIONS(2594),
    [anon_sym_public] = ACTIONS(2594),
    [anon_sym_var] = ACTIONS(2594),
    [anon_sym_while] = ACTIONS(2594),
    [anon_sym_SQUOTE] = ACTIONS(2596),
    [anon_sym_try] = ACTIONS(2594),
    [anon_sym_LT] = ACTIONS(2596),
    [sym_number] = ACTIONS(2596),
    [anon_sym_SLASH] = ACTIONS(2594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2594),
    [anon_sym_function] = ACTIONS(2594),
    [sym_undefined] = ACTIONS(2594),
    [anon_sym_new] = ACTIONS(2594),
    [ts_builtin_sym_end] = ACTIONS(2596),
    [anon_sym_let] = ACTIONS(2594),
    [anon_sym_PLUS] = ACTIONS(2594),
    [anon_sym_export] = ACTIONS(2594),
    [anon_sym_do] = ACTIONS(2594),
    [anon_sym_TILDE] = ACTIONS(2596),
    [anon_sym_with] = ACTIONS(2594),
  },
  [604] = {
    [sym_object_type] = STATE(835),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(476),
  },
  [605] = {
    [sym_identifier] = ACTIONS(2598),
    [anon_sym_BQUOTE] = ACTIONS(2600),
    [anon_sym_debugger] = ACTIONS(2598),
    [anon_sym_symbol] = ACTIONS(2598),
    [anon_sym_AT] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(2598),
    [anon_sym_void] = ACTIONS(2598),
    [anon_sym_break] = ACTIONS(2598),
    [anon_sym_const] = ACTIONS(2598),
    [sym_super] = ACTIONS(2598),
    [anon_sym_return] = ACTIONS(2598),
    [anon_sym_private] = ACTIONS(2598),
    [anon_sym_get] = ACTIONS(2598),
    [anon_sym_RBRACE] = ACTIONS(2600),
    [anon_sym_interface] = ACTIONS(2598),
    [anon_sym_default] = ACTIONS(2598),
    [anon_sym_enum] = ACTIONS(2598),
    [anon_sym_delete] = ACTIONS(2598),
    [anon_sym_continue] = ACTIONS(2598),
    [anon_sym_DASH_DASH] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(2598),
    [anon_sym_this] = ACTIONS(2598),
    [anon_sym_yield] = ACTIONS(2598),
    [sym_true] = ACTIONS(2598),
    [anon_sym_throw] = ACTIONS(2598),
    [anon_sym_protected] = ACTIONS(2598),
    [anon_sym_abstract] = ACTIONS(2598),
    [anon_sym_set] = ACTIONS(2598),
    [anon_sym_type] = ACTIONS(2598),
    [anon_sym_import] = ACTIONS(2598),
    [anon_sym_namespace] = ACTIONS(2598),
    [anon_sym_PLUS_PLUS] = ACTIONS(2600),
    [anon_sym_await] = ACTIONS(2598),
    [anon_sym_DQUOTE] = ACTIONS(2600),
    [anon_sym_else] = ACTIONS(2598),
    [anon_sym_BANG] = ACTIONS(2600),
    [anon_sym_for] = ACTIONS(2598),
    [anon_sym_LBRACK] = ACTIONS(2600),
    [sym_false] = ACTIONS(2598),
    [anon_sym_SEMI] = ACTIONS(2600),
    [anon_sym_case] = ACTIONS(2598),
    [anon_sym_module] = ACTIONS(2598),
    [anon_sym_number] = ACTIONS(2598),
    [anon_sym_class] = ACTIONS(2598),
    [anon_sym_declare] = ACTIONS(2598),
    [anon_sym_typeof] = ACTIONS(2598),
    [anon_sym_LBRACE] = ACTIONS(2600),
    [anon_sym_switch] = ACTIONS(2598),
    [anon_sym_LPAREN] = ACTIONS(2600),
    [sym_null] = ACTIONS(2598),
    [anon_sym_any] = ACTIONS(2598),
    [anon_sym_boolean] = ACTIONS(2598),
    [anon_sym_async] = ACTIONS(2598),
    [anon_sym_public] = ACTIONS(2598),
    [anon_sym_var] = ACTIONS(2598),
    [anon_sym_while] = ACTIONS(2598),
    [anon_sym_SQUOTE] = ACTIONS(2600),
    [anon_sym_try] = ACTIONS(2598),
    [anon_sym_LT] = ACTIONS(2600),
    [sym_number] = ACTIONS(2600),
    [anon_sym_SLASH] = ACTIONS(2598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2598),
    [anon_sym_function] = ACTIONS(2598),
    [sym_undefined] = ACTIONS(2598),
    [anon_sym_new] = ACTIONS(2598),
    [ts_builtin_sym_end] = ACTIONS(2600),
    [anon_sym_let] = ACTIONS(2598),
    [anon_sym_PLUS] = ACTIONS(2598),
    [anon_sym_export] = ACTIONS(2598),
    [anon_sym_do] = ACTIONS(2598),
    [anon_sym_TILDE] = ACTIONS(2600),
    [anon_sym_with] = ACTIONS(2598),
  },
  [606] = {
    [sym__initializer] = STATE(836),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RBRACE] = ACTIONS(2602),
    [anon_sym_COMMA] = ACTIONS(2602),
    [sym_comment] = ACTIONS(3),
  },
  [607] = {
    [aux_sym_enum_body_repeat1] = STATE(839),
    [anon_sym_RBRACE] = ACTIONS(2604),
    [anon_sym_COMMA] = ACTIONS(2606),
    [sym_comment] = ACTIONS(3),
  },
  [608] = {
    [sym_type_alias_declaration] = STATE(840),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(840),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(840),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(840),
    [sym_return_statement] = STATE(840),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(840),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(840),
    [sym_switch_statement] = STATE(840),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(840),
    [sym_throw_statement] = STATE(840),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(840),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(840),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(840),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(840),
    [sym_abstract_class] = STATE(840),
    [sym_interface_declaration] = STATE(840),
    [sym_statement_block] = STATE(840),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(840),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(840),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(840),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(840),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(840),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(840),
    [sym_empty_statement] = STATE(840),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(840),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(840),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(840),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(840),
    [sym_break_statement] = STATE(840),
    [sym_labeled_statement] = STATE(840),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(840),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [609] = {
    [sym_class_body] = STATE(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1793),
  },
  [610] = {
    [sym_class_heritage] = STATE(842),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(841),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1793),
  },
  [611] = {
    [sym_identifier] = ACTIONS(2608),
    [anon_sym_BQUOTE] = ACTIONS(2610),
    [anon_sym_debugger] = ACTIONS(2608),
    [anon_sym_symbol] = ACTIONS(2608),
    [anon_sym_AT] = ACTIONS(2610),
    [anon_sym_DASH] = ACTIONS(2608),
    [anon_sym_void] = ACTIONS(2608),
    [anon_sym_break] = ACTIONS(2608),
    [anon_sym_const] = ACTIONS(2608),
    [sym_super] = ACTIONS(2608),
    [anon_sym_return] = ACTIONS(2608),
    [anon_sym_private] = ACTIONS(2608),
    [anon_sym_get] = ACTIONS(2608),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_interface] = ACTIONS(2608),
    [anon_sym_default] = ACTIONS(2608),
    [anon_sym_enum] = ACTIONS(2608),
    [anon_sym_delete] = ACTIONS(2608),
    [anon_sym_continue] = ACTIONS(2608),
    [anon_sym_DASH_DASH] = ACTIONS(2610),
    [anon_sym_if] = ACTIONS(2608),
    [anon_sym_this] = ACTIONS(2608),
    [anon_sym_yield] = ACTIONS(2608),
    [sym_true] = ACTIONS(2608),
    [anon_sym_throw] = ACTIONS(2608),
    [anon_sym_protected] = ACTIONS(2608),
    [anon_sym_abstract] = ACTIONS(2608),
    [anon_sym_set] = ACTIONS(2608),
    [anon_sym_type] = ACTIONS(2608),
    [anon_sym_import] = ACTIONS(2608),
    [anon_sym_namespace] = ACTIONS(2608),
    [anon_sym_PLUS_PLUS] = ACTIONS(2610),
    [anon_sym_await] = ACTIONS(2608),
    [anon_sym_DQUOTE] = ACTIONS(2610),
    [anon_sym_else] = ACTIONS(2608),
    [anon_sym_BANG] = ACTIONS(2610),
    [anon_sym_for] = ACTIONS(2608),
    [anon_sym_LBRACK] = ACTIONS(2610),
    [sym_false] = ACTIONS(2608),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_case] = ACTIONS(2608),
    [anon_sym_module] = ACTIONS(2608),
    [anon_sym_number] = ACTIONS(2608),
    [anon_sym_class] = ACTIONS(2608),
    [anon_sym_declare] = ACTIONS(2608),
    [anon_sym_typeof] = ACTIONS(2608),
    [anon_sym_LBRACE] = ACTIONS(2610),
    [anon_sym_switch] = ACTIONS(2608),
    [anon_sym_LPAREN] = ACTIONS(2610),
    [sym_null] = ACTIONS(2608),
    [anon_sym_any] = ACTIONS(2608),
    [anon_sym_boolean] = ACTIONS(2608),
    [anon_sym_async] = ACTIONS(2608),
    [anon_sym_public] = ACTIONS(2608),
    [anon_sym_var] = ACTIONS(2608),
    [anon_sym_while] = ACTIONS(2608),
    [anon_sym_SQUOTE] = ACTIONS(2610),
    [anon_sym_try] = ACTIONS(2608),
    [anon_sym_LT] = ACTIONS(2610),
    [sym_number] = ACTIONS(2610),
    [anon_sym_SLASH] = ACTIONS(2608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2608),
    [anon_sym_function] = ACTIONS(2608),
    [sym_undefined] = ACTIONS(2608),
    [anon_sym_new] = ACTIONS(2608),
    [ts_builtin_sym_end] = ACTIONS(2610),
    [anon_sym_let] = ACTIONS(2608),
    [anon_sym_PLUS] = ACTIONS(2608),
    [anon_sym_export] = ACTIONS(2608),
    [anon_sym_do] = ACTIONS(2608),
    [anon_sym_TILDE] = ACTIONS(2610),
    [anon_sym_with] = ACTIONS(2608),
  },
  [612] = {
    [sym__automatic_semicolon] = ACTIONS(2612),
    [anon_sym_AMP] = ACTIONS(2614),
    [anon_sym_SEMI] = ACTIONS(2612),
    [anon_sym_PIPE] = ACTIONS(2616),
    [sym_comment] = ACTIONS(3),
  },
  [613] = {
    [sym__type] = STATE(844),
    [sym_constructor_type] = STATE(844),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_function_type] = STATE(844),
    [sym_nested_identifier] = STATE(2393),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_array_type] = STATE(1496),
    [sym_tuple_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(844),
    [sym_intersection_type] = STATE(844),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_this] = ACTIONS(1823),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [614] = {
    [anon_sym_from] = ACTIONS(2618),
    [sym_comment] = ACTIONS(3),
  },
  [615] = {
    [anon_sym_LPAREN] = ACTIONS(2620),
    [sym_comment] = ACTIONS(3),
  },
  [616] = {
    [sym__automatic_semicolon] = ACTIONS(2622),
    [anon_sym_SEMI] = ACTIONS(2622),
    [anon_sym_DOT] = ACTIONS(2624),
    [sym_comment] = ACTIONS(3),
  },
  [617] = {
    [anon_sym_require] = ACTIONS(2626),
    [sym_comment] = ACTIONS(3),
  },
  [618] = {
    [sym_identifier] = ACTIONS(2628),
    [anon_sym_BQUOTE] = ACTIONS(2630),
    [anon_sym_debugger] = ACTIONS(2628),
    [anon_sym_symbol] = ACTIONS(2628),
    [anon_sym_AT] = ACTIONS(2630),
    [anon_sym_DASH] = ACTIONS(2628),
    [anon_sym_void] = ACTIONS(2628),
    [anon_sym_break] = ACTIONS(2628),
    [anon_sym_const] = ACTIONS(2628),
    [sym_super] = ACTIONS(2628),
    [anon_sym_return] = ACTIONS(2628),
    [anon_sym_private] = ACTIONS(2628),
    [anon_sym_get] = ACTIONS(2628),
    [anon_sym_RBRACE] = ACTIONS(2630),
    [anon_sym_interface] = ACTIONS(2628),
    [anon_sym_default] = ACTIONS(2628),
    [anon_sym_enum] = ACTIONS(2628),
    [anon_sym_delete] = ACTIONS(2628),
    [anon_sym_continue] = ACTIONS(2628),
    [anon_sym_DASH_DASH] = ACTIONS(2630),
    [anon_sym_if] = ACTIONS(2628),
    [anon_sym_this] = ACTIONS(2628),
    [anon_sym_yield] = ACTIONS(2628),
    [sym_true] = ACTIONS(2628),
    [anon_sym_throw] = ACTIONS(2628),
    [anon_sym_protected] = ACTIONS(2628),
    [anon_sym_abstract] = ACTIONS(2628),
    [anon_sym_set] = ACTIONS(2628),
    [anon_sym_type] = ACTIONS(2628),
    [anon_sym_import] = ACTIONS(2628),
    [anon_sym_namespace] = ACTIONS(2628),
    [anon_sym_PLUS_PLUS] = ACTIONS(2630),
    [anon_sym_await] = ACTIONS(2628),
    [anon_sym_DQUOTE] = ACTIONS(2630),
    [anon_sym_else] = ACTIONS(2628),
    [anon_sym_BANG] = ACTIONS(2630),
    [anon_sym_for] = ACTIONS(2628),
    [anon_sym_LBRACK] = ACTIONS(2630),
    [sym_false] = ACTIONS(2628),
    [anon_sym_SEMI] = ACTIONS(2630),
    [anon_sym_case] = ACTIONS(2628),
    [anon_sym_module] = ACTIONS(2628),
    [anon_sym_number] = ACTIONS(2628),
    [anon_sym_class] = ACTIONS(2628),
    [anon_sym_declare] = ACTIONS(2628),
    [anon_sym_typeof] = ACTIONS(2628),
    [anon_sym_LBRACE] = ACTIONS(2630),
    [anon_sym_switch] = ACTIONS(2628),
    [anon_sym_LPAREN] = ACTIONS(2630),
    [sym_null] = ACTIONS(2628),
    [anon_sym_any] = ACTIONS(2628),
    [anon_sym_boolean] = ACTIONS(2628),
    [anon_sym_async] = ACTIONS(2628),
    [anon_sym_public] = ACTIONS(2628),
    [anon_sym_var] = ACTIONS(2628),
    [anon_sym_while] = ACTIONS(2628),
    [anon_sym_SQUOTE] = ACTIONS(2630),
    [anon_sym_try] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(2630),
    [sym_number] = ACTIONS(2630),
    [anon_sym_SLASH] = ACTIONS(2628),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2628),
    [anon_sym_function] = ACTIONS(2628),
    [sym_undefined] = ACTIONS(2628),
    [anon_sym_new] = ACTIONS(2628),
    [ts_builtin_sym_end] = ACTIONS(2630),
    [anon_sym_let] = ACTIONS(2628),
    [anon_sym_PLUS] = ACTIONS(2628),
    [anon_sym_export] = ACTIONS(2628),
    [anon_sym_do] = ACTIONS(2628),
    [anon_sym_TILDE] = ACTIONS(2630),
    [anon_sym_with] = ACTIONS(2628),
  },
  [619] = {
    [sym__automatic_semicolon] = ACTIONS(2632),
    [anon_sym_SEMI] = ACTIONS(2632),
    [sym_comment] = ACTIONS(3),
  },
  [620] = {
    [anon_sym_from] = ACTIONS(2634),
    [sym_comment] = ACTIONS(3),
  },
  [621] = {
    [sym_identifier] = ACTIONS(2636),
    [sym_comment] = ACTIONS(3),
  },
  [622] = {
    [anon_sym_RBRACE] = ACTIONS(2638),
    [anon_sym_COMMA] = ACTIONS(2638),
    [anon_sym_as] = ACTIONS(2640),
    [sym_comment] = ACTIONS(3),
  },
  [623] = {
    [anon_sym_from] = ACTIONS(2642),
    [sym_comment] = ACTIONS(3),
  },
  [624] = {
    [sym__import_export_specifier] = STATE(851),
    [sym_identifier] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(2644),
    [anon_sym_typeof] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
  },
  [625] = {
    [anon_sym_from] = ACTIONS(2646),
    [sym_comment] = ACTIONS(3),
  },
  [626] = {
    [aux_sym_named_imports_repeat1] = STATE(853),
    [anon_sym_COMMA] = ACTIONS(2648),
    [anon_sym_RBRACE] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
  },
  [627] = {
    [sym__automatic_semicolon] = ACTIONS(2650),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(2650),
  },
  [628] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2652),
    [sym__automatic_semicolon] = ACTIONS(2652),
    [anon_sym_BQUOTE] = ACTIONS(2652),
    [anon_sym_symbol] = ACTIONS(2654),
    [anon_sym_PIPE] = ACTIONS(2654),
    [anon_sym_STAR] = ACTIONS(2654),
    [anon_sym_GT_GT_GT] = ACTIONS(2652),
    [anon_sym_break] = ACTIONS(2654),
    [anon_sym_BANG_EQ] = ACTIONS(2654),
    [anon_sym_return] = ACTIONS(2654),
    [anon_sym_RBRACE] = ACTIONS(2652),
    [anon_sym_PERCENT] = ACTIONS(2652),
    [anon_sym_interface] = ACTIONS(2654),
    [anon_sym_as] = ACTIONS(2654),
    [anon_sym_delete] = ACTIONS(2654),
    [anon_sym_if] = ACTIONS(2654),
    [anon_sym_instanceof] = ACTIONS(2654),
    [anon_sym_yield] = ACTIONS(2654),
    [sym_true] = ACTIONS(2654),
    [anon_sym_protected] = ACTIONS(2654),
    [anon_sym_DOT] = ACTIONS(2654),
    [anon_sym_set] = ACTIONS(2654),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2652),
    [anon_sym_import] = ACTIONS(2654),
    [anon_sym_await] = ACTIONS(2654),
    [anon_sym_DQUOTE] = ACTIONS(2652),
    [anon_sym_for] = ACTIONS(2654),
    [anon_sym_SEMI] = ACTIONS(2652),
    [anon_sym_number] = ACTIONS(2654),
    [anon_sym_typeof] = ACTIONS(2654),
    [anon_sym_LT_LT] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2652),
    [anon_sym_AMP_AMP] = ACTIONS(2652),
    [anon_sym_switch] = ACTIONS(2654),
    [anon_sym_LT_EQ] = ACTIONS(2652),
    [sym_null] = ACTIONS(2654),
    [anon_sym_any] = ACTIONS(2654),
    [anon_sym_async] = ACTIONS(2654),
    [anon_sym_public] = ACTIONS(2654),
    [anon_sym_var] = ACTIONS(2654),
    [anon_sym_QMARK] = ACTIONS(2652),
    [anon_sym_while] = ACTIONS(2654),
    [anon_sym_SQUOTE] = ACTIONS(2652),
    [anon_sym_SLASH] = ACTIONS(2654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2654),
    [anon_sym_new] = ACTIONS(2654),
    [anon_sym_CARET] = ACTIONS(2652),
    [anon_sym_export] = ACTIONS(2654),
    [anon_sym_GT_GT] = ACTIONS(2654),
    [anon_sym_with] = ACTIONS(2654),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2652),
    [sym_identifier] = ACTIONS(2654),
    [anon_sym_debugger] = ACTIONS(2654),
    [anon_sym_AT] = ACTIONS(2652),
    [anon_sym_COMMA] = ACTIONS(2652),
    [anon_sym_DASH] = ACTIONS(2654),
    [anon_sym_void] = ACTIONS(2654),
    [anon_sym_const] = ACTIONS(2654),
    [anon_sym_GT_EQ] = ACTIONS(2652),
    [sym_super] = ACTIONS(2654),
    [anon_sym_private] = ACTIONS(2654),
    [anon_sym_get] = ACTIONS(2654),
    [anon_sym_default] = ACTIONS(2654),
    [anon_sym_enum] = ACTIONS(2654),
    [anon_sym_continue] = ACTIONS(2654),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_this] = ACTIONS(2654),
    [anon_sym_throw] = ACTIONS(2654),
    [anon_sym_abstract] = ACTIONS(2654),
    [anon_sym_type] = ACTIONS(2654),
    [anon_sym_STAR_STAR] = ACTIONS(2652),
    [anon_sym_namespace] = ACTIONS(2654),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_else] = ACTIONS(2654),
    [anon_sym_BANG] = ACTIONS(2654),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [sym_false] = ACTIONS(2654),
    [anon_sym_case] = ACTIONS(2654),
    [anon_sym_module] = ACTIONS(2654),
    [anon_sym_class] = ACTIONS(2654),
    [anon_sym_declare] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2652),
    [anon_sym_GT] = ACTIONS(2654),
    [anon_sym_boolean] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2654),
    [anon_sym_PIPE_PIPE] = ACTIONS(2652),
    [anon_sym_try] = ACTIONS(2654),
    [anon_sym_EQ_EQ] = ACTIONS(2654),
    [anon_sym_LT] = ACTIONS(2654),
    [sym_number] = ACTIONS(2652),
    [ts_builtin_sym_end] = ACTIONS(2652),
    [anon_sym_function] = ACTIONS(2654),
    [sym_undefined] = ACTIONS(2654),
    [anon_sym_let] = ACTIONS(2654),
    [anon_sym_PLUS] = ACTIONS(2654),
    [anon_sym_do] = ACTIONS(2654),
    [anon_sym_TILDE] = ACTIONS(2652),
    [anon_sym_in] = ACTIONS(2654),
  },
  [629] = {
    [sym_array] = STATE(855),
    [sym_object] = STATE(856),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(2656),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(185),
  },
  [630] = {
    [anon_sym_of] = ACTIONS(2658),
    [sym_comment] = ACTIONS(3),
  },
  [631] = {
    [anon_sym_of] = ACTIONS(2660),
    [sym_comment] = ACTIONS(3),
  },
  [632] = {
    [anon_sym_of] = ACTIONS(2662),
    [sym_comment] = ACTIONS(3),
  },
  [633] = {
    [sym_new_expression] = STATE(860),
    [sym_augmented_assignment_expression] = STATE(860),
    [sym_unary_expression] = STATE(860),
    [sym_update_expression] = STATE(860),
    [sym_regex] = STATE(860),
    [sym_meta_property] = STATE(860),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(860),
    [sym_yield_expression] = STATE(860),
    [sym_as_expression] = STATE(860),
    [sym_non_null_expression] = STATE(860),
    [sym_internal_module] = STATE(860),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(860),
    [sym_await_expression] = STATE(860),
    [sym_member_expression] = STATE(54),
    [sym_sequence_expression] = STATE(861),
    [sym_string] = STATE(860),
    [sym_this] = STATE(860),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(860),
    [sym_generator_function] = STATE(860),
    [sym_call_expression] = STATE(860),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(860),
    [sym_ternary_expression] = STATE(860),
    [sym_binary_expression] = STATE(860),
    [sym_template_string] = STATE(860),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(860),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(860),
    [sym_class] = STATE(860),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(2664),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(2664),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(2664),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2666),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(2664),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [634] = {
    [sym_new_expression] = STATE(862),
    [sym_augmented_assignment_expression] = STATE(862),
    [sym_unary_expression] = STATE(862),
    [sym_update_expression] = STATE(862),
    [sym_regex] = STATE(862),
    [sym_meta_property] = STATE(862),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(862),
    [sym_yield_expression] = STATE(862),
    [sym_as_expression] = STATE(862),
    [sym_non_null_expression] = STATE(862),
    [sym_internal_module] = STATE(862),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(862),
    [sym_await_expression] = STATE(862),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(862),
    [sym_this] = STATE(862),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(862),
    [sym_generator_function] = STATE(862),
    [sym_call_expression] = STATE(862),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(862),
    [sym_ternary_expression] = STATE(862),
    [sym_binary_expression] = STATE(862),
    [sym_template_string] = STATE(862),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(862),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(862),
    [sym_class] = STATE(862),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(2668),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(2668),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(2668),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2670),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(2668),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [635] = {
    [sym__initializer] = STATE(316),
    [sym_type_annotation] = STATE(317),
    [sym__automatic_semicolon] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym_of] = ACTIONS(2658),
    [anon_sym_COMMA] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(2672),
  },
  [636] = {
    [sym__initializer] = STATE(322),
    [sym_type_annotation] = STATE(323),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_of] = ACTIONS(2660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(2674),
  },
  [637] = {
    [sym__initializer] = STATE(324),
    [sym_type_annotation] = STATE(325),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_of] = ACTIONS(2662),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(2676),
  },
  [638] = {
    [sym_new_expression] = STATE(867),
    [sym_augmented_assignment_expression] = STATE(867),
    [sym_unary_expression] = STATE(867),
    [sym_update_expression] = STATE(867),
    [sym_regex] = STATE(867),
    [sym_meta_property] = STATE(867),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(867),
    [sym_yield_expression] = STATE(867),
    [sym_as_expression] = STATE(867),
    [sym_non_null_expression] = STATE(867),
    [sym_internal_module] = STATE(867),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(867),
    [sym_await_expression] = STATE(867),
    [sym_member_expression] = STATE(1201),
    [sym_sequence_expression] = STATE(868),
    [sym_string] = STATE(867),
    [sym_this] = STATE(867),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(867),
    [sym_generator_function] = STATE(867),
    [sym_call_expression] = STATE(867),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(867),
    [sym_ternary_expression] = STATE(867),
    [sym_binary_expression] = STATE(867),
    [sym_template_string] = STATE(867),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(867),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(867),
    [sym_class] = STATE(867),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(2678),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(2678),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(2678),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(2680),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2682),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(2678),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [639] = {
    [sym_new_expression] = STATE(869),
    [sym_augmented_assignment_expression] = STATE(869),
    [sym_unary_expression] = STATE(869),
    [sym_update_expression] = STATE(869),
    [sym_regex] = STATE(869),
    [sym_meta_property] = STATE(869),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(869),
    [sym_yield_expression] = STATE(869),
    [sym_as_expression] = STATE(869),
    [sym_non_null_expression] = STATE(869),
    [sym_internal_module] = STATE(869),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(869),
    [sym_await_expression] = STATE(869),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(869),
    [sym_this] = STATE(869),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(869),
    [sym_generator_function] = STATE(869),
    [sym_call_expression] = STATE(869),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(869),
    [sym_ternary_expression] = STATE(869),
    [sym_binary_expression] = STATE(869),
    [sym_template_string] = STATE(869),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(869),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(869),
    [sym_class] = STATE(869),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(2684),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(2684),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(2684),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2686),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(2684),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [640] = {
    [sym_new_expression] = STATE(870),
    [sym_augmented_assignment_expression] = STATE(870),
    [sym_unary_expression] = STATE(870),
    [sym_update_expression] = STATE(870),
    [sym_regex] = STATE(870),
    [sym_meta_property] = STATE(870),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(870),
    [sym_yield_expression] = STATE(870),
    [sym_as_expression] = STATE(870),
    [sym_non_null_expression] = STATE(870),
    [sym_internal_module] = STATE(870),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(870),
    [sym_await_expression] = STATE(870),
    [sym_member_expression] = STATE(54),
    [sym_sequence_expression] = STATE(871),
    [sym_string] = STATE(870),
    [sym_this] = STATE(870),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(870),
    [sym_generator_function] = STATE(870),
    [sym_call_expression] = STATE(870),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(870),
    [sym_ternary_expression] = STATE(870),
    [sym_binary_expression] = STATE(870),
    [sym_template_string] = STATE(870),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(870),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(870),
    [sym_class] = STATE(870),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(2688),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(2688),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(2688),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2690),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(2688),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [641] = {
    [sym_new_expression] = STATE(872),
    [sym_augmented_assignment_expression] = STATE(872),
    [sym_unary_expression] = STATE(872),
    [sym_update_expression] = STATE(872),
    [sym_regex] = STATE(872),
    [sym_meta_property] = STATE(872),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(872),
    [sym_yield_expression] = STATE(872),
    [sym_as_expression] = STATE(872),
    [sym_non_null_expression] = STATE(872),
    [sym_internal_module] = STATE(872),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(872),
    [sym_await_expression] = STATE(872),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(872),
    [sym_this] = STATE(872),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(872),
    [sym_generator_function] = STATE(872),
    [sym_call_expression] = STATE(872),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(872),
    [sym_ternary_expression] = STATE(872),
    [sym_binary_expression] = STATE(872),
    [sym_template_string] = STATE(872),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(872),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(872),
    [sym_class] = STATE(872),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(2692),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(2692),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(2692),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2694),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(2692),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [642] = {
    [sym_new_expression] = STATE(873),
    [sym_augmented_assignment_expression] = STATE(873),
    [sym_unary_expression] = STATE(873),
    [sym_update_expression] = STATE(873),
    [sym_regex] = STATE(873),
    [sym_meta_property] = STATE(873),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(873),
    [sym_yield_expression] = STATE(873),
    [sym_as_expression] = STATE(873),
    [sym_non_null_expression] = STATE(873),
    [sym_internal_module] = STATE(873),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(873),
    [sym_await_expression] = STATE(873),
    [sym_member_expression] = STATE(54),
    [sym_sequence_expression] = STATE(874),
    [sym_string] = STATE(873),
    [sym_this] = STATE(873),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(873),
    [sym_generator_function] = STATE(873),
    [sym_call_expression] = STATE(873),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(873),
    [sym_ternary_expression] = STATE(873),
    [sym_binary_expression] = STATE(873),
    [sym_template_string] = STATE(873),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(873),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(873),
    [sym_class] = STATE(873),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(2696),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(2696),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(2696),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(2696),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [643] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2700),
    [sym__automatic_semicolon] = ACTIONS(2700),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2702),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_DASH] = ACTIONS(2702),
    [anon_sym_STAR] = ACTIONS(2702),
    [anon_sym_GT_GT_GT] = ACTIONS(2700),
    [anon_sym_EQ] = ACTIONS(2702),
    [anon_sym_BANG_EQ] = ACTIONS(2702),
    [anon_sym_GT_EQ] = ACTIONS(2700),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_PERCENT] = ACTIONS(2700),
    [anon_sym_as] = ACTIONS(2700),
    [anon_sym_DASH_DASH] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2700),
    [anon_sym_DOT] = ACTIONS(2700),
    [anon_sym_STAR_STAR] = ACTIONS(2700),
    [anon_sym_PLUS_PLUS] = ACTIONS(2700),
    [anon_sym_BANG] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(2700),
    [anon_sym_SEMI] = ACTIONS(2700),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_of] = ACTIONS(2700),
    [anon_sym_LT_EQ] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2700),
    [anon_sym_GT] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2702),
    [anon_sym_QMARK] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2702),
    [anon_sym_RPAREN] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2702),
    [anon_sym_SLASH] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_GT_GT] = ACTIONS(2702),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2700),
    [anon_sym_in] = ACTIONS(2702),
  },
  [644] = {
    [sym_identifier] = ACTIONS(2704),
    [sym_comment] = ACTIONS(3),
  },
  [645] = {
    [sym_new_expression] = STATE(876),
    [sym_augmented_assignment_expression] = STATE(876),
    [sym_unary_expression] = STATE(876),
    [sym_update_expression] = STATE(876),
    [sym_regex] = STATE(876),
    [sym_meta_property] = STATE(876),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(876),
    [sym_yield_expression] = STATE(876),
    [sym_as_expression] = STATE(876),
    [sym_non_null_expression] = STATE(876),
    [sym_internal_module] = STATE(876),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(876),
    [sym_await_expression] = STATE(876),
    [sym_member_expression] = STATE(2338),
    [sym_generic_type] = STATE(877),
    [sym_string] = STATE(876),
    [sym_this] = STATE(876),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_nested_type_identifier] = STATE(378),
    [sym_anonymous_class] = STATE(876),
    [sym_generator_function] = STATE(876),
    [sym_call_expression] = STATE(876),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(876),
    [sym_ternary_expression] = STATE(876),
    [sym_binary_expression] = STATE(876),
    [sym_template_string] = STATE(876),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(876),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(876),
    [sym__type_reference] = STATE(877),
    [sym_class] = STATE(876),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(885),
    [sym_false] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(2706),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(2708),
    [sym_true] = ACTIONS(2706),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(2706),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [646] = {
    [aux_sym_extends_clause_repeat1] = STATE(878),
    [anon_sym_implements] = ACTIONS(2710),
    [anon_sym_COMMA] = ACTIONS(1930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2710),
  },
  [647] = {
    [sym__type] = STATE(792),
    [sym_constructor_type] = STATE(792),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(792),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(792),
    [sym_intersection_type] = STATE(792),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [648] = {
    [aux_sym_implements_clause_repeat1] = STATE(794),
    [anon_sym_COMMA] = ACTIONS(1954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2712),
  },
  [649] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2714),
    [sym__automatic_semicolon] = ACTIONS(2714),
    [anon_sym_BQUOTE] = ACTIONS(2714),
    [anon_sym_symbol] = ACTIONS(2716),
    [anon_sym_PIPE] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2716),
    [anon_sym_GT_GT_GT] = ACTIONS(2714),
    [anon_sym_break] = ACTIONS(2716),
    [anon_sym_BANG_EQ] = ACTIONS(2716),
    [anon_sym_return] = ACTIONS(2716),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_PERCENT] = ACTIONS(2714),
    [anon_sym_interface] = ACTIONS(2716),
    [anon_sym_as] = ACTIONS(2716),
    [anon_sym_delete] = ACTIONS(2716),
    [anon_sym_if] = ACTIONS(2716),
    [anon_sym_instanceof] = ACTIONS(2716),
    [anon_sym_yield] = ACTIONS(2716),
    [sym_true] = ACTIONS(2716),
    [anon_sym_protected] = ACTIONS(2716),
    [anon_sym_DOT] = ACTIONS(2716),
    [anon_sym_set] = ACTIONS(2716),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2714),
    [anon_sym_import] = ACTIONS(2716),
    [anon_sym_await] = ACTIONS(2716),
    [anon_sym_DQUOTE] = ACTIONS(2714),
    [anon_sym_for] = ACTIONS(2716),
    [anon_sym_SEMI] = ACTIONS(2714),
    [anon_sym_number] = ACTIONS(2716),
    [anon_sym_typeof] = ACTIONS(2716),
    [anon_sym_LT_LT] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(2714),
    [anon_sym_AMP_AMP] = ACTIONS(2714),
    [anon_sym_switch] = ACTIONS(2716),
    [anon_sym_LT_EQ] = ACTIONS(2714),
    [sym_null] = ACTIONS(2716),
    [anon_sym_any] = ACTIONS(2716),
    [anon_sym_async] = ACTIONS(2716),
    [anon_sym_public] = ACTIONS(2716),
    [anon_sym_var] = ACTIONS(2716),
    [anon_sym_QMARK] = ACTIONS(2714),
    [anon_sym_while] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2716),
    [anon_sym_new] = ACTIONS(2716),
    [anon_sym_CARET] = ACTIONS(2714),
    [anon_sym_export] = ACTIONS(2716),
    [anon_sym_GT_GT] = ACTIONS(2716),
    [anon_sym_with] = ACTIONS(2716),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2714),
    [sym_identifier] = ACTIONS(2716),
    [anon_sym_debugger] = ACTIONS(2716),
    [anon_sym_AT] = ACTIONS(2714),
    [anon_sym_COMMA] = ACTIONS(2714),
    [anon_sym_DASH] = ACTIONS(2716),
    [anon_sym_void] = ACTIONS(2716),
    [anon_sym_const] = ACTIONS(2716),
    [anon_sym_GT_EQ] = ACTIONS(2714),
    [sym_super] = ACTIONS(2716),
    [anon_sym_private] = ACTIONS(2716),
    [anon_sym_get] = ACTIONS(2716),
    [anon_sym_default] = ACTIONS(2716),
    [anon_sym_enum] = ACTIONS(2716),
    [anon_sym_continue] = ACTIONS(2716),
    [anon_sym_DASH_DASH] = ACTIONS(2714),
    [anon_sym_this] = ACTIONS(2716),
    [anon_sym_throw] = ACTIONS(2716),
    [anon_sym_abstract] = ACTIONS(2716),
    [anon_sym_type] = ACTIONS(2716),
    [anon_sym_STAR_STAR] = ACTIONS(2714),
    [anon_sym_namespace] = ACTIONS(2716),
    [anon_sym_PLUS_PLUS] = ACTIONS(2714),
    [anon_sym_else] = ACTIONS(2716),
    [anon_sym_BANG] = ACTIONS(2716),
    [anon_sym_LBRACK] = ACTIONS(2714),
    [sym_false] = ACTIONS(2716),
    [anon_sym_case] = ACTIONS(2716),
    [anon_sym_module] = ACTIONS(2716),
    [anon_sym_class] = ACTIONS(2716),
    [anon_sym_declare] = ACTIONS(2716),
    [anon_sym_LPAREN] = ACTIONS(2714),
    [anon_sym_GT] = ACTIONS(2716),
    [anon_sym_boolean] = ACTIONS(2716),
    [anon_sym_AMP] = ACTIONS(2716),
    [anon_sym_PIPE_PIPE] = ACTIONS(2714),
    [anon_sym_try] = ACTIONS(2716),
    [anon_sym_EQ_EQ] = ACTIONS(2716),
    [anon_sym_LT] = ACTIONS(2716),
    [sym_number] = ACTIONS(2714),
    [ts_builtin_sym_end] = ACTIONS(2714),
    [anon_sym_function] = ACTIONS(2716),
    [sym_undefined] = ACTIONS(2716),
    [anon_sym_let] = ACTIONS(2716),
    [anon_sym_PLUS] = ACTIONS(2716),
    [anon_sym_do] = ACTIONS(2716),
    [anon_sym_TILDE] = ACTIONS(2714),
    [anon_sym_in] = ACTIONS(2716),
  },
  [650] = {
    [sym_class_body] = STATE(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(917),
  },
  [651] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1307),
    [anon_sym_AMP_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_EQ] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(1307),
    [anon_sym_PIPE_EQ] = ACTIONS(1307),
    [anon_sym_DASH_EQ] = ACTIONS(1307),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(2718),
    [anon_sym_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(2720),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(1307),
    [anon_sym_EQ_GT] = ACTIONS(2722),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1307),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2724),
  },
  [652] = {
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(2726),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [653] = {
    [sym_new_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(2350),
    [sym_update_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2350),
    [sym_yield_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_non_null_expression] = STATE(2350),
    [sym_internal_module] = STATE(2350),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2350),
    [sym_this] = STATE(2350),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2350),
    [sym_ternary_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2350),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(1323),
    [anon_sym_COLON] = ACTIONS(2726),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(1323),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_BANG] = ACTIONS(2730),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1323),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(1335),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_in] = ACTIONS(139),
  },
  [654] = {
    [sym_call_signature] = STATE(2380),
    [sym__initializer] = STATE(1215),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2732),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(2734),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(2734),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(2734),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(2726),
    [anon_sym_protected] = ACTIONS(2734),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_set] = ACTIONS(2734),
    [anon_sym_type] = ACTIONS(2734),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(2734),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_namespace] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2734),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(2734),
    [anon_sym_declare] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(2734),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(2734),
    [anon_sym_async] = ACTIONS(2734),
    [anon_sym_public] = ACTIONS(2734),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(2734),
    [anon_sym_function] = ACTIONS(1136),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [655] = {
    [sym_nested_identifier] = STATE(1592),
    [sym__module] = STATE(1483),
    [sym_string] = STATE(1594),
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(2726),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [656] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(2736),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [657] = {
    [anon_sym_RBRACK] = ACTIONS(2738),
    [sym_comment] = ACTIONS(3),
  },
  [658] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(1287),
  },
  [659] = {
    [sym_call_signature] = STATE(885),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(2740),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [660] = {
    [sym_string] = STATE(886),
    [sym__property_name] = STATE(886),
    [sym_computed_property_name] = STATE(886),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [661] = {
    [sym_string] = STATE(886),
    [sym__property_name] = STATE(886),
    [sym_computed_property_name] = STATE(886),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [662] = {
    [sym_string] = STATE(890),
    [sym__property_name] = STATE(890),
    [sym_computed_property_name] = STATE(890),
    [anon_sym_get] = ACTIONS(2744),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(2746),
    [anon_sym_STAR] = ACTIONS(2748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(2744),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(2750),
  },
  [663] = {
    [sym_string] = STATE(886),
    [sym__property_name] = STATE(886),
    [sym_computed_property_name] = STATE(886),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(2748),
    [anon_sym_EQ] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(2752),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(2752),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_BANG] = ACTIONS(986),
  },
  [664] = {
    [sym_call_signature] = STATE(885),
    [sym__initializer] = STATE(893),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym_type_annotation] = STATE(894),
    [sym__automatic_semicolon] = ACTIONS(2754),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(2754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(2758),
  },
  [665] = {
    [sym_string] = STATE(895),
    [sym__property_name] = STATE(895),
    [sym_computed_property_name] = STATE(895),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_EQ] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(2760),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_BANG] = ACTIONS(986),
  },
  [666] = {
    [sym_string] = STATE(896),
    [sym__property_name] = STATE(896),
    [sym_computed_property_name] = STATE(896),
    [anon_sym_get] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(2762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(919),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(919),
  },
  [667] = {
    [sym_string] = STATE(895),
    [sym__property_name] = STATE(895),
    [sym_computed_property_name] = STATE(895),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(2760),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [668] = {
    [sym_call_signature] = STATE(898),
    [sym__initializer] = STATE(893),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym_type_annotation] = STATE(894),
    [sym__automatic_semicolon] = ACTIONS(2754),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_QMARK] = ACTIONS(2764),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(2754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(2758),
  },
  [669] = {
    [anon_sym_LBRACK] = ACTIONS(2766),
    [sym_identifier] = ACTIONS(2768),
    [anon_sym_module] = ACTIONS(2768),
    [anon_sym_symbol] = ACTIONS(2768),
    [anon_sym_number] = ACTIONS(2768),
    [anon_sym_AT] = ACTIONS(2766),
    [anon_sym_declare] = ACTIONS(2768),
    [anon_sym_STAR] = ACTIONS(2766),
    [anon_sym_void] = ACTIONS(2768),
    [anon_sym_any] = ACTIONS(2768),
    [anon_sym_private] = ACTIONS(2768),
    [anon_sym_boolean] = ACTIONS(2768),
    [anon_sym_async] = ACTIONS(2768),
    [anon_sym_public] = ACTIONS(2768),
    [anon_sym_get] = ACTIONS(2768),
    [anon_sym_RBRACE] = ACTIONS(2766),
    [anon_sym_static] = ACTIONS(2768),
    [anon_sym_SQUOTE] = ACTIONS(2766),
    [sym_number] = ACTIONS(2766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2768),
    [anon_sym_string] = ACTIONS(2768),
    [anon_sym_abstract] = ACTIONS(2768),
    [anon_sym_set] = ACTIONS(2768),
    [anon_sym_type] = ACTIONS(2768),
    [anon_sym_import] = ACTIONS(2768),
    [anon_sym_export] = ACTIONS(2768),
    [anon_sym_namespace] = ACTIONS(2768),
    [sym_readonly] = ACTIONS(2768),
    [anon_sym_DQUOTE] = ACTIONS(2766),
  },
  [670] = {
    [sym_call_signature] = STATE(885),
    [sym__initializer] = STATE(893),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym_type_annotation] = STATE(894),
    [sym__automatic_semicolon] = ACTIONS(2754),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(2754),
    [sym_comment] = ACTIONS(3),
  },
  [671] = {
    [sym__initializer] = STATE(893),
    [sym_type_annotation] = STATE(894),
    [sym__automatic_semicolon] = ACTIONS(2754),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_COMMA] = ACTIONS(2754),
    [sym_comment] = ACTIONS(3),
  },
  [672] = {
    [sym_statement_block] = STATE(1392),
    [sym__automatic_semicolon] = ACTIONS(2770),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(2770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2772),
  },
  [673] = {
    [sym__automatic_semicolon] = ACTIONS(2754),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_COMMA] = ACTIONS(2754),
    [sym_comment] = ACTIONS(3),
  },
  [674] = {
    [sym__initializer] = STATE(893),
    [sym__automatic_semicolon] = ACTIONS(2754),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(2754),
    [anon_sym_COMMA] = ACTIONS(2754),
    [sym_comment] = ACTIONS(3),
  },
  [675] = {
    [sym_string] = STATE(890),
    [sym__property_name] = STATE(890),
    [sym_computed_property_name] = STATE(890),
    [anon_sym_get] = ACTIONS(2744),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(2750),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(2746),
    [anon_sym_STAR] = ACTIONS(2748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(2744),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [sym_readonly] = ACTIONS(2774),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [676] = {
    [sym_string] = STATE(890),
    [sym__property_name] = STATE(890),
    [sym_computed_property_name] = STATE(890),
    [anon_sym_get] = ACTIONS(2744),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(2746),
    [anon_sym_STAR] = ACTIONS(2748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_abstract] = ACTIONS(2776),
    [anon_sym_set] = ACTIONS(2744),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(2750),
  },
  [677] = {
    [sym_string] = STATE(903),
    [sym__property_name] = STATE(903),
    [sym_computed_property_name] = STATE(903),
    [anon_sym_get] = ACTIONS(2778),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(919),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(2780),
    [anon_sym_STAR] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [sym_readonly] = ACTIONS(2776),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [678] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2784),
    [sym__automatic_semicolon] = ACTIONS(2784),
    [anon_sym_BQUOTE] = ACTIONS(2784),
    [anon_sym_PIPE] = ACTIONS(2786),
    [anon_sym_COMMA] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_STAR] = ACTIONS(2786),
    [anon_sym_GT_GT_GT] = ACTIONS(2784),
    [anon_sym_BANG_EQ] = ACTIONS(2786),
    [anon_sym_GT_EQ] = ACTIONS(2784),
    [anon_sym_RBRACE] = ACTIONS(2784),
    [anon_sym_PERCENT] = ACTIONS(2784),
    [anon_sym_as] = ACTIONS(2784),
    [anon_sym_DASH_DASH] = ACTIONS(2784),
    [anon_sym_instanceof] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2784),
    [anon_sym_STAR_STAR] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2784),
    [anon_sym_else] = ACTIONS(2784),
    [anon_sym_BANG] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_SEMI] = ACTIONS(2784),
    [anon_sym_LT_LT] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2784),
    [anon_sym_LT_EQ] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2784),
    [anon_sym_GT] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2786),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_PIPE_PIPE] = ACTIONS(2784),
    [anon_sym_while] = ACTIONS(2784),
    [anon_sym_EQ_EQ] = ACTIONS(2786),
    [anon_sym_RPAREN] = ACTIONS(2784),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2784),
    [anon_sym_PLUS] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2784),
    [anon_sym_in] = ACTIONS(2786),
  },
  [679] = {
    [sym_public_field_definition] = STATE(394),
    [sym__property_name] = STATE(395),
    [sym_decorator] = STATE(679),
    [sym_method_signature] = STATE(394),
    [sym_accessibility_modifier] = STATE(396),
    [sym_abstract_method_signature] = STATE(394),
    [sym_computed_property_name] = STATE(395),
    [aux_sym_class_body_repeat1] = STATE(679),
    [sym_index_signature] = STATE(394),
    [sym_string] = STATE(395),
    [sym_method_definition] = STATE(398),
    [anon_sym_LBRACK] = ACTIONS(2788),
    [sym_identifier] = ACTIONS(2791),
    [anon_sym_module] = ACTIONS(2791),
    [anon_sym_symbol] = ACTIONS(2791),
    [anon_sym_number] = ACTIONS(2791),
    [anon_sym_AT] = ACTIONS(2794),
    [anon_sym_declare] = ACTIONS(2791),
    [anon_sym_STAR] = ACTIONS(2797),
    [anon_sym_void] = ACTIONS(2791),
    [anon_sym_any] = ACTIONS(2791),
    [anon_sym_private] = ACTIONS(2800),
    [anon_sym_boolean] = ACTIONS(2791),
    [anon_sym_async] = ACTIONS(2803),
    [anon_sym_public] = ACTIONS(2800),
    [anon_sym_get] = ACTIONS(2806),
    [anon_sym_RBRACE] = ACTIONS(2766),
    [anon_sym_static] = ACTIONS(2809),
    [anon_sym_SQUOTE] = ACTIONS(2812),
    [sym_number] = ACTIONS(2815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2800),
    [anon_sym_string] = ACTIONS(2791),
    [anon_sym_abstract] = ACTIONS(2818),
    [anon_sym_set] = ACTIONS(2806),
    [anon_sym_type] = ACTIONS(2791),
    [anon_sym_import] = ACTIONS(2791),
    [anon_sym_export] = ACTIONS(2791),
    [anon_sym_namespace] = ACTIONS(2791),
    [sym_readonly] = ACTIONS(2821),
    [anon_sym_DQUOTE] = ACTIONS(2824),
  },
  [680] = {
    [anon_sym_COLON] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
  },
  [681] = {
    [sym_nested_identifier] = STATE(616),
    [sym_identifier] = ACTIONS(2829),
    [sym_comment] = ACTIONS(3),
  },
  [682] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2831),
    [sym__automatic_semicolon] = ACTIONS(2831),
    [anon_sym_BQUOTE] = ACTIONS(2831),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_GT_GT_GT] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_BANG_EQ] = ACTIONS(2833),
    [anon_sym_GT_EQ] = ACTIONS(2831),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_as] = ACTIONS(2831),
    [anon_sym_DASH_DASH] = ACTIONS(2831),
    [anon_sym_instanceof] = ACTIONS(2831),
    [anon_sym_DOT] = ACTIONS(2831),
    [anon_sym_STAR_STAR] = ACTIONS(2831),
    [anon_sym_PLUS_PLUS] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_SEMI] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2831),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_of] = ACTIONS(2831),
    [anon_sym_LT_EQ] = ACTIONS(2831),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2831),
    [anon_sym_in] = ACTIONS(2833),
  },
  [683] = {
    [anon_sym_COMMA] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [sym_comment] = ACTIONS(3),
  },
  [684] = {
    [sym_call_signature] = STATE(905),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [685] = {
    [sym_statement_block] = STATE(906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [686] = {
    [sym_call_signature] = STATE(905),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(2837),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [687] = {
    [sym_string] = STATE(908),
    [sym__property_name] = STATE(908),
    [sym_computed_property_name] = STATE(908),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [688] = {
    [sym_string] = STATE(908),
    [sym__property_name] = STATE(908),
    [sym_computed_property_name] = STATE(908),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [689] = {
    [sym_string] = STATE(908),
    [sym__property_name] = STATE(908),
    [sym_computed_property_name] = STATE(908),
    [anon_sym_get] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(2839),
    [anon_sym_STAR] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(2841),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [690] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1900),
    [anon_sym_LBRACK] = ACTIONS(1900),
    [anon_sym_BANG] = ACTIONS(1902),
    [anon_sym_SEMI] = ACTIONS(1900),
    [anon_sym_BQUOTE] = ACTIONS(1900),
    [sym__automatic_semicolon] = ACTIONS(1900),
    [anon_sym_PIPE] = ACTIONS(1902),
    [anon_sym_COMMA] = ACTIONS(1900),
    [anon_sym_LT_LT] = ACTIONS(1900),
    [anon_sym_STAR] = ACTIONS(1902),
    [anon_sym_GT_GT_GT] = ACTIONS(1900),
    [anon_sym_EQ] = ACTIONS(1902),
    [anon_sym_AMP_AMP] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1902),
    [anon_sym_BANG_EQ] = ACTIONS(1902),
    [anon_sym_LT_EQ] = ACTIONS(1900),
    [anon_sym_LPAREN] = ACTIONS(2845),
    [anon_sym_GT_EQ] = ACTIONS(1900),
    [anon_sym_GT] = ACTIONS(1902),
    [anon_sym_AMP] = ACTIONS(1902),
    [anon_sym_PERCENT] = ACTIONS(1900),
    [anon_sym_QMARK] = ACTIONS(2845),
    [anon_sym_as] = ACTIONS(1900),
    [anon_sym_PIPE_PIPE] = ACTIONS(1900),
    [anon_sym_DASH_DASH] = ACTIONS(1900),
    [anon_sym_EQ_EQ] = ACTIONS(1902),
    [anon_sym_instanceof] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(2848),
    [anon_sym_SLASH] = ACTIONS(1902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_CARET] = ACTIONS(1900),
    [anon_sym_STAR_STAR] = ACTIONS(1900),
    [anon_sym_PLUS] = ACTIONS(1902),
    [anon_sym_GT_GT] = ACTIONS(1902),
    [anon_sym_PLUS_PLUS] = ACTIONS(1900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1900),
    [anon_sym_in] = ACTIONS(1902),
  },
  [691] = {
    [sym_string] = STATE(908),
    [sym__property_name] = STATE(908),
    [sym_computed_property_name] = STATE(908),
    [anon_sym_get] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(2839),
    [anon_sym_STAR] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(2841),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(2853),
  },
  [692] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2855),
    [sym__automatic_semicolon] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_COMMA] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2857),
    [anon_sym_STAR] = ACTIONS(2857),
    [anon_sym_GT_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_BANG_EQ] = ACTIONS(2857),
    [anon_sym_GT_EQ] = ACTIONS(2855),
    [anon_sym_RBRACE] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [anon_sym_DASH_DASH] = ACTIONS(2855),
    [anon_sym_instanceof] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_STAR_STAR] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2855),
    [anon_sym_BANG] = ACTIONS(2857),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_SEMI] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_of] = ACTIONS(2855),
    [anon_sym_LT_EQ] = ACTIONS(2855),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_SLASH] = ACTIONS(2857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2857),
    [anon_sym_GT_GT] = ACTIONS(2857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2855),
    [anon_sym_in] = ACTIONS(2857),
  },
  [693] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(2859),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_RBRACE] = ACTIONS(2859),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [694] = {
    [anon_sym_COMMA] = ACTIONS(2861),
    [anon_sym_RBRACE] = ACTIONS(2861),
    [sym_comment] = ACTIONS(3),
  },
  [695] = {
    [aux_sym_object_repeat1] = STATE(434),
    [anon_sym_RBRACE] = ACTIONS(2863),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [696] = {
    [sym_new_expression] = STATE(913),
    [sym_augmented_assignment_expression] = STATE(913),
    [sym_unary_expression] = STATE(913),
    [sym_update_expression] = STATE(913),
    [sym_regex] = STATE(913),
    [sym_meta_property] = STATE(913),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(913),
    [sym_yield_expression] = STATE(913),
    [sym_as_expression] = STATE(913),
    [sym_non_null_expression] = STATE(913),
    [sym_internal_module] = STATE(913),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(913),
    [sym_await_expression] = STATE(913),
    [sym_member_expression] = STATE(1201),
    [sym_sequence_expression] = STATE(914),
    [sym_string] = STATE(913),
    [sym_this] = STATE(913),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(913),
    [sym_generator_function] = STATE(913),
    [sym_call_expression] = STATE(913),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(913),
    [sym_ternary_expression] = STATE(913),
    [sym_binary_expression] = STATE(913),
    [sym_template_string] = STATE(913),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(913),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(913),
    [sym_class] = STATE(913),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(266),
    [sym_false] = ACTIONS(2865),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(2865),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(2867),
    [sym_true] = ACTIONS(2865),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(2865),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [697] = {
    [sym_identifier] = ACTIONS(2869),
    [anon_sym_BQUOTE] = ACTIONS(2871),
    [anon_sym_debugger] = ACTIONS(2869),
    [anon_sym_symbol] = ACTIONS(2869),
    [anon_sym_AT] = ACTIONS(2871),
    [anon_sym_DASH] = ACTIONS(2869),
    [anon_sym_void] = ACTIONS(2869),
    [anon_sym_break] = ACTIONS(2869),
    [anon_sym_const] = ACTIONS(2869),
    [sym_super] = ACTIONS(2869),
    [anon_sym_return] = ACTIONS(2869),
    [anon_sym_private] = ACTIONS(2869),
    [anon_sym_get] = ACTIONS(2869),
    [anon_sym_RBRACE] = ACTIONS(2871),
    [anon_sym_interface] = ACTIONS(2869),
    [anon_sym_default] = ACTIONS(2869),
    [anon_sym_enum] = ACTIONS(2869),
    [anon_sym_delete] = ACTIONS(2869),
    [anon_sym_continue] = ACTIONS(2869),
    [anon_sym_DASH_DASH] = ACTIONS(2871),
    [anon_sym_if] = ACTIONS(2869),
    [anon_sym_this] = ACTIONS(2869),
    [anon_sym_yield] = ACTIONS(2869),
    [sym_true] = ACTIONS(2869),
    [anon_sym_throw] = ACTIONS(2869),
    [anon_sym_protected] = ACTIONS(2869),
    [anon_sym_abstract] = ACTIONS(2869),
    [anon_sym_set] = ACTIONS(2869),
    [anon_sym_type] = ACTIONS(2869),
    [anon_sym_import] = ACTIONS(2869),
    [anon_sym_namespace] = ACTIONS(2869),
    [anon_sym_PLUS_PLUS] = ACTIONS(2871),
    [anon_sym_await] = ACTIONS(2869),
    [anon_sym_DQUOTE] = ACTIONS(2871),
    [anon_sym_else] = ACTIONS(2869),
    [anon_sym_BANG] = ACTIONS(2871),
    [anon_sym_for] = ACTIONS(2869),
    [anon_sym_LBRACK] = ACTIONS(2871),
    [sym_false] = ACTIONS(2869),
    [anon_sym_SEMI] = ACTIONS(2871),
    [anon_sym_case] = ACTIONS(2869),
    [anon_sym_module] = ACTIONS(2869),
    [anon_sym_number] = ACTIONS(2869),
    [anon_sym_class] = ACTIONS(2869),
    [anon_sym_declare] = ACTIONS(2869),
    [anon_sym_typeof] = ACTIONS(2869),
    [anon_sym_LBRACE] = ACTIONS(2871),
    [anon_sym_switch] = ACTIONS(2869),
    [anon_sym_LPAREN] = ACTIONS(2871),
    [sym_null] = ACTIONS(2869),
    [anon_sym_any] = ACTIONS(2869),
    [anon_sym_boolean] = ACTIONS(2869),
    [anon_sym_async] = ACTIONS(2869),
    [anon_sym_public] = ACTIONS(2869),
    [anon_sym_var] = ACTIONS(2869),
    [anon_sym_while] = ACTIONS(2869),
    [anon_sym_SQUOTE] = ACTIONS(2871),
    [anon_sym_try] = ACTIONS(2869),
    [anon_sym_LT] = ACTIONS(2871),
    [sym_number] = ACTIONS(2871),
    [anon_sym_SLASH] = ACTIONS(2869),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2869),
    [anon_sym_function] = ACTIONS(2869),
    [sym_undefined] = ACTIONS(2869),
    [anon_sym_new] = ACTIONS(2869),
    [ts_builtin_sym_end] = ACTIONS(2871),
    [anon_sym_let] = ACTIONS(2869),
    [anon_sym_PLUS] = ACTIONS(2869),
    [anon_sym_export] = ACTIONS(2869),
    [anon_sym_do] = ACTIONS(2869),
    [anon_sym_TILDE] = ACTIONS(2871),
    [anon_sym_with] = ACTIONS(2869),
  },
  [698] = {
    [anon_sym_COLON] = ACTIONS(2873),
    [sym_comment] = ACTIONS(3),
  },
  [699] = {
    [sym_switch_case] = STATE(917),
    [sym_switch_default] = STATE(917),
    [aux_sym_switch_body_repeat1] = STATE(917),
    [anon_sym_RBRACE] = ACTIONS(2875),
    [anon_sym_default] = ACTIONS(2104),
    [anon_sym_case] = ACTIONS(2106),
    [sym_comment] = ACTIONS(3),
  },
  [700] = {
    [anon_sym_COMMA] = ACTIONS(2877),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [sym_comment] = ACTIONS(3),
  },
  [701] = {
    [sym__initializer] = STATE(918),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2877),
    [sym_comment] = ACTIONS(3),
  },
  [702] = {
    [anon_sym_COMMA] = ACTIONS(2879),
    [anon_sym_RPAREN] = ACTIONS(2879),
    [sym_comment] = ACTIONS(3),
  },
  [703] = {
    [sym__initializer] = STATE(919),
    [sym_type_annotation] = STATE(920),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2881),
    [anon_sym_COMMA] = ACTIONS(2881),
    [sym_comment] = ACTIONS(3),
  },
  [704] = {
    [anon_sym_COMMA] = ACTIONS(2883),
    [anon_sym_RPAREN] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
  },
  [705] = {
    [sym__initializer] = STATE(921),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(2883),
    [anon_sym_COMMA] = ACTIONS(2883),
    [sym_comment] = ACTIONS(3),
  },
  [706] = {
    [sym__initializer] = STATE(918),
    [sym_type_annotation] = STATE(922),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2877),
    [anon_sym_COMMA] = ACTIONS(2877),
    [sym_comment] = ACTIONS(3),
  },
  [707] = {
    [sym__initializer] = STATE(923),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(2879),
    [anon_sym_COMMA] = ACTIONS(2879),
    [sym_comment] = ACTIONS(3),
  },
  [708] = {
    [sym__initializer] = STATE(924),
    [sym_type_annotation] = STATE(925),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2885),
    [anon_sym_COMMA] = ACTIONS(2885),
    [sym_comment] = ACTIONS(3),
  },
  [709] = {
    [anon_sym_COMMA] = ACTIONS(2887),
    [anon_sym_RPAREN] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
  },
  [710] = {
    [sym__initializer] = STATE(926),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(2887),
    [anon_sym_COMMA] = ACTIONS(2887),
    [sym_comment] = ACTIONS(3),
  },
  [711] = {
    [sym__initializer] = STATE(927),
    [sym_type_annotation] = STATE(928),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2889),
    [anon_sym_COMMA] = ACTIONS(2889),
    [sym_comment] = ACTIONS(3),
  },
  [712] = {
    [anon_sym_COMMA] = ACTIONS(2891),
    [anon_sym_RPAREN] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
  },
  [713] = {
    [sym__initializer] = STATE(929),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(2891),
    [anon_sym_COMMA] = ACTIONS(2891),
    [sym_comment] = ACTIONS(3),
  },
  [714] = {
    [anon_sym_COMMA] = ACTIONS(2893),
    [anon_sym_RPAREN] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
  },
  [715] = {
    [sym__initializer] = STATE(930),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(2893),
    [anon_sym_COMMA] = ACTIONS(2893),
    [sym_comment] = ACTIONS(3),
  },
  [716] = {
    [anon_sym_COMMA] = ACTIONS(2895),
    [anon_sym_RPAREN] = ACTIONS(2895),
    [sym_comment] = ACTIONS(3),
  },
  [717] = {
    [anon_sym_COMMA] = ACTIONS(2897),
    [anon_sym_RPAREN] = ACTIONS(2897),
    [sym_comment] = ACTIONS(3),
  },
  [718] = {
    [anon_sym_COLON] = ACTIONS(2899),
    [anon_sym_EQ_GT] = ACTIONS(2899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2899),
  },
  [719] = {
    [aux_sym_export_statement_repeat1] = STATE(2472),
    [sym_decorator] = STATE(2472),
    [sym_object] = STATE(465),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(931),
    [sym_array] = STATE(467),
    [sym_rest_parameter] = STATE(931),
    [sym_optional_parameter] = STATE(931),
    [sym_this] = STATE(468),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_symbol] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_void] = ACTIONS(1154),
    [anon_sym_string] = ACTIONS(1154),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [anon_sym_export] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
    [anon_sym_any] = ACTIONS(1154),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_boolean] = ACTIONS(1154),
    [anon_sym_async] = ACTIONS(1154),
  },
  [720] = {
    [anon_sym_COMMA] = ACTIONS(2901),
    [anon_sym_RPAREN] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
  },
  [721] = {
    [aux_sym_export_statement_repeat1] = STATE(719),
    [sym_decorator] = STATE(719),
    [sym_object] = STATE(465),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(720),
    [sym_array] = STATE(467),
    [sym_rest_parameter] = STATE(720),
    [sym_optional_parameter] = STATE(720),
    [sym_this] = STATE(468),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_symbol] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1154),
    [anon_sym_any] = ACTIONS(1154),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_boolean] = ACTIONS(1154),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_RPAREN] = ACTIONS(2903),
    [anon_sym_this] = ACTIONS(284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_string] = ACTIONS(1154),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [anon_sym_export] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
  },
  [722] = {
    [aux_sym_formal_parameters_repeat1] = STATE(722),
    [anon_sym_COMMA] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
  },
  [723] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2908),
    [sym__automatic_semicolon] = ACTIONS(2908),
    [anon_sym_BQUOTE] = ACTIONS(2908),
    [anon_sym_PIPE] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_STAR] = ACTIONS(2910),
    [anon_sym_GT_GT_GT] = ACTIONS(2908),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_GT_EQ] = ACTIONS(2908),
    [anon_sym_RBRACE] = ACTIONS(2908),
    [anon_sym_PERCENT] = ACTIONS(2908),
    [anon_sym_as] = ACTIONS(2908),
    [anon_sym_DASH_DASH] = ACTIONS(2908),
    [anon_sym_instanceof] = ACTIONS(2908),
    [anon_sym_DOT] = ACTIONS(2908),
    [anon_sym_STAR_STAR] = ACTIONS(2908),
    [anon_sym_PLUS_PLUS] = ACTIONS(2908),
    [anon_sym_BANG] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2908),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym_LT_LT] = ACTIONS(2908),
    [anon_sym_AMP_AMP] = ACTIONS(2908),
    [anon_sym_LT_EQ] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [anon_sym_GT] = ACTIONS(2910),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2908),
    [anon_sym_PIPE_PIPE] = ACTIONS(2908),
    [anon_sym_EQ_EQ] = ACTIONS(2910),
    [anon_sym_RPAREN] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(2910),
    [anon_sym_SLASH] = ACTIONS(2910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2908),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_GT_GT] = ACTIONS(2910),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2908),
    [anon_sym_in] = ACTIONS(2910),
  },
  [724] = {
    [sym__initializer] = STATE(935),
    [sym_type_annotation] = STATE(936),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2912),
    [anon_sym_QMARK] = ACTIONS(2914),
    [anon_sym_COMMA] = ACTIONS(2912),
    [sym_comment] = ACTIONS(3),
  },
  [725] = {
    [sym__initializer] = STATE(923),
    [sym_type_annotation] = STATE(938),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2879),
    [anon_sym_QMARK] = ACTIONS(2916),
    [anon_sym_COMMA] = ACTIONS(2879),
    [sym_comment] = ACTIONS(3),
  },
  [726] = {
    [sym__initializer] = STATE(940),
    [sym_type_annotation] = STATE(941),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2918),
    [anon_sym_QMARK] = ACTIONS(2920),
    [anon_sym_COMMA] = ACTIONS(2918),
    [sym_comment] = ACTIONS(3),
  },
  [727] = {
    [sym__initializer] = STATE(923),
    [sym_type_annotation] = STATE(938),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2879),
    [anon_sym_COMMA] = ACTIONS(2879),
    [sym_comment] = ACTIONS(3),
  },
  [728] = {
    [sym__initializer] = STATE(943),
    [sym_type_annotation] = STATE(944),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(2922),
    [anon_sym_QMARK] = ACTIONS(2924),
    [anon_sym_COMMA] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
  },
  [729] = {
    [anon_sym_COMMA] = ACTIONS(2138),
    [anon_sym_RPAREN] = ACTIONS(2138),
    [sym_comment] = ACTIONS(3),
  },
  [730] = {
    [anon_sym_COMMA] = ACTIONS(2179),
    [anon_sym_RPAREN] = ACTIONS(2179),
    [sym_comment] = ACTIONS(3),
  },
  [731] = {
    [aux_sym_formal_parameters_repeat1] = STATE(722),
    [anon_sym_RPAREN] = ACTIONS(2903),
    [anon_sym_COMMA] = ACTIONS(2926),
    [sym_comment] = ACTIONS(3),
  },
  [732] = {
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [sym_comment] = ACTIONS(3),
  },
  [733] = {
    [anon_sym_COMMA] = ACTIONS(2928),
    [anon_sym_RPAREN] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
  },
  [734] = {
    [sym__initializer] = STATE(946),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(2928),
    [anon_sym_COMMA] = ACTIONS(2928),
    [sym_comment] = ACTIONS(3),
  },
  [735] = {
    [anon_sym_COMMA] = ACTIONS(2930),
    [anon_sym_RPAREN] = ACTIONS(2930),
    [sym_comment] = ACTIONS(3),
  },
  [736] = {
    [anon_sym_COMMA] = ACTIONS(2932),
    [anon_sym_RPAREN] = ACTIONS(2932),
    [sym_comment] = ACTIONS(3),
  },
  [737] = {
    [sym__initializer] = STATE(947),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(2932),
    [anon_sym_COMMA] = ACTIONS(2932),
    [sym_comment] = ACTIONS(3),
  },
  [738] = {
    [anon_sym_COMMA] = ACTIONS(2934),
    [anon_sym_RPAREN] = ACTIONS(2934),
    [sym_comment] = ACTIONS(3),
  },
  [739] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2936),
    [sym__automatic_semicolon] = ACTIONS(2936),
    [anon_sym_BQUOTE] = ACTIONS(2936),
    [anon_sym_PIPE] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_GT_GT_GT] = ACTIONS(2936),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_GT_EQ] = ACTIONS(2936),
    [anon_sym_RBRACE] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(2936),
    [anon_sym_as] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_instanceof] = ACTIONS(2936),
    [anon_sym_DOT] = ACTIONS(2936),
    [anon_sym_STAR_STAR] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_BANG] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_LT_LT] = ACTIONS(2936),
    [anon_sym_AMP_AMP] = ACTIONS(2936),
    [anon_sym_LT_EQ] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2936),
    [anon_sym_GT] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2936),
    [anon_sym_PIPE_PIPE] = ACTIONS(2936),
    [anon_sym_EQ_EQ] = ACTIONS(2938),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2938),
    [anon_sym_SLASH] = ACTIONS(2938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2936),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_GT_GT] = ACTIONS(2938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2936),
    [anon_sym_in] = ACTIONS(2938),
  },
  [740] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [sym__automatic_semicolon] = ACTIONS(2936),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(590),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_in] = ACTIONS(125),
  },
  [741] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2940),
    [sym__automatic_semicolon] = ACTIONS(2940),
    [anon_sym_BQUOTE] = ACTIONS(2940),
    [anon_sym_PIPE] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(2942),
    [anon_sym_GT_GT_GT] = ACTIONS(2940),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2940),
    [anon_sym_RBRACE] = ACTIONS(2940),
    [anon_sym_PERCENT] = ACTIONS(2940),
    [anon_sym_as] = ACTIONS(2940),
    [anon_sym_DASH_DASH] = ACTIONS(2940),
    [anon_sym_instanceof] = ACTIONS(2940),
    [anon_sym_DOT] = ACTIONS(2940),
    [anon_sym_STAR_STAR] = ACTIONS(2940),
    [anon_sym_PLUS_PLUS] = ACTIONS(2940),
    [anon_sym_BANG] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2940),
    [anon_sym_SEMI] = ACTIONS(2940),
    [anon_sym_LT_LT] = ACTIONS(2940),
    [anon_sym_AMP_AMP] = ACTIONS(2940),
    [anon_sym_LT_EQ] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2940),
    [anon_sym_GT] = ACTIONS(2942),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2940),
    [anon_sym_PIPE_PIPE] = ACTIONS(2940),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_RPAREN] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2942),
    [anon_sym_SLASH] = ACTIONS(2942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2940),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_GT_GT] = ACTIONS(2942),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2940),
    [anon_sym_in] = ACTIONS(2942),
  },
  [742] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [sym__automatic_semicolon] = ACTIONS(2940),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(2940),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(2940),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(590),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_RPAREN] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_in] = ACTIONS(125),
  },
  [743] = {
    [sym_statement_block] = STATE(949),
    [sym__automatic_semicolon] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(805),
  },
  [744] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2946),
    [sym__automatic_semicolon] = ACTIONS(2946),
    [anon_sym_BQUOTE] = ACTIONS(2946),
    [anon_sym_symbol] = ACTIONS(2948),
    [anon_sym_PIPE] = ACTIONS(2948),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_GT_GT_GT] = ACTIONS(2946),
    [anon_sym_break] = ACTIONS(2948),
    [anon_sym_BANG_EQ] = ACTIONS(2948),
    [anon_sym_return] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_interface] = ACTIONS(2948),
    [anon_sym_as] = ACTIONS(2948),
    [anon_sym_delete] = ACTIONS(2948),
    [anon_sym_if] = ACTIONS(2948),
    [anon_sym_instanceof] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2948),
    [sym_true] = ACTIONS(2948),
    [anon_sym_protected] = ACTIONS(2948),
    [anon_sym_DOT] = ACTIONS(2948),
    [anon_sym_set] = ACTIONS(2948),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2946),
    [anon_sym_import] = ACTIONS(2948),
    [anon_sym_await] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_number] = ACTIONS(2948),
    [anon_sym_typeof] = ACTIONS(2948),
    [anon_sym_LT_LT] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2948),
    [anon_sym_LT_EQ] = ACTIONS(2946),
    [sym_null] = ACTIONS(2948),
    [anon_sym_any] = ACTIONS(2948),
    [anon_sym_async] = ACTIONS(2948),
    [anon_sym_public] = ACTIONS(2948),
    [anon_sym_var] = ACTIONS(2948),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2946),
    [anon_sym_SLASH] = ACTIONS(2948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2948),
    [anon_sym_CARET] = ACTIONS(2946),
    [anon_sym_export] = ACTIONS(2948),
    [anon_sym_GT_GT] = ACTIONS(2948),
    [anon_sym_with] = ACTIONS(2948),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2946),
    [sym_identifier] = ACTIONS(2948),
    [anon_sym_debugger] = ACTIONS(2948),
    [anon_sym_AT] = ACTIONS(2946),
    [anon_sym_COMMA] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2948),
    [anon_sym_void] = ACTIONS(2948),
    [anon_sym_const] = ACTIONS(2948),
    [anon_sym_GT_EQ] = ACTIONS(2946),
    [sym_super] = ACTIONS(2948),
    [anon_sym_private] = ACTIONS(2948),
    [anon_sym_get] = ACTIONS(2948),
    [anon_sym_default] = ACTIONS(2948),
    [anon_sym_enum] = ACTIONS(2948),
    [anon_sym_continue] = ACTIONS(2948),
    [anon_sym_DASH_DASH] = ACTIONS(2946),
    [anon_sym_this] = ACTIONS(2948),
    [anon_sym_throw] = ACTIONS(2948),
    [anon_sym_abstract] = ACTIONS(2948),
    [anon_sym_type] = ACTIONS(2948),
    [anon_sym_STAR_STAR] = ACTIONS(2946),
    [anon_sym_namespace] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [sym_false] = ACTIONS(2948),
    [anon_sym_case] = ACTIONS(2948),
    [anon_sym_module] = ACTIONS(2948),
    [anon_sym_class] = ACTIONS(2948),
    [anon_sym_declare] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2948),
    [anon_sym_boolean] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2948),
    [anon_sym_EQ_EQ] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2948),
    [sym_number] = ACTIONS(2946),
    [ts_builtin_sym_end] = ACTIONS(2946),
    [anon_sym_function] = ACTIONS(2948),
    [sym_undefined] = ACTIONS(2948),
    [anon_sym_let] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2948),
    [anon_sym_do] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2946),
    [anon_sym_in] = ACTIONS(2948),
  },
  [745] = {
    [sym_identifier] = ACTIONS(2950),
    [anon_sym_BQUOTE] = ACTIONS(2952),
    [anon_sym_debugger] = ACTIONS(2950),
    [anon_sym_symbol] = ACTIONS(2950),
    [anon_sym_AT] = ACTIONS(2952),
    [anon_sym_DASH] = ACTIONS(2950),
    [anon_sym_void] = ACTIONS(2950),
    [anon_sym_break] = ACTIONS(2950),
    [anon_sym_const] = ACTIONS(2950),
    [sym_super] = ACTIONS(2950),
    [anon_sym_return] = ACTIONS(2950),
    [anon_sym_private] = ACTIONS(2950),
    [anon_sym_get] = ACTIONS(2950),
    [anon_sym_RBRACE] = ACTIONS(2952),
    [anon_sym_interface] = ACTIONS(2950),
    [anon_sym_default] = ACTIONS(2950),
    [anon_sym_enum] = ACTIONS(2950),
    [anon_sym_delete] = ACTIONS(2950),
    [anon_sym_continue] = ACTIONS(2950),
    [anon_sym_DASH_DASH] = ACTIONS(2952),
    [anon_sym_if] = ACTIONS(2950),
    [anon_sym_this] = ACTIONS(2950),
    [anon_sym_yield] = ACTIONS(2950),
    [sym_true] = ACTIONS(2950),
    [anon_sym_throw] = ACTIONS(2950),
    [anon_sym_protected] = ACTIONS(2950),
    [anon_sym_abstract] = ACTIONS(2950),
    [anon_sym_set] = ACTIONS(2950),
    [anon_sym_type] = ACTIONS(2950),
    [anon_sym_import] = ACTIONS(2950),
    [anon_sym_namespace] = ACTIONS(2950),
    [anon_sym_PLUS_PLUS] = ACTIONS(2952),
    [anon_sym_await] = ACTIONS(2950),
    [anon_sym_DQUOTE] = ACTIONS(2952),
    [anon_sym_else] = ACTIONS(2950),
    [anon_sym_BANG] = ACTIONS(2952),
    [anon_sym_for] = ACTIONS(2950),
    [anon_sym_LBRACK] = ACTIONS(2952),
    [sym_false] = ACTIONS(2950),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym_case] = ACTIONS(2950),
    [anon_sym_module] = ACTIONS(2950),
    [anon_sym_number] = ACTIONS(2950),
    [anon_sym_class] = ACTIONS(2950),
    [anon_sym_declare] = ACTIONS(2950),
    [anon_sym_typeof] = ACTIONS(2950),
    [anon_sym_LBRACE] = ACTIONS(2952),
    [anon_sym_switch] = ACTIONS(2950),
    [anon_sym_LPAREN] = ACTIONS(2952),
    [sym_null] = ACTIONS(2950),
    [anon_sym_any] = ACTIONS(2950),
    [anon_sym_boolean] = ACTIONS(2950),
    [anon_sym_async] = ACTIONS(2950),
    [anon_sym_public] = ACTIONS(2950),
    [anon_sym_var] = ACTIONS(2950),
    [anon_sym_while] = ACTIONS(2950),
    [anon_sym_SQUOTE] = ACTIONS(2952),
    [anon_sym_try] = ACTIONS(2950),
    [anon_sym_LT] = ACTIONS(2952),
    [sym_number] = ACTIONS(2952),
    [anon_sym_SLASH] = ACTIONS(2950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2950),
    [anon_sym_function] = ACTIONS(2950),
    [sym_undefined] = ACTIONS(2950),
    [anon_sym_new] = ACTIONS(2950),
    [ts_builtin_sym_end] = ACTIONS(2952),
    [anon_sym_let] = ACTIONS(2950),
    [anon_sym_PLUS] = ACTIONS(2950),
    [anon_sym_export] = ACTIONS(2950),
    [anon_sym_do] = ACTIONS(2950),
    [anon_sym_TILDE] = ACTIONS(2952),
    [anon_sym_with] = ACTIONS(2950),
  },
  [746] = {
    [sym_identifier] = ACTIONS(2954),
    [sym_comment] = ACTIONS(3),
  },
  [747] = {
    [sym_identifier] = ACTIONS(2956),
    [anon_sym_BQUOTE] = ACTIONS(2958),
    [anon_sym_debugger] = ACTIONS(2956),
    [anon_sym_symbol] = ACTIONS(2956),
    [anon_sym_AT] = ACTIONS(2958),
    [anon_sym_DASH] = ACTIONS(2956),
    [anon_sym_void] = ACTIONS(2956),
    [anon_sym_break] = ACTIONS(2956),
    [anon_sym_const] = ACTIONS(2956),
    [sym_super] = ACTIONS(2956),
    [anon_sym_return] = ACTIONS(2956),
    [anon_sym_private] = ACTIONS(2956),
    [anon_sym_get] = ACTIONS(2956),
    [anon_sym_RBRACE] = ACTIONS(2958),
    [anon_sym_interface] = ACTIONS(2956),
    [anon_sym_default] = ACTIONS(2956),
    [anon_sym_enum] = ACTIONS(2956),
    [anon_sym_delete] = ACTIONS(2956),
    [anon_sym_continue] = ACTIONS(2956),
    [anon_sym_DASH_DASH] = ACTIONS(2958),
    [anon_sym_if] = ACTIONS(2956),
    [anon_sym_this] = ACTIONS(2956),
    [anon_sym_yield] = ACTIONS(2956),
    [sym_true] = ACTIONS(2956),
    [anon_sym_throw] = ACTIONS(2956),
    [anon_sym_protected] = ACTIONS(2956),
    [anon_sym_abstract] = ACTIONS(2956),
    [anon_sym_set] = ACTIONS(2956),
    [anon_sym_type] = ACTIONS(2956),
    [anon_sym_import] = ACTIONS(2956),
    [anon_sym_namespace] = ACTIONS(2956),
    [anon_sym_PLUS_PLUS] = ACTIONS(2958),
    [anon_sym_await] = ACTIONS(2956),
    [anon_sym_DQUOTE] = ACTIONS(2958),
    [anon_sym_else] = ACTIONS(2956),
    [anon_sym_BANG] = ACTIONS(2958),
    [anon_sym_for] = ACTIONS(2956),
    [anon_sym_LBRACK] = ACTIONS(2958),
    [sym_false] = ACTIONS(2956),
    [anon_sym_SEMI] = ACTIONS(2958),
    [anon_sym_case] = ACTIONS(2956),
    [anon_sym_module] = ACTIONS(2956),
    [anon_sym_number] = ACTIONS(2956),
    [anon_sym_class] = ACTIONS(2956),
    [anon_sym_declare] = ACTIONS(2956),
    [anon_sym_typeof] = ACTIONS(2956),
    [anon_sym_LBRACE] = ACTIONS(2958),
    [anon_sym_switch] = ACTIONS(2956),
    [anon_sym_LPAREN] = ACTIONS(2958),
    [sym_null] = ACTIONS(2956),
    [anon_sym_any] = ACTIONS(2956),
    [anon_sym_boolean] = ACTIONS(2956),
    [anon_sym_async] = ACTIONS(2956),
    [anon_sym_public] = ACTIONS(2956),
    [anon_sym_var] = ACTIONS(2956),
    [anon_sym_while] = ACTIONS(2956),
    [anon_sym_SQUOTE] = ACTIONS(2958),
    [anon_sym_try] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2958),
    [sym_number] = ACTIONS(2958),
    [anon_sym_SLASH] = ACTIONS(2956),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(2956),
    [anon_sym_string] = ACTIONS(2956),
    [anon_sym_function] = ACTIONS(2956),
    [sym_undefined] = ACTIONS(2956),
    [anon_sym_new] = ACTIONS(2956),
    [ts_builtin_sym_end] = ACTIONS(2958),
    [anon_sym_let] = ACTIONS(2956),
    [anon_sym_PLUS] = ACTIONS(2956),
    [anon_sym_export] = ACTIONS(2956),
    [anon_sym_do] = ACTIONS(2956),
    [anon_sym_TILDE] = ACTIONS(2958),
    [anon_sym_with] = ACTIONS(2956),
  },
  [748] = {
    [sym_identifier] = ACTIONS(2960),
    [anon_sym_BQUOTE] = ACTIONS(2962),
    [anon_sym_debugger] = ACTIONS(2960),
    [anon_sym_symbol] = ACTIONS(2960),
    [anon_sym_AT] = ACTIONS(2962),
    [anon_sym_DASH] = ACTIONS(2960),
    [anon_sym_void] = ACTIONS(2960),
    [anon_sym_break] = ACTIONS(2960),
    [anon_sym_const] = ACTIONS(2960),
    [sym_super] = ACTIONS(2960),
    [anon_sym_return] = ACTIONS(2960),
    [anon_sym_private] = ACTIONS(2960),
    [anon_sym_get] = ACTIONS(2960),
    [anon_sym_RBRACE] = ACTIONS(2962),
    [anon_sym_interface] = ACTIONS(2960),
    [anon_sym_default] = ACTIONS(2960),
    [anon_sym_enum] = ACTIONS(2960),
    [anon_sym_delete] = ACTIONS(2960),
    [anon_sym_continue] = ACTIONS(2960),
    [anon_sym_DASH_DASH] = ACTIONS(2962),
    [anon_sym_if] = ACTIONS(2960),
    [anon_sym_this] = ACTIONS(2960),
    [anon_sym_yield] = ACTIONS(2960),
    [sym_true] = ACTIONS(2960),
    [anon_sym_throw] = ACTIONS(2960),
    [anon_sym_protected] = ACTIONS(2960),
    [anon_sym_abstract] = ACTIONS(2960),
    [anon_sym_set] = ACTIONS(2960),
    [anon_sym_type] = ACTIONS(2960),
    [anon_sym_import] = ACTIONS(2960),
    [anon_sym_namespace] = ACTIONS(2960),
    [anon_sym_PLUS_PLUS] = ACTIONS(2962),
    [anon_sym_await] = ACTIONS(2960),
    [anon_sym_DQUOTE] = ACTIONS(2962),
    [anon_sym_else] = ACTIONS(2960),
    [anon_sym_BANG] = ACTIONS(2962),
    [anon_sym_for] = ACTIONS(2960),
    [anon_sym_LBRACK] = ACTIONS(2962),
    [sym_false] = ACTIONS(2960),
    [anon_sym_SEMI] = ACTIONS(2962),
    [anon_sym_case] = ACTIONS(2960),
    [anon_sym_module] = ACTIONS(2960),
    [anon_sym_number] = ACTIONS(2960),
    [anon_sym_class] = ACTIONS(2960),
    [anon_sym_declare] = ACTIONS(2960),
    [anon_sym_typeof] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(2962),
    [anon_sym_switch] = ACTIONS(2960),
    [anon_sym_LPAREN] = ACTIONS(2962),
    [sym_null] = ACTIONS(2960),
    [anon_sym_any] = ACTIONS(2960),
    [anon_sym_boolean] = ACTIONS(2960),
    [anon_sym_async] = ACTIONS(2960),
    [anon_sym_public] = ACTIONS(2960),
    [anon_sym_var] = ACTIONS(2960),
    [anon_sym_while] = ACTIONS(2960),
    [anon_sym_SQUOTE] = ACTIONS(2962),
    [anon_sym_try] = ACTIONS(2960),
    [anon_sym_LT] = ACTIONS(2962),
    [sym_number] = ACTIONS(2962),
    [anon_sym_SLASH] = ACTIONS(2960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2960),
    [anon_sym_function] = ACTIONS(2960),
    [sym_undefined] = ACTIONS(2960),
    [anon_sym_new] = ACTIONS(2960),
    [ts_builtin_sym_end] = ACTIONS(2962),
    [anon_sym_let] = ACTIONS(2960),
    [anon_sym_PLUS] = ACTIONS(2960),
    [anon_sym_export] = ACTIONS(2960),
    [anon_sym_do] = ACTIONS(2960),
    [anon_sym_TILDE] = ACTIONS(2962),
    [anon_sym_with] = ACTIONS(2960),
  },
  [749] = {
    [sym_identifier] = ACTIONS(2964),
    [anon_sym_BQUOTE] = ACTIONS(2966),
    [anon_sym_debugger] = ACTIONS(2964),
    [anon_sym_symbol] = ACTIONS(2964),
    [anon_sym_AT] = ACTIONS(2966),
    [anon_sym_DASH] = ACTIONS(2964),
    [anon_sym_void] = ACTIONS(2964),
    [anon_sym_break] = ACTIONS(2964),
    [anon_sym_const] = ACTIONS(2964),
    [sym_super] = ACTIONS(2964),
    [anon_sym_return] = ACTIONS(2964),
    [anon_sym_private] = ACTIONS(2964),
    [anon_sym_get] = ACTIONS(2964),
    [anon_sym_RBRACE] = ACTIONS(2966),
    [anon_sym_interface] = ACTIONS(2964),
    [anon_sym_default] = ACTIONS(2964),
    [anon_sym_enum] = ACTIONS(2964),
    [anon_sym_delete] = ACTIONS(2964),
    [anon_sym_continue] = ACTIONS(2964),
    [anon_sym_DASH_DASH] = ACTIONS(2966),
    [anon_sym_if] = ACTIONS(2964),
    [anon_sym_this] = ACTIONS(2964),
    [anon_sym_yield] = ACTIONS(2964),
    [sym_true] = ACTIONS(2964),
    [anon_sym_throw] = ACTIONS(2964),
    [anon_sym_protected] = ACTIONS(2964),
    [anon_sym_abstract] = ACTIONS(2964),
    [anon_sym_set] = ACTIONS(2964),
    [anon_sym_type] = ACTIONS(2964),
    [anon_sym_import] = ACTIONS(2964),
    [anon_sym_namespace] = ACTIONS(2964),
    [anon_sym_PLUS_PLUS] = ACTIONS(2966),
    [anon_sym_await] = ACTIONS(2964),
    [anon_sym_DQUOTE] = ACTIONS(2966),
    [anon_sym_else] = ACTIONS(2964),
    [anon_sym_BANG] = ACTIONS(2966),
    [anon_sym_for] = ACTIONS(2964),
    [anon_sym_LBRACK] = ACTIONS(2966),
    [sym_false] = ACTIONS(2964),
    [anon_sym_SEMI] = ACTIONS(2966),
    [anon_sym_case] = ACTIONS(2964),
    [anon_sym_module] = ACTIONS(2964),
    [anon_sym_number] = ACTIONS(2964),
    [anon_sym_class] = ACTIONS(2964),
    [anon_sym_declare] = ACTIONS(2964),
    [anon_sym_typeof] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(2966),
    [anon_sym_switch] = ACTIONS(2964),
    [anon_sym_LPAREN] = ACTIONS(2966),
    [sym_null] = ACTIONS(2964),
    [anon_sym_any] = ACTIONS(2964),
    [anon_sym_boolean] = ACTIONS(2964),
    [anon_sym_async] = ACTIONS(2964),
    [anon_sym_public] = ACTIONS(2964),
    [anon_sym_var] = ACTIONS(2964),
    [anon_sym_while] = ACTIONS(2964),
    [anon_sym_SQUOTE] = ACTIONS(2966),
    [anon_sym_try] = ACTIONS(2964),
    [anon_sym_LT] = ACTIONS(2966),
    [sym_number] = ACTIONS(2966),
    [anon_sym_SLASH] = ACTIONS(2964),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2964),
    [anon_sym_function] = ACTIONS(2964),
    [sym_undefined] = ACTIONS(2964),
    [anon_sym_new] = ACTIONS(2964),
    [ts_builtin_sym_end] = ACTIONS(2966),
    [anon_sym_let] = ACTIONS(2964),
    [anon_sym_PLUS] = ACTIONS(2964),
    [anon_sym_export] = ACTIONS(2964),
    [anon_sym_do] = ACTIONS(2964),
    [anon_sym_TILDE] = ACTIONS(2966),
    [anon_sym_with] = ACTIONS(2964),
  },
  [750] = {
    [anon_sym_GT] = ACTIONS(2968),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(2968),
    [sym_comment] = ACTIONS(3),
  },
  [751] = {
    [anon_sym_EQ] = ACTIONS(2970),
    [anon_sym_GT] = ACTIONS(2970),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(2970),
    [sym_comment] = ACTIONS(3),
  },
  [752] = {
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_RBRACK] = ACTIONS(2972),
    [sym_comment] = ACTIONS(3),
  },
  [753] = {
    [anon_sym_EQ_GT] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2974),
    [anon_sym_while] = ACTIONS(2974),
    [anon_sym_RPAREN] = ACTIONS(2974),
    [anon_sym_LT] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2974),
    [anon_sym_PIPE] = ACTIONS(2974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2976),
    [anon_sym_EQ] = ACTIONS(2976),
    [anon_sym_DOT] = ACTIONS(2652),
    [anon_sym_RBRACK] = ACTIONS(2974),
    [anon_sym_GT] = ACTIONS(2974),
    [anon_sym_implements] = ACTIONS(2974),
    [anon_sym_else] = ACTIONS(2974),
    [anon_sym_in] = ACTIONS(2974),
  },
  [754] = {
    [anon_sym_EQ_GT] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_while] = ACTIONS(2978),
    [anon_sym_RPAREN] = ACTIONS(2978),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(2980),
    [anon_sym_RBRACK] = ACTIONS(2978),
    [anon_sym_GT] = ACTIONS(2978),
    [anon_sym_else] = ACTIONS(2978),
  },
  [755] = {
    [anon_sym_EQ_GT] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_while] = ACTIONS(2982),
    [anon_sym_RPAREN] = ACTIONS(2982),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2982),
    [anon_sym_EQ] = ACTIONS(2984),
    [anon_sym_RBRACK] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2982),
    [anon_sym_else] = ACTIONS(2982),
  },
  [756] = {
    [anon_sym_COMMA] = ACTIONS(2986),
    [anon_sym_GT] = ACTIONS(2986),
    [sym_comment] = ACTIONS(3),
  },
  [757] = {
    [aux_sym_object_type_repeat1] = STATE(954),
    [sym__automatic_semicolon] = ACTIONS(2988),
    [anon_sym_RBRACE] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2990),
    [anon_sym_COMMA] = ACTIONS(2988),
    [sym_comment] = ACTIONS(3),
  },
  [758] = {
    [sym_call_signature] = STATE(956),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(2992),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [759] = {
    [sym_string] = STATE(957),
    [sym__property_name] = STATE(957),
    [sym_computed_property_name] = STATE(957),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(2994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [760] = {
    [sym_string] = STATE(961),
    [sym__property_name] = STATE(961),
    [sym_computed_property_name] = STATE(961),
    [anon_sym_get] = ACTIONS(2996),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(2998),
    [anon_sym_STAR] = ACTIONS(3000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(2996),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(3002),
  },
  [761] = {
    [sym_string] = STATE(957),
    [sym__property_name] = STATE(957),
    [sym_computed_property_name] = STATE(957),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(2994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [762] = {
    [sym_string] = STATE(957),
    [sym__property_name] = STATE(957),
    [sym_computed_property_name] = STATE(957),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(3000),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(3004),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(2994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(3004),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [763] = {
    [sym_call_signature] = STATE(956),
    [sym_type_annotation] = STATE(963),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(3006),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3006),
    [anon_sym_QMARK] = ACTIONS(3008),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3006),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3006),
    [sym_comment] = ACTIONS(3),
  },
  [764] = {
    [sym_type_annotation] = STATE(964),
    [sym__automatic_semicolon] = ACTIONS(3010),
    [anon_sym_RBRACE] = ACTIONS(3010),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3010),
    [anon_sym_COMMA] = ACTIONS(3010),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3010),
    [sym_comment] = ACTIONS(3),
  },
  [765] = {
    [sym_formal_parameters] = STATE(965),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [766] = {
    [sym_call_signature] = STATE(956),
    [sym_type_annotation] = STATE(963),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(3006),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3006),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3006),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3006),
    [sym_comment] = ACTIONS(3),
  },
  [767] = {
    [sym__automatic_semicolon] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2770),
    [sym_comment] = ACTIONS(3),
  },
  [768] = {
    [sym__automatic_semicolon] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(3006),
    [anon_sym_SEMI] = ACTIONS(3006),
    [anon_sym_COMMA] = ACTIONS(3006),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3006),
    [sym_comment] = ACTIONS(3),
  },
  [769] = {
    [sym_string] = STATE(961),
    [sym__property_name] = STATE(961),
    [sym_computed_property_name] = STATE(961),
    [anon_sym_get] = ACTIONS(2996),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(3002),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(2998),
    [anon_sym_STAR] = ACTIONS(3000),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(2996),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [sym_readonly] = ACTIONS(3012),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [770] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(967),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(967),
    [sym_call_signature] = STATE(967),
    [sym_construct_signature] = STATE(967),
    [sym_index_signature] = STATE(967),
    [sym_export_statement] = STATE(967),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(2990),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2990),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [771] = {
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [anon_sym_symbol] = ACTIONS(3016),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_break] = ACTIONS(3016),
    [anon_sym_return] = ACTIONS(3016),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_interface] = ACTIONS(3016),
    [anon_sym_delete] = ACTIONS(3016),
    [anon_sym_if] = ACTIONS(3016),
    [anon_sym_yield] = ACTIONS(3016),
    [sym_true] = ACTIONS(3016),
    [anon_sym_protected] = ACTIONS(3016),
    [anon_sym_set] = ACTIONS(3016),
    [anon_sym_import] = ACTIONS(3016),
    [anon_sym_await] = ACTIONS(3016),
    [anon_sym_DQUOTE] = ACTIONS(3014),
    [anon_sym_for] = ACTIONS(3016),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym_number] = ACTIONS(3016),
    [anon_sym_typeof] = ACTIONS(3016),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_switch] = ACTIONS(3016),
    [anon_sym_RBRACK] = ACTIONS(3014),
    [sym_null] = ACTIONS(3016),
    [anon_sym_any] = ACTIONS(3016),
    [anon_sym_async] = ACTIONS(3016),
    [anon_sym_public] = ACTIONS(3016),
    [anon_sym_var] = ACTIONS(3016),
    [anon_sym_while] = ACTIONS(3016),
    [anon_sym_SQUOTE] = ACTIONS(3014),
    [anon_sym_RPAREN] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3016),
    [anon_sym_new] = ACTIONS(3016),
    [anon_sym_export] = ACTIONS(3016),
    [anon_sym_with] = ACTIONS(3016),
    [sym_identifier] = ACTIONS(3016),
    [anon_sym_debugger] = ACTIONS(3016),
    [anon_sym_AT] = ACTIONS(3014),
    [anon_sym_COMMA] = ACTIONS(3014),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_EQ] = ACTIONS(3016),
    [anon_sym_void] = ACTIONS(3016),
    [anon_sym_const] = ACTIONS(3016),
    [sym_super] = ACTIONS(3016),
    [anon_sym_private] = ACTIONS(3016),
    [anon_sym_get] = ACTIONS(3016),
    [anon_sym_default] = ACTIONS(3016),
    [anon_sym_enum] = ACTIONS(3016),
    [anon_sym_continue] = ACTIONS(3016),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_this] = ACTIONS(3016),
    [anon_sym_throw] = ACTIONS(3016),
    [anon_sym_abstract] = ACTIONS(3016),
    [anon_sym_type] = ACTIONS(3016),
    [anon_sym_namespace] = ACTIONS(3016),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_else] = ACTIONS(3016),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [sym_false] = ACTIONS(3016),
    [anon_sym_case] = ACTIONS(3016),
    [anon_sym_module] = ACTIONS(3016),
    [anon_sym_class] = ACTIONS(3016),
    [anon_sym_declare] = ACTIONS(3016),
    [anon_sym_LPAREN] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_boolean] = ACTIONS(3016),
    [anon_sym_EQ_GT] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_try] = ACTIONS(3016),
    [anon_sym_LT] = ACTIONS(3014),
    [sym_number] = ACTIONS(3014),
    [ts_builtin_sym_end] = ACTIONS(3014),
    [anon_sym_function] = ACTIONS(3016),
    [sym_undefined] = ACTIONS(3016),
    [anon_sym_let] = ACTIONS(3016),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_do] = ACTIONS(3016),
    [anon_sym_TILDE] = ACTIONS(3014),
  },
  [772] = {
    [aux_sym_object_type_repeat1] = STATE(968),
    [sym__automatic_semicolon] = ACTIONS(2988),
    [anon_sym_RBRACE] = ACTIONS(2990),
    [anon_sym_SEMI] = ACTIONS(2988),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2990),
    [anon_sym_COMMA] = ACTIONS(2988),
    [sym_comment] = ACTIONS(3),
  },
  [773] = {
    [anon_sym_BQUOTE] = ACTIONS(3018),
    [anon_sym_symbol] = ACTIONS(3020),
    [anon_sym_PIPE] = ACTIONS(3018),
    [anon_sym_break] = ACTIONS(3020),
    [anon_sym_return] = ACTIONS(3020),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_interface] = ACTIONS(3020),
    [anon_sym_delete] = ACTIONS(3020),
    [anon_sym_if] = ACTIONS(3020),
    [anon_sym_yield] = ACTIONS(3020),
    [sym_true] = ACTIONS(3020),
    [anon_sym_protected] = ACTIONS(3020),
    [anon_sym_set] = ACTIONS(3020),
    [anon_sym_import] = ACTIONS(3020),
    [anon_sym_await] = ACTIONS(3020),
    [anon_sym_DQUOTE] = ACTIONS(3018),
    [anon_sym_for] = ACTIONS(3020),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym_number] = ACTIONS(3020),
    [anon_sym_typeof] = ACTIONS(3020),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_switch] = ACTIONS(3020),
    [anon_sym_RBRACK] = ACTIONS(3018),
    [sym_null] = ACTIONS(3020),
    [anon_sym_any] = ACTIONS(3020),
    [anon_sym_async] = ACTIONS(3020),
    [anon_sym_public] = ACTIONS(3020),
    [anon_sym_var] = ACTIONS(3020),
    [anon_sym_while] = ACTIONS(3020),
    [anon_sym_SQUOTE] = ACTIONS(3018),
    [anon_sym_RPAREN] = ACTIONS(3018),
    [anon_sym_SLASH] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3020),
    [anon_sym_new] = ACTIONS(3020),
    [anon_sym_export] = ACTIONS(3020),
    [anon_sym_with] = ACTIONS(3020),
    [sym_identifier] = ACTIONS(3020),
    [anon_sym_debugger] = ACTIONS(3020),
    [anon_sym_AT] = ACTIONS(3018),
    [anon_sym_COMMA] = ACTIONS(3018),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_EQ] = ACTIONS(3020),
    [anon_sym_void] = ACTIONS(3020),
    [anon_sym_const] = ACTIONS(3020),
    [sym_super] = ACTIONS(3020),
    [anon_sym_private] = ACTIONS(3020),
    [anon_sym_get] = ACTIONS(3020),
    [anon_sym_default] = ACTIONS(3020),
    [anon_sym_enum] = ACTIONS(3020),
    [anon_sym_continue] = ACTIONS(3020),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [anon_sym_this] = ACTIONS(3020),
    [anon_sym_throw] = ACTIONS(3020),
    [anon_sym_abstract] = ACTIONS(3020),
    [anon_sym_type] = ACTIONS(3020),
    [anon_sym_namespace] = ACTIONS(3020),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_else] = ACTIONS(3020),
    [anon_sym_BANG] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [sym_false] = ACTIONS(3020),
    [anon_sym_case] = ACTIONS(3020),
    [anon_sym_module] = ACTIONS(3020),
    [anon_sym_class] = ACTIONS(3020),
    [anon_sym_declare] = ACTIONS(3020),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [anon_sym_GT] = ACTIONS(3018),
    [anon_sym_boolean] = ACTIONS(3020),
    [anon_sym_EQ_GT] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_try] = ACTIONS(3020),
    [anon_sym_LT] = ACTIONS(3018),
    [sym_number] = ACTIONS(3018),
    [ts_builtin_sym_end] = ACTIONS(3018),
    [anon_sym_function] = ACTIONS(3020),
    [sym_undefined] = ACTIONS(3020),
    [anon_sym_let] = ACTIONS(3020),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_do] = ACTIONS(3020),
    [anon_sym_TILDE] = ACTIONS(3018),
  },
  [774] = {
    [aux_sym_implements_clause_repeat1] = STATE(794),
    [anon_sym_COMMA] = ACTIONS(1954),
    [anon_sym_RBRACK] = ACTIONS(3022),
    [sym_comment] = ACTIONS(3),
  },
  [775] = {
    [sym__type] = STATE(970),
    [sym_constructor_type] = STATE(970),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(970),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(970),
    [sym_intersection_type] = STATE(970),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [776] = {
    [anon_sym_EQ_GT] = ACTIONS(3024),
    [sym_comment] = ACTIONS(3),
  },
  [777] = {
    [sym_new_expression] = STATE(2037),
    [sym_augmented_assignment_expression] = STATE(2037),
    [sym_unary_expression] = STATE(2037),
    [sym_update_expression] = STATE(2037),
    [sym_regex] = STATE(2037),
    [sym_meta_property] = STATE(2037),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(2037),
    [sym_yield_expression] = STATE(2037),
    [sym_as_expression] = STATE(2037),
    [sym_non_null_expression] = STATE(2037),
    [sym_internal_module] = STATE(2037),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2037),
    [sym_await_expression] = STATE(2037),
    [sym_member_expression] = STATE(1201),
    [sym_mapped_type] = STATE(657),
    [sym_spread_element] = STATE(1755),
    [sym_string] = STATE(2037),
    [sym_this] = STATE(2037),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [aux_sym_array_repeat1] = STATE(1756),
    [sym_nested_type_identifier] = STATE(658),
    [sym_anonymous_class] = STATE(2037),
    [sym_generator_function] = STATE(2037),
    [sym_call_expression] = STATE(2037),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(2037),
    [sym_ternary_expression] = STATE(2037),
    [sym_binary_expression] = STATE(2037),
    [sym_template_string] = STATE(2037),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2037),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(2037),
    [sym_class] = STATE(2037),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(3026),
    [sym_false] = ACTIONS(3028),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3030),
    [anon_sym_symbol] = ACTIONS(3030),
    [anon_sym_number] = ACTIONS(3030),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(3030),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_void] = ACTIONS(3032),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_RBRACK] = ACTIONS(2343),
    [sym_null] = ACTIONS(3028),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3030),
    [anon_sym_private] = ACTIONS(3030),
    [anon_sym_boolean] = ACTIONS(3030),
    [anon_sym_async] = ACTIONS(3034),
    [anon_sym_public] = ACTIONS(3030),
    [anon_sym_get] = ACTIONS(3030),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(3036),
    [sym_true] = ACTIONS(3028),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(3030),
    [anon_sym_string] = ACTIONS(3030),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3028),
    [anon_sym_set] = ACTIONS(3030),
    [anon_sym_type] = ACTIONS(3030),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(3030),
    [anon_sym_export] = ACTIONS(3030),
    [anon_sym_namespace] = ACTIONS(3038),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [778] = {
    [sym_property_signature] = STATE(757),
    [sym_call_signature] = STATE(757),
    [sym_construct_signature] = STATE(757),
    [sym_index_signature] = STATE(757),
    [sym_method_definition] = STATE(414),
    [sym_accessibility_modifier] = STATE(787),
    [sym_spread_element] = STATE(414),
    [sym_string] = STATE(786),
    [sym_type_parameters] = STATE(1741),
    [sym_pair] = STATE(414),
    [aux_sym_export_statement_repeat1] = STATE(975),
    [sym_object] = STATE(310),
    [sym__property_name] = STATE(786),
    [sym_assignment_pattern] = STATE(414),
    [sym_method_signature] = STATE(757),
    [sym_export_statement] = STATE(757),
    [sym_decorator] = STATE(975),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(786),
    [sym_array] = STATE(312),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_module] = ACTIONS(3042),
    [anon_sym_symbol] = ACTIONS(3042),
    [anon_sym_number] = ACTIONS(3042),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(3042),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_void] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(3042),
    [anon_sym_private] = ACTIONS(3044),
    [anon_sym_boolean] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(2369),
    [anon_sym_async] = ACTIONS(3046),
    [anon_sym_get] = ACTIONS(3048),
    [anon_sym_RBRACE] = ACTIONS(998),
    [anon_sym_public] = ACTIONS(3044),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3044),
    [anon_sym_string] = ACTIONS(3042),
    [anon_sym_set] = ACTIONS(3048),
    [anon_sym_type] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(3042),
    [anon_sym_export] = ACTIONS(3050),
    [sym_readonly] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [779] = {
    [sym__property_name] = STATE(2292),
    [aux_sym_object_repeat1] = STATE(1834),
    [sym_string] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(3054),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(3054),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [780] = {
    [sym__property_name] = STATE(2292),
    [aux_sym_object_repeat1] = STATE(1834),
    [sym_string] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [781] = {
    [sym_string] = STATE(977),
    [sym__property_name] = STATE(977),
    [sym_computed_property_name] = STATE(977),
    [anon_sym_get] = ACTIONS(3060),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(3062),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(3060),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [sym_readonly] = ACTIONS(3066),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [782] = {
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_COLON] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(2245),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_AMP] = ACTIONS(2245),
    [anon_sym_RPAREN] = ACTIONS(1027),
    [anon_sym_PIPE] = ACTIONS(2245),
    [anon_sym_COMMA] = ACTIONS(1027),
    [sym_comment] = ACTIONS(3),
  },
  [783] = {
    [sym_type_alias_declaration] = STATE(1271),
    [sym__declaration] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_enum_declaration] = STATE(1271),
    [sym_function] = STATE(1271),
    [sym_variable_declaration] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(1763),
    [aux_sym_object_repeat1] = STATE(1834),
    [sym_ambient_declaration] = STATE(1271),
    [sym_import_alias] = STATE(1271),
    [sym_export_statement] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_export_clause] = STATE(1801),
    [sym_lexical_declaration] = STATE(1271),
    [sym_decorator] = STATE(1763),
    [sym_function_signature] = STATE(1271),
    [sym_abstract_class] = STATE(1271),
    [sym_module] = STATE(1271),
    [sym_interface_declaration] = STATE(1271),
    [sym_class] = STATE(1271),
    [sym__automatic_semicolon] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(2249),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2253),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_EQ] = ACTIONS(2257),
    [anon_sym_const] = ACTIONS(2259),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_async] = ACTIONS(2261),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_var] = ACTIONS(2263),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_interface] = ACTIONS(2265),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2269),
    [anon_sym_as] = ACTIONS(2271),
    [anon_sym_LT] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_abstract] = ACTIONS(2275),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(2277),
    [anon_sym_let] = ACTIONS(2279),
    [anon_sym_import] = ACTIONS(2281),
    [anon_sym_export] = ACTIONS(2283),
    [anon_sym_namespace] = ACTIONS(2285),
  },
  [784] = {
    [sym_string] = STATE(977),
    [sym__property_name] = STATE(977),
    [sym_computed_property_name] = STATE(977),
    [anon_sym_get] = ACTIONS(3060),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(3060),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(3062),
  },
  [785] = {
    [sym__property_name] = STATE(439),
    [sym_decorator] = STATE(2472),
    [aux_sym_export_statement_repeat1] = STATE(2472),
    [sym_accessibility_modifier] = STATE(180),
    [sym_computed_property_name] = STATE(439),
    [sym_method_definition] = STATE(1837),
    [sym_string] = STATE(439),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_get] = ACTIONS(1080),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [sym_number] = ACTIONS(1082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(3068),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [786] = {
    [sym_call_signature] = STATE(1883),
    [sym_type_annotation] = STATE(768),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(2289),
    [anon_sym_RBRACE] = ACTIONS(2289),
    [anon_sym_COLON] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(2289),
    [anon_sym_QMARK] = ACTIONS(3072),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2289),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(2289),
    [sym_comment] = ACTIONS(3),
  },
  [787] = {
    [sym_string] = STATE(977),
    [sym__property_name] = STATE(977),
    [sym_computed_property_name] = STATE(977),
    [anon_sym_get] = ACTIONS(3060),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(3062),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(3064),
    [anon_sym_STAR] = ACTIONS(3052),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(3060),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [sym_readonly] = ACTIONS(3066),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(3074),
    [anon_sym_private] = ACTIONS(919),
  },
  [788] = {
    [anon_sym_BQUOTE] = ACTIONS(3076),
    [anon_sym_symbol] = ACTIONS(3078),
    [anon_sym_PIPE] = ACTIONS(3076),
    [anon_sym_break] = ACTIONS(3078),
    [anon_sym_return] = ACTIONS(3078),
    [anon_sym_RBRACE] = ACTIONS(3076),
    [anon_sym_interface] = ACTIONS(3078),
    [anon_sym_delete] = ACTIONS(3078),
    [anon_sym_if] = ACTIONS(3078),
    [anon_sym_yield] = ACTIONS(3078),
    [sym_true] = ACTIONS(3078),
    [anon_sym_protected] = ACTIONS(3078),
    [anon_sym_set] = ACTIONS(3078),
    [anon_sym_import] = ACTIONS(3078),
    [anon_sym_await] = ACTIONS(3078),
    [anon_sym_DQUOTE] = ACTIONS(3076),
    [anon_sym_for] = ACTIONS(3078),
    [anon_sym_SEMI] = ACTIONS(3076),
    [anon_sym_number] = ACTIONS(3078),
    [anon_sym_typeof] = ACTIONS(3078),
    [anon_sym_LBRACE] = ACTIONS(3076),
    [anon_sym_switch] = ACTIONS(3078),
    [anon_sym_RBRACK] = ACTIONS(3076),
    [sym_null] = ACTIONS(3078),
    [anon_sym_any] = ACTIONS(3078),
    [anon_sym_async] = ACTIONS(3078),
    [anon_sym_public] = ACTIONS(3078),
    [anon_sym_var] = ACTIONS(3078),
    [anon_sym_while] = ACTIONS(3078),
    [anon_sym_SQUOTE] = ACTIONS(3076),
    [anon_sym_RPAREN] = ACTIONS(3076),
    [anon_sym_SLASH] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3078),
    [anon_sym_new] = ACTIONS(3078),
    [anon_sym_export] = ACTIONS(3078),
    [anon_sym_with] = ACTIONS(3078),
    [sym_identifier] = ACTIONS(3078),
    [anon_sym_debugger] = ACTIONS(3078),
    [anon_sym_AT] = ACTIONS(3076),
    [anon_sym_COMMA] = ACTIONS(3076),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_EQ] = ACTIONS(3078),
    [anon_sym_void] = ACTIONS(3078),
    [anon_sym_const] = ACTIONS(3078),
    [sym_super] = ACTIONS(3078),
    [anon_sym_private] = ACTIONS(3078),
    [anon_sym_get] = ACTIONS(3078),
    [anon_sym_default] = ACTIONS(3078),
    [anon_sym_enum] = ACTIONS(3078),
    [anon_sym_continue] = ACTIONS(3078),
    [anon_sym_DASH_DASH] = ACTIONS(3076),
    [anon_sym_this] = ACTIONS(3078),
    [anon_sym_throw] = ACTIONS(3078),
    [anon_sym_abstract] = ACTIONS(3078),
    [anon_sym_type] = ACTIONS(3078),
    [anon_sym_namespace] = ACTIONS(3078),
    [anon_sym_PLUS_PLUS] = ACTIONS(3076),
    [anon_sym_else] = ACTIONS(3078),
    [anon_sym_BANG] = ACTIONS(3076),
    [anon_sym_LBRACK] = ACTIONS(3076),
    [sym_false] = ACTIONS(3078),
    [anon_sym_case] = ACTIONS(3078),
    [anon_sym_module] = ACTIONS(3078),
    [anon_sym_class] = ACTIONS(3078),
    [anon_sym_declare] = ACTIONS(3078),
    [anon_sym_LPAREN] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_boolean] = ACTIONS(3078),
    [anon_sym_EQ_GT] = ACTIONS(3076),
    [anon_sym_AMP] = ACTIONS(3076),
    [anon_sym_try] = ACTIONS(3078),
    [anon_sym_LT] = ACTIONS(3076),
    [sym_number] = ACTIONS(3076),
    [ts_builtin_sym_end] = ACTIONS(3076),
    [anon_sym_function] = ACTIONS(3078),
    [sym_undefined] = ACTIONS(3078),
    [anon_sym_let] = ACTIONS(3078),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_do] = ACTIONS(3078),
    [anon_sym_TILDE] = ACTIONS(3076),
  },
  [789] = {
    [anon_sym_BQUOTE] = ACTIONS(3080),
    [anon_sym_symbol] = ACTIONS(3082),
    [anon_sym_PIPE] = ACTIONS(3080),
    [anon_sym_break] = ACTIONS(3082),
    [anon_sym_return] = ACTIONS(3082),
    [anon_sym_RBRACE] = ACTIONS(3080),
    [anon_sym_interface] = ACTIONS(3082),
    [anon_sym_delete] = ACTIONS(3082),
    [anon_sym_if] = ACTIONS(3082),
    [anon_sym_yield] = ACTIONS(3082),
    [sym_true] = ACTIONS(3082),
    [anon_sym_protected] = ACTIONS(3082),
    [anon_sym_set] = ACTIONS(3082),
    [anon_sym_import] = ACTIONS(3082),
    [anon_sym_await] = ACTIONS(3082),
    [anon_sym_DQUOTE] = ACTIONS(3080),
    [anon_sym_for] = ACTIONS(3082),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_number] = ACTIONS(3082),
    [anon_sym_typeof] = ACTIONS(3082),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_switch] = ACTIONS(3082),
    [anon_sym_RBRACK] = ACTIONS(3080),
    [sym_null] = ACTIONS(3082),
    [anon_sym_any] = ACTIONS(3082),
    [anon_sym_async] = ACTIONS(3082),
    [anon_sym_public] = ACTIONS(3082),
    [anon_sym_var] = ACTIONS(3082),
    [anon_sym_while] = ACTIONS(3082),
    [anon_sym_SQUOTE] = ACTIONS(3080),
    [anon_sym_RPAREN] = ACTIONS(3080),
    [anon_sym_SLASH] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3082),
    [anon_sym_new] = ACTIONS(3082),
    [anon_sym_export] = ACTIONS(3082),
    [anon_sym_with] = ACTIONS(3082),
    [sym_identifier] = ACTIONS(3082),
    [anon_sym_debugger] = ACTIONS(3082),
    [anon_sym_AT] = ACTIONS(3080),
    [anon_sym_COMMA] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_EQ] = ACTIONS(3082),
    [anon_sym_void] = ACTIONS(3082),
    [anon_sym_const] = ACTIONS(3082),
    [sym_super] = ACTIONS(3082),
    [anon_sym_private] = ACTIONS(3082),
    [anon_sym_get] = ACTIONS(3082),
    [anon_sym_default] = ACTIONS(3082),
    [anon_sym_enum] = ACTIONS(3082),
    [anon_sym_continue] = ACTIONS(3082),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_this] = ACTIONS(3082),
    [anon_sym_throw] = ACTIONS(3082),
    [anon_sym_abstract] = ACTIONS(3082),
    [anon_sym_type] = ACTIONS(3082),
    [anon_sym_namespace] = ACTIONS(3082),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_else] = ACTIONS(3082),
    [anon_sym_BANG] = ACTIONS(3080),
    [anon_sym_LBRACK] = ACTIONS(3080),
    [sym_false] = ACTIONS(3082),
    [anon_sym_case] = ACTIONS(3082),
    [anon_sym_module] = ACTIONS(3082),
    [anon_sym_class] = ACTIONS(3082),
    [anon_sym_declare] = ACTIONS(3082),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3080),
    [anon_sym_boolean] = ACTIONS(3082),
    [anon_sym_EQ_GT] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3080),
    [anon_sym_try] = ACTIONS(3082),
    [anon_sym_LT] = ACTIONS(3080),
    [sym_number] = ACTIONS(3080),
    [ts_builtin_sym_end] = ACTIONS(3080),
    [anon_sym_function] = ACTIONS(3082),
    [sym_undefined] = ACTIONS(3082),
    [anon_sym_let] = ACTIONS(3082),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_do] = ACTIONS(3082),
    [anon_sym_TILDE] = ACTIONS(3080),
  },
  [790] = {
    [anon_sym_BQUOTE] = ACTIONS(3084),
    [anon_sym_symbol] = ACTIONS(3086),
    [anon_sym_PIPE] = ACTIONS(3084),
    [anon_sym_break] = ACTIONS(3086),
    [anon_sym_return] = ACTIONS(3086),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_interface] = ACTIONS(3086),
    [anon_sym_delete] = ACTIONS(3086),
    [anon_sym_if] = ACTIONS(3086),
    [anon_sym_yield] = ACTIONS(3086),
    [sym_true] = ACTIONS(3086),
    [anon_sym_protected] = ACTIONS(3086),
    [anon_sym_set] = ACTIONS(3086),
    [anon_sym_import] = ACTIONS(3086),
    [anon_sym_await] = ACTIONS(3086),
    [anon_sym_DQUOTE] = ACTIONS(3084),
    [anon_sym_for] = ACTIONS(3086),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym_number] = ACTIONS(3086),
    [anon_sym_typeof] = ACTIONS(3086),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_switch] = ACTIONS(3086),
    [anon_sym_RBRACK] = ACTIONS(3084),
    [sym_null] = ACTIONS(3086),
    [anon_sym_any] = ACTIONS(3086),
    [anon_sym_async] = ACTIONS(3086),
    [anon_sym_public] = ACTIONS(3086),
    [anon_sym_var] = ACTIONS(3086),
    [anon_sym_while] = ACTIONS(3086),
    [anon_sym_SQUOTE] = ACTIONS(3084),
    [anon_sym_RPAREN] = ACTIONS(3084),
    [anon_sym_SLASH] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3086),
    [anon_sym_new] = ACTIONS(3086),
    [anon_sym_export] = ACTIONS(3086),
    [anon_sym_with] = ACTIONS(3086),
    [sym_identifier] = ACTIONS(3086),
    [anon_sym_debugger] = ACTIONS(3086),
    [anon_sym_AT] = ACTIONS(3084),
    [anon_sym_COMMA] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_EQ] = ACTIONS(3086),
    [anon_sym_void] = ACTIONS(3086),
    [anon_sym_const] = ACTIONS(3086),
    [sym_super] = ACTIONS(3086),
    [anon_sym_private] = ACTIONS(3086),
    [anon_sym_get] = ACTIONS(3086),
    [anon_sym_default] = ACTIONS(3086),
    [anon_sym_enum] = ACTIONS(3086),
    [anon_sym_continue] = ACTIONS(3086),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_this] = ACTIONS(3086),
    [anon_sym_throw] = ACTIONS(3086),
    [anon_sym_abstract] = ACTIONS(3086),
    [anon_sym_type] = ACTIONS(3086),
    [anon_sym_namespace] = ACTIONS(3086),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_else] = ACTIONS(3086),
    [anon_sym_BANG] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(3084),
    [sym_false] = ACTIONS(3086),
    [anon_sym_case] = ACTIONS(3086),
    [anon_sym_module] = ACTIONS(3086),
    [anon_sym_class] = ACTIONS(3086),
    [anon_sym_declare] = ACTIONS(3086),
    [anon_sym_LPAREN] = ACTIONS(3084),
    [anon_sym_GT] = ACTIONS(3084),
    [anon_sym_boolean] = ACTIONS(3086),
    [anon_sym_EQ_GT] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_try] = ACTIONS(3086),
    [anon_sym_LT] = ACTIONS(3084),
    [sym_number] = ACTIONS(3084),
    [ts_builtin_sym_end] = ACTIONS(3084),
    [anon_sym_function] = ACTIONS(3086),
    [sym_undefined] = ACTIONS(3086),
    [anon_sym_let] = ACTIONS(3086),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_do] = ACTIONS(3086),
    [anon_sym_TILDE] = ACTIONS(3084),
  },
  [791] = {
    [anon_sym_BQUOTE] = ACTIONS(3088),
    [anon_sym_symbol] = ACTIONS(3090),
    [anon_sym_PIPE] = ACTIONS(3088),
    [anon_sym_break] = ACTIONS(3090),
    [anon_sym_return] = ACTIONS(3090),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_interface] = ACTIONS(3090),
    [anon_sym_delete] = ACTIONS(3090),
    [anon_sym_if] = ACTIONS(3090),
    [anon_sym_yield] = ACTIONS(3090),
    [sym_true] = ACTIONS(3090),
    [anon_sym_protected] = ACTIONS(3090),
    [anon_sym_set] = ACTIONS(3090),
    [anon_sym_import] = ACTIONS(3090),
    [anon_sym_await] = ACTIONS(3090),
    [anon_sym_DQUOTE] = ACTIONS(3088),
    [anon_sym_for] = ACTIONS(3090),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym_number] = ACTIONS(3090),
    [anon_sym_typeof] = ACTIONS(3090),
    [anon_sym_LBRACE] = ACTIONS(3090),
    [anon_sym_switch] = ACTIONS(3090),
    [anon_sym_RBRACK] = ACTIONS(3088),
    [sym_null] = ACTIONS(3090),
    [anon_sym_any] = ACTIONS(3090),
    [anon_sym_async] = ACTIONS(3090),
    [anon_sym_public] = ACTIONS(3090),
    [anon_sym_var] = ACTIONS(3090),
    [anon_sym_while] = ACTIONS(3090),
    [anon_sym_SQUOTE] = ACTIONS(3088),
    [anon_sym_RPAREN] = ACTIONS(3088),
    [anon_sym_SLASH] = ACTIONS(3090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3090),
    [anon_sym_new] = ACTIONS(3090),
    [anon_sym_export] = ACTIONS(3090),
    [anon_sym_with] = ACTIONS(3090),
    [sym_identifier] = ACTIONS(3090),
    [anon_sym_debugger] = ACTIONS(3090),
    [anon_sym_AT] = ACTIONS(3088),
    [anon_sym_COMMA] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3090),
    [anon_sym_EQ] = ACTIONS(3090),
    [anon_sym_void] = ACTIONS(3090),
    [anon_sym_const] = ACTIONS(3090),
    [sym_super] = ACTIONS(3090),
    [anon_sym_private] = ACTIONS(3090),
    [anon_sym_get] = ACTIONS(3090),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3088),
    [anon_sym_default] = ACTIONS(3090),
    [anon_sym_enum] = ACTIONS(3090),
    [anon_sym_continue] = ACTIONS(3090),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_this] = ACTIONS(3090),
    [anon_sym_throw] = ACTIONS(3090),
    [anon_sym_abstract] = ACTIONS(3090),
    [anon_sym_type] = ACTIONS(3090),
    [anon_sym_namespace] = ACTIONS(3090),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_else] = ACTIONS(3090),
    [anon_sym_BANG] = ACTIONS(3088),
    [anon_sym_LBRACK] = ACTIONS(3088),
    [sym_false] = ACTIONS(3090),
    [anon_sym_case] = ACTIONS(3090),
    [anon_sym_module] = ACTIONS(3090),
    [anon_sym_class] = ACTIONS(3090),
    [anon_sym_declare] = ACTIONS(3090),
    [anon_sym_LPAREN] = ACTIONS(3088),
    [anon_sym_GT] = ACTIONS(3088),
    [anon_sym_boolean] = ACTIONS(3090),
    [anon_sym_EQ_GT] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3088),
    [anon_sym_try] = ACTIONS(3090),
    [anon_sym_LT] = ACTIONS(3088),
    [sym_number] = ACTIONS(3088),
    [ts_builtin_sym_end] = ACTIONS(3088),
    [anon_sym_function] = ACTIONS(3090),
    [sym_undefined] = ACTIONS(3090),
    [anon_sym_let] = ACTIONS(3090),
    [anon_sym_PLUS] = ACTIONS(3090),
    [anon_sym_implements] = ACTIONS(3090),
    [anon_sym_do] = ACTIONS(3090),
    [anon_sym_TILDE] = ACTIONS(3088),
  },
  [792] = {
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_RBRACK] = ACTIONS(3092),
    [anon_sym_GT] = ACTIONS(3092),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(3092),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3092),
  },
  [793] = {
    [sym__type] = STATE(792),
    [sym_constructor_type] = STATE(792),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(792),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(792),
    [sym_intersection_type] = STATE(792),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_GT] = ACTIONS(3094),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [794] = {
    [aux_sym_implements_clause_repeat1] = STATE(794),
    [anon_sym_GT] = ACTIONS(3092),
    [anon_sym_RBRACK] = ACTIONS(3092),
    [anon_sym_COMMA] = ACTIONS(3096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3092),
  },
  [795] = {
    [sym__type] = STATE(982),
    [sym_constructor_type] = STATE(982),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(982),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(982),
    [sym_intersection_type] = STATE(982),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [796] = {
    [anon_sym_EQ_GT] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_while] = ACTIONS(3099),
    [anon_sym_RPAREN] = ACTIONS(3099),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(3099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3101),
    [anon_sym_RBRACK] = ACTIONS(3099),
    [anon_sym_GT] = ACTIONS(3099),
    [anon_sym_else] = ACTIONS(3099),
  },
  [797] = {
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_RBRACK] = ACTIONS(3103),
    [sym_comment] = ACTIONS(3),
  },
  [798] = {
    [anon_sym_extends] = ACTIONS(3105),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3105),
    [anon_sym_EQ] = ACTIONS(3105),
    [anon_sym_LPAREN] = ACTIONS(3105),
    [anon_sym_implements] = ACTIONS(3105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3107),
  },
  [799] = {
    [anon_sym_COMMA] = ACTIONS(3109),
    [anon_sym_GT] = ACTIONS(3109),
    [sym_comment] = ACTIONS(3),
  },
  [800] = {
    [sym_type_parameter] = STATE(799),
    [anon_sym_GT] = ACTIONS(3111),
    [sym_identifier] = ACTIONS(1176),
    [sym_comment] = ACTIONS(3),
  },
  [801] = {
    [aux_sym_type_parameters_repeat1] = STATE(801),
    [anon_sym_COMMA] = ACTIONS(3113),
    [anon_sym_GT] = ACTIONS(3109),
    [sym_comment] = ACTIONS(3),
  },
  [802] = {
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [anon_sym_symbol] = ACTIONS(3118),
    [anon_sym_PIPE] = ACTIONS(3116),
    [anon_sym_break] = ACTIONS(3118),
    [anon_sym_return] = ACTIONS(3118),
    [anon_sym_RBRACE] = ACTIONS(3116),
    [anon_sym_interface] = ACTIONS(3118),
    [anon_sym_delete] = ACTIONS(3118),
    [anon_sym_if] = ACTIONS(3118),
    [anon_sym_yield] = ACTIONS(3118),
    [sym_true] = ACTIONS(3118),
    [anon_sym_protected] = ACTIONS(3118),
    [anon_sym_set] = ACTIONS(3118),
    [anon_sym_import] = ACTIONS(3118),
    [anon_sym_await] = ACTIONS(3118),
    [anon_sym_DQUOTE] = ACTIONS(3116),
    [anon_sym_for] = ACTIONS(3118),
    [anon_sym_SEMI] = ACTIONS(3116),
    [anon_sym_number] = ACTIONS(3118),
    [anon_sym_typeof] = ACTIONS(3118),
    [anon_sym_LBRACE] = ACTIONS(3116),
    [anon_sym_switch] = ACTIONS(3118),
    [anon_sym_RBRACK] = ACTIONS(3116),
    [sym_null] = ACTIONS(3118),
    [anon_sym_any] = ACTIONS(3118),
    [anon_sym_async] = ACTIONS(3118),
    [anon_sym_public] = ACTIONS(3118),
    [anon_sym_var] = ACTIONS(3118),
    [anon_sym_while] = ACTIONS(3118),
    [anon_sym_SQUOTE] = ACTIONS(3116),
    [anon_sym_RPAREN] = ACTIONS(3116),
    [anon_sym_SLASH] = ACTIONS(3118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3118),
    [anon_sym_new] = ACTIONS(3118),
    [anon_sym_export] = ACTIONS(3118),
    [anon_sym_with] = ACTIONS(3118),
    [sym_identifier] = ACTIONS(3118),
    [anon_sym_debugger] = ACTIONS(3118),
    [anon_sym_AT] = ACTIONS(3116),
    [anon_sym_COMMA] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(3118),
    [anon_sym_EQ] = ACTIONS(3118),
    [anon_sym_void] = ACTIONS(3118),
    [anon_sym_const] = ACTIONS(3118),
    [sym_super] = ACTIONS(3118),
    [anon_sym_private] = ACTIONS(3118),
    [anon_sym_get] = ACTIONS(3118),
    [anon_sym_default] = ACTIONS(3118),
    [anon_sym_enum] = ACTIONS(3118),
    [anon_sym_continue] = ACTIONS(3118),
    [anon_sym_DASH_DASH] = ACTIONS(3116),
    [anon_sym_this] = ACTIONS(3118),
    [anon_sym_throw] = ACTIONS(3118),
    [anon_sym_abstract] = ACTIONS(3118),
    [anon_sym_type] = ACTIONS(3118),
    [anon_sym_namespace] = ACTIONS(3118),
    [anon_sym_PLUS_PLUS] = ACTIONS(3116),
    [anon_sym_else] = ACTIONS(3118),
    [anon_sym_BANG] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(3116),
    [sym_false] = ACTIONS(3118),
    [anon_sym_case] = ACTIONS(3118),
    [anon_sym_module] = ACTIONS(3118),
    [anon_sym_class] = ACTIONS(3118),
    [anon_sym_declare] = ACTIONS(3118),
    [anon_sym_LPAREN] = ACTIONS(3116),
    [anon_sym_GT] = ACTIONS(3116),
    [anon_sym_boolean] = ACTIONS(3118),
    [anon_sym_EQ_GT] = ACTIONS(3116),
    [anon_sym_AMP] = ACTIONS(3116),
    [anon_sym_try] = ACTIONS(3118),
    [anon_sym_LT] = ACTIONS(3116),
    [sym_number] = ACTIONS(3116),
    [ts_builtin_sym_end] = ACTIONS(3116),
    [anon_sym_function] = ACTIONS(3118),
    [sym_undefined] = ACTIONS(3118),
    [anon_sym_let] = ACTIONS(3118),
    [anon_sym_PLUS] = ACTIONS(3118),
    [anon_sym_do] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3116),
  },
  [803] = {
    [anon_sym_EQ_GT] = ACTIONS(3120),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(3120),
    [anon_sym_while] = ACTIONS(3120),
    [anon_sym_RPAREN] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(3120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3120),
    [anon_sym_EQ] = ACTIONS(3122),
    [anon_sym_RBRACK] = ACTIONS(3120),
    [anon_sym_GT] = ACTIONS(3120),
    [anon_sym_else] = ACTIONS(3120),
  },
  [804] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3124),
    [sym__automatic_semicolon] = ACTIONS(3124),
    [anon_sym_BQUOTE] = ACTIONS(3124),
    [anon_sym_PIPE] = ACTIONS(3126),
    [anon_sym_COMMA] = ACTIONS(3124),
    [anon_sym_DASH] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_GT_GT_GT] = ACTIONS(3124),
    [anon_sym_BANG_EQ] = ACTIONS(3126),
    [anon_sym_GT_EQ] = ACTIONS(3124),
    [anon_sym_RBRACE] = ACTIONS(3124),
    [anon_sym_PERCENT] = ACTIONS(3124),
    [anon_sym_as] = ACTIONS(3124),
    [anon_sym_DASH_DASH] = ACTIONS(3124),
    [anon_sym_instanceof] = ACTIONS(3124),
    [anon_sym_DOT] = ACTIONS(3124),
    [anon_sym_STAR_STAR] = ACTIONS(3124),
    [anon_sym_PLUS_PLUS] = ACTIONS(3124),
    [anon_sym_BANG] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3124),
    [anon_sym_SEMI] = ACTIONS(3124),
    [anon_sym_LT_LT] = ACTIONS(3124),
    [anon_sym_AMP_AMP] = ACTIONS(3124),
    [anon_sym_LT_EQ] = ACTIONS(3124),
    [anon_sym_LPAREN] = ACTIONS(3124),
    [anon_sym_GT] = ACTIONS(3126),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym_QMARK] = ACTIONS(3124),
    [anon_sym_PIPE_PIPE] = ACTIONS(3124),
    [anon_sym_EQ_EQ] = ACTIONS(3126),
    [anon_sym_RPAREN] = ACTIONS(3124),
    [anon_sym_LT] = ACTIONS(3126),
    [anon_sym_SLASH] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3126),
    [anon_sym_GT_GT] = ACTIONS(3126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3124),
    [anon_sym_in] = ACTIONS(3126),
  },
  [805] = {
    [sym_identifier] = ACTIONS(3128),
    [anon_sym_BQUOTE] = ACTIONS(3130),
    [anon_sym_debugger] = ACTIONS(3128),
    [anon_sym_symbol] = ACTIONS(3128),
    [anon_sym_AT] = ACTIONS(3130),
    [anon_sym_DASH] = ACTIONS(3128),
    [anon_sym_void] = ACTIONS(3128),
    [anon_sym_break] = ACTIONS(3128),
    [anon_sym_const] = ACTIONS(3128),
    [sym_super] = ACTIONS(3128),
    [anon_sym_return] = ACTIONS(3128),
    [anon_sym_private] = ACTIONS(3128),
    [anon_sym_get] = ACTIONS(3128),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_interface] = ACTIONS(3128),
    [anon_sym_default] = ACTIONS(3128),
    [anon_sym_enum] = ACTIONS(3128),
    [anon_sym_delete] = ACTIONS(3128),
    [anon_sym_continue] = ACTIONS(3128),
    [anon_sym_DASH_DASH] = ACTIONS(3130),
    [anon_sym_if] = ACTIONS(3128),
    [anon_sym_this] = ACTIONS(3128),
    [anon_sym_yield] = ACTIONS(3128),
    [sym_true] = ACTIONS(3128),
    [anon_sym_throw] = ACTIONS(3128),
    [anon_sym_protected] = ACTIONS(3128),
    [anon_sym_abstract] = ACTIONS(3128),
    [anon_sym_set] = ACTIONS(3128),
    [anon_sym_type] = ACTIONS(3128),
    [anon_sym_import] = ACTIONS(3128),
    [anon_sym_namespace] = ACTIONS(3128),
    [anon_sym_PLUS_PLUS] = ACTIONS(3130),
    [anon_sym_await] = ACTIONS(3128),
    [anon_sym_DQUOTE] = ACTIONS(3130),
    [anon_sym_else] = ACTIONS(3128),
    [anon_sym_BANG] = ACTIONS(3130),
    [anon_sym_for] = ACTIONS(3128),
    [anon_sym_LBRACK] = ACTIONS(3130),
    [sym_false] = ACTIONS(3128),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym_case] = ACTIONS(3128),
    [anon_sym_module] = ACTIONS(3128),
    [anon_sym_number] = ACTIONS(3128),
    [anon_sym_class] = ACTIONS(3128),
    [anon_sym_declare] = ACTIONS(3128),
    [anon_sym_typeof] = ACTIONS(3128),
    [anon_sym_LBRACE] = ACTIONS(3130),
    [anon_sym_switch] = ACTIONS(3128),
    [anon_sym_LPAREN] = ACTIONS(3130),
    [sym_null] = ACTIONS(3128),
    [anon_sym_any] = ACTIONS(3128),
    [anon_sym_boolean] = ACTIONS(3128),
    [anon_sym_async] = ACTIONS(3128),
    [anon_sym_public] = ACTIONS(3128),
    [anon_sym_var] = ACTIONS(3128),
    [anon_sym_while] = ACTIONS(3128),
    [anon_sym_SQUOTE] = ACTIONS(3130),
    [anon_sym_try] = ACTIONS(3128),
    [anon_sym_LT] = ACTIONS(3130),
    [sym_number] = ACTIONS(3130),
    [anon_sym_SLASH] = ACTIONS(3128),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3128),
    [anon_sym_function] = ACTIONS(3128),
    [sym_undefined] = ACTIONS(3128),
    [anon_sym_new] = ACTIONS(3128),
    [ts_builtin_sym_end] = ACTIONS(3130),
    [anon_sym_let] = ACTIONS(3128),
    [anon_sym_PLUS] = ACTIONS(3128),
    [anon_sym_export] = ACTIONS(3128),
    [anon_sym_do] = ACTIONS(3128),
    [anon_sym_TILDE] = ACTIONS(3130),
    [anon_sym_with] = ACTIONS(3128),
  },
  [806] = {
    [sym_statement_block] = STATE(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(805),
  },
  [807] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3132),
    [sym__automatic_semicolon] = ACTIONS(3132),
    [anon_sym_BQUOTE] = ACTIONS(3132),
    [anon_sym_symbol] = ACTIONS(3134),
    [anon_sym_PIPE] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_GT_GT_GT] = ACTIONS(3132),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_BANG_EQ] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_RBRACE] = ACTIONS(3132),
    [anon_sym_PERCENT] = ACTIONS(3132),
    [anon_sym_interface] = ACTIONS(3134),
    [anon_sym_as] = ACTIONS(3134),
    [anon_sym_delete] = ACTIONS(3134),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_instanceof] = ACTIONS(3134),
    [anon_sym_yield] = ACTIONS(3134),
    [sym_true] = ACTIONS(3134),
    [anon_sym_protected] = ACTIONS(3134),
    [anon_sym_DOT] = ACTIONS(3134),
    [anon_sym_set] = ACTIONS(3134),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3132),
    [anon_sym_import] = ACTIONS(3134),
    [anon_sym_await] = ACTIONS(3134),
    [anon_sym_DQUOTE] = ACTIONS(3132),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3132),
    [anon_sym_number] = ACTIONS(3134),
    [anon_sym_typeof] = ACTIONS(3134),
    [anon_sym_LT_LT] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3132),
    [anon_sym_AMP_AMP] = ACTIONS(3132),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_LT_EQ] = ACTIONS(3132),
    [sym_null] = ACTIONS(3134),
    [anon_sym_any] = ACTIONS(3134),
    [anon_sym_async] = ACTIONS(3134),
    [anon_sym_public] = ACTIONS(3134),
    [anon_sym_var] = ACTIONS(3134),
    [anon_sym_QMARK] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_SQUOTE] = ACTIONS(3132),
    [anon_sym_SLASH] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [anon_sym_CARET] = ACTIONS(3132),
    [anon_sym_export] = ACTIONS(3134),
    [anon_sym_GT_GT] = ACTIONS(3134),
    [anon_sym_with] = ACTIONS(3134),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3132),
    [sym_identifier] = ACTIONS(3134),
    [anon_sym_debugger] = ACTIONS(3134),
    [anon_sym_AT] = ACTIONS(3132),
    [anon_sym_COMMA] = ACTIONS(3132),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_void] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [anon_sym_GT_EQ] = ACTIONS(3132),
    [sym_super] = ACTIONS(3134),
    [anon_sym_private] = ACTIONS(3134),
    [anon_sym_get] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [anon_sym_this] = ACTIONS(3134),
    [anon_sym_throw] = ACTIONS(3134),
    [anon_sym_abstract] = ACTIONS(3134),
    [anon_sym_type] = ACTIONS(3134),
    [anon_sym_STAR_STAR] = ACTIONS(3132),
    [anon_sym_namespace] = ACTIONS(3134),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_else] = ACTIONS(3134),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [sym_false] = ACTIONS(3134),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_module] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_declare] = ACTIONS(3134),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [anon_sym_GT] = ACTIONS(3134),
    [anon_sym_boolean] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3134),
    [anon_sym_PIPE_PIPE] = ACTIONS(3132),
    [anon_sym_try] = ACTIONS(3134),
    [anon_sym_EQ_EQ] = ACTIONS(3134),
    [anon_sym_LT] = ACTIONS(3134),
    [sym_number] = ACTIONS(3132),
    [ts_builtin_sym_end] = ACTIONS(3132),
    [anon_sym_function] = ACTIONS(3134),
    [sym_undefined] = ACTIONS(3134),
    [anon_sym_let] = ACTIONS(3134),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3132),
    [anon_sym_in] = ACTIONS(3134),
  },
  [808] = {
    [sym_new_expression] = STATE(370),
    [sym_augmented_assignment_expression] = STATE(370),
    [sym_unary_expression] = STATE(370),
    [sym_update_expression] = STATE(370),
    [sym_regex] = STATE(370),
    [sym_meta_property] = STATE(370),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(370),
    [sym_yield_expression] = STATE(370),
    [sym_as_expression] = STATE(370),
    [sym_non_null_expression] = STATE(370),
    [sym_internal_module] = STATE(370),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(370),
    [sym_await_expression] = STATE(370),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(370),
    [sym_this] = STATE(370),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(370),
    [sym_generator_function] = STATE(370),
    [sym_call_expression] = STATE(370),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(370),
    [sym_ternary_expression] = STATE(370),
    [sym_binary_expression] = STATE(370),
    [sym_template_string] = STATE(370),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(370),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(370),
    [sym_class] = STATE(370),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(3136),
    [sym_false] = ACTIONS(829),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(829),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(831),
    [sym_true] = ACTIONS(829),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(829),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [809] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1753),
    [sym__automatic_semicolon] = ACTIONS(1753),
    [anon_sym_BQUOTE] = ACTIONS(1753),
    [anon_sym_PIPE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1755),
    [anon_sym_GT_GT_GT] = ACTIONS(1753),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_GT_EQ] = ACTIONS(1753),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_PERCENT] = ACTIONS(1753),
    [anon_sym_as] = ACTIONS(1753),
    [anon_sym_DASH_DASH] = ACTIONS(1753),
    [anon_sym_instanceof] = ACTIONS(1753),
    [anon_sym_COLON] = ACTIONS(1138),
    [anon_sym_DOT] = ACTIONS(1753),
    [anon_sym_STAR_STAR] = ACTIONS(1753),
    [anon_sym_PLUS_PLUS] = ACTIONS(1753),
    [anon_sym_BANG] = ACTIONS(1755),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_LT_LT] = ACTIONS(1753),
    [anon_sym_AMP_AMP] = ACTIONS(1753),
    [anon_sym_LT_EQ] = ACTIONS(1753),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_GT] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(1138),
    [anon_sym_AMP] = ACTIONS(1755),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_PIPE_PIPE] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_RPAREN] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_GT_GT] = ACTIONS(1755),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1753),
    [anon_sym_in] = ACTIONS(1755),
  },
  [810] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [aux_sym_array_repeat1] = STATE(602),
    [sym_type_annotation] = STATE(2040),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(3140),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [811] = {
    [sym_identifier] = ACTIONS(3142),
    [anon_sym_BQUOTE] = ACTIONS(3144),
    [anon_sym_debugger] = ACTIONS(3142),
    [anon_sym_symbol] = ACTIONS(3142),
    [anon_sym_AT] = ACTIONS(3144),
    [anon_sym_DASH] = ACTIONS(3142),
    [anon_sym_void] = ACTIONS(3142),
    [anon_sym_break] = ACTIONS(3142),
    [anon_sym_const] = ACTIONS(3142),
    [sym_super] = ACTIONS(3142),
    [anon_sym_return] = ACTIONS(3142),
    [anon_sym_private] = ACTIONS(3142),
    [anon_sym_get] = ACTIONS(3142),
    [anon_sym_RBRACE] = ACTIONS(3144),
    [anon_sym_interface] = ACTIONS(3142),
    [anon_sym_default] = ACTIONS(3142),
    [anon_sym_enum] = ACTIONS(3142),
    [anon_sym_delete] = ACTIONS(3142),
    [anon_sym_continue] = ACTIONS(3142),
    [anon_sym_DASH_DASH] = ACTIONS(3144),
    [anon_sym_if] = ACTIONS(3142),
    [anon_sym_this] = ACTIONS(3142),
    [anon_sym_yield] = ACTIONS(3142),
    [sym_true] = ACTIONS(3142),
    [anon_sym_throw] = ACTIONS(3142),
    [anon_sym_protected] = ACTIONS(3142),
    [anon_sym_abstract] = ACTIONS(3142),
    [anon_sym_set] = ACTIONS(3142),
    [anon_sym_type] = ACTIONS(3142),
    [anon_sym_import] = ACTIONS(3142),
    [anon_sym_namespace] = ACTIONS(3142),
    [anon_sym_PLUS_PLUS] = ACTIONS(3144),
    [anon_sym_await] = ACTIONS(3142),
    [anon_sym_DQUOTE] = ACTIONS(3144),
    [anon_sym_else] = ACTIONS(3142),
    [anon_sym_BANG] = ACTIONS(3144),
    [anon_sym_for] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(3144),
    [sym_false] = ACTIONS(3142),
    [anon_sym_SEMI] = ACTIONS(3144),
    [anon_sym_case] = ACTIONS(3142),
    [anon_sym_module] = ACTIONS(3142),
    [anon_sym_number] = ACTIONS(3142),
    [anon_sym_class] = ACTIONS(3142),
    [anon_sym_declare] = ACTIONS(3142),
    [anon_sym_typeof] = ACTIONS(3142),
    [anon_sym_LBRACE] = ACTIONS(3144),
    [anon_sym_switch] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(3144),
    [sym_null] = ACTIONS(3142),
    [anon_sym_any] = ACTIONS(3142),
    [anon_sym_boolean] = ACTIONS(3142),
    [anon_sym_async] = ACTIONS(3142),
    [anon_sym_public] = ACTIONS(3142),
    [anon_sym_var] = ACTIONS(3142),
    [anon_sym_while] = ACTIONS(3142),
    [anon_sym_SQUOTE] = ACTIONS(3144),
    [anon_sym_try] = ACTIONS(3142),
    [anon_sym_LT] = ACTIONS(3144),
    [sym_number] = ACTIONS(3144),
    [anon_sym_SLASH] = ACTIONS(3142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3142),
    [anon_sym_function] = ACTIONS(3142),
    [sym_undefined] = ACTIONS(3142),
    [anon_sym_new] = ACTIONS(3142),
    [ts_builtin_sym_end] = ACTIONS(3144),
    [anon_sym_let] = ACTIONS(3142),
    [anon_sym_PLUS] = ACTIONS(3142),
    [anon_sym_export] = ACTIONS(3142),
    [anon_sym_do] = ACTIONS(3142),
    [anon_sym_TILDE] = ACTIONS(3144),
    [anon_sym_with] = ACTIONS(3142),
  },
  [812] = {
    [sym__automatic_semicolon] = ACTIONS(3146),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym_from] = ACTIONS(3146),
    [sym_comment] = ACTIONS(3),
  },
  [813] = {
    [sym__import_export_specifier] = STATE(991),
    [sym_identifier] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [anon_sym_typeof] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
  },
  [814] = {
    [sym__automatic_semicolon] = ACTIONS(3150),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym_from] = ACTIONS(3150),
    [sym_comment] = ACTIONS(3),
  },
  [815] = {
    [aux_sym_export_clause_repeat1] = STATE(993),
    [anon_sym_COMMA] = ACTIONS(3152),
    [anon_sym_RBRACE] = ACTIONS(3148),
    [sym_comment] = ACTIONS(3),
  },
  [816] = {
    [sym__automatic_semicolon] = ACTIONS(3154),
    [anon_sym_SEMI] = ACTIONS(3154),
    [sym_comment] = ACTIONS(3),
  },
  [817] = {
    [sym__automatic_semicolon] = ACTIONS(3156),
    [anon_sym_SEMI] = ACTIONS(3156),
    [sym_comment] = ACTIONS(3),
  },
  [818] = {
    [sym_new_expression] = STATE(996),
    [sym_augmented_assignment_expression] = STATE(996),
    [sym_unary_expression] = STATE(996),
    [sym_update_expression] = STATE(996),
    [sym_regex] = STATE(996),
    [sym_meta_property] = STATE(996),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(996),
    [sym_yield_expression] = STATE(996),
    [sym_as_expression] = STATE(996),
    [sym_non_null_expression] = STATE(996),
    [sym_internal_module] = STATE(996),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(996),
    [sym_await_expression] = STATE(996),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(996),
    [sym_this] = STATE(996),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(996),
    [sym_generator_function] = STATE(996),
    [sym_call_expression] = STATE(996),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(996),
    [sym_ternary_expression] = STATE(996),
    [sym_binary_expression] = STATE(996),
    [sym_template_string] = STATE(996),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(996),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(996),
    [sym_class] = STATE(996),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(3158),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(3158),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(3158),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3160),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(3158),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [819] = {
    [sym_new_expression] = STATE(289),
    [sym_constructor_type] = STATE(754),
    [sym_augmented_assignment_expression] = STATE(289),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(289),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(289),
    [sym_call_signature] = STATE(52),
    [sym_yield_expression] = STATE(289),
    [sym_as_expression] = STATE(289),
    [sym_internal_module] = STATE(289),
    [sym_arrow_function] = STATE(289),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(54),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(574),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(57),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(289),
    [sym_subscript_expression] = STATE(54),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(289),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(289),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(754),
    [sym__type] = STATE(754),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(289),
    [sym_meta_property] = STATE(289),
    [sym_function_type] = STATE(754),
    [sym__expression] = STATE(289),
    [sym_non_null_expression] = STATE(289),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(89),
    [sym_await_expression] = STATE(289),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(289),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_anonymous_class] = STATE(289),
    [sym_call_expression] = STATE(289),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(289),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(289),
    [sym_type_arguments] = STATE(64),
    [sym_union_type] = STATE(754),
    [sym_parenthesized_expression] = STATE(289),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(289),
    [sym_class] = STATE(289),
    [sym_identifier] = ACTIONS(1634),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(1636),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(1638),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(1640),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(1642),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(1644),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [sym_false] = ACTIONS(1644),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(1636),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(1648),
    [anon_sym_LBRACE] = ACTIONS(1650),
    [anon_sym_LPAREN] = ACTIONS(1652),
    [sym_null] = ACTIONS(618),
    [anon_sym_any] = ACTIONS(1636),
    [anon_sym_boolean] = ACTIONS(1636),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1654),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1636),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(618),
    [anon_sym_new] = ACTIONS(1656),
    [anon_sym_PLUS] = ACTIONS(1638),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [820] = {
    [sym__initializer] = STATE(72),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(113),
    [anon_sym_AMP_EQ] = ACTIONS(113),
    [anon_sym_PLUS_EQ] = ACTIONS(113),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(113),
    [anon_sym_PIPE_EQ] = ACTIONS(113),
    [anon_sym_DASH_EQ] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(3162),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_STAR_EQ] = ACTIONS(113),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(113),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [821] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(2313),
    [anon_sym_COMMA] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(2311),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2313),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [822] = {
    [sym__initializer] = STATE(444),
    [sym_type_annotation] = STATE(445),
    [sym_type_arguments] = STATE(497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_AMP_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_EQ] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(1090),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_is] = ACTIONS(1207),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(1088),
    [anon_sym_STAR_EQ] = ACTIONS(1088),
    [anon_sym_PIPE_EQ] = ACTIONS(1088),
    [anon_sym_DASH_EQ] = ACTIONS(1088),
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_LT_LT_EQ] = ACTIONS(1088),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(3164),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1100),
    [anon_sym_SLASH_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(3168),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3170),
  },
  [823] = {
    [sym__initializer] = STATE(452),
    [sym_type_annotation] = STATE(453),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(1114),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(3172),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [824] = {
    [sym_new_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym__initializer] = STATE(452),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_non_null_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1220),
    [sym_this] = STATE(1220),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1220),
    [sym_generator_function] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_type_annotation] = STATE(453),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1220),
    [sym_class] = STATE(1220),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(1124),
    [anon_sym_COLON] = ACTIONS(1117),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(1124),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(3172),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(1130),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [825] = {
    [sym_formal_parameters] = STATE(998),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [826] = {
    [sym_type_annotation] = STATE(269),
    [anon_sym_EQ_GT] = ACTIONS(3176),
    [anon_sym_COLON] = ACTIONS(568),
    [sym_comment] = ACTIONS(3),
  },
  [827] = {
    [sym_type_annotation] = STATE(562),
    [anon_sym_EQ_GT] = ACTIONS(3179),
    [anon_sym_COLON] = ACTIONS(568),
    [sym_comment] = ACTIONS(3),
  },
  [828] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(3154),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(3154),
    [anon_sym_in] = ACTIONS(2455),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2469),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(600),
  },
  [829] = {
    [sym_class_body] = STATE(999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(917),
  },
  [830] = {
    [sym_class_heritage] = STATE(1000),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(999),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(917),
  },
  [831] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3182),
    [sym__automatic_semicolon] = ACTIONS(3182),
    [anon_sym_BQUOTE] = ACTIONS(3182),
    [anon_sym_symbol] = ACTIONS(3184),
    [anon_sym_PIPE] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_GT_GT_GT] = ACTIONS(3182),
    [anon_sym_break] = ACTIONS(3184),
    [anon_sym_BANG_EQ] = ACTIONS(3184),
    [anon_sym_return] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3182),
    [anon_sym_PERCENT] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3184),
    [anon_sym_as] = ACTIONS(3184),
    [anon_sym_delete] = ACTIONS(3184),
    [anon_sym_if] = ACTIONS(3184),
    [anon_sym_instanceof] = ACTIONS(3184),
    [anon_sym_yield] = ACTIONS(3184),
    [sym_true] = ACTIONS(3184),
    [anon_sym_protected] = ACTIONS(3184),
    [anon_sym_DOT] = ACTIONS(3184),
    [anon_sym_set] = ACTIONS(3184),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3182),
    [anon_sym_import] = ACTIONS(3184),
    [anon_sym_await] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3184),
    [anon_sym_SEMI] = ACTIONS(3182),
    [anon_sym_number] = ACTIONS(3184),
    [anon_sym_typeof] = ACTIONS(3184),
    [anon_sym_LT_LT] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3182),
    [anon_sym_AMP_AMP] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3184),
    [anon_sym_LT_EQ] = ACTIONS(3182),
    [sym_null] = ACTIONS(3184),
    [anon_sym_any] = ACTIONS(3184),
    [anon_sym_async] = ACTIONS(3184),
    [anon_sym_public] = ACTIONS(3184),
    [anon_sym_var] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3182),
    [anon_sym_SLASH] = ACTIONS(3184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3184),
    [anon_sym_new] = ACTIONS(3184),
    [anon_sym_CARET] = ACTIONS(3182),
    [anon_sym_export] = ACTIONS(3184),
    [anon_sym_GT_GT] = ACTIONS(3184),
    [anon_sym_with] = ACTIONS(3184),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3182),
    [sym_identifier] = ACTIONS(3184),
    [anon_sym_debugger] = ACTIONS(3184),
    [anon_sym_AT] = ACTIONS(3182),
    [anon_sym_COMMA] = ACTIONS(3182),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_void] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [anon_sym_GT_EQ] = ACTIONS(3182),
    [sym_super] = ACTIONS(3184),
    [anon_sym_private] = ACTIONS(3184),
    [anon_sym_get] = ACTIONS(3184),
    [anon_sym_default] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [anon_sym_continue] = ACTIONS(3184),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [anon_sym_this] = ACTIONS(3184),
    [anon_sym_throw] = ACTIONS(3184),
    [anon_sym_abstract] = ACTIONS(3184),
    [anon_sym_type] = ACTIONS(3184),
    [anon_sym_STAR_STAR] = ACTIONS(3182),
    [anon_sym_namespace] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [sym_false] = ACTIONS(3184),
    [anon_sym_case] = ACTIONS(3184),
    [anon_sym_module] = ACTIONS(3184),
    [anon_sym_class] = ACTIONS(3184),
    [anon_sym_declare] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [anon_sym_GT] = ACTIONS(3184),
    [anon_sym_boolean] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_PIPE_PIPE] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3184),
    [anon_sym_EQ_EQ] = ACTIONS(3184),
    [anon_sym_LT] = ACTIONS(3184),
    [sym_number] = ACTIONS(3182),
    [ts_builtin_sym_end] = ACTIONS(3182),
    [anon_sym_function] = ACTIONS(3184),
    [sym_undefined] = ACTIONS(3184),
    [anon_sym_let] = ACTIONS(3184),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_do] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3184),
  },
  [832] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3186),
    [sym__automatic_semicolon] = ACTIONS(3186),
    [anon_sym_BQUOTE] = ACTIONS(3186),
    [anon_sym_PIPE] = ACTIONS(3188),
    [anon_sym_COMMA] = ACTIONS(3186),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(3188),
    [anon_sym_GT_GT_GT] = ACTIONS(3186),
    [anon_sym_BANG_EQ] = ACTIONS(3188),
    [anon_sym_GT_EQ] = ACTIONS(3186),
    [anon_sym_RBRACE] = ACTIONS(3186),
    [anon_sym_PERCENT] = ACTIONS(3186),
    [anon_sym_as] = ACTIONS(3186),
    [anon_sym_DASH_DASH] = ACTIONS(3186),
    [anon_sym_instanceof] = ACTIONS(3186),
    [anon_sym_DOT] = ACTIONS(3186),
    [anon_sym_STAR_STAR] = ACTIONS(3186),
    [anon_sym_PLUS_PLUS] = ACTIONS(3186),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_LBRACK] = ACTIONS(3186),
    [anon_sym_SEMI] = ACTIONS(3186),
    [anon_sym_LT_LT] = ACTIONS(3186),
    [anon_sym_AMP_AMP] = ACTIONS(3186),
    [anon_sym_LT_EQ] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(3186),
    [anon_sym_GT] = ACTIONS(3188),
    [anon_sym_AMP] = ACTIONS(3188),
    [anon_sym_QMARK] = ACTIONS(3186),
    [anon_sym_PIPE_PIPE] = ACTIONS(3186),
    [anon_sym_EQ_EQ] = ACTIONS(3188),
    [anon_sym_RPAREN] = ACTIONS(3186),
    [anon_sym_LT] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3186),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_GT_GT] = ACTIONS(3188),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3186),
    [anon_sym_in] = ACTIONS(3188),
  },
  [833] = {
    [sym_statement_block] = STATE(1448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3190),
  },
  [834] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3192),
    [sym__automatic_semicolon] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3192),
    [anon_sym_PIPE] = ACTIONS(3194),
    [anon_sym_COMMA] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_GT_GT_GT] = ACTIONS(3192),
    [anon_sym_BANG_EQ] = ACTIONS(3194),
    [anon_sym_GT_EQ] = ACTIONS(3192),
    [anon_sym_RBRACE] = ACTIONS(3192),
    [anon_sym_PERCENT] = ACTIONS(3192),
    [anon_sym_as] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3192),
    [anon_sym_instanceof] = ACTIONS(3192),
    [anon_sym_DOT] = ACTIONS(3192),
    [anon_sym_STAR_STAR] = ACTIONS(3192),
    [anon_sym_PLUS_PLUS] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_SEMI] = ACTIONS(3192),
    [anon_sym_LT_LT] = ACTIONS(3192),
    [anon_sym_AMP_AMP] = ACTIONS(3192),
    [anon_sym_LT_EQ] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3192),
    [anon_sym_GT] = ACTIONS(3194),
    [anon_sym_AMP] = ACTIONS(3194),
    [anon_sym_QMARK] = ACTIONS(3192),
    [anon_sym_PIPE_PIPE] = ACTIONS(3192),
    [anon_sym_EQ_EQ] = ACTIONS(3194),
    [anon_sym_RPAREN] = ACTIONS(3192),
    [anon_sym_LT] = ACTIONS(3194),
    [anon_sym_SLASH] = ACTIONS(3194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3194),
    [anon_sym_GT_GT] = ACTIONS(3194),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3192),
    [anon_sym_in] = ACTIONS(3194),
  },
  [835] = {
    [sym_identifier] = ACTIONS(3196),
    [anon_sym_BQUOTE] = ACTIONS(3198),
    [anon_sym_debugger] = ACTIONS(3196),
    [anon_sym_symbol] = ACTIONS(3196),
    [anon_sym_AT] = ACTIONS(3198),
    [anon_sym_DASH] = ACTIONS(3196),
    [anon_sym_void] = ACTIONS(3196),
    [anon_sym_break] = ACTIONS(3196),
    [anon_sym_const] = ACTIONS(3196),
    [sym_super] = ACTIONS(3196),
    [anon_sym_return] = ACTIONS(3196),
    [anon_sym_private] = ACTIONS(3196),
    [anon_sym_get] = ACTIONS(3196),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_interface] = ACTIONS(3196),
    [anon_sym_default] = ACTIONS(3196),
    [anon_sym_enum] = ACTIONS(3196),
    [anon_sym_delete] = ACTIONS(3196),
    [anon_sym_continue] = ACTIONS(3196),
    [anon_sym_DASH_DASH] = ACTIONS(3198),
    [anon_sym_if] = ACTIONS(3196),
    [anon_sym_this] = ACTIONS(3196),
    [anon_sym_yield] = ACTIONS(3196),
    [sym_true] = ACTIONS(3196),
    [anon_sym_throw] = ACTIONS(3196),
    [anon_sym_protected] = ACTIONS(3196),
    [anon_sym_abstract] = ACTIONS(3196),
    [anon_sym_set] = ACTIONS(3196),
    [anon_sym_type] = ACTIONS(3196),
    [anon_sym_import] = ACTIONS(3196),
    [anon_sym_namespace] = ACTIONS(3196),
    [anon_sym_PLUS_PLUS] = ACTIONS(3198),
    [anon_sym_await] = ACTIONS(3196),
    [anon_sym_DQUOTE] = ACTIONS(3198),
    [anon_sym_else] = ACTIONS(3196),
    [anon_sym_BANG] = ACTIONS(3198),
    [anon_sym_for] = ACTIONS(3196),
    [anon_sym_LBRACK] = ACTIONS(3198),
    [sym_false] = ACTIONS(3196),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_case] = ACTIONS(3196),
    [anon_sym_module] = ACTIONS(3196),
    [anon_sym_number] = ACTIONS(3196),
    [anon_sym_class] = ACTIONS(3196),
    [anon_sym_declare] = ACTIONS(3196),
    [anon_sym_typeof] = ACTIONS(3196),
    [anon_sym_LBRACE] = ACTIONS(3198),
    [anon_sym_switch] = ACTIONS(3196),
    [anon_sym_LPAREN] = ACTIONS(3198),
    [sym_null] = ACTIONS(3196),
    [anon_sym_any] = ACTIONS(3196),
    [anon_sym_boolean] = ACTIONS(3196),
    [anon_sym_async] = ACTIONS(3196),
    [anon_sym_public] = ACTIONS(3196),
    [anon_sym_var] = ACTIONS(3196),
    [anon_sym_while] = ACTIONS(3196),
    [anon_sym_SQUOTE] = ACTIONS(3198),
    [anon_sym_try] = ACTIONS(3196),
    [anon_sym_LT] = ACTIONS(3198),
    [sym_number] = ACTIONS(3198),
    [anon_sym_SLASH] = ACTIONS(3196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3196),
    [anon_sym_function] = ACTIONS(3196),
    [sym_undefined] = ACTIONS(3196),
    [anon_sym_new] = ACTIONS(3196),
    [ts_builtin_sym_end] = ACTIONS(3198),
    [anon_sym_let] = ACTIONS(3196),
    [anon_sym_PLUS] = ACTIONS(3196),
    [anon_sym_export] = ACTIONS(3196),
    [anon_sym_do] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3198),
    [anon_sym_with] = ACTIONS(3196),
  },
  [836] = {
    [anon_sym_COMMA] = ACTIONS(3200),
    [anon_sym_RBRACE] = ACTIONS(3200),
    [sym_comment] = ACTIONS(3),
  },
  [837] = {
    [sym__property_name] = STATE(606),
    [sym_computed_property_name] = STATE(606),
    [sym__enum_member] = STATE(1002),
    [sym_string] = STATE(606),
    [sym_enum_assignment] = STATE(1002),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(3202),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [sym_number] = ACTIONS(1773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [838] = {
    [sym_identifier] = ACTIONS(3204),
    [anon_sym_BQUOTE] = ACTIONS(3206),
    [anon_sym_debugger] = ACTIONS(3204),
    [anon_sym_symbol] = ACTIONS(3204),
    [anon_sym_AT] = ACTIONS(3206),
    [anon_sym_DASH] = ACTIONS(3204),
    [anon_sym_void] = ACTIONS(3204),
    [anon_sym_break] = ACTIONS(3204),
    [anon_sym_const] = ACTIONS(3204),
    [sym_super] = ACTIONS(3204),
    [anon_sym_return] = ACTIONS(3204),
    [anon_sym_private] = ACTIONS(3204),
    [anon_sym_get] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3206),
    [anon_sym_interface] = ACTIONS(3204),
    [anon_sym_default] = ACTIONS(3204),
    [anon_sym_enum] = ACTIONS(3204),
    [anon_sym_delete] = ACTIONS(3204),
    [anon_sym_continue] = ACTIONS(3204),
    [anon_sym_DASH_DASH] = ACTIONS(3206),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_this] = ACTIONS(3204),
    [anon_sym_yield] = ACTIONS(3204),
    [sym_true] = ACTIONS(3204),
    [anon_sym_throw] = ACTIONS(3204),
    [anon_sym_protected] = ACTIONS(3204),
    [anon_sym_abstract] = ACTIONS(3204),
    [anon_sym_set] = ACTIONS(3204),
    [anon_sym_type] = ACTIONS(3204),
    [anon_sym_import] = ACTIONS(3204),
    [anon_sym_namespace] = ACTIONS(3204),
    [anon_sym_PLUS_PLUS] = ACTIONS(3206),
    [anon_sym_await] = ACTIONS(3204),
    [anon_sym_DQUOTE] = ACTIONS(3206),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_BANG] = ACTIONS(3206),
    [anon_sym_for] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3206),
    [sym_false] = ACTIONS(3204),
    [anon_sym_SEMI] = ACTIONS(3206),
    [anon_sym_case] = ACTIONS(3204),
    [anon_sym_module] = ACTIONS(3204),
    [anon_sym_number] = ACTIONS(3204),
    [anon_sym_class] = ACTIONS(3204),
    [anon_sym_declare] = ACTIONS(3204),
    [anon_sym_typeof] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3206),
    [anon_sym_switch] = ACTIONS(3204),
    [anon_sym_LPAREN] = ACTIONS(3206),
    [sym_null] = ACTIONS(3204),
    [anon_sym_any] = ACTIONS(3204),
    [anon_sym_boolean] = ACTIONS(3204),
    [anon_sym_async] = ACTIONS(3204),
    [anon_sym_public] = ACTIONS(3204),
    [anon_sym_var] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_SQUOTE] = ACTIONS(3206),
    [anon_sym_try] = ACTIONS(3204),
    [anon_sym_LT] = ACTIONS(3206),
    [sym_number] = ACTIONS(3206),
    [anon_sym_SLASH] = ACTIONS(3204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3204),
    [anon_sym_function] = ACTIONS(3204),
    [sym_undefined] = ACTIONS(3204),
    [anon_sym_new] = ACTIONS(3204),
    [ts_builtin_sym_end] = ACTIONS(3206),
    [anon_sym_let] = ACTIONS(3204),
    [anon_sym_PLUS] = ACTIONS(3204),
    [anon_sym_export] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_TILDE] = ACTIONS(3206),
    [anon_sym_with] = ACTIONS(3204),
  },
  [839] = {
    [aux_sym_enum_body_repeat1] = STATE(1004),
    [anon_sym_RBRACE] = ACTIONS(3202),
    [anon_sym_COMMA] = ACTIONS(3208),
    [sym_comment] = ACTIONS(3),
  },
  [840] = {
    [sym_identifier] = ACTIONS(3210),
    [anon_sym_BQUOTE] = ACTIONS(3212),
    [anon_sym_debugger] = ACTIONS(3210),
    [anon_sym_symbol] = ACTIONS(3210),
    [anon_sym_AT] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3210),
    [anon_sym_void] = ACTIONS(3210),
    [anon_sym_break] = ACTIONS(3210),
    [anon_sym_const] = ACTIONS(3210),
    [sym_super] = ACTIONS(3210),
    [anon_sym_return] = ACTIONS(3210),
    [anon_sym_private] = ACTIONS(3210),
    [anon_sym_get] = ACTIONS(3210),
    [anon_sym_RBRACE] = ACTIONS(3212),
    [anon_sym_interface] = ACTIONS(3210),
    [anon_sym_default] = ACTIONS(3210),
    [anon_sym_enum] = ACTIONS(3210),
    [anon_sym_delete] = ACTIONS(3210),
    [anon_sym_continue] = ACTIONS(3210),
    [anon_sym_DASH_DASH] = ACTIONS(3212),
    [anon_sym_if] = ACTIONS(3210),
    [anon_sym_this] = ACTIONS(3210),
    [anon_sym_yield] = ACTIONS(3210),
    [sym_true] = ACTIONS(3210),
    [anon_sym_throw] = ACTIONS(3210),
    [anon_sym_protected] = ACTIONS(3210),
    [anon_sym_abstract] = ACTIONS(3210),
    [anon_sym_set] = ACTIONS(3210),
    [anon_sym_type] = ACTIONS(3210),
    [anon_sym_import] = ACTIONS(3210),
    [anon_sym_namespace] = ACTIONS(3210),
    [anon_sym_PLUS_PLUS] = ACTIONS(3212),
    [anon_sym_await] = ACTIONS(3210),
    [anon_sym_DQUOTE] = ACTIONS(3212),
    [anon_sym_else] = ACTIONS(3210),
    [anon_sym_BANG] = ACTIONS(3212),
    [anon_sym_for] = ACTIONS(3210),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [sym_false] = ACTIONS(3210),
    [anon_sym_SEMI] = ACTIONS(3212),
    [anon_sym_case] = ACTIONS(3210),
    [anon_sym_module] = ACTIONS(3210),
    [anon_sym_number] = ACTIONS(3210),
    [anon_sym_class] = ACTIONS(3210),
    [anon_sym_declare] = ACTIONS(3210),
    [anon_sym_typeof] = ACTIONS(3210),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [anon_sym_switch] = ACTIONS(3210),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [sym_null] = ACTIONS(3210),
    [anon_sym_any] = ACTIONS(3210),
    [anon_sym_boolean] = ACTIONS(3210),
    [anon_sym_async] = ACTIONS(3210),
    [anon_sym_public] = ACTIONS(3210),
    [anon_sym_var] = ACTIONS(3210),
    [anon_sym_while] = ACTIONS(3210),
    [anon_sym_SQUOTE] = ACTIONS(3212),
    [anon_sym_try] = ACTIONS(3210),
    [anon_sym_LT] = ACTIONS(3212),
    [sym_number] = ACTIONS(3212),
    [anon_sym_SLASH] = ACTIONS(3210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3210),
    [anon_sym_function] = ACTIONS(3210),
    [sym_undefined] = ACTIONS(3210),
    [anon_sym_new] = ACTIONS(3210),
    [ts_builtin_sym_end] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3210),
    [anon_sym_PLUS] = ACTIONS(3210),
    [anon_sym_export] = ACTIONS(3210),
    [anon_sym_do] = ACTIONS(3210),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_with] = ACTIONS(3210),
  },
  [841] = {
    [sym_identifier] = ACTIONS(3214),
    [anon_sym_BQUOTE] = ACTIONS(3216),
    [anon_sym_debugger] = ACTIONS(3214),
    [anon_sym_symbol] = ACTIONS(3214),
    [anon_sym_AT] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3214),
    [anon_sym_void] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_const] = ACTIONS(3214),
    [sym_super] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_private] = ACTIONS(3214),
    [anon_sym_get] = ACTIONS(3214),
    [anon_sym_RBRACE] = ACTIONS(3216),
    [anon_sym_interface] = ACTIONS(3214),
    [anon_sym_default] = ACTIONS(3214),
    [anon_sym_enum] = ACTIONS(3214),
    [anon_sym_delete] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3216),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_this] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3214),
    [sym_true] = ACTIONS(3214),
    [anon_sym_throw] = ACTIONS(3214),
    [anon_sym_protected] = ACTIONS(3214),
    [anon_sym_abstract] = ACTIONS(3214),
    [anon_sym_set] = ACTIONS(3214),
    [anon_sym_type] = ACTIONS(3214),
    [anon_sym_import] = ACTIONS(3214),
    [anon_sym_namespace] = ACTIONS(3214),
    [anon_sym_PLUS_PLUS] = ACTIONS(3216),
    [anon_sym_await] = ACTIONS(3214),
    [anon_sym_DQUOTE] = ACTIONS(3216),
    [anon_sym_else] = ACTIONS(3214),
    [anon_sym_BANG] = ACTIONS(3216),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3216),
    [sym_false] = ACTIONS(3214),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym_case] = ACTIONS(3214),
    [anon_sym_module] = ACTIONS(3214),
    [anon_sym_number] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_declare] = ACTIONS(3214),
    [anon_sym_typeof] = ACTIONS(3214),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [anon_sym_switch] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3216),
    [sym_null] = ACTIONS(3214),
    [anon_sym_any] = ACTIONS(3214),
    [anon_sym_boolean] = ACTIONS(3214),
    [anon_sym_async] = ACTIONS(3214),
    [anon_sym_public] = ACTIONS(3214),
    [anon_sym_var] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_SQUOTE] = ACTIONS(3216),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3216),
    [sym_number] = ACTIONS(3216),
    [anon_sym_SLASH] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3214),
    [anon_sym_function] = ACTIONS(3214),
    [sym_undefined] = ACTIONS(3214),
    [anon_sym_new] = ACTIONS(3214),
    [ts_builtin_sym_end] = ACTIONS(3216),
    [anon_sym_let] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3214),
    [anon_sym_export] = ACTIONS(3214),
    [anon_sym_do] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_with] = ACTIONS(3214),
  },
  [842] = {
    [sym_class_body] = STATE(1005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1793),
  },
  [843] = {
    [sym_identifier] = ACTIONS(3218),
    [anon_sym_BQUOTE] = ACTIONS(3220),
    [anon_sym_debugger] = ACTIONS(3218),
    [anon_sym_symbol] = ACTIONS(3218),
    [anon_sym_AT] = ACTIONS(3220),
    [anon_sym_DASH] = ACTIONS(3218),
    [anon_sym_void] = ACTIONS(3218),
    [anon_sym_break] = ACTIONS(3218),
    [anon_sym_const] = ACTIONS(3218),
    [sym_super] = ACTIONS(3218),
    [anon_sym_return] = ACTIONS(3218),
    [anon_sym_private] = ACTIONS(3218),
    [anon_sym_get] = ACTIONS(3218),
    [anon_sym_RBRACE] = ACTIONS(3220),
    [anon_sym_interface] = ACTIONS(3218),
    [anon_sym_default] = ACTIONS(3218),
    [anon_sym_enum] = ACTIONS(3218),
    [anon_sym_delete] = ACTIONS(3218),
    [anon_sym_continue] = ACTIONS(3218),
    [anon_sym_DASH_DASH] = ACTIONS(3220),
    [anon_sym_if] = ACTIONS(3218),
    [anon_sym_this] = ACTIONS(3218),
    [anon_sym_yield] = ACTIONS(3218),
    [sym_true] = ACTIONS(3218),
    [anon_sym_throw] = ACTIONS(3218),
    [anon_sym_protected] = ACTIONS(3218),
    [anon_sym_abstract] = ACTIONS(3218),
    [anon_sym_set] = ACTIONS(3218),
    [anon_sym_type] = ACTIONS(3218),
    [anon_sym_import] = ACTIONS(3218),
    [anon_sym_namespace] = ACTIONS(3218),
    [anon_sym_PLUS_PLUS] = ACTIONS(3220),
    [anon_sym_await] = ACTIONS(3218),
    [anon_sym_DQUOTE] = ACTIONS(3220),
    [anon_sym_else] = ACTIONS(3218),
    [anon_sym_BANG] = ACTIONS(3220),
    [anon_sym_for] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3220),
    [sym_false] = ACTIONS(3218),
    [anon_sym_SEMI] = ACTIONS(3220),
    [anon_sym_case] = ACTIONS(3218),
    [anon_sym_module] = ACTIONS(3218),
    [anon_sym_number] = ACTIONS(3218),
    [anon_sym_class] = ACTIONS(3218),
    [anon_sym_declare] = ACTIONS(3218),
    [anon_sym_typeof] = ACTIONS(3218),
    [anon_sym_LBRACE] = ACTIONS(3220),
    [anon_sym_switch] = ACTIONS(3218),
    [anon_sym_LPAREN] = ACTIONS(3220),
    [sym_null] = ACTIONS(3218),
    [anon_sym_any] = ACTIONS(3218),
    [anon_sym_boolean] = ACTIONS(3218),
    [anon_sym_async] = ACTIONS(3218),
    [anon_sym_public] = ACTIONS(3218),
    [anon_sym_var] = ACTIONS(3218),
    [anon_sym_while] = ACTIONS(3218),
    [anon_sym_SQUOTE] = ACTIONS(3220),
    [anon_sym_try] = ACTIONS(3218),
    [anon_sym_LT] = ACTIONS(3220),
    [sym_number] = ACTIONS(3220),
    [anon_sym_SLASH] = ACTIONS(3218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3218),
    [anon_sym_function] = ACTIONS(3218),
    [sym_undefined] = ACTIONS(3218),
    [anon_sym_new] = ACTIONS(3218),
    [ts_builtin_sym_end] = ACTIONS(3220),
    [anon_sym_let] = ACTIONS(3218),
    [anon_sym_PLUS] = ACTIONS(3218),
    [anon_sym_export] = ACTIONS(3218),
    [anon_sym_do] = ACTIONS(3218),
    [anon_sym_TILDE] = ACTIONS(3220),
    [anon_sym_with] = ACTIONS(3218),
  },
  [844] = {
    [sym__automatic_semicolon] = ACTIONS(3222),
    [anon_sym_AMP] = ACTIONS(2614),
    [anon_sym_SEMI] = ACTIONS(3222),
    [anon_sym_PIPE] = ACTIONS(2616),
    [sym_comment] = ACTIONS(3),
  },
  [845] = {
    [sym_string] = STATE(1007),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(308),
  },
  [846] = {
    [sym_identifier] = ACTIONS(3224),
    [anon_sym_BQUOTE] = ACTIONS(3226),
    [anon_sym_debugger] = ACTIONS(3224),
    [anon_sym_symbol] = ACTIONS(3224),
    [anon_sym_AT] = ACTIONS(3226),
    [anon_sym_DASH] = ACTIONS(3224),
    [anon_sym_void] = ACTIONS(3224),
    [anon_sym_break] = ACTIONS(3224),
    [anon_sym_const] = ACTIONS(3224),
    [sym_super] = ACTIONS(3224),
    [anon_sym_return] = ACTIONS(3224),
    [anon_sym_private] = ACTIONS(3224),
    [anon_sym_get] = ACTIONS(3224),
    [anon_sym_RBRACE] = ACTIONS(3226),
    [anon_sym_interface] = ACTIONS(3224),
    [anon_sym_default] = ACTIONS(3224),
    [anon_sym_enum] = ACTIONS(3224),
    [anon_sym_delete] = ACTIONS(3224),
    [anon_sym_continue] = ACTIONS(3224),
    [anon_sym_DASH_DASH] = ACTIONS(3226),
    [anon_sym_if] = ACTIONS(3224),
    [anon_sym_this] = ACTIONS(3224),
    [anon_sym_yield] = ACTIONS(3224),
    [sym_true] = ACTIONS(3224),
    [anon_sym_throw] = ACTIONS(3224),
    [anon_sym_protected] = ACTIONS(3224),
    [anon_sym_abstract] = ACTIONS(3224),
    [anon_sym_set] = ACTIONS(3224),
    [anon_sym_type] = ACTIONS(3224),
    [anon_sym_import] = ACTIONS(3224),
    [anon_sym_namespace] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3226),
    [anon_sym_await] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3226),
    [anon_sym_else] = ACTIONS(3224),
    [anon_sym_BANG] = ACTIONS(3226),
    [anon_sym_for] = ACTIONS(3224),
    [anon_sym_LBRACK] = ACTIONS(3226),
    [sym_false] = ACTIONS(3224),
    [anon_sym_SEMI] = ACTIONS(3226),
    [anon_sym_case] = ACTIONS(3224),
    [anon_sym_module] = ACTIONS(3224),
    [anon_sym_number] = ACTIONS(3224),
    [anon_sym_class] = ACTIONS(3224),
    [anon_sym_declare] = ACTIONS(3224),
    [anon_sym_typeof] = ACTIONS(3224),
    [anon_sym_LBRACE] = ACTIONS(3226),
    [anon_sym_switch] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(3226),
    [sym_null] = ACTIONS(3224),
    [anon_sym_any] = ACTIONS(3224),
    [anon_sym_boolean] = ACTIONS(3224),
    [anon_sym_async] = ACTIONS(3224),
    [anon_sym_public] = ACTIONS(3224),
    [anon_sym_var] = ACTIONS(3224),
    [anon_sym_while] = ACTIONS(3224),
    [anon_sym_SQUOTE] = ACTIONS(3226),
    [anon_sym_try] = ACTIONS(3224),
    [anon_sym_LT] = ACTIONS(3226),
    [sym_number] = ACTIONS(3226),
    [anon_sym_SLASH] = ACTIONS(3224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3224),
    [anon_sym_function] = ACTIONS(3224),
    [sym_undefined] = ACTIONS(3224),
    [anon_sym_new] = ACTIONS(3224),
    [ts_builtin_sym_end] = ACTIONS(3226),
    [anon_sym_let] = ACTIONS(3224),
    [anon_sym_PLUS] = ACTIONS(3224),
    [anon_sym_export] = ACTIONS(3224),
    [anon_sym_do] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3226),
    [anon_sym_with] = ACTIONS(3224),
  },
  [847] = {
    [sym_identifier] = ACTIONS(3228),
    [anon_sym_BQUOTE] = ACTIONS(3230),
    [anon_sym_debugger] = ACTIONS(3228),
    [anon_sym_symbol] = ACTIONS(3228),
    [anon_sym_AT] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3228),
    [anon_sym_void] = ACTIONS(3228),
    [anon_sym_break] = ACTIONS(3228),
    [anon_sym_const] = ACTIONS(3228),
    [sym_super] = ACTIONS(3228),
    [anon_sym_return] = ACTIONS(3228),
    [anon_sym_private] = ACTIONS(3228),
    [anon_sym_get] = ACTIONS(3228),
    [anon_sym_RBRACE] = ACTIONS(3230),
    [anon_sym_interface] = ACTIONS(3228),
    [anon_sym_default] = ACTIONS(3228),
    [anon_sym_enum] = ACTIONS(3228),
    [anon_sym_delete] = ACTIONS(3228),
    [anon_sym_continue] = ACTIONS(3228),
    [anon_sym_DASH_DASH] = ACTIONS(3230),
    [anon_sym_if] = ACTIONS(3228),
    [anon_sym_this] = ACTIONS(3228),
    [anon_sym_yield] = ACTIONS(3228),
    [sym_true] = ACTIONS(3228),
    [anon_sym_throw] = ACTIONS(3228),
    [anon_sym_protected] = ACTIONS(3228),
    [anon_sym_abstract] = ACTIONS(3228),
    [anon_sym_set] = ACTIONS(3228),
    [anon_sym_type] = ACTIONS(3228),
    [anon_sym_import] = ACTIONS(3228),
    [anon_sym_namespace] = ACTIONS(3228),
    [anon_sym_PLUS_PLUS] = ACTIONS(3230),
    [anon_sym_await] = ACTIONS(3228),
    [anon_sym_DQUOTE] = ACTIONS(3230),
    [anon_sym_else] = ACTIONS(3228),
    [anon_sym_BANG] = ACTIONS(3230),
    [anon_sym_for] = ACTIONS(3228),
    [anon_sym_LBRACK] = ACTIONS(3230),
    [sym_false] = ACTIONS(3228),
    [anon_sym_SEMI] = ACTIONS(3230),
    [anon_sym_case] = ACTIONS(3228),
    [anon_sym_module] = ACTIONS(3228),
    [anon_sym_number] = ACTIONS(3228),
    [anon_sym_class] = ACTIONS(3228),
    [anon_sym_declare] = ACTIONS(3228),
    [anon_sym_typeof] = ACTIONS(3228),
    [anon_sym_LBRACE] = ACTIONS(3230),
    [anon_sym_switch] = ACTIONS(3228),
    [anon_sym_LPAREN] = ACTIONS(3230),
    [sym_null] = ACTIONS(3228),
    [anon_sym_any] = ACTIONS(3228),
    [anon_sym_boolean] = ACTIONS(3228),
    [anon_sym_async] = ACTIONS(3228),
    [anon_sym_public] = ACTIONS(3228),
    [anon_sym_var] = ACTIONS(3228),
    [anon_sym_while] = ACTIONS(3228),
    [anon_sym_SQUOTE] = ACTIONS(3230),
    [anon_sym_try] = ACTIONS(3228),
    [anon_sym_LT] = ACTIONS(3230),
    [sym_number] = ACTIONS(3230),
    [anon_sym_SLASH] = ACTIONS(3228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3228),
    [anon_sym_function] = ACTIONS(3228),
    [sym_undefined] = ACTIONS(3228),
    [anon_sym_new] = ACTIONS(3228),
    [ts_builtin_sym_end] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3228),
    [anon_sym_PLUS] = ACTIONS(3228),
    [anon_sym_export] = ACTIONS(3228),
    [anon_sym_do] = ACTIONS(3228),
    [anon_sym_TILDE] = ACTIONS(3230),
    [anon_sym_with] = ACTIONS(3228),
  },
  [848] = {
    [anon_sym_COMMA] = ACTIONS(3232),
    [anon_sym_RBRACE] = ACTIONS(3232),
    [sym_comment] = ACTIONS(3),
  },
  [849] = {
    [sym_identifier] = ACTIONS(3234),
    [sym_comment] = ACTIONS(3),
  },
  [850] = {
    [anon_sym_from] = ACTIONS(3236),
    [sym_comment] = ACTIONS(3),
  },
  [851] = {
    [anon_sym_COMMA] = ACTIONS(3238),
    [anon_sym_RBRACE] = ACTIONS(3238),
    [sym_comment] = ACTIONS(3),
  },
  [852] = {
    [sym__import_export_specifier] = STATE(851),
    [sym_identifier] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(3240),
    [anon_sym_typeof] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
  },
  [853] = {
    [aux_sym_named_imports_repeat1] = STATE(853),
    [anon_sym_COMMA] = ACTIONS(3242),
    [anon_sym_RBRACE] = ACTIONS(3245),
    [sym_comment] = ACTIONS(3),
  },
  [854] = {
    [anon_sym_of] = ACTIONS(3247),
    [sym_comment] = ACTIONS(3),
  },
  [855] = {
    [anon_sym_of] = ACTIONS(3249),
    [sym_comment] = ACTIONS(3),
  },
  [856] = {
    [anon_sym_of] = ACTIONS(3251),
    [sym_comment] = ACTIONS(3),
  },
  [857] = {
    [sym_new_expression] = STATE(1014),
    [sym_augmented_assignment_expression] = STATE(1014),
    [sym_unary_expression] = STATE(1014),
    [sym_update_expression] = STATE(1014),
    [sym_regex] = STATE(1014),
    [sym_meta_property] = STATE(1014),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1014),
    [sym_yield_expression] = STATE(1014),
    [sym_as_expression] = STATE(1014),
    [sym_non_null_expression] = STATE(1014),
    [sym_internal_module] = STATE(1014),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1014),
    [sym_await_expression] = STATE(1014),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1014),
    [sym_this] = STATE(1014),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1014),
    [sym_generator_function] = STATE(1014),
    [sym_call_expression] = STATE(1014),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1014),
    [sym_ternary_expression] = STATE(1014),
    [sym_binary_expression] = STATE(1014),
    [sym_template_string] = STATE(1014),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1014),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1014),
    [sym_class] = STATE(1014),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(3253),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3253),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3253),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3255),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3253),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [858] = {
    [sym_new_expression] = STATE(1015),
    [sym_augmented_assignment_expression] = STATE(1015),
    [sym_unary_expression] = STATE(1015),
    [sym_update_expression] = STATE(1015),
    [sym_regex] = STATE(1015),
    [sym_meta_property] = STATE(1015),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1015),
    [sym_yield_expression] = STATE(1015),
    [sym_as_expression] = STATE(1015),
    [sym_non_null_expression] = STATE(1015),
    [sym_internal_module] = STATE(1015),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1015),
    [sym_await_expression] = STATE(1015),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1015),
    [sym_this] = STATE(1015),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1015),
    [sym_generator_function] = STATE(1015),
    [sym_call_expression] = STATE(1015),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1015),
    [sym_ternary_expression] = STATE(1015),
    [sym_binary_expression] = STATE(1015),
    [sym_template_string] = STATE(1015),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1015),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1015),
    [sym_class] = STATE(1015),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(3257),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3257),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3257),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3259),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3257),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [859] = {
    [sym_new_expression] = STATE(1016),
    [sym_augmented_assignment_expression] = STATE(1016),
    [sym_unary_expression] = STATE(1016),
    [sym_update_expression] = STATE(1016),
    [sym_regex] = STATE(1016),
    [sym_meta_property] = STATE(1016),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1016),
    [sym_yield_expression] = STATE(1016),
    [sym_as_expression] = STATE(1016),
    [sym_non_null_expression] = STATE(1016),
    [sym_internal_module] = STATE(1016),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1016),
    [sym_await_expression] = STATE(1016),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1016),
    [sym_this] = STATE(1016),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1016),
    [sym_generator_function] = STATE(1016),
    [sym_call_expression] = STATE(1016),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1016),
    [sym_ternary_expression] = STATE(1016),
    [sym_binary_expression] = STATE(1016),
    [sym_template_string] = STATE(1016),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1016),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1016),
    [sym_class] = STATE(1016),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(3261),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3261),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3261),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3263),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3261),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [860] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_RPAREN] = ACTIONS(3265),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [861] = {
    [anon_sym_RPAREN] = ACTIONS(3265),
    [sym_comment] = ACTIONS(3),
  },
  [862] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(3267),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [863] = {
    [sym_new_expression] = STATE(1019),
    [sym_augmented_assignment_expression] = STATE(1019),
    [sym_unary_expression] = STATE(1019),
    [sym_update_expression] = STATE(1019),
    [sym_regex] = STATE(1019),
    [sym_meta_property] = STATE(1019),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1019),
    [sym_yield_expression] = STATE(1019),
    [sym_as_expression] = STATE(1019),
    [sym_non_null_expression] = STATE(1019),
    [sym_internal_module] = STATE(1019),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1019),
    [sym_await_expression] = STATE(1019),
    [sym_member_expression] = STATE(1201),
    [sym_sequence_expression] = STATE(1020),
    [sym_string] = STATE(1019),
    [sym_this] = STATE(1019),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1019),
    [sym_generator_function] = STATE(1019),
    [sym_call_expression] = STATE(1019),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1019),
    [sym_ternary_expression] = STATE(1019),
    [sym_binary_expression] = STATE(1019),
    [sym_template_string] = STATE(1019),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1019),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1019),
    [sym_class] = STATE(1019),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3269),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3269),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3269),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3271),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3269),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [864] = {
    [sym_new_expression] = STATE(1021),
    [sym_augmented_assignment_expression] = STATE(1021),
    [sym_unary_expression] = STATE(1021),
    [sym_update_expression] = STATE(1021),
    [sym_regex] = STATE(1021),
    [sym_meta_property] = STATE(1021),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1021),
    [sym_yield_expression] = STATE(1021),
    [sym_as_expression] = STATE(1021),
    [sym_non_null_expression] = STATE(1021),
    [sym_internal_module] = STATE(1021),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1021),
    [sym_await_expression] = STATE(1021),
    [sym_member_expression] = STATE(1201),
    [sym_sequence_expression] = STATE(1022),
    [sym_string] = STATE(1021),
    [sym_this] = STATE(1021),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1021),
    [sym_generator_function] = STATE(1021),
    [sym_call_expression] = STATE(1021),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1021),
    [sym_ternary_expression] = STATE(1021),
    [sym_binary_expression] = STATE(1021),
    [sym_template_string] = STATE(1021),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1021),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1021),
    [sym_class] = STATE(1021),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3273),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3273),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3273),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3275),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3273),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [865] = {
    [sym_new_expression] = STATE(1023),
    [sym_augmented_assignment_expression] = STATE(1023),
    [sym_unary_expression] = STATE(1023),
    [sym_update_expression] = STATE(1023),
    [sym_regex] = STATE(1023),
    [sym_meta_property] = STATE(1023),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1023),
    [sym_yield_expression] = STATE(1023),
    [sym_as_expression] = STATE(1023),
    [sym_non_null_expression] = STATE(1023),
    [sym_internal_module] = STATE(1023),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1023),
    [sym_await_expression] = STATE(1023),
    [sym_member_expression] = STATE(1201),
    [sym_sequence_expression] = STATE(1024),
    [sym_string] = STATE(1023),
    [sym_this] = STATE(1023),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1023),
    [sym_generator_function] = STATE(1023),
    [sym_call_expression] = STATE(1023),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1023),
    [sym_ternary_expression] = STATE(1023),
    [sym_binary_expression] = STATE(1023),
    [sym_template_string] = STATE(1023),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1023),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1023),
    [sym_class] = STATE(1023),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3277),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3277),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3277),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3279),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3277),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [866] = {
    [sym_type_alias_declaration] = STATE(1025),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1025),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1025),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1025),
    [sym_return_statement] = STATE(1025),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1025),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1025),
    [sym_switch_statement] = STATE(1025),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1025),
    [sym_throw_statement] = STATE(1025),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1025),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1025),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1025),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1025),
    [sym_abstract_class] = STATE(1025),
    [sym_interface_declaration] = STATE(1025),
    [sym_statement_block] = STATE(1025),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1025),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1025),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1025),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1025),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1025),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1025),
    [sym_empty_statement] = STATE(1025),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1025),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1025),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1025),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1025),
    [sym_break_statement] = STATE(1025),
    [sym_labeled_statement] = STATE(1025),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1025),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [867] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(3281),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [868] = {
    [anon_sym_RPAREN] = ACTIONS(3281),
    [sym_comment] = ACTIONS(3),
  },
  [869] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(3283),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [870] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_RPAREN] = ACTIONS(3285),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [871] = {
    [anon_sym_RPAREN] = ACTIONS(3285),
    [sym_comment] = ACTIONS(3),
  },
  [872] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(3287),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [873] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_RPAREN] = ACTIONS(3289),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [874] = {
    [anon_sym_RPAREN] = ACTIONS(3289),
    [sym_comment] = ACTIONS(3),
  },
  [875] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(1697),
    [anon_sym_COMMA] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3291),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_LBRACE] = ACTIONS(3297),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_GT] = ACTIONS(1697),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(1697),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_implements] = ACTIONS(3291),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1697),
  },
  [876] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1922),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_COMMA] = ACTIONS(3300),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(3300),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG_EQ] = ACTIONS(1922),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1942),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_implements] = ACTIONS(3300),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1924),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [877] = {
    [anon_sym_implements] = ACTIONS(3300),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3302),
  },
  [878] = {
    [aux_sym_extends_clause_repeat1] = STATE(878),
    [anon_sym_implements] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(3304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3300),
  },
  [879] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3307),
    [sym__automatic_semicolon] = ACTIONS(3307),
    [anon_sym_BQUOTE] = ACTIONS(3307),
    [anon_sym_symbol] = ACTIONS(3309),
    [anon_sym_PIPE] = ACTIONS(3309),
    [anon_sym_STAR] = ACTIONS(3309),
    [anon_sym_GT_GT_GT] = ACTIONS(3307),
    [anon_sym_break] = ACTIONS(3309),
    [anon_sym_BANG_EQ] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3309),
    [anon_sym_RBRACE] = ACTIONS(3307),
    [anon_sym_PERCENT] = ACTIONS(3307),
    [anon_sym_interface] = ACTIONS(3309),
    [anon_sym_as] = ACTIONS(3309),
    [anon_sym_delete] = ACTIONS(3309),
    [anon_sym_if] = ACTIONS(3309),
    [anon_sym_instanceof] = ACTIONS(3309),
    [anon_sym_yield] = ACTIONS(3309),
    [sym_true] = ACTIONS(3309),
    [anon_sym_protected] = ACTIONS(3309),
    [anon_sym_DOT] = ACTIONS(3309),
    [anon_sym_set] = ACTIONS(3309),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3307),
    [anon_sym_import] = ACTIONS(3309),
    [anon_sym_await] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [anon_sym_for] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3307),
    [anon_sym_number] = ACTIONS(3309),
    [anon_sym_typeof] = ACTIONS(3309),
    [anon_sym_LT_LT] = ACTIONS(3307),
    [anon_sym_LBRACE] = ACTIONS(3307),
    [anon_sym_AMP_AMP] = ACTIONS(3307),
    [anon_sym_switch] = ACTIONS(3309),
    [anon_sym_LT_EQ] = ACTIONS(3307),
    [sym_null] = ACTIONS(3309),
    [anon_sym_any] = ACTIONS(3309),
    [anon_sym_async] = ACTIONS(3309),
    [anon_sym_public] = ACTIONS(3309),
    [anon_sym_var] = ACTIONS(3309),
    [anon_sym_QMARK] = ACTIONS(3307),
    [anon_sym_while] = ACTIONS(3309),
    [anon_sym_SQUOTE] = ACTIONS(3307),
    [anon_sym_SLASH] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3309),
    [anon_sym_new] = ACTIONS(3309),
    [anon_sym_CARET] = ACTIONS(3307),
    [anon_sym_export] = ACTIONS(3309),
    [anon_sym_GT_GT] = ACTIONS(3309),
    [anon_sym_with] = ACTIONS(3309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3307),
    [sym_identifier] = ACTIONS(3309),
    [anon_sym_debugger] = ACTIONS(3309),
    [anon_sym_AT] = ACTIONS(3307),
    [anon_sym_COMMA] = ACTIONS(3307),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_void] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [anon_sym_GT_EQ] = ACTIONS(3307),
    [sym_super] = ACTIONS(3309),
    [anon_sym_private] = ACTIONS(3309),
    [anon_sym_get] = ACTIONS(3309),
    [anon_sym_default] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [anon_sym_continue] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3307),
    [anon_sym_this] = ACTIONS(3309),
    [anon_sym_throw] = ACTIONS(3309),
    [anon_sym_abstract] = ACTIONS(3309),
    [anon_sym_type] = ACTIONS(3309),
    [anon_sym_STAR_STAR] = ACTIONS(3307),
    [anon_sym_namespace] = ACTIONS(3309),
    [anon_sym_PLUS_PLUS] = ACTIONS(3307),
    [anon_sym_else] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [sym_false] = ACTIONS(3309),
    [anon_sym_case] = ACTIONS(3309),
    [anon_sym_module] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_declare] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3309),
    [anon_sym_boolean] = ACTIONS(3309),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_PIPE_PIPE] = ACTIONS(3307),
    [anon_sym_try] = ACTIONS(3309),
    [anon_sym_EQ_EQ] = ACTIONS(3309),
    [anon_sym_LT] = ACTIONS(3309),
    [sym_number] = ACTIONS(3307),
    [ts_builtin_sym_end] = ACTIONS(3307),
    [anon_sym_function] = ACTIONS(3309),
    [sym_undefined] = ACTIONS(3309),
    [anon_sym_let] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_do] = ACTIONS(3309),
    [anon_sym_TILDE] = ACTIONS(3307),
    [anon_sym_in] = ACTIONS(3309),
  },
  [880] = {
    [sym_predefined_type] = STATE(1031),
    [anon_sym_void] = ACTIONS(3311),
    [anon_sym_string] = ACTIONS(3311),
    [anon_sym_symbol] = ACTIONS(3311),
    [anon_sym_number] = ACTIONS(3311),
    [anon_sym_any] = ACTIONS(3311),
    [anon_sym_boolean] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
  },
  [881] = {
    [sym_predefined_type] = STATE(1032),
    [anon_sym_void] = ACTIONS(3311),
    [anon_sym_string] = ACTIONS(3311),
    [anon_sym_symbol] = ACTIONS(3311),
    [anon_sym_number] = ACTIONS(3311),
    [anon_sym_any] = ACTIONS(3311),
    [anon_sym_boolean] = ACTIONS(3311),
    [sym_comment] = ACTIONS(3),
  },
  [882] = {
    [sym__automatic_semicolon] = ACTIONS(2851),
    [anon_sym_RBRACE] = ACTIONS(2851),
    [anon_sym_SEMI] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_COMMA] = ACTIONS(2851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(2851),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2851),
    [anon_sym_BANG] = ACTIONS(2851),
  },
  [883] = {
    [sym_type_annotation] = STATE(1033),
    [anon_sym_COLON] = ACTIONS(719),
    [sym_comment] = ACTIONS(3),
  },
  [884] = {
    [sym_call_signature] = STATE(1034),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [885] = {
    [sym_statement_block] = STATE(1444),
    [sym__automatic_semicolon] = ACTIONS(3313),
    [anon_sym_SEMI] = ACTIONS(3313),
    [anon_sym_COMMA] = ACTIONS(3313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2772),
  },
  [886] = {
    [sym_call_signature] = STATE(1034),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(3315),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [887] = {
    [sym_string] = STATE(1036),
    [sym__property_name] = STATE(1036),
    [sym_computed_property_name] = STATE(1036),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_EQ] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_BANG] = ACTIONS(986),
  },
  [888] = {
    [sym_string] = STATE(1036),
    [sym__property_name] = STATE(1036),
    [sym_computed_property_name] = STATE(1036),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(3317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [889] = {
    [sym_string] = STATE(1036),
    [sym__property_name] = STATE(1036),
    [sym_computed_property_name] = STATE(1036),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(3319),
    [anon_sym_EQ] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(3321),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(3321),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_BANG] = ACTIONS(986),
  },
  [890] = {
    [sym_call_signature] = STATE(1034),
    [sym__initializer] = STATE(1041),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym_type_annotation] = STATE(1042),
    [sym__automatic_semicolon] = ACTIONS(3323),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_QMARK] = ACTIONS(3325),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3327),
  },
  [891] = {
    [sym_call_signature] = STATE(1034),
    [sym__initializer] = STATE(1041),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym_type_annotation] = STATE(1042),
    [sym__automatic_semicolon] = ACTIONS(3323),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3323),
    [sym_comment] = ACTIONS(3),
  },
  [892] = {
    [sym__initializer] = STATE(1041),
    [sym_type_annotation] = STATE(1042),
    [sym__automatic_semicolon] = ACTIONS(3323),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_COMMA] = ACTIONS(3323),
    [sym_comment] = ACTIONS(3),
  },
  [893] = {
    [sym__automatic_semicolon] = ACTIONS(3323),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_COMMA] = ACTIONS(3323),
    [sym_comment] = ACTIONS(3),
  },
  [894] = {
    [sym__initializer] = STATE(1041),
    [sym__automatic_semicolon] = ACTIONS(3323),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_COMMA] = ACTIONS(3323),
    [sym_comment] = ACTIONS(3),
  },
  [895] = {
    [sym_call_signature] = STATE(1044),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(3329),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [896] = {
    [sym__initializer] = STATE(1041),
    [sym_type_annotation] = STATE(1042),
    [sym__automatic_semicolon] = ACTIONS(3323),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_QMARK] = ACTIONS(3327),
    [anon_sym_COMMA] = ACTIONS(3323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3327),
  },
  [897] = {
    [sym_call_signature] = STATE(1044),
    [sym__initializer] = STATE(1041),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym_type_annotation] = STATE(1042),
    [sym__automatic_semicolon] = ACTIONS(3323),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3323),
    [sym_comment] = ACTIONS(3),
  },
  [898] = {
    [sym__automatic_semicolon] = ACTIONS(3331),
    [anon_sym_SEMI] = ACTIONS(3331),
    [anon_sym_COMMA] = ACTIONS(3331),
    [sym_comment] = ACTIONS(3),
  },
  [899] = {
    [sym_string] = STATE(1046),
    [sym__property_name] = STATE(1046),
    [sym_computed_property_name] = STATE(1046),
    [anon_sym_get] = ACTIONS(3333),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(3335),
    [anon_sym_STAR] = ACTIONS(3319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(3333),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(3337),
  },
  [900] = {
    [sym_string] = STATE(1047),
    [sym__property_name] = STATE(1047),
    [sym_computed_property_name] = STATE(1047),
    [anon_sym_get] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(3339),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(919),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(919),
  },
  [901] = {
    [sym_string] = STATE(1048),
    [sym__property_name] = STATE(1048),
    [sym_computed_property_name] = STATE(1048),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_EQ] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_BANG] = ACTIONS(986),
  },
  [902] = {
    [sym_string] = STATE(1048),
    [sym__property_name] = STATE(1048),
    [sym_computed_property_name] = STATE(1048),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(3341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [903] = {
    [sym_call_signature] = STATE(1044),
    [sym__initializer] = STATE(1041),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym_type_annotation] = STATE(1042),
    [sym__automatic_semicolon] = ACTIONS(3323),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3323),
    [anon_sym_QMARK] = ACTIONS(3343),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3327),
  },
  [904] = {
    [sym__type] = STATE(1050),
    [sym_constructor_type] = STATE(1050),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1050),
    [sym_nested_identifier] = STATE(2437),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(2436),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(1678),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(1050),
    [sym_intersection_type] = STATE(1050),
    [sym_formal_parameters] = STATE(2157),
    [sym_identifier] = ACTIONS(3345),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [905] = {
    [sym_statement_block] = STATE(1051),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [906] = {
    [anon_sym_COMMA] = ACTIONS(3357),
    [anon_sym_RBRACE] = ACTIONS(3357),
    [sym_comment] = ACTIONS(3),
  },
  [907] = {
    [sym_call_signature] = STATE(1052),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [908] = {
    [sym_call_signature] = STATE(1052),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(3359),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [909] = {
    [sym_string] = STATE(1054),
    [sym__property_name] = STATE(1054),
    [sym_computed_property_name] = STATE(1054),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [910] = {
    [sym_string] = STATE(1054),
    [sym__property_name] = STATE(1054),
    [sym_computed_property_name] = STATE(1054),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(3361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [911] = {
    [sym_string] = STATE(1054),
    [sym__property_name] = STATE(1054),
    [sym_computed_property_name] = STATE(1054),
    [anon_sym_get] = ACTIONS(3363),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3361),
    [anon_sym_STAR] = ACTIONS(3365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(3363),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [912] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3367),
    [sym__automatic_semicolon] = ACTIONS(3367),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [anon_sym_PIPE] = ACTIONS(3369),
    [anon_sym_COMMA] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3369),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_GT_GT_GT] = ACTIONS(3367),
    [anon_sym_EQ] = ACTIONS(3369),
    [anon_sym_BANG_EQ] = ACTIONS(3369),
    [anon_sym_GT_EQ] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_PERCENT] = ACTIONS(3367),
    [anon_sym_as] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3367),
    [anon_sym_instanceof] = ACTIONS(3367),
    [anon_sym_DOT] = ACTIONS(3367),
    [anon_sym_STAR_STAR] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_SEMI] = ACTIONS(3367),
    [anon_sym_LT_LT] = ACTIONS(3367),
    [anon_sym_AMP_AMP] = ACTIONS(3367),
    [anon_sym_of] = ACTIONS(3367),
    [anon_sym_LT_EQ] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_GT] = ACTIONS(3369),
    [anon_sym_AMP] = ACTIONS(3369),
    [anon_sym_QMARK] = ACTIONS(3367),
    [anon_sym_PIPE_PIPE] = ACTIONS(3367),
    [anon_sym_EQ_EQ] = ACTIONS(3369),
    [anon_sym_RPAREN] = ACTIONS(3367),
    [anon_sym_LT] = ACTIONS(3369),
    [anon_sym_SLASH] = ACTIONS(3369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3369),
    [anon_sym_GT_GT] = ACTIONS(3369),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3367),
    [anon_sym_in] = ACTIONS(3369),
  },
  [913] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3371),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [914] = {
    [anon_sym_COLON] = ACTIONS(3371),
    [sym_comment] = ACTIONS(3),
  },
  [915] = {
    [sym_type_alias_declaration] = STATE(1058),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1058),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1058),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1058),
    [sym_return_statement] = STATE(1058),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1058),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1058),
    [sym_switch_statement] = STATE(1058),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1058),
    [sym_throw_statement] = STATE(1058),
    [aux_sym_program_repeat1] = STATE(1058),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1058),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1058),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1058),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1058),
    [sym_abstract_class] = STATE(1058),
    [sym_interface_declaration] = STATE(1058),
    [sym_statement_block] = STATE(1058),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1058),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1058),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1058),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1058),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1058),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1058),
    [sym_empty_statement] = STATE(1058),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1058),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1058),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1058),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1058),
    [sym_break_statement] = STATE(1058),
    [sym_labeled_statement] = STATE(1058),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1058),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(3373),
    [anon_sym_default] = ACTIONS(3375),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(3375),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [916] = {
    [sym_identifier] = ACTIONS(3377),
    [anon_sym_BQUOTE] = ACTIONS(3379),
    [anon_sym_debugger] = ACTIONS(3377),
    [anon_sym_symbol] = ACTIONS(3377),
    [anon_sym_AT] = ACTIONS(3379),
    [anon_sym_DASH] = ACTIONS(3377),
    [anon_sym_void] = ACTIONS(3377),
    [anon_sym_break] = ACTIONS(3377),
    [anon_sym_const] = ACTIONS(3377),
    [sym_super] = ACTIONS(3377),
    [anon_sym_return] = ACTIONS(3377),
    [anon_sym_private] = ACTIONS(3377),
    [anon_sym_get] = ACTIONS(3377),
    [anon_sym_RBRACE] = ACTIONS(3379),
    [anon_sym_interface] = ACTIONS(3377),
    [anon_sym_default] = ACTIONS(3377),
    [anon_sym_enum] = ACTIONS(3377),
    [anon_sym_delete] = ACTIONS(3377),
    [anon_sym_continue] = ACTIONS(3377),
    [anon_sym_DASH_DASH] = ACTIONS(3379),
    [anon_sym_if] = ACTIONS(3377),
    [anon_sym_this] = ACTIONS(3377),
    [anon_sym_yield] = ACTIONS(3377),
    [sym_true] = ACTIONS(3377),
    [anon_sym_throw] = ACTIONS(3377),
    [anon_sym_protected] = ACTIONS(3377),
    [anon_sym_abstract] = ACTIONS(3377),
    [anon_sym_set] = ACTIONS(3377),
    [anon_sym_type] = ACTIONS(3377),
    [anon_sym_import] = ACTIONS(3377),
    [anon_sym_namespace] = ACTIONS(3377),
    [anon_sym_PLUS_PLUS] = ACTIONS(3379),
    [anon_sym_await] = ACTIONS(3377),
    [anon_sym_DQUOTE] = ACTIONS(3379),
    [anon_sym_else] = ACTIONS(3377),
    [anon_sym_BANG] = ACTIONS(3379),
    [anon_sym_for] = ACTIONS(3377),
    [anon_sym_LBRACK] = ACTIONS(3379),
    [sym_false] = ACTIONS(3377),
    [anon_sym_SEMI] = ACTIONS(3379),
    [anon_sym_case] = ACTIONS(3377),
    [anon_sym_module] = ACTIONS(3377),
    [anon_sym_number] = ACTIONS(3377),
    [anon_sym_class] = ACTIONS(3377),
    [anon_sym_declare] = ACTIONS(3377),
    [anon_sym_typeof] = ACTIONS(3377),
    [anon_sym_LBRACE] = ACTIONS(3379),
    [anon_sym_switch] = ACTIONS(3377),
    [anon_sym_LPAREN] = ACTIONS(3379),
    [sym_null] = ACTIONS(3377),
    [anon_sym_any] = ACTIONS(3377),
    [anon_sym_boolean] = ACTIONS(3377),
    [anon_sym_async] = ACTIONS(3377),
    [anon_sym_public] = ACTIONS(3377),
    [anon_sym_var] = ACTIONS(3377),
    [anon_sym_while] = ACTIONS(3377),
    [anon_sym_SQUOTE] = ACTIONS(3379),
    [anon_sym_try] = ACTIONS(3377),
    [anon_sym_LT] = ACTIONS(3379),
    [sym_number] = ACTIONS(3379),
    [anon_sym_SLASH] = ACTIONS(3377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3377),
    [anon_sym_function] = ACTIONS(3377),
    [sym_undefined] = ACTIONS(3377),
    [anon_sym_new] = ACTIONS(3377),
    [ts_builtin_sym_end] = ACTIONS(3379),
    [anon_sym_let] = ACTIONS(3377),
    [anon_sym_PLUS] = ACTIONS(3377),
    [anon_sym_export] = ACTIONS(3377),
    [anon_sym_do] = ACTIONS(3377),
    [anon_sym_TILDE] = ACTIONS(3379),
    [anon_sym_with] = ACTIONS(3377),
  },
  [917] = {
    [sym_switch_default] = STATE(917),
    [aux_sym_switch_body_repeat1] = STATE(917),
    [sym_switch_case] = STATE(917),
    [anon_sym_RBRACE] = ACTIONS(3381),
    [anon_sym_default] = ACTIONS(3383),
    [anon_sym_case] = ACTIONS(3386),
    [sym_comment] = ACTIONS(3),
  },
  [918] = {
    [anon_sym_COMMA] = ACTIONS(3389),
    [anon_sym_RPAREN] = ACTIONS(3389),
    [sym_comment] = ACTIONS(3),
  },
  [919] = {
    [anon_sym_COMMA] = ACTIONS(3391),
    [anon_sym_RPAREN] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
  },
  [920] = {
    [sym__initializer] = STATE(1059),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(3391),
    [anon_sym_COMMA] = ACTIONS(3391),
    [sym_comment] = ACTIONS(3),
  },
  [921] = {
    [anon_sym_COMMA] = ACTIONS(3393),
    [anon_sym_RPAREN] = ACTIONS(3393),
    [sym_comment] = ACTIONS(3),
  },
  [922] = {
    [sym__initializer] = STATE(1060),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(3389),
    [anon_sym_COMMA] = ACTIONS(3389),
    [sym_comment] = ACTIONS(3),
  },
  [923] = {
    [anon_sym_COMMA] = ACTIONS(3395),
    [anon_sym_RPAREN] = ACTIONS(3395),
    [sym_comment] = ACTIONS(3),
  },
  [924] = {
    [anon_sym_COMMA] = ACTIONS(3397),
    [anon_sym_RPAREN] = ACTIONS(3397),
    [sym_comment] = ACTIONS(3),
  },
  [925] = {
    [sym__initializer] = STATE(1061),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(3397),
    [anon_sym_COMMA] = ACTIONS(3397),
    [sym_comment] = ACTIONS(3),
  },
  [926] = {
    [anon_sym_COMMA] = ACTIONS(3399),
    [anon_sym_RPAREN] = ACTIONS(3399),
    [sym_comment] = ACTIONS(3),
  },
  [927] = {
    [anon_sym_COMMA] = ACTIONS(3401),
    [anon_sym_RPAREN] = ACTIONS(3401),
    [sym_comment] = ACTIONS(3),
  },
  [928] = {
    [sym__initializer] = STATE(1062),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(3401),
    [anon_sym_COMMA] = ACTIONS(3401),
    [sym_comment] = ACTIONS(3),
  },
  [929] = {
    [anon_sym_COMMA] = ACTIONS(3403),
    [anon_sym_RPAREN] = ACTIONS(3403),
    [sym_comment] = ACTIONS(3),
  },
  [930] = {
    [anon_sym_COMMA] = ACTIONS(3405),
    [anon_sym_RPAREN] = ACTIONS(3405),
    [sym_comment] = ACTIONS(3),
  },
  [931] = {
    [anon_sym_COMMA] = ACTIONS(3407),
    [anon_sym_RPAREN] = ACTIONS(3407),
    [sym_comment] = ACTIONS(3),
  },
  [932] = {
    [anon_sym_COLON] = ACTIONS(3409),
    [anon_sym_EQ_GT] = ACTIONS(3409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3409),
  },
  [933] = {
    [aux_sym_export_statement_repeat1] = STATE(719),
    [sym_decorator] = STATE(719),
    [sym_object] = STATE(465),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(720),
    [sym_array] = STATE(467),
    [sym_rest_parameter] = STATE(720),
    [sym_optional_parameter] = STATE(720),
    [sym_this] = STATE(468),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_symbol] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_void] = ACTIONS(1154),
    [anon_sym_string] = ACTIONS(1154),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [anon_sym_export] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
    [anon_sym_any] = ACTIONS(1154),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_boolean] = ACTIONS(1154),
    [anon_sym_async] = ACTIONS(1154),
  },
  [934] = {
    [sym__initializer] = STATE(1063),
    [sym_type_annotation] = STATE(1064),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(3411),
    [anon_sym_COMMA] = ACTIONS(3411),
    [sym_comment] = ACTIONS(3),
  },
  [935] = {
    [anon_sym_COMMA] = ACTIONS(3413),
    [anon_sym_RPAREN] = ACTIONS(3413),
    [sym_comment] = ACTIONS(3),
  },
  [936] = {
    [sym__initializer] = STATE(1065),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(3413),
    [anon_sym_COMMA] = ACTIONS(3413),
    [sym_comment] = ACTIONS(3),
  },
  [937] = {
    [sym__initializer] = STATE(1060),
    [sym_type_annotation] = STATE(1066),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(3389),
    [anon_sym_COMMA] = ACTIONS(3389),
    [sym_comment] = ACTIONS(3),
  },
  [938] = {
    [sym__initializer] = STATE(1067),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(3395),
    [anon_sym_COMMA] = ACTIONS(3395),
    [sym_comment] = ACTIONS(3),
  },
  [939] = {
    [sym__initializer] = STATE(1068),
    [sym_type_annotation] = STATE(1069),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(3415),
    [anon_sym_COMMA] = ACTIONS(3415),
    [sym_comment] = ACTIONS(3),
  },
  [940] = {
    [anon_sym_COMMA] = ACTIONS(3417),
    [anon_sym_RPAREN] = ACTIONS(3417),
    [sym_comment] = ACTIONS(3),
  },
  [941] = {
    [sym__initializer] = STATE(1070),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(3417),
    [anon_sym_COMMA] = ACTIONS(3417),
    [sym_comment] = ACTIONS(3),
  },
  [942] = {
    [sym__initializer] = STATE(1071),
    [sym_type_annotation] = STATE(1072),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_RPAREN] = ACTIONS(3419),
    [anon_sym_COMMA] = ACTIONS(3419),
    [sym_comment] = ACTIONS(3),
  },
  [943] = {
    [anon_sym_COMMA] = ACTIONS(3421),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
  },
  [944] = {
    [sym__initializer] = STATE(1073),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [anon_sym_COMMA] = ACTIONS(3421),
    [sym_comment] = ACTIONS(3),
  },
  [945] = {
    [aux_sym_export_statement_repeat1] = STATE(719),
    [sym_decorator] = STATE(719),
    [sym_object] = STATE(465),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(720),
    [sym_array] = STATE(467),
    [sym_rest_parameter] = STATE(720),
    [sym_optional_parameter] = STATE(720),
    [sym_this] = STATE(468),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_symbol] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1154),
    [anon_sym_any] = ACTIONS(1154),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_boolean] = ACTIONS(1154),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [anon_sym_this] = ACTIONS(284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_string] = ACTIONS(1154),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [anon_sym_export] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
  },
  [946] = {
    [anon_sym_COMMA] = ACTIONS(3425),
    [anon_sym_RPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(3),
  },
  [947] = {
    [anon_sym_COMMA] = ACTIONS(3427),
    [anon_sym_RPAREN] = ACTIONS(3427),
    [sym_comment] = ACTIONS(3),
  },
  [948] = {
    [sym_identifier] = ACTIONS(3429),
    [anon_sym_BQUOTE] = ACTIONS(3431),
    [anon_sym_debugger] = ACTIONS(3429),
    [anon_sym_symbol] = ACTIONS(3429),
    [anon_sym_AT] = ACTIONS(3431),
    [anon_sym_DASH] = ACTIONS(3429),
    [anon_sym_void] = ACTIONS(3429),
    [anon_sym_break] = ACTIONS(3429),
    [anon_sym_const] = ACTIONS(3429),
    [sym_super] = ACTIONS(3429),
    [anon_sym_return] = ACTIONS(3429),
    [anon_sym_private] = ACTIONS(3429),
    [anon_sym_get] = ACTIONS(3429),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_interface] = ACTIONS(3429),
    [anon_sym_default] = ACTIONS(3429),
    [anon_sym_enum] = ACTIONS(3429),
    [anon_sym_delete] = ACTIONS(3429),
    [anon_sym_continue] = ACTIONS(3429),
    [anon_sym_DASH_DASH] = ACTIONS(3431),
    [anon_sym_if] = ACTIONS(3429),
    [anon_sym_this] = ACTIONS(3429),
    [anon_sym_yield] = ACTIONS(3429),
    [sym_true] = ACTIONS(3429),
    [anon_sym_throw] = ACTIONS(3429),
    [anon_sym_protected] = ACTIONS(3429),
    [anon_sym_abstract] = ACTIONS(3429),
    [anon_sym_set] = ACTIONS(3429),
    [anon_sym_type] = ACTIONS(3429),
    [anon_sym_import] = ACTIONS(3429),
    [anon_sym_namespace] = ACTIONS(3429),
    [anon_sym_PLUS_PLUS] = ACTIONS(3431),
    [anon_sym_await] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(3431),
    [anon_sym_else] = ACTIONS(3429),
    [anon_sym_BANG] = ACTIONS(3431),
    [anon_sym_for] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(3431),
    [sym_false] = ACTIONS(3429),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym_case] = ACTIONS(3429),
    [anon_sym_module] = ACTIONS(3429),
    [anon_sym_number] = ACTIONS(3429),
    [anon_sym_class] = ACTIONS(3429),
    [anon_sym_declare] = ACTIONS(3429),
    [anon_sym_typeof] = ACTIONS(3429),
    [anon_sym_LBRACE] = ACTIONS(3431),
    [anon_sym_switch] = ACTIONS(3429),
    [anon_sym_LPAREN] = ACTIONS(3431),
    [sym_null] = ACTIONS(3429),
    [anon_sym_any] = ACTIONS(3429),
    [anon_sym_boolean] = ACTIONS(3429),
    [anon_sym_async] = ACTIONS(3429),
    [anon_sym_public] = ACTIONS(3429),
    [anon_sym_var] = ACTIONS(3429),
    [anon_sym_while] = ACTIONS(3429),
    [anon_sym_SQUOTE] = ACTIONS(3431),
    [anon_sym_try] = ACTIONS(3429),
    [anon_sym_LT] = ACTIONS(3431),
    [sym_number] = ACTIONS(3431),
    [anon_sym_SLASH] = ACTIONS(3429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3429),
    [anon_sym_function] = ACTIONS(3429),
    [sym_undefined] = ACTIONS(3429),
    [anon_sym_new] = ACTIONS(3429),
    [ts_builtin_sym_end] = ACTIONS(3431),
    [anon_sym_let] = ACTIONS(3429),
    [anon_sym_PLUS] = ACTIONS(3429),
    [anon_sym_export] = ACTIONS(3429),
    [anon_sym_do] = ACTIONS(3429),
    [anon_sym_TILDE] = ACTIONS(3431),
    [anon_sym_with] = ACTIONS(3429),
  },
  [949] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3433),
    [sym__automatic_semicolon] = ACTIONS(3433),
    [anon_sym_BQUOTE] = ACTIONS(3433),
    [anon_sym_symbol] = ACTIONS(3435),
    [anon_sym_PIPE] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3435),
    [anon_sym_GT_GT_GT] = ACTIONS(3433),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_BANG_EQ] = ACTIONS(3435),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_RBRACE] = ACTIONS(3433),
    [anon_sym_PERCENT] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3435),
    [anon_sym_as] = ACTIONS(3435),
    [anon_sym_delete] = ACTIONS(3435),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_instanceof] = ACTIONS(3435),
    [anon_sym_yield] = ACTIONS(3435),
    [sym_true] = ACTIONS(3435),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_DOT] = ACTIONS(3435),
    [anon_sym_set] = ACTIONS(3435),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3433),
    [anon_sym_import] = ACTIONS(3435),
    [anon_sym_await] = ACTIONS(3435),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym_number] = ACTIONS(3435),
    [anon_sym_typeof] = ACTIONS(3435),
    [anon_sym_LT_LT] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_AMP_AMP] = ACTIONS(3433),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_LT_EQ] = ACTIONS(3433),
    [sym_null] = ACTIONS(3435),
    [anon_sym_any] = ACTIONS(3435),
    [anon_sym_async] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_var] = ACTIONS(3435),
    [anon_sym_QMARK] = ACTIONS(3433),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_SLASH] = ACTIONS(3435),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [anon_sym_CARET] = ACTIONS(3433),
    [anon_sym_export] = ACTIONS(3435),
    [anon_sym_GT_GT] = ACTIONS(3435),
    [anon_sym_with] = ACTIONS(3435),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3433),
    [sym_identifier] = ACTIONS(3435),
    [anon_sym_debugger] = ACTIONS(3435),
    [anon_sym_AT] = ACTIONS(3433),
    [anon_sym_COMMA] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_void] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [anon_sym_GT_EQ] = ACTIONS(3433),
    [sym_super] = ACTIONS(3435),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_get] = ACTIONS(3435),
    [anon_sym_default] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [anon_sym_this] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_abstract] = ACTIONS(3435),
    [anon_sym_type] = ACTIONS(3435),
    [anon_sym_STAR_STAR] = ACTIONS(3433),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_else] = ACTIONS(3435),
    [anon_sym_BANG] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [sym_false] = ACTIONS(3435),
    [anon_sym_case] = ACTIONS(3435),
    [anon_sym_module] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_declare] = ACTIONS(3435),
    [anon_sym_LPAREN] = ACTIONS(3433),
    [anon_sym_GT] = ACTIONS(3435),
    [anon_sym_boolean] = ACTIONS(3435),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_PIPE_PIPE] = ACTIONS(3433),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_EQ_EQ] = ACTIONS(3435),
    [anon_sym_LT] = ACTIONS(3435),
    [sym_number] = ACTIONS(3433),
    [ts_builtin_sym_end] = ACTIONS(3433),
    [anon_sym_function] = ACTIONS(3435),
    [sym_undefined] = ACTIONS(3435),
    [anon_sym_let] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_in] = ACTIONS(3435),
  },
  [950] = {
    [anon_sym_RPAREN] = ACTIONS(3437),
    [sym_comment] = ACTIONS(3),
  },
  [951] = {
    [anon_sym_BQUOTE] = ACTIONS(3439),
    [anon_sym_symbol] = ACTIONS(3441),
    [anon_sym_PIPE] = ACTIONS(3439),
    [anon_sym_break] = ACTIONS(3441),
    [anon_sym_return] = ACTIONS(3441),
    [anon_sym_RBRACE] = ACTIONS(3439),
    [anon_sym_interface] = ACTIONS(3441),
    [anon_sym_delete] = ACTIONS(3441),
    [anon_sym_if] = ACTIONS(3441),
    [anon_sym_yield] = ACTIONS(3441),
    [sym_true] = ACTIONS(3441),
    [anon_sym_protected] = ACTIONS(3441),
    [anon_sym_set] = ACTIONS(3441),
    [anon_sym_import] = ACTIONS(3441),
    [anon_sym_await] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(3439),
    [anon_sym_for] = ACTIONS(3441),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_number] = ACTIONS(3441),
    [anon_sym_typeof] = ACTIONS(3441),
    [anon_sym_LBRACE] = ACTIONS(3439),
    [anon_sym_switch] = ACTIONS(3441),
    [anon_sym_RBRACK] = ACTIONS(3439),
    [sym_null] = ACTIONS(3441),
    [anon_sym_any] = ACTIONS(3441),
    [anon_sym_async] = ACTIONS(3441),
    [anon_sym_public] = ACTIONS(3441),
    [anon_sym_var] = ACTIONS(3441),
    [anon_sym_while] = ACTIONS(3441),
    [anon_sym_SQUOTE] = ACTIONS(3439),
    [anon_sym_RPAREN] = ACTIONS(3439),
    [anon_sym_SLASH] = ACTIONS(3441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3441),
    [anon_sym_new] = ACTIONS(3441),
    [anon_sym_export] = ACTIONS(3441),
    [anon_sym_with] = ACTIONS(3441),
    [sym_identifier] = ACTIONS(3441),
    [anon_sym_debugger] = ACTIONS(3441),
    [anon_sym_AT] = ACTIONS(3439),
    [anon_sym_COMMA] = ACTIONS(3439),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_void] = ACTIONS(3441),
    [anon_sym_const] = ACTIONS(3441),
    [sym_super] = ACTIONS(3441),
    [anon_sym_private] = ACTIONS(3441),
    [anon_sym_get] = ACTIONS(3441),
    [anon_sym_default] = ACTIONS(3441),
    [anon_sym_enum] = ACTIONS(3441),
    [anon_sym_continue] = ACTIONS(3441),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [anon_sym_this] = ACTIONS(3441),
    [anon_sym_throw] = ACTIONS(3441),
    [anon_sym_abstract] = ACTIONS(3441),
    [anon_sym_type] = ACTIONS(3441),
    [anon_sym_namespace] = ACTIONS(3441),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_else] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [sym_false] = ACTIONS(3441),
    [anon_sym_case] = ACTIONS(3441),
    [anon_sym_module] = ACTIONS(3441),
    [anon_sym_class] = ACTIONS(3441),
    [anon_sym_declare] = ACTIONS(3441),
    [anon_sym_LPAREN] = ACTIONS(3439),
    [anon_sym_GT] = ACTIONS(3439),
    [anon_sym_boolean] = ACTIONS(3441),
    [anon_sym_EQ_GT] = ACTIONS(3439),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym_try] = ACTIONS(3441),
    [anon_sym_LT] = ACTIONS(3439),
    [sym_number] = ACTIONS(3439),
    [ts_builtin_sym_end] = ACTIONS(3439),
    [anon_sym_function] = ACTIONS(3441),
    [sym_undefined] = ACTIONS(3441),
    [anon_sym_let] = ACTIONS(3441),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_do] = ACTIONS(3441),
    [anon_sym_TILDE] = ACTIONS(3439),
  },
  [952] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(967),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(967),
    [sym_call_signature] = STATE(967),
    [sym_construct_signature] = STATE(967),
    [sym_index_signature] = STATE(967),
    [sym_export_statement] = STATE(967),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(3443),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3443),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [953] = {
    [anon_sym_BQUOTE] = ACTIONS(3445),
    [anon_sym_symbol] = ACTIONS(3447),
    [anon_sym_PIPE] = ACTIONS(3445),
    [anon_sym_break] = ACTIONS(3447),
    [anon_sym_return] = ACTIONS(3447),
    [anon_sym_RBRACE] = ACTIONS(3445),
    [anon_sym_interface] = ACTIONS(3447),
    [anon_sym_delete] = ACTIONS(3447),
    [anon_sym_if] = ACTIONS(3447),
    [anon_sym_yield] = ACTIONS(3447),
    [sym_true] = ACTIONS(3447),
    [anon_sym_protected] = ACTIONS(3447),
    [anon_sym_set] = ACTIONS(3447),
    [anon_sym_import] = ACTIONS(3447),
    [anon_sym_await] = ACTIONS(3447),
    [anon_sym_DQUOTE] = ACTIONS(3445),
    [anon_sym_for] = ACTIONS(3447),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym_number] = ACTIONS(3447),
    [anon_sym_typeof] = ACTIONS(3447),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_switch] = ACTIONS(3447),
    [anon_sym_RBRACK] = ACTIONS(3445),
    [sym_null] = ACTIONS(3447),
    [anon_sym_any] = ACTIONS(3447),
    [anon_sym_async] = ACTIONS(3447),
    [anon_sym_public] = ACTIONS(3447),
    [anon_sym_var] = ACTIONS(3447),
    [anon_sym_while] = ACTIONS(3447),
    [anon_sym_SQUOTE] = ACTIONS(3445),
    [anon_sym_RPAREN] = ACTIONS(3445),
    [anon_sym_SLASH] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3447),
    [anon_sym_new] = ACTIONS(3447),
    [anon_sym_export] = ACTIONS(3447),
    [anon_sym_with] = ACTIONS(3447),
    [sym_identifier] = ACTIONS(3447),
    [anon_sym_debugger] = ACTIONS(3447),
    [anon_sym_AT] = ACTIONS(3445),
    [anon_sym_COMMA] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3447),
    [anon_sym_EQ] = ACTIONS(3447),
    [anon_sym_void] = ACTIONS(3447),
    [anon_sym_const] = ACTIONS(3447),
    [sym_super] = ACTIONS(3447),
    [anon_sym_private] = ACTIONS(3447),
    [anon_sym_get] = ACTIONS(3447),
    [anon_sym_default] = ACTIONS(3447),
    [anon_sym_enum] = ACTIONS(3447),
    [anon_sym_continue] = ACTIONS(3447),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_this] = ACTIONS(3447),
    [anon_sym_throw] = ACTIONS(3447),
    [anon_sym_abstract] = ACTIONS(3447),
    [anon_sym_type] = ACTIONS(3447),
    [anon_sym_namespace] = ACTIONS(3447),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_else] = ACTIONS(3447),
    [anon_sym_BANG] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [sym_false] = ACTIONS(3447),
    [anon_sym_case] = ACTIONS(3447),
    [anon_sym_module] = ACTIONS(3447),
    [anon_sym_class] = ACTIONS(3447),
    [anon_sym_declare] = ACTIONS(3447),
    [anon_sym_LPAREN] = ACTIONS(3445),
    [anon_sym_GT] = ACTIONS(3445),
    [anon_sym_boolean] = ACTIONS(3447),
    [anon_sym_EQ_GT] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3445),
    [anon_sym_try] = ACTIONS(3447),
    [anon_sym_LT] = ACTIONS(3445),
    [sym_number] = ACTIONS(3445),
    [ts_builtin_sym_end] = ACTIONS(3445),
    [anon_sym_function] = ACTIONS(3447),
    [sym_undefined] = ACTIONS(3447),
    [anon_sym_let] = ACTIONS(3447),
    [anon_sym_PLUS] = ACTIONS(3447),
    [anon_sym_do] = ACTIONS(3447),
    [anon_sym_TILDE] = ACTIONS(3445),
  },
  [954] = {
    [aux_sym_object_type_repeat1] = STATE(968),
    [sym__automatic_semicolon] = ACTIONS(3449),
    [anon_sym_RBRACE] = ACTIONS(3443),
    [anon_sym_SEMI] = ACTIONS(3449),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3443),
    [anon_sym_COMMA] = ACTIONS(3449),
    [sym_comment] = ACTIONS(3),
  },
  [955] = {
    [sym_call_signature] = STATE(1078),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [956] = {
    [sym__automatic_semicolon] = ACTIONS(3313),
    [anon_sym_RBRACE] = ACTIONS(3313),
    [anon_sym_SEMI] = ACTIONS(3313),
    [anon_sym_COMMA] = ACTIONS(3313),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3313),
    [sym_comment] = ACTIONS(3),
  },
  [957] = {
    [sym_call_signature] = STATE(1078),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(3451),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [958] = {
    [sym_string] = STATE(1080),
    [sym__property_name] = STATE(1080),
    [sym_computed_property_name] = STATE(1080),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [959] = {
    [sym_string] = STATE(1080),
    [sym__property_name] = STATE(1080),
    [sym_computed_property_name] = STATE(1080),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(3453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [960] = {
    [sym_string] = STATE(1080),
    [sym__property_name] = STATE(1080),
    [sym_computed_property_name] = STATE(1080),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(3455),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(3457),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(3457),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [961] = {
    [sym_call_signature] = STATE(1078),
    [sym_type_annotation] = STATE(1084),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_QMARK] = ACTIONS(3461),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
  },
  [962] = {
    [sym_call_signature] = STATE(1078),
    [sym_type_annotation] = STATE(1084),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
  },
  [963] = {
    [sym__automatic_semicolon] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_COMMA] = ACTIONS(3459),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
  },
  [964] = {
    [sym__automatic_semicolon] = ACTIONS(3463),
    [anon_sym_RBRACE] = ACTIONS(3463),
    [anon_sym_SEMI] = ACTIONS(3463),
    [anon_sym_COMMA] = ACTIONS(3463),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3463),
    [sym_comment] = ACTIONS(3),
  },
  [965] = {
    [sym_type_annotation] = STATE(1085),
    [sym__automatic_semicolon] = ACTIONS(3463),
    [anon_sym_RBRACE] = ACTIONS(3463),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3463),
    [anon_sym_COMMA] = ACTIONS(3463),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3463),
    [sym_comment] = ACTIONS(3),
  },
  [966] = {
    [sym_string] = STATE(1087),
    [sym__property_name] = STATE(1087),
    [sym_computed_property_name] = STATE(1087),
    [anon_sym_get] = ACTIONS(3465),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(3467),
    [anon_sym_STAR] = ACTIONS(3455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(3465),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(3469),
  },
  [967] = {
    [sym__automatic_semicolon] = ACTIONS(3471),
    [anon_sym_RBRACE] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3471),
    [anon_sym_COMMA] = ACTIONS(3471),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
  },
  [968] = {
    [aux_sym_object_type_repeat1] = STATE(968),
    [sym__automatic_semicolon] = ACTIONS(3473),
    [anon_sym_RBRACE] = ACTIONS(3471),
    [anon_sym_SEMI] = ACTIONS(3473),
    [anon_sym_COMMA] = ACTIONS(3473),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3471),
    [sym_comment] = ACTIONS(3),
  },
  [969] = {
    [anon_sym_BQUOTE] = ACTIONS(3476),
    [anon_sym_symbol] = ACTIONS(3478),
    [anon_sym_PIPE] = ACTIONS(3476),
    [anon_sym_break] = ACTIONS(3478),
    [anon_sym_return] = ACTIONS(3478),
    [anon_sym_RBRACE] = ACTIONS(3476),
    [anon_sym_interface] = ACTIONS(3478),
    [anon_sym_delete] = ACTIONS(3478),
    [anon_sym_if] = ACTIONS(3478),
    [anon_sym_yield] = ACTIONS(3478),
    [sym_true] = ACTIONS(3478),
    [anon_sym_protected] = ACTIONS(3478),
    [anon_sym_set] = ACTIONS(3478),
    [anon_sym_import] = ACTIONS(3478),
    [anon_sym_await] = ACTIONS(3478),
    [anon_sym_DQUOTE] = ACTIONS(3476),
    [anon_sym_for] = ACTIONS(3478),
    [anon_sym_SEMI] = ACTIONS(3476),
    [anon_sym_number] = ACTIONS(3478),
    [anon_sym_typeof] = ACTIONS(3478),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_switch] = ACTIONS(3478),
    [anon_sym_RBRACK] = ACTIONS(3476),
    [sym_null] = ACTIONS(3478),
    [anon_sym_any] = ACTIONS(3478),
    [anon_sym_async] = ACTIONS(3478),
    [anon_sym_public] = ACTIONS(3478),
    [anon_sym_var] = ACTIONS(3478),
    [anon_sym_while] = ACTIONS(3478),
    [anon_sym_SQUOTE] = ACTIONS(3476),
    [anon_sym_RPAREN] = ACTIONS(3476),
    [anon_sym_SLASH] = ACTIONS(3478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3478),
    [anon_sym_new] = ACTIONS(3478),
    [anon_sym_export] = ACTIONS(3478),
    [anon_sym_with] = ACTIONS(3478),
    [sym_identifier] = ACTIONS(3478),
    [anon_sym_debugger] = ACTIONS(3478),
    [anon_sym_AT] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3478),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_void] = ACTIONS(3478),
    [anon_sym_const] = ACTIONS(3478),
    [sym_super] = ACTIONS(3478),
    [anon_sym_private] = ACTIONS(3478),
    [anon_sym_get] = ACTIONS(3478),
    [anon_sym_default] = ACTIONS(3478),
    [anon_sym_enum] = ACTIONS(3478),
    [anon_sym_continue] = ACTIONS(3478),
    [anon_sym_DASH_DASH] = ACTIONS(3476),
    [anon_sym_this] = ACTIONS(3478),
    [anon_sym_throw] = ACTIONS(3478),
    [anon_sym_abstract] = ACTIONS(3478),
    [anon_sym_type] = ACTIONS(3478),
    [anon_sym_namespace] = ACTIONS(3478),
    [anon_sym_PLUS_PLUS] = ACTIONS(3476),
    [anon_sym_else] = ACTIONS(3478),
    [anon_sym_BANG] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [sym_false] = ACTIONS(3478),
    [anon_sym_case] = ACTIONS(3478),
    [anon_sym_module] = ACTIONS(3478),
    [anon_sym_class] = ACTIONS(3478),
    [anon_sym_declare] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_GT] = ACTIONS(3476),
    [anon_sym_boolean] = ACTIONS(3478),
    [anon_sym_EQ_GT] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_try] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(3476),
    [sym_number] = ACTIONS(3476),
    [ts_builtin_sym_end] = ACTIONS(3476),
    [anon_sym_function] = ACTIONS(3478),
    [sym_undefined] = ACTIONS(3478),
    [anon_sym_let] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3478),
    [anon_sym_do] = ACTIONS(3478),
    [anon_sym_TILDE] = ACTIONS(3476),
  },
  [970] = {
    [anon_sym_EQ_GT] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_while] = ACTIONS(3480),
    [anon_sym_RPAREN] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(3480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3482),
    [anon_sym_RBRACK] = ACTIONS(3480),
    [anon_sym_GT] = ACTIONS(3480),
    [anon_sym_else] = ACTIONS(3480),
  },
  [971] = {
    [sym__type] = STATE(1089),
    [sym_constructor_type] = STATE(1089),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1089),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(1089),
    [sym_intersection_type] = STATE(1089),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [972] = {
    [sym_string] = STATE(2292),
    [sym__property_name] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(3484),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(3054),
    [anon_sym_RBRACE] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(3054),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [973] = {
    [sym_string] = STATE(2292),
    [sym__property_name] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(3484),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(3484),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [974] = {
    [sym_type_alias_declaration] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(1763),
    [sym__declaration] = STATE(1271),
    [sym_ambient_declaration] = STATE(1271),
    [sym_import_alias] = STATE(1271),
    [sym_export_statement] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_export_clause] = STATE(1801),
    [sym_lexical_declaration] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_decorator] = STATE(1763),
    [sym_enum_declaration] = STATE(1271),
    [sym_function] = STATE(1271),
    [sym_function_signature] = STATE(1271),
    [sym_variable_declaration] = STATE(1271),
    [sym_abstract_class] = STATE(1271),
    [sym_module] = STATE(1271),
    [sym_interface_declaration] = STATE(1271),
    [sym_class] = STATE(1271),
    [sym__automatic_semicolon] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(2249),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2253),
    [anon_sym_COMMA] = ACTIONS(3484),
    [anon_sym_STAR] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_EQ] = ACTIONS(2257),
    [anon_sym_const] = ACTIONS(2259),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_async] = ACTIONS(2261),
    [anon_sym_RBRACE] = ACTIONS(3484),
    [anon_sym_var] = ACTIONS(2263),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_interface] = ACTIONS(2265),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2269),
    [anon_sym_as] = ACTIONS(2271),
    [anon_sym_LT] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_abstract] = ACTIONS(2275),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(2277),
    [anon_sym_let] = ACTIONS(2279),
    [anon_sym_import] = ACTIONS(2281),
    [anon_sym_export] = ACTIONS(2283),
    [anon_sym_namespace] = ACTIONS(2285),
  },
  [975] = {
    [sym_computed_property_name] = STATE(439),
    [sym__property_name] = STATE(439),
    [sym_decorator] = STATE(2472),
    [sym_method_definition] = STATE(683),
    [sym_string] = STATE(439),
    [sym_accessibility_modifier] = STATE(180),
    [aux_sym_export_statement_repeat1] = STATE(2472),
    [anon_sym_get] = ACTIONS(1080),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [sym_number] = ACTIONS(1082),
    [anon_sym_STAR] = ACTIONS(376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(3068),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
  },
  [976] = {
    [sym_string] = STATE(1090),
    [sym__property_name] = STATE(1090),
    [sym_computed_property_name] = STATE(1090),
    [anon_sym_get] = ACTIONS(3487),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(3489),
    [anon_sym_STAR] = ACTIONS(3491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(3493),
  },
  [977] = {
    [sym_call_signature] = STATE(1915),
    [sym_type_annotation] = STATE(963),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(3006),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3006),
    [anon_sym_QMARK] = ACTIONS(3495),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3006),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3006),
    [sym_comment] = ACTIONS(3),
  },
  [978] = {
    [sym_new_expression] = STATE(693),
    [sym_constructor_type] = STATE(1359),
    [sym_augmented_assignment_expression] = STATE(693),
    [sym_lookup_type] = STATE(1496),
    [sym_unary_expression] = STATE(693),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_regex] = STATE(693),
    [sym_call_signature] = STATE(1740),
    [sym_yield_expression] = STATE(693),
    [sym_as_expression] = STATE(693),
    [sym_internal_module] = STATE(693),
    [sym_arrow_function] = STATE(693),
    [sym__primary_type] = STATE(1496),
    [sym_member_expression] = STATE(1201),
    [sym_mapped_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_string] = STATE(1723),
    [sym_type_parameters] = STATE(1867),
    [sym_array_type] = STATE(1496),
    [sym_object] = STATE(1202),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_generator_function] = STATE(693),
    [sym_subscript_expression] = STATE(1201),
    [sym_type_query] = STATE(1496),
    [sym_ternary_expression] = STATE(693),
    [sym_existential_type] = STATE(1496),
    [sym_template_string] = STATE(693),
    [sym_object_type] = STATE(1496),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(1375),
    [sym_intersection_type] = STATE(1359),
    [sym__type] = STATE(1359),
    [sym_index_type_query] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_update_expression] = STATE(693),
    [sym_meta_property] = STATE(693),
    [sym_function_type] = STATE(1359),
    [sym__expression] = STATE(693),
    [sym_non_null_expression] = STATE(693),
    [sym_nested_identifier] = STATE(2393),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(693),
    [sym_generic_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_this] = STATE(693),
    [sym_tuple_type] = STATE(1496),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(693),
    [sym_call_expression] = STATE(693),
    [sym_type_predicate] = STATE(1496),
    [sym_assignment_expression] = STATE(693),
    [sym__number] = STATE(1488),
    [sym_binary_expression] = STATE(693),
    [sym_type_arguments] = STATE(1205),
    [sym_union_type] = STATE(1359),
    [sym_parenthesized_expression] = STATE(693),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(693),
    [sym_class] = STATE(693),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(3497),
    [sym_false] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(3505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_LBRACE] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_void] = ACTIONS(3511),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_LPAREN] = ACTIONS(3513),
    [sym_null] = ACTIONS(2085),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(3515),
    [sym_number] = ACTIONS(3517),
    [sym_true] = ACTIONS(3499),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(2085),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [979] = {
    [sym_call_signature] = STATE(1915),
    [sym_type_annotation] = STATE(963),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(3006),
    [anon_sym_RBRACE] = ACTIONS(3006),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3006),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3006),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3006),
    [sym_comment] = ACTIONS(3),
  },
  [980] = {
    [sym_string] = STATE(1090),
    [sym__property_name] = STATE(1090),
    [sym_computed_property_name] = STATE(1090),
    [anon_sym_get] = ACTIONS(3487),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(3493),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(3489),
    [anon_sym_STAR] = ACTIONS(3491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(3487),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [sym_readonly] = ACTIONS(3521),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [981] = {
    [anon_sym_BQUOTE] = ACTIONS(3523),
    [anon_sym_symbol] = ACTIONS(3525),
    [anon_sym_PIPE] = ACTIONS(3523),
    [anon_sym_break] = ACTIONS(3525),
    [anon_sym_return] = ACTIONS(3525),
    [anon_sym_RBRACE] = ACTIONS(3523),
    [anon_sym_interface] = ACTIONS(3525),
    [anon_sym_delete] = ACTIONS(3525),
    [anon_sym_if] = ACTIONS(3525),
    [anon_sym_yield] = ACTIONS(3525),
    [sym_true] = ACTIONS(3525),
    [anon_sym_protected] = ACTIONS(3525),
    [anon_sym_set] = ACTIONS(3525),
    [anon_sym_import] = ACTIONS(3525),
    [anon_sym_await] = ACTIONS(3525),
    [anon_sym_DQUOTE] = ACTIONS(3523),
    [anon_sym_for] = ACTIONS(3525),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym_number] = ACTIONS(3525),
    [anon_sym_typeof] = ACTIONS(3525),
    [anon_sym_LBRACE] = ACTIONS(3525),
    [anon_sym_switch] = ACTIONS(3525),
    [anon_sym_RBRACK] = ACTIONS(3523),
    [sym_null] = ACTIONS(3525),
    [anon_sym_any] = ACTIONS(3525),
    [anon_sym_async] = ACTIONS(3525),
    [anon_sym_public] = ACTIONS(3525),
    [anon_sym_var] = ACTIONS(3525),
    [anon_sym_while] = ACTIONS(3525),
    [anon_sym_SQUOTE] = ACTIONS(3523),
    [anon_sym_RPAREN] = ACTIONS(3523),
    [anon_sym_SLASH] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3525),
    [anon_sym_new] = ACTIONS(3525),
    [anon_sym_export] = ACTIONS(3525),
    [anon_sym_with] = ACTIONS(3525),
    [sym_identifier] = ACTIONS(3525),
    [anon_sym_debugger] = ACTIONS(3525),
    [anon_sym_AT] = ACTIONS(3523),
    [anon_sym_COMMA] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_EQ] = ACTIONS(3525),
    [anon_sym_void] = ACTIONS(3525),
    [anon_sym_const] = ACTIONS(3525),
    [sym_super] = ACTIONS(3525),
    [anon_sym_private] = ACTIONS(3525),
    [anon_sym_get] = ACTIONS(3525),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3523),
    [anon_sym_default] = ACTIONS(3525),
    [anon_sym_enum] = ACTIONS(3525),
    [anon_sym_continue] = ACTIONS(3525),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_this] = ACTIONS(3525),
    [anon_sym_throw] = ACTIONS(3525),
    [anon_sym_abstract] = ACTIONS(3525),
    [anon_sym_type] = ACTIONS(3525),
    [anon_sym_namespace] = ACTIONS(3525),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_else] = ACTIONS(3525),
    [anon_sym_BANG] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [sym_false] = ACTIONS(3525),
    [anon_sym_case] = ACTIONS(3525),
    [anon_sym_module] = ACTIONS(3525),
    [anon_sym_class] = ACTIONS(3525),
    [anon_sym_declare] = ACTIONS(3525),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_GT] = ACTIONS(3523),
    [anon_sym_boolean] = ACTIONS(3525),
    [anon_sym_EQ_GT] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_try] = ACTIONS(3525),
    [anon_sym_LT] = ACTIONS(3523),
    [sym_number] = ACTIONS(3523),
    [ts_builtin_sym_end] = ACTIONS(3523),
    [anon_sym_function] = ACTIONS(3525),
    [sym_undefined] = ACTIONS(3525),
    [anon_sym_let] = ACTIONS(3525),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_implements] = ACTIONS(3525),
    [anon_sym_do] = ACTIONS(3525),
    [anon_sym_TILDE] = ACTIONS(3523),
  },
  [982] = {
    [anon_sym_EQ_GT] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_while] = ACTIONS(3527),
    [anon_sym_RPAREN] = ACTIONS(3527),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_RBRACK] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3527),
    [anon_sym_else] = ACTIONS(3527),
  },
  [983] = {
    [anon_sym_BQUOTE] = ACTIONS(3531),
    [anon_sym_symbol] = ACTIONS(3533),
    [anon_sym_PIPE] = ACTIONS(3531),
    [anon_sym_break] = ACTIONS(3533),
    [anon_sym_return] = ACTIONS(3533),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [anon_sym_interface] = ACTIONS(3533),
    [anon_sym_delete] = ACTIONS(3533),
    [anon_sym_if] = ACTIONS(3533),
    [anon_sym_yield] = ACTIONS(3533),
    [sym_true] = ACTIONS(3533),
    [anon_sym_protected] = ACTIONS(3533),
    [anon_sym_set] = ACTIONS(3533),
    [anon_sym_import] = ACTIONS(3533),
    [anon_sym_await] = ACTIONS(3533),
    [anon_sym_DQUOTE] = ACTIONS(3531),
    [anon_sym_for] = ACTIONS(3533),
    [anon_sym_SEMI] = ACTIONS(3531),
    [anon_sym_number] = ACTIONS(3533),
    [anon_sym_typeof] = ACTIONS(3533),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_switch] = ACTIONS(3533),
    [anon_sym_RBRACK] = ACTIONS(3531),
    [sym_null] = ACTIONS(3533),
    [anon_sym_any] = ACTIONS(3533),
    [anon_sym_async] = ACTIONS(3533),
    [anon_sym_public] = ACTIONS(3533),
    [anon_sym_var] = ACTIONS(3533),
    [anon_sym_while] = ACTIONS(3533),
    [anon_sym_SQUOTE] = ACTIONS(3531),
    [anon_sym_RPAREN] = ACTIONS(3531),
    [anon_sym_SLASH] = ACTIONS(3533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3533),
    [anon_sym_new] = ACTIONS(3533),
    [anon_sym_export] = ACTIONS(3533),
    [anon_sym_with] = ACTIONS(3533),
    [sym_identifier] = ACTIONS(3533),
    [anon_sym_debugger] = ACTIONS(3533),
    [anon_sym_AT] = ACTIONS(3531),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_EQ] = ACTIONS(3533),
    [anon_sym_void] = ACTIONS(3533),
    [anon_sym_const] = ACTIONS(3533),
    [sym_super] = ACTIONS(3533),
    [anon_sym_private] = ACTIONS(3533),
    [anon_sym_get] = ACTIONS(3533),
    [anon_sym_default] = ACTIONS(3533),
    [anon_sym_enum] = ACTIONS(3533),
    [anon_sym_continue] = ACTIONS(3533),
    [anon_sym_DASH_DASH] = ACTIONS(3531),
    [anon_sym_this] = ACTIONS(3533),
    [anon_sym_throw] = ACTIONS(3533),
    [anon_sym_abstract] = ACTIONS(3533),
    [anon_sym_type] = ACTIONS(3533),
    [anon_sym_namespace] = ACTIONS(3533),
    [anon_sym_PLUS_PLUS] = ACTIONS(3531),
    [anon_sym_else] = ACTIONS(3533),
    [anon_sym_BANG] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [sym_false] = ACTIONS(3533),
    [anon_sym_case] = ACTIONS(3533),
    [anon_sym_module] = ACTIONS(3533),
    [anon_sym_class] = ACTIONS(3533),
    [anon_sym_declare] = ACTIONS(3533),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3531),
    [anon_sym_boolean] = ACTIONS(3533),
    [anon_sym_EQ_GT] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_try] = ACTIONS(3533),
    [anon_sym_LT] = ACTIONS(3531),
    [sym_number] = ACTIONS(3531),
    [ts_builtin_sym_end] = ACTIONS(3531),
    [anon_sym_function] = ACTIONS(3533),
    [sym_undefined] = ACTIONS(3533),
    [anon_sym_let] = ACTIONS(3533),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_do] = ACTIONS(3533),
    [anon_sym_TILDE] = ACTIONS(3531),
  },
  [984] = {
    [anon_sym_extends] = ACTIONS(3535),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3535),
    [anon_sym_EQ] = ACTIONS(3535),
    [anon_sym_LPAREN] = ACTIONS(3535),
    [anon_sym_implements] = ACTIONS(3535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3537),
  },
  [985] = {
    [sym_type_parameter] = STATE(799),
    [sym_identifier] = ACTIONS(1176),
    [sym_comment] = ACTIONS(3),
  },
  [986] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3539),
    [sym__automatic_semicolon] = ACTIONS(3539),
    [anon_sym_BQUOTE] = ACTIONS(3539),
    [anon_sym_symbol] = ACTIONS(3541),
    [anon_sym_PIPE] = ACTIONS(3541),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_GT_GT_GT] = ACTIONS(3539),
    [anon_sym_break] = ACTIONS(3541),
    [anon_sym_BANG_EQ] = ACTIONS(3541),
    [anon_sym_return] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3541),
    [anon_sym_as] = ACTIONS(3541),
    [anon_sym_delete] = ACTIONS(3541),
    [anon_sym_if] = ACTIONS(3541),
    [anon_sym_instanceof] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3541),
    [sym_true] = ACTIONS(3541),
    [anon_sym_protected] = ACTIONS(3541),
    [anon_sym_DOT] = ACTIONS(3541),
    [anon_sym_set] = ACTIONS(3541),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3539),
    [anon_sym_import] = ACTIONS(3541),
    [anon_sym_await] = ACTIONS(3541),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_for] = ACTIONS(3541),
    [anon_sym_SEMI] = ACTIONS(3539),
    [anon_sym_number] = ACTIONS(3541),
    [anon_sym_typeof] = ACTIONS(3541),
    [anon_sym_LT_LT] = ACTIONS(3539),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_switch] = ACTIONS(3541),
    [anon_sym_LT_EQ] = ACTIONS(3539),
    [sym_null] = ACTIONS(3541),
    [anon_sym_any] = ACTIONS(3541),
    [anon_sym_async] = ACTIONS(3541),
    [anon_sym_public] = ACTIONS(3541),
    [anon_sym_var] = ACTIONS(3541),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3541),
    [anon_sym_SQUOTE] = ACTIONS(3539),
    [anon_sym_SLASH] = ACTIONS(3541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3541),
    [anon_sym_CARET] = ACTIONS(3539),
    [anon_sym_export] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3541),
    [anon_sym_with] = ACTIONS(3541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3539),
    [sym_identifier] = ACTIONS(3541),
    [anon_sym_debugger] = ACTIONS(3541),
    [anon_sym_AT] = ACTIONS(3539),
    [anon_sym_COMMA] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3541),
    [anon_sym_void] = ACTIONS(3541),
    [anon_sym_const] = ACTIONS(3541),
    [anon_sym_GT_EQ] = ACTIONS(3539),
    [sym_super] = ACTIONS(3541),
    [anon_sym_private] = ACTIONS(3541),
    [anon_sym_get] = ACTIONS(3541),
    [anon_sym_default] = ACTIONS(3541),
    [anon_sym_enum] = ACTIONS(3541),
    [anon_sym_continue] = ACTIONS(3541),
    [anon_sym_DASH_DASH] = ACTIONS(3539),
    [anon_sym_this] = ACTIONS(3541),
    [anon_sym_throw] = ACTIONS(3541),
    [anon_sym_abstract] = ACTIONS(3541),
    [anon_sym_type] = ACTIONS(3541),
    [anon_sym_STAR_STAR] = ACTIONS(3539),
    [anon_sym_namespace] = ACTIONS(3541),
    [anon_sym_PLUS_PLUS] = ACTIONS(3539),
    [anon_sym_else] = ACTIONS(3541),
    [anon_sym_BANG] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [sym_false] = ACTIONS(3541),
    [anon_sym_case] = ACTIONS(3541),
    [anon_sym_module] = ACTIONS(3541),
    [anon_sym_class] = ACTIONS(3541),
    [anon_sym_declare] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_GT] = ACTIONS(3541),
    [anon_sym_boolean] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3541),
    [anon_sym_EQ_EQ] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3541),
    [sym_number] = ACTIONS(3539),
    [ts_builtin_sym_end] = ACTIONS(3539),
    [anon_sym_function] = ACTIONS(3541),
    [sym_undefined] = ACTIONS(3541),
    [anon_sym_let] = ACTIONS(3541),
    [anon_sym_PLUS] = ACTIONS(3541),
    [anon_sym_do] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3539),
    [anon_sym_in] = ACTIONS(3541),
  },
  [987] = {
    [sym__initializer] = STATE(1211),
    [sym_type_annotation] = STATE(717),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_AMP_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_EQ] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(3543),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(1088),
    [anon_sym_STAR_EQ] = ACTIONS(1088),
    [anon_sym_PIPE_EQ] = ACTIONS(1088),
    [anon_sym_DASH_EQ] = ACTIONS(1088),
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1088),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(3543),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_SLASH_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(847),
  },
  [988] = {
    [sym_new_expression] = STATE(1093),
    [sym_augmented_assignment_expression] = STATE(1093),
    [sym_unary_expression] = STATE(1093),
    [sym_update_expression] = STATE(1093),
    [sym_regex] = STATE(1093),
    [sym_meta_property] = STATE(1093),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1093),
    [sym_yield_expression] = STATE(1093),
    [sym_as_expression] = STATE(1093),
    [sym_non_null_expression] = STATE(1093),
    [sym_internal_module] = STATE(1093),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1093),
    [sym_await_expression] = STATE(1093),
    [sym_member_expression] = STATE(1201),
    [sym_spread_element] = STATE(372),
    [sym_sequence_expression] = STATE(1365),
    [sym_string] = STATE(1093),
    [sym_this] = STATE(1093),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1093),
    [sym_generator_function] = STATE(1093),
    [sym_call_expression] = STATE(1093),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1093),
    [sym_ternary_expression] = STATE(1093),
    [sym_binary_expression] = STATE(1093),
    [sym_template_string] = STATE(1093),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1093),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1093),
    [sym_class] = STATE(1093),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(266),
    [sym_false] = ACTIONS(3546),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_COMMA] = ACTIONS(833),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3546),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_RPAREN] = ACTIONS(833),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(3548),
    [sym_true] = ACTIONS(3546),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3546),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [989] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2588),
    [sym__automatic_semicolon] = ACTIONS(2588),
    [anon_sym_BQUOTE] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_DASH] = ACTIONS(2590),
    [anon_sym_STAR] = ACTIONS(2590),
    [anon_sym_GT_GT_GT] = ACTIONS(2588),
    [anon_sym_BANG_EQ] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2588),
    [anon_sym_PERCENT] = ACTIONS(2588),
    [anon_sym_as] = ACTIONS(2588),
    [anon_sym_DASH_DASH] = ACTIONS(2588),
    [anon_sym_instanceof] = ACTIONS(2588),
    [anon_sym_DOT] = ACTIONS(2588),
    [anon_sym_STAR_STAR] = ACTIONS(2588),
    [anon_sym_PLUS_PLUS] = ACTIONS(2588),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_SEMI] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_LT_EQ] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2590),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_SLASH] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2590),
    [anon_sym_GT_GT] = ACTIONS(2590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2588),
    [anon_sym_in] = ACTIONS(2590),
  },
  [990] = {
    [sym__automatic_semicolon] = ACTIONS(3550),
    [anon_sym_SEMI] = ACTIONS(3550),
    [anon_sym_from] = ACTIONS(3550),
    [sym_comment] = ACTIONS(3),
  },
  [991] = {
    [anon_sym_COMMA] = ACTIONS(3552),
    [anon_sym_RBRACE] = ACTIONS(3552),
    [sym_comment] = ACTIONS(3),
  },
  [992] = {
    [sym__import_export_specifier] = STATE(991),
    [sym_identifier] = ACTIONS(787),
    [anon_sym_RBRACE] = ACTIONS(3554),
    [anon_sym_typeof] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
  },
  [993] = {
    [aux_sym_export_clause_repeat1] = STATE(993),
    [anon_sym_COMMA] = ACTIONS(3556),
    [anon_sym_RBRACE] = ACTIONS(3559),
    [sym_comment] = ACTIONS(3),
  },
  [994] = {
    [sym_identifier] = ACTIONS(3561),
    [anon_sym_BQUOTE] = ACTIONS(3563),
    [anon_sym_debugger] = ACTIONS(3561),
    [anon_sym_symbol] = ACTIONS(3561),
    [anon_sym_AT] = ACTIONS(3563),
    [anon_sym_DASH] = ACTIONS(3561),
    [anon_sym_void] = ACTIONS(3561),
    [anon_sym_break] = ACTIONS(3561),
    [anon_sym_const] = ACTIONS(3561),
    [sym_super] = ACTIONS(3561),
    [anon_sym_return] = ACTIONS(3561),
    [anon_sym_private] = ACTIONS(3561),
    [anon_sym_get] = ACTIONS(3561),
    [anon_sym_RBRACE] = ACTIONS(3563),
    [anon_sym_interface] = ACTIONS(3561),
    [anon_sym_default] = ACTIONS(3561),
    [anon_sym_enum] = ACTIONS(3561),
    [anon_sym_delete] = ACTIONS(3561),
    [anon_sym_continue] = ACTIONS(3561),
    [anon_sym_DASH_DASH] = ACTIONS(3563),
    [anon_sym_if] = ACTIONS(3561),
    [anon_sym_this] = ACTIONS(3561),
    [anon_sym_yield] = ACTIONS(3561),
    [sym_true] = ACTIONS(3561),
    [anon_sym_throw] = ACTIONS(3561),
    [anon_sym_protected] = ACTIONS(3561),
    [anon_sym_abstract] = ACTIONS(3561),
    [anon_sym_set] = ACTIONS(3561),
    [anon_sym_type] = ACTIONS(3561),
    [anon_sym_import] = ACTIONS(3561),
    [anon_sym_namespace] = ACTIONS(3561),
    [anon_sym_PLUS_PLUS] = ACTIONS(3563),
    [anon_sym_await] = ACTIONS(3561),
    [anon_sym_DQUOTE] = ACTIONS(3563),
    [anon_sym_else] = ACTIONS(3561),
    [anon_sym_BANG] = ACTIONS(3563),
    [anon_sym_for] = ACTIONS(3561),
    [anon_sym_LBRACK] = ACTIONS(3563),
    [sym_false] = ACTIONS(3561),
    [anon_sym_SEMI] = ACTIONS(3563),
    [anon_sym_case] = ACTIONS(3561),
    [anon_sym_module] = ACTIONS(3561),
    [anon_sym_number] = ACTIONS(3561),
    [anon_sym_class] = ACTIONS(3561),
    [anon_sym_declare] = ACTIONS(3561),
    [anon_sym_typeof] = ACTIONS(3561),
    [anon_sym_LBRACE] = ACTIONS(3563),
    [anon_sym_switch] = ACTIONS(3561),
    [anon_sym_LPAREN] = ACTIONS(3563),
    [sym_null] = ACTIONS(3561),
    [anon_sym_any] = ACTIONS(3561),
    [anon_sym_boolean] = ACTIONS(3561),
    [anon_sym_async] = ACTIONS(3561),
    [anon_sym_public] = ACTIONS(3561),
    [anon_sym_var] = ACTIONS(3561),
    [anon_sym_while] = ACTIONS(3561),
    [anon_sym_SQUOTE] = ACTIONS(3563),
    [anon_sym_try] = ACTIONS(3561),
    [anon_sym_LT] = ACTIONS(3563),
    [sym_number] = ACTIONS(3563),
    [anon_sym_SLASH] = ACTIONS(3561),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3561),
    [anon_sym_function] = ACTIONS(3561),
    [sym_undefined] = ACTIONS(3561),
    [anon_sym_new] = ACTIONS(3561),
    [ts_builtin_sym_end] = ACTIONS(3563),
    [anon_sym_let] = ACTIONS(3561),
    [anon_sym_PLUS] = ACTIONS(3561),
    [anon_sym_export] = ACTIONS(3561),
    [anon_sym_do] = ACTIONS(3561),
    [anon_sym_TILDE] = ACTIONS(3563),
    [anon_sym_with] = ACTIONS(3561),
  },
  [995] = {
    [sym_identifier] = ACTIONS(3565),
    [anon_sym_BQUOTE] = ACTIONS(3567),
    [anon_sym_debugger] = ACTIONS(3565),
    [anon_sym_symbol] = ACTIONS(3565),
    [anon_sym_AT] = ACTIONS(3567),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_void] = ACTIONS(3565),
    [anon_sym_break] = ACTIONS(3565),
    [anon_sym_const] = ACTIONS(3565),
    [sym_super] = ACTIONS(3565),
    [anon_sym_return] = ACTIONS(3565),
    [anon_sym_private] = ACTIONS(3565),
    [anon_sym_get] = ACTIONS(3565),
    [anon_sym_RBRACE] = ACTIONS(3567),
    [anon_sym_interface] = ACTIONS(3565),
    [anon_sym_default] = ACTIONS(3565),
    [anon_sym_enum] = ACTIONS(3565),
    [anon_sym_delete] = ACTIONS(3565),
    [anon_sym_continue] = ACTIONS(3565),
    [anon_sym_DASH_DASH] = ACTIONS(3567),
    [anon_sym_if] = ACTIONS(3565),
    [anon_sym_this] = ACTIONS(3565),
    [anon_sym_yield] = ACTIONS(3565),
    [sym_true] = ACTIONS(3565),
    [anon_sym_throw] = ACTIONS(3565),
    [anon_sym_protected] = ACTIONS(3565),
    [anon_sym_abstract] = ACTIONS(3565),
    [anon_sym_set] = ACTIONS(3565),
    [anon_sym_type] = ACTIONS(3565),
    [anon_sym_import] = ACTIONS(3565),
    [anon_sym_namespace] = ACTIONS(3565),
    [anon_sym_PLUS_PLUS] = ACTIONS(3567),
    [anon_sym_await] = ACTIONS(3565),
    [anon_sym_DQUOTE] = ACTIONS(3567),
    [anon_sym_else] = ACTIONS(3565),
    [anon_sym_BANG] = ACTIONS(3567),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_LBRACK] = ACTIONS(3567),
    [sym_false] = ACTIONS(3565),
    [anon_sym_SEMI] = ACTIONS(3567),
    [anon_sym_case] = ACTIONS(3565),
    [anon_sym_module] = ACTIONS(3565),
    [anon_sym_number] = ACTIONS(3565),
    [anon_sym_class] = ACTIONS(3565),
    [anon_sym_declare] = ACTIONS(3565),
    [anon_sym_typeof] = ACTIONS(3565),
    [anon_sym_LBRACE] = ACTIONS(3567),
    [anon_sym_switch] = ACTIONS(3565),
    [anon_sym_LPAREN] = ACTIONS(3567),
    [sym_null] = ACTIONS(3565),
    [anon_sym_any] = ACTIONS(3565),
    [anon_sym_boolean] = ACTIONS(3565),
    [anon_sym_async] = ACTIONS(3565),
    [anon_sym_public] = ACTIONS(3565),
    [anon_sym_var] = ACTIONS(3565),
    [anon_sym_while] = ACTIONS(3565),
    [anon_sym_SQUOTE] = ACTIONS(3567),
    [anon_sym_try] = ACTIONS(3565),
    [anon_sym_LT] = ACTIONS(3567),
    [sym_number] = ACTIONS(3567),
    [anon_sym_SLASH] = ACTIONS(3565),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3565),
    [anon_sym_function] = ACTIONS(3565),
    [sym_undefined] = ACTIONS(3565),
    [anon_sym_new] = ACTIONS(3565),
    [ts_builtin_sym_end] = ACTIONS(3567),
    [anon_sym_let] = ACTIONS(3565),
    [anon_sym_PLUS] = ACTIONS(3565),
    [anon_sym_export] = ACTIONS(3565),
    [anon_sym_do] = ACTIONS(3565),
    [anon_sym_TILDE] = ACTIONS(3567),
    [anon_sym_with] = ACTIONS(3565),
  },
  [996] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(572),
    [sym__automatic_semicolon] = ACTIONS(3569),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_COMMA] = ACTIONS(3569),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(125),
    [anon_sym_GT_EQ] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(3569),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(572),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(3569),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_LT_EQ] = ACTIONS(572),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(125),
    [anon_sym_AMP] = ACTIONS(586),
    [anon_sym_QMARK] = ACTIONS(588),
    [anon_sym_PIPE_PIPE] = ACTIONS(590),
    [anon_sym_EQ_EQ] = ACTIONS(125),
    [anon_sym_RPAREN] = ACTIONS(3569),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(590),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(572),
    [anon_sym_in] = ACTIONS(125),
  },
  [997] = {
    [sym_identifier] = ACTIONS(3571),
    [sym_comment] = ACTIONS(3),
  },
  [998] = {
    [sym_type_annotation] = STATE(562),
    [anon_sym_EQ_GT] = ACTIONS(3573),
    [anon_sym_COLON] = ACTIONS(568),
    [sym_comment] = ACTIONS(3),
  },
  [999] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3576),
    [sym__automatic_semicolon] = ACTIONS(3576),
    [anon_sym_BQUOTE] = ACTIONS(3576),
    [anon_sym_symbol] = ACTIONS(3578),
    [anon_sym_PIPE] = ACTIONS(3578),
    [anon_sym_STAR] = ACTIONS(3578),
    [anon_sym_GT_GT_GT] = ACTIONS(3576),
    [anon_sym_break] = ACTIONS(3578),
    [anon_sym_BANG_EQ] = ACTIONS(3578),
    [anon_sym_return] = ACTIONS(3578),
    [anon_sym_RBRACE] = ACTIONS(3576),
    [anon_sym_PERCENT] = ACTIONS(3576),
    [anon_sym_interface] = ACTIONS(3578),
    [anon_sym_as] = ACTIONS(3578),
    [anon_sym_delete] = ACTIONS(3578),
    [anon_sym_if] = ACTIONS(3578),
    [anon_sym_instanceof] = ACTIONS(3578),
    [anon_sym_yield] = ACTIONS(3578),
    [sym_true] = ACTIONS(3578),
    [anon_sym_protected] = ACTIONS(3578),
    [anon_sym_DOT] = ACTIONS(3578),
    [anon_sym_set] = ACTIONS(3578),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3576),
    [anon_sym_import] = ACTIONS(3578),
    [anon_sym_await] = ACTIONS(3578),
    [anon_sym_DQUOTE] = ACTIONS(3576),
    [anon_sym_for] = ACTIONS(3578),
    [anon_sym_SEMI] = ACTIONS(3576),
    [anon_sym_number] = ACTIONS(3578),
    [anon_sym_typeof] = ACTIONS(3578),
    [anon_sym_LT_LT] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3576),
    [anon_sym_AMP_AMP] = ACTIONS(3576),
    [anon_sym_switch] = ACTIONS(3578),
    [anon_sym_LT_EQ] = ACTIONS(3576),
    [sym_null] = ACTIONS(3578),
    [anon_sym_any] = ACTIONS(3578),
    [anon_sym_async] = ACTIONS(3578),
    [anon_sym_public] = ACTIONS(3578),
    [anon_sym_var] = ACTIONS(3578),
    [anon_sym_QMARK] = ACTIONS(3576),
    [anon_sym_while] = ACTIONS(3578),
    [anon_sym_SQUOTE] = ACTIONS(3576),
    [anon_sym_SLASH] = ACTIONS(3578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3578),
    [anon_sym_new] = ACTIONS(3578),
    [anon_sym_CARET] = ACTIONS(3576),
    [anon_sym_export] = ACTIONS(3578),
    [anon_sym_GT_GT] = ACTIONS(3578),
    [anon_sym_with] = ACTIONS(3578),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3576),
    [sym_identifier] = ACTIONS(3578),
    [anon_sym_debugger] = ACTIONS(3578),
    [anon_sym_AT] = ACTIONS(3576),
    [anon_sym_COMMA] = ACTIONS(3576),
    [anon_sym_DASH] = ACTIONS(3578),
    [anon_sym_void] = ACTIONS(3578),
    [anon_sym_const] = ACTIONS(3578),
    [anon_sym_GT_EQ] = ACTIONS(3576),
    [sym_super] = ACTIONS(3578),
    [anon_sym_private] = ACTIONS(3578),
    [anon_sym_get] = ACTIONS(3578),
    [anon_sym_default] = ACTIONS(3578),
    [anon_sym_enum] = ACTIONS(3578),
    [anon_sym_continue] = ACTIONS(3578),
    [anon_sym_DASH_DASH] = ACTIONS(3576),
    [anon_sym_this] = ACTIONS(3578),
    [anon_sym_throw] = ACTIONS(3578),
    [anon_sym_abstract] = ACTIONS(3578),
    [anon_sym_type] = ACTIONS(3578),
    [anon_sym_STAR_STAR] = ACTIONS(3576),
    [anon_sym_namespace] = ACTIONS(3578),
    [anon_sym_PLUS_PLUS] = ACTIONS(3576),
    [anon_sym_else] = ACTIONS(3578),
    [anon_sym_BANG] = ACTIONS(3578),
    [anon_sym_LBRACK] = ACTIONS(3576),
    [sym_false] = ACTIONS(3578),
    [anon_sym_case] = ACTIONS(3578),
    [anon_sym_module] = ACTIONS(3578),
    [anon_sym_class] = ACTIONS(3578),
    [anon_sym_declare] = ACTIONS(3578),
    [anon_sym_LPAREN] = ACTIONS(3576),
    [anon_sym_GT] = ACTIONS(3578),
    [anon_sym_boolean] = ACTIONS(3578),
    [anon_sym_AMP] = ACTIONS(3578),
    [anon_sym_PIPE_PIPE] = ACTIONS(3576),
    [anon_sym_try] = ACTIONS(3578),
    [anon_sym_EQ_EQ] = ACTIONS(3578),
    [anon_sym_LT] = ACTIONS(3578),
    [sym_number] = ACTIONS(3576),
    [ts_builtin_sym_end] = ACTIONS(3576),
    [anon_sym_function] = ACTIONS(3578),
    [sym_undefined] = ACTIONS(3578),
    [anon_sym_let] = ACTIONS(3578),
    [anon_sym_PLUS] = ACTIONS(3578),
    [anon_sym_do] = ACTIONS(3578),
    [anon_sym_TILDE] = ACTIONS(3576),
    [anon_sym_in] = ACTIONS(3578),
  },
  [1000] = {
    [sym_class_body] = STATE(1097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(917),
  },
  [1001] = {
    [sym_identifier] = ACTIONS(3580),
    [anon_sym_BQUOTE] = ACTIONS(3582),
    [anon_sym_debugger] = ACTIONS(3580),
    [anon_sym_symbol] = ACTIONS(3580),
    [anon_sym_AT] = ACTIONS(3582),
    [anon_sym_DASH] = ACTIONS(3580),
    [anon_sym_void] = ACTIONS(3580),
    [anon_sym_break] = ACTIONS(3580),
    [anon_sym_const] = ACTIONS(3580),
    [sym_super] = ACTIONS(3580),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_private] = ACTIONS(3580),
    [anon_sym_get] = ACTIONS(3580),
    [anon_sym_RBRACE] = ACTIONS(3582),
    [anon_sym_interface] = ACTIONS(3580),
    [anon_sym_default] = ACTIONS(3580),
    [anon_sym_enum] = ACTIONS(3580),
    [anon_sym_delete] = ACTIONS(3580),
    [anon_sym_continue] = ACTIONS(3580),
    [anon_sym_DASH_DASH] = ACTIONS(3582),
    [anon_sym_if] = ACTIONS(3580),
    [anon_sym_this] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3580),
    [sym_true] = ACTIONS(3580),
    [anon_sym_throw] = ACTIONS(3580),
    [anon_sym_protected] = ACTIONS(3580),
    [anon_sym_abstract] = ACTIONS(3580),
    [anon_sym_set] = ACTIONS(3580),
    [anon_sym_type] = ACTIONS(3580),
    [anon_sym_import] = ACTIONS(3580),
    [anon_sym_namespace] = ACTIONS(3580),
    [anon_sym_PLUS_PLUS] = ACTIONS(3582),
    [anon_sym_await] = ACTIONS(3580),
    [anon_sym_DQUOTE] = ACTIONS(3582),
    [anon_sym_else] = ACTIONS(3580),
    [anon_sym_BANG] = ACTIONS(3582),
    [anon_sym_for] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3582),
    [sym_false] = ACTIONS(3580),
    [anon_sym_SEMI] = ACTIONS(3582),
    [anon_sym_case] = ACTIONS(3580),
    [anon_sym_module] = ACTIONS(3580),
    [anon_sym_number] = ACTIONS(3580),
    [anon_sym_class] = ACTIONS(3580),
    [anon_sym_declare] = ACTIONS(3580),
    [anon_sym_typeof] = ACTIONS(3580),
    [anon_sym_LBRACE] = ACTIONS(3582),
    [anon_sym_switch] = ACTIONS(3580),
    [anon_sym_LPAREN] = ACTIONS(3582),
    [sym_null] = ACTIONS(3580),
    [anon_sym_any] = ACTIONS(3580),
    [anon_sym_boolean] = ACTIONS(3580),
    [anon_sym_async] = ACTIONS(3580),
    [anon_sym_public] = ACTIONS(3580),
    [anon_sym_var] = ACTIONS(3580),
    [anon_sym_while] = ACTIONS(3580),
    [anon_sym_SQUOTE] = ACTIONS(3582),
    [anon_sym_try] = ACTIONS(3580),
    [anon_sym_LT] = ACTIONS(3582),
    [sym_number] = ACTIONS(3582),
    [anon_sym_SLASH] = ACTIONS(3580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3580),
    [anon_sym_function] = ACTIONS(3580),
    [sym_undefined] = ACTIONS(3580),
    [anon_sym_new] = ACTIONS(3580),
    [ts_builtin_sym_end] = ACTIONS(3582),
    [anon_sym_let] = ACTIONS(3580),
    [anon_sym_PLUS] = ACTIONS(3580),
    [anon_sym_export] = ACTIONS(3580),
    [anon_sym_do] = ACTIONS(3580),
    [anon_sym_TILDE] = ACTIONS(3582),
    [anon_sym_with] = ACTIONS(3580),
  },
  [1002] = {
    [anon_sym_COMMA] = ACTIONS(3584),
    [anon_sym_RBRACE] = ACTIONS(3584),
    [sym_comment] = ACTIONS(3),
  },
  [1003] = {
    [sym__property_name] = STATE(606),
    [sym_computed_property_name] = STATE(606),
    [sym__enum_member] = STATE(1002),
    [sym_string] = STATE(606),
    [sym_enum_assignment] = STATE(1002),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(3586),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [sym_number] = ACTIONS(1773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [1004] = {
    [aux_sym_enum_body_repeat1] = STATE(1004),
    [anon_sym_COMMA] = ACTIONS(3588),
    [anon_sym_RBRACE] = ACTIONS(3584),
    [sym_comment] = ACTIONS(3),
  },
  [1005] = {
    [sym_identifier] = ACTIONS(3591),
    [anon_sym_BQUOTE] = ACTIONS(3593),
    [anon_sym_debugger] = ACTIONS(3591),
    [anon_sym_symbol] = ACTIONS(3591),
    [anon_sym_AT] = ACTIONS(3593),
    [anon_sym_DASH] = ACTIONS(3591),
    [anon_sym_void] = ACTIONS(3591),
    [anon_sym_break] = ACTIONS(3591),
    [anon_sym_const] = ACTIONS(3591),
    [sym_super] = ACTIONS(3591),
    [anon_sym_return] = ACTIONS(3591),
    [anon_sym_private] = ACTIONS(3591),
    [anon_sym_get] = ACTIONS(3591),
    [anon_sym_RBRACE] = ACTIONS(3593),
    [anon_sym_interface] = ACTIONS(3591),
    [anon_sym_default] = ACTIONS(3591),
    [anon_sym_enum] = ACTIONS(3591),
    [anon_sym_delete] = ACTIONS(3591),
    [anon_sym_continue] = ACTIONS(3591),
    [anon_sym_DASH_DASH] = ACTIONS(3593),
    [anon_sym_if] = ACTIONS(3591),
    [anon_sym_this] = ACTIONS(3591),
    [anon_sym_yield] = ACTIONS(3591),
    [sym_true] = ACTIONS(3591),
    [anon_sym_throw] = ACTIONS(3591),
    [anon_sym_protected] = ACTIONS(3591),
    [anon_sym_abstract] = ACTIONS(3591),
    [anon_sym_set] = ACTIONS(3591),
    [anon_sym_type] = ACTIONS(3591),
    [anon_sym_import] = ACTIONS(3591),
    [anon_sym_namespace] = ACTIONS(3591),
    [anon_sym_PLUS_PLUS] = ACTIONS(3593),
    [anon_sym_await] = ACTIONS(3591),
    [anon_sym_DQUOTE] = ACTIONS(3593),
    [anon_sym_else] = ACTIONS(3591),
    [anon_sym_BANG] = ACTIONS(3593),
    [anon_sym_for] = ACTIONS(3591),
    [anon_sym_LBRACK] = ACTIONS(3593),
    [sym_false] = ACTIONS(3591),
    [anon_sym_SEMI] = ACTIONS(3593),
    [anon_sym_case] = ACTIONS(3591),
    [anon_sym_module] = ACTIONS(3591),
    [anon_sym_number] = ACTIONS(3591),
    [anon_sym_class] = ACTIONS(3591),
    [anon_sym_declare] = ACTIONS(3591),
    [anon_sym_typeof] = ACTIONS(3591),
    [anon_sym_LBRACE] = ACTIONS(3593),
    [anon_sym_switch] = ACTIONS(3591),
    [anon_sym_LPAREN] = ACTIONS(3593),
    [sym_null] = ACTIONS(3591),
    [anon_sym_any] = ACTIONS(3591),
    [anon_sym_boolean] = ACTIONS(3591),
    [anon_sym_async] = ACTIONS(3591),
    [anon_sym_public] = ACTIONS(3591),
    [anon_sym_var] = ACTIONS(3591),
    [anon_sym_while] = ACTIONS(3591),
    [anon_sym_SQUOTE] = ACTIONS(3593),
    [anon_sym_try] = ACTIONS(3591),
    [anon_sym_LT] = ACTIONS(3593),
    [sym_number] = ACTIONS(3593),
    [anon_sym_SLASH] = ACTIONS(3591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3591),
    [anon_sym_function] = ACTIONS(3591),
    [sym_undefined] = ACTIONS(3591),
    [anon_sym_new] = ACTIONS(3591),
    [ts_builtin_sym_end] = ACTIONS(3593),
    [anon_sym_let] = ACTIONS(3591),
    [anon_sym_PLUS] = ACTIONS(3591),
    [anon_sym_export] = ACTIONS(3591),
    [anon_sym_do] = ACTIONS(3591),
    [anon_sym_TILDE] = ACTIONS(3593),
    [anon_sym_with] = ACTIONS(3591),
  },
  [1006] = {
    [sym_identifier] = ACTIONS(3595),
    [anon_sym_BQUOTE] = ACTIONS(3597),
    [anon_sym_debugger] = ACTIONS(3595),
    [anon_sym_symbol] = ACTIONS(3595),
    [anon_sym_AT] = ACTIONS(3597),
    [anon_sym_DASH] = ACTIONS(3595),
    [anon_sym_void] = ACTIONS(3595),
    [anon_sym_break] = ACTIONS(3595),
    [anon_sym_const] = ACTIONS(3595),
    [sym_super] = ACTIONS(3595),
    [anon_sym_return] = ACTIONS(3595),
    [anon_sym_private] = ACTIONS(3595),
    [anon_sym_get] = ACTIONS(3595),
    [anon_sym_RBRACE] = ACTIONS(3597),
    [anon_sym_interface] = ACTIONS(3595),
    [anon_sym_default] = ACTIONS(3595),
    [anon_sym_enum] = ACTIONS(3595),
    [anon_sym_delete] = ACTIONS(3595),
    [anon_sym_continue] = ACTIONS(3595),
    [anon_sym_DASH_DASH] = ACTIONS(3597),
    [anon_sym_if] = ACTIONS(3595),
    [anon_sym_this] = ACTIONS(3595),
    [anon_sym_yield] = ACTIONS(3595),
    [sym_true] = ACTIONS(3595),
    [anon_sym_throw] = ACTIONS(3595),
    [anon_sym_protected] = ACTIONS(3595),
    [anon_sym_abstract] = ACTIONS(3595),
    [anon_sym_set] = ACTIONS(3595),
    [anon_sym_type] = ACTIONS(3595),
    [anon_sym_import] = ACTIONS(3595),
    [anon_sym_namespace] = ACTIONS(3595),
    [anon_sym_PLUS_PLUS] = ACTIONS(3597),
    [anon_sym_await] = ACTIONS(3595),
    [anon_sym_DQUOTE] = ACTIONS(3597),
    [anon_sym_else] = ACTIONS(3595),
    [anon_sym_BANG] = ACTIONS(3597),
    [anon_sym_for] = ACTIONS(3595),
    [anon_sym_LBRACK] = ACTIONS(3597),
    [sym_false] = ACTIONS(3595),
    [anon_sym_SEMI] = ACTIONS(3597),
    [anon_sym_case] = ACTIONS(3595),
    [anon_sym_module] = ACTIONS(3595),
    [anon_sym_number] = ACTIONS(3595),
    [anon_sym_class] = ACTIONS(3595),
    [anon_sym_declare] = ACTIONS(3595),
    [anon_sym_typeof] = ACTIONS(3595),
    [anon_sym_LBRACE] = ACTIONS(3597),
    [anon_sym_switch] = ACTIONS(3595),
    [anon_sym_LPAREN] = ACTIONS(3597),
    [sym_null] = ACTIONS(3595),
    [anon_sym_any] = ACTIONS(3595),
    [anon_sym_boolean] = ACTIONS(3595),
    [anon_sym_async] = ACTIONS(3595),
    [anon_sym_public] = ACTIONS(3595),
    [anon_sym_var] = ACTIONS(3595),
    [anon_sym_while] = ACTIONS(3595),
    [anon_sym_SQUOTE] = ACTIONS(3597),
    [anon_sym_try] = ACTIONS(3595),
    [anon_sym_LT] = ACTIONS(3597),
    [sym_number] = ACTIONS(3597),
    [anon_sym_SLASH] = ACTIONS(3595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3595),
    [anon_sym_function] = ACTIONS(3595),
    [sym_undefined] = ACTIONS(3595),
    [anon_sym_new] = ACTIONS(3595),
    [ts_builtin_sym_end] = ACTIONS(3597),
    [anon_sym_let] = ACTIONS(3595),
    [anon_sym_PLUS] = ACTIONS(3595),
    [anon_sym_export] = ACTIONS(3595),
    [anon_sym_do] = ACTIONS(3595),
    [anon_sym_TILDE] = ACTIONS(3597),
    [anon_sym_with] = ACTIONS(3595),
  },
  [1007] = {
    [anon_sym_RPAREN] = ACTIONS(3599),
    [sym_comment] = ACTIONS(3),
  },
  [1008] = {
    [anon_sym_COMMA] = ACTIONS(3601),
    [anon_sym_RBRACE] = ACTIONS(3601),
    [sym_comment] = ACTIONS(3),
  },
  [1009] = {
    [anon_sym_from] = ACTIONS(3603),
    [sym_comment] = ACTIONS(3),
  },
  [1010] = {
    [sym__import_export_specifier] = STATE(851),
    [sym_identifier] = ACTIONS(787),
    [anon_sym_typeof] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
  },
  [1011] = {
    [sym_new_expression] = STATE(1101),
    [sym_augmented_assignment_expression] = STATE(1101),
    [sym_unary_expression] = STATE(1101),
    [sym_update_expression] = STATE(1101),
    [sym_regex] = STATE(1101),
    [sym_meta_property] = STATE(1101),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1101),
    [sym_yield_expression] = STATE(1101),
    [sym_as_expression] = STATE(1101),
    [sym_non_null_expression] = STATE(1101),
    [sym_internal_module] = STATE(1101),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1101),
    [sym_await_expression] = STATE(1101),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1101),
    [sym_this] = STATE(1101),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1101),
    [sym_generator_function] = STATE(1101),
    [sym_call_expression] = STATE(1101),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1101),
    [sym_ternary_expression] = STATE(1101),
    [sym_binary_expression] = STATE(1101),
    [sym_template_string] = STATE(1101),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1101),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1101),
    [sym_class] = STATE(1101),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(3605),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3605),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3605),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3607),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3605),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [1012] = {
    [sym_new_expression] = STATE(1102),
    [sym_augmented_assignment_expression] = STATE(1102),
    [sym_unary_expression] = STATE(1102),
    [sym_update_expression] = STATE(1102),
    [sym_regex] = STATE(1102),
    [sym_meta_property] = STATE(1102),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1102),
    [sym_yield_expression] = STATE(1102),
    [sym_as_expression] = STATE(1102),
    [sym_non_null_expression] = STATE(1102),
    [sym_internal_module] = STATE(1102),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1102),
    [sym_await_expression] = STATE(1102),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1102),
    [sym_this] = STATE(1102),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1102),
    [sym_generator_function] = STATE(1102),
    [sym_call_expression] = STATE(1102),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1102),
    [sym_ternary_expression] = STATE(1102),
    [sym_binary_expression] = STATE(1102),
    [sym_template_string] = STATE(1102),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1102),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1102),
    [sym_class] = STATE(1102),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(3609),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3609),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3609),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3611),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3609),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [1013] = {
    [sym_new_expression] = STATE(1103),
    [sym_augmented_assignment_expression] = STATE(1103),
    [sym_unary_expression] = STATE(1103),
    [sym_update_expression] = STATE(1103),
    [sym_regex] = STATE(1103),
    [sym_meta_property] = STATE(1103),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1103),
    [sym_yield_expression] = STATE(1103),
    [sym_as_expression] = STATE(1103),
    [sym_non_null_expression] = STATE(1103),
    [sym_internal_module] = STATE(1103),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1103),
    [sym_await_expression] = STATE(1103),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1103),
    [sym_this] = STATE(1103),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1103),
    [sym_generator_function] = STATE(1103),
    [sym_call_expression] = STATE(1103),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1103),
    [sym_ternary_expression] = STATE(1103),
    [sym_binary_expression] = STATE(1103),
    [sym_template_string] = STATE(1103),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1103),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1103),
    [sym_class] = STATE(1103),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(3613),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3613),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3613),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3615),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3613),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [1014] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(3617),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1015] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(3619),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1016] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(3621),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1017] = {
    [sym_type_alias_declaration] = STATE(1107),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1107),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1107),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1107),
    [sym_return_statement] = STATE(1107),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1107),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1107),
    [sym_switch_statement] = STATE(1107),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1107),
    [sym_throw_statement] = STATE(1107),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1107),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1107),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1107),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1107),
    [sym_abstract_class] = STATE(1107),
    [sym_interface_declaration] = STATE(1107),
    [sym_statement_block] = STATE(1107),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1107),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1107),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1107),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1107),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1107),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1107),
    [sym_empty_statement] = STATE(1107),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1107),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1107),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1107),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1107),
    [sym_break_statement] = STATE(1107),
    [sym_labeled_statement] = STATE(1107),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1107),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1018] = {
    [sym_type_alias_declaration] = STATE(1108),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1108),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1108),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1108),
    [sym_return_statement] = STATE(1108),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1108),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1108),
    [sym_switch_statement] = STATE(1108),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1108),
    [sym_throw_statement] = STATE(1108),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1108),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1108),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1108),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1108),
    [sym_abstract_class] = STATE(1108),
    [sym_interface_declaration] = STATE(1108),
    [sym_statement_block] = STATE(1108),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1108),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1108),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1108),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1108),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1108),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1108),
    [sym_empty_statement] = STATE(1108),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1108),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1108),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1108),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1108),
    [sym_break_statement] = STATE(1108),
    [sym_labeled_statement] = STATE(1108),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1108),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1019] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(3623),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1020] = {
    [anon_sym_RPAREN] = ACTIONS(3623),
    [sym_comment] = ACTIONS(3),
  },
  [1021] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(3625),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1022] = {
    [anon_sym_RPAREN] = ACTIONS(3625),
    [sym_comment] = ACTIONS(3),
  },
  [1023] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(3627),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1024] = {
    [anon_sym_RPAREN] = ACTIONS(3627),
    [sym_comment] = ACTIONS(3),
  },
  [1025] = {
    [sym_identifier] = ACTIONS(3629),
    [anon_sym_BQUOTE] = ACTIONS(3631),
    [anon_sym_debugger] = ACTIONS(3629),
    [anon_sym_symbol] = ACTIONS(3629),
    [anon_sym_AT] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3629),
    [anon_sym_void] = ACTIONS(3629),
    [anon_sym_break] = ACTIONS(3629),
    [anon_sym_const] = ACTIONS(3629),
    [sym_super] = ACTIONS(3629),
    [anon_sym_return] = ACTIONS(3629),
    [anon_sym_private] = ACTIONS(3629),
    [anon_sym_get] = ACTIONS(3629),
    [anon_sym_RBRACE] = ACTIONS(3631),
    [anon_sym_interface] = ACTIONS(3629),
    [anon_sym_default] = ACTIONS(3629),
    [anon_sym_enum] = ACTIONS(3629),
    [anon_sym_delete] = ACTIONS(3629),
    [anon_sym_continue] = ACTIONS(3629),
    [anon_sym_DASH_DASH] = ACTIONS(3631),
    [anon_sym_if] = ACTIONS(3629),
    [anon_sym_this] = ACTIONS(3629),
    [anon_sym_yield] = ACTIONS(3629),
    [sym_true] = ACTIONS(3629),
    [anon_sym_throw] = ACTIONS(3629),
    [anon_sym_protected] = ACTIONS(3629),
    [anon_sym_abstract] = ACTIONS(3629),
    [anon_sym_set] = ACTIONS(3629),
    [anon_sym_type] = ACTIONS(3629),
    [anon_sym_import] = ACTIONS(3629),
    [anon_sym_namespace] = ACTIONS(3629),
    [anon_sym_PLUS_PLUS] = ACTIONS(3631),
    [anon_sym_await] = ACTIONS(3629),
    [anon_sym_DQUOTE] = ACTIONS(3631),
    [anon_sym_else] = ACTIONS(3629),
    [anon_sym_BANG] = ACTIONS(3631),
    [anon_sym_for] = ACTIONS(3629),
    [anon_sym_LBRACK] = ACTIONS(3631),
    [sym_false] = ACTIONS(3629),
    [anon_sym_SEMI] = ACTIONS(3631),
    [anon_sym_case] = ACTIONS(3629),
    [anon_sym_module] = ACTIONS(3629),
    [anon_sym_number] = ACTIONS(3629),
    [anon_sym_class] = ACTIONS(3629),
    [anon_sym_declare] = ACTIONS(3629),
    [anon_sym_typeof] = ACTIONS(3629),
    [anon_sym_LBRACE] = ACTIONS(3631),
    [anon_sym_switch] = ACTIONS(3629),
    [anon_sym_LPAREN] = ACTIONS(3631),
    [sym_null] = ACTIONS(3629),
    [anon_sym_any] = ACTIONS(3629),
    [anon_sym_boolean] = ACTIONS(3629),
    [anon_sym_async] = ACTIONS(3629),
    [anon_sym_public] = ACTIONS(3629),
    [anon_sym_var] = ACTIONS(3629),
    [anon_sym_while] = ACTIONS(3629),
    [anon_sym_SQUOTE] = ACTIONS(3631),
    [anon_sym_try] = ACTIONS(3629),
    [anon_sym_LT] = ACTIONS(3631),
    [sym_number] = ACTIONS(3631),
    [anon_sym_SLASH] = ACTIONS(3629),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3629),
    [anon_sym_function] = ACTIONS(3629),
    [sym_undefined] = ACTIONS(3629),
    [anon_sym_new] = ACTIONS(3629),
    [ts_builtin_sym_end] = ACTIONS(3631),
    [anon_sym_let] = ACTIONS(3629),
    [anon_sym_PLUS] = ACTIONS(3629),
    [anon_sym_export] = ACTIONS(3629),
    [anon_sym_do] = ACTIONS(3629),
    [anon_sym_TILDE] = ACTIONS(3631),
    [anon_sym_with] = ACTIONS(3629),
  },
  [1026] = {
    [sym_type_alias_declaration] = STATE(1112),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1112),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1112),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1112),
    [sym_return_statement] = STATE(1112),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1112),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1112),
    [sym_switch_statement] = STATE(1112),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1112),
    [sym_throw_statement] = STATE(1112),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1112),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1112),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1112),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1112),
    [sym_abstract_class] = STATE(1112),
    [sym_interface_declaration] = STATE(1112),
    [sym_statement_block] = STATE(1112),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1112),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1112),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1112),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1112),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1112),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1112),
    [sym_empty_statement] = STATE(1112),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1112),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1112),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1112),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1112),
    [sym_break_statement] = STATE(1112),
    [sym_labeled_statement] = STATE(1112),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1112),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1027] = {
    [sym_type_alias_declaration] = STATE(1113),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1113),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1113),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1113),
    [sym_return_statement] = STATE(1113),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1113),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1113),
    [sym_switch_statement] = STATE(1113),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1113),
    [sym_throw_statement] = STATE(1113),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1113),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1113),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1113),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1113),
    [sym_abstract_class] = STATE(1113),
    [sym_interface_declaration] = STATE(1113),
    [sym_statement_block] = STATE(1113),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1113),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1113),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1113),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1113),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1113),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1113),
    [sym_empty_statement] = STATE(1113),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1113),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1113),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1113),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1113),
    [sym_break_statement] = STATE(1113),
    [sym_labeled_statement] = STATE(1113),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1113),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1028] = {
    [sym_type_alias_declaration] = STATE(1114),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1114),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1114),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1114),
    [sym_return_statement] = STATE(1114),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1114),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1114),
    [sym_switch_statement] = STATE(1114),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1114),
    [sym_throw_statement] = STATE(1114),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1114),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1114),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1114),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1114),
    [sym_abstract_class] = STATE(1114),
    [sym_interface_declaration] = STATE(1114),
    [sym_statement_block] = STATE(1114),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1114),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1114),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1114),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1114),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1114),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1114),
    [sym_empty_statement] = STATE(1114),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1114),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1114),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1114),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1114),
    [sym_break_statement] = STATE(1114),
    [sym_labeled_statement] = STATE(1114),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1114),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1029] = {
    [sym_type_alias_declaration] = STATE(1115),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1115),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1115),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1115),
    [sym_return_statement] = STATE(1115),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1115),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1115),
    [sym_switch_statement] = STATE(1115),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1115),
    [sym_throw_statement] = STATE(1115),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1115),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1115),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1115),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1115),
    [sym_abstract_class] = STATE(1115),
    [sym_interface_declaration] = STATE(1115),
    [sym_statement_block] = STATE(1115),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1115),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1115),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1115),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1115),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1115),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1115),
    [sym_empty_statement] = STATE(1115),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1115),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1115),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1115),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1115),
    [sym_break_statement] = STATE(1115),
    [sym_labeled_statement] = STATE(1115),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1115),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1030] = {
    [sym_type_alias_declaration] = STATE(1116),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1116),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1116),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1116),
    [sym_return_statement] = STATE(1116),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1116),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1116),
    [sym_switch_statement] = STATE(1116),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1116),
    [sym_throw_statement] = STATE(1116),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1116),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1116),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1116),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1116),
    [sym_abstract_class] = STATE(1116),
    [sym_interface_declaration] = STATE(1116),
    [sym_statement_block] = STATE(1116),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1116),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1116),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1116),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1116),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1116),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1116),
    [sym_empty_statement] = STATE(1116),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1116),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1116),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1116),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1116),
    [sym_break_statement] = STATE(1116),
    [sym_labeled_statement] = STATE(1116),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1116),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1031] = {
    [anon_sym_RBRACK] = ACTIONS(3633),
    [sym_comment] = ACTIONS(3),
  },
  [1032] = {
    [anon_sym_RBRACK] = ACTIONS(3635),
    [sym_comment] = ACTIONS(3),
  },
  [1033] = {
    [sym__automatic_semicolon] = ACTIONS(3637),
    [anon_sym_RBRACE] = ACTIONS(3637),
    [anon_sym_SEMI] = ACTIONS(3637),
    [anon_sym_COMMA] = ACTIONS(3637),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3637),
  },
  [1034] = {
    [sym_statement_block] = STATE(1469),
    [sym__automatic_semicolon] = ACTIONS(3639),
    [anon_sym_SEMI] = ACTIONS(3639),
    [anon_sym_COMMA] = ACTIONS(3639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2772),
  },
  [1035] = {
    [sym_call_signature] = STATE(1119),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [1036] = {
    [sym_call_signature] = STATE(1119),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(3641),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [1037] = {
    [sym_string] = STATE(1121),
    [sym__property_name] = STATE(1121),
    [sym_computed_property_name] = STATE(1121),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1038] = {
    [sym_string] = STATE(1121),
    [sym__property_name] = STATE(1121),
    [sym_computed_property_name] = STATE(1121),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(3643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1039] = {
    [sym_call_signature] = STATE(1119),
    [sym__initializer] = STATE(1122),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym_type_annotation] = STATE(1123),
    [sym__automatic_semicolon] = ACTIONS(3645),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
  },
  [1040] = {
    [sym__initializer] = STATE(1122),
    [sym_type_annotation] = STATE(1123),
    [sym__automatic_semicolon] = ACTIONS(3645),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_COMMA] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
  },
  [1041] = {
    [sym__automatic_semicolon] = ACTIONS(3645),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_COMMA] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
  },
  [1042] = {
    [sym__initializer] = STATE(1122),
    [sym__automatic_semicolon] = ACTIONS(3645),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_COMMA] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
  },
  [1043] = {
    [sym_call_signature] = STATE(1124),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [1044] = {
    [sym__automatic_semicolon] = ACTIONS(3647),
    [anon_sym_SEMI] = ACTIONS(3647),
    [anon_sym_COMMA] = ACTIONS(3647),
    [sym_comment] = ACTIONS(3),
  },
  [1045] = {
    [sym_string] = STATE(1121),
    [sym__property_name] = STATE(1121),
    [sym_computed_property_name] = STATE(1121),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(3649),
    [anon_sym_EQ] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(3651),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(3651),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_BANG] = ACTIONS(986),
  },
  [1046] = {
    [sym_call_signature] = STATE(1119),
    [sym__initializer] = STATE(1122),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym_type_annotation] = STATE(1123),
    [sym__automatic_semicolon] = ACTIONS(3645),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_QMARK] = ACTIONS(3653),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3655),
  },
  [1047] = {
    [sym__initializer] = STATE(1122),
    [sym_type_annotation] = STATE(1123),
    [sym__automatic_semicolon] = ACTIONS(3645),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_QMARK] = ACTIONS(3655),
    [anon_sym_COMMA] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3655),
  },
  [1048] = {
    [sym_call_signature] = STATE(1124),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(3657),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [1049] = {
    [sym_call_signature] = STATE(1124),
    [sym__initializer] = STATE(1122),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym_type_annotation] = STATE(1123),
    [sym__automatic_semicolon] = ACTIONS(3645),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3645),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3645),
    [sym_comment] = ACTIONS(3),
  },
  [1050] = {
    [sym_identifier] = ACTIONS(3659),
    [anon_sym_BQUOTE] = ACTIONS(3661),
    [anon_sym_debugger] = ACTIONS(3659),
    [anon_sym_symbol] = ACTIONS(3659),
    [anon_sym_AT] = ACTIONS(3661),
    [anon_sym_PIPE] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(3659),
    [anon_sym_void] = ACTIONS(3659),
    [anon_sym_break] = ACTIONS(3659),
    [anon_sym_const] = ACTIONS(3659),
    [sym_super] = ACTIONS(3659),
    [anon_sym_return] = ACTIONS(3659),
    [anon_sym_private] = ACTIONS(3659),
    [anon_sym_get] = ACTIONS(3659),
    [anon_sym_RBRACE] = ACTIONS(3661),
    [anon_sym_interface] = ACTIONS(3659),
    [anon_sym_default] = ACTIONS(3659),
    [anon_sym_enum] = ACTIONS(3659),
    [anon_sym_delete] = ACTIONS(3659),
    [anon_sym_continue] = ACTIONS(3659),
    [anon_sym_DASH_DASH] = ACTIONS(3661),
    [anon_sym_if] = ACTIONS(3659),
    [anon_sym_this] = ACTIONS(3659),
    [anon_sym_yield] = ACTIONS(3659),
    [sym_true] = ACTIONS(3659),
    [anon_sym_throw] = ACTIONS(3659),
    [anon_sym_protected] = ACTIONS(3659),
    [anon_sym_abstract] = ACTIONS(3659),
    [anon_sym_set] = ACTIONS(3659),
    [anon_sym_type] = ACTIONS(3659),
    [anon_sym_import] = ACTIONS(3659),
    [anon_sym_namespace] = ACTIONS(3659),
    [anon_sym_PLUS_PLUS] = ACTIONS(3661),
    [anon_sym_await] = ACTIONS(3659),
    [anon_sym_DQUOTE] = ACTIONS(3661),
    [anon_sym_else] = ACTIONS(3659),
    [anon_sym_BANG] = ACTIONS(3661),
    [anon_sym_for] = ACTIONS(3659),
    [anon_sym_LBRACK] = ACTIONS(3661),
    [sym_false] = ACTIONS(3659),
    [anon_sym_SEMI] = ACTIONS(3661),
    [anon_sym_case] = ACTIONS(3659),
    [anon_sym_module] = ACTIONS(3659),
    [anon_sym_number] = ACTIONS(3659),
    [anon_sym_class] = ACTIONS(3659),
    [anon_sym_declare] = ACTIONS(3659),
    [anon_sym_typeof] = ACTIONS(3659),
    [anon_sym_LBRACE] = ACTIONS(3661),
    [anon_sym_switch] = ACTIONS(3659),
    [anon_sym_LPAREN] = ACTIONS(3661),
    [sym_null] = ACTIONS(3659),
    [anon_sym_any] = ACTIONS(3659),
    [anon_sym_boolean] = ACTIONS(3659),
    [anon_sym_async] = ACTIONS(3659),
    [anon_sym_public] = ACTIONS(3659),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_var] = ACTIONS(3659),
    [anon_sym_while] = ACTIONS(3659),
    [anon_sym_SQUOTE] = ACTIONS(3661),
    [anon_sym_try] = ACTIONS(3659),
    [anon_sym_LT] = ACTIONS(3661),
    [sym_number] = ACTIONS(3661),
    [anon_sym_SLASH] = ACTIONS(3659),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3659),
    [anon_sym_function] = ACTIONS(3659),
    [sym_undefined] = ACTIONS(3659),
    [anon_sym_new] = ACTIONS(3659),
    [ts_builtin_sym_end] = ACTIONS(3661),
    [anon_sym_let] = ACTIONS(3659),
    [anon_sym_PLUS] = ACTIONS(3659),
    [anon_sym_export] = ACTIONS(3659),
    [anon_sym_do] = ACTIONS(3659),
    [anon_sym_TILDE] = ACTIONS(3661),
    [anon_sym_with] = ACTIONS(3659),
  },
  [1051] = {
    [anon_sym_COMMA] = ACTIONS(3667),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [sym_comment] = ACTIONS(3),
  },
  [1052] = {
    [sym_statement_block] = STATE(1130),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [1053] = {
    [sym_call_signature] = STATE(1131),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [1054] = {
    [sym_call_signature] = STATE(1131),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(3669),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [1055] = {
    [sym_string] = STATE(1133),
    [sym__property_name] = STATE(1133),
    [sym_computed_property_name] = STATE(1133),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1056] = {
    [sym_string] = STATE(1133),
    [sym__property_name] = STATE(1133),
    [sym_computed_property_name] = STATE(1133),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(3671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1057] = {
    [sym_type_alias_declaration] = STATE(1134),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1134),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1134),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1134),
    [sym_return_statement] = STATE(1134),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1134),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1134),
    [sym_switch_statement] = STATE(1134),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1134),
    [sym_throw_statement] = STATE(1134),
    [aux_sym_program_repeat1] = STATE(1134),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1134),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1134),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1134),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1134),
    [sym_abstract_class] = STATE(1134),
    [sym_interface_declaration] = STATE(1134),
    [sym_statement_block] = STATE(1134),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1134),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1134),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1134),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1134),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1134),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1134),
    [sym_empty_statement] = STATE(1134),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1134),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1134),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1134),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1134),
    [sym_break_statement] = STATE(1134),
    [sym_labeled_statement] = STATE(1134),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1134),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(3673),
    [anon_sym_default] = ACTIONS(3675),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(3675),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1058] = {
    [sym_type_alias_declaration] = STATE(266),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(266),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(266),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(266),
    [sym_return_statement] = STATE(266),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(266),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(266),
    [sym_switch_statement] = STATE(266),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(266),
    [sym_throw_statement] = STATE(266),
    [aux_sym_program_repeat1] = STATE(266),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(266),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(266),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(266),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(266),
    [sym_abstract_class] = STATE(266),
    [sym_interface_declaration] = STATE(266),
    [sym_statement_block] = STATE(266),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(266),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(266),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(266),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(266),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(266),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(266),
    [sym_empty_statement] = STATE(266),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(266),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(266),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(266),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(266),
    [sym_break_statement] = STATE(266),
    [sym_labeled_statement] = STATE(266),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(266),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(3677),
    [anon_sym_default] = ACTIONS(3679),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(3679),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1059] = {
    [anon_sym_COMMA] = ACTIONS(3681),
    [anon_sym_RPAREN] = ACTIONS(3681),
    [sym_comment] = ACTIONS(3),
  },
  [1060] = {
    [anon_sym_COMMA] = ACTIONS(3683),
    [anon_sym_RPAREN] = ACTIONS(3683),
    [sym_comment] = ACTIONS(3),
  },
  [1061] = {
    [anon_sym_COMMA] = ACTIONS(3685),
    [anon_sym_RPAREN] = ACTIONS(3685),
    [sym_comment] = ACTIONS(3),
  },
  [1062] = {
    [anon_sym_COMMA] = ACTIONS(3687),
    [anon_sym_RPAREN] = ACTIONS(3687),
    [sym_comment] = ACTIONS(3),
  },
  [1063] = {
    [anon_sym_COMMA] = ACTIONS(3689),
    [anon_sym_RPAREN] = ACTIONS(3689),
    [sym_comment] = ACTIONS(3),
  },
  [1064] = {
    [sym__initializer] = STATE(1135),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(3689),
    [anon_sym_COMMA] = ACTIONS(3689),
    [sym_comment] = ACTIONS(3),
  },
  [1065] = {
    [anon_sym_COMMA] = ACTIONS(3691),
    [anon_sym_RPAREN] = ACTIONS(3691),
    [sym_comment] = ACTIONS(3),
  },
  [1066] = {
    [sym__initializer] = STATE(1136),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(3683),
    [anon_sym_COMMA] = ACTIONS(3683),
    [sym_comment] = ACTIONS(3),
  },
  [1067] = {
    [anon_sym_COMMA] = ACTIONS(3693),
    [anon_sym_RPAREN] = ACTIONS(3693),
    [sym_comment] = ACTIONS(3),
  },
  [1068] = {
    [anon_sym_COMMA] = ACTIONS(3695),
    [anon_sym_RPAREN] = ACTIONS(3695),
    [sym_comment] = ACTIONS(3),
  },
  [1069] = {
    [sym__initializer] = STATE(1137),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(3695),
    [anon_sym_COMMA] = ACTIONS(3695),
    [sym_comment] = ACTIONS(3),
  },
  [1070] = {
    [anon_sym_COMMA] = ACTIONS(3697),
    [anon_sym_RPAREN] = ACTIONS(3697),
    [sym_comment] = ACTIONS(3),
  },
  [1071] = {
    [anon_sym_COMMA] = ACTIONS(3699),
    [anon_sym_RPAREN] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
  },
  [1072] = {
    [sym__initializer] = STATE(1138),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RPAREN] = ACTIONS(3699),
    [anon_sym_COMMA] = ACTIONS(3699),
    [sym_comment] = ACTIONS(3),
  },
  [1073] = {
    [anon_sym_COMMA] = ACTIONS(3701),
    [anon_sym_RPAREN] = ACTIONS(3701),
    [sym_comment] = ACTIONS(3),
  },
  [1074] = {
    [anon_sym_COLON] = ACTIONS(3703),
    [anon_sym_EQ_GT] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3703),
  },
  [1075] = {
    [sym_statement_block] = STATE(1139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [1076] = {
    [anon_sym_BQUOTE] = ACTIONS(3705),
    [anon_sym_symbol] = ACTIONS(3707),
    [anon_sym_PIPE] = ACTIONS(3705),
    [anon_sym_break] = ACTIONS(3707),
    [anon_sym_return] = ACTIONS(3707),
    [anon_sym_RBRACE] = ACTIONS(3705),
    [anon_sym_interface] = ACTIONS(3707),
    [anon_sym_delete] = ACTIONS(3707),
    [anon_sym_if] = ACTIONS(3707),
    [anon_sym_yield] = ACTIONS(3707),
    [sym_true] = ACTIONS(3707),
    [anon_sym_protected] = ACTIONS(3707),
    [anon_sym_set] = ACTIONS(3707),
    [anon_sym_import] = ACTIONS(3707),
    [anon_sym_await] = ACTIONS(3707),
    [anon_sym_DQUOTE] = ACTIONS(3705),
    [anon_sym_for] = ACTIONS(3707),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym_number] = ACTIONS(3707),
    [anon_sym_typeof] = ACTIONS(3707),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_switch] = ACTIONS(3707),
    [anon_sym_RBRACK] = ACTIONS(3705),
    [sym_null] = ACTIONS(3707),
    [anon_sym_any] = ACTIONS(3707),
    [anon_sym_async] = ACTIONS(3707),
    [anon_sym_public] = ACTIONS(3707),
    [anon_sym_var] = ACTIONS(3707),
    [anon_sym_while] = ACTIONS(3707),
    [anon_sym_SQUOTE] = ACTIONS(3705),
    [anon_sym_RPAREN] = ACTIONS(3705),
    [anon_sym_SLASH] = ACTIONS(3707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3707),
    [anon_sym_new] = ACTIONS(3707),
    [anon_sym_export] = ACTIONS(3707),
    [anon_sym_with] = ACTIONS(3707),
    [sym_identifier] = ACTIONS(3707),
    [anon_sym_debugger] = ACTIONS(3707),
    [anon_sym_AT] = ACTIONS(3705),
    [anon_sym_COMMA] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3707),
    [anon_sym_EQ] = ACTIONS(3707),
    [anon_sym_void] = ACTIONS(3707),
    [anon_sym_const] = ACTIONS(3707),
    [sym_super] = ACTIONS(3707),
    [anon_sym_private] = ACTIONS(3707),
    [anon_sym_get] = ACTIONS(3707),
    [anon_sym_default] = ACTIONS(3707),
    [anon_sym_enum] = ACTIONS(3707),
    [anon_sym_continue] = ACTIONS(3707),
    [anon_sym_DASH_DASH] = ACTIONS(3705),
    [anon_sym_this] = ACTIONS(3707),
    [anon_sym_throw] = ACTIONS(3707),
    [anon_sym_abstract] = ACTIONS(3707),
    [anon_sym_type] = ACTIONS(3707),
    [anon_sym_namespace] = ACTIONS(3707),
    [anon_sym_PLUS_PLUS] = ACTIONS(3705),
    [anon_sym_else] = ACTIONS(3707),
    [anon_sym_BANG] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [sym_false] = ACTIONS(3707),
    [anon_sym_case] = ACTIONS(3707),
    [anon_sym_module] = ACTIONS(3707),
    [anon_sym_class] = ACTIONS(3707),
    [anon_sym_declare] = ACTIONS(3707),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_GT] = ACTIONS(3705),
    [anon_sym_boolean] = ACTIONS(3707),
    [anon_sym_EQ_GT] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_try] = ACTIONS(3707),
    [anon_sym_LT] = ACTIONS(3705),
    [sym_number] = ACTIONS(3705),
    [ts_builtin_sym_end] = ACTIONS(3705),
    [anon_sym_function] = ACTIONS(3707),
    [sym_undefined] = ACTIONS(3707),
    [anon_sym_let] = ACTIONS(3707),
    [anon_sym_PLUS] = ACTIONS(3707),
    [anon_sym_do] = ACTIONS(3707),
    [anon_sym_TILDE] = ACTIONS(3705),
  },
  [1077] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(967),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(967),
    [sym_call_signature] = STATE(967),
    [sym_construct_signature] = STATE(967),
    [sym_index_signature] = STATE(967),
    [sym_export_statement] = STATE(967),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(3709),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3709),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1078] = {
    [sym__automatic_semicolon] = ACTIONS(3639),
    [anon_sym_RBRACE] = ACTIONS(3639),
    [anon_sym_SEMI] = ACTIONS(3639),
    [anon_sym_COMMA] = ACTIONS(3639),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3639),
    [sym_comment] = ACTIONS(3),
  },
  [1079] = {
    [sym_call_signature] = STATE(1141),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [1080] = {
    [sym_call_signature] = STATE(1141),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(3711),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [1081] = {
    [sym_string] = STATE(1143),
    [sym__property_name] = STATE(1143),
    [sym_computed_property_name] = STATE(1143),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1082] = {
    [sym_string] = STATE(1143),
    [sym__property_name] = STATE(1143),
    [sym_computed_property_name] = STATE(1143),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(3713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1083] = {
    [sym_call_signature] = STATE(1141),
    [sym_type_annotation] = STATE(1144),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(3715),
    [anon_sym_RBRACE] = ACTIONS(3715),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
  },
  [1084] = {
    [sym__automatic_semicolon] = ACTIONS(3715),
    [anon_sym_RBRACE] = ACTIONS(3715),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_COMMA] = ACTIONS(3715),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
  },
  [1085] = {
    [sym__automatic_semicolon] = ACTIONS(3717),
    [anon_sym_RBRACE] = ACTIONS(3717),
    [anon_sym_SEMI] = ACTIONS(3717),
    [anon_sym_COMMA] = ACTIONS(3717),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3717),
    [sym_comment] = ACTIONS(3),
  },
  [1086] = {
    [sym_string] = STATE(1143),
    [sym__property_name] = STATE(1143),
    [sym_computed_property_name] = STATE(1143),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(3719),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(3721),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(3721),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1087] = {
    [sym_call_signature] = STATE(1141),
    [sym_type_annotation] = STATE(1144),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(3715),
    [anon_sym_RBRACE] = ACTIONS(3715),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_QMARK] = ACTIONS(3723),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
  },
  [1088] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(967),
    [sym_decorator] = STATE(510),
    [sym__property_name] = STATE(511),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_property_signature] = STATE(967),
    [sym_call_signature] = STATE(967),
    [sym_export_statement] = STATE(967),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_construct_signature] = STATE(967),
    [sym_index_signature] = STATE(967),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1089] = {
    [anon_sym_EQ_GT] = ACTIONS(3725),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_LBRACK] = ACTIONS(3725),
    [anon_sym_while] = ACTIONS(3725),
    [anon_sym_RPAREN] = ACTIONS(3725),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(3725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3725),
    [anon_sym_EQ] = ACTIONS(3727),
    [anon_sym_RBRACK] = ACTIONS(3725),
    [anon_sym_GT] = ACTIONS(3725),
    [anon_sym_else] = ACTIONS(3725),
  },
  [1090] = {
    [sym_call_signature] = STATE(1930),
    [sym_type_annotation] = STATE(1084),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_QMARK] = ACTIONS(3729),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
  },
  [1091] = {
    [sym_call_signature] = STATE(1930),
    [sym_type_annotation] = STATE(1084),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(3459),
    [anon_sym_RBRACE] = ACTIONS(3459),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3459),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3459),
    [sym_comment] = ACTIONS(3),
  },
  [1092] = {
    [sym_string] = STATE(1149),
    [sym__property_name] = STATE(1149),
    [sym_computed_property_name] = STATE(1149),
    [anon_sym_get] = ACTIONS(3731),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_public] = ACTIONS(919),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_declare] = ACTIONS(919),
    [sym_number] = ACTIONS(3733),
    [anon_sym_STAR] = ACTIONS(3735),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_protected] = ACTIONS(919),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(3731),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(919),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_async] = ACTIONS(3737),
  },
  [1093] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1898),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(1898),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1094] = {
    [sym__automatic_semicolon] = ACTIONS(3739),
    [anon_sym_SEMI] = ACTIONS(3739),
    [anon_sym_from] = ACTIONS(3739),
    [sym_comment] = ACTIONS(3),
  },
  [1095] = {
    [sym__import_export_specifier] = STATE(991),
    [sym_identifier] = ACTIONS(787),
    [anon_sym_typeof] = ACTIONS(791),
    [anon_sym_type] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
  },
  [1096] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [sym__automatic_semicolon] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_RBRACE] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_SEMI] = ACTIONS(1695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_GT] = ACTIONS(3741),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(3741),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1697),
  },
  [1097] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3744),
    [sym__automatic_semicolon] = ACTIONS(3744),
    [anon_sym_BQUOTE] = ACTIONS(3744),
    [anon_sym_symbol] = ACTIONS(3746),
    [anon_sym_PIPE] = ACTIONS(3746),
    [anon_sym_STAR] = ACTIONS(3746),
    [anon_sym_GT_GT_GT] = ACTIONS(3744),
    [anon_sym_break] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_PERCENT] = ACTIONS(3744),
    [anon_sym_interface] = ACTIONS(3746),
    [anon_sym_as] = ACTIONS(3746),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_instanceof] = ACTIONS(3746),
    [anon_sym_yield] = ACTIONS(3746),
    [sym_true] = ACTIONS(3746),
    [anon_sym_protected] = ACTIONS(3746),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_set] = ACTIONS(3746),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3744),
    [anon_sym_import] = ACTIONS(3746),
    [anon_sym_await] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_number] = ACTIONS(3746),
    [anon_sym_typeof] = ACTIONS(3746),
    [anon_sym_LT_LT] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_AMP_AMP] = ACTIONS(3744),
    [anon_sym_switch] = ACTIONS(3746),
    [anon_sym_LT_EQ] = ACTIONS(3744),
    [sym_null] = ACTIONS(3746),
    [anon_sym_any] = ACTIONS(3746),
    [anon_sym_async] = ACTIONS(3746),
    [anon_sym_public] = ACTIONS(3746),
    [anon_sym_var] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3744),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_SQUOTE] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(3746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3746),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_CARET] = ACTIONS(3744),
    [anon_sym_export] = ACTIONS(3746),
    [anon_sym_GT_GT] = ACTIONS(3746),
    [anon_sym_with] = ACTIONS(3746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3744),
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_debugger] = ACTIONS(3746),
    [anon_sym_AT] = ACTIONS(3744),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_void] = ACTIONS(3746),
    [anon_sym_const] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3744),
    [sym_super] = ACTIONS(3746),
    [anon_sym_private] = ACTIONS(3746),
    [anon_sym_get] = ACTIONS(3746),
    [anon_sym_default] = ACTIONS(3746),
    [anon_sym_enum] = ACTIONS(3746),
    [anon_sym_continue] = ACTIONS(3746),
    [anon_sym_DASH_DASH] = ACTIONS(3744),
    [anon_sym_this] = ACTIONS(3746),
    [anon_sym_throw] = ACTIONS(3746),
    [anon_sym_abstract] = ACTIONS(3746),
    [anon_sym_type] = ACTIONS(3746),
    [anon_sym_STAR_STAR] = ACTIONS(3744),
    [anon_sym_namespace] = ACTIONS(3746),
    [anon_sym_PLUS_PLUS] = ACTIONS(3744),
    [anon_sym_else] = ACTIONS(3746),
    [anon_sym_BANG] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [sym_false] = ACTIONS(3746),
    [anon_sym_case] = ACTIONS(3746),
    [anon_sym_module] = ACTIONS(3746),
    [anon_sym_class] = ACTIONS(3746),
    [anon_sym_declare] = ACTIONS(3746),
    [anon_sym_LPAREN] = ACTIONS(3744),
    [anon_sym_GT] = ACTIONS(3746),
    [anon_sym_boolean] = ACTIONS(3746),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_PIPE_PIPE] = ACTIONS(3744),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_EQ_EQ] = ACTIONS(3746),
    [anon_sym_LT] = ACTIONS(3746),
    [sym_number] = ACTIONS(3744),
    [ts_builtin_sym_end] = ACTIONS(3744),
    [anon_sym_function] = ACTIONS(3746),
    [sym_undefined] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3744),
    [anon_sym_in] = ACTIONS(3746),
  },
  [1098] = {
    [sym_identifier] = ACTIONS(3748),
    [anon_sym_BQUOTE] = ACTIONS(3750),
    [anon_sym_debugger] = ACTIONS(3748),
    [anon_sym_symbol] = ACTIONS(3748),
    [anon_sym_AT] = ACTIONS(3750),
    [anon_sym_DASH] = ACTIONS(3748),
    [anon_sym_void] = ACTIONS(3748),
    [anon_sym_break] = ACTIONS(3748),
    [anon_sym_const] = ACTIONS(3748),
    [sym_super] = ACTIONS(3748),
    [anon_sym_return] = ACTIONS(3748),
    [anon_sym_private] = ACTIONS(3748),
    [anon_sym_get] = ACTIONS(3748),
    [anon_sym_RBRACE] = ACTIONS(3750),
    [anon_sym_interface] = ACTIONS(3748),
    [anon_sym_default] = ACTIONS(3748),
    [anon_sym_enum] = ACTIONS(3748),
    [anon_sym_delete] = ACTIONS(3748),
    [anon_sym_continue] = ACTIONS(3748),
    [anon_sym_DASH_DASH] = ACTIONS(3750),
    [anon_sym_if] = ACTIONS(3748),
    [anon_sym_this] = ACTIONS(3748),
    [anon_sym_yield] = ACTIONS(3748),
    [sym_true] = ACTIONS(3748),
    [anon_sym_throw] = ACTIONS(3748),
    [anon_sym_protected] = ACTIONS(3748),
    [anon_sym_abstract] = ACTIONS(3748),
    [anon_sym_set] = ACTIONS(3748),
    [anon_sym_type] = ACTIONS(3748),
    [anon_sym_import] = ACTIONS(3748),
    [anon_sym_namespace] = ACTIONS(3748),
    [anon_sym_PLUS_PLUS] = ACTIONS(3750),
    [anon_sym_await] = ACTIONS(3748),
    [anon_sym_DQUOTE] = ACTIONS(3750),
    [anon_sym_else] = ACTIONS(3748),
    [anon_sym_BANG] = ACTIONS(3750),
    [anon_sym_for] = ACTIONS(3748),
    [anon_sym_LBRACK] = ACTIONS(3750),
    [sym_false] = ACTIONS(3748),
    [anon_sym_SEMI] = ACTIONS(3750),
    [anon_sym_case] = ACTIONS(3748),
    [anon_sym_module] = ACTIONS(3748),
    [anon_sym_number] = ACTIONS(3748),
    [anon_sym_class] = ACTIONS(3748),
    [anon_sym_declare] = ACTIONS(3748),
    [anon_sym_typeof] = ACTIONS(3748),
    [anon_sym_LBRACE] = ACTIONS(3750),
    [anon_sym_switch] = ACTIONS(3748),
    [anon_sym_LPAREN] = ACTIONS(3750),
    [sym_null] = ACTIONS(3748),
    [anon_sym_any] = ACTIONS(3748),
    [anon_sym_boolean] = ACTIONS(3748),
    [anon_sym_async] = ACTIONS(3748),
    [anon_sym_public] = ACTIONS(3748),
    [anon_sym_var] = ACTIONS(3748),
    [anon_sym_while] = ACTIONS(3748),
    [anon_sym_SQUOTE] = ACTIONS(3750),
    [anon_sym_try] = ACTIONS(3748),
    [anon_sym_LT] = ACTIONS(3750),
    [sym_number] = ACTIONS(3750),
    [anon_sym_SLASH] = ACTIONS(3748),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3748),
    [anon_sym_function] = ACTIONS(3748),
    [sym_undefined] = ACTIONS(3748),
    [anon_sym_new] = ACTIONS(3748),
    [ts_builtin_sym_end] = ACTIONS(3750),
    [anon_sym_let] = ACTIONS(3748),
    [anon_sym_PLUS] = ACTIONS(3748),
    [anon_sym_export] = ACTIONS(3748),
    [anon_sym_do] = ACTIONS(3748),
    [anon_sym_TILDE] = ACTIONS(3750),
    [anon_sym_with] = ACTIONS(3748),
  },
  [1099] = {
    [sym_computed_property_name] = STATE(606),
    [sym__enum_member] = STATE(1002),
    [sym__property_name] = STATE(606),
    [sym_string] = STATE(606),
    [sym_enum_assignment] = STATE(1002),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(1773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1100] = {
    [sym__automatic_semicolon] = ACTIONS(3752),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3752),
  },
  [1101] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(3754),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1102] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(3756),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1103] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(3758),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1104] = {
    [sym_type_alias_declaration] = STATE(1153),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1153),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1153),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1153),
    [sym_return_statement] = STATE(1153),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1153),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1153),
    [sym_switch_statement] = STATE(1153),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1153),
    [sym_throw_statement] = STATE(1153),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1153),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1153),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1153),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1153),
    [sym_abstract_class] = STATE(1153),
    [sym_interface_declaration] = STATE(1153),
    [sym_statement_block] = STATE(1153),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1153),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1153),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1153),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1153),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1153),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1153),
    [sym_empty_statement] = STATE(1153),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1153),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1153),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1153),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1153),
    [sym_break_statement] = STATE(1153),
    [sym_labeled_statement] = STATE(1153),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1153),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1105] = {
    [sym_type_alias_declaration] = STATE(1154),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1154),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1154),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1154),
    [sym_return_statement] = STATE(1154),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1154),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1154),
    [sym_switch_statement] = STATE(1154),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1154),
    [sym_throw_statement] = STATE(1154),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1154),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1154),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1154),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1154),
    [sym_abstract_class] = STATE(1154),
    [sym_interface_declaration] = STATE(1154),
    [sym_statement_block] = STATE(1154),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1154),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1154),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1154),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1154),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1154),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1154),
    [sym_empty_statement] = STATE(1154),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1154),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1154),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1154),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1154),
    [sym_break_statement] = STATE(1154),
    [sym_labeled_statement] = STATE(1154),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1154),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1106] = {
    [sym_type_alias_declaration] = STATE(1155),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1155),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1155),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1155),
    [sym_return_statement] = STATE(1155),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1155),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1155),
    [sym_switch_statement] = STATE(1155),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1155),
    [sym_throw_statement] = STATE(1155),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1155),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1155),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1155),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1155),
    [sym_abstract_class] = STATE(1155),
    [sym_interface_declaration] = STATE(1155),
    [sym_statement_block] = STATE(1155),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1155),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1155),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1155),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1155),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1155),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1155),
    [sym_empty_statement] = STATE(1155),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1155),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1155),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1155),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1155),
    [sym_break_statement] = STATE(1155),
    [sym_labeled_statement] = STATE(1155),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1155),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1107] = {
    [sym_identifier] = ACTIONS(3760),
    [anon_sym_BQUOTE] = ACTIONS(3762),
    [anon_sym_debugger] = ACTIONS(3760),
    [anon_sym_symbol] = ACTIONS(3760),
    [anon_sym_AT] = ACTIONS(3762),
    [anon_sym_DASH] = ACTIONS(3760),
    [anon_sym_void] = ACTIONS(3760),
    [anon_sym_break] = ACTIONS(3760),
    [anon_sym_const] = ACTIONS(3760),
    [sym_super] = ACTIONS(3760),
    [anon_sym_return] = ACTIONS(3760),
    [anon_sym_private] = ACTIONS(3760),
    [anon_sym_get] = ACTIONS(3760),
    [anon_sym_RBRACE] = ACTIONS(3762),
    [anon_sym_interface] = ACTIONS(3760),
    [anon_sym_default] = ACTIONS(3760),
    [anon_sym_enum] = ACTIONS(3760),
    [anon_sym_delete] = ACTIONS(3760),
    [anon_sym_continue] = ACTIONS(3760),
    [anon_sym_DASH_DASH] = ACTIONS(3762),
    [anon_sym_if] = ACTIONS(3760),
    [anon_sym_this] = ACTIONS(3760),
    [anon_sym_yield] = ACTIONS(3760),
    [sym_true] = ACTIONS(3760),
    [anon_sym_throw] = ACTIONS(3760),
    [anon_sym_protected] = ACTIONS(3760),
    [anon_sym_abstract] = ACTIONS(3760),
    [anon_sym_set] = ACTIONS(3760),
    [anon_sym_type] = ACTIONS(3760),
    [anon_sym_import] = ACTIONS(3760),
    [anon_sym_namespace] = ACTIONS(3760),
    [anon_sym_PLUS_PLUS] = ACTIONS(3762),
    [anon_sym_await] = ACTIONS(3760),
    [anon_sym_DQUOTE] = ACTIONS(3762),
    [anon_sym_else] = ACTIONS(3760),
    [anon_sym_BANG] = ACTIONS(3762),
    [anon_sym_for] = ACTIONS(3760),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [sym_false] = ACTIONS(3760),
    [anon_sym_SEMI] = ACTIONS(3762),
    [anon_sym_case] = ACTIONS(3760),
    [anon_sym_module] = ACTIONS(3760),
    [anon_sym_number] = ACTIONS(3760),
    [anon_sym_class] = ACTIONS(3760),
    [anon_sym_declare] = ACTIONS(3760),
    [anon_sym_typeof] = ACTIONS(3760),
    [anon_sym_LBRACE] = ACTIONS(3762),
    [anon_sym_switch] = ACTIONS(3760),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [sym_null] = ACTIONS(3760),
    [anon_sym_any] = ACTIONS(3760),
    [anon_sym_boolean] = ACTIONS(3760),
    [anon_sym_async] = ACTIONS(3760),
    [anon_sym_public] = ACTIONS(3760),
    [anon_sym_var] = ACTIONS(3760),
    [anon_sym_while] = ACTIONS(3760),
    [anon_sym_SQUOTE] = ACTIONS(3762),
    [anon_sym_try] = ACTIONS(3760),
    [anon_sym_LT] = ACTIONS(3762),
    [sym_number] = ACTIONS(3762),
    [anon_sym_SLASH] = ACTIONS(3760),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3760),
    [anon_sym_function] = ACTIONS(3760),
    [sym_undefined] = ACTIONS(3760),
    [anon_sym_new] = ACTIONS(3760),
    [ts_builtin_sym_end] = ACTIONS(3762),
    [anon_sym_let] = ACTIONS(3760),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_export] = ACTIONS(3760),
    [anon_sym_do] = ACTIONS(3760),
    [anon_sym_TILDE] = ACTIONS(3762),
    [anon_sym_with] = ACTIONS(3760),
  },
  [1108] = {
    [sym_identifier] = ACTIONS(3764),
    [anon_sym_BQUOTE] = ACTIONS(3766),
    [anon_sym_debugger] = ACTIONS(3764),
    [anon_sym_symbol] = ACTIONS(3764),
    [anon_sym_AT] = ACTIONS(3766),
    [anon_sym_DASH] = ACTIONS(3764),
    [anon_sym_void] = ACTIONS(3764),
    [anon_sym_break] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3764),
    [sym_super] = ACTIONS(3764),
    [anon_sym_return] = ACTIONS(3764),
    [anon_sym_private] = ACTIONS(3764),
    [anon_sym_get] = ACTIONS(3764),
    [anon_sym_RBRACE] = ACTIONS(3766),
    [anon_sym_interface] = ACTIONS(3764),
    [anon_sym_default] = ACTIONS(3764),
    [anon_sym_enum] = ACTIONS(3764),
    [anon_sym_delete] = ACTIONS(3764),
    [anon_sym_continue] = ACTIONS(3764),
    [anon_sym_DASH_DASH] = ACTIONS(3766),
    [anon_sym_if] = ACTIONS(3764),
    [anon_sym_this] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3764),
    [sym_true] = ACTIONS(3764),
    [anon_sym_throw] = ACTIONS(3764),
    [anon_sym_protected] = ACTIONS(3764),
    [anon_sym_abstract] = ACTIONS(3764),
    [anon_sym_set] = ACTIONS(3764),
    [anon_sym_type] = ACTIONS(3764),
    [anon_sym_import] = ACTIONS(3764),
    [anon_sym_namespace] = ACTIONS(3764),
    [anon_sym_PLUS_PLUS] = ACTIONS(3766),
    [anon_sym_await] = ACTIONS(3764),
    [anon_sym_DQUOTE] = ACTIONS(3766),
    [anon_sym_else] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_for] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3766),
    [sym_false] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym_case] = ACTIONS(3764),
    [anon_sym_module] = ACTIONS(3764),
    [anon_sym_number] = ACTIONS(3764),
    [anon_sym_class] = ACTIONS(3764),
    [anon_sym_declare] = ACTIONS(3764),
    [anon_sym_typeof] = ACTIONS(3764),
    [anon_sym_LBRACE] = ACTIONS(3766),
    [anon_sym_switch] = ACTIONS(3764),
    [anon_sym_LPAREN] = ACTIONS(3766),
    [sym_null] = ACTIONS(3764),
    [anon_sym_any] = ACTIONS(3764),
    [anon_sym_boolean] = ACTIONS(3764),
    [anon_sym_async] = ACTIONS(3764),
    [anon_sym_public] = ACTIONS(3764),
    [anon_sym_var] = ACTIONS(3764),
    [anon_sym_while] = ACTIONS(3764),
    [anon_sym_SQUOTE] = ACTIONS(3766),
    [anon_sym_try] = ACTIONS(3764),
    [anon_sym_LT] = ACTIONS(3766),
    [sym_number] = ACTIONS(3766),
    [anon_sym_SLASH] = ACTIONS(3764),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3764),
    [anon_sym_function] = ACTIONS(3764),
    [sym_undefined] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3764),
    [ts_builtin_sym_end] = ACTIONS(3766),
    [anon_sym_let] = ACTIONS(3764),
    [anon_sym_PLUS] = ACTIONS(3764),
    [anon_sym_export] = ACTIONS(3764),
    [anon_sym_do] = ACTIONS(3764),
    [anon_sym_TILDE] = ACTIONS(3766),
    [anon_sym_with] = ACTIONS(3764),
  },
  [1109] = {
    [sym_type_alias_declaration] = STATE(1156),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1156),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1156),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1156),
    [sym_return_statement] = STATE(1156),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1156),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1156),
    [sym_switch_statement] = STATE(1156),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1156),
    [sym_throw_statement] = STATE(1156),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1156),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1156),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1156),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1156),
    [sym_abstract_class] = STATE(1156),
    [sym_interface_declaration] = STATE(1156),
    [sym_statement_block] = STATE(1156),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1156),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1156),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1156),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1156),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1156),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1156),
    [sym_empty_statement] = STATE(1156),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1156),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1156),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1156),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1156),
    [sym_break_statement] = STATE(1156),
    [sym_labeled_statement] = STATE(1156),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1156),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1110] = {
    [sym_type_alias_declaration] = STATE(1157),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1157),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1157),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1157),
    [sym_return_statement] = STATE(1157),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1157),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1157),
    [sym_switch_statement] = STATE(1157),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1157),
    [sym_throw_statement] = STATE(1157),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1157),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1157),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1157),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1157),
    [sym_abstract_class] = STATE(1157),
    [sym_interface_declaration] = STATE(1157),
    [sym_statement_block] = STATE(1157),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1157),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1157),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1157),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1157),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1157),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1157),
    [sym_empty_statement] = STATE(1157),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1157),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1157),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1157),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1157),
    [sym_break_statement] = STATE(1157),
    [sym_labeled_statement] = STATE(1157),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1157),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1111] = {
    [sym_type_alias_declaration] = STATE(1158),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1158),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1158),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1158),
    [sym_return_statement] = STATE(1158),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1158),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1158),
    [sym_switch_statement] = STATE(1158),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1158),
    [sym_throw_statement] = STATE(1158),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1158),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1158),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1158),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1158),
    [sym_abstract_class] = STATE(1158),
    [sym_interface_declaration] = STATE(1158),
    [sym_statement_block] = STATE(1158),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1158),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1158),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1158),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1158),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1158),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1158),
    [sym_empty_statement] = STATE(1158),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1158),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1158),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1158),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1158),
    [sym_break_statement] = STATE(1158),
    [sym_labeled_statement] = STATE(1158),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1158),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1112] = {
    [sym_identifier] = ACTIONS(3768),
    [anon_sym_BQUOTE] = ACTIONS(3770),
    [anon_sym_debugger] = ACTIONS(3768),
    [anon_sym_symbol] = ACTIONS(3768),
    [anon_sym_AT] = ACTIONS(3770),
    [anon_sym_DASH] = ACTIONS(3768),
    [anon_sym_void] = ACTIONS(3768),
    [anon_sym_break] = ACTIONS(3768),
    [anon_sym_const] = ACTIONS(3768),
    [sym_super] = ACTIONS(3768),
    [anon_sym_return] = ACTIONS(3768),
    [anon_sym_private] = ACTIONS(3768),
    [anon_sym_get] = ACTIONS(3768),
    [anon_sym_RBRACE] = ACTIONS(3770),
    [anon_sym_interface] = ACTIONS(3768),
    [anon_sym_default] = ACTIONS(3768),
    [anon_sym_enum] = ACTIONS(3768),
    [anon_sym_delete] = ACTIONS(3768),
    [anon_sym_continue] = ACTIONS(3768),
    [anon_sym_DASH_DASH] = ACTIONS(3770),
    [anon_sym_if] = ACTIONS(3768),
    [anon_sym_this] = ACTIONS(3768),
    [anon_sym_yield] = ACTIONS(3768),
    [sym_true] = ACTIONS(3768),
    [anon_sym_throw] = ACTIONS(3768),
    [anon_sym_protected] = ACTIONS(3768),
    [anon_sym_abstract] = ACTIONS(3768),
    [anon_sym_set] = ACTIONS(3768),
    [anon_sym_type] = ACTIONS(3768),
    [anon_sym_import] = ACTIONS(3768),
    [anon_sym_namespace] = ACTIONS(3768),
    [anon_sym_PLUS_PLUS] = ACTIONS(3770),
    [anon_sym_await] = ACTIONS(3768),
    [anon_sym_DQUOTE] = ACTIONS(3770),
    [anon_sym_else] = ACTIONS(3768),
    [anon_sym_BANG] = ACTIONS(3770),
    [anon_sym_for] = ACTIONS(3768),
    [anon_sym_LBRACK] = ACTIONS(3770),
    [sym_false] = ACTIONS(3768),
    [anon_sym_SEMI] = ACTIONS(3770),
    [anon_sym_case] = ACTIONS(3768),
    [anon_sym_module] = ACTIONS(3768),
    [anon_sym_number] = ACTIONS(3768),
    [anon_sym_class] = ACTIONS(3768),
    [anon_sym_declare] = ACTIONS(3768),
    [anon_sym_typeof] = ACTIONS(3768),
    [anon_sym_LBRACE] = ACTIONS(3770),
    [anon_sym_switch] = ACTIONS(3768),
    [anon_sym_LPAREN] = ACTIONS(3770),
    [sym_null] = ACTIONS(3768),
    [anon_sym_any] = ACTIONS(3768),
    [anon_sym_boolean] = ACTIONS(3768),
    [anon_sym_async] = ACTIONS(3768),
    [anon_sym_public] = ACTIONS(3768),
    [anon_sym_var] = ACTIONS(3768),
    [anon_sym_while] = ACTIONS(3768),
    [anon_sym_SQUOTE] = ACTIONS(3770),
    [anon_sym_try] = ACTIONS(3768),
    [anon_sym_LT] = ACTIONS(3770),
    [sym_number] = ACTIONS(3770),
    [anon_sym_SLASH] = ACTIONS(3768),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3768),
    [anon_sym_function] = ACTIONS(3768),
    [sym_undefined] = ACTIONS(3768),
    [anon_sym_new] = ACTIONS(3768),
    [ts_builtin_sym_end] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3768),
    [anon_sym_PLUS] = ACTIONS(3768),
    [anon_sym_export] = ACTIONS(3768),
    [anon_sym_do] = ACTIONS(3768),
    [anon_sym_TILDE] = ACTIONS(3770),
    [anon_sym_with] = ACTIONS(3768),
  },
  [1113] = {
    [sym_identifier] = ACTIONS(3772),
    [anon_sym_BQUOTE] = ACTIONS(3774),
    [anon_sym_debugger] = ACTIONS(3772),
    [anon_sym_symbol] = ACTIONS(3772),
    [anon_sym_AT] = ACTIONS(3774),
    [anon_sym_DASH] = ACTIONS(3772),
    [anon_sym_void] = ACTIONS(3772),
    [anon_sym_break] = ACTIONS(3772),
    [anon_sym_const] = ACTIONS(3772),
    [sym_super] = ACTIONS(3772),
    [anon_sym_return] = ACTIONS(3772),
    [anon_sym_private] = ACTIONS(3772),
    [anon_sym_get] = ACTIONS(3772),
    [anon_sym_RBRACE] = ACTIONS(3774),
    [anon_sym_interface] = ACTIONS(3772),
    [anon_sym_default] = ACTIONS(3772),
    [anon_sym_enum] = ACTIONS(3772),
    [anon_sym_delete] = ACTIONS(3772),
    [anon_sym_continue] = ACTIONS(3772),
    [anon_sym_DASH_DASH] = ACTIONS(3774),
    [anon_sym_if] = ACTIONS(3772),
    [anon_sym_this] = ACTIONS(3772),
    [anon_sym_yield] = ACTIONS(3772),
    [sym_true] = ACTIONS(3772),
    [anon_sym_throw] = ACTIONS(3772),
    [anon_sym_protected] = ACTIONS(3772),
    [anon_sym_abstract] = ACTIONS(3772),
    [anon_sym_set] = ACTIONS(3772),
    [anon_sym_type] = ACTIONS(3772),
    [anon_sym_import] = ACTIONS(3772),
    [anon_sym_namespace] = ACTIONS(3772),
    [anon_sym_PLUS_PLUS] = ACTIONS(3774),
    [anon_sym_await] = ACTIONS(3772),
    [anon_sym_DQUOTE] = ACTIONS(3774),
    [anon_sym_else] = ACTIONS(3772),
    [anon_sym_BANG] = ACTIONS(3774),
    [anon_sym_for] = ACTIONS(3772),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [sym_false] = ACTIONS(3772),
    [anon_sym_SEMI] = ACTIONS(3774),
    [anon_sym_case] = ACTIONS(3772),
    [anon_sym_module] = ACTIONS(3772),
    [anon_sym_number] = ACTIONS(3772),
    [anon_sym_class] = ACTIONS(3772),
    [anon_sym_declare] = ACTIONS(3772),
    [anon_sym_typeof] = ACTIONS(3772),
    [anon_sym_LBRACE] = ACTIONS(3774),
    [anon_sym_switch] = ACTIONS(3772),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [sym_null] = ACTIONS(3772),
    [anon_sym_any] = ACTIONS(3772),
    [anon_sym_boolean] = ACTIONS(3772),
    [anon_sym_async] = ACTIONS(3772),
    [anon_sym_public] = ACTIONS(3772),
    [anon_sym_var] = ACTIONS(3772),
    [anon_sym_while] = ACTIONS(3772),
    [anon_sym_SQUOTE] = ACTIONS(3774),
    [anon_sym_try] = ACTIONS(3772),
    [anon_sym_LT] = ACTIONS(3774),
    [sym_number] = ACTIONS(3774),
    [anon_sym_SLASH] = ACTIONS(3772),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3772),
    [anon_sym_function] = ACTIONS(3772),
    [sym_undefined] = ACTIONS(3772),
    [anon_sym_new] = ACTIONS(3772),
    [ts_builtin_sym_end] = ACTIONS(3774),
    [anon_sym_let] = ACTIONS(3772),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_export] = ACTIONS(3772),
    [anon_sym_do] = ACTIONS(3772),
    [anon_sym_TILDE] = ACTIONS(3774),
    [anon_sym_with] = ACTIONS(3772),
  },
  [1114] = {
    [sym_identifier] = ACTIONS(3776),
    [anon_sym_BQUOTE] = ACTIONS(3778),
    [anon_sym_debugger] = ACTIONS(3776),
    [anon_sym_symbol] = ACTIONS(3776),
    [anon_sym_AT] = ACTIONS(3778),
    [anon_sym_DASH] = ACTIONS(3776),
    [anon_sym_void] = ACTIONS(3776),
    [anon_sym_break] = ACTIONS(3776),
    [anon_sym_const] = ACTIONS(3776),
    [sym_super] = ACTIONS(3776),
    [anon_sym_return] = ACTIONS(3776),
    [anon_sym_private] = ACTIONS(3776),
    [anon_sym_get] = ACTIONS(3776),
    [anon_sym_RBRACE] = ACTIONS(3778),
    [anon_sym_interface] = ACTIONS(3776),
    [anon_sym_default] = ACTIONS(3776),
    [anon_sym_enum] = ACTIONS(3776),
    [anon_sym_delete] = ACTIONS(3776),
    [anon_sym_continue] = ACTIONS(3776),
    [anon_sym_DASH_DASH] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(3776),
    [anon_sym_this] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3776),
    [sym_true] = ACTIONS(3776),
    [anon_sym_throw] = ACTIONS(3776),
    [anon_sym_protected] = ACTIONS(3776),
    [anon_sym_abstract] = ACTIONS(3776),
    [anon_sym_set] = ACTIONS(3776),
    [anon_sym_type] = ACTIONS(3776),
    [anon_sym_import] = ACTIONS(3776),
    [anon_sym_namespace] = ACTIONS(3776),
    [anon_sym_PLUS_PLUS] = ACTIONS(3778),
    [anon_sym_await] = ACTIONS(3776),
    [anon_sym_DQUOTE] = ACTIONS(3778),
    [anon_sym_else] = ACTIONS(3776),
    [anon_sym_BANG] = ACTIONS(3778),
    [anon_sym_for] = ACTIONS(3776),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [sym_false] = ACTIONS(3776),
    [anon_sym_SEMI] = ACTIONS(3778),
    [anon_sym_case] = ACTIONS(3776),
    [anon_sym_module] = ACTIONS(3776),
    [anon_sym_number] = ACTIONS(3776),
    [anon_sym_class] = ACTIONS(3776),
    [anon_sym_declare] = ACTIONS(3776),
    [anon_sym_typeof] = ACTIONS(3776),
    [anon_sym_LBRACE] = ACTIONS(3778),
    [anon_sym_switch] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3778),
    [sym_null] = ACTIONS(3776),
    [anon_sym_any] = ACTIONS(3776),
    [anon_sym_boolean] = ACTIONS(3776),
    [anon_sym_async] = ACTIONS(3776),
    [anon_sym_public] = ACTIONS(3776),
    [anon_sym_var] = ACTIONS(3776),
    [anon_sym_while] = ACTIONS(3776),
    [anon_sym_SQUOTE] = ACTIONS(3778),
    [anon_sym_try] = ACTIONS(3776),
    [anon_sym_LT] = ACTIONS(3778),
    [sym_number] = ACTIONS(3778),
    [anon_sym_SLASH] = ACTIONS(3776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3776),
    [anon_sym_function] = ACTIONS(3776),
    [sym_undefined] = ACTIONS(3776),
    [anon_sym_new] = ACTIONS(3776),
    [ts_builtin_sym_end] = ACTIONS(3778),
    [anon_sym_let] = ACTIONS(3776),
    [anon_sym_PLUS] = ACTIONS(3776),
    [anon_sym_export] = ACTIONS(3776),
    [anon_sym_do] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(3778),
    [anon_sym_with] = ACTIONS(3776),
  },
  [1115] = {
    [sym_identifier] = ACTIONS(3780),
    [anon_sym_BQUOTE] = ACTIONS(3782),
    [anon_sym_debugger] = ACTIONS(3780),
    [anon_sym_symbol] = ACTIONS(3780),
    [anon_sym_AT] = ACTIONS(3782),
    [anon_sym_DASH] = ACTIONS(3780),
    [anon_sym_void] = ACTIONS(3780),
    [anon_sym_break] = ACTIONS(3780),
    [anon_sym_const] = ACTIONS(3780),
    [sym_super] = ACTIONS(3780),
    [anon_sym_return] = ACTIONS(3780),
    [anon_sym_private] = ACTIONS(3780),
    [anon_sym_get] = ACTIONS(3780),
    [anon_sym_RBRACE] = ACTIONS(3782),
    [anon_sym_interface] = ACTIONS(3780),
    [anon_sym_default] = ACTIONS(3780),
    [anon_sym_enum] = ACTIONS(3780),
    [anon_sym_delete] = ACTIONS(3780),
    [anon_sym_continue] = ACTIONS(3780),
    [anon_sym_DASH_DASH] = ACTIONS(3782),
    [anon_sym_if] = ACTIONS(3780),
    [anon_sym_this] = ACTIONS(3780),
    [anon_sym_yield] = ACTIONS(3780),
    [sym_true] = ACTIONS(3780),
    [anon_sym_throw] = ACTIONS(3780),
    [anon_sym_protected] = ACTIONS(3780),
    [anon_sym_abstract] = ACTIONS(3780),
    [anon_sym_set] = ACTIONS(3780),
    [anon_sym_type] = ACTIONS(3780),
    [anon_sym_import] = ACTIONS(3780),
    [anon_sym_namespace] = ACTIONS(3780),
    [anon_sym_PLUS_PLUS] = ACTIONS(3782),
    [anon_sym_await] = ACTIONS(3780),
    [anon_sym_DQUOTE] = ACTIONS(3782),
    [anon_sym_else] = ACTIONS(3780),
    [anon_sym_BANG] = ACTIONS(3782),
    [anon_sym_for] = ACTIONS(3780),
    [anon_sym_LBRACK] = ACTIONS(3782),
    [sym_false] = ACTIONS(3780),
    [anon_sym_SEMI] = ACTIONS(3782),
    [anon_sym_case] = ACTIONS(3780),
    [anon_sym_module] = ACTIONS(3780),
    [anon_sym_number] = ACTIONS(3780),
    [anon_sym_class] = ACTIONS(3780),
    [anon_sym_declare] = ACTIONS(3780),
    [anon_sym_typeof] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3782),
    [anon_sym_switch] = ACTIONS(3780),
    [anon_sym_LPAREN] = ACTIONS(3782),
    [sym_null] = ACTIONS(3780),
    [anon_sym_any] = ACTIONS(3780),
    [anon_sym_boolean] = ACTIONS(3780),
    [anon_sym_async] = ACTIONS(3780),
    [anon_sym_public] = ACTIONS(3780),
    [anon_sym_var] = ACTIONS(3780),
    [anon_sym_while] = ACTIONS(3780),
    [anon_sym_SQUOTE] = ACTIONS(3782),
    [anon_sym_try] = ACTIONS(3780),
    [anon_sym_LT] = ACTIONS(3782),
    [sym_number] = ACTIONS(3782),
    [anon_sym_SLASH] = ACTIONS(3780),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3780),
    [anon_sym_function] = ACTIONS(3780),
    [sym_undefined] = ACTIONS(3780),
    [anon_sym_new] = ACTIONS(3780),
    [ts_builtin_sym_end] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3780),
    [anon_sym_PLUS] = ACTIONS(3780),
    [anon_sym_export] = ACTIONS(3780),
    [anon_sym_do] = ACTIONS(3780),
    [anon_sym_TILDE] = ACTIONS(3782),
    [anon_sym_with] = ACTIONS(3780),
  },
  [1116] = {
    [sym_identifier] = ACTIONS(3784),
    [anon_sym_BQUOTE] = ACTIONS(3786),
    [anon_sym_debugger] = ACTIONS(3784),
    [anon_sym_symbol] = ACTIONS(3784),
    [anon_sym_AT] = ACTIONS(3786),
    [anon_sym_DASH] = ACTIONS(3784),
    [anon_sym_void] = ACTIONS(3784),
    [anon_sym_break] = ACTIONS(3784),
    [anon_sym_const] = ACTIONS(3784),
    [sym_super] = ACTIONS(3784),
    [anon_sym_return] = ACTIONS(3784),
    [anon_sym_private] = ACTIONS(3784),
    [anon_sym_get] = ACTIONS(3784),
    [anon_sym_RBRACE] = ACTIONS(3786),
    [anon_sym_interface] = ACTIONS(3784),
    [anon_sym_default] = ACTIONS(3784),
    [anon_sym_enum] = ACTIONS(3784),
    [anon_sym_delete] = ACTIONS(3784),
    [anon_sym_continue] = ACTIONS(3784),
    [anon_sym_DASH_DASH] = ACTIONS(3786),
    [anon_sym_if] = ACTIONS(3784),
    [anon_sym_this] = ACTIONS(3784),
    [anon_sym_yield] = ACTIONS(3784),
    [sym_true] = ACTIONS(3784),
    [anon_sym_throw] = ACTIONS(3784),
    [anon_sym_protected] = ACTIONS(3784),
    [anon_sym_abstract] = ACTIONS(3784),
    [anon_sym_set] = ACTIONS(3784),
    [anon_sym_type] = ACTIONS(3784),
    [anon_sym_import] = ACTIONS(3784),
    [anon_sym_namespace] = ACTIONS(3784),
    [anon_sym_PLUS_PLUS] = ACTIONS(3786),
    [anon_sym_await] = ACTIONS(3784),
    [anon_sym_DQUOTE] = ACTIONS(3786),
    [anon_sym_else] = ACTIONS(3784),
    [anon_sym_BANG] = ACTIONS(3786),
    [anon_sym_for] = ACTIONS(3784),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [sym_false] = ACTIONS(3784),
    [anon_sym_SEMI] = ACTIONS(3786),
    [anon_sym_case] = ACTIONS(3784),
    [anon_sym_module] = ACTIONS(3784),
    [anon_sym_number] = ACTIONS(3784),
    [anon_sym_class] = ACTIONS(3784),
    [anon_sym_declare] = ACTIONS(3784),
    [anon_sym_typeof] = ACTIONS(3784),
    [anon_sym_LBRACE] = ACTIONS(3786),
    [anon_sym_switch] = ACTIONS(3784),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [sym_null] = ACTIONS(3784),
    [anon_sym_any] = ACTIONS(3784),
    [anon_sym_boolean] = ACTIONS(3784),
    [anon_sym_async] = ACTIONS(3784),
    [anon_sym_public] = ACTIONS(3784),
    [anon_sym_var] = ACTIONS(3784),
    [anon_sym_while] = ACTIONS(3784),
    [anon_sym_SQUOTE] = ACTIONS(3786),
    [anon_sym_try] = ACTIONS(3784),
    [anon_sym_LT] = ACTIONS(3786),
    [sym_number] = ACTIONS(3786),
    [anon_sym_SLASH] = ACTIONS(3784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3784),
    [anon_sym_function] = ACTIONS(3784),
    [sym_undefined] = ACTIONS(3784),
    [anon_sym_new] = ACTIONS(3784),
    [ts_builtin_sym_end] = ACTIONS(3786),
    [anon_sym_let] = ACTIONS(3784),
    [anon_sym_PLUS] = ACTIONS(3784),
    [anon_sym_export] = ACTIONS(3784),
    [anon_sym_do] = ACTIONS(3784),
    [anon_sym_TILDE] = ACTIONS(3786),
    [anon_sym_with] = ACTIONS(3784),
  },
  [1117] = {
    [sym_type_annotation] = STATE(1159),
    [anon_sym_COLON] = ACTIONS(719),
    [sym_comment] = ACTIONS(3),
  },
  [1118] = {
    [sym_type_annotation] = STATE(1160),
    [anon_sym_COLON] = ACTIONS(719),
    [sym_comment] = ACTIONS(3),
  },
  [1119] = {
    [sym_statement_block] = STATE(1477),
    [sym__automatic_semicolon] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3788),
    [anon_sym_COMMA] = ACTIONS(3788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2772),
  },
  [1120] = {
    [sym_call_signature] = STATE(1161),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [1121] = {
    [sym_call_signature] = STATE(1161),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(3790),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [1122] = {
    [sym__automatic_semicolon] = ACTIONS(3792),
    [anon_sym_SEMI] = ACTIONS(3792),
    [anon_sym_COMMA] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
  },
  [1123] = {
    [sym__initializer] = STATE(1163),
    [sym__automatic_semicolon] = ACTIONS(3792),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(3792),
    [anon_sym_COMMA] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
  },
  [1124] = {
    [sym__automatic_semicolon] = ACTIONS(3794),
    [anon_sym_SEMI] = ACTIONS(3794),
    [anon_sym_COMMA] = ACTIONS(3794),
    [sym_comment] = ACTIONS(3),
  },
  [1125] = {
    [sym_string] = STATE(1164),
    [sym__property_name] = STATE(1164),
    [sym_computed_property_name] = STATE(1164),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1126] = {
    [sym_string] = STATE(1164),
    [sym__property_name] = STATE(1164),
    [sym_computed_property_name] = STATE(1164),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(3796),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1127] = {
    [sym_call_signature] = STATE(1161),
    [sym__initializer] = STATE(1163),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym_type_annotation] = STATE(1165),
    [sym__automatic_semicolon] = ACTIONS(3792),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3792),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
  },
  [1128] = {
    [sym__initializer] = STATE(1163),
    [sym_type_annotation] = STATE(1165),
    [sym__automatic_semicolon] = ACTIONS(3792),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3792),
    [anon_sym_COMMA] = ACTIONS(3792),
    [sym_comment] = ACTIONS(3),
  },
  [1129] = {
    [sym_call_signature] = STATE(1166),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [1130] = {
    [anon_sym_COMMA] = ACTIONS(3798),
    [anon_sym_RBRACE] = ACTIONS(3798),
    [sym_comment] = ACTIONS(3),
  },
  [1131] = {
    [sym_statement_block] = STATE(1167),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [1132] = {
    [sym_call_signature] = STATE(1168),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [1133] = {
    [sym_call_signature] = STATE(1168),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [1134] = {
    [sym_type_alias_declaration] = STATE(266),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(266),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(266),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(266),
    [sym_return_statement] = STATE(266),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(266),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(266),
    [sym_switch_statement] = STATE(266),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(266),
    [sym_throw_statement] = STATE(266),
    [aux_sym_program_repeat1] = STATE(266),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(266),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(266),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(266),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(266),
    [sym_abstract_class] = STATE(266),
    [sym_interface_declaration] = STATE(266),
    [sym_statement_block] = STATE(266),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(266),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(266),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(266),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(266),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(266),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(266),
    [sym_empty_statement] = STATE(266),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(266),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(266),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(266),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(266),
    [sym_break_statement] = STATE(266),
    [sym_labeled_statement] = STATE(266),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(266),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(3802),
    [anon_sym_default] = ACTIONS(3804),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(3804),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1135] = {
    [anon_sym_COMMA] = ACTIONS(3806),
    [anon_sym_RPAREN] = ACTIONS(3806),
    [sym_comment] = ACTIONS(3),
  },
  [1136] = {
    [anon_sym_COMMA] = ACTIONS(3808),
    [anon_sym_RPAREN] = ACTIONS(3808),
    [sym_comment] = ACTIONS(3),
  },
  [1137] = {
    [anon_sym_COMMA] = ACTIONS(3810),
    [anon_sym_RPAREN] = ACTIONS(3810),
    [sym_comment] = ACTIONS(3),
  },
  [1138] = {
    [anon_sym_COMMA] = ACTIONS(3812),
    [anon_sym_RPAREN] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
  },
  [1139] = {
    [sym_identifier] = ACTIONS(3814),
    [anon_sym_BQUOTE] = ACTIONS(3816),
    [anon_sym_debugger] = ACTIONS(3814),
    [anon_sym_symbol] = ACTIONS(3814),
    [anon_sym_AT] = ACTIONS(3816),
    [anon_sym_DASH] = ACTIONS(3814),
    [anon_sym_void] = ACTIONS(3814),
    [anon_sym_break] = ACTIONS(3814),
    [anon_sym_const] = ACTIONS(3814),
    [sym_super] = ACTIONS(3814),
    [anon_sym_return] = ACTIONS(3814),
    [anon_sym_private] = ACTIONS(3814),
    [anon_sym_get] = ACTIONS(3814),
    [anon_sym_RBRACE] = ACTIONS(3816),
    [anon_sym_interface] = ACTIONS(3814),
    [anon_sym_default] = ACTIONS(3814),
    [anon_sym_enum] = ACTIONS(3814),
    [anon_sym_delete] = ACTIONS(3814),
    [anon_sym_continue] = ACTIONS(3814),
    [anon_sym_DASH_DASH] = ACTIONS(3816),
    [anon_sym_if] = ACTIONS(3814),
    [anon_sym_this] = ACTIONS(3814),
    [anon_sym_yield] = ACTIONS(3814),
    [sym_true] = ACTIONS(3814),
    [anon_sym_throw] = ACTIONS(3814),
    [anon_sym_protected] = ACTIONS(3814),
    [anon_sym_abstract] = ACTIONS(3814),
    [anon_sym_set] = ACTIONS(3814),
    [anon_sym_type] = ACTIONS(3814),
    [anon_sym_import] = ACTIONS(3814),
    [anon_sym_namespace] = ACTIONS(3814),
    [anon_sym_PLUS_PLUS] = ACTIONS(3816),
    [anon_sym_await] = ACTIONS(3814),
    [anon_sym_DQUOTE] = ACTIONS(3816),
    [anon_sym_else] = ACTIONS(3814),
    [anon_sym_BANG] = ACTIONS(3816),
    [anon_sym_for] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3816),
    [sym_false] = ACTIONS(3814),
    [anon_sym_SEMI] = ACTIONS(3816),
    [anon_sym_case] = ACTIONS(3814),
    [anon_sym_module] = ACTIONS(3814),
    [anon_sym_number] = ACTIONS(3814),
    [anon_sym_class] = ACTIONS(3814),
    [anon_sym_declare] = ACTIONS(3814),
    [anon_sym_typeof] = ACTIONS(3814),
    [anon_sym_LBRACE] = ACTIONS(3816),
    [anon_sym_switch] = ACTIONS(3814),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [sym_null] = ACTIONS(3814),
    [anon_sym_any] = ACTIONS(3814),
    [anon_sym_boolean] = ACTIONS(3814),
    [anon_sym_async] = ACTIONS(3814),
    [anon_sym_public] = ACTIONS(3814),
    [anon_sym_var] = ACTIONS(3814),
    [anon_sym_while] = ACTIONS(3814),
    [anon_sym_SQUOTE] = ACTIONS(3816),
    [anon_sym_try] = ACTIONS(3814),
    [anon_sym_LT] = ACTIONS(3816),
    [sym_number] = ACTIONS(3816),
    [anon_sym_SLASH] = ACTIONS(3814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(3814),
    [anon_sym_string] = ACTIONS(3814),
    [anon_sym_function] = ACTIONS(3814),
    [sym_undefined] = ACTIONS(3814),
    [anon_sym_new] = ACTIONS(3814),
    [ts_builtin_sym_end] = ACTIONS(3816),
    [anon_sym_let] = ACTIONS(3814),
    [anon_sym_PLUS] = ACTIONS(3814),
    [anon_sym_export] = ACTIONS(3814),
    [anon_sym_do] = ACTIONS(3814),
    [anon_sym_TILDE] = ACTIONS(3816),
    [anon_sym_with] = ACTIONS(3814),
  },
  [1140] = {
    [anon_sym_BQUOTE] = ACTIONS(3818),
    [anon_sym_symbol] = ACTIONS(3820),
    [anon_sym_PIPE] = ACTIONS(3818),
    [anon_sym_break] = ACTIONS(3820),
    [anon_sym_return] = ACTIONS(3820),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_interface] = ACTIONS(3820),
    [anon_sym_delete] = ACTIONS(3820),
    [anon_sym_if] = ACTIONS(3820),
    [anon_sym_yield] = ACTIONS(3820),
    [sym_true] = ACTIONS(3820),
    [anon_sym_protected] = ACTIONS(3820),
    [anon_sym_set] = ACTIONS(3820),
    [anon_sym_import] = ACTIONS(3820),
    [anon_sym_await] = ACTIONS(3820),
    [anon_sym_DQUOTE] = ACTIONS(3818),
    [anon_sym_for] = ACTIONS(3820),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_number] = ACTIONS(3820),
    [anon_sym_typeof] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_switch] = ACTIONS(3820),
    [anon_sym_RBRACK] = ACTIONS(3818),
    [sym_null] = ACTIONS(3820),
    [anon_sym_any] = ACTIONS(3820),
    [anon_sym_async] = ACTIONS(3820),
    [anon_sym_public] = ACTIONS(3820),
    [anon_sym_var] = ACTIONS(3820),
    [anon_sym_while] = ACTIONS(3820),
    [anon_sym_SQUOTE] = ACTIONS(3818),
    [anon_sym_RPAREN] = ACTIONS(3818),
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3820),
    [anon_sym_new] = ACTIONS(3820),
    [anon_sym_export] = ACTIONS(3820),
    [anon_sym_with] = ACTIONS(3820),
    [sym_identifier] = ACTIONS(3820),
    [anon_sym_debugger] = ACTIONS(3820),
    [anon_sym_AT] = ACTIONS(3818),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_void] = ACTIONS(3820),
    [anon_sym_const] = ACTIONS(3820),
    [sym_super] = ACTIONS(3820),
    [anon_sym_private] = ACTIONS(3820),
    [anon_sym_get] = ACTIONS(3820),
    [anon_sym_default] = ACTIONS(3820),
    [anon_sym_enum] = ACTIONS(3820),
    [anon_sym_continue] = ACTIONS(3820),
    [anon_sym_DASH_DASH] = ACTIONS(3818),
    [anon_sym_this] = ACTIONS(3820),
    [anon_sym_throw] = ACTIONS(3820),
    [anon_sym_abstract] = ACTIONS(3820),
    [anon_sym_type] = ACTIONS(3820),
    [anon_sym_namespace] = ACTIONS(3820),
    [anon_sym_PLUS_PLUS] = ACTIONS(3818),
    [anon_sym_else] = ACTIONS(3820),
    [anon_sym_BANG] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [sym_false] = ACTIONS(3820),
    [anon_sym_case] = ACTIONS(3820),
    [anon_sym_module] = ACTIONS(3820),
    [anon_sym_class] = ACTIONS(3820),
    [anon_sym_declare] = ACTIONS(3820),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_GT] = ACTIONS(3818),
    [anon_sym_boolean] = ACTIONS(3820),
    [anon_sym_EQ_GT] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_try] = ACTIONS(3820),
    [anon_sym_LT] = ACTIONS(3818),
    [sym_number] = ACTIONS(3818),
    [ts_builtin_sym_end] = ACTIONS(3818),
    [anon_sym_function] = ACTIONS(3820),
    [sym_undefined] = ACTIONS(3820),
    [anon_sym_let] = ACTIONS(3820),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_do] = ACTIONS(3820),
    [anon_sym_TILDE] = ACTIONS(3818),
  },
  [1141] = {
    [sym__automatic_semicolon] = ACTIONS(3788),
    [anon_sym_RBRACE] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3788),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3788),
    [sym_comment] = ACTIONS(3),
  },
  [1142] = {
    [sym_call_signature] = STATE(1170),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [1143] = {
    [sym_call_signature] = STATE(1170),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(3822),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [1144] = {
    [sym__automatic_semicolon] = ACTIONS(3824),
    [anon_sym_RBRACE] = ACTIONS(3824),
    [anon_sym_SEMI] = ACTIONS(3824),
    [anon_sym_COMMA] = ACTIONS(3824),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3824),
    [sym_comment] = ACTIONS(3),
  },
  [1145] = {
    [sym_string] = STATE(1172),
    [sym__property_name] = STATE(1172),
    [sym_computed_property_name] = STATE(1172),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1146] = {
    [sym_string] = STATE(1172),
    [sym__property_name] = STATE(1172),
    [sym_computed_property_name] = STATE(1172),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(3826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1147] = {
    [sym_call_signature] = STATE(1170),
    [sym_type_annotation] = STATE(1173),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(3824),
    [anon_sym_RBRACE] = ACTIONS(3824),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3824),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3824),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3824),
    [sym_comment] = ACTIONS(3),
  },
  [1148] = {
    [sym_call_signature] = STATE(1938),
    [sym_type_annotation] = STATE(1144),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(3715),
    [anon_sym_RBRACE] = ACTIONS(3715),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
  },
  [1149] = {
    [sym_call_signature] = STATE(1938),
    [sym_type_annotation] = STATE(1144),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(3715),
    [anon_sym_RBRACE] = ACTIONS(3715),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3715),
    [anon_sym_QMARK] = ACTIONS(3828),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3715),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3715),
    [sym_comment] = ACTIONS(3),
  },
  [1150] = {
    [sym_type_alias_declaration] = STATE(1175),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1175),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1175),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1175),
    [sym_return_statement] = STATE(1175),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1175),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1175),
    [sym_switch_statement] = STATE(1175),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1175),
    [sym_throw_statement] = STATE(1175),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1175),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1175),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1175),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1175),
    [sym_abstract_class] = STATE(1175),
    [sym_interface_declaration] = STATE(1175),
    [sym_statement_block] = STATE(1175),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1175),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1175),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1175),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1175),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1175),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1175),
    [sym_empty_statement] = STATE(1175),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1175),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1175),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1175),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1175),
    [sym_break_statement] = STATE(1175),
    [sym_labeled_statement] = STATE(1175),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1175),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1151] = {
    [sym_type_alias_declaration] = STATE(1176),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1176),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1176),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1176),
    [sym_return_statement] = STATE(1176),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1176),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1176),
    [sym_switch_statement] = STATE(1176),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1176),
    [sym_throw_statement] = STATE(1176),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1176),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1176),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1176),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1176),
    [sym_abstract_class] = STATE(1176),
    [sym_interface_declaration] = STATE(1176),
    [sym_statement_block] = STATE(1176),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1176),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1176),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1176),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1176),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1176),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1176),
    [sym_empty_statement] = STATE(1176),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1176),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1176),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1176),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1176),
    [sym_break_statement] = STATE(1176),
    [sym_labeled_statement] = STATE(1176),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1176),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1152] = {
    [sym_type_alias_declaration] = STATE(1177),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1177),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1177),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1177),
    [sym_return_statement] = STATE(1177),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1177),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1177),
    [sym_switch_statement] = STATE(1177),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1177),
    [sym_throw_statement] = STATE(1177),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1177),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1177),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1177),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1177),
    [sym_abstract_class] = STATE(1177),
    [sym_interface_declaration] = STATE(1177),
    [sym_statement_block] = STATE(1177),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1177),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1177),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1177),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1177),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1177),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1177),
    [sym_empty_statement] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1177),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1177),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1177),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1177),
    [sym_break_statement] = STATE(1177),
    [sym_labeled_statement] = STATE(1177),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1177),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1153] = {
    [sym_identifier] = ACTIONS(3830),
    [anon_sym_BQUOTE] = ACTIONS(3832),
    [anon_sym_debugger] = ACTIONS(3830),
    [anon_sym_symbol] = ACTIONS(3830),
    [anon_sym_AT] = ACTIONS(3832),
    [anon_sym_DASH] = ACTIONS(3830),
    [anon_sym_void] = ACTIONS(3830),
    [anon_sym_break] = ACTIONS(3830),
    [anon_sym_const] = ACTIONS(3830),
    [sym_super] = ACTIONS(3830),
    [anon_sym_return] = ACTIONS(3830),
    [anon_sym_private] = ACTIONS(3830),
    [anon_sym_get] = ACTIONS(3830),
    [anon_sym_RBRACE] = ACTIONS(3832),
    [anon_sym_interface] = ACTIONS(3830),
    [anon_sym_default] = ACTIONS(3830),
    [anon_sym_enum] = ACTIONS(3830),
    [anon_sym_delete] = ACTIONS(3830),
    [anon_sym_continue] = ACTIONS(3830),
    [anon_sym_DASH_DASH] = ACTIONS(3832),
    [anon_sym_if] = ACTIONS(3830),
    [anon_sym_this] = ACTIONS(3830),
    [anon_sym_yield] = ACTIONS(3830),
    [sym_true] = ACTIONS(3830),
    [anon_sym_throw] = ACTIONS(3830),
    [anon_sym_protected] = ACTIONS(3830),
    [anon_sym_abstract] = ACTIONS(3830),
    [anon_sym_set] = ACTIONS(3830),
    [anon_sym_type] = ACTIONS(3830),
    [anon_sym_import] = ACTIONS(3830),
    [anon_sym_namespace] = ACTIONS(3830),
    [anon_sym_PLUS_PLUS] = ACTIONS(3832),
    [anon_sym_await] = ACTIONS(3830),
    [anon_sym_DQUOTE] = ACTIONS(3832),
    [anon_sym_else] = ACTIONS(3830),
    [anon_sym_BANG] = ACTIONS(3832),
    [anon_sym_for] = ACTIONS(3830),
    [anon_sym_LBRACK] = ACTIONS(3832),
    [sym_false] = ACTIONS(3830),
    [anon_sym_SEMI] = ACTIONS(3832),
    [anon_sym_case] = ACTIONS(3830),
    [anon_sym_module] = ACTIONS(3830),
    [anon_sym_number] = ACTIONS(3830),
    [anon_sym_class] = ACTIONS(3830),
    [anon_sym_declare] = ACTIONS(3830),
    [anon_sym_typeof] = ACTIONS(3830),
    [anon_sym_LBRACE] = ACTIONS(3832),
    [anon_sym_switch] = ACTIONS(3830),
    [anon_sym_LPAREN] = ACTIONS(3832),
    [sym_null] = ACTIONS(3830),
    [anon_sym_any] = ACTIONS(3830),
    [anon_sym_boolean] = ACTIONS(3830),
    [anon_sym_async] = ACTIONS(3830),
    [anon_sym_public] = ACTIONS(3830),
    [anon_sym_var] = ACTIONS(3830),
    [anon_sym_while] = ACTIONS(3830),
    [anon_sym_SQUOTE] = ACTIONS(3832),
    [anon_sym_try] = ACTIONS(3830),
    [anon_sym_LT] = ACTIONS(3832),
    [sym_number] = ACTIONS(3832),
    [anon_sym_SLASH] = ACTIONS(3830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3830),
    [anon_sym_function] = ACTIONS(3830),
    [sym_undefined] = ACTIONS(3830),
    [anon_sym_new] = ACTIONS(3830),
    [ts_builtin_sym_end] = ACTIONS(3832),
    [anon_sym_let] = ACTIONS(3830),
    [anon_sym_PLUS] = ACTIONS(3830),
    [anon_sym_export] = ACTIONS(3830),
    [anon_sym_do] = ACTIONS(3830),
    [anon_sym_TILDE] = ACTIONS(3832),
    [anon_sym_with] = ACTIONS(3830),
  },
  [1154] = {
    [sym_identifier] = ACTIONS(3834),
    [anon_sym_BQUOTE] = ACTIONS(3836),
    [anon_sym_debugger] = ACTIONS(3834),
    [anon_sym_symbol] = ACTIONS(3834),
    [anon_sym_AT] = ACTIONS(3836),
    [anon_sym_DASH] = ACTIONS(3834),
    [anon_sym_void] = ACTIONS(3834),
    [anon_sym_break] = ACTIONS(3834),
    [anon_sym_const] = ACTIONS(3834),
    [sym_super] = ACTIONS(3834),
    [anon_sym_return] = ACTIONS(3834),
    [anon_sym_private] = ACTIONS(3834),
    [anon_sym_get] = ACTIONS(3834),
    [anon_sym_RBRACE] = ACTIONS(3836),
    [anon_sym_interface] = ACTIONS(3834),
    [anon_sym_default] = ACTIONS(3834),
    [anon_sym_enum] = ACTIONS(3834),
    [anon_sym_delete] = ACTIONS(3834),
    [anon_sym_continue] = ACTIONS(3834),
    [anon_sym_DASH_DASH] = ACTIONS(3836),
    [anon_sym_if] = ACTIONS(3834),
    [anon_sym_this] = ACTIONS(3834),
    [anon_sym_yield] = ACTIONS(3834),
    [sym_true] = ACTIONS(3834),
    [anon_sym_throw] = ACTIONS(3834),
    [anon_sym_protected] = ACTIONS(3834),
    [anon_sym_abstract] = ACTIONS(3834),
    [anon_sym_set] = ACTIONS(3834),
    [anon_sym_type] = ACTIONS(3834),
    [anon_sym_import] = ACTIONS(3834),
    [anon_sym_namespace] = ACTIONS(3834),
    [anon_sym_PLUS_PLUS] = ACTIONS(3836),
    [anon_sym_await] = ACTIONS(3834),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_else] = ACTIONS(3834),
    [anon_sym_BANG] = ACTIONS(3836),
    [anon_sym_for] = ACTIONS(3834),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [sym_false] = ACTIONS(3834),
    [anon_sym_SEMI] = ACTIONS(3836),
    [anon_sym_case] = ACTIONS(3834),
    [anon_sym_module] = ACTIONS(3834),
    [anon_sym_number] = ACTIONS(3834),
    [anon_sym_class] = ACTIONS(3834),
    [anon_sym_declare] = ACTIONS(3834),
    [anon_sym_typeof] = ACTIONS(3834),
    [anon_sym_LBRACE] = ACTIONS(3836),
    [anon_sym_switch] = ACTIONS(3834),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [sym_null] = ACTIONS(3834),
    [anon_sym_any] = ACTIONS(3834),
    [anon_sym_boolean] = ACTIONS(3834),
    [anon_sym_async] = ACTIONS(3834),
    [anon_sym_public] = ACTIONS(3834),
    [anon_sym_var] = ACTIONS(3834),
    [anon_sym_while] = ACTIONS(3834),
    [anon_sym_SQUOTE] = ACTIONS(3836),
    [anon_sym_try] = ACTIONS(3834),
    [anon_sym_LT] = ACTIONS(3836),
    [sym_number] = ACTIONS(3836),
    [anon_sym_SLASH] = ACTIONS(3834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3834),
    [anon_sym_function] = ACTIONS(3834),
    [sym_undefined] = ACTIONS(3834),
    [anon_sym_new] = ACTIONS(3834),
    [ts_builtin_sym_end] = ACTIONS(3836),
    [anon_sym_let] = ACTIONS(3834),
    [anon_sym_PLUS] = ACTIONS(3834),
    [anon_sym_export] = ACTIONS(3834),
    [anon_sym_do] = ACTIONS(3834),
    [anon_sym_TILDE] = ACTIONS(3836),
    [anon_sym_with] = ACTIONS(3834),
  },
  [1155] = {
    [sym_identifier] = ACTIONS(3838),
    [anon_sym_BQUOTE] = ACTIONS(3840),
    [anon_sym_debugger] = ACTIONS(3838),
    [anon_sym_symbol] = ACTIONS(3838),
    [anon_sym_AT] = ACTIONS(3840),
    [anon_sym_DASH] = ACTIONS(3838),
    [anon_sym_void] = ACTIONS(3838),
    [anon_sym_break] = ACTIONS(3838),
    [anon_sym_const] = ACTIONS(3838),
    [sym_super] = ACTIONS(3838),
    [anon_sym_return] = ACTIONS(3838),
    [anon_sym_private] = ACTIONS(3838),
    [anon_sym_get] = ACTIONS(3838),
    [anon_sym_RBRACE] = ACTIONS(3840),
    [anon_sym_interface] = ACTIONS(3838),
    [anon_sym_default] = ACTIONS(3838),
    [anon_sym_enum] = ACTIONS(3838),
    [anon_sym_delete] = ACTIONS(3838),
    [anon_sym_continue] = ACTIONS(3838),
    [anon_sym_DASH_DASH] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(3838),
    [anon_sym_this] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3838),
    [sym_true] = ACTIONS(3838),
    [anon_sym_throw] = ACTIONS(3838),
    [anon_sym_protected] = ACTIONS(3838),
    [anon_sym_abstract] = ACTIONS(3838),
    [anon_sym_set] = ACTIONS(3838),
    [anon_sym_type] = ACTIONS(3838),
    [anon_sym_import] = ACTIONS(3838),
    [anon_sym_namespace] = ACTIONS(3838),
    [anon_sym_PLUS_PLUS] = ACTIONS(3840),
    [anon_sym_await] = ACTIONS(3838),
    [anon_sym_DQUOTE] = ACTIONS(3840),
    [anon_sym_else] = ACTIONS(3838),
    [anon_sym_BANG] = ACTIONS(3840),
    [anon_sym_for] = ACTIONS(3838),
    [anon_sym_LBRACK] = ACTIONS(3840),
    [sym_false] = ACTIONS(3838),
    [anon_sym_SEMI] = ACTIONS(3840),
    [anon_sym_case] = ACTIONS(3838),
    [anon_sym_module] = ACTIONS(3838),
    [anon_sym_number] = ACTIONS(3838),
    [anon_sym_class] = ACTIONS(3838),
    [anon_sym_declare] = ACTIONS(3838),
    [anon_sym_typeof] = ACTIONS(3838),
    [anon_sym_LBRACE] = ACTIONS(3840),
    [anon_sym_switch] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3840),
    [sym_null] = ACTIONS(3838),
    [anon_sym_any] = ACTIONS(3838),
    [anon_sym_boolean] = ACTIONS(3838),
    [anon_sym_async] = ACTIONS(3838),
    [anon_sym_public] = ACTIONS(3838),
    [anon_sym_var] = ACTIONS(3838),
    [anon_sym_while] = ACTIONS(3838),
    [anon_sym_SQUOTE] = ACTIONS(3840),
    [anon_sym_try] = ACTIONS(3838),
    [anon_sym_LT] = ACTIONS(3840),
    [sym_number] = ACTIONS(3840),
    [anon_sym_SLASH] = ACTIONS(3838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3838),
    [anon_sym_function] = ACTIONS(3838),
    [sym_undefined] = ACTIONS(3838),
    [anon_sym_new] = ACTIONS(3838),
    [ts_builtin_sym_end] = ACTIONS(3840),
    [anon_sym_let] = ACTIONS(3838),
    [anon_sym_PLUS] = ACTIONS(3838),
    [anon_sym_export] = ACTIONS(3838),
    [anon_sym_do] = ACTIONS(3838),
    [anon_sym_TILDE] = ACTIONS(3840),
    [anon_sym_with] = ACTIONS(3838),
  },
  [1156] = {
    [sym_identifier] = ACTIONS(3842),
    [anon_sym_BQUOTE] = ACTIONS(3844),
    [anon_sym_debugger] = ACTIONS(3842),
    [anon_sym_symbol] = ACTIONS(3842),
    [anon_sym_AT] = ACTIONS(3844),
    [anon_sym_DASH] = ACTIONS(3842),
    [anon_sym_void] = ACTIONS(3842),
    [anon_sym_break] = ACTIONS(3842),
    [anon_sym_const] = ACTIONS(3842),
    [sym_super] = ACTIONS(3842),
    [anon_sym_return] = ACTIONS(3842),
    [anon_sym_private] = ACTIONS(3842),
    [anon_sym_get] = ACTIONS(3842),
    [anon_sym_RBRACE] = ACTIONS(3844),
    [anon_sym_interface] = ACTIONS(3842),
    [anon_sym_default] = ACTIONS(3842),
    [anon_sym_enum] = ACTIONS(3842),
    [anon_sym_delete] = ACTIONS(3842),
    [anon_sym_continue] = ACTIONS(3842),
    [anon_sym_DASH_DASH] = ACTIONS(3844),
    [anon_sym_if] = ACTIONS(3842),
    [anon_sym_this] = ACTIONS(3842),
    [anon_sym_yield] = ACTIONS(3842),
    [sym_true] = ACTIONS(3842),
    [anon_sym_throw] = ACTIONS(3842),
    [anon_sym_protected] = ACTIONS(3842),
    [anon_sym_abstract] = ACTIONS(3842),
    [anon_sym_set] = ACTIONS(3842),
    [anon_sym_type] = ACTIONS(3842),
    [anon_sym_import] = ACTIONS(3842),
    [anon_sym_namespace] = ACTIONS(3842),
    [anon_sym_PLUS_PLUS] = ACTIONS(3844),
    [anon_sym_await] = ACTIONS(3842),
    [anon_sym_DQUOTE] = ACTIONS(3844),
    [anon_sym_else] = ACTIONS(3842),
    [anon_sym_BANG] = ACTIONS(3844),
    [anon_sym_for] = ACTIONS(3842),
    [anon_sym_LBRACK] = ACTIONS(3844),
    [sym_false] = ACTIONS(3842),
    [anon_sym_SEMI] = ACTIONS(3844),
    [anon_sym_case] = ACTIONS(3842),
    [anon_sym_module] = ACTIONS(3842),
    [anon_sym_number] = ACTIONS(3842),
    [anon_sym_class] = ACTIONS(3842),
    [anon_sym_declare] = ACTIONS(3842),
    [anon_sym_typeof] = ACTIONS(3842),
    [anon_sym_LBRACE] = ACTIONS(3844),
    [anon_sym_switch] = ACTIONS(3842),
    [anon_sym_LPAREN] = ACTIONS(3844),
    [sym_null] = ACTIONS(3842),
    [anon_sym_any] = ACTIONS(3842),
    [anon_sym_boolean] = ACTIONS(3842),
    [anon_sym_async] = ACTIONS(3842),
    [anon_sym_public] = ACTIONS(3842),
    [anon_sym_var] = ACTIONS(3842),
    [anon_sym_while] = ACTIONS(3842),
    [anon_sym_SQUOTE] = ACTIONS(3844),
    [anon_sym_try] = ACTIONS(3842),
    [anon_sym_LT] = ACTIONS(3844),
    [sym_number] = ACTIONS(3844),
    [anon_sym_SLASH] = ACTIONS(3842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3842),
    [anon_sym_function] = ACTIONS(3842),
    [sym_undefined] = ACTIONS(3842),
    [anon_sym_new] = ACTIONS(3842),
    [ts_builtin_sym_end] = ACTIONS(3844),
    [anon_sym_let] = ACTIONS(3842),
    [anon_sym_PLUS] = ACTIONS(3842),
    [anon_sym_export] = ACTIONS(3842),
    [anon_sym_do] = ACTIONS(3842),
    [anon_sym_TILDE] = ACTIONS(3844),
    [anon_sym_with] = ACTIONS(3842),
  },
  [1157] = {
    [sym_identifier] = ACTIONS(3846),
    [anon_sym_BQUOTE] = ACTIONS(3848),
    [anon_sym_debugger] = ACTIONS(3846),
    [anon_sym_symbol] = ACTIONS(3846),
    [anon_sym_AT] = ACTIONS(3848),
    [anon_sym_DASH] = ACTIONS(3846),
    [anon_sym_void] = ACTIONS(3846),
    [anon_sym_break] = ACTIONS(3846),
    [anon_sym_const] = ACTIONS(3846),
    [sym_super] = ACTIONS(3846),
    [anon_sym_return] = ACTIONS(3846),
    [anon_sym_private] = ACTIONS(3846),
    [anon_sym_get] = ACTIONS(3846),
    [anon_sym_RBRACE] = ACTIONS(3848),
    [anon_sym_interface] = ACTIONS(3846),
    [anon_sym_default] = ACTIONS(3846),
    [anon_sym_enum] = ACTIONS(3846),
    [anon_sym_delete] = ACTIONS(3846),
    [anon_sym_continue] = ACTIONS(3846),
    [anon_sym_DASH_DASH] = ACTIONS(3848),
    [anon_sym_if] = ACTIONS(3846),
    [anon_sym_this] = ACTIONS(3846),
    [anon_sym_yield] = ACTIONS(3846),
    [sym_true] = ACTIONS(3846),
    [anon_sym_throw] = ACTIONS(3846),
    [anon_sym_protected] = ACTIONS(3846),
    [anon_sym_abstract] = ACTIONS(3846),
    [anon_sym_set] = ACTIONS(3846),
    [anon_sym_type] = ACTIONS(3846),
    [anon_sym_import] = ACTIONS(3846),
    [anon_sym_namespace] = ACTIONS(3846),
    [anon_sym_PLUS_PLUS] = ACTIONS(3848),
    [anon_sym_await] = ACTIONS(3846),
    [anon_sym_DQUOTE] = ACTIONS(3848),
    [anon_sym_else] = ACTIONS(3846),
    [anon_sym_BANG] = ACTIONS(3848),
    [anon_sym_for] = ACTIONS(3846),
    [anon_sym_LBRACK] = ACTIONS(3848),
    [sym_false] = ACTIONS(3846),
    [anon_sym_SEMI] = ACTIONS(3848),
    [anon_sym_case] = ACTIONS(3846),
    [anon_sym_module] = ACTIONS(3846),
    [anon_sym_number] = ACTIONS(3846),
    [anon_sym_class] = ACTIONS(3846),
    [anon_sym_declare] = ACTIONS(3846),
    [anon_sym_typeof] = ACTIONS(3846),
    [anon_sym_LBRACE] = ACTIONS(3848),
    [anon_sym_switch] = ACTIONS(3846),
    [anon_sym_LPAREN] = ACTIONS(3848),
    [sym_null] = ACTIONS(3846),
    [anon_sym_any] = ACTIONS(3846),
    [anon_sym_boolean] = ACTIONS(3846),
    [anon_sym_async] = ACTIONS(3846),
    [anon_sym_public] = ACTIONS(3846),
    [anon_sym_var] = ACTIONS(3846),
    [anon_sym_while] = ACTIONS(3846),
    [anon_sym_SQUOTE] = ACTIONS(3848),
    [anon_sym_try] = ACTIONS(3846),
    [anon_sym_LT] = ACTIONS(3848),
    [sym_number] = ACTIONS(3848),
    [anon_sym_SLASH] = ACTIONS(3846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3846),
    [anon_sym_function] = ACTIONS(3846),
    [sym_undefined] = ACTIONS(3846),
    [anon_sym_new] = ACTIONS(3846),
    [ts_builtin_sym_end] = ACTIONS(3848),
    [anon_sym_let] = ACTIONS(3846),
    [anon_sym_PLUS] = ACTIONS(3846),
    [anon_sym_export] = ACTIONS(3846),
    [anon_sym_do] = ACTIONS(3846),
    [anon_sym_TILDE] = ACTIONS(3848),
    [anon_sym_with] = ACTIONS(3846),
  },
  [1158] = {
    [sym_identifier] = ACTIONS(3850),
    [anon_sym_BQUOTE] = ACTIONS(3852),
    [anon_sym_debugger] = ACTIONS(3850),
    [anon_sym_symbol] = ACTIONS(3850),
    [anon_sym_AT] = ACTIONS(3852),
    [anon_sym_DASH] = ACTIONS(3850),
    [anon_sym_void] = ACTIONS(3850),
    [anon_sym_break] = ACTIONS(3850),
    [anon_sym_const] = ACTIONS(3850),
    [sym_super] = ACTIONS(3850),
    [anon_sym_return] = ACTIONS(3850),
    [anon_sym_private] = ACTIONS(3850),
    [anon_sym_get] = ACTIONS(3850),
    [anon_sym_RBRACE] = ACTIONS(3852),
    [anon_sym_interface] = ACTIONS(3850),
    [anon_sym_default] = ACTIONS(3850),
    [anon_sym_enum] = ACTIONS(3850),
    [anon_sym_delete] = ACTIONS(3850),
    [anon_sym_continue] = ACTIONS(3850),
    [anon_sym_DASH_DASH] = ACTIONS(3852),
    [anon_sym_if] = ACTIONS(3850),
    [anon_sym_this] = ACTIONS(3850),
    [anon_sym_yield] = ACTIONS(3850),
    [sym_true] = ACTIONS(3850),
    [anon_sym_throw] = ACTIONS(3850),
    [anon_sym_protected] = ACTIONS(3850),
    [anon_sym_abstract] = ACTIONS(3850),
    [anon_sym_set] = ACTIONS(3850),
    [anon_sym_type] = ACTIONS(3850),
    [anon_sym_import] = ACTIONS(3850),
    [anon_sym_namespace] = ACTIONS(3850),
    [anon_sym_PLUS_PLUS] = ACTIONS(3852),
    [anon_sym_await] = ACTIONS(3850),
    [anon_sym_DQUOTE] = ACTIONS(3852),
    [anon_sym_else] = ACTIONS(3850),
    [anon_sym_BANG] = ACTIONS(3852),
    [anon_sym_for] = ACTIONS(3850),
    [anon_sym_LBRACK] = ACTIONS(3852),
    [sym_false] = ACTIONS(3850),
    [anon_sym_SEMI] = ACTIONS(3852),
    [anon_sym_case] = ACTIONS(3850),
    [anon_sym_module] = ACTIONS(3850),
    [anon_sym_number] = ACTIONS(3850),
    [anon_sym_class] = ACTIONS(3850),
    [anon_sym_declare] = ACTIONS(3850),
    [anon_sym_typeof] = ACTIONS(3850),
    [anon_sym_LBRACE] = ACTIONS(3852),
    [anon_sym_switch] = ACTIONS(3850),
    [anon_sym_LPAREN] = ACTIONS(3852),
    [sym_null] = ACTIONS(3850),
    [anon_sym_any] = ACTIONS(3850),
    [anon_sym_boolean] = ACTIONS(3850),
    [anon_sym_async] = ACTIONS(3850),
    [anon_sym_public] = ACTIONS(3850),
    [anon_sym_var] = ACTIONS(3850),
    [anon_sym_while] = ACTIONS(3850),
    [anon_sym_SQUOTE] = ACTIONS(3852),
    [anon_sym_try] = ACTIONS(3850),
    [anon_sym_LT] = ACTIONS(3852),
    [sym_number] = ACTIONS(3852),
    [anon_sym_SLASH] = ACTIONS(3850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3850),
    [anon_sym_function] = ACTIONS(3850),
    [sym_undefined] = ACTIONS(3850),
    [anon_sym_new] = ACTIONS(3850),
    [ts_builtin_sym_end] = ACTIONS(3852),
    [anon_sym_let] = ACTIONS(3850),
    [anon_sym_PLUS] = ACTIONS(3850),
    [anon_sym_export] = ACTIONS(3850),
    [anon_sym_do] = ACTIONS(3850),
    [anon_sym_TILDE] = ACTIONS(3852),
    [anon_sym_with] = ACTIONS(3850),
  },
  [1159] = {
    [sym__automatic_semicolon] = ACTIONS(3854),
    [anon_sym_RBRACE] = ACTIONS(3854),
    [anon_sym_SEMI] = ACTIONS(3854),
    [anon_sym_COMMA] = ACTIONS(3854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3854),
  },
  [1160] = {
    [sym__automatic_semicolon] = ACTIONS(3856),
    [anon_sym_RBRACE] = ACTIONS(3856),
    [anon_sym_SEMI] = ACTIONS(3856),
    [anon_sym_COMMA] = ACTIONS(3856),
    [sym_comment] = ACTIONS(3),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3856),
  },
  [1161] = {
    [sym_statement_block] = STATE(1479),
    [sym__automatic_semicolon] = ACTIONS(3858),
    [anon_sym_SEMI] = ACTIONS(3858),
    [anon_sym_COMMA] = ACTIONS(3858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2772),
  },
  [1162] = {
    [sym_call_signature] = STATE(1178),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [1163] = {
    [sym__automatic_semicolon] = ACTIONS(3860),
    [anon_sym_SEMI] = ACTIONS(3860),
    [anon_sym_COMMA] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
  },
  [1164] = {
    [sym_call_signature] = STATE(1178),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(3862),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [1165] = {
    [sym__initializer] = STATE(1180),
    [sym__automatic_semicolon] = ACTIONS(3860),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_SEMI] = ACTIONS(3860),
    [anon_sym_COMMA] = ACTIONS(3860),
    [sym_comment] = ACTIONS(3),
  },
  [1166] = {
    [sym__automatic_semicolon] = ACTIONS(3864),
    [anon_sym_SEMI] = ACTIONS(3864),
    [anon_sym_COMMA] = ACTIONS(3864),
    [sym_comment] = ACTIONS(3),
  },
  [1167] = {
    [anon_sym_COMMA] = ACTIONS(3866),
    [anon_sym_RBRACE] = ACTIONS(3866),
    [sym_comment] = ACTIONS(3),
  },
  [1168] = {
    [sym_statement_block] = STATE(1181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [1169] = {
    [sym_call_signature] = STATE(1182),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [1170] = {
    [sym__automatic_semicolon] = ACTIONS(3858),
    [anon_sym_RBRACE] = ACTIONS(3858),
    [anon_sym_SEMI] = ACTIONS(3858),
    [anon_sym_COMMA] = ACTIONS(3858),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3858),
    [sym_comment] = ACTIONS(3),
  },
  [1171] = {
    [sym_call_signature] = STATE(1183),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [1172] = {
    [sym_call_signature] = STATE(1183),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(3868),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [1173] = {
    [sym__automatic_semicolon] = ACTIONS(3870),
    [anon_sym_RBRACE] = ACTIONS(3870),
    [anon_sym_SEMI] = ACTIONS(3870),
    [anon_sym_COMMA] = ACTIONS(3870),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3870),
    [sym_comment] = ACTIONS(3),
  },
  [1174] = {
    [sym_call_signature] = STATE(1942),
    [sym_type_annotation] = STATE(1173),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [sym__automatic_semicolon] = ACTIONS(3824),
    [anon_sym_RBRACE] = ACTIONS(3824),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(3824),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3824),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_COMMA] = ACTIONS(3824),
    [sym_comment] = ACTIONS(3),
  },
  [1175] = {
    [sym_identifier] = ACTIONS(3872),
    [anon_sym_BQUOTE] = ACTIONS(3874),
    [anon_sym_debugger] = ACTIONS(3872),
    [anon_sym_symbol] = ACTIONS(3872),
    [anon_sym_AT] = ACTIONS(3874),
    [anon_sym_DASH] = ACTIONS(3872),
    [anon_sym_void] = ACTIONS(3872),
    [anon_sym_break] = ACTIONS(3872),
    [anon_sym_const] = ACTIONS(3872),
    [sym_super] = ACTIONS(3872),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_private] = ACTIONS(3872),
    [anon_sym_get] = ACTIONS(3872),
    [anon_sym_RBRACE] = ACTIONS(3874),
    [anon_sym_interface] = ACTIONS(3872),
    [anon_sym_default] = ACTIONS(3872),
    [anon_sym_enum] = ACTIONS(3872),
    [anon_sym_delete] = ACTIONS(3872),
    [anon_sym_continue] = ACTIONS(3872),
    [anon_sym_DASH_DASH] = ACTIONS(3874),
    [anon_sym_if] = ACTIONS(3872),
    [anon_sym_this] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3872),
    [sym_true] = ACTIONS(3872),
    [anon_sym_throw] = ACTIONS(3872),
    [anon_sym_protected] = ACTIONS(3872),
    [anon_sym_abstract] = ACTIONS(3872),
    [anon_sym_set] = ACTIONS(3872),
    [anon_sym_type] = ACTIONS(3872),
    [anon_sym_import] = ACTIONS(3872),
    [anon_sym_namespace] = ACTIONS(3872),
    [anon_sym_PLUS_PLUS] = ACTIONS(3874),
    [anon_sym_await] = ACTIONS(3872),
    [anon_sym_DQUOTE] = ACTIONS(3874),
    [anon_sym_else] = ACTIONS(3872),
    [anon_sym_BANG] = ACTIONS(3874),
    [anon_sym_for] = ACTIONS(3872),
    [anon_sym_LBRACK] = ACTIONS(3874),
    [sym_false] = ACTIONS(3872),
    [anon_sym_SEMI] = ACTIONS(3874),
    [anon_sym_case] = ACTIONS(3872),
    [anon_sym_module] = ACTIONS(3872),
    [anon_sym_number] = ACTIONS(3872),
    [anon_sym_class] = ACTIONS(3872),
    [anon_sym_declare] = ACTIONS(3872),
    [anon_sym_typeof] = ACTIONS(3872),
    [anon_sym_LBRACE] = ACTIONS(3874),
    [anon_sym_switch] = ACTIONS(3872),
    [anon_sym_LPAREN] = ACTIONS(3874),
    [sym_null] = ACTIONS(3872),
    [anon_sym_any] = ACTIONS(3872),
    [anon_sym_boolean] = ACTIONS(3872),
    [anon_sym_async] = ACTIONS(3872),
    [anon_sym_public] = ACTIONS(3872),
    [anon_sym_var] = ACTIONS(3872),
    [anon_sym_while] = ACTIONS(3872),
    [anon_sym_SQUOTE] = ACTIONS(3874),
    [anon_sym_try] = ACTIONS(3872),
    [anon_sym_LT] = ACTIONS(3874),
    [sym_number] = ACTIONS(3874),
    [anon_sym_SLASH] = ACTIONS(3872),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3872),
    [anon_sym_function] = ACTIONS(3872),
    [sym_undefined] = ACTIONS(3872),
    [anon_sym_new] = ACTIONS(3872),
    [ts_builtin_sym_end] = ACTIONS(3874),
    [anon_sym_let] = ACTIONS(3872),
    [anon_sym_PLUS] = ACTIONS(3872),
    [anon_sym_export] = ACTIONS(3872),
    [anon_sym_do] = ACTIONS(3872),
    [anon_sym_TILDE] = ACTIONS(3874),
    [anon_sym_with] = ACTIONS(3872),
  },
  [1176] = {
    [sym_identifier] = ACTIONS(3876),
    [anon_sym_BQUOTE] = ACTIONS(3878),
    [anon_sym_debugger] = ACTIONS(3876),
    [anon_sym_symbol] = ACTIONS(3876),
    [anon_sym_AT] = ACTIONS(3878),
    [anon_sym_DASH] = ACTIONS(3876),
    [anon_sym_void] = ACTIONS(3876),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_const] = ACTIONS(3876),
    [sym_super] = ACTIONS(3876),
    [anon_sym_return] = ACTIONS(3876),
    [anon_sym_private] = ACTIONS(3876),
    [anon_sym_get] = ACTIONS(3876),
    [anon_sym_RBRACE] = ACTIONS(3878),
    [anon_sym_interface] = ACTIONS(3876),
    [anon_sym_default] = ACTIONS(3876),
    [anon_sym_enum] = ACTIONS(3876),
    [anon_sym_delete] = ACTIONS(3876),
    [anon_sym_continue] = ACTIONS(3876),
    [anon_sym_DASH_DASH] = ACTIONS(3878),
    [anon_sym_if] = ACTIONS(3876),
    [anon_sym_this] = ACTIONS(3876),
    [anon_sym_yield] = ACTIONS(3876),
    [sym_true] = ACTIONS(3876),
    [anon_sym_throw] = ACTIONS(3876),
    [anon_sym_protected] = ACTIONS(3876),
    [anon_sym_abstract] = ACTIONS(3876),
    [anon_sym_set] = ACTIONS(3876),
    [anon_sym_type] = ACTIONS(3876),
    [anon_sym_import] = ACTIONS(3876),
    [anon_sym_namespace] = ACTIONS(3876),
    [anon_sym_PLUS_PLUS] = ACTIONS(3878),
    [anon_sym_await] = ACTIONS(3876),
    [anon_sym_DQUOTE] = ACTIONS(3878),
    [anon_sym_else] = ACTIONS(3876),
    [anon_sym_BANG] = ACTIONS(3878),
    [anon_sym_for] = ACTIONS(3876),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [sym_false] = ACTIONS(3876),
    [anon_sym_SEMI] = ACTIONS(3878),
    [anon_sym_case] = ACTIONS(3876),
    [anon_sym_module] = ACTIONS(3876),
    [anon_sym_number] = ACTIONS(3876),
    [anon_sym_class] = ACTIONS(3876),
    [anon_sym_declare] = ACTIONS(3876),
    [anon_sym_typeof] = ACTIONS(3876),
    [anon_sym_LBRACE] = ACTIONS(3878),
    [anon_sym_switch] = ACTIONS(3876),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [sym_null] = ACTIONS(3876),
    [anon_sym_any] = ACTIONS(3876),
    [anon_sym_boolean] = ACTIONS(3876),
    [anon_sym_async] = ACTIONS(3876),
    [anon_sym_public] = ACTIONS(3876),
    [anon_sym_var] = ACTIONS(3876),
    [anon_sym_while] = ACTIONS(3876),
    [anon_sym_SQUOTE] = ACTIONS(3878),
    [anon_sym_try] = ACTIONS(3876),
    [anon_sym_LT] = ACTIONS(3878),
    [sym_number] = ACTIONS(3878),
    [anon_sym_SLASH] = ACTIONS(3876),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3876),
    [anon_sym_function] = ACTIONS(3876),
    [sym_undefined] = ACTIONS(3876),
    [anon_sym_new] = ACTIONS(3876),
    [ts_builtin_sym_end] = ACTIONS(3878),
    [anon_sym_let] = ACTIONS(3876),
    [anon_sym_PLUS] = ACTIONS(3876),
    [anon_sym_export] = ACTIONS(3876),
    [anon_sym_do] = ACTIONS(3876),
    [anon_sym_TILDE] = ACTIONS(3878),
    [anon_sym_with] = ACTIONS(3876),
  },
  [1177] = {
    [sym_identifier] = ACTIONS(3880),
    [anon_sym_BQUOTE] = ACTIONS(3882),
    [anon_sym_debugger] = ACTIONS(3880),
    [anon_sym_symbol] = ACTIONS(3880),
    [anon_sym_AT] = ACTIONS(3882),
    [anon_sym_DASH] = ACTIONS(3880),
    [anon_sym_void] = ACTIONS(3880),
    [anon_sym_break] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3880),
    [sym_super] = ACTIONS(3880),
    [anon_sym_return] = ACTIONS(3880),
    [anon_sym_private] = ACTIONS(3880),
    [anon_sym_get] = ACTIONS(3880),
    [anon_sym_RBRACE] = ACTIONS(3882),
    [anon_sym_interface] = ACTIONS(3880),
    [anon_sym_default] = ACTIONS(3880),
    [anon_sym_enum] = ACTIONS(3880),
    [anon_sym_delete] = ACTIONS(3880),
    [anon_sym_continue] = ACTIONS(3880),
    [anon_sym_DASH_DASH] = ACTIONS(3882),
    [anon_sym_if] = ACTIONS(3880),
    [anon_sym_this] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3880),
    [sym_true] = ACTIONS(3880),
    [anon_sym_throw] = ACTIONS(3880),
    [anon_sym_protected] = ACTIONS(3880),
    [anon_sym_abstract] = ACTIONS(3880),
    [anon_sym_set] = ACTIONS(3880),
    [anon_sym_type] = ACTIONS(3880),
    [anon_sym_import] = ACTIONS(3880),
    [anon_sym_namespace] = ACTIONS(3880),
    [anon_sym_PLUS_PLUS] = ACTIONS(3882),
    [anon_sym_await] = ACTIONS(3880),
    [anon_sym_DQUOTE] = ACTIONS(3882),
    [anon_sym_else] = ACTIONS(3880),
    [anon_sym_BANG] = ACTIONS(3882),
    [anon_sym_for] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [sym_false] = ACTIONS(3880),
    [anon_sym_SEMI] = ACTIONS(3882),
    [anon_sym_case] = ACTIONS(3880),
    [anon_sym_module] = ACTIONS(3880),
    [anon_sym_number] = ACTIONS(3880),
    [anon_sym_class] = ACTIONS(3880),
    [anon_sym_declare] = ACTIONS(3880),
    [anon_sym_typeof] = ACTIONS(3880),
    [anon_sym_LBRACE] = ACTIONS(3882),
    [anon_sym_switch] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3882),
    [sym_null] = ACTIONS(3880),
    [anon_sym_any] = ACTIONS(3880),
    [anon_sym_boolean] = ACTIONS(3880),
    [anon_sym_async] = ACTIONS(3880),
    [anon_sym_public] = ACTIONS(3880),
    [anon_sym_var] = ACTIONS(3880),
    [anon_sym_while] = ACTIONS(3880),
    [anon_sym_SQUOTE] = ACTIONS(3882),
    [anon_sym_try] = ACTIONS(3880),
    [anon_sym_LT] = ACTIONS(3882),
    [sym_number] = ACTIONS(3882),
    [anon_sym_SLASH] = ACTIONS(3880),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3880),
    [anon_sym_function] = ACTIONS(3880),
    [sym_undefined] = ACTIONS(3880),
    [anon_sym_new] = ACTIONS(3880),
    [ts_builtin_sym_end] = ACTIONS(3882),
    [anon_sym_let] = ACTIONS(3880),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_export] = ACTIONS(3880),
    [anon_sym_do] = ACTIONS(3880),
    [anon_sym_TILDE] = ACTIONS(3882),
    [anon_sym_with] = ACTIONS(3880),
  },
  [1178] = {
    [sym_statement_block] = STATE(1480),
    [sym__automatic_semicolon] = ACTIONS(3884),
    [anon_sym_SEMI] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2772),
  },
  [1179] = {
    [sym_call_signature] = STATE(1185),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [1180] = {
    [sym__automatic_semicolon] = ACTIONS(3886),
    [anon_sym_SEMI] = ACTIONS(3886),
    [anon_sym_COMMA] = ACTIONS(3886),
    [sym_comment] = ACTIONS(3),
  },
  [1181] = {
    [anon_sym_COMMA] = ACTIONS(3888),
    [anon_sym_RBRACE] = ACTIONS(3888),
    [sym_comment] = ACTIONS(3),
  },
  [1182] = {
    [sym_statement_block] = STATE(1186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [1183] = {
    [sym__automatic_semicolon] = ACTIONS(3884),
    [anon_sym_RBRACE] = ACTIONS(3884),
    [anon_sym_SEMI] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3884),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3884),
    [sym_comment] = ACTIONS(3),
  },
  [1184] = {
    [sym_call_signature] = STATE(1187),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [1185] = {
    [sym_statement_block] = STATE(1481),
    [sym__automatic_semicolon] = ACTIONS(3890),
    [anon_sym_SEMI] = ACTIONS(3890),
    [anon_sym_COMMA] = ACTIONS(3890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2772),
  },
  [1186] = {
    [anon_sym_COMMA] = ACTIONS(3892),
    [anon_sym_RBRACE] = ACTIONS(3892),
    [sym_comment] = ACTIONS(3),
  },
  [1187] = {
    [sym__automatic_semicolon] = ACTIONS(3890),
    [anon_sym_RBRACE] = ACTIONS(3890),
    [anon_sym_SEMI] = ACTIONS(3890),
    [anon_sym_COMMA] = ACTIONS(3890),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3890),
    [sym_comment] = ACTIONS(3),
  },
  [1188] = {
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1189] = {
    [sym_new_expression] = STATE(1218),
    [sym_augmented_assignment_expression] = STATE(1218),
    [sym_unary_expression] = STATE(1218),
    [sym_update_expression] = STATE(1218),
    [sym_regex] = STATE(1218),
    [sym_meta_property] = STATE(1218),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1218),
    [sym_yield_expression] = STATE(1218),
    [sym_as_expression] = STATE(1218),
    [sym_non_null_expression] = STATE(1218),
    [sym_internal_module] = STATE(1218),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1218),
    [sym_await_expression] = STATE(1218),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1218),
    [sym_this] = STATE(1218),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1218),
    [sym_generator_function] = STATE(1218),
    [sym_call_expression] = STATE(1218),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1218),
    [sym_ternary_expression] = STATE(1218),
    [sym_binary_expression] = STATE(1218),
    [sym_template_string] = STATE(1218),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1218),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1218),
    [sym_class] = STATE(1218),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3894),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3894),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3894),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3896),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3894),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1190] = {
    [sym_new_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_non_null_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1220),
    [sym_this] = STATE(1220),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1220),
    [sym_generator_function] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1220),
    [sym_class] = STATE(1220),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(1124),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(1124),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_BANG] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(1130),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_in] = ACTIONS(139),
  },
  [1191] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1192] = {
    [sym_new_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_non_null_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1220),
    [sym_this] = STATE(1220),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1220),
    [sym_generator_function] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1220),
    [sym_class] = STATE(1220),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(1124),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(1124),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1130),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1193] = {
    [sym_new_expression] = STATE(1222),
    [sym_augmented_assignment_expression] = STATE(1222),
    [sym_unary_expression] = STATE(1222),
    [sym_update_expression] = STATE(1222),
    [sym_regex] = STATE(1222),
    [sym_meta_property] = STATE(1222),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1222),
    [sym_yield_expression] = STATE(1222),
    [sym_as_expression] = STATE(1222),
    [sym_non_null_expression] = STATE(1222),
    [sym_internal_module] = STATE(1222),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1222),
    [sym_await_expression] = STATE(1222),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1222),
    [sym_this] = STATE(1222),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1222),
    [sym_generator_function] = STATE(1222),
    [sym_call_expression] = STATE(1222),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1222),
    [sym_ternary_expression] = STATE(1222),
    [sym_binary_expression] = STATE(1222),
    [sym_template_string] = STATE(1222),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1222),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1222),
    [sym_class] = STATE(1222),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3898),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3898),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3898),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3900),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1194] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(213),
    [anon_sym_PIPE] = ACTIONS(215),
    [anon_sym_COMMA] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_EQ] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [anon_sym_RBRACE] = ACTIONS(213),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_LBRACE_PIPE] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_DASH_DASH] = ACTIONS(213),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_COLON] = ACTIONS(213),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_PLUS_PLUS] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_LBRACK] = ACTIONS(213),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(213),
    [anon_sym_RBRACK] = ACTIONS(213),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_AMP] = ACTIONS(215),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_RPAREN] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_SLASH] = ACTIONS(215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(215),
    [anon_sym_implements] = ACTIONS(213),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(215),
  },
  [1195] = {
    [sym_new_expression] = STATE(1223),
    [sym_augmented_assignment_expression] = STATE(1223),
    [sym_unary_expression] = STATE(1223),
    [sym_update_expression] = STATE(1223),
    [sym_regex] = STATE(1223),
    [sym_meta_property] = STATE(1223),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1223),
    [sym_yield_expression] = STATE(1223),
    [sym_as_expression] = STATE(1223),
    [sym_non_null_expression] = STATE(1223),
    [sym_internal_module] = STATE(1223),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1223),
    [sym_await_expression] = STATE(1223),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1223),
    [sym_this] = STATE(1223),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1223),
    [sym_generator_function] = STATE(1223),
    [sym_call_expression] = STATE(1223),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1223),
    [sym_ternary_expression] = STATE(1223),
    [sym_binary_expression] = STATE(1223),
    [sym_template_string] = STATE(1223),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1223),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1223),
    [sym_class] = STATE(1223),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(217),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT_GT_GT] = ACTIONS(217),
    [anon_sym_BANG_EQ] = ACTIONS(219),
    [anon_sym_RBRACE] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(217),
    [anon_sym_as] = ACTIONS(219),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_instanceof] = ACTIONS(219),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3902),
    [anon_sym_COLON] = ACTIONS(217),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_DOT] = ACTIONS(219),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LT_LT] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_RBRACK] = ACTIONS(217),
    [sym_null] = ACTIONS(3902),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_QMARK] = ACTIONS(217),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(217),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_CARET] = ACTIONS(217),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(217),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_STAR_STAR] = ACTIONS(217),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_BANG] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3902),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_PIPE_PIPE] = ACTIONS(217),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(3904),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3902),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_in] = ACTIONS(219),
  },
  [1196] = {
    [sym_nested_identifier] = STATE(1592),
    [sym__module] = STATE(1483),
    [sym_string] = STATE(1594),
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1197] = {
    [sym_new_expression] = STATE(1227),
    [sym_augmented_assignment_expression] = STATE(1227),
    [sym_unary_expression] = STATE(1227),
    [sym_update_expression] = STATE(1227),
    [sym_regex] = STATE(1227),
    [sym_meta_property] = STATE(1227),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1227),
    [sym_yield_expression] = STATE(1227),
    [sym_as_expression] = STATE(1227),
    [sym_non_null_expression] = STATE(1227),
    [sym_internal_module] = STATE(1227),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1227),
    [sym_await_expression] = STATE(1227),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1227),
    [sym_this] = STATE(1227),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1227),
    [sym_generator_function] = STATE(1227),
    [sym_call_expression] = STATE(1227),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1227),
    [sym_ternary_expression] = STATE(1227),
    [sym_binary_expression] = STATE(1227),
    [sym_template_string] = STATE(1227),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1227),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1227),
    [sym_class] = STATE(1227),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3906),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3906),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3906),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3908),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3906),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1198] = {
    [sym_new_expression] = STATE(1229),
    [sym_augmented_assignment_expression] = STATE(1229),
    [sym_unary_expression] = STATE(1229),
    [sym_update_expression] = STATE(1229),
    [sym_regex] = STATE(1229),
    [sym_meta_property] = STATE(1229),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1229),
    [sym_yield_expression] = STATE(1229),
    [sym_as_expression] = STATE(1229),
    [sym_non_null_expression] = STATE(1229),
    [sym_internal_module] = STATE(1229),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1229),
    [sym_await_expression] = STATE(1229),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1229),
    [sym_this] = STATE(1229),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1229),
    [sym_generator_function] = STATE(1229),
    [sym_call_expression] = STATE(1229),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1229),
    [sym_ternary_expression] = STATE(1229),
    [sym_binary_expression] = STATE(1229),
    [sym_template_string] = STATE(1229),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1229),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1229),
    [sym_class] = STATE(1229),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3910),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3910),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3910),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3912),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3910),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1199] = {
    [sym_new_expression] = STATE(1261),
    [sym_augmented_assignment_expression] = STATE(1800),
    [sym_unary_expression] = STATE(1800),
    [sym_update_expression] = STATE(1800),
    [sym_regex] = STATE(1261),
    [sym_meta_property] = STATE(1261),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1800),
    [sym_yield_expression] = STATE(1800),
    [sym_as_expression] = STATE(1800),
    [sym_non_null_expression] = STATE(1800),
    [sym_internal_module] = STATE(1800),
    [sym_function] = STATE(1266),
    [sym_arrow_function] = STATE(1261),
    [sym_await_expression] = STATE(1800),
    [sym_member_expression] = STATE(1267),
    [sym_string] = STATE(1261),
    [sym_this] = STATE(1261),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1268),
    [sym_anonymous_class] = STATE(1261),
    [sym_generator_function] = STATE(1261),
    [sym_call_expression] = STATE(1800),
    [sym_subscript_expression] = STATE(1267),
    [sym_assignment_expression] = STATE(1800),
    [sym_ternary_expression] = STATE(1800),
    [sym_binary_expression] = STATE(1800),
    [sym_template_string] = STATE(1261),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1261),
    [sym_array] = STATE(1269),
    [sym_type_assertion] = STATE(1800),
    [sym_class] = STATE(1261),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(3916),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(3918),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(3916),
    [anon_sym_get] = ACTIONS(3916),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(3920),
    [anon_sym_protected] = ACTIONS(3916),
    [anon_sym_DOT] = ACTIONS(3922),
    [anon_sym_set] = ACTIONS(3916),
    [anon_sym_type] = ACTIONS(3916),
    [anon_sym_import] = ACTIONS(3916),
    [anon_sym_namespace] = ACTIONS(3924),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3920),
    [anon_sym_module] = ACTIONS(3916),
    [anon_sym_number] = ACTIONS(3916),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(3916),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3920),
    [anon_sym_any] = ACTIONS(3916),
    [anon_sym_boolean] = ACTIONS(3916),
    [anon_sym_async] = ACTIONS(3926),
    [anon_sym_public] = ACTIONS(3916),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3928),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3920),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(3916),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [1200] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(562),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(562),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1201] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1088),
    [anon_sym_AMP_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_EQ] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(1088),
    [anon_sym_PIPE_EQ] = ACTIONS(1088),
    [anon_sym_DASH_EQ] = ACTIONS(1088),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(1088),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(1088),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1088),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1202] = {
    [sym__initializer] = STATE(1273),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(847),
  },
  [1203] = {
    [sym_type_annotation] = STATE(1275),
    [sym__automatic_semicolon] = ACTIONS(566),
    [anon_sym_RBRACE] = ACTIONS(566),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(566),
    [anon_sym_PIPE_RBRACE] = ACTIONS(566),
    [anon_sym_COMMA] = ACTIONS(566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(566),
  },
  [1204] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_else] = ACTIONS(562),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_while] = ACTIONS(562),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1205] = {
    [sym_new_expression] = STATE(1286),
    [sym_augmented_assignment_expression] = STATE(1286),
    [sym_unary_expression] = STATE(1286),
    [sym_update_expression] = STATE(1286),
    [sym_regex] = STATE(1286),
    [sym_meta_property] = STATE(1286),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1286),
    [sym_yield_expression] = STATE(1286),
    [sym_as_expression] = STATE(1286),
    [sym_non_null_expression] = STATE(1286),
    [sym_internal_module] = STATE(1286),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1286),
    [sym_await_expression] = STATE(1286),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1286),
    [sym_this] = STATE(1286),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1286),
    [sym_generator_function] = STATE(1286),
    [sym_call_expression] = STATE(1286),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1286),
    [sym_ternary_expression] = STATE(1286),
    [sym_binary_expression] = STATE(1286),
    [sym_template_string] = STATE(1286),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1286),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1286),
    [sym_class] = STATE(1286),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3930),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3930),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3930),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3932),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3930),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1206] = {
    [sym__initializer] = STATE(1287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(847),
  },
  [1207] = {
    [sym_new_expression] = STATE(1289),
    [sym_augmented_assignment_expression] = STATE(1289),
    [sym_unary_expression] = STATE(1289),
    [sym_update_expression] = STATE(1289),
    [sym_regex] = STATE(1289),
    [sym_meta_property] = STATE(1289),
    [sym_call_signature] = STATE(1740),
    [sym_statement_block] = STATE(1288),
    [sym__expression] = STATE(1289),
    [sym_yield_expression] = STATE(1289),
    [sym_as_expression] = STATE(1289),
    [sym_non_null_expression] = STATE(1289),
    [sym_internal_module] = STATE(1289),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1289),
    [sym_await_expression] = STATE(1289),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1289),
    [sym_this] = STATE(1289),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1289),
    [sym_generator_function] = STATE(1289),
    [sym_call_expression] = STATE(1289),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1289),
    [sym_ternary_expression] = STATE(1289),
    [sym_binary_expression] = STATE(1289),
    [sym_template_string] = STATE(1289),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1289),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1289),
    [sym_class] = STATE(1289),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3934),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3934),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3934),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3938),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3934),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1208] = {
    [sym_new_expression] = STATE(1290),
    [sym_augmented_assignment_expression] = STATE(1290),
    [sym_unary_expression] = STATE(1290),
    [sym_update_expression] = STATE(1290),
    [sym_regex] = STATE(1290),
    [sym_meta_property] = STATE(1290),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1290),
    [sym_yield_expression] = STATE(1290),
    [sym_as_expression] = STATE(1290),
    [sym_non_null_expression] = STATE(1290),
    [sym_internal_module] = STATE(1290),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1290),
    [sym_await_expression] = STATE(1290),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1290),
    [sym_this] = STATE(1290),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1290),
    [sym_generator_function] = STATE(1290),
    [sym_call_expression] = STATE(1290),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1290),
    [sym_ternary_expression] = STATE(1290),
    [sym_binary_expression] = STATE(1290),
    [sym_template_string] = STATE(1290),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1290),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1290),
    [sym_class] = STATE(1290),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3940),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3940),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3940),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3942),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1209] = {
    [sym_new_expression] = STATE(1291),
    [sym_augmented_assignment_expression] = STATE(1291),
    [sym_unary_expression] = STATE(1291),
    [sym_update_expression] = STATE(1291),
    [sym_regex] = STATE(1291),
    [sym_meta_property] = STATE(1291),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1291),
    [sym_yield_expression] = STATE(1291),
    [sym_as_expression] = STATE(1291),
    [sym_non_null_expression] = STATE(1291),
    [sym_internal_module] = STATE(1291),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1291),
    [sym_await_expression] = STATE(1291),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1291),
    [sym_this] = STATE(1291),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1291),
    [sym_generator_function] = STATE(1291),
    [sym_call_expression] = STATE(1291),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1291),
    [sym_ternary_expression] = STATE(1291),
    [sym_binary_expression] = STATE(1291),
    [sym_template_string] = STATE(1291),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1291),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1291),
    [sym_class] = STATE(1291),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3944),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3944),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3944),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3946),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3944),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1210] = {
    [sym_new_expression] = STATE(1292),
    [sym_augmented_assignment_expression] = STATE(1292),
    [sym_unary_expression] = STATE(1292),
    [sym_update_expression] = STATE(1292),
    [sym_regex] = STATE(1292),
    [sym_meta_property] = STATE(1292),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1292),
    [sym_yield_expression] = STATE(1292),
    [sym_as_expression] = STATE(1292),
    [sym_non_null_expression] = STATE(1292),
    [sym_internal_module] = STATE(1292),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1292),
    [sym_await_expression] = STATE(1292),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1292),
    [sym_this] = STATE(1292),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1292),
    [sym_generator_function] = STATE(1292),
    [sym_call_expression] = STATE(1292),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1292),
    [sym_ternary_expression] = STATE(1292),
    [sym_binary_expression] = STATE(1292),
    [sym_template_string] = STATE(1292),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1292),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1292),
    [sym_class] = STATE(1292),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3948),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3948),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3948),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3950),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1211] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(632),
    [anon_sym_BQUOTE] = ACTIONS(632),
    [anon_sym_PIPE] = ACTIONS(634),
    [anon_sym_COMMA] = ACTIONS(632),
    [anon_sym_DASH] = ACTIONS(634),
    [anon_sym_STAR] = ACTIONS(634),
    [anon_sym_GT_GT_GT] = ACTIONS(632),
    [anon_sym_BANG_EQ] = ACTIONS(634),
    [anon_sym_GT_EQ] = ACTIONS(632),
    [anon_sym_RBRACE] = ACTIONS(632),
    [anon_sym_PERCENT] = ACTIONS(632),
    [anon_sym_LBRACE_PIPE] = ACTIONS(632),
    [anon_sym_as] = ACTIONS(632),
    [anon_sym_DASH_DASH] = ACTIONS(632),
    [anon_sym_instanceof] = ACTIONS(632),
    [anon_sym_COLON] = ACTIONS(632),
    [anon_sym_DOT] = ACTIONS(632),
    [anon_sym_STAR_STAR] = ACTIONS(632),
    [anon_sym_PLUS_PLUS] = ACTIONS(632),
    [anon_sym_BANG] = ACTIONS(634),
    [anon_sym_LBRACK] = ACTIONS(632),
    [anon_sym_LT_LT] = ACTIONS(632),
    [anon_sym_LBRACE] = ACTIONS(634),
    [anon_sym_AMP_AMP] = ACTIONS(632),
    [anon_sym_LT_EQ] = ACTIONS(632),
    [anon_sym_LPAREN] = ACTIONS(632),
    [anon_sym_RBRACK] = ACTIONS(632),
    [anon_sym_GT] = ACTIONS(634),
    [anon_sym_AMP] = ACTIONS(634),
    [anon_sym_QMARK] = ACTIONS(632),
    [anon_sym_PIPE_PIPE] = ACTIONS(632),
    [anon_sym_EQ_EQ] = ACTIONS(634),
    [anon_sym_RPAREN] = ACTIONS(632),
    [anon_sym_LT] = ACTIONS(634),
    [anon_sym_SLASH] = ACTIONS(634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(632),
    [anon_sym_PLUS] = ACTIONS(634),
    [anon_sym_implements] = ACTIONS(632),
    [anon_sym_GT_GT] = ACTIONS(634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(632),
    [anon_sym_in] = ACTIONS(634),
  },
  [1212] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(640),
    [anon_sym_BQUOTE] = ACTIONS(640),
    [anon_sym_PIPE] = ACTIONS(642),
    [anon_sym_COMMA] = ACTIONS(640),
    [anon_sym_DASH] = ACTIONS(642),
    [anon_sym_STAR] = ACTIONS(642),
    [anon_sym_GT_GT_GT] = ACTIONS(640),
    [anon_sym_BANG_EQ] = ACTIONS(642),
    [anon_sym_GT_EQ] = ACTIONS(640),
    [anon_sym_RBRACE] = ACTIONS(640),
    [anon_sym_PERCENT] = ACTIONS(640),
    [anon_sym_LBRACE_PIPE] = ACTIONS(640),
    [anon_sym_as] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_instanceof] = ACTIONS(640),
    [anon_sym_COLON] = ACTIONS(640),
    [anon_sym_DOT] = ACTIONS(640),
    [anon_sym_STAR_STAR] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(640),
    [anon_sym_LT_LT] = ACTIONS(640),
    [anon_sym_LBRACE] = ACTIONS(642),
    [anon_sym_AMP_AMP] = ACTIONS(640),
    [anon_sym_LT_EQ] = ACTIONS(640),
    [anon_sym_LPAREN] = ACTIONS(640),
    [anon_sym_RBRACK] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP] = ACTIONS(642),
    [anon_sym_QMARK] = ACTIONS(640),
    [anon_sym_PIPE_PIPE] = ACTIONS(640),
    [anon_sym_EQ_EQ] = ACTIONS(642),
    [anon_sym_RPAREN] = ACTIONS(640),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_SLASH] = ACTIONS(642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(642),
    [anon_sym_implements] = ACTIONS(640),
    [anon_sym_GT_GT] = ACTIONS(642),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(640),
    [anon_sym_in] = ACTIONS(642),
  },
  [1213] = {
    [sym_new_expression] = STATE(1296),
    [sym_augmented_assignment_expression] = STATE(1296),
    [sym_unary_expression] = STATE(1296),
    [sym_update_expression] = STATE(1296),
    [sym_regex] = STATE(1296),
    [sym_meta_property] = STATE(1296),
    [sym_call_signature] = STATE(1740),
    [sym_statement_block] = STATE(1295),
    [sym__expression] = STATE(1296),
    [sym_yield_expression] = STATE(1296),
    [sym_as_expression] = STATE(1296),
    [sym_non_null_expression] = STATE(1296),
    [sym_internal_module] = STATE(1296),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1296),
    [sym_await_expression] = STATE(1296),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1296),
    [sym_this] = STATE(1296),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1296),
    [sym_generator_function] = STATE(1296),
    [sym_call_expression] = STATE(1296),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1296),
    [sym_ternary_expression] = STATE(1296),
    [sym_binary_expression] = STATE(1296),
    [sym_template_string] = STATE(1296),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1296),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1296),
    [sym_class] = STATE(1296),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3952),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3952),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3952),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3954),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3952),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1214] = {
    [sym_new_expression] = STATE(1297),
    [sym_augmented_assignment_expression] = STATE(1297),
    [sym_unary_expression] = STATE(1297),
    [sym_update_expression] = STATE(1297),
    [sym_regex] = STATE(1297),
    [sym_meta_property] = STATE(1297),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1297),
    [sym_yield_expression] = STATE(1297),
    [sym_as_expression] = STATE(1297),
    [sym_non_null_expression] = STATE(1297),
    [sym_internal_module] = STATE(1297),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1297),
    [sym_await_expression] = STATE(1297),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1297),
    [sym_this] = STATE(1297),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1297),
    [sym_generator_function] = STATE(1297),
    [sym_call_expression] = STATE(1297),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1297),
    [sym_ternary_expression] = STATE(1297),
    [sym_binary_expression] = STATE(1297),
    [sym_template_string] = STATE(1297),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1297),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1297),
    [sym_class] = STATE(1297),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3956),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3956),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3956),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3958),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3956),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1215] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(662),
    [anon_sym_BQUOTE] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_COMMA] = ACTIONS(662),
    [anon_sym_DASH] = ACTIONS(664),
    [anon_sym_STAR] = ACTIONS(664),
    [anon_sym_GT_GT_GT] = ACTIONS(662),
    [anon_sym_BANG_EQ] = ACTIONS(664),
    [anon_sym_GT_EQ] = ACTIONS(662),
    [anon_sym_RBRACE] = ACTIONS(662),
    [anon_sym_PERCENT] = ACTIONS(662),
    [anon_sym_LBRACE_PIPE] = ACTIONS(662),
    [anon_sym_as] = ACTIONS(662),
    [anon_sym_DASH_DASH] = ACTIONS(662),
    [anon_sym_instanceof] = ACTIONS(662),
    [anon_sym_COLON] = ACTIONS(662),
    [anon_sym_DOT] = ACTIONS(662),
    [anon_sym_STAR_STAR] = ACTIONS(662),
    [anon_sym_PLUS_PLUS] = ACTIONS(662),
    [anon_sym_BANG] = ACTIONS(664),
    [anon_sym_LBRACK] = ACTIONS(662),
    [anon_sym_LT_LT] = ACTIONS(662),
    [anon_sym_LBRACE] = ACTIONS(664),
    [anon_sym_AMP_AMP] = ACTIONS(662),
    [anon_sym_LT_EQ] = ACTIONS(662),
    [anon_sym_LPAREN] = ACTIONS(662),
    [anon_sym_RBRACK] = ACTIONS(662),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_AMP] = ACTIONS(664),
    [anon_sym_QMARK] = ACTIONS(662),
    [anon_sym_PIPE_PIPE] = ACTIONS(662),
    [anon_sym_EQ_EQ] = ACTIONS(664),
    [anon_sym_RPAREN] = ACTIONS(662),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_SLASH] = ACTIONS(664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(662),
    [anon_sym_PLUS] = ACTIONS(664),
    [anon_sym_implements] = ACTIONS(662),
    [anon_sym_GT_GT] = ACTIONS(664),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(662),
    [anon_sym_in] = ACTIONS(664),
  },
  [1216] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1088),
    [anon_sym_AMP_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_EQ] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(1088),
    [anon_sym_PIPE_EQ] = ACTIONS(1088),
    [anon_sym_DASH_EQ] = ACTIONS(1088),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(1088),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(1088),
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1088),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(847),
  },
  [1217] = {
    [sym_call_signature] = STATE(1782),
    [sym__initializer] = STATE(1215),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1132),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(1134),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(1134),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_private] = ACTIONS(1134),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_get] = ACTIONS(1134),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(1134),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_set] = ACTIONS(1134),
    [anon_sym_type] = ACTIONS(1134),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(1134),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_namespace] = ACTIONS(1134),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1134),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(1134),
    [anon_sym_declare] = ACTIONS(1134),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(1134),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(1134),
    [anon_sym_async] = ACTIONS(1134),
    [anon_sym_public] = ACTIONS(1134),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(1134),
    [anon_sym_function] = ACTIONS(1136),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(1134),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1218] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_COMMA] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_RBRACE] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(702),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(700),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_RPAREN] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [1219] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1220] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_COMMA] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_RBRACE] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(700),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_RPAREN] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [1221] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(739),
    [anon_sym_BQUOTE] = ACTIONS(739),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_COMMA] = ACTIONS(739),
    [anon_sym_DASH] = ACTIONS(741),
    [anon_sym_STAR] = ACTIONS(741),
    [anon_sym_GT_GT_GT] = ACTIONS(739),
    [anon_sym_BANG_EQ] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(739),
    [anon_sym_RBRACE] = ACTIONS(739),
    [anon_sym_PERCENT] = ACTIONS(739),
    [anon_sym_LBRACE_PIPE] = ACTIONS(739),
    [anon_sym_as] = ACTIONS(739),
    [anon_sym_DASH_DASH] = ACTIONS(739),
    [anon_sym_instanceof] = ACTIONS(739),
    [anon_sym_COLON] = ACTIONS(739),
    [anon_sym_DOT] = ACTIONS(739),
    [anon_sym_STAR_STAR] = ACTIONS(739),
    [anon_sym_PLUS_PLUS] = ACTIONS(739),
    [anon_sym_BANG] = ACTIONS(741),
    [anon_sym_LBRACK] = ACTIONS(739),
    [anon_sym_LT_LT] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(739),
    [anon_sym_LT_EQ] = ACTIONS(739),
    [anon_sym_LPAREN] = ACTIONS(739),
    [anon_sym_RBRACK] = ACTIONS(739),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_QMARK] = ACTIONS(739),
    [anon_sym_PIPE_PIPE] = ACTIONS(739),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_RPAREN] = ACTIONS(739),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(739),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_implements] = ACTIONS(739),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(739),
    [anon_sym_in] = ACTIONS(741),
  },
  [1222] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(759),
    [anon_sym_BQUOTE] = ACTIONS(759),
    [anon_sym_PIPE] = ACTIONS(761),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_DASH] = ACTIONS(761),
    [anon_sym_STAR] = ACTIONS(761),
    [anon_sym_GT_GT_GT] = ACTIONS(759),
    [anon_sym_BANG_EQ] = ACTIONS(761),
    [anon_sym_GT_EQ] = ACTIONS(759),
    [anon_sym_RBRACE] = ACTIONS(759),
    [anon_sym_PERCENT] = ACTIONS(759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(759),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(759),
    [anon_sym_instanceof] = ACTIONS(759),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(759),
    [anon_sym_PLUS_PLUS] = ACTIONS(759),
    [anon_sym_BANG] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(761),
    [anon_sym_AMP_AMP] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_RBRACK] = ACTIONS(759),
    [anon_sym_GT] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(759),
    [anon_sym_EQ_EQ] = ACTIONS(761),
    [anon_sym_RPAREN] = ACTIONS(759),
    [anon_sym_LT] = ACTIONS(761),
    [anon_sym_SLASH] = ACTIONS(761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(759),
    [anon_sym_PLUS] = ACTIONS(761),
    [anon_sym_implements] = ACTIONS(759),
    [anon_sym_GT_GT] = ACTIONS(761),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(759),
    [anon_sym_in] = ACTIONS(761),
  },
  [1223] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(767),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(767),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_in] = ACTIONS(847),
  },
  [1224] = {
    [sym_statement_block] = STATE(1309),
    [sym_identifier] = ACTIONS(801),
    [anon_sym_BQUOTE] = ACTIONS(799),
    [anon_sym_debugger] = ACTIONS(801),
    [anon_sym_symbol] = ACTIONS(801),
    [anon_sym_AT] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(801),
    [anon_sym_const] = ACTIONS(801),
    [sym_super] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_private] = ACTIONS(801),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(799),
    [anon_sym_interface] = ACTIONS(801),
    [anon_sym_default] = ACTIONS(801),
    [anon_sym_enum] = ACTIONS(801),
    [anon_sym_delete] = ACTIONS(801),
    [anon_sym_continue] = ACTIONS(801),
    [anon_sym_DASH_DASH] = ACTIONS(799),
    [anon_sym_if] = ACTIONS(801),
    [anon_sym_this] = ACTIONS(801),
    [anon_sym_yield] = ACTIONS(801),
    [sym_true] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(801),
    [anon_sym_protected] = ACTIONS(801),
    [anon_sym_abstract] = ACTIONS(801),
    [anon_sym_DOT] = ACTIONS(2309),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_type] = ACTIONS(801),
    [anon_sym_import] = ACTIONS(801),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(799),
    [anon_sym_await] = ACTIONS(801),
    [anon_sym_DQUOTE] = ACTIONS(799),
    [anon_sym_else] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(799),
    [sym_false] = ACTIONS(801),
    [anon_sym_SEMI] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_module] = ACTIONS(801),
    [anon_sym_number] = ACTIONS(801),
    [anon_sym_class] = ACTIONS(801),
    [anon_sym_declare] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(448),
    [anon_sym_switch] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(799),
    [sym_null] = ACTIONS(801),
    [anon_sym_any] = ACTIONS(801),
    [anon_sym_boolean] = ACTIONS(801),
    [anon_sym_async] = ACTIONS(801),
    [anon_sym_public] = ACTIONS(801),
    [anon_sym_var] = ACTIONS(801),
    [anon_sym_while] = ACTIONS(801),
    [anon_sym_SQUOTE] = ACTIONS(799),
    [anon_sym_try] = ACTIONS(801),
    [anon_sym_LT] = ACTIONS(799),
    [sym_number] = ACTIONS(799),
    [anon_sym_SLASH] = ACTIONS(801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(801),
    [anon_sym_function] = ACTIONS(801),
    [sym_undefined] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(801),
    [ts_builtin_sym_end] = ACTIONS(799),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(801),
    [anon_sym_export] = ACTIONS(801),
    [anon_sym_do] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(799),
    [anon_sym_with] = ACTIONS(801),
  },
  [1225] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(807),
    [sym__automatic_semicolon] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_COMMA] = ACTIONS(807),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(809),
    [anon_sym_GT_GT_GT] = ACTIONS(807),
    [anon_sym_BANG_EQ] = ACTIONS(809),
    [anon_sym_GT_EQ] = ACTIONS(807),
    [anon_sym_RBRACE] = ACTIONS(807),
    [anon_sym_PERCENT] = ACTIONS(807),
    [anon_sym_as] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(807),
    [anon_sym_instanceof] = ACTIONS(807),
    [anon_sym_DOT] = ACTIONS(807),
    [anon_sym_STAR_STAR] = ACTIONS(807),
    [anon_sym_PLUS_PLUS] = ACTIONS(807),
    [anon_sym_else] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_SEMI] = ACTIONS(807),
    [anon_sym_LT_LT] = ACTIONS(807),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_LT_EQ] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_GT] = ACTIONS(809),
    [anon_sym_AMP] = ACTIONS(809),
    [anon_sym_QMARK] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [anon_sym_while] = ACTIONS(807),
    [anon_sym_EQ_EQ] = ACTIONS(809),
    [anon_sym_RPAREN] = ACTIONS(807),
    [anon_sym_LT] = ACTIONS(809),
    [anon_sym_SLASH] = ACTIONS(809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_GT_GT] = ACTIONS(809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(807),
    [anon_sym_in] = ACTIONS(809),
  },
  [1226] = {
    [sym_statement_block] = STATE(1309),
    [sym_identifier] = ACTIONS(801),
    [anon_sym_BQUOTE] = ACTIONS(799),
    [anon_sym_debugger] = ACTIONS(801),
    [anon_sym_symbol] = ACTIONS(801),
    [anon_sym_AT] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_void] = ACTIONS(801),
    [anon_sym_break] = ACTIONS(801),
    [anon_sym_const] = ACTIONS(801),
    [sym_super] = ACTIONS(801),
    [anon_sym_return] = ACTIONS(801),
    [anon_sym_private] = ACTIONS(801),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_RBRACE] = ACTIONS(799),
    [anon_sym_interface] = ACTIONS(801),
    [anon_sym_default] = ACTIONS(801),
    [anon_sym_enum] = ACTIONS(801),
    [anon_sym_delete] = ACTIONS(801),
    [anon_sym_continue] = ACTIONS(801),
    [anon_sym_DASH_DASH] = ACTIONS(799),
    [anon_sym_if] = ACTIONS(801),
    [anon_sym_this] = ACTIONS(801),
    [anon_sym_yield] = ACTIONS(801),
    [sym_true] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(801),
    [anon_sym_protected] = ACTIONS(801),
    [anon_sym_abstract] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_type] = ACTIONS(801),
    [anon_sym_import] = ACTIONS(801),
    [anon_sym_namespace] = ACTIONS(801),
    [anon_sym_PLUS_PLUS] = ACTIONS(799),
    [anon_sym_await] = ACTIONS(801),
    [anon_sym_DQUOTE] = ACTIONS(799),
    [anon_sym_else] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(799),
    [anon_sym_for] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(799),
    [sym_false] = ACTIONS(801),
    [anon_sym_SEMI] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_module] = ACTIONS(801),
    [anon_sym_number] = ACTIONS(801),
    [anon_sym_class] = ACTIONS(801),
    [anon_sym_declare] = ACTIONS(801),
    [anon_sym_typeof] = ACTIONS(801),
    [anon_sym_LBRACE] = ACTIONS(448),
    [anon_sym_switch] = ACTIONS(801),
    [anon_sym_LPAREN] = ACTIONS(799),
    [sym_null] = ACTIONS(801),
    [anon_sym_any] = ACTIONS(801),
    [anon_sym_boolean] = ACTIONS(801),
    [anon_sym_async] = ACTIONS(801),
    [anon_sym_public] = ACTIONS(801),
    [anon_sym_var] = ACTIONS(801),
    [anon_sym_while] = ACTIONS(801),
    [anon_sym_SQUOTE] = ACTIONS(799),
    [anon_sym_try] = ACTIONS(801),
    [anon_sym_LT] = ACTIONS(799),
    [sym_number] = ACTIONS(799),
    [anon_sym_SLASH] = ACTIONS(801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(801),
    [anon_sym_function] = ACTIONS(801),
    [sym_undefined] = ACTIONS(801),
    [anon_sym_new] = ACTIONS(801),
    [ts_builtin_sym_end] = ACTIONS(799),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_PLUS] = ACTIONS(801),
    [anon_sym_export] = ACTIONS(801),
    [anon_sym_do] = ACTIONS(801),
    [anon_sym_TILDE] = ACTIONS(799),
    [anon_sym_with] = ACTIONS(801),
  },
  [1227] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(811),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(811),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_in] = ACTIONS(847),
  },
  [1228] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [sym__automatic_semicolon] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_break] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_return] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_interface] = ACTIONS(815),
    [anon_sym_as] = ACTIONS(815),
    [anon_sym_delete] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_instanceof] = ACTIONS(815),
    [anon_sym_yield] = ACTIONS(815),
    [sym_true] = ACTIONS(815),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_DOT] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_import] = ACTIONS(815),
    [anon_sym_await] = ACTIONS(815),
    [anon_sym_DQUOTE] = ACTIONS(813),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_typeof] = ACTIONS(815),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_switch] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [sym_null] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_var] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_new] = ACTIONS(815),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_GT_GT] = ACTIONS(815),
    [anon_sym_with] = ACTIONS(815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [sym_identifier] = ACTIONS(815),
    [anon_sym_debugger] = ACTIONS(815),
    [anon_sym_AT] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_const] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [sym_super] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_default] = ACTIONS(815),
    [anon_sym_enum] = ACTIONS(815),
    [anon_sym_continue] = ACTIONS(815),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_this] = ACTIONS(815),
    [anon_sym_throw] = ACTIONS(815),
    [anon_sym_abstract] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_else] = ACTIONS(815),
    [anon_sym_BANG] = ACTIONS(815),
    [anon_sym_LBRACK] = ACTIONS(813),
    [sym_false] = ACTIONS(815),
    [anon_sym_case] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_class] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(813),
    [anon_sym_GT] = ACTIONS(815),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(815),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_try] = ACTIONS(815),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(815),
    [sym_number] = ACTIONS(813),
    [ts_builtin_sym_end] = ACTIONS(813),
    [anon_sym_function] = ACTIONS(815),
    [sym_undefined] = ACTIONS(815),
    [anon_sym_let] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_do] = ACTIONS(815),
    [anon_sym_TILDE] = ACTIONS(813),
    [anon_sym_in] = ACTIONS(815),
  },
  [1229] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_COMMA] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_RBRACE] = ACTIONS(700),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(700),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_RPAREN] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(3960),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [1230] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(839),
    [anon_sym_BQUOTE] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(841),
    [anon_sym_COMMA] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(841),
    [anon_sym_STAR] = ACTIONS(841),
    [anon_sym_GT_GT_GT] = ACTIONS(839),
    [anon_sym_EQ] = ACTIONS(841),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_GT_EQ] = ACTIONS(839),
    [anon_sym_RBRACE] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_LBRACE_PIPE] = ACTIONS(839),
    [anon_sym_as] = ACTIONS(839),
    [anon_sym_DASH_DASH] = ACTIONS(839),
    [anon_sym_instanceof] = ACTIONS(839),
    [anon_sym_COLON] = ACTIONS(839),
    [anon_sym_DOT] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PLUS_PLUS] = ACTIONS(839),
    [anon_sym_BANG] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_AMP_AMP] = ACTIONS(839),
    [anon_sym_of] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(839),
    [anon_sym_LPAREN] = ACTIONS(839),
    [anon_sym_RBRACK] = ACTIONS(839),
    [anon_sym_GT] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(839),
    [anon_sym_PIPE_PIPE] = ACTIONS(839),
    [anon_sym_EQ_EQ] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_implements] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(839),
    [anon_sym_in] = ACTIONS(841),
  },
  [1231] = {
    [sym__automatic_semicolon] = ACTIONS(881),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(881),
    [anon_sym_COMMA] = ACTIONS(881),
    [anon_sym_PIPE_RBRACE] = ACTIONS(881),
    [sym_comment] = ACTIONS(3),
  },
  [1232] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(947),
    [anon_sym_BQUOTE] = ACTIONS(947),
    [anon_sym_PIPE] = ACTIONS(949),
    [anon_sym_COMMA] = ACTIONS(947),
    [anon_sym_DASH] = ACTIONS(949),
    [anon_sym_STAR] = ACTIONS(949),
    [anon_sym_GT_GT_GT] = ACTIONS(947),
    [anon_sym_BANG_EQ] = ACTIONS(949),
    [anon_sym_GT_EQ] = ACTIONS(947),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_PERCENT] = ACTIONS(947),
    [anon_sym_LBRACE_PIPE] = ACTIONS(947),
    [anon_sym_as] = ACTIONS(947),
    [anon_sym_DASH_DASH] = ACTIONS(947),
    [anon_sym_instanceof] = ACTIONS(947),
    [anon_sym_COLON] = ACTIONS(947),
    [anon_sym_DOT] = ACTIONS(947),
    [anon_sym_STAR_STAR] = ACTIONS(947),
    [anon_sym_PLUS_PLUS] = ACTIONS(947),
    [anon_sym_BANG] = ACTIONS(949),
    [anon_sym_LBRACK] = ACTIONS(947),
    [anon_sym_LT_LT] = ACTIONS(947),
    [anon_sym_LBRACE] = ACTIONS(949),
    [anon_sym_AMP_AMP] = ACTIONS(947),
    [anon_sym_LT_EQ] = ACTIONS(947),
    [anon_sym_LPAREN] = ACTIONS(947),
    [anon_sym_RBRACK] = ACTIONS(947),
    [anon_sym_GT] = ACTIONS(949),
    [anon_sym_AMP] = ACTIONS(949),
    [anon_sym_QMARK] = ACTIONS(947),
    [anon_sym_PIPE_PIPE] = ACTIONS(947),
    [anon_sym_EQ_EQ] = ACTIONS(949),
    [anon_sym_RPAREN] = ACTIONS(947),
    [anon_sym_LT] = ACTIONS(949),
    [anon_sym_SLASH] = ACTIONS(949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(947),
    [anon_sym_PLUS] = ACTIONS(949),
    [anon_sym_implements] = ACTIONS(947),
    [anon_sym_GT_GT] = ACTIONS(949),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(947),
    [anon_sym_in] = ACTIONS(949),
  },
  [1233] = {
    [sym_string] = STATE(2225),
    [sym_nested_identifier] = STATE(2224),
    [sym__module] = STATE(1231),
    [sym_identifier] = ACTIONS(3963),
    [anon_sym_DOT] = ACTIONS(3965),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(87),
  },
  [1234] = {
    [sym_type_alias_declaration] = STATE(1237),
    [aux_sym_export_statement_repeat1] = STATE(1763),
    [sym__declaration] = STATE(1237),
    [sym_ambient_declaration] = STATE(1237),
    [sym_import_alias] = STATE(1237),
    [sym_export_statement] = STATE(1237),
    [sym_generator_function] = STATE(1237),
    [sym_lexical_declaration] = STATE(1237),
    [sym_internal_module] = STATE(1237),
    [sym_decorator] = STATE(1763),
    [sym_enum_declaration] = STATE(1237),
    [sym_function] = STATE(1237),
    [sym_function_signature] = STATE(1237),
    [sym_variable_declaration] = STATE(1237),
    [sym_abstract_class] = STATE(1237),
    [sym_module] = STATE(1237),
    [sym_interface_declaration] = STATE(1237),
    [sym_class] = STATE(1237),
    [anon_sym_var] = ACTIONS(2263),
    [anon_sym_interface] = ACTIONS(2265),
    [anon_sym_enum] = ACTIONS(2269),
    [anon_sym_module] = ACTIONS(3967),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2253),
    [anon_sym_global] = ACTIONS(3969),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_const] = ACTIONS(2259),
    [anon_sym_abstract] = ACTIONS(2275),
    [anon_sym_type] = ACTIONS(2277),
    [anon_sym_let] = ACTIONS(2279),
    [anon_sym_import] = ACTIONS(2281),
    [anon_sym_export] = ACTIONS(2283),
    [anon_sym_namespace] = ACTIONS(2285),
    [anon_sym_async] = ACTIONS(2261),
  },
  [1235] = {
    [sym_type_alias_declaration] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(1763),
    [sym__declaration] = STATE(1271),
    [sym_ambient_declaration] = STATE(1271),
    [sym_import_alias] = STATE(1271),
    [sym_export_statement] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_export_clause] = STATE(1801),
    [sym_lexical_declaration] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_decorator] = STATE(1763),
    [sym_enum_declaration] = STATE(1271),
    [sym_function] = STATE(1271),
    [sym_function_signature] = STATE(1271),
    [sym_variable_declaration] = STATE(1271),
    [sym_abstract_class] = STATE(1271),
    [sym_module] = STATE(1271),
    [sym_interface_declaration] = STATE(1271),
    [sym_class] = STATE(1271),
    [anon_sym_var] = ACTIONS(2263),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_interface] = ACTIONS(2265),
    [anon_sym_enum] = ACTIONS(2269),
    [anon_sym_module] = ACTIONS(2249),
    [anon_sym_as] = ACTIONS(2271),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2253),
    [anon_sym_STAR] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_EQ] = ACTIONS(2257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_const] = ACTIONS(2259),
    [anon_sym_abstract] = ACTIONS(2275),
    [anon_sym_type] = ACTIONS(2277),
    [anon_sym_let] = ACTIONS(2279),
    [anon_sym_import] = ACTIONS(2281),
    [anon_sym_export] = ACTIONS(2283),
    [anon_sym_namespace] = ACTIONS(2285),
    [anon_sym_async] = ACTIONS(2261),
  },
  [1236] = {
    [sym_string] = STATE(2225),
    [sym_nested_identifier] = STATE(2224),
    [sym__module] = STATE(127),
    [sym_identifier] = ACTIONS(3963),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(87),
  },
  [1237] = {
    [sym__automatic_semicolon] = ACTIONS(973),
    [anon_sym_RBRACE] = ACTIONS(973),
    [anon_sym_SEMI] = ACTIONS(973),
    [anon_sym_COMMA] = ACTIONS(973),
    [anon_sym_PIPE_RBRACE] = ACTIONS(973),
    [sym_comment] = ACTIONS(3),
  },
  [1238] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [sym__automatic_semicolon] = ACTIONS(1027),
    [anon_sym_BQUOTE] = ACTIONS(1027),
    [anon_sym_PIPE] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1031),
    [anon_sym_GT_GT_GT] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1031),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_else] = ACTIONS(1033),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [anon_sym_SEMI] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1031),
    [anon_sym_AMP] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_while] = ACTIONS(1033),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_RPAREN] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1031),
    [anon_sym_SLASH] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(1031),
  },
  [1239] = {
    [sym_new_expression] = STATE(1835),
    [sym_augmented_assignment_expression] = STATE(1835),
    [sym_unary_expression] = STATE(1835),
    [sym_update_expression] = STATE(1835),
    [sym_regex] = STATE(1835),
    [sym_meta_property] = STATE(1835),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1835),
    [sym_yield_expression] = STATE(1835),
    [sym_as_expression] = STATE(1835),
    [sym_non_null_expression] = STATE(1835),
    [sym_internal_module] = STATE(1835),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1835),
    [sym_await_expression] = STATE(1835),
    [sym_member_expression] = STATE(1201),
    [sym_spread_element] = STATE(1755),
    [sym_string] = STATE(1835),
    [sym_this] = STATE(1835),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [aux_sym_array_repeat1] = STATE(1756),
    [sym_anonymous_class] = STATE(1835),
    [sym_generator_function] = STATE(1835),
    [sym_call_expression] = STATE(1835),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1835),
    [sym_ternary_expression] = STATE(1835),
    [sym_binary_expression] = STATE(1835),
    [sym_template_string] = STATE(1835),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1835),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1835),
    [sym_class] = STATE(1835),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(266),
    [sym_false] = ACTIONS(3971),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_RBRACK] = ACTIONS(2343),
    [sym_null] = ACTIONS(3971),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(3973),
    [sym_true] = ACTIONS(3971),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3971),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [1240] = {
    [sym__initializer] = STATE(444),
    [sym_type_annotation] = STATE(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_AMP_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_EQ] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(1090),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(1088),
    [anon_sym_STAR_EQ] = ACTIONS(1088),
    [anon_sym_PIPE_EQ] = ACTIONS(1088),
    [anon_sym_DASH_EQ] = ACTIONS(1088),
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(1097),
    [anon_sym_LT_LT_EQ] = ACTIONS(1088),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(1090),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_SLASH_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(847),
  },
  [1241] = {
    [sym__initializer] = STATE(452),
    [sym_type_annotation] = STATE(453),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(1114),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1242] = {
    [sym_new_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym__initializer] = STATE(452),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_non_null_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1220),
    [sym_this] = STATE(1220),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1220),
    [sym_generator_function] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_type_annotation] = STATE(453),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1220),
    [sym_class] = STATE(1220),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(1124),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(1124),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(1130),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1243] = {
    [sym__initializer] = STATE(452),
    [sym_type_annotation] = STATE(453),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(1012),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_this] = ACTIONS(1012),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_namespace] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [sym_readonly] = ACTIONS(1012),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1014),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(1014),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1244] = {
    [sym_call_signature] = STATE(1782),
    [sym__initializer] = STATE(452),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_type_annotation] = STATE(453),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1132),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(1134),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(1134),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_private] = ACTIONS(1134),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_get] = ACTIONS(1134),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_protected] = ACTIONS(1134),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_set] = ACTIONS(1134),
    [anon_sym_type] = ACTIONS(1134),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(1134),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_namespace] = ACTIONS(1134),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1134),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(1134),
    [anon_sym_declare] = ACTIONS(1134),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(1134),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(1134),
    [anon_sym_async] = ACTIONS(1134),
    [anon_sym_public] = ACTIONS(1134),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(1114),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(1134),
    [anon_sym_function] = ACTIONS(1136),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(1134),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1245] = {
    [anon_sym_COLON] = ACTIONS(1138),
    [anon_sym_RBRACE] = ACTIONS(1138),
    [sym__automatic_semicolon] = ACTIONS(1138),
    [anon_sym_SEMI] = ACTIONS(1138),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1138),
    [anon_sym_COMMA] = ACTIONS(1138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1138),
  },
  [1246] = {
    [sym_nested_identifier] = STATE(1592),
    [sym__module] = STATE(1483),
    [sym_string] = STATE(1594),
    [sym__initializer] = STATE(452),
    [sym_type_annotation] = STATE(453),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(1109),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(1114),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1247] = {
    [sym__initializer] = STATE(461),
    [sym_type_annotation] = STATE(445),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(1090),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(1090),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1248] = {
    [sym__initializer] = STATE(470),
    [sym_type_annotation] = STATE(471),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(1160),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(1163),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(1160),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(847),
  },
  [1249] = {
    [sym__initializer] = STATE(473),
    [sym_type_annotation] = STATE(474),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(1166),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(1169),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(1166),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(847),
  },
  [1250] = {
    [aux_sym_export_statement_repeat1] = STATE(1842),
    [sym_decorator] = STATE(1842),
    [sym_object] = STATE(465),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(1779),
    [sym_array] = STATE(467),
    [sym_rest_parameter] = STATE(1779),
    [sym_optional_parameter] = STATE(1779),
    [sym_this] = STATE(468),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_symbol] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1154),
    [anon_sym_any] = ACTIONS(1154),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_boolean] = ACTIONS(1154),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_RPAREN] = ACTIONS(3975),
    [anon_sym_this] = ACTIONS(284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_string] = ACTIONS(1154),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [anon_sym_export] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
  },
  [1251] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1216),
    [sym__automatic_semicolon] = ACTIONS(1216),
    [anon_sym_BQUOTE] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_COMMA] = ACTIONS(1216),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_STAR] = ACTIONS(1218),
    [anon_sym_GT_GT_GT] = ACTIONS(1216),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_GT_EQ] = ACTIONS(1216),
    [anon_sym_RBRACE] = ACTIONS(1216),
    [anon_sym_PERCENT] = ACTIONS(1216),
    [anon_sym_as] = ACTIONS(1216),
    [anon_sym_DASH_DASH] = ACTIONS(1216),
    [anon_sym_instanceof] = ACTIONS(1216),
    [anon_sym_DOT] = ACTIONS(1216),
    [anon_sym_STAR_STAR] = ACTIONS(1216),
    [anon_sym_PLUS_PLUS] = ACTIONS(1216),
    [anon_sym_BANG] = ACTIONS(1218),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1216),
    [anon_sym_LT_LT] = ACTIONS(1216),
    [anon_sym_AMP_AMP] = ACTIONS(1216),
    [anon_sym_LT_EQ] = ACTIONS(1216),
    [anon_sym_LPAREN] = ACTIONS(1216),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_QMARK] = ACTIONS(1216),
    [anon_sym_PIPE_PIPE] = ACTIONS(1216),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_RPAREN] = ACTIONS(1216),
    [anon_sym_LT] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1216),
    [anon_sym_PLUS] = ACTIONS(1218),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1216),
    [anon_sym_in] = ACTIONS(1218),
  },
  [1252] = {
    [sym_index_type_query] = STATE(1334),
    [sym_lookup_type] = STATE(1334),
    [sym_this_type] = STATE(1334),
    [sym_flow_maybe_type] = STATE(1334),
    [sym_nested_identifier] = STATE(2241),
    [sym__primary_type] = STATE(1334),
    [sym_generic_type] = STATE(1334),
    [sym_mapped_type] = STATE(1334),
    [sym_literal_type] = STATE(1334),
    [sym_parenthesized_type] = STATE(1334),
    [sym_predefined_type] = STATE(1334),
    [sym_string] = STATE(1251),
    [sym_array_type] = STATE(1334),
    [sym_tuple_type] = STATE(1334),
    [sym_nested_type_identifier] = STATE(1258),
    [sym_type_predicate] = STATE(1334),
    [sym_type_query] = STATE(1334),
    [sym__number] = STATE(1251),
    [sym_existential_type] = STATE(1334),
    [sym_object_type] = STATE(1334),
    [sym_identifier] = ACTIONS(1600),
    [sym_false] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1606),
    [anon_sym_number] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_keyof] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_void] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(3977),
    [anon_sym_any] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [anon_sym_QMARK] = ACTIONS(1626),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1628),
    [sym_number] = ACTIONS(1630),
    [sym_true] = ACTIONS(1602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [1253] = {
    [sym__type] = STATE(1336),
    [sym_constructor_type] = STATE(1336),
    [sym_index_type_query] = STATE(1259),
    [sym_lookup_type] = STATE(1259),
    [sym_this_type] = STATE(1259),
    [sym_flow_maybe_type] = STATE(1259),
    [sym_function_type] = STATE(1336),
    [sym_nested_identifier] = STATE(2241),
    [sym__primary_type] = STATE(1259),
    [sym_generic_type] = STATE(1259),
    [sym_mapped_type] = STATE(1259),
    [sym_literal_type] = STATE(1259),
    [sym_parenthesized_type] = STATE(1259),
    [sym_predefined_type] = STATE(1259),
    [sym_type_parameters] = STATE(2240),
    [sym_string] = STATE(1251),
    [sym_array_type] = STATE(1259),
    [sym_tuple_type] = STATE(1259),
    [sym_nested_type_identifier] = STATE(1258),
    [sym_type_predicate] = STATE(1259),
    [sym_type_query] = STATE(1259),
    [sym__number] = STATE(1251),
    [sym_existential_type] = STATE(1259),
    [sym_object_type] = STATE(1259),
    [sym_union_type] = STATE(1336),
    [sym_intersection_type] = STATE(1336),
    [sym_formal_parameters] = STATE(1796),
    [sym_identifier] = ACTIONS(1600),
    [sym_false] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1606),
    [anon_sym_number] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_keyof] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_void] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_QMARK] = ACTIONS(1626),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1628),
    [sym_number] = ACTIONS(1630),
    [sym_true] = ACTIONS(1602),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_new] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [1254] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1244),
    [sym__automatic_semicolon] = ACTIONS(1244),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [anon_sym_PIPE] = ACTIONS(1246),
    [anon_sym_COMMA] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_GT_GT_GT] = ACTIONS(1244),
    [anon_sym_BANG_EQ] = ACTIONS(1246),
    [anon_sym_GT_EQ] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_PERCENT] = ACTIONS(1244),
    [anon_sym_as] = ACTIONS(1244),
    [anon_sym_DASH_DASH] = ACTIONS(1244),
    [anon_sym_instanceof] = ACTIONS(1244),
    [anon_sym_DOT] = ACTIONS(1244),
    [anon_sym_STAR_STAR] = ACTIONS(1244),
    [anon_sym_PLUS_PLUS] = ACTIONS(1244),
    [anon_sym_BANG] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_SEMI] = ACTIONS(1244),
    [anon_sym_LT_LT] = ACTIONS(1244),
    [anon_sym_AMP_AMP] = ACTIONS(1244),
    [anon_sym_LT_EQ] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1244),
    [anon_sym_GT] = ACTIONS(1246),
    [anon_sym_AMP] = ACTIONS(1246),
    [anon_sym_QMARK] = ACTIONS(1244),
    [anon_sym_PIPE_PIPE] = ACTIONS(1244),
    [anon_sym_EQ_EQ] = ACTIONS(1246),
    [anon_sym_RPAREN] = ACTIONS(1244),
    [anon_sym_LT] = ACTIONS(1246),
    [anon_sym_SLASH] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_GT_GT] = ACTIONS(1246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1244),
    [anon_sym_in] = ACTIONS(1246),
  },
  [1255] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1248),
    [sym__automatic_semicolon] = ACTIONS(1248),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [anon_sym_PIPE] = ACTIONS(1250),
    [anon_sym_COMMA] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_GT_GT_GT] = ACTIONS(1248),
    [anon_sym_BANG_EQ] = ACTIONS(1250),
    [anon_sym_GT_EQ] = ACTIONS(1248),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_PERCENT] = ACTIONS(1248),
    [anon_sym_as] = ACTIONS(1248),
    [anon_sym_DASH_DASH] = ACTIONS(1248),
    [anon_sym_instanceof] = ACTIONS(1248),
    [anon_sym_DOT] = ACTIONS(1248),
    [anon_sym_STAR_STAR] = ACTIONS(1248),
    [anon_sym_PLUS_PLUS] = ACTIONS(1248),
    [anon_sym_BANG] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_SEMI] = ACTIONS(1248),
    [anon_sym_LT_LT] = ACTIONS(1248),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_LT_EQ] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [anon_sym_GT] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(1250),
    [anon_sym_QMARK] = ACTIONS(1248),
    [anon_sym_PIPE_PIPE] = ACTIONS(1248),
    [anon_sym_EQ_EQ] = ACTIONS(1250),
    [anon_sym_RPAREN] = ACTIONS(1248),
    [anon_sym_LT] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_GT_GT] = ACTIONS(1250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1248),
    [anon_sym_in] = ACTIONS(1250),
  },
  [1256] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1256),
    [sym__automatic_semicolon] = ACTIONS(1256),
    [anon_sym_BQUOTE] = ACTIONS(1256),
    [anon_sym_PIPE] = ACTIONS(1258),
    [anon_sym_COMMA] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_GT_GT_GT] = ACTIONS(1256),
    [anon_sym_BANG_EQ] = ACTIONS(1258),
    [anon_sym_GT_EQ] = ACTIONS(1256),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_PERCENT] = ACTIONS(1256),
    [anon_sym_as] = ACTIONS(1256),
    [anon_sym_DASH_DASH] = ACTIONS(1256),
    [anon_sym_instanceof] = ACTIONS(1256),
    [anon_sym_DOT] = ACTIONS(1256),
    [anon_sym_STAR_STAR] = ACTIONS(1256),
    [anon_sym_PLUS_PLUS] = ACTIONS(1256),
    [anon_sym_BANG] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(1256),
    [anon_sym_SEMI] = ACTIONS(1256),
    [anon_sym_LT_LT] = ACTIONS(1256),
    [anon_sym_AMP_AMP] = ACTIONS(1256),
    [anon_sym_LT_EQ] = ACTIONS(1256),
    [anon_sym_LPAREN] = ACTIONS(1256),
    [anon_sym_GT] = ACTIONS(1258),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_QMARK] = ACTIONS(1256),
    [anon_sym_PIPE_PIPE] = ACTIONS(1256),
    [anon_sym_EQ_EQ] = ACTIONS(1258),
    [anon_sym_RPAREN] = ACTIONS(1256),
    [anon_sym_LT] = ACTIONS(1258),
    [anon_sym_SLASH] = ACTIONS(1258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1258),
    [anon_sym_GT_GT] = ACTIONS(1258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1256),
    [anon_sym_in] = ACTIONS(1258),
  },
  [1257] = {
    [sym__type] = STATE(1344),
    [sym_constructor_type] = STATE(1344),
    [sym_index_type_query] = STATE(1259),
    [sym_lookup_type] = STATE(1259),
    [sym_this_type] = STATE(1259),
    [sym_flow_maybe_type] = STATE(1259),
    [sym_function_type] = STATE(1344),
    [sym_nested_identifier] = STATE(2241),
    [sym__primary_type] = STATE(1259),
    [sym_generic_type] = STATE(1259),
    [sym_mapped_type] = STATE(1259),
    [sym_literal_type] = STATE(1259),
    [sym_parenthesized_type] = STATE(1259),
    [sym_predefined_type] = STATE(1259),
    [sym_type_parameters] = STATE(2240),
    [sym_string] = STATE(1251),
    [sym_array_type] = STATE(1259),
    [sym_tuple_type] = STATE(1259),
    [sym_nested_type_identifier] = STATE(1258),
    [sym_type_predicate] = STATE(1259),
    [sym_type_query] = STATE(1259),
    [sym__number] = STATE(1251),
    [sym_existential_type] = STATE(1259),
    [sym_object_type] = STATE(1259),
    [sym_union_type] = STATE(1344),
    [sym_intersection_type] = STATE(1344),
    [sym_formal_parameters] = STATE(1796),
    [sym_identifier] = ACTIONS(1600),
    [sym_false] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1606),
    [anon_sym_number] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_keyof] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_void] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_QMARK] = ACTIONS(1626),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1628),
    [sym_number] = ACTIONS(1630),
    [sym_true] = ACTIONS(1602),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_new] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [1258] = {
    [sym_type_arguments] = STATE(1349),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1280),
    [sym__automatic_semicolon] = ACTIONS(1280),
    [anon_sym_BQUOTE] = ACTIONS(1280),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_COMMA] = ACTIONS(1280),
    [anon_sym_DASH] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(1285),
    [anon_sym_GT_GT_GT] = ACTIONS(1280),
    [anon_sym_BANG_EQ] = ACTIONS(1285),
    [anon_sym_GT_EQ] = ACTIONS(1280),
    [anon_sym_RBRACE] = ACTIONS(1280),
    [anon_sym_PERCENT] = ACTIONS(1280),
    [anon_sym_as] = ACTIONS(1280),
    [anon_sym_DASH_DASH] = ACTIONS(1280),
    [anon_sym_instanceof] = ACTIONS(1280),
    [anon_sym_DOT] = ACTIONS(1280),
    [anon_sym_STAR_STAR] = ACTIONS(1280),
    [anon_sym_PLUS_PLUS] = ACTIONS(1280),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_LBRACK] = ACTIONS(3979),
    [anon_sym_SEMI] = ACTIONS(1280),
    [anon_sym_LT_LT] = ACTIONS(1280),
    [anon_sym_AMP_AMP] = ACTIONS(1280),
    [anon_sym_LT_EQ] = ACTIONS(1280),
    [anon_sym_LPAREN] = ACTIONS(1280),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(1280),
    [anon_sym_PIPE_PIPE] = ACTIONS(1280),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(3982),
    [anon_sym_SLASH] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1280),
    [anon_sym_in] = ACTIONS(3985),
  },
  [1259] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1293),
    [sym__automatic_semicolon] = ACTIONS(1293),
    [anon_sym_BQUOTE] = ACTIONS(1293),
    [anon_sym_PIPE] = ACTIONS(1295),
    [anon_sym_COMMA] = ACTIONS(1293),
    [anon_sym_DASH] = ACTIONS(1295),
    [anon_sym_STAR] = ACTIONS(1295),
    [anon_sym_GT_GT_GT] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1295),
    [anon_sym_GT_EQ] = ACTIONS(1293),
    [anon_sym_RBRACE] = ACTIONS(1293),
    [anon_sym_PERCENT] = ACTIONS(1293),
    [anon_sym_as] = ACTIONS(1293),
    [anon_sym_DASH_DASH] = ACTIONS(1293),
    [anon_sym_instanceof] = ACTIONS(1293),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_STAR_STAR] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_SEMI] = ACTIONS(1293),
    [anon_sym_LT_LT] = ACTIONS(1293),
    [anon_sym_AMP_AMP] = ACTIONS(1293),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1293),
    [anon_sym_PIPE_PIPE] = ACTIONS(1293),
    [anon_sym_EQ_EQ] = ACTIONS(1295),
    [anon_sym_RPAREN] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1295),
    [anon_sym_SLASH] = ACTIONS(1295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1295),
    [anon_sym_GT_GT] = ACTIONS(1295),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1293),
    [anon_sym_in] = ACTIONS(1295),
  },
  [1260] = {
    [sym__initializer] = STATE(1211),
    [sym_arguments] = STATE(1353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_PERCENT_EQ] = ACTIONS(1307),
    [anon_sym_AMP_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_EQ] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_CARET_EQ] = ACTIONS(1307),
    [anon_sym_PIPE_EQ] = ACTIONS(1307),
    [anon_sym_DASH_EQ] = ACTIONS(1307),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_PERCENT] = ACTIONS(1309),
    [anon_sym_LT_LT_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_COLON] = ACTIONS(1305),
    [anon_sym_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(1309),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_LT_LT] = ACTIONS(1309),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1305),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_STAR_EQ] = ACTIONS(1307),
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1307),
    [anon_sym_CARET] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [1261] = {
    [sym_arguments] = STATE(1353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1305),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_PERCENT] = ACTIONS(1305),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1305),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_COLON] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1305),
    [anon_sym_STAR_STAR] = ACTIONS(1305),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_LT_LT] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1305),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_implements] = ACTIONS(1305),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [1262] = {
    [sym__initializer] = STATE(1215),
    [sym_arguments] = STATE(1355),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1315),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1315),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_instanceof] = ACTIONS(1315),
    [anon_sym_COLON] = ACTIONS(1315),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [1263] = {
    [sym_new_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [sym_call_signature] = STATE(2379),
    [sym_yield_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_internal_module] = STATE(2350),
    [sym_arrow_function] = STATE(2350),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2350),
    [sym_type_parameters] = STATE(55),
    [sym_arguments] = STATE(1355),
    [sym_object] = STATE(2522),
    [sym_generator_function] = STATE(2350),
    [sym_subscript_expression] = STATE(2521),
    [sym_ternary_expression] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym__initializer] = STATE(1215),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym__expression] = STATE(2350),
    [sym_non_null_expression] = STATE(2350),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(2350),
    [sym_this] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_type_arguments] = STATE(2523),
    [sym_parenthesized_expression] = STATE(2350),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1315),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(1323),
    [anon_sym_COLON] = ACTIONS(1315),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_RBRACK] = ACTIONS(1315),
    [sym_null] = ACTIONS(1323),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [sym_false] = ACTIONS(1323),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_LT] = ACTIONS(1319),
    [sym_number] = ACTIONS(1335),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_in] = ACTIONS(1319),
  },
  [1264] = {
    [sym__initializer] = STATE(1215),
    [sym_formal_parameters] = STATE(58),
    [sym_call_signature] = STATE(1782),
    [sym_type_parameters] = STATE(55),
    [sym_arguments] = STATE(1355),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(1132),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(1134),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1134),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(1134),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(1134),
    [anon_sym_RBRACE] = ACTIONS(1315),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_COLON] = ACTIONS(1315),
    [anon_sym_protected] = ACTIONS(1134),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_set] = ACTIONS(1134),
    [anon_sym_type] = ACTIONS(1134),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_import] = ACTIONS(1134),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_namespace] = ACTIONS(1134),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_module] = ACTIONS(1134),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(1134),
    [anon_sym_declare] = ACTIONS(1134),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_RBRACK] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_any] = ACTIONS(1134),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(1134),
    [anon_sym_async] = ACTIONS(1134),
    [anon_sym_public] = ACTIONS(1134),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(1134),
    [anon_sym_function] = ACTIONS(1136),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_export] = ACTIONS(1134),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [1265] = {
    [sym_nested_identifier] = STATE(1592),
    [sym__module] = STATE(1483),
    [sym__initializer] = STATE(1215),
    [sym_string] = STATE(1594),
    [sym_arguments] = STATE(1355),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_RBRACE] = ACTIONS(1315),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_COLON] = ACTIONS(1315),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [1266] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1356),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1305),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_PERCENT] = ACTIONS(1305),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1305),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_COLON] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1305),
    [anon_sym_STAR_STAR] = ACTIONS(1305),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_LT_LT] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(1305),
    [anon_sym_RBRACK] = ACTIONS(1305),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_implements] = ACTIONS(1305),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [1267] = {
    [sym__initializer] = STATE(1211),
    [sym_arguments] = STATE(1353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_PERCENT_EQ] = ACTIONS(1307),
    [anon_sym_AMP_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_EQ] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_CARET_EQ] = ACTIONS(1307),
    [anon_sym_PIPE_EQ] = ACTIONS(1307),
    [anon_sym_DASH_EQ] = ACTIONS(1307),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_PERCENT] = ACTIONS(1309),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1305),
    [anon_sym_LT_LT_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_COLON] = ACTIONS(1305),
    [anon_sym_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(1305),
    [anon_sym_STAR_STAR] = ACTIONS(1309),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_LT_LT] = ACTIONS(1309),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1305),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_STAR_EQ] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1307),
    [anon_sym_CARET] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_implements] = ACTIONS(1305),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [1268] = {
    [sym__initializer] = STATE(1273),
    [sym_arguments] = STATE(1353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1305),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_PERCENT] = ACTIONS(1305),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1305),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_COLON] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1305),
    [anon_sym_STAR_STAR] = ACTIONS(1305),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_LT_LT] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1305),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_implements] = ACTIONS(1305),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [1269] = {
    [sym__initializer] = STATE(1287),
    [sym_arguments] = STATE(1353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1305),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_RBRACE] = ACTIONS(1305),
    [anon_sym_PERCENT] = ACTIONS(1305),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1305),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_COLON] = ACTIONS(1305),
    [anon_sym_DOT] = ACTIONS(1305),
    [anon_sym_STAR_STAR] = ACTIONS(1305),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_LT_LT] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1305),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1305),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_implements] = ACTIONS(1305),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [1270] = {
    [sym_string] = STATE(2225),
    [sym_nested_identifier] = STATE(2224),
    [sym__module] = STATE(1231),
    [sym_identifier] = ACTIONS(3963),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(87),
  },
  [1271] = {
    [sym__automatic_semicolon] = ACTIONS(1399),
    [anon_sym_RBRACE] = ACTIONS(1399),
    [anon_sym_SEMI] = ACTIONS(1399),
    [anon_sym_COMMA] = ACTIONS(1399),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1399),
    [sym_comment] = ACTIONS(3),
  },
  [1272] = {
    [sym_type_annotation] = STATE(1358),
    [sym__automatic_semicolon] = ACTIONS(1405),
    [anon_sym_RBRACE] = ACTIONS(1405),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(1405),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1405),
    [anon_sym_COMMA] = ACTIONS(1405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1405),
  },
  [1273] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1564),
    [anon_sym_BQUOTE] = ACTIONS(1564),
    [anon_sym_PIPE] = ACTIONS(1566),
    [anon_sym_COMMA] = ACTIONS(1564),
    [anon_sym_DASH] = ACTIONS(1566),
    [anon_sym_STAR] = ACTIONS(1566),
    [anon_sym_GT_GT_GT] = ACTIONS(1564),
    [anon_sym_BANG_EQ] = ACTIONS(1566),
    [anon_sym_GT_EQ] = ACTIONS(1564),
    [anon_sym_RBRACE] = ACTIONS(1564),
    [anon_sym_PERCENT] = ACTIONS(1564),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1564),
    [anon_sym_as] = ACTIONS(1564),
    [anon_sym_DASH_DASH] = ACTIONS(1564),
    [anon_sym_instanceof] = ACTIONS(1564),
    [anon_sym_COLON] = ACTIONS(1564),
    [anon_sym_DOT] = ACTIONS(1564),
    [anon_sym_STAR_STAR] = ACTIONS(1564),
    [anon_sym_PLUS_PLUS] = ACTIONS(1564),
    [anon_sym_BANG] = ACTIONS(1566),
    [anon_sym_LBRACK] = ACTIONS(1564),
    [anon_sym_LT_LT] = ACTIONS(1564),
    [anon_sym_LBRACE] = ACTIONS(1566),
    [anon_sym_AMP_AMP] = ACTIONS(1564),
    [anon_sym_LT_EQ] = ACTIONS(1564),
    [anon_sym_LPAREN] = ACTIONS(1564),
    [anon_sym_RBRACK] = ACTIONS(1564),
    [anon_sym_GT] = ACTIONS(1566),
    [anon_sym_AMP] = ACTIONS(1566),
    [anon_sym_QMARK] = ACTIONS(1564),
    [anon_sym_PIPE_PIPE] = ACTIONS(1564),
    [anon_sym_EQ_EQ] = ACTIONS(1566),
    [anon_sym_RPAREN] = ACTIONS(1564),
    [anon_sym_LT] = ACTIONS(1566),
    [anon_sym_SLASH] = ACTIONS(1566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1564),
    [anon_sym_PLUS] = ACTIONS(1566),
    [anon_sym_implements] = ACTIONS(1564),
    [anon_sym_GT_GT] = ACTIONS(1566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1564),
    [anon_sym_in] = ACTIONS(1566),
  },
  [1274] = {
    [sym__type] = STATE(1359),
    [sym_constructor_type] = STATE(1359),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_function_type] = STATE(1359),
    [sym_nested_identifier] = STATE(2393),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_array_type] = STATE(1496),
    [sym_tuple_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(1359),
    [sym_intersection_type] = STATE(1359),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_this] = ACTIONS(1823),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1275] = {
    [sym__automatic_semicolon] = ACTIONS(1405),
    [anon_sym_RBRACE] = ACTIONS(1405),
    [anon_sym_SEMI] = ACTIONS(1405),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1405),
    [anon_sym_COMMA] = ACTIONS(1405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1405),
  },
  [1276] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1572),
    [anon_sym_BQUOTE] = ACTIONS(1572),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_COMMA] = ACTIONS(1572),
    [anon_sym_DASH] = ACTIONS(1574),
    [anon_sym_STAR] = ACTIONS(1574),
    [anon_sym_GT_GT_GT] = ACTIONS(1572),
    [anon_sym_BANG_EQ] = ACTIONS(1574),
    [anon_sym_GT_EQ] = ACTIONS(1572),
    [anon_sym_RBRACE] = ACTIONS(1572),
    [anon_sym_PERCENT] = ACTIONS(1572),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1572),
    [anon_sym_as] = ACTIONS(1572),
    [anon_sym_DASH_DASH] = ACTIONS(1572),
    [anon_sym_instanceof] = ACTIONS(1572),
    [anon_sym_COLON] = ACTIONS(1572),
    [anon_sym_DOT] = ACTIONS(1572),
    [anon_sym_STAR_STAR] = ACTIONS(1572),
    [anon_sym_PLUS_PLUS] = ACTIONS(1572),
    [anon_sym_BANG] = ACTIONS(1574),
    [anon_sym_LBRACK] = ACTIONS(1572),
    [anon_sym_LT_LT] = ACTIONS(1572),
    [anon_sym_LBRACE] = ACTIONS(1574),
    [anon_sym_AMP_AMP] = ACTIONS(1572),
    [anon_sym_LT_EQ] = ACTIONS(1572),
    [anon_sym_LPAREN] = ACTIONS(1572),
    [anon_sym_RBRACK] = ACTIONS(1572),
    [anon_sym_GT] = ACTIONS(1574),
    [anon_sym_AMP] = ACTIONS(1574),
    [anon_sym_QMARK] = ACTIONS(1572),
    [anon_sym_PIPE_PIPE] = ACTIONS(1572),
    [anon_sym_EQ_EQ] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(1572),
    [anon_sym_LT] = ACTIONS(1574),
    [anon_sym_SLASH] = ACTIONS(1574),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1572),
    [anon_sym_PLUS] = ACTIONS(1574),
    [anon_sym_implements] = ACTIONS(1572),
    [anon_sym_GT_GT] = ACTIONS(1574),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1572),
    [anon_sym_in] = ACTIONS(1574),
  },
  [1277] = {
    [sym_new_expression] = STATE(1360),
    [sym_augmented_assignment_expression] = STATE(1360),
    [sym_unary_expression] = STATE(1360),
    [sym_update_expression] = STATE(1360),
    [sym_regex] = STATE(1360),
    [sym_meta_property] = STATE(1360),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1360),
    [sym_yield_expression] = STATE(1360),
    [sym_as_expression] = STATE(1360),
    [sym_non_null_expression] = STATE(1360),
    [sym_internal_module] = STATE(1360),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1360),
    [sym_await_expression] = STATE(1360),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1360),
    [sym_this] = STATE(1360),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1360),
    [sym_generator_function] = STATE(1360),
    [sym_call_expression] = STATE(1360),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1360),
    [sym_ternary_expression] = STATE(1360),
    [sym_binary_expression] = STATE(1360),
    [sym_template_string] = STATE(1360),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1360),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1360),
    [sym_class] = STATE(1360),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3990),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3990),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3990),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3992),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1278] = {
    [sym_new_expression] = STATE(1361),
    [sym_augmented_assignment_expression] = STATE(1361),
    [sym_unary_expression] = STATE(1361),
    [sym_update_expression] = STATE(1361),
    [sym_regex] = STATE(1361),
    [sym_meta_property] = STATE(1361),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1361),
    [sym_yield_expression] = STATE(1361),
    [sym_as_expression] = STATE(1361),
    [sym_non_null_expression] = STATE(1361),
    [sym_internal_module] = STATE(1361),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1361),
    [sym_await_expression] = STATE(1361),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1361),
    [sym_this] = STATE(1361),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1361),
    [sym_generator_function] = STATE(1361),
    [sym_call_expression] = STATE(1361),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1361),
    [sym_ternary_expression] = STATE(1361),
    [sym_binary_expression] = STATE(1361),
    [sym_template_string] = STATE(1361),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1361),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1361),
    [sym_class] = STATE(1361),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3994),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3994),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3994),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3996),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3994),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1279] = {
    [sym_new_expression] = STATE(1362),
    [sym_augmented_assignment_expression] = STATE(1362),
    [sym_unary_expression] = STATE(1362),
    [sym_update_expression] = STATE(1362),
    [sym_regex] = STATE(1362),
    [sym_meta_property] = STATE(1362),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1362),
    [sym_yield_expression] = STATE(1362),
    [sym_as_expression] = STATE(1362),
    [sym_non_null_expression] = STATE(1362),
    [sym_internal_module] = STATE(1362),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1362),
    [sym_await_expression] = STATE(1362),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1362),
    [sym_this] = STATE(1362),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1362),
    [sym_generator_function] = STATE(1362),
    [sym_call_expression] = STATE(1362),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1362),
    [sym_ternary_expression] = STATE(1362),
    [sym_binary_expression] = STATE(1362),
    [sym_template_string] = STATE(1362),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1362),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1362),
    [sym_class] = STATE(1362),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3998),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3998),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3998),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4000),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3998),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1280] = {
    [sym_new_expression] = STATE(1363),
    [sym_augmented_assignment_expression] = STATE(1363),
    [sym_unary_expression] = STATE(1363),
    [sym_update_expression] = STATE(1363),
    [sym_regex] = STATE(1363),
    [sym_meta_property] = STATE(1363),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1363),
    [sym_yield_expression] = STATE(1363),
    [sym_as_expression] = STATE(1363),
    [sym_non_null_expression] = STATE(1363),
    [sym_internal_module] = STATE(1363),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1363),
    [sym_await_expression] = STATE(1363),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1363),
    [sym_this] = STATE(1363),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1363),
    [sym_generator_function] = STATE(1363),
    [sym_call_expression] = STATE(1363),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1363),
    [sym_ternary_expression] = STATE(1363),
    [sym_binary_expression] = STATE(1363),
    [sym_template_string] = STATE(1363),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1363),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1363),
    [sym_class] = STATE(1363),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(4002),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(4002),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4002),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4004),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4002),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1281] = {
    [sym_new_expression] = STATE(1364),
    [sym_augmented_assignment_expression] = STATE(1364),
    [sym_unary_expression] = STATE(1364),
    [sym_update_expression] = STATE(1364),
    [sym_regex] = STATE(1364),
    [sym_meta_property] = STATE(1364),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1364),
    [sym_yield_expression] = STATE(1364),
    [sym_as_expression] = STATE(1364),
    [sym_non_null_expression] = STATE(1364),
    [sym_internal_module] = STATE(1364),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1364),
    [sym_await_expression] = STATE(1364),
    [sym_member_expression] = STATE(1201),
    [sym_sequence_expression] = STATE(1365),
    [sym_string] = STATE(1364),
    [sym_this] = STATE(1364),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1364),
    [sym_generator_function] = STATE(1364),
    [sym_call_expression] = STATE(1364),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1364),
    [sym_ternary_expression] = STATE(1364),
    [sym_binary_expression] = STATE(1364),
    [sym_template_string] = STATE(1364),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1364),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1364),
    [sym_class] = STATE(1364),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(4006),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(4006),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4006),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4008),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4006),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1282] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(759),
    [anon_sym_BQUOTE] = ACTIONS(759),
    [anon_sym_PIPE] = ACTIONS(761),
    [anon_sym_COMMA] = ACTIONS(759),
    [anon_sym_DASH] = ACTIONS(761),
    [anon_sym_STAR] = ACTIONS(761),
    [anon_sym_GT_GT_GT] = ACTIONS(759),
    [anon_sym_BANG_EQ] = ACTIONS(761),
    [anon_sym_GT_EQ] = ACTIONS(759),
    [anon_sym_RBRACE] = ACTIONS(759),
    [anon_sym_PERCENT] = ACTIONS(759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(759),
    [anon_sym_as] = ACTIONS(759),
    [anon_sym_DASH_DASH] = ACTIONS(759),
    [anon_sym_instanceof] = ACTIONS(759),
    [anon_sym_COLON] = ACTIONS(759),
    [anon_sym_DOT] = ACTIONS(759),
    [anon_sym_STAR_STAR] = ACTIONS(759),
    [anon_sym_PLUS_PLUS] = ACTIONS(759),
    [anon_sym_BANG] = ACTIONS(761),
    [anon_sym_LBRACK] = ACTIONS(759),
    [anon_sym_LT_LT] = ACTIONS(759),
    [anon_sym_LBRACE] = ACTIONS(761),
    [anon_sym_AMP_AMP] = ACTIONS(759),
    [anon_sym_LT_EQ] = ACTIONS(759),
    [anon_sym_LPAREN] = ACTIONS(759),
    [anon_sym_RBRACK] = ACTIONS(759),
    [anon_sym_GT] = ACTIONS(761),
    [anon_sym_AMP] = ACTIONS(761),
    [anon_sym_QMARK] = ACTIONS(759),
    [anon_sym_PIPE_PIPE] = ACTIONS(759),
    [anon_sym_EQ_EQ] = ACTIONS(761),
    [anon_sym_RPAREN] = ACTIONS(759),
    [anon_sym_LT] = ACTIONS(761),
    [anon_sym_SLASH] = ACTIONS(761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(759),
    [anon_sym_PLUS] = ACTIONS(761),
    [anon_sym_implements] = ACTIONS(759),
    [anon_sym_GT_GT] = ACTIONS(761),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(759),
    [anon_sym_in] = ACTIONS(761),
  },
  [1283] = {
    [sym_new_expression] = STATE(1290),
    [sym_constructor_type] = STATE(232),
    [sym_augmented_assignment_expression] = STATE(1290),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(1290),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(1290),
    [sym_call_signature] = STATE(1740),
    [sym_yield_expression] = STATE(1290),
    [sym_as_expression] = STATE(1290),
    [sym_internal_module] = STATE(1290),
    [sym_arrow_function] = STATE(1290),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(1201),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1369),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(1202),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(1290),
    [sym_subscript_expression] = STATE(1201),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(1290),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(1290),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(232),
    [sym__type] = STATE(232),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(1290),
    [sym_meta_property] = STATE(1290),
    [sym_function_type] = STATE(232),
    [sym__expression] = STATE(1290),
    [sym_non_null_expression] = STATE(1290),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(1290),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(1290),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(1290),
    [sym_call_expression] = STATE(1290),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(1290),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(1290),
    [sym_type_arguments] = STATE(1205),
    [sym_union_type] = STATE(232),
    [sym_parenthesized_expression] = STATE(1290),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1290),
    [sym_class] = STATE(1290),
    [sym_identifier] = ACTIONS(4010),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(4012),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(4014),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(4016),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(4018),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(4020),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(4020),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(4012),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(4022),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [sym_null] = ACTIONS(3940),
    [anon_sym_any] = ACTIONS(4012),
    [anon_sym_boolean] = ACTIONS(4012),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4012),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(4014),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1284] = {
    [sym_new_expression] = STATE(1376),
    [sym_augmented_assignment_expression] = STATE(1376),
    [sym_unary_expression] = STATE(1376),
    [sym_update_expression] = STATE(1376),
    [sym_regex] = STATE(1376),
    [sym_meta_property] = STATE(1376),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1376),
    [sym_yield_expression] = STATE(1376),
    [sym_as_expression] = STATE(1376),
    [sym_non_null_expression] = STATE(1376),
    [sym_internal_module] = STATE(1376),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1376),
    [sym_await_expression] = STATE(1376),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1376),
    [sym_this] = STATE(1376),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1376),
    [sym_generator_function] = STATE(1376),
    [sym_call_expression] = STATE(1376),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1376),
    [sym_ternary_expression] = STATE(1376),
    [sym_binary_expression] = STATE(1376),
    [sym_template_string] = STATE(1376),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1376),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1376),
    [sym_class] = STATE(1376),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(4026),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(4026),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4026),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4028),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4026),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1285] = {
    [sym_type_alias_declaration] = STATE(1357),
    [aux_sym_export_statement_repeat1] = STATE(1763),
    [sym__declaration] = STATE(1357),
    [sym_ambient_declaration] = STATE(1357),
    [sym_import_alias] = STATE(1357),
    [sym_export_statement] = STATE(1357),
    [sym_generator_function] = STATE(1357),
    [sym_lexical_declaration] = STATE(1357),
    [sym_internal_module] = STATE(1357),
    [sym_decorator] = STATE(1763),
    [sym_enum_declaration] = STATE(1357),
    [sym_function] = STATE(1357),
    [sym_function_signature] = STATE(1357),
    [sym_variable_declaration] = STATE(1357),
    [sym_abstract_class] = STATE(1357),
    [sym_module] = STATE(1357),
    [sym_interface_declaration] = STATE(1357),
    [sym_class] = STATE(1357),
    [anon_sym_var] = ACTIONS(2263),
    [anon_sym_default] = ACTIONS(4030),
    [anon_sym_interface] = ACTIONS(2265),
    [anon_sym_enum] = ACTIONS(2269),
    [anon_sym_module] = ACTIONS(2249),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_const] = ACTIONS(2259),
    [anon_sym_abstract] = ACTIONS(2275),
    [anon_sym_type] = ACTIONS(2277),
    [anon_sym_let] = ACTIONS(2279),
    [anon_sym_import] = ACTIONS(2281),
    [anon_sym_export] = ACTIONS(2283),
    [anon_sym_namespace] = ACTIONS(2285),
    [anon_sym_async] = ACTIONS(2261),
  },
  [1286] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1673),
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_DASH] = ACTIONS(1673),
    [anon_sym_STAR] = ACTIONS(1673),
    [anon_sym_GT_GT_GT] = ACTIONS(1671),
    [anon_sym_BANG_EQ] = ACTIONS(1673),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_RBRACE] = ACTIONS(1671),
    [anon_sym_PERCENT] = ACTIONS(1671),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1671),
    [anon_sym_as] = ACTIONS(1671),
    [anon_sym_DASH_DASH] = ACTIONS(1671),
    [anon_sym_instanceof] = ACTIONS(1671),
    [anon_sym_COLON] = ACTIONS(1671),
    [anon_sym_DOT] = ACTIONS(1671),
    [anon_sym_STAR_STAR] = ACTIONS(1671),
    [anon_sym_PLUS_PLUS] = ACTIONS(1671),
    [anon_sym_BANG] = ACTIONS(1673),
    [anon_sym_LBRACK] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [anon_sym_LBRACE] = ACTIONS(1673),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_LT_EQ] = ACTIONS(1671),
    [anon_sym_LPAREN] = ACTIONS(1671),
    [anon_sym_RBRACK] = ACTIONS(1671),
    [anon_sym_GT] = ACTIONS(1673),
    [anon_sym_AMP] = ACTIONS(1673),
    [anon_sym_QMARK] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [anon_sym_EQ_EQ] = ACTIONS(1673),
    [anon_sym_RPAREN] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1673),
    [anon_sym_SLASH] = ACTIONS(1673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1671),
    [anon_sym_PLUS] = ACTIONS(1673),
    [anon_sym_implements] = ACTIONS(1671),
    [anon_sym_GT_GT] = ACTIONS(1673),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1671),
    [anon_sym_in] = ACTIONS(1673),
  },
  [1287] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(1675),
    [anon_sym_DASH] = ACTIONS(1677),
    [anon_sym_STAR] = ACTIONS(1677),
    [anon_sym_GT_GT_GT] = ACTIONS(1675),
    [anon_sym_BANG_EQ] = ACTIONS(1677),
    [anon_sym_GT_EQ] = ACTIONS(1675),
    [anon_sym_RBRACE] = ACTIONS(1675),
    [anon_sym_PERCENT] = ACTIONS(1675),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1675),
    [anon_sym_as] = ACTIONS(1675),
    [anon_sym_DASH_DASH] = ACTIONS(1675),
    [anon_sym_instanceof] = ACTIONS(1675),
    [anon_sym_COLON] = ACTIONS(1675),
    [anon_sym_DOT] = ACTIONS(1675),
    [anon_sym_STAR_STAR] = ACTIONS(1675),
    [anon_sym_PLUS_PLUS] = ACTIONS(1675),
    [anon_sym_BANG] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_LBRACE] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_LT_EQ] = ACTIONS(1675),
    [anon_sym_LPAREN] = ACTIONS(1675),
    [anon_sym_RBRACK] = ACTIONS(1675),
    [anon_sym_GT] = ACTIONS(1677),
    [anon_sym_AMP] = ACTIONS(1677),
    [anon_sym_QMARK] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [anon_sym_EQ_EQ] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1677),
    [anon_sym_SLASH] = ACTIONS(1677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1675),
    [anon_sym_PLUS] = ACTIONS(1677),
    [anon_sym_implements] = ACTIONS(1675),
    [anon_sym_GT_GT] = ACTIONS(1677),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1675),
    [anon_sym_in] = ACTIONS(1677),
  },
  [1288] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1679),
    [anon_sym_BQUOTE] = ACTIONS(1679),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_STAR] = ACTIONS(1681),
    [anon_sym_GT_GT_GT] = ACTIONS(1679),
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(1679),
    [anon_sym_RBRACE] = ACTIONS(1679),
    [anon_sym_PERCENT] = ACTIONS(1679),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1679),
    [anon_sym_as] = ACTIONS(1679),
    [anon_sym_DASH_DASH] = ACTIONS(1679),
    [anon_sym_instanceof] = ACTIONS(1679),
    [anon_sym_COLON] = ACTIONS(1679),
    [anon_sym_DOT] = ACTIONS(1679),
    [anon_sym_STAR_STAR] = ACTIONS(1679),
    [anon_sym_PLUS_PLUS] = ACTIONS(1679),
    [anon_sym_BANG] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1679),
    [anon_sym_LT_LT] = ACTIONS(1679),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1679),
    [anon_sym_LT_EQ] = ACTIONS(1679),
    [anon_sym_LPAREN] = ACTIONS(1679),
    [anon_sym_RBRACK] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_QMARK] = ACTIONS(1679),
    [anon_sym_PIPE_PIPE] = ACTIONS(1679),
    [anon_sym_EQ_EQ] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_SLASH] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1679),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_implements] = ACTIONS(1679),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1679),
    [anon_sym_in] = ACTIONS(1681),
  },
  [1289] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(1679),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(1679),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(1679),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_in] = ACTIONS(847),
  },
  [1290] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_COLON] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [1291] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1687),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(1687),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(1687),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(1687),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_in] = ACTIONS(847),
  },
  [1292] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1689),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(1689),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(1689),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1689),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(1689),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_in] = ACTIONS(847),
  },
  [1293] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(1697),
    [anon_sym_COMMA] = ACTIONS(1695),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_RBRACE] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1695),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_COLON] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(1695),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_RBRACK] = ACTIONS(1695),
    [anon_sym_GT] = ACTIONS(1697),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(1697),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_implements] = ACTIONS(1695),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1697),
  },
  [1294] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BQUOTE] = ACTIONS(1701),
    [anon_sym_PIPE] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(1701),
    [anon_sym_DASH] = ACTIONS(1703),
    [anon_sym_STAR] = ACTIONS(1703),
    [anon_sym_GT_GT_GT] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_GT_EQ] = ACTIONS(1701),
    [anon_sym_RBRACE] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1701),
    [anon_sym_as] = ACTIONS(1701),
    [anon_sym_DASH_DASH] = ACTIONS(1701),
    [anon_sym_instanceof] = ACTIONS(1701),
    [anon_sym_COLON] = ACTIONS(1701),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_STAR_STAR] = ACTIONS(1701),
    [anon_sym_PLUS_PLUS] = ACTIONS(1701),
    [anon_sym_BANG] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1701),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1701),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_LPAREN] = ACTIONS(1701),
    [anon_sym_RBRACK] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1701),
    [anon_sym_PIPE_PIPE] = ACTIONS(1701),
    [anon_sym_EQ_EQ] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_implements] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1701),
    [anon_sym_in] = ACTIONS(1703),
  },
  [1295] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1713),
    [anon_sym_BQUOTE] = ACTIONS(1713),
    [anon_sym_PIPE] = ACTIONS(1715),
    [anon_sym_COMMA] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(1715),
    [anon_sym_STAR] = ACTIONS(1715),
    [anon_sym_GT_GT_GT] = ACTIONS(1713),
    [anon_sym_BANG_EQ] = ACTIONS(1715),
    [anon_sym_GT_EQ] = ACTIONS(1713),
    [anon_sym_RBRACE] = ACTIONS(1713),
    [anon_sym_PERCENT] = ACTIONS(1713),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1713),
    [anon_sym_as] = ACTIONS(1713),
    [anon_sym_DASH_DASH] = ACTIONS(1713),
    [anon_sym_instanceof] = ACTIONS(1713),
    [anon_sym_COLON] = ACTIONS(1713),
    [anon_sym_DOT] = ACTIONS(1713),
    [anon_sym_STAR_STAR] = ACTIONS(1713),
    [anon_sym_PLUS_PLUS] = ACTIONS(1713),
    [anon_sym_BANG] = ACTIONS(1715),
    [anon_sym_LBRACK] = ACTIONS(1713),
    [anon_sym_LT_LT] = ACTIONS(1713),
    [anon_sym_LBRACE] = ACTIONS(1715),
    [anon_sym_AMP_AMP] = ACTIONS(1713),
    [anon_sym_LT_EQ] = ACTIONS(1713),
    [anon_sym_LPAREN] = ACTIONS(1713),
    [anon_sym_RBRACK] = ACTIONS(1713),
    [anon_sym_GT] = ACTIONS(1715),
    [anon_sym_AMP] = ACTIONS(1715),
    [anon_sym_QMARK] = ACTIONS(1713),
    [anon_sym_PIPE_PIPE] = ACTIONS(1713),
    [anon_sym_EQ_EQ] = ACTIONS(1715),
    [anon_sym_RPAREN] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(1715),
    [anon_sym_SLASH] = ACTIONS(1715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1713),
    [anon_sym_PLUS] = ACTIONS(1715),
    [anon_sym_implements] = ACTIONS(1713),
    [anon_sym_GT_GT] = ACTIONS(1715),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1713),
    [anon_sym_in] = ACTIONS(1715),
  },
  [1296] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1713),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(1713),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(1713),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1713),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_in] = ACTIONS(847),
  },
  [1297] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1717),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(1717),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(1717),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1717),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(1717),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_in] = ACTIONS(847),
  },
  [1298] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1719),
    [anon_sym_BQUOTE] = ACTIONS(1719),
    [anon_sym_PERCENT_EQ] = ACTIONS(1719),
    [anon_sym_AMP_EQ] = ACTIONS(1719),
    [anon_sym_PLUS_EQ] = ACTIONS(1719),
    [anon_sym_PIPE] = ACTIONS(1721),
    [anon_sym_COMMA] = ACTIONS(1719),
    [anon_sym_DASH] = ACTIONS(1721),
    [anon_sym_STAR] = ACTIONS(1721),
    [anon_sym_GT_GT_GT] = ACTIONS(1721),
    [anon_sym_EQ] = ACTIONS(1721),
    [anon_sym_BANG_EQ] = ACTIONS(1721),
    [anon_sym_GT_EQ] = ACTIONS(1719),
    [anon_sym_CARET_EQ] = ACTIONS(1719),
    [anon_sym_PIPE_EQ] = ACTIONS(1719),
    [anon_sym_DASH_EQ] = ACTIONS(1719),
    [anon_sym_RBRACE] = ACTIONS(1719),
    [anon_sym_PERCENT] = ACTIONS(1721),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1719),
    [anon_sym_LT_LT_EQ] = ACTIONS(1719),
    [anon_sym_as] = ACTIONS(1719),
    [anon_sym_DASH_DASH] = ACTIONS(1719),
    [anon_sym_instanceof] = ACTIONS(1719),
    [anon_sym_COLON] = ACTIONS(1719),
    [anon_sym_GT_GT_EQ] = ACTIONS(1719),
    [anon_sym_DOT] = ACTIONS(1719),
    [anon_sym_STAR_STAR] = ACTIONS(1721),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1719),
    [anon_sym_PLUS_PLUS] = ACTIONS(1719),
    [anon_sym_BANG] = ACTIONS(1721),
    [anon_sym_LBRACK] = ACTIONS(1719),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1719),
    [anon_sym_LT_LT] = ACTIONS(1721),
    [anon_sym_LBRACE] = ACTIONS(1721),
    [anon_sym_AMP_AMP] = ACTIONS(1719),
    [anon_sym_LT_EQ] = ACTIONS(1719),
    [anon_sym_LPAREN] = ACTIONS(1719),
    [anon_sym_RBRACK] = ACTIONS(1719),
    [anon_sym_GT] = ACTIONS(1721),
    [anon_sym_STAR_EQ] = ACTIONS(1719),
    [anon_sym_AMP] = ACTIONS(1721),
    [anon_sym_QMARK] = ACTIONS(1719),
    [anon_sym_PIPE_PIPE] = ACTIONS(1719),
    [anon_sym_EQ_EQ] = ACTIONS(1721),
    [anon_sym_RPAREN] = ACTIONS(1719),
    [anon_sym_LT] = ACTIONS(1721),
    [anon_sym_SLASH] = ACTIONS(1721),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1721),
    [anon_sym_PLUS] = ACTIONS(1721),
    [anon_sym_implements] = ACTIONS(1719),
    [anon_sym_GT_GT] = ACTIONS(1721),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1719),
    [anon_sym_in] = ACTIONS(1721),
  },
  [1299] = {
    [sym__initializer] = STATE(589),
    [aux_sym_object_repeat1] = STATE(1834),
    [sym__automatic_semicolon] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
  },
  [1300] = {
    [aux_sym_object_repeat1] = STATE(1834),
    [sym__automatic_semicolon] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
  },
  [1301] = {
    [aux_sym_object_repeat1] = STATE(1834),
    [sym__automatic_semicolon] = ACTIONS(986),
    [anon_sym_LBRACK] = ACTIONS(1014),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_symbol] = ACTIONS(1012),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_namespace] = ACTIONS(1012),
    [sym_readonly] = ACTIONS(1012),
    [anon_sym_DQUOTE] = ACTIONS(1014),
  },
  [1302] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BQUOTE] = ACTIONS(1027),
    [anon_sym_PIPE] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1031),
    [anon_sym_GT_GT_GT] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1031),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_COLON] = ACTIONS(1027),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_of] = ACTIONS(1027),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_RBRACK] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1031),
    [anon_sym_AMP] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_RPAREN] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1031),
    [anon_sym_SLASH] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_implements] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(1031),
  },
  [1303] = {
    [sym__automatic_semicolon] = ACTIONS(1741),
    [anon_sym_RBRACE] = ACTIONS(1741),
    [anon_sym_SEMI] = ACTIONS(1741),
    [anon_sym_COMMA] = ACTIONS(1741),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1741),
    [sym_comment] = ACTIONS(3),
  },
  [1304] = {
    [sym_type_arguments] = STATE(1333),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1201),
    [sym__automatic_semicolon] = ACTIONS(1201),
    [anon_sym_BQUOTE] = ACTIONS(1201),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_COMMA] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_GT_GT_GT] = ACTIONS(1201),
    [anon_sym_BANG_EQ] = ACTIONS(1751),
    [anon_sym_GT_EQ] = ACTIONS(1201),
    [anon_sym_RBRACE] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1201),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_DASH_DASH] = ACTIONS(1201),
    [anon_sym_instanceof] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1201),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_LBRACK] = ACTIONS(4034),
    [anon_sym_SEMI] = ACTIONS(1201),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(4037),
    [anon_sym_AMP_AMP] = ACTIONS(1201),
    [anon_sym_LT_EQ] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_PIPE_PIPE] = ACTIONS(1201),
    [anon_sym_EQ_EQ] = ACTIONS(1751),
    [anon_sym_RPAREN] = ACTIONS(1201),
    [anon_sym_LT] = ACTIONS(4039),
    [anon_sym_SLASH] = ACTIONS(1751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_GT_GT] = ACTIONS(1751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(4042),
  },
  [1305] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1753),
    [anon_sym_BQUOTE] = ACTIONS(1753),
    [anon_sym_AT] = ACTIONS(1753),
    [anon_sym_PIPE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1755),
    [anon_sym_GT_GT_GT] = ACTIONS(1753),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_GT_EQ] = ACTIONS(1753),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_PERCENT] = ACTIONS(1753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1753),
    [anon_sym_as] = ACTIONS(1753),
    [anon_sym_DASH_DASH] = ACTIONS(1753),
    [anon_sym_instanceof] = ACTIONS(1753),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_DOT] = ACTIONS(1753),
    [anon_sym_STAR_STAR] = ACTIONS(1753),
    [anon_sym_PLUS_PLUS] = ACTIONS(1753),
    [anon_sym_BANG] = ACTIONS(1755),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_class] = ACTIONS(1753),
    [anon_sym_LT_LT] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_AMP_AMP] = ACTIONS(1753),
    [anon_sym_LT_EQ] = ACTIONS(1753),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_RBRACK] = ACTIONS(1753),
    [anon_sym_GT] = ACTIONS(1755),
    [anon_sym_AMP] = ACTIONS(1755),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_PIPE_PIPE] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_RPAREN] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1753),
    [anon_sym_GT_GT] = ACTIONS(1755),
    [anon_sym_implements] = ACTIONS(1753),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1753),
    [anon_sym_in] = ACTIONS(1755),
  },
  [1306] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1759),
    [anon_sym_BQUOTE] = ACTIONS(1759),
    [anon_sym_PIPE] = ACTIONS(1761),
    [anon_sym_COMMA] = ACTIONS(1759),
    [anon_sym_DASH] = ACTIONS(1761),
    [anon_sym_STAR] = ACTIONS(1761),
    [anon_sym_GT_GT_GT] = ACTIONS(1759),
    [anon_sym_BANG_EQ] = ACTIONS(1761),
    [anon_sym_GT_EQ] = ACTIONS(1759),
    [anon_sym_RBRACE] = ACTIONS(1759),
    [anon_sym_PERCENT] = ACTIONS(1759),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1759),
    [anon_sym_as] = ACTIONS(1759),
    [anon_sym_DASH_DASH] = ACTIONS(1759),
    [anon_sym_instanceof] = ACTIONS(1759),
    [anon_sym_COLON] = ACTIONS(1759),
    [anon_sym_DOT] = ACTIONS(1759),
    [anon_sym_STAR_STAR] = ACTIONS(1759),
    [anon_sym_PLUS_PLUS] = ACTIONS(1759),
    [anon_sym_BANG] = ACTIONS(1761),
    [anon_sym_LBRACK] = ACTIONS(1759),
    [anon_sym_LT_LT] = ACTIONS(1759),
    [anon_sym_LBRACE] = ACTIONS(1761),
    [anon_sym_AMP_AMP] = ACTIONS(1759),
    [anon_sym_LT_EQ] = ACTIONS(1759),
    [anon_sym_LPAREN] = ACTIONS(1759),
    [anon_sym_RBRACK] = ACTIONS(1759),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_AMP] = ACTIONS(1761),
    [anon_sym_QMARK] = ACTIONS(1759),
    [anon_sym_PIPE_PIPE] = ACTIONS(1759),
    [anon_sym_EQ_EQ] = ACTIONS(1761),
    [anon_sym_RPAREN] = ACTIONS(1759),
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_SLASH] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1759),
    [anon_sym_PLUS] = ACTIONS(1761),
    [anon_sym_implements] = ACTIONS(1759),
    [anon_sym_GT_GT] = ACTIONS(1761),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1759),
    [anon_sym_in] = ACTIONS(1761),
  },
  [1307] = {
    [sym__automatic_semicolon] = ACTIONS(1769),
    [anon_sym_RBRACE] = ACTIONS(1769),
    [anon_sym_SEMI] = ACTIONS(1769),
    [anon_sym_COMMA] = ACTIONS(1769),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1769),
    [sym_comment] = ACTIONS(3),
  },
  [1308] = {
    [sym__automatic_semicolon] = ACTIONS(1777),
    [anon_sym_RBRACE] = ACTIONS(1777),
    [anon_sym_SEMI] = ACTIONS(1777),
    [anon_sym_COMMA] = ACTIONS(1777),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
  },
  [1309] = {
    [sym_identifier] = ACTIONS(1863),
    [anon_sym_BQUOTE] = ACTIONS(1861),
    [anon_sym_debugger] = ACTIONS(1863),
    [anon_sym_symbol] = ACTIONS(1863),
    [anon_sym_AT] = ACTIONS(1861),
    [anon_sym_DASH] = ACTIONS(1863),
    [anon_sym_void] = ACTIONS(1863),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_const] = ACTIONS(1863),
    [sym_super] = ACTIONS(1863),
    [anon_sym_return] = ACTIONS(1863),
    [anon_sym_private] = ACTIONS(1863),
    [anon_sym_get] = ACTIONS(1863),
    [anon_sym_RBRACE] = ACTIONS(1861),
    [anon_sym_interface] = ACTIONS(1863),
    [anon_sym_default] = ACTIONS(1863),
    [anon_sym_enum] = ACTIONS(1863),
    [anon_sym_delete] = ACTIONS(1863),
    [anon_sym_continue] = ACTIONS(1863),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_if] = ACTIONS(1863),
    [anon_sym_this] = ACTIONS(1863),
    [anon_sym_yield] = ACTIONS(1863),
    [sym_true] = ACTIONS(1863),
    [anon_sym_throw] = ACTIONS(1863),
    [anon_sym_protected] = ACTIONS(1863),
    [anon_sym_abstract] = ACTIONS(1863),
    [anon_sym_set] = ACTIONS(1863),
    [anon_sym_type] = ACTIONS(1863),
    [anon_sym_import] = ACTIONS(1863),
    [anon_sym_namespace] = ACTIONS(1863),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_await] = ACTIONS(1863),
    [anon_sym_DQUOTE] = ACTIONS(1861),
    [anon_sym_else] = ACTIONS(1863),
    [anon_sym_BANG] = ACTIONS(1861),
    [anon_sym_for] = ACTIONS(1863),
    [anon_sym_LBRACK] = ACTIONS(1861),
    [sym_false] = ACTIONS(1863),
    [anon_sym_SEMI] = ACTIONS(1861),
    [anon_sym_case] = ACTIONS(1863),
    [anon_sym_module] = ACTIONS(1863),
    [anon_sym_number] = ACTIONS(1863),
    [anon_sym_class] = ACTIONS(1863),
    [anon_sym_declare] = ACTIONS(1863),
    [anon_sym_typeof] = ACTIONS(1863),
    [anon_sym_LBRACE] = ACTIONS(1861),
    [anon_sym_switch] = ACTIONS(1863),
    [anon_sym_LPAREN] = ACTIONS(1861),
    [sym_null] = ACTIONS(1863),
    [anon_sym_any] = ACTIONS(1863),
    [anon_sym_boolean] = ACTIONS(1863),
    [anon_sym_async] = ACTIONS(1863),
    [anon_sym_public] = ACTIONS(1863),
    [anon_sym_var] = ACTIONS(1863),
    [anon_sym_while] = ACTIONS(1863),
    [anon_sym_SQUOTE] = ACTIONS(1861),
    [anon_sym_try] = ACTIONS(1863),
    [anon_sym_LT] = ACTIONS(1861),
    [sym_number] = ACTIONS(1861),
    [anon_sym_SLASH] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1863),
    [anon_sym_function] = ACTIONS(1863),
    [sym_undefined] = ACTIONS(1863),
    [anon_sym_new] = ACTIONS(1863),
    [ts_builtin_sym_end] = ACTIONS(1861),
    [anon_sym_let] = ACTIONS(1863),
    [anon_sym_PLUS] = ACTIONS(1863),
    [anon_sym_export] = ACTIONS(1863),
    [anon_sym_do] = ACTIONS(1863),
    [anon_sym_TILDE] = ACTIONS(1861),
    [anon_sym_with] = ACTIONS(1863),
  },
  [1310] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1865),
    [sym__automatic_semicolon] = ACTIONS(1865),
    [anon_sym_BQUOTE] = ACTIONS(1865),
    [anon_sym_symbol] = ACTIONS(1867),
    [anon_sym_PIPE] = ACTIONS(1867),
    [anon_sym_STAR] = ACTIONS(1867),
    [anon_sym_GT_GT_GT] = ACTIONS(1865),
    [anon_sym_break] = ACTIONS(1867),
    [anon_sym_BANG_EQ] = ACTIONS(1867),
    [anon_sym_return] = ACTIONS(1867),
    [anon_sym_RBRACE] = ACTIONS(1865),
    [anon_sym_PERCENT] = ACTIONS(1865),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_as] = ACTIONS(1867),
    [anon_sym_delete] = ACTIONS(1867),
    [anon_sym_if] = ACTIONS(1867),
    [anon_sym_instanceof] = ACTIONS(1867),
    [anon_sym_yield] = ACTIONS(1867),
    [sym_true] = ACTIONS(1867),
    [anon_sym_protected] = ACTIONS(1867),
    [anon_sym_DOT] = ACTIONS(1867),
    [anon_sym_set] = ACTIONS(1867),
    [anon_sym_import] = ACTIONS(1867),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DQUOTE] = ACTIONS(1865),
    [anon_sym_for] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_number] = ACTIONS(1867),
    [anon_sym_typeof] = ACTIONS(1867),
    [anon_sym_LT_LT] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1865),
    [anon_sym_AMP_AMP] = ACTIONS(1865),
    [anon_sym_switch] = ACTIONS(1867),
    [anon_sym_LT_EQ] = ACTIONS(1865),
    [sym_null] = ACTIONS(1867),
    [anon_sym_any] = ACTIONS(1867),
    [anon_sym_async] = ACTIONS(1867),
    [anon_sym_public] = ACTIONS(1867),
    [anon_sym_var] = ACTIONS(1867),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_while] = ACTIONS(1867),
    [anon_sym_SQUOTE] = ACTIONS(1865),
    [anon_sym_SLASH] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1867),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_CARET] = ACTIONS(1865),
    [anon_sym_export] = ACTIONS(1867),
    [anon_sym_GT_GT] = ACTIONS(1867),
    [anon_sym_with] = ACTIONS(1867),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1865),
    [sym_identifier] = ACTIONS(1867),
    [anon_sym_debugger] = ACTIONS(1867),
    [anon_sym_AT] = ACTIONS(1865),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_DASH] = ACTIONS(1867),
    [anon_sym_void] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1865),
    [sym_super] = ACTIONS(1867),
    [anon_sym_private] = ACTIONS(1867),
    [anon_sym_get] = ACTIONS(1867),
    [anon_sym_default] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1867),
    [anon_sym_continue] = ACTIONS(1867),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_this] = ACTIONS(1867),
    [anon_sym_throw] = ACTIONS(1867),
    [anon_sym_abstract] = ACTIONS(1867),
    [anon_sym_type] = ACTIONS(1867),
    [anon_sym_STAR_STAR] = ACTIONS(1865),
    [anon_sym_namespace] = ACTIONS(1867),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_else] = ACTIONS(1867),
    [anon_sym_BANG] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [sym_false] = ACTIONS(1867),
    [anon_sym_case] = ACTIONS(1867),
    [anon_sym_module] = ACTIONS(1867),
    [anon_sym_class] = ACTIONS(1867),
    [anon_sym_declare] = ACTIONS(1867),
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_boolean] = ACTIONS(1867),
    [anon_sym_AMP] = ACTIONS(1867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1865),
    [anon_sym_try] = ACTIONS(1867),
    [anon_sym_EQ_EQ] = ACTIONS(1867),
    [anon_sym_LT] = ACTIONS(1867),
    [sym_number] = ACTIONS(1865),
    [ts_builtin_sym_end] = ACTIONS(1865),
    [anon_sym_function] = ACTIONS(1867),
    [sym_undefined] = ACTIONS(1867),
    [anon_sym_let] = ACTIONS(1867),
    [anon_sym_PLUS] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(1867),
    [anon_sym_TILDE] = ACTIONS(1865),
    [anon_sym_in] = ACTIONS(1867),
  },
  [1311] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1900),
    [anon_sym_BQUOTE] = ACTIONS(1900),
    [anon_sym_PIPE] = ACTIONS(1902),
    [anon_sym_COMMA] = ACTIONS(1900),
    [anon_sym_DASH] = ACTIONS(1902),
    [anon_sym_STAR] = ACTIONS(1902),
    [anon_sym_GT_GT_GT] = ACTIONS(1900),
    [anon_sym_EQ] = ACTIONS(1902),
    [anon_sym_BANG_EQ] = ACTIONS(1902),
    [anon_sym_GT_EQ] = ACTIONS(1900),
    [anon_sym_RBRACE] = ACTIONS(1900),
    [anon_sym_PERCENT] = ACTIONS(1900),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1900),
    [anon_sym_as] = ACTIONS(1900),
    [anon_sym_DASH_DASH] = ACTIONS(1900),
    [anon_sym_instanceof] = ACTIONS(1900),
    [anon_sym_COLON] = ACTIONS(1900),
    [anon_sym_DOT] = ACTIONS(1900),
    [anon_sym_STAR_STAR] = ACTIONS(1900),
    [anon_sym_PLUS_PLUS] = ACTIONS(1900),
    [anon_sym_BANG] = ACTIONS(1902),
    [anon_sym_LBRACK] = ACTIONS(1900),
    [anon_sym_LT_LT] = ACTIONS(1900),
    [anon_sym_LBRACE] = ACTIONS(1902),
    [anon_sym_AMP_AMP] = ACTIONS(1900),
    [anon_sym_of] = ACTIONS(1900),
    [anon_sym_LT_EQ] = ACTIONS(1900),
    [anon_sym_LPAREN] = ACTIONS(1900),
    [anon_sym_RBRACK] = ACTIONS(1900),
    [anon_sym_GT] = ACTIONS(1902),
    [anon_sym_AMP] = ACTIONS(1902),
    [anon_sym_QMARK] = ACTIONS(1900),
    [anon_sym_PIPE_PIPE] = ACTIONS(1900),
    [anon_sym_EQ_EQ] = ACTIONS(1902),
    [anon_sym_RPAREN] = ACTIONS(1900),
    [anon_sym_LT] = ACTIONS(1902),
    [anon_sym_SLASH] = ACTIONS(1902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1900),
    [anon_sym_PLUS] = ACTIONS(1902),
    [anon_sym_implements] = ACTIONS(1900),
    [anon_sym_GT_GT] = ACTIONS(1902),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1900),
    [anon_sym_in] = ACTIONS(1902),
  },
  [1312] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1958),
    [sym__automatic_semicolon] = ACTIONS(1958),
    [anon_sym_BQUOTE] = ACTIONS(1958),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_COMMA] = ACTIONS(1958),
    [anon_sym_DASH] = ACTIONS(1960),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_GT_GT_GT] = ACTIONS(1958),
    [anon_sym_BANG_EQ] = ACTIONS(1960),
    [anon_sym_GT_EQ] = ACTIONS(1958),
    [anon_sym_RBRACE] = ACTIONS(1958),
    [anon_sym_PERCENT] = ACTIONS(1958),
    [anon_sym_as] = ACTIONS(1958),
    [anon_sym_DASH_DASH] = ACTIONS(1958),
    [anon_sym_instanceof] = ACTIONS(1958),
    [anon_sym_DOT] = ACTIONS(1958),
    [anon_sym_STAR_STAR] = ACTIONS(1958),
    [anon_sym_PLUS_PLUS] = ACTIONS(1958),
    [anon_sym_else] = ACTIONS(1958),
    [anon_sym_BANG] = ACTIONS(1960),
    [anon_sym_LBRACK] = ACTIONS(1958),
    [anon_sym_SEMI] = ACTIONS(1958),
    [anon_sym_LT_LT] = ACTIONS(1958),
    [anon_sym_AMP_AMP] = ACTIONS(1958),
    [anon_sym_LT_EQ] = ACTIONS(1958),
    [anon_sym_LPAREN] = ACTIONS(1958),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_QMARK] = ACTIONS(1958),
    [anon_sym_PIPE_PIPE] = ACTIONS(1958),
    [anon_sym_while] = ACTIONS(1958),
    [anon_sym_EQ_EQ] = ACTIONS(1960),
    [anon_sym_RPAREN] = ACTIONS(1958),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_SLASH] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_PLUS] = ACTIONS(1960),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1958),
    [anon_sym_in] = ACTIONS(1960),
  },
  [1313] = {
    [anon_sym_EQ] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COMMA] = ACTIONS(986),
  },
  [1314] = {
    [anon_sym_LBRACK] = ACTIONS(1014),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_symbol] = ACTIONS(1012),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_namespace] = ACTIONS(1012),
    [sym_readonly] = ACTIONS(1012),
    [anon_sym_DQUOTE] = ACTIONS(1014),
  },
  [1315] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1992),
    [anon_sym_BQUOTE] = ACTIONS(1992),
    [anon_sym_PIPE] = ACTIONS(1994),
    [anon_sym_COMMA] = ACTIONS(1992),
    [anon_sym_DASH] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_GT_GT_GT] = ACTIONS(1992),
    [anon_sym_BANG_EQ] = ACTIONS(1994),
    [anon_sym_GT_EQ] = ACTIONS(1992),
    [anon_sym_RBRACE] = ACTIONS(1992),
    [anon_sym_PERCENT] = ACTIONS(1992),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1992),
    [anon_sym_as] = ACTIONS(1992),
    [anon_sym_DASH_DASH] = ACTIONS(1992),
    [anon_sym_instanceof] = ACTIONS(1992),
    [anon_sym_COLON] = ACTIONS(1992),
    [anon_sym_DOT] = ACTIONS(1992),
    [anon_sym_STAR_STAR] = ACTIONS(1992),
    [anon_sym_PLUS_PLUS] = ACTIONS(1992),
    [anon_sym_else] = ACTIONS(1992),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_LBRACK] = ACTIONS(1992),
    [anon_sym_LT_LT] = ACTIONS(1992),
    [anon_sym_LBRACE] = ACTIONS(1994),
    [anon_sym_AMP_AMP] = ACTIONS(1992),
    [anon_sym_LT_EQ] = ACTIONS(1992),
    [anon_sym_LPAREN] = ACTIONS(1992),
    [anon_sym_RBRACK] = ACTIONS(1992),
    [anon_sym_GT] = ACTIONS(1994),
    [anon_sym_AMP] = ACTIONS(1994),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_PIPE_PIPE] = ACTIONS(1992),
    [anon_sym_while] = ACTIONS(1992),
    [anon_sym_EQ_EQ] = ACTIONS(1994),
    [anon_sym_RPAREN] = ACTIONS(1992),
    [anon_sym_LT] = ACTIONS(1994),
    [anon_sym_SLASH] = ACTIONS(1994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1992),
    [anon_sym_PLUS] = ACTIONS(1994),
    [anon_sym_implements] = ACTIONS(1992),
    [anon_sym_GT_GT] = ACTIONS(1994),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1992),
    [anon_sym_in] = ACTIONS(1994),
  },
  [1316] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2024),
    [anon_sym_BQUOTE] = ACTIONS(2024),
    [anon_sym_PIPE] = ACTIONS(2026),
    [anon_sym_COMMA] = ACTIONS(2024),
    [anon_sym_DASH] = ACTIONS(2026),
    [anon_sym_STAR] = ACTIONS(2026),
    [anon_sym_GT_GT_GT] = ACTIONS(2024),
    [anon_sym_BANG_EQ] = ACTIONS(2026),
    [anon_sym_GT_EQ] = ACTIONS(2024),
    [anon_sym_RBRACE] = ACTIONS(2024),
    [anon_sym_PERCENT] = ACTIONS(2024),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2024),
    [anon_sym_as] = ACTIONS(2024),
    [anon_sym_DASH_DASH] = ACTIONS(2024),
    [anon_sym_instanceof] = ACTIONS(2024),
    [anon_sym_COLON] = ACTIONS(2024),
    [anon_sym_DOT] = ACTIONS(2024),
    [anon_sym_STAR_STAR] = ACTIONS(2024),
    [anon_sym_PLUS_PLUS] = ACTIONS(2024),
    [anon_sym_BANG] = ACTIONS(2026),
    [anon_sym_LBRACK] = ACTIONS(2024),
    [anon_sym_LT_LT] = ACTIONS(2024),
    [anon_sym_LBRACE] = ACTIONS(2026),
    [anon_sym_AMP_AMP] = ACTIONS(2024),
    [anon_sym_LT_EQ] = ACTIONS(2024),
    [anon_sym_LPAREN] = ACTIONS(2024),
    [anon_sym_RBRACK] = ACTIONS(2024),
    [anon_sym_GT] = ACTIONS(2026),
    [anon_sym_AMP] = ACTIONS(2026),
    [anon_sym_QMARK] = ACTIONS(2024),
    [anon_sym_PIPE_PIPE] = ACTIONS(2024),
    [anon_sym_EQ_EQ] = ACTIONS(2026),
    [anon_sym_RPAREN] = ACTIONS(2024),
    [anon_sym_LT] = ACTIONS(2026),
    [anon_sym_SLASH] = ACTIONS(2026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2024),
    [anon_sym_PLUS] = ACTIONS(2026),
    [anon_sym_implements] = ACTIONS(2024),
    [anon_sym_GT_GT] = ACTIONS(2026),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2024),
    [anon_sym_in] = ACTIONS(2026),
  },
  [1317] = {
    [sym__automatic_semicolon] = ACTIONS(2034),
    [anon_sym_RBRACE] = ACTIONS(2034),
    [anon_sym_SEMI] = ACTIONS(2034),
    [anon_sym_COMMA] = ACTIONS(2034),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2034),
    [sym_comment] = ACTIONS(3),
  },
  [1318] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2042),
    [anon_sym_BQUOTE] = ACTIONS(2042),
    [anon_sym_PIPE] = ACTIONS(2044),
    [anon_sym_COMMA] = ACTIONS(2042),
    [anon_sym_DASH] = ACTIONS(2044),
    [anon_sym_STAR] = ACTIONS(2044),
    [anon_sym_GT_GT_GT] = ACTIONS(2042),
    [anon_sym_EQ] = ACTIONS(2044),
    [anon_sym_BANG_EQ] = ACTIONS(2044),
    [anon_sym_GT_EQ] = ACTIONS(2042),
    [anon_sym_RBRACE] = ACTIONS(2042),
    [anon_sym_PERCENT] = ACTIONS(2042),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2042),
    [anon_sym_as] = ACTIONS(2042),
    [anon_sym_DASH_DASH] = ACTIONS(2042),
    [anon_sym_instanceof] = ACTIONS(2042),
    [anon_sym_COLON] = ACTIONS(2042),
    [anon_sym_DOT] = ACTIONS(2042),
    [anon_sym_STAR_STAR] = ACTIONS(2042),
    [anon_sym_PLUS_PLUS] = ACTIONS(2042),
    [anon_sym_BANG] = ACTIONS(2044),
    [anon_sym_LBRACK] = ACTIONS(2042),
    [anon_sym_LT_LT] = ACTIONS(2042),
    [anon_sym_LBRACE] = ACTIONS(2044),
    [anon_sym_AMP_AMP] = ACTIONS(2042),
    [anon_sym_of] = ACTIONS(2042),
    [anon_sym_LT_EQ] = ACTIONS(2042),
    [anon_sym_LPAREN] = ACTIONS(2042),
    [anon_sym_RBRACK] = ACTIONS(2042),
    [anon_sym_GT] = ACTIONS(2044),
    [anon_sym_AMP] = ACTIONS(2044),
    [anon_sym_QMARK] = ACTIONS(2042),
    [anon_sym_PIPE_PIPE] = ACTIONS(2042),
    [anon_sym_EQ_EQ] = ACTIONS(2044),
    [anon_sym_RPAREN] = ACTIONS(2042),
    [anon_sym_LT] = ACTIONS(2044),
    [anon_sym_SLASH] = ACTIONS(2044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2042),
    [anon_sym_PLUS] = ACTIONS(2044),
    [anon_sym_implements] = ACTIONS(2042),
    [anon_sym_GT_GT] = ACTIONS(2044),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2042),
    [anon_sym_in] = ACTIONS(2044),
  },
  [1319] = {
    [sym__initializer] = STATE(589),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(3484),
    [sym__automatic_semicolon] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(3484),
    [sym_comment] = ACTIONS(3),
  },
  [1320] = {
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(3484),
    [sym__automatic_semicolon] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(3484),
    [sym_comment] = ACTIONS(3),
  },
  [1321] = {
    [sym__automatic_semicolon] = ACTIONS(986),
    [anon_sym_LBRACK] = ACTIONS(1014),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_symbol] = ACTIONS(1012),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_COMMA] = ACTIONS(3484),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_RBRACE] = ACTIONS(3484),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_namespace] = ACTIONS(1012),
    [sym_readonly] = ACTIONS(1012),
    [anon_sym_DQUOTE] = ACTIONS(1014),
  },
  [1322] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2075),
    [anon_sym_BQUOTE] = ACTIONS(2075),
    [anon_sym_PIPE] = ACTIONS(2077),
    [anon_sym_COMMA] = ACTIONS(2075),
    [anon_sym_DASH] = ACTIONS(2077),
    [anon_sym_STAR] = ACTIONS(2077),
    [anon_sym_GT_GT_GT] = ACTIONS(2075),
    [anon_sym_EQ] = ACTIONS(2077),
    [anon_sym_BANG_EQ] = ACTIONS(2077),
    [anon_sym_GT_EQ] = ACTIONS(2075),
    [anon_sym_RBRACE] = ACTIONS(2075),
    [anon_sym_PERCENT] = ACTIONS(2075),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2075),
    [anon_sym_as] = ACTIONS(2075),
    [anon_sym_DASH_DASH] = ACTIONS(2075),
    [anon_sym_instanceof] = ACTIONS(2075),
    [anon_sym_COLON] = ACTIONS(2075),
    [anon_sym_DOT] = ACTIONS(2075),
    [anon_sym_STAR_STAR] = ACTIONS(2075),
    [anon_sym_PLUS_PLUS] = ACTIONS(2075),
    [anon_sym_BANG] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(2075),
    [anon_sym_LT_LT] = ACTIONS(2075),
    [anon_sym_LBRACE] = ACTIONS(2077),
    [anon_sym_AMP_AMP] = ACTIONS(2075),
    [anon_sym_of] = ACTIONS(2075),
    [anon_sym_LT_EQ] = ACTIONS(2075),
    [anon_sym_LPAREN] = ACTIONS(2075),
    [anon_sym_RBRACK] = ACTIONS(2075),
    [anon_sym_GT] = ACTIONS(2077),
    [anon_sym_AMP] = ACTIONS(2077),
    [anon_sym_QMARK] = ACTIONS(2075),
    [anon_sym_PIPE_PIPE] = ACTIONS(2075),
    [anon_sym_EQ_EQ] = ACTIONS(2077),
    [anon_sym_RPAREN] = ACTIONS(2075),
    [anon_sym_LT] = ACTIONS(2077),
    [anon_sym_SLASH] = ACTIONS(2077),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2075),
    [anon_sym_PLUS] = ACTIONS(2077),
    [anon_sym_implements] = ACTIONS(2075),
    [anon_sym_GT_GT] = ACTIONS(2077),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2075),
    [anon_sym_in] = ACTIONS(2077),
  },
  [1323] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2081),
    [sym__automatic_semicolon] = ACTIONS(2081),
    [anon_sym_BQUOTE] = ACTIONS(2081),
    [anon_sym_PIPE] = ACTIONS(2083),
    [anon_sym_COMMA] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2083),
    [anon_sym_GT_GT_GT] = ACTIONS(2081),
    [anon_sym_BANG_EQ] = ACTIONS(2083),
    [anon_sym_GT_EQ] = ACTIONS(2081),
    [anon_sym_RBRACE] = ACTIONS(2081),
    [anon_sym_PERCENT] = ACTIONS(2081),
    [anon_sym_as] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(2081),
    [anon_sym_instanceof] = ACTIONS(2081),
    [anon_sym_DOT] = ACTIONS(2081),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2081),
    [anon_sym_PLUS_PLUS] = ACTIONS(2081),
    [anon_sym_else] = ACTIONS(2081),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_SEMI] = ACTIONS(2081),
    [anon_sym_LT_LT] = ACTIONS(2081),
    [anon_sym_AMP_AMP] = ACTIONS(2081),
    [anon_sym_LT_EQ] = ACTIONS(2081),
    [anon_sym_LPAREN] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_QMARK] = ACTIONS(2081),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_while] = ACTIONS(2081),
    [anon_sym_EQ_EQ] = ACTIONS(2083),
    [anon_sym_RPAREN] = ACTIONS(2081),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_GT_GT] = ACTIONS(2083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2081),
    [anon_sym_in] = ACTIONS(2083),
  },
  [1324] = {
    [sym_type_alias_declaration] = STATE(1357),
    [aux_sym_export_statement_repeat1] = STATE(1763),
    [sym__declaration] = STATE(1357),
    [sym_ambient_declaration] = STATE(1357),
    [sym_import_alias] = STATE(1357),
    [sym_export_statement] = STATE(1357),
    [sym_generator_function] = STATE(1357),
    [sym_lexical_declaration] = STATE(1357),
    [sym_internal_module] = STATE(1357),
    [sym_decorator] = STATE(1763),
    [sym_enum_declaration] = STATE(1357),
    [sym_function] = STATE(1357),
    [sym_function_signature] = STATE(1357),
    [sym_variable_declaration] = STATE(1357),
    [sym_abstract_class] = STATE(1357),
    [sym_module] = STATE(1357),
    [sym_interface_declaration] = STATE(1357),
    [sym_class] = STATE(1357),
    [anon_sym_var] = ACTIONS(2263),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_interface] = ACTIONS(2265),
    [anon_sym_enum] = ACTIONS(2269),
    [anon_sym_default] = ACTIONS(4030),
    [anon_sym_module] = ACTIONS(2249),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_declare] = ACTIONS(2253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_const] = ACTIONS(2259),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_abstract] = ACTIONS(2275),
    [anon_sym_type] = ACTIONS(2277),
    [anon_sym_let] = ACTIONS(2279),
    [anon_sym_import] = ACTIONS(2281),
    [anon_sym_export] = ACTIONS(2283),
    [anon_sym_namespace] = ACTIONS(2285),
    [anon_sym_async] = ACTIONS(2261),
  },
  [1325] = {
    [anon_sym_COLON] = ACTIONS(2144),
    [anon_sym_RBRACE] = ACTIONS(2144),
    [sym__automatic_semicolon] = ACTIONS(2144),
    [anon_sym_SEMI] = ACTIONS(2144),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2144),
    [anon_sym_COMMA] = ACTIONS(2144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2144),
  },
  [1326] = {
    [sym_identifier] = ACTIONS(2150),
    [anon_sym_BQUOTE] = ACTIONS(2148),
    [anon_sym_debugger] = ACTIONS(2150),
    [anon_sym_symbol] = ACTIONS(2150),
    [anon_sym_AT] = ACTIONS(2148),
    [anon_sym_DASH] = ACTIONS(2150),
    [anon_sym_void] = ACTIONS(2150),
    [anon_sym_break] = ACTIONS(2150),
    [anon_sym_const] = ACTIONS(2150),
    [sym_super] = ACTIONS(2150),
    [anon_sym_return] = ACTIONS(2150),
    [anon_sym_private] = ACTIONS(2150),
    [anon_sym_get] = ACTIONS(2150),
    [anon_sym_interface] = ACTIONS(2150),
    [anon_sym_enum] = ACTIONS(2150),
    [anon_sym_delete] = ACTIONS(2150),
    [anon_sym_continue] = ACTIONS(2150),
    [anon_sym_DASH_DASH] = ACTIONS(2148),
    [anon_sym_if] = ACTIONS(2150),
    [anon_sym_this] = ACTIONS(2150),
    [anon_sym_yield] = ACTIONS(2150),
    [sym_true] = ACTIONS(2150),
    [anon_sym_throw] = ACTIONS(2150),
    [anon_sym_protected] = ACTIONS(2150),
    [anon_sym_abstract] = ACTIONS(2150),
    [anon_sym_set] = ACTIONS(2150),
    [anon_sym_type] = ACTIONS(2150),
    [anon_sym_import] = ACTIONS(2150),
    [anon_sym_namespace] = ACTIONS(2150),
    [anon_sym_PLUS_PLUS] = ACTIONS(2148),
    [anon_sym_await] = ACTIONS(2150),
    [anon_sym_DQUOTE] = ACTIONS(2148),
    [anon_sym_BANG] = ACTIONS(2148),
    [anon_sym_for] = ACTIONS(2150),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [sym_false] = ACTIONS(2150),
    [anon_sym_SEMI] = ACTIONS(2148),
    [anon_sym_module] = ACTIONS(2150),
    [anon_sym_number] = ACTIONS(2150),
    [anon_sym_class] = ACTIONS(2150),
    [anon_sym_declare] = ACTIONS(2150),
    [anon_sym_typeof] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(2148),
    [anon_sym_switch] = ACTIONS(2150),
    [anon_sym_LPAREN] = ACTIONS(2148),
    [sym_null] = ACTIONS(2150),
    [anon_sym_any] = ACTIONS(2150),
    [anon_sym_boolean] = ACTIONS(2150),
    [anon_sym_async] = ACTIONS(2150),
    [anon_sym_public] = ACTIONS(2150),
    [anon_sym_var] = ACTIONS(2150),
    [anon_sym_while] = ACTIONS(2150),
    [anon_sym_SQUOTE] = ACTIONS(2148),
    [anon_sym_try] = ACTIONS(2150),
    [anon_sym_LT] = ACTIONS(2148),
    [sym_number] = ACTIONS(2148),
    [anon_sym_SLASH] = ACTIONS(2150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2150),
    [anon_sym_function] = ACTIONS(2150),
    [sym_undefined] = ACTIONS(2150),
    [anon_sym_new] = ACTIONS(2150),
    [anon_sym_let] = ACTIONS(2150),
    [anon_sym_PLUS] = ACTIONS(2150),
    [anon_sym_export] = ACTIONS(2150),
    [anon_sym_do] = ACTIONS(2150),
    [anon_sym_TILDE] = ACTIONS(2148),
    [anon_sym_with] = ACTIONS(2150),
  },
  [1327] = {
    [sym_new_expression] = STATE(1396),
    [sym_augmented_assignment_expression] = STATE(1396),
    [sym_unary_expression] = STATE(1396),
    [sym_update_expression] = STATE(1396),
    [sym_regex] = STATE(1396),
    [sym_meta_property] = STATE(1396),
    [sym_call_signature] = STATE(1740),
    [sym_statement_block] = STATE(1395),
    [sym__expression] = STATE(1396),
    [sym_yield_expression] = STATE(1396),
    [sym_as_expression] = STATE(1396),
    [sym_non_null_expression] = STATE(1396),
    [sym_internal_module] = STATE(1396),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1396),
    [sym_await_expression] = STATE(1396),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1396),
    [sym_this] = STATE(1396),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1396),
    [sym_generator_function] = STATE(1396),
    [sym_call_expression] = STATE(1396),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1396),
    [sym_ternary_expression] = STATE(1396),
    [sym_binary_expression] = STATE(1396),
    [sym_template_string] = STATE(1396),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1396),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1396),
    [sym_class] = STATE(1396),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(4045),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(4045),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4045),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4047),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4045),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1328] = {
    [sym_new_expression] = STATE(1398),
    [sym_augmented_assignment_expression] = STATE(1398),
    [sym_unary_expression] = STATE(1398),
    [sym_update_expression] = STATE(1398),
    [sym_regex] = STATE(1398),
    [sym_meta_property] = STATE(1398),
    [sym_call_signature] = STATE(1740),
    [sym_statement_block] = STATE(1397),
    [sym__expression] = STATE(1398),
    [sym_yield_expression] = STATE(1398),
    [sym_as_expression] = STATE(1398),
    [sym_non_null_expression] = STATE(1398),
    [sym_internal_module] = STATE(1398),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1398),
    [sym_await_expression] = STATE(1398),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1398),
    [sym_this] = STATE(1398),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1398),
    [sym_generator_function] = STATE(1398),
    [sym_call_expression] = STATE(1398),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1398),
    [sym_ternary_expression] = STATE(1398),
    [sym_binary_expression] = STATE(1398),
    [sym_template_string] = STATE(1398),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1398),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1398),
    [sym_class] = STATE(1398),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(4049),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(4049),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4049),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4051),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4049),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1329] = {
    [sym__automatic_semicolon] = ACTIONS(2200),
    [anon_sym_RBRACE] = ACTIONS(2200),
    [anon_sym_SEMI] = ACTIONS(2200),
    [anon_sym_COMMA] = ACTIONS(2200),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2200),
    [sym_comment] = ACTIONS(3),
  },
  [1330] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1033),
    [sym__automatic_semicolon] = ACTIONS(1033),
    [anon_sym_BQUOTE] = ACTIONS(1033),
    [anon_sym_symbol] = ACTIONS(1029),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1029),
    [anon_sym_GT_GT_GT] = ACTIONS(1033),
    [anon_sym_break] = ACTIONS(1029),
    [anon_sym_BANG_EQ] = ACTIONS(1029),
    [anon_sym_return] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_PERCENT] = ACTIONS(1033),
    [anon_sym_interface] = ACTIONS(1029),
    [anon_sym_as] = ACTIONS(1029),
    [anon_sym_delete] = ACTIONS(1029),
    [anon_sym_if] = ACTIONS(1029),
    [anon_sym_instanceof] = ACTIONS(1029),
    [anon_sym_yield] = ACTIONS(1029),
    [sym_true] = ACTIONS(1029),
    [anon_sym_protected] = ACTIONS(1029),
    [anon_sym_DOT] = ACTIONS(1029),
    [anon_sym_set] = ACTIONS(1029),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1033),
    [anon_sym_import] = ACTIONS(1029),
    [anon_sym_await] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(1033),
    [anon_sym_for] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1033),
    [anon_sym_number] = ACTIONS(1029),
    [anon_sym_typeof] = ACTIONS(1029),
    [anon_sym_LT_LT] = ACTIONS(1033),
    [anon_sym_LBRACE] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_switch] = ACTIONS(1029),
    [anon_sym_LT_EQ] = ACTIONS(1033),
    [sym_null] = ACTIONS(1029),
    [anon_sym_any] = ACTIONS(1029),
    [anon_sym_async] = ACTIONS(1029),
    [anon_sym_public] = ACTIONS(1029),
    [anon_sym_var] = ACTIONS(1029),
    [anon_sym_QMARK] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(1033),
    [anon_sym_SLASH] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1029),
    [anon_sym_new] = ACTIONS(1029),
    [anon_sym_CARET] = ACTIONS(1033),
    [anon_sym_export] = ACTIONS(1029),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_with] = ACTIONS(1029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1029),
    [anon_sym_debugger] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(1033),
    [anon_sym_COMMA] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1029),
    [anon_sym_void] = ACTIONS(1029),
    [anon_sym_const] = ACTIONS(1029),
    [anon_sym_GT_EQ] = ACTIONS(1033),
    [sym_super] = ACTIONS(1029),
    [anon_sym_private] = ACTIONS(1029),
    [anon_sym_get] = ACTIONS(1029),
    [anon_sym_default] = ACTIONS(1029),
    [anon_sym_enum] = ACTIONS(1029),
    [anon_sym_continue] = ACTIONS(1029),
    [anon_sym_DASH_DASH] = ACTIONS(1033),
    [anon_sym_this] = ACTIONS(1029),
    [anon_sym_throw] = ACTIONS(1029),
    [anon_sym_abstract] = ACTIONS(1029),
    [anon_sym_type] = ACTIONS(1029),
    [anon_sym_STAR_STAR] = ACTIONS(1033),
    [anon_sym_namespace] = ACTIONS(1029),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_else] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [sym_false] = ACTIONS(1029),
    [anon_sym_case] = ACTIONS(1029),
    [anon_sym_module] = ACTIONS(1029),
    [anon_sym_class] = ACTIONS(1029),
    [anon_sym_declare] = ACTIONS(1029),
    [anon_sym_LPAREN] = ACTIONS(1033),
    [anon_sym_GT] = ACTIONS(1029),
    [anon_sym_boolean] = ACTIONS(1029),
    [anon_sym_AMP] = ACTIONS(1029),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_try] = ACTIONS(1029),
    [anon_sym_EQ_EQ] = ACTIONS(1029),
    [anon_sym_LT] = ACTIONS(1029),
    [sym_number] = ACTIONS(1033),
    [ts_builtin_sym_end] = ACTIONS(1033),
    [anon_sym_function] = ACTIONS(1029),
    [sym_undefined] = ACTIONS(1029),
    [anon_sym_let] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1029),
    [anon_sym_do] = ACTIONS(1029),
    [anon_sym_TILDE] = ACTIONS(1033),
    [anon_sym_in] = ACTIONS(1029),
  },
  [1331] = {
    [sym__type] = STATE(1402),
    [sym_constructor_type] = STATE(1402),
    [sym_index_type_query] = STATE(1259),
    [sym_lookup_type] = STATE(1259),
    [sym_this_type] = STATE(1259),
    [sym_flow_maybe_type] = STATE(1259),
    [sym_function_type] = STATE(1402),
    [sym_nested_identifier] = STATE(2241),
    [sym__primary_type] = STATE(1259),
    [sym_generic_type] = STATE(1259),
    [sym_mapped_type] = STATE(1259),
    [sym_literal_type] = STATE(1259),
    [sym_parenthesized_type] = STATE(1259),
    [sym_predefined_type] = STATE(1259),
    [sym_type_parameters] = STATE(2240),
    [sym_string] = STATE(1251),
    [sym_array_type] = STATE(1259),
    [sym_tuple_type] = STATE(1259),
    [sym_nested_type_identifier] = STATE(1258),
    [sym_type_predicate] = STATE(1259),
    [sym_type_query] = STATE(1259),
    [sym__number] = STATE(1251),
    [sym_existential_type] = STATE(1259),
    [sym_object_type] = STATE(1259),
    [sym_union_type] = STATE(1402),
    [sym_intersection_type] = STATE(1402),
    [sym_formal_parameters] = STATE(1796),
    [sym_identifier] = ACTIONS(1600),
    [sym_false] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1606),
    [anon_sym_number] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_keyof] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_void] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_QMARK] = ACTIONS(1626),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1628),
    [sym_number] = ACTIONS(1630),
    [sym_true] = ACTIONS(1602),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_new] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [1332] = {
    [sym__type] = STATE(1403),
    [sym_constructor_type] = STATE(1403),
    [sym_index_type_query] = STATE(1259),
    [sym_lookup_type] = STATE(1259),
    [sym_this_type] = STATE(1259),
    [sym_flow_maybe_type] = STATE(1259),
    [sym_function_type] = STATE(1403),
    [sym_nested_identifier] = STATE(2241),
    [sym__primary_type] = STATE(1259),
    [sym_generic_type] = STATE(1259),
    [sym_mapped_type] = STATE(1259),
    [sym_literal_type] = STATE(1259),
    [sym_parenthesized_type] = STATE(1259),
    [sym_predefined_type] = STATE(1259),
    [sym_type_parameters] = STATE(2240),
    [sym_string] = STATE(1251),
    [sym_array_type] = STATE(1259),
    [sym_tuple_type] = STATE(1259),
    [sym_nested_type_identifier] = STATE(1258),
    [sym_type_predicate] = STATE(1259),
    [sym_type_query] = STATE(1259),
    [sym__number] = STATE(1251),
    [sym_existential_type] = STATE(1259),
    [sym_object_type] = STATE(1259),
    [sym_union_type] = STATE(1403),
    [sym_intersection_type] = STATE(1403),
    [sym_formal_parameters] = STATE(1796),
    [sym_identifier] = ACTIONS(1600),
    [sym_false] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1606),
    [anon_sym_number] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_keyof] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_void] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_QMARK] = ACTIONS(1626),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1628),
    [sym_number] = ACTIONS(1630),
    [sym_true] = ACTIONS(1602),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_new] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [1333] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_BQUOTE] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_GT_GT_GT] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_PERCENT] = ACTIONS(2223),
    [anon_sym_as] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_DOT] = ACTIONS(2223),
    [anon_sym_STAR_STAR] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_BANG] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_LT_LT] = ACTIONS(2223),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(2223),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_GT_GT] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(2225),
  },
  [1334] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2227),
    [sym__automatic_semicolon] = ACTIONS(2227),
    [anon_sym_BQUOTE] = ACTIONS(2227),
    [anon_sym_PIPE] = ACTIONS(2229),
    [anon_sym_COMMA] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_GT_GT_GT] = ACTIONS(2227),
    [anon_sym_BANG_EQ] = ACTIONS(2229),
    [anon_sym_GT_EQ] = ACTIONS(2227),
    [anon_sym_RBRACE] = ACTIONS(2227),
    [anon_sym_PERCENT] = ACTIONS(2227),
    [anon_sym_as] = ACTIONS(2227),
    [anon_sym_DASH_DASH] = ACTIONS(2227),
    [anon_sym_instanceof] = ACTIONS(2227),
    [anon_sym_DOT] = ACTIONS(2227),
    [anon_sym_STAR_STAR] = ACTIONS(2227),
    [anon_sym_PLUS_PLUS] = ACTIONS(2227),
    [anon_sym_BANG] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_SEMI] = ACTIONS(2227),
    [anon_sym_LT_LT] = ACTIONS(2227),
    [anon_sym_AMP_AMP] = ACTIONS(2227),
    [anon_sym_LT_EQ] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(2227),
    [anon_sym_GT] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2229),
    [anon_sym_QMARK] = ACTIONS(2227),
    [anon_sym_PIPE_PIPE] = ACTIONS(2227),
    [anon_sym_EQ_EQ] = ACTIONS(2229),
    [anon_sym_RPAREN] = ACTIONS(2227),
    [anon_sym_LT] = ACTIONS(2229),
    [anon_sym_SLASH] = ACTIONS(2229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2227),
    [anon_sym_PLUS] = ACTIONS(2229),
    [anon_sym_GT_GT] = ACTIONS(2229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2227),
    [anon_sym_in] = ACTIONS(2229),
  },
  [1335] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2245),
    [sym__automatic_semicolon] = ACTIONS(2245),
    [anon_sym_BQUOTE] = ACTIONS(2245),
    [anon_sym_PIPE] = ACTIONS(2247),
    [anon_sym_COMMA] = ACTIONS(2245),
    [anon_sym_DASH] = ACTIONS(2247),
    [anon_sym_STAR] = ACTIONS(2247),
    [anon_sym_GT_GT_GT] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2247),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_RBRACE] = ACTIONS(2245),
    [anon_sym_PERCENT] = ACTIONS(2245),
    [anon_sym_as] = ACTIONS(2245),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_instanceof] = ACTIONS(2245),
    [anon_sym_DOT] = ACTIONS(2245),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2245),
    [anon_sym_STAR_STAR] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_BANG] = ACTIONS(2247),
    [anon_sym_LBRACK] = ACTIONS(2245),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_AMP_AMP] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_LPAREN] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2247),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_RPAREN] = ACTIONS(2245),
    [anon_sym_LT] = ACTIONS(2247),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2247),
    [anon_sym_GT_GT] = ACTIONS(2247),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2245),
    [anon_sym_in] = ACTIONS(2247),
  },
  [1336] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2301),
    [sym__automatic_semicolon] = ACTIONS(2301),
    [anon_sym_BQUOTE] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_DASH] = ACTIONS(2303),
    [anon_sym_STAR] = ACTIONS(2303),
    [anon_sym_GT_GT_GT] = ACTIONS(2301),
    [anon_sym_BANG_EQ] = ACTIONS(2303),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_as] = ACTIONS(2301),
    [anon_sym_DASH_DASH] = ACTIONS(2301),
    [anon_sym_instanceof] = ACTIONS(2301),
    [anon_sym_DOT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2301),
    [anon_sym_PLUS_PLUS] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_LT_LT] = ACTIONS(2301),
    [anon_sym_AMP_AMP] = ACTIONS(2301),
    [anon_sym_LT_EQ] = ACTIONS(2301),
    [anon_sym_LPAREN] = ACTIONS(2301),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_QMARK] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_EQ_EQ] = ACTIONS(2303),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_SLASH] = ACTIONS(2303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2303),
    [anon_sym_GT_GT] = ACTIONS(2303),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2301),
    [anon_sym_in] = ACTIONS(2303),
  },
  [1337] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2305),
    [sym__automatic_semicolon] = ACTIONS(2305),
    [anon_sym_BQUOTE] = ACTIONS(2305),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(2307),
    [anon_sym_GT_GT_GT] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_PERCENT] = ACTIONS(2305),
    [anon_sym_as] = ACTIONS(2305),
    [anon_sym_DASH_DASH] = ACTIONS(2305),
    [anon_sym_instanceof] = ACTIONS(2305),
    [anon_sym_DOT] = ACTIONS(4053),
    [anon_sym_STAR_STAR] = ACTIONS(2305),
    [anon_sym_PLUS_PLUS] = ACTIONS(2305),
    [anon_sym_BANG] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(2305),
    [anon_sym_AMP_AMP] = ACTIONS(2305),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_LPAREN] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_QMARK] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2305),
    [anon_sym_in] = ACTIONS(2307),
  },
  [1338] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2311),
    [sym__automatic_semicolon] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(2311),
    [anon_sym_PIPE] = ACTIONS(2313),
    [anon_sym_COMMA] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_STAR] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_BANG_EQ] = ACTIONS(2313),
    [anon_sym_GT_EQ] = ACTIONS(2311),
    [anon_sym_RBRACE] = ACTIONS(2311),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_as] = ACTIONS(2311),
    [anon_sym_DASH_DASH] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2311),
    [anon_sym_DOT] = ACTIONS(2311),
    [anon_sym_STAR_STAR] = ACTIONS(2311),
    [anon_sym_PLUS_PLUS] = ACTIONS(2311),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2311),
    [anon_sym_SEMI] = ACTIONS(2311),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_AMP_AMP] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2311),
    [anon_sym_GT] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2313),
    [anon_sym_QMARK] = ACTIONS(2311),
    [anon_sym_PIPE_PIPE] = ACTIONS(2311),
    [anon_sym_EQ_EQ] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(2311),
    [anon_sym_LT] = ACTIONS(2313),
    [anon_sym_SLASH] = ACTIONS(2313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2311),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2311),
    [anon_sym_in] = ACTIONS(2313),
  },
  [1339] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2315),
    [sym__automatic_semicolon] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2317),
    [anon_sym_COMMA] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2317),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2315),
    [anon_sym_BANG_EQ] = ACTIONS(2317),
    [anon_sym_GT_EQ] = ACTIONS(2315),
    [anon_sym_RBRACE] = ACTIONS(2315),
    [anon_sym_PERCENT] = ACTIONS(2315),
    [anon_sym_as] = ACTIONS(2315),
    [anon_sym_DASH_DASH] = ACTIONS(2315),
    [anon_sym_instanceof] = ACTIONS(2315),
    [anon_sym_DOT] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(2315),
    [anon_sym_PLUS_PLUS] = ACTIONS(2315),
    [anon_sym_BANG] = ACTIONS(2317),
    [anon_sym_LBRACK] = ACTIONS(2315),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_LT_EQ] = ACTIONS(2315),
    [anon_sym_LPAREN] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2317),
    [anon_sym_AMP] = ACTIONS(2317),
    [anon_sym_QMARK] = ACTIONS(2315),
    [anon_sym_PIPE_PIPE] = ACTIONS(2315),
    [anon_sym_EQ_EQ] = ACTIONS(2317),
    [anon_sym_RPAREN] = ACTIONS(2315),
    [anon_sym_LT] = ACTIONS(2317),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2315),
    [anon_sym_PLUS] = ACTIONS(2317),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2315),
    [anon_sym_in] = ACTIONS(2317),
  },
  [1340] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2319),
    [sym__automatic_semicolon] = ACTIONS(2319),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_PIPE] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_GT_GT_GT] = ACTIONS(2319),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_GT_EQ] = ACTIONS(2319),
    [anon_sym_RBRACE] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2319),
    [anon_sym_as] = ACTIONS(2319),
    [anon_sym_DASH_DASH] = ACTIONS(2319),
    [anon_sym_instanceof] = ACTIONS(2319),
    [anon_sym_DOT] = ACTIONS(2319),
    [anon_sym_STAR_STAR] = ACTIONS(2319),
    [anon_sym_PLUS_PLUS] = ACTIONS(2319),
    [anon_sym_BANG] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [anon_sym_SEMI] = ACTIONS(2319),
    [anon_sym_LT_LT] = ACTIONS(2319),
    [anon_sym_AMP_AMP] = ACTIONS(2319),
    [anon_sym_LT_EQ] = ACTIONS(2319),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_GT] = ACTIONS(2321),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2319),
    [anon_sym_PIPE_PIPE] = ACTIONS(2319),
    [anon_sym_EQ_EQ] = ACTIONS(2321),
    [anon_sym_RPAREN] = ACTIONS(2319),
    [anon_sym_LT] = ACTIONS(2321),
    [anon_sym_SLASH] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2319),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_GT_GT] = ACTIONS(2321),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2319),
    [anon_sym_in] = ACTIONS(2321),
  },
  [1341] = {
    [sym_new_expression] = STATE(138),
    [sym_constructor_type] = STATE(514),
    [sym_augmented_assignment_expression] = STATE(138),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(138),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(138),
    [sym_call_signature] = STATE(1740),
    [sym_yield_expression] = STATE(138),
    [sym_as_expression] = STATE(138),
    [sym_internal_module] = STATE(138),
    [sym_arrow_function] = STATE(138),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(1201),
    [sym_mapped_type] = STATE(237),
    [sym_spread_element] = STATE(139),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1535),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(1202),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(138),
    [sym_subscript_expression] = STATE(1201),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(138),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(138),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(514),
    [sym__type] = STATE(514),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(138),
    [sym_meta_property] = STATE(138),
    [sym_function_type] = STATE(514),
    [sym__expression] = STATE(138),
    [sym_non_null_expression] = STATE(138),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(138),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(138),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [aux_sym_array_repeat1] = STATE(140),
    [sym_anonymous_class] = STATE(138),
    [sym_call_expression] = STATE(138),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(138),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(138),
    [sym_type_arguments] = STATE(1205),
    [sym_union_type] = STATE(514),
    [sym_parenthesized_expression] = STATE(138),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(138),
    [sym_class] = STATE(138),
    [sym_identifier] = ACTIONS(2325),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(2327),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(2329),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_void] = ACTIONS(2331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2333),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(2335),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(2335),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(2327),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_RBRACK] = ACTIONS(304),
    [sym_null] = ACTIONS(288),
    [anon_sym_any] = ACTIONS(2327),
    [anon_sym_boolean] = ACTIONS(2327),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2347),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2327),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(288),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2329),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1342] = {
    [sym_pair] = STATE(1776),
    [aux_sym_export_statement_repeat1] = STATE(785),
    [sym_object] = STATE(310),
    [sym__property_name] = STATE(786),
    [aux_sym_object_repeat1] = STATE(1778),
    [sym_assignment_pattern] = STATE(1776),
    [sym_method_signature] = STATE(2043),
    [sym_property_signature] = STATE(2043),
    [sym_call_signature] = STATE(2043),
    [sym_construct_signature] = STATE(2043),
    [sym_export_statement] = STATE(2043),
    [sym_method_definition] = STATE(1776),
    [sym_index_signature] = STATE(2043),
    [sym_decorator] = STATE(785),
    [sym_accessibility_modifier] = STATE(787),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(786),
    [sym_array] = STATE(312),
    [sym_spread_element] = STATE(1776),
    [sym_string] = STATE(786),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(2357),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_module] = ACTIONS(2361),
    [anon_sym_symbol] = ACTIONS(2361),
    [anon_sym_number] = ACTIONS(2361),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(4057),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_void] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(2361),
    [anon_sym_private] = ACTIONS(2367),
    [anon_sym_boolean] = ACTIONS(2361),
    [anon_sym_static] = ACTIONS(2369),
    [anon_sym_async] = ACTIONS(2371),
    [anon_sym_get] = ACTIONS(2373),
    [anon_sym_RBRACE] = ACTIONS(4059),
    [anon_sym_public] = ACTIONS(2367),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2367),
    [anon_sym_string] = ACTIONS(2361),
    [anon_sym_set] = ACTIONS(2373),
    [anon_sym_type] = ACTIONS(2361),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(2361),
    [anon_sym_export] = ACTIONS(2379),
    [sym_readonly] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(2361),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4061),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1343] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [sym__automatic_semicolon] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(213),
    [anon_sym_PIPE] = ACTIONS(4063),
    [anon_sym_COMMA] = ACTIONS(2383),
    [anon_sym_DASH] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [anon_sym_RBRACE] = ACTIONS(213),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_DASH_DASH] = ACTIONS(213),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_PLUS_PLUS] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_SEMI] = ACTIONS(213),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(213),
    [anon_sym_GT] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_RPAREN] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_SLASH] = ACTIONS(215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(215),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(215),
  },
  [1344] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2388),
    [sym__automatic_semicolon] = ACTIONS(2388),
    [anon_sym_BQUOTE] = ACTIONS(2388),
    [anon_sym_PIPE] = ACTIONS(2390),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_GT_GT_GT] = ACTIONS(2388),
    [anon_sym_BANG_EQ] = ACTIONS(2390),
    [anon_sym_GT_EQ] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_PERCENT] = ACTIONS(2388),
    [anon_sym_as] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [anon_sym_instanceof] = ACTIONS(2388),
    [anon_sym_DOT] = ACTIONS(2388),
    [anon_sym_STAR_STAR] = ACTIONS(2388),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym_LT_LT] = ACTIONS(2388),
    [anon_sym_AMP_AMP] = ACTIONS(2388),
    [anon_sym_LT_EQ] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_GT] = ACTIONS(2390),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_QMARK] = ACTIONS(2388),
    [anon_sym_PIPE_PIPE] = ACTIONS(2388),
    [anon_sym_EQ_EQ] = ACTIONS(2390),
    [anon_sym_RPAREN] = ACTIONS(2388),
    [anon_sym_LT] = ACTIONS(2390),
    [anon_sym_SLASH] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2388),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_GT_GT] = ACTIONS(2390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2388),
    [anon_sym_in] = ACTIONS(2390),
  },
  [1345] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2392),
    [sym__automatic_semicolon] = ACTIONS(2392),
    [anon_sym_BQUOTE] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2394),
    [anon_sym_COMMA] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_GT_GT_GT] = ACTIONS(2392),
    [anon_sym_BANG_EQ] = ACTIONS(2394),
    [anon_sym_GT_EQ] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_PERCENT] = ACTIONS(2392),
    [anon_sym_as] = ACTIONS(2392),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [anon_sym_instanceof] = ACTIONS(2392),
    [anon_sym_DOT] = ACTIONS(2392),
    [anon_sym_STAR_STAR] = ACTIONS(2392),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym_LT_LT] = ACTIONS(2392),
    [anon_sym_AMP_AMP] = ACTIONS(2392),
    [anon_sym_LT_EQ] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_GT] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_QMARK] = ACTIONS(2392),
    [anon_sym_PIPE_PIPE] = ACTIONS(2392),
    [anon_sym_EQ_EQ] = ACTIONS(2394),
    [anon_sym_RPAREN] = ACTIONS(2392),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_SLASH] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2392),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_GT_GT] = ACTIONS(2394),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2392),
    [anon_sym_in] = ACTIONS(2394),
  },
  [1346] = {
    [sym__type] = STATE(1413),
    [sym_constructor_type] = STATE(1413),
    [sym_index_type_query] = STATE(1259),
    [sym_lookup_type] = STATE(1259),
    [sym_this_type] = STATE(1259),
    [sym_flow_maybe_type] = STATE(1259),
    [sym_function_type] = STATE(1413),
    [sym_nested_identifier] = STATE(2241),
    [sym__primary_type] = STATE(1259),
    [sym_generic_type] = STATE(1259),
    [sym_mapped_type] = STATE(1259),
    [sym_literal_type] = STATE(1259),
    [sym_parenthesized_type] = STATE(1259),
    [sym_predefined_type] = STATE(1259),
    [sym_type_parameters] = STATE(2240),
    [sym_string] = STATE(1251),
    [sym_array_type] = STATE(1259),
    [sym_tuple_type] = STATE(1259),
    [sym_nested_type_identifier] = STATE(1258),
    [sym_type_predicate] = STATE(1259),
    [sym_type_query] = STATE(1259),
    [sym__number] = STATE(1251),
    [sym_existential_type] = STATE(1259),
    [sym_object_type] = STATE(1259),
    [sym_union_type] = STATE(1413),
    [sym_intersection_type] = STATE(1413),
    [sym_formal_parameters] = STATE(1796),
    [sym_identifier] = ACTIONS(1600),
    [sym_false] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1606),
    [anon_sym_number] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_keyof] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_void] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_QMARK] = ACTIONS(1626),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1628),
    [sym_number] = ACTIONS(1630),
    [sym_true] = ACTIONS(1602),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_new] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [1347] = {
    [sym__type] = STATE(1414),
    [sym_constructor_type] = STATE(1414),
    [sym_index_type_query] = STATE(1259),
    [sym_lookup_type] = STATE(1259),
    [sym_this_type] = STATE(1259),
    [sym_flow_maybe_type] = STATE(1259),
    [sym_function_type] = STATE(1414),
    [sym_nested_identifier] = STATE(2241),
    [sym__primary_type] = STATE(1259),
    [sym_generic_type] = STATE(1259),
    [sym_mapped_type] = STATE(1259),
    [sym_literal_type] = STATE(1259),
    [sym_parenthesized_type] = STATE(1259),
    [sym_predefined_type] = STATE(1259),
    [sym_type_parameters] = STATE(2240),
    [sym_string] = STATE(1251),
    [sym_array_type] = STATE(1259),
    [sym_tuple_type] = STATE(1259),
    [sym_nested_type_identifier] = STATE(1258),
    [sym_type_predicate] = STATE(1259),
    [sym_type_query] = STATE(1259),
    [sym__number] = STATE(1251),
    [sym_existential_type] = STATE(1259),
    [sym_object_type] = STATE(1259),
    [sym_union_type] = STATE(1414),
    [sym_intersection_type] = STATE(1414),
    [sym_formal_parameters] = STATE(1796),
    [sym_identifier] = ACTIONS(1600),
    [sym_false] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1606),
    [anon_sym_number] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_keyof] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_void] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_QMARK] = ACTIONS(1626),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1628),
    [sym_number] = ACTIONS(1630),
    [sym_true] = ACTIONS(1602),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_new] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [1348] = {
    [sym__type] = STATE(1417),
    [sym_constructor_type] = STATE(1417),
    [sym_index_type_query] = STATE(1259),
    [sym_lookup_type] = STATE(1259),
    [sym_this_type] = STATE(1259),
    [sym_flow_maybe_type] = STATE(1259),
    [sym_function_type] = STATE(1417),
    [sym_nested_identifier] = STATE(2241),
    [sym__primary_type] = STATE(1259),
    [sym_generic_type] = STATE(1259),
    [sym_mapped_type] = STATE(1259),
    [sym_literal_type] = STATE(1259),
    [sym_parenthesized_type] = STATE(1259),
    [sym_predefined_type] = STATE(1259),
    [sym_type_parameters] = STATE(2240),
    [sym_string] = STATE(1251),
    [sym_array_type] = STATE(1259),
    [sym_tuple_type] = STATE(1259),
    [sym_nested_type_identifier] = STATE(1258),
    [sym_type_predicate] = STATE(1259),
    [sym_type_query] = STATE(1259),
    [sym__number] = STATE(1251),
    [sym_existential_type] = STATE(1259),
    [sym_object_type] = STATE(1259),
    [sym_union_type] = STATE(1417),
    [sym_intersection_type] = STATE(1417),
    [sym_formal_parameters] = STATE(1796),
    [sym_identifier] = ACTIONS(1600),
    [sym_false] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1606),
    [anon_sym_number] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_keyof] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_void] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_QMARK] = ACTIONS(1626),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1628),
    [sym_number] = ACTIONS(1630),
    [sym_true] = ACTIONS(1602),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_new] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [1349] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2402),
    [sym__automatic_semicolon] = ACTIONS(2402),
    [anon_sym_BQUOTE] = ACTIONS(2402),
    [anon_sym_PIPE] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2404),
    [anon_sym_GT_GT_GT] = ACTIONS(2402),
    [anon_sym_BANG_EQ] = ACTIONS(2404),
    [anon_sym_GT_EQ] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_PERCENT] = ACTIONS(2402),
    [anon_sym_as] = ACTIONS(2402),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_instanceof] = ACTIONS(2402),
    [anon_sym_DOT] = ACTIONS(2402),
    [anon_sym_STAR_STAR] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym_LT_LT] = ACTIONS(2402),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_LT_EQ] = ACTIONS(2402),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_GT] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_QMARK] = ACTIONS(2402),
    [anon_sym_PIPE_PIPE] = ACTIONS(2402),
    [anon_sym_EQ_EQ] = ACTIONS(2404),
    [anon_sym_RPAREN] = ACTIONS(2402),
    [anon_sym_LT] = ACTIONS(2404),
    [anon_sym_SLASH] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2402),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_GT_GT] = ACTIONS(2404),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2402),
    [anon_sym_in] = ACTIONS(2404),
  },
  [1350] = {
    [sym__type] = STATE(1419),
    [sym_constructor_type] = STATE(1419),
    [sym_index_type_query] = STATE(1259),
    [sym_lookup_type] = STATE(1259),
    [sym_this_type] = STATE(1259),
    [sym_flow_maybe_type] = STATE(1259),
    [sym_function_type] = STATE(1419),
    [sym_nested_identifier] = STATE(2241),
    [sym__primary_type] = STATE(1259),
    [sym_generic_type] = STATE(1259),
    [sym_mapped_type] = STATE(1259),
    [sym_literal_type] = STATE(1259),
    [sym_parenthesized_type] = STATE(1259),
    [sym_predefined_type] = STATE(1259),
    [sym_type_parameters] = STATE(2240),
    [sym_string] = STATE(1251),
    [sym_array_type] = STATE(1259),
    [sym_tuple_type] = STATE(1259),
    [sym_nested_type_identifier] = STATE(1258),
    [sym_type_predicate] = STATE(1259),
    [sym_type_query] = STATE(1259),
    [sym__number] = STATE(1251),
    [sym_existential_type] = STATE(1259),
    [sym_object_type] = STATE(1259),
    [sym_union_type] = STATE(1419),
    [sym_intersection_type] = STATE(1419),
    [sym_formal_parameters] = STATE(1796),
    [sym_identifier] = ACTIONS(1600),
    [sym_false] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1606),
    [anon_sym_number] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_keyof] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_void] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_QMARK] = ACTIONS(1626),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1628),
    [sym_number] = ACTIONS(1630),
    [sym_true] = ACTIONS(1602),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_new] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [1351] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2416),
    [anon_sym_BQUOTE] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_GT_GT_GT] = ACTIONS(2416),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_GT_EQ] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_PERCENT] = ACTIONS(2416),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2416),
    [anon_sym_as] = ACTIONS(2418),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_instanceof] = ACTIONS(2418),
    [sym_regex_flags] = ACTIONS(4066),
    [anon_sym_COLON] = ACTIONS(2416),
    [anon_sym_DOT] = ACTIONS(2416),
    [anon_sym_STAR_STAR] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_LT_LT] = ACTIONS(2416),
    [anon_sym_LBRACE] = ACTIONS(2418),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_LT_EQ] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_RBRACK] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_QMARK] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_EQ_EQ] = ACTIONS(2418),
    [anon_sym_RPAREN] = ACTIONS(2416),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2416),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_GT_GT] = ACTIONS(2418),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2416),
    [anon_sym_in] = ACTIONS(2418),
  },
  [1352] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2424),
    [sym__automatic_semicolon] = ACTIONS(2424),
    [anon_sym_BQUOTE] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_GT_GT_GT] = ACTIONS(2424),
    [anon_sym_BANG_EQ] = ACTIONS(2426),
    [anon_sym_GT_EQ] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_PERCENT] = ACTIONS(2424),
    [anon_sym_as] = ACTIONS(2424),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [anon_sym_instanceof] = ACTIONS(2424),
    [anon_sym_DOT] = ACTIONS(2424),
    [anon_sym_STAR_STAR] = ACTIONS(2424),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_else] = ACTIONS(2424),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_LT_LT] = ACTIONS(2424),
    [anon_sym_AMP_AMP] = ACTIONS(2424),
    [anon_sym_LT_EQ] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_GT] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2426),
    [anon_sym_QMARK] = ACTIONS(2424),
    [anon_sym_PIPE_PIPE] = ACTIONS(2424),
    [anon_sym_while] = ACTIONS(2424),
    [anon_sym_EQ_EQ] = ACTIONS(2426),
    [anon_sym_RPAREN] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2424),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_GT_GT] = ACTIONS(2426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2424),
    [anon_sym_in] = ACTIONS(2426),
  },
  [1353] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2428),
    [anon_sym_BQUOTE] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(2430),
    [anon_sym_GT_GT_GT] = ACTIONS(2428),
    [anon_sym_BANG_EQ] = ACTIONS(2430),
    [anon_sym_GT_EQ] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2428),
    [anon_sym_as] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_instanceof] = ACTIONS(2428),
    [anon_sym_COLON] = ACTIONS(2428),
    [anon_sym_DOT] = ACTIONS(2428),
    [anon_sym_STAR_STAR] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_LT_LT] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_AMP_AMP] = ACTIONS(2428),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2428),
    [anon_sym_EQ_EQ] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_implements] = ACTIONS(2428),
    [anon_sym_GT_GT] = ACTIONS(2430),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2430),
  },
  [1354] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2432),
    [anon_sym_BQUOTE] = ACTIONS(2432),
    [anon_sym_PIPE] = ACTIONS(2434),
    [anon_sym_COMMA] = ACTIONS(2432),
    [anon_sym_DASH] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(2434),
    [anon_sym_GT_GT_GT] = ACTIONS(2432),
    [anon_sym_BANG_EQ] = ACTIONS(2434),
    [anon_sym_GT_EQ] = ACTIONS(2432),
    [anon_sym_RBRACE] = ACTIONS(2432),
    [anon_sym_PERCENT] = ACTIONS(2432),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2432),
    [anon_sym_as] = ACTIONS(2432),
    [anon_sym_DASH_DASH] = ACTIONS(2432),
    [anon_sym_instanceof] = ACTIONS(2432),
    [anon_sym_COLON] = ACTIONS(2432),
    [anon_sym_DOT] = ACTIONS(2432),
    [anon_sym_STAR_STAR] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2432),
    [anon_sym_BANG] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_LT_LT] = ACTIONS(2432),
    [anon_sym_LBRACE] = ACTIONS(2434),
    [anon_sym_AMP_AMP] = ACTIONS(2432),
    [anon_sym_LT_EQ] = ACTIONS(2432),
    [anon_sym_LPAREN] = ACTIONS(2432),
    [anon_sym_RBRACK] = ACTIONS(2432),
    [anon_sym_GT] = ACTIONS(2434),
    [anon_sym_AMP] = ACTIONS(2434),
    [anon_sym_QMARK] = ACTIONS(2432),
    [anon_sym_PIPE_PIPE] = ACTIONS(2432),
    [anon_sym_EQ_EQ] = ACTIONS(2434),
    [anon_sym_RPAREN] = ACTIONS(2432),
    [anon_sym_LT] = ACTIONS(2434),
    [anon_sym_SLASH] = ACTIONS(2434),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2432),
    [anon_sym_PLUS] = ACTIONS(2434),
    [anon_sym_implements] = ACTIONS(2432),
    [anon_sym_GT_GT] = ACTIONS(2434),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2432),
    [anon_sym_in] = ACTIONS(2434),
  },
  [1355] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2436),
    [anon_sym_BQUOTE] = ACTIONS(2436),
    [anon_sym_PIPE] = ACTIONS(2438),
    [anon_sym_COMMA] = ACTIONS(2436),
    [anon_sym_DASH] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(2438),
    [anon_sym_GT_GT_GT] = ACTIONS(2436),
    [anon_sym_BANG_EQ] = ACTIONS(2438),
    [anon_sym_GT_EQ] = ACTIONS(2436),
    [anon_sym_RBRACE] = ACTIONS(2436),
    [anon_sym_PERCENT] = ACTIONS(2436),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2436),
    [anon_sym_as] = ACTIONS(2436),
    [anon_sym_DASH_DASH] = ACTIONS(2436),
    [anon_sym_instanceof] = ACTIONS(2436),
    [anon_sym_COLON] = ACTIONS(2436),
    [anon_sym_DOT] = ACTIONS(2436),
    [anon_sym_STAR_STAR] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2436),
    [anon_sym_BANG] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_LT_LT] = ACTIONS(2436),
    [anon_sym_LBRACE] = ACTIONS(2438),
    [anon_sym_AMP_AMP] = ACTIONS(2436),
    [anon_sym_LT_EQ] = ACTIONS(2436),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_RBRACK] = ACTIONS(2436),
    [anon_sym_GT] = ACTIONS(2438),
    [anon_sym_AMP] = ACTIONS(2438),
    [anon_sym_QMARK] = ACTIONS(2436),
    [anon_sym_PIPE_PIPE] = ACTIONS(2436),
    [anon_sym_EQ_EQ] = ACTIONS(2438),
    [anon_sym_RPAREN] = ACTIONS(2436),
    [anon_sym_LT] = ACTIONS(2438),
    [anon_sym_SLASH] = ACTIONS(2438),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2436),
    [anon_sym_PLUS] = ACTIONS(2438),
    [anon_sym_implements] = ACTIONS(2436),
    [anon_sym_GT_GT] = ACTIONS(2438),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2436),
    [anon_sym_in] = ACTIONS(2438),
  },
  [1356] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2428),
    [anon_sym_BQUOTE] = ACTIONS(2428),
    [anon_sym_PIPE] = ACTIONS(2430),
    [anon_sym_COMMA] = ACTIONS(2428),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(2430),
    [anon_sym_GT_GT_GT] = ACTIONS(2428),
    [anon_sym_BANG_EQ] = ACTIONS(2430),
    [anon_sym_GT_EQ] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_PERCENT] = ACTIONS(2428),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2428),
    [anon_sym_as] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_instanceof] = ACTIONS(2428),
    [anon_sym_COLON] = ACTIONS(2428),
    [anon_sym_DOT] = ACTIONS(2428),
    [anon_sym_STAR_STAR] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_BANG] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_LT_LT] = ACTIONS(2428),
    [anon_sym_LBRACE] = ACTIONS(2430),
    [anon_sym_AMP_AMP] = ACTIONS(2428),
    [anon_sym_LT_EQ] = ACTIONS(2428),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_RBRACK] = ACTIONS(2428),
    [anon_sym_GT] = ACTIONS(2430),
    [anon_sym_AMP] = ACTIONS(2430),
    [anon_sym_QMARK] = ACTIONS(2428),
    [anon_sym_PIPE_PIPE] = ACTIONS(2428),
    [anon_sym_EQ_EQ] = ACTIONS(2430),
    [anon_sym_RPAREN] = ACTIONS(2428),
    [anon_sym_LT] = ACTIONS(2430),
    [anon_sym_SLASH] = ACTIONS(2430),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2428),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_implements] = ACTIONS(2428),
    [anon_sym_GT_GT] = ACTIONS(2430),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2428),
    [anon_sym_in] = ACTIONS(2430),
  },
  [1357] = {
    [sym__automatic_semicolon] = ACTIONS(2481),
    [anon_sym_RBRACE] = ACTIONS(2481),
    [anon_sym_SEMI] = ACTIONS(2481),
    [anon_sym_COMMA] = ACTIONS(2481),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2481),
    [sym_comment] = ACTIONS(3),
  },
  [1358] = {
    [sym__automatic_semicolon] = ACTIONS(2489),
    [anon_sym_RBRACE] = ACTIONS(2489),
    [anon_sym_SEMI] = ACTIONS(2489),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2489),
    [anon_sym_COMMA] = ACTIONS(2489),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2489),
  },
  [1359] = {
    [sym__automatic_semicolon] = ACTIONS(2491),
    [anon_sym_AMP] = ACTIONS(2614),
    [anon_sym_RBRACE] = ACTIONS(2491),
    [anon_sym_SEMI] = ACTIONS(2491),
    [anon_sym_PIPE] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(2491),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2491),
    [anon_sym_EQ] = ACTIONS(2491),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2491),
  },
  [1360] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_in] = ACTIONS(847),
  },
  [1361] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_GT_GT_GT] = ACTIONS(1683),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_COLON] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_SLASH] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [1362] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_COLON] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [1363] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_in] = ACTIONS(847),
  },
  [1364] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACK] = ACTIONS(2498),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(2498),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2498),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1365] = {
    [anon_sym_COLON] = ACTIONS(2498),
    [anon_sym_RBRACE] = ACTIONS(2498),
    [anon_sym_RPAREN] = ACTIONS(2498),
    [sym_comment] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(2498),
  },
  [1366] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_STAR] = ACTIONS(2504),
    [anon_sym_GT_GT_GT] = ACTIONS(2502),
    [anon_sym_BANG_EQ] = ACTIONS(2504),
    [anon_sym_GT_EQ] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_PERCENT] = ACTIONS(2502),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2502),
    [anon_sym_as] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_instanceof] = ACTIONS(2502),
    [anon_sym_COLON] = ACTIONS(2502),
    [anon_sym_DOT] = ACTIONS(2502),
    [anon_sym_STAR_STAR] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(2504),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_LT_EQ] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_RBRACK] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_QMARK] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2504),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_SLASH] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_implements] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2502),
    [anon_sym_in] = ACTIONS(2504),
  },
  [1367] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2502),
    [anon_sym_BQUOTE] = ACTIONS(2502),
    [anon_sym_PIPE] = ACTIONS(2504),
    [anon_sym_COMMA] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2504),
    [anon_sym_STAR] = ACTIONS(2504),
    [anon_sym_GT_GT_GT] = ACTIONS(2502),
    [anon_sym_BANG_EQ] = ACTIONS(2504),
    [anon_sym_GT_EQ] = ACTIONS(2502),
    [anon_sym_RBRACE] = ACTIONS(2502),
    [anon_sym_PERCENT] = ACTIONS(2502),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2502),
    [anon_sym_as] = ACTIONS(2502),
    [anon_sym_DASH_DASH] = ACTIONS(2502),
    [anon_sym_instanceof] = ACTIONS(2502),
    [anon_sym_COLON] = ACTIONS(2502),
    [anon_sym_DOT] = ACTIONS(2502),
    [anon_sym_STAR_STAR] = ACTIONS(2502),
    [anon_sym_PLUS_PLUS] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2504),
    [anon_sym_LBRACK] = ACTIONS(2502),
    [anon_sym_LT_LT] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(2504),
    [anon_sym_AMP_AMP] = ACTIONS(2502),
    [anon_sym_LT_EQ] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2502),
    [anon_sym_RBRACK] = ACTIONS(2502),
    [anon_sym_GT] = ACTIONS(2504),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_QMARK] = ACTIONS(2502),
    [anon_sym_PIPE_PIPE] = ACTIONS(2502),
    [anon_sym_EQ_EQ] = ACTIONS(2504),
    [anon_sym_RPAREN] = ACTIONS(2502),
    [anon_sym_LT] = ACTIONS(2504),
    [anon_sym_SLASH] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2504),
    [anon_sym_implements] = ACTIONS(2502),
    [anon_sym_GT_GT] = ACTIONS(2504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2502),
    [anon_sym_in] = ACTIONS(2504),
  },
  [1368] = {
    [sym__initializer] = STATE(1211),
    [sym_type_arguments] = STATE(497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1088),
    [anon_sym_AMP_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_EQ] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2509),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(1088),
    [anon_sym_PIPE_EQ] = ACTIONS(1088),
    [anon_sym_DASH_EQ] = ACTIONS(1088),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(1088),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(4073),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_is] = ACTIONS(1207),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_STAR_EQ] = ACTIONS(1088),
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1088),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4075),
  },
  [1369] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(2520),
    [anon_sym_COMMA] = ACTIONS(2523),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1370] = {
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(2526),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1371] = {
    [sym_new_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_non_null_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_identifier] = STATE(516),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1220),
    [sym_this] = STATE(1220),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1220),
    [sym_generator_function] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1220),
    [sym_class] = STATE(1220),
    [sym_identifier] = ACTIONS(4077),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(1124),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(1124),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1130),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1372] = {
    [sym_new_expression] = STATE(1218),
    [sym_augmented_assignment_expression] = STATE(1218),
    [sym_unary_expression] = STATE(1218),
    [sym_update_expression] = STATE(1218),
    [sym_regex] = STATE(1218),
    [sym_meta_property] = STATE(1218),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1218),
    [sym_yield_expression] = STATE(1218),
    [sym_as_expression] = STATE(1218),
    [sym_non_null_expression] = STATE(1218),
    [sym_internal_module] = STATE(1218),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1218),
    [sym_await_expression] = STATE(1218),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1218),
    [sym_this] = STATE(1218),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1218),
    [sym_generator_function] = STATE(1218),
    [sym_call_expression] = STATE(1218),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1218),
    [sym_ternary_expression] = STATE(1218),
    [sym_binary_expression] = STATE(1218),
    [sym_template_string] = STATE(1218),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1218),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1218),
    [sym_class] = STATE(1218),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3894),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3894),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3894),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4079),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3894),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1373] = {
    [sym_new_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_non_null_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1220),
    [sym_this] = STATE(1220),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1220),
    [sym_generator_function] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1220),
    [sym_class] = STATE(1220),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(1124),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(1124),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_BANG] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_GT] = ACTIONS(2526),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(1130),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_in] = ACTIONS(139),
  },
  [1374] = {
    [sym_new_expression] = STATE(1261),
    [sym_augmented_assignment_expression] = STATE(1800),
    [sym_unary_expression] = STATE(1800),
    [sym_update_expression] = STATE(1800),
    [sym_regex] = STATE(1261),
    [sym_meta_property] = STATE(1261),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1800),
    [sym_yield_expression] = STATE(1800),
    [sym_as_expression] = STATE(1800),
    [sym_non_null_expression] = STATE(1800),
    [sym_internal_module] = STATE(1800),
    [sym_function] = STATE(1266),
    [sym_arrow_function] = STATE(1261),
    [sym_await_expression] = STATE(1800),
    [sym_member_expression] = STATE(1267),
    [sym_string] = STATE(1261),
    [sym_this] = STATE(1261),
    [sym_type_parameters] = STATE(825),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1268),
    [sym_anonymous_class] = STATE(1261),
    [sym_generator_function] = STATE(1261),
    [sym_call_expression] = STATE(1800),
    [sym_subscript_expression] = STATE(1267),
    [sym_assignment_expression] = STATE(1800),
    [sym_ternary_expression] = STATE(1800),
    [sym_binary_expression] = STATE(1800),
    [sym_template_string] = STATE(1261),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(826),
    [sym_parenthesized_expression] = STATE(1261),
    [sym_array] = STATE(1269),
    [sym_type_assertion] = STATE(1800),
    [sym_class] = STATE(1261),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(3916),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(3918),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(3916),
    [anon_sym_get] = ACTIONS(3916),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(3920),
    [anon_sym_protected] = ACTIONS(3916),
    [anon_sym_DOT] = ACTIONS(3922),
    [anon_sym_set] = ACTIONS(3916),
    [anon_sym_type] = ACTIONS(3916),
    [anon_sym_import] = ACTIONS(3916),
    [anon_sym_namespace] = ACTIONS(3924),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3920),
    [anon_sym_module] = ACTIONS(3916),
    [anon_sym_number] = ACTIONS(3916),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(3916),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3920),
    [anon_sym_any] = ACTIONS(3916),
    [anon_sym_boolean] = ACTIONS(3916),
    [anon_sym_async] = ACTIONS(3926),
    [anon_sym_public] = ACTIONS(3916),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3928),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3920),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(3916),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [1375] = {
    [sym_type_annotation] = STATE(269),
    [anon_sym_EQ_GT] = ACTIONS(4081),
    [anon_sym_COLON] = ACTIONS(568),
    [sym_comment] = ACTIONS(3),
  },
  [1376] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_GT_GT_GT] = ACTIONS(1683),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_COLON] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(4070),
    [anon_sym_SLASH] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [1377] = {
    [sym__automatic_semicolon] = ACTIONS(2569),
    [anon_sym_RBRACE] = ACTIONS(2569),
    [anon_sym_SEMI] = ACTIONS(2569),
    [anon_sym_COMMA] = ACTIONS(2569),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2569),
    [sym_comment] = ACTIONS(3),
  },
  [1378] = {
    [sym__automatic_semicolon] = ACTIONS(2575),
    [anon_sym_RBRACE] = ACTIONS(2575),
    [anon_sym_SEMI] = ACTIONS(2575),
    [anon_sym_COMMA] = ACTIONS(2575),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2575),
    [sym_comment] = ACTIONS(3),
  },
  [1379] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2584),
    [anon_sym_BQUOTE] = ACTIONS(2584),
    [anon_sym_PERCENT_EQ] = ACTIONS(2584),
    [anon_sym_AMP_EQ] = ACTIONS(2584),
    [anon_sym_PLUS_EQ] = ACTIONS(2584),
    [anon_sym_PIPE] = ACTIONS(2586),
    [anon_sym_COMMA] = ACTIONS(2584),
    [anon_sym_DASH] = ACTIONS(2586),
    [anon_sym_STAR] = ACTIONS(2586),
    [anon_sym_GT_GT_GT] = ACTIONS(2586),
    [anon_sym_EQ] = ACTIONS(2586),
    [anon_sym_BANG_EQ] = ACTIONS(2586),
    [anon_sym_GT_EQ] = ACTIONS(2584),
    [anon_sym_CARET_EQ] = ACTIONS(2584),
    [anon_sym_PIPE_EQ] = ACTIONS(2584),
    [anon_sym_DASH_EQ] = ACTIONS(2584),
    [anon_sym_RBRACE] = ACTIONS(2584),
    [anon_sym_PERCENT] = ACTIONS(2586),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2584),
    [anon_sym_LT_LT_EQ] = ACTIONS(2584),
    [anon_sym_as] = ACTIONS(2584),
    [anon_sym_DASH_DASH] = ACTIONS(2584),
    [anon_sym_instanceof] = ACTIONS(2584),
    [anon_sym_COLON] = ACTIONS(2584),
    [anon_sym_GT_GT_EQ] = ACTIONS(2584),
    [anon_sym_DOT] = ACTIONS(2584),
    [anon_sym_STAR_STAR] = ACTIONS(2586),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2584),
    [anon_sym_PLUS_PLUS] = ACTIONS(2584),
    [anon_sym_BANG] = ACTIONS(2586),
    [anon_sym_LBRACK] = ACTIONS(2584),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(2584),
    [anon_sym_LT_LT] = ACTIONS(2586),
    [anon_sym_LBRACE] = ACTIONS(2586),
    [anon_sym_AMP_AMP] = ACTIONS(2584),
    [anon_sym_LT_EQ] = ACTIONS(2584),
    [anon_sym_LPAREN] = ACTIONS(2584),
    [anon_sym_RBRACK] = ACTIONS(2584),
    [anon_sym_GT] = ACTIONS(2586),
    [anon_sym_STAR_EQ] = ACTIONS(2584),
    [anon_sym_AMP] = ACTIONS(2586),
    [anon_sym_QMARK] = ACTIONS(2584),
    [anon_sym_PIPE_PIPE] = ACTIONS(2584),
    [anon_sym_EQ_EQ] = ACTIONS(2586),
    [anon_sym_RPAREN] = ACTIONS(2584),
    [anon_sym_LT] = ACTIONS(2586),
    [anon_sym_SLASH] = ACTIONS(2586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(2584),
    [anon_sym_CARET] = ACTIONS(2586),
    [anon_sym_PLUS] = ACTIONS(2586),
    [anon_sym_implements] = ACTIONS(2584),
    [anon_sym_GT_GT] = ACTIONS(2586),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2584),
    [anon_sym_in] = ACTIONS(2586),
  },
  [1380] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2588),
    [anon_sym_BQUOTE] = ACTIONS(2588),
    [anon_sym_AT] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_DASH] = ACTIONS(2590),
    [anon_sym_STAR] = ACTIONS(2590),
    [anon_sym_GT_GT_GT] = ACTIONS(2588),
    [anon_sym_BANG_EQ] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2588),
    [anon_sym_PERCENT] = ACTIONS(2588),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2588),
    [anon_sym_as] = ACTIONS(2588),
    [anon_sym_DASH_DASH] = ACTIONS(2588),
    [anon_sym_instanceof] = ACTIONS(2588),
    [anon_sym_COLON] = ACTIONS(2588),
    [anon_sym_DOT] = ACTIONS(2588),
    [anon_sym_STAR_STAR] = ACTIONS(2588),
    [anon_sym_PLUS_PLUS] = ACTIONS(2588),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_class] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_LT_EQ] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_RBRACK] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2590),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_SLASH] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2590),
    [anon_sym_export] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2590),
    [anon_sym_implements] = ACTIONS(2588),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2588),
    [anon_sym_in] = ACTIONS(2590),
  },
  [1381] = {
    [sym__automatic_semicolon] = ACTIONS(2596),
    [anon_sym_RBRACE] = ACTIONS(2596),
    [anon_sym_SEMI] = ACTIONS(2596),
    [anon_sym_COMMA] = ACTIONS(2596),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2596),
    [sym_comment] = ACTIONS(3),
  },
  [1382] = {
    [sym__automatic_semicolon] = ACTIONS(2600),
    [anon_sym_RBRACE] = ACTIONS(2600),
    [anon_sym_SEMI] = ACTIONS(2600),
    [anon_sym_COMMA] = ACTIONS(2600),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2600),
    [sym_comment] = ACTIONS(3),
  },
  [1383] = {
    [sym__automatic_semicolon] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2610),
    [anon_sym_SEMI] = ACTIONS(2610),
    [anon_sym_COMMA] = ACTIONS(2610),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2610),
    [sym_comment] = ACTIONS(3),
  },
  [1384] = {
    [anon_sym_BQUOTE] = ACTIONS(2652),
    [anon_sym_symbol] = ACTIONS(2654),
    [anon_sym_PIPE] = ACTIONS(2652),
    [anon_sym_break] = ACTIONS(2654),
    [anon_sym_return] = ACTIONS(2654),
    [anon_sym_RBRACE] = ACTIONS(2652),
    [anon_sym_interface] = ACTIONS(2654),
    [anon_sym_delete] = ACTIONS(2654),
    [anon_sym_if] = ACTIONS(2654),
    [anon_sym_yield] = ACTIONS(2654),
    [sym_true] = ACTIONS(2654),
    [anon_sym_protected] = ACTIONS(2654),
    [anon_sym_DOT] = ACTIONS(2654),
    [anon_sym_set] = ACTIONS(2654),
    [anon_sym_import] = ACTIONS(2654),
    [anon_sym_await] = ACTIONS(2654),
    [anon_sym_DQUOTE] = ACTIONS(2652),
    [anon_sym_for] = ACTIONS(2654),
    [anon_sym_SEMI] = ACTIONS(2652),
    [anon_sym_number] = ACTIONS(2654),
    [anon_sym_typeof] = ACTIONS(2654),
    [anon_sym_LBRACE] = ACTIONS(2652),
    [anon_sym_switch] = ACTIONS(2654),
    [anon_sym_RBRACK] = ACTIONS(2652),
    [sym_null] = ACTIONS(2654),
    [anon_sym_any] = ACTIONS(2654),
    [anon_sym_async] = ACTIONS(2654),
    [anon_sym_public] = ACTIONS(2654),
    [anon_sym_var] = ACTIONS(2654),
    [anon_sym_while] = ACTIONS(2654),
    [anon_sym_SQUOTE] = ACTIONS(2652),
    [anon_sym_RPAREN] = ACTIONS(2652),
    [anon_sym_SLASH] = ACTIONS(2654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2654),
    [anon_sym_new] = ACTIONS(2654),
    [anon_sym_export] = ACTIONS(2654),
    [anon_sym_with] = ACTIONS(2654),
    [sym_identifier] = ACTIONS(2654),
    [anon_sym_debugger] = ACTIONS(2654),
    [anon_sym_AT] = ACTIONS(2652),
    [anon_sym_COMMA] = ACTIONS(2652),
    [anon_sym_DASH] = ACTIONS(2654),
    [anon_sym_EQ] = ACTIONS(2654),
    [anon_sym_void] = ACTIONS(2654),
    [anon_sym_const] = ACTIONS(2654),
    [sym_super] = ACTIONS(2654),
    [anon_sym_private] = ACTIONS(2654),
    [anon_sym_get] = ACTIONS(2654),
    [anon_sym_default] = ACTIONS(2654),
    [anon_sym_enum] = ACTIONS(2654),
    [anon_sym_continue] = ACTIONS(2654),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_this] = ACTIONS(2654),
    [anon_sym_throw] = ACTIONS(2654),
    [anon_sym_abstract] = ACTIONS(2654),
    [anon_sym_type] = ACTIONS(2654),
    [anon_sym_namespace] = ACTIONS(2654),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_else] = ACTIONS(2654),
    [anon_sym_BANG] = ACTIONS(2652),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [sym_false] = ACTIONS(2654),
    [anon_sym_case] = ACTIONS(2654),
    [anon_sym_module] = ACTIONS(2654),
    [anon_sym_class] = ACTIONS(2654),
    [anon_sym_declare] = ACTIONS(2654),
    [anon_sym_LPAREN] = ACTIONS(2652),
    [anon_sym_GT] = ACTIONS(2652),
    [anon_sym_boolean] = ACTIONS(2654),
    [anon_sym_EQ_GT] = ACTIONS(2652),
    [anon_sym_AMP] = ACTIONS(2652),
    [anon_sym_try] = ACTIONS(2654),
    [anon_sym_LT] = ACTIONS(2652),
    [sym_number] = ACTIONS(2652),
    [ts_builtin_sym_end] = ACTIONS(2652),
    [anon_sym_function] = ACTIONS(2654),
    [sym_undefined] = ACTIONS(2654),
    [anon_sym_let] = ACTIONS(2654),
    [anon_sym_PLUS] = ACTIONS(2654),
    [anon_sym_do] = ACTIONS(2654),
    [anon_sym_TILDE] = ACTIONS(2652),
  },
  [1385] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2700),
    [anon_sym_BQUOTE] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2702),
    [anon_sym_COMMA] = ACTIONS(2700),
    [anon_sym_DASH] = ACTIONS(2702),
    [anon_sym_STAR] = ACTIONS(2702),
    [anon_sym_GT_GT_GT] = ACTIONS(2700),
    [anon_sym_EQ] = ACTIONS(2702),
    [anon_sym_BANG_EQ] = ACTIONS(2702),
    [anon_sym_GT_EQ] = ACTIONS(2700),
    [anon_sym_RBRACE] = ACTIONS(2700),
    [anon_sym_PERCENT] = ACTIONS(2700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2700),
    [anon_sym_as] = ACTIONS(2700),
    [anon_sym_DASH_DASH] = ACTIONS(2700),
    [anon_sym_instanceof] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2700),
    [anon_sym_DOT] = ACTIONS(2700),
    [anon_sym_STAR_STAR] = ACTIONS(2700),
    [anon_sym_PLUS_PLUS] = ACTIONS(2700),
    [anon_sym_BANG] = ACTIONS(2702),
    [anon_sym_LBRACK] = ACTIONS(2700),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_LBRACE] = ACTIONS(2702),
    [anon_sym_AMP_AMP] = ACTIONS(2700),
    [anon_sym_of] = ACTIONS(2700),
    [anon_sym_LT_EQ] = ACTIONS(2700),
    [anon_sym_LPAREN] = ACTIONS(2700),
    [anon_sym_RBRACK] = ACTIONS(2700),
    [anon_sym_GT] = ACTIONS(2702),
    [anon_sym_AMP] = ACTIONS(2702),
    [anon_sym_QMARK] = ACTIONS(2700),
    [anon_sym_PIPE_PIPE] = ACTIONS(2700),
    [anon_sym_EQ_EQ] = ACTIONS(2702),
    [anon_sym_RPAREN] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2702),
    [anon_sym_SLASH] = ACTIONS(2702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_PLUS] = ACTIONS(2702),
    [anon_sym_implements] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2702),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2700),
    [anon_sym_in] = ACTIONS(2702),
  },
  [1386] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2714),
    [sym__automatic_semicolon] = ACTIONS(2714),
    [anon_sym_BQUOTE] = ACTIONS(2714),
    [anon_sym_PIPE] = ACTIONS(2716),
    [anon_sym_COMMA] = ACTIONS(2714),
    [anon_sym_DASH] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2716),
    [anon_sym_GT_GT_GT] = ACTIONS(2714),
    [anon_sym_BANG_EQ] = ACTIONS(2716),
    [anon_sym_GT_EQ] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_PERCENT] = ACTIONS(2714),
    [anon_sym_as] = ACTIONS(2714),
    [anon_sym_DASH_DASH] = ACTIONS(2714),
    [anon_sym_instanceof] = ACTIONS(2714),
    [anon_sym_DOT] = ACTIONS(2714),
    [anon_sym_STAR_STAR] = ACTIONS(2714),
    [anon_sym_PLUS_PLUS] = ACTIONS(2714),
    [anon_sym_else] = ACTIONS(2714),
    [anon_sym_BANG] = ACTIONS(2716),
    [anon_sym_LBRACK] = ACTIONS(2714),
    [anon_sym_SEMI] = ACTIONS(2714),
    [anon_sym_LT_LT] = ACTIONS(2714),
    [anon_sym_AMP_AMP] = ACTIONS(2714),
    [anon_sym_LT_EQ] = ACTIONS(2714),
    [anon_sym_LPAREN] = ACTIONS(2714),
    [anon_sym_GT] = ACTIONS(2716),
    [anon_sym_AMP] = ACTIONS(2716),
    [anon_sym_QMARK] = ACTIONS(2714),
    [anon_sym_PIPE_PIPE] = ACTIONS(2714),
    [anon_sym_while] = ACTIONS(2714),
    [anon_sym_EQ_EQ] = ACTIONS(2716),
    [anon_sym_RPAREN] = ACTIONS(2714),
    [anon_sym_LT] = ACTIONS(2716),
    [anon_sym_SLASH] = ACTIONS(2716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2714),
    [anon_sym_PLUS] = ACTIONS(2716),
    [anon_sym_GT_GT] = ACTIONS(2716),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2714),
    [anon_sym_in] = ACTIONS(2716),
  },
  [1387] = {
    [sym_string] = STATE(886),
    [sym__property_name] = STATE(886),
    [sym_computed_property_name] = STATE(886),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_EQ] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(2742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_BANG] = ACTIONS(986),
  },
  [1388] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2784),
    [anon_sym_BQUOTE] = ACTIONS(2784),
    [anon_sym_PIPE] = ACTIONS(2786),
    [anon_sym_COMMA] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_STAR] = ACTIONS(2786),
    [anon_sym_GT_GT_GT] = ACTIONS(2784),
    [anon_sym_BANG_EQ] = ACTIONS(2786),
    [anon_sym_GT_EQ] = ACTIONS(2784),
    [anon_sym_RBRACE] = ACTIONS(2784),
    [anon_sym_PERCENT] = ACTIONS(2784),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2784),
    [anon_sym_as] = ACTIONS(2784),
    [anon_sym_DASH_DASH] = ACTIONS(2784),
    [anon_sym_instanceof] = ACTIONS(2784),
    [anon_sym_COLON] = ACTIONS(2784),
    [anon_sym_DOT] = ACTIONS(2784),
    [anon_sym_STAR_STAR] = ACTIONS(2784),
    [anon_sym_PLUS_PLUS] = ACTIONS(2784),
    [anon_sym_else] = ACTIONS(2784),
    [anon_sym_BANG] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LT_LT] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_AMP_AMP] = ACTIONS(2784),
    [anon_sym_LT_EQ] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2784),
    [anon_sym_RBRACK] = ACTIONS(2784),
    [anon_sym_GT] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2786),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_PIPE_PIPE] = ACTIONS(2784),
    [anon_sym_while] = ACTIONS(2784),
    [anon_sym_EQ_EQ] = ACTIONS(2786),
    [anon_sym_RPAREN] = ACTIONS(2784),
    [anon_sym_LT] = ACTIONS(2786),
    [anon_sym_SLASH] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2784),
    [anon_sym_PLUS] = ACTIONS(2786),
    [anon_sym_implements] = ACTIONS(2784),
    [anon_sym_GT_GT] = ACTIONS(2786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2784),
    [anon_sym_in] = ACTIONS(2786),
  },
  [1389] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2831),
    [anon_sym_BQUOTE] = ACTIONS(2831),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2831),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_GT_GT_GT] = ACTIONS(2831),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_BANG_EQ] = ACTIONS(2833),
    [anon_sym_GT_EQ] = ACTIONS(2831),
    [anon_sym_RBRACE] = ACTIONS(2831),
    [anon_sym_PERCENT] = ACTIONS(2831),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2831),
    [anon_sym_as] = ACTIONS(2831),
    [anon_sym_DASH_DASH] = ACTIONS(2831),
    [anon_sym_instanceof] = ACTIONS(2831),
    [anon_sym_COLON] = ACTIONS(2831),
    [anon_sym_DOT] = ACTIONS(2831),
    [anon_sym_STAR_STAR] = ACTIONS(2831),
    [anon_sym_PLUS_PLUS] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2831),
    [anon_sym_LT_LT] = ACTIONS(2831),
    [anon_sym_LBRACE] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2831),
    [anon_sym_of] = ACTIONS(2831),
    [anon_sym_LT_EQ] = ACTIONS(2831),
    [anon_sym_LPAREN] = ACTIONS(2831),
    [anon_sym_RBRACK] = ACTIONS(2831),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_QMARK] = ACTIONS(2831),
    [anon_sym_PIPE_PIPE] = ACTIONS(2831),
    [anon_sym_EQ_EQ] = ACTIONS(2833),
    [anon_sym_RPAREN] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2831),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_implements] = ACTIONS(2831),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2831),
    [anon_sym_in] = ACTIONS(2833),
  },
  [1390] = {
    [anon_sym_EQ] = ACTIONS(1900),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [sym_comment] = ACTIONS(3),
  },
  [1391] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2855),
    [anon_sym_BQUOTE] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2857),
    [anon_sym_COMMA] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2857),
    [anon_sym_STAR] = ACTIONS(2857),
    [anon_sym_GT_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ] = ACTIONS(2857),
    [anon_sym_BANG_EQ] = ACTIONS(2857),
    [anon_sym_GT_EQ] = ACTIONS(2855),
    [anon_sym_RBRACE] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [anon_sym_DASH_DASH] = ACTIONS(2855),
    [anon_sym_instanceof] = ACTIONS(2855),
    [anon_sym_COLON] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_STAR_STAR] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2855),
    [anon_sym_BANG] = ACTIONS(2857),
    [anon_sym_LBRACK] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(2857),
    [anon_sym_AMP_AMP] = ACTIONS(2855),
    [anon_sym_of] = ACTIONS(2855),
    [anon_sym_LT_EQ] = ACTIONS(2855),
    [anon_sym_LPAREN] = ACTIONS(2855),
    [anon_sym_RBRACK] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2857),
    [anon_sym_AMP] = ACTIONS(2857),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_PIPE_PIPE] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2857),
    [anon_sym_RPAREN] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2857),
    [anon_sym_SLASH] = ACTIONS(2857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PLUS] = ACTIONS(2857),
    [anon_sym_implements] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2855),
    [anon_sym_in] = ACTIONS(2857),
  },
  [1392] = {
    [sym__automatic_semicolon] = ACTIONS(2861),
    [anon_sym_LBRACK] = ACTIONS(2861),
    [sym_identifier] = ACTIONS(4084),
    [anon_sym_SEMI] = ACTIONS(2861),
    [anon_sym_module] = ACTIONS(4084),
    [anon_sym_symbol] = ACTIONS(4084),
    [anon_sym_number] = ACTIONS(4084),
    [anon_sym_AT] = ACTIONS(2861),
    [anon_sym_declare] = ACTIONS(4084),
    [anon_sym_STAR] = ACTIONS(2861),
    [anon_sym_void] = ACTIONS(4084),
    [anon_sym_any] = ACTIONS(4084),
    [anon_sym_private] = ACTIONS(4084),
    [anon_sym_boolean] = ACTIONS(4084),
    [anon_sym_async] = ACTIONS(4084),
    [anon_sym_public] = ACTIONS(4084),
    [anon_sym_get] = ACTIONS(4084),
    [anon_sym_RBRACE] = ACTIONS(2861),
    [anon_sym_static] = ACTIONS(4084),
    [anon_sym_SQUOTE] = ACTIONS(2861),
    [sym_number] = ACTIONS(2861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4084),
    [anon_sym_string] = ACTIONS(4084),
    [anon_sym_abstract] = ACTIONS(4084),
    [anon_sym_set] = ACTIONS(4084),
    [anon_sym_type] = ACTIONS(4084),
    [anon_sym_import] = ACTIONS(4084),
    [anon_sym_export] = ACTIONS(4084),
    [anon_sym_namespace] = ACTIONS(4084),
    [sym_readonly] = ACTIONS(4084),
    [anon_sym_DQUOTE] = ACTIONS(2861),
  },
  [1393] = {
    [anon_sym_COLON] = ACTIONS(2899),
    [anon_sym_RBRACE] = ACTIONS(2899),
    [sym__automatic_semicolon] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2899),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2899),
    [anon_sym_COMMA] = ACTIONS(2899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2899),
  },
  [1394] = {
    [sym_identifier] = ACTIONS(2910),
    [anon_sym_BQUOTE] = ACTIONS(2908),
    [anon_sym_debugger] = ACTIONS(2910),
    [anon_sym_symbol] = ACTIONS(2910),
    [anon_sym_AT] = ACTIONS(2908),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_void] = ACTIONS(2910),
    [anon_sym_break] = ACTIONS(2910),
    [anon_sym_const] = ACTIONS(2910),
    [sym_super] = ACTIONS(2910),
    [anon_sym_return] = ACTIONS(2910),
    [anon_sym_private] = ACTIONS(2910),
    [anon_sym_get] = ACTIONS(2910),
    [anon_sym_interface] = ACTIONS(2910),
    [anon_sym_enum] = ACTIONS(2910),
    [anon_sym_delete] = ACTIONS(2910),
    [anon_sym_continue] = ACTIONS(2910),
    [anon_sym_DASH_DASH] = ACTIONS(2908),
    [anon_sym_if] = ACTIONS(2910),
    [anon_sym_this] = ACTIONS(2910),
    [anon_sym_yield] = ACTIONS(2910),
    [sym_true] = ACTIONS(2910),
    [anon_sym_throw] = ACTIONS(2910),
    [anon_sym_protected] = ACTIONS(2910),
    [anon_sym_abstract] = ACTIONS(2910),
    [anon_sym_set] = ACTIONS(2910),
    [anon_sym_type] = ACTIONS(2910),
    [anon_sym_import] = ACTIONS(2910),
    [anon_sym_namespace] = ACTIONS(2910),
    [anon_sym_PLUS_PLUS] = ACTIONS(2908),
    [anon_sym_await] = ACTIONS(2910),
    [anon_sym_DQUOTE] = ACTIONS(2908),
    [anon_sym_BANG] = ACTIONS(2908),
    [anon_sym_for] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2908),
    [sym_false] = ACTIONS(2910),
    [anon_sym_SEMI] = ACTIONS(2908),
    [anon_sym_module] = ACTIONS(2910),
    [anon_sym_number] = ACTIONS(2910),
    [anon_sym_class] = ACTIONS(2910),
    [anon_sym_declare] = ACTIONS(2910),
    [anon_sym_typeof] = ACTIONS(2910),
    [anon_sym_LBRACE] = ACTIONS(2908),
    [anon_sym_switch] = ACTIONS(2910),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [sym_null] = ACTIONS(2910),
    [anon_sym_any] = ACTIONS(2910),
    [anon_sym_boolean] = ACTIONS(2910),
    [anon_sym_async] = ACTIONS(2910),
    [anon_sym_public] = ACTIONS(2910),
    [anon_sym_var] = ACTIONS(2910),
    [anon_sym_while] = ACTIONS(2910),
    [anon_sym_SQUOTE] = ACTIONS(2908),
    [anon_sym_try] = ACTIONS(2910),
    [anon_sym_LT] = ACTIONS(2908),
    [sym_number] = ACTIONS(2908),
    [anon_sym_SLASH] = ACTIONS(2910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2910),
    [anon_sym_function] = ACTIONS(2910),
    [sym_undefined] = ACTIONS(2910),
    [anon_sym_new] = ACTIONS(2910),
    [anon_sym_let] = ACTIONS(2910),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_export] = ACTIONS(2910),
    [anon_sym_do] = ACTIONS(2910),
    [anon_sym_TILDE] = ACTIONS(2908),
    [anon_sym_with] = ACTIONS(2910),
  },
  [1395] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2936),
    [anon_sym_BQUOTE] = ACTIONS(2936),
    [anon_sym_PIPE] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_DASH] = ACTIONS(2938),
    [anon_sym_STAR] = ACTIONS(2938),
    [anon_sym_GT_GT_GT] = ACTIONS(2936),
    [anon_sym_BANG_EQ] = ACTIONS(2938),
    [anon_sym_GT_EQ] = ACTIONS(2936),
    [anon_sym_RBRACE] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(2936),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2936),
    [anon_sym_as] = ACTIONS(2936),
    [anon_sym_DASH_DASH] = ACTIONS(2936),
    [anon_sym_instanceof] = ACTIONS(2936),
    [anon_sym_COLON] = ACTIONS(2936),
    [anon_sym_DOT] = ACTIONS(2936),
    [anon_sym_STAR_STAR] = ACTIONS(2936),
    [anon_sym_PLUS_PLUS] = ACTIONS(2936),
    [anon_sym_BANG] = ACTIONS(2938),
    [anon_sym_LBRACK] = ACTIONS(2936),
    [anon_sym_LT_LT] = ACTIONS(2936),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(2936),
    [anon_sym_LT_EQ] = ACTIONS(2936),
    [anon_sym_LPAREN] = ACTIONS(2936),
    [anon_sym_RBRACK] = ACTIONS(2936),
    [anon_sym_GT] = ACTIONS(2938),
    [anon_sym_AMP] = ACTIONS(2938),
    [anon_sym_QMARK] = ACTIONS(2936),
    [anon_sym_PIPE_PIPE] = ACTIONS(2936),
    [anon_sym_EQ_EQ] = ACTIONS(2938),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2938),
    [anon_sym_SLASH] = ACTIONS(2938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2936),
    [anon_sym_PLUS] = ACTIONS(2938),
    [anon_sym_implements] = ACTIONS(2936),
    [anon_sym_GT_GT] = ACTIONS(2938),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2936),
    [anon_sym_in] = ACTIONS(2938),
  },
  [1396] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(2936),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(2936),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_in] = ACTIONS(847),
  },
  [1397] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2940),
    [anon_sym_BQUOTE] = ACTIONS(2940),
    [anon_sym_PIPE] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_DASH] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(2942),
    [anon_sym_GT_GT_GT] = ACTIONS(2940),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2940),
    [anon_sym_RBRACE] = ACTIONS(2940),
    [anon_sym_PERCENT] = ACTIONS(2940),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2940),
    [anon_sym_as] = ACTIONS(2940),
    [anon_sym_DASH_DASH] = ACTIONS(2940),
    [anon_sym_instanceof] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(2940),
    [anon_sym_DOT] = ACTIONS(2940),
    [anon_sym_STAR_STAR] = ACTIONS(2940),
    [anon_sym_PLUS_PLUS] = ACTIONS(2940),
    [anon_sym_BANG] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(2940),
    [anon_sym_LT_LT] = ACTIONS(2940),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(2940),
    [anon_sym_LT_EQ] = ACTIONS(2940),
    [anon_sym_LPAREN] = ACTIONS(2940),
    [anon_sym_RBRACK] = ACTIONS(2940),
    [anon_sym_GT] = ACTIONS(2942),
    [anon_sym_AMP] = ACTIONS(2942),
    [anon_sym_QMARK] = ACTIONS(2940),
    [anon_sym_PIPE_PIPE] = ACTIONS(2940),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_RPAREN] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(2942),
    [anon_sym_SLASH] = ACTIONS(2942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2940),
    [anon_sym_PLUS] = ACTIONS(2942),
    [anon_sym_implements] = ACTIONS(2940),
    [anon_sym_GT_GT] = ACTIONS(2942),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2940),
    [anon_sym_in] = ACTIONS(2942),
  },
  [1398] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(2940),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(2940),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(2940),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(2940),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_in] = ACTIONS(847),
  },
  [1399] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2946),
    [sym__automatic_semicolon] = ACTIONS(2946),
    [anon_sym_BQUOTE] = ACTIONS(2946),
    [anon_sym_PIPE] = ACTIONS(2948),
    [anon_sym_COMMA] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2948),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_GT_GT_GT] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2948),
    [anon_sym_GT_EQ] = ACTIONS(2946),
    [anon_sym_RBRACE] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_as] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2946),
    [anon_sym_instanceof] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_STAR_STAR] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_LT_LT] = ACTIONS(2946),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_LT_EQ] = ACTIONS(2946),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_EQ_EQ] = ACTIONS(2948),
    [anon_sym_RPAREN] = ACTIONS(2946),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_SLASH] = ACTIONS(2948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2948),
    [anon_sym_GT_GT] = ACTIONS(2948),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2946),
    [anon_sym_in] = ACTIONS(2948),
  },
  [1400] = {
    [sym__automatic_semicolon] = ACTIONS(2952),
    [anon_sym_RBRACE] = ACTIONS(2952),
    [anon_sym_SEMI] = ACTIONS(2952),
    [anon_sym_COMMA] = ACTIONS(2952),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2952),
    [sym_comment] = ACTIONS(3),
  },
  [1401] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2974),
    [sym__automatic_semicolon] = ACTIONS(2974),
    [anon_sym_BQUOTE] = ACTIONS(2974),
    [anon_sym_PIPE] = ACTIONS(2976),
    [anon_sym_COMMA] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2976),
    [anon_sym_STAR] = ACTIONS(2976),
    [anon_sym_GT_GT_GT] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2976),
    [anon_sym_GT_EQ] = ACTIONS(2974),
    [anon_sym_RBRACE] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_as] = ACTIONS(2974),
    [anon_sym_DASH_DASH] = ACTIONS(2974),
    [anon_sym_instanceof] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_STAR_STAR] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2976),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym_LT_LT] = ACTIONS(2974),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_LT_EQ] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_GT] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2976),
    [anon_sym_QMARK] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_EQ_EQ] = ACTIONS(2976),
    [anon_sym_RPAREN] = ACTIONS(2974),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_SLASH] = ACTIONS(2976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2976),
    [anon_sym_GT_GT] = ACTIONS(2976),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2974),
    [anon_sym_in] = ACTIONS(2976),
  },
  [1402] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2978),
    [sym__automatic_semicolon] = ACTIONS(2978),
    [anon_sym_BQUOTE] = ACTIONS(2978),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2980),
    [anon_sym_GT_GT_GT] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2980),
    [anon_sym_GT_EQ] = ACTIONS(2978),
    [anon_sym_RBRACE] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_as] = ACTIONS(2978),
    [anon_sym_DASH_DASH] = ACTIONS(2978),
    [anon_sym_instanceof] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_STAR_STAR] = ACTIONS(2978),
    [anon_sym_PLUS_PLUS] = ACTIONS(2978),
    [anon_sym_BANG] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_SEMI] = ACTIONS(2978),
    [anon_sym_LT_LT] = ACTIONS(2978),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_LT_EQ] = ACTIONS(2978),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_GT] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(4091),
    [anon_sym_QMARK] = ACTIONS(2978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_EQ_EQ] = ACTIONS(2980),
    [anon_sym_RPAREN] = ACTIONS(2978),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_SLASH] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_GT_GT] = ACTIONS(2980),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2978),
    [anon_sym_in] = ACTIONS(2980),
  },
  [1403] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2982),
    [sym__automatic_semicolon] = ACTIONS(2982),
    [anon_sym_BQUOTE] = ACTIONS(2982),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_GT_GT_GT] = ACTIONS(2982),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_GT_EQ] = ACTIONS(2982),
    [anon_sym_RBRACE] = ACTIONS(2982),
    [anon_sym_PERCENT] = ACTIONS(2982),
    [anon_sym_as] = ACTIONS(2982),
    [anon_sym_DASH_DASH] = ACTIONS(2982),
    [anon_sym_instanceof] = ACTIONS(2982),
    [anon_sym_DOT] = ACTIONS(2982),
    [anon_sym_STAR_STAR] = ACTIONS(2982),
    [anon_sym_PLUS_PLUS] = ACTIONS(2982),
    [anon_sym_BANG] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_LT_LT] = ACTIONS(2982),
    [anon_sym_AMP_AMP] = ACTIONS(2982),
    [anon_sym_LT_EQ] = ACTIONS(2982),
    [anon_sym_LPAREN] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(4091),
    [anon_sym_QMARK] = ACTIONS(2982),
    [anon_sym_PIPE_PIPE] = ACTIONS(2982),
    [anon_sym_EQ_EQ] = ACTIONS(2984),
    [anon_sym_RPAREN] = ACTIONS(2982),
    [anon_sym_LT] = ACTIONS(2984),
    [anon_sym_SLASH] = ACTIONS(2984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_GT_GT] = ACTIONS(2984),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2982),
    [anon_sym_in] = ACTIONS(2984),
  },
  [1404] = {
    [sym_string] = STATE(957),
    [sym__property_name] = STATE(957),
    [sym_computed_property_name] = STATE(957),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(2994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1405] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3014),
    [sym__automatic_semicolon] = ACTIONS(3014),
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [anon_sym_PIPE] = ACTIONS(3016),
    [anon_sym_COMMA] = ACTIONS(3014),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_GT_GT_GT] = ACTIONS(3014),
    [anon_sym_BANG_EQ] = ACTIONS(3016),
    [anon_sym_GT_EQ] = ACTIONS(3014),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_PERCENT] = ACTIONS(3014),
    [anon_sym_as] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_instanceof] = ACTIONS(3014),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3014),
    [anon_sym_STAR_STAR] = ACTIONS(3014),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_LPAREN] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3016),
    [anon_sym_QMARK] = ACTIONS(3014),
    [anon_sym_PIPE_PIPE] = ACTIONS(3014),
    [anon_sym_EQ_EQ] = ACTIONS(3016),
    [anon_sym_RPAREN] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3016),
    [anon_sym_SLASH] = ACTIONS(3016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_GT_GT] = ACTIONS(3016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3014),
    [anon_sym_in] = ACTIONS(3016),
  },
  [1406] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3018),
    [sym__automatic_semicolon] = ACTIONS(3018),
    [anon_sym_BQUOTE] = ACTIONS(3018),
    [anon_sym_PIPE] = ACTIONS(3020),
    [anon_sym_COMMA] = ACTIONS(3018),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3020),
    [anon_sym_GT_GT_GT] = ACTIONS(3018),
    [anon_sym_BANG_EQ] = ACTIONS(3020),
    [anon_sym_GT_EQ] = ACTIONS(3018),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_PERCENT] = ACTIONS(3018),
    [anon_sym_as] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [anon_sym_instanceof] = ACTIONS(3018),
    [anon_sym_DOT] = ACTIONS(3018),
    [anon_sym_STAR_STAR] = ACTIONS(3018),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_BANG] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym_LT_LT] = ACTIONS(3018),
    [anon_sym_AMP_AMP] = ACTIONS(3018),
    [anon_sym_LT_EQ] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [anon_sym_GT] = ACTIONS(3020),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_QMARK] = ACTIONS(3018),
    [anon_sym_PIPE_PIPE] = ACTIONS(3018),
    [anon_sym_EQ_EQ] = ACTIONS(3020),
    [anon_sym_RPAREN] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(3020),
    [anon_sym_SLASH] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_GT_GT] = ACTIONS(3020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3020),
  },
  [1407] = {
    [sym__type] = STATE(1453),
    [sym_constructor_type] = STATE(1453),
    [sym_index_type_query] = STATE(1259),
    [sym_lookup_type] = STATE(1259),
    [sym_this_type] = STATE(1259),
    [sym_flow_maybe_type] = STATE(1259),
    [sym_function_type] = STATE(1453),
    [sym_nested_identifier] = STATE(2241),
    [sym__primary_type] = STATE(1259),
    [sym_generic_type] = STATE(1259),
    [sym_mapped_type] = STATE(1259),
    [sym_literal_type] = STATE(1259),
    [sym_parenthesized_type] = STATE(1259),
    [sym_predefined_type] = STATE(1259),
    [sym_type_parameters] = STATE(2240),
    [sym_string] = STATE(1251),
    [sym_array_type] = STATE(1259),
    [sym_tuple_type] = STATE(1259),
    [sym_nested_type_identifier] = STATE(1258),
    [sym_type_predicate] = STATE(1259),
    [sym_type_query] = STATE(1259),
    [sym__number] = STATE(1251),
    [sym_existential_type] = STATE(1259),
    [sym_object_type] = STATE(1259),
    [sym_union_type] = STATE(1453),
    [sym_intersection_type] = STATE(1453),
    [sym_formal_parameters] = STATE(1796),
    [sym_identifier] = ACTIONS(1600),
    [sym_false] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1606),
    [anon_sym_number] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_keyof] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_void] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_QMARK] = ACTIONS(1626),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1628),
    [sym_number] = ACTIONS(1630),
    [sym_true] = ACTIONS(1602),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_new] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [1408] = {
    [sym__property_name] = STATE(2292),
    [aux_sym_object_repeat1] = STATE(408),
    [sym_string] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(3052),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(3054),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(3054),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1409] = {
    [sym__property_name] = STATE(2292),
    [aux_sym_object_repeat1] = STATE(408),
    [sym_string] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1410] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [sym__automatic_semicolon] = ACTIONS(1027),
    [anon_sym_BQUOTE] = ACTIONS(1027),
    [anon_sym_PIPE] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1031),
    [anon_sym_GT_GT_GT] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1031),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [anon_sym_SEMI] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1031),
    [anon_sym_AMP] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_RPAREN] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1031),
    [anon_sym_SLASH] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(1031),
  },
  [1411] = {
    [sym_type_alias_declaration] = STATE(1271),
    [sym__declaration] = STATE(1271),
    [sym_internal_module] = STATE(1271),
    [sym_enum_declaration] = STATE(1271),
    [sym_function] = STATE(1271),
    [sym_variable_declaration] = STATE(1271),
    [aux_sym_export_statement_repeat1] = STATE(1763),
    [aux_sym_object_repeat1] = STATE(408),
    [sym_ambient_declaration] = STATE(1271),
    [sym_import_alias] = STATE(1271),
    [sym_export_statement] = STATE(1271),
    [sym_generator_function] = STATE(1271),
    [sym_export_clause] = STATE(1801),
    [sym_lexical_declaration] = STATE(1271),
    [sym_decorator] = STATE(1763),
    [sym_function_signature] = STATE(1271),
    [sym_abstract_class] = STATE(1271),
    [sym_module] = STATE(1271),
    [sym_interface_declaration] = STATE(1271),
    [sym_class] = STATE(1271),
    [sym__automatic_semicolon] = ACTIONS(986),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(2249),
    [anon_sym_class] = ACTIONS(2251),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(2253),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(2255),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_EQ] = ACTIONS(2257),
    [anon_sym_const] = ACTIONS(2259),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_async] = ACTIONS(2261),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_var] = ACTIONS(2263),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_interface] = ACTIONS(2265),
    [anon_sym_default] = ACTIONS(2267),
    [anon_sym_enum] = ACTIONS(2269),
    [anon_sym_as] = ACTIONS(2271),
    [anon_sym_LT] = ACTIONS(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_function] = ACTIONS(2273),
    [anon_sym_abstract] = ACTIONS(2275),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(2277),
    [anon_sym_let] = ACTIONS(2279),
    [anon_sym_import] = ACTIONS(2281),
    [anon_sym_export] = ACTIONS(2283),
    [anon_sym_namespace] = ACTIONS(2285),
  },
  [1412] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3076),
    [sym__automatic_semicolon] = ACTIONS(3076),
    [anon_sym_BQUOTE] = ACTIONS(3076),
    [anon_sym_PIPE] = ACTIONS(3078),
    [anon_sym_COMMA] = ACTIONS(3076),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_STAR] = ACTIONS(3078),
    [anon_sym_GT_GT_GT] = ACTIONS(3076),
    [anon_sym_BANG_EQ] = ACTIONS(3078),
    [anon_sym_GT_EQ] = ACTIONS(3076),
    [anon_sym_RBRACE] = ACTIONS(3076),
    [anon_sym_PERCENT] = ACTIONS(3076),
    [anon_sym_as] = ACTIONS(3076),
    [anon_sym_DASH_DASH] = ACTIONS(3076),
    [anon_sym_instanceof] = ACTIONS(3076),
    [anon_sym_DOT] = ACTIONS(3076),
    [anon_sym_STAR_STAR] = ACTIONS(3076),
    [anon_sym_PLUS_PLUS] = ACTIONS(3076),
    [anon_sym_BANG] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3076),
    [anon_sym_SEMI] = ACTIONS(3076),
    [anon_sym_LT_LT] = ACTIONS(3076),
    [anon_sym_AMP_AMP] = ACTIONS(3076),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_LPAREN] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym_QMARK] = ACTIONS(3076),
    [anon_sym_PIPE_PIPE] = ACTIONS(3076),
    [anon_sym_EQ_EQ] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3076),
    [anon_sym_LT] = ACTIONS(3078),
    [anon_sym_SLASH] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3076),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_GT_GT] = ACTIONS(3078),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3076),
    [anon_sym_in] = ACTIONS(3078),
  },
  [1413] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3080),
    [sym__automatic_semicolon] = ACTIONS(3080),
    [anon_sym_BQUOTE] = ACTIONS(3080),
    [anon_sym_PIPE] = ACTIONS(3082),
    [anon_sym_COMMA] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3082),
    [anon_sym_GT_GT_GT] = ACTIONS(3080),
    [anon_sym_BANG_EQ] = ACTIONS(3082),
    [anon_sym_GT_EQ] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3080),
    [anon_sym_PERCENT] = ACTIONS(3080),
    [anon_sym_as] = ACTIONS(3080),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_instanceof] = ACTIONS(3080),
    [anon_sym_DOT] = ACTIONS(3080),
    [anon_sym_STAR_STAR] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_LT_LT] = ACTIONS(3080),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_LT_EQ] = ACTIONS(3080),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3082),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_QMARK] = ACTIONS(3080),
    [anon_sym_PIPE_PIPE] = ACTIONS(3080),
    [anon_sym_EQ_EQ] = ACTIONS(3082),
    [anon_sym_RPAREN] = ACTIONS(3080),
    [anon_sym_LT] = ACTIONS(3082),
    [anon_sym_SLASH] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3080),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_GT_GT] = ACTIONS(3082),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3082),
  },
  [1414] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3084),
    [sym__automatic_semicolon] = ACTIONS(3084),
    [anon_sym_BQUOTE] = ACTIONS(3084),
    [anon_sym_PIPE] = ACTIONS(3086),
    [anon_sym_COMMA] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3086),
    [anon_sym_GT_GT_GT] = ACTIONS(3084),
    [anon_sym_BANG_EQ] = ACTIONS(3086),
    [anon_sym_GT_EQ] = ACTIONS(3084),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_PERCENT] = ACTIONS(3084),
    [anon_sym_as] = ACTIONS(3084),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_instanceof] = ACTIONS(3084),
    [anon_sym_DOT] = ACTIONS(3084),
    [anon_sym_STAR_STAR] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3084),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym_LT_LT] = ACTIONS(3084),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_LT_EQ] = ACTIONS(3084),
    [anon_sym_LPAREN] = ACTIONS(3084),
    [anon_sym_GT] = ACTIONS(3086),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_QMARK] = ACTIONS(3084),
    [anon_sym_PIPE_PIPE] = ACTIONS(3084),
    [anon_sym_EQ_EQ] = ACTIONS(3086),
    [anon_sym_RPAREN] = ACTIONS(3084),
    [anon_sym_LT] = ACTIONS(3086),
    [anon_sym_SLASH] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_GT_GT] = ACTIONS(3086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3084),
    [anon_sym_in] = ACTIONS(3086),
  },
  [1415] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3088),
    [sym__automatic_semicolon] = ACTIONS(3088),
    [anon_sym_BQUOTE] = ACTIONS(3088),
    [anon_sym_PIPE] = ACTIONS(3090),
    [anon_sym_COMMA] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3090),
    [anon_sym_GT_GT_GT] = ACTIONS(3088),
    [anon_sym_BANG_EQ] = ACTIONS(3090),
    [anon_sym_GT_EQ] = ACTIONS(3088),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_PERCENT] = ACTIONS(3088),
    [anon_sym_as] = ACTIONS(3088),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_instanceof] = ACTIONS(3088),
    [anon_sym_DOT] = ACTIONS(3088),
    [anon_sym_STAR_STAR] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3090),
    [anon_sym_LBRACK] = ACTIONS(3088),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_LT_EQ] = ACTIONS(3088),
    [anon_sym_LPAREN] = ACTIONS(3088),
    [anon_sym_GT] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3090),
    [anon_sym_QMARK] = ACTIONS(3088),
    [anon_sym_PIPE_PIPE] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(3090),
    [anon_sym_RPAREN] = ACTIONS(3088),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_SLASH] = ACTIONS(3090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3088),
    [anon_sym_PLUS] = ACTIONS(3090),
    [anon_sym_GT_GT] = ACTIONS(3090),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3088),
    [anon_sym_in] = ACTIONS(3090),
  },
  [1416] = {
    [sym__type] = STATE(1456),
    [sym_constructor_type] = STATE(1456),
    [sym_index_type_query] = STATE(1259),
    [sym_lookup_type] = STATE(1259),
    [sym_this_type] = STATE(1259),
    [sym_flow_maybe_type] = STATE(1259),
    [sym_function_type] = STATE(1456),
    [sym_nested_identifier] = STATE(2241),
    [sym__primary_type] = STATE(1259),
    [sym_generic_type] = STATE(1259),
    [sym_mapped_type] = STATE(1259),
    [sym_literal_type] = STATE(1259),
    [sym_parenthesized_type] = STATE(1259),
    [sym_predefined_type] = STATE(1259),
    [sym_type_parameters] = STATE(2240),
    [sym_string] = STATE(1251),
    [sym_array_type] = STATE(1259),
    [sym_tuple_type] = STATE(1259),
    [sym_nested_type_identifier] = STATE(1258),
    [sym_type_predicate] = STATE(1259),
    [sym_type_query] = STATE(1259),
    [sym__number] = STATE(1251),
    [sym_existential_type] = STATE(1259),
    [sym_object_type] = STATE(1259),
    [sym_union_type] = STATE(1456),
    [sym_intersection_type] = STATE(1456),
    [sym_formal_parameters] = STATE(1796),
    [sym_identifier] = ACTIONS(1600),
    [sym_false] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1606),
    [anon_sym_number] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_keyof] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_void] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_QMARK] = ACTIONS(1626),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1628),
    [sym_number] = ACTIONS(1630),
    [sym_true] = ACTIONS(1602),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_new] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [1417] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3099),
    [sym__automatic_semicolon] = ACTIONS(3099),
    [anon_sym_BQUOTE] = ACTIONS(3099),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3101),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_GT_GT_GT] = ACTIONS(3099),
    [anon_sym_BANG_EQ] = ACTIONS(3101),
    [anon_sym_GT_EQ] = ACTIONS(3099),
    [anon_sym_RBRACE] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_as] = ACTIONS(3099),
    [anon_sym_DASH_DASH] = ACTIONS(3099),
    [anon_sym_instanceof] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_STAR_STAR] = ACTIONS(3099),
    [anon_sym_PLUS_PLUS] = ACTIONS(3099),
    [anon_sym_BANG] = ACTIONS(3101),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_SEMI] = ACTIONS(3099),
    [anon_sym_LT_LT] = ACTIONS(3099),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_LT_EQ] = ACTIONS(3099),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_GT] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(4091),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_EQ_EQ] = ACTIONS(3101),
    [anon_sym_RPAREN] = ACTIONS(3099),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_SLASH] = ACTIONS(3101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_GT_GT] = ACTIONS(3101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3099),
    [anon_sym_in] = ACTIONS(3101),
  },
  [1418] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3116),
    [sym__automatic_semicolon] = ACTIONS(3116),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3118),
    [anon_sym_COMMA] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(3118),
    [anon_sym_STAR] = ACTIONS(3118),
    [anon_sym_GT_GT_GT] = ACTIONS(3116),
    [anon_sym_BANG_EQ] = ACTIONS(3118),
    [anon_sym_GT_EQ] = ACTIONS(3116),
    [anon_sym_RBRACE] = ACTIONS(3116),
    [anon_sym_PERCENT] = ACTIONS(3116),
    [anon_sym_as] = ACTIONS(3116),
    [anon_sym_DASH_DASH] = ACTIONS(3116),
    [anon_sym_instanceof] = ACTIONS(3116),
    [anon_sym_DOT] = ACTIONS(3116),
    [anon_sym_STAR_STAR] = ACTIONS(3116),
    [anon_sym_PLUS_PLUS] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_LBRACK] = ACTIONS(3116),
    [anon_sym_SEMI] = ACTIONS(3116),
    [anon_sym_LT_LT] = ACTIONS(3116),
    [anon_sym_AMP_AMP] = ACTIONS(3116),
    [anon_sym_LT_EQ] = ACTIONS(3116),
    [anon_sym_LPAREN] = ACTIONS(3116),
    [anon_sym_GT] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3118),
    [anon_sym_QMARK] = ACTIONS(3116),
    [anon_sym_PIPE_PIPE] = ACTIONS(3116),
    [anon_sym_EQ_EQ] = ACTIONS(3118),
    [anon_sym_RPAREN] = ACTIONS(3116),
    [anon_sym_LT] = ACTIONS(3118),
    [anon_sym_SLASH] = ACTIONS(3118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3116),
    [anon_sym_PLUS] = ACTIONS(3118),
    [anon_sym_GT_GT] = ACTIONS(3118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3116),
    [anon_sym_in] = ACTIONS(3118),
  },
  [1419] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3120),
    [sym__automatic_semicolon] = ACTIONS(3120),
    [anon_sym_BQUOTE] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3122),
    [anon_sym_GT_GT_GT] = ACTIONS(3120),
    [anon_sym_BANG_EQ] = ACTIONS(3122),
    [anon_sym_GT_EQ] = ACTIONS(3120),
    [anon_sym_RBRACE] = ACTIONS(3120),
    [anon_sym_PERCENT] = ACTIONS(3120),
    [anon_sym_as] = ACTIONS(3120),
    [anon_sym_DASH_DASH] = ACTIONS(3120),
    [anon_sym_instanceof] = ACTIONS(3120),
    [anon_sym_DOT] = ACTIONS(3120),
    [anon_sym_STAR_STAR] = ACTIONS(3120),
    [anon_sym_PLUS_PLUS] = ACTIONS(3120),
    [anon_sym_BANG] = ACTIONS(3122),
    [anon_sym_LBRACK] = ACTIONS(3120),
    [anon_sym_SEMI] = ACTIONS(3120),
    [anon_sym_LT_LT] = ACTIONS(3120),
    [anon_sym_AMP_AMP] = ACTIONS(3120),
    [anon_sym_LT_EQ] = ACTIONS(3120),
    [anon_sym_LPAREN] = ACTIONS(3120),
    [anon_sym_GT] = ACTIONS(3122),
    [anon_sym_AMP] = ACTIONS(4091),
    [anon_sym_QMARK] = ACTIONS(3120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3120),
    [anon_sym_EQ_EQ] = ACTIONS(3122),
    [anon_sym_RPAREN] = ACTIONS(3120),
    [anon_sym_LT] = ACTIONS(3122),
    [anon_sym_SLASH] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3120),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_GT_GT] = ACTIONS(3122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3120),
    [anon_sym_in] = ACTIONS(3122),
  },
  [1420] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3124),
    [anon_sym_BQUOTE] = ACTIONS(3124),
    [anon_sym_PIPE] = ACTIONS(3126),
    [anon_sym_COMMA] = ACTIONS(3124),
    [anon_sym_DASH] = ACTIONS(3126),
    [anon_sym_STAR] = ACTIONS(3126),
    [anon_sym_GT_GT_GT] = ACTIONS(3124),
    [anon_sym_BANG_EQ] = ACTIONS(3126),
    [anon_sym_GT_EQ] = ACTIONS(3124),
    [anon_sym_RBRACE] = ACTIONS(3124),
    [anon_sym_PERCENT] = ACTIONS(3124),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3124),
    [anon_sym_as] = ACTIONS(3124),
    [anon_sym_DASH_DASH] = ACTIONS(3124),
    [anon_sym_instanceof] = ACTIONS(3124),
    [anon_sym_COLON] = ACTIONS(3124),
    [anon_sym_DOT] = ACTIONS(3124),
    [anon_sym_STAR_STAR] = ACTIONS(3124),
    [anon_sym_PLUS_PLUS] = ACTIONS(3124),
    [anon_sym_BANG] = ACTIONS(3126),
    [anon_sym_LBRACK] = ACTIONS(3124),
    [anon_sym_LT_LT] = ACTIONS(3124),
    [anon_sym_LBRACE] = ACTIONS(3126),
    [anon_sym_AMP_AMP] = ACTIONS(3124),
    [anon_sym_LT_EQ] = ACTIONS(3124),
    [anon_sym_LPAREN] = ACTIONS(3124),
    [anon_sym_RBRACK] = ACTIONS(3124),
    [anon_sym_GT] = ACTIONS(3126),
    [anon_sym_AMP] = ACTIONS(3126),
    [anon_sym_QMARK] = ACTIONS(3124),
    [anon_sym_PIPE_PIPE] = ACTIONS(3124),
    [anon_sym_EQ_EQ] = ACTIONS(3126),
    [anon_sym_RPAREN] = ACTIONS(3124),
    [anon_sym_LT] = ACTIONS(3126),
    [anon_sym_SLASH] = ACTIONS(3126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3124),
    [anon_sym_PLUS] = ACTIONS(3126),
    [anon_sym_implements] = ACTIONS(3124),
    [anon_sym_GT_GT] = ACTIONS(3126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3124),
    [anon_sym_in] = ACTIONS(3126),
  },
  [1421] = {
    [sym__automatic_semicolon] = ACTIONS(3130),
    [anon_sym_RBRACE] = ACTIONS(3130),
    [anon_sym_SEMI] = ACTIONS(3130),
    [anon_sym_COMMA] = ACTIONS(3130),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3130),
    [sym_comment] = ACTIONS(3),
  },
  [1422] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3132),
    [sym__automatic_semicolon] = ACTIONS(3132),
    [anon_sym_BQUOTE] = ACTIONS(3132),
    [anon_sym_PIPE] = ACTIONS(3134),
    [anon_sym_COMMA] = ACTIONS(3132),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_GT_GT_GT] = ACTIONS(3132),
    [anon_sym_BANG_EQ] = ACTIONS(3134),
    [anon_sym_GT_EQ] = ACTIONS(3132),
    [anon_sym_RBRACE] = ACTIONS(3132),
    [anon_sym_PERCENT] = ACTIONS(3132),
    [anon_sym_as] = ACTIONS(3132),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [anon_sym_instanceof] = ACTIONS(3132),
    [anon_sym_DOT] = ACTIONS(3132),
    [anon_sym_STAR_STAR] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_else] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_SEMI] = ACTIONS(3132),
    [anon_sym_LT_LT] = ACTIONS(3132),
    [anon_sym_AMP_AMP] = ACTIONS(3132),
    [anon_sym_LT_EQ] = ACTIONS(3132),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [anon_sym_GT] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3134),
    [anon_sym_QMARK] = ACTIONS(3132),
    [anon_sym_PIPE_PIPE] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3132),
    [anon_sym_EQ_EQ] = ACTIONS(3134),
    [anon_sym_RPAREN] = ACTIONS(3132),
    [anon_sym_LT] = ACTIONS(3134),
    [anon_sym_SLASH] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_GT_GT] = ACTIONS(3134),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3132),
    [anon_sym_in] = ACTIONS(3134),
  },
  [1423] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1753),
    [anon_sym_BQUOTE] = ACTIONS(1753),
    [anon_sym_PIPE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1755),
    [anon_sym_GT_GT_GT] = ACTIONS(1753),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_GT_EQ] = ACTIONS(1753),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_PERCENT] = ACTIONS(1753),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1753),
    [anon_sym_as] = ACTIONS(1753),
    [anon_sym_DASH_DASH] = ACTIONS(1753),
    [anon_sym_instanceof] = ACTIONS(1753),
    [anon_sym_COLON] = ACTIONS(1138),
    [anon_sym_DOT] = ACTIONS(1753),
    [anon_sym_STAR_STAR] = ACTIONS(1753),
    [anon_sym_PLUS_PLUS] = ACTIONS(1753),
    [anon_sym_BANG] = ACTIONS(1755),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_LT_LT] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1755),
    [anon_sym_AMP_AMP] = ACTIONS(1753),
    [anon_sym_LT_EQ] = ACTIONS(1753),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_RBRACK] = ACTIONS(1753),
    [anon_sym_GT] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(1138),
    [anon_sym_AMP] = ACTIONS(1755),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_PIPE_PIPE] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_RPAREN] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_implements] = ACTIONS(1753),
    [anon_sym_GT_GT] = ACTIONS(1755),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1753),
    [anon_sym_in] = ACTIONS(1755),
  },
  [1424] = {
    [sym__automatic_semicolon] = ACTIONS(3144),
    [anon_sym_RBRACE] = ACTIONS(3144),
    [anon_sym_SEMI] = ACTIONS(3144),
    [anon_sym_COMMA] = ACTIONS(3144),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3144),
    [sym_comment] = ACTIONS(3),
  },
  [1425] = {
    [sym_new_expression] = STATE(1461),
    [sym_augmented_assignment_expression] = STATE(1461),
    [sym_unary_expression] = STATE(1461),
    [sym_update_expression] = STATE(1461),
    [sym_regex] = STATE(1461),
    [sym_meta_property] = STATE(1461),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1461),
    [sym_yield_expression] = STATE(1461),
    [sym_as_expression] = STATE(1461),
    [sym_non_null_expression] = STATE(1461),
    [sym_internal_module] = STATE(1461),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1461),
    [sym_await_expression] = STATE(1461),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1461),
    [sym_this] = STATE(1461),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1461),
    [sym_generator_function] = STATE(1461),
    [sym_call_expression] = STATE(1461),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1461),
    [sym_ternary_expression] = STATE(1461),
    [sym_binary_expression] = STATE(1461),
    [sym_template_string] = STATE(1461),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1461),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1461),
    [sym_class] = STATE(1461),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(4093),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(4093),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4093),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4095),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4093),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1426] = {
    [sym_new_expression] = STATE(1290),
    [sym_constructor_type] = STATE(754),
    [sym_augmented_assignment_expression] = STATE(1290),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(1290),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(1290),
    [sym_call_signature] = STATE(1740),
    [sym_yield_expression] = STATE(1290),
    [sym_as_expression] = STATE(1290),
    [sym_internal_module] = STATE(1290),
    [sym_arrow_function] = STATE(1290),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(1201),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1369),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(1202),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(1290),
    [sym_subscript_expression] = STATE(1201),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(1290),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(1290),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(754),
    [sym__type] = STATE(754),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(1290),
    [sym_meta_property] = STATE(1290),
    [sym_function_type] = STATE(754),
    [sym__expression] = STATE(1290),
    [sym_non_null_expression] = STATE(1290),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(1290),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(1290),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(1290),
    [sym_call_expression] = STATE(1290),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(1290),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(1290),
    [sym_type_arguments] = STATE(1205),
    [sym_union_type] = STATE(754),
    [sym_parenthesized_expression] = STATE(1290),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1290),
    [sym_class] = STATE(1290),
    [sym_identifier] = ACTIONS(4010),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(4012),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(4014),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(4016),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(4018),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(4020),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(4020),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(4012),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(4022),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [sym_null] = ACTIONS(3940),
    [anon_sym_any] = ACTIONS(4012),
    [anon_sym_boolean] = ACTIONS(4012),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4024),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4012),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(4014),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1427] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1088),
    [anon_sym_AMP_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_EQ] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(1088),
    [anon_sym_PIPE_EQ] = ACTIONS(1088),
    [anon_sym_DASH_EQ] = ACTIONS(1088),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(1088),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(4097),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_STAR_EQ] = ACTIONS(1088),
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1088),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(847),
  },
  [1428] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(2313),
    [anon_sym_COMMA] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACE] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(2311),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2313),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1429] = {
    [sym_type_annotation] = STATE(269),
    [anon_sym_EQ_GT] = ACTIONS(4099),
    [anon_sym_COLON] = ACTIONS(568),
    [sym_comment] = ACTIONS(3),
  },
  [1430] = {
    [sym_type_annotation] = STATE(562),
    [anon_sym_EQ_GT] = ACTIONS(4102),
    [anon_sym_COLON] = ACTIONS(568),
    [sym_comment] = ACTIONS(3),
  },
  [1431] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3182),
    [sym__automatic_semicolon] = ACTIONS(3182),
    [anon_sym_BQUOTE] = ACTIONS(3182),
    [anon_sym_PIPE] = ACTIONS(3184),
    [anon_sym_COMMA] = ACTIONS(3182),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_GT_GT_GT] = ACTIONS(3182),
    [anon_sym_BANG_EQ] = ACTIONS(3184),
    [anon_sym_GT_EQ] = ACTIONS(3182),
    [anon_sym_RBRACE] = ACTIONS(3182),
    [anon_sym_PERCENT] = ACTIONS(3182),
    [anon_sym_as] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [anon_sym_instanceof] = ACTIONS(3182),
    [anon_sym_DOT] = ACTIONS(3182),
    [anon_sym_STAR_STAR] = ACTIONS(3182),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_SEMI] = ACTIONS(3182),
    [anon_sym_LT_LT] = ACTIONS(3182),
    [anon_sym_AMP_AMP] = ACTIONS(3182),
    [anon_sym_LT_EQ] = ACTIONS(3182),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [anon_sym_GT] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3182),
    [anon_sym_PIPE_PIPE] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_EQ_EQ] = ACTIONS(3184),
    [anon_sym_RPAREN] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(3184),
    [anon_sym_SLASH] = ACTIONS(3184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_GT_GT] = ACTIONS(3184),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3184),
  },
  [1432] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3186),
    [anon_sym_BQUOTE] = ACTIONS(3186),
    [anon_sym_PIPE] = ACTIONS(3188),
    [anon_sym_COMMA] = ACTIONS(3186),
    [anon_sym_DASH] = ACTIONS(3188),
    [anon_sym_STAR] = ACTIONS(3188),
    [anon_sym_GT_GT_GT] = ACTIONS(3186),
    [anon_sym_BANG_EQ] = ACTIONS(3188),
    [anon_sym_GT_EQ] = ACTIONS(3186),
    [anon_sym_RBRACE] = ACTIONS(3186),
    [anon_sym_PERCENT] = ACTIONS(3186),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3186),
    [anon_sym_as] = ACTIONS(3186),
    [anon_sym_DASH_DASH] = ACTIONS(3186),
    [anon_sym_instanceof] = ACTIONS(3186),
    [anon_sym_COLON] = ACTIONS(3186),
    [anon_sym_DOT] = ACTIONS(3186),
    [anon_sym_STAR_STAR] = ACTIONS(3186),
    [anon_sym_PLUS_PLUS] = ACTIONS(3186),
    [anon_sym_BANG] = ACTIONS(3188),
    [anon_sym_LBRACK] = ACTIONS(3186),
    [anon_sym_LT_LT] = ACTIONS(3186),
    [anon_sym_LBRACE] = ACTIONS(3188),
    [anon_sym_AMP_AMP] = ACTIONS(3186),
    [anon_sym_LT_EQ] = ACTIONS(3186),
    [anon_sym_LPAREN] = ACTIONS(3186),
    [anon_sym_RBRACK] = ACTIONS(3186),
    [anon_sym_GT] = ACTIONS(3188),
    [anon_sym_AMP] = ACTIONS(3188),
    [anon_sym_QMARK] = ACTIONS(3186),
    [anon_sym_PIPE_PIPE] = ACTIONS(3186),
    [anon_sym_EQ_EQ] = ACTIONS(3188),
    [anon_sym_RPAREN] = ACTIONS(3186),
    [anon_sym_LT] = ACTIONS(3188),
    [anon_sym_SLASH] = ACTIONS(3188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3186),
    [anon_sym_PLUS] = ACTIONS(3188),
    [anon_sym_implements] = ACTIONS(3186),
    [anon_sym_GT_GT] = ACTIONS(3188),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3186),
    [anon_sym_in] = ACTIONS(3188),
  },
  [1433] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3192),
    [anon_sym_BQUOTE] = ACTIONS(3192),
    [anon_sym_AT] = ACTIONS(3192),
    [anon_sym_PIPE] = ACTIONS(3194),
    [anon_sym_COMMA] = ACTIONS(3192),
    [anon_sym_DASH] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3194),
    [anon_sym_GT_GT_GT] = ACTIONS(3192),
    [anon_sym_BANG_EQ] = ACTIONS(3194),
    [anon_sym_GT_EQ] = ACTIONS(3192),
    [anon_sym_RBRACE] = ACTIONS(3192),
    [anon_sym_PERCENT] = ACTIONS(3192),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3192),
    [anon_sym_as] = ACTIONS(3192),
    [anon_sym_DASH_DASH] = ACTIONS(3192),
    [anon_sym_instanceof] = ACTIONS(3192),
    [anon_sym_COLON] = ACTIONS(3192),
    [anon_sym_DOT] = ACTIONS(3192),
    [anon_sym_STAR_STAR] = ACTIONS(3192),
    [anon_sym_PLUS_PLUS] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3192),
    [anon_sym_LT_LT] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3194),
    [anon_sym_AMP_AMP] = ACTIONS(3192),
    [anon_sym_LT_EQ] = ACTIONS(3192),
    [anon_sym_LPAREN] = ACTIONS(3192),
    [anon_sym_RBRACK] = ACTIONS(3192),
    [anon_sym_GT] = ACTIONS(3194),
    [anon_sym_AMP] = ACTIONS(3194),
    [anon_sym_QMARK] = ACTIONS(3192),
    [anon_sym_PIPE_PIPE] = ACTIONS(3192),
    [anon_sym_EQ_EQ] = ACTIONS(3194),
    [anon_sym_RPAREN] = ACTIONS(3192),
    [anon_sym_LT] = ACTIONS(3194),
    [anon_sym_SLASH] = ACTIONS(3194),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3192),
    [anon_sym_PLUS] = ACTIONS(3194),
    [anon_sym_export] = ACTIONS(3192),
    [anon_sym_GT_GT] = ACTIONS(3194),
    [anon_sym_implements] = ACTIONS(3192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3192),
    [anon_sym_in] = ACTIONS(3194),
  },
  [1434] = {
    [sym__automatic_semicolon] = ACTIONS(3198),
    [anon_sym_RBRACE] = ACTIONS(3198),
    [anon_sym_SEMI] = ACTIONS(3198),
    [anon_sym_COMMA] = ACTIONS(3198),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3198),
    [sym_comment] = ACTIONS(3),
  },
  [1435] = {
    [sym__automatic_semicolon] = ACTIONS(3206),
    [anon_sym_RBRACE] = ACTIONS(3206),
    [anon_sym_SEMI] = ACTIONS(3206),
    [anon_sym_COMMA] = ACTIONS(3206),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3206),
    [sym_comment] = ACTIONS(3),
  },
  [1436] = {
    [sym__automatic_semicolon] = ACTIONS(3216),
    [anon_sym_RBRACE] = ACTIONS(3216),
    [anon_sym_SEMI] = ACTIONS(3216),
    [anon_sym_COMMA] = ACTIONS(3216),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3216),
    [sym_comment] = ACTIONS(3),
  },
  [1437] = {
    [sym__automatic_semicolon] = ACTIONS(3220),
    [anon_sym_RBRACE] = ACTIONS(3220),
    [anon_sym_SEMI] = ACTIONS(3220),
    [anon_sym_COMMA] = ACTIONS(3220),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3220),
    [sym_comment] = ACTIONS(3),
  },
  [1438] = {
    [sym__automatic_semicolon] = ACTIONS(3226),
    [anon_sym_RBRACE] = ACTIONS(3226),
    [anon_sym_SEMI] = ACTIONS(3226),
    [anon_sym_COMMA] = ACTIONS(3226),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3226),
    [sym_comment] = ACTIONS(3),
  },
  [1439] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [sym__automatic_semicolon] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(3297),
    [anon_sym_COMMA] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_RBRACE] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_SEMI] = ACTIONS(1695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_GT] = ACTIONS(3297),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(3297),
  },
  [1440] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3307),
    [sym__automatic_semicolon] = ACTIONS(3307),
    [anon_sym_BQUOTE] = ACTIONS(3307),
    [anon_sym_PIPE] = ACTIONS(3309),
    [anon_sym_COMMA] = ACTIONS(3307),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_STAR] = ACTIONS(3309),
    [anon_sym_GT_GT_GT] = ACTIONS(3307),
    [anon_sym_BANG_EQ] = ACTIONS(3309),
    [anon_sym_GT_EQ] = ACTIONS(3307),
    [anon_sym_RBRACE] = ACTIONS(3307),
    [anon_sym_PERCENT] = ACTIONS(3307),
    [anon_sym_as] = ACTIONS(3307),
    [anon_sym_DASH_DASH] = ACTIONS(3307),
    [anon_sym_instanceof] = ACTIONS(3307),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_STAR_STAR] = ACTIONS(3307),
    [anon_sym_PLUS_PLUS] = ACTIONS(3307),
    [anon_sym_else] = ACTIONS(3307),
    [anon_sym_BANG] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [anon_sym_SEMI] = ACTIONS(3307),
    [anon_sym_LT_LT] = ACTIONS(3307),
    [anon_sym_AMP_AMP] = ACTIONS(3307),
    [anon_sym_LT_EQ] = ACTIONS(3307),
    [anon_sym_LPAREN] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3309),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_QMARK] = ACTIONS(3307),
    [anon_sym_PIPE_PIPE] = ACTIONS(3307),
    [anon_sym_while] = ACTIONS(3307),
    [anon_sym_EQ_EQ] = ACTIONS(3309),
    [anon_sym_RPAREN] = ACTIONS(3307),
    [anon_sym_LT] = ACTIONS(3309),
    [anon_sym_SLASH] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3307),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_GT_GT] = ACTIONS(3309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3307),
    [anon_sym_in] = ACTIONS(3309),
  },
  [1441] = {
    [anon_sym_EQ] = ACTIONS(2851),
    [anon_sym_RBRACE] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COMMA] = ACTIONS(2851),
  },
  [1442] = {
    [sym_string] = STATE(1036),
    [sym__property_name] = STATE(1036),
    [sym_computed_property_name] = STATE(1036),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1443] = {
    [sym__type] = STATE(1468),
    [sym_constructor_type] = STATE(1468),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1468),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(1468),
    [sym_intersection_type] = STATE(1468),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1444] = {
    [sym__automatic_semicolon] = ACTIONS(3357),
    [anon_sym_LBRACK] = ACTIONS(3357),
    [sym_identifier] = ACTIONS(4105),
    [anon_sym_SEMI] = ACTIONS(3357),
    [anon_sym_module] = ACTIONS(4105),
    [anon_sym_symbol] = ACTIONS(4105),
    [anon_sym_number] = ACTIONS(4105),
    [anon_sym_AT] = ACTIONS(3357),
    [anon_sym_declare] = ACTIONS(4105),
    [anon_sym_STAR] = ACTIONS(3357),
    [anon_sym_void] = ACTIONS(4105),
    [anon_sym_any] = ACTIONS(4105),
    [anon_sym_private] = ACTIONS(4105),
    [anon_sym_boolean] = ACTIONS(4105),
    [anon_sym_async] = ACTIONS(4105),
    [anon_sym_public] = ACTIONS(4105),
    [anon_sym_get] = ACTIONS(4105),
    [anon_sym_RBRACE] = ACTIONS(3357),
    [anon_sym_static] = ACTIONS(4105),
    [anon_sym_SQUOTE] = ACTIONS(3357),
    [sym_number] = ACTIONS(3357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4105),
    [anon_sym_string] = ACTIONS(4105),
    [anon_sym_abstract] = ACTIONS(4105),
    [anon_sym_set] = ACTIONS(4105),
    [anon_sym_type] = ACTIONS(4105),
    [anon_sym_import] = ACTIONS(4105),
    [anon_sym_export] = ACTIONS(4105),
    [anon_sym_namespace] = ACTIONS(4105),
    [sym_readonly] = ACTIONS(4105),
    [anon_sym_DQUOTE] = ACTIONS(3357),
  },
  [1445] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3367),
    [anon_sym_BQUOTE] = ACTIONS(3367),
    [anon_sym_PIPE] = ACTIONS(3369),
    [anon_sym_COMMA] = ACTIONS(3367),
    [anon_sym_DASH] = ACTIONS(3369),
    [anon_sym_STAR] = ACTIONS(3369),
    [anon_sym_GT_GT_GT] = ACTIONS(3367),
    [anon_sym_EQ] = ACTIONS(3369),
    [anon_sym_BANG_EQ] = ACTIONS(3369),
    [anon_sym_GT_EQ] = ACTIONS(3367),
    [anon_sym_RBRACE] = ACTIONS(3367),
    [anon_sym_PERCENT] = ACTIONS(3367),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3367),
    [anon_sym_as] = ACTIONS(3367),
    [anon_sym_DASH_DASH] = ACTIONS(3367),
    [anon_sym_instanceof] = ACTIONS(3367),
    [anon_sym_COLON] = ACTIONS(3367),
    [anon_sym_DOT] = ACTIONS(3367),
    [anon_sym_STAR_STAR] = ACTIONS(3367),
    [anon_sym_PLUS_PLUS] = ACTIONS(3367),
    [anon_sym_BANG] = ACTIONS(3369),
    [anon_sym_LBRACK] = ACTIONS(3367),
    [anon_sym_LT_LT] = ACTIONS(3367),
    [anon_sym_LBRACE] = ACTIONS(3369),
    [anon_sym_AMP_AMP] = ACTIONS(3367),
    [anon_sym_of] = ACTIONS(3367),
    [anon_sym_LT_EQ] = ACTIONS(3367),
    [anon_sym_LPAREN] = ACTIONS(3367),
    [anon_sym_RBRACK] = ACTIONS(3367),
    [anon_sym_GT] = ACTIONS(3369),
    [anon_sym_AMP] = ACTIONS(3369),
    [anon_sym_QMARK] = ACTIONS(3367),
    [anon_sym_PIPE_PIPE] = ACTIONS(3367),
    [anon_sym_EQ_EQ] = ACTIONS(3369),
    [anon_sym_RPAREN] = ACTIONS(3367),
    [anon_sym_LT] = ACTIONS(3369),
    [anon_sym_SLASH] = ACTIONS(3369),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3367),
    [anon_sym_PLUS] = ACTIONS(3369),
    [anon_sym_implements] = ACTIONS(3367),
    [anon_sym_GT_GT] = ACTIONS(3369),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3367),
    [anon_sym_in] = ACTIONS(3369),
  },
  [1446] = {
    [anon_sym_COLON] = ACTIONS(3409),
    [anon_sym_RBRACE] = ACTIONS(3409),
    [sym__automatic_semicolon] = ACTIONS(3409),
    [anon_sym_SEMI] = ACTIONS(3409),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3409),
    [anon_sym_COMMA] = ACTIONS(3409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3409),
  },
  [1447] = {
    [sym__automatic_semicolon] = ACTIONS(3431),
    [anon_sym_RBRACE] = ACTIONS(3431),
    [anon_sym_SEMI] = ACTIONS(3431),
    [anon_sym_COMMA] = ACTIONS(3431),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3431),
    [sym_comment] = ACTIONS(3),
  },
  [1448] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3433),
    [sym__automatic_semicolon] = ACTIONS(3433),
    [anon_sym_BQUOTE] = ACTIONS(3433),
    [anon_sym_PIPE] = ACTIONS(3435),
    [anon_sym_COMMA] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3435),
    [anon_sym_GT_GT_GT] = ACTIONS(3433),
    [anon_sym_BANG_EQ] = ACTIONS(3435),
    [anon_sym_GT_EQ] = ACTIONS(3433),
    [anon_sym_RBRACE] = ACTIONS(3433),
    [anon_sym_PERCENT] = ACTIONS(3433),
    [anon_sym_as] = ACTIONS(3433),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [anon_sym_instanceof] = ACTIONS(3433),
    [anon_sym_DOT] = ACTIONS(3433),
    [anon_sym_STAR_STAR] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_else] = ACTIONS(3433),
    [anon_sym_BANG] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym_LT_LT] = ACTIONS(3433),
    [anon_sym_AMP_AMP] = ACTIONS(3433),
    [anon_sym_LT_EQ] = ACTIONS(3433),
    [anon_sym_LPAREN] = ACTIONS(3433),
    [anon_sym_GT] = ACTIONS(3435),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_QMARK] = ACTIONS(3433),
    [anon_sym_PIPE_PIPE] = ACTIONS(3433),
    [anon_sym_while] = ACTIONS(3433),
    [anon_sym_EQ_EQ] = ACTIONS(3435),
    [anon_sym_RPAREN] = ACTIONS(3433),
    [anon_sym_LT] = ACTIONS(3435),
    [anon_sym_SLASH] = ACTIONS(3435),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3433),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_GT_GT] = ACTIONS(3435),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3433),
    [anon_sym_in] = ACTIONS(3435),
  },
  [1449] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3439),
    [sym__automatic_semicolon] = ACTIONS(3439),
    [anon_sym_BQUOTE] = ACTIONS(3439),
    [anon_sym_PIPE] = ACTIONS(3441),
    [anon_sym_COMMA] = ACTIONS(3439),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_GT_GT_GT] = ACTIONS(3439),
    [anon_sym_BANG_EQ] = ACTIONS(3441),
    [anon_sym_GT_EQ] = ACTIONS(3439),
    [anon_sym_RBRACE] = ACTIONS(3439),
    [anon_sym_PERCENT] = ACTIONS(3439),
    [anon_sym_as] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [anon_sym_instanceof] = ACTIONS(3439),
    [anon_sym_DOT] = ACTIONS(3439),
    [anon_sym_STAR_STAR] = ACTIONS(3439),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_LT_LT] = ACTIONS(3439),
    [anon_sym_AMP_AMP] = ACTIONS(3439),
    [anon_sym_LT_EQ] = ACTIONS(3439),
    [anon_sym_LPAREN] = ACTIONS(3439),
    [anon_sym_GT] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_QMARK] = ACTIONS(3439),
    [anon_sym_PIPE_PIPE] = ACTIONS(3439),
    [anon_sym_EQ_EQ] = ACTIONS(3441),
    [anon_sym_RPAREN] = ACTIONS(3439),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_SLASH] = ACTIONS(3441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_GT_GT] = ACTIONS(3441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3439),
    [anon_sym_in] = ACTIONS(3441),
  },
  [1450] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3445),
    [sym__automatic_semicolon] = ACTIONS(3445),
    [anon_sym_BQUOTE] = ACTIONS(3445),
    [anon_sym_PIPE] = ACTIONS(3447),
    [anon_sym_COMMA] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3447),
    [anon_sym_STAR] = ACTIONS(3447),
    [anon_sym_GT_GT_GT] = ACTIONS(3445),
    [anon_sym_BANG_EQ] = ACTIONS(3447),
    [anon_sym_GT_EQ] = ACTIONS(3445),
    [anon_sym_RBRACE] = ACTIONS(3445),
    [anon_sym_PERCENT] = ACTIONS(3445),
    [anon_sym_as] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_instanceof] = ACTIONS(3445),
    [anon_sym_DOT] = ACTIONS(3445),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3445),
    [anon_sym_STAR_STAR] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym_LT_LT] = ACTIONS(3445),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_LT_EQ] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3445),
    [anon_sym_GT] = ACTIONS(3447),
    [anon_sym_AMP] = ACTIONS(3447),
    [anon_sym_QMARK] = ACTIONS(3445),
    [anon_sym_PIPE_PIPE] = ACTIONS(3445),
    [anon_sym_EQ_EQ] = ACTIONS(3447),
    [anon_sym_RPAREN] = ACTIONS(3445),
    [anon_sym_LT] = ACTIONS(3447),
    [anon_sym_SLASH] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3445),
    [anon_sym_PLUS] = ACTIONS(3447),
    [anon_sym_GT_GT] = ACTIONS(3447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3445),
    [anon_sym_in] = ACTIONS(3447),
  },
  [1451] = {
    [sym_string] = STATE(1080),
    [sym__property_name] = STATE(1080),
    [sym_computed_property_name] = STATE(1080),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1452] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3476),
    [sym__automatic_semicolon] = ACTIONS(3476),
    [anon_sym_BQUOTE] = ACTIONS(3476),
    [anon_sym_PIPE] = ACTIONS(3478),
    [anon_sym_COMMA] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3478),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_GT_GT_GT] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3478),
    [anon_sym_GT_EQ] = ACTIONS(3476),
    [anon_sym_RBRACE] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_as] = ACTIONS(3476),
    [anon_sym_DASH_DASH] = ACTIONS(3476),
    [anon_sym_instanceof] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_PLUS_PLUS] = ACTIONS(3476),
    [anon_sym_BANG] = ACTIONS(3478),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_SEMI] = ACTIONS(3476),
    [anon_sym_LT_LT] = ACTIONS(3476),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_LT_EQ] = ACTIONS(3476),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_GT] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_EQ_EQ] = ACTIONS(3478),
    [anon_sym_RPAREN] = ACTIONS(3476),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_SLASH] = ACTIONS(3478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3478),
    [anon_sym_GT_GT] = ACTIONS(3478),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3476),
    [anon_sym_in] = ACTIONS(3478),
  },
  [1453] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3480),
    [sym__automatic_semicolon] = ACTIONS(3480),
    [anon_sym_BQUOTE] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3482),
    [anon_sym_STAR] = ACTIONS(3482),
    [anon_sym_GT_GT_GT] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3482),
    [anon_sym_GT_EQ] = ACTIONS(3480),
    [anon_sym_RBRACE] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_as] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3480),
    [anon_sym_instanceof] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3480),
    [anon_sym_PLUS_PLUS] = ACTIONS(3480),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_SEMI] = ACTIONS(3480),
    [anon_sym_LT_LT] = ACTIONS(3480),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_LT_EQ] = ACTIONS(3480),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_GT] = ACTIONS(3482),
    [anon_sym_AMP] = ACTIONS(4091),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_RPAREN] = ACTIONS(3480),
    [anon_sym_LT] = ACTIONS(3482),
    [anon_sym_SLASH] = ACTIONS(3482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3482),
    [anon_sym_GT_GT] = ACTIONS(3482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3480),
    [anon_sym_in] = ACTIONS(3482),
  },
  [1454] = {
    [sym__type] = STATE(1473),
    [sym_constructor_type] = STATE(1473),
    [sym_index_type_query] = STATE(1259),
    [sym_lookup_type] = STATE(1259),
    [sym_this_type] = STATE(1259),
    [sym_flow_maybe_type] = STATE(1259),
    [sym_function_type] = STATE(1473),
    [sym_nested_identifier] = STATE(2241),
    [sym__primary_type] = STATE(1259),
    [sym_generic_type] = STATE(1259),
    [sym_mapped_type] = STATE(1259),
    [sym_literal_type] = STATE(1259),
    [sym_parenthesized_type] = STATE(1259),
    [sym_predefined_type] = STATE(1259),
    [sym_type_parameters] = STATE(2240),
    [sym_string] = STATE(1251),
    [sym_array_type] = STATE(1259),
    [sym_tuple_type] = STATE(1259),
    [sym_nested_type_identifier] = STATE(1258),
    [sym_type_predicate] = STATE(1259),
    [sym_type_query] = STATE(1259),
    [sym__number] = STATE(1251),
    [sym_existential_type] = STATE(1259),
    [sym_object_type] = STATE(1259),
    [sym_union_type] = STATE(1473),
    [sym_intersection_type] = STATE(1473),
    [sym_formal_parameters] = STATE(1796),
    [sym_identifier] = ACTIONS(1600),
    [sym_false] = ACTIONS(1602),
    [anon_sym_LBRACK] = ACTIONS(1604),
    [anon_sym_symbol] = ACTIONS(1606),
    [anon_sym_number] = ACTIONS(1606),
    [anon_sym_typeof] = ACTIONS(1608),
    [anon_sym_keyof] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1614),
    [anon_sym_LBRACE] = ACTIONS(1616),
    [anon_sym_PIPE] = ACTIONS(1618),
    [anon_sym_void] = ACTIONS(1606),
    [anon_sym_LPAREN] = ACTIONS(1620),
    [anon_sym_any] = ACTIONS(1606),
    [anon_sym_boolean] = ACTIONS(1606),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [anon_sym_AMP] = ACTIONS(1624),
    [anon_sym_QMARK] = ACTIONS(1626),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_this] = ACTIONS(1628),
    [sym_number] = ACTIONS(1630),
    [sym_true] = ACTIONS(1602),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1606),
    [anon_sym_new] = ACTIONS(1632),
    [anon_sym_PLUS] = ACTIONS(1612),
    [anon_sym_DQUOTE] = ACTIONS(57),
  },
  [1455] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3523),
    [sym__automatic_semicolon] = ACTIONS(3523),
    [anon_sym_BQUOTE] = ACTIONS(3523),
    [anon_sym_PIPE] = ACTIONS(3525),
    [anon_sym_COMMA] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3525),
    [anon_sym_GT_GT_GT] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3525),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_RBRACE] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_as] = ACTIONS(3523),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_instanceof] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_STAR_STAR] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_BANG] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3523),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_GT] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_EQ_EQ] = ACTIONS(3525),
    [anon_sym_RPAREN] = ACTIONS(3523),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_SLASH] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3523),
    [anon_sym_in] = ACTIONS(3525),
  },
  [1456] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3527),
    [sym__automatic_semicolon] = ACTIONS(3527),
    [anon_sym_BQUOTE] = ACTIONS(3527),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_GT_GT_GT] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3529),
    [anon_sym_GT_EQ] = ACTIONS(3527),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_as] = ACTIONS(3527),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_instanceof] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_STAR_STAR] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3527),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_EQ] = ACTIONS(3527),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(4091),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_EQ_EQ] = ACTIONS(3529),
    [anon_sym_RPAREN] = ACTIONS(3527),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_SLASH] = ACTIONS(3529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3527),
    [anon_sym_in] = ACTIONS(3529),
  },
  [1457] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [sym__automatic_semicolon] = ACTIONS(3531),
    [anon_sym_BQUOTE] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_as] = ACTIONS(3531),
    [anon_sym_DASH_DASH] = ACTIONS(3531),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_STAR_STAR] = ACTIONS(3531),
    [anon_sym_PLUS_PLUS] = ACTIONS(3531),
    [anon_sym_BANG] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_SEMI] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_EQ_EQ] = ACTIONS(3533),
    [anon_sym_RPAREN] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_SLASH] = ACTIONS(3533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_GT_GT] = ACTIONS(3533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3533),
  },
  [1458] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3539),
    [sym__automatic_semicolon] = ACTIONS(3539),
    [anon_sym_BQUOTE] = ACTIONS(3539),
    [anon_sym_PIPE] = ACTIONS(3541),
    [anon_sym_COMMA] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3541),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_GT_GT_GT] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3541),
    [anon_sym_GT_EQ] = ACTIONS(3539),
    [anon_sym_RBRACE] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_as] = ACTIONS(3539),
    [anon_sym_DASH_DASH] = ACTIONS(3539),
    [anon_sym_instanceof] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_STAR_STAR] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(3539),
    [anon_sym_else] = ACTIONS(3539),
    [anon_sym_BANG] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_SEMI] = ACTIONS(3539),
    [anon_sym_LT_LT] = ACTIONS(3539),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_LT_EQ] = ACTIONS(3539),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_GT] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_EQ_EQ] = ACTIONS(3541),
    [anon_sym_RPAREN] = ACTIONS(3539),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_SLASH] = ACTIONS(3541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3541),
    [anon_sym_GT_GT] = ACTIONS(3541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3539),
    [anon_sym_in] = ACTIONS(3541),
  },
  [1459] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2588),
    [anon_sym_BQUOTE] = ACTIONS(2588),
    [anon_sym_PIPE] = ACTIONS(2590),
    [anon_sym_COMMA] = ACTIONS(2588),
    [anon_sym_DASH] = ACTIONS(2590),
    [anon_sym_STAR] = ACTIONS(2590),
    [anon_sym_GT_GT_GT] = ACTIONS(2588),
    [anon_sym_BANG_EQ] = ACTIONS(2590),
    [anon_sym_GT_EQ] = ACTIONS(2588),
    [anon_sym_RBRACE] = ACTIONS(2588),
    [anon_sym_PERCENT] = ACTIONS(2588),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2588),
    [anon_sym_as] = ACTIONS(2588),
    [anon_sym_DASH_DASH] = ACTIONS(2588),
    [anon_sym_instanceof] = ACTIONS(2588),
    [anon_sym_COLON] = ACTIONS(2588),
    [anon_sym_DOT] = ACTIONS(2588),
    [anon_sym_STAR_STAR] = ACTIONS(2588),
    [anon_sym_PLUS_PLUS] = ACTIONS(2588),
    [anon_sym_BANG] = ACTIONS(2590),
    [anon_sym_LBRACK] = ACTIONS(2588),
    [anon_sym_LT_LT] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2590),
    [anon_sym_AMP_AMP] = ACTIONS(2588),
    [anon_sym_LT_EQ] = ACTIONS(2588),
    [anon_sym_LPAREN] = ACTIONS(2588),
    [anon_sym_RBRACK] = ACTIONS(2588),
    [anon_sym_GT] = ACTIONS(2590),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_QMARK] = ACTIONS(2588),
    [anon_sym_PIPE_PIPE] = ACTIONS(2588),
    [anon_sym_EQ_EQ] = ACTIONS(2590),
    [anon_sym_RPAREN] = ACTIONS(2588),
    [anon_sym_LT] = ACTIONS(2590),
    [anon_sym_SLASH] = ACTIONS(2590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2588),
    [anon_sym_PLUS] = ACTIONS(2590),
    [anon_sym_implements] = ACTIONS(2588),
    [anon_sym_GT_GT] = ACTIONS(2590),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2588),
    [anon_sym_in] = ACTIONS(2590),
  },
  [1460] = {
    [sym__automatic_semicolon] = ACTIONS(3563),
    [anon_sym_RBRACE] = ACTIONS(3563),
    [anon_sym_SEMI] = ACTIONS(3563),
    [anon_sym_COMMA] = ACTIONS(3563),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3563),
    [sym_comment] = ACTIONS(3),
  },
  [1461] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(3569),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACE] = ACTIONS(3569),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(3569),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(3569),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_RPAREN] = ACTIONS(3569),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_in] = ACTIONS(847),
  },
  [1462] = {
    [sym_type_annotation] = STATE(562),
    [anon_sym_EQ_GT] = ACTIONS(4107),
    [anon_sym_COLON] = ACTIONS(568),
    [sym_comment] = ACTIONS(3),
  },
  [1463] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3576),
    [sym__automatic_semicolon] = ACTIONS(3576),
    [anon_sym_BQUOTE] = ACTIONS(3576),
    [anon_sym_PIPE] = ACTIONS(3578),
    [anon_sym_COMMA] = ACTIONS(3576),
    [anon_sym_DASH] = ACTIONS(3578),
    [anon_sym_STAR] = ACTIONS(3578),
    [anon_sym_GT_GT_GT] = ACTIONS(3576),
    [anon_sym_BANG_EQ] = ACTIONS(3578),
    [anon_sym_GT_EQ] = ACTIONS(3576),
    [anon_sym_RBRACE] = ACTIONS(3576),
    [anon_sym_PERCENT] = ACTIONS(3576),
    [anon_sym_as] = ACTIONS(3576),
    [anon_sym_DASH_DASH] = ACTIONS(3576),
    [anon_sym_instanceof] = ACTIONS(3576),
    [anon_sym_DOT] = ACTIONS(3576),
    [anon_sym_STAR_STAR] = ACTIONS(3576),
    [anon_sym_PLUS_PLUS] = ACTIONS(3576),
    [anon_sym_else] = ACTIONS(3576),
    [anon_sym_BANG] = ACTIONS(3578),
    [anon_sym_LBRACK] = ACTIONS(3576),
    [anon_sym_SEMI] = ACTIONS(3576),
    [anon_sym_LT_LT] = ACTIONS(3576),
    [anon_sym_AMP_AMP] = ACTIONS(3576),
    [anon_sym_LT_EQ] = ACTIONS(3576),
    [anon_sym_LPAREN] = ACTIONS(3576),
    [anon_sym_GT] = ACTIONS(3578),
    [anon_sym_AMP] = ACTIONS(3578),
    [anon_sym_QMARK] = ACTIONS(3576),
    [anon_sym_PIPE_PIPE] = ACTIONS(3576),
    [anon_sym_while] = ACTIONS(3576),
    [anon_sym_EQ_EQ] = ACTIONS(3578),
    [anon_sym_RPAREN] = ACTIONS(3576),
    [anon_sym_LT] = ACTIONS(3578),
    [anon_sym_SLASH] = ACTIONS(3578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3576),
    [anon_sym_PLUS] = ACTIONS(3578),
    [anon_sym_GT_GT] = ACTIONS(3578),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3576),
    [anon_sym_in] = ACTIONS(3578),
  },
  [1464] = {
    [sym__automatic_semicolon] = ACTIONS(3582),
    [anon_sym_RBRACE] = ACTIONS(3582),
    [anon_sym_SEMI] = ACTIONS(3582),
    [anon_sym_COMMA] = ACTIONS(3582),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3582),
    [sym_comment] = ACTIONS(3),
  },
  [1465] = {
    [sym__automatic_semicolon] = ACTIONS(3593),
    [anon_sym_RBRACE] = ACTIONS(3593),
    [anon_sym_SEMI] = ACTIONS(3593),
    [anon_sym_COMMA] = ACTIONS(3593),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3593),
    [sym_comment] = ACTIONS(3),
  },
  [1466] = {
    [sym__automatic_semicolon] = ACTIONS(3597),
    [anon_sym_RBRACE] = ACTIONS(3597),
    [anon_sym_SEMI] = ACTIONS(3597),
    [anon_sym_COMMA] = ACTIONS(3597),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3597),
    [sym_comment] = ACTIONS(3),
  },
  [1467] = {
    [sym_string] = STATE(1121),
    [sym__property_name] = STATE(1121),
    [sym_computed_property_name] = STATE(1121),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_EQ] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3643),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_BANG] = ACTIONS(986),
  },
  [1468] = {
    [anon_sym_else] = ACTIONS(3661),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_while] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
  },
  [1469] = {
    [sym__automatic_semicolon] = ACTIONS(3667),
    [anon_sym_LBRACK] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(4110),
    [anon_sym_SEMI] = ACTIONS(3667),
    [anon_sym_module] = ACTIONS(4110),
    [anon_sym_symbol] = ACTIONS(4110),
    [anon_sym_number] = ACTIONS(4110),
    [anon_sym_AT] = ACTIONS(3667),
    [anon_sym_declare] = ACTIONS(4110),
    [anon_sym_STAR] = ACTIONS(3667),
    [anon_sym_void] = ACTIONS(4110),
    [anon_sym_any] = ACTIONS(4110),
    [anon_sym_private] = ACTIONS(4110),
    [anon_sym_boolean] = ACTIONS(4110),
    [anon_sym_async] = ACTIONS(4110),
    [anon_sym_public] = ACTIONS(4110),
    [anon_sym_get] = ACTIONS(4110),
    [anon_sym_RBRACE] = ACTIONS(3667),
    [anon_sym_static] = ACTIONS(4110),
    [anon_sym_SQUOTE] = ACTIONS(3667),
    [sym_number] = ACTIONS(3667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4110),
    [anon_sym_string] = ACTIONS(4110),
    [anon_sym_abstract] = ACTIONS(4110),
    [anon_sym_set] = ACTIONS(4110),
    [anon_sym_type] = ACTIONS(4110),
    [anon_sym_import] = ACTIONS(4110),
    [anon_sym_export] = ACTIONS(4110),
    [anon_sym_namespace] = ACTIONS(4110),
    [sym_readonly] = ACTIONS(4110),
    [anon_sym_DQUOTE] = ACTIONS(3667),
  },
  [1470] = {
    [anon_sym_COLON] = ACTIONS(3703),
    [anon_sym_RBRACE] = ACTIONS(3703),
    [sym__automatic_semicolon] = ACTIONS(3703),
    [anon_sym_SEMI] = ACTIONS(3703),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3703),
    [anon_sym_COMMA] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3703),
  },
  [1471] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3705),
    [sym__automatic_semicolon] = ACTIONS(3705),
    [anon_sym_BQUOTE] = ACTIONS(3705),
    [anon_sym_PIPE] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3707),
    [anon_sym_GT_GT_GT] = ACTIONS(3705),
    [anon_sym_BANG_EQ] = ACTIONS(3707),
    [anon_sym_GT_EQ] = ACTIONS(3705),
    [anon_sym_RBRACE] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_as] = ACTIONS(3705),
    [anon_sym_DASH_DASH] = ACTIONS(3705),
    [anon_sym_instanceof] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3705),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3705),
    [anon_sym_STAR_STAR] = ACTIONS(3705),
    [anon_sym_PLUS_PLUS] = ACTIONS(3705),
    [anon_sym_BANG] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym_LT_LT] = ACTIONS(3705),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_LT_EQ] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_GT] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3707),
    [anon_sym_QMARK] = ACTIONS(3705),
    [anon_sym_PIPE_PIPE] = ACTIONS(3705),
    [anon_sym_EQ_EQ] = ACTIONS(3707),
    [anon_sym_RPAREN] = ACTIONS(3705),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_SLASH] = ACTIONS(3707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3707),
    [anon_sym_GT_GT] = ACTIONS(3707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3705),
    [anon_sym_in] = ACTIONS(3707),
  },
  [1472] = {
    [sym_string] = STATE(1143),
    [sym__property_name] = STATE(1143),
    [sym_computed_property_name] = STATE(1143),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(3713),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1473] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3725),
    [sym__automatic_semicolon] = ACTIONS(3725),
    [anon_sym_BQUOTE] = ACTIONS(3725),
    [anon_sym_PIPE] = ACTIONS(4089),
    [anon_sym_COMMA] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_STAR] = ACTIONS(3727),
    [anon_sym_GT_GT_GT] = ACTIONS(3725),
    [anon_sym_BANG_EQ] = ACTIONS(3727),
    [anon_sym_GT_EQ] = ACTIONS(3725),
    [anon_sym_RBRACE] = ACTIONS(3725),
    [anon_sym_PERCENT] = ACTIONS(3725),
    [anon_sym_as] = ACTIONS(3725),
    [anon_sym_DASH_DASH] = ACTIONS(3725),
    [anon_sym_instanceof] = ACTIONS(3725),
    [anon_sym_DOT] = ACTIONS(3725),
    [anon_sym_STAR_STAR] = ACTIONS(3725),
    [anon_sym_PLUS_PLUS] = ACTIONS(3725),
    [anon_sym_BANG] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3725),
    [anon_sym_SEMI] = ACTIONS(3725),
    [anon_sym_LT_LT] = ACTIONS(3725),
    [anon_sym_AMP_AMP] = ACTIONS(3725),
    [anon_sym_LT_EQ] = ACTIONS(3725),
    [anon_sym_LPAREN] = ACTIONS(3725),
    [anon_sym_GT] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(4091),
    [anon_sym_QMARK] = ACTIONS(3725),
    [anon_sym_PIPE_PIPE] = ACTIONS(3725),
    [anon_sym_EQ_EQ] = ACTIONS(3727),
    [anon_sym_RPAREN] = ACTIONS(3725),
    [anon_sym_LT] = ACTIONS(3727),
    [anon_sym_SLASH] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3725),
    [anon_sym_PLUS] = ACTIONS(3727),
    [anon_sym_GT_GT] = ACTIONS(3727),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3725),
    [anon_sym_in] = ACTIONS(3727),
  },
  [1474] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_RBRACE] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1695),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_COLON] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_RBRACK] = ACTIONS(1695),
    [anon_sym_GT] = ACTIONS(3741),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(3741),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_implements] = ACTIONS(1695),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1697),
  },
  [1475] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3744),
    [sym__automatic_semicolon] = ACTIONS(3744),
    [anon_sym_BQUOTE] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_STAR] = ACTIONS(3746),
    [anon_sym_GT_GT_GT] = ACTIONS(3744),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_PERCENT] = ACTIONS(3744),
    [anon_sym_as] = ACTIONS(3744),
    [anon_sym_DASH_DASH] = ACTIONS(3744),
    [anon_sym_instanceof] = ACTIONS(3744),
    [anon_sym_DOT] = ACTIONS(3744),
    [anon_sym_STAR_STAR] = ACTIONS(3744),
    [anon_sym_PLUS_PLUS] = ACTIONS(3744),
    [anon_sym_else] = ACTIONS(3744),
    [anon_sym_BANG] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_LT_LT] = ACTIONS(3744),
    [anon_sym_AMP_AMP] = ACTIONS(3744),
    [anon_sym_LT_EQ] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(3744),
    [anon_sym_GT] = ACTIONS(3746),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3744),
    [anon_sym_PIPE_PIPE] = ACTIONS(3744),
    [anon_sym_while] = ACTIONS(3744),
    [anon_sym_EQ_EQ] = ACTIONS(3746),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3746),
    [anon_sym_SLASH] = ACTIONS(3746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3744),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_GT_GT] = ACTIONS(3746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3744),
    [anon_sym_in] = ACTIONS(3746),
  },
  [1476] = {
    [sym__automatic_semicolon] = ACTIONS(3750),
    [anon_sym_RBRACE] = ACTIONS(3750),
    [anon_sym_SEMI] = ACTIONS(3750),
    [anon_sym_COMMA] = ACTIONS(3750),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3750),
    [sym_comment] = ACTIONS(3),
  },
  [1477] = {
    [sym__automatic_semicolon] = ACTIONS(3798),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [sym_identifier] = ACTIONS(4112),
    [anon_sym_SEMI] = ACTIONS(3798),
    [anon_sym_module] = ACTIONS(4112),
    [anon_sym_symbol] = ACTIONS(4112),
    [anon_sym_number] = ACTIONS(4112),
    [anon_sym_AT] = ACTIONS(3798),
    [anon_sym_declare] = ACTIONS(4112),
    [anon_sym_STAR] = ACTIONS(3798),
    [anon_sym_void] = ACTIONS(4112),
    [anon_sym_any] = ACTIONS(4112),
    [anon_sym_private] = ACTIONS(4112),
    [anon_sym_boolean] = ACTIONS(4112),
    [anon_sym_async] = ACTIONS(4112),
    [anon_sym_public] = ACTIONS(4112),
    [anon_sym_get] = ACTIONS(4112),
    [anon_sym_RBRACE] = ACTIONS(3798),
    [anon_sym_static] = ACTIONS(4112),
    [anon_sym_SQUOTE] = ACTIONS(3798),
    [sym_number] = ACTIONS(3798),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4112),
    [anon_sym_string] = ACTIONS(4112),
    [anon_sym_abstract] = ACTIONS(4112),
    [anon_sym_set] = ACTIONS(4112),
    [anon_sym_type] = ACTIONS(4112),
    [anon_sym_import] = ACTIONS(4112),
    [anon_sym_export] = ACTIONS(4112),
    [anon_sym_namespace] = ACTIONS(4112),
    [sym_readonly] = ACTIONS(4112),
    [anon_sym_DQUOTE] = ACTIONS(3798),
  },
  [1478] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [sym__automatic_semicolon] = ACTIONS(3818),
    [anon_sym_BQUOTE] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3820),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3820),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3820),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_as] = ACTIONS(3818),
    [anon_sym_DASH_DASH] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_DOT] = ACTIONS(3818),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_PLUS_PLUS] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_GT] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3820),
    [anon_sym_RPAREN] = ACTIONS(3818),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_GT_GT] = ACTIONS(3820),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_in] = ACTIONS(3820),
  },
  [1479] = {
    [sym__automatic_semicolon] = ACTIONS(3866),
    [anon_sym_LBRACK] = ACTIONS(3866),
    [sym_identifier] = ACTIONS(4114),
    [anon_sym_SEMI] = ACTIONS(3866),
    [anon_sym_module] = ACTIONS(4114),
    [anon_sym_symbol] = ACTIONS(4114),
    [anon_sym_number] = ACTIONS(4114),
    [anon_sym_AT] = ACTIONS(3866),
    [anon_sym_declare] = ACTIONS(4114),
    [anon_sym_STAR] = ACTIONS(3866),
    [anon_sym_void] = ACTIONS(4114),
    [anon_sym_any] = ACTIONS(4114),
    [anon_sym_private] = ACTIONS(4114),
    [anon_sym_boolean] = ACTIONS(4114),
    [anon_sym_async] = ACTIONS(4114),
    [anon_sym_public] = ACTIONS(4114),
    [anon_sym_get] = ACTIONS(4114),
    [anon_sym_RBRACE] = ACTIONS(3866),
    [anon_sym_static] = ACTIONS(4114),
    [anon_sym_SQUOTE] = ACTIONS(3866),
    [sym_number] = ACTIONS(3866),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4114),
    [anon_sym_string] = ACTIONS(4114),
    [anon_sym_abstract] = ACTIONS(4114),
    [anon_sym_set] = ACTIONS(4114),
    [anon_sym_type] = ACTIONS(4114),
    [anon_sym_import] = ACTIONS(4114),
    [anon_sym_export] = ACTIONS(4114),
    [anon_sym_namespace] = ACTIONS(4114),
    [sym_readonly] = ACTIONS(4114),
    [anon_sym_DQUOTE] = ACTIONS(3866),
  },
  [1480] = {
    [sym__automatic_semicolon] = ACTIONS(3888),
    [anon_sym_LBRACK] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(4116),
    [anon_sym_SEMI] = ACTIONS(3888),
    [anon_sym_module] = ACTIONS(4116),
    [anon_sym_symbol] = ACTIONS(4116),
    [anon_sym_number] = ACTIONS(4116),
    [anon_sym_AT] = ACTIONS(3888),
    [anon_sym_declare] = ACTIONS(4116),
    [anon_sym_STAR] = ACTIONS(3888),
    [anon_sym_void] = ACTIONS(4116),
    [anon_sym_any] = ACTIONS(4116),
    [anon_sym_private] = ACTIONS(4116),
    [anon_sym_boolean] = ACTIONS(4116),
    [anon_sym_async] = ACTIONS(4116),
    [anon_sym_public] = ACTIONS(4116),
    [anon_sym_get] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(3888),
    [anon_sym_static] = ACTIONS(4116),
    [anon_sym_SQUOTE] = ACTIONS(3888),
    [sym_number] = ACTIONS(3888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4116),
    [anon_sym_string] = ACTIONS(4116),
    [anon_sym_abstract] = ACTIONS(4116),
    [anon_sym_set] = ACTIONS(4116),
    [anon_sym_type] = ACTIONS(4116),
    [anon_sym_import] = ACTIONS(4116),
    [anon_sym_export] = ACTIONS(4116),
    [anon_sym_namespace] = ACTIONS(4116),
    [sym_readonly] = ACTIONS(4116),
    [anon_sym_DQUOTE] = ACTIONS(3888),
  },
  [1481] = {
    [sym__automatic_semicolon] = ACTIONS(3892),
    [anon_sym_LBRACK] = ACTIONS(3892),
    [sym_identifier] = ACTIONS(4118),
    [anon_sym_SEMI] = ACTIONS(3892),
    [anon_sym_module] = ACTIONS(4118),
    [anon_sym_symbol] = ACTIONS(4118),
    [anon_sym_number] = ACTIONS(4118),
    [anon_sym_AT] = ACTIONS(3892),
    [anon_sym_declare] = ACTIONS(4118),
    [anon_sym_STAR] = ACTIONS(3892),
    [anon_sym_void] = ACTIONS(4118),
    [anon_sym_any] = ACTIONS(4118),
    [anon_sym_private] = ACTIONS(4118),
    [anon_sym_boolean] = ACTIONS(4118),
    [anon_sym_async] = ACTIONS(4118),
    [anon_sym_public] = ACTIONS(4118),
    [anon_sym_get] = ACTIONS(4118),
    [anon_sym_RBRACE] = ACTIONS(3892),
    [anon_sym_static] = ACTIONS(4118),
    [anon_sym_SQUOTE] = ACTIONS(3892),
    [sym_number] = ACTIONS(3892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4118),
    [anon_sym_string] = ACTIONS(4118),
    [anon_sym_abstract] = ACTIONS(4118),
    [anon_sym_set] = ACTIONS(4118),
    [anon_sym_type] = ACTIONS(4118),
    [anon_sym_import] = ACTIONS(4118),
    [anon_sym_export] = ACTIONS(4118),
    [anon_sym_namespace] = ACTIONS(4118),
    [sym_readonly] = ACTIONS(4118),
    [anon_sym_DQUOTE] = ACTIONS(3892),
  },
  [1482] = {
    [sym_statement_block] = STATE(1504),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(799),
    [sym__automatic_semicolon] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(799),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_GT_GT_GT] = ACTIONS(799),
    [anon_sym_BANG_EQ] = ACTIONS(801),
    [anon_sym_GT_EQ] = ACTIONS(799),
    [anon_sym_RBRACE] = ACTIONS(799),
    [anon_sym_PERCENT] = ACTIONS(799),
    [anon_sym_as] = ACTIONS(799),
    [anon_sym_DASH_DASH] = ACTIONS(799),
    [anon_sym_instanceof] = ACTIONS(799),
    [anon_sym_DOT] = ACTIONS(4053),
    [anon_sym_STAR_STAR] = ACTIONS(799),
    [anon_sym_PLUS_PLUS] = ACTIONS(799),
    [anon_sym_else] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(799),
    [anon_sym_SEMI] = ACTIONS(799),
    [anon_sym_LT_LT] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3190),
    [anon_sym_AMP_AMP] = ACTIONS(799),
    [anon_sym_LT_EQ] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(799),
    [anon_sym_GT] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_PIPE_PIPE] = ACTIONS(799),
    [anon_sym_while] = ACTIONS(799),
    [anon_sym_EQ_EQ] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(799),
    [anon_sym_LT] = ACTIONS(801),
    [anon_sym_SLASH] = ACTIONS(801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(801),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(799),
    [anon_sym_in] = ACTIONS(801),
  },
  [1483] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(807),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_COMMA] = ACTIONS(807),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_STAR] = ACTIONS(809),
    [anon_sym_GT_GT_GT] = ACTIONS(807),
    [anon_sym_BANG_EQ] = ACTIONS(809),
    [anon_sym_GT_EQ] = ACTIONS(807),
    [anon_sym_RBRACE] = ACTIONS(807),
    [anon_sym_PERCENT] = ACTIONS(807),
    [anon_sym_LBRACE_PIPE] = ACTIONS(807),
    [anon_sym_as] = ACTIONS(807),
    [anon_sym_DASH_DASH] = ACTIONS(807),
    [anon_sym_instanceof] = ACTIONS(807),
    [anon_sym_COLON] = ACTIONS(807),
    [anon_sym_DOT] = ACTIONS(807),
    [anon_sym_STAR_STAR] = ACTIONS(807),
    [anon_sym_PLUS_PLUS] = ACTIONS(807),
    [anon_sym_else] = ACTIONS(807),
    [anon_sym_BANG] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LT_LT] = ACTIONS(807),
    [anon_sym_LBRACE] = ACTIONS(809),
    [anon_sym_AMP_AMP] = ACTIONS(807),
    [anon_sym_LT_EQ] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(807),
    [anon_sym_RBRACK] = ACTIONS(807),
    [anon_sym_GT] = ACTIONS(809),
    [anon_sym_AMP] = ACTIONS(809),
    [anon_sym_QMARK] = ACTIONS(807),
    [anon_sym_PIPE_PIPE] = ACTIONS(807),
    [anon_sym_while] = ACTIONS(807),
    [anon_sym_EQ_EQ] = ACTIONS(809),
    [anon_sym_RPAREN] = ACTIONS(807),
    [anon_sym_LT] = ACTIONS(809),
    [anon_sym_SLASH] = ACTIONS(809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(807),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_implements] = ACTIONS(807),
    [anon_sym_GT_GT] = ACTIONS(809),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(807),
    [anon_sym_in] = ACTIONS(809),
  },
  [1484] = {
    [sym_statement_block] = STATE(1504),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(799),
    [sym__automatic_semicolon] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(799),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_GT_GT_GT] = ACTIONS(799),
    [anon_sym_BANG_EQ] = ACTIONS(801),
    [anon_sym_GT_EQ] = ACTIONS(799),
    [anon_sym_RBRACE] = ACTIONS(799),
    [anon_sym_PERCENT] = ACTIONS(799),
    [anon_sym_as] = ACTIONS(799),
    [anon_sym_DASH_DASH] = ACTIONS(799),
    [anon_sym_instanceof] = ACTIONS(799),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_STAR_STAR] = ACTIONS(799),
    [anon_sym_PLUS_PLUS] = ACTIONS(799),
    [anon_sym_else] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(799),
    [anon_sym_SEMI] = ACTIONS(799),
    [anon_sym_LT_LT] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(3190),
    [anon_sym_AMP_AMP] = ACTIONS(799),
    [anon_sym_LT_EQ] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(799),
    [anon_sym_GT] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_PIPE_PIPE] = ACTIONS(799),
    [anon_sym_while] = ACTIONS(799),
    [anon_sym_EQ_EQ] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(799),
    [anon_sym_LT] = ACTIONS(801),
    [anon_sym_SLASH] = ACTIONS(801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(801),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(799),
    [anon_sym_in] = ACTIONS(801),
  },
  [1485] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(813),
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(815),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_STAR] = ACTIONS(815),
    [anon_sym_GT_GT_GT] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_BANG_EQ] = ACTIONS(815),
    [anon_sym_GT_EQ] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_PERCENT] = ACTIONS(813),
    [anon_sym_LBRACE_PIPE] = ACTIONS(813),
    [anon_sym_as] = ACTIONS(813),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_instanceof] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(813),
    [anon_sym_DOT] = ACTIONS(813),
    [anon_sym_STAR_STAR] = ACTIONS(813),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_else] = ACTIONS(813),
    [anon_sym_BANG] = ACTIONS(815),
    [anon_sym_LBRACK] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(813),
    [anon_sym_LBRACE] = ACTIONS(815),
    [anon_sym_AMP_AMP] = ACTIONS(813),
    [anon_sym_LT_EQ] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(813),
    [anon_sym_RBRACK] = ACTIONS(813),
    [anon_sym_GT] = ACTIONS(815),
    [anon_sym_AMP] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_PIPE_PIPE] = ACTIONS(813),
    [anon_sym_while] = ACTIONS(813),
    [anon_sym_EQ_EQ] = ACTIONS(815),
    [anon_sym_RPAREN] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(815),
    [anon_sym_SLASH] = ACTIONS(815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_implements] = ACTIONS(813),
    [anon_sym_GT_GT] = ACTIONS(815),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(813),
    [anon_sym_in] = ACTIONS(815),
  },
  [1486] = {
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_of] = ACTIONS(839),
    [anon_sym_COLON] = ACTIONS(839),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(839),
  },
  [1487] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BQUOTE] = ACTIONS(1027),
    [anon_sym_PIPE] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1031),
    [anon_sym_GT_GT_GT] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1031),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_COLON] = ACTIONS(1027),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_RBRACK] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1031),
    [anon_sym_AMP] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_RPAREN] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1031),
    [anon_sym_SLASH] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_implements] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(1031),
  },
  [1488] = {
    [sym__automatic_semicolon] = ACTIONS(1216),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_AMP] = ACTIONS(1216),
    [anon_sym_SEMI] = ACTIONS(1216),
    [anon_sym_RBRACE] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_COMMA] = ACTIONS(1216),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1216),
    [anon_sym_EQ] = ACTIONS(1216),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1216),
  },
  [1489] = {
    [sym_index_type_query] = STATE(1517),
    [sym_lookup_type] = STATE(1517),
    [sym_this_type] = STATE(1517),
    [sym_flow_maybe_type] = STATE(1517),
    [sym_nested_identifier] = STATE(2393),
    [sym__primary_type] = STATE(1517),
    [sym_generic_type] = STATE(1517),
    [sym_mapped_type] = STATE(1517),
    [sym_literal_type] = STATE(1517),
    [sym_parenthesized_type] = STATE(1517),
    [sym_predefined_type] = STATE(1517),
    [sym_string] = STATE(1488),
    [sym_array_type] = STATE(1517),
    [sym_tuple_type] = STATE(1517),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_type_predicate] = STATE(1517),
    [sym_type_query] = STATE(1517),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1517),
    [sym_object_type] = STATE(1517),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(4120),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_this] = ACTIONS(1823),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1490] = {
    [sym__type] = STATE(1519),
    [sym_constructor_type] = STATE(1519),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_function_type] = STATE(1519),
    [sym_nested_identifier] = STATE(2393),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_array_type] = STATE(1496),
    [sym_tuple_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(1519),
    [sym_intersection_type] = STATE(1519),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_this] = ACTIONS(1823),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1491] = {
    [sym__automatic_semicolon] = ACTIONS(1244),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_AMP] = ACTIONS(1244),
    [anon_sym_SEMI] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_PIPE] = ACTIONS(1246),
    [anon_sym_COMMA] = ACTIONS(1244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1244),
    [anon_sym_EQ] = ACTIONS(1244),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1244),
  },
  [1492] = {
    [sym__automatic_semicolon] = ACTIONS(1248),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_AMP] = ACTIONS(1248),
    [anon_sym_SEMI] = ACTIONS(1248),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_PIPE] = ACTIONS(1250),
    [anon_sym_COMMA] = ACTIONS(1248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1248),
    [anon_sym_EQ] = ACTIONS(1248),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1248),
  },
  [1493] = {
    [sym__automatic_semicolon] = ACTIONS(1256),
    [anon_sym_LBRACK] = ACTIONS(1256),
    [anon_sym_AMP] = ACTIONS(1256),
    [anon_sym_SEMI] = ACTIONS(1256),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_PIPE] = ACTIONS(1258),
    [anon_sym_COMMA] = ACTIONS(1256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1256),
    [anon_sym_EQ] = ACTIONS(1256),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1256),
  },
  [1494] = {
    [sym__type] = STATE(1525),
    [sym_constructor_type] = STATE(1525),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_function_type] = STATE(1525),
    [sym_nested_identifier] = STATE(2393),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_array_type] = STATE(1496),
    [sym_tuple_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(1525),
    [sym_intersection_type] = STATE(1525),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_this] = ACTIONS(1823),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1495] = {
    [sym_type_arguments] = STATE(1530),
    [sym__automatic_semicolon] = ACTIONS(1280),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_AMP] = ACTIONS(1280),
    [anon_sym_SEMI] = ACTIONS(1280),
    [anon_sym_RBRACE] = ACTIONS(1280),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_COMMA] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(4125),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1280),
    [anon_sym_EQ] = ACTIONS(1280),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1280),
    [anon_sym_in] = ACTIONS(4127),
  },
  [1496] = {
    [sym__automatic_semicolon] = ACTIONS(1293),
    [anon_sym_AMP] = ACTIONS(1293),
    [anon_sym_LBRACK] = ACTIONS(4129),
    [anon_sym_SEMI] = ACTIONS(1293),
    [anon_sym_RBRACE] = ACTIONS(1293),
    [anon_sym_PIPE] = ACTIONS(1295),
    [anon_sym_COMMA] = ACTIONS(1293),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1293),
    [anon_sym_EQ] = ACTIONS(1293),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1293),
  },
  [1497] = {
    [sym_new_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(2350),
    [sym_update_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2350),
    [sym_yield_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_non_null_expression] = STATE(2350),
    [sym_internal_module] = STATE(2350),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2350),
    [sym_this] = STATE(2350),
    [sym_type_parameters] = STATE(55),
    [sym_arguments] = STATE(1355),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2350),
    [sym_ternary_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2350),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(1323),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [sym_false] = ACTIONS(1323),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(1315),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [sym_null] = ACTIONS(1323),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_EQ_GT] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_LT] = ACTIONS(1319),
    [sym_number] = ACTIONS(1335),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_implements] = ACTIONS(1319),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [1498] = {
    [sym__initializer] = STATE(589),
    [aux_sym_object_repeat1] = STATE(408),
    [sym__automatic_semicolon] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
  },
  [1499] = {
    [aux_sym_object_repeat1] = STATE(408),
    [sym__automatic_semicolon] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
  },
  [1500] = {
    [aux_sym_object_repeat1] = STATE(408),
    [sym__automatic_semicolon] = ACTIONS(986),
    [anon_sym_LBRACK] = ACTIONS(1014),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_symbol] = ACTIONS(1012),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_RBRACE] = ACTIONS(975),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_namespace] = ACTIONS(1012),
    [sym_readonly] = ACTIONS(1012),
    [anon_sym_DQUOTE] = ACTIONS(1014),
  },
  [1501] = {
    [anon_sym_EQ] = ACTIONS(1027),
    [anon_sym_of] = ACTIONS(1027),
    [anon_sym_COLON] = ACTIONS(1027),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(1027),
  },
  [1502] = {
    [sym_type_arguments] = STATE(1516),
    [sym__automatic_semicolon] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(4133),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_SEMI] = ACTIONS(1201),
    [anon_sym_RBRACE] = ACTIONS(1201),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_COMMA] = ACTIONS(1201),
    [anon_sym_LT] = ACTIONS(4125),
    [sym_comment] = ACTIONS(3),
    [anon_sym_is] = ACTIONS(4136),
    [anon_sym_EQ] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(4140),
  },
  [1503] = {
    [anon_sym_LBRACK] = ACTIONS(1753),
    [sym_identifier] = ACTIONS(1755),
    [anon_sym_module] = ACTIONS(1755),
    [anon_sym_symbol] = ACTIONS(1755),
    [anon_sym_number] = ACTIONS(1755),
    [anon_sym_AT] = ACTIONS(1753),
    [anon_sym_class] = ACTIONS(1755),
    [anon_sym_declare] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1753),
    [anon_sym_LBRACE] = ACTIONS(1753),
    [anon_sym_void] = ACTIONS(1755),
    [anon_sym_any] = ACTIONS(1755),
    [anon_sym_private] = ACTIONS(1755),
    [anon_sym_boolean] = ACTIONS(1755),
    [anon_sym_async] = ACTIONS(1755),
    [anon_sym_public] = ACTIONS(1755),
    [anon_sym_get] = ACTIONS(1755),
    [anon_sym_static] = ACTIONS(1755),
    [anon_sym_RBRACE] = ACTIONS(1753),
    [anon_sym_SQUOTE] = ACTIONS(1753),
    [anon_sym_this] = ACTIONS(1755),
    [sym_number] = ACTIONS(1753),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1755),
    [anon_sym_string] = ACTIONS(1755),
    [anon_sym_abstract] = ACTIONS(1755),
    [anon_sym_set] = ACTIONS(1755),
    [anon_sym_type] = ACTIONS(1755),
    [anon_sym_import] = ACTIONS(1755),
    [anon_sym_export] = ACTIONS(1755),
    [sym_readonly] = ACTIONS(1755),
    [anon_sym_namespace] = ACTIONS(1755),
    [anon_sym_DQUOTE] = ACTIONS(1753),
  },
  [1504] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1861),
    [sym__automatic_semicolon] = ACTIONS(1861),
    [anon_sym_BQUOTE] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_COMMA] = ACTIONS(1861),
    [anon_sym_DASH] = ACTIONS(1863),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_GT_GT_GT] = ACTIONS(1861),
    [anon_sym_BANG_EQ] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1861),
    [anon_sym_RBRACE] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [anon_sym_as] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_instanceof] = ACTIONS(1861),
    [anon_sym_DOT] = ACTIONS(1861),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_else] = ACTIONS(1861),
    [anon_sym_BANG] = ACTIONS(1863),
    [anon_sym_LBRACK] = ACTIONS(1861),
    [anon_sym_SEMI] = ACTIONS(1861),
    [anon_sym_LT_LT] = ACTIONS(1861),
    [anon_sym_AMP_AMP] = ACTIONS(1861),
    [anon_sym_LT_EQ] = ACTIONS(1861),
    [anon_sym_LPAREN] = ACTIONS(1861),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_AMP] = ACTIONS(1863),
    [anon_sym_QMARK] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE] = ACTIONS(1861),
    [anon_sym_while] = ACTIONS(1861),
    [anon_sym_EQ_EQ] = ACTIONS(1863),
    [anon_sym_RPAREN] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_SLASH] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_PLUS] = ACTIONS(1863),
    [anon_sym_GT_GT] = ACTIONS(1863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1861),
    [anon_sym_in] = ACTIONS(1863),
  },
  [1505] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1865),
    [anon_sym_BQUOTE] = ACTIONS(1865),
    [anon_sym_PIPE] = ACTIONS(1867),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_DASH] = ACTIONS(1867),
    [anon_sym_STAR] = ACTIONS(1867),
    [anon_sym_GT_GT_GT] = ACTIONS(1865),
    [anon_sym_EQ] = ACTIONS(1867),
    [anon_sym_BANG_EQ] = ACTIONS(1867),
    [anon_sym_GT_EQ] = ACTIONS(1865),
    [anon_sym_RBRACE] = ACTIONS(1865),
    [anon_sym_PERCENT] = ACTIONS(1865),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1865),
    [anon_sym_as] = ACTIONS(1865),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_instanceof] = ACTIONS(1865),
    [anon_sym_COLON] = ACTIONS(1865),
    [anon_sym_DOT] = ACTIONS(1865),
    [anon_sym_STAR_STAR] = ACTIONS(1865),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_else] = ACTIONS(1865),
    [anon_sym_BANG] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_LT_LT] = ACTIONS(1865),
    [anon_sym_LBRACE] = ACTIONS(1867),
    [anon_sym_AMP_AMP] = ACTIONS(1865),
    [anon_sym_LT_EQ] = ACTIONS(1865),
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_RBRACK] = ACTIONS(1865),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_AMP] = ACTIONS(1867),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_PIPE_PIPE] = ACTIONS(1865),
    [anon_sym_while] = ACTIONS(1865),
    [anon_sym_EQ_EQ] = ACTIONS(1867),
    [anon_sym_RPAREN] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_SLASH] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1865),
    [anon_sym_PLUS] = ACTIONS(1867),
    [anon_sym_implements] = ACTIONS(1865),
    [anon_sym_GT_GT] = ACTIONS(1867),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1865),
    [anon_sym_in] = ACTIONS(1867),
  },
  [1506] = {
    [anon_sym_EQ] = ACTIONS(1900),
    [anon_sym_of] = ACTIONS(1900),
    [anon_sym_COLON] = ACTIONS(1900),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(1900),
  },
  [1507] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1958),
    [anon_sym_BQUOTE] = ACTIONS(1958),
    [anon_sym_PIPE] = ACTIONS(1960),
    [anon_sym_COMMA] = ACTIONS(1958),
    [anon_sym_DASH] = ACTIONS(1960),
    [anon_sym_STAR] = ACTIONS(1960),
    [anon_sym_GT_GT_GT] = ACTIONS(1958),
    [anon_sym_BANG_EQ] = ACTIONS(1960),
    [anon_sym_GT_EQ] = ACTIONS(1958),
    [anon_sym_RBRACE] = ACTIONS(1958),
    [anon_sym_PERCENT] = ACTIONS(1958),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1958),
    [anon_sym_as] = ACTIONS(1958),
    [anon_sym_DASH_DASH] = ACTIONS(1958),
    [anon_sym_instanceof] = ACTIONS(1958),
    [anon_sym_COLON] = ACTIONS(1958),
    [anon_sym_DOT] = ACTIONS(1958),
    [anon_sym_STAR_STAR] = ACTIONS(1958),
    [anon_sym_PLUS_PLUS] = ACTIONS(1958),
    [anon_sym_else] = ACTIONS(1958),
    [anon_sym_BANG] = ACTIONS(1960),
    [anon_sym_LBRACK] = ACTIONS(1958),
    [anon_sym_LT_LT] = ACTIONS(1958),
    [anon_sym_LBRACE] = ACTIONS(1960),
    [anon_sym_AMP_AMP] = ACTIONS(1958),
    [anon_sym_LT_EQ] = ACTIONS(1958),
    [anon_sym_LPAREN] = ACTIONS(1958),
    [anon_sym_RBRACK] = ACTIONS(1958),
    [anon_sym_GT] = ACTIONS(1960),
    [anon_sym_AMP] = ACTIONS(1960),
    [anon_sym_QMARK] = ACTIONS(1958),
    [anon_sym_PIPE_PIPE] = ACTIONS(1958),
    [anon_sym_while] = ACTIONS(1958),
    [anon_sym_EQ_EQ] = ACTIONS(1960),
    [anon_sym_RPAREN] = ACTIONS(1958),
    [anon_sym_LT] = ACTIONS(1960),
    [anon_sym_SLASH] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1958),
    [anon_sym_PLUS] = ACTIONS(1960),
    [anon_sym_implements] = ACTIONS(1958),
    [anon_sym_GT_GT] = ACTIONS(1960),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1958),
    [anon_sym_in] = ACTIONS(1960),
  },
  [1508] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1992),
    [sym__automatic_semicolon] = ACTIONS(1992),
    [anon_sym_BQUOTE] = ACTIONS(1992),
    [anon_sym_symbol] = ACTIONS(1994),
    [anon_sym_PIPE] = ACTIONS(1994),
    [anon_sym_STAR] = ACTIONS(1994),
    [anon_sym_GT_GT_GT] = ACTIONS(1992),
    [anon_sym_break] = ACTIONS(1994),
    [anon_sym_BANG_EQ] = ACTIONS(1994),
    [anon_sym_return] = ACTIONS(1994),
    [anon_sym_RBRACE] = ACTIONS(1992),
    [anon_sym_PERCENT] = ACTIONS(1992),
    [anon_sym_interface] = ACTIONS(1994),
    [anon_sym_as] = ACTIONS(1994),
    [anon_sym_delete] = ACTIONS(1994),
    [anon_sym_if] = ACTIONS(1994),
    [anon_sym_instanceof] = ACTIONS(1994),
    [anon_sym_yield] = ACTIONS(1994),
    [sym_true] = ACTIONS(1994),
    [anon_sym_protected] = ACTIONS(1994),
    [anon_sym_DOT] = ACTIONS(1994),
    [anon_sym_set] = ACTIONS(1994),
    [anon_sym_import] = ACTIONS(1994),
    [anon_sym_await] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1992),
    [anon_sym_for] = ACTIONS(1994),
    [anon_sym_SEMI] = ACTIONS(1992),
    [anon_sym_number] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1994),
    [anon_sym_LT_LT] = ACTIONS(1992),
    [anon_sym_LBRACE] = ACTIONS(1992),
    [anon_sym_AMP_AMP] = ACTIONS(1992),
    [anon_sym_switch] = ACTIONS(1994),
    [anon_sym_LT_EQ] = ACTIONS(1992),
    [sym_null] = ACTIONS(1994),
    [anon_sym_any] = ACTIONS(1994),
    [anon_sym_async] = ACTIONS(1994),
    [anon_sym_public] = ACTIONS(1994),
    [anon_sym_var] = ACTIONS(1994),
    [anon_sym_QMARK] = ACTIONS(1992),
    [anon_sym_while] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1992),
    [anon_sym_SLASH] = ACTIONS(1994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1994),
    [anon_sym_new] = ACTIONS(1994),
    [anon_sym_CARET] = ACTIONS(1992),
    [anon_sym_export] = ACTIONS(1994),
    [anon_sym_GT_GT] = ACTIONS(1994),
    [anon_sym_with] = ACTIONS(1994),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1992),
    [sym_identifier] = ACTIONS(1994),
    [anon_sym_debugger] = ACTIONS(1994),
    [anon_sym_AT] = ACTIONS(1992),
    [anon_sym_COMMA] = ACTIONS(1992),
    [anon_sym_DASH] = ACTIONS(1994),
    [anon_sym_void] = ACTIONS(1994),
    [anon_sym_const] = ACTIONS(1994),
    [anon_sym_GT_EQ] = ACTIONS(1992),
    [sym_super] = ACTIONS(1994),
    [anon_sym_private] = ACTIONS(1994),
    [anon_sym_get] = ACTIONS(1994),
    [anon_sym_default] = ACTIONS(1994),
    [anon_sym_enum] = ACTIONS(1994),
    [anon_sym_continue] = ACTIONS(1994),
    [anon_sym_DASH_DASH] = ACTIONS(1992),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_throw] = ACTIONS(1994),
    [anon_sym_abstract] = ACTIONS(1994),
    [anon_sym_type] = ACTIONS(1994),
    [anon_sym_STAR_STAR] = ACTIONS(1992),
    [anon_sym_namespace] = ACTIONS(1994),
    [anon_sym_PLUS_PLUS] = ACTIONS(1992),
    [anon_sym_else] = ACTIONS(1994),
    [anon_sym_BANG] = ACTIONS(1994),
    [anon_sym_LBRACK] = ACTIONS(1992),
    [sym_false] = ACTIONS(1994),
    [anon_sym_case] = ACTIONS(1994),
    [anon_sym_module] = ACTIONS(1994),
    [anon_sym_class] = ACTIONS(1994),
    [anon_sym_declare] = ACTIONS(1994),
    [anon_sym_LPAREN] = ACTIONS(1992),
    [anon_sym_GT] = ACTIONS(1994),
    [anon_sym_boolean] = ACTIONS(1994),
    [anon_sym_AMP] = ACTIONS(1994),
    [anon_sym_PIPE_PIPE] = ACTIONS(1992),
    [anon_sym_try] = ACTIONS(1994),
    [anon_sym_EQ_EQ] = ACTIONS(1994),
    [anon_sym_LT] = ACTIONS(1994),
    [sym_number] = ACTIONS(1992),
    [ts_builtin_sym_end] = ACTIONS(1992),
    [anon_sym_function] = ACTIONS(1994),
    [sym_undefined] = ACTIONS(1994),
    [anon_sym_let] = ACTIONS(1994),
    [anon_sym_PLUS] = ACTIONS(1994),
    [anon_sym_do] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1992),
    [anon_sym_in] = ACTIONS(1994),
  },
  [1509] = {
    [anon_sym_EQ] = ACTIONS(2042),
    [anon_sym_of] = ACTIONS(2042),
    [anon_sym_COLON] = ACTIONS(2042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(2042),
  },
  [1510] = {
    [anon_sym_EQ] = ACTIONS(2075),
    [anon_sym_of] = ACTIONS(2075),
    [anon_sym_COLON] = ACTIONS(2075),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(2075),
  },
  [1511] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2081),
    [sym__automatic_semicolon] = ACTIONS(2081),
    [anon_sym_BQUOTE] = ACTIONS(2081),
    [anon_sym_symbol] = ACTIONS(2083),
    [anon_sym_PIPE] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2083),
    [anon_sym_GT_GT_GT] = ACTIONS(2081),
    [anon_sym_break] = ACTIONS(2083),
    [anon_sym_BANG_EQ] = ACTIONS(2083),
    [anon_sym_return] = ACTIONS(2083),
    [anon_sym_RBRACE] = ACTIONS(2081),
    [anon_sym_PERCENT] = ACTIONS(2081),
    [anon_sym_interface] = ACTIONS(2083),
    [anon_sym_as] = ACTIONS(2083),
    [anon_sym_delete] = ACTIONS(2083),
    [anon_sym_if] = ACTIONS(2083),
    [anon_sym_instanceof] = ACTIONS(2083),
    [anon_sym_yield] = ACTIONS(2083),
    [sym_true] = ACTIONS(2083),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_DOT] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_import] = ACTIONS(2083),
    [anon_sym_await] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(2081),
    [anon_sym_for] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2081),
    [anon_sym_number] = ACTIONS(2083),
    [anon_sym_typeof] = ACTIONS(2083),
    [anon_sym_LT_LT] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(2081),
    [anon_sym_AMP_AMP] = ACTIONS(2081),
    [anon_sym_switch] = ACTIONS(2083),
    [anon_sym_LT_EQ] = ACTIONS(2081),
    [sym_null] = ACTIONS(2083),
    [anon_sym_any] = ACTIONS(2083),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_var] = ACTIONS(2083),
    [anon_sym_QMARK] = ACTIONS(2081),
    [anon_sym_while] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2081),
    [anon_sym_SLASH] = ACTIONS(2083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_new] = ACTIONS(2083),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_GT_GT] = ACTIONS(2083),
    [anon_sym_with] = ACTIONS(2083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2081),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_debugger] = ACTIONS(2083),
    [anon_sym_AT] = ACTIONS(2081),
    [anon_sym_COMMA] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_void] = ACTIONS(2083),
    [anon_sym_const] = ACTIONS(2083),
    [anon_sym_GT_EQ] = ACTIONS(2081),
    [sym_super] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_default] = ACTIONS(2083),
    [anon_sym_enum] = ACTIONS(2083),
    [anon_sym_continue] = ACTIONS(2083),
    [anon_sym_DASH_DASH] = ACTIONS(2081),
    [anon_sym_this] = ACTIONS(2083),
    [anon_sym_throw] = ACTIONS(2083),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_STAR_STAR] = ACTIONS(2081),
    [anon_sym_namespace] = ACTIONS(2083),
    [anon_sym_PLUS_PLUS] = ACTIONS(2081),
    [anon_sym_else] = ACTIONS(2083),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [sym_false] = ACTIONS(2083),
    [anon_sym_case] = ACTIONS(2083),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_class] = ACTIONS(2083),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_LPAREN] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2083),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_try] = ACTIONS(2083),
    [anon_sym_EQ_EQ] = ACTIONS(2083),
    [anon_sym_LT] = ACTIONS(2083),
    [sym_number] = ACTIONS(2081),
    [ts_builtin_sym_end] = ACTIONS(2081),
    [anon_sym_function] = ACTIONS(2083),
    [sym_undefined] = ACTIONS(2083),
    [anon_sym_let] = ACTIONS(2083),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_do] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(2081),
    [anon_sym_in] = ACTIONS(2083),
  },
  [1512] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2148),
    [anon_sym_BQUOTE] = ACTIONS(2148),
    [anon_sym_PIPE] = ACTIONS(2150),
    [anon_sym_COMMA] = ACTIONS(2148),
    [anon_sym_DASH] = ACTIONS(2150),
    [anon_sym_STAR] = ACTIONS(2150),
    [anon_sym_GT_GT_GT] = ACTIONS(2148),
    [anon_sym_BANG_EQ] = ACTIONS(2150),
    [anon_sym_GT_EQ] = ACTIONS(2148),
    [anon_sym_RBRACE] = ACTIONS(2148),
    [anon_sym_PERCENT] = ACTIONS(2148),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2148),
    [anon_sym_as] = ACTIONS(2148),
    [anon_sym_DASH_DASH] = ACTIONS(2148),
    [anon_sym_instanceof] = ACTIONS(2148),
    [anon_sym_COLON] = ACTIONS(2148),
    [anon_sym_DOT] = ACTIONS(2148),
    [anon_sym_STAR_STAR] = ACTIONS(2148),
    [anon_sym_PLUS_PLUS] = ACTIONS(2148),
    [anon_sym_BANG] = ACTIONS(2150),
    [anon_sym_LBRACK] = ACTIONS(2148),
    [anon_sym_LT_LT] = ACTIONS(2148),
    [anon_sym_LBRACE] = ACTIONS(2150),
    [anon_sym_AMP_AMP] = ACTIONS(2148),
    [anon_sym_LT_EQ] = ACTIONS(2148),
    [anon_sym_LPAREN] = ACTIONS(2148),
    [anon_sym_RBRACK] = ACTIONS(2148),
    [anon_sym_GT] = ACTIONS(2150),
    [anon_sym_AMP] = ACTIONS(2150),
    [anon_sym_QMARK] = ACTIONS(2148),
    [anon_sym_PIPE_PIPE] = ACTIONS(2148),
    [anon_sym_EQ_EQ] = ACTIONS(2150),
    [anon_sym_RPAREN] = ACTIONS(2148),
    [anon_sym_LT] = ACTIONS(2150),
    [anon_sym_SLASH] = ACTIONS(2150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2148),
    [anon_sym_PLUS] = ACTIONS(2150),
    [anon_sym_implements] = ACTIONS(2148),
    [anon_sym_GT_GT] = ACTIONS(2150),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2148),
    [anon_sym_in] = ACTIONS(2150),
  },
  [1513] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1033),
    [sym__automatic_semicolon] = ACTIONS(1033),
    [anon_sym_BQUOTE] = ACTIONS(1033),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1029),
    [anon_sym_GT_GT_GT] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(1029),
    [anon_sym_GT_EQ] = ACTIONS(1033),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_PERCENT] = ACTIONS(1033),
    [anon_sym_as] = ACTIONS(1033),
    [anon_sym_DASH_DASH] = ACTIONS(1033),
    [anon_sym_instanceof] = ACTIONS(1033),
    [anon_sym_DOT] = ACTIONS(1033),
    [anon_sym_STAR_STAR] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_else] = ACTIONS(1033),
    [anon_sym_BANG] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_SEMI] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1033),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_LT_EQ] = ACTIONS(1033),
    [anon_sym_LPAREN] = ACTIONS(1033),
    [anon_sym_GT] = ACTIONS(1029),
    [anon_sym_AMP] = ACTIONS(1029),
    [anon_sym_QMARK] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_while] = ACTIONS(1033),
    [anon_sym_EQ_EQ] = ACTIONS(1029),
    [anon_sym_RPAREN] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1029),
    [anon_sym_SLASH] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1033),
    [anon_sym_PLUS] = ACTIONS(1029),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1033),
    [anon_sym_in] = ACTIONS(1029),
  },
  [1514] = {
    [sym__type] = STATE(1550),
    [sym_constructor_type] = STATE(1550),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_function_type] = STATE(1550),
    [sym_nested_identifier] = STATE(2393),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_array_type] = STATE(1496),
    [sym_tuple_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(1550),
    [sym_intersection_type] = STATE(1550),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_this] = ACTIONS(1823),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1515] = {
    [sym__type] = STATE(1551),
    [sym_constructor_type] = STATE(1551),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_function_type] = STATE(1551),
    [sym_nested_identifier] = STATE(2393),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_array_type] = STATE(1496),
    [sym_tuple_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(1551),
    [sym_intersection_type] = STATE(1551),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_this] = ACTIONS(1823),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1516] = {
    [sym__automatic_semicolon] = ACTIONS(2223),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_AMP] = ACTIONS(2223),
    [anon_sym_SEMI] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_COMMA] = ACTIONS(2223),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2223),
    [anon_sym_EQ] = ACTIONS(2223),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2223),
  },
  [1517] = {
    [sym__automatic_semicolon] = ACTIONS(2227),
    [anon_sym_LBRACK] = ACTIONS(4129),
    [anon_sym_AMP] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(2227),
    [anon_sym_RBRACE] = ACTIONS(2227),
    [anon_sym_PIPE] = ACTIONS(2229),
    [anon_sym_COMMA] = ACTIONS(2227),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2227),
    [anon_sym_EQ] = ACTIONS(2227),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2227),
  },
  [1518] = {
    [sym__automatic_semicolon] = ACTIONS(2245),
    [anon_sym_LBRACK] = ACTIONS(2245),
    [anon_sym_AMP] = ACTIONS(2245),
    [anon_sym_SEMI] = ACTIONS(2245),
    [anon_sym_RBRACE] = ACTIONS(2245),
    [anon_sym_PIPE] = ACTIONS(2247),
    [anon_sym_COMMA] = ACTIONS(2245),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2245),
    [anon_sym_EQ] = ACTIONS(2245),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2245),
  },
  [1519] = {
    [sym__automatic_semicolon] = ACTIONS(2301),
    [anon_sym_AMP] = ACTIONS(2301),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_SEMI] = ACTIONS(2301),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_COMMA] = ACTIONS(2301),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2301),
    [anon_sym_EQ] = ACTIONS(2301),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2301),
  },
  [1520] = {
    [sym__automatic_semicolon] = ACTIONS(2305),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_AMP] = ACTIONS(2305),
    [anon_sym_SEMI] = ACTIONS(2305),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_COMMA] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2305),
    [anon_sym_EQ] = ACTIONS(2305),
    [anon_sym_DOT] = ACTIONS(4142),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2305),
  },
  [1521] = {
    [sym__automatic_semicolon] = ACTIONS(2311),
    [anon_sym_LBRACK] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2311),
    [anon_sym_SEMI] = ACTIONS(2311),
    [anon_sym_RBRACE] = ACTIONS(2311),
    [anon_sym_PIPE] = ACTIONS(2313),
    [anon_sym_COMMA] = ACTIONS(2311),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2311),
    [anon_sym_EQ] = ACTIONS(2311),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2311),
  },
  [1522] = {
    [sym__automatic_semicolon] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(2315),
    [anon_sym_AMP] = ACTIONS(2315),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_RBRACE] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2317),
    [anon_sym_COMMA] = ACTIONS(2315),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2315),
    [anon_sym_EQ] = ACTIONS(2315),
    [anon_sym_DOT] = ACTIONS(4138),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2315),
  },
  [1523] = {
    [sym__automatic_semicolon] = ACTIONS(2319),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [anon_sym_AMP] = ACTIONS(2319),
    [anon_sym_SEMI] = ACTIONS(2319),
    [anon_sym_RBRACE] = ACTIONS(2319),
    [anon_sym_PIPE] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2319),
    [anon_sym_EQ] = ACTIONS(2319),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2319),
  },
  [1524] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(213),
    [anon_sym_PIPE] = ACTIONS(4063),
    [anon_sym_COMMA] = ACTIONS(2383),
    [anon_sym_DASH] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [anon_sym_RBRACE] = ACTIONS(213),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_LBRACE_PIPE] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_DASH_DASH] = ACTIONS(213),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_COLON] = ACTIONS(213),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_PLUS_PLUS] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_LBRACE] = ACTIONS(215),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(213),
    [anon_sym_RBRACK] = ACTIONS(213),
    [anon_sym_GT] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_RPAREN] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_SLASH] = ACTIONS(215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(215),
    [anon_sym_implements] = ACTIONS(213),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(215),
  },
  [1525] = {
    [sym__automatic_semicolon] = ACTIONS(2388),
    [anon_sym_AMP] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_PIPE] = ACTIONS(2390),
    [anon_sym_COMMA] = ACTIONS(2388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2388),
    [anon_sym_EQ] = ACTIONS(2388),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2388),
  },
  [1526] = {
    [sym__automatic_semicolon] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_AMP] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2394),
    [anon_sym_COMMA] = ACTIONS(2392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2392),
    [anon_sym_EQ] = ACTIONS(2392),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2392),
  },
  [1527] = {
    [sym__type] = STATE(1557),
    [sym_constructor_type] = STATE(1557),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_function_type] = STATE(1557),
    [sym_nested_identifier] = STATE(2393),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_array_type] = STATE(1496),
    [sym_tuple_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(1557),
    [sym_intersection_type] = STATE(1557),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_this] = ACTIONS(1823),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1528] = {
    [sym__type] = STATE(1558),
    [sym_constructor_type] = STATE(1558),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_function_type] = STATE(1558),
    [sym_nested_identifier] = STATE(2393),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_array_type] = STATE(1496),
    [sym_tuple_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(1558),
    [sym_intersection_type] = STATE(1558),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_this] = ACTIONS(1823),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1529] = {
    [sym__type] = STATE(1561),
    [sym_constructor_type] = STATE(1561),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_function_type] = STATE(1561),
    [sym_nested_identifier] = STATE(2393),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_array_type] = STATE(1496),
    [sym_tuple_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(1561),
    [sym_intersection_type] = STATE(1561),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_this] = ACTIONS(1823),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1530] = {
    [sym__automatic_semicolon] = ACTIONS(2402),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_AMP] = ACTIONS(2402),
    [anon_sym_SEMI] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_PIPE] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(2402),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2402),
    [anon_sym_EQ] = ACTIONS(2402),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2402),
  },
  [1531] = {
    [sym__type] = STATE(1563),
    [sym_constructor_type] = STATE(1563),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_function_type] = STATE(1563),
    [sym_nested_identifier] = STATE(2393),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_array_type] = STATE(1496),
    [sym_tuple_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(1563),
    [sym_intersection_type] = STATE(1563),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_this] = ACTIONS(1823),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1532] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2416),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_BANG] = ACTIONS(2418),
    [anon_sym_BQUOTE] = ACTIONS(2416),
    [anon_sym_PIPE] = ACTIONS(2418),
    [anon_sym_COMMA] = ACTIONS(2416),
    [anon_sym_LT_LT] = ACTIONS(2416),
    [anon_sym_STAR] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_AMP_AMP] = ACTIONS(2416),
    [anon_sym_GT_GT_GT] = ACTIONS(2416),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_BANG_EQ] = ACTIONS(2418),
    [anon_sym_LT_EQ] = ACTIONS(2416),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_GT_EQ] = ACTIONS(2416),
    [anon_sym_GT] = ACTIONS(2418),
    [anon_sym_AMP] = ACTIONS(2418),
    [anon_sym_PERCENT] = ACTIONS(2416),
    [anon_sym_QMARK] = ACTIONS(2416),
    [anon_sym_as] = ACTIONS(2418),
    [anon_sym_PIPE_PIPE] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_EQ_EQ] = ACTIONS(2418),
    [anon_sym_instanceof] = ACTIONS(2418),
    [anon_sym_LT] = ACTIONS(2418),
    [anon_sym_SLASH] = ACTIONS(2418),
    [sym_comment] = ACTIONS(3),
    [sym_regex_flags] = ACTIONS(4066),
    [anon_sym_DOT] = ACTIONS(2416),
    [anon_sym_CARET] = ACTIONS(2416),
    [anon_sym_STAR_STAR] = ACTIONS(2416),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_implements] = ACTIONS(2418),
    [anon_sym_GT_GT] = ACTIONS(2418),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2416),
    [anon_sym_in] = ACTIONS(2418),
  },
  [1533] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2424),
    [anon_sym_BQUOTE] = ACTIONS(2424),
    [anon_sym_PIPE] = ACTIONS(2426),
    [anon_sym_COMMA] = ACTIONS(2424),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_STAR] = ACTIONS(2426),
    [anon_sym_GT_GT_GT] = ACTIONS(2424),
    [anon_sym_BANG_EQ] = ACTIONS(2426),
    [anon_sym_GT_EQ] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_PERCENT] = ACTIONS(2424),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2424),
    [anon_sym_as] = ACTIONS(2424),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [anon_sym_instanceof] = ACTIONS(2424),
    [anon_sym_COLON] = ACTIONS(2424),
    [anon_sym_DOT] = ACTIONS(2424),
    [anon_sym_STAR_STAR] = ACTIONS(2424),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_else] = ACTIONS(2424),
    [anon_sym_BANG] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_LT_LT] = ACTIONS(2424),
    [anon_sym_LBRACE] = ACTIONS(2426),
    [anon_sym_AMP_AMP] = ACTIONS(2424),
    [anon_sym_LT_EQ] = ACTIONS(2424),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_RBRACK] = ACTIONS(2424),
    [anon_sym_GT] = ACTIONS(2426),
    [anon_sym_AMP] = ACTIONS(2426),
    [anon_sym_QMARK] = ACTIONS(2424),
    [anon_sym_PIPE_PIPE] = ACTIONS(2424),
    [anon_sym_while] = ACTIONS(2424),
    [anon_sym_EQ_EQ] = ACTIONS(2426),
    [anon_sym_RPAREN] = ACTIONS(2424),
    [anon_sym_LT] = ACTIONS(2426),
    [anon_sym_SLASH] = ACTIONS(2426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2424),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_implements] = ACTIONS(2424),
    [anon_sym_GT_GT] = ACTIONS(2426),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2424),
    [anon_sym_in] = ACTIONS(2426),
  },
  [1534] = {
    [sym__initializer] = STATE(1211),
    [sym_type_arguments] = STATE(497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_AMP_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_EQ] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2509),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_is] = ACTIONS(1207),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(2509),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1088),
    [anon_sym_STAR_EQ] = ACTIONS(1088),
    [anon_sym_PIPE_EQ] = ACTIONS(1088),
    [anon_sym_DASH_EQ] = ACTIONS(1088),
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1088),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4146),
  },
  [1535] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(2520),
    [anon_sym_COMMA] = ACTIONS(2523),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(2523),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1536] = {
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1537] = {
    [sym_new_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_non_null_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1220),
    [sym_this] = STATE(1220),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1220),
    [sym_generator_function] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1220),
    [sym_class] = STATE(1220),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(1124),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_RBRACK] = ACTIONS(2529),
    [sym_null] = ACTIONS(1124),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(1130),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1538] = {
    [sym_new_expression] = STATE(1261),
    [sym_augmented_assignment_expression] = STATE(1800),
    [sym_unary_expression] = STATE(1800),
    [sym_update_expression] = STATE(1800),
    [sym_regex] = STATE(1261),
    [sym_meta_property] = STATE(1261),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(1800),
    [sym_yield_expression] = STATE(1800),
    [sym_as_expression] = STATE(1800),
    [sym_non_null_expression] = STATE(1800),
    [sym_internal_module] = STATE(1800),
    [sym_function] = STATE(1266),
    [sym_arrow_function] = STATE(1261),
    [sym_await_expression] = STATE(1800),
    [sym_member_expression] = STATE(1267),
    [sym_string] = STATE(1261),
    [sym_this] = STATE(1261),
    [sym_type_parameters] = STATE(825),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1268),
    [sym_anonymous_class] = STATE(1261),
    [sym_generator_function] = STATE(1261),
    [sym_call_expression] = STATE(1800),
    [sym_subscript_expression] = STATE(1267),
    [sym_assignment_expression] = STATE(1800),
    [sym_ternary_expression] = STATE(1800),
    [sym_binary_expression] = STATE(1800),
    [sym_template_string] = STATE(1261),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(826),
    [sym_parenthesized_expression] = STATE(1261),
    [sym_array] = STATE(1269),
    [sym_type_assertion] = STATE(1800),
    [sym_class] = STATE(1261),
    [sym_identifier] = ACTIONS(4148),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(4150),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(4152),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(4150),
    [anon_sym_get] = ACTIONS(4150),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(3920),
    [anon_sym_protected] = ACTIONS(4150),
    [anon_sym_DOT] = ACTIONS(3922),
    [anon_sym_set] = ACTIONS(4150),
    [anon_sym_type] = ACTIONS(4150),
    [anon_sym_import] = ACTIONS(4150),
    [anon_sym_namespace] = ACTIONS(4154),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3920),
    [anon_sym_module] = ACTIONS(4150),
    [anon_sym_number] = ACTIONS(4150),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(4150),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3920),
    [anon_sym_any] = ACTIONS(4150),
    [anon_sym_boolean] = ACTIONS(4150),
    [anon_sym_async] = ACTIONS(4156),
    [anon_sym_public] = ACTIONS(4150),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3928),
    [anon_sym_SLASH] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4150),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3920),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(4150),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [1539] = {
    [anon_sym_LBRACK] = ACTIONS(2588),
    [sym_identifier] = ACTIONS(2590),
    [anon_sym_module] = ACTIONS(2590),
    [anon_sym_symbol] = ACTIONS(2590),
    [anon_sym_number] = ACTIONS(2590),
    [anon_sym_AT] = ACTIONS(2588),
    [anon_sym_class] = ACTIONS(2590),
    [anon_sym_declare] = ACTIONS(2590),
    [anon_sym_STAR] = ACTIONS(2588),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2588),
    [anon_sym_LBRACE] = ACTIONS(2588),
    [anon_sym_void] = ACTIONS(2590),
    [anon_sym_any] = ACTIONS(2590),
    [anon_sym_private] = ACTIONS(2590),
    [anon_sym_boolean] = ACTIONS(2590),
    [anon_sym_async] = ACTIONS(2590),
    [anon_sym_public] = ACTIONS(2590),
    [anon_sym_get] = ACTIONS(2590),
    [anon_sym_static] = ACTIONS(2590),
    [anon_sym_RBRACE] = ACTIONS(2588),
    [anon_sym_SQUOTE] = ACTIONS(2588),
    [anon_sym_this] = ACTIONS(2590),
    [sym_number] = ACTIONS(2588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2590),
    [anon_sym_string] = ACTIONS(2590),
    [anon_sym_abstract] = ACTIONS(2590),
    [anon_sym_set] = ACTIONS(2590),
    [anon_sym_type] = ACTIONS(2590),
    [anon_sym_import] = ACTIONS(2590),
    [anon_sym_export] = ACTIONS(2590),
    [sym_readonly] = ACTIONS(2590),
    [anon_sym_namespace] = ACTIONS(2590),
    [anon_sym_DQUOTE] = ACTIONS(2588),
  },
  [1540] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2652),
    [sym__automatic_semicolon] = ACTIONS(2652),
    [anon_sym_BQUOTE] = ACTIONS(2652),
    [anon_sym_PIPE] = ACTIONS(2654),
    [anon_sym_COMMA] = ACTIONS(2652),
    [anon_sym_DASH] = ACTIONS(2654),
    [anon_sym_STAR] = ACTIONS(2654),
    [anon_sym_GT_GT_GT] = ACTIONS(2652),
    [anon_sym_BANG_EQ] = ACTIONS(2654),
    [anon_sym_GT_EQ] = ACTIONS(2652),
    [anon_sym_RBRACE] = ACTIONS(2652),
    [anon_sym_PERCENT] = ACTIONS(2652),
    [anon_sym_as] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_instanceof] = ACTIONS(2652),
    [anon_sym_DOT] = ACTIONS(2652),
    [anon_sym_STAR_STAR] = ACTIONS(2652),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_else] = ACTIONS(2652),
    [anon_sym_BANG] = ACTIONS(2654),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [anon_sym_SEMI] = ACTIONS(2652),
    [anon_sym_LT_LT] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2652),
    [anon_sym_AMP_AMP] = ACTIONS(2652),
    [anon_sym_LT_EQ] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(2652),
    [anon_sym_GT] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2654),
    [anon_sym_QMARK] = ACTIONS(2652),
    [anon_sym_PIPE_PIPE] = ACTIONS(2652),
    [anon_sym_while] = ACTIONS(2652),
    [anon_sym_EQ_EQ] = ACTIONS(2654),
    [anon_sym_RPAREN] = ACTIONS(2652),
    [anon_sym_LT] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2652),
    [anon_sym_PLUS] = ACTIONS(2654),
    [anon_sym_GT_GT] = ACTIONS(2654),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2652),
    [anon_sym_in] = ACTIONS(2654),
  },
  [1541] = {
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_of] = ACTIONS(2700),
    [anon_sym_COLON] = ACTIONS(2700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(2700),
  },
  [1542] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2714),
    [anon_sym_BQUOTE] = ACTIONS(2714),
    [anon_sym_PIPE] = ACTIONS(2716),
    [anon_sym_COMMA] = ACTIONS(2714),
    [anon_sym_DASH] = ACTIONS(2716),
    [anon_sym_STAR] = ACTIONS(2716),
    [anon_sym_GT_GT_GT] = ACTIONS(2714),
    [anon_sym_BANG_EQ] = ACTIONS(2716),
    [anon_sym_GT_EQ] = ACTIONS(2714),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_PERCENT] = ACTIONS(2714),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2714),
    [anon_sym_as] = ACTIONS(2714),
    [anon_sym_DASH_DASH] = ACTIONS(2714),
    [anon_sym_instanceof] = ACTIONS(2714),
    [anon_sym_COLON] = ACTIONS(2714),
    [anon_sym_DOT] = ACTIONS(2714),
    [anon_sym_STAR_STAR] = ACTIONS(2714),
    [anon_sym_PLUS_PLUS] = ACTIONS(2714),
    [anon_sym_else] = ACTIONS(2714),
    [anon_sym_BANG] = ACTIONS(2716),
    [anon_sym_LBRACK] = ACTIONS(2714),
    [anon_sym_LT_LT] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(2716),
    [anon_sym_AMP_AMP] = ACTIONS(2714),
    [anon_sym_LT_EQ] = ACTIONS(2714),
    [anon_sym_LPAREN] = ACTIONS(2714),
    [anon_sym_RBRACK] = ACTIONS(2714),
    [anon_sym_GT] = ACTIONS(2716),
    [anon_sym_AMP] = ACTIONS(2716),
    [anon_sym_QMARK] = ACTIONS(2714),
    [anon_sym_PIPE_PIPE] = ACTIONS(2714),
    [anon_sym_while] = ACTIONS(2714),
    [anon_sym_EQ_EQ] = ACTIONS(2716),
    [anon_sym_RPAREN] = ACTIONS(2714),
    [anon_sym_LT] = ACTIONS(2716),
    [anon_sym_SLASH] = ACTIONS(2716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2714),
    [anon_sym_PLUS] = ACTIONS(2716),
    [anon_sym_implements] = ACTIONS(2714),
    [anon_sym_GT_GT] = ACTIONS(2716),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2714),
    [anon_sym_in] = ACTIONS(2716),
  },
  [1543] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2784),
    [sym__automatic_semicolon] = ACTIONS(2784),
    [anon_sym_BQUOTE] = ACTIONS(2784),
    [anon_sym_symbol] = ACTIONS(2786),
    [anon_sym_PIPE] = ACTIONS(2786),
    [anon_sym_STAR] = ACTIONS(2786),
    [anon_sym_GT_GT_GT] = ACTIONS(2784),
    [anon_sym_break] = ACTIONS(2786),
    [anon_sym_BANG_EQ] = ACTIONS(2786),
    [anon_sym_return] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2784),
    [anon_sym_PERCENT] = ACTIONS(2784),
    [anon_sym_interface] = ACTIONS(2786),
    [anon_sym_as] = ACTIONS(2786),
    [anon_sym_delete] = ACTIONS(2786),
    [anon_sym_if] = ACTIONS(2786),
    [anon_sym_instanceof] = ACTIONS(2786),
    [anon_sym_yield] = ACTIONS(2786),
    [sym_true] = ACTIONS(2786),
    [anon_sym_protected] = ACTIONS(2786),
    [anon_sym_DOT] = ACTIONS(2786),
    [anon_sym_set] = ACTIONS(2786),
    [anon_sym_import] = ACTIONS(2786),
    [anon_sym_await] = ACTIONS(2786),
    [anon_sym_DQUOTE] = ACTIONS(2784),
    [anon_sym_for] = ACTIONS(2786),
    [anon_sym_SEMI] = ACTIONS(2784),
    [anon_sym_number] = ACTIONS(2786),
    [anon_sym_typeof] = ACTIONS(2786),
    [anon_sym_LT_LT] = ACTIONS(2784),
    [anon_sym_LBRACE] = ACTIONS(2784),
    [anon_sym_AMP_AMP] = ACTIONS(2784),
    [anon_sym_switch] = ACTIONS(2786),
    [anon_sym_LT_EQ] = ACTIONS(2784),
    [sym_null] = ACTIONS(2786),
    [anon_sym_any] = ACTIONS(2786),
    [anon_sym_async] = ACTIONS(2786),
    [anon_sym_public] = ACTIONS(2786),
    [anon_sym_var] = ACTIONS(2786),
    [anon_sym_QMARK] = ACTIONS(2784),
    [anon_sym_while] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2784),
    [anon_sym_SLASH] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2786),
    [anon_sym_new] = ACTIONS(2786),
    [anon_sym_CARET] = ACTIONS(2784),
    [anon_sym_export] = ACTIONS(2786),
    [anon_sym_GT_GT] = ACTIONS(2786),
    [anon_sym_with] = ACTIONS(2786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2784),
    [sym_identifier] = ACTIONS(2786),
    [anon_sym_debugger] = ACTIONS(2786),
    [anon_sym_AT] = ACTIONS(2784),
    [anon_sym_COMMA] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_void] = ACTIONS(2786),
    [anon_sym_const] = ACTIONS(2786),
    [anon_sym_GT_EQ] = ACTIONS(2784),
    [sym_super] = ACTIONS(2786),
    [anon_sym_private] = ACTIONS(2786),
    [anon_sym_get] = ACTIONS(2786),
    [anon_sym_default] = ACTIONS(2786),
    [anon_sym_enum] = ACTIONS(2786),
    [anon_sym_continue] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2784),
    [anon_sym_this] = ACTIONS(2786),
    [anon_sym_throw] = ACTIONS(2786),
    [anon_sym_abstract] = ACTIONS(2786),
    [anon_sym_type] = ACTIONS(2786),
    [anon_sym_STAR_STAR] = ACTIONS(2784),
    [anon_sym_namespace] = ACTIONS(2786),
    [anon_sym_PLUS_PLUS] = ACTIONS(2784),
    [anon_sym_else] = ACTIONS(2786),
    [anon_sym_BANG] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [sym_false] = ACTIONS(2786),
    [anon_sym_case] = ACTIONS(2786),
    [anon_sym_module] = ACTIONS(2786),
    [anon_sym_class] = ACTIONS(2786),
    [anon_sym_declare] = ACTIONS(2786),
    [anon_sym_LPAREN] = ACTIONS(2784),
    [anon_sym_GT] = ACTIONS(2786),
    [anon_sym_boolean] = ACTIONS(2786),
    [anon_sym_AMP] = ACTIONS(2786),
    [anon_sym_PIPE_PIPE] = ACTIONS(2784),
    [anon_sym_try] = ACTIONS(2786),
    [anon_sym_EQ_EQ] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2786),
    [sym_number] = ACTIONS(2784),
    [ts_builtin_sym_end] = ACTIONS(2784),
    [anon_sym_function] = ACTIONS(2786),
    [sym_undefined] = ACTIONS(2786),
    [anon_sym_let] = ACTIONS(2786),
    [anon_sym_PLUS] = ACTIONS(2786),
    [anon_sym_do] = ACTIONS(2786),
    [anon_sym_TILDE] = ACTIONS(2784),
    [anon_sym_in] = ACTIONS(2786),
  },
  [1544] = {
    [anon_sym_EQ] = ACTIONS(2831),
    [anon_sym_of] = ACTIONS(2831),
    [anon_sym_COLON] = ACTIONS(2831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(2831),
  },
  [1545] = {
    [anon_sym_EQ] = ACTIONS(1900),
    [anon_sym_RBRACE] = ACTIONS(2851),
    [anon_sym_COLON] = ACTIONS(2851),
    [anon_sym_SEMI] = ACTIONS(2851),
    [anon_sym_QMARK] = ACTIONS(2851),
    [anon_sym_LPAREN] = ACTIONS(2851),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2851),
    [sym__automatic_semicolon] = ACTIONS(2851),
    [anon_sym_LT] = ACTIONS(2851),
    [anon_sym_COMMA] = ACTIONS(2851),
    [sym_comment] = ACTIONS(3),
  },
  [1546] = {
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_of] = ACTIONS(2855),
    [anon_sym_COLON] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(2855),
  },
  [1547] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2908),
    [anon_sym_BQUOTE] = ACTIONS(2908),
    [anon_sym_PIPE] = ACTIONS(2910),
    [anon_sym_COMMA] = ACTIONS(2908),
    [anon_sym_DASH] = ACTIONS(2910),
    [anon_sym_STAR] = ACTIONS(2910),
    [anon_sym_GT_GT_GT] = ACTIONS(2908),
    [anon_sym_BANG_EQ] = ACTIONS(2910),
    [anon_sym_GT_EQ] = ACTIONS(2908),
    [anon_sym_RBRACE] = ACTIONS(2908),
    [anon_sym_PERCENT] = ACTIONS(2908),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2908),
    [anon_sym_as] = ACTIONS(2908),
    [anon_sym_DASH_DASH] = ACTIONS(2908),
    [anon_sym_instanceof] = ACTIONS(2908),
    [anon_sym_COLON] = ACTIONS(2908),
    [anon_sym_DOT] = ACTIONS(2908),
    [anon_sym_STAR_STAR] = ACTIONS(2908),
    [anon_sym_PLUS_PLUS] = ACTIONS(2908),
    [anon_sym_BANG] = ACTIONS(2910),
    [anon_sym_LBRACK] = ACTIONS(2908),
    [anon_sym_LT_LT] = ACTIONS(2908),
    [anon_sym_LBRACE] = ACTIONS(2910),
    [anon_sym_AMP_AMP] = ACTIONS(2908),
    [anon_sym_LT_EQ] = ACTIONS(2908),
    [anon_sym_LPAREN] = ACTIONS(2908),
    [anon_sym_RBRACK] = ACTIONS(2908),
    [anon_sym_GT] = ACTIONS(2910),
    [anon_sym_AMP] = ACTIONS(2910),
    [anon_sym_QMARK] = ACTIONS(2908),
    [anon_sym_PIPE_PIPE] = ACTIONS(2908),
    [anon_sym_EQ_EQ] = ACTIONS(2910),
    [anon_sym_RPAREN] = ACTIONS(2908),
    [anon_sym_LT] = ACTIONS(2910),
    [anon_sym_SLASH] = ACTIONS(2910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2908),
    [anon_sym_PLUS] = ACTIONS(2910),
    [anon_sym_implements] = ACTIONS(2908),
    [anon_sym_GT_GT] = ACTIONS(2910),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2908),
    [anon_sym_in] = ACTIONS(2910),
  },
  [1548] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2946),
    [anon_sym_BQUOTE] = ACTIONS(2946),
    [anon_sym_PIPE] = ACTIONS(2948),
    [anon_sym_COMMA] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2948),
    [anon_sym_STAR] = ACTIONS(2948),
    [anon_sym_GT_GT_GT] = ACTIONS(2946),
    [anon_sym_BANG_EQ] = ACTIONS(2948),
    [anon_sym_GT_EQ] = ACTIONS(2946),
    [anon_sym_RBRACE] = ACTIONS(2946),
    [anon_sym_PERCENT] = ACTIONS(2946),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2946),
    [anon_sym_as] = ACTIONS(2946),
    [anon_sym_DASH_DASH] = ACTIONS(2946),
    [anon_sym_instanceof] = ACTIONS(2946),
    [anon_sym_COLON] = ACTIONS(2946),
    [anon_sym_DOT] = ACTIONS(2946),
    [anon_sym_STAR_STAR] = ACTIONS(2946),
    [anon_sym_PLUS_PLUS] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2946),
    [anon_sym_BANG] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [anon_sym_LT_LT] = ACTIONS(2946),
    [anon_sym_LBRACE] = ACTIONS(2948),
    [anon_sym_AMP_AMP] = ACTIONS(2946),
    [anon_sym_LT_EQ] = ACTIONS(2946),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [anon_sym_RBRACK] = ACTIONS(2946),
    [anon_sym_GT] = ACTIONS(2948),
    [anon_sym_AMP] = ACTIONS(2948),
    [anon_sym_QMARK] = ACTIONS(2946),
    [anon_sym_PIPE_PIPE] = ACTIONS(2946),
    [anon_sym_while] = ACTIONS(2946),
    [anon_sym_EQ_EQ] = ACTIONS(2948),
    [anon_sym_RPAREN] = ACTIONS(2946),
    [anon_sym_LT] = ACTIONS(2948),
    [anon_sym_SLASH] = ACTIONS(2948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2946),
    [anon_sym_PLUS] = ACTIONS(2948),
    [anon_sym_implements] = ACTIONS(2946),
    [anon_sym_GT_GT] = ACTIONS(2948),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2946),
    [anon_sym_in] = ACTIONS(2948),
  },
  [1549] = {
    [sym__automatic_semicolon] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym_RBRACE] = ACTIONS(2974),
    [anon_sym_LT] = ACTIONS(2974),
    [anon_sym_COMMA] = ACTIONS(2974),
    [anon_sym_PIPE] = ACTIONS(2976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_EQ] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(2652),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2974),
    [anon_sym_in] = ACTIONS(2974),
  },
  [1550] = {
    [sym__automatic_semicolon] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_AMP] = ACTIONS(2614),
    [anon_sym_SEMI] = ACTIONS(2978),
    [anon_sym_RBRACE] = ACTIONS(2978),
    [anon_sym_PIPE] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(2978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_EQ] = ACTIONS(2978),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2978),
  },
  [1551] = {
    [sym__automatic_semicolon] = ACTIONS(2982),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_AMP] = ACTIONS(2614),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_RBRACE] = ACTIONS(2982),
    [anon_sym_PIPE] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(2982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2982),
    [anon_sym_EQ] = ACTIONS(2982),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2982),
  },
  [1552] = {
    [sym__automatic_semicolon] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3014),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_PIPE] = ACTIONS(3016),
    [anon_sym_COMMA] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3014),
    [anon_sym_EQ] = ACTIONS(3014),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3014),
  },
  [1553] = {
    [sym__automatic_semicolon] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_AMP] = ACTIONS(3018),
    [anon_sym_SEMI] = ACTIONS(3018),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_PIPE] = ACTIONS(3020),
    [anon_sym_COMMA] = ACTIONS(3018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3018),
    [anon_sym_EQ] = ACTIONS(3018),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3018),
  },
  [1554] = {
    [sym__type] = STATE(1579),
    [sym_constructor_type] = STATE(1579),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_function_type] = STATE(1579),
    [sym_nested_identifier] = STATE(2393),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_array_type] = STATE(1496),
    [sym_tuple_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(1579),
    [sym_intersection_type] = STATE(1579),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_this] = ACTIONS(1823),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1555] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BQUOTE] = ACTIONS(1027),
    [anon_sym_PIPE] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1031),
    [anon_sym_GT_GT_GT] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1031),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_COLON] = ACTIONS(1027),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_LBRACE] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_RBRACK] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1031),
    [anon_sym_AMP] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_RPAREN] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1031),
    [anon_sym_SLASH] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_implements] = ACTIONS(1027),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(1031),
  },
  [1556] = {
    [sym__automatic_semicolon] = ACTIONS(3076),
    [anon_sym_LBRACK] = ACTIONS(3076),
    [anon_sym_AMP] = ACTIONS(3076),
    [anon_sym_SEMI] = ACTIONS(3076),
    [anon_sym_RBRACE] = ACTIONS(3076),
    [anon_sym_PIPE] = ACTIONS(3078),
    [anon_sym_COMMA] = ACTIONS(3076),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3076),
    [anon_sym_EQ] = ACTIONS(3076),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3076),
  },
  [1557] = {
    [sym__automatic_semicolon] = ACTIONS(3080),
    [anon_sym_AMP] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3080),
    [anon_sym_SEMI] = ACTIONS(3080),
    [anon_sym_LBRACK] = ACTIONS(3080),
    [anon_sym_PIPE] = ACTIONS(3082),
    [anon_sym_COMMA] = ACTIONS(3080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3080),
    [anon_sym_EQ] = ACTIONS(3080),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3080),
  },
  [1558] = {
    [sym__automatic_semicolon] = ACTIONS(3084),
    [anon_sym_AMP] = ACTIONS(3084),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_SEMI] = ACTIONS(3084),
    [anon_sym_LBRACK] = ACTIONS(3084),
    [anon_sym_PIPE] = ACTIONS(3086),
    [anon_sym_COMMA] = ACTIONS(3084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3084),
    [anon_sym_EQ] = ACTIONS(3084),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3084),
  },
  [1559] = {
    [sym__automatic_semicolon] = ACTIONS(3088),
    [anon_sym_LBRACK] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3088),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_PIPE] = ACTIONS(3090),
    [anon_sym_COMMA] = ACTIONS(3088),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3088),
    [anon_sym_EQ] = ACTIONS(3088),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3088),
  },
  [1560] = {
    [sym__type] = STATE(1582),
    [sym_constructor_type] = STATE(1582),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_function_type] = STATE(1582),
    [sym_nested_identifier] = STATE(2393),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_array_type] = STATE(1496),
    [sym_tuple_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(1582),
    [sym_intersection_type] = STATE(1582),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_this] = ACTIONS(1823),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1561] = {
    [sym__automatic_semicolon] = ACTIONS(3099),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_AMP] = ACTIONS(2614),
    [anon_sym_SEMI] = ACTIONS(3099),
    [anon_sym_RBRACE] = ACTIONS(3099),
    [anon_sym_PIPE] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(3099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_EQ] = ACTIONS(3099),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3099),
  },
  [1562] = {
    [sym__automatic_semicolon] = ACTIONS(3116),
    [anon_sym_LBRACK] = ACTIONS(3116),
    [anon_sym_AMP] = ACTIONS(3116),
    [anon_sym_SEMI] = ACTIONS(3116),
    [anon_sym_RBRACE] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3118),
    [anon_sym_COMMA] = ACTIONS(3116),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3116),
    [anon_sym_EQ] = ACTIONS(3116),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3116),
  },
  [1563] = {
    [sym__automatic_semicolon] = ACTIONS(3120),
    [anon_sym_AMP] = ACTIONS(2614),
    [anon_sym_RBRACE] = ACTIONS(3120),
    [anon_sym_SEMI] = ACTIONS(3120),
    [anon_sym_LBRACK] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(3120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3120),
    [anon_sym_EQ] = ACTIONS(3120),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3120),
  },
  [1564] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3132),
    [anon_sym_BQUOTE] = ACTIONS(3132),
    [anon_sym_PIPE] = ACTIONS(3134),
    [anon_sym_COMMA] = ACTIONS(3132),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_STAR] = ACTIONS(3134),
    [anon_sym_GT_GT_GT] = ACTIONS(3132),
    [anon_sym_BANG_EQ] = ACTIONS(3134),
    [anon_sym_GT_EQ] = ACTIONS(3132),
    [anon_sym_RBRACE] = ACTIONS(3132),
    [anon_sym_PERCENT] = ACTIONS(3132),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3132),
    [anon_sym_as] = ACTIONS(3132),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [anon_sym_instanceof] = ACTIONS(3132),
    [anon_sym_COLON] = ACTIONS(3132),
    [anon_sym_DOT] = ACTIONS(3132),
    [anon_sym_STAR_STAR] = ACTIONS(3132),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_else] = ACTIONS(3132),
    [anon_sym_BANG] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [anon_sym_LT_LT] = ACTIONS(3132),
    [anon_sym_LBRACE] = ACTIONS(3134),
    [anon_sym_AMP_AMP] = ACTIONS(3132),
    [anon_sym_LT_EQ] = ACTIONS(3132),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [anon_sym_RBRACK] = ACTIONS(3132),
    [anon_sym_GT] = ACTIONS(3134),
    [anon_sym_AMP] = ACTIONS(3134),
    [anon_sym_QMARK] = ACTIONS(3132),
    [anon_sym_PIPE_PIPE] = ACTIONS(3132),
    [anon_sym_while] = ACTIONS(3132),
    [anon_sym_EQ_EQ] = ACTIONS(3134),
    [anon_sym_RPAREN] = ACTIONS(3132),
    [anon_sym_LT] = ACTIONS(3134),
    [anon_sym_SLASH] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3132),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_implements] = ACTIONS(3132),
    [anon_sym_GT_GT] = ACTIONS(3134),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3132),
    [anon_sym_in] = ACTIONS(3134),
  },
  [1565] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1753),
    [anon_sym_BQUOTE] = ACTIONS(1753),
    [anon_sym_PIPE] = ACTIONS(1755),
    [anon_sym_COMMA] = ACTIONS(1753),
    [anon_sym_DASH] = ACTIONS(1755),
    [anon_sym_STAR] = ACTIONS(1755),
    [anon_sym_GT_GT_GT] = ACTIONS(1753),
    [anon_sym_BANG_EQ] = ACTIONS(1755),
    [anon_sym_GT_EQ] = ACTIONS(1753),
    [anon_sym_PERCENT] = ACTIONS(1753),
    [anon_sym_as] = ACTIONS(1753),
    [anon_sym_DASH_DASH] = ACTIONS(1753),
    [anon_sym_instanceof] = ACTIONS(1753),
    [anon_sym_COLON] = ACTIONS(1753),
    [anon_sym_DOT] = ACTIONS(1753),
    [anon_sym_STAR_STAR] = ACTIONS(1753),
    [anon_sym_PLUS_PLUS] = ACTIONS(1753),
    [anon_sym_BANG] = ACTIONS(1755),
    [anon_sym_LBRACK] = ACTIONS(1753),
    [anon_sym_LT_LT] = ACTIONS(1753),
    [anon_sym_AMP_AMP] = ACTIONS(1753),
    [anon_sym_LT_EQ] = ACTIONS(1753),
    [anon_sym_LPAREN] = ACTIONS(1753),
    [anon_sym_GT] = ACTIONS(1755),
    [anon_sym_EQ_GT] = ACTIONS(1138),
    [anon_sym_AMP] = ACTIONS(1755),
    [anon_sym_QMARK] = ACTIONS(1753),
    [anon_sym_PIPE_PIPE] = ACTIONS(1753),
    [anon_sym_EQ_EQ] = ACTIONS(1755),
    [anon_sym_RPAREN] = ACTIONS(1753),
    [anon_sym_LT] = ACTIONS(1755),
    [anon_sym_SLASH] = ACTIONS(1755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1753),
    [anon_sym_PLUS] = ACTIONS(1755),
    [anon_sym_GT_GT] = ACTIONS(1755),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1753),
    [anon_sym_in] = ACTIONS(1755),
  },
  [1566] = {
    [sym_new_expression] = STATE(1969),
    [sym_constructor_type] = STATE(754),
    [sym_augmented_assignment_expression] = STATE(1969),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(1969),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(1969),
    [sym_call_signature] = STATE(2379),
    [sym_yield_expression] = STATE(1969),
    [sym_as_expression] = STATE(1969),
    [sym_internal_module] = STATE(1969),
    [sym_arrow_function] = STATE(1969),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(2521),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1535),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(2522),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(1969),
    [sym_subscript_expression] = STATE(2521),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(1969),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(1969),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(754),
    [sym__type] = STATE(754),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(1969),
    [sym_meta_property] = STATE(1969),
    [sym_function_type] = STATE(754),
    [sym__expression] = STATE(1969),
    [sym_non_null_expression] = STATE(1969),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(1969),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(1969),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(1969),
    [sym_call_expression] = STATE(1969),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(1969),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(1969),
    [sym_type_arguments] = STATE(2523),
    [sym_union_type] = STATE(754),
    [sym_parenthesized_expression] = STATE(1969),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1969),
    [sym_class] = STATE(1969),
    [sym_identifier] = ACTIONS(4158),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(4160),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(4162),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(4164),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(2333),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(2335),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(2335),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(4160),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(4166),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [sym_null] = ACTIONS(4168),
    [anon_sym_any] = ACTIONS(4160),
    [anon_sym_boolean] = ACTIONS(4160),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2347),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4160),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4162),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [1567] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_AMP_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_EQ] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(2305),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(1088),
    [anon_sym_STAR_EQ] = ACTIONS(1088),
    [anon_sym_PIPE_EQ] = ACTIONS(1088),
    [anon_sym_DASH_EQ] = ACTIONS(1088),
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1088),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(4172),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(847),
  },
  [1568] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2311),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(2313),
    [anon_sym_COMMA] = ACTIONS(2311),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(2311),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(2313),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1569] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3182),
    [anon_sym_BQUOTE] = ACTIONS(3182),
    [anon_sym_PIPE] = ACTIONS(3184),
    [anon_sym_COMMA] = ACTIONS(3182),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_STAR] = ACTIONS(3184),
    [anon_sym_GT_GT_GT] = ACTIONS(3182),
    [anon_sym_BANG_EQ] = ACTIONS(3184),
    [anon_sym_GT_EQ] = ACTIONS(3182),
    [anon_sym_RBRACE] = ACTIONS(3182),
    [anon_sym_PERCENT] = ACTIONS(3182),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3182),
    [anon_sym_as] = ACTIONS(3182),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [anon_sym_instanceof] = ACTIONS(3182),
    [anon_sym_COLON] = ACTIONS(3182),
    [anon_sym_DOT] = ACTIONS(3182),
    [anon_sym_STAR_STAR] = ACTIONS(3182),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3182),
    [anon_sym_BANG] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [anon_sym_LT_LT] = ACTIONS(3182),
    [anon_sym_LBRACE] = ACTIONS(3184),
    [anon_sym_AMP_AMP] = ACTIONS(3182),
    [anon_sym_LT_EQ] = ACTIONS(3182),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [anon_sym_RBRACK] = ACTIONS(3182),
    [anon_sym_GT] = ACTIONS(3184),
    [anon_sym_AMP] = ACTIONS(3184),
    [anon_sym_QMARK] = ACTIONS(3182),
    [anon_sym_PIPE_PIPE] = ACTIONS(3182),
    [anon_sym_while] = ACTIONS(3182),
    [anon_sym_EQ_EQ] = ACTIONS(3184),
    [anon_sym_RPAREN] = ACTIONS(3182),
    [anon_sym_LT] = ACTIONS(3184),
    [anon_sym_SLASH] = ACTIONS(3184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3182),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_implements] = ACTIONS(3182),
    [anon_sym_GT_GT] = ACTIONS(3184),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3182),
    [anon_sym_in] = ACTIONS(3184),
  },
  [1570] = {
    [anon_sym_LBRACK] = ACTIONS(3192),
    [sym_identifier] = ACTIONS(3194),
    [anon_sym_module] = ACTIONS(3194),
    [anon_sym_symbol] = ACTIONS(3194),
    [anon_sym_number] = ACTIONS(3194),
    [anon_sym_AT] = ACTIONS(3192),
    [anon_sym_class] = ACTIONS(3194),
    [anon_sym_declare] = ACTIONS(3194),
    [anon_sym_STAR] = ACTIONS(3192),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3192),
    [anon_sym_LBRACE] = ACTIONS(3192),
    [anon_sym_void] = ACTIONS(3194),
    [anon_sym_any] = ACTIONS(3194),
    [anon_sym_private] = ACTIONS(3194),
    [anon_sym_boolean] = ACTIONS(3194),
    [anon_sym_async] = ACTIONS(3194),
    [anon_sym_public] = ACTIONS(3194),
    [anon_sym_get] = ACTIONS(3194),
    [anon_sym_static] = ACTIONS(3194),
    [anon_sym_RBRACE] = ACTIONS(3192),
    [anon_sym_SQUOTE] = ACTIONS(3192),
    [anon_sym_this] = ACTIONS(3194),
    [sym_number] = ACTIONS(3192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3194),
    [anon_sym_string] = ACTIONS(3194),
    [anon_sym_abstract] = ACTIONS(3194),
    [anon_sym_set] = ACTIONS(3194),
    [anon_sym_type] = ACTIONS(3194),
    [anon_sym_import] = ACTIONS(3194),
    [anon_sym_export] = ACTIONS(3194),
    [sym_readonly] = ACTIONS(3194),
    [anon_sym_namespace] = ACTIONS(3194),
    [anon_sym_DQUOTE] = ACTIONS(3192),
  },
  [1571] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(3297),
    [anon_sym_COMMA] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_RBRACE] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1695),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_COLON] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_LBRACE] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_RBRACK] = ACTIONS(1695),
    [anon_sym_GT] = ACTIONS(3297),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_implements] = ACTIONS(1695),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(3297),
  },
  [1572] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3307),
    [anon_sym_BQUOTE] = ACTIONS(3307),
    [anon_sym_PIPE] = ACTIONS(3309),
    [anon_sym_COMMA] = ACTIONS(3307),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_STAR] = ACTIONS(3309),
    [anon_sym_GT_GT_GT] = ACTIONS(3307),
    [anon_sym_BANG_EQ] = ACTIONS(3309),
    [anon_sym_GT_EQ] = ACTIONS(3307),
    [anon_sym_RBRACE] = ACTIONS(3307),
    [anon_sym_PERCENT] = ACTIONS(3307),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3307),
    [anon_sym_as] = ACTIONS(3307),
    [anon_sym_DASH_DASH] = ACTIONS(3307),
    [anon_sym_instanceof] = ACTIONS(3307),
    [anon_sym_COLON] = ACTIONS(3307),
    [anon_sym_DOT] = ACTIONS(3307),
    [anon_sym_STAR_STAR] = ACTIONS(3307),
    [anon_sym_PLUS_PLUS] = ACTIONS(3307),
    [anon_sym_else] = ACTIONS(3307),
    [anon_sym_BANG] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [anon_sym_LT_LT] = ACTIONS(3307),
    [anon_sym_LBRACE] = ACTIONS(3309),
    [anon_sym_AMP_AMP] = ACTIONS(3307),
    [anon_sym_LT_EQ] = ACTIONS(3307),
    [anon_sym_LPAREN] = ACTIONS(3307),
    [anon_sym_RBRACK] = ACTIONS(3307),
    [anon_sym_GT] = ACTIONS(3309),
    [anon_sym_AMP] = ACTIONS(3309),
    [anon_sym_QMARK] = ACTIONS(3307),
    [anon_sym_PIPE_PIPE] = ACTIONS(3307),
    [anon_sym_while] = ACTIONS(3307),
    [anon_sym_EQ_EQ] = ACTIONS(3309),
    [anon_sym_RPAREN] = ACTIONS(3307),
    [anon_sym_LT] = ACTIONS(3309),
    [anon_sym_SLASH] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3307),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_implements] = ACTIONS(3307),
    [anon_sym_GT_GT] = ACTIONS(3309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3307),
    [anon_sym_in] = ACTIONS(3309),
  },
  [1573] = {
    [sym_tuple_type] = STATE(1496),
    [sym__type] = STATE(1586),
    [sym_constructor_type] = STATE(1586),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_array_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_function_type] = STATE(1586),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_nested_identifier] = STATE(2393),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(1586),
    [sym_intersection_type] = STATE(1586),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_this] = ACTIONS(1823),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_keyof] = ACTIONS(1805),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_PIPE] = ACTIONS(1813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(1801),
  },
  [1574] = {
    [anon_sym_EQ] = ACTIONS(3367),
    [anon_sym_of] = ACTIONS(3367),
    [anon_sym_COLON] = ACTIONS(3367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3367),
  },
  [1575] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3433),
    [anon_sym_BQUOTE] = ACTIONS(3433),
    [anon_sym_PIPE] = ACTIONS(3435),
    [anon_sym_COMMA] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_STAR] = ACTIONS(3435),
    [anon_sym_GT_GT_GT] = ACTIONS(3433),
    [anon_sym_BANG_EQ] = ACTIONS(3435),
    [anon_sym_GT_EQ] = ACTIONS(3433),
    [anon_sym_RBRACE] = ACTIONS(3433),
    [anon_sym_PERCENT] = ACTIONS(3433),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3433),
    [anon_sym_as] = ACTIONS(3433),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [anon_sym_instanceof] = ACTIONS(3433),
    [anon_sym_COLON] = ACTIONS(3433),
    [anon_sym_DOT] = ACTIONS(3433),
    [anon_sym_STAR_STAR] = ACTIONS(3433),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_else] = ACTIONS(3433),
    [anon_sym_BANG] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [anon_sym_LT_LT] = ACTIONS(3433),
    [anon_sym_LBRACE] = ACTIONS(3435),
    [anon_sym_AMP_AMP] = ACTIONS(3433),
    [anon_sym_LT_EQ] = ACTIONS(3433),
    [anon_sym_LPAREN] = ACTIONS(3433),
    [anon_sym_RBRACK] = ACTIONS(3433),
    [anon_sym_GT] = ACTIONS(3435),
    [anon_sym_AMP] = ACTIONS(3435),
    [anon_sym_QMARK] = ACTIONS(3433),
    [anon_sym_PIPE_PIPE] = ACTIONS(3433),
    [anon_sym_while] = ACTIONS(3433),
    [anon_sym_EQ_EQ] = ACTIONS(3435),
    [anon_sym_RPAREN] = ACTIONS(3433),
    [anon_sym_LT] = ACTIONS(3435),
    [anon_sym_SLASH] = ACTIONS(3435),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3433),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_implements] = ACTIONS(3433),
    [anon_sym_GT_GT] = ACTIONS(3435),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3433),
    [anon_sym_in] = ACTIONS(3435),
  },
  [1576] = {
    [sym__automatic_semicolon] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_AMP] = ACTIONS(3439),
    [anon_sym_SEMI] = ACTIONS(3439),
    [anon_sym_RBRACE] = ACTIONS(3439),
    [anon_sym_PIPE] = ACTIONS(3441),
    [anon_sym_COMMA] = ACTIONS(3439),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3439),
    [anon_sym_EQ] = ACTIONS(3439),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3439),
  },
  [1577] = {
    [sym__automatic_semicolon] = ACTIONS(3445),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_AMP] = ACTIONS(3445),
    [anon_sym_SEMI] = ACTIONS(3445),
    [anon_sym_RBRACE] = ACTIONS(3445),
    [anon_sym_PIPE] = ACTIONS(3447),
    [anon_sym_COMMA] = ACTIONS(3445),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3445),
    [anon_sym_EQ] = ACTIONS(3445),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3445),
  },
  [1578] = {
    [sym__automatic_semicolon] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_SEMI] = ACTIONS(3476),
    [anon_sym_RBRACE] = ACTIONS(3476),
    [anon_sym_PIPE] = ACTIONS(3478),
    [anon_sym_COMMA] = ACTIONS(3476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3476),
    [anon_sym_EQ] = ACTIONS(3476),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3476),
  },
  [1579] = {
    [sym__automatic_semicolon] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(2614),
    [anon_sym_RBRACE] = ACTIONS(3480),
    [anon_sym_SEMI] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(3480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_EQ] = ACTIONS(3480),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3480),
  },
  [1580] = {
    [sym__type] = STATE(1588),
    [sym_constructor_type] = STATE(1588),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_function_type] = STATE(1588),
    [sym_nested_identifier] = STATE(2393),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_array_type] = STATE(1496),
    [sym_tuple_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(1588),
    [sym_intersection_type] = STATE(1588),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_boolean] = ACTIONS(1801),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_this] = ACTIONS(1823),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1581] = {
    [sym__automatic_semicolon] = ACTIONS(3523),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_AMP] = ACTIONS(3523),
    [anon_sym_SEMI] = ACTIONS(3523),
    [anon_sym_RBRACE] = ACTIONS(3523),
    [anon_sym_PIPE] = ACTIONS(3525),
    [anon_sym_COMMA] = ACTIONS(3523),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3523),
    [anon_sym_EQ] = ACTIONS(3523),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3523),
  },
  [1582] = {
    [sym__automatic_semicolon] = ACTIONS(3527),
    [anon_sym_AMP] = ACTIONS(2614),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_PIPE] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(3527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_EQ] = ACTIONS(3527),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3527),
  },
  [1583] = {
    [sym__automatic_semicolon] = ACTIONS(3531),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_AMP] = ACTIONS(3531),
    [anon_sym_SEMI] = ACTIONS(3531),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3531),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3531),
    [anon_sym_EQ] = ACTIONS(3531),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3531),
  },
  [1584] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3539),
    [anon_sym_BQUOTE] = ACTIONS(3539),
    [anon_sym_PIPE] = ACTIONS(3541),
    [anon_sym_COMMA] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3541),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_GT_GT_GT] = ACTIONS(3539),
    [anon_sym_BANG_EQ] = ACTIONS(3541),
    [anon_sym_GT_EQ] = ACTIONS(3539),
    [anon_sym_RBRACE] = ACTIONS(3539),
    [anon_sym_PERCENT] = ACTIONS(3539),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3539),
    [anon_sym_as] = ACTIONS(3539),
    [anon_sym_DASH_DASH] = ACTIONS(3539),
    [anon_sym_instanceof] = ACTIONS(3539),
    [anon_sym_COLON] = ACTIONS(3539),
    [anon_sym_DOT] = ACTIONS(3539),
    [anon_sym_STAR_STAR] = ACTIONS(3539),
    [anon_sym_PLUS_PLUS] = ACTIONS(3539),
    [anon_sym_else] = ACTIONS(3539),
    [anon_sym_BANG] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [anon_sym_LT_LT] = ACTIONS(3539),
    [anon_sym_LBRACE] = ACTIONS(3541),
    [anon_sym_AMP_AMP] = ACTIONS(3539),
    [anon_sym_LT_EQ] = ACTIONS(3539),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [anon_sym_RBRACK] = ACTIONS(3539),
    [anon_sym_GT] = ACTIONS(3541),
    [anon_sym_AMP] = ACTIONS(3541),
    [anon_sym_QMARK] = ACTIONS(3539),
    [anon_sym_PIPE_PIPE] = ACTIONS(3539),
    [anon_sym_while] = ACTIONS(3539),
    [anon_sym_EQ_EQ] = ACTIONS(3541),
    [anon_sym_RPAREN] = ACTIONS(3539),
    [anon_sym_LT] = ACTIONS(3541),
    [anon_sym_SLASH] = ACTIONS(3541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3539),
    [anon_sym_PLUS] = ACTIONS(3541),
    [anon_sym_implements] = ACTIONS(3539),
    [anon_sym_GT_GT] = ACTIONS(3541),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3539),
    [anon_sym_in] = ACTIONS(3541),
  },
  [1585] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3576),
    [anon_sym_BQUOTE] = ACTIONS(3576),
    [anon_sym_PIPE] = ACTIONS(3578),
    [anon_sym_COMMA] = ACTIONS(3576),
    [anon_sym_DASH] = ACTIONS(3578),
    [anon_sym_STAR] = ACTIONS(3578),
    [anon_sym_GT_GT_GT] = ACTIONS(3576),
    [anon_sym_BANG_EQ] = ACTIONS(3578),
    [anon_sym_GT_EQ] = ACTIONS(3576),
    [anon_sym_RBRACE] = ACTIONS(3576),
    [anon_sym_PERCENT] = ACTIONS(3576),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3576),
    [anon_sym_as] = ACTIONS(3576),
    [anon_sym_DASH_DASH] = ACTIONS(3576),
    [anon_sym_instanceof] = ACTIONS(3576),
    [anon_sym_COLON] = ACTIONS(3576),
    [anon_sym_DOT] = ACTIONS(3576),
    [anon_sym_STAR_STAR] = ACTIONS(3576),
    [anon_sym_PLUS_PLUS] = ACTIONS(3576),
    [anon_sym_else] = ACTIONS(3576),
    [anon_sym_BANG] = ACTIONS(3578),
    [anon_sym_LBRACK] = ACTIONS(3576),
    [anon_sym_LT_LT] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3578),
    [anon_sym_AMP_AMP] = ACTIONS(3576),
    [anon_sym_LT_EQ] = ACTIONS(3576),
    [anon_sym_LPAREN] = ACTIONS(3576),
    [anon_sym_RBRACK] = ACTIONS(3576),
    [anon_sym_GT] = ACTIONS(3578),
    [anon_sym_AMP] = ACTIONS(3578),
    [anon_sym_QMARK] = ACTIONS(3576),
    [anon_sym_PIPE_PIPE] = ACTIONS(3576),
    [anon_sym_while] = ACTIONS(3576),
    [anon_sym_EQ_EQ] = ACTIONS(3578),
    [anon_sym_RPAREN] = ACTIONS(3576),
    [anon_sym_LT] = ACTIONS(3578),
    [anon_sym_SLASH] = ACTIONS(3578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3576),
    [anon_sym_PLUS] = ACTIONS(3578),
    [anon_sym_implements] = ACTIONS(3576),
    [anon_sym_GT_GT] = ACTIONS(3578),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3576),
    [anon_sym_in] = ACTIONS(3578),
  },
  [1586] = {
    [sym__automatic_semicolon] = ACTIONS(3661),
    [anon_sym_RBRACE] = ACTIONS(3661),
    [anon_sym_AMP] = ACTIONS(2614),
    [anon_sym_SEMI] = ACTIONS(3661),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3661),
    [anon_sym_PIPE] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(3661),
    [sym_comment] = ACTIONS(3),
  },
  [1587] = {
    [sym__automatic_semicolon] = ACTIONS(3705),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_AMP] = ACTIONS(3705),
    [anon_sym_SEMI] = ACTIONS(3705),
    [anon_sym_RBRACE] = ACTIONS(3705),
    [anon_sym_PIPE] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3705),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3705),
    [anon_sym_EQ] = ACTIONS(3705),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3705),
  },
  [1588] = {
    [sym__automatic_semicolon] = ACTIONS(3725),
    [anon_sym_AMP] = ACTIONS(2614),
    [anon_sym_RBRACE] = ACTIONS(3725),
    [anon_sym_SEMI] = ACTIONS(3725),
    [anon_sym_LBRACK] = ACTIONS(3725),
    [anon_sym_PIPE] = ACTIONS(4068),
    [anon_sym_COMMA] = ACTIONS(3725),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3725),
    [anon_sym_EQ] = ACTIONS(3725),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3725),
  },
  [1589] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_RBRACK] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(1697),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(3741),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1697),
  },
  [1590] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3744),
    [anon_sym_BQUOTE] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_STAR] = ACTIONS(3746),
    [anon_sym_GT_GT_GT] = ACTIONS(3744),
    [anon_sym_BANG_EQ] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_PERCENT] = ACTIONS(3744),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3744),
    [anon_sym_as] = ACTIONS(3744),
    [anon_sym_DASH_DASH] = ACTIONS(3744),
    [anon_sym_instanceof] = ACTIONS(3744),
    [anon_sym_COLON] = ACTIONS(3744),
    [anon_sym_DOT] = ACTIONS(3744),
    [anon_sym_STAR_STAR] = ACTIONS(3744),
    [anon_sym_PLUS_PLUS] = ACTIONS(3744),
    [anon_sym_else] = ACTIONS(3744),
    [anon_sym_BANG] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [anon_sym_LT_LT] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3744),
    [anon_sym_LT_EQ] = ACTIONS(3744),
    [anon_sym_LPAREN] = ACTIONS(3744),
    [anon_sym_RBRACK] = ACTIONS(3744),
    [anon_sym_GT] = ACTIONS(3746),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_QMARK] = ACTIONS(3744),
    [anon_sym_PIPE_PIPE] = ACTIONS(3744),
    [anon_sym_while] = ACTIONS(3744),
    [anon_sym_EQ_EQ] = ACTIONS(3746),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_LT] = ACTIONS(3746),
    [anon_sym_SLASH] = ACTIONS(3746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3744),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_implements] = ACTIONS(3744),
    [anon_sym_GT_GT] = ACTIONS(3746),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3744),
    [anon_sym_in] = ACTIONS(3746),
  },
  [1591] = {
    [sym__automatic_semicolon] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_AMP] = ACTIONS(3818),
    [anon_sym_SEMI] = ACTIONS(3818),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3820),
    [anon_sym_COMMA] = ACTIONS(3818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3818),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3818),
  },
  [1592] = {
    [sym_statement_block] = STATE(1606),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(799),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_GT_GT_GT] = ACTIONS(799),
    [anon_sym_BANG_EQ] = ACTIONS(801),
    [anon_sym_GT_EQ] = ACTIONS(799),
    [anon_sym_RBRACE] = ACTIONS(799),
    [anon_sym_PERCENT] = ACTIONS(799),
    [anon_sym_LBRACE_PIPE] = ACTIONS(799),
    [anon_sym_as] = ACTIONS(799),
    [anon_sym_DASH_DASH] = ACTIONS(799),
    [anon_sym_instanceof] = ACTIONS(799),
    [anon_sym_COLON] = ACTIONS(799),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_STAR_STAR] = ACTIONS(799),
    [anon_sym_PLUS_PLUS] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(799),
    [anon_sym_LT_LT] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(4176),
    [anon_sym_AMP_AMP] = ACTIONS(799),
    [anon_sym_LT_EQ] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(799),
    [anon_sym_RBRACK] = ACTIONS(799),
    [anon_sym_GT] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_PIPE_PIPE] = ACTIONS(799),
    [anon_sym_EQ_EQ] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(799),
    [anon_sym_LT] = ACTIONS(801),
    [anon_sym_SLASH] = ACTIONS(801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(801),
    [anon_sym_implements] = ACTIONS(799),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(799),
    [anon_sym_in] = ACTIONS(801),
  },
  [1593] = {
    [sym_identifier] = ACTIONS(809),
    [anon_sym_BQUOTE] = ACTIONS(807),
    [anon_sym_debugger] = ACTIONS(809),
    [anon_sym_symbol] = ACTIONS(809),
    [anon_sym_AT] = ACTIONS(807),
    [anon_sym_DASH] = ACTIONS(809),
    [anon_sym_void] = ACTIONS(809),
    [anon_sym_break] = ACTIONS(809),
    [anon_sym_const] = ACTIONS(809),
    [sym_super] = ACTIONS(809),
    [anon_sym_return] = ACTIONS(809),
    [anon_sym_private] = ACTIONS(809),
    [anon_sym_get] = ACTIONS(809),
    [anon_sym_RBRACE] = ACTIONS(807),
    [anon_sym_interface] = ACTIONS(809),
    [anon_sym_default] = ACTIONS(809),
    [anon_sym_enum] = ACTIONS(809),
    [anon_sym_delete] = ACTIONS(809),
    [anon_sym_continue] = ACTIONS(809),
    [anon_sym_DASH_DASH] = ACTIONS(807),
    [anon_sym_if] = ACTIONS(809),
    [anon_sym_this] = ACTIONS(809),
    [anon_sym_yield] = ACTIONS(809),
    [sym_true] = ACTIONS(809),
    [anon_sym_throw] = ACTIONS(809),
    [anon_sym_protected] = ACTIONS(809),
    [anon_sym_abstract] = ACTIONS(809),
    [anon_sym_set] = ACTIONS(809),
    [anon_sym_type] = ACTIONS(809),
    [anon_sym_import] = ACTIONS(809),
    [anon_sym_namespace] = ACTIONS(809),
    [anon_sym_PLUS_PLUS] = ACTIONS(807),
    [anon_sym_await] = ACTIONS(809),
    [anon_sym_DQUOTE] = ACTIONS(807),
    [anon_sym_else] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(807),
    [anon_sym_for] = ACTIONS(809),
    [anon_sym_LBRACK] = ACTIONS(807),
    [sym_false] = ACTIONS(809),
    [anon_sym_SEMI] = ACTIONS(807),
    [anon_sym_case] = ACTIONS(809),
    [anon_sym_module] = ACTIONS(809),
    [anon_sym_number] = ACTIONS(809),
    [anon_sym_class] = ACTIONS(809),
    [anon_sym_declare] = ACTIONS(809),
    [anon_sym_typeof] = ACTIONS(809),
    [anon_sym_LBRACE] = ACTIONS(807),
    [anon_sym_switch] = ACTIONS(809),
    [anon_sym_LPAREN] = ACTIONS(807),
    [sym_null] = ACTIONS(809),
    [anon_sym_any] = ACTIONS(809),
    [anon_sym_boolean] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(809),
    [anon_sym_public] = ACTIONS(809),
    [anon_sym_var] = ACTIONS(809),
    [anon_sym_while] = ACTIONS(809),
    [anon_sym_SQUOTE] = ACTIONS(807),
    [anon_sym_try] = ACTIONS(809),
    [anon_sym_LT] = ACTIONS(807),
    [sym_number] = ACTIONS(807),
    [anon_sym_SLASH] = ACTIONS(809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(809),
    [anon_sym_function] = ACTIONS(809),
    [sym_undefined] = ACTIONS(809),
    [anon_sym_new] = ACTIONS(809),
    [ts_builtin_sym_end] = ACTIONS(807),
    [anon_sym_let] = ACTIONS(809),
    [anon_sym_PLUS] = ACTIONS(809),
    [anon_sym_export] = ACTIONS(809),
    [anon_sym_do] = ACTIONS(809),
    [anon_sym_TILDE] = ACTIONS(807),
    [anon_sym_with] = ACTIONS(809),
  },
  [1594] = {
    [sym_statement_block] = STATE(1606),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(799),
    [anon_sym_BQUOTE] = ACTIONS(799),
    [anon_sym_PIPE] = ACTIONS(801),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_DASH] = ACTIONS(801),
    [anon_sym_STAR] = ACTIONS(801),
    [anon_sym_GT_GT_GT] = ACTIONS(799),
    [anon_sym_BANG_EQ] = ACTIONS(801),
    [anon_sym_GT_EQ] = ACTIONS(799),
    [anon_sym_RBRACE] = ACTIONS(799),
    [anon_sym_PERCENT] = ACTIONS(799),
    [anon_sym_LBRACE_PIPE] = ACTIONS(799),
    [anon_sym_as] = ACTIONS(799),
    [anon_sym_DASH_DASH] = ACTIONS(799),
    [anon_sym_instanceof] = ACTIONS(799),
    [anon_sym_COLON] = ACTIONS(799),
    [anon_sym_DOT] = ACTIONS(799),
    [anon_sym_STAR_STAR] = ACTIONS(799),
    [anon_sym_PLUS_PLUS] = ACTIONS(799),
    [anon_sym_BANG] = ACTIONS(801),
    [anon_sym_LBRACK] = ACTIONS(799),
    [anon_sym_LT_LT] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(4176),
    [anon_sym_AMP_AMP] = ACTIONS(799),
    [anon_sym_LT_EQ] = ACTIONS(799),
    [anon_sym_LPAREN] = ACTIONS(799),
    [anon_sym_RBRACK] = ACTIONS(799),
    [anon_sym_GT] = ACTIONS(801),
    [anon_sym_AMP] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(799),
    [anon_sym_PIPE_PIPE] = ACTIONS(799),
    [anon_sym_EQ_EQ] = ACTIONS(801),
    [anon_sym_RPAREN] = ACTIONS(799),
    [anon_sym_LT] = ACTIONS(801),
    [anon_sym_SLASH] = ACTIONS(801),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(799),
    [anon_sym_PLUS] = ACTIONS(801),
    [anon_sym_implements] = ACTIONS(799),
    [anon_sym_GT_GT] = ACTIONS(801),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(799),
    [anon_sym_in] = ACTIONS(801),
  },
  [1595] = {
    [anon_sym_BQUOTE] = ACTIONS(813),
    [anon_sym_symbol] = ACTIONS(815),
    [anon_sym_PIPE] = ACTIONS(813),
    [anon_sym_break] = ACTIONS(815),
    [anon_sym_return] = ACTIONS(815),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_interface] = ACTIONS(815),
    [anon_sym_delete] = ACTIONS(815),
    [anon_sym_if] = ACTIONS(815),
    [anon_sym_yield] = ACTIONS(815),
    [sym_true] = ACTIONS(815),
    [anon_sym_COLON] = ACTIONS(813),
    [anon_sym_protected] = ACTIONS(815),
    [anon_sym_set] = ACTIONS(815),
    [anon_sym_import] = ACTIONS(815),
    [anon_sym_await] = ACTIONS(815),
    [anon_sym_DQUOTE] = ACTIONS(813),
    [anon_sym_for] = ACTIONS(815),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_number] = ACTIONS(815),
    [anon_sym_typeof] = ACTIONS(815),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_switch] = ACTIONS(815),
    [anon_sym_RBRACK] = ACTIONS(813),
    [sym_null] = ACTIONS(815),
    [anon_sym_any] = ACTIONS(815),
    [anon_sym_async] = ACTIONS(815),
    [anon_sym_public] = ACTIONS(815),
    [anon_sym_var] = ACTIONS(815),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_while] = ACTIONS(815),
    [anon_sym_SQUOTE] = ACTIONS(813),
    [anon_sym_RPAREN] = ACTIONS(813),
    [anon_sym_SLASH] = ACTIONS(815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(815),
    [anon_sym_new] = ACTIONS(815),
    [anon_sym_export] = ACTIONS(815),
    [anon_sym_with] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [anon_sym_debugger] = ACTIONS(815),
    [anon_sym_AT] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_DASH] = ACTIONS(815),
    [anon_sym_EQ] = ACTIONS(815),
    [anon_sym_void] = ACTIONS(815),
    [anon_sym_const] = ACTIONS(815),
    [sym_super] = ACTIONS(815),
    [anon_sym_private] = ACTIONS(815),
    [anon_sym_get] = ACTIONS(815),
    [anon_sym_default] = ACTIONS(815),
    [anon_sym_enum] = ACTIONS(815),
    [anon_sym_continue] = ACTIONS(815),
    [anon_sym_DASH_DASH] = ACTIONS(813),
    [anon_sym_this] = ACTIONS(815),
    [anon_sym_throw] = ACTIONS(815),
    [anon_sym_abstract] = ACTIONS(815),
    [anon_sym_type] = ACTIONS(815),
    [anon_sym_namespace] = ACTIONS(815),
    [anon_sym_PLUS_PLUS] = ACTIONS(813),
    [anon_sym_else] = ACTIONS(815),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(813),
    [sym_false] = ACTIONS(815),
    [anon_sym_case] = ACTIONS(815),
    [anon_sym_module] = ACTIONS(815),
    [anon_sym_class] = ACTIONS(815),
    [anon_sym_declare] = ACTIONS(815),
    [anon_sym_LPAREN] = ACTIONS(813),
    [anon_sym_GT] = ACTIONS(813),
    [anon_sym_boolean] = ACTIONS(815),
    [anon_sym_EQ_GT] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_try] = ACTIONS(815),
    [anon_sym_LT] = ACTIONS(813),
    [sym_number] = ACTIONS(813),
    [ts_builtin_sym_end] = ACTIONS(813),
    [anon_sym_function] = ACTIONS(815),
    [sym_undefined] = ACTIONS(815),
    [anon_sym_let] = ACTIONS(815),
    [anon_sym_PLUS] = ACTIONS(815),
    [anon_sym_do] = ACTIONS(815),
    [anon_sym_TILDE] = ACTIONS(813),
  },
  [1596] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1216),
    [anon_sym_BQUOTE] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_COMMA] = ACTIONS(1216),
    [anon_sym_DASH] = ACTIONS(1218),
    [anon_sym_STAR] = ACTIONS(1218),
    [anon_sym_GT_GT_GT] = ACTIONS(1216),
    [anon_sym_BANG_EQ] = ACTIONS(1218),
    [anon_sym_GT_EQ] = ACTIONS(1216),
    [anon_sym_RBRACE] = ACTIONS(1216),
    [anon_sym_PERCENT] = ACTIONS(1216),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1216),
    [anon_sym_as] = ACTIONS(1216),
    [anon_sym_DASH_DASH] = ACTIONS(1216),
    [anon_sym_instanceof] = ACTIONS(1216),
    [anon_sym_COLON] = ACTIONS(1216),
    [anon_sym_DOT] = ACTIONS(1216),
    [anon_sym_STAR_STAR] = ACTIONS(1216),
    [anon_sym_PLUS_PLUS] = ACTIONS(1216),
    [anon_sym_BANG] = ACTIONS(1218),
    [anon_sym_LBRACK] = ACTIONS(1216),
    [anon_sym_LT_LT] = ACTIONS(1216),
    [anon_sym_LBRACE] = ACTIONS(1218),
    [anon_sym_AMP_AMP] = ACTIONS(1216),
    [anon_sym_LT_EQ] = ACTIONS(1216),
    [anon_sym_LPAREN] = ACTIONS(1216),
    [anon_sym_RBRACK] = ACTIONS(1216),
    [anon_sym_GT] = ACTIONS(1218),
    [anon_sym_AMP] = ACTIONS(1218),
    [anon_sym_QMARK] = ACTIONS(1216),
    [anon_sym_PIPE_PIPE] = ACTIONS(1216),
    [anon_sym_EQ_EQ] = ACTIONS(1218),
    [anon_sym_RPAREN] = ACTIONS(1216),
    [anon_sym_LT] = ACTIONS(1218),
    [anon_sym_SLASH] = ACTIONS(1218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1216),
    [anon_sym_PLUS] = ACTIONS(1218),
    [anon_sym_implements] = ACTIONS(1216),
    [anon_sym_GT_GT] = ACTIONS(1218),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1216),
    [anon_sym_in] = ACTIONS(1218),
  },
  [1597] = {
    [sym_index_type_query] = STATE(1615),
    [sym_lookup_type] = STATE(1615),
    [sym_this_type] = STATE(1615),
    [sym_flow_maybe_type] = STATE(1615),
    [sym_nested_identifier] = STATE(2424),
    [sym__primary_type] = STATE(1615),
    [sym_generic_type] = STATE(1615),
    [sym_mapped_type] = STATE(1615),
    [sym_literal_type] = STATE(1615),
    [sym_parenthesized_type] = STATE(1615),
    [sym_predefined_type] = STATE(1615),
    [sym_string] = STATE(1596),
    [sym_array_type] = STATE(1615),
    [sym_tuple_type] = STATE(1615),
    [sym_nested_type_identifier] = STATE(1603),
    [sym_type_predicate] = STATE(1615),
    [sym_type_query] = STATE(1615),
    [sym__number] = STATE(1596),
    [sym_existential_type] = STATE(1615),
    [sym_object_type] = STATE(1615),
    [sym_identifier] = ACTIONS(4178),
    [sym_false] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_symbol] = ACTIONS(4184),
    [anon_sym_number] = ACTIONS(4184),
    [anon_sym_typeof] = ACTIONS(4186),
    [anon_sym_keyof] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4194),
    [anon_sym_void] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4196),
    [anon_sym_any] = ACTIONS(4184),
    [anon_sym_boolean] = ACTIONS(4184),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4198),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_this] = ACTIONS(4202),
    [sym_number] = ACTIONS(4204),
    [sym_true] = ACTIONS(4180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4184),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [1598] = {
    [sym__type] = STATE(1617),
    [sym_constructor_type] = STATE(1617),
    [sym_index_type_query] = STATE(1604),
    [sym_lookup_type] = STATE(1604),
    [sym_this_type] = STATE(1604),
    [sym_flow_maybe_type] = STATE(1604),
    [sym_function_type] = STATE(1617),
    [sym_nested_identifier] = STATE(2424),
    [sym__primary_type] = STATE(1604),
    [sym_generic_type] = STATE(1604),
    [sym_mapped_type] = STATE(1604),
    [sym_literal_type] = STATE(1604),
    [sym_parenthesized_type] = STATE(1604),
    [sym_predefined_type] = STATE(1604),
    [sym_type_parameters] = STATE(2423),
    [sym_string] = STATE(1596),
    [sym_array_type] = STATE(1604),
    [sym_tuple_type] = STATE(1604),
    [sym_nested_type_identifier] = STATE(1603),
    [sym_type_predicate] = STATE(1604),
    [sym_type_query] = STATE(1604),
    [sym__number] = STATE(1596),
    [sym_existential_type] = STATE(1604),
    [sym_object_type] = STATE(1604),
    [sym_union_type] = STATE(1617),
    [sym_intersection_type] = STATE(1617),
    [sym_formal_parameters] = STATE(2110),
    [sym_identifier] = ACTIONS(4178),
    [sym_false] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_symbol] = ACTIONS(4184),
    [anon_sym_number] = ACTIONS(4184),
    [anon_sym_typeof] = ACTIONS(4186),
    [anon_sym_keyof] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4194),
    [anon_sym_PIPE] = ACTIONS(4206),
    [anon_sym_void] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(4184),
    [anon_sym_boolean] = ACTIONS(4184),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_this] = ACTIONS(4202),
    [sym_number] = ACTIONS(4204),
    [sym_true] = ACTIONS(4180),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [1599] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1244),
    [anon_sym_BQUOTE] = ACTIONS(1244),
    [anon_sym_PIPE] = ACTIONS(1246),
    [anon_sym_COMMA] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(1246),
    [anon_sym_STAR] = ACTIONS(1246),
    [anon_sym_GT_GT_GT] = ACTIONS(1244),
    [anon_sym_BANG_EQ] = ACTIONS(1246),
    [anon_sym_GT_EQ] = ACTIONS(1244),
    [anon_sym_RBRACE] = ACTIONS(1244),
    [anon_sym_PERCENT] = ACTIONS(1244),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1244),
    [anon_sym_as] = ACTIONS(1244),
    [anon_sym_DASH_DASH] = ACTIONS(1244),
    [anon_sym_instanceof] = ACTIONS(1244),
    [anon_sym_COLON] = ACTIONS(1244),
    [anon_sym_DOT] = ACTIONS(1244),
    [anon_sym_STAR_STAR] = ACTIONS(1244),
    [anon_sym_PLUS_PLUS] = ACTIONS(1244),
    [anon_sym_BANG] = ACTIONS(1246),
    [anon_sym_LBRACK] = ACTIONS(1244),
    [anon_sym_LT_LT] = ACTIONS(1244),
    [anon_sym_LBRACE] = ACTIONS(1246),
    [anon_sym_AMP_AMP] = ACTIONS(1244),
    [anon_sym_LT_EQ] = ACTIONS(1244),
    [anon_sym_LPAREN] = ACTIONS(1244),
    [anon_sym_RBRACK] = ACTIONS(1244),
    [anon_sym_GT] = ACTIONS(1246),
    [anon_sym_AMP] = ACTIONS(1246),
    [anon_sym_QMARK] = ACTIONS(1244),
    [anon_sym_PIPE_PIPE] = ACTIONS(1244),
    [anon_sym_EQ_EQ] = ACTIONS(1246),
    [anon_sym_RPAREN] = ACTIONS(1244),
    [anon_sym_LT] = ACTIONS(1246),
    [anon_sym_SLASH] = ACTIONS(1246),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1244),
    [anon_sym_PLUS] = ACTIONS(1246),
    [anon_sym_implements] = ACTIONS(1244),
    [anon_sym_GT_GT] = ACTIONS(1246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1244),
    [anon_sym_in] = ACTIONS(1246),
  },
  [1600] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1248),
    [anon_sym_BQUOTE] = ACTIONS(1248),
    [anon_sym_PIPE] = ACTIONS(1250),
    [anon_sym_COMMA] = ACTIONS(1248),
    [anon_sym_DASH] = ACTIONS(1250),
    [anon_sym_STAR] = ACTIONS(1250),
    [anon_sym_GT_GT_GT] = ACTIONS(1248),
    [anon_sym_BANG_EQ] = ACTIONS(1250),
    [anon_sym_GT_EQ] = ACTIONS(1248),
    [anon_sym_RBRACE] = ACTIONS(1248),
    [anon_sym_PERCENT] = ACTIONS(1248),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1248),
    [anon_sym_as] = ACTIONS(1248),
    [anon_sym_DASH_DASH] = ACTIONS(1248),
    [anon_sym_instanceof] = ACTIONS(1248),
    [anon_sym_COLON] = ACTIONS(1248),
    [anon_sym_DOT] = ACTIONS(1248),
    [anon_sym_STAR_STAR] = ACTIONS(1248),
    [anon_sym_PLUS_PLUS] = ACTIONS(1248),
    [anon_sym_BANG] = ACTIONS(1250),
    [anon_sym_LBRACK] = ACTIONS(1248),
    [anon_sym_LT_LT] = ACTIONS(1248),
    [anon_sym_LBRACE] = ACTIONS(1250),
    [anon_sym_AMP_AMP] = ACTIONS(1248),
    [anon_sym_LT_EQ] = ACTIONS(1248),
    [anon_sym_LPAREN] = ACTIONS(1248),
    [anon_sym_RBRACK] = ACTIONS(1248),
    [anon_sym_GT] = ACTIONS(1250),
    [anon_sym_AMP] = ACTIONS(1250),
    [anon_sym_QMARK] = ACTIONS(1248),
    [anon_sym_PIPE_PIPE] = ACTIONS(1248),
    [anon_sym_EQ_EQ] = ACTIONS(1250),
    [anon_sym_RPAREN] = ACTIONS(1248),
    [anon_sym_LT] = ACTIONS(1250),
    [anon_sym_SLASH] = ACTIONS(1250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1248),
    [anon_sym_PLUS] = ACTIONS(1250),
    [anon_sym_implements] = ACTIONS(1248),
    [anon_sym_GT_GT] = ACTIONS(1250),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1248),
    [anon_sym_in] = ACTIONS(1250),
  },
  [1601] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1256),
    [anon_sym_BQUOTE] = ACTIONS(1256),
    [anon_sym_PIPE] = ACTIONS(1258),
    [anon_sym_COMMA] = ACTIONS(1256),
    [anon_sym_DASH] = ACTIONS(1258),
    [anon_sym_STAR] = ACTIONS(1258),
    [anon_sym_GT_GT_GT] = ACTIONS(1256),
    [anon_sym_BANG_EQ] = ACTIONS(1258),
    [anon_sym_GT_EQ] = ACTIONS(1256),
    [anon_sym_RBRACE] = ACTIONS(1256),
    [anon_sym_PERCENT] = ACTIONS(1256),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1256),
    [anon_sym_as] = ACTIONS(1256),
    [anon_sym_DASH_DASH] = ACTIONS(1256),
    [anon_sym_instanceof] = ACTIONS(1256),
    [anon_sym_COLON] = ACTIONS(1256),
    [anon_sym_DOT] = ACTIONS(1256),
    [anon_sym_STAR_STAR] = ACTIONS(1256),
    [anon_sym_PLUS_PLUS] = ACTIONS(1256),
    [anon_sym_BANG] = ACTIONS(1258),
    [anon_sym_LBRACK] = ACTIONS(1256),
    [anon_sym_LT_LT] = ACTIONS(1256),
    [anon_sym_LBRACE] = ACTIONS(1258),
    [anon_sym_AMP_AMP] = ACTIONS(1256),
    [anon_sym_LT_EQ] = ACTIONS(1256),
    [anon_sym_LPAREN] = ACTIONS(1256),
    [anon_sym_RBRACK] = ACTIONS(1256),
    [anon_sym_GT] = ACTIONS(1258),
    [anon_sym_AMP] = ACTIONS(1258),
    [anon_sym_QMARK] = ACTIONS(1256),
    [anon_sym_PIPE_PIPE] = ACTIONS(1256),
    [anon_sym_EQ_EQ] = ACTIONS(1258),
    [anon_sym_RPAREN] = ACTIONS(1256),
    [anon_sym_LT] = ACTIONS(1258),
    [anon_sym_SLASH] = ACTIONS(1258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1256),
    [anon_sym_PLUS] = ACTIONS(1258),
    [anon_sym_implements] = ACTIONS(1256),
    [anon_sym_GT_GT] = ACTIONS(1258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1256),
    [anon_sym_in] = ACTIONS(1258),
  },
  [1602] = {
    [sym__type] = STATE(1623),
    [sym_constructor_type] = STATE(1623),
    [sym_index_type_query] = STATE(1604),
    [sym_lookup_type] = STATE(1604),
    [sym_this_type] = STATE(1604),
    [sym_flow_maybe_type] = STATE(1604),
    [sym_function_type] = STATE(1623),
    [sym_nested_identifier] = STATE(2424),
    [sym__primary_type] = STATE(1604),
    [sym_generic_type] = STATE(1604),
    [sym_mapped_type] = STATE(1604),
    [sym_literal_type] = STATE(1604),
    [sym_parenthesized_type] = STATE(1604),
    [sym_predefined_type] = STATE(1604),
    [sym_type_parameters] = STATE(2423),
    [sym_string] = STATE(1596),
    [sym_array_type] = STATE(1604),
    [sym_tuple_type] = STATE(1604),
    [sym_nested_type_identifier] = STATE(1603),
    [sym_type_predicate] = STATE(1604),
    [sym_type_query] = STATE(1604),
    [sym__number] = STATE(1596),
    [sym_existential_type] = STATE(1604),
    [sym_object_type] = STATE(1604),
    [sym_union_type] = STATE(1623),
    [sym_intersection_type] = STATE(1623),
    [sym_formal_parameters] = STATE(2110),
    [sym_identifier] = ACTIONS(4178),
    [sym_false] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_symbol] = ACTIONS(4184),
    [anon_sym_number] = ACTIONS(4184),
    [anon_sym_typeof] = ACTIONS(4186),
    [anon_sym_keyof] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4194),
    [anon_sym_PIPE] = ACTIONS(4206),
    [anon_sym_void] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(4184),
    [anon_sym_boolean] = ACTIONS(4184),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_this] = ACTIONS(4202),
    [sym_number] = ACTIONS(4204),
    [sym_true] = ACTIONS(4180),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [1603] = {
    [sym_type_arguments] = STATE(1628),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1280),
    [anon_sym_BQUOTE] = ACTIONS(1280),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_COMMA] = ACTIONS(1280),
    [anon_sym_DASH] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(1285),
    [anon_sym_GT_GT_GT] = ACTIONS(1280),
    [anon_sym_BANG_EQ] = ACTIONS(1285),
    [anon_sym_GT_EQ] = ACTIONS(1280),
    [anon_sym_RBRACE] = ACTIONS(1280),
    [anon_sym_PERCENT] = ACTIONS(1280),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1280),
    [anon_sym_as] = ACTIONS(1280),
    [anon_sym_DASH_DASH] = ACTIONS(1280),
    [anon_sym_instanceof] = ACTIONS(1280),
    [anon_sym_COLON] = ACTIONS(1280),
    [anon_sym_DOT] = ACTIONS(1280),
    [anon_sym_STAR_STAR] = ACTIONS(1280),
    [anon_sym_PLUS_PLUS] = ACTIONS(1280),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_LT_LT] = ACTIONS(1280),
    [anon_sym_LBRACE] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1280),
    [anon_sym_LT_EQ] = ACTIONS(1280),
    [anon_sym_LPAREN] = ACTIONS(1280),
    [anon_sym_RBRACK] = ACTIONS(1280),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(1280),
    [anon_sym_PIPE_PIPE] = ACTIONS(1280),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1280),
    [anon_sym_LT] = ACTIONS(4217),
    [anon_sym_SLASH] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1280),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_implements] = ACTIONS(1280),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1280),
    [anon_sym_in] = ACTIONS(4220),
  },
  [1604] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1293),
    [anon_sym_BQUOTE] = ACTIONS(1293),
    [anon_sym_PIPE] = ACTIONS(1295),
    [anon_sym_COMMA] = ACTIONS(1293),
    [anon_sym_DASH] = ACTIONS(1295),
    [anon_sym_STAR] = ACTIONS(1295),
    [anon_sym_GT_GT_GT] = ACTIONS(1293),
    [anon_sym_BANG_EQ] = ACTIONS(1295),
    [anon_sym_GT_EQ] = ACTIONS(1293),
    [anon_sym_RBRACE] = ACTIONS(1293),
    [anon_sym_PERCENT] = ACTIONS(1293),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1293),
    [anon_sym_as] = ACTIONS(1293),
    [anon_sym_DASH_DASH] = ACTIONS(1293),
    [anon_sym_instanceof] = ACTIONS(1293),
    [anon_sym_COLON] = ACTIONS(1293),
    [anon_sym_DOT] = ACTIONS(1293),
    [anon_sym_STAR_STAR] = ACTIONS(1293),
    [anon_sym_PLUS_PLUS] = ACTIONS(1293),
    [anon_sym_BANG] = ACTIONS(1295),
    [anon_sym_LBRACK] = ACTIONS(4223),
    [anon_sym_LT_LT] = ACTIONS(1293),
    [anon_sym_LBRACE] = ACTIONS(1295),
    [anon_sym_AMP_AMP] = ACTIONS(1293),
    [anon_sym_LT_EQ] = ACTIONS(1293),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_RBRACK] = ACTIONS(1293),
    [anon_sym_GT] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
    [anon_sym_QMARK] = ACTIONS(1293),
    [anon_sym_PIPE_PIPE] = ACTIONS(1293),
    [anon_sym_EQ_EQ] = ACTIONS(1295),
    [anon_sym_RPAREN] = ACTIONS(1293),
    [anon_sym_LT] = ACTIONS(1295),
    [anon_sym_SLASH] = ACTIONS(1295),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1293),
    [anon_sym_PLUS] = ACTIONS(1295),
    [anon_sym_implements] = ACTIONS(1293),
    [anon_sym_GT_GT] = ACTIONS(1295),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1293),
    [anon_sym_in] = ACTIONS(1295),
  },
  [1605] = {
    [sym_type_arguments] = STATE(1614),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1201),
    [anon_sym_BQUOTE] = ACTIONS(1201),
    [anon_sym_PIPE] = ACTIONS(1751),
    [anon_sym_COMMA] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_STAR] = ACTIONS(1751),
    [anon_sym_GT_GT_GT] = ACTIONS(1201),
    [anon_sym_BANG_EQ] = ACTIONS(1751),
    [anon_sym_GT_EQ] = ACTIONS(1201),
    [anon_sym_RBRACE] = ACTIONS(1201),
    [anon_sym_PERCENT] = ACTIONS(1201),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1201),
    [anon_sym_as] = ACTIONS(1201),
    [anon_sym_DASH_DASH] = ACTIONS(1201),
    [anon_sym_instanceof] = ACTIONS(1201),
    [anon_sym_COLON] = ACTIONS(1201),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_STAR_STAR] = ACTIONS(1201),
    [anon_sym_PLUS_PLUS] = ACTIONS(1201),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_LBRACK] = ACTIONS(4227),
    [anon_sym_LT_LT] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(4230),
    [anon_sym_AMP_AMP] = ACTIONS(1201),
    [anon_sym_LBRACE] = ACTIONS(1751),
    [anon_sym_LT_EQ] = ACTIONS(1201),
    [anon_sym_LPAREN] = ACTIONS(1201),
    [anon_sym_RBRACK] = ACTIONS(1201),
    [anon_sym_GT] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1751),
    [anon_sym_QMARK] = ACTIONS(1201),
    [anon_sym_PIPE_PIPE] = ACTIONS(1201),
    [anon_sym_EQ_EQ] = ACTIONS(1751),
    [anon_sym_RPAREN] = ACTIONS(1201),
    [anon_sym_LT] = ACTIONS(4232),
    [anon_sym_SLASH] = ACTIONS(1751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1201),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_implements] = ACTIONS(1201),
    [anon_sym_GT_GT] = ACTIONS(1751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(4235),
  },
  [1606] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1861),
    [anon_sym_BQUOTE] = ACTIONS(1861),
    [anon_sym_PIPE] = ACTIONS(1863),
    [anon_sym_COMMA] = ACTIONS(1861),
    [anon_sym_DASH] = ACTIONS(1863),
    [anon_sym_STAR] = ACTIONS(1863),
    [anon_sym_GT_GT_GT] = ACTIONS(1861),
    [anon_sym_BANG_EQ] = ACTIONS(1863),
    [anon_sym_GT_EQ] = ACTIONS(1861),
    [anon_sym_RBRACE] = ACTIONS(1861),
    [anon_sym_PERCENT] = ACTIONS(1861),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1861),
    [anon_sym_as] = ACTIONS(1861),
    [anon_sym_DASH_DASH] = ACTIONS(1861),
    [anon_sym_instanceof] = ACTIONS(1861),
    [anon_sym_COLON] = ACTIONS(1861),
    [anon_sym_DOT] = ACTIONS(1861),
    [anon_sym_STAR_STAR] = ACTIONS(1861),
    [anon_sym_PLUS_PLUS] = ACTIONS(1861),
    [anon_sym_BANG] = ACTIONS(1863),
    [anon_sym_LBRACK] = ACTIONS(1861),
    [anon_sym_LT_LT] = ACTIONS(1861),
    [anon_sym_LBRACE] = ACTIONS(1863),
    [anon_sym_AMP_AMP] = ACTIONS(1861),
    [anon_sym_LT_EQ] = ACTIONS(1861),
    [anon_sym_LPAREN] = ACTIONS(1861),
    [anon_sym_RBRACK] = ACTIONS(1861),
    [anon_sym_GT] = ACTIONS(1863),
    [anon_sym_AMP] = ACTIONS(1863),
    [anon_sym_QMARK] = ACTIONS(1861),
    [anon_sym_PIPE_PIPE] = ACTIONS(1861),
    [anon_sym_EQ_EQ] = ACTIONS(1863),
    [anon_sym_RPAREN] = ACTIONS(1861),
    [anon_sym_LT] = ACTIONS(1863),
    [anon_sym_SLASH] = ACTIONS(1863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1861),
    [anon_sym_PLUS] = ACTIONS(1863),
    [anon_sym_implements] = ACTIONS(1861),
    [anon_sym_GT_GT] = ACTIONS(1863),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1861),
    [anon_sym_in] = ACTIONS(1863),
  },
  [1607] = {
    [anon_sym_BQUOTE] = ACTIONS(1865),
    [anon_sym_symbol] = ACTIONS(1867),
    [anon_sym_PIPE] = ACTIONS(1865),
    [anon_sym_break] = ACTIONS(1867),
    [anon_sym_return] = ACTIONS(1867),
    [anon_sym_RBRACE] = ACTIONS(1865),
    [anon_sym_interface] = ACTIONS(1867),
    [anon_sym_delete] = ACTIONS(1867),
    [anon_sym_if] = ACTIONS(1867),
    [anon_sym_yield] = ACTIONS(1867),
    [sym_true] = ACTIONS(1867),
    [anon_sym_COLON] = ACTIONS(1865),
    [anon_sym_protected] = ACTIONS(1867),
    [anon_sym_set] = ACTIONS(1867),
    [anon_sym_import] = ACTIONS(1867),
    [anon_sym_await] = ACTIONS(1867),
    [anon_sym_DQUOTE] = ACTIONS(1865),
    [anon_sym_for] = ACTIONS(1867),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_number] = ACTIONS(1867),
    [anon_sym_typeof] = ACTIONS(1867),
    [anon_sym_LBRACE] = ACTIONS(1865),
    [anon_sym_switch] = ACTIONS(1867),
    [anon_sym_RBRACK] = ACTIONS(1865),
    [sym_null] = ACTIONS(1867),
    [anon_sym_any] = ACTIONS(1867),
    [anon_sym_async] = ACTIONS(1867),
    [anon_sym_public] = ACTIONS(1867),
    [anon_sym_var] = ACTIONS(1867),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_while] = ACTIONS(1867),
    [anon_sym_SQUOTE] = ACTIONS(1865),
    [anon_sym_RPAREN] = ACTIONS(1865),
    [anon_sym_SLASH] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1867),
    [anon_sym_new] = ACTIONS(1867),
    [anon_sym_export] = ACTIONS(1867),
    [anon_sym_with] = ACTIONS(1867),
    [sym_identifier] = ACTIONS(1867),
    [anon_sym_debugger] = ACTIONS(1867),
    [anon_sym_AT] = ACTIONS(1865),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_DASH] = ACTIONS(1867),
    [anon_sym_EQ] = ACTIONS(1867),
    [anon_sym_void] = ACTIONS(1867),
    [anon_sym_const] = ACTIONS(1867),
    [sym_super] = ACTIONS(1867),
    [anon_sym_private] = ACTIONS(1867),
    [anon_sym_get] = ACTIONS(1867),
    [anon_sym_default] = ACTIONS(1867),
    [anon_sym_enum] = ACTIONS(1867),
    [anon_sym_continue] = ACTIONS(1867),
    [anon_sym_DASH_DASH] = ACTIONS(1865),
    [anon_sym_this] = ACTIONS(1867),
    [anon_sym_throw] = ACTIONS(1867),
    [anon_sym_abstract] = ACTIONS(1867),
    [anon_sym_type] = ACTIONS(1867),
    [anon_sym_namespace] = ACTIONS(1867),
    [anon_sym_PLUS_PLUS] = ACTIONS(1865),
    [anon_sym_else] = ACTIONS(1867),
    [anon_sym_BANG] = ACTIONS(1865),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [sym_false] = ACTIONS(1867),
    [anon_sym_case] = ACTIONS(1867),
    [anon_sym_module] = ACTIONS(1867),
    [anon_sym_class] = ACTIONS(1867),
    [anon_sym_declare] = ACTIONS(1867),
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_GT] = ACTIONS(1865),
    [anon_sym_boolean] = ACTIONS(1867),
    [anon_sym_EQ_GT] = ACTIONS(1865),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_try] = ACTIONS(1867),
    [anon_sym_LT] = ACTIONS(1865),
    [sym_number] = ACTIONS(1865),
    [ts_builtin_sym_end] = ACTIONS(1865),
    [anon_sym_function] = ACTIONS(1867),
    [sym_undefined] = ACTIONS(1867),
    [anon_sym_let] = ACTIONS(1867),
    [anon_sym_PLUS] = ACTIONS(1867),
    [anon_sym_do] = ACTIONS(1867),
    [anon_sym_TILDE] = ACTIONS(1865),
  },
  [1608] = {
    [sym_identifier] = ACTIONS(1960),
    [anon_sym_BQUOTE] = ACTIONS(1958),
    [anon_sym_debugger] = ACTIONS(1960),
    [anon_sym_symbol] = ACTIONS(1960),
    [anon_sym_AT] = ACTIONS(1958),
    [anon_sym_DASH] = ACTIONS(1960),
    [anon_sym_void] = ACTIONS(1960),
    [anon_sym_break] = ACTIONS(1960),
    [anon_sym_const] = ACTIONS(1960),
    [sym_super] = ACTIONS(1960),
    [anon_sym_return] = ACTIONS(1960),
    [anon_sym_private] = ACTIONS(1960),
    [anon_sym_get] = ACTIONS(1960),
    [anon_sym_RBRACE] = ACTIONS(1958),
    [anon_sym_interface] = ACTIONS(1960),
    [anon_sym_default] = ACTIONS(1960),
    [anon_sym_enum] = ACTIONS(1960),
    [anon_sym_delete] = ACTIONS(1960),
    [anon_sym_continue] = ACTIONS(1960),
    [anon_sym_DASH_DASH] = ACTIONS(1958),
    [anon_sym_if] = ACTIONS(1960),
    [anon_sym_this] = ACTIONS(1960),
    [anon_sym_yield] = ACTIONS(1960),
    [sym_true] = ACTIONS(1960),
    [anon_sym_throw] = ACTIONS(1960),
    [anon_sym_protected] = ACTIONS(1960),
    [anon_sym_abstract] = ACTIONS(1960),
    [anon_sym_set] = ACTIONS(1960),
    [anon_sym_type] = ACTIONS(1960),
    [anon_sym_import] = ACTIONS(1960),
    [anon_sym_namespace] = ACTIONS(1960),
    [anon_sym_PLUS_PLUS] = ACTIONS(1958),
    [anon_sym_await] = ACTIONS(1960),
    [anon_sym_DQUOTE] = ACTIONS(1958),
    [anon_sym_else] = ACTIONS(1960),
    [anon_sym_BANG] = ACTIONS(1958),
    [anon_sym_for] = ACTIONS(1960),
    [anon_sym_LBRACK] = ACTIONS(1958),
    [sym_false] = ACTIONS(1960),
    [anon_sym_SEMI] = ACTIONS(1958),
    [anon_sym_case] = ACTIONS(1960),
    [anon_sym_module] = ACTIONS(1960),
    [anon_sym_number] = ACTIONS(1960),
    [anon_sym_class] = ACTIONS(1960),
    [anon_sym_declare] = ACTIONS(1960),
    [anon_sym_typeof] = ACTIONS(1960),
    [anon_sym_LBRACE] = ACTIONS(1958),
    [anon_sym_switch] = ACTIONS(1960),
    [anon_sym_LPAREN] = ACTIONS(1958),
    [sym_null] = ACTIONS(1960),
    [anon_sym_any] = ACTIONS(1960),
    [anon_sym_boolean] = ACTIONS(1960),
    [anon_sym_async] = ACTIONS(1960),
    [anon_sym_public] = ACTIONS(1960),
    [anon_sym_var] = ACTIONS(1960),
    [anon_sym_while] = ACTIONS(1960),
    [anon_sym_SQUOTE] = ACTIONS(1958),
    [anon_sym_try] = ACTIONS(1960),
    [anon_sym_LT] = ACTIONS(1958),
    [sym_number] = ACTIONS(1958),
    [anon_sym_SLASH] = ACTIONS(1960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1960),
    [anon_sym_function] = ACTIONS(1960),
    [sym_undefined] = ACTIONS(1960),
    [anon_sym_new] = ACTIONS(1960),
    [ts_builtin_sym_end] = ACTIONS(1958),
    [anon_sym_let] = ACTIONS(1960),
    [anon_sym_PLUS] = ACTIONS(1960),
    [anon_sym_export] = ACTIONS(1960),
    [anon_sym_do] = ACTIONS(1960),
    [anon_sym_TILDE] = ACTIONS(1958),
    [anon_sym_with] = ACTIONS(1960),
  },
  [1609] = {
    [sym_identifier] = ACTIONS(1994),
    [anon_sym_BQUOTE] = ACTIONS(1992),
    [anon_sym_debugger] = ACTIONS(1994),
    [anon_sym_symbol] = ACTIONS(1994),
    [anon_sym_AT] = ACTIONS(1992),
    [anon_sym_DASH] = ACTIONS(1994),
    [anon_sym_void] = ACTIONS(1994),
    [anon_sym_break] = ACTIONS(1994),
    [anon_sym_const] = ACTIONS(1994),
    [sym_super] = ACTIONS(1994),
    [anon_sym_return] = ACTIONS(1994),
    [anon_sym_private] = ACTIONS(1994),
    [anon_sym_get] = ACTIONS(1994),
    [anon_sym_RBRACE] = ACTIONS(1992),
    [anon_sym_interface] = ACTIONS(1994),
    [anon_sym_default] = ACTIONS(1994),
    [anon_sym_enum] = ACTIONS(1994),
    [anon_sym_delete] = ACTIONS(1994),
    [anon_sym_continue] = ACTIONS(1994),
    [anon_sym_DASH_DASH] = ACTIONS(1992),
    [anon_sym_if] = ACTIONS(1994),
    [anon_sym_this] = ACTIONS(1994),
    [anon_sym_yield] = ACTIONS(1994),
    [sym_true] = ACTIONS(1994),
    [anon_sym_throw] = ACTIONS(1994),
    [anon_sym_protected] = ACTIONS(1994),
    [anon_sym_abstract] = ACTIONS(1994),
    [anon_sym_set] = ACTIONS(1994),
    [anon_sym_type] = ACTIONS(1994),
    [anon_sym_import] = ACTIONS(1994),
    [anon_sym_namespace] = ACTIONS(1994),
    [anon_sym_PLUS_PLUS] = ACTIONS(1992),
    [anon_sym_await] = ACTIONS(1994),
    [anon_sym_DQUOTE] = ACTIONS(1992),
    [anon_sym_else] = ACTIONS(1994),
    [anon_sym_BANG] = ACTIONS(1992),
    [anon_sym_for] = ACTIONS(1994),
    [anon_sym_LBRACK] = ACTIONS(1992),
    [sym_false] = ACTIONS(1994),
    [anon_sym_SEMI] = ACTIONS(1992),
    [anon_sym_case] = ACTIONS(1994),
    [anon_sym_module] = ACTIONS(1994),
    [anon_sym_number] = ACTIONS(1994),
    [anon_sym_class] = ACTIONS(1994),
    [anon_sym_declare] = ACTIONS(1994),
    [anon_sym_typeof] = ACTIONS(1994),
    [anon_sym_LBRACE] = ACTIONS(1992),
    [anon_sym_switch] = ACTIONS(1994),
    [anon_sym_LPAREN] = ACTIONS(1992),
    [sym_null] = ACTIONS(1994),
    [anon_sym_any] = ACTIONS(1994),
    [anon_sym_boolean] = ACTIONS(1994),
    [anon_sym_async] = ACTIONS(1994),
    [anon_sym_public] = ACTIONS(1994),
    [anon_sym_var] = ACTIONS(1994),
    [anon_sym_while] = ACTIONS(1994),
    [anon_sym_SQUOTE] = ACTIONS(1992),
    [anon_sym_try] = ACTIONS(1994),
    [anon_sym_LT] = ACTIONS(1992),
    [sym_number] = ACTIONS(1992),
    [anon_sym_SLASH] = ACTIONS(1994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1994),
    [anon_sym_function] = ACTIONS(1994),
    [sym_undefined] = ACTIONS(1994),
    [anon_sym_new] = ACTIONS(1994),
    [ts_builtin_sym_end] = ACTIONS(1992),
    [anon_sym_let] = ACTIONS(1994),
    [anon_sym_PLUS] = ACTIONS(1994),
    [anon_sym_export] = ACTIONS(1994),
    [anon_sym_do] = ACTIONS(1994),
    [anon_sym_TILDE] = ACTIONS(1992),
    [anon_sym_with] = ACTIONS(1994),
  },
  [1610] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2081),
    [anon_sym_BQUOTE] = ACTIONS(2081),
    [anon_sym_PIPE] = ACTIONS(2083),
    [anon_sym_COMMA] = ACTIONS(2081),
    [anon_sym_DASH] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2083),
    [anon_sym_GT_GT_GT] = ACTIONS(2081),
    [anon_sym_BANG_EQ] = ACTIONS(2083),
    [anon_sym_GT_EQ] = ACTIONS(2081),
    [anon_sym_RBRACE] = ACTIONS(2081),
    [anon_sym_PERCENT] = ACTIONS(2081),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2081),
    [anon_sym_as] = ACTIONS(2081),
    [anon_sym_DASH_DASH] = ACTIONS(2081),
    [anon_sym_instanceof] = ACTIONS(2081),
    [anon_sym_COLON] = ACTIONS(2081),
    [anon_sym_DOT] = ACTIONS(2081),
    [anon_sym_STAR_STAR] = ACTIONS(2081),
    [anon_sym_PLUS_PLUS] = ACTIONS(2081),
    [anon_sym_BANG] = ACTIONS(2083),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [anon_sym_LT_LT] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(2083),
    [anon_sym_AMP_AMP] = ACTIONS(2081),
    [anon_sym_LT_EQ] = ACTIONS(2081),
    [anon_sym_LPAREN] = ACTIONS(2081),
    [anon_sym_RBRACK] = ACTIONS(2081),
    [anon_sym_GT] = ACTIONS(2083),
    [anon_sym_AMP] = ACTIONS(2083),
    [anon_sym_QMARK] = ACTIONS(2081),
    [anon_sym_PIPE_PIPE] = ACTIONS(2081),
    [anon_sym_EQ_EQ] = ACTIONS(2083),
    [anon_sym_RPAREN] = ACTIONS(2081),
    [anon_sym_LT] = ACTIONS(2083),
    [anon_sym_SLASH] = ACTIONS(2083),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2081),
    [anon_sym_PLUS] = ACTIONS(2083),
    [anon_sym_implements] = ACTIONS(2081),
    [anon_sym_GT_GT] = ACTIONS(2083),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2081),
    [anon_sym_in] = ACTIONS(2083),
  },
  [1611] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1033),
    [anon_sym_BQUOTE] = ACTIONS(1033),
    [anon_sym_PIPE] = ACTIONS(1029),
    [anon_sym_COMMA] = ACTIONS(1033),
    [anon_sym_DASH] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1029),
    [anon_sym_GT_GT_GT] = ACTIONS(1033),
    [anon_sym_BANG_EQ] = ACTIONS(1029),
    [anon_sym_GT_EQ] = ACTIONS(1033),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_PERCENT] = ACTIONS(1033),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1033),
    [anon_sym_as] = ACTIONS(1033),
    [anon_sym_DASH_DASH] = ACTIONS(1033),
    [anon_sym_instanceof] = ACTIONS(1033),
    [anon_sym_COLON] = ACTIONS(1033),
    [anon_sym_DOT] = ACTIONS(1033),
    [anon_sym_STAR_STAR] = ACTIONS(1033),
    [anon_sym_PLUS_PLUS] = ACTIONS(1033),
    [anon_sym_BANG] = ACTIONS(1029),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [anon_sym_LT_LT] = ACTIONS(1033),
    [anon_sym_LBRACE] = ACTIONS(1029),
    [anon_sym_AMP_AMP] = ACTIONS(1033),
    [anon_sym_LT_EQ] = ACTIONS(1033),
    [anon_sym_LPAREN] = ACTIONS(1033),
    [anon_sym_RBRACK] = ACTIONS(1033),
    [anon_sym_GT] = ACTIONS(1029),
    [anon_sym_AMP] = ACTIONS(1029),
    [anon_sym_QMARK] = ACTIONS(1033),
    [anon_sym_PIPE_PIPE] = ACTIONS(1033),
    [anon_sym_EQ_EQ] = ACTIONS(1029),
    [anon_sym_RPAREN] = ACTIONS(1033),
    [anon_sym_LT] = ACTIONS(1029),
    [anon_sym_SLASH] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1033),
    [anon_sym_PLUS] = ACTIONS(1029),
    [anon_sym_implements] = ACTIONS(1033),
    [anon_sym_GT_GT] = ACTIONS(1029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1033),
    [anon_sym_in] = ACTIONS(1029),
  },
  [1612] = {
    [sym__type] = STATE(1640),
    [sym_constructor_type] = STATE(1640),
    [sym_index_type_query] = STATE(1604),
    [sym_lookup_type] = STATE(1604),
    [sym_this_type] = STATE(1604),
    [sym_flow_maybe_type] = STATE(1604),
    [sym_function_type] = STATE(1640),
    [sym_nested_identifier] = STATE(2424),
    [sym__primary_type] = STATE(1604),
    [sym_generic_type] = STATE(1604),
    [sym_mapped_type] = STATE(1604),
    [sym_literal_type] = STATE(1604),
    [sym_parenthesized_type] = STATE(1604),
    [sym_predefined_type] = STATE(1604),
    [sym_type_parameters] = STATE(2423),
    [sym_string] = STATE(1596),
    [sym_array_type] = STATE(1604),
    [sym_tuple_type] = STATE(1604),
    [sym_nested_type_identifier] = STATE(1603),
    [sym_type_predicate] = STATE(1604),
    [sym_type_query] = STATE(1604),
    [sym__number] = STATE(1596),
    [sym_existential_type] = STATE(1604),
    [sym_object_type] = STATE(1604),
    [sym_union_type] = STATE(1640),
    [sym_intersection_type] = STATE(1640),
    [sym_formal_parameters] = STATE(2110),
    [sym_identifier] = ACTIONS(4178),
    [sym_false] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_symbol] = ACTIONS(4184),
    [anon_sym_number] = ACTIONS(4184),
    [anon_sym_typeof] = ACTIONS(4186),
    [anon_sym_keyof] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4194),
    [anon_sym_PIPE] = ACTIONS(4206),
    [anon_sym_void] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(4184),
    [anon_sym_boolean] = ACTIONS(4184),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_this] = ACTIONS(4202),
    [sym_number] = ACTIONS(4204),
    [sym_true] = ACTIONS(4180),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [1613] = {
    [sym__type] = STATE(1641),
    [sym_constructor_type] = STATE(1641),
    [sym_index_type_query] = STATE(1604),
    [sym_lookup_type] = STATE(1604),
    [sym_this_type] = STATE(1604),
    [sym_flow_maybe_type] = STATE(1604),
    [sym_function_type] = STATE(1641),
    [sym_nested_identifier] = STATE(2424),
    [sym__primary_type] = STATE(1604),
    [sym_generic_type] = STATE(1604),
    [sym_mapped_type] = STATE(1604),
    [sym_literal_type] = STATE(1604),
    [sym_parenthesized_type] = STATE(1604),
    [sym_predefined_type] = STATE(1604),
    [sym_type_parameters] = STATE(2423),
    [sym_string] = STATE(1596),
    [sym_array_type] = STATE(1604),
    [sym_tuple_type] = STATE(1604),
    [sym_nested_type_identifier] = STATE(1603),
    [sym_type_predicate] = STATE(1604),
    [sym_type_query] = STATE(1604),
    [sym__number] = STATE(1596),
    [sym_existential_type] = STATE(1604),
    [sym_object_type] = STATE(1604),
    [sym_union_type] = STATE(1641),
    [sym_intersection_type] = STATE(1641),
    [sym_formal_parameters] = STATE(2110),
    [sym_identifier] = ACTIONS(4178),
    [sym_false] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_symbol] = ACTIONS(4184),
    [anon_sym_number] = ACTIONS(4184),
    [anon_sym_typeof] = ACTIONS(4186),
    [anon_sym_keyof] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4194),
    [anon_sym_PIPE] = ACTIONS(4206),
    [anon_sym_void] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(4184),
    [anon_sym_boolean] = ACTIONS(4184),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_this] = ACTIONS(4202),
    [sym_number] = ACTIONS(4204),
    [sym_true] = ACTIONS(4180),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [1614] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2223),
    [anon_sym_BQUOTE] = ACTIONS(2223),
    [anon_sym_PIPE] = ACTIONS(2225),
    [anon_sym_COMMA] = ACTIONS(2223),
    [anon_sym_DASH] = ACTIONS(2225),
    [anon_sym_STAR] = ACTIONS(2225),
    [anon_sym_GT_GT_GT] = ACTIONS(2223),
    [anon_sym_BANG_EQ] = ACTIONS(2225),
    [anon_sym_GT_EQ] = ACTIONS(2223),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_PERCENT] = ACTIONS(2223),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2223),
    [anon_sym_as] = ACTIONS(2223),
    [anon_sym_DASH_DASH] = ACTIONS(2223),
    [anon_sym_instanceof] = ACTIONS(2223),
    [anon_sym_COLON] = ACTIONS(2223),
    [anon_sym_DOT] = ACTIONS(2223),
    [anon_sym_STAR_STAR] = ACTIONS(2223),
    [anon_sym_PLUS_PLUS] = ACTIONS(2223),
    [anon_sym_BANG] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(2223),
    [anon_sym_LT_LT] = ACTIONS(2223),
    [anon_sym_LBRACE] = ACTIONS(2225),
    [anon_sym_AMP_AMP] = ACTIONS(2223),
    [anon_sym_LT_EQ] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(2223),
    [anon_sym_RBRACK] = ACTIONS(2223),
    [anon_sym_GT] = ACTIONS(2225),
    [anon_sym_AMP] = ACTIONS(2225),
    [anon_sym_QMARK] = ACTIONS(2223),
    [anon_sym_PIPE_PIPE] = ACTIONS(2223),
    [anon_sym_EQ_EQ] = ACTIONS(2225),
    [anon_sym_RPAREN] = ACTIONS(2223),
    [anon_sym_LT] = ACTIONS(2225),
    [anon_sym_SLASH] = ACTIONS(2225),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2223),
    [anon_sym_PLUS] = ACTIONS(2225),
    [anon_sym_implements] = ACTIONS(2223),
    [anon_sym_GT_GT] = ACTIONS(2225),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2223),
    [anon_sym_in] = ACTIONS(2225),
  },
  [1615] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2227),
    [anon_sym_BQUOTE] = ACTIONS(2227),
    [anon_sym_PIPE] = ACTIONS(2229),
    [anon_sym_COMMA] = ACTIONS(2227),
    [anon_sym_DASH] = ACTIONS(2229),
    [anon_sym_STAR] = ACTIONS(2229),
    [anon_sym_GT_GT_GT] = ACTIONS(2227),
    [anon_sym_BANG_EQ] = ACTIONS(2229),
    [anon_sym_GT_EQ] = ACTIONS(2227),
    [anon_sym_RBRACE] = ACTIONS(2227),
    [anon_sym_PERCENT] = ACTIONS(2227),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2227),
    [anon_sym_as] = ACTIONS(2227),
    [anon_sym_DASH_DASH] = ACTIONS(2227),
    [anon_sym_instanceof] = ACTIONS(2227),
    [anon_sym_COLON] = ACTIONS(2227),
    [anon_sym_DOT] = ACTIONS(2227),
    [anon_sym_STAR_STAR] = ACTIONS(2227),
    [anon_sym_PLUS_PLUS] = ACTIONS(2227),
    [anon_sym_BANG] = ACTIONS(2229),
    [anon_sym_LBRACK] = ACTIONS(4223),
    [anon_sym_LT_LT] = ACTIONS(2227),
    [anon_sym_LBRACE] = ACTIONS(2229),
    [anon_sym_AMP_AMP] = ACTIONS(2227),
    [anon_sym_LT_EQ] = ACTIONS(2227),
    [anon_sym_LPAREN] = ACTIONS(2227),
    [anon_sym_RBRACK] = ACTIONS(2227),
    [anon_sym_GT] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2229),
    [anon_sym_QMARK] = ACTIONS(2227),
    [anon_sym_PIPE_PIPE] = ACTIONS(2227),
    [anon_sym_EQ_EQ] = ACTIONS(2229),
    [anon_sym_RPAREN] = ACTIONS(2227),
    [anon_sym_LT] = ACTIONS(2229),
    [anon_sym_SLASH] = ACTIONS(2229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2227),
    [anon_sym_PLUS] = ACTIONS(2229),
    [anon_sym_implements] = ACTIONS(2227),
    [anon_sym_GT_GT] = ACTIONS(2229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2227),
    [anon_sym_in] = ACTIONS(2229),
  },
  [1616] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2245),
    [anon_sym_BQUOTE] = ACTIONS(2245),
    [anon_sym_PIPE] = ACTIONS(2247),
    [anon_sym_COMMA] = ACTIONS(2245),
    [anon_sym_DASH] = ACTIONS(2247),
    [anon_sym_STAR] = ACTIONS(2247),
    [anon_sym_GT_GT_GT] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(2247),
    [anon_sym_GT_EQ] = ACTIONS(2245),
    [anon_sym_RBRACE] = ACTIONS(2245),
    [anon_sym_PERCENT] = ACTIONS(2245),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2245),
    [anon_sym_as] = ACTIONS(2245),
    [anon_sym_DASH_DASH] = ACTIONS(2245),
    [anon_sym_instanceof] = ACTIONS(2245),
    [anon_sym_COLON] = ACTIONS(2245),
    [anon_sym_DOT] = ACTIONS(2245),
    [anon_sym_STAR_STAR] = ACTIONS(2245),
    [anon_sym_PLUS_PLUS] = ACTIONS(2245),
    [anon_sym_BANG] = ACTIONS(2247),
    [anon_sym_LBRACK] = ACTIONS(2245),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_LBRACE] = ACTIONS(2247),
    [anon_sym_AMP_AMP] = ACTIONS(2245),
    [anon_sym_LT_EQ] = ACTIONS(2245),
    [anon_sym_LPAREN] = ACTIONS(2245),
    [anon_sym_RBRACK] = ACTIONS(2245),
    [anon_sym_GT] = ACTIONS(2247),
    [anon_sym_AMP] = ACTIONS(2247),
    [anon_sym_QMARK] = ACTIONS(2245),
    [anon_sym_PIPE_PIPE] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_RPAREN] = ACTIONS(2245),
    [anon_sym_LT] = ACTIONS(2247),
    [anon_sym_SLASH] = ACTIONS(2247),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2247),
    [anon_sym_implements] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2247),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2245),
    [anon_sym_in] = ACTIONS(2247),
  },
  [1617] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2301),
    [anon_sym_BQUOTE] = ACTIONS(2301),
    [anon_sym_PIPE] = ACTIONS(2303),
    [anon_sym_COMMA] = ACTIONS(2301),
    [anon_sym_DASH] = ACTIONS(2303),
    [anon_sym_STAR] = ACTIONS(2303),
    [anon_sym_GT_GT_GT] = ACTIONS(2301),
    [anon_sym_BANG_EQ] = ACTIONS(2303),
    [anon_sym_GT_EQ] = ACTIONS(2301),
    [anon_sym_RBRACE] = ACTIONS(2301),
    [anon_sym_PERCENT] = ACTIONS(2301),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2301),
    [anon_sym_as] = ACTIONS(2301),
    [anon_sym_DASH_DASH] = ACTIONS(2301),
    [anon_sym_instanceof] = ACTIONS(2301),
    [anon_sym_COLON] = ACTIONS(2301),
    [anon_sym_DOT] = ACTIONS(2301),
    [anon_sym_STAR_STAR] = ACTIONS(2301),
    [anon_sym_PLUS_PLUS] = ACTIONS(2301),
    [anon_sym_BANG] = ACTIONS(2303),
    [anon_sym_LBRACK] = ACTIONS(2301),
    [anon_sym_LT_LT] = ACTIONS(2301),
    [anon_sym_LBRACE] = ACTIONS(2303),
    [anon_sym_AMP_AMP] = ACTIONS(2301),
    [anon_sym_LT_EQ] = ACTIONS(2301),
    [anon_sym_LPAREN] = ACTIONS(2301),
    [anon_sym_RBRACK] = ACTIONS(2301),
    [anon_sym_GT] = ACTIONS(2303),
    [anon_sym_AMP] = ACTIONS(2303),
    [anon_sym_QMARK] = ACTIONS(2301),
    [anon_sym_PIPE_PIPE] = ACTIONS(2301),
    [anon_sym_EQ_EQ] = ACTIONS(2303),
    [anon_sym_RPAREN] = ACTIONS(2301),
    [anon_sym_LT] = ACTIONS(2303),
    [anon_sym_SLASH] = ACTIONS(2303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2301),
    [anon_sym_PLUS] = ACTIONS(2303),
    [anon_sym_implements] = ACTIONS(2301),
    [anon_sym_GT_GT] = ACTIONS(2303),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2301),
    [anon_sym_in] = ACTIONS(2303),
  },
  [1618] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2305),
    [anon_sym_BQUOTE] = ACTIONS(2305),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_DASH] = ACTIONS(2307),
    [anon_sym_STAR] = ACTIONS(2307),
    [anon_sym_GT_GT_GT] = ACTIONS(2305),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_GT_EQ] = ACTIONS(2305),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_PERCENT] = ACTIONS(2305),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2305),
    [anon_sym_as] = ACTIONS(2305),
    [anon_sym_DASH_DASH] = ACTIONS(2305),
    [anon_sym_instanceof] = ACTIONS(2305),
    [anon_sym_COLON] = ACTIONS(2305),
    [anon_sym_DOT] = ACTIONS(4174),
    [anon_sym_STAR_STAR] = ACTIONS(2305),
    [anon_sym_PLUS_PLUS] = ACTIONS(2305),
    [anon_sym_BANG] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(2305),
    [anon_sym_LBRACE] = ACTIONS(2307),
    [anon_sym_AMP_AMP] = ACTIONS(2305),
    [anon_sym_LT_EQ] = ACTIONS(2305),
    [anon_sym_LPAREN] = ACTIONS(2305),
    [anon_sym_RBRACK] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_QMARK] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(2305),
    [anon_sym_EQ_EQ] = ACTIONS(2307),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_LT] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2307),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2305),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_implements] = ACTIONS(2305),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2305),
    [anon_sym_in] = ACTIONS(2307),
  },
  [1619] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2311),
    [anon_sym_BQUOTE] = ACTIONS(2311),
    [anon_sym_PIPE] = ACTIONS(2313),
    [anon_sym_COMMA] = ACTIONS(2311),
    [anon_sym_DASH] = ACTIONS(2313),
    [anon_sym_STAR] = ACTIONS(2313),
    [anon_sym_GT_GT_GT] = ACTIONS(2311),
    [anon_sym_BANG_EQ] = ACTIONS(2313),
    [anon_sym_GT_EQ] = ACTIONS(2311),
    [anon_sym_RBRACE] = ACTIONS(2311),
    [anon_sym_PERCENT] = ACTIONS(2311),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2311),
    [anon_sym_as] = ACTIONS(2311),
    [anon_sym_DASH_DASH] = ACTIONS(2311),
    [anon_sym_instanceof] = ACTIONS(2311),
    [anon_sym_COLON] = ACTIONS(2311),
    [anon_sym_DOT] = ACTIONS(2311),
    [anon_sym_STAR_STAR] = ACTIONS(2311),
    [anon_sym_PLUS_PLUS] = ACTIONS(2311),
    [anon_sym_BANG] = ACTIONS(2313),
    [anon_sym_LBRACK] = ACTIONS(2311),
    [anon_sym_LT_LT] = ACTIONS(2311),
    [anon_sym_LBRACE] = ACTIONS(2313),
    [anon_sym_AMP_AMP] = ACTIONS(2311),
    [anon_sym_LT_EQ] = ACTIONS(2311),
    [anon_sym_LPAREN] = ACTIONS(2311),
    [anon_sym_RBRACK] = ACTIONS(2311),
    [anon_sym_GT] = ACTIONS(2313),
    [anon_sym_AMP] = ACTIONS(2313),
    [anon_sym_QMARK] = ACTIONS(2311),
    [anon_sym_PIPE_PIPE] = ACTIONS(2311),
    [anon_sym_EQ_EQ] = ACTIONS(2313),
    [anon_sym_RPAREN] = ACTIONS(2311),
    [anon_sym_LT] = ACTIONS(2313),
    [anon_sym_SLASH] = ACTIONS(2313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2311),
    [anon_sym_PLUS] = ACTIONS(2313),
    [anon_sym_implements] = ACTIONS(2311),
    [anon_sym_GT_GT] = ACTIONS(2313),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2311),
    [anon_sym_in] = ACTIONS(2313),
  },
  [1620] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2315),
    [anon_sym_BQUOTE] = ACTIONS(2315),
    [anon_sym_PIPE] = ACTIONS(2317),
    [anon_sym_COMMA] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2317),
    [anon_sym_STAR] = ACTIONS(2317),
    [anon_sym_GT_GT_GT] = ACTIONS(2315),
    [anon_sym_BANG_EQ] = ACTIONS(2317),
    [anon_sym_GT_EQ] = ACTIONS(2315),
    [anon_sym_RBRACE] = ACTIONS(2315),
    [anon_sym_PERCENT] = ACTIONS(2315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2315),
    [anon_sym_as] = ACTIONS(2315),
    [anon_sym_DASH_DASH] = ACTIONS(2315),
    [anon_sym_instanceof] = ACTIONS(2315),
    [anon_sym_COLON] = ACTIONS(2315),
    [anon_sym_DOT] = ACTIONS(4225),
    [anon_sym_STAR_STAR] = ACTIONS(2315),
    [anon_sym_PLUS_PLUS] = ACTIONS(2315),
    [anon_sym_BANG] = ACTIONS(2317),
    [anon_sym_LBRACK] = ACTIONS(2315),
    [anon_sym_LT_LT] = ACTIONS(2315),
    [anon_sym_LBRACE] = ACTIONS(2317),
    [anon_sym_AMP_AMP] = ACTIONS(2315),
    [anon_sym_LT_EQ] = ACTIONS(2315),
    [anon_sym_LPAREN] = ACTIONS(2315),
    [anon_sym_RBRACK] = ACTIONS(2315),
    [anon_sym_GT] = ACTIONS(2317),
    [anon_sym_AMP] = ACTIONS(2317),
    [anon_sym_QMARK] = ACTIONS(2315),
    [anon_sym_PIPE_PIPE] = ACTIONS(2315),
    [anon_sym_EQ_EQ] = ACTIONS(2317),
    [anon_sym_RPAREN] = ACTIONS(2315),
    [anon_sym_LT] = ACTIONS(2317),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2315),
    [anon_sym_PLUS] = ACTIONS(2317),
    [anon_sym_implements] = ACTIONS(2315),
    [anon_sym_GT_GT] = ACTIONS(2317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2315),
    [anon_sym_in] = ACTIONS(2317),
  },
  [1621] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2319),
    [anon_sym_BQUOTE] = ACTIONS(2319),
    [anon_sym_PIPE] = ACTIONS(2321),
    [anon_sym_COMMA] = ACTIONS(2319),
    [anon_sym_DASH] = ACTIONS(2321),
    [anon_sym_STAR] = ACTIONS(2321),
    [anon_sym_GT_GT_GT] = ACTIONS(2319),
    [anon_sym_BANG_EQ] = ACTIONS(2321),
    [anon_sym_GT_EQ] = ACTIONS(2319),
    [anon_sym_RBRACE] = ACTIONS(2319),
    [anon_sym_PERCENT] = ACTIONS(2319),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2319),
    [anon_sym_as] = ACTIONS(2319),
    [anon_sym_DASH_DASH] = ACTIONS(2319),
    [anon_sym_instanceof] = ACTIONS(2319),
    [anon_sym_COLON] = ACTIONS(2319),
    [anon_sym_DOT] = ACTIONS(2319),
    [anon_sym_STAR_STAR] = ACTIONS(2319),
    [anon_sym_PLUS_PLUS] = ACTIONS(2319),
    [anon_sym_BANG] = ACTIONS(2321),
    [anon_sym_LBRACK] = ACTIONS(2319),
    [anon_sym_LT_LT] = ACTIONS(2319),
    [anon_sym_LBRACE] = ACTIONS(2321),
    [anon_sym_AMP_AMP] = ACTIONS(2319),
    [anon_sym_LT_EQ] = ACTIONS(2319),
    [anon_sym_LPAREN] = ACTIONS(2319),
    [anon_sym_RBRACK] = ACTIONS(2319),
    [anon_sym_GT] = ACTIONS(2321),
    [anon_sym_AMP] = ACTIONS(2321),
    [anon_sym_QMARK] = ACTIONS(2319),
    [anon_sym_PIPE_PIPE] = ACTIONS(2319),
    [anon_sym_EQ_EQ] = ACTIONS(2321),
    [anon_sym_RPAREN] = ACTIONS(2319),
    [anon_sym_LT] = ACTIONS(2321),
    [anon_sym_SLASH] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2319),
    [anon_sym_PLUS] = ACTIONS(2321),
    [anon_sym_implements] = ACTIONS(2319),
    [anon_sym_GT_GT] = ACTIONS(2321),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2319),
    [anon_sym_in] = ACTIONS(2321),
  },
  [1622] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(213),
    [anon_sym_PIPE] = ACTIONS(4063),
    [anon_sym_COMMA] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(213),
    [anon_sym_RBRACK] = ACTIONS(2383),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_DASH_DASH] = ACTIONS(213),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_SLASH] = ACTIONS(215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(215),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_PLUS_PLUS] = ACTIONS(213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(215),
  },
  [1623] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2388),
    [anon_sym_BQUOTE] = ACTIONS(2388),
    [anon_sym_PIPE] = ACTIONS(2390),
    [anon_sym_COMMA] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2390),
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_GT_GT_GT] = ACTIONS(2388),
    [anon_sym_BANG_EQ] = ACTIONS(2390),
    [anon_sym_GT_EQ] = ACTIONS(2388),
    [anon_sym_RBRACE] = ACTIONS(2388),
    [anon_sym_PERCENT] = ACTIONS(2388),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2388),
    [anon_sym_as] = ACTIONS(2388),
    [anon_sym_DASH_DASH] = ACTIONS(2388),
    [anon_sym_instanceof] = ACTIONS(2388),
    [anon_sym_COLON] = ACTIONS(2388),
    [anon_sym_DOT] = ACTIONS(2388),
    [anon_sym_STAR_STAR] = ACTIONS(2388),
    [anon_sym_PLUS_PLUS] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_LBRACK] = ACTIONS(2388),
    [anon_sym_LT_LT] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_AMP_AMP] = ACTIONS(2388),
    [anon_sym_LT_EQ] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2388),
    [anon_sym_RBRACK] = ACTIONS(2388),
    [anon_sym_GT] = ACTIONS(2390),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_QMARK] = ACTIONS(2388),
    [anon_sym_PIPE_PIPE] = ACTIONS(2388),
    [anon_sym_EQ_EQ] = ACTIONS(2390),
    [anon_sym_RPAREN] = ACTIONS(2388),
    [anon_sym_LT] = ACTIONS(2390),
    [anon_sym_SLASH] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2388),
    [anon_sym_PLUS] = ACTIONS(2390),
    [anon_sym_implements] = ACTIONS(2388),
    [anon_sym_GT_GT] = ACTIONS(2390),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2388),
    [anon_sym_in] = ACTIONS(2390),
  },
  [1624] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2392),
    [anon_sym_BQUOTE] = ACTIONS(2392),
    [anon_sym_PIPE] = ACTIONS(2394),
    [anon_sym_COMMA] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2394),
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_GT_GT_GT] = ACTIONS(2392),
    [anon_sym_BANG_EQ] = ACTIONS(2394),
    [anon_sym_GT_EQ] = ACTIONS(2392),
    [anon_sym_RBRACE] = ACTIONS(2392),
    [anon_sym_PERCENT] = ACTIONS(2392),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2392),
    [anon_sym_as] = ACTIONS(2392),
    [anon_sym_DASH_DASH] = ACTIONS(2392),
    [anon_sym_instanceof] = ACTIONS(2392),
    [anon_sym_COLON] = ACTIONS(2392),
    [anon_sym_DOT] = ACTIONS(2392),
    [anon_sym_STAR_STAR] = ACTIONS(2392),
    [anon_sym_PLUS_PLUS] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_LBRACK] = ACTIONS(2392),
    [anon_sym_LT_LT] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_AMP_AMP] = ACTIONS(2392),
    [anon_sym_LT_EQ] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2392),
    [anon_sym_RBRACK] = ACTIONS(2392),
    [anon_sym_GT] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_QMARK] = ACTIONS(2392),
    [anon_sym_PIPE_PIPE] = ACTIONS(2392),
    [anon_sym_EQ_EQ] = ACTIONS(2394),
    [anon_sym_RPAREN] = ACTIONS(2392),
    [anon_sym_LT] = ACTIONS(2394),
    [anon_sym_SLASH] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2392),
    [anon_sym_PLUS] = ACTIONS(2394),
    [anon_sym_implements] = ACTIONS(2392),
    [anon_sym_GT_GT] = ACTIONS(2394),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2392),
    [anon_sym_in] = ACTIONS(2394),
  },
  [1625] = {
    [sym__type] = STATE(1647),
    [sym_constructor_type] = STATE(1647),
    [sym_index_type_query] = STATE(1604),
    [sym_lookup_type] = STATE(1604),
    [sym_this_type] = STATE(1604),
    [sym_flow_maybe_type] = STATE(1604),
    [sym_function_type] = STATE(1647),
    [sym_nested_identifier] = STATE(2424),
    [sym__primary_type] = STATE(1604),
    [sym_generic_type] = STATE(1604),
    [sym_mapped_type] = STATE(1604),
    [sym_literal_type] = STATE(1604),
    [sym_parenthesized_type] = STATE(1604),
    [sym_predefined_type] = STATE(1604),
    [sym_type_parameters] = STATE(2423),
    [sym_string] = STATE(1596),
    [sym_array_type] = STATE(1604),
    [sym_tuple_type] = STATE(1604),
    [sym_nested_type_identifier] = STATE(1603),
    [sym_type_predicate] = STATE(1604),
    [sym_type_query] = STATE(1604),
    [sym__number] = STATE(1596),
    [sym_existential_type] = STATE(1604),
    [sym_object_type] = STATE(1604),
    [sym_union_type] = STATE(1647),
    [sym_intersection_type] = STATE(1647),
    [sym_formal_parameters] = STATE(2110),
    [sym_identifier] = ACTIONS(4178),
    [sym_false] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_symbol] = ACTIONS(4184),
    [anon_sym_number] = ACTIONS(4184),
    [anon_sym_typeof] = ACTIONS(4186),
    [anon_sym_keyof] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4194),
    [anon_sym_PIPE] = ACTIONS(4206),
    [anon_sym_void] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(4184),
    [anon_sym_boolean] = ACTIONS(4184),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_this] = ACTIONS(4202),
    [sym_number] = ACTIONS(4204),
    [sym_true] = ACTIONS(4180),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [1626] = {
    [sym__type] = STATE(1648),
    [sym_constructor_type] = STATE(1648),
    [sym_index_type_query] = STATE(1604),
    [sym_lookup_type] = STATE(1604),
    [sym_this_type] = STATE(1604),
    [sym_flow_maybe_type] = STATE(1604),
    [sym_function_type] = STATE(1648),
    [sym_nested_identifier] = STATE(2424),
    [sym__primary_type] = STATE(1604),
    [sym_generic_type] = STATE(1604),
    [sym_mapped_type] = STATE(1604),
    [sym_literal_type] = STATE(1604),
    [sym_parenthesized_type] = STATE(1604),
    [sym_predefined_type] = STATE(1604),
    [sym_type_parameters] = STATE(2423),
    [sym_string] = STATE(1596),
    [sym_array_type] = STATE(1604),
    [sym_tuple_type] = STATE(1604),
    [sym_nested_type_identifier] = STATE(1603),
    [sym_type_predicate] = STATE(1604),
    [sym_type_query] = STATE(1604),
    [sym__number] = STATE(1596),
    [sym_existential_type] = STATE(1604),
    [sym_object_type] = STATE(1604),
    [sym_union_type] = STATE(1648),
    [sym_intersection_type] = STATE(1648),
    [sym_formal_parameters] = STATE(2110),
    [sym_identifier] = ACTIONS(4178),
    [sym_false] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_symbol] = ACTIONS(4184),
    [anon_sym_number] = ACTIONS(4184),
    [anon_sym_typeof] = ACTIONS(4186),
    [anon_sym_keyof] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4194),
    [anon_sym_PIPE] = ACTIONS(4206),
    [anon_sym_void] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(4184),
    [anon_sym_boolean] = ACTIONS(4184),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_this] = ACTIONS(4202),
    [sym_number] = ACTIONS(4204),
    [sym_true] = ACTIONS(4180),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [1627] = {
    [sym__type] = STATE(1651),
    [sym_constructor_type] = STATE(1651),
    [sym_index_type_query] = STATE(1604),
    [sym_lookup_type] = STATE(1604),
    [sym_this_type] = STATE(1604),
    [sym_flow_maybe_type] = STATE(1604),
    [sym_function_type] = STATE(1651),
    [sym_nested_identifier] = STATE(2424),
    [sym__primary_type] = STATE(1604),
    [sym_generic_type] = STATE(1604),
    [sym_mapped_type] = STATE(1604),
    [sym_literal_type] = STATE(1604),
    [sym_parenthesized_type] = STATE(1604),
    [sym_predefined_type] = STATE(1604),
    [sym_type_parameters] = STATE(2423),
    [sym_string] = STATE(1596),
    [sym_array_type] = STATE(1604),
    [sym_tuple_type] = STATE(1604),
    [sym_nested_type_identifier] = STATE(1603),
    [sym_type_predicate] = STATE(1604),
    [sym_type_query] = STATE(1604),
    [sym__number] = STATE(1596),
    [sym_existential_type] = STATE(1604),
    [sym_object_type] = STATE(1604),
    [sym_union_type] = STATE(1651),
    [sym_intersection_type] = STATE(1651),
    [sym_formal_parameters] = STATE(2110),
    [sym_identifier] = ACTIONS(4178),
    [sym_false] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_symbol] = ACTIONS(4184),
    [anon_sym_number] = ACTIONS(4184),
    [anon_sym_typeof] = ACTIONS(4186),
    [anon_sym_keyof] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4194),
    [anon_sym_PIPE] = ACTIONS(4206),
    [anon_sym_void] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(4184),
    [anon_sym_boolean] = ACTIONS(4184),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_this] = ACTIONS(4202),
    [sym_number] = ACTIONS(4204),
    [sym_true] = ACTIONS(4180),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [1628] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2402),
    [anon_sym_BQUOTE] = ACTIONS(2402),
    [anon_sym_PIPE] = ACTIONS(2404),
    [anon_sym_COMMA] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2404),
    [anon_sym_STAR] = ACTIONS(2404),
    [anon_sym_GT_GT_GT] = ACTIONS(2402),
    [anon_sym_BANG_EQ] = ACTIONS(2404),
    [anon_sym_GT_EQ] = ACTIONS(2402),
    [anon_sym_RBRACE] = ACTIONS(2402),
    [anon_sym_PERCENT] = ACTIONS(2402),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2402),
    [anon_sym_as] = ACTIONS(2402),
    [anon_sym_DASH_DASH] = ACTIONS(2402),
    [anon_sym_instanceof] = ACTIONS(2402),
    [anon_sym_COLON] = ACTIONS(2402),
    [anon_sym_DOT] = ACTIONS(2402),
    [anon_sym_STAR_STAR] = ACTIONS(2402),
    [anon_sym_PLUS_PLUS] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2404),
    [anon_sym_LBRACK] = ACTIONS(2402),
    [anon_sym_LT_LT] = ACTIONS(2402),
    [anon_sym_LBRACE] = ACTIONS(2404),
    [anon_sym_AMP_AMP] = ACTIONS(2402),
    [anon_sym_LT_EQ] = ACTIONS(2402),
    [anon_sym_LPAREN] = ACTIONS(2402),
    [anon_sym_RBRACK] = ACTIONS(2402),
    [anon_sym_GT] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_QMARK] = ACTIONS(2402),
    [anon_sym_PIPE_PIPE] = ACTIONS(2402),
    [anon_sym_EQ_EQ] = ACTIONS(2404),
    [anon_sym_RPAREN] = ACTIONS(2402),
    [anon_sym_LT] = ACTIONS(2404),
    [anon_sym_SLASH] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2402),
    [anon_sym_PLUS] = ACTIONS(2404),
    [anon_sym_implements] = ACTIONS(2402),
    [anon_sym_GT_GT] = ACTIONS(2404),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2402),
    [anon_sym_in] = ACTIONS(2404),
  },
  [1629] = {
    [sym__type] = STATE(1653),
    [sym_constructor_type] = STATE(1653),
    [sym_index_type_query] = STATE(1604),
    [sym_lookup_type] = STATE(1604),
    [sym_this_type] = STATE(1604),
    [sym_flow_maybe_type] = STATE(1604),
    [sym_function_type] = STATE(1653),
    [sym_nested_identifier] = STATE(2424),
    [sym__primary_type] = STATE(1604),
    [sym_generic_type] = STATE(1604),
    [sym_mapped_type] = STATE(1604),
    [sym_literal_type] = STATE(1604),
    [sym_parenthesized_type] = STATE(1604),
    [sym_predefined_type] = STATE(1604),
    [sym_type_parameters] = STATE(2423),
    [sym_string] = STATE(1596),
    [sym_array_type] = STATE(1604),
    [sym_tuple_type] = STATE(1604),
    [sym_nested_type_identifier] = STATE(1603),
    [sym_type_predicate] = STATE(1604),
    [sym_type_query] = STATE(1604),
    [sym__number] = STATE(1596),
    [sym_existential_type] = STATE(1604),
    [sym_object_type] = STATE(1604),
    [sym_union_type] = STATE(1653),
    [sym_intersection_type] = STATE(1653),
    [sym_formal_parameters] = STATE(2110),
    [sym_identifier] = ACTIONS(4178),
    [sym_false] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_symbol] = ACTIONS(4184),
    [anon_sym_number] = ACTIONS(4184),
    [anon_sym_typeof] = ACTIONS(4186),
    [anon_sym_keyof] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4194),
    [anon_sym_PIPE] = ACTIONS(4206),
    [anon_sym_void] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(4184),
    [anon_sym_boolean] = ACTIONS(4184),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_this] = ACTIONS(4202),
    [sym_number] = ACTIONS(4204),
    [sym_true] = ACTIONS(4180),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [1630] = {
    [sym_identifier] = ACTIONS(2426),
    [anon_sym_BQUOTE] = ACTIONS(2424),
    [anon_sym_debugger] = ACTIONS(2426),
    [anon_sym_symbol] = ACTIONS(2426),
    [anon_sym_AT] = ACTIONS(2424),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_void] = ACTIONS(2426),
    [anon_sym_break] = ACTIONS(2426),
    [anon_sym_const] = ACTIONS(2426),
    [sym_super] = ACTIONS(2426),
    [anon_sym_return] = ACTIONS(2426),
    [anon_sym_private] = ACTIONS(2426),
    [anon_sym_get] = ACTIONS(2426),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_interface] = ACTIONS(2426),
    [anon_sym_default] = ACTIONS(2426),
    [anon_sym_enum] = ACTIONS(2426),
    [anon_sym_delete] = ACTIONS(2426),
    [anon_sym_continue] = ACTIONS(2426),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [anon_sym_if] = ACTIONS(2426),
    [anon_sym_this] = ACTIONS(2426),
    [anon_sym_yield] = ACTIONS(2426),
    [sym_true] = ACTIONS(2426),
    [anon_sym_throw] = ACTIONS(2426),
    [anon_sym_protected] = ACTIONS(2426),
    [anon_sym_abstract] = ACTIONS(2426),
    [anon_sym_set] = ACTIONS(2426),
    [anon_sym_type] = ACTIONS(2426),
    [anon_sym_import] = ACTIONS(2426),
    [anon_sym_namespace] = ACTIONS(2426),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_await] = ACTIONS(2426),
    [anon_sym_DQUOTE] = ACTIONS(2424),
    [anon_sym_else] = ACTIONS(2426),
    [anon_sym_BANG] = ACTIONS(2424),
    [anon_sym_for] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [sym_false] = ACTIONS(2426),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_case] = ACTIONS(2426),
    [anon_sym_module] = ACTIONS(2426),
    [anon_sym_number] = ACTIONS(2426),
    [anon_sym_class] = ACTIONS(2426),
    [anon_sym_declare] = ACTIONS(2426),
    [anon_sym_typeof] = ACTIONS(2426),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [anon_sym_switch] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [sym_null] = ACTIONS(2426),
    [anon_sym_any] = ACTIONS(2426),
    [anon_sym_boolean] = ACTIONS(2426),
    [anon_sym_async] = ACTIONS(2426),
    [anon_sym_public] = ACTIONS(2426),
    [anon_sym_var] = ACTIONS(2426),
    [anon_sym_while] = ACTIONS(2426),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [anon_sym_try] = ACTIONS(2426),
    [anon_sym_LT] = ACTIONS(2424),
    [sym_number] = ACTIONS(2424),
    [anon_sym_SLASH] = ACTIONS(2426),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2426),
    [anon_sym_function] = ACTIONS(2426),
    [sym_undefined] = ACTIONS(2426),
    [anon_sym_new] = ACTIONS(2426),
    [ts_builtin_sym_end] = ACTIONS(2424),
    [anon_sym_let] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_export] = ACTIONS(2426),
    [anon_sym_do] = ACTIONS(2426),
    [anon_sym_TILDE] = ACTIONS(2424),
    [anon_sym_with] = ACTIONS(2426),
  },
  [1631] = {
    [sym__initializer] = STATE(1211),
    [sym_type_arguments] = STATE(497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1307),
    [anon_sym_AMP_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_EQ] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(1307),
    [anon_sym_PIPE_EQ] = ACTIONS(1307),
    [anon_sym_DASH_EQ] = ACTIONS(1307),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(4238),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_is] = ACTIONS(1207),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_STAR_EQ] = ACTIONS(1307),
    [anon_sym_EQ_GT] = ACTIONS(2722),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1307),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4240),
  },
  [1632] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(1216),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1633] = {
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(2526),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1634] = {
    [sym_new_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(2350),
    [sym_update_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2350),
    [sym_yield_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_non_null_expression] = STATE(2350),
    [sym_internal_module] = STATE(2350),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2350),
    [sym_this] = STATE(2350),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2350),
    [sym_ternary_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2350),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(1323),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(1323),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_BANG] = ACTIONS(2730),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1323),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_GT] = ACTIONS(2526),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(1335),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_in] = ACTIONS(139),
  },
  [1635] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2652),
    [anon_sym_BQUOTE] = ACTIONS(2652),
    [anon_sym_PIPE] = ACTIONS(2654),
    [anon_sym_COMMA] = ACTIONS(2652),
    [anon_sym_DASH] = ACTIONS(2654),
    [anon_sym_STAR] = ACTIONS(2654),
    [anon_sym_GT_GT_GT] = ACTIONS(2652),
    [anon_sym_BANG_EQ] = ACTIONS(2654),
    [anon_sym_GT_EQ] = ACTIONS(2652),
    [anon_sym_RBRACE] = ACTIONS(2652),
    [anon_sym_PERCENT] = ACTIONS(2652),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2652),
    [anon_sym_as] = ACTIONS(2652),
    [anon_sym_DASH_DASH] = ACTIONS(2652),
    [anon_sym_instanceof] = ACTIONS(2652),
    [anon_sym_COLON] = ACTIONS(2652),
    [anon_sym_DOT] = ACTIONS(2652),
    [anon_sym_STAR_STAR] = ACTIONS(2652),
    [anon_sym_PLUS_PLUS] = ACTIONS(2652),
    [anon_sym_BANG] = ACTIONS(2654),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [anon_sym_LT_LT] = ACTIONS(2652),
    [anon_sym_LBRACE] = ACTIONS(2654),
    [anon_sym_AMP_AMP] = ACTIONS(2652),
    [anon_sym_LT_EQ] = ACTIONS(2652),
    [anon_sym_LPAREN] = ACTIONS(2652),
    [anon_sym_RBRACK] = ACTIONS(2652),
    [anon_sym_GT] = ACTIONS(2654),
    [anon_sym_AMP] = ACTIONS(2654),
    [anon_sym_QMARK] = ACTIONS(2652),
    [anon_sym_PIPE_PIPE] = ACTIONS(2652),
    [anon_sym_EQ_EQ] = ACTIONS(2654),
    [anon_sym_RPAREN] = ACTIONS(2652),
    [anon_sym_LT] = ACTIONS(2654),
    [anon_sym_SLASH] = ACTIONS(2654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2652),
    [anon_sym_PLUS] = ACTIONS(2654),
    [anon_sym_implements] = ACTIONS(2652),
    [anon_sym_GT_GT] = ACTIONS(2654),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2652),
    [anon_sym_in] = ACTIONS(2654),
  },
  [1636] = {
    [sym_identifier] = ACTIONS(2716),
    [anon_sym_BQUOTE] = ACTIONS(2714),
    [anon_sym_debugger] = ACTIONS(2716),
    [anon_sym_symbol] = ACTIONS(2716),
    [anon_sym_AT] = ACTIONS(2714),
    [anon_sym_DASH] = ACTIONS(2716),
    [anon_sym_void] = ACTIONS(2716),
    [anon_sym_break] = ACTIONS(2716),
    [anon_sym_const] = ACTIONS(2716),
    [sym_super] = ACTIONS(2716),
    [anon_sym_return] = ACTIONS(2716),
    [anon_sym_private] = ACTIONS(2716),
    [anon_sym_get] = ACTIONS(2716),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_interface] = ACTIONS(2716),
    [anon_sym_default] = ACTIONS(2716),
    [anon_sym_enum] = ACTIONS(2716),
    [anon_sym_delete] = ACTIONS(2716),
    [anon_sym_continue] = ACTIONS(2716),
    [anon_sym_DASH_DASH] = ACTIONS(2714),
    [anon_sym_if] = ACTIONS(2716),
    [anon_sym_this] = ACTIONS(2716),
    [anon_sym_yield] = ACTIONS(2716),
    [sym_true] = ACTIONS(2716),
    [anon_sym_throw] = ACTIONS(2716),
    [anon_sym_protected] = ACTIONS(2716),
    [anon_sym_abstract] = ACTIONS(2716),
    [anon_sym_set] = ACTIONS(2716),
    [anon_sym_type] = ACTIONS(2716),
    [anon_sym_import] = ACTIONS(2716),
    [anon_sym_namespace] = ACTIONS(2716),
    [anon_sym_PLUS_PLUS] = ACTIONS(2714),
    [anon_sym_await] = ACTIONS(2716),
    [anon_sym_DQUOTE] = ACTIONS(2714),
    [anon_sym_else] = ACTIONS(2716),
    [anon_sym_BANG] = ACTIONS(2714),
    [anon_sym_for] = ACTIONS(2716),
    [anon_sym_LBRACK] = ACTIONS(2714),
    [sym_false] = ACTIONS(2716),
    [anon_sym_SEMI] = ACTIONS(2714),
    [anon_sym_case] = ACTIONS(2716),
    [anon_sym_module] = ACTIONS(2716),
    [anon_sym_number] = ACTIONS(2716),
    [anon_sym_class] = ACTIONS(2716),
    [anon_sym_declare] = ACTIONS(2716),
    [anon_sym_typeof] = ACTIONS(2716),
    [anon_sym_LBRACE] = ACTIONS(2714),
    [anon_sym_switch] = ACTIONS(2716),
    [anon_sym_LPAREN] = ACTIONS(2714),
    [sym_null] = ACTIONS(2716),
    [anon_sym_any] = ACTIONS(2716),
    [anon_sym_boolean] = ACTIONS(2716),
    [anon_sym_async] = ACTIONS(2716),
    [anon_sym_public] = ACTIONS(2716),
    [anon_sym_var] = ACTIONS(2716),
    [anon_sym_while] = ACTIONS(2716),
    [anon_sym_SQUOTE] = ACTIONS(2714),
    [anon_sym_try] = ACTIONS(2716),
    [anon_sym_LT] = ACTIONS(2714),
    [sym_number] = ACTIONS(2714),
    [anon_sym_SLASH] = ACTIONS(2716),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2716),
    [anon_sym_function] = ACTIONS(2716),
    [sym_undefined] = ACTIONS(2716),
    [anon_sym_new] = ACTIONS(2716),
    [ts_builtin_sym_end] = ACTIONS(2714),
    [anon_sym_let] = ACTIONS(2716),
    [anon_sym_PLUS] = ACTIONS(2716),
    [anon_sym_export] = ACTIONS(2716),
    [anon_sym_do] = ACTIONS(2716),
    [anon_sym_TILDE] = ACTIONS(2714),
    [anon_sym_with] = ACTIONS(2716),
  },
  [1637] = {
    [sym_identifier] = ACTIONS(2786),
    [anon_sym_BQUOTE] = ACTIONS(2784),
    [anon_sym_debugger] = ACTIONS(2786),
    [anon_sym_symbol] = ACTIONS(2786),
    [anon_sym_AT] = ACTIONS(2784),
    [anon_sym_DASH] = ACTIONS(2786),
    [anon_sym_void] = ACTIONS(2786),
    [anon_sym_break] = ACTIONS(2786),
    [anon_sym_const] = ACTIONS(2786),
    [sym_super] = ACTIONS(2786),
    [anon_sym_return] = ACTIONS(2786),
    [anon_sym_private] = ACTIONS(2786),
    [anon_sym_get] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2784),
    [anon_sym_interface] = ACTIONS(2786),
    [anon_sym_default] = ACTIONS(2786),
    [anon_sym_enum] = ACTIONS(2786),
    [anon_sym_delete] = ACTIONS(2786),
    [anon_sym_continue] = ACTIONS(2786),
    [anon_sym_DASH_DASH] = ACTIONS(2784),
    [anon_sym_if] = ACTIONS(2786),
    [anon_sym_this] = ACTIONS(2786),
    [anon_sym_yield] = ACTIONS(2786),
    [sym_true] = ACTIONS(2786),
    [anon_sym_throw] = ACTIONS(2786),
    [anon_sym_protected] = ACTIONS(2786),
    [anon_sym_abstract] = ACTIONS(2786),
    [anon_sym_set] = ACTIONS(2786),
    [anon_sym_type] = ACTIONS(2786),
    [anon_sym_import] = ACTIONS(2786),
    [anon_sym_namespace] = ACTIONS(2786),
    [anon_sym_PLUS_PLUS] = ACTIONS(2784),
    [anon_sym_await] = ACTIONS(2786),
    [anon_sym_DQUOTE] = ACTIONS(2784),
    [anon_sym_else] = ACTIONS(2786),
    [anon_sym_BANG] = ACTIONS(2784),
    [anon_sym_for] = ACTIONS(2786),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [sym_false] = ACTIONS(2786),
    [anon_sym_SEMI] = ACTIONS(2784),
    [anon_sym_case] = ACTIONS(2786),
    [anon_sym_module] = ACTIONS(2786),
    [anon_sym_number] = ACTIONS(2786),
    [anon_sym_class] = ACTIONS(2786),
    [anon_sym_declare] = ACTIONS(2786),
    [anon_sym_typeof] = ACTIONS(2786),
    [anon_sym_LBRACE] = ACTIONS(2784),
    [anon_sym_switch] = ACTIONS(2786),
    [anon_sym_LPAREN] = ACTIONS(2784),
    [sym_null] = ACTIONS(2786),
    [anon_sym_any] = ACTIONS(2786),
    [anon_sym_boolean] = ACTIONS(2786),
    [anon_sym_async] = ACTIONS(2786),
    [anon_sym_public] = ACTIONS(2786),
    [anon_sym_var] = ACTIONS(2786),
    [anon_sym_while] = ACTIONS(2786),
    [anon_sym_SQUOTE] = ACTIONS(2784),
    [anon_sym_try] = ACTIONS(2786),
    [anon_sym_LT] = ACTIONS(2784),
    [sym_number] = ACTIONS(2784),
    [anon_sym_SLASH] = ACTIONS(2786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2786),
    [anon_sym_function] = ACTIONS(2786),
    [sym_undefined] = ACTIONS(2786),
    [anon_sym_new] = ACTIONS(2786),
    [ts_builtin_sym_end] = ACTIONS(2784),
    [anon_sym_let] = ACTIONS(2786),
    [anon_sym_PLUS] = ACTIONS(2786),
    [anon_sym_export] = ACTIONS(2786),
    [anon_sym_do] = ACTIONS(2786),
    [anon_sym_TILDE] = ACTIONS(2784),
    [anon_sym_with] = ACTIONS(2786),
  },
  [1638] = {
    [sym_identifier] = ACTIONS(2948),
    [anon_sym_BQUOTE] = ACTIONS(2946),
    [anon_sym_debugger] = ACTIONS(2948),
    [anon_sym_symbol] = ACTIONS(2948),
    [anon_sym_AT] = ACTIONS(2946),
    [anon_sym_DASH] = ACTIONS(2948),
    [anon_sym_void] = ACTIONS(2948),
    [anon_sym_break] = ACTIONS(2948),
    [anon_sym_const] = ACTIONS(2948),
    [sym_super] = ACTIONS(2948),
    [anon_sym_return] = ACTIONS(2948),
    [anon_sym_private] = ACTIONS(2948),
    [anon_sym_get] = ACTIONS(2948),
    [anon_sym_RBRACE] = ACTIONS(2946),
    [anon_sym_interface] = ACTIONS(2948),
    [anon_sym_default] = ACTIONS(2948),
    [anon_sym_enum] = ACTIONS(2948),
    [anon_sym_delete] = ACTIONS(2948),
    [anon_sym_continue] = ACTIONS(2948),
    [anon_sym_DASH_DASH] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2948),
    [anon_sym_this] = ACTIONS(2948),
    [anon_sym_yield] = ACTIONS(2948),
    [sym_true] = ACTIONS(2948),
    [anon_sym_throw] = ACTIONS(2948),
    [anon_sym_protected] = ACTIONS(2948),
    [anon_sym_abstract] = ACTIONS(2948),
    [anon_sym_set] = ACTIONS(2948),
    [anon_sym_type] = ACTIONS(2948),
    [anon_sym_import] = ACTIONS(2948),
    [anon_sym_namespace] = ACTIONS(2948),
    [anon_sym_PLUS_PLUS] = ACTIONS(2946),
    [anon_sym_await] = ACTIONS(2948),
    [anon_sym_DQUOTE] = ACTIONS(2946),
    [anon_sym_else] = ACTIONS(2948),
    [anon_sym_BANG] = ACTIONS(2946),
    [anon_sym_for] = ACTIONS(2948),
    [anon_sym_LBRACK] = ACTIONS(2946),
    [sym_false] = ACTIONS(2948),
    [anon_sym_SEMI] = ACTIONS(2946),
    [anon_sym_case] = ACTIONS(2948),
    [anon_sym_module] = ACTIONS(2948),
    [anon_sym_number] = ACTIONS(2948),
    [anon_sym_class] = ACTIONS(2948),
    [anon_sym_declare] = ACTIONS(2948),
    [anon_sym_typeof] = ACTIONS(2948),
    [anon_sym_LBRACE] = ACTIONS(2946),
    [anon_sym_switch] = ACTIONS(2948),
    [anon_sym_LPAREN] = ACTIONS(2946),
    [sym_null] = ACTIONS(2948),
    [anon_sym_any] = ACTIONS(2948),
    [anon_sym_boolean] = ACTIONS(2948),
    [anon_sym_async] = ACTIONS(2948),
    [anon_sym_public] = ACTIONS(2948),
    [anon_sym_var] = ACTIONS(2948),
    [anon_sym_while] = ACTIONS(2948),
    [anon_sym_SQUOTE] = ACTIONS(2946),
    [anon_sym_try] = ACTIONS(2948),
    [anon_sym_LT] = ACTIONS(2946),
    [sym_number] = ACTIONS(2946),
    [anon_sym_SLASH] = ACTIONS(2948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2948),
    [anon_sym_function] = ACTIONS(2948),
    [sym_undefined] = ACTIONS(2948),
    [anon_sym_new] = ACTIONS(2948),
    [ts_builtin_sym_end] = ACTIONS(2946),
    [anon_sym_let] = ACTIONS(2948),
    [anon_sym_PLUS] = ACTIONS(2948),
    [anon_sym_export] = ACTIONS(2948),
    [anon_sym_do] = ACTIONS(2948),
    [anon_sym_TILDE] = ACTIONS(2946),
    [anon_sym_with] = ACTIONS(2948),
  },
  [1639] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2974),
    [anon_sym_BQUOTE] = ACTIONS(2974),
    [anon_sym_PIPE] = ACTIONS(2976),
    [anon_sym_COMMA] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2976),
    [anon_sym_STAR] = ACTIONS(2976),
    [anon_sym_GT_GT_GT] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(2976),
    [anon_sym_GT_EQ] = ACTIONS(2974),
    [anon_sym_RBRACE] = ACTIONS(2974),
    [anon_sym_PERCENT] = ACTIONS(2974),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2974),
    [anon_sym_as] = ACTIONS(2974),
    [anon_sym_DASH_DASH] = ACTIONS(2974),
    [anon_sym_instanceof] = ACTIONS(2974),
    [anon_sym_COLON] = ACTIONS(2974),
    [anon_sym_DOT] = ACTIONS(4086),
    [anon_sym_STAR_STAR] = ACTIONS(2974),
    [anon_sym_PLUS_PLUS] = ACTIONS(2974),
    [anon_sym_BANG] = ACTIONS(2976),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [anon_sym_LT_LT] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(2976),
    [anon_sym_AMP_AMP] = ACTIONS(2974),
    [anon_sym_LT_EQ] = ACTIONS(2974),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_RBRACK] = ACTIONS(2974),
    [anon_sym_GT] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2976),
    [anon_sym_QMARK] = ACTIONS(2974),
    [anon_sym_PIPE_PIPE] = ACTIONS(2974),
    [anon_sym_EQ_EQ] = ACTIONS(2976),
    [anon_sym_RPAREN] = ACTIONS(2974),
    [anon_sym_LT] = ACTIONS(2976),
    [anon_sym_SLASH] = ACTIONS(2976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2974),
    [anon_sym_PLUS] = ACTIONS(2976),
    [anon_sym_implements] = ACTIONS(2974),
    [anon_sym_GT_GT] = ACTIONS(2976),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2974),
    [anon_sym_in] = ACTIONS(2976),
  },
  [1640] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2978),
    [anon_sym_BQUOTE] = ACTIONS(2978),
    [anon_sym_PIPE] = ACTIONS(4242),
    [anon_sym_COMMA] = ACTIONS(2978),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_STAR] = ACTIONS(2980),
    [anon_sym_GT_GT_GT] = ACTIONS(2978),
    [anon_sym_BANG_EQ] = ACTIONS(2980),
    [anon_sym_GT_EQ] = ACTIONS(2978),
    [anon_sym_RBRACE] = ACTIONS(2978),
    [anon_sym_PERCENT] = ACTIONS(2978),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2978),
    [anon_sym_as] = ACTIONS(2978),
    [anon_sym_DASH_DASH] = ACTIONS(2978),
    [anon_sym_instanceof] = ACTIONS(2978),
    [anon_sym_COLON] = ACTIONS(2978),
    [anon_sym_DOT] = ACTIONS(2978),
    [anon_sym_STAR_STAR] = ACTIONS(2978),
    [anon_sym_PLUS_PLUS] = ACTIONS(2978),
    [anon_sym_BANG] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [anon_sym_LT_LT] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(2980),
    [anon_sym_AMP_AMP] = ACTIONS(2978),
    [anon_sym_LT_EQ] = ACTIONS(2978),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [anon_sym_RBRACK] = ACTIONS(2978),
    [anon_sym_GT] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(2978),
    [anon_sym_PIPE_PIPE] = ACTIONS(2978),
    [anon_sym_EQ_EQ] = ACTIONS(2980),
    [anon_sym_RPAREN] = ACTIONS(2978),
    [anon_sym_LT] = ACTIONS(2980),
    [anon_sym_SLASH] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2978),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_implements] = ACTIONS(2978),
    [anon_sym_GT_GT] = ACTIONS(2980),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2978),
    [anon_sym_in] = ACTIONS(2980),
  },
  [1641] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2982),
    [anon_sym_BQUOTE] = ACTIONS(2982),
    [anon_sym_PIPE] = ACTIONS(4242),
    [anon_sym_COMMA] = ACTIONS(2982),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_STAR] = ACTIONS(2984),
    [anon_sym_GT_GT_GT] = ACTIONS(2982),
    [anon_sym_BANG_EQ] = ACTIONS(2984),
    [anon_sym_GT_EQ] = ACTIONS(2982),
    [anon_sym_RBRACE] = ACTIONS(2982),
    [anon_sym_PERCENT] = ACTIONS(2982),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2982),
    [anon_sym_as] = ACTIONS(2982),
    [anon_sym_DASH_DASH] = ACTIONS(2982),
    [anon_sym_instanceof] = ACTIONS(2982),
    [anon_sym_COLON] = ACTIONS(2982),
    [anon_sym_DOT] = ACTIONS(2982),
    [anon_sym_STAR_STAR] = ACTIONS(2982),
    [anon_sym_PLUS_PLUS] = ACTIONS(2982),
    [anon_sym_BANG] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [anon_sym_LT_LT] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(2984),
    [anon_sym_AMP_AMP] = ACTIONS(2982),
    [anon_sym_LT_EQ] = ACTIONS(2982),
    [anon_sym_LPAREN] = ACTIONS(2982),
    [anon_sym_RBRACK] = ACTIONS(2982),
    [anon_sym_GT] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(2982),
    [anon_sym_PIPE_PIPE] = ACTIONS(2982),
    [anon_sym_EQ_EQ] = ACTIONS(2984),
    [anon_sym_RPAREN] = ACTIONS(2982),
    [anon_sym_LT] = ACTIONS(2984),
    [anon_sym_SLASH] = ACTIONS(2984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(2982),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_implements] = ACTIONS(2982),
    [anon_sym_GT_GT] = ACTIONS(2984),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2982),
    [anon_sym_in] = ACTIONS(2984),
  },
  [1642] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3014),
    [anon_sym_BQUOTE] = ACTIONS(3014),
    [anon_sym_PIPE] = ACTIONS(3016),
    [anon_sym_COMMA] = ACTIONS(3014),
    [anon_sym_DASH] = ACTIONS(3016),
    [anon_sym_STAR] = ACTIONS(3016),
    [anon_sym_GT_GT_GT] = ACTIONS(3014),
    [anon_sym_BANG_EQ] = ACTIONS(3016),
    [anon_sym_GT_EQ] = ACTIONS(3014),
    [anon_sym_RBRACE] = ACTIONS(3014),
    [anon_sym_PERCENT] = ACTIONS(3014),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3014),
    [anon_sym_as] = ACTIONS(3014),
    [anon_sym_DASH_DASH] = ACTIONS(3014),
    [anon_sym_instanceof] = ACTIONS(3014),
    [anon_sym_COLON] = ACTIONS(3014),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_STAR_STAR] = ACTIONS(3014),
    [anon_sym_PLUS_PLUS] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3016),
    [anon_sym_LBRACK] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3014),
    [anon_sym_LBRACE] = ACTIONS(3016),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_LPAREN] = ACTIONS(3014),
    [anon_sym_RBRACK] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3016),
    [anon_sym_AMP] = ACTIONS(3016),
    [anon_sym_QMARK] = ACTIONS(3014),
    [anon_sym_PIPE_PIPE] = ACTIONS(3014),
    [anon_sym_EQ_EQ] = ACTIONS(3016),
    [anon_sym_RPAREN] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3016),
    [anon_sym_SLASH] = ACTIONS(3016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3016),
    [anon_sym_implements] = ACTIONS(3014),
    [anon_sym_GT_GT] = ACTIONS(3016),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3014),
    [anon_sym_in] = ACTIONS(3016),
  },
  [1643] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3018),
    [anon_sym_BQUOTE] = ACTIONS(3018),
    [anon_sym_PIPE] = ACTIONS(3020),
    [anon_sym_COMMA] = ACTIONS(3018),
    [anon_sym_DASH] = ACTIONS(3020),
    [anon_sym_STAR] = ACTIONS(3020),
    [anon_sym_GT_GT_GT] = ACTIONS(3018),
    [anon_sym_BANG_EQ] = ACTIONS(3020),
    [anon_sym_GT_EQ] = ACTIONS(3018),
    [anon_sym_RBRACE] = ACTIONS(3018),
    [anon_sym_PERCENT] = ACTIONS(3018),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3018),
    [anon_sym_as] = ACTIONS(3018),
    [anon_sym_DASH_DASH] = ACTIONS(3018),
    [anon_sym_instanceof] = ACTIONS(3018),
    [anon_sym_COLON] = ACTIONS(3018),
    [anon_sym_DOT] = ACTIONS(3018),
    [anon_sym_STAR_STAR] = ACTIONS(3018),
    [anon_sym_PLUS_PLUS] = ACTIONS(3018),
    [anon_sym_BANG] = ACTIONS(3020),
    [anon_sym_LBRACK] = ACTIONS(3018),
    [anon_sym_LT_LT] = ACTIONS(3018),
    [anon_sym_LBRACE] = ACTIONS(3020),
    [anon_sym_AMP_AMP] = ACTIONS(3018),
    [anon_sym_LT_EQ] = ACTIONS(3018),
    [anon_sym_LPAREN] = ACTIONS(3018),
    [anon_sym_RBRACK] = ACTIONS(3018),
    [anon_sym_GT] = ACTIONS(3020),
    [anon_sym_AMP] = ACTIONS(3020),
    [anon_sym_QMARK] = ACTIONS(3018),
    [anon_sym_PIPE_PIPE] = ACTIONS(3018),
    [anon_sym_EQ_EQ] = ACTIONS(3020),
    [anon_sym_RPAREN] = ACTIONS(3018),
    [anon_sym_LT] = ACTIONS(3020),
    [anon_sym_SLASH] = ACTIONS(3020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3018),
    [anon_sym_PLUS] = ACTIONS(3020),
    [anon_sym_implements] = ACTIONS(3018),
    [anon_sym_GT_GT] = ACTIONS(3020),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3018),
    [anon_sym_in] = ACTIONS(3020),
  },
  [1644] = {
    [sym__type] = STATE(1665),
    [sym_constructor_type] = STATE(1665),
    [sym_index_type_query] = STATE(1604),
    [sym_lookup_type] = STATE(1604),
    [sym_this_type] = STATE(1604),
    [sym_flow_maybe_type] = STATE(1604),
    [sym_function_type] = STATE(1665),
    [sym_nested_identifier] = STATE(2424),
    [sym__primary_type] = STATE(1604),
    [sym_generic_type] = STATE(1604),
    [sym_mapped_type] = STATE(1604),
    [sym_literal_type] = STATE(1604),
    [sym_parenthesized_type] = STATE(1604),
    [sym_predefined_type] = STATE(1604),
    [sym_type_parameters] = STATE(2423),
    [sym_string] = STATE(1596),
    [sym_array_type] = STATE(1604),
    [sym_tuple_type] = STATE(1604),
    [sym_nested_type_identifier] = STATE(1603),
    [sym_type_predicate] = STATE(1604),
    [sym_type_query] = STATE(1604),
    [sym__number] = STATE(1596),
    [sym_existential_type] = STATE(1604),
    [sym_object_type] = STATE(1604),
    [sym_union_type] = STATE(1665),
    [sym_intersection_type] = STATE(1665),
    [sym_formal_parameters] = STATE(2110),
    [sym_identifier] = ACTIONS(4178),
    [sym_false] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_symbol] = ACTIONS(4184),
    [anon_sym_number] = ACTIONS(4184),
    [anon_sym_typeof] = ACTIONS(4186),
    [anon_sym_keyof] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4194),
    [anon_sym_PIPE] = ACTIONS(4206),
    [anon_sym_void] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(4184),
    [anon_sym_boolean] = ACTIONS(4184),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_this] = ACTIONS(4202),
    [sym_number] = ACTIONS(4204),
    [sym_true] = ACTIONS(4180),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [1645] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_BQUOTE] = ACTIONS(1027),
    [anon_sym_PIPE] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(2245),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1031),
    [anon_sym_GT_GT_GT] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1031),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_COLON] = ACTIONS(1027),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_RBRACK] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1031),
    [anon_sym_AMP] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_RPAREN] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1031),
    [anon_sym_SLASH] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(1031),
  },
  [1646] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3076),
    [anon_sym_BQUOTE] = ACTIONS(3076),
    [anon_sym_PIPE] = ACTIONS(3078),
    [anon_sym_COMMA] = ACTIONS(3076),
    [anon_sym_DASH] = ACTIONS(3078),
    [anon_sym_STAR] = ACTIONS(3078),
    [anon_sym_GT_GT_GT] = ACTIONS(3076),
    [anon_sym_BANG_EQ] = ACTIONS(3078),
    [anon_sym_GT_EQ] = ACTIONS(3076),
    [anon_sym_RBRACE] = ACTIONS(3076),
    [anon_sym_PERCENT] = ACTIONS(3076),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3076),
    [anon_sym_as] = ACTIONS(3076),
    [anon_sym_DASH_DASH] = ACTIONS(3076),
    [anon_sym_instanceof] = ACTIONS(3076),
    [anon_sym_COLON] = ACTIONS(3076),
    [anon_sym_DOT] = ACTIONS(3076),
    [anon_sym_STAR_STAR] = ACTIONS(3076),
    [anon_sym_PLUS_PLUS] = ACTIONS(3076),
    [anon_sym_BANG] = ACTIONS(3078),
    [anon_sym_LBRACK] = ACTIONS(3076),
    [anon_sym_LT_LT] = ACTIONS(3076),
    [anon_sym_LBRACE] = ACTIONS(3078),
    [anon_sym_AMP_AMP] = ACTIONS(3076),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_LPAREN] = ACTIONS(3076),
    [anon_sym_RBRACK] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3078),
    [anon_sym_AMP] = ACTIONS(3078),
    [anon_sym_QMARK] = ACTIONS(3076),
    [anon_sym_PIPE_PIPE] = ACTIONS(3076),
    [anon_sym_EQ_EQ] = ACTIONS(3078),
    [anon_sym_RPAREN] = ACTIONS(3076),
    [anon_sym_LT] = ACTIONS(3078),
    [anon_sym_SLASH] = ACTIONS(3078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3076),
    [anon_sym_PLUS] = ACTIONS(3078),
    [anon_sym_implements] = ACTIONS(3076),
    [anon_sym_GT_GT] = ACTIONS(3078),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3076),
    [anon_sym_in] = ACTIONS(3078),
  },
  [1647] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3080),
    [anon_sym_BQUOTE] = ACTIONS(3080),
    [anon_sym_PIPE] = ACTIONS(3082),
    [anon_sym_COMMA] = ACTIONS(3080),
    [anon_sym_DASH] = ACTIONS(3082),
    [anon_sym_STAR] = ACTIONS(3082),
    [anon_sym_GT_GT_GT] = ACTIONS(3080),
    [anon_sym_BANG_EQ] = ACTIONS(3082),
    [anon_sym_GT_EQ] = ACTIONS(3080),
    [anon_sym_RBRACE] = ACTIONS(3080),
    [anon_sym_PERCENT] = ACTIONS(3080),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3080),
    [anon_sym_as] = ACTIONS(3080),
    [anon_sym_DASH_DASH] = ACTIONS(3080),
    [anon_sym_instanceof] = ACTIONS(3080),
    [anon_sym_COLON] = ACTIONS(3080),
    [anon_sym_DOT] = ACTIONS(3080),
    [anon_sym_STAR_STAR] = ACTIONS(3080),
    [anon_sym_PLUS_PLUS] = ACTIONS(3080),
    [anon_sym_BANG] = ACTIONS(3082),
    [anon_sym_LBRACK] = ACTIONS(3080),
    [anon_sym_LT_LT] = ACTIONS(3080),
    [anon_sym_LBRACE] = ACTIONS(3082),
    [anon_sym_AMP_AMP] = ACTIONS(3080),
    [anon_sym_LT_EQ] = ACTIONS(3080),
    [anon_sym_LPAREN] = ACTIONS(3080),
    [anon_sym_RBRACK] = ACTIONS(3080),
    [anon_sym_GT] = ACTIONS(3082),
    [anon_sym_AMP] = ACTIONS(3082),
    [anon_sym_QMARK] = ACTIONS(3080),
    [anon_sym_PIPE_PIPE] = ACTIONS(3080),
    [anon_sym_EQ_EQ] = ACTIONS(3082),
    [anon_sym_RPAREN] = ACTIONS(3080),
    [anon_sym_LT] = ACTIONS(3082),
    [anon_sym_SLASH] = ACTIONS(3082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3080),
    [anon_sym_PLUS] = ACTIONS(3082),
    [anon_sym_implements] = ACTIONS(3080),
    [anon_sym_GT_GT] = ACTIONS(3082),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3080),
    [anon_sym_in] = ACTIONS(3082),
  },
  [1648] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3084),
    [anon_sym_BQUOTE] = ACTIONS(3084),
    [anon_sym_PIPE] = ACTIONS(3086),
    [anon_sym_COMMA] = ACTIONS(3084),
    [anon_sym_DASH] = ACTIONS(3086),
    [anon_sym_STAR] = ACTIONS(3086),
    [anon_sym_GT_GT_GT] = ACTIONS(3084),
    [anon_sym_BANG_EQ] = ACTIONS(3086),
    [anon_sym_GT_EQ] = ACTIONS(3084),
    [anon_sym_RBRACE] = ACTIONS(3084),
    [anon_sym_PERCENT] = ACTIONS(3084),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3084),
    [anon_sym_as] = ACTIONS(3084),
    [anon_sym_DASH_DASH] = ACTIONS(3084),
    [anon_sym_instanceof] = ACTIONS(3084),
    [anon_sym_COLON] = ACTIONS(3084),
    [anon_sym_DOT] = ACTIONS(3084),
    [anon_sym_STAR_STAR] = ACTIONS(3084),
    [anon_sym_PLUS_PLUS] = ACTIONS(3084),
    [anon_sym_BANG] = ACTIONS(3086),
    [anon_sym_LBRACK] = ACTIONS(3084),
    [anon_sym_LT_LT] = ACTIONS(3084),
    [anon_sym_LBRACE] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3084),
    [anon_sym_LT_EQ] = ACTIONS(3084),
    [anon_sym_LPAREN] = ACTIONS(3084),
    [anon_sym_RBRACK] = ACTIONS(3084),
    [anon_sym_GT] = ACTIONS(3086),
    [anon_sym_AMP] = ACTIONS(3086),
    [anon_sym_QMARK] = ACTIONS(3084),
    [anon_sym_PIPE_PIPE] = ACTIONS(3084),
    [anon_sym_EQ_EQ] = ACTIONS(3086),
    [anon_sym_RPAREN] = ACTIONS(3084),
    [anon_sym_LT] = ACTIONS(3086),
    [anon_sym_SLASH] = ACTIONS(3086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3084),
    [anon_sym_PLUS] = ACTIONS(3086),
    [anon_sym_implements] = ACTIONS(3084),
    [anon_sym_GT_GT] = ACTIONS(3086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3084),
    [anon_sym_in] = ACTIONS(3086),
  },
  [1649] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3088),
    [anon_sym_BQUOTE] = ACTIONS(3088),
    [anon_sym_PIPE] = ACTIONS(3090),
    [anon_sym_COMMA] = ACTIONS(3088),
    [anon_sym_DASH] = ACTIONS(3090),
    [anon_sym_STAR] = ACTIONS(3090),
    [anon_sym_GT_GT_GT] = ACTIONS(3088),
    [anon_sym_BANG_EQ] = ACTIONS(3090),
    [anon_sym_GT_EQ] = ACTIONS(3088),
    [anon_sym_RBRACE] = ACTIONS(3088),
    [anon_sym_PERCENT] = ACTIONS(3088),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3088),
    [anon_sym_as] = ACTIONS(3088),
    [anon_sym_DASH_DASH] = ACTIONS(3088),
    [anon_sym_instanceof] = ACTIONS(3088),
    [anon_sym_COLON] = ACTIONS(3088),
    [anon_sym_DOT] = ACTIONS(3088),
    [anon_sym_STAR_STAR] = ACTIONS(3088),
    [anon_sym_PLUS_PLUS] = ACTIONS(3088),
    [anon_sym_BANG] = ACTIONS(3090),
    [anon_sym_LBRACK] = ACTIONS(3088),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_LBRACE] = ACTIONS(3090),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_LT_EQ] = ACTIONS(3088),
    [anon_sym_LPAREN] = ACTIONS(3088),
    [anon_sym_RBRACK] = ACTIONS(3088),
    [anon_sym_GT] = ACTIONS(3090),
    [anon_sym_AMP] = ACTIONS(3090),
    [anon_sym_QMARK] = ACTIONS(3088),
    [anon_sym_PIPE_PIPE] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(3090),
    [anon_sym_RPAREN] = ACTIONS(3088),
    [anon_sym_LT] = ACTIONS(3090),
    [anon_sym_SLASH] = ACTIONS(3090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3088),
    [anon_sym_PLUS] = ACTIONS(3090),
    [anon_sym_implements] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3090),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3088),
    [anon_sym_in] = ACTIONS(3090),
  },
  [1650] = {
    [sym__type] = STATE(1668),
    [sym_constructor_type] = STATE(1668),
    [sym_index_type_query] = STATE(1604),
    [sym_lookup_type] = STATE(1604),
    [sym_this_type] = STATE(1604),
    [sym_flow_maybe_type] = STATE(1604),
    [sym_function_type] = STATE(1668),
    [sym_nested_identifier] = STATE(2424),
    [sym__primary_type] = STATE(1604),
    [sym_generic_type] = STATE(1604),
    [sym_mapped_type] = STATE(1604),
    [sym_literal_type] = STATE(1604),
    [sym_parenthesized_type] = STATE(1604),
    [sym_predefined_type] = STATE(1604),
    [sym_type_parameters] = STATE(2423),
    [sym_string] = STATE(1596),
    [sym_array_type] = STATE(1604),
    [sym_tuple_type] = STATE(1604),
    [sym_nested_type_identifier] = STATE(1603),
    [sym_type_predicate] = STATE(1604),
    [sym_type_query] = STATE(1604),
    [sym__number] = STATE(1596),
    [sym_existential_type] = STATE(1604),
    [sym_object_type] = STATE(1604),
    [sym_union_type] = STATE(1668),
    [sym_intersection_type] = STATE(1668),
    [sym_formal_parameters] = STATE(2110),
    [sym_identifier] = ACTIONS(4178),
    [sym_false] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_symbol] = ACTIONS(4184),
    [anon_sym_number] = ACTIONS(4184),
    [anon_sym_typeof] = ACTIONS(4186),
    [anon_sym_keyof] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4194),
    [anon_sym_PIPE] = ACTIONS(4206),
    [anon_sym_void] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(4184),
    [anon_sym_boolean] = ACTIONS(4184),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_this] = ACTIONS(4202),
    [sym_number] = ACTIONS(4204),
    [sym_true] = ACTIONS(4180),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [1651] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3099),
    [anon_sym_BQUOTE] = ACTIONS(3099),
    [anon_sym_PIPE] = ACTIONS(4242),
    [anon_sym_COMMA] = ACTIONS(3099),
    [anon_sym_DASH] = ACTIONS(3101),
    [anon_sym_STAR] = ACTIONS(3101),
    [anon_sym_GT_GT_GT] = ACTIONS(3099),
    [anon_sym_BANG_EQ] = ACTIONS(3101),
    [anon_sym_GT_EQ] = ACTIONS(3099),
    [anon_sym_RBRACE] = ACTIONS(3099),
    [anon_sym_PERCENT] = ACTIONS(3099),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3099),
    [anon_sym_as] = ACTIONS(3099),
    [anon_sym_DASH_DASH] = ACTIONS(3099),
    [anon_sym_instanceof] = ACTIONS(3099),
    [anon_sym_COLON] = ACTIONS(3099),
    [anon_sym_DOT] = ACTIONS(3099),
    [anon_sym_STAR_STAR] = ACTIONS(3099),
    [anon_sym_PLUS_PLUS] = ACTIONS(3099),
    [anon_sym_BANG] = ACTIONS(3101),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [anon_sym_LT_LT] = ACTIONS(3099),
    [anon_sym_LBRACE] = ACTIONS(3101),
    [anon_sym_AMP_AMP] = ACTIONS(3099),
    [anon_sym_LT_EQ] = ACTIONS(3099),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [anon_sym_RBRACK] = ACTIONS(3099),
    [anon_sym_GT] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(3099),
    [anon_sym_PIPE_PIPE] = ACTIONS(3099),
    [anon_sym_EQ_EQ] = ACTIONS(3101),
    [anon_sym_RPAREN] = ACTIONS(3099),
    [anon_sym_LT] = ACTIONS(3101),
    [anon_sym_SLASH] = ACTIONS(3101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3099),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_implements] = ACTIONS(3099),
    [anon_sym_GT_GT] = ACTIONS(3101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3099),
    [anon_sym_in] = ACTIONS(3101),
  },
  [1652] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3116),
    [anon_sym_BQUOTE] = ACTIONS(3116),
    [anon_sym_PIPE] = ACTIONS(3118),
    [anon_sym_COMMA] = ACTIONS(3116),
    [anon_sym_DASH] = ACTIONS(3118),
    [anon_sym_STAR] = ACTIONS(3118),
    [anon_sym_GT_GT_GT] = ACTIONS(3116),
    [anon_sym_BANG_EQ] = ACTIONS(3118),
    [anon_sym_GT_EQ] = ACTIONS(3116),
    [anon_sym_RBRACE] = ACTIONS(3116),
    [anon_sym_PERCENT] = ACTIONS(3116),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3116),
    [anon_sym_as] = ACTIONS(3116),
    [anon_sym_DASH_DASH] = ACTIONS(3116),
    [anon_sym_instanceof] = ACTIONS(3116),
    [anon_sym_COLON] = ACTIONS(3116),
    [anon_sym_DOT] = ACTIONS(3116),
    [anon_sym_STAR_STAR] = ACTIONS(3116),
    [anon_sym_PLUS_PLUS] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_LBRACK] = ACTIONS(3116),
    [anon_sym_LT_LT] = ACTIONS(3116),
    [anon_sym_LBRACE] = ACTIONS(3118),
    [anon_sym_AMP_AMP] = ACTIONS(3116),
    [anon_sym_LT_EQ] = ACTIONS(3116),
    [anon_sym_LPAREN] = ACTIONS(3116),
    [anon_sym_RBRACK] = ACTIONS(3116),
    [anon_sym_GT] = ACTIONS(3118),
    [anon_sym_AMP] = ACTIONS(3118),
    [anon_sym_QMARK] = ACTIONS(3116),
    [anon_sym_PIPE_PIPE] = ACTIONS(3116),
    [anon_sym_EQ_EQ] = ACTIONS(3118),
    [anon_sym_RPAREN] = ACTIONS(3116),
    [anon_sym_LT] = ACTIONS(3118),
    [anon_sym_SLASH] = ACTIONS(3118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3116),
    [anon_sym_PLUS] = ACTIONS(3118),
    [anon_sym_implements] = ACTIONS(3116),
    [anon_sym_GT_GT] = ACTIONS(3118),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3116),
    [anon_sym_in] = ACTIONS(3118),
  },
  [1653] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3120),
    [anon_sym_BQUOTE] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(4242),
    [anon_sym_COMMA] = ACTIONS(3120),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_STAR] = ACTIONS(3122),
    [anon_sym_GT_GT_GT] = ACTIONS(3120),
    [anon_sym_BANG_EQ] = ACTIONS(3122),
    [anon_sym_GT_EQ] = ACTIONS(3120),
    [anon_sym_RBRACE] = ACTIONS(3120),
    [anon_sym_PERCENT] = ACTIONS(3120),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3120),
    [anon_sym_as] = ACTIONS(3120),
    [anon_sym_DASH_DASH] = ACTIONS(3120),
    [anon_sym_instanceof] = ACTIONS(3120),
    [anon_sym_COLON] = ACTIONS(3120),
    [anon_sym_DOT] = ACTIONS(3120),
    [anon_sym_STAR_STAR] = ACTIONS(3120),
    [anon_sym_PLUS_PLUS] = ACTIONS(3120),
    [anon_sym_BANG] = ACTIONS(3122),
    [anon_sym_LBRACK] = ACTIONS(3120),
    [anon_sym_LT_LT] = ACTIONS(3120),
    [anon_sym_LBRACE] = ACTIONS(3122),
    [anon_sym_AMP_AMP] = ACTIONS(3120),
    [anon_sym_LT_EQ] = ACTIONS(3120),
    [anon_sym_LPAREN] = ACTIONS(3120),
    [anon_sym_RBRACK] = ACTIONS(3120),
    [anon_sym_GT] = ACTIONS(3122),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(3120),
    [anon_sym_PIPE_PIPE] = ACTIONS(3120),
    [anon_sym_EQ_EQ] = ACTIONS(3122),
    [anon_sym_RPAREN] = ACTIONS(3120),
    [anon_sym_LT] = ACTIONS(3122),
    [anon_sym_SLASH] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3120),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_implements] = ACTIONS(3120),
    [anon_sym_GT_GT] = ACTIONS(3122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3120),
    [anon_sym_in] = ACTIONS(3122),
  },
  [1654] = {
    [sym_identifier] = ACTIONS(3134),
    [anon_sym_BQUOTE] = ACTIONS(3132),
    [anon_sym_debugger] = ACTIONS(3134),
    [anon_sym_symbol] = ACTIONS(3134),
    [anon_sym_AT] = ACTIONS(3132),
    [anon_sym_DASH] = ACTIONS(3134),
    [anon_sym_void] = ACTIONS(3134),
    [anon_sym_break] = ACTIONS(3134),
    [anon_sym_const] = ACTIONS(3134),
    [sym_super] = ACTIONS(3134),
    [anon_sym_return] = ACTIONS(3134),
    [anon_sym_private] = ACTIONS(3134),
    [anon_sym_get] = ACTIONS(3134),
    [anon_sym_RBRACE] = ACTIONS(3132),
    [anon_sym_interface] = ACTIONS(3134),
    [anon_sym_default] = ACTIONS(3134),
    [anon_sym_enum] = ACTIONS(3134),
    [anon_sym_delete] = ACTIONS(3134),
    [anon_sym_continue] = ACTIONS(3134),
    [anon_sym_DASH_DASH] = ACTIONS(3132),
    [anon_sym_if] = ACTIONS(3134),
    [anon_sym_this] = ACTIONS(3134),
    [anon_sym_yield] = ACTIONS(3134),
    [sym_true] = ACTIONS(3134),
    [anon_sym_throw] = ACTIONS(3134),
    [anon_sym_protected] = ACTIONS(3134),
    [anon_sym_abstract] = ACTIONS(3134),
    [anon_sym_set] = ACTIONS(3134),
    [anon_sym_type] = ACTIONS(3134),
    [anon_sym_import] = ACTIONS(3134),
    [anon_sym_namespace] = ACTIONS(3134),
    [anon_sym_PLUS_PLUS] = ACTIONS(3132),
    [anon_sym_await] = ACTIONS(3134),
    [anon_sym_DQUOTE] = ACTIONS(3132),
    [anon_sym_else] = ACTIONS(3134),
    [anon_sym_BANG] = ACTIONS(3132),
    [anon_sym_for] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(3132),
    [sym_false] = ACTIONS(3134),
    [anon_sym_SEMI] = ACTIONS(3132),
    [anon_sym_case] = ACTIONS(3134),
    [anon_sym_module] = ACTIONS(3134),
    [anon_sym_number] = ACTIONS(3134),
    [anon_sym_class] = ACTIONS(3134),
    [anon_sym_declare] = ACTIONS(3134),
    [anon_sym_typeof] = ACTIONS(3134),
    [anon_sym_LBRACE] = ACTIONS(3132),
    [anon_sym_switch] = ACTIONS(3134),
    [anon_sym_LPAREN] = ACTIONS(3132),
    [sym_null] = ACTIONS(3134),
    [anon_sym_any] = ACTIONS(3134),
    [anon_sym_boolean] = ACTIONS(3134),
    [anon_sym_async] = ACTIONS(3134),
    [anon_sym_public] = ACTIONS(3134),
    [anon_sym_var] = ACTIONS(3134),
    [anon_sym_while] = ACTIONS(3134),
    [anon_sym_SQUOTE] = ACTIONS(3132),
    [anon_sym_try] = ACTIONS(3134),
    [anon_sym_LT] = ACTIONS(3132),
    [sym_number] = ACTIONS(3132),
    [anon_sym_SLASH] = ACTIONS(3134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3134),
    [anon_sym_function] = ACTIONS(3134),
    [sym_undefined] = ACTIONS(3134),
    [anon_sym_new] = ACTIONS(3134),
    [ts_builtin_sym_end] = ACTIONS(3132),
    [anon_sym_let] = ACTIONS(3134),
    [anon_sym_PLUS] = ACTIONS(3134),
    [anon_sym_export] = ACTIONS(3134),
    [anon_sym_do] = ACTIONS(3134),
    [anon_sym_TILDE] = ACTIONS(3132),
    [anon_sym_with] = ACTIONS(3134),
  },
  [1655] = {
    [sym_new_expression] = STATE(1969),
    [sym_constructor_type] = STATE(754),
    [sym_augmented_assignment_expression] = STATE(1969),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(1969),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(1969),
    [sym_call_signature] = STATE(2379),
    [sym_yield_expression] = STATE(1969),
    [sym_as_expression] = STATE(1969),
    [sym_internal_module] = STATE(1969),
    [sym_arrow_function] = STATE(1969),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(2521),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1632),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(2522),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(1969),
    [sym_subscript_expression] = STATE(2521),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(1969),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(1969),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(754),
    [sym__type] = STATE(754),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(1969),
    [sym_meta_property] = STATE(1969),
    [sym_function_type] = STATE(754),
    [sym__expression] = STATE(1969),
    [sym_non_null_expression] = STATE(1969),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(1969),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(1969),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(1969),
    [sym_call_expression] = STATE(1969),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(1969),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(1969),
    [sym_type_arguments] = STATE(2523),
    [sym_union_type] = STATE(754),
    [sym_parenthesized_expression] = STATE(1969),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1969),
    [sym_class] = STATE(1969),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(4248),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(4250),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(4252),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(4254),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(4256),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(4256),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(4248),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(4258),
    [anon_sym_LBRACE] = ACTIONS(4260),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [sym_null] = ACTIONS(4168),
    [anon_sym_any] = ACTIONS(4248),
    [anon_sym_boolean] = ACTIONS(4248),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4262),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4248),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4250),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [1656] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1088),
    [anon_sym_AMP_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_EQ] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(1088),
    [anon_sym_PIPE_EQ] = ACTIONS(1088),
    [anon_sym_DASH_EQ] = ACTIONS(1088),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(1088),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(4264),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(2305),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(1088),
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(2305),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1088),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(847),
  },
  [1657] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2311),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(2313),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(2311),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(2313),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(2311),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1658] = {
    [sym_identifier] = ACTIONS(3184),
    [anon_sym_BQUOTE] = ACTIONS(3182),
    [anon_sym_debugger] = ACTIONS(3184),
    [anon_sym_symbol] = ACTIONS(3184),
    [anon_sym_AT] = ACTIONS(3182),
    [anon_sym_DASH] = ACTIONS(3184),
    [anon_sym_void] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3184),
    [anon_sym_const] = ACTIONS(3184),
    [sym_super] = ACTIONS(3184),
    [anon_sym_return] = ACTIONS(3184),
    [anon_sym_private] = ACTIONS(3184),
    [anon_sym_get] = ACTIONS(3184),
    [anon_sym_RBRACE] = ACTIONS(3182),
    [anon_sym_interface] = ACTIONS(3184),
    [anon_sym_default] = ACTIONS(3184),
    [anon_sym_enum] = ACTIONS(3184),
    [anon_sym_delete] = ACTIONS(3184),
    [anon_sym_continue] = ACTIONS(3184),
    [anon_sym_DASH_DASH] = ACTIONS(3182),
    [anon_sym_if] = ACTIONS(3184),
    [anon_sym_this] = ACTIONS(3184),
    [anon_sym_yield] = ACTIONS(3184),
    [sym_true] = ACTIONS(3184),
    [anon_sym_throw] = ACTIONS(3184),
    [anon_sym_protected] = ACTIONS(3184),
    [anon_sym_abstract] = ACTIONS(3184),
    [anon_sym_set] = ACTIONS(3184),
    [anon_sym_type] = ACTIONS(3184),
    [anon_sym_import] = ACTIONS(3184),
    [anon_sym_namespace] = ACTIONS(3184),
    [anon_sym_PLUS_PLUS] = ACTIONS(3182),
    [anon_sym_await] = ACTIONS(3184),
    [anon_sym_DQUOTE] = ACTIONS(3182),
    [anon_sym_else] = ACTIONS(3184),
    [anon_sym_BANG] = ACTIONS(3182),
    [anon_sym_for] = ACTIONS(3184),
    [anon_sym_LBRACK] = ACTIONS(3182),
    [sym_false] = ACTIONS(3184),
    [anon_sym_SEMI] = ACTIONS(3182),
    [anon_sym_case] = ACTIONS(3184),
    [anon_sym_module] = ACTIONS(3184),
    [anon_sym_number] = ACTIONS(3184),
    [anon_sym_class] = ACTIONS(3184),
    [anon_sym_declare] = ACTIONS(3184),
    [anon_sym_typeof] = ACTIONS(3184),
    [anon_sym_LBRACE] = ACTIONS(3182),
    [anon_sym_switch] = ACTIONS(3184),
    [anon_sym_LPAREN] = ACTIONS(3182),
    [sym_null] = ACTIONS(3184),
    [anon_sym_any] = ACTIONS(3184),
    [anon_sym_boolean] = ACTIONS(3184),
    [anon_sym_async] = ACTIONS(3184),
    [anon_sym_public] = ACTIONS(3184),
    [anon_sym_var] = ACTIONS(3184),
    [anon_sym_while] = ACTIONS(3184),
    [anon_sym_SQUOTE] = ACTIONS(3182),
    [anon_sym_try] = ACTIONS(3184),
    [anon_sym_LT] = ACTIONS(3182),
    [sym_number] = ACTIONS(3182),
    [anon_sym_SLASH] = ACTIONS(3184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3184),
    [anon_sym_function] = ACTIONS(3184),
    [sym_undefined] = ACTIONS(3184),
    [anon_sym_new] = ACTIONS(3184),
    [ts_builtin_sym_end] = ACTIONS(3182),
    [anon_sym_let] = ACTIONS(3184),
    [anon_sym_PLUS] = ACTIONS(3184),
    [anon_sym_export] = ACTIONS(3184),
    [anon_sym_do] = ACTIONS(3184),
    [anon_sym_TILDE] = ACTIONS(3182),
    [anon_sym_with] = ACTIONS(3184),
  },
  [1659] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(1697),
    [anon_sym_COMMA] = ACTIONS(1695),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_RBRACK] = ACTIONS(1695),
    [anon_sym_GT] = ACTIONS(1697),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(1697),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(3297),
  },
  [1660] = {
    [sym_identifier] = ACTIONS(3309),
    [anon_sym_BQUOTE] = ACTIONS(3307),
    [anon_sym_debugger] = ACTIONS(3309),
    [anon_sym_symbol] = ACTIONS(3309),
    [anon_sym_AT] = ACTIONS(3307),
    [anon_sym_DASH] = ACTIONS(3309),
    [anon_sym_void] = ACTIONS(3309),
    [anon_sym_break] = ACTIONS(3309),
    [anon_sym_const] = ACTIONS(3309),
    [sym_super] = ACTIONS(3309),
    [anon_sym_return] = ACTIONS(3309),
    [anon_sym_private] = ACTIONS(3309),
    [anon_sym_get] = ACTIONS(3309),
    [anon_sym_RBRACE] = ACTIONS(3307),
    [anon_sym_interface] = ACTIONS(3309),
    [anon_sym_default] = ACTIONS(3309),
    [anon_sym_enum] = ACTIONS(3309),
    [anon_sym_delete] = ACTIONS(3309),
    [anon_sym_continue] = ACTIONS(3309),
    [anon_sym_DASH_DASH] = ACTIONS(3307),
    [anon_sym_if] = ACTIONS(3309),
    [anon_sym_this] = ACTIONS(3309),
    [anon_sym_yield] = ACTIONS(3309),
    [sym_true] = ACTIONS(3309),
    [anon_sym_throw] = ACTIONS(3309),
    [anon_sym_protected] = ACTIONS(3309),
    [anon_sym_abstract] = ACTIONS(3309),
    [anon_sym_set] = ACTIONS(3309),
    [anon_sym_type] = ACTIONS(3309),
    [anon_sym_import] = ACTIONS(3309),
    [anon_sym_namespace] = ACTIONS(3309),
    [anon_sym_PLUS_PLUS] = ACTIONS(3307),
    [anon_sym_await] = ACTIONS(3309),
    [anon_sym_DQUOTE] = ACTIONS(3307),
    [anon_sym_else] = ACTIONS(3309),
    [anon_sym_BANG] = ACTIONS(3307),
    [anon_sym_for] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3307),
    [sym_false] = ACTIONS(3309),
    [anon_sym_SEMI] = ACTIONS(3307),
    [anon_sym_case] = ACTIONS(3309),
    [anon_sym_module] = ACTIONS(3309),
    [anon_sym_number] = ACTIONS(3309),
    [anon_sym_class] = ACTIONS(3309),
    [anon_sym_declare] = ACTIONS(3309),
    [anon_sym_typeof] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(3307),
    [anon_sym_switch] = ACTIONS(3309),
    [anon_sym_LPAREN] = ACTIONS(3307),
    [sym_null] = ACTIONS(3309),
    [anon_sym_any] = ACTIONS(3309),
    [anon_sym_boolean] = ACTIONS(3309),
    [anon_sym_async] = ACTIONS(3309),
    [anon_sym_public] = ACTIONS(3309),
    [anon_sym_var] = ACTIONS(3309),
    [anon_sym_while] = ACTIONS(3309),
    [anon_sym_SQUOTE] = ACTIONS(3307),
    [anon_sym_try] = ACTIONS(3309),
    [anon_sym_LT] = ACTIONS(3307),
    [sym_number] = ACTIONS(3307),
    [anon_sym_SLASH] = ACTIONS(3309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3309),
    [anon_sym_function] = ACTIONS(3309),
    [sym_undefined] = ACTIONS(3309),
    [anon_sym_new] = ACTIONS(3309),
    [ts_builtin_sym_end] = ACTIONS(3307),
    [anon_sym_let] = ACTIONS(3309),
    [anon_sym_PLUS] = ACTIONS(3309),
    [anon_sym_export] = ACTIONS(3309),
    [anon_sym_do] = ACTIONS(3309),
    [anon_sym_TILDE] = ACTIONS(3307),
    [anon_sym_with] = ACTIONS(3309),
  },
  [1661] = {
    [sym_identifier] = ACTIONS(3435),
    [anon_sym_BQUOTE] = ACTIONS(3433),
    [anon_sym_debugger] = ACTIONS(3435),
    [anon_sym_symbol] = ACTIONS(3435),
    [anon_sym_AT] = ACTIONS(3433),
    [anon_sym_DASH] = ACTIONS(3435),
    [anon_sym_void] = ACTIONS(3435),
    [anon_sym_break] = ACTIONS(3435),
    [anon_sym_const] = ACTIONS(3435),
    [sym_super] = ACTIONS(3435),
    [anon_sym_return] = ACTIONS(3435),
    [anon_sym_private] = ACTIONS(3435),
    [anon_sym_get] = ACTIONS(3435),
    [anon_sym_RBRACE] = ACTIONS(3433),
    [anon_sym_interface] = ACTIONS(3435),
    [anon_sym_default] = ACTIONS(3435),
    [anon_sym_enum] = ACTIONS(3435),
    [anon_sym_delete] = ACTIONS(3435),
    [anon_sym_continue] = ACTIONS(3435),
    [anon_sym_DASH_DASH] = ACTIONS(3433),
    [anon_sym_if] = ACTIONS(3435),
    [anon_sym_this] = ACTIONS(3435),
    [anon_sym_yield] = ACTIONS(3435),
    [sym_true] = ACTIONS(3435),
    [anon_sym_throw] = ACTIONS(3435),
    [anon_sym_protected] = ACTIONS(3435),
    [anon_sym_abstract] = ACTIONS(3435),
    [anon_sym_set] = ACTIONS(3435),
    [anon_sym_type] = ACTIONS(3435),
    [anon_sym_import] = ACTIONS(3435),
    [anon_sym_namespace] = ACTIONS(3435),
    [anon_sym_PLUS_PLUS] = ACTIONS(3433),
    [anon_sym_await] = ACTIONS(3435),
    [anon_sym_DQUOTE] = ACTIONS(3433),
    [anon_sym_else] = ACTIONS(3435),
    [anon_sym_BANG] = ACTIONS(3433),
    [anon_sym_for] = ACTIONS(3435),
    [anon_sym_LBRACK] = ACTIONS(3433),
    [sym_false] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(3433),
    [anon_sym_case] = ACTIONS(3435),
    [anon_sym_module] = ACTIONS(3435),
    [anon_sym_number] = ACTIONS(3435),
    [anon_sym_class] = ACTIONS(3435),
    [anon_sym_declare] = ACTIONS(3435),
    [anon_sym_typeof] = ACTIONS(3435),
    [anon_sym_LBRACE] = ACTIONS(3433),
    [anon_sym_switch] = ACTIONS(3435),
    [anon_sym_LPAREN] = ACTIONS(3433),
    [sym_null] = ACTIONS(3435),
    [anon_sym_any] = ACTIONS(3435),
    [anon_sym_boolean] = ACTIONS(3435),
    [anon_sym_async] = ACTIONS(3435),
    [anon_sym_public] = ACTIONS(3435),
    [anon_sym_var] = ACTIONS(3435),
    [anon_sym_while] = ACTIONS(3435),
    [anon_sym_SQUOTE] = ACTIONS(3433),
    [anon_sym_try] = ACTIONS(3435),
    [anon_sym_LT] = ACTIONS(3433),
    [sym_number] = ACTIONS(3433),
    [anon_sym_SLASH] = ACTIONS(3435),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3435),
    [anon_sym_function] = ACTIONS(3435),
    [sym_undefined] = ACTIONS(3435),
    [anon_sym_new] = ACTIONS(3435),
    [ts_builtin_sym_end] = ACTIONS(3433),
    [anon_sym_let] = ACTIONS(3435),
    [anon_sym_PLUS] = ACTIONS(3435),
    [anon_sym_export] = ACTIONS(3435),
    [anon_sym_do] = ACTIONS(3435),
    [anon_sym_TILDE] = ACTIONS(3433),
    [anon_sym_with] = ACTIONS(3435),
  },
  [1662] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3439),
    [anon_sym_BQUOTE] = ACTIONS(3439),
    [anon_sym_PIPE] = ACTIONS(3441),
    [anon_sym_COMMA] = ACTIONS(3439),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_STAR] = ACTIONS(3441),
    [anon_sym_GT_GT_GT] = ACTIONS(3439),
    [anon_sym_BANG_EQ] = ACTIONS(3441),
    [anon_sym_GT_EQ] = ACTIONS(3439),
    [anon_sym_RBRACE] = ACTIONS(3439),
    [anon_sym_PERCENT] = ACTIONS(3439),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3439),
    [anon_sym_as] = ACTIONS(3439),
    [anon_sym_DASH_DASH] = ACTIONS(3439),
    [anon_sym_instanceof] = ACTIONS(3439),
    [anon_sym_COLON] = ACTIONS(3439),
    [anon_sym_DOT] = ACTIONS(3439),
    [anon_sym_STAR_STAR] = ACTIONS(3439),
    [anon_sym_PLUS_PLUS] = ACTIONS(3439),
    [anon_sym_BANG] = ACTIONS(3441),
    [anon_sym_LBRACK] = ACTIONS(3439),
    [anon_sym_LT_LT] = ACTIONS(3439),
    [anon_sym_LBRACE] = ACTIONS(3441),
    [anon_sym_AMP_AMP] = ACTIONS(3439),
    [anon_sym_LT_EQ] = ACTIONS(3439),
    [anon_sym_LPAREN] = ACTIONS(3439),
    [anon_sym_RBRACK] = ACTIONS(3439),
    [anon_sym_GT] = ACTIONS(3441),
    [anon_sym_AMP] = ACTIONS(3441),
    [anon_sym_QMARK] = ACTIONS(3439),
    [anon_sym_PIPE_PIPE] = ACTIONS(3439),
    [anon_sym_EQ_EQ] = ACTIONS(3441),
    [anon_sym_RPAREN] = ACTIONS(3439),
    [anon_sym_LT] = ACTIONS(3441),
    [anon_sym_SLASH] = ACTIONS(3441),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3439),
    [anon_sym_PLUS] = ACTIONS(3441),
    [anon_sym_implements] = ACTIONS(3439),
    [anon_sym_GT_GT] = ACTIONS(3441),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3439),
    [anon_sym_in] = ACTIONS(3441),
  },
  [1663] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3445),
    [anon_sym_BQUOTE] = ACTIONS(3445),
    [anon_sym_PIPE] = ACTIONS(3447),
    [anon_sym_COMMA] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3447),
    [anon_sym_STAR] = ACTIONS(3447),
    [anon_sym_GT_GT_GT] = ACTIONS(3445),
    [anon_sym_BANG_EQ] = ACTIONS(3447),
    [anon_sym_GT_EQ] = ACTIONS(3445),
    [anon_sym_RBRACE] = ACTIONS(3445),
    [anon_sym_PERCENT] = ACTIONS(3445),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3445),
    [anon_sym_as] = ACTIONS(3445),
    [anon_sym_DASH_DASH] = ACTIONS(3445),
    [anon_sym_instanceof] = ACTIONS(3445),
    [anon_sym_COLON] = ACTIONS(3445),
    [anon_sym_DOT] = ACTIONS(3445),
    [anon_sym_STAR_STAR] = ACTIONS(3445),
    [anon_sym_PLUS_PLUS] = ACTIONS(3445),
    [anon_sym_BANG] = ACTIONS(3447),
    [anon_sym_LBRACK] = ACTIONS(3445),
    [anon_sym_LT_LT] = ACTIONS(3445),
    [anon_sym_LBRACE] = ACTIONS(3447),
    [anon_sym_AMP_AMP] = ACTIONS(3445),
    [anon_sym_LT_EQ] = ACTIONS(3445),
    [anon_sym_LPAREN] = ACTIONS(3445),
    [anon_sym_RBRACK] = ACTIONS(3445),
    [anon_sym_GT] = ACTIONS(3447),
    [anon_sym_AMP] = ACTIONS(3447),
    [anon_sym_QMARK] = ACTIONS(3445),
    [anon_sym_PIPE_PIPE] = ACTIONS(3445),
    [anon_sym_EQ_EQ] = ACTIONS(3447),
    [anon_sym_RPAREN] = ACTIONS(3445),
    [anon_sym_LT] = ACTIONS(3447),
    [anon_sym_SLASH] = ACTIONS(3447),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3445),
    [anon_sym_PLUS] = ACTIONS(3447),
    [anon_sym_implements] = ACTIONS(3445),
    [anon_sym_GT_GT] = ACTIONS(3447),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3445),
    [anon_sym_in] = ACTIONS(3447),
  },
  [1664] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3476),
    [anon_sym_BQUOTE] = ACTIONS(3476),
    [anon_sym_PIPE] = ACTIONS(3478),
    [anon_sym_COMMA] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3478),
    [anon_sym_STAR] = ACTIONS(3478),
    [anon_sym_GT_GT_GT] = ACTIONS(3476),
    [anon_sym_BANG_EQ] = ACTIONS(3478),
    [anon_sym_GT_EQ] = ACTIONS(3476),
    [anon_sym_RBRACE] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3476),
    [anon_sym_as] = ACTIONS(3476),
    [anon_sym_DASH_DASH] = ACTIONS(3476),
    [anon_sym_instanceof] = ACTIONS(3476),
    [anon_sym_COLON] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_STAR_STAR] = ACTIONS(3476),
    [anon_sym_PLUS_PLUS] = ACTIONS(3476),
    [anon_sym_BANG] = ACTIONS(3478),
    [anon_sym_LBRACK] = ACTIONS(3476),
    [anon_sym_LT_LT] = ACTIONS(3476),
    [anon_sym_LBRACE] = ACTIONS(3478),
    [anon_sym_AMP_AMP] = ACTIONS(3476),
    [anon_sym_LT_EQ] = ACTIONS(3476),
    [anon_sym_LPAREN] = ACTIONS(3476),
    [anon_sym_RBRACK] = ACTIONS(3476),
    [anon_sym_GT] = ACTIONS(3478),
    [anon_sym_AMP] = ACTIONS(3478),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_PIPE_PIPE] = ACTIONS(3476),
    [anon_sym_EQ_EQ] = ACTIONS(3478),
    [anon_sym_RPAREN] = ACTIONS(3476),
    [anon_sym_LT] = ACTIONS(3478),
    [anon_sym_SLASH] = ACTIONS(3478),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3476),
    [anon_sym_PLUS] = ACTIONS(3478),
    [anon_sym_implements] = ACTIONS(3476),
    [anon_sym_GT_GT] = ACTIONS(3478),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3476),
    [anon_sym_in] = ACTIONS(3478),
  },
  [1665] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3480),
    [anon_sym_BQUOTE] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(4242),
    [anon_sym_COMMA] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3482),
    [anon_sym_STAR] = ACTIONS(3482),
    [anon_sym_GT_GT_GT] = ACTIONS(3480),
    [anon_sym_BANG_EQ] = ACTIONS(3482),
    [anon_sym_GT_EQ] = ACTIONS(3480),
    [anon_sym_RBRACE] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3480),
    [anon_sym_as] = ACTIONS(3480),
    [anon_sym_DASH_DASH] = ACTIONS(3480),
    [anon_sym_instanceof] = ACTIONS(3480),
    [anon_sym_COLON] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_STAR_STAR] = ACTIONS(3480),
    [anon_sym_PLUS_PLUS] = ACTIONS(3480),
    [anon_sym_BANG] = ACTIONS(3482),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [anon_sym_LT_LT] = ACTIONS(3480),
    [anon_sym_LBRACE] = ACTIONS(3482),
    [anon_sym_AMP_AMP] = ACTIONS(3480),
    [anon_sym_LT_EQ] = ACTIONS(3480),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [anon_sym_RBRACK] = ACTIONS(3480),
    [anon_sym_GT] = ACTIONS(3482),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE] = ACTIONS(3480),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_RPAREN] = ACTIONS(3480),
    [anon_sym_LT] = ACTIONS(3482),
    [anon_sym_SLASH] = ACTIONS(3482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3480),
    [anon_sym_PLUS] = ACTIONS(3482),
    [anon_sym_implements] = ACTIONS(3480),
    [anon_sym_GT_GT] = ACTIONS(3482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3480),
    [anon_sym_in] = ACTIONS(3482),
  },
  [1666] = {
    [sym__type] = STATE(1673),
    [sym_constructor_type] = STATE(1673),
    [sym_index_type_query] = STATE(1604),
    [sym_lookup_type] = STATE(1604),
    [sym_this_type] = STATE(1604),
    [sym_flow_maybe_type] = STATE(1604),
    [sym_function_type] = STATE(1673),
    [sym_nested_identifier] = STATE(2424),
    [sym__primary_type] = STATE(1604),
    [sym_generic_type] = STATE(1604),
    [sym_mapped_type] = STATE(1604),
    [sym_literal_type] = STATE(1604),
    [sym_parenthesized_type] = STATE(1604),
    [sym_predefined_type] = STATE(1604),
    [sym_type_parameters] = STATE(2423),
    [sym_string] = STATE(1596),
    [sym_array_type] = STATE(1604),
    [sym_tuple_type] = STATE(1604),
    [sym_nested_type_identifier] = STATE(1603),
    [sym_type_predicate] = STATE(1604),
    [sym_type_query] = STATE(1604),
    [sym__number] = STATE(1596),
    [sym_existential_type] = STATE(1604),
    [sym_object_type] = STATE(1604),
    [sym_union_type] = STATE(1673),
    [sym_intersection_type] = STATE(1673),
    [sym_formal_parameters] = STATE(2110),
    [sym_identifier] = ACTIONS(4178),
    [sym_false] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_symbol] = ACTIONS(4184),
    [anon_sym_number] = ACTIONS(4184),
    [anon_sym_typeof] = ACTIONS(4186),
    [anon_sym_keyof] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4194),
    [anon_sym_PIPE] = ACTIONS(4206),
    [anon_sym_void] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(4184),
    [anon_sym_boolean] = ACTIONS(4184),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_this] = ACTIONS(4202),
    [sym_number] = ACTIONS(4204),
    [sym_true] = ACTIONS(4180),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [1667] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3523),
    [anon_sym_BQUOTE] = ACTIONS(3523),
    [anon_sym_PIPE] = ACTIONS(3525),
    [anon_sym_COMMA] = ACTIONS(3523),
    [anon_sym_DASH] = ACTIONS(3525),
    [anon_sym_STAR] = ACTIONS(3525),
    [anon_sym_GT_GT_GT] = ACTIONS(3523),
    [anon_sym_BANG_EQ] = ACTIONS(3525),
    [anon_sym_GT_EQ] = ACTIONS(3523),
    [anon_sym_RBRACE] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3523),
    [anon_sym_as] = ACTIONS(3523),
    [anon_sym_DASH_DASH] = ACTIONS(3523),
    [anon_sym_instanceof] = ACTIONS(3523),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_DOT] = ACTIONS(3523),
    [anon_sym_STAR_STAR] = ACTIONS(3523),
    [anon_sym_PLUS_PLUS] = ACTIONS(3523),
    [anon_sym_BANG] = ACTIONS(3525),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_LT_LT] = ACTIONS(3523),
    [anon_sym_LBRACE] = ACTIONS(3525),
    [anon_sym_AMP_AMP] = ACTIONS(3523),
    [anon_sym_LT_EQ] = ACTIONS(3523),
    [anon_sym_LPAREN] = ACTIONS(3523),
    [anon_sym_RBRACK] = ACTIONS(3523),
    [anon_sym_GT] = ACTIONS(3525),
    [anon_sym_AMP] = ACTIONS(3525),
    [anon_sym_QMARK] = ACTIONS(3523),
    [anon_sym_PIPE_PIPE] = ACTIONS(3523),
    [anon_sym_EQ_EQ] = ACTIONS(3525),
    [anon_sym_RPAREN] = ACTIONS(3523),
    [anon_sym_LT] = ACTIONS(3525),
    [anon_sym_SLASH] = ACTIONS(3525),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3523),
    [anon_sym_PLUS] = ACTIONS(3525),
    [anon_sym_implements] = ACTIONS(3523),
    [anon_sym_GT_GT] = ACTIONS(3525),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3523),
    [anon_sym_in] = ACTIONS(3525),
  },
  [1668] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3527),
    [anon_sym_BQUOTE] = ACTIONS(3527),
    [anon_sym_PIPE] = ACTIONS(4242),
    [anon_sym_COMMA] = ACTIONS(3527),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_STAR] = ACTIONS(3529),
    [anon_sym_GT_GT_GT] = ACTIONS(3527),
    [anon_sym_BANG_EQ] = ACTIONS(3529),
    [anon_sym_GT_EQ] = ACTIONS(3527),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [anon_sym_PERCENT] = ACTIONS(3527),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3527),
    [anon_sym_as] = ACTIONS(3527),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_instanceof] = ACTIONS(3527),
    [anon_sym_COLON] = ACTIONS(3527),
    [anon_sym_DOT] = ACTIONS(3527),
    [anon_sym_STAR_STAR] = ACTIONS(3527),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_BANG] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [anon_sym_LT_LT] = ACTIONS(3527),
    [anon_sym_LBRACE] = ACTIONS(3529),
    [anon_sym_AMP_AMP] = ACTIONS(3527),
    [anon_sym_LT_EQ] = ACTIONS(3527),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [anon_sym_RBRACK] = ACTIONS(3527),
    [anon_sym_GT] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(3527),
    [anon_sym_PIPE_PIPE] = ACTIONS(3527),
    [anon_sym_EQ_EQ] = ACTIONS(3529),
    [anon_sym_RPAREN] = ACTIONS(3527),
    [anon_sym_LT] = ACTIONS(3529),
    [anon_sym_SLASH] = ACTIONS(3529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3527),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_implements] = ACTIONS(3527),
    [anon_sym_GT_GT] = ACTIONS(3529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3527),
    [anon_sym_in] = ACTIONS(3529),
  },
  [1669] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3531),
    [anon_sym_BQUOTE] = ACTIONS(3531),
    [anon_sym_PIPE] = ACTIONS(3533),
    [anon_sym_COMMA] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3533),
    [anon_sym_STAR] = ACTIONS(3533),
    [anon_sym_GT_GT_GT] = ACTIONS(3531),
    [anon_sym_BANG_EQ] = ACTIONS(3533),
    [anon_sym_GT_EQ] = ACTIONS(3531),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [anon_sym_PERCENT] = ACTIONS(3531),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3531),
    [anon_sym_as] = ACTIONS(3531),
    [anon_sym_DASH_DASH] = ACTIONS(3531),
    [anon_sym_instanceof] = ACTIONS(3531),
    [anon_sym_COLON] = ACTIONS(3531),
    [anon_sym_DOT] = ACTIONS(3531),
    [anon_sym_STAR_STAR] = ACTIONS(3531),
    [anon_sym_PLUS_PLUS] = ACTIONS(3531),
    [anon_sym_BANG] = ACTIONS(3533),
    [anon_sym_LBRACK] = ACTIONS(3531),
    [anon_sym_LT_LT] = ACTIONS(3531),
    [anon_sym_LBRACE] = ACTIONS(3533),
    [anon_sym_AMP_AMP] = ACTIONS(3531),
    [anon_sym_LT_EQ] = ACTIONS(3531),
    [anon_sym_LPAREN] = ACTIONS(3531),
    [anon_sym_RBRACK] = ACTIONS(3531),
    [anon_sym_GT] = ACTIONS(3533),
    [anon_sym_AMP] = ACTIONS(3533),
    [anon_sym_QMARK] = ACTIONS(3531),
    [anon_sym_PIPE_PIPE] = ACTIONS(3531),
    [anon_sym_EQ_EQ] = ACTIONS(3533),
    [anon_sym_RPAREN] = ACTIONS(3531),
    [anon_sym_LT] = ACTIONS(3533),
    [anon_sym_SLASH] = ACTIONS(3533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3531),
    [anon_sym_PLUS] = ACTIONS(3533),
    [anon_sym_implements] = ACTIONS(3531),
    [anon_sym_GT_GT] = ACTIONS(3533),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3531),
    [anon_sym_in] = ACTIONS(3533),
  },
  [1670] = {
    [sym_identifier] = ACTIONS(3541),
    [anon_sym_BQUOTE] = ACTIONS(3539),
    [anon_sym_debugger] = ACTIONS(3541),
    [anon_sym_symbol] = ACTIONS(3541),
    [anon_sym_AT] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(3541),
    [anon_sym_void] = ACTIONS(3541),
    [anon_sym_break] = ACTIONS(3541),
    [anon_sym_const] = ACTIONS(3541),
    [sym_super] = ACTIONS(3541),
    [anon_sym_return] = ACTIONS(3541),
    [anon_sym_private] = ACTIONS(3541),
    [anon_sym_get] = ACTIONS(3541),
    [anon_sym_RBRACE] = ACTIONS(3539),
    [anon_sym_interface] = ACTIONS(3541),
    [anon_sym_default] = ACTIONS(3541),
    [anon_sym_enum] = ACTIONS(3541),
    [anon_sym_delete] = ACTIONS(3541),
    [anon_sym_continue] = ACTIONS(3541),
    [anon_sym_DASH_DASH] = ACTIONS(3539),
    [anon_sym_if] = ACTIONS(3541),
    [anon_sym_this] = ACTIONS(3541),
    [anon_sym_yield] = ACTIONS(3541),
    [sym_true] = ACTIONS(3541),
    [anon_sym_throw] = ACTIONS(3541),
    [anon_sym_protected] = ACTIONS(3541),
    [anon_sym_abstract] = ACTIONS(3541),
    [anon_sym_set] = ACTIONS(3541),
    [anon_sym_type] = ACTIONS(3541),
    [anon_sym_import] = ACTIONS(3541),
    [anon_sym_namespace] = ACTIONS(3541),
    [anon_sym_PLUS_PLUS] = ACTIONS(3539),
    [anon_sym_await] = ACTIONS(3541),
    [anon_sym_DQUOTE] = ACTIONS(3539),
    [anon_sym_else] = ACTIONS(3541),
    [anon_sym_BANG] = ACTIONS(3539),
    [anon_sym_for] = ACTIONS(3541),
    [anon_sym_LBRACK] = ACTIONS(3539),
    [sym_false] = ACTIONS(3541),
    [anon_sym_SEMI] = ACTIONS(3539),
    [anon_sym_case] = ACTIONS(3541),
    [anon_sym_module] = ACTIONS(3541),
    [anon_sym_number] = ACTIONS(3541),
    [anon_sym_class] = ACTIONS(3541),
    [anon_sym_declare] = ACTIONS(3541),
    [anon_sym_typeof] = ACTIONS(3541),
    [anon_sym_LBRACE] = ACTIONS(3539),
    [anon_sym_switch] = ACTIONS(3541),
    [anon_sym_LPAREN] = ACTIONS(3539),
    [sym_null] = ACTIONS(3541),
    [anon_sym_any] = ACTIONS(3541),
    [anon_sym_boolean] = ACTIONS(3541),
    [anon_sym_async] = ACTIONS(3541),
    [anon_sym_public] = ACTIONS(3541),
    [anon_sym_var] = ACTIONS(3541),
    [anon_sym_while] = ACTIONS(3541),
    [anon_sym_SQUOTE] = ACTIONS(3539),
    [anon_sym_try] = ACTIONS(3541),
    [anon_sym_LT] = ACTIONS(3539),
    [sym_number] = ACTIONS(3539),
    [anon_sym_SLASH] = ACTIONS(3541),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3541),
    [anon_sym_function] = ACTIONS(3541),
    [sym_undefined] = ACTIONS(3541),
    [anon_sym_new] = ACTIONS(3541),
    [ts_builtin_sym_end] = ACTIONS(3539),
    [anon_sym_let] = ACTIONS(3541),
    [anon_sym_PLUS] = ACTIONS(3541),
    [anon_sym_export] = ACTIONS(3541),
    [anon_sym_do] = ACTIONS(3541),
    [anon_sym_TILDE] = ACTIONS(3539),
    [anon_sym_with] = ACTIONS(3541),
  },
  [1671] = {
    [sym_identifier] = ACTIONS(3578),
    [anon_sym_BQUOTE] = ACTIONS(3576),
    [anon_sym_debugger] = ACTIONS(3578),
    [anon_sym_symbol] = ACTIONS(3578),
    [anon_sym_AT] = ACTIONS(3576),
    [anon_sym_DASH] = ACTIONS(3578),
    [anon_sym_void] = ACTIONS(3578),
    [anon_sym_break] = ACTIONS(3578),
    [anon_sym_const] = ACTIONS(3578),
    [sym_super] = ACTIONS(3578),
    [anon_sym_return] = ACTIONS(3578),
    [anon_sym_private] = ACTIONS(3578),
    [anon_sym_get] = ACTIONS(3578),
    [anon_sym_RBRACE] = ACTIONS(3576),
    [anon_sym_interface] = ACTIONS(3578),
    [anon_sym_default] = ACTIONS(3578),
    [anon_sym_enum] = ACTIONS(3578),
    [anon_sym_delete] = ACTIONS(3578),
    [anon_sym_continue] = ACTIONS(3578),
    [anon_sym_DASH_DASH] = ACTIONS(3576),
    [anon_sym_if] = ACTIONS(3578),
    [anon_sym_this] = ACTIONS(3578),
    [anon_sym_yield] = ACTIONS(3578),
    [sym_true] = ACTIONS(3578),
    [anon_sym_throw] = ACTIONS(3578),
    [anon_sym_protected] = ACTIONS(3578),
    [anon_sym_abstract] = ACTIONS(3578),
    [anon_sym_set] = ACTIONS(3578),
    [anon_sym_type] = ACTIONS(3578),
    [anon_sym_import] = ACTIONS(3578),
    [anon_sym_namespace] = ACTIONS(3578),
    [anon_sym_PLUS_PLUS] = ACTIONS(3576),
    [anon_sym_await] = ACTIONS(3578),
    [anon_sym_DQUOTE] = ACTIONS(3576),
    [anon_sym_else] = ACTIONS(3578),
    [anon_sym_BANG] = ACTIONS(3576),
    [anon_sym_for] = ACTIONS(3578),
    [anon_sym_LBRACK] = ACTIONS(3576),
    [sym_false] = ACTIONS(3578),
    [anon_sym_SEMI] = ACTIONS(3576),
    [anon_sym_case] = ACTIONS(3578),
    [anon_sym_module] = ACTIONS(3578),
    [anon_sym_number] = ACTIONS(3578),
    [anon_sym_class] = ACTIONS(3578),
    [anon_sym_declare] = ACTIONS(3578),
    [anon_sym_typeof] = ACTIONS(3578),
    [anon_sym_LBRACE] = ACTIONS(3576),
    [anon_sym_switch] = ACTIONS(3578),
    [anon_sym_LPAREN] = ACTIONS(3576),
    [sym_null] = ACTIONS(3578),
    [anon_sym_any] = ACTIONS(3578),
    [anon_sym_boolean] = ACTIONS(3578),
    [anon_sym_async] = ACTIONS(3578),
    [anon_sym_public] = ACTIONS(3578),
    [anon_sym_var] = ACTIONS(3578),
    [anon_sym_while] = ACTIONS(3578),
    [anon_sym_SQUOTE] = ACTIONS(3576),
    [anon_sym_try] = ACTIONS(3578),
    [anon_sym_LT] = ACTIONS(3576),
    [sym_number] = ACTIONS(3576),
    [anon_sym_SLASH] = ACTIONS(3578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3578),
    [anon_sym_function] = ACTIONS(3578),
    [sym_undefined] = ACTIONS(3578),
    [anon_sym_new] = ACTIONS(3578),
    [ts_builtin_sym_end] = ACTIONS(3576),
    [anon_sym_let] = ACTIONS(3578),
    [anon_sym_PLUS] = ACTIONS(3578),
    [anon_sym_export] = ACTIONS(3578),
    [anon_sym_do] = ACTIONS(3578),
    [anon_sym_TILDE] = ACTIONS(3576),
    [anon_sym_with] = ACTIONS(3578),
  },
  [1672] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3705),
    [anon_sym_BQUOTE] = ACTIONS(3705),
    [anon_sym_PIPE] = ACTIONS(3707),
    [anon_sym_COMMA] = ACTIONS(3705),
    [anon_sym_DASH] = ACTIONS(3707),
    [anon_sym_STAR] = ACTIONS(3707),
    [anon_sym_GT_GT_GT] = ACTIONS(3705),
    [anon_sym_BANG_EQ] = ACTIONS(3707),
    [anon_sym_GT_EQ] = ACTIONS(3705),
    [anon_sym_RBRACE] = ACTIONS(3705),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3705),
    [anon_sym_as] = ACTIONS(3705),
    [anon_sym_DASH_DASH] = ACTIONS(3705),
    [anon_sym_instanceof] = ACTIONS(3705),
    [anon_sym_COLON] = ACTIONS(3705),
    [anon_sym_DOT] = ACTIONS(3705),
    [anon_sym_STAR_STAR] = ACTIONS(3705),
    [anon_sym_PLUS_PLUS] = ACTIONS(3705),
    [anon_sym_BANG] = ACTIONS(3707),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_LT_LT] = ACTIONS(3705),
    [anon_sym_LBRACE] = ACTIONS(3707),
    [anon_sym_AMP_AMP] = ACTIONS(3705),
    [anon_sym_LT_EQ] = ACTIONS(3705),
    [anon_sym_LPAREN] = ACTIONS(3705),
    [anon_sym_RBRACK] = ACTIONS(3705),
    [anon_sym_GT] = ACTIONS(3707),
    [anon_sym_AMP] = ACTIONS(3707),
    [anon_sym_QMARK] = ACTIONS(3705),
    [anon_sym_PIPE_PIPE] = ACTIONS(3705),
    [anon_sym_EQ_EQ] = ACTIONS(3707),
    [anon_sym_RPAREN] = ACTIONS(3705),
    [anon_sym_LT] = ACTIONS(3707),
    [anon_sym_SLASH] = ACTIONS(3707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3705),
    [anon_sym_PLUS] = ACTIONS(3707),
    [anon_sym_implements] = ACTIONS(3705),
    [anon_sym_GT_GT] = ACTIONS(3707),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3705),
    [anon_sym_in] = ACTIONS(3707),
  },
  [1673] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3725),
    [anon_sym_BQUOTE] = ACTIONS(3725),
    [anon_sym_PIPE] = ACTIONS(4242),
    [anon_sym_COMMA] = ACTIONS(3725),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_STAR] = ACTIONS(3727),
    [anon_sym_GT_GT_GT] = ACTIONS(3725),
    [anon_sym_BANG_EQ] = ACTIONS(3727),
    [anon_sym_GT_EQ] = ACTIONS(3725),
    [anon_sym_RBRACE] = ACTIONS(3725),
    [anon_sym_PERCENT] = ACTIONS(3725),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3725),
    [anon_sym_as] = ACTIONS(3725),
    [anon_sym_DASH_DASH] = ACTIONS(3725),
    [anon_sym_instanceof] = ACTIONS(3725),
    [anon_sym_COLON] = ACTIONS(3725),
    [anon_sym_DOT] = ACTIONS(3725),
    [anon_sym_STAR_STAR] = ACTIONS(3725),
    [anon_sym_PLUS_PLUS] = ACTIONS(3725),
    [anon_sym_BANG] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3725),
    [anon_sym_LT_LT] = ACTIONS(3725),
    [anon_sym_LBRACE] = ACTIONS(3727),
    [anon_sym_AMP_AMP] = ACTIONS(3725),
    [anon_sym_LT_EQ] = ACTIONS(3725),
    [anon_sym_LPAREN] = ACTIONS(3725),
    [anon_sym_RBRACK] = ACTIONS(3725),
    [anon_sym_GT] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_QMARK] = ACTIONS(3725),
    [anon_sym_PIPE_PIPE] = ACTIONS(3725),
    [anon_sym_EQ_EQ] = ACTIONS(3727),
    [anon_sym_RPAREN] = ACTIONS(3725),
    [anon_sym_LT] = ACTIONS(3727),
    [anon_sym_SLASH] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3725),
    [anon_sym_PLUS] = ACTIONS(3727),
    [anon_sym_implements] = ACTIONS(3725),
    [anon_sym_GT_GT] = ACTIONS(3727),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3725),
    [anon_sym_in] = ACTIONS(3727),
  },
  [1674] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_COMMA] = ACTIONS(2652),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_COLON] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_RBRACK] = ACTIONS(1695),
    [anon_sym_GT] = ACTIONS(3741),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(3741),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1697),
  },
  [1675] = {
    [sym_identifier] = ACTIONS(3746),
    [anon_sym_BQUOTE] = ACTIONS(3744),
    [anon_sym_debugger] = ACTIONS(3746),
    [anon_sym_symbol] = ACTIONS(3746),
    [anon_sym_AT] = ACTIONS(3744),
    [anon_sym_DASH] = ACTIONS(3746),
    [anon_sym_void] = ACTIONS(3746),
    [anon_sym_break] = ACTIONS(3746),
    [anon_sym_const] = ACTIONS(3746),
    [sym_super] = ACTIONS(3746),
    [anon_sym_return] = ACTIONS(3746),
    [anon_sym_private] = ACTIONS(3746),
    [anon_sym_get] = ACTIONS(3746),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_interface] = ACTIONS(3746),
    [anon_sym_default] = ACTIONS(3746),
    [anon_sym_enum] = ACTIONS(3746),
    [anon_sym_delete] = ACTIONS(3746),
    [anon_sym_continue] = ACTIONS(3746),
    [anon_sym_DASH_DASH] = ACTIONS(3744),
    [anon_sym_if] = ACTIONS(3746),
    [anon_sym_this] = ACTIONS(3746),
    [anon_sym_yield] = ACTIONS(3746),
    [sym_true] = ACTIONS(3746),
    [anon_sym_throw] = ACTIONS(3746),
    [anon_sym_protected] = ACTIONS(3746),
    [anon_sym_abstract] = ACTIONS(3746),
    [anon_sym_set] = ACTIONS(3746),
    [anon_sym_type] = ACTIONS(3746),
    [anon_sym_import] = ACTIONS(3746),
    [anon_sym_namespace] = ACTIONS(3746),
    [anon_sym_PLUS_PLUS] = ACTIONS(3744),
    [anon_sym_await] = ACTIONS(3746),
    [anon_sym_DQUOTE] = ACTIONS(3744),
    [anon_sym_else] = ACTIONS(3746),
    [anon_sym_BANG] = ACTIONS(3744),
    [anon_sym_for] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [sym_false] = ACTIONS(3746),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_case] = ACTIONS(3746),
    [anon_sym_module] = ACTIONS(3746),
    [anon_sym_number] = ACTIONS(3746),
    [anon_sym_class] = ACTIONS(3746),
    [anon_sym_declare] = ACTIONS(3746),
    [anon_sym_typeof] = ACTIONS(3746),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_switch] = ACTIONS(3746),
    [anon_sym_LPAREN] = ACTIONS(3744),
    [sym_null] = ACTIONS(3746),
    [anon_sym_any] = ACTIONS(3746),
    [anon_sym_boolean] = ACTIONS(3746),
    [anon_sym_async] = ACTIONS(3746),
    [anon_sym_public] = ACTIONS(3746),
    [anon_sym_var] = ACTIONS(3746),
    [anon_sym_while] = ACTIONS(3746),
    [anon_sym_SQUOTE] = ACTIONS(3744),
    [anon_sym_try] = ACTIONS(3746),
    [anon_sym_LT] = ACTIONS(3744),
    [sym_number] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(3746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3746),
    [anon_sym_function] = ACTIONS(3746),
    [sym_undefined] = ACTIONS(3746),
    [anon_sym_new] = ACTIONS(3746),
    [ts_builtin_sym_end] = ACTIONS(3744),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_export] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3744),
    [anon_sym_with] = ACTIONS(3746),
  },
  [1676] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(3818),
    [anon_sym_BQUOTE] = ACTIONS(3818),
    [anon_sym_PIPE] = ACTIONS(3820),
    [anon_sym_COMMA] = ACTIONS(3818),
    [anon_sym_DASH] = ACTIONS(3820),
    [anon_sym_STAR] = ACTIONS(3820),
    [anon_sym_GT_GT_GT] = ACTIONS(3818),
    [anon_sym_BANG_EQ] = ACTIONS(3820),
    [anon_sym_GT_EQ] = ACTIONS(3818),
    [anon_sym_RBRACE] = ACTIONS(3818),
    [anon_sym_PERCENT] = ACTIONS(3818),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3818),
    [anon_sym_as] = ACTIONS(3818),
    [anon_sym_DASH_DASH] = ACTIONS(3818),
    [anon_sym_instanceof] = ACTIONS(3818),
    [anon_sym_COLON] = ACTIONS(3818),
    [anon_sym_DOT] = ACTIONS(3818),
    [anon_sym_STAR_STAR] = ACTIONS(3818),
    [anon_sym_PLUS_PLUS] = ACTIONS(3818),
    [anon_sym_BANG] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3818),
    [anon_sym_LT_LT] = ACTIONS(3818),
    [anon_sym_LBRACE] = ACTIONS(3820),
    [anon_sym_AMP_AMP] = ACTIONS(3818),
    [anon_sym_LT_EQ] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3818),
    [anon_sym_RBRACK] = ACTIONS(3818),
    [anon_sym_GT] = ACTIONS(3820),
    [anon_sym_AMP] = ACTIONS(3820),
    [anon_sym_QMARK] = ACTIONS(3818),
    [anon_sym_PIPE_PIPE] = ACTIONS(3818),
    [anon_sym_EQ_EQ] = ACTIONS(3820),
    [anon_sym_RPAREN] = ACTIONS(3818),
    [anon_sym_LT] = ACTIONS(3820),
    [anon_sym_SLASH] = ACTIONS(3820),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3818),
    [anon_sym_PLUS] = ACTIONS(3820),
    [anon_sym_implements] = ACTIONS(3818),
    [anon_sym_GT_GT] = ACTIONS(3820),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3818),
    [anon_sym_in] = ACTIONS(3820),
  },
  [1677] = {
    [sym__automatic_semicolon] = ACTIONS(813),
    [anon_sym_RBRACE] = ACTIONS(813),
    [anon_sym_LBRACK] = ACTIONS(813),
    [anon_sym_SEMI] = ACTIONS(813),
    [anon_sym_QMARK] = ACTIONS(813),
    [anon_sym_AMP] = ACTIONS(813),
    [anon_sym_LT] = ACTIONS(813),
    [anon_sym_COMMA] = ACTIONS(813),
    [anon_sym_PIPE] = ACTIONS(815),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(813),
    [anon_sym_EQ] = ACTIONS(813),
    [anon_sym_COLON] = ACTIONS(813),
    [anon_sym_LPAREN] = ACTIONS(813),
    [anon_sym_PIPE_RBRACE] = ACTIONS(813),
    [anon_sym_BANG] = ACTIONS(813),
  },
  [1678] = {
    [sym_type_arguments] = STATE(537),
    [anon_sym_BQUOTE] = ACTIONS(1280),
    [anon_sym_symbol] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_break] = ACTIONS(1285),
    [anon_sym_return] = ACTIONS(1285),
    [anon_sym_RBRACE] = ACTIONS(1280),
    [anon_sym_interface] = ACTIONS(1285),
    [anon_sym_delete] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(1285),
    [sym_true] = ACTIONS(1285),
    [anon_sym_protected] = ACTIONS(1285),
    [anon_sym_set] = ACTIONS(1285),
    [anon_sym_import] = ACTIONS(1285),
    [anon_sym_await] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1280),
    [anon_sym_for] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1280),
    [anon_sym_number] = ACTIONS(1285),
    [anon_sym_typeof] = ACTIONS(1285),
    [anon_sym_LBRACE] = ACTIONS(1280),
    [anon_sym_switch] = ACTIONS(1285),
    [sym_null] = ACTIONS(1285),
    [anon_sym_any] = ACTIONS(1285),
    [anon_sym_async] = ACTIONS(1285),
    [anon_sym_public] = ACTIONS(1285),
    [anon_sym_var] = ACTIONS(1285),
    [anon_sym_while] = ACTIONS(1285),
    [anon_sym_SQUOTE] = ACTIONS(1280),
    [anon_sym_SLASH] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1285),
    [anon_sym_new] = ACTIONS(1285),
    [anon_sym_export] = ACTIONS(1285),
    [anon_sym_with] = ACTIONS(1285),
    [sym_identifier] = ACTIONS(1285),
    [anon_sym_debugger] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(1280),
    [anon_sym_DASH] = ACTIONS(1285),
    [anon_sym_void] = ACTIONS(1285),
    [anon_sym_const] = ACTIONS(1285),
    [sym_super] = ACTIONS(1285),
    [anon_sym_private] = ACTIONS(1285),
    [anon_sym_get] = ACTIONS(1285),
    [anon_sym_default] = ACTIONS(1285),
    [anon_sym_enum] = ACTIONS(1285),
    [anon_sym_continue] = ACTIONS(1285),
    [anon_sym_DASH_DASH] = ACTIONS(1280),
    [anon_sym_this] = ACTIONS(1285),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_abstract] = ACTIONS(1285),
    [anon_sym_type] = ACTIONS(1285),
    [anon_sym_namespace] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1280),
    [anon_sym_else] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(1280),
    [anon_sym_LBRACK] = ACTIONS(1282),
    [sym_false] = ACTIONS(1285),
    [anon_sym_case] = ACTIONS(1285),
    [anon_sym_module] = ACTIONS(1285),
    [anon_sym_class] = ACTIONS(1285),
    [anon_sym_declare] = ACTIONS(1285),
    [anon_sym_LPAREN] = ACTIONS(1280),
    [anon_sym_boolean] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1280),
    [anon_sym_try] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(4266),
    [sym_number] = ACTIONS(1280),
    [ts_builtin_sym_end] = ACTIONS(1280),
    [anon_sym_function] = ACTIONS(1285),
    [sym_undefined] = ACTIONS(1285),
    [anon_sym_let] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1285),
    [anon_sym_TILDE] = ACTIONS(1280),
    [anon_sym_in] = ACTIONS(4269),
  },
  [1679] = {
    [sym_type_arguments] = STATE(497),
    [anon_sym_BQUOTE] = ACTIONS(1201),
    [anon_sym_symbol] = ACTIONS(1751),
    [anon_sym_PIPE] = ACTIONS(1201),
    [anon_sym_break] = ACTIONS(1751),
    [anon_sym_return] = ACTIONS(1751),
    [anon_sym_RBRACE] = ACTIONS(1201),
    [anon_sym_interface] = ACTIONS(1751),
    [anon_sym_delete] = ACTIONS(1751),
    [anon_sym_if] = ACTIONS(1751),
    [anon_sym_yield] = ACTIONS(1751),
    [sym_true] = ACTIONS(1751),
    [anon_sym_protected] = ACTIONS(1751),
    [anon_sym_DOT] = ACTIONS(4271),
    [anon_sym_set] = ACTIONS(1751),
    [anon_sym_import] = ACTIONS(1751),
    [anon_sym_await] = ACTIONS(1751),
    [anon_sym_DQUOTE] = ACTIONS(1201),
    [anon_sym_for] = ACTIONS(1751),
    [anon_sym_SEMI] = ACTIONS(1201),
    [anon_sym_number] = ACTIONS(1751),
    [anon_sym_typeof] = ACTIONS(1751),
    [anon_sym_LBRACE] = ACTIONS(1201),
    [anon_sym_switch] = ACTIONS(1751),
    [sym_null] = ACTIONS(1751),
    [anon_sym_any] = ACTIONS(1751),
    [anon_sym_async] = ACTIONS(1751),
    [anon_sym_public] = ACTIONS(1751),
    [anon_sym_var] = ACTIONS(1751),
    [anon_sym_while] = ACTIONS(1751),
    [anon_sym_SQUOTE] = ACTIONS(1201),
    [anon_sym_SLASH] = ACTIONS(1751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1751),
    [anon_sym_new] = ACTIONS(1751),
    [anon_sym_export] = ACTIONS(1751),
    [anon_sym_with] = ACTIONS(1751),
    [sym_identifier] = ACTIONS(1751),
    [anon_sym_debugger] = ACTIONS(1751),
    [anon_sym_AT] = ACTIONS(1201),
    [anon_sym_DASH] = ACTIONS(1751),
    [anon_sym_void] = ACTIONS(1751),
    [anon_sym_const] = ACTIONS(1751),
    [sym_super] = ACTIONS(1751),
    [anon_sym_private] = ACTIONS(1751),
    [anon_sym_get] = ACTIONS(1751),
    [anon_sym_default] = ACTIONS(1751),
    [anon_sym_enum] = ACTIONS(1751),
    [anon_sym_continue] = ACTIONS(1751),
    [anon_sym_DASH_DASH] = ACTIONS(1201),
    [anon_sym_this] = ACTIONS(1751),
    [anon_sym_throw] = ACTIONS(1751),
    [anon_sym_abstract] = ACTIONS(1751),
    [anon_sym_type] = ACTIONS(1751),
    [anon_sym_namespace] = ACTIONS(1751),
    [anon_sym_PLUS_PLUS] = ACTIONS(1201),
    [anon_sym_else] = ACTIONS(1751),
    [anon_sym_BANG] = ACTIONS(1201),
    [anon_sym_LBRACK] = ACTIONS(1198),
    [sym_false] = ACTIONS(1751),
    [anon_sym_case] = ACTIONS(1751),
    [anon_sym_module] = ACTIONS(1751),
    [anon_sym_class] = ACTIONS(1751),
    [anon_sym_declare] = ACTIONS(1751),
    [anon_sym_is] = ACTIONS(4273),
    [anon_sym_LPAREN] = ACTIONS(1201),
    [anon_sym_boolean] = ACTIONS(1751),
    [anon_sym_AMP] = ACTIONS(1201),
    [anon_sym_try] = ACTIONS(1751),
    [anon_sym_LT] = ACTIONS(4275),
    [sym_number] = ACTIONS(1201),
    [ts_builtin_sym_end] = ACTIONS(1201),
    [anon_sym_function] = ACTIONS(1751),
    [sym_undefined] = ACTIONS(1751),
    [anon_sym_let] = ACTIONS(1751),
    [anon_sym_PLUS] = ACTIONS(1751),
    [anon_sym_do] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(4278),
  },
  [1680] = {
    [sym__automatic_semicolon] = ACTIONS(1865),
    [anon_sym_RBRACE] = ACTIONS(1865),
    [anon_sym_LBRACK] = ACTIONS(1865),
    [anon_sym_SEMI] = ACTIONS(1865),
    [anon_sym_QMARK] = ACTIONS(1865),
    [anon_sym_AMP] = ACTIONS(1865),
    [anon_sym_LT] = ACTIONS(1865),
    [anon_sym_COMMA] = ACTIONS(1865),
    [anon_sym_PIPE] = ACTIONS(1867),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1865),
    [anon_sym_EQ] = ACTIONS(1865),
    [anon_sym_COLON] = ACTIONS(1865),
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1865),
    [anon_sym_BANG] = ACTIONS(1865),
  },
  [1681] = {
    [sym__automatic_semicolon] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(2081),
    [sym_identifier] = ACTIONS(2083),
    [anon_sym_SEMI] = ACTIONS(2081),
    [anon_sym_module] = ACTIONS(2083),
    [anon_sym_symbol] = ACTIONS(2083),
    [anon_sym_number] = ACTIONS(2083),
    [anon_sym_AT] = ACTIONS(2081),
    [anon_sym_declare] = ACTIONS(2083),
    [anon_sym_STAR] = ACTIONS(2081),
    [anon_sym_void] = ACTIONS(2083),
    [anon_sym_any] = ACTIONS(2083),
    [anon_sym_private] = ACTIONS(2083),
    [anon_sym_boolean] = ACTIONS(2083),
    [anon_sym_async] = ACTIONS(2083),
    [anon_sym_public] = ACTIONS(2083),
    [anon_sym_get] = ACTIONS(2083),
    [anon_sym_RBRACE] = ACTIONS(2081),
    [anon_sym_static] = ACTIONS(2083),
    [anon_sym_SQUOTE] = ACTIONS(2081),
    [sym_number] = ACTIONS(2081),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2083),
    [anon_sym_string] = ACTIONS(2083),
    [anon_sym_abstract] = ACTIONS(2083),
    [anon_sym_set] = ACTIONS(2083),
    [anon_sym_type] = ACTIONS(2083),
    [anon_sym_import] = ACTIONS(2083),
    [anon_sym_export] = ACTIONS(2083),
    [anon_sym_namespace] = ACTIONS(2083),
    [sym_readonly] = ACTIONS(2083),
    [anon_sym_DQUOTE] = ACTIONS(2081),
  },
  [1682] = {
    [sym__automatic_semicolon] = ACTIONS(1033),
    [anon_sym_LBRACK] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1029),
    [anon_sym_SEMI] = ACTIONS(1033),
    [anon_sym_module] = ACTIONS(1029),
    [anon_sym_symbol] = ACTIONS(1029),
    [anon_sym_number] = ACTIONS(1029),
    [anon_sym_AT] = ACTIONS(1033),
    [anon_sym_declare] = ACTIONS(1029),
    [anon_sym_STAR] = ACTIONS(1033),
    [anon_sym_void] = ACTIONS(1029),
    [anon_sym_any] = ACTIONS(1029),
    [anon_sym_private] = ACTIONS(1029),
    [anon_sym_boolean] = ACTIONS(1029),
    [anon_sym_async] = ACTIONS(1029),
    [anon_sym_public] = ACTIONS(1029),
    [anon_sym_get] = ACTIONS(1029),
    [anon_sym_RBRACE] = ACTIONS(1033),
    [anon_sym_static] = ACTIONS(1029),
    [anon_sym_SQUOTE] = ACTIONS(1033),
    [sym_number] = ACTIONS(1033),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1029),
    [anon_sym_string] = ACTIONS(1029),
    [anon_sym_abstract] = ACTIONS(1029),
    [anon_sym_set] = ACTIONS(1029),
    [anon_sym_type] = ACTIONS(1029),
    [anon_sym_import] = ACTIONS(1029),
    [anon_sym_export] = ACTIONS(1029),
    [anon_sym_namespace] = ACTIONS(1029),
    [sym_readonly] = ACTIONS(1029),
    [anon_sym_DQUOTE] = ACTIONS(1033),
  },
  [1683] = {
    [sym__type] = STATE(1696),
    [sym_constructor_type] = STATE(1696),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1696),
    [sym_nested_identifier] = STATE(2437),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(2436),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(1678),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(1696),
    [sym_intersection_type] = STATE(1696),
    [sym_formal_parameters] = STATE(2157),
    [sym_identifier] = ACTIONS(3345),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1684] = {
    [sym__type] = STATE(1697),
    [sym_constructor_type] = STATE(1697),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1697),
    [sym_nested_identifier] = STATE(2437),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(2436),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(1678),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(1697),
    [sym_intersection_type] = STATE(1697),
    [sym_formal_parameters] = STATE(2157),
    [sym_identifier] = ACTIONS(3345),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1685] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(213),
    [anon_sym_PIPE] = ACTIONS(4063),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(1248),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [anon_sym_RBRACK] = ACTIONS(213),
    [anon_sym_GT] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_DASH_DASH] = ACTIONS(213),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_RPAREN] = ACTIONS(213),
    [anon_sym_SLASH] = ACTIONS(215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(213),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(215),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_PLUS_PLUS] = ACTIONS(213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(215),
  },
  [1686] = {
    [sym__type] = STATE(789),
    [sym_constructor_type] = STATE(789),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(789),
    [sym_nested_identifier] = STATE(2437),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(2436),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(1678),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(789),
    [sym_intersection_type] = STATE(789),
    [sym_formal_parameters] = STATE(2157),
    [sym_identifier] = ACTIONS(3345),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1687] = {
    [sym__type] = STATE(790),
    [sym_constructor_type] = STATE(790),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(790),
    [sym_nested_identifier] = STATE(2437),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(2436),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(1678),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(790),
    [sym_intersection_type] = STATE(790),
    [sym_formal_parameters] = STATE(2157),
    [sym_identifier] = ACTIONS(3345),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1688] = {
    [sym__type] = STATE(1701),
    [sym_constructor_type] = STATE(1701),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1701),
    [sym_nested_identifier] = STATE(2437),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(2436),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(1678),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(1701),
    [sym_intersection_type] = STATE(1701),
    [sym_formal_parameters] = STATE(2157),
    [sym_identifier] = ACTIONS(3345),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1689] = {
    [sym__type] = STATE(1702),
    [sym_constructor_type] = STATE(1702),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1702),
    [sym_nested_identifier] = STATE(2437),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(2436),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(1678),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(1702),
    [sym_intersection_type] = STATE(1702),
    [sym_formal_parameters] = STATE(2157),
    [sym_identifier] = ACTIONS(3345),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1690] = {
    [sym__initializer] = STATE(72),
    [sym_type_arguments] = STATE(497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4280),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4280),
    [anon_sym_AMP_EQ] = ACTIONS(4280),
    [anon_sym_PLUS_EQ] = ACTIONS(4280),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(1201),
    [anon_sym_is] = ACTIONS(1207),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_CARET_EQ] = ACTIONS(4280),
    [anon_sym_STAR_EQ] = ACTIONS(4280),
    [anon_sym_PIPE_EQ] = ACTIONS(4280),
    [anon_sym_DASH_EQ] = ACTIONS(4280),
    [anon_sym_EQ_GT] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4280),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4280),
    [anon_sym_GT_GT_EQ] = ACTIONS(4280),
    [anon_sym_DOT] = ACTIONS(4286),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4288),
  },
  [1691] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(2520),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(2523),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(2523),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1692] = {
    [sym__initializer] = STATE(80),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4290),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4290),
    [anon_sym_AMP_EQ] = ACTIONS(4290),
    [anon_sym_PLUS_EQ] = ACTIONS(4290),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_COMMA] = ACTIONS(1244),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(2526),
    [anon_sym_CARET_EQ] = ACTIONS(4290),
    [anon_sym_STAR_EQ] = ACTIONS(4290),
    [anon_sym_PIPE_EQ] = ACTIONS(4290),
    [anon_sym_DASH_EQ] = ACTIONS(4290),
    [anon_sym_EQ_GT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4290),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4290),
    [anon_sym_GT_GT_EQ] = ACTIONS(4290),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4290),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1693] = {
    [sym_new_expression] = STATE(2217),
    [sym_augmented_assignment_expression] = STATE(2217),
    [sym__initializer] = STATE(80),
    [sym_unary_expression] = STATE(2217),
    [sym_update_expression] = STATE(2217),
    [sym_regex] = STATE(2217),
    [sym_meta_property] = STATE(2217),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(2217),
    [sym_yield_expression] = STATE(2217),
    [sym_as_expression] = STATE(2217),
    [sym_non_null_expression] = STATE(2217),
    [sym_internal_module] = STATE(2217),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(2217),
    [sym_await_expression] = STATE(2217),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(2217),
    [sym_this] = STATE(2217),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(2217),
    [sym_generator_function] = STATE(2217),
    [sym_call_expression] = STATE(2217),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(2217),
    [sym_ternary_expression] = STATE(2217),
    [sym_binary_expression] = STATE(2217),
    [sym_template_string] = STATE(2217),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2217),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(2217),
    [sym_class] = STATE(2217),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1367),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(4290),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_AMP_EQ] = ACTIONS(4290),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4290),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(4290),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_PIPE_EQ] = ACTIONS(4290),
    [anon_sym_DASH_EQ] = ACTIONS(4290),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(4290),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(1379),
    [sym_true] = ACTIONS(4294),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_GT_GT_EQ] = ACTIONS(4290),
    [anon_sym_DOT] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4290),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(4296),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(4294),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4290),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(2526),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_STAR_EQ] = ACTIONS(4290),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_EQ_GT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(4298),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4290),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(4294),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1694] = {
    [sym__automatic_semicolon] = ACTIONS(2652),
    [anon_sym_LBRACK] = ACTIONS(2652),
    [anon_sym_AMP] = ACTIONS(2652),
    [anon_sym_SEMI] = ACTIONS(2652),
    [anon_sym_RBRACE] = ACTIONS(2652),
    [anon_sym_PIPE] = ACTIONS(2654),
    [anon_sym_COMMA] = ACTIONS(2652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(2652),
    [anon_sym_EQ] = ACTIONS(2652),
    [anon_sym_DOT] = ACTIONS(2652),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2652),
  },
  [1695] = {
    [anon_sym_BQUOTE] = ACTIONS(2974),
    [anon_sym_symbol] = ACTIONS(2976),
    [anon_sym_PIPE] = ACTIONS(2974),
    [anon_sym_break] = ACTIONS(2976),
    [anon_sym_return] = ACTIONS(2976),
    [anon_sym_RBRACE] = ACTIONS(2974),
    [anon_sym_interface] = ACTIONS(2976),
    [anon_sym_delete] = ACTIONS(2976),
    [anon_sym_if] = ACTIONS(2976),
    [anon_sym_yield] = ACTIONS(2976),
    [sym_true] = ACTIONS(2976),
    [anon_sym_protected] = ACTIONS(2976),
    [anon_sym_DOT] = ACTIONS(2654),
    [anon_sym_set] = ACTIONS(2976),
    [anon_sym_import] = ACTIONS(2976),
    [anon_sym_await] = ACTIONS(2976),
    [anon_sym_DQUOTE] = ACTIONS(2974),
    [anon_sym_for] = ACTIONS(2976),
    [anon_sym_SEMI] = ACTIONS(2974),
    [anon_sym_number] = ACTIONS(2976),
    [anon_sym_typeof] = ACTIONS(2976),
    [anon_sym_LBRACE] = ACTIONS(2974),
    [anon_sym_switch] = ACTIONS(2976),
    [sym_null] = ACTIONS(2976),
    [anon_sym_any] = ACTIONS(2976),
    [anon_sym_async] = ACTIONS(2976),
    [anon_sym_public] = ACTIONS(2976),
    [anon_sym_var] = ACTIONS(2976),
    [anon_sym_while] = ACTIONS(2976),
    [anon_sym_SQUOTE] = ACTIONS(2974),
    [anon_sym_SLASH] = ACTIONS(2976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2976),
    [anon_sym_new] = ACTIONS(2976),
    [anon_sym_export] = ACTIONS(2976),
    [anon_sym_with] = ACTIONS(2976),
    [sym_identifier] = ACTIONS(2976),
    [anon_sym_debugger] = ACTIONS(2976),
    [anon_sym_AT] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(2976),
    [anon_sym_void] = ACTIONS(2976),
    [anon_sym_const] = ACTIONS(2976),
    [sym_super] = ACTIONS(2976),
    [anon_sym_private] = ACTIONS(2976),
    [anon_sym_get] = ACTIONS(2976),
    [anon_sym_default] = ACTIONS(2976),
    [anon_sym_enum] = ACTIONS(2976),
    [anon_sym_continue] = ACTIONS(2976),
    [anon_sym_DASH_DASH] = ACTIONS(2974),
    [anon_sym_this] = ACTIONS(2976),
    [anon_sym_throw] = ACTIONS(2976),
    [anon_sym_abstract] = ACTIONS(2976),
    [anon_sym_type] = ACTIONS(2976),
    [anon_sym_namespace] = ACTIONS(2976),
    [anon_sym_PLUS_PLUS] = ACTIONS(2974),
    [anon_sym_else] = ACTIONS(2976),
    [anon_sym_BANG] = ACTIONS(2974),
    [anon_sym_LBRACK] = ACTIONS(2974),
    [sym_false] = ACTIONS(2976),
    [anon_sym_case] = ACTIONS(2976),
    [anon_sym_module] = ACTIONS(2976),
    [anon_sym_class] = ACTIONS(2976),
    [anon_sym_declare] = ACTIONS(2976),
    [anon_sym_LPAREN] = ACTIONS(2974),
    [anon_sym_boolean] = ACTIONS(2976),
    [anon_sym_AMP] = ACTIONS(2974),
    [anon_sym_try] = ACTIONS(2976),
    [anon_sym_LT] = ACTIONS(2974),
    [sym_number] = ACTIONS(2974),
    [ts_builtin_sym_end] = ACTIONS(2974),
    [anon_sym_function] = ACTIONS(2976),
    [sym_undefined] = ACTIONS(2976),
    [anon_sym_let] = ACTIONS(2976),
    [anon_sym_PLUS] = ACTIONS(2976),
    [anon_sym_do] = ACTIONS(2976),
    [anon_sym_TILDE] = ACTIONS(2974),
    [anon_sym_in] = ACTIONS(2976),
  },
  [1696] = {
    [sym_identifier] = ACTIONS(2980),
    [anon_sym_BQUOTE] = ACTIONS(2978),
    [anon_sym_debugger] = ACTIONS(2980),
    [anon_sym_symbol] = ACTIONS(2980),
    [anon_sym_AT] = ACTIONS(2978),
    [anon_sym_PIPE] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(2980),
    [anon_sym_void] = ACTIONS(2980),
    [anon_sym_break] = ACTIONS(2980),
    [anon_sym_const] = ACTIONS(2980),
    [sym_super] = ACTIONS(2980),
    [anon_sym_return] = ACTIONS(2980),
    [anon_sym_private] = ACTIONS(2980),
    [anon_sym_get] = ACTIONS(2980),
    [anon_sym_RBRACE] = ACTIONS(2978),
    [anon_sym_interface] = ACTIONS(2980),
    [anon_sym_default] = ACTIONS(2980),
    [anon_sym_enum] = ACTIONS(2980),
    [anon_sym_delete] = ACTIONS(2980),
    [anon_sym_continue] = ACTIONS(2980),
    [anon_sym_DASH_DASH] = ACTIONS(2978),
    [anon_sym_if] = ACTIONS(2980),
    [anon_sym_this] = ACTIONS(2980),
    [anon_sym_yield] = ACTIONS(2980),
    [sym_true] = ACTIONS(2980),
    [anon_sym_throw] = ACTIONS(2980),
    [anon_sym_protected] = ACTIONS(2980),
    [anon_sym_abstract] = ACTIONS(2980),
    [anon_sym_set] = ACTIONS(2980),
    [anon_sym_type] = ACTIONS(2980),
    [anon_sym_import] = ACTIONS(2980),
    [anon_sym_namespace] = ACTIONS(2980),
    [anon_sym_PLUS_PLUS] = ACTIONS(2978),
    [anon_sym_await] = ACTIONS(2980),
    [anon_sym_DQUOTE] = ACTIONS(2978),
    [anon_sym_else] = ACTIONS(2980),
    [anon_sym_BANG] = ACTIONS(2978),
    [anon_sym_for] = ACTIONS(2980),
    [anon_sym_LBRACK] = ACTIONS(2978),
    [sym_false] = ACTIONS(2980),
    [anon_sym_SEMI] = ACTIONS(2978),
    [anon_sym_case] = ACTIONS(2980),
    [anon_sym_module] = ACTIONS(2980),
    [anon_sym_number] = ACTIONS(2980),
    [anon_sym_class] = ACTIONS(2980),
    [anon_sym_declare] = ACTIONS(2980),
    [anon_sym_typeof] = ACTIONS(2980),
    [anon_sym_LBRACE] = ACTIONS(2978),
    [anon_sym_switch] = ACTIONS(2980),
    [anon_sym_LPAREN] = ACTIONS(2978),
    [sym_null] = ACTIONS(2980),
    [anon_sym_any] = ACTIONS(2980),
    [anon_sym_boolean] = ACTIONS(2980),
    [anon_sym_async] = ACTIONS(2980),
    [anon_sym_public] = ACTIONS(2980),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_var] = ACTIONS(2980),
    [anon_sym_while] = ACTIONS(2980),
    [anon_sym_SQUOTE] = ACTIONS(2978),
    [anon_sym_try] = ACTIONS(2980),
    [anon_sym_LT] = ACTIONS(2978),
    [sym_number] = ACTIONS(2978),
    [anon_sym_SLASH] = ACTIONS(2980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2980),
    [anon_sym_function] = ACTIONS(2980),
    [sym_undefined] = ACTIONS(2980),
    [anon_sym_new] = ACTIONS(2980),
    [ts_builtin_sym_end] = ACTIONS(2978),
    [anon_sym_let] = ACTIONS(2980),
    [anon_sym_PLUS] = ACTIONS(2980),
    [anon_sym_export] = ACTIONS(2980),
    [anon_sym_do] = ACTIONS(2980),
    [anon_sym_TILDE] = ACTIONS(2978),
    [anon_sym_with] = ACTIONS(2980),
  },
  [1697] = {
    [sym_identifier] = ACTIONS(2984),
    [anon_sym_BQUOTE] = ACTIONS(2982),
    [anon_sym_debugger] = ACTIONS(2984),
    [anon_sym_symbol] = ACTIONS(2984),
    [anon_sym_AT] = ACTIONS(2982),
    [anon_sym_PIPE] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(2984),
    [anon_sym_void] = ACTIONS(2984),
    [anon_sym_break] = ACTIONS(2984),
    [anon_sym_const] = ACTIONS(2984),
    [sym_super] = ACTIONS(2984),
    [anon_sym_return] = ACTIONS(2984),
    [anon_sym_private] = ACTIONS(2984),
    [anon_sym_get] = ACTIONS(2984),
    [anon_sym_RBRACE] = ACTIONS(2982),
    [anon_sym_interface] = ACTIONS(2984),
    [anon_sym_default] = ACTIONS(2984),
    [anon_sym_enum] = ACTIONS(2984),
    [anon_sym_delete] = ACTIONS(2984),
    [anon_sym_continue] = ACTIONS(2984),
    [anon_sym_DASH_DASH] = ACTIONS(2982),
    [anon_sym_if] = ACTIONS(2984),
    [anon_sym_this] = ACTIONS(2984),
    [anon_sym_yield] = ACTIONS(2984),
    [sym_true] = ACTIONS(2984),
    [anon_sym_throw] = ACTIONS(2984),
    [anon_sym_protected] = ACTIONS(2984),
    [anon_sym_abstract] = ACTIONS(2984),
    [anon_sym_set] = ACTIONS(2984),
    [anon_sym_type] = ACTIONS(2984),
    [anon_sym_import] = ACTIONS(2984),
    [anon_sym_namespace] = ACTIONS(2984),
    [anon_sym_PLUS_PLUS] = ACTIONS(2982),
    [anon_sym_await] = ACTIONS(2984),
    [anon_sym_DQUOTE] = ACTIONS(2982),
    [anon_sym_else] = ACTIONS(2984),
    [anon_sym_BANG] = ACTIONS(2982),
    [anon_sym_for] = ACTIONS(2984),
    [anon_sym_LBRACK] = ACTIONS(2982),
    [sym_false] = ACTIONS(2984),
    [anon_sym_SEMI] = ACTIONS(2982),
    [anon_sym_case] = ACTIONS(2984),
    [anon_sym_module] = ACTIONS(2984),
    [anon_sym_number] = ACTIONS(2984),
    [anon_sym_class] = ACTIONS(2984),
    [anon_sym_declare] = ACTIONS(2984),
    [anon_sym_typeof] = ACTIONS(2984),
    [anon_sym_LBRACE] = ACTIONS(2982),
    [anon_sym_switch] = ACTIONS(2984),
    [anon_sym_LPAREN] = ACTIONS(2982),
    [sym_null] = ACTIONS(2984),
    [anon_sym_any] = ACTIONS(2984),
    [anon_sym_boolean] = ACTIONS(2984),
    [anon_sym_async] = ACTIONS(2984),
    [anon_sym_public] = ACTIONS(2984),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_var] = ACTIONS(2984),
    [anon_sym_while] = ACTIONS(2984),
    [anon_sym_SQUOTE] = ACTIONS(2982),
    [anon_sym_try] = ACTIONS(2984),
    [anon_sym_LT] = ACTIONS(2982),
    [sym_number] = ACTIONS(2982),
    [anon_sym_SLASH] = ACTIONS(2984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2984),
    [anon_sym_function] = ACTIONS(2984),
    [sym_undefined] = ACTIONS(2984),
    [anon_sym_new] = ACTIONS(2984),
    [ts_builtin_sym_end] = ACTIONS(2982),
    [anon_sym_let] = ACTIONS(2984),
    [anon_sym_PLUS] = ACTIONS(2984),
    [anon_sym_export] = ACTIONS(2984),
    [anon_sym_do] = ACTIONS(2984),
    [anon_sym_TILDE] = ACTIONS(2982),
    [anon_sym_with] = ACTIONS(2984),
  },
  [1698] = {
    [sym__type] = STATE(1707),
    [sym_constructor_type] = STATE(1707),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1707),
    [sym_nested_identifier] = STATE(2437),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(2436),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(1678),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(1707),
    [sym_intersection_type] = STATE(1707),
    [sym_formal_parameters] = STATE(2157),
    [sym_identifier] = ACTIONS(3345),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1699] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_SEMI] = ACTIONS(1027),
    [anon_sym_BQUOTE] = ACTIONS(1027),
    [sym__automatic_semicolon] = ACTIONS(1027),
    [anon_sym_PIPE] = ACTIONS(1031),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_STAR] = ACTIONS(1031),
    [anon_sym_GT_GT_GT] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_COMMA] = ACTIONS(2245),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1031),
    [anon_sym_AMP] = ACTIONS(1031),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(1027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1031),
    [anon_sym_SLASH] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(1031),
  },
  [1700] = {
    [sym__type] = STATE(1709),
    [sym_constructor_type] = STATE(1709),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1709),
    [sym_nested_identifier] = STATE(2437),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(2436),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(1678),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(1709),
    [sym_intersection_type] = STATE(1709),
    [sym_formal_parameters] = STATE(2157),
    [sym_identifier] = ACTIONS(3345),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1701] = {
    [sym_identifier] = ACTIONS(3101),
    [anon_sym_BQUOTE] = ACTIONS(3099),
    [anon_sym_debugger] = ACTIONS(3101),
    [anon_sym_symbol] = ACTIONS(3101),
    [anon_sym_AT] = ACTIONS(3099),
    [anon_sym_PIPE] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(3101),
    [anon_sym_void] = ACTIONS(3101),
    [anon_sym_break] = ACTIONS(3101),
    [anon_sym_const] = ACTIONS(3101),
    [sym_super] = ACTIONS(3101),
    [anon_sym_return] = ACTIONS(3101),
    [anon_sym_private] = ACTIONS(3101),
    [anon_sym_get] = ACTIONS(3101),
    [anon_sym_RBRACE] = ACTIONS(3099),
    [anon_sym_interface] = ACTIONS(3101),
    [anon_sym_default] = ACTIONS(3101),
    [anon_sym_enum] = ACTIONS(3101),
    [anon_sym_delete] = ACTIONS(3101),
    [anon_sym_continue] = ACTIONS(3101),
    [anon_sym_DASH_DASH] = ACTIONS(3099),
    [anon_sym_if] = ACTIONS(3101),
    [anon_sym_this] = ACTIONS(3101),
    [anon_sym_yield] = ACTIONS(3101),
    [sym_true] = ACTIONS(3101),
    [anon_sym_throw] = ACTIONS(3101),
    [anon_sym_protected] = ACTIONS(3101),
    [anon_sym_abstract] = ACTIONS(3101),
    [anon_sym_set] = ACTIONS(3101),
    [anon_sym_type] = ACTIONS(3101),
    [anon_sym_import] = ACTIONS(3101),
    [anon_sym_namespace] = ACTIONS(3101),
    [anon_sym_PLUS_PLUS] = ACTIONS(3099),
    [anon_sym_await] = ACTIONS(3101),
    [anon_sym_DQUOTE] = ACTIONS(3099),
    [anon_sym_else] = ACTIONS(3101),
    [anon_sym_BANG] = ACTIONS(3099),
    [anon_sym_for] = ACTIONS(3101),
    [anon_sym_LBRACK] = ACTIONS(3099),
    [sym_false] = ACTIONS(3101),
    [anon_sym_SEMI] = ACTIONS(3099),
    [anon_sym_case] = ACTIONS(3101),
    [anon_sym_module] = ACTIONS(3101),
    [anon_sym_number] = ACTIONS(3101),
    [anon_sym_class] = ACTIONS(3101),
    [anon_sym_declare] = ACTIONS(3101),
    [anon_sym_typeof] = ACTIONS(3101),
    [anon_sym_LBRACE] = ACTIONS(3099),
    [anon_sym_switch] = ACTIONS(3101),
    [anon_sym_LPAREN] = ACTIONS(3099),
    [sym_null] = ACTIONS(3101),
    [anon_sym_any] = ACTIONS(3101),
    [anon_sym_boolean] = ACTIONS(3101),
    [anon_sym_async] = ACTIONS(3101),
    [anon_sym_public] = ACTIONS(3101),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_var] = ACTIONS(3101),
    [anon_sym_while] = ACTIONS(3101),
    [anon_sym_SQUOTE] = ACTIONS(3099),
    [anon_sym_try] = ACTIONS(3101),
    [anon_sym_LT] = ACTIONS(3099),
    [sym_number] = ACTIONS(3099),
    [anon_sym_SLASH] = ACTIONS(3101),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3101),
    [anon_sym_function] = ACTIONS(3101),
    [sym_undefined] = ACTIONS(3101),
    [anon_sym_new] = ACTIONS(3101),
    [ts_builtin_sym_end] = ACTIONS(3099),
    [anon_sym_let] = ACTIONS(3101),
    [anon_sym_PLUS] = ACTIONS(3101),
    [anon_sym_export] = ACTIONS(3101),
    [anon_sym_do] = ACTIONS(3101),
    [anon_sym_TILDE] = ACTIONS(3099),
    [anon_sym_with] = ACTIONS(3101),
  },
  [1702] = {
    [sym_identifier] = ACTIONS(3122),
    [anon_sym_BQUOTE] = ACTIONS(3120),
    [anon_sym_debugger] = ACTIONS(3122),
    [anon_sym_symbol] = ACTIONS(3122),
    [anon_sym_AT] = ACTIONS(3120),
    [anon_sym_PIPE] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(3122),
    [anon_sym_void] = ACTIONS(3122),
    [anon_sym_break] = ACTIONS(3122),
    [anon_sym_const] = ACTIONS(3122),
    [sym_super] = ACTIONS(3122),
    [anon_sym_return] = ACTIONS(3122),
    [anon_sym_private] = ACTIONS(3122),
    [anon_sym_get] = ACTIONS(3122),
    [anon_sym_RBRACE] = ACTIONS(3120),
    [anon_sym_interface] = ACTIONS(3122),
    [anon_sym_default] = ACTIONS(3122),
    [anon_sym_enum] = ACTIONS(3122),
    [anon_sym_delete] = ACTIONS(3122),
    [anon_sym_continue] = ACTIONS(3122),
    [anon_sym_DASH_DASH] = ACTIONS(3120),
    [anon_sym_if] = ACTIONS(3122),
    [anon_sym_this] = ACTIONS(3122),
    [anon_sym_yield] = ACTIONS(3122),
    [sym_true] = ACTIONS(3122),
    [anon_sym_throw] = ACTIONS(3122),
    [anon_sym_protected] = ACTIONS(3122),
    [anon_sym_abstract] = ACTIONS(3122),
    [anon_sym_set] = ACTIONS(3122),
    [anon_sym_type] = ACTIONS(3122),
    [anon_sym_import] = ACTIONS(3122),
    [anon_sym_namespace] = ACTIONS(3122),
    [anon_sym_PLUS_PLUS] = ACTIONS(3120),
    [anon_sym_await] = ACTIONS(3122),
    [anon_sym_DQUOTE] = ACTIONS(3120),
    [anon_sym_else] = ACTIONS(3122),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_for] = ACTIONS(3122),
    [anon_sym_LBRACK] = ACTIONS(3120),
    [sym_false] = ACTIONS(3122),
    [anon_sym_SEMI] = ACTIONS(3120),
    [anon_sym_case] = ACTIONS(3122),
    [anon_sym_module] = ACTIONS(3122),
    [anon_sym_number] = ACTIONS(3122),
    [anon_sym_class] = ACTIONS(3122),
    [anon_sym_declare] = ACTIONS(3122),
    [anon_sym_typeof] = ACTIONS(3122),
    [anon_sym_LBRACE] = ACTIONS(3120),
    [anon_sym_switch] = ACTIONS(3122),
    [anon_sym_LPAREN] = ACTIONS(3120),
    [sym_null] = ACTIONS(3122),
    [anon_sym_any] = ACTIONS(3122),
    [anon_sym_boolean] = ACTIONS(3122),
    [anon_sym_async] = ACTIONS(3122),
    [anon_sym_public] = ACTIONS(3122),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_var] = ACTIONS(3122),
    [anon_sym_while] = ACTIONS(3122),
    [anon_sym_SQUOTE] = ACTIONS(3120),
    [anon_sym_try] = ACTIONS(3122),
    [anon_sym_LT] = ACTIONS(3120),
    [sym_number] = ACTIONS(3120),
    [anon_sym_SLASH] = ACTIONS(3122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3122),
    [anon_sym_function] = ACTIONS(3122),
    [sym_undefined] = ACTIONS(3122),
    [anon_sym_new] = ACTIONS(3122),
    [ts_builtin_sym_end] = ACTIONS(3120),
    [anon_sym_let] = ACTIONS(3122),
    [anon_sym_PLUS] = ACTIONS(3122),
    [anon_sym_export] = ACTIONS(3122),
    [anon_sym_do] = ACTIONS(3122),
    [anon_sym_TILDE] = ACTIONS(3120),
    [anon_sym_with] = ACTIONS(3122),
  },
  [1703] = {
    [sym_new_expression] = STATE(1290),
    [sym_constructor_type] = STATE(754),
    [sym_augmented_assignment_expression] = STATE(1290),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(1290),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(1290),
    [sym_call_signature] = STATE(1740),
    [sym_yield_expression] = STATE(1290),
    [sym_as_expression] = STATE(1290),
    [sym_internal_module] = STATE(1290),
    [sym_arrow_function] = STATE(1290),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(1201),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1691),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(1202),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(1290),
    [sym_subscript_expression] = STATE(1201),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(1290),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(1290),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(754),
    [sym__type] = STATE(754),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(1290),
    [sym_meta_property] = STATE(1290),
    [sym_function_type] = STATE(754),
    [sym__expression] = STATE(1290),
    [sym_non_null_expression] = STATE(1290),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(1290),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(1290),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(1290),
    [sym_call_expression] = STATE(1290),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(1290),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(1290),
    [sym_type_arguments] = STATE(1205),
    [sym_union_type] = STATE(754),
    [sym_parenthesized_expression] = STATE(1290),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1290),
    [sym_class] = STATE(1290),
    [sym_identifier] = ACTIONS(4300),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(4302),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(4304),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(2546),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(2546),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(4302),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(2548),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [sym_null] = ACTIONS(3940),
    [anon_sym_any] = ACTIONS(4302),
    [anon_sym_boolean] = ACTIONS(4302),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2550),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4302),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3940),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2540),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1704] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(2305),
    [sym__automatic_semicolon] = ACTIONS(2305),
    [anon_sym_PERCENT_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_AMP_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_EQ] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(1088),
    [anon_sym_STAR_EQ] = ACTIONS(1088),
    [anon_sym_PIPE_EQ] = ACTIONS(1088),
    [anon_sym_DASH_EQ] = ACTIONS(1088),
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(2305),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1088),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(4306),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2305),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1088),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(847),
  },
  [1705] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2311),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(2311),
    [sym__automatic_semicolon] = ACTIONS(2311),
    [anon_sym_PIPE] = ACTIONS(2313),
    [anon_sym_COMMA] = ACTIONS(2311),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_RBRACE] = ACTIONS(2311),
    [anon_sym_AMP] = ACTIONS(2313),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2311),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1706] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(3297),
    [anon_sym_COMMA] = ACTIONS(3291),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_RBRACK] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(1697),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(3297),
  },
  [1707] = {
    [sym_identifier] = ACTIONS(3482),
    [anon_sym_BQUOTE] = ACTIONS(3480),
    [anon_sym_debugger] = ACTIONS(3482),
    [anon_sym_symbol] = ACTIONS(3482),
    [anon_sym_AT] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(3482),
    [anon_sym_void] = ACTIONS(3482),
    [anon_sym_break] = ACTIONS(3482),
    [anon_sym_const] = ACTIONS(3482),
    [sym_super] = ACTIONS(3482),
    [anon_sym_return] = ACTIONS(3482),
    [anon_sym_private] = ACTIONS(3482),
    [anon_sym_get] = ACTIONS(3482),
    [anon_sym_RBRACE] = ACTIONS(3480),
    [anon_sym_interface] = ACTIONS(3482),
    [anon_sym_default] = ACTIONS(3482),
    [anon_sym_enum] = ACTIONS(3482),
    [anon_sym_delete] = ACTIONS(3482),
    [anon_sym_continue] = ACTIONS(3482),
    [anon_sym_DASH_DASH] = ACTIONS(3480),
    [anon_sym_if] = ACTIONS(3482),
    [anon_sym_this] = ACTIONS(3482),
    [anon_sym_yield] = ACTIONS(3482),
    [sym_true] = ACTIONS(3482),
    [anon_sym_throw] = ACTIONS(3482),
    [anon_sym_protected] = ACTIONS(3482),
    [anon_sym_abstract] = ACTIONS(3482),
    [anon_sym_set] = ACTIONS(3482),
    [anon_sym_type] = ACTIONS(3482),
    [anon_sym_import] = ACTIONS(3482),
    [anon_sym_namespace] = ACTIONS(3482),
    [anon_sym_PLUS_PLUS] = ACTIONS(3480),
    [anon_sym_await] = ACTIONS(3482),
    [anon_sym_DQUOTE] = ACTIONS(3480),
    [anon_sym_else] = ACTIONS(3482),
    [anon_sym_BANG] = ACTIONS(3480),
    [anon_sym_for] = ACTIONS(3482),
    [anon_sym_LBRACK] = ACTIONS(3480),
    [sym_false] = ACTIONS(3482),
    [anon_sym_SEMI] = ACTIONS(3480),
    [anon_sym_case] = ACTIONS(3482),
    [anon_sym_module] = ACTIONS(3482),
    [anon_sym_number] = ACTIONS(3482),
    [anon_sym_class] = ACTIONS(3482),
    [anon_sym_declare] = ACTIONS(3482),
    [anon_sym_typeof] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(3480),
    [anon_sym_switch] = ACTIONS(3482),
    [anon_sym_LPAREN] = ACTIONS(3480),
    [sym_null] = ACTIONS(3482),
    [anon_sym_any] = ACTIONS(3482),
    [anon_sym_boolean] = ACTIONS(3482),
    [anon_sym_async] = ACTIONS(3482),
    [anon_sym_public] = ACTIONS(3482),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_var] = ACTIONS(3482),
    [anon_sym_while] = ACTIONS(3482),
    [anon_sym_SQUOTE] = ACTIONS(3480),
    [anon_sym_try] = ACTIONS(3482),
    [anon_sym_LT] = ACTIONS(3480),
    [sym_number] = ACTIONS(3480),
    [anon_sym_SLASH] = ACTIONS(3482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3482),
    [anon_sym_function] = ACTIONS(3482),
    [sym_undefined] = ACTIONS(3482),
    [anon_sym_new] = ACTIONS(3482),
    [ts_builtin_sym_end] = ACTIONS(3480),
    [anon_sym_let] = ACTIONS(3482),
    [anon_sym_PLUS] = ACTIONS(3482),
    [anon_sym_export] = ACTIONS(3482),
    [anon_sym_do] = ACTIONS(3482),
    [anon_sym_TILDE] = ACTIONS(3480),
    [anon_sym_with] = ACTIONS(3482),
  },
  [1708] = {
    [sym__type] = STATE(1710),
    [sym_constructor_type] = STATE(1710),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1710),
    [sym_nested_identifier] = STATE(2437),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(2436),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(1678),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(1710),
    [sym_intersection_type] = STATE(1710),
    [sym_formal_parameters] = STATE(2157),
    [sym_identifier] = ACTIONS(3345),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1709] = {
    [sym_identifier] = ACTIONS(3529),
    [anon_sym_BQUOTE] = ACTIONS(3527),
    [anon_sym_debugger] = ACTIONS(3529),
    [anon_sym_symbol] = ACTIONS(3529),
    [anon_sym_AT] = ACTIONS(3527),
    [anon_sym_PIPE] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_void] = ACTIONS(3529),
    [anon_sym_break] = ACTIONS(3529),
    [anon_sym_const] = ACTIONS(3529),
    [sym_super] = ACTIONS(3529),
    [anon_sym_return] = ACTIONS(3529),
    [anon_sym_private] = ACTIONS(3529),
    [anon_sym_get] = ACTIONS(3529),
    [anon_sym_RBRACE] = ACTIONS(3527),
    [anon_sym_interface] = ACTIONS(3529),
    [anon_sym_default] = ACTIONS(3529),
    [anon_sym_enum] = ACTIONS(3529),
    [anon_sym_delete] = ACTIONS(3529),
    [anon_sym_continue] = ACTIONS(3529),
    [anon_sym_DASH_DASH] = ACTIONS(3527),
    [anon_sym_if] = ACTIONS(3529),
    [anon_sym_this] = ACTIONS(3529),
    [anon_sym_yield] = ACTIONS(3529),
    [sym_true] = ACTIONS(3529),
    [anon_sym_throw] = ACTIONS(3529),
    [anon_sym_protected] = ACTIONS(3529),
    [anon_sym_abstract] = ACTIONS(3529),
    [anon_sym_set] = ACTIONS(3529),
    [anon_sym_type] = ACTIONS(3529),
    [anon_sym_import] = ACTIONS(3529),
    [anon_sym_namespace] = ACTIONS(3529),
    [anon_sym_PLUS_PLUS] = ACTIONS(3527),
    [anon_sym_await] = ACTIONS(3529),
    [anon_sym_DQUOTE] = ACTIONS(3527),
    [anon_sym_else] = ACTIONS(3529),
    [anon_sym_BANG] = ACTIONS(3527),
    [anon_sym_for] = ACTIONS(3529),
    [anon_sym_LBRACK] = ACTIONS(3527),
    [sym_false] = ACTIONS(3529),
    [anon_sym_SEMI] = ACTIONS(3527),
    [anon_sym_case] = ACTIONS(3529),
    [anon_sym_module] = ACTIONS(3529),
    [anon_sym_number] = ACTIONS(3529),
    [anon_sym_class] = ACTIONS(3529),
    [anon_sym_declare] = ACTIONS(3529),
    [anon_sym_typeof] = ACTIONS(3529),
    [anon_sym_LBRACE] = ACTIONS(3527),
    [anon_sym_switch] = ACTIONS(3529),
    [anon_sym_LPAREN] = ACTIONS(3527),
    [sym_null] = ACTIONS(3529),
    [anon_sym_any] = ACTIONS(3529),
    [anon_sym_boolean] = ACTIONS(3529),
    [anon_sym_async] = ACTIONS(3529),
    [anon_sym_public] = ACTIONS(3529),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_var] = ACTIONS(3529),
    [anon_sym_while] = ACTIONS(3529),
    [anon_sym_SQUOTE] = ACTIONS(3527),
    [anon_sym_try] = ACTIONS(3529),
    [anon_sym_LT] = ACTIONS(3527),
    [sym_number] = ACTIONS(3527),
    [anon_sym_SLASH] = ACTIONS(3529),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3529),
    [anon_sym_function] = ACTIONS(3529),
    [sym_undefined] = ACTIONS(3529),
    [anon_sym_new] = ACTIONS(3529),
    [ts_builtin_sym_end] = ACTIONS(3527),
    [anon_sym_let] = ACTIONS(3529),
    [anon_sym_PLUS] = ACTIONS(3529),
    [anon_sym_export] = ACTIONS(3529),
    [anon_sym_do] = ACTIONS(3529),
    [anon_sym_TILDE] = ACTIONS(3527),
    [anon_sym_with] = ACTIONS(3529),
  },
  [1710] = {
    [sym_identifier] = ACTIONS(3727),
    [anon_sym_BQUOTE] = ACTIONS(3725),
    [anon_sym_debugger] = ACTIONS(3727),
    [anon_sym_symbol] = ACTIONS(3727),
    [anon_sym_AT] = ACTIONS(3725),
    [anon_sym_PIPE] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(3727),
    [anon_sym_void] = ACTIONS(3727),
    [anon_sym_break] = ACTIONS(3727),
    [anon_sym_const] = ACTIONS(3727),
    [sym_super] = ACTIONS(3727),
    [anon_sym_return] = ACTIONS(3727),
    [anon_sym_private] = ACTIONS(3727),
    [anon_sym_get] = ACTIONS(3727),
    [anon_sym_RBRACE] = ACTIONS(3725),
    [anon_sym_interface] = ACTIONS(3727),
    [anon_sym_default] = ACTIONS(3727),
    [anon_sym_enum] = ACTIONS(3727),
    [anon_sym_delete] = ACTIONS(3727),
    [anon_sym_continue] = ACTIONS(3727),
    [anon_sym_DASH_DASH] = ACTIONS(3725),
    [anon_sym_if] = ACTIONS(3727),
    [anon_sym_this] = ACTIONS(3727),
    [anon_sym_yield] = ACTIONS(3727),
    [sym_true] = ACTIONS(3727),
    [anon_sym_throw] = ACTIONS(3727),
    [anon_sym_protected] = ACTIONS(3727),
    [anon_sym_abstract] = ACTIONS(3727),
    [anon_sym_set] = ACTIONS(3727),
    [anon_sym_type] = ACTIONS(3727),
    [anon_sym_import] = ACTIONS(3727),
    [anon_sym_namespace] = ACTIONS(3727),
    [anon_sym_PLUS_PLUS] = ACTIONS(3725),
    [anon_sym_await] = ACTIONS(3727),
    [anon_sym_DQUOTE] = ACTIONS(3725),
    [anon_sym_else] = ACTIONS(3727),
    [anon_sym_BANG] = ACTIONS(3725),
    [anon_sym_for] = ACTIONS(3727),
    [anon_sym_LBRACK] = ACTIONS(3725),
    [sym_false] = ACTIONS(3727),
    [anon_sym_SEMI] = ACTIONS(3725),
    [anon_sym_case] = ACTIONS(3727),
    [anon_sym_module] = ACTIONS(3727),
    [anon_sym_number] = ACTIONS(3727),
    [anon_sym_class] = ACTIONS(3727),
    [anon_sym_declare] = ACTIONS(3727),
    [anon_sym_typeof] = ACTIONS(3727),
    [anon_sym_LBRACE] = ACTIONS(3725),
    [anon_sym_switch] = ACTIONS(3727),
    [anon_sym_LPAREN] = ACTIONS(3725),
    [sym_null] = ACTIONS(3727),
    [anon_sym_any] = ACTIONS(3727),
    [anon_sym_boolean] = ACTIONS(3727),
    [anon_sym_async] = ACTIONS(3727),
    [anon_sym_public] = ACTIONS(3727),
    [anon_sym_AMP] = ACTIONS(3665),
    [anon_sym_var] = ACTIONS(3727),
    [anon_sym_while] = ACTIONS(3727),
    [anon_sym_SQUOTE] = ACTIONS(3725),
    [anon_sym_try] = ACTIONS(3727),
    [anon_sym_LT] = ACTIONS(3725),
    [sym_number] = ACTIONS(3725),
    [anon_sym_SLASH] = ACTIONS(3727),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3727),
    [anon_sym_function] = ACTIONS(3727),
    [sym_undefined] = ACTIONS(3727),
    [anon_sym_new] = ACTIONS(3727),
    [ts_builtin_sym_end] = ACTIONS(3725),
    [anon_sym_let] = ACTIONS(3727),
    [anon_sym_PLUS] = ACTIONS(3727),
    [anon_sym_export] = ACTIONS(3727),
    [anon_sym_do] = ACTIONS(3727),
    [anon_sym_TILDE] = ACTIONS(3725),
    [anon_sym_with] = ACTIONS(3727),
  },
  [1711] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_COMMA] = ACTIONS(1695),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_COLON] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_RBRACK] = ACTIONS(3294),
    [anon_sym_GT] = ACTIONS(1697),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(3741),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1697),
  },
  [1712] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(213),
    [anon_sym_PIPE] = ACTIONS(4063),
    [anon_sym_COMMA] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_EQ] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_DASH_DASH] = ACTIONS(213),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_COLON] = ACTIONS(213),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_PLUS_PLUS] = ACTIONS(213),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(213),
    [anon_sym_RBRACK] = ACTIONS(2383),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_RPAREN] = ACTIONS(2383),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_SLASH] = ACTIONS(215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(215),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(215),
  },
  [1713] = {
    [sym__initializer] = STATE(1211),
    [sym_type_arguments] = STATE(1516),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(4308),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(1201),
    [sym__automatic_semicolon] = ACTIONS(1201),
    [anon_sym_PERCENT_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_AMP_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_EQ] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2509),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_is] = ACTIONS(4136),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(1088),
    [anon_sym_STAR_EQ] = ACTIONS(1088),
    [anon_sym_PIPE_EQ] = ACTIONS(1088),
    [anon_sym_DASH_EQ] = ACTIONS(1088),
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [anon_sym_RBRACE] = ACTIONS(2509),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1088),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(4312),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(4315),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1201),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1088),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4317),
  },
  [1714] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(2520),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(1216),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1715] = {
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(1244),
    [sym__automatic_semicolon] = ACTIONS(1244),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_RBRACE] = ACTIONS(2529),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1244),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1716] = {
    [sym_new_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_non_null_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1220),
    [sym_this] = STATE(1220),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1220),
    [sym_generator_function] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1220),
    [sym_class] = STATE(1220),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(1244),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_RBRACE] = ACTIONS(2529),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(1124),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1244),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1124),
    [anon_sym_SEMI] = ACTIONS(1244),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(1124),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(1130),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1717] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1027),
    [anon_sym_LBRACK] = ACTIONS(1027),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_BQUOTE] = ACTIONS(1027),
    [anon_sym_SEMI] = ACTIONS(2245),
    [sym__automatic_semicolon] = ACTIONS(2245),
    [anon_sym_PIPE] = ACTIONS(1031),
    [anon_sym_COMMA] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1031),
    [anon_sym_GT_GT_GT] = ACTIONS(1027),
    [anon_sym_EQ] = ACTIONS(1031),
    [anon_sym_AMP_AMP] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1031),
    [anon_sym_BANG_EQ] = ACTIONS(1031),
    [anon_sym_LT_EQ] = ACTIONS(1027),
    [anon_sym_LPAREN] = ACTIONS(1027),
    [anon_sym_GT_EQ] = ACTIONS(1027),
    [anon_sym_GT] = ACTIONS(1031),
    [anon_sym_RBRACE] = ACTIONS(1027),
    [anon_sym_AMP] = ACTIONS(1031),
    [anon_sym_QMARK] = ACTIONS(1027),
    [anon_sym_PERCENT] = ACTIONS(1027),
    [anon_sym_as] = ACTIONS(1027),
    [anon_sym_PIPE_PIPE] = ACTIONS(1027),
    [anon_sym_DASH_DASH] = ACTIONS(1027),
    [anon_sym_EQ_EQ] = ACTIONS(1031),
    [anon_sym_instanceof] = ACTIONS(1027),
    [anon_sym_LT] = ACTIONS(1031),
    [anon_sym_SLASH] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(1027),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_STAR_STAR] = ACTIONS(1027),
    [anon_sym_PLUS] = ACTIONS(1031),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(1031),
    [anon_sym_PLUS_PLUS] = ACTIONS(1027),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1027),
    [anon_sym_in] = ACTIONS(1031),
  },
  [1718] = {
    [sym_new_expression] = STATE(2081),
    [sym_constructor_type] = STATE(754),
    [sym_augmented_assignment_expression] = STATE(2081),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(2081),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(2081),
    [sym_call_signature] = STATE(1997),
    [sym_yield_expression] = STATE(2081),
    [sym_as_expression] = STATE(2081),
    [sym_internal_module] = STATE(2081),
    [sym_arrow_function] = STATE(2081),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(2338),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1369),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(2339),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(2081),
    [sym_subscript_expression] = STATE(2338),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(2081),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(2081),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(754),
    [sym__type] = STATE(754),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(2081),
    [sym_meta_property] = STATE(2081),
    [sym_function_type] = STATE(754),
    [sym__expression] = STATE(2081),
    [sym_non_null_expression] = STATE(2081),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(2081),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(2081),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(2081),
    [sym_call_expression] = STATE(2081),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(2081),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(2081),
    [sym_type_arguments] = STATE(1947),
    [sym_union_type] = STATE(754),
    [sym_parenthesized_expression] = STATE(2081),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2081),
    [sym_class] = STATE(2081),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4319),
    [sym_false] = ACTIONS(4020),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(4321),
    [anon_sym_number] = ACTIONS(4321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(4323),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4325),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(4327),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [sym_null] = ACTIONS(4329),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4321),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(4321),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(4018),
    [sym_number] = ACTIONS(4024),
    [sym_true] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(4321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4329),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(4331),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(4325),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1719] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(3297),
    [anon_sym_COMMA] = ACTIONS(2974),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_COLON] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_RBRACK] = ACTIONS(1695),
    [anon_sym_GT] = ACTIONS(3297),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(3297),
  },
  [1720] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_SEMI] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [sym__automatic_semicolon] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_COMMA] = ACTIONS(2652),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_GT] = ACTIONS(3741),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(3741),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1697),
  },
  [1721] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_SEMI] = ACTIONS(213),
    [anon_sym_BQUOTE] = ACTIONS(213),
    [sym__automatic_semicolon] = ACTIONS(213),
    [anon_sym_PIPE] = ACTIONS(4063),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(215),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_COMMA] = ACTIONS(1248),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [anon_sym_GT] = ACTIONS(4063),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_DASH_DASH] = ACTIONS(213),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_SLASH] = ACTIONS(215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(215),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_PLUS_PLUS] = ACTIONS(213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(215),
  },
  [1722] = {
    [sym__initializer] = STATE(1211),
    [sym_type_arguments] = STATE(497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1088),
    [anon_sym_AMP_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_EQ] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(1088),
    [anon_sym_PIPE_EQ] = ACTIONS(1088),
    [anon_sym_DASH_EQ] = ACTIONS(1088),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(1088),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(3168),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_is] = ACTIONS(1207),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(2509),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(1088),
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(2509),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1088),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3170),
  },
  [1723] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2523),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(1216),
    [sym__automatic_semicolon] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(2520),
    [anon_sym_COMMA] = ACTIONS(2523),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_RBRACE] = ACTIONS(2523),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1216),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1724] = {
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(2529),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(2529),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1725] = {
    [sym_new_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_non_null_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1220),
    [sym_this] = STATE(1220),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1220),
    [sym_generator_function] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1220),
    [sym_class] = STATE(1220),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(1124),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(2529),
    [sym_null] = ACTIONS(1124),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(2529),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_BANG] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(1130),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_in] = ACTIONS(139),
  },
  [1726] = {
    [sym_new_expression] = STATE(1808),
    [sym_constructor_type] = STATE(754),
    [sym_augmented_assignment_expression] = STATE(1808),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(1808),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(1808),
    [sym_call_signature] = STATE(2456),
    [sym_yield_expression] = STATE(1808),
    [sym_as_expression] = STATE(1808),
    [sym_internal_module] = STATE(1808),
    [sym_arrow_function] = STATE(1808),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(2457),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1714),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(2458),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(1808),
    [sym_subscript_expression] = STATE(2457),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(1808),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(1808),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(754),
    [sym__type] = STATE(754),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(1808),
    [sym_meta_property] = STATE(1808),
    [sym_function_type] = STATE(754),
    [sym__expression] = STATE(1808),
    [sym_non_null_expression] = STATE(1808),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(89),
    [sym_await_expression] = STATE(1808),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(1808),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_anonymous_class] = STATE(1808),
    [sym_call_expression] = STATE(1808),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(1808),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(1808),
    [sym_type_arguments] = STATE(2459),
    [sym_union_type] = STATE(754),
    [sym_parenthesized_expression] = STATE(1808),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1808),
    [sym_class] = STATE(1808),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(4333),
    [sym_false] = ACTIONS(4335),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(4337),
    [anon_sym_number] = ACTIONS(4337),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(4339),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4341),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(4345),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_LPAREN] = ACTIONS(1652),
    [sym_null] = ACTIONS(4347),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4337),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(4337),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(4349),
    [sym_number] = ACTIONS(4351),
    [sym_true] = ACTIONS(4335),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(4337),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(4347),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(4353),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(4341),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [1727] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(3297),
    [anon_sym_COMMA] = ACTIONS(1695),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_COLON] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_RBRACK] = ACTIONS(3291),
    [anon_sym_GT] = ACTIONS(1697),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(3291),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(3297),
  },
  [1728] = {
    [sym__automatic_semicolon] = ACTIONS(2652),
    [anon_sym_LBRACK] = ACTIONS(3294),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_SEMI] = ACTIONS(2652),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(3741),
    [anon_sym_COMMA] = ACTIONS(3294),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_GT] = ACTIONS(1697),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_RBRACE] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3741),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2652),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(1697),
  },
  [1729] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(213),
    [anon_sym_LBRACK] = ACTIONS(2383),
    [anon_sym_BANG] = ACTIONS(215),
    [anon_sym_BQUOTE] = ACTIONS(213),
    [anon_sym_SEMI] = ACTIONS(1248),
    [sym__automatic_semicolon] = ACTIONS(1248),
    [anon_sym_PIPE] = ACTIONS(4063),
    [anon_sym_COMMA] = ACTIONS(2383),
    [anon_sym_LT_LT] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(215),
    [anon_sym_GT_GT_GT] = ACTIONS(213),
    [anon_sym_AMP_AMP] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(215),
    [anon_sym_BANG_EQ] = ACTIONS(215),
    [anon_sym_LT_EQ] = ACTIONS(213),
    [anon_sym_LPAREN] = ACTIONS(213),
    [anon_sym_GT_EQ] = ACTIONS(213),
    [anon_sym_GT] = ACTIONS(215),
    [anon_sym_RBRACE] = ACTIONS(2383),
    [anon_sym_AMP] = ACTIONS(4063),
    [anon_sym_QMARK] = ACTIONS(213),
    [anon_sym_PERCENT] = ACTIONS(213),
    [anon_sym_as] = ACTIONS(213),
    [anon_sym_PIPE_PIPE] = ACTIONS(213),
    [anon_sym_DASH_DASH] = ACTIONS(213),
    [anon_sym_EQ_EQ] = ACTIONS(215),
    [anon_sym_instanceof] = ACTIONS(213),
    [anon_sym_LT] = ACTIONS(215),
    [anon_sym_SLASH] = ACTIONS(215),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(213),
    [anon_sym_CARET] = ACTIONS(213),
    [anon_sym_STAR_STAR] = ACTIONS(213),
    [anon_sym_PLUS] = ACTIONS(215),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1248),
    [anon_sym_GT_GT] = ACTIONS(215),
    [anon_sym_PLUS_PLUS] = ACTIONS(213),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(213),
    [anon_sym_in] = ACTIONS(215),
  },
  [1730] = {
    [sym_new_expression] = STATE(1290),
    [sym_constructor_type] = STATE(1550),
    [sym_augmented_assignment_expression] = STATE(1290),
    [sym_lookup_type] = STATE(1496),
    [sym_unary_expression] = STATE(1290),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_regex] = STATE(1290),
    [sym_call_signature] = STATE(1740),
    [sym_yield_expression] = STATE(1290),
    [sym_as_expression] = STATE(1290),
    [sym_internal_module] = STATE(1290),
    [sym_arrow_function] = STATE(1290),
    [sym__primary_type] = STATE(1496),
    [sym_member_expression] = STATE(1201),
    [sym_mapped_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_string] = STATE(1723),
    [sym_type_parameters] = STATE(1867),
    [sym_array_type] = STATE(1496),
    [sym_object] = STATE(1202),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_generator_function] = STATE(1290),
    [sym_subscript_expression] = STATE(1201),
    [sym_type_query] = STATE(1496),
    [sym_ternary_expression] = STATE(1290),
    [sym_existential_type] = STATE(1496),
    [sym_template_string] = STATE(1290),
    [sym_object_type] = STATE(1496),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(1375),
    [sym_intersection_type] = STATE(1550),
    [sym__type] = STATE(1550),
    [sym_index_type_query] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_update_expression] = STATE(1290),
    [sym_meta_property] = STATE(1290),
    [sym_function_type] = STATE(1550),
    [sym__expression] = STATE(1290),
    [sym_non_null_expression] = STATE(1290),
    [sym_nested_identifier] = STATE(2393),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(1290),
    [sym_generic_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_this] = STATE(1290),
    [sym_tuple_type] = STATE(1496),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(1290),
    [sym_call_expression] = STATE(1290),
    [sym_type_predicate] = STATE(1496),
    [sym_assignment_expression] = STATE(1290),
    [sym__number] = STATE(1488),
    [sym_binary_expression] = STATE(1290),
    [sym_type_arguments] = STATE(1205),
    [sym_union_type] = STATE(1550),
    [sym_parenthesized_expression] = STATE(1290),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1290),
    [sym_class] = STATE(1290),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(3497),
    [sym_false] = ACTIONS(3499),
    [anon_sym_LBRACK] = ACTIONS(3501),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(3503),
    [anon_sym_number] = ACTIONS(3503),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(3505),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(3507),
    [anon_sym_keyof] = ACTIONS(1805),
    [anon_sym_LBRACE] = ACTIONS(3509),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_void] = ACTIONS(3511),
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_LPAREN] = ACTIONS(3513),
    [sym_null] = ACTIONS(3940),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(3503),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(3503),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(3515),
    [sym_number] = ACTIONS(3517),
    [sym_true] = ACTIONS(3499),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(3503),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3940),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(3519),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(3507),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [1731] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_SEMI] = ACTIONS(1695),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [sym__automatic_semicolon] = ACTIONS(1695),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(3297),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_COMMA] = ACTIONS(2974),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_GT] = ACTIONS(3297),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(3297),
  },
  [1732] = {
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_BANG] = ACTIONS(1697),
    [anon_sym_BQUOTE] = ACTIONS(1695),
    [anon_sym_SEMI] = ACTIONS(2974),
    [sym__automatic_semicolon] = ACTIONS(2974),
    [anon_sym_PERCENT_EQ] = ACTIONS(1695),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_AMP_EQ] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(1695),
    [anon_sym_PIPE] = ACTIONS(3297),
    [anon_sym_COMMA] = ACTIONS(3291),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_STAR] = ACTIONS(1697),
    [anon_sym_GT_GT_GT] = ACTIONS(1697),
    [anon_sym_EQ] = ACTIONS(1697),
    [anon_sym_AMP_AMP] = ACTIONS(1695),
    [anon_sym_DASH] = ACTIONS(1697),
    [anon_sym_BANG_EQ] = ACTIONS(1697),
    [anon_sym_LT_EQ] = ACTIONS(1695),
    [anon_sym_LPAREN] = ACTIONS(1695),
    [anon_sym_GT_EQ] = ACTIONS(1695),
    [anon_sym_GT] = ACTIONS(1697),
    [anon_sym_CARET_EQ] = ACTIONS(1695),
    [anon_sym_STAR_EQ] = ACTIONS(1695),
    [anon_sym_PIPE_EQ] = ACTIONS(1695),
    [anon_sym_DASH_EQ] = ACTIONS(1695),
    [anon_sym_RBRACE] = ACTIONS(3291),
    [anon_sym_AMP] = ACTIONS(3297),
    [anon_sym_QMARK] = ACTIONS(1695),
    [anon_sym_LT_LT_EQ] = ACTIONS(1695),
    [anon_sym_as] = ACTIONS(1695),
    [anon_sym_PIPE_PIPE] = ACTIONS(1695),
    [anon_sym_PERCENT] = ACTIONS(1697),
    [anon_sym_DASH_DASH] = ACTIONS(1695),
    [anon_sym_EQ_EQ] = ACTIONS(1697),
    [anon_sym_instanceof] = ACTIONS(1695),
    [anon_sym_LT] = ACTIONS(3297),
    [anon_sym_SLASH] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1695),
    [anon_sym_GT_GT_EQ] = ACTIONS(1695),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_CARET] = ACTIONS(1697),
    [anon_sym_STAR_STAR] = ACTIONS(1697),
    [anon_sym_PLUS] = ACTIONS(1697),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1695),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_PLUS_PLUS] = ACTIONS(1695),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1695),
    [anon_sym_in] = ACTIONS(3297),
  },
  [1733] = {
    [aux_sym_template_string_repeat1] = STATE(1744),
    [sym_template_substitution] = STATE(1744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(4355),
    [sym__template_chars] = ACTIONS(4357),
    [sym_escape_sequence] = ACTIONS(4357),
    [sym_comment] = ACTIONS(3),
  },
  [1734] = {
    [sym_nested_identifier] = STATE(1482),
    [sym__module] = STATE(1225),
    [sym_string] = STATE(1484),
    [sym__initializer] = STATE(80),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4359),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1735] = {
    [aux_sym_string_repeat1] = STATE(1753),
    [sym_escape_sequence] = ACTIONS(4361),
    [aux_sym_string_token1] = ACTIONS(4361),
    [anon_sym_DQUOTE] = ACTIONS(4363),
    [sym_comment] = ACTIONS(256),
  },
  [1736] = {
    [sym_new_expression] = STATE(1754),
    [sym_augmented_assignment_expression] = STATE(1754),
    [sym_unary_expression] = STATE(1754),
    [sym_regex] = STATE(1754),
    [sym_call_signature] = STATE(1740),
    [sym_yield_expression] = STATE(1754),
    [sym_as_expression] = STATE(1754),
    [sym_internal_module] = STATE(1754),
    [sym_arrow_function] = STATE(1754),
    [sym_member_expression] = STATE(1201),
    [sym_spread_element] = STATE(1755),
    [sym_string] = STATE(1754),
    [sym_type_parameters] = STATE(55),
    [sym_object] = STATE(1202),
    [sym_generator_function] = STATE(1754),
    [sym_subscript_expression] = STATE(1201),
    [sym_ternary_expression] = STATE(1754),
    [sym_template_string] = STATE(1754),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_update_expression] = STATE(1754),
    [sym_meta_property] = STATE(1754),
    [sym__expression] = STATE(1754),
    [sym_non_null_expression] = STATE(1754),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(1754),
    [sym_this] = STATE(1754),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [aux_sym_array_repeat1] = STATE(1756),
    [sym_anonymous_class] = STATE(1754),
    [sym_call_expression] = STATE(1754),
    [sym_assignment_expression] = STATE(1754),
    [sym_binary_expression] = STATE(1754),
    [sym_type_arguments] = STATE(1205),
    [sym_parenthesized_expression] = STATE(1754),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1754),
    [sym_class] = STATE(1754),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(2345),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(2345),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_RBRACK] = ACTIONS(2343),
    [sym_null] = ACTIONS(2345),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4365),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(2345),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1737] = {
    [sym_class_heritage] = STATE(1759),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(1232),
    [anon_sym_extends] = ACTIONS(328),
    [sym_identifier] = ACTIONS(4367),
    [anon_sym_implements] = ACTIONS(332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [1738] = {
    [sym_new_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_do_statement] = STATE(182),
    [sym_internal_module] = STATE(53),
    [sym_accessibility_modifier] = STATE(180),
    [sym_import_statement] = STATE(182),
    [sym_member_expression] = STATE(54),
    [sym_switch_statement] = STATE(182),
    [sym_string] = STATE(178),
    [sym_type_parameters] = STATE(55),
    [sym_throw_statement] = STATE(182),
    [aux_sym_program_repeat1] = STATE(182),
    [sym_object] = STATE(184),
    [sym_generator_function] = STATE(53),
    [sym_ternary_expression] = STATE(59),
    [sym_for_of_statement] = STATE(182),
    [sym_decorator] = STATE(186),
    [sym_computed_property_name] = STATE(183),
    [sym_abstract_class] = STATE(182),
    [sym_statement_block] = STATE(182),
    [sym_update_expression] = STATE(59),
    [sym_debugger_statement] = STATE(182),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_function] = STATE(60),
    [sym_for_statement] = STATE(182),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(182),
    [sym_pair] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(186),
    [sym_assignment_pattern] = STATE(181),
    [sym_export_statement] = STATE(182),
    [sym_call_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(182),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_break_statement] = STATE(182),
    [sym_parenthesized_expression] = STATE(59),
    [sym_module] = STATE(182),
    [sym_class] = STATE(53),
    [sym_type_alias_declaration] = STATE(182),
    [sym__declaration] = STATE(182),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_if_statement] = STATE(182),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_return_statement] = STATE(182),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_arrow_function] = STATE(59),
    [sym_expression_statement] = STATE(182),
    [sym_spread_element] = STATE(181),
    [sym_try_statement] = STATE(182),
    [sym__property_name] = STATE(183),
    [aux_sym_object_repeat1] = STATE(185),
    [sym_ambient_declaration] = STATE(182),
    [sym_subscript_expression] = STATE(54),
    [sym_template_string] = STATE(59),
    [sym_continue_statement] = STATE(182),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(182),
    [sym_interface_declaration] = STATE(182),
    [sym_while_statement] = STATE(182),
    [sym_meta_property] = STATE(59),
    [sym_method_definition] = STATE(181),
    [sym_enum_declaration] = STATE(182),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(182),
    [sym_sequence_expression] = STATE(62),
    [sym_with_statement] = STATE(182),
    [sym_import_alias] = STATE(182),
    [sym_anonymous_class] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_for_in_statement] = STATE(182),
    [sym_labeled_statement] = STATE(182),
    [sym_array] = STATE(187),
    [sym_type_assertion] = STATE(59),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(370),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_void] = ACTIONS(378),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_get] = ACTIONS(384),
    [anon_sym_RBRACE] = ACTIONS(4371),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(384),
    [anon_sym_type] = ACTIONS(388),
    [anon_sym_import] = ACTIONS(390),
    [anon_sym_namespace] = ACTIONS(392),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(396),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(398),
    [anon_sym_number] = ACTIONS(370),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(400),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(370),
    [anon_sym_boolean] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(402),
    [anon_sym_public] = ACTIONS(380),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(404),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(370),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(406),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1739] = {
    [aux_sym_string_repeat2] = STATE(1786),
    [sym_escape_sequence] = ACTIONS(4373),
    [aux_sym_string_token2] = ACTIONS(4373),
    [sym_comment] = ACTIONS(256),
    [anon_sym_SQUOTE] = ACTIONS(4363),
  },
  [1740] = {
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
  },
  [1741] = {
    [sym_formal_parameters] = STATE(1272),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [1742] = {
    [sym_type_alias_declaration] = STATE(292),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(292),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(292),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(292),
    [sym_return_statement] = STATE(292),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(292),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(292),
    [sym_switch_statement] = STATE(292),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(292),
    [sym_throw_statement] = STATE(292),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(292),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(292),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(292),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(292),
    [sym_abstract_class] = STATE(292),
    [sym_interface_declaration] = STATE(292),
    [sym_statement_block] = STATE(292),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(292),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(292),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(292),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(292),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(292),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(292),
    [sym_empty_statement] = STATE(292),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(292),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(292),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(292),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(292),
    [sym_break_statement] = STATE(292),
    [sym_labeled_statement] = STATE(292),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(292),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1743] = {
    [sym_identifier] = ACTIONS(4375),
    [sym_comment] = ACTIONS(3),
  },
  [1744] = {
    [aux_sym_template_string_repeat1] = STATE(297),
    [sym_template_substitution] = STATE(297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(127),
    [anon_sym_BQUOTE] = ACTIONS(4377),
    [sym__template_chars] = ACTIONS(646),
    [sym_escape_sequence] = ACTIONS(646),
    [sym_comment] = ACTIONS(3),
  },
  [1745] = {
    [sym_identifier] = ACTIONS(4379),
    [sym_comment] = ACTIONS(3),
  },
  [1746] = {
    [sym_pair] = STATE(1776),
    [sym__property_name] = STATE(183),
    [sym_object] = STATE(310),
    [aux_sym_export_statement_repeat1] = STATE(2260),
    [aux_sym_object_repeat1] = STATE(1778),
    [sym_assignment_pattern] = STATE(1776),
    [sym_method_definition] = STATE(1776),
    [sym_decorator] = STATE(2260),
    [sym_accessibility_modifier] = STATE(180),
    [sym_computed_property_name] = STATE(183),
    [sym_array] = STATE(312),
    [sym_spread_element] = STATE(1776),
    [sym_string] = STATE(183),
    [sym_identifier] = ACTIONS(4381),
    [anon_sym_LBRACK] = ACTIONS(680),
    [anon_sym_module] = ACTIONS(4383),
    [anon_sym_symbol] = ACTIONS(4383),
    [anon_sym_number] = ACTIONS(4383),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(4383),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_void] = ACTIONS(4383),
    [anon_sym_any] = ACTIONS(4383),
    [anon_sym_private] = ACTIONS(4385),
    [anon_sym_boolean] = ACTIONS(4383),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_async] = ACTIONS(4387),
    [anon_sym_get] = ACTIONS(4389),
    [anon_sym_RBRACE] = ACTIONS(4391),
    [anon_sym_public] = ACTIONS(4385),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [sym_number] = ACTIONS(692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4385),
    [anon_sym_string] = ACTIONS(4383),
    [anon_sym_set] = ACTIONS(4389),
    [anon_sym_type] = ACTIONS(4383),
    [anon_sym_import] = ACTIONS(4383),
    [anon_sym_export] = ACTIONS(4383),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_namespace] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1747] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1819),
    [sym__automatic_semicolon] = ACTIONS(4393),
    [anon_sym_SEMI] = ACTIONS(4393),
    [anon_sym_COMMA] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
  },
  [1748] = {
    [sym_new_expression] = STATE(1822),
    [sym_augmented_assignment_expression] = STATE(1822),
    [sym_unary_expression] = STATE(1822),
    [sym_regex] = STATE(1822),
    [sym_call_signature] = STATE(1740),
    [sym_yield_expression] = STATE(1822),
    [sym_as_expression] = STATE(1822),
    [sym_internal_module] = STATE(1822),
    [sym_arrow_function] = STATE(1822),
    [sym_member_expression] = STATE(1201),
    [sym_spread_element] = STATE(1823),
    [sym_string] = STATE(1822),
    [sym_type_parameters] = STATE(55),
    [sym_object] = STATE(1202),
    [sym_generator_function] = STATE(1822),
    [sym_subscript_expression] = STATE(1201),
    [sym_ternary_expression] = STATE(1822),
    [sym_template_string] = STATE(1822),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_update_expression] = STATE(1822),
    [sym_meta_property] = STATE(1822),
    [sym__expression] = STATE(1822),
    [sym_non_null_expression] = STATE(1822),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(1822),
    [sym_this] = STATE(1822),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [aux_sym_array_repeat1] = STATE(1824),
    [sym_anonymous_class] = STATE(1822),
    [sym_call_expression] = STATE(1822),
    [sym_assignment_expression] = STATE(1822),
    [sym_binary_expression] = STATE(1822),
    [sym_type_arguments] = STATE(1205),
    [sym_parenthesized_expression] = STATE(1822),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1822),
    [sym_class] = STATE(1822),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(4395),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(4395),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4395),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(4397),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4399),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4395),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1749] = {
    [sym_template_string] = STATE(1306),
    [sym_arguments] = STATE(1306),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_LPAREN] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
  },
  [1750] = {
    [sym_type_parameters] = STATE(1825),
    [sym_object_type] = STATE(1307),
    [sym_extends_clause] = STATE(1826),
    [anon_sym_extends] = ACTIONS(749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1616),
  },
  [1751] = {
    [sym_enum_body] = STATE(1308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4401),
  },
  [1752] = {
    [sym_type_alias_declaration] = STATE(2263),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(2263),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(2263),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(2263),
    [sym_return_statement] = STATE(2263),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(2263),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2263),
    [sym_switch_statement] = STATE(2263),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(2263),
    [sym_throw_statement] = STATE(2263),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(2263),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(2263),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(2263),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(2263),
    [sym_abstract_class] = STATE(2263),
    [sym_interface_declaration] = STATE(2263),
    [sym_statement_block] = STATE(2263),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(2263),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(2263),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(2263),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2263),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(2263),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(2263),
    [sym_empty_statement] = STATE(2263),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(2263),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(2263),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2263),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(2263),
    [sym_break_statement] = STATE(2263),
    [sym_labeled_statement] = STATE(2263),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(2263),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1753] = {
    [aux_sym_string_repeat1] = STATE(362),
    [sym_escape_sequence] = ACTIONS(817),
    [aux_sym_string_token1] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(4403),
    [sym_comment] = ACTIONS(256),
  },
  [1754] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [aux_sym_array_repeat1] = STATE(1830),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACK] = ACTIONS(4405),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1755] = {
    [aux_sym_array_repeat1] = STATE(1830),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_RBRACK] = ACTIONS(4405),
    [sym_comment] = ACTIONS(3),
  },
  [1756] = {
    [aux_sym_array_repeat1] = STATE(375),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_RBRACK] = ACTIONS(4405),
    [sym_comment] = ACTIONS(3),
  },
  [1757] = {
    [sym_class_heritage] = STATE(1831),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_type_parameters] = STATE(1832),
    [sym_class_body] = STATE(1312),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [1758] = {
    [sym_public_field_definition] = STATE(394),
    [sym__property_name] = STATE(395),
    [sym_method_signature] = STATE(394),
    [sym_abstract_method_signature] = STATE(394),
    [aux_sym_class_body_repeat1] = STATE(1833),
    [sym_index_signature] = STATE(394),
    [sym_method_definition] = STATE(398),
    [sym_decorator] = STATE(1833),
    [sym_accessibility_modifier] = STATE(396),
    [sym_computed_property_name] = STATE(395),
    [sym_string] = STATE(395),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(923),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(931),
    [anon_sym_RBRACE] = ACTIONS(4407),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [sym_number] = ACTIONS(937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_abstract] = ACTIONS(939),
    [anon_sym_set] = ACTIONS(931),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [sym_readonly] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1759] = {
    [sym_class_body] = STATE(1316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [1760] = {
    [sym_identifier] = ACTIONS(4409),
    [sym_comment] = ACTIONS(3),
  },
  [1761] = {
    [sym_statement_block] = STATE(1317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4411),
  },
  [1762] = {
    [sym_nested_identifier] = STATE(1224),
    [sym__module] = STATE(1483),
    [sym_string] = STATE(1226),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(308),
  },
  [1763] = {
    [aux_sym_export_statement_repeat1] = STATE(284),
    [sym_decorator] = STATE(284),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(2287),
    [anon_sym_class] = ACTIONS(4413),
    [sym_comment] = ACTIONS(3),
  },
  [1764] = {
    [sym__initializer] = STATE(407),
    [aux_sym_object_repeat1] = STATE(1834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(113),
    [anon_sym_AMP_EQ] = ACTIONS(113),
    [anon_sym_PLUS_EQ] = ACTIONS(113),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(113),
    [anon_sym_PIPE_EQ] = ACTIONS(113),
    [anon_sym_DASH_EQ] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(977),
    [anon_sym_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(980),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(113),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(980),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(983),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(113),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [1765] = {
    [sym__initializer] = STATE(80),
    [aux_sym_object_repeat1] = STATE(1834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1766] = {
    [sym_new_expression] = STATE(91),
    [sym_augmented_assignment_expression] = STATE(91),
    [sym_unary_expression] = STATE(91),
    [sym_regex] = STATE(91),
    [sym_call_signature] = STATE(52),
    [sym_yield_expression] = STATE(91),
    [sym_as_expression] = STATE(91),
    [sym_internal_module] = STATE(91),
    [sym_arrow_function] = STATE(91),
    [sym_member_expression] = STATE(54),
    [sym_string] = STATE(91),
    [sym_type_parameters] = STATE(55),
    [sym_object] = STATE(57),
    [aux_sym_object_repeat1] = STATE(1834),
    [sym_generator_function] = STATE(91),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(91),
    [sym_template_string] = STATE(91),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym__initializer] = STATE(80),
    [sym_update_expression] = STATE(91),
    [sym_meta_property] = STATE(91),
    [sym__expression] = STATE(91),
    [sym_non_null_expression] = STATE(91),
    [sym_function] = STATE(89),
    [sym_await_expression] = STATE(91),
    [sym_this] = STATE(91),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_anonymous_class] = STATE(91),
    [sym_call_expression] = STATE(91),
    [sym_assignment_expression] = STATE(91),
    [sym_binary_expression] = STATE(91),
    [sym_type_arguments] = STATE(64),
    [sym_parenthesized_expression] = STATE(91),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(91),
    [sym_class] = STATE(91),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(165),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_DOT] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [sym_null] = ACTIONS(165),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_BANG] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(165),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(77),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(173),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(165),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_in] = ACTIONS(139),
  },
  [1767] = {
    [sym__initializer] = STATE(80),
    [aux_sym_object_repeat1] = STATE(1834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(1012),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(1012),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_DOT] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [sym_readonly] = ACTIONS(1012),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1012),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1014),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [sym_number] = ACTIONS(1014),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_in] = ACTIONS(139),
  },
  [1768] = {
    [sym__property_name] = STATE(417),
    [aux_sym_object_repeat1] = STATE(1834),
    [sym__initializer] = STATE(80),
    [sym_computed_property_name] = STATE(417),
    [sym_string] = STATE(417),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_DOT] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [sym_number] = ACTIONS(1010),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_in] = ACTIONS(139),
  },
  [1769] = {
    [sym__initializer] = STATE(80),
    [aux_sym_object_repeat1] = STATE(1834),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(231),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1770] = {
    [sym_import_require_clause] = STATE(123),
    [aux_sym_object_repeat1] = STATE(1834),
    [sym_named_imports] = STATE(125),
    [sym__initializer] = STATE(80),
    [sym_import_clause] = STATE(124),
    [sym_string] = STATE(123),
    [sym_namespace_import] = STATE(125),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(233),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(235),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_type] = ACTIONS(238),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_typeof] = ACTIONS(238),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(240),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1771] = {
    [sym_nested_identifier] = STATE(126),
    [sym__module] = STATE(127),
    [aux_sym_object_repeat1] = STATE(1834),
    [sym__initializer] = STATE(80),
    [sym_string] = STATE(128),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(242),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(244),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(246),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1772] = {
    [sym_nested_identifier] = STATE(1224),
    [sym__module] = STATE(141),
    [aux_sym_object_repeat1] = STATE(1834),
    [sym__initializer] = STATE(80),
    [sym_string] = STATE(1226),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(322),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1773] = {
    [sym_type_alias_declaration] = STATE(160),
    [sym__declaration] = STATE(160),
    [sym__initializer] = STATE(80),
    [sym_internal_module] = STATE(160),
    [sym_enum_declaration] = STATE(160),
    [sym_function] = STATE(160),
    [sym_variable_declaration] = STATE(160),
    [aux_sym_export_statement_repeat1] = STATE(159),
    [aux_sym_object_repeat1] = STATE(1834),
    [sym_ambient_declaration] = STATE(160),
    [sym_import_alias] = STATE(160),
    [sym_export_statement] = STATE(160),
    [sym_generator_function] = STATE(160),
    [sym_lexical_declaration] = STATE(160),
    [sym_decorator] = STATE(159),
    [sym_function_signature] = STATE(160),
    [sym_abstract_class] = STATE(160),
    [sym_module] = STATE(160),
    [sym_interface_declaration] = STATE(160),
    [sym_class] = STATE(160),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_global] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_const] = ACTIONS(338),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_interface] = ACTIONS(340),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_abstract] = ACTIONS(344),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(352),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(354),
    [anon_sym_declare] = ACTIONS(356),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_async] = ACTIONS(358),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_var] = ACTIONS(360),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_function] = ACTIONS(362),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_let] = ACTIONS(364),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(366),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1774] = {
    [sym__property_name] = STATE(417),
    [aux_sym_object_repeat1] = STATE(1834),
    [sym__initializer] = STATE(80),
    [sym_formal_parameters] = STATE(58),
    [sym_computed_property_name] = STATE(417),
    [sym_call_signature] = STATE(206),
    [sym_string] = STATE(417),
    [sym_type_parameters] = STATE(55),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(1039),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(1041),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1039),
    [anon_sym_DOT] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(1044),
    [anon_sym_import] = ACTIONS(1039),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(1039),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_any] = ACTIONS(1039),
    [anon_sym_async] = ACTIONS(1039),
    [anon_sym_public] = ACTIONS(1039),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(1039),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(1039),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1046),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(1039),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_private] = ACTIONS(1039),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_get] = ACTIONS(1044),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_type] = ACTIONS(1039),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1039),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(1024),
    [anon_sym_module] = ACTIONS(1039),
    [anon_sym_declare] = ACTIONS(1039),
    [anon_sym_LPAREN] = ACTIONS(1048),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(1039),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(1052),
    [sym_number] = ACTIONS(1010),
    [anon_sym_function] = ACTIONS(440),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_in] = ACTIONS(139),
  },
  [1775] = {
    [sym_type_alias_declaration] = STATE(261),
    [sym__declaration] = STATE(261),
    [sym__initializer] = STATE(80),
    [sym_internal_module] = STATE(261),
    [sym_enum_declaration] = STATE(261),
    [sym_function] = STATE(261),
    [sym_variable_declaration] = STATE(261),
    [aux_sym_export_statement_repeat1] = STATE(159),
    [aux_sym_object_repeat1] = STATE(1834),
    [sym_ambient_declaration] = STATE(261),
    [sym_import_alias] = STATE(261),
    [sym_export_statement] = STATE(261),
    [sym_generator_function] = STATE(261),
    [sym_export_clause] = STATE(262),
    [sym_lexical_declaration] = STATE(261),
    [sym_decorator] = STATE(159),
    [sym_function_signature] = STATE(261),
    [sym_abstract_class] = STATE(261),
    [sym_module] = STATE(261),
    [sym_interface_declaration] = STATE(261),
    [sym_class] = STATE(261),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(524),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(527),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_const] = ACTIONS(338),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_interface] = ACTIONS(340),
    [anon_sym_default] = ACTIONS(529),
    [anon_sym_as] = ACTIONS(531),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_abstract] = ACTIONS(344),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(350),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(534),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(354),
    [anon_sym_declare] = ACTIONS(356),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(988),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_async] = ACTIONS(358),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_var] = ACTIONS(360),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(991),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_function] = ACTIONS(362),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_let] = ACTIONS(364),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(366),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1776] = {
    [aux_sym_object_repeat1] = STATE(1836),
    [anon_sym_RBRACE] = ACTIONS(4415),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [1777] = {
    [sym_type_alias_declaration] = STATE(266),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(266),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(266),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(266),
    [sym_return_statement] = STATE(266),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(266),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(266),
    [sym_switch_statement] = STATE(266),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(266),
    [sym_throw_statement] = STATE(266),
    [aux_sym_program_repeat1] = STATE(266),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(266),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(266),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(266),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(266),
    [sym_abstract_class] = STATE(266),
    [sym_interface_declaration] = STATE(266),
    [sym_statement_block] = STATE(266),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(266),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(266),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(266),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(266),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(266),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(266),
    [sym_empty_statement] = STATE(266),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(266),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(266),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(266),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(266),
    [sym_break_statement] = STATE(266),
    [sym_labeled_statement] = STATE(266),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(266),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4417),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1778] = {
    [aux_sym_object_repeat1] = STATE(434),
    [anon_sym_RBRACE] = ACTIONS(4415),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [1779] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1839),
    [anon_sym_RPAREN] = ACTIONS(4419),
    [anon_sym_COMMA] = ACTIONS(4421),
    [sym_comment] = ACTIONS(3),
  },
  [1780] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_type_annotation] = STATE(1840),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(4423),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1781] = {
    [anon_sym_RPAREN] = ACTIONS(4423),
    [sym_comment] = ACTIONS(3),
  },
  [1782] = {
    [anon_sym_EQ_GT] = ACTIONS(4425),
    [sym_comment] = ACTIONS(3),
  },
  [1783] = {
    [anon_sym_EQ_GT] = ACTIONS(4427),
    [sym_comment] = ACTIONS(3),
  },
  [1784] = {
    [aux_sym_variable_declaration_repeat1] = STATE(1844),
    [sym__automatic_semicolon] = ACTIONS(4429),
    [anon_sym_SEMI] = ACTIONS(4429),
    [anon_sym_COMMA] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
  },
  [1785] = {
    [sym_type_alias_declaration] = STATE(483),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(483),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(483),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(483),
    [sym_return_statement] = STATE(483),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(483),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(483),
    [sym_switch_statement] = STATE(483),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(483),
    [sym_throw_statement] = STATE(483),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(483),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(483),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(483),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(483),
    [sym_abstract_class] = STATE(483),
    [sym_interface_declaration] = STATE(483),
    [sym_statement_block] = STATE(483),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(483),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(483),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(483),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(483),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(483),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(483),
    [sym_empty_statement] = STATE(483),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(483),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(483),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(483),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(483),
    [sym_break_statement] = STATE(483),
    [sym_labeled_statement] = STATE(483),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(483),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1786] = {
    [aux_sym_string_repeat2] = STATE(484),
    [sym_escape_sequence] = ACTIONS(1184),
    [aux_sym_string_token2] = ACTIONS(1184),
    [sym_comment] = ACTIONS(256),
    [anon_sym_SQUOTE] = ACTIONS(4403),
  },
  [1787] = {
    [sym_type_alias_declaration] = STATE(2007),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(2007),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(2007),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(2007),
    [sym_return_statement] = STATE(2007),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(2007),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2007),
    [sym_switch_statement] = STATE(2007),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(2007),
    [sym_throw_statement] = STATE(2007),
    [aux_sym_program_repeat1] = STATE(2007),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(2007),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(2007),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(2007),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(2007),
    [sym_abstract_class] = STATE(2007),
    [sym_interface_declaration] = STATE(2007),
    [sym_statement_block] = STATE(2007),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(2007),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(2007),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(2007),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2007),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(2007),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(2007),
    [sym_empty_statement] = STATE(2007),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(2007),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(2007),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2007),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(2007),
    [sym_break_statement] = STATE(2007),
    [sym_labeled_statement] = STATE(2007),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(2007),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4431),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1788] = {
    [sym_index_type_query] = STATE(500),
    [sym_lookup_type] = STATE(500),
    [sym_this_type] = STATE(500),
    [sym_flow_maybe_type] = STATE(500),
    [sym_nested_identifier] = STATE(2437),
    [sym__primary_type] = STATE(500),
    [sym_generic_type] = STATE(500),
    [sym_mapped_type] = STATE(500),
    [sym_literal_type] = STATE(500),
    [sym_parenthesized_type] = STATE(500),
    [sym_predefined_type] = STATE(500),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(500),
    [sym_tuple_type] = STATE(500),
    [sym_nested_type_identifier] = STATE(1678),
    [sym_type_predicate] = STATE(500),
    [sym_type_query] = STATE(500),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(500),
    [sym_object_type] = STATE(500),
    [sym_identifier] = ACTIONS(3345),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(1220),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_QMARK] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1789] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(1846),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(1846),
    [sym_call_signature] = STATE(1846),
    [sym_construct_signature] = STATE(1846),
    [sym_index_signature] = STATE(1846),
    [sym_export_statement] = STATE(1846),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(4433),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_COMMA] = ACTIONS(4433),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(4435),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4435),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1790] = {
    [sym__type] = STATE(515),
    [sym_constructor_type] = STATE(515),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(515),
    [sym_nested_identifier] = STATE(2437),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(2436),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(1678),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(515),
    [sym_intersection_type] = STATE(515),
    [sym_formal_parameters] = STATE(2157),
    [sym_identifier] = ACTIONS(3345),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1791] = {
    [sym_nested_identifier] = STATE(1337),
    [sym_identifier] = ACTIONS(4437),
    [sym_comment] = ACTIONS(3),
  },
  [1792] = {
    [sym_number] = ACTIONS(4439),
    [sym_comment] = ACTIONS(3),
  },
  [1793] = {
    [sym_nested_type_identifier] = STATE(1340),
    [sym_nested_identifier] = STATE(2241),
    [sym_identifier] = ACTIONS(4441),
    [sym_comment] = ACTIONS(3),
  },
  [1794] = {
    [sym__type] = STATE(528),
    [sym_constructor_type] = STATE(528),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(528),
    [sym_nested_identifier] = STATE(2437),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(2436),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(1678),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(528),
    [sym_intersection_type] = STATE(528),
    [sym_formal_parameters] = STATE(2157),
    [sym_identifier] = ACTIONS(3345),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(3347),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(3349),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(3351),
    [anon_sym_QMARK] = ACTIONS(3353),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(3355),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1795] = {
    [aux_sym_implements_clause_repeat1] = STATE(1854),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_GT] = ACTIONS(4443),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(4445),
    [sym_comment] = ACTIONS(3),
  },
  [1796] = {
    [anon_sym_EQ_GT] = ACTIONS(4447),
    [sym_comment] = ACTIONS(3),
  },
  [1797] = {
    [anon_sym_SLASH2] = ACTIONS(4449),
    [sym_comment] = ACTIONS(3),
  },
  [1798] = {
    [sym_statement_block] = STATE(1352),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3190),
  },
  [1799] = {
    [anon_sym_target] = ACTIONS(4451),
    [sym_comment] = ACTIONS(3),
  },
  [1800] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1801] = {
    [sym__from_clause] = STATE(1859),
    [sym__automatic_semicolon] = ACTIONS(4453),
    [anon_sym_SEMI] = ACTIONS(4453),
    [anon_sym_from] = ACTIONS(797),
    [sym_comment] = ACTIONS(3),
  },
  [1802] = {
    [sym_type_alias_declaration] = STATE(561),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(561),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(561),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(561),
    [sym_return_statement] = STATE(561),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(561),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(561),
    [sym_switch_statement] = STATE(561),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(561),
    [sym_throw_statement] = STATE(561),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(561),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(561),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(561),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(561),
    [sym_abstract_class] = STATE(561),
    [sym_interface_declaration] = STATE(561),
    [sym_statement_block] = STATE(561),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(561),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(561),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(561),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(561),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(561),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(561),
    [sym_empty_statement] = STATE(561),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(561),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(561),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(561),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(561),
    [sym_break_statement] = STATE(561),
    [sym_labeled_statement] = STATE(561),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(561),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1803] = {
    [sym__type] = STATE(1366),
    [sym_constructor_type] = STATE(1366),
    [sym_index_type_query] = STATE(1604),
    [sym_lookup_type] = STATE(1604),
    [sym_this_type] = STATE(1604),
    [sym_flow_maybe_type] = STATE(1604),
    [sym_function_type] = STATE(1366),
    [sym_nested_identifier] = STATE(2424),
    [sym__primary_type] = STATE(1604),
    [sym_generic_type] = STATE(1604),
    [sym_mapped_type] = STATE(1604),
    [sym_literal_type] = STATE(1604),
    [sym_parenthesized_type] = STATE(1604),
    [sym_predefined_type] = STATE(1604),
    [sym_type_parameters] = STATE(2423),
    [sym_string] = STATE(1596),
    [sym_array_type] = STATE(1604),
    [sym_tuple_type] = STATE(1604),
    [sym_nested_type_identifier] = STATE(1603),
    [sym_type_predicate] = STATE(1604),
    [sym_type_query] = STATE(1604),
    [sym__number] = STATE(1596),
    [sym_existential_type] = STATE(1604),
    [sym_template_string] = STATE(1367),
    [sym_object_type] = STATE(1604),
    [sym_union_type] = STATE(1366),
    [sym_intersection_type] = STATE(1366),
    [sym_formal_parameters] = STATE(2110),
    [sym_identifier] = ACTIONS(4178),
    [sym_false] = ACTIONS(4180),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_symbol] = ACTIONS(4184),
    [anon_sym_number] = ACTIONS(4184),
    [anon_sym_typeof] = ACTIONS(4186),
    [anon_sym_keyof] = ACTIONS(4188),
    [anon_sym_DASH] = ACTIONS(4190),
    [anon_sym_STAR] = ACTIONS(4192),
    [anon_sym_LBRACE] = ACTIONS(4194),
    [anon_sym_PIPE] = ACTIONS(4206),
    [anon_sym_void] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4208),
    [anon_sym_any] = ACTIONS(4184),
    [anon_sym_boolean] = ACTIONS(4184),
    [anon_sym_LBRACE_PIPE] = ACTIONS(4198),
    [anon_sym_AMP] = ACTIONS(4210),
    [anon_sym_QMARK] = ACTIONS(4200),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_this] = ACTIONS(4202),
    [sym_number] = ACTIONS(4204),
    [sym_true] = ACTIONS(4180),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_PLUS] = ACTIONS(4190),
    [anon_sym_DQUOTE] = ACTIONS(294),
  },
  [1804] = {
    [sym_new_expression] = STATE(1808),
    [sym_constructor_type] = STATE(232),
    [sym_augmented_assignment_expression] = STATE(1808),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(1808),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(1808),
    [sym_call_signature] = STATE(2456),
    [sym_yield_expression] = STATE(1808),
    [sym_as_expression] = STATE(1808),
    [sym_internal_module] = STATE(1808),
    [sym_arrow_function] = STATE(1808),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(2457),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1714),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(2458),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(1808),
    [sym_subscript_expression] = STATE(2457),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(1808),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(1808),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(232),
    [sym__type] = STATE(232),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(1808),
    [sym_meta_property] = STATE(1808),
    [sym_function_type] = STATE(232),
    [sym__expression] = STATE(1808),
    [sym_non_null_expression] = STATE(1808),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(89),
    [sym_await_expression] = STATE(1808),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(1808),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_anonymous_class] = STATE(1808),
    [sym_call_expression] = STATE(1808),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(1808),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(1808),
    [sym_type_arguments] = STATE(2459),
    [sym_union_type] = STATE(232),
    [sym_parenthesized_expression] = STATE(1808),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1808),
    [sym_class] = STATE(1808),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(4333),
    [sym_false] = ACTIONS(4335),
    [anon_sym_LBRACK] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(4337),
    [anon_sym_number] = ACTIONS(4337),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(4339),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4341),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(4343),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(4345),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_LPAREN] = ACTIONS(1652),
    [sym_null] = ACTIONS(4347),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(4337),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(4337),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(4349),
    [sym_number] = ACTIONS(4351),
    [sym_true] = ACTIONS(4335),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(4337),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(4347),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(4353),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(4341),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [1805] = {
    [sym_type_alias_declaration] = STATE(559),
    [aux_sym_export_statement_repeat1] = STATE(2233),
    [sym__declaration] = STATE(559),
    [sym_ambient_declaration] = STATE(559),
    [sym_import_alias] = STATE(559),
    [sym_export_statement] = STATE(559),
    [sym_generator_function] = STATE(559),
    [sym_lexical_declaration] = STATE(559),
    [sym_internal_module] = STATE(559),
    [sym_decorator] = STATE(2233),
    [sym_enum_declaration] = STATE(559),
    [sym_function] = STATE(559),
    [sym_function_signature] = STATE(559),
    [sym_variable_declaration] = STATE(559),
    [sym_abstract_class] = STATE(559),
    [sym_module] = STATE(559),
    [sym_interface_declaration] = STATE(559),
    [sym_class] = STATE(559),
    [anon_sym_var] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(1662),
    [anon_sym_interface] = ACTIONS(340),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_module] = ACTIONS(4455),
    [anon_sym_class] = ACTIONS(4457),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(4461),
    [anon_sym_const] = ACTIONS(338),
    [anon_sym_abstract] = ACTIONS(4463),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_let] = ACTIONS(364),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_export] = ACTIONS(4465),
    [anon_sym_namespace] = ACTIONS(4467),
    [anon_sym_async] = ACTIONS(4469),
  },
  [1806] = {
    [sym_class_heritage] = STATE(1870),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(1316),
    [anon_sym_extends] = ACTIONS(328),
    [sym_identifier] = ACTIONS(4471),
    [anon_sym_implements] = ACTIONS(332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [1807] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(1679),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1679),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2469),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2455),
  },
  [1808] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [1809] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(1687),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1687),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2469),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2455),
  },
  [1810] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(1689),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1689),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2469),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2455),
  },
  [1811] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(1713),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1713),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2469),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2455),
  },
  [1812] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(1717),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1717),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2469),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2455),
  },
  [1813] = {
    [sym__initializer] = STATE(589),
    [aux_sym_object_repeat1] = STATE(1834),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [1814] = {
    [aux_sym_object_repeat1] = STATE(1834),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [1815] = {
    [aux_sym_object_repeat1] = STATE(1834),
    [anon_sym_LBRACK] = ACTIONS(1014),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_symbol] = ACTIONS(1012),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_namespace] = ACTIONS(1012),
    [sym_readonly] = ACTIONS(1012),
    [anon_sym_DQUOTE] = ACTIONS(1014),
  },
  [1816] = {
    [sym__property_name] = STATE(417),
    [aux_sym_object_repeat1] = STATE(1834),
    [sym_string] = STATE(417),
    [sym_computed_property_name] = STATE(417),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(1020),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1016),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1817] = {
    [sym__property_name] = STATE(417),
    [aux_sym_object_repeat1] = STATE(1834),
    [sym_string] = STATE(417),
    [sym_computed_property_name] = STATE(417),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(3056),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1818] = {
    [sym_enum_body] = STATE(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4401),
  },
  [1819] = {
    [aux_sym_variable_declaration_repeat1] = STATE(597),
    [sym__automatic_semicolon] = ACTIONS(4473),
    [anon_sym_SEMI] = ACTIONS(4473),
    [anon_sym_COMMA] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
  },
  [1820] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACK] = ACTIONS(4475),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1821] = {
    [anon_sym_RBRACK] = ACTIONS(4475),
    [sym_comment] = ACTIONS(3),
  },
  [1822] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [aux_sym_array_repeat1] = STATE(1871),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(4477),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1823] = {
    [aux_sym_array_repeat1] = STATE(1871),
    [anon_sym_RPAREN] = ACTIONS(4477),
    [anon_sym_COMMA] = ACTIONS(272),
    [sym_comment] = ACTIONS(3),
  },
  [1824] = {
    [aux_sym_array_repeat1] = STATE(375),
    [anon_sym_RPAREN] = ACTIONS(4477),
    [anon_sym_COMMA] = ACTIONS(272),
    [sym_comment] = ACTIONS(3),
  },
  [1825] = {
    [sym_object_type] = STATE(1381),
    [sym_extends_clause] = STATE(1872),
    [anon_sym_extends] = ACTIONS(749),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1616),
  },
  [1826] = {
    [sym_object_type] = STATE(1381),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1616),
  },
  [1827] = {
    [sym_computed_property_name] = STATE(606),
    [sym__enum_member] = STATE(1873),
    [sym__property_name] = STATE(606),
    [sym_string] = STATE(606),
    [sym_enum_assignment] = STATE(1873),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_RBRACE] = ACTIONS(4479),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(1773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1828] = {
    [sym_class_heritage] = STATE(1875),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_type_parameters] = STATE(1876),
    [sym_class_body] = STATE(1383),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [1829] = {
    [sym_identifier] = ACTIONS(4481),
    [sym_comment] = ACTIONS(3),
  },
  [1830] = {
    [aux_sym_array_repeat1] = STATE(375),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_RBRACK] = ACTIONS(4483),
    [sym_comment] = ACTIONS(3),
  },
  [1831] = {
    [sym_class_body] = STATE(1386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [1832] = {
    [sym_class_heritage] = STATE(1880),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(1386),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [1833] = {
    [sym_public_field_definition] = STATE(394),
    [sym__property_name] = STATE(395),
    [sym_method_signature] = STATE(394),
    [sym_abstract_method_signature] = STATE(394),
    [aux_sym_class_body_repeat1] = STATE(679),
    [sym_index_signature] = STATE(394),
    [sym_method_definition] = STATE(398),
    [sym_decorator] = STATE(679),
    [sym_accessibility_modifier] = STATE(396),
    [sym_computed_property_name] = STATE(395),
    [sym_string] = STATE(395),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(923),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(931),
    [anon_sym_RBRACE] = ACTIONS(4485),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [sym_number] = ACTIONS(937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_abstract] = ACTIONS(939),
    [anon_sym_set] = ACTIONS(931),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [sym_readonly] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1834] = {
    [aux_sym_object_repeat1] = STATE(434),
    [anon_sym_RBRACE] = ACTIONS(4487),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [1835] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [aux_sym_array_repeat1] = STATE(1830),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACK] = ACTIONS(4489),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1836] = {
    [aux_sym_object_repeat1] = STATE(434),
    [anon_sym_RBRACE] = ACTIONS(4491),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [1837] = {
    [aux_sym_object_repeat1] = STATE(1886),
    [anon_sym_RBRACE] = ACTIONS(4491),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [1838] = {
    [aux_sym_export_statement_repeat1] = STATE(719),
    [sym_decorator] = STATE(719),
    [sym_object] = STATE(465),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(720),
    [sym_array] = STATE(467),
    [sym_rest_parameter] = STATE(720),
    [sym_optional_parameter] = STATE(720),
    [sym_this] = STATE(468),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_symbol] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1154),
    [anon_sym_any] = ACTIONS(1154),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_boolean] = ACTIONS(1154),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_RPAREN] = ACTIONS(4493),
    [anon_sym_this] = ACTIONS(284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_string] = ACTIONS(1154),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [anon_sym_export] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
  },
  [1839] = {
    [aux_sym_formal_parameters_repeat1] = STATE(722),
    [anon_sym_RPAREN] = ACTIONS(4493),
    [anon_sym_COMMA] = ACTIONS(4495),
    [sym_comment] = ACTIONS(3),
  },
  [1840] = {
    [anon_sym_RPAREN] = ACTIONS(4497),
    [sym_comment] = ACTIONS(3),
  },
  [1841] = {
    [aux_sym_formal_parameters_repeat1] = STATE(1888),
    [anon_sym_RPAREN] = ACTIONS(4493),
    [anon_sym_COMMA] = ACTIONS(4495),
    [sym_comment] = ACTIONS(3),
  },
  [1842] = {
    [aux_sym_export_statement_repeat1] = STATE(2472),
    [sym_decorator] = STATE(2472),
    [sym_object] = STATE(465),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(1841),
    [sym_array] = STATE(467),
    [sym_rest_parameter] = STATE(1841),
    [sym_optional_parameter] = STATE(1841),
    [sym_this] = STATE(468),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_symbol] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1154),
    [anon_sym_any] = ACTIONS(1154),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_boolean] = ACTIONS(1154),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_this] = ACTIONS(284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_string] = ACTIONS(1154),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [anon_sym_export] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
  },
  [1843] = {
    [sym_statement_block] = STATE(1399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3190),
  },
  [1844] = {
    [aux_sym_variable_declaration_repeat1] = STATE(597),
    [sym__automatic_semicolon] = ACTIONS(4499),
    [anon_sym_SEMI] = ACTIONS(4499),
    [anon_sym_COMMA] = ACTIONS(725),
    [sym_comment] = ACTIONS(3),
  },
  [1845] = {
    [sym_identifier] = ACTIONS(4501),
    [sym_comment] = ACTIONS(3),
  },
  [1846] = {
    [aux_sym_object_type_repeat1] = STATE(1895),
    [sym__automatic_semicolon] = ACTIONS(4503),
    [anon_sym_RBRACE] = ACTIONS(4505),
    [anon_sym_SEMI] = ACTIONS(4503),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4505),
    [anon_sym_COMMA] = ACTIONS(4503),
    [sym_comment] = ACTIONS(3),
  },
  [1847] = {
    [aux_sym_implements_clause_repeat1] = STATE(1896),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_RBRACK] = ACTIONS(4507),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(1954),
    [sym_comment] = ACTIONS(3),
  },
  [1848] = {
    [anon_sym_BQUOTE] = ACTIONS(2315),
    [anon_sym_symbol] = ACTIONS(2317),
    [anon_sym_PIPE] = ACTIONS(2315),
    [anon_sym_break] = ACTIONS(2317),
    [anon_sym_return] = ACTIONS(2317),
    [anon_sym_RBRACE] = ACTIONS(2315),
    [anon_sym_interface] = ACTIONS(2317),
    [anon_sym_delete] = ACTIONS(2317),
    [anon_sym_if] = ACTIONS(2317),
    [anon_sym_yield] = ACTIONS(2317),
    [sym_true] = ACTIONS(2317),
    [anon_sym_protected] = ACTIONS(2317),
    [anon_sym_DOT] = ACTIONS(4271),
    [anon_sym_set] = ACTIONS(2317),
    [anon_sym_import] = ACTIONS(2317),
    [anon_sym_await] = ACTIONS(2317),
    [anon_sym_DQUOTE] = ACTIONS(2315),
    [anon_sym_for] = ACTIONS(2317),
    [anon_sym_SEMI] = ACTIONS(2315),
    [anon_sym_number] = ACTIONS(2317),
    [anon_sym_typeof] = ACTIONS(2317),
    [anon_sym_LBRACE] = ACTIONS(2315),
    [anon_sym_switch] = ACTIONS(2317),
    [sym_null] = ACTIONS(2317),
    [anon_sym_any] = ACTIONS(2317),
    [anon_sym_async] = ACTIONS(2317),
    [anon_sym_public] = ACTIONS(2317),
    [anon_sym_var] = ACTIONS(2317),
    [anon_sym_while] = ACTIONS(2317),
    [anon_sym_SQUOTE] = ACTIONS(2315),
    [anon_sym_SLASH] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2317),
    [anon_sym_new] = ACTIONS(2317),
    [anon_sym_export] = ACTIONS(2317),
    [anon_sym_with] = ACTIONS(2317),
    [sym_identifier] = ACTIONS(2317),
    [anon_sym_debugger] = ACTIONS(2317),
    [anon_sym_AT] = ACTIONS(2315),
    [anon_sym_DASH] = ACTIONS(2317),
    [anon_sym_void] = ACTIONS(2317),
    [anon_sym_const] = ACTIONS(2317),
    [sym_super] = ACTIONS(2317),
    [anon_sym_private] = ACTIONS(2317),
    [anon_sym_get] = ACTIONS(2317),
    [anon_sym_default] = ACTIONS(2317),
    [anon_sym_enum] = ACTIONS(2317),
    [anon_sym_continue] = ACTIONS(2317),
    [anon_sym_DASH_DASH] = ACTIONS(2315),
    [anon_sym_this] = ACTIONS(2317),
    [anon_sym_throw] = ACTIONS(2317),
    [anon_sym_abstract] = ACTIONS(2317),
    [anon_sym_type] = ACTIONS(2317),
    [anon_sym_namespace] = ACTIONS(2317),
    [anon_sym_PLUS_PLUS] = ACTIONS(2315),
    [anon_sym_else] = ACTIONS(2317),
    [anon_sym_BANG] = ACTIONS(2315),
    [anon_sym_LBRACK] = ACTIONS(2315),
    [sym_false] = ACTIONS(2317),
    [anon_sym_case] = ACTIONS(2317),
    [anon_sym_module] = ACTIONS(2317),
    [anon_sym_class] = ACTIONS(2317),
    [anon_sym_declare] = ACTIONS(2317),
    [anon_sym_LPAREN] = ACTIONS(2315),
    [anon_sym_boolean] = ACTIONS(2317),
    [anon_sym_AMP] = ACTIONS(2315),
    [anon_sym_try] = ACTIONS(2317),
    [anon_sym_LT] = ACTIONS(2315),
    [sym_number] = ACTIONS(2315),
    [ts_builtin_sym_end] = ACTIONS(2315),
    [anon_sym_function] = ACTIONS(2317),
    [sym_undefined] = ACTIONS(2317),
    [anon_sym_let] = ACTIONS(2317),
    [anon_sym_PLUS] = ACTIONS(2317),
    [anon_sym_do] = ACTIONS(2317),
    [anon_sym_TILDE] = ACTIONS(2315),
  },
  [1849] = {
    [anon_sym_EQ_GT] = ACTIONS(4509),
    [sym_comment] = ACTIONS(3),
  },
  [1850] = {
    [sym_new_expression] = STATE(1754),
    [sym_constructor_type] = STATE(2044),
    [sym_augmented_assignment_expression] = STATE(1754),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(1754),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(1754),
    [sym_call_signature] = STATE(1740),
    [sym_yield_expression] = STATE(1754),
    [sym_as_expression] = STATE(1754),
    [sym_internal_module] = STATE(1754),
    [sym_arrow_function] = STATE(1754),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(1201),
    [sym_mapped_type] = STATE(237),
    [sym_spread_element] = STATE(1755),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1535),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(1202),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(1754),
    [sym_subscript_expression] = STATE(1201),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(1754),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(1754),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(2044),
    [sym__type] = STATE(2044),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(1754),
    [sym_meta_property] = STATE(1754),
    [sym_function_type] = STATE(2044),
    [sym__expression] = STATE(1754),
    [sym_non_null_expression] = STATE(1754),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(1754),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(1754),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [aux_sym_array_repeat1] = STATE(1756),
    [sym_anonymous_class] = STATE(1754),
    [sym_call_expression] = STATE(1754),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(1754),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(1754),
    [sym_type_arguments] = STATE(1205),
    [sym_union_type] = STATE(2044),
    [sym_parenthesized_expression] = STATE(1754),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1754),
    [sym_class] = STATE(1754),
    [sym_identifier] = ACTIONS(2325),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(2327),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(2329),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_void] = ACTIONS(2331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2333),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(2335),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(2335),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(2327),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [anon_sym_RBRACK] = ACTIONS(2343),
    [sym_null] = ACTIONS(2345),
    [anon_sym_any] = ACTIONS(2327),
    [anon_sym_boolean] = ACTIONS(2327),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2347),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2327),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(2345),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2329),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1851] = {
    [sym_property_signature] = STATE(513),
    [sym_call_signature] = STATE(513),
    [sym_construct_signature] = STATE(513),
    [sym_index_signature] = STATE(513),
    [sym_method_definition] = STATE(181),
    [sym_accessibility_modifier] = STATE(787),
    [sym_spread_element] = STATE(181),
    [sym_string] = STATE(786),
    [sym_type_parameters] = STATE(1741),
    [sym_pair] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(1899),
    [sym_object] = STATE(310),
    [sym__property_name] = STATE(786),
    [aux_sym_object_repeat1] = STATE(185),
    [sym_assignment_pattern] = STATE(181),
    [sym_method_signature] = STATE(513),
    [sym_export_statement] = STATE(513),
    [sym_decorator] = STATE(1899),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(786),
    [sym_array] = STATE(312),
    [sym_identifier] = ACTIONS(4511),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_SEMI] = ACTIONS(1222),
    [anon_sym_module] = ACTIONS(4513),
    [anon_sym_symbol] = ACTIONS(4513),
    [anon_sym_number] = ACTIONS(4513),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(4513),
    [anon_sym_COMMA] = ACTIONS(2363),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_void] = ACTIONS(4513),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(4513),
    [anon_sym_private] = ACTIONS(4515),
    [anon_sym_boolean] = ACTIONS(4513),
    [anon_sym_static] = ACTIONS(2369),
    [anon_sym_async] = ACTIONS(4517),
    [anon_sym_get] = ACTIONS(4519),
    [anon_sym_RBRACE] = ACTIONS(4521),
    [anon_sym_public] = ACTIONS(4515),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4515),
    [anon_sym_string] = ACTIONS(4513),
    [anon_sym_set] = ACTIONS(4519),
    [anon_sym_type] = ACTIONS(4513),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(4513),
    [anon_sym_export] = ACTIONS(4523),
    [sym_readonly] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(4513),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1852] = {
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_RPAREN] = ACTIONS(4525),
    [anon_sym_PIPE] = ACTIONS(1276),
    [sym_comment] = ACTIONS(3),
  },
  [1853] = {
    [sym__type] = STATE(792),
    [sym_constructor_type] = STATE(792),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(792),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(792),
    [sym_intersection_type] = STATE(792),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_GT] = ACTIONS(4527),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1854] = {
    [aux_sym_implements_clause_repeat1] = STATE(794),
    [anon_sym_GT] = ACTIONS(4527),
    [anon_sym_COMMA] = ACTIONS(4529),
    [sym_comment] = ACTIONS(3),
  },
  [1855] = {
    [anon_sym_EQ_GT] = ACTIONS(4531),
    [sym_comment] = ACTIONS(3),
  },
  [1856] = {
    [anon_sym_RBRACK] = ACTIONS(4533),
    [sym_comment] = ACTIONS(3),
  },
  [1857] = {
    [sym_statement_block] = STATE(1638),
    [sym__automatic_semicolon] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [1858] = {
    [sym_statement_block] = STATE(1422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3190),
  },
  [1859] = {
    [sym__automatic_semicolon] = ACTIONS(4535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4535),
  },
  [1860] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(4535),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4535),
    [anon_sym_in] = ACTIONS(2455),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2469),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(600),
  },
  [1861] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2455),
  },
  [1862] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_GT_GT_GT] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(4537),
    [anon_sym_SLASH] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [1863] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(4537),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [1864] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2455),
  },
  [1865] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4540),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1866] = {
    [sym_new_expression] = STATE(2009),
    [sym_constructor_type] = STATE(527),
    [sym_augmented_assignment_expression] = STATE(2009),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(2009),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(2009),
    [sym_call_signature] = STATE(1740),
    [sym_rest_parameter] = STATE(198),
    [sym_yield_expression] = STATE(2009),
    [sym_as_expression] = STATE(2009),
    [sym_internal_module] = STATE(2009),
    [sym_accessibility_modifier] = STATE(200),
    [sym_arrow_function] = STATE(2009),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(1201),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1691),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(204),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(2009),
    [sym_subscript_expression] = STATE(1201),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(2009),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(2009),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(203),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(527),
    [sym__type] = STATE(527),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(2009),
    [sym_meta_property] = STATE(2009),
    [sym_function_type] = STATE(527),
    [sym__expression] = STATE(2009),
    [sym_non_null_expression] = STATE(2009),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_required_parameter] = STATE(198),
    [sym_await_expression] = STATE(2009),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_sequence_expression] = STATE(2010),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(202),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(203),
    [sym_anonymous_class] = STATE(2009),
    [sym_optional_parameter] = STATE(198),
    [sym_call_expression] = STATE(2009),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(2009),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(2009),
    [sym_type_arguments] = STATE(1205),
    [sym_union_type] = STATE(527),
    [sym_parenthesized_expression] = STATE(2009),
    [sym_array] = STATE(205),
    [sym_type_assertion] = STATE(2009),
    [sym_class] = STATE(2009),
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(2538),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(2542),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(414),
    [anon_sym_get] = ACTIONS(410),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(2546),
    [anon_sym_protected] = ACTIONS(414),
    [anon_sym_set] = ACTIONS(410),
    [anon_sym_type] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(410),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(420),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(2546),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_number] = ACTIONS(2538),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(410),
    [anon_sym_typeof] = ACTIONS(2548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [sym_null] = ACTIONS(4542),
    [anon_sym_any] = ACTIONS(2538),
    [anon_sym_boolean] = ACTIONS(2538),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_public] = ACTIONS(414),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2550),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2538),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4542),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2540),
    [anon_sym_export] = ACTIONS(410),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [1867] = {
    [sym_formal_parameters] = STATE(1430),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [1868] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_GT_GT_GT] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(4537),
    [anon_sym_SLASH] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [1869] = {
    [sym_class_heritage] = STATE(1907),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_type_parameters] = STATE(1908),
    [sym_class_body] = STATE(1431),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [1870] = {
    [sym_class_body] = STATE(1432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [1871] = {
    [aux_sym_array_repeat1] = STATE(375),
    [anon_sym_RPAREN] = ACTIONS(4544),
    [anon_sym_COMMA] = ACTIONS(272),
    [sym_comment] = ACTIONS(3),
  },
  [1872] = {
    [sym_object_type] = STATE(1434),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1616),
  },
  [1873] = {
    [aux_sym_enum_body_repeat1] = STATE(1911),
    [anon_sym_COMMA] = ACTIONS(4546),
    [anon_sym_RBRACE] = ACTIONS(4548),
    [sym_comment] = ACTIONS(3),
  },
  [1874] = {
    [sym_type_alias_declaration] = STATE(840),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(840),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(840),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(840),
    [sym_return_statement] = STATE(840),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(840),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(840),
    [sym_switch_statement] = STATE(840),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(840),
    [sym_throw_statement] = STATE(840),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(840),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(840),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(840),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(840),
    [sym_abstract_class] = STATE(840),
    [sym_interface_declaration] = STATE(840),
    [sym_statement_block] = STATE(840),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(840),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(840),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(840),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(840),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(840),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(840),
    [sym_empty_statement] = STATE(840),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(840),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(840),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(840),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(840),
    [sym_break_statement] = STATE(840),
    [sym_labeled_statement] = STATE(840),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(840),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1875] = {
    [sym_class_body] = STATE(1436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [1876] = {
    [sym_class_heritage] = STATE(1912),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(1436),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [1877] = {
    [sym__automatic_semicolon] = ACTIONS(4550),
    [anon_sym_AMP] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(4550),
    [sym_comment] = ACTIONS(3),
  },
  [1878] = {
    [sym__automatic_semicolon] = ACTIONS(4552),
    [anon_sym_SEMI] = ACTIONS(4552),
    [anon_sym_DOT] = ACTIONS(2624),
    [sym_comment] = ACTIONS(3),
  },
  [1879] = {
    [sym_identifier] = ACTIONS(4554),
    [sym_comment] = ACTIONS(3),
  },
  [1880] = {
    [sym_class_body] = STATE(1440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [1881] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_AMP_EQ] = ACTIONS(1088),
    [anon_sym_PLUS_EQ] = ACTIONS(1088),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(1088),
    [anon_sym_STAR_EQ] = ACTIONS(1088),
    [anon_sym_PIPE_EQ] = ACTIONS(1088),
    [anon_sym_DASH_EQ] = ACTIONS(1088),
    [anon_sym_EQ_GT] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1088),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2718),
    [anon_sym_SLASH_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT_EQ] = ACTIONS(1088),
    [anon_sym_DOT] = ACTIONS(2720),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1088),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(3170),
  },
  [1882] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(4556),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1883] = {
    [sym_statement_block] = STATE(694),
    [sym__automatic_semicolon] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(2770),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_PIPE_RBRACE] = ACTIONS(2770),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [1884] = {
    [anon_sym_COLON] = ACTIONS(4558),
    [sym_comment] = ACTIONS(3),
  },
  [1885] = {
    [sym_nested_identifier] = STATE(1878),
    [sym_identifier] = ACTIONS(4560),
    [sym_comment] = ACTIONS(3),
  },
  [1886] = {
    [aux_sym_object_repeat1] = STATE(434),
    [anon_sym_RBRACE] = ACTIONS(4562),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [1887] = {
    [aux_sym_export_statement_repeat1] = STATE(719),
    [sym_decorator] = STATE(719),
    [sym_object] = STATE(465),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(720),
    [sym_array] = STATE(467),
    [sym_rest_parameter] = STATE(720),
    [sym_optional_parameter] = STATE(720),
    [sym_this] = STATE(468),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_symbol] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1154),
    [anon_sym_any] = ACTIONS(1154),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_boolean] = ACTIONS(1154),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_RPAREN] = ACTIONS(4564),
    [anon_sym_this] = ACTIONS(284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_string] = ACTIONS(1154),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [anon_sym_export] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
  },
  [1888] = {
    [aux_sym_formal_parameters_repeat1] = STATE(722),
    [anon_sym_RPAREN] = ACTIONS(4564),
    [anon_sym_COMMA] = ACTIONS(4566),
    [sym_comment] = ACTIONS(3),
  },
  [1889] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2936),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2469),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2455),
  },
  [1890] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(2940),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(2940),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2469),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2455),
  },
  [1891] = {
    [sym_statement_block] = STATE(1661),
    [sym__automatic_semicolon] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [1892] = {
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_RBRACK] = ACTIONS(4568),
    [sym_comment] = ACTIONS(3),
  },
  [1893] = {
    [aux_sym_object_type_repeat1] = STATE(1918),
    [sym__automatic_semicolon] = ACTIONS(4570),
    [anon_sym_RBRACE] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4572),
    [anon_sym_COMMA] = ACTIONS(4570),
    [sym_comment] = ACTIONS(3),
  },
  [1894] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(967),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(967),
    [sym_call_signature] = STATE(967),
    [sym_construct_signature] = STATE(967),
    [sym_index_signature] = STATE(967),
    [sym_export_statement] = STATE(967),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(4572),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4572),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1895] = {
    [aux_sym_object_type_repeat1] = STATE(968),
    [sym__automatic_semicolon] = ACTIONS(4570),
    [anon_sym_RBRACE] = ACTIONS(4572),
    [anon_sym_SEMI] = ACTIONS(4570),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4572),
    [anon_sym_COMMA] = ACTIONS(4570),
    [sym_comment] = ACTIONS(3),
  },
  [1896] = {
    [aux_sym_implements_clause_repeat1] = STATE(794),
    [anon_sym_COMMA] = ACTIONS(1954),
    [anon_sym_RBRACK] = ACTIONS(4574),
    [sym_comment] = ACTIONS(3),
  },
  [1897] = {
    [anon_sym_EQ_GT] = ACTIONS(4576),
    [sym_comment] = ACTIONS(3),
  },
  [1898] = {
    [sym_pair] = STATE(414),
    [aux_sym_export_statement_repeat1] = STATE(975),
    [sym_object] = STATE(310),
    [sym__property_name] = STATE(786),
    [sym_assignment_pattern] = STATE(414),
    [sym_method_signature] = STATE(2064),
    [sym_property_signature] = STATE(2064),
    [sym_call_signature] = STATE(2064),
    [sym_construct_signature] = STATE(2064),
    [sym_index_signature] = STATE(2064),
    [sym_export_statement] = STATE(2064),
    [sym_method_definition] = STATE(414),
    [sym_decorator] = STATE(975),
    [sym_accessibility_modifier] = STATE(787),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(786),
    [sym_array] = STATE(312),
    [sym_spread_element] = STATE(414),
    [sym_string] = STATE(786),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(3040),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_module] = ACTIONS(3042),
    [anon_sym_symbol] = ACTIONS(3042),
    [anon_sym_number] = ACTIONS(3042),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(3042),
    [anon_sym_COMMA] = ACTIONS(998),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_void] = ACTIONS(3042),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(3042),
    [anon_sym_private] = ACTIONS(3044),
    [anon_sym_boolean] = ACTIONS(3042),
    [anon_sym_static] = ACTIONS(2369),
    [anon_sym_async] = ACTIONS(3046),
    [anon_sym_get] = ACTIONS(3048),
    [anon_sym_RBRACE] = ACTIONS(998),
    [anon_sym_public] = ACTIONS(3044),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(3044),
    [anon_sym_string] = ACTIONS(3042),
    [anon_sym_set] = ACTIONS(3048),
    [anon_sym_type] = ACTIONS(3042),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(3042),
    [anon_sym_export] = ACTIONS(3050),
    [sym_readonly] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(3042),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1899] = {
    [sym__property_name] = STATE(439),
    [sym_decorator] = STATE(2472),
    [aux_sym_export_statement_repeat1] = STATE(2472),
    [sym_accessibility_modifier] = STATE(180),
    [sym_computed_property_name] = STATE(439),
    [sym_method_definition] = STATE(438),
    [sym_string] = STATE(439),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_get] = ACTIONS(1080),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [sym_number] = ACTIONS(1082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(3068),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1900] = {
    [sym__type] = STATE(792),
    [sym_constructor_type] = STATE(792),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(792),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(792),
    [sym_intersection_type] = STATE(792),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_GT] = ACTIONS(4578),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1901] = {
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_RBRACK] = ACTIONS(4580),
    [sym_comment] = ACTIONS(3),
  },
  [1902] = {
    [sym_statement_block] = STATE(1458),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3190),
  },
  [1903] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [aux_sym_array_repeat1] = STATE(1871),
    [sym_type_annotation] = STATE(2040),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(3138),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(4582),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [1904] = {
    [sym__automatic_semicolon] = ACTIONS(4584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(4584),
  },
  [1905] = {
    [sym_formal_parameters] = STATE(1462),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [1906] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [sym__automatic_semicolon] = ACTIONS(4584),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_SEMI] = ACTIONS(4584),
    [anon_sym_in] = ACTIONS(2455),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2469),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_BANG] = ACTIONS(600),
  },
  [1907] = {
    [sym_class_body] = STATE(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [1908] = {
    [sym_class_heritage] = STATE(1921),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(1463),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [1909] = {
    [sym_statement_block] = STATE(1575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4586),
  },
  [1910] = {
    [sym_computed_property_name] = STATE(606),
    [sym__enum_member] = STATE(1002),
    [sym__property_name] = STATE(606),
    [sym_string] = STATE(606),
    [sym_enum_assignment] = STATE(1002),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(1773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1911] = {
    [aux_sym_enum_body_repeat1] = STATE(1004),
    [anon_sym_COMMA] = ACTIONS(4590),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [sym_comment] = ACTIONS(3),
  },
  [1912] = {
    [sym_class_body] = STATE(1465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [1913] = {
    [sym__automatic_semicolon] = ACTIONS(4592),
    [anon_sym_AMP] = ACTIONS(2614),
    [anon_sym_PIPE] = ACTIONS(2616),
    [anon_sym_SEMI] = ACTIONS(4592),
    [sym_comment] = ACTIONS(3),
  },
  [1914] = {
    [sym_type_alias_declaration] = STATE(1025),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1025),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1025),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1025),
    [sym_return_statement] = STATE(1025),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1025),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1025),
    [sym_switch_statement] = STATE(1025),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1025),
    [sym_throw_statement] = STATE(1025),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1025),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1025),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1025),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1025),
    [sym_abstract_class] = STATE(1025),
    [sym_interface_declaration] = STATE(1025),
    [sym_statement_block] = STATE(1025),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1025),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1025),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1025),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1025),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1025),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1025),
    [sym_empty_statement] = STATE(1025),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1025),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1025),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1025),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1025),
    [sym_break_statement] = STATE(1025),
    [sym_labeled_statement] = STATE(1025),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1025),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1915] = {
    [sym_statement_block] = STATE(906),
    [sym__automatic_semicolon] = ACTIONS(3313),
    [anon_sym_RBRACE] = ACTIONS(3313),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3313),
    [anon_sym_COMMA] = ACTIONS(3313),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [1916] = {
    [aux_sym_export_statement_repeat1] = STATE(719),
    [sym_decorator] = STATE(719),
    [sym_object] = STATE(465),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(720),
    [sym_array] = STATE(467),
    [sym_rest_parameter] = STATE(720),
    [sym_optional_parameter] = STATE(720),
    [sym_this] = STATE(468),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(1152),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_symbol] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1154),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1154),
    [anon_sym_any] = ACTIONS(1154),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_boolean] = ACTIONS(1154),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_RPAREN] = ACTIONS(4594),
    [anon_sym_this] = ACTIONS(284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_string] = ACTIONS(1154),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [anon_sym_export] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
  },
  [1917] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(967),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(967),
    [sym_call_signature] = STATE(967),
    [sym_construct_signature] = STATE(967),
    [sym_index_signature] = STATE(967),
    [sym_export_statement] = STATE(967),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(4596),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4596),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1918] = {
    [aux_sym_object_type_repeat1] = STATE(968),
    [sym__automatic_semicolon] = ACTIONS(4598),
    [anon_sym_RBRACE] = ACTIONS(4596),
    [anon_sym_SEMI] = ACTIONS(4598),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4596),
    [anon_sym_COMMA] = ACTIONS(4598),
    [sym_comment] = ACTIONS(3),
  },
  [1919] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(3569),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(3569),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2469),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2455),
  },
  [1920] = {
    [sym_identifier] = ACTIONS(4600),
    [sym_comment] = ACTIONS(3),
  },
  [1921] = {
    [sym_class_body] = STATE(1475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [1922] = {
    [sym_computed_property_name] = STATE(606),
    [sym__enum_member] = STATE(1002),
    [sym__property_name] = STATE(606),
    [sym_string] = STATE(606),
    [sym_enum_assignment] = STATE(1002),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_RBRACE] = ACTIONS(4602),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(1773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_async] = ACTIONS(1006),
  },
  [1923] = {
    [sym_type_alias_declaration] = STATE(1107),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1107),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1107),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1107),
    [sym_return_statement] = STATE(1107),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1107),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1107),
    [sym_switch_statement] = STATE(1107),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1107),
    [sym_throw_statement] = STATE(1107),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1107),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1107),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1107),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1107),
    [sym_abstract_class] = STATE(1107),
    [sym_interface_declaration] = STATE(1107),
    [sym_statement_block] = STATE(1107),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1107),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1107),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1107),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1107),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1107),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1107),
    [sym_empty_statement] = STATE(1107),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1107),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1107),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1107),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1107),
    [sym_break_statement] = STATE(1107),
    [sym_labeled_statement] = STATE(1107),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1107),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1924] = {
    [sym_type_alias_declaration] = STATE(1108),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1108),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1108),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1108),
    [sym_return_statement] = STATE(1108),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1108),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1108),
    [sym_switch_statement] = STATE(1108),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1108),
    [sym_throw_statement] = STATE(1108),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1108),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1108),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1108),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1108),
    [sym_abstract_class] = STATE(1108),
    [sym_interface_declaration] = STATE(1108),
    [sym_statement_block] = STATE(1108),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1108),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1108),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1108),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1108),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1108),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1108),
    [sym_empty_statement] = STATE(1108),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1108),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1108),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1108),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1108),
    [sym_break_statement] = STATE(1108),
    [sym_labeled_statement] = STATE(1108),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1108),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1925] = {
    [sym_type_alias_declaration] = STATE(1112),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1112),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1112),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1112),
    [sym_return_statement] = STATE(1112),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1112),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1112),
    [sym_switch_statement] = STATE(1112),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1112),
    [sym_throw_statement] = STATE(1112),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1112),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1112),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1112),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1112),
    [sym_abstract_class] = STATE(1112),
    [sym_interface_declaration] = STATE(1112),
    [sym_statement_block] = STATE(1112),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1112),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1112),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1112),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1112),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1112),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1112),
    [sym_empty_statement] = STATE(1112),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1112),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1112),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1112),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1112),
    [sym_break_statement] = STATE(1112),
    [sym_labeled_statement] = STATE(1112),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1112),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1926] = {
    [sym_type_alias_declaration] = STATE(1113),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1113),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1113),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1113),
    [sym_return_statement] = STATE(1113),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1113),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1113),
    [sym_switch_statement] = STATE(1113),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1113),
    [sym_throw_statement] = STATE(1113),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1113),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1113),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1113),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1113),
    [sym_abstract_class] = STATE(1113),
    [sym_interface_declaration] = STATE(1113),
    [sym_statement_block] = STATE(1113),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1113),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1113),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1113),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1113),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1113),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1113),
    [sym_empty_statement] = STATE(1113),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1113),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1113),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1113),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1113),
    [sym_break_statement] = STATE(1113),
    [sym_labeled_statement] = STATE(1113),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1113),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1927] = {
    [sym_type_alias_declaration] = STATE(1114),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1114),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1114),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1114),
    [sym_return_statement] = STATE(1114),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1114),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1114),
    [sym_switch_statement] = STATE(1114),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1114),
    [sym_throw_statement] = STATE(1114),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1114),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1114),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1114),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1114),
    [sym_abstract_class] = STATE(1114),
    [sym_interface_declaration] = STATE(1114),
    [sym_statement_block] = STATE(1114),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1114),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1114),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1114),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1114),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1114),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1114),
    [sym_empty_statement] = STATE(1114),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1114),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1114),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1114),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1114),
    [sym_break_statement] = STATE(1114),
    [sym_labeled_statement] = STATE(1114),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1114),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1928] = {
    [sym_type_alias_declaration] = STATE(1115),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1115),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1115),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1115),
    [sym_return_statement] = STATE(1115),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1115),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1115),
    [sym_switch_statement] = STATE(1115),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1115),
    [sym_throw_statement] = STATE(1115),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1115),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1115),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1115),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1115),
    [sym_abstract_class] = STATE(1115),
    [sym_interface_declaration] = STATE(1115),
    [sym_statement_block] = STATE(1115),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1115),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1115),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1115),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1115),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1115),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1115),
    [sym_empty_statement] = STATE(1115),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1115),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1115),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1115),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1115),
    [sym_break_statement] = STATE(1115),
    [sym_labeled_statement] = STATE(1115),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1115),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1929] = {
    [sym_type_alias_declaration] = STATE(1116),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1116),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1116),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1116),
    [sym_return_statement] = STATE(1116),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1116),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1116),
    [sym_switch_statement] = STATE(1116),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1116),
    [sym_throw_statement] = STATE(1116),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1116),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1116),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1116),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1116),
    [sym_abstract_class] = STATE(1116),
    [sym_interface_declaration] = STATE(1116),
    [sym_statement_block] = STATE(1116),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1116),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1116),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1116),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1116),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1116),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1116),
    [sym_empty_statement] = STATE(1116),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1116),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1116),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1116),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1116),
    [sym_break_statement] = STATE(1116),
    [sym_labeled_statement] = STATE(1116),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1116),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1930] = {
    [sym_statement_block] = STATE(1051),
    [sym__automatic_semicolon] = ACTIONS(3639),
    [anon_sym_RBRACE] = ACTIONS(3639),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3639),
    [anon_sym_COMMA] = ACTIONS(3639),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3639),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [1931] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(967),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(967),
    [sym_call_signature] = STATE(967),
    [sym_construct_signature] = STATE(967),
    [sym_index_signature] = STATE(967),
    [sym_export_statement] = STATE(967),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(4604),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4604),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [1932] = {
    [sym_type_alias_declaration] = STATE(1153),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1153),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1153),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1153),
    [sym_return_statement] = STATE(1153),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1153),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1153),
    [sym_switch_statement] = STATE(1153),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1153),
    [sym_throw_statement] = STATE(1153),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1153),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1153),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1153),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1153),
    [sym_abstract_class] = STATE(1153),
    [sym_interface_declaration] = STATE(1153),
    [sym_statement_block] = STATE(1153),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1153),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1153),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1153),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1153),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1153),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1153),
    [sym_empty_statement] = STATE(1153),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1153),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1153),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1153),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1153),
    [sym_break_statement] = STATE(1153),
    [sym_labeled_statement] = STATE(1153),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1153),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1933] = {
    [sym_type_alias_declaration] = STATE(1154),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1154),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1154),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1154),
    [sym_return_statement] = STATE(1154),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1154),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1154),
    [sym_switch_statement] = STATE(1154),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1154),
    [sym_throw_statement] = STATE(1154),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1154),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1154),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1154),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1154),
    [sym_abstract_class] = STATE(1154),
    [sym_interface_declaration] = STATE(1154),
    [sym_statement_block] = STATE(1154),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1154),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1154),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1154),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1154),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1154),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1154),
    [sym_empty_statement] = STATE(1154),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1154),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1154),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1154),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1154),
    [sym_break_statement] = STATE(1154),
    [sym_labeled_statement] = STATE(1154),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1154),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1934] = {
    [sym_type_alias_declaration] = STATE(1155),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1155),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1155),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1155),
    [sym_return_statement] = STATE(1155),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1155),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1155),
    [sym_switch_statement] = STATE(1155),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1155),
    [sym_throw_statement] = STATE(1155),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1155),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1155),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1155),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1155),
    [sym_abstract_class] = STATE(1155),
    [sym_interface_declaration] = STATE(1155),
    [sym_statement_block] = STATE(1155),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1155),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1155),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1155),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1155),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1155),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1155),
    [sym_empty_statement] = STATE(1155),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1155),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1155),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1155),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1155),
    [sym_break_statement] = STATE(1155),
    [sym_labeled_statement] = STATE(1155),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1155),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1935] = {
    [sym_type_alias_declaration] = STATE(1156),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1156),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1156),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1156),
    [sym_return_statement] = STATE(1156),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1156),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1156),
    [sym_switch_statement] = STATE(1156),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1156),
    [sym_throw_statement] = STATE(1156),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1156),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1156),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1156),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1156),
    [sym_abstract_class] = STATE(1156),
    [sym_interface_declaration] = STATE(1156),
    [sym_statement_block] = STATE(1156),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1156),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1156),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1156),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1156),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1156),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1156),
    [sym_empty_statement] = STATE(1156),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1156),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1156),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1156),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1156),
    [sym_break_statement] = STATE(1156),
    [sym_labeled_statement] = STATE(1156),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1156),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1936] = {
    [sym_type_alias_declaration] = STATE(1157),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1157),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1157),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1157),
    [sym_return_statement] = STATE(1157),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1157),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1157),
    [sym_switch_statement] = STATE(1157),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1157),
    [sym_throw_statement] = STATE(1157),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1157),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1157),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1157),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1157),
    [sym_abstract_class] = STATE(1157),
    [sym_interface_declaration] = STATE(1157),
    [sym_statement_block] = STATE(1157),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1157),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1157),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1157),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1157),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1157),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1157),
    [sym_empty_statement] = STATE(1157),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1157),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1157),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1157),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1157),
    [sym_break_statement] = STATE(1157),
    [sym_labeled_statement] = STATE(1157),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1157),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1937] = {
    [sym_type_alias_declaration] = STATE(1158),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1158),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1158),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1158),
    [sym_return_statement] = STATE(1158),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1158),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1158),
    [sym_switch_statement] = STATE(1158),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1158),
    [sym_throw_statement] = STATE(1158),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1158),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1158),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1158),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1158),
    [sym_abstract_class] = STATE(1158),
    [sym_interface_declaration] = STATE(1158),
    [sym_statement_block] = STATE(1158),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1158),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1158),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1158),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1158),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1158),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1158),
    [sym_empty_statement] = STATE(1158),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1158),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1158),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1158),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1158),
    [sym_break_statement] = STATE(1158),
    [sym_labeled_statement] = STATE(1158),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1158),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1938] = {
    [sym_statement_block] = STATE(1130),
    [sym__automatic_semicolon] = ACTIONS(3788),
    [anon_sym_RBRACE] = ACTIONS(3788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3788),
    [anon_sym_COMMA] = ACTIONS(3788),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3788),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [1939] = {
    [sym_type_alias_declaration] = STATE(1175),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1175),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1175),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1175),
    [sym_return_statement] = STATE(1175),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1175),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1175),
    [sym_switch_statement] = STATE(1175),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1175),
    [sym_throw_statement] = STATE(1175),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1175),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1175),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1175),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1175),
    [sym_abstract_class] = STATE(1175),
    [sym_interface_declaration] = STATE(1175),
    [sym_statement_block] = STATE(1175),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1175),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1175),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1175),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1175),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1175),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1175),
    [sym_empty_statement] = STATE(1175),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1175),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1175),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1175),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1175),
    [sym_break_statement] = STATE(1175),
    [sym_labeled_statement] = STATE(1175),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1175),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1940] = {
    [sym_type_alias_declaration] = STATE(1176),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1176),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1176),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1176),
    [sym_return_statement] = STATE(1176),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1176),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1176),
    [sym_switch_statement] = STATE(1176),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1176),
    [sym_throw_statement] = STATE(1176),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1176),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1176),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1176),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1176),
    [sym_abstract_class] = STATE(1176),
    [sym_interface_declaration] = STATE(1176),
    [sym_statement_block] = STATE(1176),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1176),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1176),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1176),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1176),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1176),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1176),
    [sym_empty_statement] = STATE(1176),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1176),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1176),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1176),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1176),
    [sym_break_statement] = STATE(1176),
    [sym_labeled_statement] = STATE(1176),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1176),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1941] = {
    [sym_type_alias_declaration] = STATE(1177),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1177),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1177),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1177),
    [sym_return_statement] = STATE(1177),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(1200),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1177),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1177),
    [sym_switch_statement] = STATE(1177),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1177),
    [sym_throw_statement] = STATE(1177),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1177),
    [sym_generator_function] = STATE(1200),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1177),
    [sym_decorator] = STATE(2204),
    [sym_continue_statement] = STATE(1177),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1177),
    [sym_abstract_class] = STATE(1177),
    [sym_interface_declaration] = STATE(1177),
    [sym_statement_block] = STATE(1177),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1177),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1177),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1177),
    [sym_function] = STATE(1204),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1177),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1177),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1177),
    [sym_empty_statement] = STATE(1177),
    [aux_sym_export_statement_repeat1] = STATE(2204),
    [sym_import_alias] = STATE(1177),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1177),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1177),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1177),
    [sym_break_statement] = STATE(1177),
    [sym_labeled_statement] = STATE(1177),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1177),
    [sym_class] = STATE(1200),
    [sym_identifier] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(540),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(542),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(544),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(546),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(548),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(550),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(552),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(554),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(556),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(558),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(560),
  },
  [1942] = {
    [sym_statement_block] = STATE(1167),
    [sym__automatic_semicolon] = ACTIONS(3858),
    [anon_sym_RBRACE] = ACTIONS(3858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3858),
    [anon_sym_COMMA] = ACTIONS(3858),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3858),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [1943] = {
    [sym_statement_block] = STATE(1181),
    [sym__automatic_semicolon] = ACTIONS(3884),
    [anon_sym_RBRACE] = ACTIONS(3884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3884),
    [anon_sym_COMMA] = ACTIONS(3884),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3884),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [1944] = {
    [sym_statement_block] = STATE(1186),
    [sym__automatic_semicolon] = ACTIONS(3890),
    [anon_sym_RBRACE] = ACTIONS(3890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3890),
    [anon_sym_COMMA] = ACTIONS(3890),
    [anon_sym_PIPE_RBRACE] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [1945] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [1946] = {
    [sym_new_expression] = STATE(1261),
    [sym_augmented_assignment_expression] = STATE(1800),
    [sym_unary_expression] = STATE(1800),
    [sym_update_expression] = STATE(1800),
    [sym_regex] = STATE(1261),
    [sym_meta_property] = STATE(1261),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(1800),
    [sym_yield_expression] = STATE(1800),
    [sym_as_expression] = STATE(1800),
    [sym_non_null_expression] = STATE(1800),
    [sym_internal_module] = STATE(1800),
    [sym_function] = STATE(1266),
    [sym_arrow_function] = STATE(1261),
    [sym_await_expression] = STATE(1800),
    [sym_member_expression] = STATE(1267),
    [sym_string] = STATE(1261),
    [sym_this] = STATE(1261),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1268),
    [sym_anonymous_class] = STATE(1261),
    [sym_generator_function] = STATE(1261),
    [sym_call_expression] = STATE(1800),
    [sym_subscript_expression] = STATE(1267),
    [sym_assignment_expression] = STATE(1800),
    [sym_ternary_expression] = STATE(1800),
    [sym_binary_expression] = STATE(1800),
    [sym_template_string] = STATE(1261),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1261),
    [sym_array] = STATE(1269),
    [sym_type_assertion] = STATE(1800),
    [sym_class] = STATE(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [sym_identifier] = ACTIONS(4148),
    [sym_false] = ACTIONS(3920),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_module] = ACTIONS(4150),
    [anon_sym_symbol] = ACTIONS(4150),
    [anon_sym_number] = ACTIONS(4150),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(4150),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(4152),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3920),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4150),
    [anon_sym_private] = ACTIONS(4150),
    [anon_sym_boolean] = ACTIONS(4150),
    [anon_sym_async] = ACTIONS(4156),
    [anon_sym_public] = ACTIONS(4150),
    [anon_sym_get] = ACTIONS(4150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(3928),
    [sym_true] = ACTIONS(3920),
    [anon_sym_yield] = ACTIONS(508),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(4150),
    [anon_sym_string] = ACTIONS(4150),
    [anon_sym_function] = ACTIONS(314),
    [anon_sym_DOT] = ACTIONS(3922),
    [sym_undefined] = ACTIONS(3920),
    [anon_sym_set] = ACTIONS(4150),
    [anon_sym_type] = ACTIONS(4150),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(4150),
    [anon_sym_export] = ACTIONS(4150),
    [anon_sym_namespace] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [1947] = {
    [sym_new_expression] = STATE(1286),
    [sym_augmented_assignment_expression] = STATE(1286),
    [sym_unary_expression] = STATE(1286),
    [sym_update_expression] = STATE(1286),
    [sym_regex] = STATE(1286),
    [sym_meta_property] = STATE(1286),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(1286),
    [sym_yield_expression] = STATE(1286),
    [sym_as_expression] = STATE(1286),
    [sym_non_null_expression] = STATE(1286),
    [sym_internal_module] = STATE(1286),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1286),
    [sym_await_expression] = STATE(1286),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(1286),
    [sym_this] = STATE(1286),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(1286),
    [sym_generator_function] = STATE(1286),
    [sym_call_expression] = STATE(1286),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(1286),
    [sym_ternary_expression] = STATE(1286),
    [sym_binary_expression] = STATE(1286),
    [sym_template_string] = STATE(1286),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1286),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(1286),
    [sym_class] = STATE(1286),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3930),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(3932),
    [sym_true] = ACTIONS(3930),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3930),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1948] = {
    [sym_new_expression] = STATE(1968),
    [sym_augmented_assignment_expression] = STATE(1968),
    [sym_unary_expression] = STATE(1968),
    [sym_update_expression] = STATE(1968),
    [sym_regex] = STATE(1968),
    [sym_meta_property] = STATE(1968),
    [sym_call_signature] = STATE(1997),
    [sym_statement_block] = STATE(1288),
    [sym__expression] = STATE(1968),
    [sym_yield_expression] = STATE(1968),
    [sym_as_expression] = STATE(1968),
    [sym_non_null_expression] = STATE(1968),
    [sym_internal_module] = STATE(1968),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1968),
    [sym_await_expression] = STATE(1968),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(1968),
    [sym_this] = STATE(1968),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(1968),
    [sym_generator_function] = STATE(1968),
    [sym_call_expression] = STATE(1968),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(1968),
    [sym_ternary_expression] = STATE(1968),
    [sym_binary_expression] = STATE(1968),
    [sym_template_string] = STATE(1968),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1968),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(1968),
    [sym_class] = STATE(1968),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4608),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4608),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4610),
    [sym_true] = ACTIONS(4608),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4608),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1949] = {
    [sym_new_expression] = STATE(2081),
    [sym_augmented_assignment_expression] = STATE(2081),
    [sym_unary_expression] = STATE(2081),
    [sym_update_expression] = STATE(2081),
    [sym_regex] = STATE(2081),
    [sym_meta_property] = STATE(2081),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2081),
    [sym_yield_expression] = STATE(2081),
    [sym_as_expression] = STATE(2081),
    [sym_non_null_expression] = STATE(2081),
    [sym_internal_module] = STATE(2081),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2081),
    [sym_await_expression] = STATE(2081),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2081),
    [sym_this] = STATE(2081),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2081),
    [sym_generator_function] = STATE(2081),
    [sym_call_expression] = STATE(2081),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2081),
    [sym_ternary_expression] = STATE(2081),
    [sym_binary_expression] = STATE(2081),
    [sym_template_string] = STATE(2081),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2081),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2081),
    [sym_class] = STATE(2081),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4329),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4329),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4612),
    [sym_true] = ACTIONS(4329),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4329),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1950] = {
    [sym_new_expression] = STATE(2082),
    [sym_augmented_assignment_expression] = STATE(2082),
    [sym_unary_expression] = STATE(2082),
    [sym_update_expression] = STATE(2082),
    [sym_regex] = STATE(2082),
    [sym_meta_property] = STATE(2082),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2082),
    [sym_yield_expression] = STATE(2082),
    [sym_as_expression] = STATE(2082),
    [sym_non_null_expression] = STATE(2082),
    [sym_internal_module] = STATE(2082),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2082),
    [sym_await_expression] = STATE(2082),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2082),
    [sym_this] = STATE(2082),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2082),
    [sym_generator_function] = STATE(2082),
    [sym_call_expression] = STATE(2082),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2082),
    [sym_ternary_expression] = STATE(2082),
    [sym_binary_expression] = STATE(2082),
    [sym_template_string] = STATE(2082),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2082),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2082),
    [sym_class] = STATE(2082),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4614),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4616),
    [sym_true] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4614),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1951] = {
    [sym_new_expression] = STATE(2083),
    [sym_augmented_assignment_expression] = STATE(2083),
    [sym_unary_expression] = STATE(2083),
    [sym_update_expression] = STATE(2083),
    [sym_regex] = STATE(2083),
    [sym_meta_property] = STATE(2083),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2083),
    [sym_yield_expression] = STATE(2083),
    [sym_as_expression] = STATE(2083),
    [sym_non_null_expression] = STATE(2083),
    [sym_internal_module] = STATE(2083),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2083),
    [sym_await_expression] = STATE(2083),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2083),
    [sym_this] = STATE(2083),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2083),
    [sym_generator_function] = STATE(2083),
    [sym_call_expression] = STATE(2083),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2083),
    [sym_ternary_expression] = STATE(2083),
    [sym_binary_expression] = STATE(2083),
    [sym_template_string] = STATE(2083),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2083),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2083),
    [sym_class] = STATE(2083),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4618),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4618),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4620),
    [sym_true] = ACTIONS(4618),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4618),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1952] = {
    [sym_new_expression] = STATE(1972),
    [sym_augmented_assignment_expression] = STATE(1972),
    [sym_unary_expression] = STATE(1972),
    [sym_update_expression] = STATE(1972),
    [sym_regex] = STATE(1972),
    [sym_meta_property] = STATE(1972),
    [sym_call_signature] = STATE(1997),
    [sym_statement_block] = STATE(1295),
    [sym__expression] = STATE(1972),
    [sym_yield_expression] = STATE(1972),
    [sym_as_expression] = STATE(1972),
    [sym_non_null_expression] = STATE(1972),
    [sym_internal_module] = STATE(1972),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1972),
    [sym_await_expression] = STATE(1972),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(1972),
    [sym_this] = STATE(1972),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(1972),
    [sym_generator_function] = STATE(1972),
    [sym_call_expression] = STATE(1972),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(1972),
    [sym_ternary_expression] = STATE(1972),
    [sym_binary_expression] = STATE(1972),
    [sym_template_string] = STATE(1972),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1972),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(1972),
    [sym_class] = STATE(1972),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4622),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4622),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4624),
    [sym_true] = ACTIONS(4622),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4622),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1953] = {
    [sym_new_expression] = STATE(2085),
    [sym_augmented_assignment_expression] = STATE(2085),
    [sym_unary_expression] = STATE(2085),
    [sym_update_expression] = STATE(2085),
    [sym_regex] = STATE(2085),
    [sym_meta_property] = STATE(2085),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2085),
    [sym_yield_expression] = STATE(2085),
    [sym_as_expression] = STATE(2085),
    [sym_non_null_expression] = STATE(2085),
    [sym_internal_module] = STATE(2085),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2085),
    [sym_await_expression] = STATE(2085),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2085),
    [sym_this] = STATE(2085),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2085),
    [sym_generator_function] = STATE(2085),
    [sym_call_expression] = STATE(2085),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2085),
    [sym_ternary_expression] = STATE(2085),
    [sym_binary_expression] = STATE(2085),
    [sym_template_string] = STATE(2085),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2085),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2085),
    [sym_class] = STATE(2085),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4626),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4626),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4628),
    [sym_true] = ACTIONS(4626),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4626),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1954] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1909),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1909),
    [anon_sym_AMP_EQ] = ACTIONS(1909),
    [anon_sym_PLUS_EQ] = ACTIONS(1909),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1913),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(1909),
    [anon_sym_STAR_EQ] = ACTIONS(1909),
    [anon_sym_PIPE_EQ] = ACTIONS(1909),
    [anon_sym_DASH_EQ] = ACTIONS(1909),
    [anon_sym_EQ_GT] = ACTIONS(1915),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1909),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1909),
    [anon_sym_GT_GT_EQ] = ACTIONS(1909),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1922),
  },
  [1955] = {
    [sym_call_signature] = STATE(2011),
    [sym__initializer] = STATE(1215),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4630),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4632),
    [anon_sym_symbol] = ACTIONS(4634),
    [anon_sym_AMP_EQ] = ACTIONS(4632),
    [anon_sym_PLUS_EQ] = ACTIONS(4632),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1913),
    [anon_sym_void] = ACTIONS(4634),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4632),
    [anon_sym_private] = ACTIONS(4634),
    [anon_sym_PIPE_EQ] = ACTIONS(4632),
    [anon_sym_DASH_EQ] = ACTIONS(4632),
    [anon_sym_get] = ACTIONS(4634),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(4632),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(4634),
    [anon_sym_GT_GT_EQ] = ACTIONS(4632),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_set] = ACTIONS(4634),
    [anon_sym_type] = ACTIONS(4634),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(4634),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4632),
    [anon_sym_namespace] = ACTIONS(4634),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4634),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4632),
    [anon_sym_number] = ACTIONS(4634),
    [anon_sym_declare] = ACTIONS(4634),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(4634),
    [anon_sym_STAR_EQ] = ACTIONS(4632),
    [anon_sym_boolean] = ACTIONS(4634),
    [anon_sym_async] = ACTIONS(4634),
    [anon_sym_public] = ACTIONS(4634),
    [anon_sym_EQ_GT] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4632),
    [anon_sym_string] = ACTIONS(4634),
    [anon_sym_function] = ACTIONS(1136),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_implements] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(4634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1956] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(767),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG_EQ] = ACTIONS(1922),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1942),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_implements] = ACTIONS(767),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1924),
    [anon_sym_in] = ACTIONS(1922),
  },
  [1957] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_COMMA] = ACTIONS(811),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(811),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG_EQ] = ACTIONS(1922),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1942),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_implements] = ACTIONS(811),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1924),
    [anon_sym_in] = ACTIONS(1922),
  },
  [1958] = {
    [sym__initializer] = STATE(1211),
    [sym_arguments] = STATE(1353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_PERCENT_EQ] = ACTIONS(1307),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_AMP_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_EQ] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_LT_LT] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1309),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1305),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_CARET_EQ] = ACTIONS(1307),
    [anon_sym_STAR_EQ] = ACTIONS(1307),
    [anon_sym_PIPE_EQ] = ACTIONS(1307),
    [anon_sym_DASH_EQ] = ACTIONS(1307),
    [anon_sym_EQ_GT] = ACTIONS(1915),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_PERCENT] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_LT_LT_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1307),
    [anon_sym_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1309),
    [anon_sym_STAR_STAR] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_implements] = ACTIONS(1305),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [1959] = {
    [sym__initializer] = STATE(1215),
    [sym_arguments] = STATE(1355),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1315),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_instanceof] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_implements] = ACTIONS(1315),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [1960] = {
    [sym_call_signature] = STATE(2011),
    [sym__initializer] = STATE(1215),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_arguments] = STATE(1355),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(4630),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(4634),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(4634),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(4634),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(4634),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_protected] = ACTIONS(4634),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_set] = ACTIONS(4634),
    [anon_sym_type] = ACTIONS(4634),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_import] = ACTIONS(4634),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_namespace] = ACTIONS(4634),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_module] = ACTIONS(4634),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(4634),
    [anon_sym_declare] = ACTIONS(4634),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(1315),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_any] = ACTIONS(4634),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(4634),
    [anon_sym_async] = ACTIONS(4634),
    [anon_sym_public] = ACTIONS(4634),
    [anon_sym_EQ_GT] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(4634),
    [anon_sym_function] = ACTIONS(1136),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_implements] = ACTIONS(1319),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_export] = ACTIONS(4634),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [1961] = {
    [sym_nested_identifier] = STATE(1592),
    [sym__module] = STATE(1483),
    [sym_string] = STATE(1594),
    [sym__initializer] = STATE(1215),
    [sym_arguments] = STATE(1355),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1315),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_implements] = ACTIONS(1319),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [1962] = {
    [sym_new_expression] = STATE(2086),
    [sym_augmented_assignment_expression] = STATE(2086),
    [sym_unary_expression] = STATE(2086),
    [sym_update_expression] = STATE(2086),
    [sym_regex] = STATE(2086),
    [sym_meta_property] = STATE(2086),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2086),
    [sym_yield_expression] = STATE(2086),
    [sym_as_expression] = STATE(2086),
    [sym_non_null_expression] = STATE(2086),
    [sym_internal_module] = STATE(2086),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2086),
    [sym_await_expression] = STATE(2086),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2086),
    [sym_this] = STATE(2086),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2086),
    [sym_generator_function] = STATE(2086),
    [sym_call_expression] = STATE(2086),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2086),
    [sym_ternary_expression] = STATE(2086),
    [sym_binary_expression] = STATE(2086),
    [sym_template_string] = STATE(2086),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2086),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2086),
    [sym_class] = STATE(2086),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4636),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4636),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4638),
    [sym_true] = ACTIONS(4636),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4636),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1963] = {
    [sym_new_expression] = STATE(2087),
    [sym_augmented_assignment_expression] = STATE(2087),
    [sym_unary_expression] = STATE(2087),
    [sym_update_expression] = STATE(2087),
    [sym_regex] = STATE(2087),
    [sym_meta_property] = STATE(2087),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2087),
    [sym_yield_expression] = STATE(2087),
    [sym_as_expression] = STATE(2087),
    [sym_non_null_expression] = STATE(2087),
    [sym_internal_module] = STATE(2087),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2087),
    [sym_await_expression] = STATE(2087),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2087),
    [sym_this] = STATE(2087),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2087),
    [sym_generator_function] = STATE(2087),
    [sym_call_expression] = STATE(2087),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2087),
    [sym_ternary_expression] = STATE(2087),
    [sym_binary_expression] = STATE(2087),
    [sym_template_string] = STATE(2087),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2087),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2087),
    [sym_class] = STATE(2087),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4640),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4640),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4642),
    [sym_true] = ACTIONS(4640),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4640),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1964] = {
    [sym_new_expression] = STATE(2088),
    [sym_augmented_assignment_expression] = STATE(2088),
    [sym_unary_expression] = STATE(2088),
    [sym_update_expression] = STATE(2088),
    [sym_regex] = STATE(2088),
    [sym_meta_property] = STATE(2088),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2088),
    [sym_yield_expression] = STATE(2088),
    [sym_as_expression] = STATE(2088),
    [sym_non_null_expression] = STATE(2088),
    [sym_internal_module] = STATE(2088),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2088),
    [sym_await_expression] = STATE(2088),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2088),
    [sym_this] = STATE(2088),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2088),
    [sym_generator_function] = STATE(2088),
    [sym_call_expression] = STATE(2088),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2088),
    [sym_ternary_expression] = STATE(2088),
    [sym_binary_expression] = STATE(2088),
    [sym_template_string] = STATE(2088),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2088),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2088),
    [sym_class] = STATE(2088),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4644),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4644),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4646),
    [sym_true] = ACTIONS(4644),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4644),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1965] = {
    [sym_new_expression] = STATE(2089),
    [sym_augmented_assignment_expression] = STATE(2089),
    [sym_unary_expression] = STATE(2089),
    [sym_update_expression] = STATE(2089),
    [sym_regex] = STATE(2089),
    [sym_meta_property] = STATE(2089),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2089),
    [sym_yield_expression] = STATE(2089),
    [sym_as_expression] = STATE(2089),
    [sym_non_null_expression] = STATE(2089),
    [sym_internal_module] = STATE(2089),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2089),
    [sym_await_expression] = STATE(2089),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2089),
    [sym_this] = STATE(2089),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2089),
    [sym_generator_function] = STATE(2089),
    [sym_call_expression] = STATE(2089),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2089),
    [sym_ternary_expression] = STATE(2089),
    [sym_binary_expression] = STATE(2089),
    [sym_template_string] = STATE(2089),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2089),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2089),
    [sym_class] = STATE(2089),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4648),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4648),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4650),
    [sym_true] = ACTIONS(4648),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4648),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1966] = {
    [sym_new_expression] = STATE(1969),
    [sym_constructor_type] = STATE(232),
    [sym_augmented_assignment_expression] = STATE(1969),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(1969),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(1969),
    [sym_call_signature] = STATE(2379),
    [sym_yield_expression] = STATE(1969),
    [sym_as_expression] = STATE(1969),
    [sym_internal_module] = STATE(1969),
    [sym_arrow_function] = STATE(1969),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(2521),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1632),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(2522),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(1969),
    [sym_subscript_expression] = STATE(2521),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(1969),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(1969),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(232),
    [sym__type] = STATE(232),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(1969),
    [sym_meta_property] = STATE(1969),
    [sym_function_type] = STATE(232),
    [sym__expression] = STATE(1969),
    [sym_non_null_expression] = STATE(1969),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(1969),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(1969),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(1969),
    [sym_call_expression] = STATE(1969),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(1969),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(1969),
    [sym_type_arguments] = STATE(2523),
    [sym_union_type] = STATE(232),
    [sym_parenthesized_expression] = STATE(1969),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1969),
    [sym_class] = STATE(1969),
    [sym_identifier] = ACTIONS(4246),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(4248),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(4250),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(4252),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(4254),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(4256),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(4256),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(4248),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(4258),
    [anon_sym_LBRACE] = ACTIONS(4260),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [sym_null] = ACTIONS(4168),
    [anon_sym_any] = ACTIONS(4248),
    [anon_sym_boolean] = ACTIONS(4248),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4262),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4248),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4170),
    [anon_sym_PLUS] = ACTIONS(4250),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [1967] = {
    [sym_new_expression] = STATE(2092),
    [sym_augmented_assignment_expression] = STATE(2092),
    [sym_unary_expression] = STATE(2092),
    [sym_update_expression] = STATE(2092),
    [sym_regex] = STATE(2092),
    [sym_meta_property] = STATE(2092),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2092),
    [sym_yield_expression] = STATE(2092),
    [sym_as_expression] = STATE(2092),
    [sym_non_null_expression] = STATE(2092),
    [sym_internal_module] = STATE(2092),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2092),
    [sym_await_expression] = STATE(2092),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2092),
    [sym_this] = STATE(2092),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2092),
    [sym_generator_function] = STATE(2092),
    [sym_call_expression] = STATE(2092),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2092),
    [sym_ternary_expression] = STATE(2092),
    [sym_binary_expression] = STATE(2092),
    [sym_template_string] = STATE(2092),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2092),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2092),
    [sym_class] = STATE(2092),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4652),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4652),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4654),
    [sym_true] = ACTIONS(4652),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4652),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1968] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1679),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG_EQ] = ACTIONS(1922),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1942),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_implements] = ACTIONS(1679),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1924),
    [anon_sym_in] = ACTIONS(1922),
  },
  [1969] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [1970] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(1687),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1687),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_in] = ACTIONS(1339),
  },
  [1971] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(1689),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(1689),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1689),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_in] = ACTIONS(1339),
  },
  [1972] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_COMMA] = ACTIONS(1713),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1713),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG_EQ] = ACTIONS(1922),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1942),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_implements] = ACTIONS(1713),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1924),
    [anon_sym_in] = ACTIONS(1922),
  },
  [1973] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(1717),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(1717),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1717),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_in] = ACTIONS(1339),
  },
  [1974] = {
    [sym_new_expression] = STATE(1987),
    [sym_augmented_assignment_expression] = STATE(1987),
    [sym_unary_expression] = STATE(1987),
    [sym_update_expression] = STATE(1987),
    [sym_regex] = STATE(1987),
    [sym_meta_property] = STATE(1987),
    [sym_call_signature] = STATE(1997),
    [sym_statement_block] = STATE(1395),
    [sym__expression] = STATE(1987),
    [sym_yield_expression] = STATE(1987),
    [sym_as_expression] = STATE(1987),
    [sym_non_null_expression] = STATE(1987),
    [sym_internal_module] = STATE(1987),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1987),
    [sym_await_expression] = STATE(1987),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(1987),
    [sym_this] = STATE(1987),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(1987),
    [sym_generator_function] = STATE(1987),
    [sym_call_expression] = STATE(1987),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(1987),
    [sym_ternary_expression] = STATE(1987),
    [sym_binary_expression] = STATE(1987),
    [sym_template_string] = STATE(1987),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1987),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(1987),
    [sym_class] = STATE(1987),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4656),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4656),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4658),
    [sym_true] = ACTIONS(4656),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4656),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1975] = {
    [sym_new_expression] = STATE(1988),
    [sym_augmented_assignment_expression] = STATE(1988),
    [sym_unary_expression] = STATE(1988),
    [sym_update_expression] = STATE(1988),
    [sym_regex] = STATE(1988),
    [sym_meta_property] = STATE(1988),
    [sym_call_signature] = STATE(1997),
    [sym_statement_block] = STATE(1397),
    [sym__expression] = STATE(1988),
    [sym_yield_expression] = STATE(1988),
    [sym_as_expression] = STATE(1988),
    [sym_non_null_expression] = STATE(1988),
    [sym_internal_module] = STATE(1988),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1988),
    [sym_await_expression] = STATE(1988),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(1988),
    [sym_this] = STATE(1988),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(1988),
    [sym_generator_function] = STATE(1988),
    [sym_call_expression] = STATE(1988),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(1988),
    [sym_ternary_expression] = STATE(1988),
    [sym_binary_expression] = STATE(1988),
    [sym_template_string] = STATE(1988),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1988),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(1988),
    [sym_class] = STATE(1988),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4660),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4660),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4662),
    [sym_true] = ACTIONS(4660),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4660),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1976] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_in] = ACTIONS(1339),
  },
  [1977] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_GT_GT_GT] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(4664),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [1978] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(4664),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [1979] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_in] = ACTIONS(1339),
  },
  [1980] = {
    [sym__initializer] = STATE(1211),
    [sym_type_arguments] = STATE(497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1909),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1909),
    [anon_sym_AMP_EQ] = ACTIONS(1909),
    [anon_sym_PLUS_EQ] = ACTIONS(1909),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2509),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_is] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(1913),
    [anon_sym_CARET_EQ] = ACTIONS(1909),
    [anon_sym_STAR_EQ] = ACTIONS(1909),
    [anon_sym_PIPE_EQ] = ACTIONS(1909),
    [anon_sym_DASH_EQ] = ACTIONS(1909),
    [anon_sym_EQ_GT] = ACTIONS(1915),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1909),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1909),
    [anon_sym_GT_GT_EQ] = ACTIONS(1909),
    [anon_sym_DOT] = ACTIONS(4073),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(4667),
  },
  [1981] = {
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4632),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4632),
    [anon_sym_AMP_EQ] = ACTIONS(4632),
    [anon_sym_PLUS_EQ] = ACTIONS(4632),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1913),
    [anon_sym_GT] = ACTIONS(2526),
    [anon_sym_CARET_EQ] = ACTIONS(4632),
    [anon_sym_STAR_EQ] = ACTIONS(4632),
    [anon_sym_PIPE_EQ] = ACTIONS(4632),
    [anon_sym_DASH_EQ] = ACTIONS(4632),
    [anon_sym_EQ_GT] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4632),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4632),
    [anon_sym_GT_GT_EQ] = ACTIONS(4632),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_implements] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1982] = {
    [sym_new_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_non_null_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_identifier] = STATE(516),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1220),
    [sym_this] = STATE(1220),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1220),
    [sym_generator_function] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1220),
    [sym_class] = STATE(1220),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(4669),
    [sym_false] = ACTIONS(1124),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(1124),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(1130),
    [sym_true] = ACTIONS(1124),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [1983] = {
    [sym_new_expression] = STATE(1218),
    [sym_augmented_assignment_expression] = STATE(1218),
    [sym_unary_expression] = STATE(1218),
    [sym_update_expression] = STATE(1218),
    [sym_regex] = STATE(1218),
    [sym_meta_property] = STATE(1218),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1218),
    [sym_yield_expression] = STATE(1218),
    [sym_as_expression] = STATE(1218),
    [sym_non_null_expression] = STATE(1218),
    [sym_internal_module] = STATE(1218),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1218),
    [sym_await_expression] = STATE(1218),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1218),
    [sym_this] = STATE(1218),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1218),
    [sym_generator_function] = STATE(1218),
    [sym_call_expression] = STATE(1218),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1218),
    [sym_ternary_expression] = STATE(1218),
    [sym_binary_expression] = STATE(1218),
    [sym_template_string] = STATE(1218),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1218),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1218),
    [sym_class] = STATE(1218),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(266),
    [sym_false] = ACTIONS(3894),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3894),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4671),
    [sym_true] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3894),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [1984] = {
    [sym_new_expression] = STATE(2415),
    [sym_augmented_assignment_expression] = STATE(2415),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(2415),
    [sym_update_expression] = STATE(2415),
    [sym_regex] = STATE(2415),
    [sym_meta_property] = STATE(2415),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2415),
    [sym_yield_expression] = STATE(2415),
    [sym_as_expression] = STATE(2415),
    [sym_non_null_expression] = STATE(2415),
    [sym_internal_module] = STATE(2415),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2415),
    [sym_await_expression] = STATE(2415),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2415),
    [sym_this] = STATE(2415),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2415),
    [sym_generator_function] = STATE(2415),
    [sym_call_expression] = STATE(2415),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2415),
    [sym_ternary_expression] = STATE(2415),
    [sym_binary_expression] = STATE(2415),
    [sym_template_string] = STATE(2415),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2415),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2415),
    [sym_class] = STATE(2415),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4606),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(4632),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_AMP_EQ] = ACTIONS(4632),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4632),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1913),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(4632),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_PIPE_EQ] = ACTIONS(4632),
    [anon_sym_DASH_EQ] = ACTIONS(4632),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(4632),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(903),
    [sym_true] = ACTIONS(4673),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_GT_GT_EQ] = ACTIONS(4632),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4632),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(4675),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(4673),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4632),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4673),
    [anon_sym_GT] = ACTIONS(2526),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_STAR_EQ] = ACTIONS(4632),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_EQ_GT] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(4677),
    [anon_sym_SLASH] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4632),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4673),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_implements] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [1985] = {
    [sym_new_expression] = STATE(1261),
    [sym_augmented_assignment_expression] = STATE(1800),
    [sym_unary_expression] = STATE(1800),
    [sym_update_expression] = STATE(1800),
    [sym_regex] = STATE(1261),
    [sym_meta_property] = STATE(1261),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1800),
    [sym_yield_expression] = STATE(1800),
    [sym_as_expression] = STATE(1800),
    [sym_non_null_expression] = STATE(1800),
    [sym_internal_module] = STATE(1800),
    [sym_function] = STATE(1266),
    [sym_arrow_function] = STATE(1261),
    [sym_await_expression] = STATE(1800),
    [sym_member_expression] = STATE(1267),
    [sym_string] = STATE(1261),
    [sym_this] = STATE(1261),
    [sym_type_parameters] = STATE(1905),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1268),
    [sym_anonymous_class] = STATE(1261),
    [sym_generator_function] = STATE(1261),
    [sym_call_expression] = STATE(1800),
    [sym_subscript_expression] = STATE(1267),
    [sym_assignment_expression] = STATE(1800),
    [sym_ternary_expression] = STATE(1800),
    [sym_binary_expression] = STATE(1800),
    [sym_template_string] = STATE(1261),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(1429),
    [sym_parenthesized_expression] = STATE(1261),
    [sym_array] = STATE(1269),
    [sym_type_assertion] = STATE(1800),
    [sym_class] = STATE(1261),
    [sym_identifier] = ACTIONS(3914),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(3916),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(3918),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(3916),
    [anon_sym_get] = ACTIONS(3916),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(3920),
    [anon_sym_protected] = ACTIONS(3916),
    [anon_sym_DOT] = ACTIONS(3922),
    [anon_sym_set] = ACTIONS(3916),
    [anon_sym_type] = ACTIONS(3916),
    [anon_sym_import] = ACTIONS(3916),
    [anon_sym_namespace] = ACTIONS(3924),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3920),
    [anon_sym_module] = ACTIONS(3916),
    [anon_sym_number] = ACTIONS(3916),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(3916),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3920),
    [anon_sym_any] = ACTIONS(3916),
    [anon_sym_boolean] = ACTIONS(3916),
    [anon_sym_async] = ACTIONS(3926),
    [anon_sym_public] = ACTIONS(3916),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3928),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(3916),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3920),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(3916),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [1986] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_GT_GT_GT] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(4664),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_SLASH] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [1987] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(2936),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG_EQ] = ACTIONS(1922),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1942),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_implements] = ACTIONS(2936),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1924),
    [anon_sym_in] = ACTIONS(1922),
  },
  [1988] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(2940),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG_EQ] = ACTIONS(1922),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1942),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_implements] = ACTIONS(2940),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1924),
    [anon_sym_in] = ACTIONS(1922),
  },
  [1989] = {
    [sym_new_expression] = STATE(2095),
    [sym_augmented_assignment_expression] = STATE(2095),
    [sym_unary_expression] = STATE(2095),
    [sym_update_expression] = STATE(2095),
    [sym_regex] = STATE(2095),
    [sym_meta_property] = STATE(2095),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2095),
    [sym_yield_expression] = STATE(2095),
    [sym_as_expression] = STATE(2095),
    [sym_non_null_expression] = STATE(2095),
    [sym_internal_module] = STATE(2095),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2095),
    [sym_await_expression] = STATE(2095),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2095),
    [sym_this] = STATE(2095),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2095),
    [sym_generator_function] = STATE(2095),
    [sym_call_expression] = STATE(2095),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2095),
    [sym_ternary_expression] = STATE(2095),
    [sym_binary_expression] = STATE(2095),
    [sym_template_string] = STATE(2095),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2095),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2095),
    [sym_class] = STATE(2095),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4679),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4679),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4681),
    [sym_true] = ACTIONS(4679),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4679),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [1990] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1909),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1909),
    [anon_sym_AMP_EQ] = ACTIONS(1909),
    [anon_sym_PLUS_EQ] = ACTIONS(1909),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1913),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_CARET_EQ] = ACTIONS(1909),
    [anon_sym_STAR_EQ] = ACTIONS(1909),
    [anon_sym_PIPE_EQ] = ACTIONS(1909),
    [anon_sym_DASH_EQ] = ACTIONS(1909),
    [anon_sym_EQ_GT] = ACTIONS(1915),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1909),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1909),
    [anon_sym_GT_GT_EQ] = ACTIONS(1909),
    [anon_sym_DOT] = ACTIONS(4097),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1922),
  },
  [1991] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(3569),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(3569),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3569),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_in] = ACTIONS(1339),
  },
  [1992] = {
    [sym_new_expression] = STATE(1290),
    [sym_constructor_type] = STATE(754),
    [sym_augmented_assignment_expression] = STATE(1290),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(1290),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(1290),
    [sym_call_signature] = STATE(1740),
    [sym_yield_expression] = STATE(1290),
    [sym_as_expression] = STATE(1290),
    [sym_internal_module] = STATE(1290),
    [sym_arrow_function] = STATE(1290),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(1201),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1535),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(1202),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(1290),
    [sym_subscript_expression] = STATE(1201),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(1290),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(1290),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(754),
    [sym__type] = STATE(754),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(1290),
    [sym_meta_property] = STATE(1290),
    [sym_function_type] = STATE(754),
    [sym__expression] = STATE(1290),
    [sym_non_null_expression] = STATE(1290),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(1290),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(1290),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(1290),
    [sym_call_expression] = STATE(1290),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(1290),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(1290),
    [sym_type_arguments] = STATE(1205),
    [sym_union_type] = STATE(754),
    [sym_parenthesized_expression] = STATE(1290),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1290),
    [sym_class] = STATE(1290),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(2325),
    [sym_false] = ACTIONS(2335),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(2327),
    [anon_sym_number] = ACTIONS(2327),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(2337),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(2329),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(2331),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [sym_null] = ACTIONS(3940),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(2327),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(2327),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2333),
    [sym_number] = ACTIONS(2347),
    [sym_true] = ACTIONS(2335),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(2327),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3940),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(2329),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [1993] = {
    [aux_sym_string_repeat1] = STATE(2000),
    [sym_escape_sequence] = ACTIONS(4683),
    [aux_sym_string_token1] = ACTIONS(4683),
    [anon_sym_DQUOTE] = ACTIONS(4685),
    [sym_comment] = ACTIONS(256),
  },
  [1994] = {
    [sym_new_expression] = STATE(2001),
    [sym_augmented_assignment_expression] = STATE(2001),
    [sym_unary_expression] = STATE(2001),
    [sym_update_expression] = STATE(2001),
    [sym_regex] = STATE(2001),
    [sym_meta_property] = STATE(2001),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(2001),
    [sym_yield_expression] = STATE(2001),
    [sym_as_expression] = STATE(2001),
    [sym_non_null_expression] = STATE(2001),
    [sym_internal_module] = STATE(2001),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2001),
    [sym_await_expression] = STATE(2001),
    [sym_member_expression] = STATE(1201),
    [sym_spread_element] = STATE(2002),
    [sym_string] = STATE(2001),
    [sym_this] = STATE(2001),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [aux_sym_array_repeat1] = STATE(2003),
    [sym_anonymous_class] = STATE(2001),
    [sym_generator_function] = STATE(2001),
    [sym_call_expression] = STATE(2001),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(2001),
    [sym_ternary_expression] = STATE(2001),
    [sym_binary_expression] = STATE(2001),
    [sym_template_string] = STATE(2001),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2001),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(2001),
    [sym_class] = STATE(2001),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(266),
    [sym_false] = ACTIONS(4687),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_RBRACK] = ACTIONS(4689),
    [sym_null] = ACTIONS(4687),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4691),
    [sym_true] = ACTIONS(4687),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4687),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [1995] = {
    [sym_new_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_do_statement] = STATE(1777),
    [sym_internal_module] = STATE(53),
    [sym_accessibility_modifier] = STATE(180),
    [sym_import_statement] = STATE(1777),
    [sym_member_expression] = STATE(54),
    [sym_switch_statement] = STATE(1777),
    [sym_string] = STATE(178),
    [sym_type_parameters] = STATE(55),
    [sym_throw_statement] = STATE(1777),
    [aux_sym_program_repeat1] = STATE(1777),
    [sym_object] = STATE(184),
    [sym_generator_function] = STATE(53),
    [sym_ternary_expression] = STATE(59),
    [sym_for_of_statement] = STATE(1777),
    [sym_decorator] = STATE(186),
    [sym_computed_property_name] = STATE(183),
    [sym_abstract_class] = STATE(1777),
    [sym_statement_block] = STATE(1777),
    [sym_update_expression] = STATE(59),
    [sym_debugger_statement] = STATE(1777),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_function] = STATE(60),
    [sym_for_statement] = STATE(1777),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(1777),
    [sym_pair] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(186),
    [sym_assignment_pattern] = STATE(181),
    [sym_export_statement] = STATE(1777),
    [sym_call_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1777),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_break_statement] = STATE(1777),
    [sym_parenthesized_expression] = STATE(59),
    [sym_module] = STATE(1777),
    [sym_class] = STATE(53),
    [sym_type_alias_declaration] = STATE(1777),
    [sym__declaration] = STATE(1777),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_if_statement] = STATE(1777),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_return_statement] = STATE(1777),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_arrow_function] = STATE(59),
    [sym_expression_statement] = STATE(1777),
    [sym_spread_element] = STATE(181),
    [sym_try_statement] = STATE(1777),
    [sym__property_name] = STATE(183),
    [aux_sym_object_repeat1] = STATE(185),
    [sym_ambient_declaration] = STATE(1777),
    [sym_subscript_expression] = STATE(54),
    [sym_template_string] = STATE(59),
    [sym_continue_statement] = STATE(1777),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1777),
    [sym_interface_declaration] = STATE(1777),
    [sym_while_statement] = STATE(1777),
    [sym_meta_property] = STATE(59),
    [sym_method_definition] = STATE(181),
    [sym_enum_declaration] = STATE(1777),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1777),
    [sym_sequence_expression] = STATE(62),
    [sym_with_statement] = STATE(1777),
    [sym_import_alias] = STATE(1777),
    [sym_anonymous_class] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_for_in_statement] = STATE(1777),
    [sym_labeled_statement] = STATE(1777),
    [sym_array] = STATE(187),
    [sym_type_assertion] = STATE(59),
    [sym_identifier] = ACTIONS(368),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(370),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_void] = ACTIONS(378),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(380),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_get] = ACTIONS(384),
    [anon_sym_RBRACE] = ACTIONS(4371),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(380),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(384),
    [anon_sym_type] = ACTIONS(388),
    [anon_sym_import] = ACTIONS(390),
    [anon_sym_namespace] = ACTIONS(392),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(396),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(398),
    [anon_sym_number] = ACTIONS(370),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(400),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(370),
    [anon_sym_boolean] = ACTIONS(370),
    [anon_sym_async] = ACTIONS(402),
    [anon_sym_public] = ACTIONS(380),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(404),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(370),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(406),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [1996] = {
    [aux_sym_string_repeat2] = STATE(2013),
    [sym_escape_sequence] = ACTIONS(4693),
    [aux_sym_string_token2] = ACTIONS(4693),
    [sym_comment] = ACTIONS(256),
    [anon_sym_SQUOTE] = ACTIONS(4685),
  },
  [1997] = {
    [anon_sym_EQ_GT] = ACTIONS(1915),
    [sym_comment] = ACTIONS(3),
  },
  [1998] = {
    [sym_pair] = STATE(2006),
    [sym__property_name] = STATE(183),
    [sym_object] = STATE(310),
    [sym_decorator] = STATE(2397),
    [sym_accessibility_modifier] = STATE(180),
    [aux_sym_export_statement_repeat1] = STATE(2397),
    [sym_computed_property_name] = STATE(183),
    [aux_sym_object_repeat1] = STATE(2008),
    [sym_array] = STATE(312),
    [sym_assignment_pattern] = STATE(2006),
    [sym_spread_element] = STATE(2006),
    [sym_string] = STATE(183),
    [sym_method_definition] = STATE(2006),
    [sym_identifier] = ACTIONS(4695),
    [anon_sym_LBRACK] = ACTIONS(680),
    [anon_sym_module] = ACTIONS(4697),
    [anon_sym_symbol] = ACTIONS(4697),
    [anon_sym_number] = ACTIONS(4697),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(4697),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_void] = ACTIONS(4697),
    [anon_sym_any] = ACTIONS(4697),
    [anon_sym_private] = ACTIONS(4699),
    [anon_sym_boolean] = ACTIONS(4697),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_async] = ACTIONS(4701),
    [anon_sym_get] = ACTIONS(4703),
    [anon_sym_RBRACE] = ACTIONS(4705),
    [anon_sym_public] = ACTIONS(4699),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [sym_number] = ACTIONS(692),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4699),
    [anon_sym_string] = ACTIONS(4697),
    [anon_sym_set] = ACTIONS(4703),
    [anon_sym_type] = ACTIONS(4697),
    [anon_sym_import] = ACTIONS(4697),
    [anon_sym_export] = ACTIONS(4697),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_namespace] = ACTIONS(4697),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [1999] = {
    [sym_new_expression] = STATE(2028),
    [sym_augmented_assignment_expression] = STATE(2028),
    [sym_unary_expression] = STATE(2028),
    [sym_regex] = STATE(2028),
    [sym_call_signature] = STATE(1740),
    [sym_yield_expression] = STATE(2028),
    [sym_as_expression] = STATE(2028),
    [sym_internal_module] = STATE(2028),
    [sym_arrow_function] = STATE(2028),
    [sym_member_expression] = STATE(1201),
    [sym_spread_element] = STATE(2029),
    [sym_string] = STATE(2028),
    [sym_type_parameters] = STATE(55),
    [sym_object] = STATE(1202),
    [sym_generator_function] = STATE(2028),
    [sym_subscript_expression] = STATE(1201),
    [sym_ternary_expression] = STATE(2028),
    [sym_template_string] = STATE(2028),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_update_expression] = STATE(2028),
    [sym_meta_property] = STATE(2028),
    [sym__expression] = STATE(2028),
    [sym_non_null_expression] = STATE(2028),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(2028),
    [sym_this] = STATE(2028),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [aux_sym_array_repeat1] = STATE(2030),
    [sym_anonymous_class] = STATE(2028),
    [sym_call_expression] = STATE(2028),
    [sym_assignment_expression] = STATE(2028),
    [sym_binary_expression] = STATE(2028),
    [sym_type_arguments] = STATE(1205),
    [sym_parenthesized_expression] = STATE(2028),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(2028),
    [sym_class] = STATE(2028),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(4707),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(4707),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4707),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(4709),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4711),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4707),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [2000] = {
    [aux_sym_string_repeat1] = STATE(362),
    [sym_escape_sequence] = ACTIONS(817),
    [aux_sym_string_token1] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(4713),
    [sym_comment] = ACTIONS(256),
  },
  [2001] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [aux_sym_array_repeat1] = STATE(2032),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACK] = ACTIONS(4715),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2002] = {
    [aux_sym_array_repeat1] = STATE(2032),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_RBRACK] = ACTIONS(4715),
    [sym_comment] = ACTIONS(3),
  },
  [2003] = {
    [aux_sym_array_repeat1] = STATE(375),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_RBRACK] = ACTIONS(4715),
    [sym_comment] = ACTIONS(3),
  },
  [2004] = {
    [sym_class_heritage] = STATE(2033),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_type_parameters] = STATE(2034),
    [sym_class_body] = STATE(1507),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [2005] = {
    [sym_public_field_definition] = STATE(394),
    [sym__property_name] = STATE(395),
    [sym_method_signature] = STATE(394),
    [sym_abstract_method_signature] = STATE(394),
    [aux_sym_class_body_repeat1] = STATE(2035),
    [sym_index_signature] = STATE(394),
    [sym_method_definition] = STATE(398),
    [sym_decorator] = STATE(2035),
    [sym_accessibility_modifier] = STATE(396),
    [sym_computed_property_name] = STATE(395),
    [sym_string] = STATE(395),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(923),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(931),
    [anon_sym_RBRACE] = ACTIONS(4717),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [sym_number] = ACTIONS(937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_abstract] = ACTIONS(939),
    [anon_sym_set] = ACTIONS(931),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [sym_readonly] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2006] = {
    [aux_sym_object_repeat1] = STATE(2038),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_RBRACE] = ACTIONS(4719),
    [sym_comment] = ACTIONS(3),
  },
  [2007] = {
    [sym_type_alias_declaration] = STATE(266),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(266),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(266),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(266),
    [sym_return_statement] = STATE(266),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(266),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(266),
    [sym_switch_statement] = STATE(266),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(266),
    [sym_throw_statement] = STATE(266),
    [aux_sym_program_repeat1] = STATE(266),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(266),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(266),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(266),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(266),
    [sym_abstract_class] = STATE(266),
    [sym_interface_declaration] = STATE(266),
    [sym_statement_block] = STATE(266),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(266),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(266),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(266),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(266),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(266),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(266),
    [sym_empty_statement] = STATE(266),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(266),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(266),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(266),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(266),
    [sym_break_statement] = STATE(266),
    [sym_labeled_statement] = STATE(266),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(266),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4721),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [2008] = {
    [aux_sym_object_repeat1] = STATE(434),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_RBRACE] = ACTIONS(4719),
    [sym_comment] = ACTIONS(3),
  },
  [2009] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_type_annotation] = STATE(2040),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(4723),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2010] = {
    [anon_sym_RPAREN] = ACTIONS(4723),
    [sym_comment] = ACTIONS(3),
  },
  [2011] = {
    [anon_sym_EQ_GT] = ACTIONS(4725),
    [sym_comment] = ACTIONS(3),
  },
  [2012] = {
    [anon_sym_EQ_GT] = ACTIONS(4727),
    [sym_comment] = ACTIONS(3),
  },
  [2013] = {
    [aux_sym_string_repeat2] = STATE(484),
    [sym_escape_sequence] = ACTIONS(1184),
    [aux_sym_string_token2] = ACTIONS(1184),
    [sym_comment] = ACTIONS(256),
    [anon_sym_SQUOTE] = ACTIONS(4713),
  },
  [2014] = {
    [sym_type_alias_declaration] = STATE(1777),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1777),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1777),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1777),
    [sym_return_statement] = STATE(1777),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1777),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1777),
    [sym_switch_statement] = STATE(1777),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1777),
    [sym_throw_statement] = STATE(1777),
    [aux_sym_program_repeat1] = STATE(1777),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1777),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1777),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1777),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1777),
    [sym_abstract_class] = STATE(1777),
    [sym_interface_declaration] = STATE(1777),
    [sym_statement_block] = STATE(1777),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1777),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1777),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1777),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1777),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1777),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1777),
    [sym_empty_statement] = STATE(1777),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1777),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1777),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1777),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1777),
    [sym_break_statement] = STATE(1777),
    [sym_labeled_statement] = STATE(1777),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1777),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4729),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [2015] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(2043),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(2043),
    [sym_call_signature] = STATE(2043),
    [sym_construct_signature] = STATE(2043),
    [sym_index_signature] = STATE(2043),
    [sym_export_statement] = STATE(2043),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(4055),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_COMMA] = ACTIONS(4055),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(4061),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4061),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2016] = {
    [sym_nested_identifier] = STATE(1520),
    [sym_identifier] = ACTIONS(4731),
    [sym_comment] = ACTIONS(3),
  },
  [2017] = {
    [sym_number] = ACTIONS(4733),
    [sym_comment] = ACTIONS(3),
  },
  [2018] = {
    [sym_nested_type_identifier] = STATE(1523),
    [sym_nested_identifier] = STATE(2393),
    [sym_identifier] = ACTIONS(4735),
    [sym_comment] = ACTIONS(3),
  },
  [2019] = {
    [aux_sym_implements_clause_repeat1] = STATE(2049),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_GT] = ACTIONS(4737),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(4739),
    [sym_comment] = ACTIONS(3),
  },
  [2020] = {
    [anon_sym_EQ_GT] = ACTIONS(4741),
    [sym_comment] = ACTIONS(3),
  },
  [2021] = {
    [anon_sym_SLASH2] = ACTIONS(4743),
    [sym_comment] = ACTIONS(3),
  },
  [2022] = {
    [sym_statement_block] = STATE(1533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4586),
  },
  [2023] = {
    [sym__initializer] = STATE(589),
    [aux_sym_object_repeat1] = STATE(2036),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_RBRACE] = ACTIONS(4745),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [2024] = {
    [aux_sym_object_repeat1] = STATE(2036),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_RBRACE] = ACTIONS(4745),
    [anon_sym_LT] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_COMMA] = ACTIONS(374),
    [sym_comment] = ACTIONS(3),
  },
  [2025] = {
    [aux_sym_object_repeat1] = STATE(2036),
    [anon_sym_LBRACK] = ACTIONS(1014),
    [sym_identifier] = ACTIONS(1012),
    [anon_sym_module] = ACTIONS(1012),
    [anon_sym_symbol] = ACTIONS(1012),
    [anon_sym_number] = ACTIONS(1012),
    [anon_sym_declare] = ACTIONS(1012),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(1014),
    [anon_sym_void] = ACTIONS(1012),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1012),
    [anon_sym_private] = ACTIONS(1012),
    [anon_sym_boolean] = ACTIONS(1012),
    [anon_sym_async] = ACTIONS(1012),
    [anon_sym_public] = ACTIONS(1012),
    [anon_sym_get] = ACTIONS(1012),
    [anon_sym_static] = ACTIONS(1012),
    [anon_sym_RBRACE] = ACTIONS(4745),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(1014),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1012),
    [anon_sym_string] = ACTIONS(1012),
    [anon_sym_set] = ACTIONS(1012),
    [anon_sym_type] = ACTIONS(1012),
    [anon_sym_import] = ACTIONS(1012),
    [anon_sym_export] = ACTIONS(1012),
    [anon_sym_namespace] = ACTIONS(1012),
    [sym_readonly] = ACTIONS(1012),
    [anon_sym_DQUOTE] = ACTIONS(1014),
  },
  [2026] = {
    [sym__property_name] = STATE(417),
    [aux_sym_object_repeat1] = STATE(2036),
    [sym_string] = STATE(417),
    [sym_computed_property_name] = STATE(417),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(1020),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1016),
    [anon_sym_RBRACE] = ACTIONS(4745),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1016),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2027] = {
    [sym__property_name] = STATE(417),
    [aux_sym_object_repeat1] = STATE(2036),
    [sym_string] = STATE(417),
    [sym_computed_property_name] = STATE(417),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(4745),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2028] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [aux_sym_array_repeat1] = STATE(2057),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(4747),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2029] = {
    [aux_sym_array_repeat1] = STATE(2057),
    [anon_sym_RPAREN] = ACTIONS(4747),
    [anon_sym_COMMA] = ACTIONS(272),
    [sym_comment] = ACTIONS(3),
  },
  [2030] = {
    [aux_sym_array_repeat1] = STATE(375),
    [anon_sym_RPAREN] = ACTIONS(4747),
    [anon_sym_COMMA] = ACTIONS(272),
    [sym_comment] = ACTIONS(3),
  },
  [2031] = {
    [sym_identifier] = ACTIONS(4749),
    [sym_comment] = ACTIONS(3),
  },
  [2032] = {
    [aux_sym_array_repeat1] = STATE(375),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_RBRACK] = ACTIONS(4751),
    [sym_comment] = ACTIONS(3),
  },
  [2033] = {
    [sym_class_body] = STATE(1542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [2034] = {
    [sym_class_heritage] = STATE(2059),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(1542),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [2035] = {
    [sym_public_field_definition] = STATE(394),
    [sym__property_name] = STATE(395),
    [sym_method_signature] = STATE(394),
    [sym_abstract_method_signature] = STATE(394),
    [aux_sym_class_body_repeat1] = STATE(679),
    [sym_index_signature] = STATE(394),
    [sym_method_definition] = STATE(398),
    [sym_decorator] = STATE(679),
    [sym_accessibility_modifier] = STATE(396),
    [sym_computed_property_name] = STATE(395),
    [sym_string] = STATE(395),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(923),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(931),
    [anon_sym_RBRACE] = ACTIONS(4753),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [sym_number] = ACTIONS(937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_abstract] = ACTIONS(939),
    [anon_sym_set] = ACTIONS(931),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [sym_readonly] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2036] = {
    [aux_sym_object_repeat1] = STATE(434),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_RBRACE] = ACTIONS(4755),
    [sym_comment] = ACTIONS(3),
  },
  [2037] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [aux_sym_array_repeat1] = STATE(1830),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_COMMA] = ACTIONS(272),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_RBRACK] = ACTIONS(4757),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2038] = {
    [aux_sym_object_repeat1] = STATE(434),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_RBRACE] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
  },
  [2039] = {
    [aux_sym_object_repeat1] = STATE(2061),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_RBRACE] = ACTIONS(4759),
    [sym_comment] = ACTIONS(3),
  },
  [2040] = {
    [anon_sym_RPAREN] = ACTIONS(4761),
    [sym_comment] = ACTIONS(3),
  },
  [2041] = {
    [sym_statement_block] = STATE(1548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4586),
  },
  [2042] = {
    [sym_identifier] = ACTIONS(4763),
    [sym_comment] = ACTIONS(3),
  },
  [2043] = {
    [aux_sym_object_type_repeat1] = STATE(2066),
    [sym__automatic_semicolon] = ACTIONS(4765),
    [anon_sym_RBRACE] = ACTIONS(4767),
    [anon_sym_SEMI] = ACTIONS(4765),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4767),
    [anon_sym_COMMA] = ACTIONS(4765),
    [sym_comment] = ACTIONS(3),
  },
  [2044] = {
    [aux_sym_implements_clause_repeat1] = STATE(2067),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_RBRACK] = ACTIONS(4769),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(1954),
    [sym_comment] = ACTIONS(3),
  },
  [2045] = {
    [anon_sym_EQ_GT] = ACTIONS(4771),
    [sym_comment] = ACTIONS(3),
  },
  [2046] = {
    [sym_property_signature] = STATE(513),
    [sym_call_signature] = STATE(513),
    [sym_construct_signature] = STATE(513),
    [sym_index_signature] = STATE(513),
    [sym_method_definition] = STATE(1776),
    [sym_accessibility_modifier] = STATE(787),
    [sym_spread_element] = STATE(1776),
    [sym_string] = STATE(786),
    [sym_type_parameters] = STATE(1741),
    [sym_pair] = STATE(1776),
    [aux_sym_export_statement_repeat1] = STATE(785),
    [sym_object] = STATE(310),
    [sym__property_name] = STATE(786),
    [aux_sym_object_repeat1] = STATE(1778),
    [sym_assignment_pattern] = STATE(1776),
    [sym_method_signature] = STATE(513),
    [sym_export_statement] = STATE(513),
    [sym_decorator] = STATE(785),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(786),
    [sym_array] = STATE(312),
    [sym_identifier] = ACTIONS(2357),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_SEMI] = ACTIONS(1222),
    [anon_sym_module] = ACTIONS(2361),
    [anon_sym_symbol] = ACTIONS(2361),
    [anon_sym_number] = ACTIONS(2361),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(2363),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_void] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(2361),
    [anon_sym_private] = ACTIONS(2367),
    [anon_sym_boolean] = ACTIONS(2361),
    [anon_sym_static] = ACTIONS(2369),
    [anon_sym_async] = ACTIONS(2371),
    [anon_sym_get] = ACTIONS(2373),
    [anon_sym_RBRACE] = ACTIONS(4773),
    [anon_sym_public] = ACTIONS(2367),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2367),
    [anon_sym_string] = ACTIONS(2361),
    [anon_sym_set] = ACTIONS(2373),
    [anon_sym_type] = ACTIONS(2361),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(2361),
    [anon_sym_export] = ACTIONS(2379),
    [sym_readonly] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(2361),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2047] = {
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_RPAREN] = ACTIONS(4775),
    [anon_sym_PIPE] = ACTIONS(1276),
    [sym_comment] = ACTIONS(3),
  },
  [2048] = {
    [sym__type] = STATE(792),
    [sym_constructor_type] = STATE(792),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(792),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(792),
    [sym_intersection_type] = STATE(792),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_GT] = ACTIONS(4777),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2049] = {
    [aux_sym_implements_clause_repeat1] = STATE(794),
    [anon_sym_GT] = ACTIONS(4777),
    [anon_sym_COMMA] = ACTIONS(4779),
    [sym_comment] = ACTIONS(3),
  },
  [2050] = {
    [anon_sym_EQ_GT] = ACTIONS(4781),
    [sym_comment] = ACTIONS(3),
  },
  [2051] = {
    [anon_sym_RBRACK] = ACTIONS(4783),
    [sym_comment] = ACTIONS(3),
  },
  [2052] = {
    [sym_statement_block] = STATE(1399),
    [sym__automatic_semicolon] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3190),
  },
  [2053] = {
    [sym_statement_block] = STATE(1564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4586),
  },
  [2054] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(4785),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2055] = {
    [sym_new_expression] = STATE(2009),
    [sym_constructor_type] = STATE(2047),
    [sym_augmented_assignment_expression] = STATE(2009),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(2009),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(2009),
    [sym_call_signature] = STATE(1740),
    [sym_rest_parameter] = STATE(198),
    [sym_yield_expression] = STATE(2009),
    [sym_as_expression] = STATE(2009),
    [sym_internal_module] = STATE(2009),
    [sym_accessibility_modifier] = STATE(200),
    [sym_arrow_function] = STATE(2009),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(1201),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1691),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(204),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(2009),
    [sym_subscript_expression] = STATE(1201),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(2009),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(2009),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(203),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(2047),
    [sym__type] = STATE(2047),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(2009),
    [sym_meta_property] = STATE(2009),
    [sym_function_type] = STATE(2047),
    [sym__expression] = STATE(2009),
    [sym_non_null_expression] = STATE(2009),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_required_parameter] = STATE(198),
    [sym_await_expression] = STATE(2009),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_sequence_expression] = STATE(2010),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(202),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(203),
    [sym_anonymous_class] = STATE(2009),
    [sym_optional_parameter] = STATE(198),
    [sym_call_expression] = STATE(2009),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(2009),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(2009),
    [sym_type_arguments] = STATE(1205),
    [sym_union_type] = STATE(2047),
    [sym_parenthesized_expression] = STATE(2009),
    [sym_array] = STATE(205),
    [sym_type_assertion] = STATE(2009),
    [sym_class] = STATE(2009),
    [sym_identifier] = ACTIONS(2536),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(2538),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(2540),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(2542),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(414),
    [anon_sym_get] = ACTIONS(410),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(2544),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(2546),
    [anon_sym_protected] = ACTIONS(414),
    [anon_sym_set] = ACTIONS(410),
    [anon_sym_type] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(410),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(420),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(2546),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_number] = ACTIONS(2538),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(410),
    [anon_sym_typeof] = ACTIONS(2548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [sym_null] = ACTIONS(4542),
    [anon_sym_any] = ACTIONS(2538),
    [anon_sym_boolean] = ACTIONS(2538),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_public] = ACTIONS(414),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(2550),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(2538),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4542),
    [anon_sym_new] = ACTIONS(2349),
    [anon_sym_PLUS] = ACTIONS(2540),
    [anon_sym_export] = ACTIONS(410),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [2056] = {
    [sym_class_heritage] = STATE(2072),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_type_parameters] = STATE(2073),
    [sym_class_body] = STATE(1569),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [2057] = {
    [aux_sym_array_repeat1] = STATE(375),
    [anon_sym_RPAREN] = ACTIONS(4787),
    [anon_sym_COMMA] = ACTIONS(272),
    [sym_comment] = ACTIONS(3),
  },
  [2058] = {
    [sym_identifier] = ACTIONS(4789),
    [sym_comment] = ACTIONS(3),
  },
  [2059] = {
    [sym_class_body] = STATE(1572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [2060] = {
    [anon_sym_COLON] = ACTIONS(4791),
    [sym_comment] = ACTIONS(3),
  },
  [2061] = {
    [aux_sym_object_repeat1] = STATE(434),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_RBRACE] = ACTIONS(4793),
    [sym_comment] = ACTIONS(3),
  },
  [2062] = {
    [sym_statement_block] = STATE(1448),
    [sym__automatic_semicolon] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3190),
  },
  [2063] = {
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_RBRACK] = ACTIONS(4795),
    [sym_comment] = ACTIONS(3),
  },
  [2064] = {
    [aux_sym_object_type_repeat1] = STATE(2075),
    [sym__automatic_semicolon] = ACTIONS(4797),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_SEMI] = ACTIONS(4797),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4799),
    [anon_sym_COMMA] = ACTIONS(4797),
    [sym_comment] = ACTIONS(3),
  },
  [2065] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(967),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(967),
    [sym_call_signature] = STATE(967),
    [sym_construct_signature] = STATE(967),
    [sym_index_signature] = STATE(967),
    [sym_export_statement] = STATE(967),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4799),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2066] = {
    [aux_sym_object_type_repeat1] = STATE(968),
    [sym__automatic_semicolon] = ACTIONS(4797),
    [anon_sym_RBRACE] = ACTIONS(4799),
    [anon_sym_SEMI] = ACTIONS(4797),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4799),
    [anon_sym_COMMA] = ACTIONS(4797),
    [sym_comment] = ACTIONS(3),
  },
  [2067] = {
    [aux_sym_implements_clause_repeat1] = STATE(794),
    [anon_sym_COMMA] = ACTIONS(1954),
    [anon_sym_RBRACK] = ACTIONS(4801),
    [sym_comment] = ACTIONS(3),
  },
  [2068] = {
    [anon_sym_EQ_GT] = ACTIONS(4803),
    [sym_comment] = ACTIONS(3),
  },
  [2069] = {
    [sym__type] = STATE(792),
    [sym_constructor_type] = STATE(792),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(792),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(792),
    [sym_intersection_type] = STATE(792),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_GT] = ACTIONS(4805),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2070] = {
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_RBRACK] = ACTIONS(4807),
    [sym_comment] = ACTIONS(3),
  },
  [2071] = {
    [sym_statement_block] = STATE(1584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4586),
  },
  [2072] = {
    [sym_class_body] = STATE(1585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [2073] = {
    [sym_class_heritage] = STATE(2077),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(1585),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [2074] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(967),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(967),
    [sym_call_signature] = STATE(967),
    [sym_construct_signature] = STATE(967),
    [sym_index_signature] = STATE(967),
    [sym_export_statement] = STATE(967),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(4809),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4809),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2075] = {
    [aux_sym_object_type_repeat1] = STATE(968),
    [sym__automatic_semicolon] = ACTIONS(4811),
    [anon_sym_RBRACE] = ACTIONS(4809),
    [anon_sym_SEMI] = ACTIONS(4811),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4809),
    [anon_sym_COMMA] = ACTIONS(4811),
    [sym_comment] = ACTIONS(3),
  },
  [2076] = {
    [sym_identifier] = ACTIONS(4813),
    [sym_comment] = ACTIONS(3),
  },
  [2077] = {
    [sym_class_body] = STATE(1590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [2078] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(967),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(967),
    [sym_call_signature] = STATE(967),
    [sym_construct_signature] = STATE(967),
    [sym_index_signature] = STATE(967),
    [sym_export_statement] = STATE(967),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(4815),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4815),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2079] = {
    [sym_new_expression] = STATE(2081),
    [sym_constructor_type] = STATE(232),
    [sym_augmented_assignment_expression] = STATE(2081),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(2081),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(2081),
    [sym_call_signature] = STATE(1997),
    [sym_yield_expression] = STATE(2081),
    [sym_as_expression] = STATE(2081),
    [sym_internal_module] = STATE(2081),
    [sym_arrow_function] = STATE(2081),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(2338),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1369),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(2339),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(2081),
    [sym_subscript_expression] = STATE(2338),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(2081),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(2081),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(232),
    [sym__type] = STATE(232),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(2081),
    [sym_meta_property] = STATE(2081),
    [sym_function_type] = STATE(232),
    [sym__expression] = STATE(2081),
    [sym_non_null_expression] = STATE(2081),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(2081),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(2081),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(2081),
    [sym_call_expression] = STATE(2081),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(2081),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(2081),
    [sym_type_arguments] = STATE(1947),
    [sym_union_type] = STATE(232),
    [sym_parenthesized_expression] = STATE(2081),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2081),
    [sym_class] = STATE(2081),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4319),
    [sym_false] = ACTIONS(4020),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(4321),
    [anon_sym_number] = ACTIONS(4321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(4323),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(4325),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(4327),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [sym_null] = ACTIONS(4329),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(4321),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(4321),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(4018),
    [sym_number] = ACTIONS(4024),
    [sym_true] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(4321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4329),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(4331),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(4325),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [2080] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(1679),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(1679),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1679),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_in] = ACTIONS(1339),
  },
  [2081] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_implements] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [2082] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_COMMA] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1687),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG_EQ] = ACTIONS(1922),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1942),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_implements] = ACTIONS(1687),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1924),
    [anon_sym_in] = ACTIONS(1922),
  },
  [2083] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_COMMA] = ACTIONS(1689),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1689),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG_EQ] = ACTIONS(1922),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1942),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_implements] = ACTIONS(1689),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1924),
    [anon_sym_in] = ACTIONS(1922),
  },
  [2084] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(1713),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(1713),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1713),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_in] = ACTIONS(1339),
  },
  [2085] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_COMMA] = ACTIONS(1717),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1717),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG_EQ] = ACTIONS(1922),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1942),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_implements] = ACTIONS(1717),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1924),
    [anon_sym_in] = ACTIONS(1922),
  },
  [2086] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG_EQ] = ACTIONS(1922),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_implements] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1924),
    [anon_sym_in] = ACTIONS(1922),
  },
  [2087] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_GT_GT_GT] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(4817),
    [anon_sym_SLASH] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_implements] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [2088] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(4817),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_implements] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [2089] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG_EQ] = ACTIONS(1922),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_implements] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1924),
    [anon_sym_in] = ACTIONS(1922),
  },
  [2090] = {
    [sym_new_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_non_null_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_identifier] = STATE(516),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1220),
    [sym_this] = STATE(1220),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1220),
    [sym_generator_function] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1220),
    [sym_class] = STATE(1220),
    [sym_identifier] = ACTIONS(4820),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(1124),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(1124),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1130),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [2091] = {
    [sym_new_expression] = STATE(1218),
    [sym_augmented_assignment_expression] = STATE(1218),
    [sym_unary_expression] = STATE(1218),
    [sym_update_expression] = STATE(1218),
    [sym_regex] = STATE(1218),
    [sym_meta_property] = STATE(1218),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1218),
    [sym_yield_expression] = STATE(1218),
    [sym_as_expression] = STATE(1218),
    [sym_non_null_expression] = STATE(1218),
    [sym_internal_module] = STATE(1218),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1218),
    [sym_await_expression] = STATE(1218),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1218),
    [sym_this] = STATE(1218),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1218),
    [sym_generator_function] = STATE(1218),
    [sym_call_expression] = STATE(1218),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1218),
    [sym_ternary_expression] = STATE(1218),
    [sym_binary_expression] = STATE(1218),
    [sym_template_string] = STATE(1218),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1218),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1218),
    [sym_class] = STATE(1218),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(3894),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3894),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3894),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4822),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3894),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [2092] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_LBRACE] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_GT_GT_GT] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(4817),
    [anon_sym_SLASH] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_implements] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [2093] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(2936),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2936),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_in] = ACTIONS(1339),
  },
  [2094] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(2940),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(2940),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2940),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_in] = ACTIONS(1339),
  },
  [2095] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1924),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1926),
    [anon_sym_COMMA] = ACTIONS(3569),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_STAR] = ACTIONS(1938),
    [anon_sym_LBRACE] = ACTIONS(3569),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_GT_GT_GT] = ACTIONS(1928),
    [anon_sym_DASH] = ACTIONS(1932),
    [anon_sym_BANG_EQ] = ACTIONS(1922),
    [anon_sym_LT_EQ] = ACTIONS(1924),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1924),
    [anon_sym_GT] = ACTIONS(1922),
    [anon_sym_AMP] = ACTIONS(1940),
    [anon_sym_PERCENT] = ACTIONS(1928),
    [anon_sym_QMARK] = ACTIONS(1942),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1944),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1922),
    [anon_sym_instanceof] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1946),
    [anon_sym_SLASH] = ACTIONS(1938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1944),
    [anon_sym_STAR_STAR] = ACTIONS(1948),
    [anon_sym_PLUS] = ACTIONS(1932),
    [anon_sym_implements] = ACTIONS(3569),
    [anon_sym_GT_GT] = ACTIONS(1938),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1924),
    [anon_sym_in] = ACTIONS(1922),
  },
  [2096] = {
    [aux_sym_string_repeat1] = STATE(2099),
    [sym_escape_sequence] = ACTIONS(4824),
    [aux_sym_string_token1] = ACTIONS(4824),
    [anon_sym_DQUOTE] = ACTIONS(4826),
    [sym_comment] = ACTIONS(256),
  },
  [2097] = {
    [sym_new_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_do_statement] = STATE(2102),
    [sym_internal_module] = STATE(53),
    [sym_accessibility_modifier] = STATE(180),
    [sym_import_statement] = STATE(2102),
    [sym_member_expression] = STATE(54),
    [sym_switch_statement] = STATE(2102),
    [sym_string] = STATE(178),
    [sym_type_parameters] = STATE(55),
    [sym_throw_statement] = STATE(2102),
    [aux_sym_program_repeat1] = STATE(2102),
    [sym_object] = STATE(184),
    [sym_generator_function] = STATE(53),
    [sym_ternary_expression] = STATE(59),
    [sym_for_of_statement] = STATE(2102),
    [sym_decorator] = STATE(2234),
    [sym_computed_property_name] = STATE(183),
    [sym_abstract_class] = STATE(2102),
    [sym_statement_block] = STATE(2102),
    [sym_update_expression] = STATE(59),
    [sym_debugger_statement] = STATE(2102),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_function] = STATE(60),
    [sym_for_statement] = STATE(2102),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(2102),
    [sym_pair] = STATE(1776),
    [aux_sym_export_statement_repeat1] = STATE(2234),
    [sym_assignment_pattern] = STATE(1776),
    [sym_export_statement] = STATE(2102),
    [sym_call_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2102),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_break_statement] = STATE(2102),
    [sym_parenthesized_expression] = STATE(59),
    [sym_module] = STATE(2102),
    [sym_class] = STATE(53),
    [sym_type_alias_declaration] = STATE(2102),
    [sym__declaration] = STATE(2102),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_if_statement] = STATE(2102),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_return_statement] = STATE(2102),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_arrow_function] = STATE(59),
    [sym_expression_statement] = STATE(2102),
    [sym_spread_element] = STATE(1776),
    [sym_try_statement] = STATE(2102),
    [sym__property_name] = STATE(183),
    [aux_sym_object_repeat1] = STATE(1778),
    [sym_ambient_declaration] = STATE(2102),
    [sym_subscript_expression] = STATE(54),
    [sym_template_string] = STATE(59),
    [sym_continue_statement] = STATE(2102),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(2102),
    [sym_interface_declaration] = STATE(2102),
    [sym_while_statement] = STATE(2102),
    [sym_meta_property] = STATE(59),
    [sym_method_definition] = STATE(1776),
    [sym_enum_declaration] = STATE(2102),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2102),
    [sym_sequence_expression] = STATE(62),
    [sym_with_statement] = STATE(2102),
    [sym_import_alias] = STATE(2102),
    [sym_anonymous_class] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_for_in_statement] = STATE(2102),
    [sym_labeled_statement] = STATE(2102),
    [sym_array] = STATE(187),
    [sym_type_assertion] = STATE(59),
    [sym_identifier] = ACTIONS(4828),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(4830),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_COMMA] = ACTIONS(374),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_void] = ACTIONS(4832),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(4834),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_get] = ACTIONS(4836),
    [anon_sym_RBRACE] = ACTIONS(4838),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(4834),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(4836),
    [anon_sym_type] = ACTIONS(4840),
    [anon_sym_import] = ACTIONS(4842),
    [anon_sym_namespace] = ACTIONS(4844),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(396),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(4846),
    [anon_sym_number] = ACTIONS(4830),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(4848),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(4830),
    [anon_sym_boolean] = ACTIONS(4830),
    [anon_sym_async] = ACTIONS(4850),
    [anon_sym_public] = ACTIONS(4834),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(404),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(4830),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(4852),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [2098] = {
    [aux_sym_string_repeat2] = STATE(2103),
    [sym_escape_sequence] = ACTIONS(4854),
    [aux_sym_string_token2] = ACTIONS(4854),
    [sym_comment] = ACTIONS(256),
    [anon_sym_SQUOTE] = ACTIONS(4826),
  },
  [2099] = {
    [aux_sym_string_repeat1] = STATE(362),
    [sym_escape_sequence] = ACTIONS(817),
    [aux_sym_string_token1] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(4856),
    [sym_comment] = ACTIONS(256),
  },
  [2100] = {
    [sym_class_heritage] = STATE(2113),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_type_parameters] = STATE(2114),
    [sym_class_body] = STATE(1608),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1793),
  },
  [2101] = {
    [sym_public_field_definition] = STATE(394),
    [sym__property_name] = STATE(395),
    [sym_method_signature] = STATE(394),
    [sym_abstract_method_signature] = STATE(394),
    [aux_sym_class_body_repeat1] = STATE(2115),
    [sym_index_signature] = STATE(394),
    [sym_method_definition] = STATE(398),
    [sym_decorator] = STATE(2115),
    [sym_accessibility_modifier] = STATE(396),
    [sym_computed_property_name] = STATE(395),
    [sym_string] = STATE(395),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(923),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(931),
    [anon_sym_RBRACE] = ACTIONS(4858),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [sym_number] = ACTIONS(937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_abstract] = ACTIONS(939),
    [anon_sym_set] = ACTIONS(931),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [sym_readonly] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2102] = {
    [sym_type_alias_declaration] = STATE(266),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(266),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(266),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(266),
    [sym_return_statement] = STATE(266),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(266),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(266),
    [sym_switch_statement] = STATE(266),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(266),
    [sym_throw_statement] = STATE(266),
    [aux_sym_program_repeat1] = STATE(266),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(266),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(266),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(266),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(266),
    [sym_abstract_class] = STATE(266),
    [sym_interface_declaration] = STATE(266),
    [sym_statement_block] = STATE(266),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(266),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(266),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(266),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(266),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(266),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(266),
    [sym_empty_statement] = STATE(266),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(266),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(266),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(266),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(266),
    [sym_break_statement] = STATE(266),
    [sym_labeled_statement] = STATE(266),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(266),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [2103] = {
    [aux_sym_string_repeat2] = STATE(484),
    [sym_escape_sequence] = ACTIONS(1184),
    [aux_sym_string_token2] = ACTIONS(1184),
    [sym_comment] = ACTIONS(256),
    [anon_sym_SQUOTE] = ACTIONS(4856),
  },
  [2104] = {
    [sym_type_alias_declaration] = STATE(2102),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(2102),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(2102),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(2102),
    [sym_return_statement] = STATE(2102),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(2102),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2102),
    [sym_switch_statement] = STATE(2102),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(2102),
    [sym_throw_statement] = STATE(2102),
    [aux_sym_program_repeat1] = STATE(2102),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(2102),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(2102),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(2102),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(2102),
    [sym_abstract_class] = STATE(2102),
    [sym_interface_declaration] = STATE(2102),
    [sym_statement_block] = STATE(2102),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(2102),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(2102),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(2102),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2102),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(2102),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(2102),
    [sym_empty_statement] = STATE(2102),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(2102),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(2102),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2102),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(2102),
    [sym_break_statement] = STATE(2102),
    [sym_labeled_statement] = STATE(2102),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(2102),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4862),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [2105] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(2118),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(2118),
    [sym_call_signature] = STATE(2118),
    [sym_construct_signature] = STATE(2118),
    [sym_index_signature] = STATE(2118),
    [sym_export_statement] = STATE(2118),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_SEMI] = ACTIONS(4864),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_COMMA] = ACTIONS(4864),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(4866),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4866),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2106] = {
    [sym_nested_identifier] = STATE(1618),
    [sym_identifier] = ACTIONS(4868),
    [sym_comment] = ACTIONS(3),
  },
  [2107] = {
    [sym_number] = ACTIONS(4870),
    [sym_comment] = ACTIONS(3),
  },
  [2108] = {
    [sym_nested_type_identifier] = STATE(1621),
    [sym_nested_identifier] = STATE(2424),
    [sym_identifier] = ACTIONS(4872),
    [sym_comment] = ACTIONS(3),
  },
  [2109] = {
    [aux_sym_implements_clause_repeat1] = STATE(2124),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_GT] = ACTIONS(4874),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(4876),
    [sym_comment] = ACTIONS(3),
  },
  [2110] = {
    [anon_sym_EQ_GT] = ACTIONS(4878),
    [sym_comment] = ACTIONS(3),
  },
  [2111] = {
    [sym_statement_block] = STATE(1630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [2112] = {
    [sym_identifier] = ACTIONS(4880),
    [sym_comment] = ACTIONS(3),
  },
  [2113] = {
    [sym_class_body] = STATE(1636),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1793),
  },
  [2114] = {
    [sym_class_heritage] = STATE(2131),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(1636),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1793),
  },
  [2115] = {
    [sym_public_field_definition] = STATE(394),
    [sym__property_name] = STATE(395),
    [sym_method_signature] = STATE(394),
    [sym_abstract_method_signature] = STATE(394),
    [aux_sym_class_body_repeat1] = STATE(679),
    [sym_index_signature] = STATE(394),
    [sym_method_definition] = STATE(398),
    [sym_decorator] = STATE(679),
    [sym_accessibility_modifier] = STATE(396),
    [sym_computed_property_name] = STATE(395),
    [sym_string] = STATE(395),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(923),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(927),
    [anon_sym_async] = ACTIONS(929),
    [anon_sym_get] = ACTIONS(931),
    [anon_sym_RBRACE] = ACTIONS(4882),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [sym_number] = ACTIONS(937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_abstract] = ACTIONS(939),
    [anon_sym_set] = ACTIONS(931),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(919),
    [anon_sym_namespace] = ACTIONS(919),
    [sym_readonly] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2116] = {
    [sym_statement_block] = STATE(1638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [2117] = {
    [sym_identifier] = ACTIONS(4884),
    [sym_comment] = ACTIONS(3),
  },
  [2118] = {
    [aux_sym_object_type_repeat1] = STATE(2136),
    [sym__automatic_semicolon] = ACTIONS(4886),
    [anon_sym_RBRACE] = ACTIONS(4888),
    [anon_sym_SEMI] = ACTIONS(4886),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4888),
    [anon_sym_COMMA] = ACTIONS(4886),
    [sym_comment] = ACTIONS(3),
  },
  [2119] = {
    [aux_sym_implements_clause_repeat1] = STATE(2137),
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_RBRACK] = ACTIONS(4890),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_COMMA] = ACTIONS(1954),
    [sym_comment] = ACTIONS(3),
  },
  [2120] = {
    [anon_sym_EQ_GT] = ACTIONS(4892),
    [sym_comment] = ACTIONS(3),
  },
  [2121] = {
    [sym_property_signature] = STATE(513),
    [sym_call_signature] = STATE(513),
    [sym_construct_signature] = STATE(513),
    [sym_index_signature] = STATE(513),
    [sym_method_definition] = STATE(1776),
    [sym_accessibility_modifier] = STATE(787),
    [sym_spread_element] = STATE(1776),
    [sym_string] = STATE(786),
    [sym_type_parameters] = STATE(1741),
    [sym_pair] = STATE(1776),
    [aux_sym_export_statement_repeat1] = STATE(785),
    [sym_object] = STATE(310),
    [sym__property_name] = STATE(786),
    [aux_sym_object_repeat1] = STATE(1778),
    [sym_assignment_pattern] = STATE(1776),
    [sym_method_signature] = STATE(513),
    [sym_export_statement] = STATE(513),
    [sym_decorator] = STATE(785),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(786),
    [sym_array] = STATE(312),
    [sym_identifier] = ACTIONS(2357),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_SEMI] = ACTIONS(1222),
    [anon_sym_module] = ACTIONS(2361),
    [anon_sym_symbol] = ACTIONS(2361),
    [anon_sym_number] = ACTIONS(2361),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(2361),
    [anon_sym_COMMA] = ACTIONS(2363),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_void] = ACTIONS(2361),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(2361),
    [anon_sym_private] = ACTIONS(2367),
    [anon_sym_boolean] = ACTIONS(2361),
    [anon_sym_static] = ACTIONS(2369),
    [anon_sym_async] = ACTIONS(2371),
    [anon_sym_get] = ACTIONS(2373),
    [anon_sym_RBRACE] = ACTIONS(4894),
    [anon_sym_public] = ACTIONS(2367),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(2367),
    [anon_sym_string] = ACTIONS(2361),
    [anon_sym_set] = ACTIONS(2373),
    [anon_sym_type] = ACTIONS(2361),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(2361),
    [anon_sym_export] = ACTIONS(2379),
    [sym_readonly] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(2361),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2122] = {
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_RPAREN] = ACTIONS(4896),
    [anon_sym_PIPE] = ACTIONS(1276),
    [sym_comment] = ACTIONS(3),
  },
  [2123] = {
    [sym__type] = STATE(792),
    [sym_constructor_type] = STATE(792),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(792),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(792),
    [sym_intersection_type] = STATE(792),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2124] = {
    [aux_sym_implements_clause_repeat1] = STATE(794),
    [anon_sym_GT] = ACTIONS(4898),
    [anon_sym_COMMA] = ACTIONS(4900),
    [sym_comment] = ACTIONS(3),
  },
  [2125] = {
    [anon_sym_EQ_GT] = ACTIONS(4902),
    [sym_comment] = ACTIONS(3),
  },
  [2126] = {
    [anon_sym_RBRACK] = ACTIONS(4904),
    [sym_comment] = ACTIONS(3),
  },
  [2127] = {
    [sym_statement_block] = STATE(1548),
    [sym__automatic_semicolon] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2422),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [2128] = {
    [sym_statement_block] = STATE(1654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [2129] = {
    [sym_class_heritage] = STATE(2142),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_type_parameters] = STATE(2143),
    [sym_class_body] = STATE(1658),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1793),
  },
  [2130] = {
    [sym_identifier] = ACTIONS(4906),
    [sym_comment] = ACTIONS(3),
  },
  [2131] = {
    [sym_class_body] = STATE(1660),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1793),
  },
  [2132] = {
    [sym_statement_block] = STATE(1575),
    [sym__automatic_semicolon] = ACTIONS(2944),
    [anon_sym_SEMI] = ACTIONS(2944),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [2133] = {
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_RBRACK] = ACTIONS(4908),
    [sym_comment] = ACTIONS(3),
  },
  [2134] = {
    [aux_sym_object_type_repeat1] = STATE(2145),
    [sym__automatic_semicolon] = ACTIONS(4910),
    [anon_sym_RBRACE] = ACTIONS(4912),
    [anon_sym_SEMI] = ACTIONS(4910),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4912),
    [anon_sym_COMMA] = ACTIONS(4910),
    [sym_comment] = ACTIONS(3),
  },
  [2135] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(967),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(967),
    [sym_call_signature] = STATE(967),
    [sym_construct_signature] = STATE(967),
    [sym_index_signature] = STATE(967),
    [sym_export_statement] = STATE(967),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(4912),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4912),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2136] = {
    [aux_sym_object_type_repeat1] = STATE(968),
    [sym__automatic_semicolon] = ACTIONS(4910),
    [anon_sym_RBRACE] = ACTIONS(4912),
    [anon_sym_SEMI] = ACTIONS(4910),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4912),
    [anon_sym_COMMA] = ACTIONS(4910),
    [sym_comment] = ACTIONS(3),
  },
  [2137] = {
    [aux_sym_implements_clause_repeat1] = STATE(794),
    [anon_sym_COMMA] = ACTIONS(1954),
    [anon_sym_RBRACK] = ACTIONS(4914),
    [sym_comment] = ACTIONS(3),
  },
  [2138] = {
    [anon_sym_EQ_GT] = ACTIONS(4916),
    [sym_comment] = ACTIONS(3),
  },
  [2139] = {
    [sym__type] = STATE(792),
    [sym_constructor_type] = STATE(792),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(792),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(792),
    [sym_intersection_type] = STATE(792),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_GT] = ACTIONS(4918),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2140] = {
    [anon_sym_AMP] = ACTIONS(1272),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_RBRACK] = ACTIONS(4920),
    [sym_comment] = ACTIONS(3),
  },
  [2141] = {
    [sym_statement_block] = STATE(1670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [2142] = {
    [sym_class_body] = STATE(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1793),
  },
  [2143] = {
    [sym_class_heritage] = STATE(2147),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(1671),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1793),
  },
  [2144] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(967),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(967),
    [sym_call_signature] = STATE(967),
    [sym_construct_signature] = STATE(967),
    [sym_index_signature] = STATE(967),
    [sym_export_statement] = STATE(967),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(4922),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4922),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2145] = {
    [aux_sym_object_type_repeat1] = STATE(968),
    [sym__automatic_semicolon] = ACTIONS(4924),
    [anon_sym_RBRACE] = ACTIONS(4922),
    [anon_sym_SEMI] = ACTIONS(4924),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4922),
    [anon_sym_COMMA] = ACTIONS(4924),
    [sym_comment] = ACTIONS(3),
  },
  [2146] = {
    [sym_identifier] = ACTIONS(4926),
    [sym_comment] = ACTIONS(3),
  },
  [2147] = {
    [sym_class_body] = STATE(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1793),
  },
  [2148] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(967),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(967),
    [sym_call_signature] = STATE(967),
    [sym_construct_signature] = STATE(967),
    [sym_index_signature] = STATE(967),
    [sym_export_statement] = STATE(967),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_RBRACE] = ACTIONS(4928),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_PIPE_RBRACE] = ACTIONS(4928),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2149] = {
    [sym_new_expression] = STATE(2415),
    [sym_augmented_assignment_expression] = STATE(2415),
    [sym_unary_expression] = STATE(2415),
    [sym_update_expression] = STATE(2415),
    [sym_regex] = STATE(2415),
    [sym_meta_property] = STATE(2415),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2415),
    [sym_yield_expression] = STATE(2415),
    [sym_as_expression] = STATE(2415),
    [sym_non_null_expression] = STATE(2415),
    [sym_internal_module] = STATE(2415),
    [sym_nested_identifier] = STATE(516),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2415),
    [sym_await_expression] = STATE(2415),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2415),
    [sym_this] = STATE(2415),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2415),
    [sym_generator_function] = STATE(2415),
    [sym_call_expression] = STATE(2415),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2415),
    [sym_ternary_expression] = STATE(2415),
    [sym_binary_expression] = STATE(2415),
    [sym_template_string] = STATE(2415),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2415),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2415),
    [sym_class] = STATE(2415),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4930),
    [sym_false] = ACTIONS(4673),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4673),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4677),
    [sym_true] = ACTIONS(4673),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4673),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [2150] = {
    [sym_new_expression] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(2414),
    [sym_unary_expression] = STATE(2414),
    [sym_update_expression] = STATE(2414),
    [sym_regex] = STATE(2414),
    [sym_meta_property] = STATE(2414),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2414),
    [sym_yield_expression] = STATE(2414),
    [sym_as_expression] = STATE(2414),
    [sym_non_null_expression] = STATE(2414),
    [sym_internal_module] = STATE(2414),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2414),
    [sym_await_expression] = STATE(2414),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2414),
    [sym_this] = STATE(2414),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2414),
    [sym_generator_function] = STATE(2414),
    [sym_call_expression] = STATE(2414),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2414),
    [sym_ternary_expression] = STATE(2414),
    [sym_binary_expression] = STATE(2414),
    [sym_template_string] = STATE(2414),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2414),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2414),
    [sym_class] = STATE(2414),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4932),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4932),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4079),
    [sym_true] = ACTIONS(4932),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4932),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [2151] = {
    [aux_sym_string_repeat1] = STATE(2153),
    [sym_escape_sequence] = ACTIONS(4934),
    [aux_sym_string_token1] = ACTIONS(4934),
    [anon_sym_DQUOTE] = ACTIONS(4936),
    [sym_comment] = ACTIONS(256),
  },
  [2152] = {
    [aux_sym_string_repeat2] = STATE(2155),
    [sym_escape_sequence] = ACTIONS(4938),
    [aux_sym_string_token2] = ACTIONS(4938),
    [sym_comment] = ACTIONS(256),
    [anon_sym_SQUOTE] = ACTIONS(4936),
  },
  [2153] = {
    [aux_sym_string_repeat1] = STATE(362),
    [sym_escape_sequence] = ACTIONS(817),
    [aux_sym_string_token1] = ACTIONS(817),
    [anon_sym_DQUOTE] = ACTIONS(4940),
    [sym_comment] = ACTIONS(256),
  },
  [2154] = {
    [sym_type_alias_declaration] = STATE(266),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(266),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(266),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(266),
    [sym_return_statement] = STATE(266),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(266),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(266),
    [sym_switch_statement] = STATE(266),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(266),
    [sym_throw_statement] = STATE(266),
    [aux_sym_program_repeat1] = STATE(266),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(266),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(266),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(266),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(266),
    [sym_abstract_class] = STATE(266),
    [sym_interface_declaration] = STATE(266),
    [sym_statement_block] = STATE(266),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(266),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(266),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(266),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(266),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(266),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(266),
    [sym_empty_statement] = STATE(266),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(266),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(266),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(266),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(266),
    [sym_break_statement] = STATE(266),
    [sym_labeled_statement] = STATE(266),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(266),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4942),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [2155] = {
    [aux_sym_string_repeat2] = STATE(484),
    [sym_escape_sequence] = ACTIONS(1184),
    [aux_sym_string_token2] = ACTIONS(1184),
    [sym_comment] = ACTIONS(256),
    [anon_sym_SQUOTE] = ACTIONS(4940),
  },
  [2156] = {
    [sym_type_alias_declaration] = STATE(2154),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(2154),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(2154),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(2154),
    [sym_return_statement] = STATE(2154),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(2154),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2154),
    [sym_switch_statement] = STATE(2154),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(2154),
    [sym_throw_statement] = STATE(2154),
    [aux_sym_program_repeat1] = STATE(2154),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(2154),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(2154),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(2154),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(2154),
    [sym_abstract_class] = STATE(2154),
    [sym_interface_declaration] = STATE(2154),
    [sym_statement_block] = STATE(2154),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(2154),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(2154),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(2154),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2154),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(2154),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(2154),
    [sym_empty_statement] = STATE(2154),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(2154),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(2154),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2154),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(2154),
    [sym_break_statement] = STATE(2154),
    [sym_labeled_statement] = STATE(2154),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(2154),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4944),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [2157] = {
    [anon_sym_EQ_GT] = ACTIONS(4946),
    [sym_comment] = ACTIONS(3),
  },
  [2158] = {
    [sym_statement_block] = STATE(1533),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [2159] = {
    [sym_identifier] = ACTIONS(4948),
    [sym_comment] = ACTIONS(3),
  },
  [2160] = {
    [sym_class_body] = STATE(649),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [2161] = {
    [sym_class_heritage] = STATE(2171),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(649),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [2162] = {
    [sym_statement_block] = STATE(1548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [2163] = {
    [sym_identifier] = ACTIONS(4950),
    [sym_comment] = ACTIONS(3),
  },
  [2164] = {
    [anon_sym_EQ_GT] = ACTIONS(4952),
    [sym_comment] = ACTIONS(3),
  },
  [2165] = {
    [sym_pair] = STATE(181),
    [aux_sym_export_statement_repeat1] = STATE(1899),
    [sym_object] = STATE(310),
    [sym__property_name] = STATE(786),
    [aux_sym_object_repeat1] = STATE(185),
    [sym_assignment_pattern] = STATE(181),
    [sym_method_signature] = STATE(513),
    [sym_property_signature] = STATE(513),
    [sym_call_signature] = STATE(513),
    [sym_construct_signature] = STATE(513),
    [sym_export_statement] = STATE(513),
    [sym_method_definition] = STATE(181),
    [sym_index_signature] = STATE(513),
    [sym_decorator] = STATE(1899),
    [sym_accessibility_modifier] = STATE(787),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(786),
    [sym_array] = STATE(312),
    [sym_spread_element] = STATE(181),
    [sym_string] = STATE(786),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(4511),
    [anon_sym_LBRACK] = ACTIONS(2359),
    [anon_sym_SEMI] = ACTIONS(1222),
    [anon_sym_module] = ACTIONS(4513),
    [anon_sym_symbol] = ACTIONS(4513),
    [anon_sym_number] = ACTIONS(4513),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(4513),
    [anon_sym_COMMA] = ACTIONS(2363),
    [anon_sym_STAR] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(300),
    [anon_sym_void] = ACTIONS(4513),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(4513),
    [anon_sym_private] = ACTIONS(4515),
    [anon_sym_boolean] = ACTIONS(4513),
    [anon_sym_static] = ACTIONS(2369),
    [anon_sym_async] = ACTIONS(4517),
    [anon_sym_get] = ACTIONS(4519),
    [anon_sym_RBRACE] = ACTIONS(4954),
    [anon_sym_public] = ACTIONS(4515),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(4515),
    [anon_sym_string] = ACTIONS(4513),
    [anon_sym_set] = ACTIONS(4519),
    [anon_sym_type] = ACTIONS(4513),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(4513),
    [anon_sym_export] = ACTIONS(4523),
    [sym_readonly] = ACTIONS(2381),
    [anon_sym_namespace] = ACTIONS(4513),
    [anon_sym_PIPE_RBRACE] = ACTIONS(1232),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2166] = {
    [anon_sym_EQ_GT] = ACTIONS(4956),
    [sym_comment] = ACTIONS(3),
  },
  [2167] = {
    [sym_statement_block] = STATE(744),
    [sym__automatic_semicolon] = ACTIONS(4958),
    [anon_sym_SEMI] = ACTIONS(4958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4411),
  },
  [2168] = {
    [sym_statement_block] = STATE(1564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [2169] = {
    [sym_class_heritage] = STATE(2175),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_type_parameters] = STATE(2176),
    [sym_class_body] = STATE(831),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [2170] = {
    [sym_identifier] = ACTIONS(4960),
    [sym_comment] = ACTIONS(3),
  },
  [2171] = {
    [sym_class_body] = STATE(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [2172] = {
    [sym_statement_block] = STATE(949),
    [sym__automatic_semicolon] = ACTIONS(4962),
    [anon_sym_SEMI] = ACTIONS(4962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4411),
  },
  [2173] = {
    [anon_sym_EQ_GT] = ACTIONS(4964),
    [sym_comment] = ACTIONS(3),
  },
  [2174] = {
    [sym_statement_block] = STATE(1584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(448),
  },
  [2175] = {
    [sym_class_body] = STATE(999),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [2176] = {
    [sym_class_heritage] = STATE(2178),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(999),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [2177] = {
    [sym_identifier] = ACTIONS(4966),
    [sym_comment] = ACTIONS(3),
  },
  [2178] = {
    [sym_class_body] = STATE(1097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [2179] = {
    [sym_new_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_non_null_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_nested_identifier] = STATE(1520),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1220),
    [sym_this] = STATE(1220),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1220),
    [sym_generator_function] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1220),
    [sym_class] = STATE(1220),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(4968),
    [sym_false] = ACTIONS(1124),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(1124),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(1130),
    [sym_true] = ACTIONS(1124),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [2180] = {
    [sym_new_expression] = STATE(1218),
    [sym_augmented_assignment_expression] = STATE(1218),
    [sym_unary_expression] = STATE(1218),
    [sym_update_expression] = STATE(1218),
    [sym_regex] = STATE(1218),
    [sym_meta_property] = STATE(1218),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1218),
    [sym_yield_expression] = STATE(1218),
    [sym_as_expression] = STATE(1218),
    [sym_non_null_expression] = STATE(1218),
    [sym_internal_module] = STATE(1218),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1218),
    [sym_await_expression] = STATE(1218),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1218),
    [sym_this] = STATE(1218),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1218),
    [sym_generator_function] = STATE(1218),
    [sym_call_expression] = STATE(1218),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1218),
    [sym_ternary_expression] = STATE(1218),
    [sym_binary_expression] = STATE(1218),
    [sym_template_string] = STATE(1218),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1218),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1218),
    [sym_class] = STATE(1218),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(266),
    [sym_false] = ACTIONS(3894),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3894),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4970),
    [sym_true] = ACTIONS(3894),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3894),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [2181] = {
    [sym_type_alias_declaration] = STATE(1777),
    [sym_new_expression] = STATE(59),
    [sym__declaration] = STATE(1777),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_if_statement] = STATE(1777),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_do_statement] = STATE(1777),
    [sym_return_statement] = STATE(1777),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(53),
    [sym_arrow_function] = STATE(59),
    [sym_import_statement] = STATE(1777),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(1777),
    [sym_switch_statement] = STATE(1777),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_try_statement] = STATE(1777),
    [sym_throw_statement] = STATE(1777),
    [aux_sym_program_repeat1] = STATE(1777),
    [sym_object] = STATE(57),
    [sym_ambient_declaration] = STATE(1777),
    [sym_generator_function] = STATE(53),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_for_of_statement] = STATE(1777),
    [sym_decorator] = STATE(63),
    [sym_continue_statement] = STATE(1777),
    [sym_formal_parameters] = STATE(58),
    [sym_function_signature] = STATE(1777),
    [sym_abstract_class] = STATE(1777),
    [sym_interface_declaration] = STATE(1777),
    [sym_statement_block] = STATE(1777),
    [sym_update_expression] = STATE(59),
    [sym_while_statement] = STATE(1777),
    [sym_meta_property] = STATE(59),
    [sym_debugger_statement] = STATE(1777),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_enum_declaration] = STATE(1777),
    [sym_function] = STATE(60),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(1777),
    [sym_sequence_expression] = STATE(62),
    [sym_for_statement] = STATE(1777),
    [sym_this] = STATE(59),
    [sym_with_statement] = STATE(1777),
    [sym_empty_statement] = STATE(1777),
    [aux_sym_export_statement_repeat1] = STATE(63),
    [sym_import_alias] = STATE(1777),
    [sym_anonymous_class] = STATE(59),
    [sym_export_statement] = STATE(1777),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(1777),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_for_in_statement] = STATE(1777),
    [sym_break_statement] = STATE(1777),
    [sym_labeled_statement] = STATE(1777),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_module] = STATE(1777),
    [sym_class] = STATE(53),
    [sym_identifier] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_debugger] = ACTIONS(9),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_break] = ACTIONS(19),
    [anon_sym_const] = ACTIONS(21),
    [sym_super] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_RBRACE] = ACTIONS(4431),
    [anon_sym_interface] = ACTIONS(27),
    [anon_sym_enum] = ACTIONS(29),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_continue] = ACTIONS(33),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_if] = ACTIONS(37),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_throw] = ACTIONS(45),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_abstract] = ACTIONS(47),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(49),
    [anon_sym_import] = ACTIONS(51),
    [anon_sym_namespace] = ACTIONS(53),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_for] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(67),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(69),
    [anon_sym_declare] = ACTIONS(71),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(73),
    [anon_sym_switch] = ACTIONS(75),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(79),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(81),
    [anon_sym_while] = ACTIONS(85),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_try] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(99),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(105),
    [anon_sym_do] = ACTIONS(107),
    [anon_sym_TILDE] = ACTIONS(59),
    [anon_sym_with] = ACTIONS(109),
  },
  [2182] = {
    [sym_identifier] = ACTIONS(4972),
    [sym_comment] = ACTIONS(3),
  },
  [2183] = {
    [sym_identifier] = ACTIONS(4974),
    [sym_comment] = ACTIONS(3),
  },
  [2184] = {
    [sym_identifier] = ACTIONS(4976),
    [sym_comment] = ACTIONS(3),
  },
  [2185] = {
    [sym_identifier] = ACTIONS(4978),
    [sym_comment] = ACTIONS(3),
  },
  [2186] = {
    [sym_identifier] = ACTIONS(4980),
    [sym_comment] = ACTIONS(3),
  },
  [2187] = {
    [sym_identifier] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
  },
  [2188] = {
    [sym__initializer] = STATE(72),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(113),
    [anon_sym_AMP_EQ] = ACTIONS(113),
    [anon_sym_PLUS_EQ] = ACTIONS(113),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(113),
    [anon_sym_PIPE_EQ] = ACTIONS(113),
    [anon_sym_DASH_EQ] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(4984),
    [anon_sym_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(113),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(113),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(125),
  },
  [2189] = {
    [sym_variable_declarator] = STATE(1747),
    [sym_array] = STATE(97),
    [sym_object] = STATE(98),
    [sym_identifier] = ACTIONS(179),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_enum] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(185),
  },
  [2190] = {
    [sym_identifier] = ACTIONS(4988),
    [sym_comment] = ACTIONS(3),
  },
  [2191] = {
    [sym_identifier] = ACTIONS(4990),
    [sym_comment] = ACTIONS(3),
  },
  [2192] = {
    [sym_parenthesized_expression] = STATE(1752),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [2193] = {
    [sym_nested_identifier] = STATE(1224),
    [sym__module] = STATE(141),
    [sym_string] = STATE(1226),
    [sym__initializer] = STATE(80),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(322),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2194] = {
    [sym_class_heritage] = STATE(146),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(149),
    [anon_sym_extends] = ACTIONS(328),
    [sym_identifier] = ACTIONS(4992),
    [anon_sym_implements] = ACTIONS(332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [2195] = {
    [sym_type_alias_declaration] = STATE(160),
    [sym__declaration] = STATE(160),
    [sym__initializer] = STATE(80),
    [sym_internal_module] = STATE(160),
    [sym_enum_declaration] = STATE(160),
    [sym_function] = STATE(160),
    [sym_variable_declaration] = STATE(160),
    [aux_sym_export_statement_repeat1] = STATE(2233),
    [sym_ambient_declaration] = STATE(160),
    [sym_import_alias] = STATE(160),
    [sym_export_statement] = STATE(160),
    [sym_generator_function] = STATE(160),
    [sym_lexical_declaration] = STATE(160),
    [sym_decorator] = STATE(2233),
    [sym_function_signature] = STATE(160),
    [sym_abstract_class] = STATE(160),
    [sym_module] = STATE(160),
    [sym_interface_declaration] = STATE(160),
    [sym_class] = STATE(160),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_global] = ACTIONS(336),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_const] = ACTIONS(338),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_interface] = ACTIONS(340),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_abstract] = ACTIONS(4463),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4994),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(4457),
    [anon_sym_declare] = ACTIONS(4459),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_async] = ACTIONS(4469),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_var] = ACTIONS(360),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_function] = ACTIONS(4461),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_let] = ACTIONS(364),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(4465),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2196] = {
    [sym_new_expression] = STATE(2009),
    [sym_augmented_assignment_expression] = STATE(2009),
    [sym_unary_expression] = STATE(2009),
    [sym_regex] = STATE(2009),
    [sym_call_signature] = STATE(1740),
    [sym_rest_parameter] = STATE(198),
    [sym_yield_expression] = STATE(2009),
    [sym_as_expression] = STATE(2009),
    [sym_internal_module] = STATE(2009),
    [sym_accessibility_modifier] = STATE(200),
    [sym_arrow_function] = STATE(2009),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(2009),
    [sym_type_parameters] = STATE(55),
    [sym_object] = STATE(204),
    [sym_generator_function] = STATE(2009),
    [sym_subscript_expression] = STATE(1201),
    [sym_ternary_expression] = STATE(2009),
    [sym_template_string] = STATE(2009),
    [sym_decorator] = STATE(203),
    [sym_formal_parameters] = STATE(58),
    [sym_update_expression] = STATE(2009),
    [sym_meta_property] = STATE(2009),
    [sym__expression] = STATE(2009),
    [sym_non_null_expression] = STATE(2009),
    [sym_function] = STATE(1219),
    [sym_required_parameter] = STATE(198),
    [sym_await_expression] = STATE(2009),
    [sym_sequence_expression] = STATE(2010),
    [sym_this] = STATE(202),
    [aux_sym_export_statement_repeat1] = STATE(203),
    [sym_anonymous_class] = STATE(2009),
    [sym_optional_parameter] = STATE(198),
    [sym_call_expression] = STATE(2009),
    [sym_assignment_expression] = STATE(2009),
    [sym_binary_expression] = STATE(2009),
    [sym_type_arguments] = STATE(1205),
    [sym_parenthesized_expression] = STATE(2009),
    [sym_array] = STATE(205),
    [sym_type_assertion] = STATE(2009),
    [sym_class] = STATE(2009),
    [sym_identifier] = ACTIONS(408),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(410),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(412),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(414),
    [anon_sym_get] = ACTIONS(410),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(4542),
    [anon_sym_protected] = ACTIONS(414),
    [anon_sym_set] = ACTIONS(410),
    [anon_sym_type] = ACTIONS(410),
    [anon_sym_import] = ACTIONS(410),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_namespace] = ACTIONS(420),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(4542),
    [anon_sym_module] = ACTIONS(410),
    [anon_sym_number] = ACTIONS(410),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(410),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4542),
    [anon_sym_any] = ACTIONS(410),
    [anon_sym_boolean] = ACTIONS(410),
    [anon_sym_async] = ACTIONS(424),
    [anon_sym_public] = ACTIONS(414),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4996),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(410),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4542),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(410),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [2197] = {
    [sym_variable_declarator] = STATE(1784),
    [sym_array] = STATE(97),
    [sym_object] = STATE(98),
    [sym_identifier] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(185),
  },
  [2198] = {
    [sym_parenthesized_expression] = STATE(1785),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [2199] = {
    [sym_regex_pattern] = ACTIONS(4998),
    [sym_comment] = ACTIONS(256),
  },
  [2200] = {
    [sym_call_signature] = STATE(2111),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(5000),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_STAR] = ACTIONS(5002),
    [sym_comment] = ACTIONS(3),
  },
  [2201] = {
    [sym_variable_declarator] = STATE(1747),
    [sym_array] = STATE(97),
    [sym_object] = STATE(98),
    [sym_identifier] = ACTIONS(442),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(185),
  },
  [2202] = {
    [sym_type_alias_declaration] = STATE(261),
    [sym__declaration] = STATE(261),
    [sym__initializer] = STATE(80),
    [sym_internal_module] = STATE(261),
    [sym_enum_declaration] = STATE(261),
    [sym_function] = STATE(261),
    [sym_variable_declaration] = STATE(261),
    [aux_sym_export_statement_repeat1] = STATE(2233),
    [sym_ambient_declaration] = STATE(261),
    [sym_import_alias] = STATE(261),
    [sym_export_statement] = STATE(261),
    [sym_generator_function] = STATE(261),
    [sym_export_clause] = STATE(262),
    [sym_lexical_declaration] = STATE(261),
    [sym_decorator] = STATE(2233),
    [sym_function_signature] = STATE(261),
    [sym_abstract_class] = STATE(261),
    [sym_module] = STATE(261),
    [sym_interface_declaration] = STATE(261),
    [sym_class] = STATE(261),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(524),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(527),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_const] = ACTIONS(338),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_interface] = ACTIONS(340),
    [anon_sym_default] = ACTIONS(529),
    [anon_sym_as] = ACTIONS(531),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_abstract] = ACTIONS(4463),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(4467),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(4455),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_class] = ACTIONS(4457),
    [anon_sym_declare] = ACTIONS(4459),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_async] = ACTIONS(4469),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_var] = ACTIONS(360),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_function] = ACTIONS(4461),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_let] = ACTIONS(364),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(4465),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2203] = {
    [sym_parenthesized_expression] = STATE(1802),
    [anon_sym_LPAREN] = ACTIONS(211),
    [sym_comment] = ACTIONS(3),
  },
  [2204] = {
    [aux_sym_export_statement_repeat1] = STATE(284),
    [sym_decorator] = STATE(284),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(5004),
    [anon_sym_class] = ACTIONS(707),
    [sym_comment] = ACTIONS(3),
  },
  [2205] = {
    [sym_new_expression] = STATE(1807),
    [sym_augmented_assignment_expression] = STATE(1807),
    [sym_unary_expression] = STATE(1807),
    [sym_update_expression] = STATE(1807),
    [sym_regex] = STATE(1807),
    [sym_meta_property] = STATE(1807),
    [sym_call_signature] = STATE(2456),
    [sym_statement_block] = STATE(287),
    [sym__expression] = STATE(1807),
    [sym_yield_expression] = STATE(1807),
    [sym_as_expression] = STATE(1807),
    [sym_non_null_expression] = STATE(1807),
    [sym_internal_module] = STATE(1807),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1807),
    [sym_await_expression] = STATE(1807),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1807),
    [sym_this] = STATE(1807),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1807),
    [sym_generator_function] = STATE(1807),
    [sym_call_expression] = STATE(1807),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1807),
    [sym_ternary_expression] = STATE(1807),
    [sym_binary_expression] = STATE(1807),
    [sym_template_string] = STATE(1807),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1807),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1807),
    [sym_class] = STATE(1807),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(614),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5006),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5008),
    [sym_true] = ACTIONS(5006),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5006),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2206] = {
    [sym_new_expression] = STATE(1808),
    [sym_augmented_assignment_expression] = STATE(1808),
    [sym_unary_expression] = STATE(1808),
    [sym_update_expression] = STATE(1808),
    [sym_regex] = STATE(1808),
    [sym_meta_property] = STATE(1808),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(1808),
    [sym_yield_expression] = STATE(1808),
    [sym_as_expression] = STATE(1808),
    [sym_non_null_expression] = STATE(1808),
    [sym_internal_module] = STATE(1808),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1808),
    [sym_await_expression] = STATE(1808),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1808),
    [sym_this] = STATE(1808),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1808),
    [sym_generator_function] = STATE(1808),
    [sym_call_expression] = STATE(1808),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1808),
    [sym_ternary_expression] = STATE(1808),
    [sym_binary_expression] = STATE(1808),
    [sym_template_string] = STATE(1808),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1808),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1808),
    [sym_class] = STATE(1808),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(4347),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4347),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5010),
    [sym_true] = ACTIONS(4347),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(4347),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2207] = {
    [sym_new_expression] = STATE(1809),
    [sym_augmented_assignment_expression] = STATE(1809),
    [sym_unary_expression] = STATE(1809),
    [sym_update_expression] = STATE(1809),
    [sym_regex] = STATE(1809),
    [sym_meta_property] = STATE(1809),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(1809),
    [sym_yield_expression] = STATE(1809),
    [sym_as_expression] = STATE(1809),
    [sym_non_null_expression] = STATE(1809),
    [sym_internal_module] = STATE(1809),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1809),
    [sym_await_expression] = STATE(1809),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1809),
    [sym_this] = STATE(1809),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1809),
    [sym_generator_function] = STATE(1809),
    [sym_call_expression] = STATE(1809),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1809),
    [sym_ternary_expression] = STATE(1809),
    [sym_binary_expression] = STATE(1809),
    [sym_template_string] = STATE(1809),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1809),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1809),
    [sym_class] = STATE(1809),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5012),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5012),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5014),
    [sym_true] = ACTIONS(5012),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5012),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2208] = {
    [sym_new_expression] = STATE(1810),
    [sym_augmented_assignment_expression] = STATE(1810),
    [sym_unary_expression] = STATE(1810),
    [sym_update_expression] = STATE(1810),
    [sym_regex] = STATE(1810),
    [sym_meta_property] = STATE(1810),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(1810),
    [sym_yield_expression] = STATE(1810),
    [sym_as_expression] = STATE(1810),
    [sym_non_null_expression] = STATE(1810),
    [sym_internal_module] = STATE(1810),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1810),
    [sym_await_expression] = STATE(1810),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1810),
    [sym_this] = STATE(1810),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1810),
    [sym_generator_function] = STATE(1810),
    [sym_call_expression] = STATE(1810),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1810),
    [sym_ternary_expression] = STATE(1810),
    [sym_binary_expression] = STATE(1810),
    [sym_template_string] = STATE(1810),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1810),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1810),
    [sym_class] = STATE(1810),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5016),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5016),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5018),
    [sym_true] = ACTIONS(5016),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5016),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2209] = {
    [sym_new_expression] = STATE(1811),
    [sym_augmented_assignment_expression] = STATE(1811),
    [sym_unary_expression] = STATE(1811),
    [sym_update_expression] = STATE(1811),
    [sym_regex] = STATE(1811),
    [sym_meta_property] = STATE(1811),
    [sym_call_signature] = STATE(2456),
    [sym_statement_block] = STATE(298),
    [sym__expression] = STATE(1811),
    [sym_yield_expression] = STATE(1811),
    [sym_as_expression] = STATE(1811),
    [sym_non_null_expression] = STATE(1811),
    [sym_internal_module] = STATE(1811),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1811),
    [sym_await_expression] = STATE(1811),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1811),
    [sym_this] = STATE(1811),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1811),
    [sym_generator_function] = STATE(1811),
    [sym_call_expression] = STATE(1811),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1811),
    [sym_ternary_expression] = STATE(1811),
    [sym_binary_expression] = STATE(1811),
    [sym_template_string] = STATE(1811),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1811),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1811),
    [sym_class] = STATE(1811),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5020),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(614),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5020),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5022),
    [sym_true] = ACTIONS(5020),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5020),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2210] = {
    [sym_new_expression] = STATE(1812),
    [sym_augmented_assignment_expression] = STATE(1812),
    [sym_unary_expression] = STATE(1812),
    [sym_update_expression] = STATE(1812),
    [sym_regex] = STATE(1812),
    [sym_meta_property] = STATE(1812),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(1812),
    [sym_yield_expression] = STATE(1812),
    [sym_as_expression] = STATE(1812),
    [sym_non_null_expression] = STATE(1812),
    [sym_internal_module] = STATE(1812),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1812),
    [sym_await_expression] = STATE(1812),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1812),
    [sym_this] = STATE(1812),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1812),
    [sym_generator_function] = STATE(1812),
    [sym_call_expression] = STATE(1812),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1812),
    [sym_ternary_expression] = STATE(1812),
    [sym_binary_expression] = STATE(1812),
    [sym_template_string] = STATE(1812),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1812),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1812),
    [sym_class] = STATE(1812),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5024),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5024),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5026),
    [sym_true] = ACTIONS(5024),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5024),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2211] = {
    [sym_arguments] = STATE(303),
    [anon_sym_LBRACK] = ACTIONS(674),
    [sym_identifier] = ACTIONS(676),
    [anon_sym_module] = ACTIONS(676),
    [anon_sym_symbol] = ACTIONS(676),
    [anon_sym_number] = ACTIONS(676),
    [anon_sym_AT] = ACTIONS(674),
    [anon_sym_class] = ACTIONS(676),
    [anon_sym_declare] = ACTIONS(676),
    [anon_sym_STAR] = ACTIONS(674),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(674),
    [anon_sym_LBRACE] = ACTIONS(674),
    [anon_sym_void] = ACTIONS(676),
    [anon_sym_LPAREN] = ACTIONS(5028),
    [anon_sym_any] = ACTIONS(676),
    [anon_sym_private] = ACTIONS(676),
    [anon_sym_boolean] = ACTIONS(676),
    [anon_sym_async] = ACTIONS(676),
    [anon_sym_public] = ACTIONS(676),
    [anon_sym_get] = ACTIONS(676),
    [anon_sym_static] = ACTIONS(676),
    [anon_sym_RBRACE] = ACTIONS(674),
    [anon_sym_SQUOTE] = ACTIONS(674),
    [anon_sym_this] = ACTIONS(676),
    [sym_number] = ACTIONS(674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(676),
    [anon_sym_string] = ACTIONS(676),
    [anon_sym_abstract] = ACTIONS(676),
    [anon_sym_DOT] = ACTIONS(5030),
    [anon_sym_set] = ACTIONS(676),
    [anon_sym_type] = ACTIONS(676),
    [anon_sym_import] = ACTIONS(676),
    [anon_sym_export] = ACTIONS(676),
    [sym_readonly] = ACTIONS(676),
    [anon_sym_namespace] = ACTIONS(676),
    [anon_sym_DQUOTE] = ACTIONS(674),
  },
  [2212] = {
    [sym__initializer] = STATE(72),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4280),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4280),
    [anon_sym_AMP_EQ] = ACTIONS(4280),
    [anon_sym_PLUS_EQ] = ACTIONS(4280),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(4280),
    [anon_sym_STAR_EQ] = ACTIONS(4280),
    [anon_sym_PIPE_EQ] = ACTIONS(4280),
    [anon_sym_DASH_EQ] = ACTIONS(4280),
    [anon_sym_EQ_GT] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4280),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4280),
    [anon_sym_GT_GT_EQ] = ACTIONS(4280),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2455),
  },
  [2213] = {
    [sym_call_signature] = STATE(2467),
    [sym__initializer] = STATE(80),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(5032),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4290),
    [anon_sym_symbol] = ACTIONS(5034),
    [anon_sym_AMP_EQ] = ACTIONS(4290),
    [anon_sym_PLUS_EQ] = ACTIONS(4290),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_void] = ACTIONS(5034),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(4290),
    [anon_sym_private] = ACTIONS(5034),
    [anon_sym_PIPE_EQ] = ACTIONS(4290),
    [anon_sym_DASH_EQ] = ACTIONS(4290),
    [anon_sym_get] = ACTIONS(5034),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(4290),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(5034),
    [anon_sym_GT_GT_EQ] = ACTIONS(4290),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_set] = ACTIONS(5034),
    [anon_sym_type] = ACTIONS(5034),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(5034),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4290),
    [anon_sym_namespace] = ACTIONS(5034),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(5034),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4290),
    [anon_sym_number] = ACTIONS(5034),
    [anon_sym_declare] = ACTIONS(5034),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(5034),
    [anon_sym_STAR_EQ] = ACTIONS(4290),
    [anon_sym_boolean] = ACTIONS(5034),
    [anon_sym_async] = ACTIONS(5034),
    [anon_sym_public] = ACTIONS(5034),
    [anon_sym_EQ_GT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4290),
    [anon_sym_string] = ACTIONS(5034),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(5034),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2214] = {
    [sym_call_signature] = STATE(2022),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(5036),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_STAR] = ACTIONS(5038),
    [sym_comment] = ACTIONS(3),
  },
  [2215] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(702),
    [anon_sym_SEMI] = ACTIONS(700),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(700),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(5040),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [2216] = {
    [aux_sym_export_statement_repeat1] = STATE(284),
    [sym_decorator] = STATE(284),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(5043),
    [sym_comment] = ACTIONS(3),
  },
  [2217] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(700),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(700),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(5040),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [2218] = {
    [sym_identifier] = ACTIONS(5045),
    [sym_comment] = ACTIONS(3),
  },
  [2219] = {
    [sym_new_expression] = STATE(1820),
    [sym_augmented_assignment_expression] = STATE(1820),
    [sym_unary_expression] = STATE(1820),
    [sym_update_expression] = STATE(1820),
    [sym_regex] = STATE(1820),
    [sym_meta_property] = STATE(1820),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1820),
    [sym_yield_expression] = STATE(1820),
    [sym_as_expression] = STATE(1820),
    [sym_non_null_expression] = STATE(1820),
    [sym_internal_module] = STATE(1820),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1820),
    [sym_await_expression] = STATE(1820),
    [sym_member_expression] = STATE(1201),
    [sym_sequence_expression] = STATE(1821),
    [sym_string] = STATE(1820),
    [sym_this] = STATE(1820),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1820),
    [sym_generator_function] = STATE(1820),
    [sym_call_expression] = STATE(1820),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1820),
    [sym_ternary_expression] = STATE(1820),
    [sym_binary_expression] = STATE(1820),
    [sym_template_string] = STATE(1820),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1820),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1820),
    [sym_class] = STATE(1820),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(5047),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5047),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5047),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5049),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5047),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [2220] = {
    [sym__type] = STATE(1795),
    [sym_constructor_type] = STATE(1795),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1795),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(1795),
    [sym_intersection_type] = STATE(1795),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2221] = {
    [sym_new_expression] = STATE(199),
    [sym_augmented_assignment_expression] = STATE(199),
    [sym_unary_expression] = STATE(199),
    [sym_update_expression] = STATE(199),
    [sym_regex] = STATE(199),
    [sym_meta_property] = STATE(199),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(199),
    [sym_yield_expression] = STATE(199),
    [sym_as_expression] = STATE(199),
    [sym_non_null_expression] = STATE(199),
    [sym_internal_module] = STATE(199),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(199),
    [sym_await_expression] = STATE(199),
    [sym_member_expression] = STATE(1201),
    [sym_sequence_expression] = STATE(201),
    [sym_string] = STATE(199),
    [sym_this] = STATE(199),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(199),
    [sym_generator_function] = STATE(199),
    [sym_call_expression] = STATE(199),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(199),
    [sym_ternary_expression] = STATE(199),
    [sym_binary_expression] = STATE(199),
    [sym_template_string] = STATE(199),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(199),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(199),
    [sym_class] = STATE(199),
    [anon_sym_BANG] = ACTIONS(296),
    [sym_identifier] = ACTIONS(266),
    [sym_false] = ACTIONS(416),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(416),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(428),
    [sym_true] = ACTIONS(416),
    [anon_sym_yield] = ACTIONS(286),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(416),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
  },
  [2222] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(767),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(767),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2469),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2455),
  },
  [2223] = {
    [sym_identifier] = ACTIONS(5051),
    [sym_comment] = ACTIONS(3),
  },
  [2224] = {
    [sym_statement_block] = STATE(360),
    [sym__automatic_semicolon] = ACTIONS(799),
    [anon_sym_RBRACE] = ACTIONS(799),
    [anon_sym_SEMI] = ACTIONS(799),
    [anon_sym_DOT] = ACTIONS(2624),
    [anon_sym_PIPE_RBRACE] = ACTIONS(799),
    [anon_sym_COMMA] = ACTIONS(799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4411),
  },
  [2225] = {
    [sym_statement_block] = STATE(360),
    [sym__automatic_semicolon] = ACTIONS(799),
    [anon_sym_RBRACE] = ACTIONS(799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(799),
    [anon_sym_COMMA] = ACTIONS(799),
    [anon_sym_PIPE_RBRACE] = ACTIONS(799),
    [anon_sym_LBRACE] = ACTIONS(4411),
  },
  [2226] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(2453),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(811),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(811),
    [anon_sym_PIPE] = ACTIONS(2457),
    [anon_sym_LT_LT] = ACTIONS(2459),
    [anon_sym_DASH] = ACTIONS(2461),
    [anon_sym_STAR] = ACTIONS(2463),
    [anon_sym_GT_GT_GT] = ACTIONS(2459),
    [anon_sym_AMP_AMP] = ACTIONS(2465),
    [anon_sym_BANG_EQ] = ACTIONS(2455),
    [anon_sym_LT_EQ] = ACTIONS(2453),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(2453),
    [anon_sym_GT] = ACTIONS(2455),
    [anon_sym_AMP] = ACTIONS(2467),
    [anon_sym_PERCENT] = ACTIONS(2459),
    [anon_sym_QMARK] = ACTIONS(2469),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(2455),
    [anon_sym_instanceof] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(2473),
    [anon_sym_SLASH] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(2471),
    [anon_sym_STAR_STAR] = ACTIONS(2475),
    [anon_sym_PLUS] = ACTIONS(2461),
    [anon_sym_GT_GT] = ACTIONS(2463),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2453),
    [anon_sym_in] = ACTIONS(2455),
  },
  [2227] = {
    [sym_template_string] = STATE(102),
    [sym_arguments] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_SEMI] = ACTIONS(700),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym__automatic_semicolon] = ACTIONS(700),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(5040),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [2228] = {
    [sym_class_heritage] = STATE(2160),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_type_parameters] = STATE(2161),
    [sym_class_body] = STATE(383),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [2229] = {
    [sym_nested_identifier] = STATE(1224),
    [sym__module] = STATE(141),
    [sym_string] = STATE(1226),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_DOT] = ACTIONS(5053),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [sym_comment] = ACTIONS(3),
  },
  [2230] = {
    [sym_identifier] = ACTIONS(5055),
    [sym_comment] = ACTIONS(3),
  },
  [2231] = {
    [sym_type_alias_declaration] = STATE(160),
    [aux_sym_export_statement_repeat1] = STATE(2233),
    [sym__declaration] = STATE(160),
    [sym_ambient_declaration] = STATE(160),
    [sym_import_alias] = STATE(160),
    [sym_export_statement] = STATE(160),
    [sym_generator_function] = STATE(160),
    [sym_lexical_declaration] = STATE(160),
    [sym_internal_module] = STATE(160),
    [sym_decorator] = STATE(2233),
    [sym_enum_declaration] = STATE(160),
    [sym_function] = STATE(160),
    [sym_function_signature] = STATE(160),
    [sym_variable_declaration] = STATE(160),
    [sym_abstract_class] = STATE(160),
    [sym_module] = STATE(160),
    [sym_interface_declaration] = STATE(160),
    [sym_class] = STATE(160),
    [anon_sym_var] = ACTIONS(360),
    [anon_sym_interface] = ACTIONS(340),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_module] = ACTIONS(4994),
    [anon_sym_class] = ACTIONS(4457),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4459),
    [anon_sym_global] = ACTIONS(336),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(4461),
    [anon_sym_const] = ACTIONS(338),
    [anon_sym_abstract] = ACTIONS(4463),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_let] = ACTIONS(364),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_export] = ACTIONS(4465),
    [anon_sym_namespace] = ACTIONS(4467),
    [anon_sym_async] = ACTIONS(4469),
  },
  [2232] = {
    [sym_type_alias_declaration] = STATE(261),
    [sym__declaration] = STATE(261),
    [sym_internal_module] = STATE(261),
    [sym_enum_declaration] = STATE(261),
    [sym_function] = STATE(261),
    [sym_variable_declaration] = STATE(261),
    [aux_sym_export_statement_repeat1] = STATE(2233),
    [sym_ambient_declaration] = STATE(261),
    [sym_import_alias] = STATE(261),
    [sym_export_statement] = STATE(261),
    [sym_generator_function] = STATE(261),
    [sym_export_clause] = STATE(262),
    [sym_lexical_declaration] = STATE(261),
    [sym_decorator] = STATE(2233),
    [sym_function_signature] = STATE(261),
    [sym_abstract_class] = STATE(261),
    [sym_module] = STATE(261),
    [sym_interface_declaration] = STATE(261),
    [sym_class] = STATE(261),
    [anon_sym_module] = ACTIONS(4455),
    [anon_sym_class] = ACTIONS(4457),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(4459),
    [anon_sym_STAR] = ACTIONS(963),
    [anon_sym_LBRACE] = ACTIONS(536),
    [anon_sym_EQ] = ACTIONS(965),
    [anon_sym_const] = ACTIONS(338),
    [anon_sym_async] = ACTIONS(4469),
    [anon_sym_var] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(529),
    [anon_sym_interface] = ACTIONS(340),
    [anon_sym_enum] = ACTIONS(342),
    [anon_sym_as] = ACTIONS(967),
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(4461),
    [anon_sym_abstract] = ACTIONS(4463),
    [anon_sym_type] = ACTIONS(346),
    [anon_sym_let] = ACTIONS(364),
    [anon_sym_import] = ACTIONS(348),
    [anon_sym_export] = ACTIONS(4465),
    [anon_sym_namespace] = ACTIONS(4467),
  },
  [2233] = {
    [aux_sym_export_statement_repeat1] = STATE(284),
    [sym_decorator] = STATE(284),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_export] = ACTIONS(5004),
    [anon_sym_class] = ACTIONS(5057),
    [sym_comment] = ACTIONS(3),
  },
  [2234] = {
    [sym__property_name] = STATE(439),
    [sym_decorator] = STATE(2472),
    [aux_sym_export_statement_repeat1] = STATE(2472),
    [sym_accessibility_modifier] = STATE(180),
    [sym_computed_property_name] = STATE(439),
    [sym_method_definition] = STATE(1837),
    [sym_string] = STATE(439),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_class] = ACTIONS(1074),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_get] = ACTIONS(1080),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [sym_number] = ACTIONS(1082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1084),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2235] = {
    [sym_call_signature] = STATE(2116),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(5059),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2236] = {
    [sym__type] = STATE(1847),
    [sym_constructor_type] = STATE(1847),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1847),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(1847),
    [sym_intersection_type] = STATE(1847),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2237] = {
    [sym_nested_type_identifier] = STATE(519),
    [sym_nested_identifier] = STATE(2437),
    [sym_identifier] = ACTIONS(5061),
    [sym_comment] = ACTIONS(3),
  },
  [2238] = {
    [sym_formal_parameters] = STATE(1849),
    [sym_type_parameters] = STATE(2278),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2239] = {
    [sym__type] = STATE(1852),
    [sym_constructor_type] = STATE(1852),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1852),
    [sym_rest_parameter] = STATE(198),
    [sym_nested_identifier] = STATE(236),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(198),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(218),
    [sym_type_parameters] = STATE(233),
    [sym_this] = STATE(468),
    [sym_predefined_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_array_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(477),
    [sym_object] = STATE(465),
    [sym_nested_type_identifier] = STATE(234),
    [sym_optional_parameter] = STATE(198),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(477),
    [sym_union_type] = STATE(1852),
    [sym_intersection_type] = STATE(1852),
    [sym_formal_parameters] = STATE(238),
    [sym_array] = STATE(467),
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_symbol] = ACTIONS(1264),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(1264),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_this] = ACTIONS(1266),
    [sym_true] = ACTIONS(452),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(452),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1264),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(1264),
    [anon_sym_boolean] = ACTIONS(1264),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1264),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_export] = ACTIONS(1154),
  },
  [2240] = {
    [sym_formal_parameters] = STATE(1855),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2241] = {
    [anon_sym_DOT] = ACTIONS(4032),
    [sym_comment] = ACTIONS(3),
  },
  [2242] = {
    [sym_call_signature] = STATE(1857),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [2243] = {
    [sym_call_signature] = STATE(1858),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(5063),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2244] = {
    [sym_statement_block] = STATE(547),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4411),
  },
  [2245] = {
    [sym__initializer] = STATE(1211),
    [sym_arguments] = STATE(548),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1305),
    [sym__automatic_semicolon] = ACTIONS(1305),
    [anon_sym_PERCENT_EQ] = ACTIONS(1307),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_AMP_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_EQ] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_LT_LT] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1309),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_CARET_EQ] = ACTIONS(1307),
    [anon_sym_STAR_EQ] = ACTIONS(1307),
    [anon_sym_PIPE_EQ] = ACTIONS(1307),
    [anon_sym_DASH_EQ] = ACTIONS(1307),
    [anon_sym_EQ_GT] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_PERCENT] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_LT_LT_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1307),
    [anon_sym_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_CARET] = ACTIONS(1309),
    [anon_sym_STAR_STAR] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1307),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [2246] = {
    [sym__initializer] = STATE(1215),
    [sym_arguments] = STATE(550),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_SEMI] = ACTIONS(1315),
    [sym__automatic_semicolon] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_instanceof] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [2247] = {
    [sym_new_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(2350),
    [sym_update_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2350),
    [sym_yield_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_non_null_expression] = STATE(2350),
    [sym_internal_module] = STATE(2350),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2350),
    [sym_this] = STATE(2350),
    [sym_type_parameters] = STATE(55),
    [sym_arguments] = STATE(550),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2350),
    [sym_ternary_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2350),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [sym__automatic_semicolon] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(1323),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [sym_false] = ACTIONS(1323),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [sym_null] = ACTIONS(1323),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_EQ_GT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_LT] = ACTIONS(1319),
    [sym_number] = ACTIONS(1335),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [2248] = {
    [sym_call_signature] = STATE(2467),
    [sym__initializer] = STATE(1215),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_arguments] = STATE(550),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [sym__automatic_semicolon] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(5032),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(5034),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(5034),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(5034),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(5034),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_protected] = ACTIONS(5034),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_set] = ACTIONS(5034),
    [anon_sym_type] = ACTIONS(5034),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_import] = ACTIONS(5034),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_namespace] = ACTIONS(5034),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_SEMI] = ACTIONS(1315),
    [anon_sym_module] = ACTIONS(5034),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(5034),
    [anon_sym_declare] = ACTIONS(5034),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_any] = ACTIONS(5034),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(5034),
    [anon_sym_async] = ACTIONS(5034),
    [anon_sym_public] = ACTIONS(5034),
    [anon_sym_EQ_GT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(5034),
    [anon_sym_function] = ACTIONS(694),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_export] = ACTIONS(5034),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [2249] = {
    [sym_nested_identifier] = STATE(1592),
    [sym__module] = STATE(1483),
    [sym_string] = STATE(1594),
    [sym__initializer] = STATE(1215),
    [sym_arguments] = STATE(550),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_SEMI] = ACTIONS(1315),
    [sym__automatic_semicolon] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [2250] = {
    [sym_nested_identifier] = STATE(1224),
    [sym__module] = STATE(141),
    [sym_string] = STATE(1226),
    [sym_identifier] = ACTIONS(951),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SQUOTE] = ACTIONS(308),
  },
  [2251] = {
    [sym__from_clause] = STATE(1859),
    [anon_sym_from] = ACTIONS(797),
    [sym_comment] = ACTIONS(3),
  },
  [2252] = {
    [sym_new_expression] = STATE(1860),
    [sym_augmented_assignment_expression] = STATE(1860),
    [sym_unary_expression] = STATE(1860),
    [sym_update_expression] = STATE(1860),
    [sym_regex] = STATE(1860),
    [sym_meta_property] = STATE(1860),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(1860),
    [sym_yield_expression] = STATE(1860),
    [sym_as_expression] = STATE(1860),
    [sym_non_null_expression] = STATE(1860),
    [sym_internal_module] = STATE(1860),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1860),
    [sym_await_expression] = STATE(1860),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1860),
    [sym_this] = STATE(1860),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1860),
    [sym_generator_function] = STATE(1860),
    [sym_call_expression] = STATE(1860),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1860),
    [sym_ternary_expression] = STATE(1860),
    [sym_binary_expression] = STATE(1860),
    [sym_template_string] = STATE(1860),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1860),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1860),
    [sym_class] = STATE(1860),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5065),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5065),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5067),
    [sym_true] = ACTIONS(5065),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5065),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2253] = {
    [sym_new_expression] = STATE(1861),
    [sym_augmented_assignment_expression] = STATE(1861),
    [sym_unary_expression] = STATE(1861),
    [sym_update_expression] = STATE(1861),
    [sym_regex] = STATE(1861),
    [sym_meta_property] = STATE(1861),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(1861),
    [sym_yield_expression] = STATE(1861),
    [sym_as_expression] = STATE(1861),
    [sym_non_null_expression] = STATE(1861),
    [sym_internal_module] = STATE(1861),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1861),
    [sym_await_expression] = STATE(1861),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1861),
    [sym_this] = STATE(1861),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1861),
    [sym_generator_function] = STATE(1861),
    [sym_call_expression] = STATE(1861),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1861),
    [sym_ternary_expression] = STATE(1861),
    [sym_binary_expression] = STATE(1861),
    [sym_template_string] = STATE(1861),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1861),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1861),
    [sym_class] = STATE(1861),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5069),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5069),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5071),
    [sym_true] = ACTIONS(5069),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5069),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2254] = {
    [sym_new_expression] = STATE(1862),
    [sym_augmented_assignment_expression] = STATE(1862),
    [sym_unary_expression] = STATE(1862),
    [sym_update_expression] = STATE(1862),
    [sym_regex] = STATE(1862),
    [sym_meta_property] = STATE(1862),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(1862),
    [sym_yield_expression] = STATE(1862),
    [sym_as_expression] = STATE(1862),
    [sym_non_null_expression] = STATE(1862),
    [sym_internal_module] = STATE(1862),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1862),
    [sym_await_expression] = STATE(1862),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1862),
    [sym_this] = STATE(1862),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1862),
    [sym_generator_function] = STATE(1862),
    [sym_call_expression] = STATE(1862),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1862),
    [sym_ternary_expression] = STATE(1862),
    [sym_binary_expression] = STATE(1862),
    [sym_template_string] = STATE(1862),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1862),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1862),
    [sym_class] = STATE(1862),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5073),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5073),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5075),
    [sym_true] = ACTIONS(5073),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5073),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2255] = {
    [sym_new_expression] = STATE(1863),
    [sym_augmented_assignment_expression] = STATE(1863),
    [sym_unary_expression] = STATE(1863),
    [sym_update_expression] = STATE(1863),
    [sym_regex] = STATE(1863),
    [sym_meta_property] = STATE(1863),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(1863),
    [sym_yield_expression] = STATE(1863),
    [sym_as_expression] = STATE(1863),
    [sym_non_null_expression] = STATE(1863),
    [sym_internal_module] = STATE(1863),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1863),
    [sym_await_expression] = STATE(1863),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1863),
    [sym_this] = STATE(1863),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1863),
    [sym_generator_function] = STATE(1863),
    [sym_call_expression] = STATE(1863),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1863),
    [sym_ternary_expression] = STATE(1863),
    [sym_binary_expression] = STATE(1863),
    [sym_template_string] = STATE(1863),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1863),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1863),
    [sym_class] = STATE(1863),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5077),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5077),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5079),
    [sym_true] = ACTIONS(5077),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5077),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2256] = {
    [sym_new_expression] = STATE(1864),
    [sym_augmented_assignment_expression] = STATE(1864),
    [sym_unary_expression] = STATE(1864),
    [sym_update_expression] = STATE(1864),
    [sym_regex] = STATE(1864),
    [sym_meta_property] = STATE(1864),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(1864),
    [sym_yield_expression] = STATE(1864),
    [sym_as_expression] = STATE(1864),
    [sym_non_null_expression] = STATE(1864),
    [sym_internal_module] = STATE(1864),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1864),
    [sym_await_expression] = STATE(1864),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1864),
    [sym_this] = STATE(1864),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1864),
    [sym_generator_function] = STATE(1864),
    [sym_call_expression] = STATE(1864),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1864),
    [sym_ternary_expression] = STATE(1864),
    [sym_binary_expression] = STATE(1864),
    [sym_template_string] = STATE(1864),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1864),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1864),
    [sym_class] = STATE(1864),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5081),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5081),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5083),
    [sym_true] = ACTIONS(5081),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5081),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2257] = {
    [sym_new_expression] = STATE(1865),
    [sym_augmented_assignment_expression] = STATE(1865),
    [sym_unary_expression] = STATE(1865),
    [sym_update_expression] = STATE(1865),
    [sym_regex] = STATE(1865),
    [sym_meta_property] = STATE(1865),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1865),
    [sym_yield_expression] = STATE(1865),
    [sym_as_expression] = STATE(1865),
    [sym_non_null_expression] = STATE(1865),
    [sym_internal_module] = STATE(1865),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1865),
    [sym_await_expression] = STATE(1865),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1865),
    [sym_this] = STATE(1865),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1865),
    [sym_generator_function] = STATE(1865),
    [sym_call_expression] = STATE(1865),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1865),
    [sym_ternary_expression] = STATE(1865),
    [sym_binary_expression] = STATE(1865),
    [sym_template_string] = STATE(1865),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1865),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1865),
    [sym_class] = STATE(1865),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5085),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5085),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5085),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5087),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5085),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2258] = {
    [sym_new_expression] = STATE(1868),
    [sym_augmented_assignment_expression] = STATE(1868),
    [sym_unary_expression] = STATE(1868),
    [sym_update_expression] = STATE(1868),
    [sym_regex] = STATE(1868),
    [sym_meta_property] = STATE(1868),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(1868),
    [sym_yield_expression] = STATE(1868),
    [sym_as_expression] = STATE(1868),
    [sym_non_null_expression] = STATE(1868),
    [sym_internal_module] = STATE(1868),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1868),
    [sym_await_expression] = STATE(1868),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1868),
    [sym_this] = STATE(1868),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1868),
    [sym_generator_function] = STATE(1868),
    [sym_call_expression] = STATE(1868),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1868),
    [sym_ternary_expression] = STATE(1868),
    [sym_binary_expression] = STATE(1868),
    [sym_template_string] = STATE(1868),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1868),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1868),
    [sym_class] = STATE(1868),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5089),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5089),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5091),
    [sym_true] = ACTIONS(5089),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5089),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2259] = {
    [sym_class_heritage] = STATE(586),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(399),
    [anon_sym_extends] = ACTIONS(328),
    [sym_identifier] = ACTIONS(5093),
    [anon_sym_implements] = ACTIONS(332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(334),
  },
  [2260] = {
    [sym__property_name] = STATE(439),
    [sym_decorator] = STATE(2472),
    [aux_sym_export_statement_repeat1] = STATE(2472),
    [sym_accessibility_modifier] = STATE(180),
    [sym_computed_property_name] = STATE(439),
    [sym_method_definition] = STATE(1837),
    [sym_string] = STATE(439),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_STAR] = ACTIONS(376),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_get] = ACTIONS(1080),
    [anon_sym_public] = ACTIONS(1076),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [sym_number] = ACTIONS(1082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2261] = {
    [sym_call_signature] = STATE(2041),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(5095),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2262] = {
    [sym_call_signature] = STATE(2041),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2263] = {
    [anon_sym_else] = ACTIONS(5097),
    [sym_comment] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(1785),
  },
  [2264] = {
    [sym_class_heritage] = STATE(2288),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_type_parameters] = STATE(2289),
    [sym_class_body] = STATE(611),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [2265] = {
    [sym_tuple_type] = STATE(1496),
    [sym__type] = STATE(1877),
    [sym_constructor_type] = STATE(1877),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_array_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_function_type] = STATE(1877),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_nested_identifier] = STATE(2393),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(1877),
    [sym_intersection_type] = STATE(1877),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_this] = ACTIONS(1823),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_keyof] = ACTIONS(1805),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_PIPE] = ACTIONS(1813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(1801),
  },
  [2266] = {
    [sym_identifier] = ACTIONS(5099),
    [sym_comment] = ACTIONS(3),
  },
  [2267] = {
    [anon_sym_EQ] = ACTIONS(5101),
    [sym_comment] = ACTIONS(3),
  },
  [2268] = {
    [sym_identifier] = ACTIONS(5103),
    [sym_comment] = ACTIONS(3),
  },
  [2269] = {
    [sym_identifier] = ACTIONS(5105),
    [sym_comment] = ACTIONS(3),
  },
  [2270] = {
    [sym_new_expression] = STATE(656),
    [sym_augmented_assignment_expression] = STATE(656),
    [sym_unary_expression] = STATE(656),
    [sym_update_expression] = STATE(656),
    [sym_regex] = STATE(656),
    [sym_meta_property] = STATE(656),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(656),
    [sym_yield_expression] = STATE(656),
    [sym_as_expression] = STATE(656),
    [sym_non_null_expression] = STATE(656),
    [sym_internal_module] = STATE(656),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(656),
    [sym_await_expression] = STATE(656),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(656),
    [sym_this] = STATE(656),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(656),
    [sym_generator_function] = STATE(656),
    [sym_call_expression] = STATE(656),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(656),
    [sym_ternary_expression] = STATE(656),
    [sym_binary_expression] = STATE(656),
    [sym_template_string] = STATE(656),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(656),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(656),
    [sym_class] = STATE(656),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(1968),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1968),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(1968),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1974),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1968),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2271] = {
    [sym_new_expression] = STATE(1889),
    [sym_augmented_assignment_expression] = STATE(1889),
    [sym_unary_expression] = STATE(1889),
    [sym_update_expression] = STATE(1889),
    [sym_regex] = STATE(1889),
    [sym_meta_property] = STATE(1889),
    [sym_call_signature] = STATE(2456),
    [sym_statement_block] = STATE(739),
    [sym__expression] = STATE(1889),
    [sym_yield_expression] = STATE(1889),
    [sym_as_expression] = STATE(1889),
    [sym_non_null_expression] = STATE(1889),
    [sym_internal_module] = STATE(1889),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1889),
    [sym_await_expression] = STATE(1889),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1889),
    [sym_this] = STATE(1889),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1889),
    [sym_generator_function] = STATE(1889),
    [sym_call_expression] = STATE(1889),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1889),
    [sym_ternary_expression] = STATE(1889),
    [sym_binary_expression] = STATE(1889),
    [sym_template_string] = STATE(1889),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1889),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1889),
    [sym_class] = STATE(1889),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5107),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(614),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5107),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5109),
    [sym_true] = ACTIONS(5107),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5107),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2272] = {
    [sym_new_expression] = STATE(1890),
    [sym_augmented_assignment_expression] = STATE(1890),
    [sym_unary_expression] = STATE(1890),
    [sym_update_expression] = STATE(1890),
    [sym_regex] = STATE(1890),
    [sym_meta_property] = STATE(1890),
    [sym_call_signature] = STATE(2456),
    [sym_statement_block] = STATE(741),
    [sym__expression] = STATE(1890),
    [sym_yield_expression] = STATE(1890),
    [sym_as_expression] = STATE(1890),
    [sym_non_null_expression] = STATE(1890),
    [sym_internal_module] = STATE(1890),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1890),
    [sym_await_expression] = STATE(1890),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1890),
    [sym_this] = STATE(1890),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1890),
    [sym_generator_function] = STATE(1890),
    [sym_call_expression] = STATE(1890),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1890),
    [sym_ternary_expression] = STATE(1890),
    [sym_binary_expression] = STATE(1890),
    [sym_template_string] = STATE(1890),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1890),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1890),
    [sym_class] = STATE(1890),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5111),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(614),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5111),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5113),
    [sym_true] = ACTIONS(5111),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5111),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2273] = {
    [sym_call_signature] = STATE(1891),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [2274] = {
    [sym_statement_block] = STATE(744),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4411),
  },
  [2275] = {
    [sym__type] = STATE(1892),
    [sym_constructor_type] = STATE(1892),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1892),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(1892),
    [sym_intersection_type] = STATE(1892),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2276] = {
    [sym__type] = STATE(1852),
    [sym_constructor_type] = STATE(1852),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1852),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(1852),
    [sym_intersection_type] = STATE(1852),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2277] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(1893),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(1893),
    [sym_call_signature] = STATE(1893),
    [sym_construct_signature] = STATE(1893),
    [sym_index_signature] = STATE(1893),
    [sym_export_statement] = STATE(1893),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2278] = {
    [sym_formal_parameters] = STATE(1897),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2279] = {
    [sym__type] = STATE(1901),
    [sym_constructor_type] = STATE(1901),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(1901),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(1901),
    [sym_intersection_type] = STATE(1901),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2280] = {
    [sym_call_signature] = STATE(1902),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2281] = {
    [sym_statement_block] = STATE(807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4411),
  },
  [2282] = {
    [sym_identifier] = ACTIONS(5115),
    [sym_comment] = ACTIONS(3),
  },
  [2283] = {
    [sym_new_expression] = STATE(2217),
    [sym_augmented_assignment_expression] = STATE(2217),
    [sym_unary_expression] = STATE(2217),
    [sym_update_expression] = STATE(2217),
    [sym_regex] = STATE(2217),
    [sym_meta_property] = STATE(2217),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(2217),
    [sym_yield_expression] = STATE(2217),
    [sym_as_expression] = STATE(2217),
    [sym_non_null_expression] = STATE(2217),
    [sym_internal_module] = STATE(2217),
    [sym_nested_identifier] = STATE(516),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(2217),
    [sym_await_expression] = STATE(2217),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(2217),
    [sym_this] = STATE(2217),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(2217),
    [sym_generator_function] = STATE(2217),
    [sym_call_expression] = STATE(2217),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(2217),
    [sym_ternary_expression] = STATE(2217),
    [sym_binary_expression] = STATE(2217),
    [sym_template_string] = STATE(2217),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2217),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(2217),
    [sym_class] = STATE(2217),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(5117),
    [sym_false] = ACTIONS(4294),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4294),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(4298),
    [sym_true] = ACTIONS(4294),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(4294),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2284] = {
    [sym_new_expression] = STATE(2215),
    [sym_augmented_assignment_expression] = STATE(2215),
    [sym_unary_expression] = STATE(2215),
    [sym_update_expression] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_meta_property] = STATE(2215),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(2215),
    [sym_yield_expression] = STATE(2215),
    [sym_as_expression] = STATE(2215),
    [sym_non_null_expression] = STATE(2215),
    [sym_internal_module] = STATE(2215),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(2215),
    [sym_await_expression] = STATE(2215),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(2215),
    [sym_this] = STATE(2215),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(2215),
    [sym_generator_function] = STATE(2215),
    [sym_call_expression] = STATE(2215),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(2215),
    [sym_ternary_expression] = STATE(2215),
    [sym_binary_expression] = STATE(2215),
    [sym_template_string] = STATE(2215),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2215),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(2215),
    [sym_class] = STATE(2215),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5119),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(2534),
    [sym_true] = ACTIONS(5119),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5119),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2285] = {
    [sym_new_expression] = STATE(244),
    [sym_augmented_assignment_expression] = STATE(250),
    [sym_unary_expression] = STATE(250),
    [sym_update_expression] = STATE(250),
    [sym_regex] = STATE(244),
    [sym_meta_property] = STATE(244),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(250),
    [sym_yield_expression] = STATE(250),
    [sym_as_expression] = STATE(250),
    [sym_non_null_expression] = STATE(250),
    [sym_internal_module] = STATE(250),
    [sym_function] = STATE(251),
    [sym_arrow_function] = STATE(244),
    [sym_await_expression] = STATE(250),
    [sym_member_expression] = STATE(252),
    [sym_string] = STATE(244),
    [sym_this] = STATE(244),
    [sym_type_parameters] = STATE(825),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(253),
    [sym_anonymous_class] = STATE(244),
    [sym_generator_function] = STATE(244),
    [sym_call_expression] = STATE(250),
    [sym_subscript_expression] = STATE(252),
    [sym_assignment_expression] = STATE(250),
    [sym_ternary_expression] = STATE(250),
    [sym_binary_expression] = STATE(250),
    [sym_template_string] = STATE(244),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(826),
    [sym_parenthesized_expression] = STATE(244),
    [sym_array] = STATE(254),
    [sym_type_assertion] = STATE(250),
    [sym_class] = STATE(244),
    [sym_identifier] = ACTIONS(5121),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(5123),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(5125),
    [sym_super] = ACTIONS(502),
    [anon_sym_private] = ACTIONS(5123),
    [anon_sym_get] = ACTIONS(5123),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(510),
    [anon_sym_protected] = ACTIONS(5123),
    [anon_sym_DOT] = ACTIONS(512),
    [anon_sym_set] = ACTIONS(5123),
    [anon_sym_type] = ACTIONS(5123),
    [anon_sym_import] = ACTIONS(5123),
    [anon_sym_namespace] = ACTIONS(5127),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(510),
    [anon_sym_module] = ACTIONS(5123),
    [anon_sym_number] = ACTIONS(5123),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(5123),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(510),
    [anon_sym_any] = ACTIONS(5123),
    [anon_sym_boolean] = ACTIONS(5123),
    [anon_sym_async] = ACTIONS(5129),
    [anon_sym_public] = ACTIONS(5123),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(522),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5123),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(510),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(5123),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2286] = {
    [sym_new_expression] = STATE(1906),
    [sym_augmented_assignment_expression] = STATE(1906),
    [sym_unary_expression] = STATE(1906),
    [sym_update_expression] = STATE(1906),
    [sym_regex] = STATE(1906),
    [sym_meta_property] = STATE(1906),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(1906),
    [sym_yield_expression] = STATE(1906),
    [sym_as_expression] = STATE(1906),
    [sym_non_null_expression] = STATE(1906),
    [sym_internal_module] = STATE(1906),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1906),
    [sym_await_expression] = STATE(1906),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1906),
    [sym_this] = STATE(1906),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1906),
    [sym_generator_function] = STATE(1906),
    [sym_call_expression] = STATE(1906),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1906),
    [sym_ternary_expression] = STATE(1906),
    [sym_binary_expression] = STATE(1906),
    [sym_template_string] = STATE(1906),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1906),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1906),
    [sym_class] = STATE(1906),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5131),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5131),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5133),
    [sym_true] = ACTIONS(5131),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5131),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2287] = {
    [sym_call_signature] = STATE(1909),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2288] = {
    [sym_class_body] = STATE(841),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [2289] = {
    [sym_class_heritage] = STATE(2296),
    [sym_extends_clause] = STATE(147),
    [sym_implements_clause] = STATE(148),
    [sym_class_body] = STATE(841),
    [anon_sym_extends] = ACTIONS(913),
    [anon_sym_implements] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [2290] = {
    [sym_tuple_type] = STATE(1496),
    [sym__type] = STATE(1913),
    [sym_constructor_type] = STATE(1913),
    [sym_index_type_query] = STATE(1496),
    [sym_lookup_type] = STATE(1496),
    [sym_this_type] = STATE(1496),
    [sym_flow_maybe_type] = STATE(1496),
    [sym_array_type] = STATE(1496),
    [sym_nested_type_identifier] = STATE(1495),
    [sym_function_type] = STATE(1913),
    [sym_type_predicate] = STATE(1496),
    [sym_type_query] = STATE(1496),
    [sym__number] = STATE(1488),
    [sym_existential_type] = STATE(1496),
    [sym_nested_identifier] = STATE(2393),
    [sym_object_type] = STATE(1496),
    [sym_union_type] = STATE(1913),
    [sym_intersection_type] = STATE(1913),
    [sym__primary_type] = STATE(1496),
    [sym_generic_type] = STATE(1496),
    [sym_mapped_type] = STATE(1496),
    [sym_literal_type] = STATE(1496),
    [sym_parenthesized_type] = STATE(1496),
    [sym_predefined_type] = STATE(1496),
    [sym_type_parameters] = STATE(2392),
    [sym_string] = STATE(1488),
    [sym_formal_parameters] = STATE(2020),
    [sym_identifier] = ACTIONS(1795),
    [sym_false] = ACTIONS(1797),
    [anon_sym_QMARK] = ACTIONS(1821),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1817),
    [anon_sym_LBRACK] = ACTIONS(1799),
    [anon_sym_AMP] = ACTIONS(1819),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_number] = ACTIONS(1801),
    [anon_sym_symbol] = ACTIONS(1801),
    [anon_sym_this] = ACTIONS(1823),
    [anon_sym_typeof] = ACTIONS(1803),
    [anon_sym_DASH] = ACTIONS(1807),
    [anon_sym_STAR] = ACTIONS(1809),
    [anon_sym_keyof] = ACTIONS(1805),
    [sym_number] = ACTIONS(1825),
    [sym_true] = ACTIONS(1797),
    [anon_sym_void] = ACTIONS(1801),
    [anon_sym_string] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1811),
    [anon_sym_new] = ACTIONS(1827),
    [anon_sym_LPAREN] = ACTIONS(1815),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_PLUS] = ACTIONS(1807),
    [anon_sym_PIPE] = ACTIONS(1813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_any] = ACTIONS(1801),
    [anon_sym_DQUOTE] = ACTIONS(943),
    [anon_sym_boolean] = ACTIONS(1801),
  },
  [2291] = {
    [sym_new_expression] = STATE(2300),
    [sym_augmented_assignment_expression] = STATE(2300),
    [sym_unary_expression] = STATE(2300),
    [sym_update_expression] = STATE(2300),
    [sym_regex] = STATE(2300),
    [sym_meta_property] = STATE(2300),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(2300),
    [sym_yield_expression] = STATE(2300),
    [sym_as_expression] = STATE(2300),
    [sym_non_null_expression] = STATE(2300),
    [sym_internal_module] = STATE(2300),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2300),
    [sym_await_expression] = STATE(2300),
    [sym_member_expression] = STATE(1201),
    [sym_sequence_expression] = STATE(2301),
    [sym_string] = STATE(2300),
    [sym_this] = STATE(2300),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(2300),
    [sym_generator_function] = STATE(2300),
    [sym_call_expression] = STATE(2300),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(2300),
    [sym_ternary_expression] = STATE(2300),
    [sym_binary_expression] = STATE(2300),
    [sym_template_string] = STATE(2300),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2300),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(2300),
    [sym_class] = STATE(2300),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(5135),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5135),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5135),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(5137),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5139),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5135),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [2292] = {
    [sym_call_signature] = STATE(1915),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(5141),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [2293] = {
    [sym_statement_block] = STATE(986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4411),
  },
  [2294] = {
    [sym_new_expression] = STATE(1919),
    [sym_augmented_assignment_expression] = STATE(1919),
    [sym_unary_expression] = STATE(1919),
    [sym_update_expression] = STATE(1919),
    [sym_regex] = STATE(1919),
    [sym_meta_property] = STATE(1919),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(1919),
    [sym_yield_expression] = STATE(1919),
    [sym_as_expression] = STATE(1919),
    [sym_non_null_expression] = STATE(1919),
    [sym_internal_module] = STATE(1919),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(1919),
    [sym_await_expression] = STATE(1919),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(1919),
    [sym_this] = STATE(1919),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(1919),
    [sym_generator_function] = STATE(1919),
    [sym_call_expression] = STATE(1919),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(1919),
    [sym_ternary_expression] = STATE(1919),
    [sym_binary_expression] = STATE(1919),
    [sym_template_string] = STATE(1919),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1919),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(1919),
    [sym_class] = STATE(1919),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5143),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5143),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5145),
    [sym_true] = ACTIONS(5143),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5143),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2295] = {
    [sym__initializer] = STATE(72),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4280),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4280),
    [anon_sym_AMP_EQ] = ACTIONS(4280),
    [anon_sym_PLUS_EQ] = ACTIONS(4280),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_CARET_EQ] = ACTIONS(4280),
    [anon_sym_STAR_EQ] = ACTIONS(4280),
    [anon_sym_PIPE_EQ] = ACTIONS(4280),
    [anon_sym_DASH_EQ] = ACTIONS(4280),
    [anon_sym_EQ_GT] = ACTIONS(4284),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4280),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4280),
    [anon_sym_GT_GT_EQ] = ACTIONS(4280),
    [anon_sym_DOT] = ACTIONS(5147),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2455),
  },
  [2296] = {
    [sym_class_body] = STATE(1005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(4369),
  },
  [2297] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_RPAREN] = ACTIONS(5149),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [2298] = {
    [anon_sym_RPAREN] = ACTIONS(5149),
    [sym_comment] = ACTIONS(3),
  },
  [2299] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5151),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2300] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(5153),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2301] = {
    [anon_sym_RPAREN] = ACTIONS(5153),
    [sym_comment] = ACTIONS(3),
  },
  [2302] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5155),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2303] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_RPAREN] = ACTIONS(5157),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [2304] = {
    [anon_sym_RPAREN] = ACTIONS(5157),
    [sym_comment] = ACTIONS(3),
  },
  [2305] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5159),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2306] = {
    [sym_template_string] = STATE(102),
    [sym_type_arguments] = STATE(103),
    [sym_arguments] = STATE(102),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [sym__automatic_semicolon] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(580),
    [anon_sym_STAR] = ACTIONS(584),
    [anon_sym_GT_GT_GT] = ACTIONS(578),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(578),
    [anon_sym_as] = ACTIONS(592),
    [anon_sym_DASH_DASH] = ACTIONS(594),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(598),
    [anon_sym_PLUS_PLUS] = ACTIONS(594),
    [anon_sym_BANG] = ACTIONS(600),
    [anon_sym_LBRACK] = ACTIONS(187),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_RPAREN] = ACTIONS(5161),
    [anon_sym_LT] = ACTIONS(596),
    [anon_sym_SLASH] = ACTIONS(584),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(580),
    [anon_sym_GT_GT] = ACTIONS(584),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [2307] = {
    [anon_sym_RPAREN] = ACTIONS(5161),
    [sym_comment] = ACTIONS(3),
  },
  [2308] = {
    [sym_call_signature] = STATE(1930),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [2309] = {
    [sym_call_signature] = STATE(1930),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(5163),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [2310] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5165),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2311] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5167),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2312] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5169),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2313] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(5171),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2314] = {
    [anon_sym_RPAREN] = ACTIONS(5171),
    [sym_comment] = ACTIONS(3),
  },
  [2315] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(5173),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2316] = {
    [anon_sym_RPAREN] = ACTIONS(5173),
    [sym_comment] = ACTIONS(3),
  },
  [2317] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(847),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(1146),
    [anon_sym_LT_LT] = ACTIONS(851),
    [anon_sym_DASH] = ACTIONS(853),
    [anon_sym_GT_GT_GT] = ACTIONS(851),
    [anon_sym_AMP_AMP] = ACTIONS(855),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_BANG_EQ] = ACTIONS(847),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(847),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_PERCENT] = ACTIONS(851),
    [anon_sym_QMARK] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(865),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(847),
    [anon_sym_instanceof] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_RPAREN] = ACTIONS(5175),
    [anon_sym_SLASH] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(875),
    [anon_sym_PLUS] = ACTIONS(853),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2318] = {
    [anon_sym_RPAREN] = ACTIONS(5175),
    [sym_comment] = ACTIONS(3),
  },
  [2319] = {
    [sym_call_signature] = STATE(1938),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [2320] = {
    [sym_call_signature] = STATE(1938),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(5177),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [2321] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5179),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2322] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5181),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2323] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5183),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2324] = {
    [sym_call_signature] = STATE(1942),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [2325] = {
    [sym_call_signature] = STATE(1942),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(5185),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [2326] = {
    [sym_call_signature] = STATE(1943),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [2327] = {
    [sym_call_signature] = STATE(1943),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_QMARK] = ACTIONS(5187),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [2328] = {
    [sym_call_signature] = STATE(1944),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [2329] = {
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4632),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4632),
    [anon_sym_AMP_EQ] = ACTIONS(4632),
    [anon_sym_PLUS_EQ] = ACTIONS(4632),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1913),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(4632),
    [anon_sym_STAR_EQ] = ACTIONS(4632),
    [anon_sym_PIPE_EQ] = ACTIONS(4632),
    [anon_sym_DASH_EQ] = ACTIONS(4632),
    [anon_sym_EQ_GT] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4632),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4632),
    [anon_sym_GT_GT_EQ] = ACTIONS(4632),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_implements] = ACTIONS(135),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4632),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2330] = {
    [sym_new_expression] = STATE(2414),
    [sym_augmented_assignment_expression] = STATE(2414),
    [sym_unary_expression] = STATE(2414),
    [sym_update_expression] = STATE(2414),
    [sym_regex] = STATE(2414),
    [sym_meta_property] = STATE(2414),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2414),
    [sym_yield_expression] = STATE(2414),
    [sym_as_expression] = STATE(2414),
    [sym_non_null_expression] = STATE(2414),
    [sym_internal_module] = STATE(2414),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2414),
    [sym_await_expression] = STATE(2414),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2414),
    [sym_this] = STATE(2414),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2414),
    [sym_generator_function] = STATE(2414),
    [sym_call_expression] = STATE(2414),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2414),
    [sym_ternary_expression] = STATE(2414),
    [sym_binary_expression] = STATE(2414),
    [sym_template_string] = STATE(2414),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2414),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2414),
    [sym_class] = STATE(2414),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4932),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4932),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5189),
    [sym_true] = ACTIONS(4932),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4932),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [2331] = {
    [sym_new_expression] = STATE(2415),
    [sym_augmented_assignment_expression] = STATE(2415),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(2415),
    [sym_update_expression] = STATE(2415),
    [sym_regex] = STATE(2415),
    [sym_meta_property] = STATE(2415),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2415),
    [sym_yield_expression] = STATE(2415),
    [sym_as_expression] = STATE(2415),
    [sym_non_null_expression] = STATE(2415),
    [sym_internal_module] = STATE(2415),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2415),
    [sym_await_expression] = STATE(2415),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2415),
    [sym_this] = STATE(2415),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2415),
    [sym_generator_function] = STATE(2415),
    [sym_call_expression] = STATE(2415),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2415),
    [sym_ternary_expression] = STATE(2415),
    [sym_binary_expression] = STATE(2415),
    [sym_template_string] = STATE(2415),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2415),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2415),
    [sym_class] = STATE(2415),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4606),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(4632),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_AMP_EQ] = ACTIONS(4632),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4632),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1913),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(4632),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_PIPE_EQ] = ACTIONS(4632),
    [anon_sym_DASH_EQ] = ACTIONS(4632),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(4632),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(903),
    [sym_true] = ACTIONS(4673),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_GT_GT_EQ] = ACTIONS(4632),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4632),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(4675),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(4673),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4632),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4673),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_STAR_EQ] = ACTIONS(4632),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_EQ_GT] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(4677),
    [anon_sym_SLASH] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4632),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4673),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_implements] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2332] = {
    [sym_new_expression] = STATE(2415),
    [sym_augmented_assignment_expression] = STATE(2415),
    [sym_unary_expression] = STATE(2415),
    [sym_update_expression] = STATE(2415),
    [sym_regex] = STATE(2415),
    [sym_meta_property] = STATE(2415),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2415),
    [sym_yield_expression] = STATE(2415),
    [sym_as_expression] = STATE(2415),
    [sym_non_null_expression] = STATE(2415),
    [sym_internal_module] = STATE(2415),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2415),
    [sym_await_expression] = STATE(2415),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2415),
    [sym_this] = STATE(2415),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2415),
    [sym_generator_function] = STATE(2415),
    [sym_call_expression] = STATE(2415),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2415),
    [sym_ternary_expression] = STATE(2415),
    [sym_binary_expression] = STATE(2415),
    [sym_template_string] = STATE(2415),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2415),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2415),
    [sym_class] = STATE(2415),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(4673),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4673),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4677),
    [sym_true] = ACTIONS(4673),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4673),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [2333] = {
    [sym_new_expression] = STATE(1222),
    [sym_augmented_assignment_expression] = STATE(1222),
    [sym_unary_expression] = STATE(1222),
    [sym_update_expression] = STATE(1222),
    [sym_regex] = STATE(1222),
    [sym_meta_property] = STATE(1222),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(1222),
    [sym_yield_expression] = STATE(1222),
    [sym_as_expression] = STATE(1222),
    [sym_non_null_expression] = STATE(1222),
    [sym_internal_module] = STATE(1222),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1222),
    [sym_await_expression] = STATE(1222),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(1222),
    [sym_this] = STATE(1222),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(1222),
    [sym_generator_function] = STATE(1222),
    [sym_call_expression] = STATE(1222),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(1222),
    [sym_ternary_expression] = STATE(1222),
    [sym_binary_expression] = STATE(1222),
    [sym_template_string] = STATE(1222),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1222),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(1222),
    [sym_class] = STATE(1222),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(3898),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3898),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(3900),
    [sym_true] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3898),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [2334] = {
    [sym_new_expression] = STATE(1956),
    [sym_augmented_assignment_expression] = STATE(1956),
    [sym_unary_expression] = STATE(1956),
    [sym_update_expression] = STATE(1956),
    [sym_regex] = STATE(1956),
    [sym_meta_property] = STATE(1956),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(1956),
    [sym_yield_expression] = STATE(1956),
    [sym_as_expression] = STATE(1956),
    [sym_non_null_expression] = STATE(1956),
    [sym_internal_module] = STATE(1956),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1956),
    [sym_await_expression] = STATE(1956),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(1956),
    [sym_this] = STATE(1956),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(1956),
    [sym_generator_function] = STATE(1956),
    [sym_call_expression] = STATE(1956),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(1956),
    [sym_ternary_expression] = STATE(1956),
    [sym_binary_expression] = STATE(1956),
    [sym_template_string] = STATE(1956),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1956),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(1956),
    [sym_class] = STATE(1956),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(217),
    [sym_identifier] = ACTIONS(4606),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_COMMA] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT_GT_GT] = ACTIONS(217),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_BANG_EQ] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(217),
    [anon_sym_as] = ACTIONS(219),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_instanceof] = ACTIONS(219),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(903),
    [sym_true] = ACTIONS(5191),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_DOT] = ACTIONS(219),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_STAR_STAR] = ACTIONS(217),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(4675),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5191),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5191),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(217),
    [anon_sym_PIPE_PIPE] = ACTIONS(217),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(5193),
    [anon_sym_SLASH] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5191),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_CARET] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_implements] = ACTIONS(219),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(217),
    [anon_sym_in] = ACTIONS(219),
  },
  [2335] = {
    [sym_nested_identifier] = STATE(1592),
    [sym__module] = STATE(1483),
    [sym_string] = STATE(1594),
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_PERCENT_EQ] = ACTIONS(4632),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4632),
    [anon_sym_AMP_EQ] = ACTIONS(4632),
    [anon_sym_PLUS_EQ] = ACTIONS(4632),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(135),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1913),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(4632),
    [anon_sym_STAR_EQ] = ACTIONS(4632),
    [anon_sym_PIPE_EQ] = ACTIONS(4632),
    [anon_sym_DASH_EQ] = ACTIONS(4632),
    [anon_sym_EQ_GT] = ACTIONS(4131),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4632),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4632),
    [anon_sym_GT_GT_EQ] = ACTIONS(4632),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_implements] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4632),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2336] = {
    [sym_new_expression] = STATE(1957),
    [sym_augmented_assignment_expression] = STATE(1957),
    [sym_unary_expression] = STATE(1957),
    [sym_update_expression] = STATE(1957),
    [sym_regex] = STATE(1957),
    [sym_meta_property] = STATE(1957),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(1957),
    [sym_yield_expression] = STATE(1957),
    [sym_as_expression] = STATE(1957),
    [sym_non_null_expression] = STATE(1957),
    [sym_internal_module] = STATE(1957),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1957),
    [sym_await_expression] = STATE(1957),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(1957),
    [sym_this] = STATE(1957),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(1957),
    [sym_generator_function] = STATE(1957),
    [sym_call_expression] = STATE(1957),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(1957),
    [sym_ternary_expression] = STATE(1957),
    [sym_binary_expression] = STATE(1957),
    [sym_template_string] = STATE(1957),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1957),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(1957),
    [sym_class] = STATE(1957),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(5195),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5195),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5197),
    [sym_true] = ACTIONS(5195),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5195),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [2337] = {
    [sym_new_expression] = STATE(2416),
    [sym_augmented_assignment_expression] = STATE(2416),
    [sym_unary_expression] = STATE(2416),
    [sym_update_expression] = STATE(2416),
    [sym_regex] = STATE(2416),
    [sym_meta_property] = STATE(2416),
    [sym_call_signature] = STATE(1997),
    [sym__expression] = STATE(2416),
    [sym_yield_expression] = STATE(2416),
    [sym_as_expression] = STATE(2416),
    [sym_non_null_expression] = STATE(2416),
    [sym_internal_module] = STATE(2416),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2416),
    [sym_await_expression] = STATE(2416),
    [sym_member_expression] = STATE(2338),
    [sym_string] = STATE(2416),
    [sym_this] = STATE(2416),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2339),
    [sym_anonymous_class] = STATE(2416),
    [sym_generator_function] = STATE(2416),
    [sym_call_expression] = STATE(2416),
    [sym_subscript_expression] = STATE(2338),
    [sym_assignment_expression] = STATE(2416),
    [sym_ternary_expression] = STATE(2416),
    [sym_binary_expression] = STATE(2416),
    [sym_template_string] = STATE(2416),
    [sym_type_arguments] = STATE(1947),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2416),
    [sym_array] = STATE(2340),
    [sym_type_assertion] = STATE(2416),
    [sym_class] = STATE(2416),
    [anon_sym_BANG] = ACTIONS(883),
    [sym_identifier] = ACTIONS(4606),
    [sym_false] = ACTIONS(5199),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(889),
    [anon_sym_symbol] = ACTIONS(889),
    [anon_sym_number] = ACTIONS(889),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(889),
    [anon_sym_typeof] = ACTIONS(891),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(895),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5199),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(889),
    [anon_sym_private] = ACTIONS(889),
    [anon_sym_boolean] = ACTIONS(889),
    [anon_sym_async] = ACTIONS(897),
    [anon_sym_public] = ACTIONS(889),
    [anon_sym_get] = ACTIONS(889),
    [anon_sym_delete] = ACTIONS(891),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(899),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5201),
    [sym_true] = ACTIONS(5199),
    [anon_sym_yield] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(889),
    [anon_sym_string] = ACTIONS(889),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5199),
    [anon_sym_set] = ACTIONS(889),
    [anon_sym_type] = ACTIONS(889),
    [anon_sym_new] = ACTIONS(907),
    [anon_sym_import] = ACTIONS(889),
    [anon_sym_export] = ACTIONS(889),
    [anon_sym_namespace] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_await] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(883),
    [anon_sym_PLUS_PLUS] = ACTIONS(899),
  },
  [2338] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1909),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1909),
    [anon_sym_AMP_EQ] = ACTIONS(1909),
    [anon_sym_PLUS_EQ] = ACTIONS(1909),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1913),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(1909),
    [anon_sym_STAR_EQ] = ACTIONS(1909),
    [anon_sym_PIPE_EQ] = ACTIONS(1909),
    [anon_sym_DASH_EQ] = ACTIONS(1909),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1909),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1909),
    [anon_sym_GT_GT_EQ] = ACTIONS(1909),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [2339] = {
    [sym__initializer] = STATE(1273),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1913),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1922),
  },
  [2340] = {
    [sym__initializer] = STATE(1287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1913),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_implements] = ACTIONS(111),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1922),
  },
  [2341] = {
    [sym_new_expression] = STATE(2080),
    [sym_augmented_assignment_expression] = STATE(2080),
    [sym_unary_expression] = STATE(2080),
    [sym_update_expression] = STATE(2080),
    [sym_regex] = STATE(2080),
    [sym_meta_property] = STATE(2080),
    [sym_call_signature] = STATE(2379),
    [sym_statement_block] = STATE(1288),
    [sym__expression] = STATE(2080),
    [sym_yield_expression] = STATE(2080),
    [sym_as_expression] = STATE(2080),
    [sym_non_null_expression] = STATE(2080),
    [sym_internal_module] = STATE(2080),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2080),
    [sym_await_expression] = STATE(2080),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2080),
    [sym_this] = STATE(2080),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2080),
    [sym_generator_function] = STATE(2080),
    [sym_call_expression] = STATE(2080),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2080),
    [sym_ternary_expression] = STATE(2080),
    [sym_binary_expression] = STATE(2080),
    [sym_template_string] = STATE(2080),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2080),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2080),
    [sym_class] = STATE(2080),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5203),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5203),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5203),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5205),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5203),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2342] = {
    [sym_new_expression] = STATE(1969),
    [sym_augmented_assignment_expression] = STATE(1969),
    [sym_unary_expression] = STATE(1969),
    [sym_update_expression] = STATE(1969),
    [sym_regex] = STATE(1969),
    [sym_meta_property] = STATE(1969),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1969),
    [sym_yield_expression] = STATE(1969),
    [sym_as_expression] = STATE(1969),
    [sym_non_null_expression] = STATE(1969),
    [sym_internal_module] = STATE(1969),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1969),
    [sym_await_expression] = STATE(1969),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1969),
    [sym_this] = STATE(1969),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1969),
    [sym_generator_function] = STATE(1969),
    [sym_call_expression] = STATE(1969),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1969),
    [sym_ternary_expression] = STATE(1969),
    [sym_binary_expression] = STATE(1969),
    [sym_template_string] = STATE(1969),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1969),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1969),
    [sym_class] = STATE(1969),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(4168),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(4168),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(4168),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5207),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2343] = {
    [sym_new_expression] = STATE(1970),
    [sym_augmented_assignment_expression] = STATE(1970),
    [sym_unary_expression] = STATE(1970),
    [sym_update_expression] = STATE(1970),
    [sym_regex] = STATE(1970),
    [sym_meta_property] = STATE(1970),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1970),
    [sym_yield_expression] = STATE(1970),
    [sym_as_expression] = STATE(1970),
    [sym_non_null_expression] = STATE(1970),
    [sym_internal_module] = STATE(1970),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1970),
    [sym_await_expression] = STATE(1970),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1970),
    [sym_this] = STATE(1970),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1970),
    [sym_generator_function] = STATE(1970),
    [sym_call_expression] = STATE(1970),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1970),
    [sym_ternary_expression] = STATE(1970),
    [sym_binary_expression] = STATE(1970),
    [sym_template_string] = STATE(1970),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1970),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1970),
    [sym_class] = STATE(1970),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5209),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5209),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5209),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5211),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5209),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2344] = {
    [sym_new_expression] = STATE(1971),
    [sym_augmented_assignment_expression] = STATE(1971),
    [sym_unary_expression] = STATE(1971),
    [sym_update_expression] = STATE(1971),
    [sym_regex] = STATE(1971),
    [sym_meta_property] = STATE(1971),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1971),
    [sym_yield_expression] = STATE(1971),
    [sym_as_expression] = STATE(1971),
    [sym_non_null_expression] = STATE(1971),
    [sym_internal_module] = STATE(1971),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1971),
    [sym_await_expression] = STATE(1971),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1971),
    [sym_this] = STATE(1971),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1971),
    [sym_generator_function] = STATE(1971),
    [sym_call_expression] = STATE(1971),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1971),
    [sym_ternary_expression] = STATE(1971),
    [sym_binary_expression] = STATE(1971),
    [sym_template_string] = STATE(1971),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1971),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1971),
    [sym_class] = STATE(1971),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5213),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5213),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5213),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5215),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5213),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2345] = {
    [sym_new_expression] = STATE(2084),
    [sym_augmented_assignment_expression] = STATE(2084),
    [sym_unary_expression] = STATE(2084),
    [sym_update_expression] = STATE(2084),
    [sym_regex] = STATE(2084),
    [sym_meta_property] = STATE(2084),
    [sym_call_signature] = STATE(2379),
    [sym_statement_block] = STATE(1295),
    [sym__expression] = STATE(2084),
    [sym_yield_expression] = STATE(2084),
    [sym_as_expression] = STATE(2084),
    [sym_non_null_expression] = STATE(2084),
    [sym_internal_module] = STATE(2084),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2084),
    [sym_await_expression] = STATE(2084),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2084),
    [sym_this] = STATE(2084),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2084),
    [sym_generator_function] = STATE(2084),
    [sym_call_expression] = STATE(2084),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2084),
    [sym_ternary_expression] = STATE(2084),
    [sym_binary_expression] = STATE(2084),
    [sym_template_string] = STATE(2084),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2084),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2084),
    [sym_class] = STATE(2084),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5217),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5217),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5217),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5219),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5217),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2346] = {
    [sym_new_expression] = STATE(1973),
    [sym_augmented_assignment_expression] = STATE(1973),
    [sym_unary_expression] = STATE(1973),
    [sym_update_expression] = STATE(1973),
    [sym_regex] = STATE(1973),
    [sym_meta_property] = STATE(1973),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1973),
    [sym_yield_expression] = STATE(1973),
    [sym_as_expression] = STATE(1973),
    [sym_non_null_expression] = STATE(1973),
    [sym_internal_module] = STATE(1973),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1973),
    [sym_await_expression] = STATE(1973),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1973),
    [sym_this] = STATE(1973),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1973),
    [sym_generator_function] = STATE(1973),
    [sym_call_expression] = STATE(1973),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1973),
    [sym_ternary_expression] = STATE(1973),
    [sym_binary_expression] = STATE(1973),
    [sym_template_string] = STATE(1973),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1973),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1973),
    [sym_class] = STATE(1973),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5221),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5221),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5221),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5223),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5221),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2347] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1307),
    [anon_sym_AMP_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_EQ] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(1307),
    [anon_sym_PIPE_EQ] = ACTIONS(1307),
    [anon_sym_DASH_EQ] = ACTIONS(1307),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(1307),
    [anon_sym_EQ_GT] = ACTIONS(2722),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1307),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1339),
  },
  [2348] = {
    [sym_call_signature] = STATE(2380),
    [sym__initializer] = STATE(1215),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(2732),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(2734),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(2734),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(2734),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(2734),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_set] = ACTIONS(2734),
    [anon_sym_type] = ACTIONS(2734),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(2734),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_namespace] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(2734),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(2734),
    [anon_sym_declare] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(2734),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(2734),
    [anon_sym_async] = ACTIONS(2734),
    [anon_sym_public] = ACTIONS(2734),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(2734),
    [anon_sym_function] = ACTIONS(1136),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2349] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_RBRACK] = ACTIONS(700),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(5225),
    [anon_sym_RPAREN] = ACTIONS(700),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [2350] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_RBRACK] = ACTIONS(700),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(5225),
    [anon_sym_RPAREN] = ACTIONS(700),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [2351] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(767),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(767),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(767),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_in] = ACTIONS(1339),
  },
  [2352] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_RBRACK] = ACTIONS(811),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(811),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(811),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_in] = ACTIONS(1339),
  },
  [2353] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_RBRACK] = ACTIONS(700),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(5225),
    [anon_sym_RPAREN] = ACTIONS(700),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(700),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [2354] = {
    [sym__initializer] = STATE(1211),
    [sym_arguments] = STATE(1353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_PERCENT_EQ] = ACTIONS(1307),
    [anon_sym_AMP_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_EQ] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_CARET_EQ] = ACTIONS(1307),
    [anon_sym_PIPE_EQ] = ACTIONS(1307),
    [anon_sym_DASH_EQ] = ACTIONS(1307),
    [anon_sym_PERCENT] = ACTIONS(1309),
    [anon_sym_LT_LT_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_COLON] = ACTIONS(1305),
    [anon_sym_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_STAR_STAR] = ACTIONS(1309),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_LT_LT] = ACTIONS(1309),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1305),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_STAR_EQ] = ACTIONS(1307),
    [anon_sym_EQ_GT] = ACTIONS(2722),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_RPAREN] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1307),
    [anon_sym_CARET] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [2355] = {
    [sym__initializer] = STATE(1215),
    [sym_arguments] = STATE(1355),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1315),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_instanceof] = ACTIONS(1315),
    [anon_sym_COLON] = ACTIONS(1315),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [2356] = {
    [sym_new_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [sym_call_signature] = STATE(2379),
    [sym_yield_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_internal_module] = STATE(2350),
    [sym_arrow_function] = STATE(2350),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2350),
    [sym_type_parameters] = STATE(55),
    [sym_arguments] = STATE(1355),
    [sym_object] = STATE(2522),
    [sym_generator_function] = STATE(2350),
    [sym_subscript_expression] = STATE(2521),
    [sym_ternary_expression] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym__initializer] = STATE(1215),
    [sym_update_expression] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym__expression] = STATE(2350),
    [sym_non_null_expression] = STATE(2350),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(2350),
    [sym_this] = STATE(2350),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_assignment_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_type_arguments] = STATE(2523),
    [sym_parenthesized_expression] = STATE(2350),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(1323),
    [anon_sym_COLON] = ACTIONS(1315),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_RBRACK] = ACTIONS(1315),
    [sym_null] = ACTIONS(1323),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [sym_false] = ACTIONS(1323),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_LT] = ACTIONS(1319),
    [sym_number] = ACTIONS(1335),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_in] = ACTIONS(1319),
  },
  [2357] = {
    [sym__initializer] = STATE(1215),
    [sym_formal_parameters] = STATE(58),
    [sym_call_signature] = STATE(2380),
    [sym_type_parameters] = STATE(55),
    [sym_arguments] = STATE(1355),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(2732),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(2734),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(2734),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(2734),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_COLON] = ACTIONS(1315),
    [anon_sym_protected] = ACTIONS(2734),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_set] = ACTIONS(2734),
    [anon_sym_type] = ACTIONS(2734),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_import] = ACTIONS(2734),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_namespace] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_module] = ACTIONS(2734),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(2734),
    [anon_sym_declare] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_RBRACK] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_any] = ACTIONS(2734),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(2734),
    [anon_sym_async] = ACTIONS(2734),
    [anon_sym_public] = ACTIONS(2734),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(2734),
    [anon_sym_function] = ACTIONS(1136),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_export] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [2358] = {
    [sym_nested_identifier] = STATE(1592),
    [sym__module] = STATE(1483),
    [sym__initializer] = STATE(1215),
    [sym_string] = STATE(1594),
    [sym_arguments] = STATE(1355),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_COLON] = ACTIONS(1315),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_RBRACK] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_RPAREN] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [2359] = {
    [sym_new_expression] = STATE(1976),
    [sym_augmented_assignment_expression] = STATE(1976),
    [sym_unary_expression] = STATE(1976),
    [sym_update_expression] = STATE(1976),
    [sym_regex] = STATE(1976),
    [sym_meta_property] = STATE(1976),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1976),
    [sym_yield_expression] = STATE(1976),
    [sym_as_expression] = STATE(1976),
    [sym_non_null_expression] = STATE(1976),
    [sym_internal_module] = STATE(1976),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1976),
    [sym_await_expression] = STATE(1976),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1976),
    [sym_this] = STATE(1976),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1976),
    [sym_generator_function] = STATE(1976),
    [sym_call_expression] = STATE(1976),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1976),
    [sym_ternary_expression] = STATE(1976),
    [sym_binary_expression] = STATE(1976),
    [sym_template_string] = STATE(1976),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1976),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1976),
    [sym_class] = STATE(1976),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5228),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5228),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5228),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5230),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5228),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2360] = {
    [sym_new_expression] = STATE(1977),
    [sym_augmented_assignment_expression] = STATE(1977),
    [sym_unary_expression] = STATE(1977),
    [sym_update_expression] = STATE(1977),
    [sym_regex] = STATE(1977),
    [sym_meta_property] = STATE(1977),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1977),
    [sym_yield_expression] = STATE(1977),
    [sym_as_expression] = STATE(1977),
    [sym_non_null_expression] = STATE(1977),
    [sym_internal_module] = STATE(1977),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1977),
    [sym_await_expression] = STATE(1977),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1977),
    [sym_this] = STATE(1977),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1977),
    [sym_generator_function] = STATE(1977),
    [sym_call_expression] = STATE(1977),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1977),
    [sym_ternary_expression] = STATE(1977),
    [sym_binary_expression] = STATE(1977),
    [sym_template_string] = STATE(1977),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1977),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1977),
    [sym_class] = STATE(1977),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5232),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5232),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5232),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5234),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5232),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2361] = {
    [sym_new_expression] = STATE(1978),
    [sym_augmented_assignment_expression] = STATE(1978),
    [sym_unary_expression] = STATE(1978),
    [sym_update_expression] = STATE(1978),
    [sym_regex] = STATE(1978),
    [sym_meta_property] = STATE(1978),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1978),
    [sym_yield_expression] = STATE(1978),
    [sym_as_expression] = STATE(1978),
    [sym_non_null_expression] = STATE(1978),
    [sym_internal_module] = STATE(1978),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1978),
    [sym_await_expression] = STATE(1978),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1978),
    [sym_this] = STATE(1978),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1978),
    [sym_generator_function] = STATE(1978),
    [sym_call_expression] = STATE(1978),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1978),
    [sym_ternary_expression] = STATE(1978),
    [sym_binary_expression] = STATE(1978),
    [sym_template_string] = STATE(1978),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1978),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1978),
    [sym_class] = STATE(1978),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5236),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5236),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5236),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5238),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5236),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2362] = {
    [sym_new_expression] = STATE(1979),
    [sym_augmented_assignment_expression] = STATE(1979),
    [sym_unary_expression] = STATE(1979),
    [sym_update_expression] = STATE(1979),
    [sym_regex] = STATE(1979),
    [sym_meta_property] = STATE(1979),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1979),
    [sym_yield_expression] = STATE(1979),
    [sym_as_expression] = STATE(1979),
    [sym_non_null_expression] = STATE(1979),
    [sym_internal_module] = STATE(1979),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1979),
    [sym_await_expression] = STATE(1979),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1979),
    [sym_this] = STATE(1979),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1979),
    [sym_generator_function] = STATE(1979),
    [sym_call_expression] = STATE(1979),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1979),
    [sym_ternary_expression] = STATE(1979),
    [sym_binary_expression] = STATE(1979),
    [sym_template_string] = STATE(1979),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1979),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1979),
    [sym_class] = STATE(1979),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5240),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5240),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5240),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5242),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5240),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2363] = {
    [sym_new_expression] = STATE(1986),
    [sym_augmented_assignment_expression] = STATE(1986),
    [sym_unary_expression] = STATE(1986),
    [sym_update_expression] = STATE(1986),
    [sym_regex] = STATE(1986),
    [sym_meta_property] = STATE(1986),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1986),
    [sym_yield_expression] = STATE(1986),
    [sym_as_expression] = STATE(1986),
    [sym_non_null_expression] = STATE(1986),
    [sym_internal_module] = STATE(1986),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1986),
    [sym_await_expression] = STATE(1986),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1986),
    [sym_this] = STATE(1986),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1986),
    [sym_generator_function] = STATE(1986),
    [sym_call_expression] = STATE(1986),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1986),
    [sym_ternary_expression] = STATE(1986),
    [sym_binary_expression] = STATE(1986),
    [sym_template_string] = STATE(1986),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1986),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1986),
    [sym_class] = STATE(1986),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5244),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5244),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5244),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5246),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5244),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2364] = {
    [sym_new_expression] = STATE(2093),
    [sym_augmented_assignment_expression] = STATE(2093),
    [sym_unary_expression] = STATE(2093),
    [sym_update_expression] = STATE(2093),
    [sym_regex] = STATE(2093),
    [sym_meta_property] = STATE(2093),
    [sym_call_signature] = STATE(2379),
    [sym_statement_block] = STATE(1395),
    [sym__expression] = STATE(2093),
    [sym_yield_expression] = STATE(2093),
    [sym_as_expression] = STATE(2093),
    [sym_non_null_expression] = STATE(2093),
    [sym_internal_module] = STATE(2093),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2093),
    [sym_await_expression] = STATE(2093),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2093),
    [sym_this] = STATE(2093),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2093),
    [sym_generator_function] = STATE(2093),
    [sym_call_expression] = STATE(2093),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2093),
    [sym_ternary_expression] = STATE(2093),
    [sym_binary_expression] = STATE(2093),
    [sym_template_string] = STATE(2093),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2093),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2093),
    [sym_class] = STATE(2093),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5248),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5248),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5248),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5250),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5248),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2365] = {
    [sym_new_expression] = STATE(2094),
    [sym_augmented_assignment_expression] = STATE(2094),
    [sym_unary_expression] = STATE(2094),
    [sym_update_expression] = STATE(2094),
    [sym_regex] = STATE(2094),
    [sym_meta_property] = STATE(2094),
    [sym_call_signature] = STATE(2379),
    [sym_statement_block] = STATE(1397),
    [sym__expression] = STATE(2094),
    [sym_yield_expression] = STATE(2094),
    [sym_as_expression] = STATE(2094),
    [sym_non_null_expression] = STATE(2094),
    [sym_internal_module] = STATE(2094),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2094),
    [sym_await_expression] = STATE(2094),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2094),
    [sym_this] = STATE(2094),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2094),
    [sym_generator_function] = STATE(2094),
    [sym_call_expression] = STATE(2094),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2094),
    [sym_ternary_expression] = STATE(2094),
    [sym_binary_expression] = STATE(2094),
    [sym_template_string] = STATE(2094),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2094),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2094),
    [sym_class] = STATE(2094),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5252),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5252),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5252),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5254),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5252),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2366] = {
    [sym_new_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_update_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2350),
    [sym_yield_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_non_null_expression] = STATE(2350),
    [sym_internal_module] = STATE(2350),
    [sym_nested_identifier] = STATE(516),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2350),
    [sym_this] = STATE(2350),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2350),
    [sym_ternary_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2350),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2350),
    [sym_class] = STATE(2350),
    [sym_identifier] = ACTIONS(5256),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(1323),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1323),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(1323),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1335),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2367] = {
    [sym_new_expression] = STATE(2349),
    [sym_augmented_assignment_expression] = STATE(2349),
    [sym_unary_expression] = STATE(2349),
    [sym_update_expression] = STATE(2349),
    [sym_regex] = STATE(2349),
    [sym_meta_property] = STATE(2349),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2349),
    [sym_yield_expression] = STATE(2349),
    [sym_as_expression] = STATE(2349),
    [sym_non_null_expression] = STATE(2349),
    [sym_internal_module] = STATE(2349),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2349),
    [sym_await_expression] = STATE(2349),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2349),
    [sym_this] = STATE(2349),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2349),
    [sym_generator_function] = STATE(2349),
    [sym_call_expression] = STATE(2349),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2349),
    [sym_ternary_expression] = STATE(2349),
    [sym_binary_expression] = STATE(2349),
    [sym_template_string] = STATE(2349),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2349),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2349),
    [sym_class] = STATE(2349),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5258),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5258),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5258),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(4079),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5258),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2368] = {
    [sym_new_expression] = STATE(1261),
    [sym_augmented_assignment_expression] = STATE(1800),
    [sym_unary_expression] = STATE(1800),
    [sym_update_expression] = STATE(1800),
    [sym_regex] = STATE(1261),
    [sym_meta_property] = STATE(1261),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1800),
    [sym_yield_expression] = STATE(1800),
    [sym_as_expression] = STATE(1800),
    [sym_non_null_expression] = STATE(1800),
    [sym_internal_module] = STATE(1800),
    [sym_function] = STATE(1266),
    [sym_arrow_function] = STATE(1261),
    [sym_await_expression] = STATE(1800),
    [sym_member_expression] = STATE(1267),
    [sym_string] = STATE(1261),
    [sym_this] = STATE(1261),
    [sym_type_parameters] = STATE(825),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1268),
    [sym_anonymous_class] = STATE(1261),
    [sym_generator_function] = STATE(1261),
    [sym_call_expression] = STATE(1800),
    [sym_subscript_expression] = STATE(1267),
    [sym_assignment_expression] = STATE(1800),
    [sym_ternary_expression] = STATE(1800),
    [sym_binary_expression] = STATE(1800),
    [sym_template_string] = STATE(1261),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(826),
    [sym_parenthesized_expression] = STATE(1261),
    [sym_array] = STATE(1269),
    [sym_type_assertion] = STATE(1800),
    [sym_class] = STATE(1261),
    [sym_identifier] = ACTIONS(5260),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(5262),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(5264),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(5262),
    [anon_sym_get] = ACTIONS(5262),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(3920),
    [anon_sym_protected] = ACTIONS(5262),
    [anon_sym_DOT] = ACTIONS(3922),
    [anon_sym_set] = ACTIONS(5262),
    [anon_sym_type] = ACTIONS(5262),
    [anon_sym_import] = ACTIONS(5262),
    [anon_sym_namespace] = ACTIONS(5266),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3920),
    [anon_sym_module] = ACTIONS(5262),
    [anon_sym_number] = ACTIONS(5262),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5262),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3920),
    [anon_sym_any] = ACTIONS(5262),
    [anon_sym_boolean] = ACTIONS(5262),
    [anon_sym_async] = ACTIONS(5268),
    [anon_sym_public] = ACTIONS(5262),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3928),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5262),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3920),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(5262),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2369] = {
    [sym_string] = STATE(2309),
    [sym__property_name] = STATE(2309),
    [sym_computed_property_name] = STATE(2309),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(5270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2370] = {
    [sym_new_expression] = STATE(1991),
    [sym_augmented_assignment_expression] = STATE(1991),
    [sym_unary_expression] = STATE(1991),
    [sym_update_expression] = STATE(1991),
    [sym_regex] = STATE(1991),
    [sym_meta_property] = STATE(1991),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1991),
    [sym_yield_expression] = STATE(1991),
    [sym_as_expression] = STATE(1991),
    [sym_non_null_expression] = STATE(1991),
    [sym_internal_module] = STATE(1991),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1991),
    [sym_await_expression] = STATE(1991),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1991),
    [sym_this] = STATE(1991),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1991),
    [sym_generator_function] = STATE(1991),
    [sym_call_expression] = STATE(1991),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1991),
    [sym_ternary_expression] = STATE(1991),
    [sym_binary_expression] = STATE(1991),
    [sym_template_string] = STATE(1991),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1991),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1991),
    [sym_class] = STATE(1991),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5272),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5272),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5272),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5274),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5272),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2371] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1307),
    [anon_sym_AMP_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_EQ] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(1307),
    [anon_sym_PIPE_EQ] = ACTIONS(1307),
    [anon_sym_DASH_EQ] = ACTIONS(1307),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(5276),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_STAR_EQ] = ACTIONS(1307),
    [anon_sym_EQ_GT] = ACTIONS(2722),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1307),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1339),
  },
  [2372] = {
    [sym_string] = STATE(2320),
    [sym__property_name] = STATE(2320),
    [sym_computed_property_name] = STATE(2320),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(5278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [2373] = {
    [sym_string] = STATE(2325),
    [sym__property_name] = STATE(2325),
    [sym_computed_property_name] = STATE(2325),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(5280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2374] = {
    [sym__initializer] = STATE(1211),
    [sym_type_arguments] = STATE(497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1307),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_AMP_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_EQ] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_is] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(2509),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(1307),
    [anon_sym_STAR_EQ] = ACTIONS(1307),
    [anon_sym_PIPE_EQ] = ACTIONS(1307),
    [anon_sym_DASH_EQ] = ACTIONS(1307),
    [anon_sym_EQ_GT] = ACTIONS(2722),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1307),
    [anon_sym_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(4144),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1307),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2724),
  },
  [2375] = {
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(2529),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2376] = {
    [sym_new_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(2350),
    [sym_update_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2350),
    [sym_yield_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_non_null_expression] = STATE(2350),
    [sym_internal_module] = STATE(2350),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2350),
    [sym_this] = STATE(2350),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2350),
    [sym_ternary_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2350),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(1323),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(2730),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1323),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_RBRACK] = ACTIONS(2529),
    [sym_null] = ACTIONS(1323),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(1335),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2377] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1307),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_AMP_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_EQ] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(2305),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(1307),
    [anon_sym_STAR_EQ] = ACTIONS(1307),
    [anon_sym_PIPE_EQ] = ACTIONS(1307),
    [anon_sym_DASH_EQ] = ACTIONS(1307),
    [anon_sym_EQ_GT] = ACTIONS(2722),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1307),
    [anon_sym_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(4172),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1307),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1339),
  },
  [2378] = {
    [sym_nested_identifier] = STATE(1482),
    [sym__module] = STATE(1225),
    [sym_string] = STATE(1484),
    [sym__initializer] = STATE(80),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(4359),
    [anon_sym_PERCENT_EQ] = ACTIONS(4290),
    [anon_sym_AMP_EQ] = ACTIONS(4290),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4290),
    [anon_sym_PLUS_EQ] = ACTIONS(4290),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(4290),
    [anon_sym_STAR_EQ] = ACTIONS(4290),
    [anon_sym_PIPE_EQ] = ACTIONS(4290),
    [anon_sym_DASH_EQ] = ACTIONS(4290),
    [anon_sym_EQ_GT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4290),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4290),
    [anon_sym_GT_GT_EQ] = ACTIONS(4290),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4290),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2379] = {
    [anon_sym_EQ_GT] = ACTIONS(2722),
    [sym_comment] = ACTIONS(3),
  },
  [2380] = {
    [anon_sym_EQ_GT] = ACTIONS(5282),
    [sym_comment] = ACTIONS(3),
  },
  [2381] = {
    [anon_sym_EQ_GT] = ACTIONS(5284),
    [sym_comment] = ACTIONS(3),
  },
  [2382] = {
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5286),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2383] = {
    [sym_new_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_update_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2350),
    [sym_yield_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_non_null_expression] = STATE(2350),
    [sym_internal_module] = STATE(2350),
    [sym_nested_identifier] = STATE(516),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2350),
    [sym_this] = STATE(2350),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2350),
    [sym_ternary_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2350),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG] = ACTIONS(518),
    [sym_identifier] = ACTIONS(5288),
    [sym_false] = ACTIONS(1323),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(1323),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(1335),
    [sym_true] = ACTIONS(1323),
    [anon_sym_yield] = ACTIONS(508),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
  },
  [2384] = {
    [sym_new_expression] = STATE(2349),
    [sym_augmented_assignment_expression] = STATE(2349),
    [sym_unary_expression] = STATE(2349),
    [sym_update_expression] = STATE(2349),
    [sym_regex] = STATE(2349),
    [sym_meta_property] = STATE(2349),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2349),
    [sym_yield_expression] = STATE(2349),
    [sym_as_expression] = STATE(2349),
    [sym_non_null_expression] = STATE(2349),
    [sym_internal_module] = STATE(2349),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2349),
    [sym_await_expression] = STATE(2349),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2349),
    [sym_this] = STATE(2349),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2349),
    [sym_generator_function] = STATE(2349),
    [sym_call_expression] = STATE(2349),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2349),
    [sym_ternary_expression] = STATE(2349),
    [sym_binary_expression] = STATE(2349),
    [sym_template_string] = STATE(2349),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2349),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2349),
    [sym_class] = STATE(2349),
    [anon_sym_BANG] = ACTIONS(518),
    [sym_identifier] = ACTIONS(1329),
    [sym_false] = ACTIONS(5258),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5258),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4671),
    [sym_true] = ACTIONS(5258),
    [anon_sym_yield] = ACTIONS(508),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5258),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
  },
  [2385] = {
    [sym_regex_pattern] = ACTIONS(5290),
    [sym_comment] = ACTIONS(256),
  },
  [2386] = {
    [sym_call_signature] = STATE(1798),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(5292),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_STAR] = ACTIONS(698),
    [sym_comment] = ACTIONS(3),
  },
  [2387] = {
    [sym__type] = STATE(2019),
    [sym_constructor_type] = STATE(2019),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(2019),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(2019),
    [sym_intersection_type] = STATE(2019),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2388] = {
    [sym_call_signature] = STATE(1843),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(5294),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2389] = {
    [sym__type] = STATE(2044),
    [sym_constructor_type] = STATE(2044),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(2044),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(2044),
    [sym_intersection_type] = STATE(2044),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2390] = {
    [sym_formal_parameters] = STATE(2045),
    [sym_type_parameters] = STATE(2404),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2391] = {
    [sym__type] = STATE(2047),
    [sym_constructor_type] = STATE(2047),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(2047),
    [sym_rest_parameter] = STATE(198),
    [sym_nested_identifier] = STATE(236),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(198),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(218),
    [sym_type_parameters] = STATE(233),
    [sym_this] = STATE(468),
    [sym_predefined_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_array_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(477),
    [sym_object] = STATE(465),
    [sym_nested_type_identifier] = STATE(234),
    [sym_optional_parameter] = STATE(198),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(477),
    [sym_union_type] = STATE(2047),
    [sym_intersection_type] = STATE(2047),
    [sym_formal_parameters] = STATE(238),
    [sym_array] = STATE(467),
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_symbol] = ACTIONS(1264),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(1264),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_this] = ACTIONS(1266),
    [sym_true] = ACTIONS(452),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(452),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1264),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(1264),
    [anon_sym_boolean] = ACTIONS(1264),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1264),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_export] = ACTIONS(1154),
  },
  [2392] = {
    [sym_formal_parameters] = STATE(2050),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2393] = {
    [anon_sym_DOT] = ACTIONS(4138),
    [sym_comment] = ACTIONS(3),
  },
  [2394] = {
    [sym_call_signature] = STATE(2052),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [2395] = {
    [sym_call_signature] = STATE(2053),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(5296),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2396] = {
    [sym_new_expression] = STATE(2382),
    [sym_augmented_assignment_expression] = STATE(2382),
    [sym_unary_expression] = STATE(2382),
    [sym_update_expression] = STATE(2382),
    [sym_regex] = STATE(2382),
    [sym_meta_property] = STATE(2382),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2382),
    [sym_yield_expression] = STATE(2382),
    [sym_as_expression] = STATE(2382),
    [sym_non_null_expression] = STATE(2382),
    [sym_internal_module] = STATE(2382),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2382),
    [sym_await_expression] = STATE(2382),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2382),
    [sym_this] = STATE(2382),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2382),
    [sym_generator_function] = STATE(2382),
    [sym_call_expression] = STATE(2382),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2382),
    [sym_ternary_expression] = STATE(2382),
    [sym_binary_expression] = STATE(2382),
    [sym_template_string] = STATE(2382),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2382),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2382),
    [sym_class] = STATE(2382),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5298),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5298),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5298),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5300),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5298),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2397] = {
    [sym_computed_property_name] = STATE(439),
    [sym__property_name] = STATE(439),
    [sym_decorator] = STATE(2472),
    [sym_method_definition] = STATE(2039),
    [sym_string] = STATE(439),
    [sym_accessibility_modifier] = STATE(180),
    [aux_sym_export_statement_repeat1] = STATE(2472),
    [anon_sym_get] = ACTIONS(1080),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1078),
    [anon_sym_static] = ACTIONS(382),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [sym_number] = ACTIONS(1082),
    [anon_sym_STAR] = ACTIONS(376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1076),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1080),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [sym_readonly] = ACTIONS(394),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1076),
    [anon_sym_public] = ACTIONS(1076),
  },
  [2398] = {
    [sym_identifier] = ACTIONS(5302),
    [sym_comment] = ACTIONS(3),
  },
  [2399] = {
    [sym_identifier] = ACTIONS(5304),
    [sym_comment] = ACTIONS(3),
  },
  [2400] = {
    [sym_call_signature] = STATE(2062),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [2401] = {
    [sym__type] = STATE(2063),
    [sym_constructor_type] = STATE(2063),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(2063),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(2063),
    [sym_intersection_type] = STATE(2063),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2402] = {
    [sym__type] = STATE(2047),
    [sym_constructor_type] = STATE(2047),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(2047),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(2047),
    [sym_intersection_type] = STATE(2047),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2403] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(2064),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(2064),
    [sym_call_signature] = STATE(2064),
    [sym_construct_signature] = STATE(2064),
    [sym_index_signature] = STATE(2064),
    [sym_export_statement] = STATE(2064),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2404] = {
    [sym_formal_parameters] = STATE(2068),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2405] = {
    [sym__type] = STATE(2070),
    [sym_constructor_type] = STATE(2070),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(2070),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(2070),
    [sym_intersection_type] = STATE(2070),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2406] = {
    [sym_call_signature] = STATE(2071),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2407] = {
    [sym_new_expression] = STATE(2581),
    [sym_augmented_assignment_expression] = STATE(2581),
    [sym_unary_expression] = STATE(2581),
    [sym_update_expression] = STATE(2581),
    [sym_regex] = STATE(2581),
    [sym_meta_property] = STATE(2581),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2581),
    [sym_yield_expression] = STATE(2581),
    [sym_as_expression] = STATE(2581),
    [sym_non_null_expression] = STATE(2581),
    [sym_internal_module] = STATE(2581),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2581),
    [sym_await_expression] = STATE(2581),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2581),
    [sym_this] = STATE(2581),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2581),
    [sym_generator_function] = STATE(2581),
    [sym_call_expression] = STATE(2581),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2581),
    [sym_ternary_expression] = STATE(2581),
    [sym_binary_expression] = STATE(2581),
    [sym_template_string] = STATE(2581),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2581),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2581),
    [sym_class] = STATE(2581),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5310),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5310),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5324),
    [sym_true] = ACTIONS(5310),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5310),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2408] = {
    [sym_new_expression] = STATE(2582),
    [sym_augmented_assignment_expression] = STATE(2582),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(2582),
    [sym_update_expression] = STATE(2582),
    [sym_regex] = STATE(2582),
    [sym_meta_property] = STATE(2582),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2582),
    [sym_yield_expression] = STATE(2582),
    [sym_as_expression] = STATE(2582),
    [sym_non_null_expression] = STATE(2582),
    [sym_internal_module] = STATE(2582),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2582),
    [sym_await_expression] = STATE(2582),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2582),
    [sym_this] = STATE(2582),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2582),
    [sym_generator_function] = STATE(2582),
    [sym_call_expression] = STATE(2582),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2582),
    [sym_ternary_expression] = STATE(2582),
    [sym_binary_expression] = STATE(2582),
    [sym_template_string] = STATE(2582),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2582),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2582),
    [sym_class] = STATE(2582),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(5308),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(5326),
    [sym_true] = ACTIONS(5338),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5334),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(5340),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5338),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(5342),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5338),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_EQ_GT] = ACTIONS(5344),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(5346),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5338),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2409] = {
    [sym_new_expression] = STATE(2582),
    [sym_augmented_assignment_expression] = STATE(2582),
    [sym_unary_expression] = STATE(2582),
    [sym_update_expression] = STATE(2582),
    [sym_regex] = STATE(2582),
    [sym_meta_property] = STATE(2582),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2582),
    [sym_yield_expression] = STATE(2582),
    [sym_as_expression] = STATE(2582),
    [sym_non_null_expression] = STATE(2582),
    [sym_internal_module] = STATE(2582),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2582),
    [sym_await_expression] = STATE(2582),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2582),
    [sym_this] = STATE(2582),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2582),
    [sym_generator_function] = STATE(2582),
    [sym_call_expression] = STATE(2582),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2582),
    [sym_ternary_expression] = STATE(2582),
    [sym_binary_expression] = STATE(2582),
    [sym_template_string] = STATE(2582),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2582),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2582),
    [sym_class] = STATE(2582),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5338),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5338),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5346),
    [sym_true] = ACTIONS(5338),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5338),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2410] = {
    [sym_new_expression] = STATE(1222),
    [sym_augmented_assignment_expression] = STATE(1222),
    [sym_unary_expression] = STATE(1222),
    [sym_update_expression] = STATE(1222),
    [sym_regex] = STATE(1222),
    [sym_meta_property] = STATE(1222),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(1222),
    [sym_yield_expression] = STATE(1222),
    [sym_as_expression] = STATE(1222),
    [sym_non_null_expression] = STATE(1222),
    [sym_internal_module] = STATE(1222),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1222),
    [sym_await_expression] = STATE(1222),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(1222),
    [sym_this] = STATE(1222),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(1222),
    [sym_generator_function] = STATE(1222),
    [sym_call_expression] = STATE(1222),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(1222),
    [sym_ternary_expression] = STATE(1222),
    [sym_binary_expression] = STATE(1222),
    [sym_template_string] = STATE(1222),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1222),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(1222),
    [sym_class] = STATE(1222),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(3898),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3898),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(3900),
    [sym_true] = ACTIONS(3898),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3898),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2411] = {
    [sym_new_expression] = STATE(2537),
    [sym_augmented_assignment_expression] = STATE(2537),
    [sym_unary_expression] = STATE(2537),
    [sym_update_expression] = STATE(2537),
    [sym_regex] = STATE(2537),
    [sym_meta_property] = STATE(2537),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2537),
    [sym_yield_expression] = STATE(2537),
    [sym_as_expression] = STATE(2537),
    [sym_non_null_expression] = STATE(2537),
    [sym_internal_module] = STATE(2537),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2537),
    [sym_await_expression] = STATE(2537),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2537),
    [sym_this] = STATE(2537),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2537),
    [sym_generator_function] = STATE(2537),
    [sym_call_expression] = STATE(2537),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2537),
    [sym_ternary_expression] = STATE(2537),
    [sym_binary_expression] = STATE(2537),
    [sym_template_string] = STATE(2537),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2537),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2537),
    [sym_class] = STATE(2537),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(217),
    [sym_identifier] = ACTIONS(5308),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_COMMA] = ACTIONS(217),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT_GT_GT] = ACTIONS(217),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_LBRACE_PIPE] = ACTIONS(217),
    [anon_sym_PERCENT] = ACTIONS(217),
    [anon_sym_as] = ACTIONS(219),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_instanceof] = ACTIONS(219),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(5326),
    [sym_true] = ACTIONS(5348),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_DOT] = ACTIONS(219),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_STAR_STAR] = ACTIONS(217),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(5340),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5348),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_LT_LT] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(5342),
    [anon_sym_AMP_AMP] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5348),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(217),
    [anon_sym_PIPE_PIPE] = ACTIONS(217),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(5350),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5348),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_CARET] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(217),
    [anon_sym_in] = ACTIONS(219),
  },
  [2412] = {
    [sym_new_expression] = STATE(2538),
    [sym_augmented_assignment_expression] = STATE(2538),
    [sym_unary_expression] = STATE(2538),
    [sym_update_expression] = STATE(2538),
    [sym_regex] = STATE(2538),
    [sym_meta_property] = STATE(2538),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2538),
    [sym_yield_expression] = STATE(2538),
    [sym_as_expression] = STATE(2538),
    [sym_non_null_expression] = STATE(2538),
    [sym_internal_module] = STATE(2538),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2538),
    [sym_await_expression] = STATE(2538),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2538),
    [sym_this] = STATE(2538),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2538),
    [sym_generator_function] = STATE(2538),
    [sym_call_expression] = STATE(2538),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2538),
    [sym_ternary_expression] = STATE(2538),
    [sym_binary_expression] = STATE(2538),
    [sym_template_string] = STATE(2538),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2538),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2538),
    [sym_class] = STATE(2538),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5352),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5352),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5354),
    [sym_true] = ACTIONS(5352),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5352),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2413] = {
    [sym_new_expression] = STATE(2583),
    [sym_augmented_assignment_expression] = STATE(2583),
    [sym_unary_expression] = STATE(2583),
    [sym_update_expression] = STATE(2583),
    [sym_regex] = STATE(2583),
    [sym_meta_property] = STATE(2583),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2583),
    [sym_yield_expression] = STATE(2583),
    [sym_as_expression] = STATE(2583),
    [sym_non_null_expression] = STATE(2583),
    [sym_internal_module] = STATE(2583),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2583),
    [sym_await_expression] = STATE(2583),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2583),
    [sym_this] = STATE(2583),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2583),
    [sym_generator_function] = STATE(2583),
    [sym_call_expression] = STATE(2583),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2583),
    [sym_ternary_expression] = STATE(2583),
    [sym_binary_expression] = STATE(2583),
    [sym_template_string] = STATE(2583),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2583),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2583),
    [sym_class] = STATE(2583),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5356),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5356),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5358),
    [sym_true] = ACTIONS(5356),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5356),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2414] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_COMMA] = ACTIONS(700),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(5360),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_implements] = ACTIONS(700),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [2415] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_COMMA] = ACTIONS(700),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(5360),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_implements] = ACTIONS(700),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [2416] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_COMMA] = ACTIONS(700),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(5360),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_implements] = ACTIONS(700),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [2417] = {
    [sym_call_signature] = STATE(2158),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(5363),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_STAR] = ACTIONS(5365),
    [sym_comment] = ACTIONS(3),
  },
  [2418] = {
    [sym__type] = STATE(2109),
    [sym_constructor_type] = STATE(2109),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(2109),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(2109),
    [sym_intersection_type] = STATE(2109),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2419] = {
    [sym_call_signature] = STATE(2162),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(5367),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2420] = {
    [sym__type] = STATE(2119),
    [sym_constructor_type] = STATE(2119),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(2119),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(2119),
    [sym_intersection_type] = STATE(2119),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2421] = {
    [sym_formal_parameters] = STATE(2120),
    [sym_type_parameters] = STATE(2432),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2422] = {
    [sym__type] = STATE(2122),
    [sym_constructor_type] = STATE(2122),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(2122),
    [sym_rest_parameter] = STATE(198),
    [sym_nested_identifier] = STATE(236),
    [sym_accessibility_modifier] = STATE(200),
    [sym_required_parameter] = STATE(198),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(218),
    [sym_type_parameters] = STATE(233),
    [sym_this] = STATE(468),
    [sym_predefined_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_array_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(477),
    [sym_object] = STATE(465),
    [sym_nested_type_identifier] = STATE(234),
    [sym_optional_parameter] = STATE(198),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(477),
    [sym_union_type] = STATE(2122),
    [sym_intersection_type] = STATE(2122),
    [sym_formal_parameters] = STATE(238),
    [sym_array] = STATE(467),
    [sym_identifier] = ACTIONS(1262),
    [anon_sym_symbol] = ACTIONS(1264),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(1264),
    [anon_sym_private] = ACTIONS(1158),
    [anon_sym_get] = ACTIONS(1154),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_this] = ACTIONS(1266),
    [sym_true] = ACTIONS(452),
    [anon_sym_protected] = ACTIONS(1158),
    [anon_sym_set] = ACTIONS(1154),
    [anon_sym_type] = ACTIONS(1154),
    [anon_sym_import] = ACTIONS(1154),
    [sym_readonly] = ACTIONS(418),
    [anon_sym_namespace] = ACTIONS(1154),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [sym_false] = ACTIONS(452),
    [anon_sym_module] = ACTIONS(1154),
    [anon_sym_number] = ACTIONS(1264),
    [anon_sym_declare] = ACTIONS(1154),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(422),
    [anon_sym_LBRACE] = ACTIONS(1270),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(1264),
    [anon_sym_boolean] = ACTIONS(1264),
    [anon_sym_async] = ACTIONS(1154),
    [anon_sym_public] = ACTIONS(1158),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_RPAREN] = ACTIONS(426),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(474),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1264),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_export] = ACTIONS(1154),
  },
  [2423] = {
    [sym_formal_parameters] = STATE(2125),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2424] = {
    [anon_sym_DOT] = ACTIONS(4225),
    [sym_comment] = ACTIONS(3),
  },
  [2425] = {
    [sym_call_signature] = STATE(2127),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [2426] = {
    [sym_call_signature] = STATE(2128),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(5369),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2427] = {
    [sym_new_expression] = STATE(2054),
    [sym_augmented_assignment_expression] = STATE(2054),
    [sym_unary_expression] = STATE(2054),
    [sym_update_expression] = STATE(2054),
    [sym_regex] = STATE(2054),
    [sym_meta_property] = STATE(2054),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2054),
    [sym_yield_expression] = STATE(2054),
    [sym_as_expression] = STATE(2054),
    [sym_non_null_expression] = STATE(2054),
    [sym_internal_module] = STATE(2054),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2054),
    [sym_await_expression] = STATE(2054),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2054),
    [sym_this] = STATE(2054),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2054),
    [sym_generator_function] = STATE(2054),
    [sym_call_expression] = STATE(2054),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2054),
    [sym_ternary_expression] = STATE(2054),
    [sym_binary_expression] = STATE(2054),
    [sym_template_string] = STATE(2054),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2054),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2054),
    [sym_class] = STATE(2054),
    [anon_sym_BANG] = ACTIONS(518),
    [sym_identifier] = ACTIONS(1329),
    [sym_false] = ACTIONS(5371),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5371),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5373),
    [sym_true] = ACTIONS(5371),
    [anon_sym_yield] = ACTIONS(508),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5371),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
  },
  [2428] = {
    [sym_call_signature] = STATE(2132),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
  },
  [2429] = {
    [sym__type] = STATE(2133),
    [sym_constructor_type] = STATE(2133),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(2133),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(2133),
    [sym_intersection_type] = STATE(2133),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2430] = {
    [sym__type] = STATE(2122),
    [sym_constructor_type] = STATE(2122),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(2122),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(2122),
    [sym_intersection_type] = STATE(2122),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2431] = {
    [aux_sym_export_statement_repeat1] = STATE(510),
    [sym_method_signature] = STATE(2134),
    [sym__property_name] = STATE(511),
    [sym_property_signature] = STATE(2134),
    [sym_call_signature] = STATE(2134),
    [sym_construct_signature] = STATE(2134),
    [sym_index_signature] = STATE(2134),
    [sym_export_statement] = STATE(2134),
    [sym_decorator] = STATE(510),
    [sym_accessibility_modifier] = STATE(512),
    [sym_formal_parameters] = STATE(1203),
    [sym_computed_property_name] = STATE(511),
    [sym_string] = STATE(511),
    [sym_type_parameters] = STATE(1741),
    [sym_identifier] = ACTIONS(919),
    [anon_sym_LBRACK] = ACTIONS(921),
    [anon_sym_module] = ACTIONS(919),
    [anon_sym_symbol] = ACTIONS(919),
    [anon_sym_number] = ACTIONS(919),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_declare] = ACTIONS(919),
    [anon_sym_STAR] = ACTIONS(1224),
    [anon_sym_void] = ACTIONS(919),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [anon_sym_any] = ACTIONS(919),
    [anon_sym_private] = ACTIONS(925),
    [anon_sym_boolean] = ACTIONS(919),
    [anon_sym_static] = ACTIONS(1228),
    [anon_sym_public] = ACTIONS(925),
    [anon_sym_get] = ACTIONS(1230),
    [anon_sym_async] = ACTIONS(1234),
    [anon_sym_SQUOTE] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(482),
    [sym_number] = ACTIONS(1236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(925),
    [anon_sym_string] = ACTIONS(919),
    [anon_sym_set] = ACTIONS(1230),
    [anon_sym_type] = ACTIONS(919),
    [anon_sym_new] = ACTIONS(1238),
    [anon_sym_import] = ACTIONS(919),
    [anon_sym_export] = ACTIONS(1240),
    [sym_readonly] = ACTIONS(1242),
    [anon_sym_namespace] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(943),
  },
  [2432] = {
    [sym_formal_parameters] = STATE(2138),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2433] = {
    [sym__type] = STATE(2140),
    [sym_constructor_type] = STATE(2140),
    [sym_index_type_query] = STATE(237),
    [sym_lookup_type] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_flow_maybe_type] = STATE(237),
    [sym_function_type] = STATE(2140),
    [sym_nested_identifier] = STATE(236),
    [sym__primary_type] = STATE(237),
    [sym_generic_type] = STATE(237),
    [sym_mapped_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_type_parameters] = STATE(233),
    [sym_string] = STATE(218),
    [sym_array_type] = STATE(237),
    [sym_tuple_type] = STATE(237),
    [sym_nested_type_identifier] = STATE(234),
    [sym_type_predicate] = STATE(237),
    [sym_type_query] = STATE(237),
    [sym__number] = STATE(218),
    [sym_existential_type] = STATE(237),
    [sym_object_type] = STATE(237),
    [sym_union_type] = STATE(2140),
    [sym_intersection_type] = STATE(2140),
    [sym_formal_parameters] = STATE(238),
    [sym_identifier] = ACTIONS(731),
    [sym_false] = ACTIONS(452),
    [anon_sym_LBRACK] = ACTIONS(458),
    [anon_sym_symbol] = ACTIONS(462),
    [anon_sym_number] = ACTIONS(462),
    [anon_sym_typeof] = ACTIONS(466),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_DASH] = ACTIONS(468),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_LBRACE] = ACTIONS(476),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_void] = ACTIONS(462),
    [anon_sym_LPAREN] = ACTIONS(480),
    [anon_sym_any] = ACTIONS(462),
    [anon_sym_boolean] = ACTIONS(462),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_this] = ACTIONS(464),
    [sym_number] = ACTIONS(474),
    [sym_true] = ACTIONS(452),
    [anon_sym_LT] = ACTIONS(482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(462),
    [anon_sym_new] = ACTIONS(478),
    [anon_sym_PLUS] = ACTIONS(468),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2434] = {
    [sym_call_signature] = STATE(2141),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2435] = {
    [sym_formal_parameters] = STATE(2164),
    [sym_type_parameters] = STATE(2441),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2436] = {
    [sym_formal_parameters] = STATE(2166),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2437] = {
    [anon_sym_DOT] = ACTIONS(5375),
    [sym_comment] = ACTIONS(3),
  },
  [2438] = {
    [sym_call_signature] = STATE(2167),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [2439] = {
    [sym_call_signature] = STATE(2168),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(5377),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2440] = {
    [sym_call_signature] = STATE(2172),
    [sym_formal_parameters] = STATE(1203),
    [sym_type_parameters] = STATE(1741),
    [anon_sym_LPAREN] = ACTIONS(1226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [2441] = {
    [sym_formal_parameters] = STATE(2173),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2442] = {
    [sym_call_signature] = STATE(2174),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2443] = {
    [sym__initializer] = STATE(80),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(4290),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4290),
    [anon_sym_AMP_EQ] = ACTIONS(4290),
    [anon_sym_PLUS_EQ] = ACTIONS(4290),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(4290),
    [anon_sym_STAR_EQ] = ACTIONS(4290),
    [anon_sym_PIPE_EQ] = ACTIONS(4290),
    [anon_sym_DASH_EQ] = ACTIONS(4290),
    [anon_sym_EQ_GT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(4290),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4290),
    [anon_sym_GT_GT_EQ] = ACTIONS(4290),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4290),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2444] = {
    [sym_decorator_member_expression] = STATE(2211),
    [sym_decorator_call_expression] = STATE(83),
    [sym__identifier_reference] = STATE(2211),
    [sym_identifier] = ACTIONS(5379),
    [anon_sym_module] = ACTIONS(147),
    [anon_sym_symbol] = ACTIONS(147),
    [anon_sym_number] = ACTIONS(147),
    [anon_sym_declare] = ACTIONS(147),
    [anon_sym_void] = ACTIONS(147),
    [anon_sym_any] = ACTIONS(147),
    [anon_sym_private] = ACTIONS(147),
    [anon_sym_boolean] = ACTIONS(147),
    [anon_sym_async] = ACTIONS(147),
    [anon_sym_public] = ACTIONS(147),
    [anon_sym_get] = ACTIONS(147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(147),
    [anon_sym_string] = ACTIONS(147),
    [anon_sym_set] = ACTIONS(147),
    [anon_sym_type] = ACTIONS(147),
    [anon_sym_import] = ACTIONS(147),
    [anon_sym_export] = ACTIONS(147),
    [anon_sym_namespace] = ACTIONS(147),
  },
  [2445] = {
    [sym_new_expression] = STATE(2215),
    [sym_augmented_assignment_expression] = STATE(2215),
    [sym_unary_expression] = STATE(2215),
    [sym_update_expression] = STATE(2215),
    [sym_regex] = STATE(2215),
    [sym_meta_property] = STATE(2215),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(2215),
    [sym_yield_expression] = STATE(2215),
    [sym_as_expression] = STATE(2215),
    [sym_non_null_expression] = STATE(2215),
    [sym_internal_module] = STATE(2215),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(2215),
    [sym_await_expression] = STATE(2215),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(2215),
    [sym_this] = STATE(2215),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(2215),
    [sym_generator_function] = STATE(2215),
    [sym_call_expression] = STATE(2215),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(2215),
    [sym_ternary_expression] = STATE(2215),
    [sym_binary_expression] = STATE(2215),
    [sym_template_string] = STATE(2215),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2215),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(2215),
    [sym_class] = STATE(2215),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5119),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5119),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5381),
    [sym_true] = ACTIONS(5119),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5119),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2446] = {
    [sym_new_expression] = STATE(2217),
    [sym_augmented_assignment_expression] = STATE(2217),
    [sym__initializer] = STATE(80),
    [sym_unary_expression] = STATE(2217),
    [sym_update_expression] = STATE(2217),
    [sym_regex] = STATE(2217),
    [sym_meta_property] = STATE(2217),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(2217),
    [sym_yield_expression] = STATE(2217),
    [sym_as_expression] = STATE(2217),
    [sym_non_null_expression] = STATE(2217),
    [sym_internal_module] = STATE(2217),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(2217),
    [sym_await_expression] = STATE(2217),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(2217),
    [sym_this] = STATE(2217),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(2217),
    [sym_generator_function] = STATE(2217),
    [sym_call_expression] = STATE(2217),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(2217),
    [sym_ternary_expression] = STATE(2217),
    [sym_binary_expression] = STATE(2217),
    [sym_template_string] = STATE(2217),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2217),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(2217),
    [sym_class] = STATE(2217),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1367),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_PERCENT_EQ] = ACTIONS(4290),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_AMP_EQ] = ACTIONS(4290),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(4290),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(23),
    [anon_sym_CARET_EQ] = ACTIONS(4290),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_PIPE_EQ] = ACTIONS(4290),
    [anon_sym_DASH_EQ] = ACTIONS(4290),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(4290),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(1379),
    [sym_true] = ACTIONS(4294),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_GT_GT_EQ] = ACTIONS(4290),
    [anon_sym_DOT] = ACTIONS(167),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4290),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(4296),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(4294),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4290),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4294),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_STAR_EQ] = ACTIONS(4290),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_EQ_GT] = ACTIONS(4292),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(4298),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4290),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(4294),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2447] = {
    [sym_new_expression] = STATE(2217),
    [sym_augmented_assignment_expression] = STATE(2217),
    [sym_unary_expression] = STATE(2217),
    [sym_update_expression] = STATE(2217),
    [sym_regex] = STATE(2217),
    [sym_meta_property] = STATE(2217),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(2217),
    [sym_yield_expression] = STATE(2217),
    [sym_as_expression] = STATE(2217),
    [sym_non_null_expression] = STATE(2217),
    [sym_internal_module] = STATE(2217),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(2217),
    [sym_await_expression] = STATE(2217),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(2217),
    [sym_this] = STATE(2217),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(2217),
    [sym_generator_function] = STATE(2217),
    [sym_call_expression] = STATE(2217),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(2217),
    [sym_ternary_expression] = STATE(2217),
    [sym_binary_expression] = STATE(2217),
    [sym_template_string] = STATE(2217),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2217),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(2217),
    [sym_class] = STATE(2217),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(4294),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(4294),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(4298),
    [sym_true] = ACTIONS(4294),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(4294),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2448] = {
    [sym_new_expression] = STATE(111),
    [sym_augmented_assignment_expression] = STATE(111),
    [sym_unary_expression] = STATE(111),
    [sym_update_expression] = STATE(111),
    [sym_regex] = STATE(111),
    [sym_meta_property] = STATE(111),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(111),
    [sym_yield_expression] = STATE(111),
    [sym_as_expression] = STATE(111),
    [sym_non_null_expression] = STATE(111),
    [sym_internal_module] = STATE(111),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(111),
    [sym_await_expression] = STATE(111),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(111),
    [sym_this] = STATE(111),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(111),
    [sym_generator_function] = STATE(111),
    [sym_call_expression] = STATE(111),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(111),
    [sym_ternary_expression] = STATE(111),
    [sym_binary_expression] = STATE(111),
    [sym_template_string] = STATE(111),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(111),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(111),
    [sym_class] = STATE(111),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(207),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(207),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(209),
    [sym_true] = ACTIONS(207),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(207),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2449] = {
    [sym_new_expression] = STATE(2222),
    [sym_augmented_assignment_expression] = STATE(2222),
    [sym_unary_expression] = STATE(2222),
    [sym_update_expression] = STATE(2222),
    [sym_regex] = STATE(2222),
    [sym_meta_property] = STATE(2222),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(2222),
    [sym_yield_expression] = STATE(2222),
    [sym_as_expression] = STATE(2222),
    [sym_non_null_expression] = STATE(2222),
    [sym_internal_module] = STATE(2222),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(2222),
    [sym_await_expression] = STATE(2222),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(2222),
    [sym_this] = STATE(2222),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(2222),
    [sym_generator_function] = STATE(2222),
    [sym_call_expression] = STATE(2222),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(2222),
    [sym_ternary_expression] = STATE(2222),
    [sym_binary_expression] = STATE(2222),
    [sym_template_string] = STATE(2222),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2222),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(2222),
    [sym_class] = STATE(2222),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(217),
    [sym__automatic_semicolon] = ACTIONS(217),
    [sym_identifier] = ACTIONS(1367),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT_GT_GT] = ACTIONS(217),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_BANG_EQ] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_PERCENT] = ACTIONS(217),
    [anon_sym_as] = ACTIONS(219),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_instanceof] = ACTIONS(219),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(1379),
    [sym_true] = ACTIONS(5383),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_DOT] = ACTIONS(219),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_STAR_STAR] = ACTIONS(217),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(4296),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(5383),
    [anon_sym_SEMI] = ACTIONS(217),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_AMP_AMP] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5383),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(217),
    [anon_sym_PIPE_PIPE] = ACTIONS(217),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(5385),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5383),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_CARET] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(217),
    [anon_sym_in] = ACTIONS(219),
  },
  [2450] = {
    [anon_sym_class] = ACTIONS(5387),
    [sym_comment] = ACTIONS(3),
  },
  [2451] = {
    [sym_new_expression] = STATE(2226),
    [sym_augmented_assignment_expression] = STATE(2226),
    [sym_unary_expression] = STATE(2226),
    [sym_update_expression] = STATE(2226),
    [sym_regex] = STATE(2226),
    [sym_meta_property] = STATE(2226),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(2226),
    [sym_yield_expression] = STATE(2226),
    [sym_as_expression] = STATE(2226),
    [sym_non_null_expression] = STATE(2226),
    [sym_internal_module] = STATE(2226),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(2226),
    [sym_await_expression] = STATE(2226),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(2226),
    [sym_this] = STATE(2226),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(2226),
    [sym_generator_function] = STATE(2226),
    [sym_call_expression] = STATE(2226),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(2226),
    [sym_ternary_expression] = STATE(2226),
    [sym_binary_expression] = STATE(2226),
    [sym_template_string] = STATE(2226),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2226),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(2226),
    [sym_class] = STATE(2226),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5389),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5389),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5391),
    [sym_true] = ACTIONS(5389),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5389),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2452] = {
    [sym_new_expression] = STATE(2227),
    [sym_augmented_assignment_expression] = STATE(2227),
    [sym_unary_expression] = STATE(2227),
    [sym_update_expression] = STATE(2227),
    [sym_regex] = STATE(2227),
    [sym_meta_property] = STATE(2227),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(2227),
    [sym_yield_expression] = STATE(2227),
    [sym_as_expression] = STATE(2227),
    [sym_non_null_expression] = STATE(2227),
    [sym_internal_module] = STATE(2227),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(2227),
    [sym_await_expression] = STATE(2227),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(2227),
    [sym_this] = STATE(2227),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(2227),
    [sym_generator_function] = STATE(2227),
    [sym_call_expression] = STATE(2227),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(2227),
    [sym_ternary_expression] = STATE(2227),
    [sym_binary_expression] = STATE(2227),
    [sym_template_string] = STATE(2227),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2227),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(2227),
    [sym_class] = STATE(2227),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(5393),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5393),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(5395),
    [sym_true] = ACTIONS(5393),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5393),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2453] = {
    [sym_call_signature] = STATE(206),
    [sym__initializer] = STATE(80),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym__automatic_semicolon] = ACTIONS(135),
    [sym_identifier] = ACTIONS(430),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(137),
    [anon_sym_symbol] = ACTIONS(432),
    [anon_sym_AMP_EQ] = ACTIONS(137),
    [anon_sym_PLUS_EQ] = ACTIONS(137),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_void] = ACTIONS(432),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(137),
    [anon_sym_private] = ACTIONS(432),
    [anon_sym_PIPE_EQ] = ACTIONS(137),
    [anon_sym_DASH_EQ] = ACTIONS(137),
    [anon_sym_get] = ACTIONS(432),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(137),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(432),
    [anon_sym_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_DOT] = ACTIONS(141),
    [anon_sym_set] = ACTIONS(432),
    [anon_sym_type] = ACTIONS(432),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(432),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(137),
    [anon_sym_namespace] = ACTIONS(432),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_SEMI] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(432),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(137),
    [anon_sym_number] = ACTIONS(432),
    [anon_sym_declare] = ACTIONS(432),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(432),
    [anon_sym_STAR_EQ] = ACTIONS(137),
    [anon_sym_boolean] = ACTIONS(432),
    [anon_sym_async] = ACTIONS(432),
    [anon_sym_public] = ACTIONS(432),
    [anon_sym_EQ_GT] = ACTIONS(143),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(137),
    [anon_sym_string] = ACTIONS(432),
    [anon_sym_function] = ACTIONS(5397),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(432),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2454] = {
    [sym_call_signature] = STATE(2244),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(5399),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [anon_sym_STAR] = ACTIONS(5401),
    [sym_comment] = ACTIONS(3),
  },
  [2455] = {
    [sym_new_expression] = STATE(244),
    [sym_augmented_assignment_expression] = STATE(250),
    [sym_unary_expression] = STATE(250),
    [sym_update_expression] = STATE(250),
    [sym_regex] = STATE(244),
    [sym_meta_property] = STATE(244),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(250),
    [sym_yield_expression] = STATE(250),
    [sym_as_expression] = STATE(250),
    [sym_non_null_expression] = STATE(250),
    [sym_internal_module] = STATE(250),
    [sym_function] = STATE(251),
    [sym_arrow_function] = STATE(244),
    [sym_await_expression] = STATE(250),
    [sym_member_expression] = STATE(252),
    [sym_string] = STATE(244),
    [sym_this] = STATE(244),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(253),
    [sym_anonymous_class] = STATE(244),
    [sym_generator_function] = STATE(244),
    [sym_call_expression] = STATE(250),
    [sym_subscript_expression] = STATE(252),
    [sym_assignment_expression] = STATE(250),
    [sym_ternary_expression] = STATE(250),
    [sym_binary_expression] = STATE(250),
    [sym_template_string] = STATE(244),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(244),
    [sym_array] = STATE(254),
    [sym_type_assertion] = STATE(250),
    [sym_class] = STATE(244),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [sym_identifier] = ACTIONS(5121),
    [sym_false] = ACTIONS(510),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_module] = ACTIONS(5123),
    [anon_sym_symbol] = ACTIONS(5123),
    [anon_sym_number] = ACTIONS(5123),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(5123),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(5125),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(510),
    [sym_super] = ACTIONS(502),
    [anon_sym_any] = ACTIONS(5123),
    [anon_sym_private] = ACTIONS(5123),
    [anon_sym_boolean] = ACTIONS(5123),
    [anon_sym_async] = ACTIONS(5129),
    [anon_sym_public] = ACTIONS(5123),
    [anon_sym_get] = ACTIONS(5123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(522),
    [sym_true] = ACTIONS(510),
    [anon_sym_yield] = ACTIONS(508),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5123),
    [anon_sym_string] = ACTIONS(5123),
    [anon_sym_function] = ACTIONS(163),
    [anon_sym_DOT] = ACTIONS(512),
    [sym_undefined] = ACTIONS(510),
    [anon_sym_set] = ACTIONS(5123),
    [anon_sym_type] = ACTIONS(5123),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(5123),
    [anon_sym_export] = ACTIONS(5123),
    [anon_sym_namespace] = ACTIONS(5127),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2456] = {
    [anon_sym_EQ_GT] = ACTIONS(4284),
    [sym_comment] = ACTIONS(3),
  },
  [2457] = {
    [sym__initializer] = STATE(72),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(4280),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(4280),
    [anon_sym_AMP_EQ] = ACTIONS(4280),
    [anon_sym_PLUS_EQ] = ACTIONS(4280),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(4280),
    [anon_sym_STAR_EQ] = ACTIONS(4280),
    [anon_sym_PIPE_EQ] = ACTIONS(4280),
    [anon_sym_DASH_EQ] = ACTIONS(4280),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(4280),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(4280),
    [anon_sym_GT_GT_EQ] = ACTIONS(4280),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [2458] = {
    [sym__initializer] = STATE(267),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2455),
  },
  [2459] = {
    [sym_new_expression] = STATE(285),
    [sym_augmented_assignment_expression] = STATE(285),
    [sym_unary_expression] = STATE(285),
    [sym_update_expression] = STATE(285),
    [sym_regex] = STATE(285),
    [sym_meta_property] = STATE(285),
    [sym_call_signature] = STATE(2456),
    [sym__expression] = STATE(285),
    [sym_yield_expression] = STATE(285),
    [sym_as_expression] = STATE(285),
    [sym_non_null_expression] = STATE(285),
    [sym_internal_module] = STATE(285),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(285),
    [sym_await_expression] = STATE(285),
    [sym_member_expression] = STATE(2457),
    [sym_string] = STATE(285),
    [sym_this] = STATE(285),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(2458),
    [sym_anonymous_class] = STATE(285),
    [sym_generator_function] = STATE(285),
    [sym_call_expression] = STATE(285),
    [sym_subscript_expression] = STATE(2457),
    [sym_assignment_expression] = STATE(285),
    [sym_ternary_expression] = STATE(285),
    [sym_binary_expression] = STATE(285),
    [sym_template_string] = STATE(285),
    [sym_type_arguments] = STATE(2459),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(285),
    [sym_array] = STATE(2460),
    [sym_type_assertion] = STATE(285),
    [sym_class] = STATE(285),
    [anon_sym_BANG] = ACTIONS(1387),
    [sym_identifier] = ACTIONS(1367),
    [sym_false] = ACTIONS(608),
    [anon_sym_LBRACK] = ACTIONS(63),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1369),
    [anon_sym_symbol] = ACTIONS(1369),
    [anon_sym_number] = ACTIONS(1369),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(1369),
    [anon_sym_typeof] = ACTIONS(1375),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(1371),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_void] = ACTIONS(1373),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(608),
    [sym_super] = ACTIONS(23),
    [anon_sym_any] = ACTIONS(1369),
    [anon_sym_private] = ACTIONS(1369),
    [anon_sym_boolean] = ACTIONS(1369),
    [anon_sym_async] = ACTIONS(1389),
    [anon_sym_public] = ACTIONS(1369),
    [anon_sym_get] = ACTIONS(1369),
    [anon_sym_delete] = ACTIONS(1375),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(39),
    [sym_number] = ACTIONS(610),
    [sym_true] = ACTIONS(608),
    [anon_sym_yield] = ACTIONS(1379),
    [anon_sym_SLASH] = ACTIONS(95),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1369),
    [anon_sym_string] = ACTIONS(1369),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(608),
    [anon_sym_set] = ACTIONS(1369),
    [anon_sym_type] = ACTIONS(1369),
    [anon_sym_new] = ACTIONS(1393),
    [anon_sym_import] = ACTIONS(1369),
    [anon_sym_export] = ACTIONS(1369),
    [anon_sym_namespace] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1371),
    [anon_sym_await] = ACTIONS(1385),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(1387),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
  },
  [2460] = {
    [sym__initializer] = STATE(286),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(2455),
  },
  [2461] = {
    [sym_identifier] = ACTIONS(5403),
    [sym_comment] = ACTIONS(3),
  },
  [2462] = {
    [sym_type_parameters] = STATE(2473),
    [anon_sym_EQ] = ACTIONS(5405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [2463] = {
    [sym_new_expression] = STATE(2593),
    [sym_augmented_assignment_expression] = STATE(2593),
    [sym_unary_expression] = STATE(2593),
    [sym_update_expression] = STATE(2593),
    [sym_regex] = STATE(2593),
    [sym_meta_property] = STATE(2593),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2593),
    [sym_yield_expression] = STATE(2593),
    [sym_as_expression] = STATE(2593),
    [sym_non_null_expression] = STATE(2593),
    [sym_internal_module] = STATE(2593),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2593),
    [sym_await_expression] = STATE(2593),
    [sym_member_expression] = STATE(2578),
    [sym_generic_type] = STATE(2594),
    [sym_string] = STATE(2593),
    [sym_this] = STATE(2593),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_nested_type_identifier] = STATE(378),
    [sym_anonymous_class] = STATE(2593),
    [sym_generator_function] = STATE(2593),
    [sym_call_expression] = STATE(2593),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2593),
    [sym_ternary_expression] = STATE(2593),
    [sym_binary_expression] = STATE(2593),
    [sym_template_string] = STATE(2593),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2593),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2593),
    [sym__type_reference] = STATE(2594),
    [sym_class] = STATE(2593),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5407),
    [sym_false] = ACTIONS(5409),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5409),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5411),
    [sym_true] = ACTIONS(5409),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5409),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2464] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(5413),
  },
  [2465] = {
    [sym_identifier] = ACTIONS(5415),
    [sym_comment] = ACTIONS(3),
  },
  [2466] = {
    [sym_identifier] = ACTIONS(5417),
    [sym_comment] = ACTIONS(3),
  },
  [2467] = {
    [anon_sym_EQ_GT] = ACTIONS(5419),
    [sym_comment] = ACTIONS(3),
  },
  [2468] = {
    [anon_sym_EQ_GT] = ACTIONS(5421),
    [sym_comment] = ACTIONS(3),
  },
  [2469] = {
    [sym_call_signature] = STATE(2274),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(5423),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2470] = {
    [sym_call_signature] = STATE(2281),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_identifier] = ACTIONS(5425),
    [anon_sym_LT] = ACTIONS(482),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
  },
  [2471] = {
    [anon_sym_namespace] = ACTIONS(5427),
    [sym_comment] = ACTIONS(3),
  },
  [2472] = {
    [aux_sym_export_statement_repeat1] = STATE(2472),
    [sym_decorator] = STATE(2472),
    [anon_sym_LBRACK] = ACTIONS(1666),
    [sym_identifier] = ACTIONS(5429),
    [anon_sym_module] = ACTIONS(5429),
    [anon_sym_symbol] = ACTIONS(5429),
    [anon_sym_number] = ACTIONS(5429),
    [anon_sym_AT] = ACTIONS(5431),
    [anon_sym_class] = ACTIONS(5429),
    [anon_sym_declare] = ACTIONS(5429),
    [anon_sym_STAR] = ACTIONS(1666),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1666),
    [anon_sym_LBRACE] = ACTIONS(1666),
    [anon_sym_void] = ACTIONS(5429),
    [anon_sym_any] = ACTIONS(5429),
    [anon_sym_private] = ACTIONS(5429),
    [anon_sym_boolean] = ACTIONS(5429),
    [anon_sym_async] = ACTIONS(5429),
    [anon_sym_public] = ACTIONS(5429),
    [anon_sym_get] = ACTIONS(5429),
    [anon_sym_static] = ACTIONS(5429),
    [anon_sym_SQUOTE] = ACTIONS(1666),
    [anon_sym_this] = ACTIONS(5429),
    [sym_number] = ACTIONS(1666),
    [sym_comment] = ACTIONS(3),
    [anon_sym_protected] = ACTIONS(5429),
    [anon_sym_string] = ACTIONS(5429),
    [anon_sym_set] = ACTIONS(5429),
    [anon_sym_type] = ACTIONS(5429),
    [anon_sym_import] = ACTIONS(5429),
    [anon_sym_export] = ACTIONS(5429),
    [sym_readonly] = ACTIONS(5429),
    [anon_sym_namespace] = ACTIONS(5429),
    [anon_sym_DQUOTE] = ACTIONS(1666),
  },
  [2473] = {
    [anon_sym_EQ] = ACTIONS(5434),
    [sym_comment] = ACTIONS(3),
  },
  [2474] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_arrow_function] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2291),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_object] = STATE(57),
    [sym_generator_function] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_update_expression] = STATE(59),
    [sym_meta_property] = STATE(59),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_function] = STATE(89),
    [sym_await_expression] = STATE(59),
    [sym_sequence_expression] = STATE(62),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(2291),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_anonymous_class] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(59),
    [sym_class] = STATE(59),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [2475] = {
    [sym_string] = STATE(2292),
    [sym__property_name] = STATE(2292),
    [sym_computed_property_name] = STATE(2292),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(3058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [2476] = {
    [sym_call_signature] = STATE(2293),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_LPAREN] = ACTIONS(490),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(482),
  },
  [2477] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5436),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2478] = {
    [sym_new_expression] = STATE(2297),
    [sym_augmented_assignment_expression] = STATE(2297),
    [sym_unary_expression] = STATE(2297),
    [sym_update_expression] = STATE(2297),
    [sym_regex] = STATE(2297),
    [sym_meta_property] = STATE(2297),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(2297),
    [sym_yield_expression] = STATE(2297),
    [sym_as_expression] = STATE(2297),
    [sym_non_null_expression] = STATE(2297),
    [sym_internal_module] = STATE(2297),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(2297),
    [sym_await_expression] = STATE(2297),
    [sym_member_expression] = STATE(54),
    [sym_sequence_expression] = STATE(2298),
    [sym_string] = STATE(2297),
    [sym_this] = STATE(2297),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(2297),
    [sym_generator_function] = STATE(2297),
    [sym_call_expression] = STATE(2297),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(2297),
    [sym_ternary_expression] = STATE(2297),
    [sym_binary_expression] = STATE(2297),
    [sym_template_string] = STATE(2297),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2297),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(2297),
    [sym_class] = STATE(2297),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(5438),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(5438),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5438),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5440),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5438),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [2479] = {
    [sym_new_expression] = STATE(2299),
    [sym_augmented_assignment_expression] = STATE(2299),
    [sym_unary_expression] = STATE(2299),
    [sym_update_expression] = STATE(2299),
    [sym_regex] = STATE(2299),
    [sym_meta_property] = STATE(2299),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2299),
    [sym_yield_expression] = STATE(2299),
    [sym_as_expression] = STATE(2299),
    [sym_non_null_expression] = STATE(2299),
    [sym_internal_module] = STATE(2299),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2299),
    [sym_await_expression] = STATE(2299),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2299),
    [sym_this] = STATE(2299),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2299),
    [sym_generator_function] = STATE(2299),
    [sym_call_expression] = STATE(2299),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2299),
    [sym_ternary_expression] = STATE(2299),
    [sym_binary_expression] = STATE(2299),
    [sym_template_string] = STATE(2299),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2299),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2299),
    [sym_class] = STATE(2299),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5442),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5442),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5442),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5444),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5442),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2480] = {
    [sym_new_expression] = STATE(2302),
    [sym_augmented_assignment_expression] = STATE(2302),
    [sym_unary_expression] = STATE(2302),
    [sym_update_expression] = STATE(2302),
    [sym_regex] = STATE(2302),
    [sym_meta_property] = STATE(2302),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2302),
    [sym_yield_expression] = STATE(2302),
    [sym_as_expression] = STATE(2302),
    [sym_non_null_expression] = STATE(2302),
    [sym_internal_module] = STATE(2302),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2302),
    [sym_await_expression] = STATE(2302),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2302),
    [sym_this] = STATE(2302),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2302),
    [sym_generator_function] = STATE(2302),
    [sym_call_expression] = STATE(2302),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2302),
    [sym_ternary_expression] = STATE(2302),
    [sym_binary_expression] = STATE(2302),
    [sym_template_string] = STATE(2302),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2302),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2302),
    [sym_class] = STATE(2302),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5446),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5446),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5446),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5448),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5446),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2481] = {
    [sym_new_expression] = STATE(2303),
    [sym_augmented_assignment_expression] = STATE(2303),
    [sym_unary_expression] = STATE(2303),
    [sym_update_expression] = STATE(2303),
    [sym_regex] = STATE(2303),
    [sym_meta_property] = STATE(2303),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(2303),
    [sym_yield_expression] = STATE(2303),
    [sym_as_expression] = STATE(2303),
    [sym_non_null_expression] = STATE(2303),
    [sym_internal_module] = STATE(2303),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(2303),
    [sym_await_expression] = STATE(2303),
    [sym_member_expression] = STATE(54),
    [sym_sequence_expression] = STATE(2304),
    [sym_string] = STATE(2303),
    [sym_this] = STATE(2303),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(2303),
    [sym_generator_function] = STATE(2303),
    [sym_call_expression] = STATE(2303),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(2303),
    [sym_ternary_expression] = STATE(2303),
    [sym_binary_expression] = STATE(2303),
    [sym_template_string] = STATE(2303),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2303),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(2303),
    [sym_class] = STATE(2303),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(5450),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(5450),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5450),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5452),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5450),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [2482] = {
    [sym_new_expression] = STATE(2305),
    [sym_augmented_assignment_expression] = STATE(2305),
    [sym_unary_expression] = STATE(2305),
    [sym_update_expression] = STATE(2305),
    [sym_regex] = STATE(2305),
    [sym_meta_property] = STATE(2305),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2305),
    [sym_yield_expression] = STATE(2305),
    [sym_as_expression] = STATE(2305),
    [sym_non_null_expression] = STATE(2305),
    [sym_internal_module] = STATE(2305),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2305),
    [sym_await_expression] = STATE(2305),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2305),
    [sym_this] = STATE(2305),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2305),
    [sym_generator_function] = STATE(2305),
    [sym_call_expression] = STATE(2305),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2305),
    [sym_ternary_expression] = STATE(2305),
    [sym_binary_expression] = STATE(2305),
    [sym_template_string] = STATE(2305),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2305),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2305),
    [sym_class] = STATE(2305),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5454),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5454),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5454),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5456),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5454),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2483] = {
    [sym_new_expression] = STATE(2306),
    [sym_augmented_assignment_expression] = STATE(2306),
    [sym_unary_expression] = STATE(2306),
    [sym_update_expression] = STATE(2306),
    [sym_regex] = STATE(2306),
    [sym_meta_property] = STATE(2306),
    [sym_call_signature] = STATE(52),
    [sym__expression] = STATE(2306),
    [sym_yield_expression] = STATE(2306),
    [sym_as_expression] = STATE(2306),
    [sym_non_null_expression] = STATE(2306),
    [sym_internal_module] = STATE(2306),
    [sym_function] = STATE(89),
    [sym_arrow_function] = STATE(2306),
    [sym_await_expression] = STATE(2306),
    [sym_member_expression] = STATE(54),
    [sym_sequence_expression] = STATE(2307),
    [sym_string] = STATE(2306),
    [sym_this] = STATE(2306),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_object] = STATE(57),
    [sym_anonymous_class] = STATE(2306),
    [sym_generator_function] = STATE(2306),
    [sym_call_expression] = STATE(2306),
    [sym_subscript_expression] = STATE(54),
    [sym_assignment_expression] = STATE(2306),
    [sym_ternary_expression] = STATE(2306),
    [sym_binary_expression] = STATE(2306),
    [sym_template_string] = STATE(2306),
    [sym_type_arguments] = STATE(64),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2306),
    [sym_array] = STATE(65),
    [sym_type_assertion] = STATE(2306),
    [sym_class] = STATE(2306),
    [sym_identifier] = ACTIONS(149),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(5458),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(5458),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(5458),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5460),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(5458),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [2484] = {
    [sym_new_expression] = STATE(2604),
    [sym_augmented_assignment_expression] = STATE(2604),
    [sym_unary_expression] = STATE(2604),
    [sym_update_expression] = STATE(2604),
    [sym_regex] = STATE(2604),
    [sym_meta_property] = STATE(2604),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2604),
    [sym_yield_expression] = STATE(2604),
    [sym_as_expression] = STATE(2604),
    [sym_non_null_expression] = STATE(2604),
    [sym_internal_module] = STATE(2604),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2604),
    [sym_await_expression] = STATE(2604),
    [sym_member_expression] = STATE(2578),
    [sym_generic_type] = STATE(877),
    [sym_string] = STATE(2604),
    [sym_this] = STATE(2604),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_nested_type_identifier] = STATE(378),
    [sym_anonymous_class] = STATE(2604),
    [sym_generator_function] = STATE(2604),
    [sym_call_expression] = STATE(2604),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2604),
    [sym_ternary_expression] = STATE(2604),
    [sym_binary_expression] = STATE(2604),
    [sym_template_string] = STATE(2604),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2604),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2604),
    [sym__type_reference] = STATE(877),
    [sym_class] = STATE(2604),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5407),
    [sym_false] = ACTIONS(5462),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5462),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5464),
    [sym_true] = ACTIONS(5462),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5462),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2485] = {
    [aux_sym_extends_clause_repeat1] = STATE(2499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2710),
    [anon_sym_COMMA] = ACTIONS(5466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5468),
  },
  [2486] = {
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2726),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2487] = {
    [sym_new_expression] = STATE(1220),
    [sym_augmented_assignment_expression] = STATE(1220),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(1220),
    [sym_update_expression] = STATE(1220),
    [sym_regex] = STATE(1220),
    [sym_meta_property] = STATE(1220),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(1220),
    [sym_yield_expression] = STATE(1220),
    [sym_as_expression] = STATE(1220),
    [sym_non_null_expression] = STATE(1220),
    [sym_internal_module] = STATE(1220),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1220),
    [sym_await_expression] = STATE(1220),
    [sym_member_expression] = STATE(1201),
    [sym_string] = STATE(1220),
    [sym_this] = STATE(1220),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(1220),
    [sym_generator_function] = STATE(1220),
    [sym_call_expression] = STATE(1220),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(1220),
    [sym_ternary_expression] = STATE(1220),
    [sym_binary_expression] = STATE(1220),
    [sym_template_string] = STATE(1220),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1220),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(1220),
    [sym_class] = STATE(1220),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(276),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(1124),
    [anon_sym_COLON] = ACTIONS(2726),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(1128),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1124),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(1124),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(1130),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1124),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2488] = {
    [sym_call_signature] = STATE(1782),
    [sym__initializer] = STATE(1215),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1132),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_symbol] = ACTIONS(1134),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_void] = ACTIONS(1134),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_private] = ACTIONS(1134),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_get] = ACTIONS(1134),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(2726),
    [anon_sym_protected] = ACTIONS(1134),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_set] = ACTIONS(1134),
    [anon_sym_type] = ACTIONS(1134),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(1134),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_namespace] = ACTIONS(1134),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(1134),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_number] = ACTIONS(1134),
    [anon_sym_declare] = ACTIONS(1134),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(1134),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_boolean] = ACTIONS(1134),
    [anon_sym_async] = ACTIONS(1134),
    [anon_sym_public] = ACTIONS(1134),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_string] = ACTIONS(1134),
    [anon_sym_function] = ACTIONS(1136),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(1134),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2489] = {
    [sym_nested_identifier] = STATE(1592),
    [sym__module] = STATE(1483),
    [sym_string] = STATE(1594),
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_PERCENT_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_AMP_EQ] = ACTIONS(1107),
    [anon_sym_PLUS_EQ] = ACTIONS(1107),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1093),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(1107),
    [anon_sym_STAR_EQ] = ACTIONS(1107),
    [anon_sym_PIPE_EQ] = ACTIONS(1107),
    [anon_sym_DASH_EQ] = ACTIONS(1107),
    [anon_sym_EQ_GT] = ACTIONS(1112),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(1107),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(2726),
    [anon_sym_SLASH_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT_EQ] = ACTIONS(1107),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1107),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2490] = {
    [sym_string] = STATE(2309),
    [sym__property_name] = STATE(2309),
    [sym_computed_property_name] = STATE(2309),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(5270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [2491] = {
    [sym_string] = STATE(2309),
    [sym__property_name] = STATE(2309),
    [sym_computed_property_name] = STATE(2309),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(5270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [2492] = {
    [sym_string] = STATE(2309),
    [sym__property_name] = STATE(2309),
    [sym_computed_property_name] = STATE(2309),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(3491),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(5470),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(5270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(5470),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2493] = {
    [sym_new_expression] = STATE(2310),
    [sym_augmented_assignment_expression] = STATE(2310),
    [sym_unary_expression] = STATE(2310),
    [sym_update_expression] = STATE(2310),
    [sym_regex] = STATE(2310),
    [sym_meta_property] = STATE(2310),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2310),
    [sym_yield_expression] = STATE(2310),
    [sym_as_expression] = STATE(2310),
    [sym_non_null_expression] = STATE(2310),
    [sym_internal_module] = STATE(2310),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2310),
    [sym_await_expression] = STATE(2310),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2310),
    [sym_this] = STATE(2310),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2310),
    [sym_generator_function] = STATE(2310),
    [sym_call_expression] = STATE(2310),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2310),
    [sym_ternary_expression] = STATE(2310),
    [sym_binary_expression] = STATE(2310),
    [sym_template_string] = STATE(2310),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2310),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2310),
    [sym_class] = STATE(2310),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5472),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5472),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5472),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5472),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2494] = {
    [sym_new_expression] = STATE(2311),
    [sym_augmented_assignment_expression] = STATE(2311),
    [sym_unary_expression] = STATE(2311),
    [sym_update_expression] = STATE(2311),
    [sym_regex] = STATE(2311),
    [sym_meta_property] = STATE(2311),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2311),
    [sym_yield_expression] = STATE(2311),
    [sym_as_expression] = STATE(2311),
    [sym_non_null_expression] = STATE(2311),
    [sym_internal_module] = STATE(2311),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2311),
    [sym_await_expression] = STATE(2311),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2311),
    [sym_this] = STATE(2311),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2311),
    [sym_generator_function] = STATE(2311),
    [sym_call_expression] = STATE(2311),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2311),
    [sym_ternary_expression] = STATE(2311),
    [sym_binary_expression] = STATE(2311),
    [sym_template_string] = STATE(2311),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2311),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2311),
    [sym_class] = STATE(2311),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5476),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5476),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5476),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5478),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5476),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2495] = {
    [sym_new_expression] = STATE(2312),
    [sym_augmented_assignment_expression] = STATE(2312),
    [sym_unary_expression] = STATE(2312),
    [sym_update_expression] = STATE(2312),
    [sym_regex] = STATE(2312),
    [sym_meta_property] = STATE(2312),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2312),
    [sym_yield_expression] = STATE(2312),
    [sym_as_expression] = STATE(2312),
    [sym_non_null_expression] = STATE(2312),
    [sym_internal_module] = STATE(2312),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2312),
    [sym_await_expression] = STATE(2312),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2312),
    [sym_this] = STATE(2312),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2312),
    [sym_generator_function] = STATE(2312),
    [sym_call_expression] = STATE(2312),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2312),
    [sym_ternary_expression] = STATE(2312),
    [sym_binary_expression] = STATE(2312),
    [sym_template_string] = STATE(2312),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2312),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2312),
    [sym_class] = STATE(2312),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5480),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5480),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5480),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5482),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5480),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2496] = {
    [sym_new_expression] = STATE(2313),
    [sym_augmented_assignment_expression] = STATE(2313),
    [sym_unary_expression] = STATE(2313),
    [sym_update_expression] = STATE(2313),
    [sym_regex] = STATE(2313),
    [sym_meta_property] = STATE(2313),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(2313),
    [sym_yield_expression] = STATE(2313),
    [sym_as_expression] = STATE(2313),
    [sym_non_null_expression] = STATE(2313),
    [sym_internal_module] = STATE(2313),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2313),
    [sym_await_expression] = STATE(2313),
    [sym_member_expression] = STATE(1201),
    [sym_sequence_expression] = STATE(2314),
    [sym_string] = STATE(2313),
    [sym_this] = STATE(2313),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(2313),
    [sym_generator_function] = STATE(2313),
    [sym_call_expression] = STATE(2313),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(2313),
    [sym_ternary_expression] = STATE(2313),
    [sym_binary_expression] = STATE(2313),
    [sym_template_string] = STATE(2313),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2313),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(2313),
    [sym_class] = STATE(2313),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(5484),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5484),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5484),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5486),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5484),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [2497] = {
    [sym_new_expression] = STATE(2315),
    [sym_augmented_assignment_expression] = STATE(2315),
    [sym_unary_expression] = STATE(2315),
    [sym_update_expression] = STATE(2315),
    [sym_regex] = STATE(2315),
    [sym_meta_property] = STATE(2315),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(2315),
    [sym_yield_expression] = STATE(2315),
    [sym_as_expression] = STATE(2315),
    [sym_non_null_expression] = STATE(2315),
    [sym_internal_module] = STATE(2315),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2315),
    [sym_await_expression] = STATE(2315),
    [sym_member_expression] = STATE(1201),
    [sym_sequence_expression] = STATE(2316),
    [sym_string] = STATE(2315),
    [sym_this] = STATE(2315),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(2315),
    [sym_generator_function] = STATE(2315),
    [sym_call_expression] = STATE(2315),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(2315),
    [sym_ternary_expression] = STATE(2315),
    [sym_binary_expression] = STATE(2315),
    [sym_template_string] = STATE(2315),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2315),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(2315),
    [sym_class] = STATE(2315),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(5488),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5488),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5488),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5490),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5488),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [2498] = {
    [sym_new_expression] = STATE(2317),
    [sym_augmented_assignment_expression] = STATE(2317),
    [sym_unary_expression] = STATE(2317),
    [sym_update_expression] = STATE(2317),
    [sym_regex] = STATE(2317),
    [sym_meta_property] = STATE(2317),
    [sym_call_signature] = STATE(1740),
    [sym__expression] = STATE(2317),
    [sym_yield_expression] = STATE(2317),
    [sym_as_expression] = STATE(2317),
    [sym_non_null_expression] = STATE(2317),
    [sym_internal_module] = STATE(2317),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2317),
    [sym_await_expression] = STATE(2317),
    [sym_member_expression] = STATE(1201),
    [sym_sequence_expression] = STATE(2318),
    [sym_string] = STATE(2317),
    [sym_this] = STATE(2317),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1202),
    [sym_anonymous_class] = STATE(2317),
    [sym_generator_function] = STATE(2317),
    [sym_call_expression] = STATE(2317),
    [sym_subscript_expression] = STATE(1201),
    [sym_assignment_expression] = STATE(2317),
    [sym_ternary_expression] = STATE(2317),
    [sym_binary_expression] = STATE(2317),
    [sym_template_string] = STATE(2317),
    [sym_type_arguments] = STATE(1205),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2317),
    [sym_array] = STATE(1206),
    [sym_type_assertion] = STATE(2317),
    [sym_class] = STATE(2317),
    [sym_identifier] = ACTIONS(266),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(270),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(274),
    [anon_sym_void] = ACTIONS(276),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(270),
    [anon_sym_get] = ACTIONS(270),
    [anon_sym_delete] = ACTIONS(280),
    [anon_sym_DASH_DASH] = ACTIONS(282),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(286),
    [sym_true] = ACTIONS(5492),
    [anon_sym_protected] = ACTIONS(270),
    [anon_sym_set] = ACTIONS(270),
    [anon_sym_type] = ACTIONS(270),
    [anon_sym_import] = ACTIONS(270),
    [anon_sym_namespace] = ACTIONS(290),
    [anon_sym_PLUS_PLUS] = ACTIONS(282),
    [anon_sym_await] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(296),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5492),
    [anon_sym_module] = ACTIONS(270),
    [anon_sym_number] = ACTIONS(270),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(270),
    [anon_sym_typeof] = ACTIONS(280),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5492),
    [anon_sym_any] = ACTIONS(270),
    [anon_sym_boolean] = ACTIONS(270),
    [anon_sym_async] = ACTIONS(306),
    [anon_sym_public] = ACTIONS(270),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5494),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(270),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5492),
    [anon_sym_new] = ACTIONS(316),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_export] = ACTIONS(270),
    [anon_sym_TILDE] = ACTIONS(296),
  },
  [2499] = {
    [aux_sym_extends_clause_repeat1] = STATE(2499),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3300),
    [anon_sym_COMMA] = ACTIONS(5496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(3302),
  },
  [2500] = {
    [sym_string] = STATE(2320),
    [sym__property_name] = STATE(2320),
    [sym_computed_property_name] = STATE(2320),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(1006),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(5278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2501] = {
    [sym_string] = STATE(2320),
    [sym__property_name] = STATE(2320),
    [sym_computed_property_name] = STATE(2320),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(5278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [2502] = {
    [sym_string] = STATE(2320),
    [sym__property_name] = STATE(2320),
    [sym_computed_property_name] = STATE(2320),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(3735),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(5499),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(5278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(5499),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2503] = {
    [sym_new_expression] = STATE(2321),
    [sym_augmented_assignment_expression] = STATE(2321),
    [sym_unary_expression] = STATE(2321),
    [sym_update_expression] = STATE(2321),
    [sym_regex] = STATE(2321),
    [sym_meta_property] = STATE(2321),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2321),
    [sym_yield_expression] = STATE(2321),
    [sym_as_expression] = STATE(2321),
    [sym_non_null_expression] = STATE(2321),
    [sym_internal_module] = STATE(2321),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2321),
    [sym_await_expression] = STATE(2321),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2321),
    [sym_this] = STATE(2321),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2321),
    [sym_generator_function] = STATE(2321),
    [sym_call_expression] = STATE(2321),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2321),
    [sym_ternary_expression] = STATE(2321),
    [sym_binary_expression] = STATE(2321),
    [sym_template_string] = STATE(2321),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2321),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2321),
    [sym_class] = STATE(2321),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5501),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5501),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5501),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5503),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5501),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2504] = {
    [sym_new_expression] = STATE(2322),
    [sym_augmented_assignment_expression] = STATE(2322),
    [sym_unary_expression] = STATE(2322),
    [sym_update_expression] = STATE(2322),
    [sym_regex] = STATE(2322),
    [sym_meta_property] = STATE(2322),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2322),
    [sym_yield_expression] = STATE(2322),
    [sym_as_expression] = STATE(2322),
    [sym_non_null_expression] = STATE(2322),
    [sym_internal_module] = STATE(2322),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2322),
    [sym_await_expression] = STATE(2322),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2322),
    [sym_this] = STATE(2322),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2322),
    [sym_generator_function] = STATE(2322),
    [sym_call_expression] = STATE(2322),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2322),
    [sym_ternary_expression] = STATE(2322),
    [sym_binary_expression] = STATE(2322),
    [sym_template_string] = STATE(2322),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2322),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2322),
    [sym_class] = STATE(2322),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5505),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5505),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5505),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5507),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5505),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2505] = {
    [sym_new_expression] = STATE(2323),
    [sym_augmented_assignment_expression] = STATE(2323),
    [sym_unary_expression] = STATE(2323),
    [sym_update_expression] = STATE(2323),
    [sym_regex] = STATE(2323),
    [sym_meta_property] = STATE(2323),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2323),
    [sym_yield_expression] = STATE(2323),
    [sym_as_expression] = STATE(2323),
    [sym_non_null_expression] = STATE(2323),
    [sym_internal_module] = STATE(2323),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2323),
    [sym_await_expression] = STATE(2323),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2323),
    [sym_this] = STATE(2323),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2323),
    [sym_generator_function] = STATE(2323),
    [sym_call_expression] = STATE(2323),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2323),
    [sym_ternary_expression] = STATE(2323),
    [sym_binary_expression] = STATE(2323),
    [sym_template_string] = STATE(2323),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2323),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2323),
    [sym_class] = STATE(2323),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5509),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5509),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5509),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5511),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5509),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2506] = {
    [sym_string] = STATE(2325),
    [sym__property_name] = STATE(2325),
    [sym_computed_property_name] = STATE(2325),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(5280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [2507] = {
    [sym_string] = STATE(2325),
    [sym__property_name] = STATE(2325),
    [sym_computed_property_name] = STATE(2325),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(5280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [2508] = {
    [sym_string] = STATE(2325),
    [sym__property_name] = STATE(2325),
    [sym_computed_property_name] = STATE(2325),
    [sym__automatic_semicolon] = ACTIONS(986),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_SEMI] = ACTIONS(986),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_COMMA] = ACTIONS(986),
    [anon_sym_STAR] = ACTIONS(5513),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_async] = ACTIONS(1006),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_get] = ACTIONS(5515),
    [anon_sym_RBRACE] = ACTIONS(986),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(5280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(986),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(5515),
    [anon_sym_PIPE_RBRACE] = ACTIONS(986),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
  },
  [2509] = {
    [sym_string] = STATE(2327),
    [sym__property_name] = STATE(2327),
    [sym_computed_property_name] = STATE(2327),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_QMARK] = ACTIONS(986),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [anon_sym_LT] = ACTIONS(986),
    [sym_number] = ACTIONS(5517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_LPAREN] = ACTIONS(986),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [2510] = {
    [sym_string] = STATE(2327),
    [sym__property_name] = STATE(2327),
    [sym_computed_property_name] = STATE(2327),
    [anon_sym_get] = ACTIONS(1006),
    [sym_identifier] = ACTIONS(1006),
    [anon_sym_LBRACK] = ACTIONS(1008),
    [anon_sym_public] = ACTIONS(1006),
    [anon_sym_module] = ACTIONS(1006),
    [anon_sym_SQUOTE] = ACTIONS(326),
    [anon_sym_number] = ACTIONS(1006),
    [anon_sym_symbol] = ACTIONS(1006),
    [anon_sym_declare] = ACTIONS(1006),
    [sym_number] = ACTIONS(5517),
    [sym_comment] = ACTIONS(3),
    [anon_sym_void] = ACTIONS(1006),
    [anon_sym_protected] = ACTIONS(1006),
    [anon_sym_string] = ACTIONS(1006),
    [anon_sym_set] = ACTIONS(1006),
    [anon_sym_type] = ACTIONS(1006),
    [anon_sym_import] = ACTIONS(1006),
    [anon_sym_export] = ACTIONS(1006),
    [anon_sym_namespace] = ACTIONS(1006),
    [anon_sym_any] = ACTIONS(1006),
    [anon_sym_private] = ACTIONS(1006),
    [anon_sym_boolean] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(324),
    [anon_sym_async] = ACTIONS(1006),
  },
  [2511] = {
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2512] = {
    [sym_new_expression] = STATE(2349),
    [sym_augmented_assignment_expression] = STATE(2349),
    [sym_unary_expression] = STATE(2349),
    [sym_update_expression] = STATE(2349),
    [sym_regex] = STATE(2349),
    [sym_meta_property] = STATE(2349),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2349),
    [sym_yield_expression] = STATE(2349),
    [sym_as_expression] = STATE(2349),
    [sym_non_null_expression] = STATE(2349),
    [sym_internal_module] = STATE(2349),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2349),
    [sym_await_expression] = STATE(2349),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2349),
    [sym_this] = STATE(2349),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2349),
    [sym_generator_function] = STATE(2349),
    [sym_call_expression] = STATE(2349),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2349),
    [sym_ternary_expression] = STATE(2349),
    [sym_binary_expression] = STATE(2349),
    [sym_template_string] = STATE(2349),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2349),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2349),
    [sym_class] = STATE(2349),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5258),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5258),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5258),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5519),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5258),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2513] = {
    [sym_new_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(2350),
    [sym_update_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2350),
    [sym_yield_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_non_null_expression] = STATE(2350),
    [sym_internal_module] = STATE(2350),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2350),
    [sym_this] = STATE(2350),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2350),
    [sym_ternary_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2350),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(1323),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [sym_null] = ACTIONS(1323),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_BANG] = ACTIONS(2730),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1323),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(1335),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_in] = ACTIONS(139),
  },
  [2514] = {
    [sym_new_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym_unary_expression] = STATE(2350),
    [sym_update_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2350),
    [sym_yield_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_non_null_expression] = STATE(2350),
    [sym_internal_module] = STATE(2350),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2350),
    [sym_this] = STATE(2350),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2350),
    [sym_ternary_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2350),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2350),
    [sym_class] = STATE(2350),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(1323),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(1323),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(1323),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(1335),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2515] = {
    [sym_new_expression] = STATE(1222),
    [sym_augmented_assignment_expression] = STATE(1222),
    [sym_unary_expression] = STATE(1222),
    [sym_update_expression] = STATE(1222),
    [sym_regex] = STATE(1222),
    [sym_meta_property] = STATE(1222),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1222),
    [sym_yield_expression] = STATE(1222),
    [sym_as_expression] = STATE(1222),
    [sym_non_null_expression] = STATE(1222),
    [sym_internal_module] = STATE(1222),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1222),
    [sym_await_expression] = STATE(1222),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1222),
    [sym_this] = STATE(1222),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1222),
    [sym_generator_function] = STATE(1222),
    [sym_call_expression] = STATE(1222),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1222),
    [sym_ternary_expression] = STATE(1222),
    [sym_binary_expression] = STATE(1222),
    [sym_template_string] = STATE(1222),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1222),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1222),
    [sym_class] = STATE(1222),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(3898),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3898),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3898),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3900),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3898),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2516] = {
    [sym_new_expression] = STATE(2351),
    [sym_augmented_assignment_expression] = STATE(2351),
    [sym_unary_expression] = STATE(2351),
    [sym_update_expression] = STATE(2351),
    [sym_regex] = STATE(2351),
    [sym_meta_property] = STATE(2351),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2351),
    [sym_yield_expression] = STATE(2351),
    [sym_as_expression] = STATE(2351),
    [sym_non_null_expression] = STATE(2351),
    [sym_internal_module] = STATE(2351),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2351),
    [sym_await_expression] = STATE(2351),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2351),
    [sym_this] = STATE(2351),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2351),
    [sym_generator_function] = STATE(2351),
    [sym_call_expression] = STATE(2351),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2351),
    [sym_ternary_expression] = STATE(2351),
    [sym_binary_expression] = STATE(2351),
    [sym_template_string] = STATE(2351),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2351),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2351),
    [sym_class] = STATE(2351),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(217),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PIPE] = ACTIONS(219),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_STAR] = ACTIONS(219),
    [anon_sym_GT_GT_GT] = ACTIONS(217),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_BANG_EQ] = ACTIONS(219),
    [anon_sym_GT_EQ] = ACTIONS(217),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_PERCENT] = ACTIONS(217),
    [anon_sym_as] = ACTIONS(219),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_instanceof] = ACTIONS(219),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5521),
    [anon_sym_COLON] = ACTIONS(217),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_DOT] = ACTIONS(219),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_STAR_STAR] = ACTIONS(217),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(2730),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5521),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(217),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_AMP_AMP] = ACTIONS(217),
    [anon_sym_LT_EQ] = ACTIONS(217),
    [anon_sym_LPAREN] = ACTIONS(302),
    [anon_sym_RBRACK] = ACTIONS(217),
    [sym_null] = ACTIONS(5521),
    [anon_sym_GT] = ACTIONS(219),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_AMP] = ACTIONS(219),
    [anon_sym_QMARK] = ACTIONS(217),
    [anon_sym_PIPE_PIPE] = ACTIONS(217),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(219),
    [anon_sym_RPAREN] = ACTIONS(217),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(5523),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5521),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(217),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_GT_GT] = ACTIONS(219),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(217),
    [anon_sym_in] = ACTIONS(219),
  },
  [2517] = {
    [sym_nested_identifier] = STATE(1592),
    [sym__module] = STATE(1483),
    [sym_string] = STATE(1594),
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_COLON] = ACTIONS(135),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(2728),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_RPAREN] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2518] = {
    [sym_new_expression] = STATE(2352),
    [sym_augmented_assignment_expression] = STATE(2352),
    [sym_unary_expression] = STATE(2352),
    [sym_update_expression] = STATE(2352),
    [sym_regex] = STATE(2352),
    [sym_meta_property] = STATE(2352),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2352),
    [sym_yield_expression] = STATE(2352),
    [sym_as_expression] = STATE(2352),
    [sym_non_null_expression] = STATE(2352),
    [sym_internal_module] = STATE(2352),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2352),
    [sym_await_expression] = STATE(2352),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2352),
    [sym_this] = STATE(2352),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2352),
    [sym_generator_function] = STATE(2352),
    [sym_call_expression] = STATE(2352),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2352),
    [sym_ternary_expression] = STATE(2352),
    [sym_binary_expression] = STATE(2352),
    [sym_template_string] = STATE(2352),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2352),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2352),
    [sym_class] = STATE(2352),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5525),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5525),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5525),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5527),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5525),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2519] = {
    [sym_new_expression] = STATE(2353),
    [sym_augmented_assignment_expression] = STATE(2353),
    [sym_unary_expression] = STATE(2353),
    [sym_update_expression] = STATE(2353),
    [sym_regex] = STATE(2353),
    [sym_meta_property] = STATE(2353),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2353),
    [sym_yield_expression] = STATE(2353),
    [sym_as_expression] = STATE(2353),
    [sym_non_null_expression] = STATE(2353),
    [sym_internal_module] = STATE(2353),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2353),
    [sym_await_expression] = STATE(2353),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2353),
    [sym_this] = STATE(2353),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2353),
    [sym_generator_function] = STATE(2353),
    [sym_call_expression] = STATE(2353),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2353),
    [sym_ternary_expression] = STATE(2353),
    [sym_binary_expression] = STATE(2353),
    [sym_template_string] = STATE(2353),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2353),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2353),
    [sym_class] = STATE(2353),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(5529),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5529),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5529),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(5531),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5529),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2520] = {
    [sym_new_expression] = STATE(1261),
    [sym_augmented_assignment_expression] = STATE(1800),
    [sym_unary_expression] = STATE(1800),
    [sym_update_expression] = STATE(1800),
    [sym_regex] = STATE(1261),
    [sym_meta_property] = STATE(1261),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1800),
    [sym_yield_expression] = STATE(1800),
    [sym_as_expression] = STATE(1800),
    [sym_non_null_expression] = STATE(1800),
    [sym_internal_module] = STATE(1800),
    [sym_function] = STATE(1266),
    [sym_arrow_function] = STATE(1261),
    [sym_await_expression] = STATE(1800),
    [sym_member_expression] = STATE(1267),
    [sym_string] = STATE(1261),
    [sym_this] = STATE(1261),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1268),
    [sym_anonymous_class] = STATE(1261),
    [sym_generator_function] = STATE(1261),
    [sym_call_expression] = STATE(1800),
    [sym_subscript_expression] = STATE(1267),
    [sym_assignment_expression] = STATE(1800),
    [sym_ternary_expression] = STATE(1800),
    [sym_binary_expression] = STATE(1800),
    [sym_template_string] = STATE(1261),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1261),
    [sym_array] = STATE(1269),
    [sym_type_assertion] = STATE(1800),
    [sym_class] = STATE(1261),
    [sym_identifier] = ACTIONS(5260),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(5262),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(5264),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(5262),
    [anon_sym_get] = ACTIONS(5262),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(3920),
    [anon_sym_protected] = ACTIONS(5262),
    [anon_sym_DOT] = ACTIONS(3922),
    [anon_sym_set] = ACTIONS(5262),
    [anon_sym_type] = ACTIONS(5262),
    [anon_sym_import] = ACTIONS(5262),
    [anon_sym_namespace] = ACTIONS(5266),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3920),
    [anon_sym_module] = ACTIONS(5262),
    [anon_sym_number] = ACTIONS(5262),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5262),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3920),
    [anon_sym_any] = ACTIONS(5262),
    [anon_sym_boolean] = ACTIONS(5262),
    [anon_sym_async] = ACTIONS(5268),
    [anon_sym_public] = ACTIONS(5262),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3928),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5262),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3920),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(5262),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2521] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(1307),
    [anon_sym_AMP_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_EQ] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(1307),
    [anon_sym_PIPE_EQ] = ACTIONS(1307),
    [anon_sym_DASH_EQ] = ACTIONS(1307),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(1307),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(1307),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1307),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [2522] = {
    [sym__initializer] = STATE(1273),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1339),
  },
  [2523] = {
    [sym_new_expression] = STATE(1286),
    [sym_augmented_assignment_expression] = STATE(1286),
    [sym_unary_expression] = STATE(1286),
    [sym_update_expression] = STATE(1286),
    [sym_regex] = STATE(1286),
    [sym_meta_property] = STATE(1286),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(1286),
    [sym_yield_expression] = STATE(1286),
    [sym_as_expression] = STATE(1286),
    [sym_non_null_expression] = STATE(1286),
    [sym_internal_module] = STATE(1286),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1286),
    [sym_await_expression] = STATE(1286),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(1286),
    [sym_this] = STATE(1286),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(1286),
    [sym_generator_function] = STATE(1286),
    [sym_call_expression] = STATE(1286),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(1286),
    [sym_ternary_expression] = STATE(1286),
    [sym_binary_expression] = STATE(1286),
    [sym_template_string] = STATE(1286),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1286),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(1286),
    [sym_class] = STATE(1286),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(1331),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(3930),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3930),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3930),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3932),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3930),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2524] = {
    [sym__initializer] = STATE(1287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_RBRACK] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(111),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(1339),
  },
  [2525] = {
    [sym_new_expression] = STATE(1261),
    [sym_augmented_assignment_expression] = STATE(1800),
    [sym_unary_expression] = STATE(1800),
    [sym_update_expression] = STATE(1800),
    [sym_regex] = STATE(1261),
    [sym_meta_property] = STATE(1261),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(1800),
    [sym_yield_expression] = STATE(1800),
    [sym_as_expression] = STATE(1800),
    [sym_non_null_expression] = STATE(1800),
    [sym_internal_module] = STATE(1800),
    [sym_function] = STATE(1266),
    [sym_arrow_function] = STATE(1261),
    [sym_await_expression] = STATE(1800),
    [sym_member_expression] = STATE(1267),
    [sym_string] = STATE(1261),
    [sym_this] = STATE(1261),
    [sym_type_parameters] = STATE(825),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1268),
    [sym_anonymous_class] = STATE(1261),
    [sym_generator_function] = STATE(1261),
    [sym_call_expression] = STATE(1800),
    [sym_subscript_expression] = STATE(1267),
    [sym_assignment_expression] = STATE(1800),
    [sym_ternary_expression] = STATE(1800),
    [sym_binary_expression] = STATE(1800),
    [sym_template_string] = STATE(1261),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(826),
    [sym_parenthesized_expression] = STATE(1261),
    [sym_array] = STATE(1269),
    [sym_type_assertion] = STATE(1800),
    [sym_class] = STATE(1261),
    [sym_identifier] = ACTIONS(5533),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_symbol] = ACTIONS(5535),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_void] = ACTIONS(5537),
    [sym_super] = ACTIONS(278),
    [anon_sym_private] = ACTIONS(5535),
    [anon_sym_get] = ACTIONS(5535),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(3920),
    [anon_sym_protected] = ACTIONS(5535),
    [anon_sym_DOT] = ACTIONS(3922),
    [anon_sym_set] = ACTIONS(5535),
    [anon_sym_type] = ACTIONS(5535),
    [anon_sym_import] = ACTIONS(5535),
    [anon_sym_namespace] = ACTIONS(5539),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(3920),
    [anon_sym_module] = ACTIONS(5535),
    [anon_sym_number] = ACTIONS(5535),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5535),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3920),
    [anon_sym_any] = ACTIONS(5535),
    [anon_sym_boolean] = ACTIONS(5535),
    [anon_sym_async] = ACTIONS(5541),
    [anon_sym_public] = ACTIONS(5535),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(3928),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(5535),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3920),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_export] = ACTIONS(5535),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2526] = {
    [sym_new_expression] = STATE(2564),
    [sym_constructor_type] = STATE(754),
    [sym_augmented_assignment_expression] = STATE(2564),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(2564),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(2564),
    [sym_call_signature] = STATE(2559),
    [sym_yield_expression] = STATE(2564),
    [sym_as_expression] = STATE(2564),
    [sym_internal_module] = STATE(2564),
    [sym_arrow_function] = STATE(2564),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(2578),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1369),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(2579),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(2564),
    [sym_subscript_expression] = STATE(2578),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(2564),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(2564),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(754),
    [sym__type] = STATE(754),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(2564),
    [sym_meta_property] = STATE(2564),
    [sym_function_type] = STATE(754),
    [sym__expression] = STATE(2564),
    [sym_non_null_expression] = STATE(2564),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(2564),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(2564),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(2564),
    [sym_call_expression] = STATE(2564),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(2564),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(2564),
    [sym_type_arguments] = STATE(2528),
    [sym_union_type] = STATE(754),
    [sym_parenthesized_expression] = STATE(2564),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2564),
    [sym_class] = STATE(2564),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5543),
    [sym_false] = ACTIONS(4020),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5545),
    [anon_sym_number] = ACTIONS(5545),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5547),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5549),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(5551),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [sym_null] = ACTIONS(5553),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5545),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5545),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(4018),
    [sym_number] = ACTIONS(4024),
    [sym_true] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5545),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5553),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5555),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5549),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2527] = {
    [sym_new_expression] = STATE(1261),
    [sym_augmented_assignment_expression] = STATE(1800),
    [sym_unary_expression] = STATE(1800),
    [sym_update_expression] = STATE(1800),
    [sym_regex] = STATE(1261),
    [sym_meta_property] = STATE(1261),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(1800),
    [sym_yield_expression] = STATE(1800),
    [sym_as_expression] = STATE(1800),
    [sym_non_null_expression] = STATE(1800),
    [sym_internal_module] = STATE(1800),
    [sym_function] = STATE(1266),
    [sym_arrow_function] = STATE(1261),
    [sym_await_expression] = STATE(1800),
    [sym_member_expression] = STATE(1267),
    [sym_string] = STATE(1261),
    [sym_this] = STATE(1261),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(1268),
    [sym_anonymous_class] = STATE(1261),
    [sym_generator_function] = STATE(1261),
    [sym_call_expression] = STATE(1800),
    [sym_subscript_expression] = STATE(1267),
    [sym_assignment_expression] = STATE(1800),
    [sym_ternary_expression] = STATE(1800),
    [sym_binary_expression] = STATE(1800),
    [sym_template_string] = STATE(1261),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1261),
    [sym_array] = STATE(1269),
    [sym_type_assertion] = STATE(1800),
    [sym_class] = STATE(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
    [sym_identifier] = ACTIONS(5533),
    [sym_false] = ACTIONS(3920),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_BANG] = ACTIONS(518),
    [anon_sym_module] = ACTIONS(5535),
    [anon_sym_symbol] = ACTIONS(5535),
    [anon_sym_number] = ACTIONS(5535),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5535),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5537),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3920),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5535),
    [anon_sym_private] = ACTIONS(5535),
    [anon_sym_boolean] = ACTIONS(5535),
    [anon_sym_async] = ACTIONS(5541),
    [anon_sym_public] = ACTIONS(5535),
    [anon_sym_get] = ACTIONS(5535),
    [sym_comment] = ACTIONS(3),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(3928),
    [sym_true] = ACTIONS(3920),
    [anon_sym_yield] = ACTIONS(508),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5535),
    [anon_sym_string] = ACTIONS(5535),
    [anon_sym_function] = ACTIONS(314),
    [anon_sym_DOT] = ACTIONS(3922),
    [sym_undefined] = ACTIONS(3920),
    [anon_sym_set] = ACTIONS(5535),
    [anon_sym_type] = ACTIONS(5535),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5535),
    [anon_sym_export] = ACTIONS(5535),
    [anon_sym_namespace] = ACTIONS(5539),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_TILDE] = ACTIONS(518),
  },
  [2528] = {
    [sym_new_expression] = STATE(1286),
    [sym_augmented_assignment_expression] = STATE(1286),
    [sym_unary_expression] = STATE(1286),
    [sym_update_expression] = STATE(1286),
    [sym_regex] = STATE(1286),
    [sym_meta_property] = STATE(1286),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(1286),
    [sym_yield_expression] = STATE(1286),
    [sym_as_expression] = STATE(1286),
    [sym_non_null_expression] = STATE(1286),
    [sym_internal_module] = STATE(1286),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(1286),
    [sym_await_expression] = STATE(1286),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(1286),
    [sym_this] = STATE(1286),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(1286),
    [sym_generator_function] = STATE(1286),
    [sym_call_expression] = STATE(1286),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(1286),
    [sym_ternary_expression] = STATE(1286),
    [sym_binary_expression] = STATE(1286),
    [sym_template_string] = STATE(1286),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(1286),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(1286),
    [sym_class] = STATE(1286),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(3930),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(3932),
    [sym_true] = ACTIONS(3930),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(3930),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2529] = {
    [sym_new_expression] = STATE(2548),
    [sym_augmented_assignment_expression] = STATE(2548),
    [sym_unary_expression] = STATE(2548),
    [sym_update_expression] = STATE(2548),
    [sym_regex] = STATE(2548),
    [sym_meta_property] = STATE(2548),
    [sym_call_signature] = STATE(2559),
    [sym_statement_block] = STATE(1288),
    [sym__expression] = STATE(2548),
    [sym_yield_expression] = STATE(2548),
    [sym_as_expression] = STATE(2548),
    [sym_non_null_expression] = STATE(2548),
    [sym_internal_module] = STATE(2548),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2548),
    [sym_await_expression] = STATE(2548),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2548),
    [sym_this] = STATE(2548),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2548),
    [sym_generator_function] = STATE(2548),
    [sym_call_expression] = STATE(2548),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2548),
    [sym_ternary_expression] = STATE(2548),
    [sym_binary_expression] = STATE(2548),
    [sym_template_string] = STATE(2548),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2548),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2548),
    [sym_class] = STATE(2548),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5557),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5557),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5559),
    [sym_true] = ACTIONS(5557),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5557),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2530] = {
    [sym_new_expression] = STATE(2564),
    [sym_augmented_assignment_expression] = STATE(2564),
    [sym_unary_expression] = STATE(2564),
    [sym_update_expression] = STATE(2564),
    [sym_regex] = STATE(2564),
    [sym_meta_property] = STATE(2564),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2564),
    [sym_yield_expression] = STATE(2564),
    [sym_as_expression] = STATE(2564),
    [sym_non_null_expression] = STATE(2564),
    [sym_internal_module] = STATE(2564),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2564),
    [sym_await_expression] = STATE(2564),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2564),
    [sym_this] = STATE(2564),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2564),
    [sym_generator_function] = STATE(2564),
    [sym_call_expression] = STATE(2564),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2564),
    [sym_ternary_expression] = STATE(2564),
    [sym_binary_expression] = STATE(2564),
    [sym_template_string] = STATE(2564),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2564),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2564),
    [sym_class] = STATE(2564),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5553),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5553),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5561),
    [sym_true] = ACTIONS(5553),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5553),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2531] = {
    [sym_new_expression] = STATE(2565),
    [sym_augmented_assignment_expression] = STATE(2565),
    [sym_unary_expression] = STATE(2565),
    [sym_update_expression] = STATE(2565),
    [sym_regex] = STATE(2565),
    [sym_meta_property] = STATE(2565),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2565),
    [sym_yield_expression] = STATE(2565),
    [sym_as_expression] = STATE(2565),
    [sym_non_null_expression] = STATE(2565),
    [sym_internal_module] = STATE(2565),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2565),
    [sym_await_expression] = STATE(2565),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2565),
    [sym_this] = STATE(2565),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2565),
    [sym_generator_function] = STATE(2565),
    [sym_call_expression] = STATE(2565),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2565),
    [sym_ternary_expression] = STATE(2565),
    [sym_binary_expression] = STATE(2565),
    [sym_template_string] = STATE(2565),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2565),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2565),
    [sym_class] = STATE(2565),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5563),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5563),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5565),
    [sym_true] = ACTIONS(5563),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5563),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2532] = {
    [sym_new_expression] = STATE(2566),
    [sym_augmented_assignment_expression] = STATE(2566),
    [sym_unary_expression] = STATE(2566),
    [sym_update_expression] = STATE(2566),
    [sym_regex] = STATE(2566),
    [sym_meta_property] = STATE(2566),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2566),
    [sym_yield_expression] = STATE(2566),
    [sym_as_expression] = STATE(2566),
    [sym_non_null_expression] = STATE(2566),
    [sym_internal_module] = STATE(2566),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2566),
    [sym_await_expression] = STATE(2566),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2566),
    [sym_this] = STATE(2566),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2566),
    [sym_generator_function] = STATE(2566),
    [sym_call_expression] = STATE(2566),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2566),
    [sym_ternary_expression] = STATE(2566),
    [sym_binary_expression] = STATE(2566),
    [sym_template_string] = STATE(2566),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2566),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2566),
    [sym_class] = STATE(2566),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5567),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5567),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5569),
    [sym_true] = ACTIONS(5567),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5567),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2533] = {
    [sym_new_expression] = STATE(2549),
    [sym_augmented_assignment_expression] = STATE(2549),
    [sym_unary_expression] = STATE(2549),
    [sym_update_expression] = STATE(2549),
    [sym_regex] = STATE(2549),
    [sym_meta_property] = STATE(2549),
    [sym_call_signature] = STATE(2559),
    [sym_statement_block] = STATE(1295),
    [sym__expression] = STATE(2549),
    [sym_yield_expression] = STATE(2549),
    [sym_as_expression] = STATE(2549),
    [sym_non_null_expression] = STATE(2549),
    [sym_internal_module] = STATE(2549),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2549),
    [sym_await_expression] = STATE(2549),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2549),
    [sym_this] = STATE(2549),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2549),
    [sym_generator_function] = STATE(2549),
    [sym_call_expression] = STATE(2549),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2549),
    [sym_ternary_expression] = STATE(2549),
    [sym_binary_expression] = STATE(2549),
    [sym_template_string] = STATE(2549),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2549),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2549),
    [sym_class] = STATE(2549),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5571),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5571),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5573),
    [sym_true] = ACTIONS(5571),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5571),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2534] = {
    [sym_new_expression] = STATE(2567),
    [sym_augmented_assignment_expression] = STATE(2567),
    [sym_unary_expression] = STATE(2567),
    [sym_update_expression] = STATE(2567),
    [sym_regex] = STATE(2567),
    [sym_meta_property] = STATE(2567),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2567),
    [sym_yield_expression] = STATE(2567),
    [sym_as_expression] = STATE(2567),
    [sym_non_null_expression] = STATE(2567),
    [sym_internal_module] = STATE(2567),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2567),
    [sym_await_expression] = STATE(2567),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2567),
    [sym_this] = STATE(2567),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2567),
    [sym_generator_function] = STATE(2567),
    [sym_call_expression] = STATE(2567),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2567),
    [sym_ternary_expression] = STATE(2567),
    [sym_binary_expression] = STATE(2567),
    [sym_template_string] = STATE(2567),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2567),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2567),
    [sym_class] = STATE(2567),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5575),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5575),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5577),
    [sym_true] = ACTIONS(5575),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5575),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2535] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5579),
    [anon_sym_AMP_EQ] = ACTIONS(5579),
    [anon_sym_PLUS_EQ] = ACTIONS(5579),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(5579),
    [anon_sym_STAR_EQ] = ACTIONS(5579),
    [anon_sym_PIPE_EQ] = ACTIONS(5579),
    [anon_sym_DASH_EQ] = ACTIONS(5579),
    [anon_sym_EQ_GT] = ACTIONS(5581),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5579),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT_EQ] = ACTIONS(5579),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2536] = {
    [sym_call_signature] = STATE(2560),
    [sym__initializer] = STATE(1215),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(5585),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_symbol] = ACTIONS(5587),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_void] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_private] = ACTIONS(5587),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_get] = ACTIONS(5587),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_protected] = ACTIONS(5587),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_set] = ACTIONS(5587),
    [anon_sym_type] = ACTIONS(5587),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(5587),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5334),
    [anon_sym_namespace] = ACTIONS(5587),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_module] = ACTIONS(5587),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_number] = ACTIONS(5587),
    [anon_sym_declare] = ACTIONS(5587),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_any] = ACTIONS(5587),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_boolean] = ACTIONS(5587),
    [anon_sym_async] = ACTIONS(5587),
    [anon_sym_public] = ACTIONS(5587),
    [anon_sym_EQ_GT] = ACTIONS(5344),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(437),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_string] = ACTIONS(5587),
    [anon_sym_function] = ACTIONS(1136),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_export] = ACTIONS(5587),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2537] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(5591),
    [anon_sym_COMMA] = ACTIONS(767),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(5597),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_BANG_EQ] = ACTIONS(5583),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(5589),
    [anon_sym_GT] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(5605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(767),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(5583),
    [anon_sym_instanceof] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(5607),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5589),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2538] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(5591),
    [anon_sym_COMMA] = ACTIONS(811),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(5613),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_BANG_EQ] = ACTIONS(5583),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(5589),
    [anon_sym_GT] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(5605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(811),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(5583),
    [anon_sym_instanceof] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(5607),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5589),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2539] = {
    [sym__initializer] = STATE(1211),
    [sym_arguments] = STATE(1353),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1305),
    [anon_sym_LBRACK] = ACTIONS(1305),
    [anon_sym_BANG] = ACTIONS(1309),
    [anon_sym_BQUOTE] = ACTIONS(1305),
    [anon_sym_PERCENT_EQ] = ACTIONS(1307),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_AMP_EQ] = ACTIONS(1307),
    [anon_sym_PLUS_EQ] = ACTIONS(1307),
    [anon_sym_PIPE] = ACTIONS(1309),
    [anon_sym_LT_LT] = ACTIONS(1309),
    [anon_sym_DASH] = ACTIONS(1309),
    [anon_sym_STAR] = ACTIONS(1309),
    [anon_sym_GT_GT_GT] = ACTIONS(1309),
    [anon_sym_AMP_AMP] = ACTIONS(1305),
    [anon_sym_LBRACE] = ACTIONS(1309),
    [anon_sym_COMMA] = ACTIONS(1305),
    [anon_sym_BANG_EQ] = ACTIONS(1309),
    [anon_sym_LT_EQ] = ACTIONS(1305),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1305),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_GT] = ACTIONS(1309),
    [anon_sym_CARET_EQ] = ACTIONS(1307),
    [anon_sym_STAR_EQ] = ACTIONS(1307),
    [anon_sym_PIPE_EQ] = ACTIONS(1307),
    [anon_sym_DASH_EQ] = ACTIONS(1307),
    [anon_sym_EQ_GT] = ACTIONS(5581),
    [anon_sym_AMP] = ACTIONS(1309),
    [anon_sym_PERCENT] = ACTIONS(1309),
    [anon_sym_QMARK] = ACTIONS(1305),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1305),
    [anon_sym_as] = ACTIONS(1305),
    [anon_sym_PIPE_PIPE] = ACTIONS(1305),
    [anon_sym_LT_LT_EQ] = ACTIONS(1307),
    [anon_sym_DASH_DASH] = ACTIONS(1305),
    [anon_sym_EQ_EQ] = ACTIONS(1309),
    [anon_sym_instanceof] = ACTIONS(1305),
    [anon_sym_LT] = ACTIONS(1309),
    [anon_sym_SLASH] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1307),
    [anon_sym_GT_GT_EQ] = ACTIONS(1307),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1309),
    [anon_sym_STAR_STAR] = ACTIONS(1309),
    [anon_sym_PLUS] = ACTIONS(1309),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1307),
    [anon_sym_GT_GT] = ACTIONS(1309),
    [anon_sym_PLUS_PLUS] = ACTIONS(1305),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1305),
    [anon_sym_in] = ACTIONS(1309),
  },
  [2540] = {
    [sym__initializer] = STATE(1215),
    [sym_arguments] = STATE(1355),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(5344),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1315),
    [anon_sym_as] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_instanceof] = ACTIONS(1315),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [2541] = {
    [sym_call_signature] = STATE(2560),
    [sym__initializer] = STATE(1215),
    [sym_formal_parameters] = STATE(58),
    [sym_type_parameters] = STATE(55),
    [sym_arguments] = STATE(1355),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(5585),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(5587),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(5587),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(5587),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(5587),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1315),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_protected] = ACTIONS(5587),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_set] = ACTIONS(5587),
    [anon_sym_type] = ACTIONS(5587),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_import] = ACTIONS(5587),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_namespace] = ACTIONS(5587),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_module] = ACTIONS(5587),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(5587),
    [anon_sym_declare] = ACTIONS(5587),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_any] = ACTIONS(5587),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(5587),
    [anon_sym_async] = ACTIONS(5587),
    [anon_sym_public] = ACTIONS(5587),
    [anon_sym_EQ_GT] = ACTIONS(5344),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(5587),
    [anon_sym_function] = ACTIONS(1136),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_export] = ACTIONS(5587),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [2542] = {
    [sym_nested_identifier] = STATE(1592),
    [sym__module] = STATE(1483),
    [sym_string] = STATE(1594),
    [sym__initializer] = STATE(1215),
    [sym_arguments] = STATE(1355),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_EQ_GT] = ACTIONS(5344),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1315),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_LT] = ACTIONS(1319),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [2543] = {
    [sym_new_expression] = STATE(2568),
    [sym_augmented_assignment_expression] = STATE(2568),
    [sym_unary_expression] = STATE(2568),
    [sym_update_expression] = STATE(2568),
    [sym_regex] = STATE(2568),
    [sym_meta_property] = STATE(2568),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2568),
    [sym_yield_expression] = STATE(2568),
    [sym_as_expression] = STATE(2568),
    [sym_non_null_expression] = STATE(2568),
    [sym_internal_module] = STATE(2568),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2568),
    [sym_await_expression] = STATE(2568),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2568),
    [sym_this] = STATE(2568),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2568),
    [sym_generator_function] = STATE(2568),
    [sym_call_expression] = STATE(2568),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2568),
    [sym_ternary_expression] = STATE(2568),
    [sym_binary_expression] = STATE(2568),
    [sym_template_string] = STATE(2568),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2568),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2568),
    [sym_class] = STATE(2568),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5615),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5615),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5617),
    [sym_true] = ACTIONS(5615),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5615),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2544] = {
    [sym_new_expression] = STATE(2569),
    [sym_augmented_assignment_expression] = STATE(2569),
    [sym_unary_expression] = STATE(2569),
    [sym_update_expression] = STATE(2569),
    [sym_regex] = STATE(2569),
    [sym_meta_property] = STATE(2569),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2569),
    [sym_yield_expression] = STATE(2569),
    [sym_as_expression] = STATE(2569),
    [sym_non_null_expression] = STATE(2569),
    [sym_internal_module] = STATE(2569),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2569),
    [sym_await_expression] = STATE(2569),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2569),
    [sym_this] = STATE(2569),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2569),
    [sym_generator_function] = STATE(2569),
    [sym_call_expression] = STATE(2569),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2569),
    [sym_ternary_expression] = STATE(2569),
    [sym_binary_expression] = STATE(2569),
    [sym_template_string] = STATE(2569),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2569),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2569),
    [sym_class] = STATE(2569),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5619),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5619),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5621),
    [sym_true] = ACTIONS(5619),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5619),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2545] = {
    [sym_new_expression] = STATE(2570),
    [sym_augmented_assignment_expression] = STATE(2570),
    [sym_unary_expression] = STATE(2570),
    [sym_update_expression] = STATE(2570),
    [sym_regex] = STATE(2570),
    [sym_meta_property] = STATE(2570),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2570),
    [sym_yield_expression] = STATE(2570),
    [sym_as_expression] = STATE(2570),
    [sym_non_null_expression] = STATE(2570),
    [sym_internal_module] = STATE(2570),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2570),
    [sym_await_expression] = STATE(2570),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2570),
    [sym_this] = STATE(2570),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2570),
    [sym_generator_function] = STATE(2570),
    [sym_call_expression] = STATE(2570),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2570),
    [sym_ternary_expression] = STATE(2570),
    [sym_binary_expression] = STATE(2570),
    [sym_template_string] = STATE(2570),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2570),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2570),
    [sym_class] = STATE(2570),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5623),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5623),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5625),
    [sym_true] = ACTIONS(5623),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5623),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2546] = {
    [sym_new_expression] = STATE(2571),
    [sym_augmented_assignment_expression] = STATE(2571),
    [sym_unary_expression] = STATE(2571),
    [sym_update_expression] = STATE(2571),
    [sym_regex] = STATE(2571),
    [sym_meta_property] = STATE(2571),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2571),
    [sym_yield_expression] = STATE(2571),
    [sym_as_expression] = STATE(2571),
    [sym_non_null_expression] = STATE(2571),
    [sym_internal_module] = STATE(2571),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2571),
    [sym_await_expression] = STATE(2571),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2571),
    [sym_this] = STATE(2571),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2571),
    [sym_generator_function] = STATE(2571),
    [sym_call_expression] = STATE(2571),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2571),
    [sym_ternary_expression] = STATE(2571),
    [sym_binary_expression] = STATE(2571),
    [sym_template_string] = STATE(2571),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2571),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2571),
    [sym_class] = STATE(2571),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5627),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5627),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5629),
    [sym_true] = ACTIONS(5627),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5627),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2547] = {
    [sym_new_expression] = STATE(2572),
    [sym_augmented_assignment_expression] = STATE(2572),
    [sym_unary_expression] = STATE(2572),
    [sym_update_expression] = STATE(2572),
    [sym_regex] = STATE(2572),
    [sym_meta_property] = STATE(2572),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2572),
    [sym_yield_expression] = STATE(2572),
    [sym_as_expression] = STATE(2572),
    [sym_non_null_expression] = STATE(2572),
    [sym_internal_module] = STATE(2572),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2572),
    [sym_await_expression] = STATE(2572),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2572),
    [sym_this] = STATE(2572),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2572),
    [sym_generator_function] = STATE(2572),
    [sym_call_expression] = STATE(2572),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2572),
    [sym_ternary_expression] = STATE(2572),
    [sym_binary_expression] = STATE(2572),
    [sym_template_string] = STATE(2572),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2572),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2572),
    [sym_class] = STATE(2572),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5631),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5631),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5633),
    [sym_true] = ACTIONS(5631),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5631),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2548] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(5591),
    [anon_sym_COMMA] = ACTIONS(1679),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_BANG_EQ] = ACTIONS(5583),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(5589),
    [anon_sym_GT] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(5605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1679),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(5583),
    [anon_sym_instanceof] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(5607),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5589),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2549] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(5591),
    [anon_sym_COMMA] = ACTIONS(1713),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(1715),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_BANG_EQ] = ACTIONS(5583),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(5589),
    [anon_sym_GT] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(5605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1713),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(5583),
    [anon_sym_instanceof] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(5607),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5589),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2550] = {
    [sym_new_expression] = STATE(2555),
    [sym_augmented_assignment_expression] = STATE(2555),
    [sym_unary_expression] = STATE(2555),
    [sym_update_expression] = STATE(2555),
    [sym_regex] = STATE(2555),
    [sym_meta_property] = STATE(2555),
    [sym_call_signature] = STATE(2559),
    [sym_statement_block] = STATE(1395),
    [sym__expression] = STATE(2555),
    [sym_yield_expression] = STATE(2555),
    [sym_as_expression] = STATE(2555),
    [sym_non_null_expression] = STATE(2555),
    [sym_internal_module] = STATE(2555),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2555),
    [sym_await_expression] = STATE(2555),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2555),
    [sym_this] = STATE(2555),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2555),
    [sym_generator_function] = STATE(2555),
    [sym_call_expression] = STATE(2555),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2555),
    [sym_ternary_expression] = STATE(2555),
    [sym_binary_expression] = STATE(2555),
    [sym_template_string] = STATE(2555),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2555),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2555),
    [sym_class] = STATE(2555),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5635),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5635),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5637),
    [sym_true] = ACTIONS(5635),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5635),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2551] = {
    [sym_new_expression] = STATE(2556),
    [sym_augmented_assignment_expression] = STATE(2556),
    [sym_unary_expression] = STATE(2556),
    [sym_update_expression] = STATE(2556),
    [sym_regex] = STATE(2556),
    [sym_meta_property] = STATE(2556),
    [sym_call_signature] = STATE(2559),
    [sym_statement_block] = STATE(1397),
    [sym__expression] = STATE(2556),
    [sym_yield_expression] = STATE(2556),
    [sym_as_expression] = STATE(2556),
    [sym_non_null_expression] = STATE(2556),
    [sym_internal_module] = STATE(2556),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2556),
    [sym_await_expression] = STATE(2556),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2556),
    [sym_this] = STATE(2556),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2556),
    [sym_generator_function] = STATE(2556),
    [sym_call_expression] = STATE(2556),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2556),
    [sym_ternary_expression] = STATE(2556),
    [sym_binary_expression] = STATE(2556),
    [sym_template_string] = STATE(2556),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2556),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2556),
    [sym_class] = STATE(2556),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5639),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(3936),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5639),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5641),
    [sym_true] = ACTIONS(5639),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5639),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2552] = {
    [sym__initializer] = STATE(1211),
    [sym_type_arguments] = STATE(497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5579),
    [anon_sym_AMP_EQ] = ACTIONS(5579),
    [anon_sym_PLUS_EQ] = ACTIONS(5579),
    [anon_sym_PIPE] = ACTIONS(2506),
    [anon_sym_COMMA] = ACTIONS(2509),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_is] = ACTIONS(1207),
    [anon_sym_GT] = ACTIONS(2506),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_CARET_EQ] = ACTIONS(5579),
    [anon_sym_STAR_EQ] = ACTIONS(5579),
    [anon_sym_PIPE_EQ] = ACTIONS(5579),
    [anon_sym_DASH_EQ] = ACTIONS(5579),
    [anon_sym_EQ_GT] = ACTIONS(5581),
    [anon_sym_AMP] = ACTIONS(2506),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5579),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT_EQ] = ACTIONS(5579),
    [anon_sym_DOT] = ACTIONS(4073),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5643),
  },
  [2553] = {
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(2529),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(2526),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_EQ_GT] = ACTIONS(5344),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2554] = {
    [sym_new_expression] = STATE(2582),
    [sym_augmented_assignment_expression] = STATE(2582),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(2582),
    [sym_update_expression] = STATE(2582),
    [sym_regex] = STATE(2582),
    [sym_meta_property] = STATE(2582),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2582),
    [sym_yield_expression] = STATE(2582),
    [sym_as_expression] = STATE(2582),
    [sym_non_null_expression] = STATE(2582),
    [sym_internal_module] = STATE(2582),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2582),
    [sym_await_expression] = STATE(2582),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2582),
    [sym_this] = STATE(2582),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2582),
    [sym_generator_function] = STATE(2582),
    [sym_call_expression] = STATE(2582),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2582),
    [sym_ternary_expression] = STATE(2582),
    [sym_binary_expression] = STATE(2582),
    [sym_template_string] = STATE(2582),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2582),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2582),
    [sym_class] = STATE(2582),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [sym_identifier] = ACTIONS(5308),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_PIPE] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2529),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(5326),
    [sym_true] = ACTIONS(5338),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5334),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(5340),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_false] = ACTIONS(5338),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(5342),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5338),
    [anon_sym_GT] = ACTIONS(2526),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_EQ_GT] = ACTIONS(5344),
    [anon_sym_AMP] = ACTIONS(2526),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(171),
    [sym_number] = ACTIONS(5346),
    [anon_sym_SLASH] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5338),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2555] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(5591),
    [anon_sym_COMMA] = ACTIONS(2936),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(2938),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_BANG_EQ] = ACTIONS(5583),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(5589),
    [anon_sym_GT] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(5605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2936),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(5583),
    [anon_sym_instanceof] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(5607),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5589),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2556] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(5591),
    [anon_sym_COMMA] = ACTIONS(2940),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(2942),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_BANG_EQ] = ACTIONS(5583),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(5589),
    [anon_sym_GT] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(5605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(2940),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(5583),
    [anon_sym_instanceof] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(5607),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5589),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2557] = {
    [sym_new_expression] = STATE(2573),
    [sym_augmented_assignment_expression] = STATE(2573),
    [sym_unary_expression] = STATE(2573),
    [sym_update_expression] = STATE(2573),
    [sym_regex] = STATE(2573),
    [sym_meta_property] = STATE(2573),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2573),
    [sym_yield_expression] = STATE(2573),
    [sym_as_expression] = STATE(2573),
    [sym_non_null_expression] = STATE(2573),
    [sym_internal_module] = STATE(2573),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2573),
    [sym_await_expression] = STATE(2573),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2573),
    [sym_this] = STATE(2573),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2573),
    [sym_generator_function] = STATE(2573),
    [sym_call_expression] = STATE(2573),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2573),
    [sym_ternary_expression] = STATE(2573),
    [sym_binary_expression] = STATE(2573),
    [sym_template_string] = STATE(2573),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2573),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2573),
    [sym_class] = STATE(2573),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5645),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5645),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5647),
    [sym_true] = ACTIONS(5645),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5645),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2558] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(2305),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5579),
    [anon_sym_AMP_EQ] = ACTIONS(5579),
    [anon_sym_PLUS_EQ] = ACTIONS(5579),
    [anon_sym_PIPE] = ACTIONS(2307),
    [anon_sym_COMMA] = ACTIONS(2305),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(2307),
    [anon_sym_CARET_EQ] = ACTIONS(5579),
    [anon_sym_STAR_EQ] = ACTIONS(5579),
    [anon_sym_PIPE_EQ] = ACTIONS(5579),
    [anon_sym_DASH_EQ] = ACTIONS(5579),
    [anon_sym_EQ_GT] = ACTIONS(5581),
    [anon_sym_AMP] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5579),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT_EQ] = ACTIONS(5579),
    [anon_sym_DOT] = ACTIONS(4097),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2559] = {
    [anon_sym_EQ_GT] = ACTIONS(5581),
    [sym_comment] = ACTIONS(3),
  },
  [2560] = {
    [anon_sym_EQ_GT] = ACTIONS(5649),
    [sym_comment] = ACTIONS(3),
  },
  [2561] = {
    [anon_sym_EQ_GT] = ACTIONS(5651),
    [sym_comment] = ACTIONS(3),
  },
  [2562] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1337),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(1339),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(1343),
    [anon_sym_DASH] = ACTIONS(1345),
    [anon_sym_STAR] = ACTIONS(1347),
    [anon_sym_GT_GT_GT] = ACTIONS(1343),
    [anon_sym_AMP_AMP] = ACTIONS(1349),
    [anon_sym_BANG_EQ] = ACTIONS(1339),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_PERCENT] = ACTIONS(1343),
    [anon_sym_QMARK] = ACTIONS(1353),
    [anon_sym_PIPE_PIPE] = ACTIONS(1355),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1339),
    [anon_sym_instanceof] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(5653),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1355),
    [anon_sym_STAR_STAR] = ACTIONS(1359),
    [anon_sym_PLUS] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1337),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2563] = {
    [sym_new_expression] = STATE(2564),
    [sym_constructor_type] = STATE(232),
    [sym_augmented_assignment_expression] = STATE(2564),
    [sym_lookup_type] = STATE(237),
    [sym_unary_expression] = STATE(2564),
    [sym_flow_maybe_type] = STATE(237),
    [sym_regex] = STATE(2564),
    [sym_call_signature] = STATE(2559),
    [sym_yield_expression] = STATE(2564),
    [sym_as_expression] = STATE(2564),
    [sym_internal_module] = STATE(2564),
    [sym_arrow_function] = STATE(2564),
    [sym__primary_type] = STATE(237),
    [sym_member_expression] = STATE(2578),
    [sym_mapped_type] = STATE(237),
    [sym_parenthesized_type] = STATE(237),
    [sym_string] = STATE(1369),
    [sym_type_parameters] = STATE(581),
    [sym_array_type] = STATE(237),
    [sym_object] = STATE(2579),
    [sym_nested_type_identifier] = STATE(234),
    [sym_generator_function] = STATE(2564),
    [sym_subscript_expression] = STATE(2578),
    [sym_type_query] = STATE(237),
    [sym_ternary_expression] = STATE(2564),
    [sym_existential_type] = STATE(237),
    [sym_template_string] = STATE(2564),
    [sym_object_type] = STATE(237),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(582),
    [sym_intersection_type] = STATE(232),
    [sym__type] = STATE(232),
    [sym_index_type_query] = STATE(237),
    [sym_this_type] = STATE(237),
    [sym_update_expression] = STATE(2564),
    [sym_meta_property] = STATE(2564),
    [sym_function_type] = STATE(232),
    [sym__expression] = STATE(2564),
    [sym_non_null_expression] = STATE(2564),
    [sym_nested_identifier] = STATE(236),
    [sym_function] = STATE(1219),
    [sym_await_expression] = STATE(2564),
    [sym_generic_type] = STATE(237),
    [sym_literal_type] = STATE(237),
    [sym_predefined_type] = STATE(237),
    [sym_this] = STATE(2564),
    [sym_tuple_type] = STATE(237),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_anonymous_class] = STATE(2564),
    [sym_call_expression] = STATE(2564),
    [sym_type_predicate] = STATE(237),
    [sym_assignment_expression] = STATE(2564),
    [sym__number] = STATE(218),
    [sym_binary_expression] = STATE(2564),
    [sym_type_arguments] = STATE(2528),
    [sym_union_type] = STATE(232),
    [sym_parenthesized_expression] = STATE(2564),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2564),
    [sym_class] = STATE(2564),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5543),
    [sym_false] = ACTIONS(4020),
    [anon_sym_LBRACK] = ACTIONS(1268),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5545),
    [anon_sym_number] = ACTIONS(5545),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5547),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5549),
    [anon_sym_keyof] = ACTIONS(472),
    [anon_sym_LBRACE] = ACTIONS(2339),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_void] = ACTIONS(5551),
    [anon_sym_PIPE] = ACTIONS(484),
    [anon_sym_LPAREN] = ACTIONS(2341),
    [sym_null] = ACTIONS(5553),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5545),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5545),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_LBRACE_PIPE] = ACTIONS(456),
    [anon_sym_AMP] = ACTIONS(460),
    [anon_sym_QMARK] = ACTIONS(454),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(4018),
    [sym_number] = ACTIONS(4024),
    [sym_true] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5545),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5553),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5555),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5549),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2564] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [2565] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(5591),
    [anon_sym_COMMA] = ACTIONS(1687),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(5655),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_BANG_EQ] = ACTIONS(5583),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(5589),
    [anon_sym_GT] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(5605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1687),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(5583),
    [anon_sym_instanceof] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(5607),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5589),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2566] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(5591),
    [anon_sym_COMMA] = ACTIONS(1689),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(5657),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_BANG_EQ] = ACTIONS(5583),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(5589),
    [anon_sym_GT] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(5605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1689),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(5583),
    [anon_sym_instanceof] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(5607),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5589),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2567] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(5591),
    [anon_sym_COMMA] = ACTIONS(1717),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(5659),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_BANG_EQ] = ACTIONS(5583),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(5589),
    [anon_sym_GT] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(5605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1717),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(5583),
    [anon_sym_instanceof] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(5607),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5589),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2568] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_BANG_EQ] = ACTIONS(5583),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(5589),
    [anon_sym_GT] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(5583),
    [anon_sym_instanceof] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5589),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2569] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_LBRACE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_GT_GT_GT] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(5661),
    [anon_sym_SLASH] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [2570] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(5661),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [2571] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_BANG_EQ] = ACTIONS(5583),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(5589),
    [anon_sym_GT] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(5583),
    [anon_sym_instanceof] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5589),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2572] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(1685),
    [anon_sym_COMMA] = ACTIONS(1683),
    [anon_sym_LT_LT] = ACTIONS(1683),
    [anon_sym_STAR] = ACTIONS(1685),
    [anon_sym_LBRACE] = ACTIONS(1685),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_GT_GT_GT] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1685),
    [anon_sym_BANG_EQ] = ACTIONS(1685),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1685),
    [anon_sym_AMP] = ACTIONS(1685),
    [anon_sym_PERCENT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(1683),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1683),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(1685),
    [anon_sym_instanceof] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(5661),
    [anon_sym_SLASH] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(1683),
    [anon_sym_STAR_STAR] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1685),
    [anon_sym_GT_GT] = ACTIONS(1685),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1683),
    [anon_sym_in] = ACTIONS(1685),
  },
  [2573] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(5591),
    [anon_sym_COMMA] = ACTIONS(3569),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(5664),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_BANG_EQ] = ACTIONS(5583),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(5589),
    [anon_sym_GT] = ACTIONS(5583),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(5605),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3569),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(5583),
    [anon_sym_instanceof] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(5607),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5589),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2574] = {
    [sym_new_expression] = STATE(2582),
    [sym_augmented_assignment_expression] = STATE(2582),
    [sym_unary_expression] = STATE(2582),
    [sym_update_expression] = STATE(2582),
    [sym_regex] = STATE(2582),
    [sym_meta_property] = STATE(2582),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2582),
    [sym_yield_expression] = STATE(2582),
    [sym_as_expression] = STATE(2582),
    [sym_non_null_expression] = STATE(2582),
    [sym_internal_module] = STATE(2582),
    [sym_nested_identifier] = STATE(516),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2582),
    [sym_await_expression] = STATE(2582),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2582),
    [sym_this] = STATE(2582),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2582),
    [sym_generator_function] = STATE(2582),
    [sym_call_expression] = STATE(2582),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2582),
    [sym_ternary_expression] = STATE(2582),
    [sym_binary_expression] = STATE(2582),
    [sym_template_string] = STATE(2582),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2582),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2582),
    [sym_class] = STATE(2582),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5666),
    [sym_false] = ACTIONS(5338),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5338),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5346),
    [sym_true] = ACTIONS(5338),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5338),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2575] = {
    [sym_new_expression] = STATE(2581),
    [sym_augmented_assignment_expression] = STATE(2581),
    [sym_unary_expression] = STATE(2581),
    [sym_update_expression] = STATE(2581),
    [sym_regex] = STATE(2581),
    [sym_meta_property] = STATE(2581),
    [sym_call_signature] = STATE(2559),
    [sym__expression] = STATE(2581),
    [sym_yield_expression] = STATE(2581),
    [sym_as_expression] = STATE(2581),
    [sym_non_null_expression] = STATE(2581),
    [sym_internal_module] = STATE(2581),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2581),
    [sym_await_expression] = STATE(2581),
    [sym_member_expression] = STATE(2578),
    [sym_string] = STATE(2581),
    [sym_this] = STATE(2581),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2579),
    [sym_anonymous_class] = STATE(2581),
    [sym_generator_function] = STATE(2581),
    [sym_call_expression] = STATE(2581),
    [sym_subscript_expression] = STATE(2578),
    [sym_assignment_expression] = STATE(2581),
    [sym_ternary_expression] = STATE(2581),
    [sym_binary_expression] = STATE(2581),
    [sym_template_string] = STATE(2581),
    [sym_type_arguments] = STATE(2528),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2581),
    [sym_array] = STATE(2580),
    [sym_type_assertion] = STATE(2581),
    [sym_class] = STATE(2581),
    [anon_sym_BANG] = ACTIONS(5306),
    [sym_identifier] = ACTIONS(5308),
    [sym_false] = ACTIONS(5310),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(5312),
    [anon_sym_symbol] = ACTIONS(5312),
    [anon_sym_number] = ACTIONS(5312),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(5312),
    [anon_sym_typeof] = ACTIONS(5314),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(5316),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(5318),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5310),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(5312),
    [anon_sym_private] = ACTIONS(5312),
    [anon_sym_boolean] = ACTIONS(5312),
    [anon_sym_async] = ACTIONS(5320),
    [anon_sym_public] = ACTIONS(5312),
    [anon_sym_get] = ACTIONS(5312),
    [anon_sym_delete] = ACTIONS(5314),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(5322),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(4079),
    [sym_true] = ACTIONS(5310),
    [anon_sym_yield] = ACTIONS(5326),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(5312),
    [anon_sym_string] = ACTIONS(5312),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5310),
    [anon_sym_set] = ACTIONS(5312),
    [anon_sym_type] = ACTIONS(5312),
    [anon_sym_new] = ACTIONS(5328),
    [anon_sym_import] = ACTIONS(5312),
    [anon_sym_export] = ACTIONS(5312),
    [anon_sym_namespace] = ACTIONS(5330),
    [anon_sym_PLUS] = ACTIONS(5316),
    [anon_sym_await] = ACTIONS(5332),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(5306),
    [anon_sym_PLUS_PLUS] = ACTIONS(5322),
  },
  [2576] = {
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_EQ_GT] = ACTIONS(5344),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(135),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(135),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2577] = {
    [sym_nested_identifier] = STATE(1592),
    [sym__module] = STATE(1483),
    [sym_string] = STATE(1594),
    [sym__initializer] = STATE(1215),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(135),
    [anon_sym_LBRACK] = ACTIONS(135),
    [anon_sym_BANG] = ACTIONS(139),
    [anon_sym_BQUOTE] = ACTIONS(135),
    [sym_identifier] = ACTIONS(1140),
    [anon_sym_PERCENT_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_AMP_EQ] = ACTIONS(5334),
    [anon_sym_PLUS_EQ] = ACTIONS(5334),
    [anon_sym_PIPE] = ACTIONS(139),
    [anon_sym_COMMA] = ACTIONS(135),
    [anon_sym_LT_LT] = ACTIONS(139),
    [anon_sym_STAR] = ACTIONS(139),
    [anon_sym_LBRACE] = ACTIONS(139),
    [anon_sym_AMP_AMP] = ACTIONS(135),
    [anon_sym_GT_GT_GT] = ACTIONS(139),
    [anon_sym_DASH] = ACTIONS(139),
    [anon_sym_BANG_EQ] = ACTIONS(139),
    [anon_sym_LT_EQ] = ACTIONS(135),
    [anon_sym_LPAREN] = ACTIONS(135),
    [anon_sym_GT_EQ] = ACTIONS(135),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(139),
    [anon_sym_CARET_EQ] = ACTIONS(5334),
    [anon_sym_STAR_EQ] = ACTIONS(5334),
    [anon_sym_PIPE_EQ] = ACTIONS(5334),
    [anon_sym_DASH_EQ] = ACTIONS(5334),
    [anon_sym_EQ_GT] = ACTIONS(5344),
    [anon_sym_AMP] = ACTIONS(139),
    [anon_sym_PERCENT] = ACTIONS(139),
    [anon_sym_QMARK] = ACTIONS(135),
    [anon_sym_LBRACE_PIPE] = ACTIONS(135),
    [anon_sym_as] = ACTIONS(139),
    [anon_sym_PIPE_PIPE] = ACTIONS(135),
    [anon_sym_LT_LT_EQ] = ACTIONS(5334),
    [anon_sym_DASH_DASH] = ACTIONS(135),
    [anon_sym_EQ_EQ] = ACTIONS(139),
    [anon_sym_instanceof] = ACTIONS(139),
    [anon_sym_LT] = ACTIONS(139),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_SLASH] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT_EQ] = ACTIONS(5334),
    [anon_sym_DOT] = ACTIONS(1120),
    [anon_sym_CARET] = ACTIONS(139),
    [anon_sym_STAR_STAR] = ACTIONS(139),
    [anon_sym_PLUS] = ACTIONS(139),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5334),
    [anon_sym_GT_GT] = ACTIONS(139),
    [anon_sym_PLUS_PLUS] = ACTIONS(135),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(135),
    [anon_sym_in] = ACTIONS(139),
  },
  [2578] = {
    [sym__initializer] = STATE(1211),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5579),
    [anon_sym_AMP_EQ] = ACTIONS(5579),
    [anon_sym_PLUS_EQ] = ACTIONS(5579),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(5579),
    [anon_sym_STAR_EQ] = ACTIONS(5579),
    [anon_sym_PIPE_EQ] = ACTIONS(5579),
    [anon_sym_DASH_EQ] = ACTIONS(5579),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5579),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT_EQ] = ACTIONS(5579),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(115),
  },
  [2579] = {
    [sym__initializer] = STATE(1273),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2580] = {
    [sym__initializer] = STATE(1287),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2581] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(702),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_COMMA] = ACTIONS(700),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [2582] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_COMMA] = ACTIONS(700),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [2583] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(700),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_BANG] = ACTIONS(877),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(702),
    [anon_sym_COMMA] = ACTIONS(700),
    [anon_sym_LT_LT] = ACTIONS(700),
    [anon_sym_STAR] = ACTIONS(702),
    [anon_sym_LBRACE] = ACTIONS(702),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_GT_GT_GT] = ACTIONS(700),
    [anon_sym_DASH] = ACTIONS(702),
    [anon_sym_BANG_EQ] = ACTIONS(702),
    [anon_sym_LT_EQ] = ACTIONS(700),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(700),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_AMP] = ACTIONS(702),
    [anon_sym_PERCENT] = ACTIONS(700),
    [anon_sym_QMARK] = ACTIONS(700),
    [anon_sym_LBRACE_PIPE] = ACTIONS(700),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(702),
    [anon_sym_instanceof] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(5668),
    [anon_sym_SLASH] = ACTIONS(702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(700),
    [anon_sym_STAR_STAR] = ACTIONS(700),
    [anon_sym_PLUS] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(702),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(700),
    [anon_sym_in] = ACTIONS(702),
  },
  [2584] = {
    [sym_new_expression] = STATE(2562),
    [sym_augmented_assignment_expression] = STATE(2562),
    [sym_unary_expression] = STATE(2562),
    [sym_update_expression] = STATE(2562),
    [sym_regex] = STATE(2562),
    [sym_meta_property] = STATE(2562),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2562),
    [sym_yield_expression] = STATE(2562),
    [sym_as_expression] = STATE(2562),
    [sym_non_null_expression] = STATE(2562),
    [sym_internal_module] = STATE(2562),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2562),
    [sym_await_expression] = STATE(2562),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2562),
    [sym_this] = STATE(2562),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2562),
    [sym_generator_function] = STATE(2562),
    [sym_call_expression] = STATE(2562),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2562),
    [sym_ternary_expression] = STATE(2562),
    [sym_binary_expression] = STATE(2562),
    [sym_template_string] = STATE(2562),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2562),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2562),
    [sym_class] = STATE(2562),
    [anon_sym_BANG] = ACTIONS(518),
    [sym_identifier] = ACTIONS(1329),
    [sym_false] = ACTIONS(5671),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5671),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5673),
    [sym_true] = ACTIONS(5671),
    [anon_sym_yield] = ACTIONS(508),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5671),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
  },
  [2585] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_function] = ACTIONS(5675),
  },
  [2586] = {
    [anon_sym_class] = ACTIONS(5677),
    [sym_comment] = ACTIONS(3),
  },
  [2587] = {
    [sym_new_expression] = STATE(59),
    [sym_augmented_assignment_expression] = STATE(59),
    [sym_unary_expression] = STATE(59),
    [sym_regex] = STATE(59),
    [sym_call_signature] = STATE(52),
    [sym_yield_expression] = STATE(59),
    [sym_as_expression] = STATE(59),
    [sym_internal_module] = STATE(59),
    [sym_arrow_function] = STATE(59),
    [sym_member_expression] = STATE(54),
    [sym_expression_statement] = STATE(2474),
    [sym_string] = STATE(59),
    [sym_type_parameters] = STATE(55),
    [sym_object] = STATE(2590),
    [sym_generator_function] = STATE(59),
    [sym_subscript_expression] = STATE(54),
    [sym_ternary_expression] = STATE(59),
    [sym_template_string] = STATE(59),
    [sym_decorator] = STATE(90),
    [sym_formal_parameters] = STATE(58),
    [sym_update_expression] = STATE(59),
    [sym_meta_property] = STATE(59),
    [sym__expression] = STATE(59),
    [sym_non_null_expression] = STATE(59),
    [sym_function] = STATE(89),
    [sym_await_expression] = STATE(59),
    [sym_variable_declaration] = STATE(2474),
    [sym_sequence_expression] = STATE(62),
    [sym_this] = STATE(59),
    [sym_empty_statement] = STATE(2474),
    [aux_sym_export_statement_repeat1] = STATE(90),
    [sym_anonymous_class] = STATE(59),
    [sym_call_expression] = STATE(59),
    [sym_assignment_expression] = STATE(59),
    [sym_lexical_declaration] = STATE(2474),
    [sym_binary_expression] = STATE(59),
    [sym_type_arguments] = STATE(64),
    [sym_parenthesized_expression] = STATE(59),
    [sym_array] = STATE(2591),
    [sym_type_assertion] = STATE(59),
    [sym_class] = STATE(59),
    [sym_identifier] = ACTIONS(5679),
    [anon_sym_BQUOTE] = ACTIONS(7),
    [anon_sym_symbol] = ACTIONS(11),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(15),
    [anon_sym_void] = ACTIONS(17),
    [anon_sym_const] = ACTIONS(5681),
    [sym_super] = ACTIONS(23),
    [anon_sym_private] = ACTIONS(11),
    [anon_sym_get] = ACTIONS(11),
    [anon_sym_delete] = ACTIONS(31),
    [anon_sym_DASH_DASH] = ACTIONS(35),
    [anon_sym_this] = ACTIONS(39),
    [anon_sym_yield] = ACTIONS(41),
    [sym_true] = ACTIONS(43),
    [anon_sym_protected] = ACTIONS(11),
    [anon_sym_set] = ACTIONS(11),
    [anon_sym_type] = ACTIONS(11),
    [anon_sym_import] = ACTIONS(11),
    [anon_sym_namespace] = ACTIONS(153),
    [anon_sym_PLUS_PLUS] = ACTIONS(35),
    [anon_sym_await] = ACTIONS(55),
    [anon_sym_DQUOTE] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_false] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(65),
    [anon_sym_module] = ACTIONS(11),
    [anon_sym_number] = ACTIONS(11),
    [anon_sym_class] = ACTIONS(155),
    [anon_sym_declare] = ACTIONS(11),
    [anon_sym_typeof] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(157),
    [anon_sym_LPAREN] = ACTIONS(77),
    [sym_null] = ACTIONS(43),
    [anon_sym_any] = ACTIONS(11),
    [anon_sym_boolean] = ACTIONS(11),
    [anon_sym_async] = ACTIONS(159),
    [anon_sym_public] = ACTIONS(11),
    [anon_sym_var] = ACTIONS(5683),
    [anon_sym_SQUOTE] = ACTIONS(87),
    [anon_sym_LT] = ACTIONS(91),
    [sym_number] = ACTIONS(93),
    [anon_sym_SLASH] = ACTIONS(95),
    [sym_comment] = ACTIONS(3),
    [anon_sym_string] = ACTIONS(11),
    [anon_sym_function] = ACTIONS(163),
    [sym_undefined] = ACTIONS(43),
    [anon_sym_new] = ACTIONS(101),
    [anon_sym_let] = ACTIONS(5681),
    [anon_sym_PLUS] = ACTIONS(15),
    [anon_sym_export] = ACTIONS(11),
    [anon_sym_TILDE] = ACTIONS(59),
  },
  [2588] = {
    [sym_new_expression] = STATE(2477),
    [sym_augmented_assignment_expression] = STATE(2477),
    [sym_unary_expression] = STATE(2477),
    [sym_update_expression] = STATE(2477),
    [sym_regex] = STATE(2477),
    [sym_meta_property] = STATE(2477),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2477),
    [sym_yield_expression] = STATE(2477),
    [sym_as_expression] = STATE(2477),
    [sym_non_null_expression] = STATE(2477),
    [sym_internal_module] = STATE(2477),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2477),
    [sym_await_expression] = STATE(2477),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2477),
    [sym_this] = STATE(2477),
    [sym_type_parameters] = STATE(55),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2477),
    [sym_generator_function] = STATE(2477),
    [sym_call_expression] = STATE(2477),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2477),
    [sym_ternary_expression] = STATE(2477),
    [sym_binary_expression] = STATE(2477),
    [sym_template_string] = STATE(2477),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2477),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2477),
    [sym_class] = STATE(2477),
    [anon_sym_BANG] = ACTIONS(518),
    [sym_identifier] = ACTIONS(1329),
    [sym_false] = ACTIONS(5685),
    [anon_sym_LBRACK] = ACTIONS(181),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_DASH] = ACTIONS(498),
    [anon_sym_LBRACE] = ACTIONS(185),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_LPAREN] = ACTIONS(302),
    [sym_null] = ACTIONS(5685),
    [sym_super] = ACTIONS(278),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_DASH_DASH] = ACTIONS(506),
    [anon_sym_this] = ACTIONS(284),
    [sym_number] = ACTIONS(5687),
    [sym_true] = ACTIONS(5685),
    [anon_sym_yield] = ACTIONS(508),
    [anon_sym_SLASH] = ACTIONS(312),
    [anon_sym_LT] = ACTIONS(91),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(5685),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(498),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_PLUS_PLUS] = ACTIONS(506),
  },
  [2589] = {
    [sym__initializer] = STATE(72),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(113),
    [anon_sym_AMP_EQ] = ACTIONS(113),
    [anon_sym_PLUS_EQ] = ACTIONS(113),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_CARET_EQ] = ACTIONS(113),
    [anon_sym_PIPE_EQ] = ACTIONS(113),
    [anon_sym_DASH_EQ] = ACTIONS(113),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_LT_LT_EQ] = ACTIONS(113),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_DOT] = ACTIONS(121),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(113),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(113),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(5689),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_STAR_EQ] = ACTIONS(113),
    [anon_sym_EQ_GT] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(113),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5691),
  },
  [2590] = {
    [sym__initializer] = STATE(267),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(5693),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5695),
  },
  [2591] = {
    [sym__initializer] = STATE(286),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [sym__automatic_semicolon] = ACTIONS(111),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(111),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_GT_GT_GT] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(117),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_PERCENT] = ACTIONS(111),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_DOT] = ACTIONS(111),
    [anon_sym_STAR_STAR] = ACTIONS(111),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_SEMI] = ACTIONS(111),
    [anon_sym_LT_LT] = ACTIONS(111),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_of] = ACTIONS(5697),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_LT] = ACTIONS(115),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(111),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5699),
  },
  [2592] = {
    [sym__initializer] = STATE(1211),
    [sym_type_arguments] = STATE(497),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(111),
    [anon_sym_LBRACK] = ACTIONS(111),
    [anon_sym_BANG] = ACTIONS(115),
    [anon_sym_BQUOTE] = ACTIONS(111),
    [anon_sym_PERCENT_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(5579),
    [anon_sym_AMP_EQ] = ACTIONS(5579),
    [anon_sym_PLUS_EQ] = ACTIONS(5579),
    [anon_sym_PIPE] = ACTIONS(115),
    [anon_sym_COMMA] = ACTIONS(1911),
    [anon_sym_LT_LT] = ACTIONS(115),
    [anon_sym_STAR] = ACTIONS(115),
    [anon_sym_LBRACE] = ACTIONS(5701),
    [anon_sym_AMP_AMP] = ACTIONS(111),
    [anon_sym_GT_GT_GT] = ACTIONS(115),
    [anon_sym_DASH] = ACTIONS(115),
    [anon_sym_BANG_EQ] = ACTIONS(115),
    [anon_sym_LT_EQ] = ACTIONS(111),
    [anon_sym_LPAREN] = ACTIONS(111),
    [anon_sym_GT_EQ] = ACTIONS(111),
    [anon_sym_EQ] = ACTIONS(5336),
    [anon_sym_GT] = ACTIONS(115),
    [anon_sym_CARET_EQ] = ACTIONS(5579),
    [anon_sym_STAR_EQ] = ACTIONS(5579),
    [anon_sym_PIPE_EQ] = ACTIONS(5579),
    [anon_sym_DASH_EQ] = ACTIONS(5579),
    [anon_sym_EQ_GT] = ACTIONS(5581),
    [anon_sym_AMP] = ACTIONS(115),
    [anon_sym_PERCENT] = ACTIONS(115),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1911),
    [anon_sym_as] = ACTIONS(111),
    [anon_sym_PIPE_PIPE] = ACTIONS(111),
    [anon_sym_LT_LT_EQ] = ACTIONS(5579),
    [anon_sym_DASH_DASH] = ACTIONS(111),
    [anon_sym_EQ_EQ] = ACTIONS(115),
    [anon_sym_instanceof] = ACTIONS(111),
    [anon_sym_LT] = ACTIONS(1917),
    [anon_sym_SLASH] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT_EQ] = ACTIONS(5579),
    [anon_sym_DOT] = ACTIONS(1920),
    [anon_sym_CARET] = ACTIONS(115),
    [anon_sym_STAR_STAR] = ACTIONS(115),
    [anon_sym_PLUS] = ACTIONS(115),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5579),
    [anon_sym_GT_GT] = ACTIONS(115),
    [anon_sym_PLUS_PLUS] = ACTIONS(111),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(111),
    [anon_sym_in] = ACTIONS(5583),
  },
  [2593] = {
    [aux_sym_extends_clause_repeat1] = STATE(2485),
    [sym_template_string] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [sym_arguments] = STATE(1221),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(5583),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(5591),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_COMMA] = ACTIONS(5466),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_LBRACE] = ACTIONS(5703),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_BANG_EQ] = ACTIONS(5583),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(5589),
    [anon_sym_GT] = ACTIONS(5583),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1934),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(5605),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(5583),
    [anon_sym_instanceof] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(5607),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5589),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2594] = {
    [aux_sym_extends_clause_repeat1] = STATE(2485),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1934),
    [anon_sym_COMMA] = ACTIONS(5466),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(5703),
  },
  [2595] = {
    [anon_sym_of] = ACTIONS(5705),
    [sym_comment] = ACTIONS(3),
  },
  [2596] = {
    [anon_sym_of] = ACTIONS(5707),
    [sym_comment] = ACTIONS(3),
  },
  [2597] = {
    [anon_sym_of] = ACTIONS(5709),
    [sym_comment] = ACTIONS(3),
  },
  [2598] = {
    [sym__initializer] = STATE(316),
    [sym_type_annotation] = STATE(317),
    [sym__automatic_semicolon] = ACTIONS(715),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(719),
    [anon_sym_SEMI] = ACTIONS(715),
    [anon_sym_of] = ACTIONS(5705),
    [anon_sym_COMMA] = ACTIONS(715),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(5711),
  },
  [2599] = {
    [sym__initializer] = STATE(322),
    [sym_type_annotation] = STATE(323),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_of] = ACTIONS(5707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(5713),
  },
  [2600] = {
    [sym__initializer] = STATE(324),
    [sym_type_annotation] = STATE(325),
    [anon_sym_EQ] = ACTIONS(717),
    [anon_sym_COLON] = ACTIONS(568),
    [anon_sym_of] = ACTIONS(5709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(5715),
  },
  [2601] = {
    [anon_sym_of] = ACTIONS(5717),
    [sym_comment] = ACTIONS(3),
  },
  [2602] = {
    [anon_sym_of] = ACTIONS(5719),
    [sym_comment] = ACTIONS(3),
  },
  [2603] = {
    [anon_sym_of] = ACTIONS(5721),
    [sym_comment] = ACTIONS(3),
  },
  [2604] = {
    [sym_template_string] = STATE(1221),
    [sym_arguments] = STATE(1221),
    [sym_type_arguments] = STATE(1749),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(5589),
    [anon_sym_LBRACK] = ACTIONS(845),
    [anon_sym_in] = ACTIONS(5583),
    [anon_sym_BQUOTE] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(5591),
    [anon_sym_COMMA] = ACTIONS(3300),
    [anon_sym_LT_LT] = ACTIONS(5593),
    [anon_sym_STAR] = ACTIONS(5595),
    [anon_sym_LBRACE] = ACTIONS(3302),
    [anon_sym_GT_GT_GT] = ACTIONS(5593),
    [anon_sym_AMP_AMP] = ACTIONS(5599),
    [anon_sym_DASH] = ACTIONS(5601),
    [anon_sym_BANG_EQ] = ACTIONS(5583),
    [anon_sym_LT_EQ] = ACTIONS(5589),
    [anon_sym_LPAREN] = ACTIONS(672),
    [anon_sym_GT_EQ] = ACTIONS(5589),
    [anon_sym_GT] = ACTIONS(5583),
    [anon_sym_LBRACE_PIPE] = ACTIONS(3300),
    [anon_sym_AMP] = ACTIONS(5603),
    [anon_sym_PERCENT] = ACTIONS(5593),
    [anon_sym_QMARK] = ACTIONS(5605),
    [anon_sym_PIPE_PIPE] = ACTIONS(5607),
    [anon_sym_as] = ACTIONS(867),
    [anon_sym_DASH_DASH] = ACTIONS(869),
    [anon_sym_EQ_EQ] = ACTIONS(5583),
    [anon_sym_instanceof] = ACTIONS(5589),
    [anon_sym_LT] = ACTIONS(5609),
    [anon_sym_SLASH] = ACTIONS(5595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(873),
    [anon_sym_CARET] = ACTIONS(5607),
    [anon_sym_STAR_STAR] = ACTIONS(5611),
    [anon_sym_PLUS] = ACTIONS(5601),
    [anon_sym_GT_GT] = ACTIONS(5595),
    [anon_sym_PLUS_PLUS] = ACTIONS(869),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5589),
    [anon_sym_BANG] = ACTIONS(877),
  },
  [2605] = {
    [sym_new_expression] = STATE(2350),
    [sym_augmented_assignment_expression] = STATE(2350),
    [sym__initializer] = STATE(1215),
    [sym_unary_expression] = STATE(2350),
    [sym_update_expression] = STATE(2350),
    [sym_regex] = STATE(2350),
    [sym_meta_property] = STATE(2350),
    [sym_call_signature] = STATE(2379),
    [sym__expression] = STATE(2350),
    [sym_yield_expression] = STATE(2350),
    [sym_as_expression] = STATE(2350),
    [sym_non_null_expression] = STATE(2350),
    [sym_internal_module] = STATE(2350),
    [sym_function] = STATE(1219),
    [sym_arrow_function] = STATE(2350),
    [sym_await_expression] = STATE(2350),
    [sym_member_expression] = STATE(2521),
    [sym_string] = STATE(2350),
    [sym_this] = STATE(2350),
    [sym_type_parameters] = STATE(55),
    [sym_arguments] = STATE(1355),
    [aux_sym_export_statement_repeat1] = STATE(2216),
    [sym_object] = STATE(2522),
    [sym_anonymous_class] = STATE(2350),
    [sym_generator_function] = STATE(2350),
    [sym_call_expression] = STATE(2350),
    [sym_subscript_expression] = STATE(2521),
    [sym_assignment_expression] = STATE(2350),
    [sym_ternary_expression] = STATE(2350),
    [sym_binary_expression] = STATE(2350),
    [sym_template_string] = STATE(2350),
    [sym_type_arguments] = STATE(2523),
    [sym_decorator] = STATE(2216),
    [sym_formal_parameters] = STATE(58),
    [sym_parenthesized_expression] = STATE(2350),
    [sym_array] = STATE(2524),
    [sym_type_assertion] = STATE(2350),
    [sym_class] = STATE(2350),
    [anon_sym_BANG_EQ_EQ] = ACTIONS(1315),
    [sym_identifier] = ACTIONS(1329),
    [anon_sym_BQUOTE] = ACTIONS(1315),
    [anon_sym_PERCENT_EQ] = ACTIONS(1317),
    [anon_sym_symbol] = ACTIONS(1321),
    [anon_sym_AMP_EQ] = ACTIONS(1317),
    [anon_sym_AT] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(1317),
    [anon_sym_PIPE] = ACTIONS(1319),
    [anon_sym_COMMA] = ACTIONS(1315),
    [anon_sym_DASH] = ACTIONS(1319),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_GT_GT_GT] = ACTIONS(1319),
    [anon_sym_EQ] = ACTIONS(1311),
    [anon_sym_void] = ACTIONS(1331),
    [anon_sym_BANG_EQ] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1315),
    [sym_super] = ACTIONS(278),
    [anon_sym_CARET_EQ] = ACTIONS(1317),
    [anon_sym_private] = ACTIONS(1321),
    [anon_sym_PIPE_EQ] = ACTIONS(1317),
    [anon_sym_DASH_EQ] = ACTIONS(1317),
    [anon_sym_get] = ACTIONS(1321),
    [anon_sym_LBRACE_PIPE] = ACTIONS(1315),
    [anon_sym_PERCENT] = ACTIONS(1319),
    [anon_sym_LT_LT_EQ] = ACTIONS(1317),
    [anon_sym_as] = ACTIONS(1319),
    [anon_sym_delete] = ACTIONS(504),
    [anon_sym_DASH_DASH] = ACTIONS(1315),
    [anon_sym_instanceof] = ACTIONS(1319),
    [anon_sym_this] = ACTIONS(284),
    [anon_sym_yield] = ACTIONS(508),
    [sym_true] = ACTIONS(1323),
    [anon_sym_protected] = ACTIONS(1321),
    [anon_sym_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_DOT] = ACTIONS(1126),
    [anon_sym_set] = ACTIONS(1321),
    [anon_sym_type] = ACTIONS(1321),
    [anon_sym_STAR_STAR] = ACTIONS(1319),
    [anon_sym_import] = ACTIONS(1321),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1317),
    [anon_sym_namespace] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1315),
    [anon_sym_await] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(294),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_LBRACK] = ACTIONS(1315),
    [sym_false] = ACTIONS(1323),
    [anon_sym_module] = ACTIONS(1321),
    [anon_sym_GT_GT_GT_EQ] = ACTIONS(1317),
    [anon_sym_number] = ACTIONS(1321),
    [anon_sym_class] = ACTIONS(298),
    [anon_sym_declare] = ACTIONS(1321),
    [anon_sym_typeof] = ACTIONS(504),
    [anon_sym_LT_LT] = ACTIONS(1319),
    [anon_sym_LBRACE] = ACTIONS(1319),
    [anon_sym_AMP_AMP] = ACTIONS(1315),
    [anon_sym_LT_EQ] = ACTIONS(1315),
    [anon_sym_LPAREN] = ACTIONS(1315),
    [sym_null] = ACTIONS(1323),
    [anon_sym_GT] = ACTIONS(1319),
    [anon_sym_any] = ACTIONS(1321),
    [anon_sym_STAR_EQ] = ACTIONS(1317),
    [anon_sym_boolean] = ACTIONS(1321),
    [anon_sym_async] = ACTIONS(1325),
    [anon_sym_public] = ACTIONS(1321),
    [anon_sym_EQ_GT] = ACTIONS(5344),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_QMARK] = ACTIONS(1315),
    [anon_sym_PIPE_PIPE] = ACTIONS(1315),
    [anon_sym_SQUOTE] = ACTIONS(308),
    [anon_sym_EQ_EQ] = ACTIONS(1319),
    [anon_sym_LT] = ACTIONS(1319),
    [sym_number] = ACTIONS(1335),
    [anon_sym_SLASH] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SLASH_EQ] = ACTIONS(1317),
    [anon_sym_string] = ACTIONS(1321),
    [anon_sym_function] = ACTIONS(314),
    [sym_undefined] = ACTIONS(1323),
    [anon_sym_new] = ACTIONS(1327),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_PLUS] = ACTIONS(1319),
    [anon_sym_export] = ACTIONS(1321),
    [anon_sym_GT_GT] = ACTIONS(1319),
    [anon_sym_TILDE] = ACTIONS(518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1315),
    [anon_sym_in] = ACTIONS(1319),
  },
  [2606] = {
    [anon_sym_await] = ACTIONS(5723),
    [anon_sym_LPAREN] = ACTIONS(5725),
    [sym_comment] = ACTIONS(3),
  },
  [2607] = {
    [sym_array] = STATE(2596),
    [sym_object] = STATE(2597),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(5727),
    [anon_sym_var] = ACTIONS(5729),
    [anon_sym_const] = ACTIONS(5729),
    [anon_sym_let] = ACTIONS(5729),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(185),
  },
  [2608] = {
    [sym_variable_declarator] = STATE(96),
    [sym_array] = STATE(2599),
    [sym_object] = STATE(2600),
    [sym_identifier] = ACTIONS(5731),
    [anon_sym_LBRACK] = ACTIONS(1884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1886),
  },
  [2609] = {
    [sym_variable_declarator] = STATE(211),
    [sym_array] = STATE(2599),
    [sym_object] = STATE(2600),
    [sym_identifier] = ACTIONS(5731),
    [anon_sym_LBRACK] = ACTIONS(1884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1886),
  },
  [2610] = {
    [sym_array] = STATE(2602),
    [sym_object] = STATE(2603),
    [anon_sym_LBRACK] = ACTIONS(181),
    [sym_identifier] = ACTIONS(5733),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(185),
  },
  [2611] = {
    [anon_sym_LPAREN] = ACTIONS(5735),
    [sym_comment] = ACTIONS(3),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = false}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = false}, SHIFT(4),
  [11] = {.count = 1, .reusable = false}, SHIFT(5),
  [13] = {.count = 1, .reusable = true}, SHIFT(6),
  [15] = {.count = 1, .reusable = false}, SHIFT(7),
  [17] = {.count = 1, .reusable = false}, SHIFT(8),
  [19] = {.count = 1, .reusable = false}, SHIFT(9),
  [21] = {.count = 1, .reusable = false}, SHIFT(10),
  [23] = {.count = 1, .reusable = false}, SHIFT(11),
  [25] = {.count = 1, .reusable = false}, SHIFT(12),
  [27] = {.count = 1, .reusable = false}, SHIFT(13),
  [29] = {.count = 1, .reusable = false}, SHIFT(14),
  [31] = {.count = 1, .reusable = false}, SHIFT(15),
  [33] = {.count = 1, .reusable = false}, SHIFT(16),
  [35] = {.count = 1, .reusable = true}, SHIFT(17),
  [37] = {.count = 1, .reusable = false}, SHIFT(18),
  [39] = {.count = 1, .reusable = false}, SHIFT(19),
  [41] = {.count = 1, .reusable = false}, SHIFT(20),
  [43] = {.count = 1, .reusable = false}, SHIFT(59),
  [45] = {.count = 1, .reusable = false}, SHIFT(21),
  [47] = {.count = 1, .reusable = false}, SHIFT(22),
  [49] = {.count = 1, .reusable = false}, SHIFT(23),
  [51] = {.count = 1, .reusable = false}, SHIFT(24),
  [53] = {.count = 1, .reusable = false}, SHIFT(25),
  [55] = {.count = 1, .reusable = false}, SHIFT(26),
  [57] = {.count = 1, .reusable = true}, SHIFT(27),
  [59] = {.count = 1, .reusable = true}, SHIFT(28),
  [61] = {.count = 1, .reusable = false}, SHIFT(29),
  [63] = {.count = 1, .reusable = true}, SHIFT(30),
  [65] = {.count = 1, .reusable = true}, SHIFT(31),
  [67] = {.count = 1, .reusable = false}, SHIFT(32),
  [69] = {.count = 1, .reusable = false}, SHIFT(33),
  [71] = {.count = 1, .reusable = false}, SHIFT(34),
  [73] = {.count = 1, .reusable = true}, SHIFT(35),
  [75] = {.count = 1, .reusable = false}, SHIFT(36),
  [77] = {.count = 1, .reusable = true}, SHIFT(37),
  [79] = {.count = 1, .reusable = false}, SHIFT(38),
  [81] = {.count = 1, .reusable = false}, SHIFT(39),
  [83] = {.count = 1, .reusable = true}, SHIFT(40),
  [85] = {.count = 1, .reusable = false}, SHIFT(41),
  [87] = {.count = 1, .reusable = true}, SHIFT(42),
  [89] = {.count = 1, .reusable = false}, SHIFT(43),
  [91] = {.count = 1, .reusable = true}, SHIFT(44),
  [93] = {.count = 1, .reusable = true}, SHIFT(59),
  [95] = {.count = 1, .reusable = false}, SHIFT(45),
  [97] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [99] = {.count = 1, .reusable = false}, SHIFT(46),
  [101] = {.count = 1, .reusable = false}, SHIFT(47),
  [103] = {.count = 1, .reusable = false}, SHIFT(48),
  [105] = {.count = 1, .reusable = false}, SHIFT(49),
  [107] = {.count = 1, .reusable = false}, SHIFT(50),
  [109] = {.count = 1, .reusable = false}, SHIFT(51),
  [111] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [113] = {.count = 1, .reusable = true}, SHIFT(68),
  [115] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [117] = {.count = 1, .reusable = false}, SHIFT(69),
  [119] = {.count = 1, .reusable = true}, SHIFT(70),
  [121] = {.count = 1, .reusable = true}, SHIFT(71),
  [123] = {.count = 1, .reusable = true}, SHIFT(66),
  [125] = {.count = 1, .reusable = false}, SHIFT(67),
  [127] = {.count = 1, .reusable = true}, SHIFT(73),
  [129] = {.count = 1, .reusable = true}, SHIFT(74),
  [131] = {.count = 1, .reusable = true}, SHIFT(75),
  [133] = {.count = 1, .reusable = true}, SHIFT(76),
  [135] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1),
  [137] = {.count = 1, .reusable = true}, SHIFT(78),
  [139] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1),
  [141] = {.count = 1, .reusable = true}, SHIFT(79),
  [143] = {.count = 1, .reusable = true}, SHIFT(77),
  [145] = {.count = 1, .reusable = false}, SHIFT(82),
  [147] = {.count = 1, .reusable = false}, SHIFT(81),
  [149] = {.count = 1, .reusable = false}, SHIFT(84),
  [151] = {.count = 1, .reusable = false}, SHIFT(88),
  [153] = {.count = 1, .reusable = false}, SHIFT(1734),
  [155] = {.count = 1, .reusable = false}, SHIFT(2194),
  [157] = {.count = 1, .reusable = true}, SHIFT(85),
  [159] = {.count = 1, .reusable = false}, SHIFT(86),
  [161] = {.count = 1, .reusable = true}, SHIFT(88),
  [163] = {.count = 1, .reusable = false}, SHIFT(87),
  [165] = {.count = 1, .reusable = false}, SHIFT(91),
  [167] = {.count = 1, .reusable = false}, SHIFT(79),
  [169] = {.count = 1, .reusable = false}, SHIFT(28),
  [171] = {.count = 1, .reusable = false}, SHIFT(44),
  [173] = {.count = 1, .reusable = true}, SHIFT(91),
  [175] = {.count = 1, .reusable = true}, SHIFT(92),
  [177] = {.count = 1, .reusable = true}, SHIFT(93),
  [179] = {.count = 1, .reusable = false}, SHIFT(94),
  [181] = {.count = 1, .reusable = true}, SHIFT(1736),
  [183] = {.count = 1, .reusable = false}, SHIFT(95),
  [185] = {.count = 1, .reusable = true}, SHIFT(1746),
  [187] = {.count = 1, .reusable = true}, SHIFT(99),
  [189] = {.count = 1, .reusable = true}, SHIFT(101),
  [191] = {.count = 1, .reusable = false}, SHIFT(100),
  [193] = {.count = 1, .reusable = true}, SHIFT(104),
  [195] = {.count = 1, .reusable = false}, SHIFT(105),
  [197] = {.count = 1, .reusable = true}, SHIFT(105),
  [199] = {.count = 1, .reusable = true}, SHIFT(107),
  [201] = {.count = 1, .reusable = true}, SHIFT(108),
  [203] = {.count = 1, .reusable = true}, SHIFT(109),
  [205] = {.count = 1, .reusable = true}, SHIFT(110),
  [207] = {.count = 1, .reusable = false}, SHIFT(111),
  [209] = {.count = 1, .reusable = true}, SHIFT(111),
  [211] = {.count = 1, .reusable = true}, SHIFT(112),
  [213] = {.count = 1, .reusable = true}, REDUCE(sym_this, 1),
  [215] = {.count = 1, .reusable = false}, REDUCE(sym_this, 1),
  [217] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 1),
  [219] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 1),
  [221] = {.count = 1, .reusable = false}, SHIFT(114),
  [223] = {.count = 1, .reusable = true}, SHIFT(114),
  [225] = {.count = 1, .reusable = false}, SHIFT(115),
  [227] = {.count = 1, .reusable = true}, SHIFT(115),
  [229] = {.count = 1, .reusable = true}, SHIFT(117),
  [231] = {.count = 1, .reusable = false}, SHIFT(118),
  [233] = {.count = 1, .reusable = false}, SHIFT(119),
  [235] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(121),
  [238] = {.count = 1, .reusable = false}, SHIFT(120),
  [240] = {.count = 1, .reusable = true}, SHIFT(122),
  [242] = {.count = 1, .reusable = false}, SHIFT(126),
  [244] = {.count = 1, .reusable = true}, SHIFT(1735),
  [246] = {.count = 1, .reusable = true}, SHIFT(1739),
  [248] = {.count = 1, .reusable = false}, SHIFT(129),
  [250] = {.count = 1, .reusable = true}, SHIFT(129),
  [252] = {.count = 1, .reusable = true}, SHIFT(131),
  [254] = {.count = 1, .reusable = false}, SHIFT(130),
  [256] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [258] = {.count = 1, .reusable = false}, SHIFT(132),
  [260] = {.count = 1, .reusable = true}, SHIFT(132),
  [262] = {.count = 1, .reusable = true}, SHIFT(133),
  [264] = {.count = 1, .reusable = true}, SHIFT(134),
  [266] = {.count = 1, .reusable = false}, SHIFT(1216),
  [268] = {.count = 1, .reusable = true}, SHIFT(1733),
  [270] = {.count = 1, .reusable = false}, SHIFT(1188),
  [272] = {.count = 1, .reusable = true}, SHIFT(136),
  [274] = {.count = 1, .reusable = false}, SHIFT(1189),
  [276] = {.count = 1, .reusable = false}, SHIFT(1190),
  [278] = {.count = 1, .reusable = false}, SHIFT(1191),
  [280] = {.count = 1, .reusable = false}, SHIFT(1192),
  [282] = {.count = 1, .reusable = true}, SHIFT(1193),
  [284] = {.count = 1, .reusable = false}, SHIFT(1194),
  [286] = {.count = 1, .reusable = false}, SHIFT(1195),
  [288] = {.count = 1, .reusable = false}, SHIFT(138),
  [290] = {.count = 1, .reusable = false}, SHIFT(1196),
  [292] = {.count = 1, .reusable = false}, SHIFT(1197),
  [294] = {.count = 1, .reusable = true}, SHIFT(1993),
  [296] = {.count = 1, .reusable = true}, SHIFT(1198),
  [298] = {.count = 1, .reusable = false}, SHIFT(1737),
  [300] = {.count = 1, .reusable = true}, SHIFT(135),
  [302] = {.count = 1, .reusable = true}, SHIFT(2196),
  [304] = {.count = 1, .reusable = true}, SHIFT(137),
  [306] = {.count = 1, .reusable = false}, SHIFT(1217),
  [308] = {.count = 1, .reusable = true}, SHIFT(1996),
  [310] = {.count = 1, .reusable = true}, SHIFT(138),
  [312] = {.count = 1, .reusable = false}, SHIFT(2199),
  [314] = {.count = 1, .reusable = false}, SHIFT(2214),
  [316] = {.count = 1, .reusable = false}, SHIFT(1199),
  [318] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [320] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [322] = {.count = 1, .reusable = false}, SHIFT(1224),
  [324] = {.count = 1, .reusable = true}, SHIFT(2096),
  [326] = {.count = 1, .reusable = true}, SHIFT(2098),
  [328] = {.count = 1, .reusable = false}, SHIFT(142),
  [330] = {.count = 1, .reusable = false}, SHIFT(144),
  [332] = {.count = 1, .reusable = false}, SHIFT(143),
  [334] = {.count = 1, .reusable = true}, SHIFT(145),
  [336] = {.count = 1, .reusable = true}, SHIFT(153),
  [338] = {.count = 1, .reusable = true}, SHIFT(10),
  [340] = {.count = 1, .reusable = true}, SHIFT(13),
  [342] = {.count = 1, .reusable = true}, SHIFT(14),
  [344] = {.count = 1, .reusable = true}, SHIFT(22),
  [346] = {.count = 1, .reusable = true}, SHIFT(155),
  [348] = {.count = 1, .reusable = true}, SHIFT(156),
  [350] = {.count = 1, .reusable = true}, SHIFT(158),
  [352] = {.count = 1, .reusable = true}, SHIFT(150),
  [354] = {.count = 1, .reusable = true}, SHIFT(151),
  [356] = {.count = 1, .reusable = true}, SHIFT(152),
  [358] = {.count = 1, .reusable = true}, SHIFT(154),
  [360] = {.count = 1, .reusable = true}, SHIFT(39),
  [362] = {.count = 1, .reusable = true}, SHIFT(2200),
  [364] = {.count = 1, .reusable = true}, SHIFT(48),
  [366] = {.count = 1, .reusable = true}, SHIFT(157),
  [368] = {.count = 1, .reusable = false}, SHIFT(161),
  [370] = {.count = 1, .reusable = false}, SHIFT(162),
  [372] = {.count = 1, .reusable = true}, SHIFT(2444),
  [374] = {.count = 1, .reusable = true}, SHIFT(163),
  [376] = {.count = 1, .reusable = true}, SHIFT(164),
  [378] = {.count = 1, .reusable = false}, SHIFT(165),
  [380] = {.count = 1, .reusable = false}, SHIFT(166),
  [382] = {.count = 1, .reusable = false}, SHIFT(167),
  [384] = {.count = 1, .reusable = false}, SHIFT(168),
  [386] = {.count = 1, .reusable = true}, SHIFT(169),
  [388] = {.count = 1, .reusable = false}, SHIFT(170),
  [390] = {.count = 1, .reusable = false}, SHIFT(171),
  [392] = {.count = 1, .reusable = false}, SHIFT(172),
  [394] = {.count = 1, .reusable = false}, SHIFT(173),
  [396] = {.count = 1, .reusable = true}, SHIFT(174),
  [398] = {.count = 1, .reusable = false}, SHIFT(175),
  [400] = {.count = 1, .reusable = false}, SHIFT(176),
  [402] = {.count = 1, .reusable = false}, SHIFT(177),
  [404] = {.count = 1, .reusable = true}, SHIFT(178),
  [406] = {.count = 1, .reusable = false}, SHIFT(179),
  [408] = {.count = 1, .reusable = false}, SHIFT(189),
  [410] = {.count = 1, .reusable = false}, SHIFT(191),
  [412] = {.count = 1, .reusable = false}, SHIFT(193),
  [414] = {.count = 1, .reusable = false}, SHIFT(194),
  [416] = {.count = 1, .reusable = false}, SHIFT(199),
  [418] = {.count = 1, .reusable = false}, SHIFT(190),
  [420] = {.count = 1, .reusable = false}, SHIFT(197),
  [422] = {.count = 1, .reusable = true}, SHIFT(192),
  [424] = {.count = 1, .reusable = false}, SHIFT(195),
  [426] = {.count = 1, .reusable = true}, SHIFT(196),
  [428] = {.count = 1, .reusable = true}, SHIFT(199),
  [430] = {.count = 1, .reusable = false}, SHIFT(206),
  [432] = {.count = 1, .reusable = false}, SHIFT(207),
  [434] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(208),
  [437] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(209),
  [440] = {.count = 1, .reusable = false}, SHIFT(210),
  [442] = {.count = 1, .reusable = true}, SHIFT(94),
  [444] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [446] = {.count = 1, .reusable = true}, SHIFT(214),
  [448] = {.count = 1, .reusable = true}, SHIFT(215),
  [450] = {.count = 1, .reusable = false}, SHIFT(217),
  [452] = {.count = 1, .reusable = false}, SHIFT(218),
  [454] = {.count = 1, .reusable = true}, SHIFT(219),
  [456] = {.count = 1, .reusable = true}, SHIFT(220),
  [458] = {.count = 1, .reusable = true}, SHIFT(221),
  [460] = {.count = 1, .reusable = true}, SHIFT(222),
  [462] = {.count = 1, .reusable = false}, SHIFT(223),
  [464] = {.count = 1, .reusable = false}, SHIFT(224),
  [466] = {.count = 1, .reusable = false}, SHIFT(225),
  [468] = {.count = 1, .reusable = true}, SHIFT(226),
  [470] = {.count = 1, .reusable = true}, SHIFT(227),
  [472] = {.count = 1, .reusable = false}, SHIFT(228),
  [474] = {.count = 1, .reusable = true}, SHIFT(218),
  [476] = {.count = 1, .reusable = false}, SHIFT(220),
  [478] = {.count = 1, .reusable = false}, SHIFT(229),
  [480] = {.count = 1, .reusable = true}, SHIFT(230),
  [482] = {.count = 1, .reusable = true}, SHIFT(209),
  [484] = {.count = 1, .reusable = true}, SHIFT(231),
  [486] = {.count = 1, .reusable = false}, SHIFT(239),
  [488] = {.count = 1, .reusable = true}, SHIFT(240),
  [490] = {.count = 1, .reusable = true}, SHIFT(208),
  [492] = {.count = 1, .reusable = true}, SHIFT(241),
  [494] = {.count = 1, .reusable = false}, SHIFT(243),
  [496] = {.count = 1, .reusable = false}, SHIFT(246),
  [498] = {.count = 1, .reusable = false}, SHIFT(2512),
  [500] = {.count = 1, .reusable = false}, SHIFT(247),
  [502] = {.count = 1, .reusable = false}, SHIFT(1945),
  [504] = {.count = 1, .reusable = false}, SHIFT(2514),
  [506] = {.count = 1, .reusable = true}, SHIFT(2515),
  [508] = {.count = 1, .reusable = false}, SHIFT(2516),
  [510] = {.count = 1, .reusable = false}, SHIFT(244),
  [512] = {.count = 1, .reusable = false}, SHIFT(245),
  [514] = {.count = 1, .reusable = false}, SHIFT(249),
  [516] = {.count = 1, .reusable = false}, SHIFT(2518),
  [518] = {.count = 1, .reusable = true}, SHIFT(2519),
  [520] = {.count = 1, .reusable = false}, SHIFT(248),
  [522] = {.count = 1, .reusable = true}, SHIFT(244),
  [524] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(256),
  [527] = {.count = 1, .reusable = false}, SHIFT(258),
  [529] = {.count = 1, .reusable = true}, SHIFT(259),
  [531] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(260),
  [534] = {.count = 1, .reusable = true}, SHIFT(255),
  [536] = {.count = 1, .reusable = true}, SHIFT(257),
  [538] = {.count = 1, .reusable = false}, SHIFT(2188),
  [540] = {.count = 1, .reusable = false}, SHIFT(2192),
  [542] = {.count = 1, .reusable = false}, SHIFT(2586),
  [544] = {.count = 1, .reusable = false}, SHIFT(2606),
  [546] = {.count = 1, .reusable = false}, SHIFT(2193),
  [548] = {.count = 1, .reusable = false}, SHIFT(2195),
  [550] = {.count = 1, .reusable = true}, SHIFT(1738),
  [552] = {.count = 1, .reusable = false}, SHIFT(2453),
  [554] = {.count = 1, .reusable = false}, SHIFT(2198),
  [556] = {.count = 1, .reusable = false}, SHIFT(2386),
  [558] = {.count = 1, .reusable = false}, SHIFT(2202),
  [560] = {.count = 1, .reusable = false}, SHIFT(2203),
  [562] = {.count = 1, .reusable = true}, REDUCE(sym__declaration, 1),
  [564] = {.count = 1, .reusable = false}, REDUCE(sym__declaration, 1),
  [566] = {.count = 1, .reusable = true}, REDUCE(sym_call_signature, 1),
  [568] = {.count = 1, .reusable = true}, SHIFT(268),
  [570] = {.count = 1, .reusable = true}, SHIFT(270),
  [572] = {.count = 1, .reusable = true}, SHIFT(67),
  [574] = {.count = 1, .reusable = false}, SHIFT(272),
  [576] = {.count = 1, .reusable = true}, SHIFT(276),
  [578] = {.count = 1, .reusable = true}, SHIFT(273),
  [580] = {.count = 1, .reusable = false}, SHIFT(274),
  [582] = {.count = 1, .reusable = true}, SHIFT(275),
  [584] = {.count = 1, .reusable = false}, SHIFT(273),
  [586] = {.count = 1, .reusable = false}, SHIFT(275),
  [588] = {.count = 1, .reusable = true}, SHIFT(277),
  [590] = {.count = 1, .reusable = true}, SHIFT(272),
  [592] = {.count = 1, .reusable = true}, SHIFT(278),
  [594] = {.count = 1, .reusable = true}, SHIFT(279),
  [596] = {.count = 1, .reusable = false}, SHIFT(280),
  [598] = {.count = 1, .reusable = true}, SHIFT(281),
  [600] = {.count = 1, .reusable = false}, SHIFT(271),
  [602] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [604] = {.count = 1, .reusable = true}, SHIFT(282),
  [606] = {.count = 1, .reusable = true}, SHIFT(283),
  [608] = {.count = 1, .reusable = false}, SHIFT(285),
  [610] = {.count = 1, .reusable = true}, SHIFT(285),
  [612] = {.count = 1, .reusable = false}, SHIFT(288),
  [614] = {.count = 1, .reusable = true}, SHIFT(1995),
  [616] = {.count = 1, .reusable = true}, SHIFT(288),
  [618] = {.count = 1, .reusable = false}, SHIFT(289),
  [620] = {.count = 1, .reusable = true}, SHIFT(289),
  [622] = {.count = 1, .reusable = false}, SHIFT(290),
  [624] = {.count = 1, .reusable = true}, SHIFT(290),
  [626] = {.count = 1, .reusable = false}, SHIFT(291),
  [628] = {.count = 1, .reusable = true}, SHIFT(291),
  [630] = {.count = 1, .reusable = true}, SHIFT(293),
  [632] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2),
  [634] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2),
  [636] = {.count = 1, .reusable = false}, SHIFT(294),
  [638] = {.count = 1, .reusable = true}, SHIFT(294),
  [640] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 2),
  [642] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 2),
  [644] = {.count = 1, .reusable = true}, SHIFT(296),
  [646] = {.count = 1, .reusable = true}, SHIFT(297),
  [648] = {.count = 1, .reusable = false}, REDUCE(sym_debugger_statement, 2),
  [650] = {.count = 1, .reusable = true}, REDUCE(sym_debugger_statement, 2),
  [652] = {.count = 1, .reusable = false}, SHIFT(299),
  [654] = {.count = 1, .reusable = true}, SHIFT(299),
  [656] = {.count = 1, .reusable = false}, SHIFT(300),
  [658] = {.count = 1, .reusable = true}, SHIFT(300),
  [660] = {.count = 1, .reusable = true}, SHIFT(301),
  [662] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2, .production_id = 1),
  [664] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2, .production_id = 1),
  [666] = {.count = 1, .reusable = true}, REDUCE(sym__identifier_reference, 1, .production_id = 1),
  [668] = {.count = 1, .reusable = false}, REDUCE(sym__identifier_reference, 1, .production_id = 1),
  [670] = {.count = 1, .reusable = true}, SHIFT(302),
  [672] = {.count = 1, .reusable = true}, SHIFT(1748),
  [674] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 2),
  [676] = {.count = 1, .reusable = false}, REDUCE(sym_decorator, 2),
  [678] = {.count = 1, .reusable = false}, SHIFT(304),
  [680] = {.count = 1, .reusable = true}, SHIFT(1239),
  [682] = {.count = 1, .reusable = false}, SHIFT(305),
  [684] = {.count = 1, .reusable = false}, SHIFT(306),
  [686] = {.count = 1, .reusable = false}, SHIFT(307),
  [688] = {.count = 1, .reusable = false}, SHIFT(308),
  [690] = {.count = 1, .reusable = true}, SHIFT(309),
  [692] = {.count = 1, .reusable = true}, SHIFT(183),
  [694] = {.count = 1, .reusable = false}, SHIFT(313),
  [696] = {.count = 1, .reusable = true}, SHIFT(314),
  [698] = {.count = 1, .reusable = true}, SHIFT(2243),
  [700] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [702] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [704] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(280),
  [707] = {.count = 1, .reusable = true}, SHIFT(2259),
  [709] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 2),
  [711] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 2),
  [713] = {.count = 1, .reusable = true}, SHIFT(315),
  [715] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 1),
  [717] = {.count = 1, .reusable = true}, SHIFT(69),
  [719] = {.count = 1, .reusable = true}, SHIFT(1274),
  [721] = {.count = 1, .reusable = true}, SHIFT(318),
  [723] = {.count = 1, .reusable = true}, SHIFT(320),
  [725] = {.count = 1, .reusable = true}, SHIFT(319),
  [727] = {.count = 1, .reusable = false}, SHIFT(326),
  [729] = {.count = 1, .reusable = true}, SHIFT(326),
  [731] = {.count = 1, .reusable = false}, SHIFT(328),
  [733] = {.count = 1, .reusable = false}, SHIFT(330),
  [735] = {.count = 1, .reusable = true}, SHIFT(329),
  [737] = {.count = 1, .reusable = true}, SHIFT(330),
  [739] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 2),
  [741] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 2),
  [743] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 2),
  [745] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [747] = {.count = 1, .reusable = true}, SHIFT(334),
  [749] = {.count = 1, .reusable = true}, SHIFT(2463),
  [751] = {.count = 1, .reusable = true}, SHIFT(338),
  [753] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 2),
  [755] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 2),
  [757] = {.count = 1, .reusable = true}, SHIFT(340),
  [759] = {.count = 1, .reusable = true}, REDUCE(sym_update_expression, 2),
  [761] = {.count = 1, .reusable = false}, REDUCE(sym_update_expression, 2),
  [763] = {.count = 1, .reusable = false}, SHIFT(1780),
  [765] = {.count = 1, .reusable = true}, SHIFT(1780),
  [767] = {.count = 1, .reusable = true}, REDUCE(sym_yield_expression, 2),
  [769] = {.count = 1, .reusable = true}, SHIFT(342),
  [771] = {.count = 1, .reusable = true}, SHIFT(343),
  [773] = {.count = 1, .reusable = true}, SHIFT(344),
  [775] = {.count = 1, .reusable = true}, SHIFT(347),
  [777] = {.count = 1, .reusable = true}, SHIFT(346),
  [779] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 1),
  [781] = {.count = 1, .reusable = true}, SHIFT(121),
  [783] = {.count = 1, .reusable = true}, SHIFT(348),
  [785] = {.count = 1, .reusable = true}, SHIFT(351),
  [787] = {.count = 1, .reusable = false}, SHIFT(352),
  [789] = {.count = 1, .reusable = true}, SHIFT(353),
  [791] = {.count = 1, .reusable = false}, SHIFT(354),
  [793] = {.count = 1, .reusable = true}, SHIFT(355),
  [795] = {.count = 1, .reusable = true}, SHIFT(357),
  [797] = {.count = 1, .reusable = true}, SHIFT(358),
  [799] = {.count = 1, .reusable = true}, REDUCE(sym__module, 1),
  [801] = {.count = 1, .reusable = false}, REDUCE(sym__module, 1),
  [803] = {.count = 1, .reusable = false}, SHIFT(359),
  [805] = {.count = 1, .reusable = true}, SHIFT(1787),
  [807] = {.count = 1, .reusable = true}, REDUCE(sym_internal_module, 2),
  [809] = {.count = 1, .reusable = false}, REDUCE(sym_internal_module, 2),
  [811] = {.count = 1, .reusable = true}, REDUCE(sym_await_expression, 2),
  [813] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [815] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [817] = {.count = 1, .reusable = true}, SHIFT(362),
  [819] = {.count = 1, .reusable = false}, SHIFT(361),
  [821] = {.count = 1, .reusable = true}, SHIFT(363),
  [823] = {.count = 1, .reusable = false}, SHIFT(364),
  [825] = {.count = 1, .reusable = false}, SHIFT(365),
  [827] = {.count = 1, .reusable = false}, SHIFT(366),
  [829] = {.count = 1, .reusable = false}, SHIFT(370),
  [831] = {.count = 1, .reusable = true}, SHIFT(370),
  [833] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 1),
  [835] = {.count = 1, .reusable = false}, SHIFT(371),
  [837] = {.count = 1, .reusable = true}, SHIFT(371),
  [839] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [841] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [843] = {.count = 1, .reusable = true}, SHIFT(1208),
  [845] = {.count = 1, .reusable = true}, SHIFT(2219),
  [847] = {.count = 1, .reusable = false}, SHIFT(1208),
  [849] = {.count = 1, .reusable = false}, SHIFT(1277),
  [851] = {.count = 1, .reusable = true}, SHIFT(1278),
  [853] = {.count = 1, .reusable = false}, SHIFT(1279),
  [855] = {.count = 1, .reusable = true}, SHIFT(1280),
  [857] = {.count = 1, .reusable = false}, SHIFT(1278),
  [859] = {.count = 1, .reusable = true}, SHIFT(373),
  [861] = {.count = 1, .reusable = false}, SHIFT(1280),
  [863] = {.count = 1, .reusable = true}, SHIFT(2257),
  [865] = {.count = 1, .reusable = true}, SHIFT(1277),
  [867] = {.count = 1, .reusable = true}, SHIFT(1803),
  [869] = {.count = 1, .reusable = true}, SHIFT(1282),
  [871] = {.count = 1, .reusable = false}, SHIFT(1283),
  [873] = {.count = 1, .reusable = true}, SHIFT(1743),
  [875] = {.count = 1, .reusable = true}, SHIFT(1284),
  [877] = {.count = 1, .reusable = false}, SHIFT(1276),
  [879] = {.count = 1, .reusable = false}, REDUCE(sym_module, 2),
  [881] = {.count = 1, .reusable = true}, REDUCE(sym_module, 2),
  [883] = {.count = 1, .reusable = true}, SHIFT(2337),
  [885] = {.count = 1, .reusable = false}, SHIFT(376),
  [887] = {.count = 1, .reusable = false}, SHIFT(377),
  [889] = {.count = 1, .reusable = false}, SHIFT(2329),
  [891] = {.count = 1, .reusable = false}, SHIFT(2332),
  [893] = {.count = 1, .reusable = false}, SHIFT(2330),
  [895] = {.count = 1, .reusable = false}, SHIFT(2331),
  [897] = {.count = 1, .reusable = false}, SHIFT(1955),
  [899] = {.count = 1, .reusable = true}, SHIFT(2333),
  [901] = {.count = 1, .reusable = true}, SHIFT(377),
  [903] = {.count = 1, .reusable = false}, SHIFT(2334),
  [905] = {.count = 1, .reusable = false}, SHIFT(2385),
  [907] = {.count = 1, .reusable = false}, SHIFT(1946),
  [909] = {.count = 1, .reusable = false}, SHIFT(2335),
  [911] = {.count = 1, .reusable = false}, SHIFT(2336),
  [913] = {.count = 1, .reusable = true}, SHIFT(142),
  [915] = {.count = 1, .reusable = true}, SHIFT(143),
  [917] = {.count = 1, .reusable = true}, SHIFT(2005),
  [919] = {.count = 1, .reusable = false}, SHIFT(384),
  [921] = {.count = 1, .reusable = true}, SHIFT(385),
  [923] = {.count = 1, .reusable = true}, SHIFT(386),
  [925] = {.count = 1, .reusable = false}, SHIFT(387),
  [927] = {.count = 1, .reusable = false}, SHIFT(390),
  [929] = {.count = 1, .reusable = false}, SHIFT(388),
  [931] = {.count = 1, .reusable = false}, SHIFT(389),
  [933] = {.count = 1, .reusable = true}, SHIFT(391),
  [935] = {.count = 1, .reusable = true}, SHIFT(2152),
  [937] = {.count = 1, .reusable = true}, SHIFT(395),
  [939] = {.count = 1, .reusable = false}, SHIFT(392),
  [941] = {.count = 1, .reusable = false}, SHIFT(393),
  [943] = {.count = 1, .reusable = true}, SHIFT(2151),
  [945] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 1),
  [947] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_class, 2),
  [949] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_class, 2),
  [951] = {.count = 1, .reusable = true}, SHIFT(1224),
  [953] = {.count = 1, .reusable = true}, SHIFT(401),
  [955] = {.count = 1, .reusable = true}, SHIFT(2100),
  [957] = {.count = 1, .reusable = true}, SHIFT(2235),
  [959] = {.count = 1, .reusable = true}, SHIFT(118),
  [961] = {.count = 1, .reusable = true}, SHIFT(403),
  [963] = {.count = 1, .reusable = true}, SHIFT(256),
  [965] = {.count = 1, .reusable = true}, SHIFT(404),
  [967] = {.count = 1, .reusable = false}, SHIFT(260),
  [969] = {.count = 1, .reusable = true}, SHIFT(405),
  [971] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 2),
  [973] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 2),
  [975] = {.count = 1, .reusable = true}, SHIFT(406),
  [977] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 2), SHIFT(70),
  [980] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 2),
  [983] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1, .production_id = 2),
  [986] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 2),
  [988] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 2),
  [991] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 2),
  [994] = {.count = 1, .reusable = false}, SHIFT(409),
  [996] = {.count = 1, .reusable = false}, SHIFT(410),
  [998] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 1),
  [1000] = {.count = 1, .reusable = false}, SHIFT(411),
  [1002] = {.count = 1, .reusable = false}, SHIFT(412),
  [1004] = {.count = 1, .reusable = false}, SHIFT(413),
  [1006] = {.count = 1, .reusable = false}, SHIFT(1313),
  [1008] = {.count = 1, .reusable = true}, SHIFT(416),
  [1010] = {.count = 1, .reusable = true}, SHIFT(417),
  [1012] = {.count = 1, .reusable = false}, REDUCE(sym_accessibility_modifier, 1),
  [1014] = {.count = 1, .reusable = true}, REDUCE(sym_accessibility_modifier, 1),
  [1016] = {.count = 1, .reusable = false}, SHIFT(418),
  [1018] = {.count = 1, .reusable = false}, SHIFT(421),
  [1020] = {.count = 1, .reusable = true}, SHIFT(420),
  [1022] = {.count = 1, .reusable = false}, SHIFT(419),
  [1024] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(416),
  [1027] = {.count = 1, .reusable = true}, REDUCE(sym_object, 2),
  [1029] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 2),
  [1031] = {.count = 1, .reusable = false}, REDUCE(sym_object, 2),
  [1033] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 2),
  [1035] = {.count = 1, .reusable = false}, SHIFT(422),
  [1037] = {.count = 1, .reusable = true}, SHIFT(422),
  [1039] = {.count = 1, .reusable = false}, SHIFT(424),
  [1041] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(420),
  [1044] = {.count = 1, .reusable = false}, SHIFT(425),
  [1046] = {.count = 1, .reusable = false}, SHIFT(423),
  [1048] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 2), SHIFT(208),
  [1052] = {.count = 3, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym__property_name, 1, .production_id = 2), SHIFT(209),
  [1056] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [1059] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__property_name, 1),
  [1062] = {.count = 1, .reusable = true}, REDUCE(sym__property_name, 1),
  [1064] = {.count = 1, .reusable = false}, SHIFT(426),
  [1066] = {.count = 1, .reusable = true}, SHIFT(427),
  [1068] = {.count = 1, .reusable = true}, SHIFT(429),
  [1070] = {.count = 1, .reusable = true}, SHIFT(430),
  [1072] = {.count = 1, .reusable = true}, SHIFT(431),
  [1074] = {.count = 1, .reusable = false}, SHIFT(283),
  [1076] = {.count = 1, .reusable = false}, SHIFT(1314),
  [1078] = {.count = 1, .reusable = false}, SHIFT(437),
  [1080] = {.count = 1, .reusable = false}, SHIFT(435),
  [1082] = {.count = 1, .reusable = true}, SHIFT(439),
  [1084] = {.count = 1, .reusable = false}, SHIFT(436),
  [1086] = {.count = 1, .reusable = true}, SHIFT(441),
  [1088] = {.count = 1, .reusable = true}, SHIFT(1209),
  [1090] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_required_parameter, 1),
  [1093] = {.count = 1, .reusable = false}, SHIFT(1210),
  [1095] = {.count = 1, .reusable = true}, SHIFT(1207),
  [1097] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(443),
  [1100] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(268),
  [1103] = {.count = 1, .reusable = false}, SHIFT(446),
  [1105] = {.count = 1, .reusable = false}, SHIFT(447),
  [1107] = {.count = 1, .reusable = true}, SHIFT(1214),
  [1109] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_required_parameter, 1, .production_id = 1),
  [1112] = {.count = 1, .reusable = true}, SHIFT(1213),
  [1114] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(451),
  [1117] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), SHIFT(268),
  [1120] = {.count = 1, .reusable = true}, SHIFT(1745),
  [1122] = {.count = 1, .reusable = true}, SHIFT(454),
  [1124] = {.count = 1, .reusable = false}, SHIFT(1220),
  [1126] = {.count = 1, .reusable = false}, SHIFT(1745),
  [1128] = {.count = 1, .reusable = false}, SHIFT(1198),
  [1130] = {.count = 1, .reusable = true}, SHIFT(1220),
  [1132] = {.count = 1, .reusable = false}, SHIFT(1782),
  [1134] = {.count = 1, .reusable = false}, SHIFT(1783),
  [1136] = {.count = 1, .reusable = false}, SHIFT(2261),
  [1138] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 2),
  [1140] = {.count = 1, .reusable = false}, SHIFT(1592),
  [1142] = {.count = 1, .reusable = true}, SHIFT(456),
  [1144] = {.count = 1, .reusable = true}, SHIFT(455),
  [1146] = {.count = 1, .reusable = true}, SHIFT(1281),
  [1148] = {.count = 1, .reusable = true}, SHIFT(458),
  [1150] = {.count = 1, .reusable = false}, SHIFT(460),
  [1152] = {.count = 1, .reusable = false}, SHIFT(463),
  [1154] = {.count = 1, .reusable = false}, SHIFT(462),
  [1156] = {.count = 1, .reusable = false}, SHIFT(1806),
  [1158] = {.count = 1, .reusable = false}, SHIFT(464),
  [1160] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_required_parameter, 1, .production_id = 3),
  [1163] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(469),
  [1166] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_required_parameter, 1, .production_id = 4),
  [1169] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(472),
  [1172] = {.count = 1, .reusable = true}, SHIFT(475),
  [1174] = {.count = 1, .reusable = true}, SHIFT(476),
  [1176] = {.count = 1, .reusable = true}, SHIFT(478),
  [1178] = {.count = 1, .reusable = true}, SHIFT(479),
  [1180] = {.count = 1, .reusable = true}, SHIFT(481),
  [1182] = {.count = 1, .reusable = true}, REDUCE(sym_program, 2),
  [1184] = {.count = 1, .reusable = true}, SHIFT(484),
  [1186] = {.count = 1, .reusable = true}, SHIFT(485),
  [1188] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 2),
  [1190] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 2),
  [1192] = {.count = 1, .reusable = false}, SHIFT(486),
  [1194] = {.count = 1, .reusable = false}, SHIFT(487),
  [1196] = {.count = 1, .reusable = true}, SHIFT(490),
  [1198] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 5), SHIFT(492),
  [1201] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 5),
  [1203] = {.count = 1, .reusable = true}, SHIFT(491),
  [1205] = {.count = 1, .reusable = true}, SHIFT(493),
  [1207] = {.count = 1, .reusable = true}, SHIFT(495),
  [1209] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 5), REDUCE(sym_type_parameter, 1, .production_id = 5),
  [1212] = {.count = 1, .reusable = true}, SHIFT(100),
  [1214] = {.count = 1, .reusable = true}, SHIFT(494),
  [1216] = {.count = 1, .reusable = true}, REDUCE(sym_literal_type, 1),
  [1218] = {.count = 1, .reusable = false}, REDUCE(sym_literal_type, 1),
  [1220] = {.count = 1, .reusable = true}, SHIFT(499),
  [1222] = {.count = 1, .reusable = true}, SHIFT(501),
  [1224] = {.count = 1, .reusable = true}, SHIFT(502),
  [1226] = {.count = 1, .reusable = true}, SHIFT(1250),
  [1228] = {.count = 1, .reusable = false}, SHIFT(503),
  [1230] = {.count = 1, .reusable = false}, SHIFT(505),
  [1232] = {.count = 1, .reusable = true}, SHIFT(506),
  [1234] = {.count = 1, .reusable = false}, SHIFT(504),
  [1236] = {.count = 1, .reusable = true}, SHIFT(511),
  [1238] = {.count = 1, .reusable = false}, SHIFT(507),
  [1240] = {.count = 1, .reusable = false}, SHIFT(508),
  [1242] = {.count = 1, .reusable = false}, SHIFT(509),
  [1244] = {.count = 1, .reusable = true}, REDUCE(sym_predefined_type, 1),
  [1246] = {.count = 1, .reusable = false}, REDUCE(sym_predefined_type, 1),
  [1248] = {.count = 1, .reusable = true}, REDUCE(sym_this_type, 1),
  [1250] = {.count = 1, .reusable = false}, REDUCE(sym_this_type, 1),
  [1252] = {.count = 1, .reusable = true}, SHIFT(516),
  [1254] = {.count = 1, .reusable = true}, SHIFT(517),
  [1256] = {.count = 1, .reusable = true}, REDUCE(sym_existential_type, 1),
  [1258] = {.count = 1, .reusable = false}, REDUCE(sym_existential_type, 1),
  [1260] = {.count = 1, .reusable = true}, SHIFT(518),
  [1262] = {.count = 1, .reusable = false}, SHIFT(523),
  [1264] = {.count = 1, .reusable = false}, SHIFT(524),
  [1266] = {.count = 1, .reusable = false}, SHIFT(526),
  [1268] = {.count = 1, .reusable = true}, SHIFT(522),
  [1270] = {.count = 1, .reusable = false}, SHIFT(525),
  [1272] = {.count = 1, .reusable = true}, SHIFT(530),
  [1274] = {.count = 1, .reusable = true}, SHIFT(529),
  [1276] = {.count = 1, .reusable = true}, SHIFT(531),
  [1278] = {.count = 1, .reusable = true}, SHIFT(532),
  [1280] = {.count = 1, .reusable = true}, REDUCE(sym__primary_type, 1),
  [1282] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(536),
  [1285] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1),
  [1287] = {.count = 1, .reusable = true}, SHIFT(535),
  [1289] = {.count = 1, .reusable = true}, SHIFT(539),
  [1291] = {.count = 1, .reusable = true}, SHIFT(538),
  [1293] = {.count = 1, .reusable = true}, REDUCE(sym__type, 1),
  [1295] = {.count = 1, .reusable = false}, REDUCE(sym__type, 1),
  [1297] = {.count = 1, .reusable = true}, SHIFT(541),
  [1299] = {.count = 1, .reusable = true}, SHIFT(542),
  [1301] = {.count = 1, .reusable = false}, SHIFT(543),
  [1303] = {.count = 1, .reusable = true}, SHIFT(545),
  [1305] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2),
  [1307] = {.count = 1, .reusable = true}, SHIFT(2343),
  [1309] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2),
  [1311] = {.count = 1, .reusable = false}, SHIFT(2344),
  [1313] = {.count = 1, .reusable = true}, SHIFT(549),
  [1315] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 2, .production_id = 6),
  [1317] = {.count = 1, .reusable = true}, SHIFT(2346),
  [1319] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 2, .production_id = 6),
  [1321] = {.count = 1, .reusable = false}, SHIFT(2511),
  [1323] = {.count = 1, .reusable = false}, SHIFT(2350),
  [1325] = {.count = 1, .reusable = false}, SHIFT(2348),
  [1327] = {.count = 1, .reusable = false}, SHIFT(2520),
  [1329] = {.count = 1, .reusable = false}, SHIFT(2347),
  [1331] = {.count = 1, .reusable = false}, SHIFT(2513),
  [1333] = {.count = 1, .reusable = false}, SHIFT(2517),
  [1335] = {.count = 1, .reusable = true}, SHIFT(2350),
  [1337] = {.count = 1, .reusable = true}, SHIFT(2342),
  [1339] = {.count = 1, .reusable = false}, SHIFT(2342),
  [1341] = {.count = 1, .reusable = false}, SHIFT(2359),
  [1343] = {.count = 1, .reusable = true}, SHIFT(2360),
  [1345] = {.count = 1, .reusable = false}, SHIFT(2361),
  [1347] = {.count = 1, .reusable = false}, SHIFT(2360),
  [1349] = {.count = 1, .reusable = true}, SHIFT(2362),
  [1351] = {.count = 1, .reusable = false}, SHIFT(2362),
  [1353] = {.count = 1, .reusable = true}, SHIFT(2396),
  [1355] = {.count = 1, .reusable = true}, SHIFT(2359),
  [1357] = {.count = 1, .reusable = false}, SHIFT(1966),
  [1359] = {.count = 1, .reusable = true}, SHIFT(2363),
  [1361] = {.count = 1, .reusable = true}, SHIFT(553),
  [1363] = {.count = 1, .reusable = true}, SHIFT(554),
  [1365] = {.count = 1, .reusable = false}, SHIFT(556),
  [1367] = {.count = 1, .reusable = false}, SHIFT(2212),
  [1369] = {.count = 1, .reusable = false}, SHIFT(2443),
  [1371] = {.count = 1, .reusable = false}, SHIFT(2445),
  [1373] = {.count = 1, .reusable = false}, SHIFT(2446),
  [1375] = {.count = 1, .reusable = false}, SHIFT(2447),
  [1377] = {.count = 1, .reusable = true}, SHIFT(2448),
  [1379] = {.count = 1, .reusable = false}, SHIFT(2449),
  [1381] = {.count = 1, .reusable = false}, SHIFT(557),
  [1383] = {.count = 1, .reusable = false}, SHIFT(2378),
  [1385] = {.count = 1, .reusable = false}, SHIFT(2451),
  [1387] = {.count = 1, .reusable = true}, SHIFT(2452),
  [1389] = {.count = 1, .reusable = false}, SHIFT(2213),
  [1391] = {.count = 1, .reusable = true}, SHIFT(557),
  [1393] = {.count = 1, .reusable = false}, SHIFT(2455),
  [1395] = {.count = 1, .reusable = true}, SHIFT(558),
  [1397] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 2),
  [1399] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 2),
  [1401] = {.count = 1, .reusable = true}, SHIFT(559),
  [1403] = {.count = 1, .reusable = true}, SHIFT(560),
  [1405] = {.count = 1, .reusable = true}, REDUCE(sym_call_signature, 2),
  [1407] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2),
  [1410] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [1413] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [1416] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [1419] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [1422] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [1425] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [1428] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(9),
  [1431] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [1434] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [1437] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [1440] = {.count = 1, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2),
  [1442] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [1445] = {.count = 1, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2),
  [1447] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [1450] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [1453] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [1456] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [1459] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(18),
  [1462] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(19),
  [1465] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(20),
  [1468] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(59),
  [1471] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(21),
  [1474] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(22),
  [1477] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(23),
  [1480] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(24),
  [1483] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(25),
  [1486] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(26),
  [1489] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(27),
  [1492] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(28),
  [1495] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(29),
  [1498] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(30),
  [1501] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(31),
  [1504] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(32),
  [1507] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(33),
  [1510] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(34),
  [1513] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(35),
  [1516] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(36),
  [1519] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(37),
  [1522] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(38),
  [1525] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(39),
  [1528] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(41),
  [1531] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(42),
  [1534] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(43),
  [1537] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(44),
  [1540] = {.count = 2, .reusable = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(59),
  [1543] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(45),
  [1546] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(46),
  [1549] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(47),
  [1552] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(48),
  [1555] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(49),
  [1558] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(50),
  [1561] = {.count = 2, .reusable = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(51),
  [1564] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2, .production_id = 3),
  [1566] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2, .production_id = 3),
  [1568] = {.count = 1, .reusable = false}, REDUCE(sym_expression_statement, 2),
  [1570] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [1572] = {.count = 1, .reusable = true}, REDUCE(sym_non_null_expression, 2),
  [1574] = {.count = 1, .reusable = false}, REDUCE(sym_non_null_expression, 2),
  [1576] = {.count = 1, .reusable = false}, SHIFT(564),
  [1578] = {.count = 1, .reusable = true}, SHIFT(564),
  [1580] = {.count = 1, .reusable = false}, SHIFT(565),
  [1582] = {.count = 1, .reusable = true}, SHIFT(565),
  [1584] = {.count = 1, .reusable = false}, SHIFT(566),
  [1586] = {.count = 1, .reusable = true}, SHIFT(566),
  [1588] = {.count = 1, .reusable = false}, SHIFT(567),
  [1590] = {.count = 1, .reusable = true}, SHIFT(567),
  [1592] = {.count = 1, .reusable = false}, SHIFT(568),
  [1594] = {.count = 1, .reusable = true}, SHIFT(568),
  [1596] = {.count = 1, .reusable = false}, SHIFT(570),
  [1598] = {.count = 1, .reusable = true}, SHIFT(570),
  [1600] = {.count = 1, .reusable = false}, SHIFT(1304),
  [1602] = {.count = 1, .reusable = false}, SHIFT(1251),
  [1604] = {.count = 1, .reusable = true}, SHIFT(2236),
  [1606] = {.count = 1, .reusable = false}, SHIFT(1254),
  [1608] = {.count = 1, .reusable = false}, SHIFT(1791),
  [1610] = {.count = 1, .reusable = false}, SHIFT(1793),
  [1612] = {.count = 1, .reusable = true}, SHIFT(1792),
  [1614] = {.count = 1, .reusable = true}, SHIFT(1256),
  [1616] = {.count = 1, .reusable = false}, SHIFT(1789),
  [1618] = {.count = 1, .reusable = true}, SHIFT(1257),
  [1620] = {.count = 1, .reusable = true}, SHIFT(2239),
  [1622] = {.count = 1, .reusable = true}, SHIFT(1789),
  [1624] = {.count = 1, .reusable = true}, SHIFT(1253),
  [1626] = {.count = 1, .reusable = true}, SHIFT(1252),
  [1628] = {.count = 1, .reusable = false}, SHIFT(1255),
  [1630] = {.count = 1, .reusable = true}, SHIFT(1251),
  [1632] = {.count = 1, .reusable = false}, SHIFT(2238),
  [1634] = {.count = 1, .reusable = false}, SHIFT(573),
  [1636] = {.count = 1, .reusable = false}, SHIFT(575),
  [1638] = {.count = 1, .reusable = false}, SHIFT(577),
  [1640] = {.count = 1, .reusable = false}, SHIFT(578),
  [1642] = {.count = 1, .reusable = false}, SHIFT(1343),
  [1644] = {.count = 1, .reusable = false}, SHIFT(574),
  [1646] = {.count = 1, .reusable = true}, SHIFT(1341),
  [1648] = {.count = 1, .reusable = false}, SHIFT(576),
  [1650] = {.count = 1, .reusable = false}, SHIFT(1851),
  [1652] = {.count = 1, .reusable = true}, SHIFT(579),
  [1654] = {.count = 1, .reusable = true}, SHIFT(574),
  [1656] = {.count = 1, .reusable = false}, SHIFT(580),
  [1658] = {.count = 1, .reusable = false}, SHIFT(583),
  [1660] = {.count = 1, .reusable = true}, SHIFT(583),
  [1662] = {.count = 1, .reusable = true}, SHIFT(584),
  [1664] = {.count = 1, .reusable = false}, SHIFT(585),
  [1666] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2),
  [1668] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2), SHIFT_REPEAT(6),
  [1671] = {.count = 1, .reusable = true}, REDUCE(sym_type_assertion, 2),
  [1673] = {.count = 1, .reusable = false}, REDUCE(sym_type_assertion, 2),
  [1675] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_expression, 2, .production_id = 4),
  [1677] = {.count = 1, .reusable = false}, REDUCE(sym_assignment_expression, 2, .production_id = 4),
  [1679] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3),
  [1681] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3),
  [1683] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [1685] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [1687] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3),
  [1689] = {.count = 1, .reusable = true}, REDUCE(sym__initializer, 2),
  [1691] = {.count = 1, .reusable = false}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 7),
  [1693] = {.count = 1, .reusable = true}, REDUCE(sym_labeled_statement, 3, .dynamic_precedence = -1, .production_id = 7),
  [1695] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 8),
  [1697] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 8),
  [1699] = {.count = 1, .reusable = true}, SHIFT(587),
  [1701] = {.count = 1, .reusable = true}, REDUCE(sym_template_string, 3),
  [1703] = {.count = 1, .reusable = false}, REDUCE(sym_template_string, 3),
  [1705] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(73),
  [1708] = {.count = 2, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2), SHIFT_REPEAT(297),
  [1711] = {.count = 1, .reusable = true}, REDUCE(aux_sym_template_string_repeat1, 2),
  [1713] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 3, .production_id = 1),
  [1715] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 3, .production_id = 1),
  [1717] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 1),
  [1719] = {.count = 1, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 9),
  [1721] = {.count = 1, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 9),
  [1723] = {.count = 1, .reusable = true}, SHIFT(588),
  [1725] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_call_expression, 2),
  [1727] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_call_expression, 2),
  [1729] = {.count = 1, .reusable = true}, SHIFT(1210),
  [1731] = {.count = 1, .reusable = true}, SHIFT(592),
  [1733] = {.count = 1, .reusable = false}, REDUCE(sym_break_statement, 3, .production_id = 10),
  [1735] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 3, .production_id = 10),
  [1737] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2),
  [1739] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 3),
  [1741] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 3),
  [1743] = {.count = 1, .reusable = true}, SHIFT(596),
  [1745] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 4),
  [1747] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 2, .production_id = 3),
  [1749] = {.count = 1, .reusable = true}, SHIFT(600),
  [1751] = {.count = 1, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 5),
  [1753] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 2),
  [1755] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 2),
  [1757] = {.count = 1, .reusable = true}, SHIFT(601),
  [1759] = {.count = 1, .reusable = true}, REDUCE(sym_call_expression, 3),
  [1761] = {.count = 1, .reusable = false}, REDUCE(sym_call_expression, 3),
  [1763] = {.count = 1, .reusable = false}, REDUCE(sym_return_statement, 3),
  [1765] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 3),
  [1767] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 3, .production_id = 11),
  [1769] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 3, .production_id = 11),
  [1771] = {.count = 1, .reusable = true}, SHIFT(605),
  [1773] = {.count = 1, .reusable = true}, SHIFT(606),
  [1775] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 3),
  [1777] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 3),
  [1779] = {.count = 1, .reusable = false}, REDUCE(sym_continue_statement, 3, .production_id = 10),
  [1781] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 3, .production_id = 10),
  [1783] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 3),
  [1785] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 3),
  [1787] = {.count = 1, .reusable = false}, SHIFT(608),
  [1789] = {.count = 1, .reusable = false}, REDUCE(sym_throw_statement, 3),
  [1791] = {.count = 1, .reusable = true}, REDUCE(sym_throw_statement, 3),
  [1793] = {.count = 1, .reusable = true}, SHIFT(2101),
  [1795] = {.count = 1, .reusable = false}, SHIFT(1502),
  [1797] = {.count = 1, .reusable = false}, SHIFT(1488),
  [1799] = {.count = 1, .reusable = true}, SHIFT(2389),
  [1801] = {.count = 1, .reusable = false}, SHIFT(1491),
  [1803] = {.count = 1, .reusable = false}, SHIFT(2016),
  [1805] = {.count = 1, .reusable = false}, SHIFT(2018),
  [1807] = {.count = 1, .reusable = true}, SHIFT(2017),
  [1809] = {.count = 1, .reusable = true}, SHIFT(1493),
  [1811] = {.count = 1, .reusable = false}, SHIFT(2015),
  [1813] = {.count = 1, .reusable = true}, SHIFT(1494),
  [1815] = {.count = 1, .reusable = true}, SHIFT(2391),
  [1817] = {.count = 1, .reusable = true}, SHIFT(2015),
  [1819] = {.count = 1, .reusable = true}, SHIFT(1490),
  [1821] = {.count = 1, .reusable = true}, SHIFT(1489),
  [1823] = {.count = 1, .reusable = false}, SHIFT(1492),
  [1825] = {.count = 1, .reusable = true}, SHIFT(1488),
  [1827] = {.count = 1, .reusable = false}, SHIFT(2390),
  [1829] = {.count = 1, .reusable = true}, SHIFT(613),
  [1831] = {.count = 1, .reusable = false}, SHIFT(616),
  [1833] = {.count = 1, .reusable = false}, SHIFT(615),
  [1835] = {.count = 1, .reusable = true}, SHIFT(617),
  [1837] = {.count = 1, .reusable = true}, SHIFT(618),
  [1839] = {.count = 1, .reusable = true}, SHIFT(620),
  [1841] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 1),
  [1843] = {.count = 1, .reusable = true}, SHIFT(621),
  [1845] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 2),
  [1847] = {.count = 1, .reusable = true}, SHIFT(622),
  [1849] = {.count = 1, .reusable = true}, SHIFT(623),
  [1851] = {.count = 1, .reusable = true}, SHIFT(624),
  [1853] = {.count = 1, .reusable = true}, SHIFT(625),
  [1855] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 3),
  [1857] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 3),
  [1859] = {.count = 1, .reusable = true}, SHIFT(628),
  [1861] = {.count = 1, .reusable = true}, REDUCE(sym__module, 2),
  [1863] = {.count = 1, .reusable = false}, REDUCE(sym__module, 2),
  [1865] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1867] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1869] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(362),
  [1872] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [1874] = {.count = 1, .reusable = false}, SHIFT(630),
  [1876] = {.count = 1, .reusable = false}, SHIFT(629),
  [1878] = {.count = 1, .reusable = true}, SHIFT(634),
  [1880] = {.count = 1, .reusable = false}, SHIFT(633),
  [1882] = {.count = 1, .reusable = true}, SHIFT(635),
  [1884] = {.count = 1, .reusable = true}, SHIFT(1994),
  [1886] = {.count = 1, .reusable = true}, SHIFT(1998),
  [1888] = {.count = 1, .reusable = true}, SHIFT(639),
  [1890] = {.count = 1, .reusable = false}, SHIFT(640),
  [1892] = {.count = 1, .reusable = true}, SHIFT(641),
  [1894] = {.count = 1, .reusable = false}, SHIFT(642),
  [1896] = {.count = 1, .reusable = true}, REDUCE(sym_spread_element, 2),
  [1898] = {.count = 1, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2),
  [1900] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [1902] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [1904] = {.count = 1, .reusable = true}, SHIFT(643),
  [1906] = {.count = 2, .reusable = true}, REDUCE(aux_sym_array_repeat1, 2), SHIFT_REPEAT(136),
  [1909] = {.count = 1, .reusable = true}, SHIFT(1950),
  [1911] = {.count = 1, .reusable = true}, REDUCE(sym__type_reference, 1, .production_id = 5),
  [1913] = {.count = 1, .reusable = false}, SHIFT(1951),
  [1915] = {.count = 1, .reusable = true}, SHIFT(1948),
  [1917] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(100),
  [1920] = {.count = 1, .reusable = true}, SHIFT(644),
  [1922] = {.count = 1, .reusable = false}, SHIFT(1949),
  [1924] = {.count = 1, .reusable = true}, SHIFT(1949),
  [1926] = {.count = 1, .reusable = false}, SHIFT(1962),
  [1928] = {.count = 1, .reusable = true}, SHIFT(1963),
  [1930] = {.count = 1, .reusable = true}, SHIFT(645),
  [1932] = {.count = 1, .reusable = false}, SHIFT(1964),
  [1934] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 2),
  [1936] = {.count = 1, .reusable = true}, SHIFT(1965),
  [1938] = {.count = 1, .reusable = false}, SHIFT(1963),
  [1940] = {.count = 1, .reusable = false}, SHIFT(1965),
  [1942] = {.count = 1, .reusable = true}, SHIFT(2427),
  [1944] = {.count = 1, .reusable = true}, SHIFT(1962),
  [1946] = {.count = 1, .reusable = false}, SHIFT(2079),
  [1948] = {.count = 1, .reusable = true}, SHIFT(1967),
  [1950] = {.count = 1, .reusable = true}, REDUCE(sym__type_reference, 1),
  [1952] = {.count = 1, .reusable = false}, REDUCE(sym__type_reference, 1),
  [1954] = {.count = 1, .reusable = true}, SHIFT(647),
  [1956] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 2),
  [1958] = {.count = 1, .reusable = true}, REDUCE(sym_class, 3, .production_id = 11),
  [1960] = {.count = 1, .reusable = false}, REDUCE(sym_class, 3, .production_id = 11),
  [1962] = {.count = 1, .reusable = false}, SHIFT(651),
  [1964] = {.count = 1, .reusable = false}, SHIFT(652),
  [1966] = {.count = 1, .reusable = false}, SHIFT(653),
  [1968] = {.count = 1, .reusable = false}, SHIFT(656),
  [1970] = {.count = 1, .reusable = false}, SHIFT(655),
  [1972] = {.count = 1, .reusable = false}, SHIFT(654),
  [1974] = {.count = 1, .reusable = true}, SHIFT(656),
  [1976] = {.count = 1, .reusable = true}, SHIFT(659),
  [1978] = {.count = 1, .reusable = true}, SHIFT(661),
  [1980] = {.count = 1, .reusable = false}, SHIFT(660),
  [1982] = {.count = 1, .reusable = false}, SHIFT(1387),
  [1984] = {.count = 1, .reusable = true}, SHIFT(2270),
  [1986] = {.count = 1, .reusable = false}, SHIFT(663),
  [1988] = {.count = 1, .reusable = true}, SHIFT(664),
  [1990] = {.count = 1, .reusable = false}, SHIFT(662),
  [1992] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 2),
  [1994] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 2),
  [1996] = {.count = 1, .reusable = false}, SHIFT(665),
  [1998] = {.count = 1, .reusable = true}, SHIFT(668),
  [2000] = {.count = 1, .reusable = true}, SHIFT(667),
  [2002] = {.count = 1, .reusable = false}, SHIFT(666),
  [2004] = {.count = 1, .reusable = true}, SHIFT(669),
  [2006] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 1),
  [2008] = {.count = 1, .reusable = true}, SHIFT(670),
  [2010] = {.count = 1, .reusable = true}, SHIFT(671),
  [2012] = {.count = 1, .reusable = false}, SHIFT(677),
  [2014] = {.count = 1, .reusable = false}, SHIFT(676),
  [2016] = {.count = 1, .reusable = false}, SHIFT(675),
  [2018] = {.count = 1, .reusable = true}, SHIFT(678),
  [2020] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 1),
  [2022] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 1),
  [2024] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_class, 3),
  [2026] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_class, 3),
  [2028] = {.count = 1, .reusable = true}, REDUCE(sym_class_heritage, 2),
  [2030] = {.count = 1, .reusable = true}, SHIFT(680),
  [2032] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 3),
  [2034] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 3),
  [2036] = {.count = 1, .reusable = true}, SHIFT(681),
  [2038] = {.count = 1, .reusable = true}, SHIFT(552),
  [2040] = {.count = 1, .reusable = true}, SHIFT(2129),
  [2042] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3, .production_id = 12),
  [2044] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3, .production_id = 12),
  [2046] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .production_id = 13), REDUCE(sym_assignment_expression, 2),
  [2049] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .production_id = 13),
  [2051] = {.count = 1, .reusable = true}, SHIFT(682),
  [2053] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2, .production_id = 12),
  [2055] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2),
  [2057] = {.count = 1, .reusable = false}, SHIFT(1882),
  [2059] = {.count = 1, .reusable = true}, SHIFT(1882),
  [2061] = {.count = 1, .reusable = true}, SHIFT(684),
  [2063] = {.count = 1, .reusable = true}, SHIFT(686),
  [2065] = {.count = 1, .reusable = false}, SHIFT(687),
  [2067] = {.count = 1, .reusable = true}, SHIFT(688),
  [2069] = {.count = 1, .reusable = false}, SHIFT(689),
  [2071] = {.count = 1, .reusable = true}, SHIFT(690),
  [2073] = {.count = 1, .reusable = false}, SHIFT(691),
  [2075] = {.count = 1, .reusable = true}, REDUCE(sym_object, 3),
  [2077] = {.count = 1, .reusable = false}, REDUCE(sym_object, 3),
  [2079] = {.count = 1, .reusable = true}, SHIFT(692),
  [2081] = {.count = 1, .reusable = true}, REDUCE(sym_statement_block, 3),
  [2083] = {.count = 1, .reusable = false}, REDUCE(sym_statement_block, 3),
  [2085] = {.count = 1, .reusable = false}, SHIFT(693),
  [2087] = {.count = 1, .reusable = true}, SHIFT(693),
  [2089] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .production_id = 3), REDUCE(sym_assignment_expression, 2, .production_id = 3),
  [2092] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .production_id = 3),
  [2094] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_repeat1, 2), SHIFT_REPEAT(163),
  [2097] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .production_id = 4), REDUCE(sym_assignment_expression, 2, .production_id = 4),
  [2100] = {.count = 1, .reusable = true}, REDUCE(sym_assignment_pattern, 2, .production_id = 4),
  [2102] = {.count = 1, .reusable = true}, SHIFT(697),
  [2104] = {.count = 1, .reusable = true}, SHIFT(698),
  [2106] = {.count = 1, .reusable = true}, SHIFT(696),
  [2108] = {.count = 1, .reusable = false}, REDUCE(sym_switch_statement, 3),
  [2110] = {.count = 1, .reusable = true}, REDUCE(sym_switch_statement, 3),
  [2112] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2),
  [2114] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_expression, 2), REDUCE(sym_required_parameter, 2),
  [2117] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2),
  [2119] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .production_id = 6),
  [2121] = {.count = 1, .reusable = true}, SHIFT(703),
  [2123] = {.count = 1, .reusable = true}, SHIFT(706),
  [2125] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .production_id = 14),
  [2127] = {.count = 1, .reusable = true}, SHIFT(708),
  [2129] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .production_id = 15),
  [2131] = {.count = 1, .reusable = true}, SHIFT(711),
  [2133] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2, .production_id = 1),
  [2135] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_expression, 2, .production_id = 1), REDUCE(sym_required_parameter, 2, .production_id = 1),
  [2138] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .production_id = 1),
  [2140] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 2),
  [2142] = {.count = 1, .reusable = true}, SHIFT(718),
  [2144] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 3),
  [2146] = {.count = 1, .reusable = true}, SHIFT(721),
  [2148] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [2150] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [2152] = {.count = 1, .reusable = true}, SHIFT(723),
  [2154] = {.count = 1, .reusable = false}, SHIFT(724),
  [2156] = {.count = 1, .reusable = false}, SHIFT(725),
  [2158] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1, .production_id = 1),
  [2160] = {.count = 1, .reusable = true}, SHIFT(451),
  [2162] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1),
  [2164] = {.count = 1, .reusable = true}, SHIFT(443),
  [2166] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1, .production_id = 3),
  [2168] = {.count = 1, .reusable = true}, SHIFT(469),
  [2170] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 1, .production_id = 4),
  [2172] = {.count = 1, .reusable = true}, SHIFT(472),
  [2174] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2, .production_id = 3),
  [2176] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_expression, 2, .production_id = 3), REDUCE(sym_required_parameter, 2, .production_id = 3),
  [2179] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .production_id = 3),
  [2181] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 2, .production_id = 4),
  [2183] = {.count = 2, .reusable = true}, REDUCE(sym_assignment_expression, 2, .production_id = 4), REDUCE(sym_required_parameter, 2, .production_id = 4),
  [2186] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 2, .production_id = 4),
  [2188] = {.count = 1, .reusable = false}, SHIFT(740),
  [2190] = {.count = 1, .reusable = true}, SHIFT(740),
  [2192] = {.count = 1, .reusable = false}, SHIFT(742),
  [2194] = {.count = 1, .reusable = true}, SHIFT(742),
  [2196] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 1, .production_id = 5),
  [2198] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 3),
  [2200] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 3),
  [2202] = {.count = 1, .reusable = true}, SHIFT(745),
  [2204] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [2206] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [2208] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat2, 2), SHIFT_REPEAT(484),
  [2211] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat2, 2),
  [2213] = {.count = 1, .reusable = true}, SHIFT(746),
  [2215] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 3),
  [2217] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 3),
  [2219] = {.count = 1, .reusable = true}, SHIFT(753),
  [2221] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 2, .production_id = 5),
  [2223] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2, .production_id = 5),
  [2225] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2, .production_id = 5),
  [2227] = {.count = 1, .reusable = true}, REDUCE(sym_flow_maybe_type, 2),
  [2229] = {.count = 1, .reusable = false}, REDUCE(sym_flow_maybe_type, 2),
  [2231] = {.count = 1, .reusable = true}, SHIFT(758),
  [2233] = {.count = 1, .reusable = false}, SHIFT(759),
  [2235] = {.count = 1, .reusable = false}, SHIFT(762),
  [2237] = {.count = 1, .reusable = true}, SHIFT(763),
  [2239] = {.count = 1, .reusable = true}, SHIFT(761),
  [2241] = {.count = 1, .reusable = false}, SHIFT(760),
  [2243] = {.count = 1, .reusable = false}, SHIFT(1404),
  [2245] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 2),
  [2247] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 2),
  [2249] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2251] = {.count = 1, .reusable = true}, SHIFT(1760),
  [2253] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2255] = {.count = 1, .reusable = true}, SHIFT(2251),
  [2257] = {.count = 1, .reusable = true}, SHIFT(2268),
  [2259] = {.count = 1, .reusable = true}, SHIFT(2189),
  [2261] = {.count = 1, .reusable = true}, SHIFT(2585),
  [2263] = {.count = 1, .reusable = true}, SHIFT(2197),
  [2265] = {.count = 1, .reusable = true}, SHIFT(2190),
  [2267] = {.count = 1, .reusable = true}, SHIFT(2252),
  [2269] = {.count = 1, .reusable = true}, SHIFT(2191),
  [2271] = {.count = 1, .reusable = false}, SHIFT(2471),
  [2273] = {.count = 1, .reusable = true}, SHIFT(2454),
  [2275] = {.count = 1, .reusable = true}, SHIFT(2450),
  [2277] = {.count = 1, .reusable = true}, SHIFT(2465),
  [2279] = {.count = 1, .reusable = true}, SHIFT(2201),
  [2281] = {.count = 1, .reusable = true}, SHIFT(2466),
  [2283] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2285] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2287] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2289] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 1),
  [2291] = {.count = 1, .reusable = true}, SHIFT(766),
  [2293] = {.count = 1, .reusable = false}, SHIFT(769),
  [2295] = {.count = 1, .reusable = true}, SHIFT(770),
  [2297] = {.count = 1, .reusable = true}, SHIFT(771),
  [2299] = {.count = 1, .reusable = true}, SHIFT(773),
  [2301] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 2),
  [2303] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 2),
  [2305] = {.count = 1, .reusable = true}, REDUCE(sym_type_query, 2),
  [2307] = {.count = 1, .reusable = false}, REDUCE(sym_type_query, 2),
  [2309] = {.count = 1, .reusable = false}, SHIFT(1829),
  [2311] = {.count = 1, .reusable = true}, REDUCE(sym__number, 2),
  [2313] = {.count = 1, .reusable = false}, REDUCE(sym__number, 2),
  [2315] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2, .production_id = 11),
  [2317] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2, .production_id = 11),
  [2319] = {.count = 1, .reusable = true}, REDUCE(sym_index_type_query, 2),
  [2321] = {.count = 1, .reusable = false}, REDUCE(sym_index_type_query, 2),
  [2323] = {.count = 1, .reusable = true}, SHIFT(775),
  [2325] = {.count = 1, .reusable = false}, SHIFT(1534),
  [2327] = {.count = 1, .reusable = false}, SHIFT(1536),
  [2329] = {.count = 1, .reusable = false}, SHIFT(1983),
  [2331] = {.count = 1, .reusable = false}, SHIFT(1537),
  [2333] = {.count = 1, .reusable = false}, SHIFT(1622),
  [2335] = {.count = 1, .reusable = false}, SHIFT(1535),
  [2337] = {.count = 1, .reusable = false}, SHIFT(1982),
  [2339] = {.count = 1, .reusable = false}, SHIFT(2046),
  [2341] = {.count = 1, .reusable = true}, SHIFT(1866),
  [2343] = {.count = 1, .reusable = true}, SHIFT(1230),
  [2345] = {.count = 1, .reusable = false}, SHIFT(1754),
  [2347] = {.count = 1, .reusable = true}, SHIFT(1535),
  [2349] = {.count = 1, .reusable = false}, SHIFT(1374),
  [2351] = {.count = 2, .reusable = true}, REDUCE(sym_required_parameter, 1), REDUCE(sym__primary_type, 1, .production_id = 5),
  [2354] = {.count = 2, .reusable = true}, REDUCE(sym_required_parameter, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2357] = {.count = 1, .reusable = false}, SHIFT(1299),
  [2359] = {.count = 1, .reusable = true}, SHIFT(777),
  [2361] = {.count = 1, .reusable = false}, SHIFT(1300),
  [2363] = {.count = 1, .reusable = true}, SHIFT(778),
  [2365] = {.count = 1, .reusable = true}, SHIFT(2475),
  [2367] = {.count = 1, .reusable = false}, SHIFT(1301),
  [2369] = {.count = 1, .reusable = false}, SHIFT(781),
  [2371] = {.count = 1, .reusable = false}, SHIFT(779),
  [2373] = {.count = 1, .reusable = false}, SHIFT(780),
  [2375] = {.count = 1, .reusable = true}, SHIFT(782),
  [2377] = {.count = 1, .reusable = true}, SHIFT(786),
  [2379] = {.count = 1, .reusable = false}, SHIFT(783),
  [2381] = {.count = 1, .reusable = false}, SHIFT(784),
  [2383] = {.count = 2, .reusable = true}, REDUCE(sym_this, 1), REDUCE(sym_this_type, 1),
  [2386] = {.count = 1, .reusable = true}, SHIFT(788),
  [2388] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 2),
  [2390] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 2),
  [2392] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 3),
  [2394] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 3),
  [2396] = {.count = 1, .reusable = true}, SHIFT(791),
  [2398] = {.count = 1, .reusable = true}, SHIFT(793),
  [2400] = {.count = 1, .reusable = true}, SHIFT(795),
  [2402] = {.count = 1, .reusable = true}, REDUCE(sym_generic_type, 2),
  [2404] = {.count = 1, .reusable = false}, REDUCE(sym_generic_type, 2),
  [2406] = {.count = 1, .reusable = true}, SHIFT(798),
  [2408] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 3),
  [2410] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 3),
  [2412] = {.count = 1, .reusable = true}, SHIFT(800),
  [2414] = {.count = 1, .reusable = true}, SHIFT(802),
  [2416] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3),
  [2418] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3),
  [2420] = {.count = 1, .reusable = false}, SHIFT(804),
  [2422] = {.count = 1, .reusable = true}, SHIFT(805),
  [2424] = {.count = 1, .reusable = true}, REDUCE(sym_function, 3),
  [2426] = {.count = 1, .reusable = false}, REDUCE(sym_function, 3),
  [2428] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3),
  [2430] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3),
  [2432] = {.count = 1, .reusable = true}, REDUCE(sym_meta_property, 3),
  [2434] = {.count = 1, .reusable = false}, REDUCE(sym_meta_property, 3),
  [2436] = {.count = 1, .reusable = true}, REDUCE(sym_new_expression, 3, .production_id = 6),
  [2438] = {.count = 1, .reusable = false}, REDUCE(sym_new_expression, 3, .production_id = 6),
  [2440] = {.count = 1, .reusable = true}, SHIFT(811),
  [2442] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 2),
  [2444] = {.count = 1, .reusable = true}, SHIFT(812),
  [2446] = {.count = 1, .reusable = true}, SHIFT(813),
  [2448] = {.count = 1, .reusable = true}, SHIFT(814),
  [2450] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), SHIFT(811),
  [2453] = {.count = 1, .reusable = true}, SHIFT(2206),
  [2455] = {.count = 1, .reusable = false}, SHIFT(2206),
  [2457] = {.count = 1, .reusable = false}, SHIFT(2253),
  [2459] = {.count = 1, .reusable = true}, SHIFT(2254),
  [2461] = {.count = 1, .reusable = false}, SHIFT(2255),
  [2463] = {.count = 1, .reusable = false}, SHIFT(2254),
  [2465] = {.count = 1, .reusable = true}, SHIFT(2256),
  [2467] = {.count = 1, .reusable = false}, SHIFT(2256),
  [2469] = {.count = 1, .reusable = true}, SHIFT(2588),
  [2471] = {.count = 1, .reusable = true}, SHIFT(2253),
  [2473] = {.count = 1, .reusable = false}, SHIFT(1804),
  [2475] = {.count = 1, .reusable = true}, SHIFT(2258),
  [2477] = {.count = 1, .reusable = true}, SHIFT(816),
  [2479] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 3),
  [2481] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 3),
  [2483] = {.count = 1, .reusable = true}, SHIFT(2221),
  [2485] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 3),
  [2487] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 3),
  [2489] = {.count = 1, .reusable = true}, REDUCE(sym_call_signature, 3),
  [2491] = {.count = 1, .reusable = true}, REDUCE(sym_type_annotation, 2),
  [2493] = {.count = 1, .reusable = false}, REDUCE(sym_type_annotation, 2),
  [2495] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(280),
  [2498] = {.count = 1, .reusable = true}, REDUCE(sym_sequence_expression, 3),
  [2500] = {.count = 1, .reusable = true}, SHIFT(818),
  [2502] = {.count = 1, .reusable = true}, REDUCE(sym_as_expression, 3),
  [2504] = {.count = 1, .reusable = false}, REDUCE(sym_as_expression, 3),
  [2506] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 5),
  [2509] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 5),
  [2512] = {.count = 1, .reusable = true}, SHIFT(1879),
  [2514] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 5), SHIFT(492),
  [2518] = {.count = 1, .reusable = false}, SHIFT(819),
  [2520] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [2523] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_literal_type, 1),
  [2526] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2529] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [2532] = {.count = 1, .reusable = false}, SHIFT(820),
  [2534] = {.count = 1, .reusable = true}, SHIFT(821),
  [2536] = {.count = 1, .reusable = false}, SHIFT(822),
  [2538] = {.count = 1, .reusable = false}, SHIFT(823),
  [2540] = {.count = 1, .reusable = false}, SHIFT(2091),
  [2542] = {.count = 1, .reusable = false}, SHIFT(824),
  [2544] = {.count = 1, .reusable = false}, SHIFT(1712),
  [2546] = {.count = 1, .reusable = false}, SHIFT(1691),
  [2548] = {.count = 1, .reusable = false}, SHIFT(2090),
  [2550] = {.count = 1, .reusable = true}, SHIFT(1691),
  [2552] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(542),
  [2555] = {.count = 1, .reusable = false}, SHIFT(828),
  [2557] = {.count = 1, .reusable = true}, SHIFT(828),
  [2559] = {.count = 1, .reusable = true}, REDUCE(sym_template_substitution, 3),
  [2561] = {.count = 1, .reusable = true}, REDUCE(sym_decorator_member_expression, 3, .production_id = 8),
  [2563] = {.count = 1, .reusable = false}, REDUCE(sym_decorator_member_expression, 3, .production_id = 8),
  [2565] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3),
  [2567] = {.count = 1, .reusable = false}, REDUCE(sym_enum_declaration, 4),
  [2569] = {.count = 1, .reusable = true}, REDUCE(sym_enum_declaration, 4),
  [2571] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [2573] = {.count = 1, .reusable = false}, REDUCE(sym_lexical_declaration, 4),
  [2575] = {.count = 1, .reusable = true}, REDUCE(sym_lexical_declaration, 4),
  [2577] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(319),
  [2580] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 4),
  [2582] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declarator, 3, .production_id = 3),
  [2584] = {.count = 1, .reusable = true}, REDUCE(sym_subscript_expression, 4),
  [2586] = {.count = 1, .reusable = false}, REDUCE(sym_subscript_expression, 4),
  [2588] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 3),
  [2590] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 3),
  [2592] = {.count = 1, .reusable = true}, SHIFT(834),
  [2594] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 4, .production_id = 11),
  [2596] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 4, .production_id = 11),
  [2598] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 2),
  [2600] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 2),
  [2602] = {.count = 1, .reusable = true}, REDUCE(sym__enum_member, 1),
  [2604] = {.count = 1, .reusable = true}, SHIFT(838),
  [2606] = {.count = 1, .reusable = true}, SHIFT(837),
  [2608] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class, 4, .production_id = 16),
  [2610] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class, 4, .production_id = 16),
  [2612] = {.count = 1, .reusable = true}, SHIFT(843),
  [2614] = {.count = 1, .reusable = true}, SHIFT(1527),
  [2616] = {.count = 1, .reusable = true}, SHIFT(1528),
  [2618] = {.count = 1, .reusable = true}, REDUCE(sym_import_clause, 3),
  [2620] = {.count = 1, .reusable = true}, SHIFT(845),
  [2622] = {.count = 1, .reusable = true}, SHIFT(846),
  [2624] = {.count = 1, .reusable = true}, SHIFT(359),
  [2626] = {.count = 1, .reusable = true}, SHIFT(615),
  [2628] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 4),
  [2630] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 4),
  [2632] = {.count = 1, .reusable = true}, SHIFT(847),
  [2634] = {.count = 1, .reusable = true}, REDUCE(sym_namespace_import, 3),
  [2636] = {.count = 1, .reusable = true}, SHIFT(848),
  [2638] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 2),
  [2640] = {.count = 1, .reusable = true}, SHIFT(849),
  [2642] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3),
  [2644] = {.count = 1, .reusable = true}, SHIFT(850),
  [2646] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 3, .production_id = 17),
  [2648] = {.count = 1, .reusable = true}, SHIFT(852),
  [2650] = {.count = 1, .reusable = true}, REDUCE(sym__from_clause, 2),
  [2652] = {.count = 1, .reusable = true}, REDUCE(sym_nested_identifier, 3),
  [2654] = {.count = 1, .reusable = false}, REDUCE(sym_nested_identifier, 3),
  [2656] = {.count = 1, .reusable = true}, SHIFT(854),
  [2658] = {.count = 1, .reusable = true}, SHIFT(857),
  [2660] = {.count = 1, .reusable = true}, SHIFT(858),
  [2662] = {.count = 1, .reusable = true}, SHIFT(859),
  [2664] = {.count = 1, .reusable = false}, SHIFT(860),
  [2666] = {.count = 1, .reusable = true}, SHIFT(860),
  [2668] = {.count = 1, .reusable = false}, SHIFT(862),
  [2670] = {.count = 1, .reusable = true}, SHIFT(862),
  [2672] = {.count = 1, .reusable = true}, SHIFT(863),
  [2674] = {.count = 1, .reusable = true}, SHIFT(864),
  [2676] = {.count = 1, .reusable = true}, SHIFT(865),
  [2678] = {.count = 1, .reusable = false}, SHIFT(867),
  [2680] = {.count = 1, .reusable = true}, SHIFT(866),
  [2682] = {.count = 1, .reusable = true}, SHIFT(867),
  [2684] = {.count = 1, .reusable = false}, SHIFT(869),
  [2686] = {.count = 1, .reusable = true}, SHIFT(869),
  [2688] = {.count = 1, .reusable = false}, SHIFT(870),
  [2690] = {.count = 1, .reusable = true}, SHIFT(870),
  [2692] = {.count = 1, .reusable = false}, SHIFT(872),
  [2694] = {.count = 1, .reusable = true}, SHIFT(872),
  [2696] = {.count = 1, .reusable = false}, SHIFT(873),
  [2698] = {.count = 1, .reusable = true}, SHIFT(873),
  [2700] = {.count = 1, .reusable = true}, REDUCE(sym_array, 4),
  [2702] = {.count = 1, .reusable = false}, REDUCE(sym_array, 4),
  [2704] = {.count = 1, .reusable = true}, SHIFT(875),
  [2706] = {.count = 1, .reusable = false}, SHIFT(876),
  [2708] = {.count = 1, .reusable = true}, SHIFT(876),
  [2710] = {.count = 1, .reusable = true}, REDUCE(sym_extends_clause, 3),
  [2712] = {.count = 1, .reusable = true}, REDUCE(sym_implements_clause, 3),
  [2714] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 11),
  [2716] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 11),
  [2718] = {.count = 1, .reusable = true}, SHIFT(880),
  [2720] = {.count = 1, .reusable = true}, SHIFT(2130),
  [2722] = {.count = 1, .reusable = true}, SHIFT(2341),
  [2724] = {.count = 1, .reusable = false}, SHIFT(1566),
  [2726] = {.count = 1, .reusable = true}, SHIFT(881),
  [2728] = {.count = 1, .reusable = true}, SHIFT(2345),
  [2730] = {.count = 1, .reusable = false}, SHIFT(2519),
  [2732] = {.count = 1, .reusable = false}, SHIFT(2380),
  [2734] = {.count = 1, .reusable = false}, SHIFT(2381),
  [2736] = {.count = 1, .reusable = true}, SHIFT(882),
  [2738] = {.count = 1, .reusable = true}, SHIFT(883),
  [2740] = {.count = 1, .reusable = true}, SHIFT(884),
  [2742] = {.count = 1, .reusable = true}, SHIFT(886),
  [2744] = {.count = 1, .reusable = false}, SHIFT(887),
  [2746] = {.count = 1, .reusable = true}, SHIFT(890),
  [2748] = {.count = 1, .reusable = true}, SHIFT(888),
  [2750] = {.count = 1, .reusable = false}, SHIFT(889),
  [2752] = {.count = 1, .reusable = false}, SHIFT(1442),
  [2754] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 2),
  [2756] = {.count = 1, .reusable = true}, SHIFT(891),
  [2758] = {.count = 1, .reusable = true}, SHIFT(892),
  [2760] = {.count = 1, .reusable = true}, SHIFT(895),
  [2762] = {.count = 1, .reusable = true}, SHIFT(896),
  [2764] = {.count = 1, .reusable = true}, SHIFT(897),
  [2766] = {.count = 1, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2),
  [2768] = {.count = 1, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2),
  [2770] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 2),
  [2772] = {.count = 1, .reusable = true}, SHIFT(2156),
  [2774] = {.count = 1, .reusable = false}, SHIFT(899),
  [2776] = {.count = 1, .reusable = false}, SHIFT(900),
  [2778] = {.count = 1, .reusable = false}, SHIFT(901),
  [2780] = {.count = 1, .reusable = true}, SHIFT(903),
  [2782] = {.count = 1, .reusable = true}, SHIFT(902),
  [2784] = {.count = 1, .reusable = true}, REDUCE(sym_class_body, 3),
  [2786] = {.count = 1, .reusable = false}, REDUCE(sym_class_body, 3),
  [2788] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(385),
  [2791] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(384),
  [2794] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2444),
  [2797] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(386),
  [2800] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(387),
  [2803] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(388),
  [2806] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(389),
  [2809] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(390),
  [2812] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2152),
  [2815] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(395),
  [2818] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(392),
  [2821] = {.count = 2, .reusable = false}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(393),
  [2824] = {.count = 2, .reusable = true}, REDUCE(aux_sym_class_body_repeat1, 2), SHIFT_REPEAT(2151),
  [2827] = {.count = 1, .reusable = true}, SHIFT(904),
  [2829] = {.count = 1, .reusable = true}, SHIFT(616),
  [2831] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4, .production_id = 12),
  [2833] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4, .production_id = 12),
  [2835] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_repeat1, 3),
  [2837] = {.count = 1, .reusable = true}, SHIFT(907),
  [2839] = {.count = 1, .reusable = true}, SHIFT(908),
  [2841] = {.count = 1, .reusable = false}, SHIFT(909),
  [2843] = {.count = 1, .reusable = true}, SHIFT(910),
  [2845] = {.count = 2, .reusable = true}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [2848] = {.count = 2, .reusable = false}, REDUCE(sym_array, 3), REDUCE(sym_computed_property_name, 3),
  [2851] = {.count = 1, .reusable = true}, REDUCE(sym_computed_property_name, 3),
  [2853] = {.count = 1, .reusable = false}, SHIFT(911),
  [2855] = {.count = 1, .reusable = true}, REDUCE(sym_object, 4),
  [2857] = {.count = 1, .reusable = false}, REDUCE(sym_object, 4),
  [2859] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3),
  [2861] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 3),
  [2863] = {.count = 1, .reusable = true}, SHIFT(912),
  [2865] = {.count = 1, .reusable = false}, SHIFT(913),
  [2867] = {.count = 1, .reusable = true}, SHIFT(913),
  [2869] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 2),
  [2871] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 2),
  [2873] = {.count = 1, .reusable = true}, SHIFT(915),
  [2875] = {.count = 1, .reusable = true}, SHIFT(916),
  [2877] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3),
  [2879] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3),
  [2881] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 6),
  [2883] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 6),
  [2885] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 14),
  [2887] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 14),
  [2889] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 15),
  [2891] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 15),
  [2893] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 1),
  [2895] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 1),
  [2897] = {.count = 1, .reusable = true}, REDUCE(sym_rest_parameter, 3),
  [2899] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 4),
  [2901] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2),
  [2903] = {.count = 1, .reusable = true}, SHIFT(932),
  [2905] = {.count = 2, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 2), SHIFT_REPEAT(933),
  [2908] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 4),
  [2910] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 4),
  [2912] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 18),
  [2914] = {.count = 1, .reusable = true}, SHIFT(934),
  [2916] = {.count = 1, .reusable = true}, SHIFT(937),
  [2918] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 19),
  [2920] = {.count = 1, .reusable = true}, SHIFT(939),
  [2922] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 20),
  [2924] = {.count = 1, .reusable = true}, SHIFT(942),
  [2926] = {.count = 1, .reusable = true}, SHIFT(945),
  [2928] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 3),
  [2930] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 3),
  [2932] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3, .production_id = 4),
  [2934] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 3, .production_id = 4),
  [2936] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4),
  [2938] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4),
  [2940] = {.count = 1, .reusable = true}, REDUCE(sym_arrow_function, 4, .production_id = 6),
  [2942] = {.count = 1, .reusable = false}, REDUCE(sym_arrow_function, 4, .production_id = 6),
  [2944] = {.count = 1, .reusable = true}, SHIFT(948),
  [2946] = {.count = 1, .reusable = true}, REDUCE(sym_function, 4),
  [2948] = {.count = 1, .reusable = false}, REDUCE(sym_function, 4),
  [2950] = {.count = 1, .reusable = false}, REDUCE(sym_variable_declaration, 4),
  [2952] = {.count = 1, .reusable = true}, REDUCE(sym_variable_declaration, 4),
  [2954] = {.count = 1, .reusable = true}, SHIFT(950),
  [2956] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 2),
  [2958] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 2),
  [2960] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 2),
  [2962] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 2),
  [2964] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4),
  [2966] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4),
  [2968] = {.count = 1, .reusable = true}, REDUCE(sym_default_type, 2),
  [2970] = {.count = 1, .reusable = true}, REDUCE(sym_constraint, 2),
  [2972] = {.count = 1, .reusable = true}, SHIFT(951),
  [2974] = {.count = 1, .reusable = true}, REDUCE(sym_nested_type_identifier, 3, .production_id = 16),
  [2976] = {.count = 1, .reusable = false}, REDUCE(sym_nested_type_identifier, 3, .production_id = 16),
  [2978] = {.count = 1, .reusable = true}, REDUCE(sym_mapped_type, 3, .production_id = 5),
  [2980] = {.count = 1, .reusable = false}, REDUCE(sym_mapped_type, 3, .production_id = 5),
  [2982] = {.count = 1, .reusable = true}, REDUCE(sym_type_predicate, 3),
  [2984] = {.count = 1, .reusable = false}, REDUCE(sym_type_predicate, 3),
  [2986] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameter, 3, .production_id = 5),
  [2988] = {.count = 1, .reusable = true}, SHIFT(952),
  [2990] = {.count = 1, .reusable = true}, SHIFT(953),
  [2992] = {.count = 1, .reusable = true}, SHIFT(955),
  [2994] = {.count = 1, .reusable = true}, SHIFT(957),
  [2996] = {.count = 1, .reusable = false}, SHIFT(958),
  [2998] = {.count = 1, .reusable = true}, SHIFT(961),
  [3000] = {.count = 1, .reusable = true}, SHIFT(959),
  [3002] = {.count = 1, .reusable = false}, SHIFT(960),
  [3004] = {.count = 1, .reusable = false}, SHIFT(1451),
  [3006] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 2),
  [3008] = {.count = 1, .reusable = true}, SHIFT(962),
  [3010] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 2),
  [3012] = {.count = 1, .reusable = false}, SHIFT(966),
  [3014] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 3),
  [3016] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 3),
  [3018] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 3),
  [3020] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 3),
  [3022] = {.count = 1, .reusable = true}, SHIFT(969),
  [3024] = {.count = 1, .reusable = true}, SHIFT(971),
  [3026] = {.count = 1, .reusable = false}, SHIFT(1881),
  [3028] = {.count = 1, .reusable = false}, SHIFT(2037),
  [3030] = {.count = 1, .reusable = false}, SHIFT(2486),
  [3032] = {.count = 1, .reusable = false}, SHIFT(2487),
  [3034] = {.count = 1, .reusable = false}, SHIFT(2488),
  [3036] = {.count = 1, .reusable = true}, SHIFT(2037),
  [3038] = {.count = 1, .reusable = false}, SHIFT(2489),
  [3040] = {.count = 1, .reusable = false}, SHIFT(1319),
  [3042] = {.count = 1, .reusable = false}, SHIFT(1320),
  [3044] = {.count = 1, .reusable = false}, SHIFT(1321),
  [3046] = {.count = 1, .reusable = false}, SHIFT(972),
  [3048] = {.count = 1, .reusable = false}, SHIFT(973),
  [3050] = {.count = 1, .reusable = false}, SHIFT(974),
  [3052] = {.count = 1, .reusable = true}, SHIFT(2491),
  [3054] = {.count = 1, .reusable = false}, SHIFT(2490),
  [3056] = {.count = 1, .reusable = true}, SHIFT(1318),
  [3058] = {.count = 1, .reusable = true}, SHIFT(2292),
  [3060] = {.count = 1, .reusable = false}, SHIFT(2369),
  [3062] = {.count = 1, .reusable = false}, SHIFT(2492),
  [3064] = {.count = 1, .reusable = true}, SHIFT(977),
  [3066] = {.count = 1, .reusable = false}, SHIFT(976),
  [3068] = {.count = 1, .reusable = false}, SHIFT(1324),
  [3070] = {.count = 1, .reusable = true}, SHIFT(978),
  [3072] = {.count = 1, .reusable = true}, SHIFT(979),
  [3074] = {.count = 1, .reusable = false}, SHIFT(980),
  [3076] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_type, 3),
  [3078] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_type, 3),
  [3080] = {.count = 1, .reusable = true}, REDUCE(sym_intersection_type, 3),
  [3082] = {.count = 1, .reusable = false}, REDUCE(sym_intersection_type, 3),
  [3084] = {.count = 1, .reusable = true}, REDUCE(sym_union_type, 3),
  [3086] = {.count = 1, .reusable = false}, REDUCE(sym_union_type, 3),
  [3088] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 4),
  [3090] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 4),
  [3092] = {.count = 1, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2),
  [3094] = {.count = 1, .reusable = true}, SHIFT(981),
  [3096] = {.count = 2, .reusable = true}, REDUCE(aux_sym_implements_clause_repeat1, 2), SHIFT_REPEAT(647),
  [3099] = {.count = 1, .reusable = true}, REDUCE(sym_mapped_type, 3),
  [3101] = {.count = 1, .reusable = false}, REDUCE(sym_mapped_type, 3),
  [3103] = {.count = 1, .reusable = true}, SHIFT(983),
  [3105] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 4),
  [3107] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 4),
  [3109] = {.count = 1, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2),
  [3111] = {.count = 1, .reusable = true}, SHIFT(984),
  [3113] = {.count = 2, .reusable = true}, REDUCE(aux_sym_type_parameters_repeat1, 2), SHIFT_REPEAT(985),
  [3116] = {.count = 1, .reusable = true}, REDUCE(sym_array_type, 3),
  [3118] = {.count = 1, .reusable = false}, REDUCE(sym_array_type, 3),
  [3120] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 3),
  [3122] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 3),
  [3124] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 4),
  [3126] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 4),
  [3128] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 4),
  [3130] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 4),
  [3132] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 4),
  [3134] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 4),
  [3136] = {.count = 1, .reusable = false}, SHIFT(987),
  [3138] = {.count = 1, .reusable = true}, SHIFT(988),
  [3140] = {.count = 1, .reusable = true}, SHIFT(989),
  [3142] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 4),
  [3144] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 4),
  [3146] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3),
  [3148] = {.count = 1, .reusable = true}, SHIFT(990),
  [3150] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 3, .production_id = 21),
  [3152] = {.count = 1, .reusable = true}, SHIFT(992),
  [3154] = {.count = 1, .reusable = true}, SHIFT(994),
  [3156] = {.count = 1, .reusable = true}, SHIFT(995),
  [3158] = {.count = 1, .reusable = false}, SHIFT(996),
  [3160] = {.count = 1, .reusable = true}, SHIFT(996),
  [3162] = {.count = 1, .reusable = true}, SHIFT(997),
  [3164] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_required_parameter, 1), REDUCE(sym__primary_type, 1, .production_id = 5),
  [3168] = {.count = 1, .reusable = true}, SHIFT(2184),
  [3170] = {.count = 1, .reusable = false}, SHIFT(1703),
  [3172] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1), REDUCE(sym_required_parameter, 1, .production_id = 1), REDUCE(sym_predefined_type, 1),
  [3176] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(775),
  [3179] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(795),
  [3182] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4, .production_id = 16),
  [3184] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4, .production_id = 16),
  [3186] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_class, 4),
  [3188] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_class, 4),
  [3190] = {.count = 1, .reusable = true}, SHIFT(2014),
  [3192] = {.count = 1, .reusable = true}, REDUCE(sym_arguments, 4),
  [3194] = {.count = 1, .reusable = false}, REDUCE(sym_arguments, 4),
  [3196] = {.count = 1, .reusable = false}, REDUCE(sym_interface_declaration, 5, .production_id = 11),
  [3198] = {.count = 1, .reusable = true}, REDUCE(sym_interface_declaration, 5, .production_id = 11),
  [3200] = {.count = 1, .reusable = true}, REDUCE(sym_enum_assignment, 2),
  [3202] = {.count = 1, .reusable = true}, SHIFT(1001),
  [3204] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 3),
  [3206] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 3),
  [3208] = {.count = 1, .reusable = true}, SHIFT(1003),
  [3210] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [3212] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [3214] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class, 5, .production_id = 16),
  [3216] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class, 5, .production_id = 16),
  [3218] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 5, .production_id = 11),
  [3220] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 5, .production_id = 11),
  [3222] = {.count = 1, .reusable = true}, SHIFT(1006),
  [3224] = {.count = 1, .reusable = false}, REDUCE(sym_import_alias, 5),
  [3226] = {.count = 1, .reusable = true}, REDUCE(sym_import_alias, 5),
  [3228] = {.count = 1, .reusable = false}, REDUCE(sym_import_statement, 5),
  [3230] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 5),
  [3232] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 3),
  [3234] = {.count = 1, .reusable = true}, SHIFT(1008),
  [3236] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 4, .production_id = 17),
  [3238] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2, .production_id = 17),
  [3240] = {.count = 1, .reusable = true}, SHIFT(1009),
  [3242] = {.count = 2, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2), SHIFT_REPEAT(1010),
  [3245] = {.count = 1, .reusable = true}, REDUCE(aux_sym_named_imports_repeat1, 2),
  [3247] = {.count = 1, .reusable = true}, SHIFT(1011),
  [3249] = {.count = 1, .reusable = true}, SHIFT(1012),
  [3251] = {.count = 1, .reusable = true}, SHIFT(1013),
  [3253] = {.count = 1, .reusable = false}, SHIFT(1014),
  [3255] = {.count = 1, .reusable = true}, SHIFT(1014),
  [3257] = {.count = 1, .reusable = false}, SHIFT(1015),
  [3259] = {.count = 1, .reusable = true}, SHIFT(1015),
  [3261] = {.count = 1, .reusable = false}, SHIFT(1016),
  [3263] = {.count = 1, .reusable = true}, SHIFT(1016),
  [3265] = {.count = 1, .reusable = true}, SHIFT(1017),
  [3267] = {.count = 1, .reusable = true}, SHIFT(1018),
  [3269] = {.count = 1, .reusable = false}, SHIFT(1019),
  [3271] = {.count = 1, .reusable = true}, SHIFT(1019),
  [3273] = {.count = 1, .reusable = false}, SHIFT(1021),
  [3275] = {.count = 1, .reusable = true}, SHIFT(1021),
  [3277] = {.count = 1, .reusable = false}, SHIFT(1023),
  [3279] = {.count = 1, .reusable = true}, SHIFT(1023),
  [3281] = {.count = 1, .reusable = true}, SHIFT(1026),
  [3283] = {.count = 1, .reusable = true}, SHIFT(1027),
  [3285] = {.count = 1, .reusable = true}, SHIFT(1028),
  [3287] = {.count = 1, .reusable = true}, SHIFT(1029),
  [3289] = {.count = 1, .reusable = true}, SHIFT(1030),
  [3291] = {.count = 2, .reusable = true}, REDUCE(sym_member_expression, 3, .production_id = 8), REDUCE(sym_nested_type_identifier, 3, .production_id = 16),
  [3294] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 8),
  [3297] = {.count = 2, .reusable = false}, REDUCE(sym_member_expression, 3, .production_id = 8), REDUCE(sym_nested_type_identifier, 3, .production_id = 16),
  [3300] = {.count = 1, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [3302] = {.count = 1, .reusable = false}, REDUCE(aux_sym_extends_clause_repeat1, 2),
  [3304] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(645),
  [3307] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 11),
  [3309] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 11),
  [3311] = {.count = 1, .reusable = true}, SHIFT(223),
  [3313] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 3),
  [3315] = {.count = 1, .reusable = true}, SHIFT(1035),
  [3317] = {.count = 1, .reusable = true}, SHIFT(1036),
  [3319] = {.count = 1, .reusable = true}, SHIFT(1038),
  [3321] = {.count = 1, .reusable = false}, SHIFT(1037),
  [3323] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 3),
  [3325] = {.count = 1, .reusable = true}, SHIFT(1039),
  [3327] = {.count = 1, .reusable = true}, SHIFT(1040),
  [3329] = {.count = 1, .reusable = true}, SHIFT(1043),
  [3331] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 3),
  [3333] = {.count = 1, .reusable = false}, SHIFT(1467),
  [3335] = {.count = 1, .reusable = true}, SHIFT(1046),
  [3337] = {.count = 1, .reusable = false}, SHIFT(1045),
  [3339] = {.count = 1, .reusable = true}, SHIFT(1047),
  [3341] = {.count = 1, .reusable = true}, SHIFT(1048),
  [3343] = {.count = 1, .reusable = true}, SHIFT(1049),
  [3345] = {.count = 1, .reusable = false}, SHIFT(1679),
  [3347] = {.count = 1, .reusable = false}, SHIFT(2237),
  [3349] = {.count = 1, .reusable = true}, SHIFT(1794),
  [3351] = {.count = 1, .reusable = true}, SHIFT(1790),
  [3353] = {.count = 1, .reusable = true}, SHIFT(1788),
  [3355] = {.count = 1, .reusable = false}, SHIFT(2435),
  [3357] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 4),
  [3359] = {.count = 1, .reusable = true}, SHIFT(1053),
  [3361] = {.count = 1, .reusable = true}, SHIFT(1054),
  [3363] = {.count = 1, .reusable = false}, SHIFT(1055),
  [3365] = {.count = 1, .reusable = true}, SHIFT(1056),
  [3367] = {.count = 1, .reusable = true}, REDUCE(sym_object, 5),
  [3369] = {.count = 1, .reusable = false}, REDUCE(sym_object, 5),
  [3371] = {.count = 1, .reusable = true}, SHIFT(1057),
  [3373] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 2),
  [3375] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 2),
  [3377] = {.count = 1, .reusable = false}, REDUCE(sym_switch_body, 3),
  [3379] = {.count = 1, .reusable = true}, REDUCE(sym_switch_body, 3),
  [3381] = {.count = 1, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [3383] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(698),
  [3386] = {.count = 2, .reusable = true}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(696),
  [3389] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4),
  [3391] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 6),
  [3393] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .production_id = 6),
  [3395] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4),
  [3397] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 14),
  [3399] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .production_id = 14),
  [3401] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 15),
  [3403] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .production_id = 15),
  [3405] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 1),
  [3407] = {.count = 1, .reusable = true}, REDUCE(aux_sym_formal_parameters_repeat1, 3),
  [3409] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 5),
  [3411] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 18),
  [3413] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .production_id = 18),
  [3415] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 19),
  [3417] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .production_id = 19),
  [3419] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 20),
  [3421] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 4, .production_id = 20),
  [3423] = {.count = 1, .reusable = true}, SHIFT(1074),
  [3425] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 3),
  [3427] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 4, .production_id = 4),
  [3429] = {.count = 1, .reusable = false}, REDUCE(sym_function_signature, 5),
  [3431] = {.count = 1, .reusable = true}, REDUCE(sym_function_signature, 5),
  [3433] = {.count = 1, .reusable = true}, REDUCE(sym_function, 5),
  [3435] = {.count = 1, .reusable = false}, REDUCE(sym_function, 5),
  [3437] = {.count = 1, .reusable = true}, SHIFT(1075),
  [3439] = {.count = 1, .reusable = true}, REDUCE(sym_lookup_type, 4, .production_id = 5),
  [3441] = {.count = 1, .reusable = false}, REDUCE(sym_lookup_type, 4, .production_id = 5),
  [3443] = {.count = 1, .reusable = true}, SHIFT(1076),
  [3445] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 4),
  [3447] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 4),
  [3449] = {.count = 1, .reusable = true}, SHIFT(1077),
  [3451] = {.count = 1, .reusable = true}, SHIFT(1079),
  [3453] = {.count = 1, .reusable = true}, SHIFT(1080),
  [3455] = {.count = 1, .reusable = true}, SHIFT(1082),
  [3457] = {.count = 1, .reusable = false}, SHIFT(1081),
  [3459] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 3),
  [3461] = {.count = 1, .reusable = true}, SHIFT(1083),
  [3463] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 3),
  [3465] = {.count = 1, .reusable = false}, SHIFT(1472),
  [3467] = {.count = 1, .reusable = true}, SHIFT(1087),
  [3469] = {.count = 1, .reusable = false}, SHIFT(1086),
  [3471] = {.count = 1, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2),
  [3473] = {.count = 2, .reusable = true}, REDUCE(aux_sym_object_type_repeat1, 2), SHIFT_REPEAT(1088),
  [3476] = {.count = 1, .reusable = true}, REDUCE(sym_tuple_type, 4),
  [3478] = {.count = 1, .reusable = false}, REDUCE(sym_tuple_type, 4),
  [3480] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 4),
  [3482] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 4),
  [3484] = {.count = 2, .reusable = true}, REDUCE(sym__property_name, 1, .production_id = 2), REDUCE(aux_sym_object_repeat1, 2, .production_id = 12),
  [3487] = {.count = 1, .reusable = false}, SHIFT(2500),
  [3489] = {.count = 1, .reusable = true}, SHIFT(1090),
  [3491] = {.count = 1, .reusable = true}, SHIFT(2501),
  [3493] = {.count = 1, .reusable = false}, SHIFT(2502),
  [3495] = {.count = 1, .reusable = true}, SHIFT(1091),
  [3497] = {.count = 1, .reusable = false}, SHIFT(1713),
  [3499] = {.count = 1, .reusable = false}, SHIFT(1723),
  [3501] = {.count = 1, .reusable = true}, SHIFT(1850),
  [3503] = {.count = 1, .reusable = false}, SHIFT(1715),
  [3505] = {.count = 1, .reusable = false}, SHIFT(2179),
  [3507] = {.count = 1, .reusable = false}, SHIFT(2180),
  [3509] = {.count = 1, .reusable = false}, SHIFT(1342),
  [3511] = {.count = 1, .reusable = false}, SHIFT(1716),
  [3513] = {.count = 1, .reusable = true}, SHIFT(2055),
  [3515] = {.count = 1, .reusable = false}, SHIFT(1729),
  [3517] = {.count = 1, .reusable = true}, SHIFT(1723),
  [3519] = {.count = 1, .reusable = false}, SHIFT(1985),
  [3521] = {.count = 1, .reusable = false}, SHIFT(1092),
  [3523] = {.count = 1, .reusable = true}, REDUCE(sym_type_arguments, 5),
  [3525] = {.count = 1, .reusable = false}, REDUCE(sym_type_arguments, 5),
  [3527] = {.count = 1, .reusable = true}, REDUCE(sym_function_type, 4),
  [3529] = {.count = 1, .reusable = false}, REDUCE(sym_function_type, 4),
  [3531] = {.count = 1, .reusable = true}, REDUCE(sym_lookup_type, 4),
  [3533] = {.count = 1, .reusable = false}, REDUCE(sym_lookup_type, 4),
  [3535] = {.count = 1, .reusable = true}, REDUCE(sym_type_parameters, 5),
  [3537] = {.count = 1, .reusable = false}, REDUCE(sym_type_parameters, 5),
  [3539] = {.count = 1, .reusable = true}, REDUCE(sym_generator_function, 5),
  [3541] = {.count = 1, .reusable = false}, REDUCE(sym_generator_function, 5),
  [3543] = {.count = 2, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym_rest_parameter, 2),
  [3546] = {.count = 1, .reusable = false}, SHIFT(1093),
  [3548] = {.count = 1, .reusable = true}, SHIFT(1093),
  [3550] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 4, .production_id = 21),
  [3552] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2, .production_id = 21),
  [3554] = {.count = 1, .reusable = true}, SHIFT(1094),
  [3556] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2), SHIFT_REPEAT(1095),
  [3559] = {.count = 1, .reusable = true}, REDUCE(aux_sym_export_clause_repeat1, 2),
  [3561] = {.count = 1, .reusable = false}, REDUCE(sym_export_statement, 5),
  [3563] = {.count = 1, .reusable = true}, REDUCE(sym_export_statement, 5),
  [3565] = {.count = 1, .reusable = false}, REDUCE(sym_do_statement, 5),
  [3567] = {.count = 1, .reusable = true}, REDUCE(sym_do_statement, 5),
  [3569] = {.count = 1, .reusable = true}, REDUCE(sym_ternary_expression, 5),
  [3571] = {.count = 1, .reusable = true}, SHIFT(1096),
  [3573] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(971),
  [3576] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5, .production_id = 16),
  [3578] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5, .production_id = 16),
  [3580] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 4),
  [3582] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 4),
  [3584] = {.count = 1, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2),
  [3586] = {.count = 1, .reusable = true}, SHIFT(1098),
  [3588] = {.count = 2, .reusable = true}, REDUCE(aux_sym_enum_body_repeat1, 2), SHIFT_REPEAT(1099),
  [3591] = {.count = 1, .reusable = false}, REDUCE(sym_abstract_class, 6, .production_id = 16),
  [3593] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_class, 6, .production_id = 16),
  [3595] = {.count = 1, .reusable = false}, REDUCE(sym_type_alias_declaration, 6, .production_id = 11),
  [3597] = {.count = 1, .reusable = true}, REDUCE(sym_type_alias_declaration, 6, .production_id = 11),
  [3599] = {.count = 1, .reusable = true}, SHIFT(1100),
  [3601] = {.count = 1, .reusable = true}, REDUCE(sym__import_export_specifier, 4),
  [3603] = {.count = 1, .reusable = true}, REDUCE(sym_named_imports, 5, .production_id = 17),
  [3605] = {.count = 1, .reusable = false}, SHIFT(1101),
  [3607] = {.count = 1, .reusable = true}, SHIFT(1101),
  [3609] = {.count = 1, .reusable = false}, SHIFT(1102),
  [3611] = {.count = 1, .reusable = true}, SHIFT(1102),
  [3613] = {.count = 1, .reusable = false}, SHIFT(1103),
  [3615] = {.count = 1, .reusable = true}, SHIFT(1103),
  [3617] = {.count = 1, .reusable = true}, SHIFT(1104),
  [3619] = {.count = 1, .reusable = true}, SHIFT(1105),
  [3621] = {.count = 1, .reusable = true}, SHIFT(1106),
  [3623] = {.count = 1, .reusable = true}, SHIFT(1109),
  [3625] = {.count = 1, .reusable = true}, SHIFT(1110),
  [3627] = {.count = 1, .reusable = true}, SHIFT(1111),
  [3629] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [3631] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [3633] = {.count = 1, .reusable = true}, SHIFT(1117),
  [3635] = {.count = 1, .reusable = true}, SHIFT(1118),
  [3637] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 4),
  [3639] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 4),
  [3641] = {.count = 1, .reusable = true}, SHIFT(1120),
  [3643] = {.count = 1, .reusable = true}, SHIFT(1121),
  [3645] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 4),
  [3647] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 4),
  [3649] = {.count = 1, .reusable = true}, SHIFT(1126),
  [3651] = {.count = 1, .reusable = false}, SHIFT(1125),
  [3653] = {.count = 1, .reusable = true}, SHIFT(1127),
  [3655] = {.count = 1, .reusable = true}, SHIFT(1128),
  [3657] = {.count = 1, .reusable = true}, SHIFT(1129),
  [3659] = {.count = 1, .reusable = false}, REDUCE(sym_ambient_declaration, 6, .production_id = 22),
  [3661] = {.count = 1, .reusable = true}, REDUCE(sym_ambient_declaration, 6, .production_id = 22),
  [3663] = {.count = 1, .reusable = true}, SHIFT(1687),
  [3665] = {.count = 1, .reusable = true}, SHIFT(1686),
  [3667] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 5),
  [3669] = {.count = 1, .reusable = true}, SHIFT(1132),
  [3671] = {.count = 1, .reusable = true}, SHIFT(1133),
  [3673] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 3),
  [3675] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 3),
  [3677] = {.count = 1, .reusable = true}, REDUCE(sym_switch_default, 3),
  [3679] = {.count = 1, .reusable = false}, REDUCE(sym_switch_default, 3),
  [3681] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .production_id = 6),
  [3683] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5),
  [3685] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .production_id = 14),
  [3687] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .production_id = 15),
  [3689] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .production_id = 18),
  [3691] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 5, .production_id = 18),
  [3693] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 5),
  [3695] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .production_id = 19),
  [3697] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 5, .production_id = 19),
  [3699] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 5, .production_id = 20),
  [3701] = {.count = 1, .reusable = true}, REDUCE(sym_required_parameter, 5, .production_id = 20),
  [3703] = {.count = 1, .reusable = true}, REDUCE(sym_formal_parameters, 6),
  [3705] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 5),
  [3707] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 5),
  [3709] = {.count = 1, .reusable = true}, SHIFT(1140),
  [3711] = {.count = 1, .reusable = true}, SHIFT(1142),
  [3713] = {.count = 1, .reusable = true}, SHIFT(1143),
  [3715] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 4),
  [3717] = {.count = 1, .reusable = true}, REDUCE(sym_construct_signature, 4),
  [3719] = {.count = 1, .reusable = true}, SHIFT(1146),
  [3721] = {.count = 1, .reusable = false}, SHIFT(1145),
  [3723] = {.count = 1, .reusable = true}, SHIFT(1147),
  [3725] = {.count = 1, .reusable = true}, REDUCE(sym_constructor_type, 5),
  [3727] = {.count = 1, .reusable = false}, REDUCE(sym_constructor_type, 5),
  [3729] = {.count = 1, .reusable = true}, SHIFT(1148),
  [3731] = {.count = 1, .reusable = false}, SHIFT(2373),
  [3733] = {.count = 1, .reusable = true}, SHIFT(1149),
  [3735] = {.count = 1, .reusable = true}, SHIFT(2507),
  [3737] = {.count = 1, .reusable = false}, SHIFT(2508),
  [3739] = {.count = 1, .reusable = true}, REDUCE(sym_export_clause, 5, .production_id = 21),
  [3741] = {.count = 2, .reusable = false}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_member_expression, 3, .production_id = 8),
  [3744] = {.count = 1, .reusable = true}, REDUCE(sym_class, 6, .production_id = 16),
  [3746] = {.count = 1, .reusable = false}, REDUCE(sym_class, 6, .production_id = 16),
  [3748] = {.count = 1, .reusable = false}, REDUCE(sym_enum_body, 5),
  [3750] = {.count = 1, .reusable = true}, REDUCE(sym_enum_body, 5),
  [3752] = {.count = 1, .reusable = true}, REDUCE(sym_import_require_clause, 6),
  [3754] = {.count = 1, .reusable = true}, SHIFT(1150),
  [3756] = {.count = 1, .reusable = true}, SHIFT(1151),
  [3758] = {.count = 1, .reusable = true}, SHIFT(1152),
  [3760] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 7),
  [3762] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 7),
  [3764] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 7),
  [3766] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 7),
  [3768] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7),
  [3770] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7),
  [3772] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 7, .production_id = 20),
  [3774] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 7, .production_id = 20),
  [3776] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 7, .production_id = 20),
  [3778] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 7, .production_id = 20),
  [3780] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 7, .production_id = 19),
  [3782] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 7, .production_id = 19),
  [3784] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 7, .production_id = 19),
  [3786] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 7, .production_id = 19),
  [3788] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 5),
  [3790] = {.count = 1, .reusable = true}, SHIFT(1162),
  [3792] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 5),
  [3794] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 5),
  [3796] = {.count = 1, .reusable = true}, SHIFT(1164),
  [3798] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 6),
  [3800] = {.count = 1, .reusable = true}, SHIFT(1169),
  [3802] = {.count = 1, .reusable = true}, REDUCE(sym_switch_case, 4),
  [3804] = {.count = 1, .reusable = false}, REDUCE(sym_switch_case, 4),
  [3806] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 6, .production_id = 18),
  [3808] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 6),
  [3810] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 6, .production_id = 19),
  [3812] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 6, .production_id = 20),
  [3814] = {.count = 1, .reusable = false}, REDUCE(sym_catch_clause, 5),
  [3816] = {.count = 1, .reusable = true}, REDUCE(sym_catch_clause, 5),
  [3818] = {.count = 1, .reusable = true}, REDUCE(sym_object_type, 6),
  [3820] = {.count = 1, .reusable = false}, REDUCE(sym_object_type, 6),
  [3822] = {.count = 1, .reusable = true}, SHIFT(1171),
  [3824] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 5),
  [3826] = {.count = 1, .reusable = true}, SHIFT(1172),
  [3828] = {.count = 1, .reusable = true}, SHIFT(1174),
  [3830] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 8),
  [3832] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 8),
  [3834] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 8, .production_id = 23),
  [3836] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 8, .production_id = 23),
  [3838] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 8, .production_id = 24),
  [3840] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 8, .production_id = 24),
  [3842] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 8),
  [3844] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 8),
  [3846] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 8, .production_id = 23),
  [3848] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 8, .production_id = 23),
  [3850] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_statement, 8, .production_id = 24),
  [3852] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_statement, 8, .production_id = 24),
  [3854] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6),
  [3856] = {.count = 1, .reusable = true}, REDUCE(sym_index_signature, 6, .production_id = 6),
  [3858] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 6),
  [3860] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 6),
  [3862] = {.count = 1, .reusable = true}, SHIFT(1179),
  [3864] = {.count = 1, .reusable = true}, REDUCE(sym_abstract_method_signature, 6),
  [3866] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 7),
  [3868] = {.count = 1, .reusable = true}, SHIFT(1184),
  [3870] = {.count = 1, .reusable = true}, REDUCE(sym_property_signature, 6),
  [3872] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 9),
  [3874] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 9),
  [3876] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 9, .production_id = 25),
  [3878] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 9, .production_id = 25),
  [3880] = {.count = 1, .reusable = false}, REDUCE(sym_for_of_statement, 9, .production_id = 26),
  [3882] = {.count = 1, .reusable = true}, REDUCE(sym_for_of_statement, 9, .production_id = 26),
  [3884] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 7),
  [3886] = {.count = 1, .reusable = true}, REDUCE(sym_public_field_definition, 7),
  [3888] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 8),
  [3890] = {.count = 1, .reusable = true}, REDUCE(sym_method_signature, 8),
  [3892] = {.count = 1, .reusable = true}, REDUCE(sym_method_definition, 9),
  [3894] = {.count = 1, .reusable = false}, SHIFT(1218),
  [3896] = {.count = 1, .reusable = true}, SHIFT(1218),
  [3898] = {.count = 1, .reusable = false}, SHIFT(1222),
  [3900] = {.count = 1, .reusable = true}, SHIFT(1222),
  [3902] = {.count = 1, .reusable = false}, SHIFT(1223),
  [3904] = {.count = 1, .reusable = true}, SHIFT(1223),
  [3906] = {.count = 1, .reusable = false}, SHIFT(1227),
  [3908] = {.count = 1, .reusable = true}, SHIFT(1227),
  [3910] = {.count = 1, .reusable = false}, SHIFT(1229),
  [3912] = {.count = 1, .reusable = true}, SHIFT(1229),
  [3914] = {.count = 1, .reusable = false}, SHIFT(1260),
  [3916] = {.count = 1, .reusable = false}, SHIFT(1262),
  [3918] = {.count = 1, .reusable = false}, SHIFT(1263),
  [3920] = {.count = 1, .reusable = false}, SHIFT(1261),
  [3922] = {.count = 1, .reusable = false}, SHIFT(1799),
  [3924] = {.count = 1, .reusable = false}, SHIFT(1265),
  [3926] = {.count = 1, .reusable = false}, SHIFT(1264),
  [3928] = {.count = 1, .reusable = true}, SHIFT(1261),
  [3930] = {.count = 1, .reusable = false}, SHIFT(1286),
  [3932] = {.count = 1, .reusable = true}, SHIFT(1286),
  [3934] = {.count = 1, .reusable = false}, SHIFT(1289),
  [3936] = {.count = 1, .reusable = true}, SHIFT(2097),
  [3938] = {.count = 1, .reusable = true}, SHIFT(1289),
  [3940] = {.count = 1, .reusable = false}, SHIFT(1290),
  [3942] = {.count = 1, .reusable = true}, SHIFT(1290),
  [3944] = {.count = 1, .reusable = false}, SHIFT(1291),
  [3946] = {.count = 1, .reusable = true}, SHIFT(1291),
  [3948] = {.count = 1, .reusable = false}, SHIFT(1292),
  [3950] = {.count = 1, .reusable = true}, SHIFT(1292),
  [3952] = {.count = 1, .reusable = false}, SHIFT(1296),
  [3954] = {.count = 1, .reusable = true}, SHIFT(1296),
  [3956] = {.count = 1, .reusable = false}, SHIFT(1297),
  [3958] = {.count = 1, .reusable = true}, SHIFT(1297),
  [3960] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(1283),
  [3963] = {.count = 1, .reusable = true}, SHIFT(2224),
  [3965] = {.count = 1, .reusable = true}, SHIFT(2398),
  [3967] = {.count = 1, .reusable = true}, SHIFT(1233),
  [3969] = {.count = 1, .reusable = true}, SHIFT(1761),
  [3971] = {.count = 1, .reusable = false}, SHIFT(1835),
  [3973] = {.count = 1, .reusable = true}, SHIFT(1835),
  [3975] = {.count = 1, .reusable = true}, SHIFT(1245),
  [3977] = {.count = 1, .reusable = true}, SHIFT(2276),
  [3979] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(2279),
  [3982] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(2220),
  [3985] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(1348),
  [3988] = {.count = 1, .reusable = true}, SHIFT(1856),
  [3990] = {.count = 1, .reusable = false}, SHIFT(1360),
  [3992] = {.count = 1, .reusable = true}, SHIFT(1360),
  [3994] = {.count = 1, .reusable = false}, SHIFT(1361),
  [3996] = {.count = 1, .reusable = true}, SHIFT(1361),
  [3998] = {.count = 1, .reusable = false}, SHIFT(1362),
  [4000] = {.count = 1, .reusable = true}, SHIFT(1362),
  [4002] = {.count = 1, .reusable = false}, SHIFT(1363),
  [4004] = {.count = 1, .reusable = true}, SHIFT(1363),
  [4006] = {.count = 1, .reusable = false}, SHIFT(1364),
  [4008] = {.count = 1, .reusable = true}, SHIFT(1364),
  [4010] = {.count = 1, .reusable = false}, SHIFT(1368),
  [4012] = {.count = 1, .reusable = false}, SHIFT(1370),
  [4014] = {.count = 1, .reusable = false}, SHIFT(1372),
  [4016] = {.count = 1, .reusable = false}, SHIFT(1373),
  [4018] = {.count = 1, .reusable = false}, SHIFT(1524),
  [4020] = {.count = 1, .reusable = false}, SHIFT(1369),
  [4022] = {.count = 1, .reusable = false}, SHIFT(1371),
  [4024] = {.count = 1, .reusable = true}, SHIFT(1369),
  [4026] = {.count = 1, .reusable = false}, SHIFT(1376),
  [4028] = {.count = 1, .reusable = true}, SHIFT(1376),
  [4030] = {.count = 1, .reusable = true}, SHIFT(2286),
  [4032] = {.count = 1, .reusable = true}, SHIFT(1845),
  [4034] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 5), SHIFT(2275),
  [4037] = {.count = 1, .reusable = true}, SHIFT(1332),
  [4039] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 5), SHIFT(2220),
  [4042] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 5), SHIFT(1331),
  [4045] = {.count = 1, .reusable = false}, SHIFT(1396),
  [4047] = {.count = 1, .reusable = true}, SHIFT(1396),
  [4049] = {.count = 1, .reusable = false}, SHIFT(1398),
  [4051] = {.count = 1, .reusable = true}, SHIFT(1398),
  [4053] = {.count = 1, .reusable = true}, SHIFT(2031),
  [4055] = {.count = 1, .reusable = true}, SHIFT(2403),
  [4057] = {.count = 1, .reusable = true}, SHIFT(1898),
  [4059] = {.count = 1, .reusable = true}, SHIFT(1717),
  [4061] = {.count = 1, .reusable = true}, SHIFT(1518),
  [4063] = {.count = 2, .reusable = false}, REDUCE(sym_this, 1), REDUCE(sym_this_type, 1),
  [4066] = {.count = 1, .reusable = false}, SHIFT(1420),
  [4068] = {.count = 1, .reusable = false}, SHIFT(1528),
  [4070] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(1283),
  [4073] = {.count = 1, .reusable = true}, SHIFT(2058),
  [4075] = {.count = 1, .reusable = false}, SHIFT(1426),
  [4077] = {.count = 1, .reusable = false}, SHIFT(1427),
  [4079] = {.count = 1, .reusable = true}, SHIFT(1428),
  [4081] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(1531),
  [4084] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 3),
  [4086] = {.count = 2, .reusable = true}, REDUCE(sym_nested_identifier, 3), REDUCE(sym_nested_type_identifier, 3, .production_id = 16),
  [4089] = {.count = 1, .reusable = false}, SHIFT(1347),
  [4091] = {.count = 1, .reusable = false}, SHIFT(1346),
  [4093] = {.count = 1, .reusable = false}, SHIFT(1461),
  [4095] = {.count = 1, .reusable = true}, SHIFT(1461),
  [4097] = {.count = 1, .reusable = true}, SHIFT(1920),
  [4099] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 1), SHIFT(1554),
  [4102] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(1560),
  [4105] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 4),
  [4107] = {.count = 2, .reusable = true}, REDUCE(sym_call_signature, 2), SHIFT(1580),
  [4110] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 5),
  [4112] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 6),
  [4114] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 7),
  [4116] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 8),
  [4118] = {.count = 1, .reusable = false}, REDUCE(sym_method_definition, 9),
  [4120] = {.count = 1, .reusable = true}, SHIFT(2402),
  [4122] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(2405),
  [4125] = {.count = 1, .reusable = true}, SHIFT(2387),
  [4127] = {.count = 1, .reusable = true}, SHIFT(1529),
  [4129] = {.count = 1, .reusable = true}, SHIFT(2051),
  [4131] = {.count = 1, .reusable = true}, SHIFT(1952),
  [4133] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 5), SHIFT(2401),
  [4136] = {.count = 1, .reusable = true}, SHIFT(1515),
  [4138] = {.count = 1, .reusable = true}, SHIFT(2042),
  [4140] = {.count = 1, .reusable = true}, SHIFT(1514),
  [4142] = {.count = 1, .reusable = true}, SHIFT(2159),
  [4144] = {.count = 1, .reusable = true}, SHIFT(2170),
  [4146] = {.count = 1, .reusable = false}, SHIFT(1992),
  [4148] = {.count = 1, .reusable = false}, SHIFT(1958),
  [4150] = {.count = 1, .reusable = false}, SHIFT(1959),
  [4152] = {.count = 1, .reusable = false}, SHIFT(1497),
  [4154] = {.count = 1, .reusable = false}, SHIFT(1961),
  [4156] = {.count = 1, .reusable = false}, SHIFT(1960),
  [4158] = {.count = 1, .reusable = false}, SHIFT(2374),
  [4160] = {.count = 1, .reusable = false}, SHIFT(2375),
  [4162] = {.count = 1, .reusable = false}, SHIFT(2384),
  [4164] = {.count = 1, .reusable = false}, SHIFT(2376),
  [4166] = {.count = 1, .reusable = false}, SHIFT(2383),
  [4168] = {.count = 1, .reusable = false}, SHIFT(1969),
  [4170] = {.count = 1, .reusable = false}, SHIFT(2368),
  [4172] = {.count = 1, .reusable = true}, SHIFT(2076),
  [4174] = {.count = 1, .reusable = true}, SHIFT(2112),
  [4176] = {.count = 1, .reusable = false}, SHIFT(2104),
  [4178] = {.count = 1, .reusable = false}, SHIFT(1605),
  [4180] = {.count = 1, .reusable = false}, SHIFT(1596),
  [4182] = {.count = 1, .reusable = true}, SHIFT(2420),
  [4184] = {.count = 1, .reusable = false}, SHIFT(1599),
  [4186] = {.count = 1, .reusable = false}, SHIFT(2106),
  [4188] = {.count = 1, .reusable = false}, SHIFT(2108),
  [4190] = {.count = 1, .reusable = true}, SHIFT(2107),
  [4192] = {.count = 1, .reusable = true}, SHIFT(1601),
  [4194] = {.count = 1, .reusable = false}, SHIFT(2105),
  [4196] = {.count = 1, .reusable = true}, SHIFT(2430),
  [4198] = {.count = 1, .reusable = true}, SHIFT(2105),
  [4200] = {.count = 1, .reusable = true}, SHIFT(1597),
  [4202] = {.count = 1, .reusable = false}, SHIFT(1600),
  [4204] = {.count = 1, .reusable = true}, SHIFT(1596),
  [4206] = {.count = 1, .reusable = true}, SHIFT(1602),
  [4208] = {.count = 1, .reusable = true}, SHIFT(2422),
  [4210] = {.count = 1, .reusable = true}, SHIFT(1598),
  [4212] = {.count = 1, .reusable = false}, SHIFT(2421),
  [4214] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(2433),
  [4217] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(2418),
  [4220] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1), SHIFT(1627),
  [4223] = {.count = 1, .reusable = true}, SHIFT(2126),
  [4225] = {.count = 1, .reusable = true}, SHIFT(2117),
  [4227] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 5), SHIFT(2429),
  [4230] = {.count = 1, .reusable = true}, SHIFT(1613),
  [4232] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 5), SHIFT(2418),
  [4235] = {.count = 2, .reusable = false}, REDUCE(sym__primary_type, 1, .production_id = 5), SHIFT(1612),
  [4238] = {.count = 1, .reusable = true}, SHIFT(2182),
  [4240] = {.count = 1, .reusable = false}, SHIFT(1655),
  [4242] = {.count = 1, .reusable = false}, SHIFT(1626),
  [4244] = {.count = 1, .reusable = false}, SHIFT(1625),
  [4246] = {.count = 1, .reusable = false}, SHIFT(1631),
  [4248] = {.count = 1, .reusable = false}, SHIFT(1633),
  [4250] = {.count = 1, .reusable = false}, SHIFT(2367),
  [4252] = {.count = 1, .reusable = false}, SHIFT(1634),
  [4254] = {.count = 1, .reusable = false}, SHIFT(1685),
  [4256] = {.count = 1, .reusable = false}, SHIFT(1632),
  [4258] = {.count = 1, .reusable = false}, SHIFT(2366),
  [4260] = {.count = 1, .reusable = false}, SHIFT(2121),
  [4262] = {.count = 1, .reusable = true}, SHIFT(1632),
  [4264] = {.count = 1, .reusable = true}, SHIFT(2177),
  [4266] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1), SHIFT(100),
  [4269] = {.count = 1, .reusable = false}, SHIFT(1688),
  [4271] = {.count = 1, .reusable = false}, SHIFT(2163),
  [4273] = {.count = 1, .reusable = false}, SHIFT(1684),
  [4275] = {.count = 2, .reusable = true}, REDUCE(sym__primary_type, 1, .production_id = 5), SHIFT(100),
  [4278] = {.count = 1, .reusable = false}, SHIFT(1683),
  [4280] = {.count = 1, .reusable = true}, SHIFT(2207),
  [4282] = {.count = 1, .reusable = false}, SHIFT(2208),
  [4284] = {.count = 1, .reusable = true}, SHIFT(2205),
  [4286] = {.count = 1, .reusable = true}, SHIFT(2186),
  [4288] = {.count = 1, .reusable = false}, SHIFT(1726),
  [4290] = {.count = 1, .reusable = true}, SHIFT(2210),
  [4292] = {.count = 1, .reusable = true}, SHIFT(2209),
  [4294] = {.count = 1, .reusable = false}, SHIFT(2217),
  [4296] = {.count = 1, .reusable = false}, SHIFT(2452),
  [4298] = {.count = 1, .reusable = true}, SHIFT(2217),
  [4300] = {.count = 1, .reusable = false}, SHIFT(1722),
  [4302] = {.count = 1, .reusable = false}, SHIFT(1724),
  [4304] = {.count = 1, .reusable = false}, SHIFT(1725),
  [4306] = {.count = 1, .reusable = true}, SHIFT(2185),
  [4308] = {.count = 3, .reusable = true}, REDUCE(sym__expression, 1), REDUCE(sym__primary_type, 1, .production_id = 5), SHIFT(2401),
  [4312] = {.count = 2, .reusable = false}, REDUCE(sym__expression, 1), SHIFT(2387),
  [4315] = {.count = 1, .reusable = true}, SHIFT(2187),
  [4317] = {.count = 1, .reusable = false}, SHIFT(1730),
  [4319] = {.count = 1, .reusable = false}, SHIFT(1980),
  [4321] = {.count = 1, .reusable = false}, SHIFT(1981),
  [4323] = {.count = 1, .reusable = false}, SHIFT(2149),
  [4325] = {.count = 1, .reusable = false}, SHIFT(2150),
  [4327] = {.count = 1, .reusable = false}, SHIFT(1984),
  [4329] = {.count = 1, .reusable = false}, SHIFT(2081),
  [4331] = {.count = 1, .reusable = false}, SHIFT(1538),
  [4333] = {.count = 1, .reusable = false}, SHIFT(1690),
  [4335] = {.count = 1, .reusable = false}, SHIFT(1714),
  [4337] = {.count = 1, .reusable = false}, SHIFT(1692),
  [4339] = {.count = 1, .reusable = false}, SHIFT(2283),
  [4341] = {.count = 1, .reusable = false}, SHIFT(2284),
  [4343] = {.count = 1, .reusable = false}, SHIFT(2165),
  [4345] = {.count = 1, .reusable = false}, SHIFT(1693),
  [4347] = {.count = 1, .reusable = false}, SHIFT(1808),
  [4349] = {.count = 1, .reusable = false}, SHIFT(1721),
  [4351] = {.count = 1, .reusable = true}, SHIFT(1714),
  [4353] = {.count = 1, .reusable = false}, SHIFT(2285),
  [4355] = {.count = 1, .reusable = true}, SHIFT(1212),
  [4357] = {.count = 1, .reusable = true}, SHIFT(1744),
  [4359] = {.count = 1, .reusable = false}, SHIFT(1482),
  [4361] = {.count = 1, .reusable = true}, SHIFT(1753),
  [4363] = {.count = 1, .reusable = false}, SHIFT(1228),
  [4365] = {.count = 1, .reusable = true}, SHIFT(1754),
  [4367] = {.count = 1, .reusable = false}, SHIFT(2004),
  [4369] = {.count = 1, .reusable = true}, SHIFT(1758),
  [4371] = {.count = 1, .reusable = true}, SHIFT(1238),
  [4373] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4375] = {.count = 1, .reusable = true}, SHIFT(1293),
  [4377] = {.count = 1, .reusable = true}, SHIFT(1294),
  [4379] = {.count = 1, .reusable = true}, SHIFT(1298),
  [4381] = {.count = 1, .reusable = false}, SHIFT(1813),
  [4383] = {.count = 1, .reusable = false}, SHIFT(1814),
  [4385] = {.count = 1, .reusable = false}, SHIFT(1815),
  [4387] = {.count = 1, .reusable = false}, SHIFT(1816),
  [4389] = {.count = 1, .reusable = false}, SHIFT(1817),
  [4391] = {.count = 1, .reusable = true}, SHIFT(1302),
  [4393] = {.count = 1, .reusable = true}, SHIFT(1303),
  [4395] = {.count = 1, .reusable = false}, SHIFT(1822),
  [4397] = {.count = 1, .reusable = true}, SHIFT(1305),
  [4399] = {.count = 1, .reusable = true}, SHIFT(1822),
  [4401] = {.count = 1, .reusable = true}, SHIFT(1827),
  [4403] = {.count = 1, .reusable = false}, SHIFT(1310),
  [4405] = {.count = 1, .reusable = true}, SHIFT(1311),
  [4407] = {.count = 1, .reusable = true}, SHIFT(1315),
  [4409] = {.count = 1, .reusable = true}, SHIFT(2228),
  [4411] = {.count = 1, .reusable = true}, SHIFT(2181),
  [4413] = {.count = 1, .reusable = true}, SHIFT(2399),
  [4415] = {.count = 1, .reusable = true}, SHIFT(1322),
  [4417] = {.count = 1, .reusable = true}, SHIFT(1323),
  [4419] = {.count = 1, .reusable = true}, SHIFT(1325),
  [4421] = {.count = 1, .reusable = true}, SHIFT(1838),
  [4423] = {.count = 1, .reusable = true}, SHIFT(1326),
  [4425] = {.count = 1, .reusable = true}, SHIFT(1327),
  [4427] = {.count = 1, .reusable = true}, SHIFT(1328),
  [4429] = {.count = 1, .reusable = true}, SHIFT(1329),
  [4431] = {.count = 1, .reusable = true}, SHIFT(1330),
  [4433] = {.count = 1, .reusable = true}, SHIFT(2277),
  [4435] = {.count = 1, .reusable = true}, SHIFT(1335),
  [4437] = {.count = 1, .reusable = true}, SHIFT(1337),
  [4439] = {.count = 1, .reusable = true}, SHIFT(1338),
  [4441] = {.count = 1, .reusable = true}, SHIFT(1339),
  [4443] = {.count = 1, .reusable = true}, SHIFT(1345),
  [4445] = {.count = 1, .reusable = true}, SHIFT(1853),
  [4447] = {.count = 1, .reusable = true}, SHIFT(1350),
  [4449] = {.count = 1, .reusable = false}, SHIFT(1351),
  [4451] = {.count = 1, .reusable = true}, SHIFT(1354),
  [4453] = {.count = 1, .reusable = true}, SHIFT(1357),
  [4455] = {.count = 1, .reusable = true}, SHIFT(2250),
  [4457] = {.count = 1, .reusable = true}, SHIFT(2230),
  [4459] = {.count = 1, .reusable = true}, SHIFT(2231),
  [4461] = {.count = 1, .reusable = true}, SHIFT(2417),
  [4463] = {.count = 1, .reusable = true}, SHIFT(2586),
  [4465] = {.count = 1, .reusable = true}, SHIFT(2232),
  [4467] = {.count = 1, .reusable = true}, SHIFT(1762),
  [4469] = {.count = 1, .reusable = true}, SHIFT(2464),
  [4471] = {.count = 1, .reusable = false}, SHIFT(2056),
  [4473] = {.count = 1, .reusable = true}, SHIFT(1378),
  [4475] = {.count = 1, .reusable = true}, SHIFT(1379),
  [4477] = {.count = 1, .reusable = true}, SHIFT(1380),
  [4479] = {.count = 1, .reusable = true}, SHIFT(1382),
  [4481] = {.count = 1, .reusable = true}, SHIFT(1384),
  [4483] = {.count = 1, .reusable = true}, SHIFT(1385),
  [4485] = {.count = 1, .reusable = true}, SHIFT(1388),
  [4487] = {.count = 1, .reusable = true}, SHIFT(1389),
  [4489] = {.count = 1, .reusable = true}, SHIFT(1390),
  [4491] = {.count = 1, .reusable = true}, SHIFT(1391),
  [4493] = {.count = 1, .reusable = true}, SHIFT(1393),
  [4495] = {.count = 1, .reusable = true}, SHIFT(1887),
  [4497] = {.count = 1, .reusable = true}, SHIFT(1394),
  [4499] = {.count = 1, .reusable = true}, SHIFT(1400),
  [4501] = {.count = 1, .reusable = true}, SHIFT(1401),
  [4503] = {.count = 1, .reusable = true}, SHIFT(1894),
  [4505] = {.count = 1, .reusable = true}, SHIFT(1405),
  [4507] = {.count = 1, .reusable = true}, SHIFT(1406),
  [4509] = {.count = 1, .reusable = true}, SHIFT(1407),
  [4511] = {.count = 1, .reusable = false}, SHIFT(1498),
  [4513] = {.count = 1, .reusable = false}, SHIFT(1499),
  [4515] = {.count = 1, .reusable = false}, SHIFT(1500),
  [4517] = {.count = 1, .reusable = false}, SHIFT(1408),
  [4519] = {.count = 1, .reusable = false}, SHIFT(1409),
  [4521] = {.count = 1, .reusable = true}, SHIFT(1410),
  [4523] = {.count = 1, .reusable = false}, SHIFT(1411),
  [4525] = {.count = 1, .reusable = true}, SHIFT(1412),
  [4527] = {.count = 1, .reusable = true}, SHIFT(1415),
  [4529] = {.count = 1, .reusable = true}, SHIFT(1900),
  [4531] = {.count = 1, .reusable = true}, SHIFT(1416),
  [4533] = {.count = 1, .reusable = true}, SHIFT(1418),
  [4535] = {.count = 1, .reusable = true}, SHIFT(1424),
  [4537] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(1804),
  [4540] = {.count = 1, .reusable = true}, SHIFT(1425),
  [4542] = {.count = 1, .reusable = false}, SHIFT(2009),
  [4544] = {.count = 1, .reusable = true}, SHIFT(1433),
  [4546] = {.count = 1, .reusable = true}, SHIFT(1910),
  [4548] = {.count = 1, .reusable = true}, SHIFT(1435),
  [4550] = {.count = 1, .reusable = true}, SHIFT(1437),
  [4552] = {.count = 1, .reusable = true}, SHIFT(1438),
  [4554] = {.count = 1, .reusable = true}, SHIFT(1439),
  [4556] = {.count = 1, .reusable = true}, SHIFT(1441),
  [4558] = {.count = 1, .reusable = true}, SHIFT(1443),
  [4560] = {.count = 1, .reusable = true}, SHIFT(1878),
  [4562] = {.count = 1, .reusable = true}, SHIFT(1445),
  [4564] = {.count = 1, .reusable = true}, SHIFT(1446),
  [4566] = {.count = 1, .reusable = true}, SHIFT(1916),
  [4568] = {.count = 1, .reusable = true}, SHIFT(1449),
  [4570] = {.count = 1, .reusable = true}, SHIFT(1917),
  [4572] = {.count = 1, .reusable = true}, SHIFT(1450),
  [4574] = {.count = 1, .reusable = true}, SHIFT(1452),
  [4576] = {.count = 1, .reusable = true}, SHIFT(1454),
  [4578] = {.count = 1, .reusable = true}, SHIFT(1455),
  [4580] = {.count = 1, .reusable = true}, SHIFT(1457),
  [4582] = {.count = 1, .reusable = true}, SHIFT(1459),
  [4584] = {.count = 1, .reusable = true}, SHIFT(1460),
  [4586] = {.count = 1, .reusable = true}, SHIFT(2104),
  [4588] = {.count = 1, .reusable = true}, SHIFT(1464),
  [4590] = {.count = 1, .reusable = true}, SHIFT(1922),
  [4592] = {.count = 1, .reusable = true}, SHIFT(1466),
  [4594] = {.count = 1, .reusable = true}, SHIFT(1470),
  [4596] = {.count = 1, .reusable = true}, SHIFT(1471),
  [4598] = {.count = 1, .reusable = true}, SHIFT(1931),
  [4600] = {.count = 1, .reusable = true}, SHIFT(1474),
  [4602] = {.count = 1, .reusable = true}, SHIFT(1476),
  [4604] = {.count = 1, .reusable = true}, SHIFT(1478),
  [4606] = {.count = 1, .reusable = false}, SHIFT(1954),
  [4608] = {.count = 1, .reusable = false}, SHIFT(1968),
  [4610] = {.count = 1, .reusable = true}, SHIFT(1968),
  [4612] = {.count = 1, .reusable = true}, SHIFT(2081),
  [4614] = {.count = 1, .reusable = false}, SHIFT(2082),
  [4616] = {.count = 1, .reusable = true}, SHIFT(2082),
  [4618] = {.count = 1, .reusable = false}, SHIFT(2083),
  [4620] = {.count = 1, .reusable = true}, SHIFT(2083),
  [4622] = {.count = 1, .reusable = false}, SHIFT(1972),
  [4624] = {.count = 1, .reusable = true}, SHIFT(1972),
  [4626] = {.count = 1, .reusable = false}, SHIFT(2085),
  [4628] = {.count = 1, .reusable = true}, SHIFT(2085),
  [4630] = {.count = 1, .reusable = false}, SHIFT(2011),
  [4632] = {.count = 1, .reusable = true}, SHIFT(1953),
  [4634] = {.count = 1, .reusable = false}, SHIFT(2012),
  [4636] = {.count = 1, .reusable = false}, SHIFT(2086),
  [4638] = {.count = 1, .reusable = true}, SHIFT(2086),
  [4640] = {.count = 1, .reusable = false}, SHIFT(2087),
  [4642] = {.count = 1, .reusable = true}, SHIFT(2087),
  [4644] = {.count = 1, .reusable = false}, SHIFT(2088),
  [4646] = {.count = 1, .reusable = true}, SHIFT(2088),
  [4648] = {.count = 1, .reusable = false}, SHIFT(2089),
  [4650] = {.count = 1, .reusable = true}, SHIFT(2089),
  [4652] = {.count = 1, .reusable = false}, SHIFT(2092),
  [4654] = {.count = 1, .reusable = true}, SHIFT(2092),
  [4656] = {.count = 1, .reusable = false}, SHIFT(1987),
  [4658] = {.count = 1, .reusable = true}, SHIFT(1987),
  [4660] = {.count = 1, .reusable = false}, SHIFT(1988),
  [4662] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4664] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(1966),
  [4667] = {.count = 1, .reusable = false}, SHIFT(1718),
  [4669] = {.count = 1, .reusable = false}, SHIFT(1567),
  [4671] = {.count = 1, .reusable = true}, SHIFT(1568),
  [4673] = {.count = 1, .reusable = false}, SHIFT(2415),
  [4675] = {.count = 1, .reusable = false}, SHIFT(2337),
  [4677] = {.count = 1, .reusable = true}, SHIFT(2415),
  [4679] = {.count = 1, .reusable = false}, SHIFT(2095),
  [4681] = {.count = 1, .reusable = true}, SHIFT(2095),
  [4683] = {.count = 1, .reusable = true}, SHIFT(2000),
  [4685] = {.count = 1, .reusable = false}, SHIFT(1485),
  [4687] = {.count = 1, .reusable = false}, SHIFT(2001),
  [4689] = {.count = 1, .reusable = true}, SHIFT(1486),
  [4691] = {.count = 1, .reusable = true}, SHIFT(2001),
  [4693] = {.count = 1, .reusable = true}, SHIFT(2013),
  [4695] = {.count = 1, .reusable = false}, SHIFT(2023),
  [4697] = {.count = 1, .reusable = false}, SHIFT(2024),
  [4699] = {.count = 1, .reusable = false}, SHIFT(2025),
  [4701] = {.count = 1, .reusable = false}, SHIFT(2026),
  [4703] = {.count = 1, .reusable = false}, SHIFT(2027),
  [4705] = {.count = 1, .reusable = true}, SHIFT(1501),
  [4707] = {.count = 1, .reusable = false}, SHIFT(2028),
  [4709] = {.count = 1, .reusable = true}, SHIFT(1503),
  [4711] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4713] = {.count = 1, .reusable = false}, SHIFT(1505),
  [4715] = {.count = 1, .reusable = true}, SHIFT(1506),
  [4717] = {.count = 1, .reusable = true}, SHIFT(1508),
  [4719] = {.count = 1, .reusable = true}, SHIFT(1510),
  [4721] = {.count = 1, .reusable = true}, SHIFT(1511),
  [4723] = {.count = 1, .reusable = true}, SHIFT(1512),
  [4725] = {.count = 1, .reusable = true}, SHIFT(1974),
  [4727] = {.count = 1, .reusable = true}, SHIFT(1975),
  [4729] = {.count = 1, .reusable = true}, SHIFT(1513),
  [4731] = {.count = 1, .reusable = true}, SHIFT(1520),
  [4733] = {.count = 1, .reusable = true}, SHIFT(1521),
  [4735] = {.count = 1, .reusable = true}, SHIFT(1522),
  [4737] = {.count = 1, .reusable = true}, SHIFT(1526),
  [4739] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4741] = {.count = 1, .reusable = true}, SHIFT(1531),
  [4743] = {.count = 1, .reusable = false}, SHIFT(1532),
  [4745] = {.count = 1, .reusable = true}, SHIFT(1509),
  [4747] = {.count = 1, .reusable = true}, SHIFT(1539),
  [4749] = {.count = 1, .reusable = true}, SHIFT(1540),
  [4751] = {.count = 1, .reusable = true}, SHIFT(1541),
  [4753] = {.count = 1, .reusable = true}, SHIFT(1543),
  [4755] = {.count = 1, .reusable = true}, SHIFT(1544),
  [4757] = {.count = 1, .reusable = true}, SHIFT(1545),
  [4759] = {.count = 1, .reusable = true}, SHIFT(1546),
  [4761] = {.count = 1, .reusable = true}, SHIFT(1547),
  [4763] = {.count = 1, .reusable = true}, SHIFT(1549),
  [4765] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4767] = {.count = 1, .reusable = true}, SHIFT(1552),
  [4769] = {.count = 1, .reusable = true}, SHIFT(1553),
  [4771] = {.count = 1, .reusable = true}, SHIFT(1554),
  [4773] = {.count = 1, .reusable = true}, SHIFT(1555),
  [4775] = {.count = 1, .reusable = true}, SHIFT(1556),
  [4777] = {.count = 1, .reusable = true}, SHIFT(1559),
  [4779] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4781] = {.count = 1, .reusable = true}, SHIFT(1560),
  [4783] = {.count = 1, .reusable = true}, SHIFT(1562),
  [4785] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4787] = {.count = 1, .reusable = true}, SHIFT(1570),
  [4789] = {.count = 1, .reusable = true}, SHIFT(1571),
  [4791] = {.count = 1, .reusable = true}, SHIFT(1573),
  [4793] = {.count = 1, .reusable = true}, SHIFT(1574),
  [4795] = {.count = 1, .reusable = true}, SHIFT(1576),
  [4797] = {.count = 1, .reusable = true}, SHIFT(2074),
  [4799] = {.count = 1, .reusable = true}, SHIFT(1577),
  [4801] = {.count = 1, .reusable = true}, SHIFT(1578),
  [4803] = {.count = 1, .reusable = true}, SHIFT(1580),
  [4805] = {.count = 1, .reusable = true}, SHIFT(1581),
  [4807] = {.count = 1, .reusable = true}, SHIFT(1583),
  [4809] = {.count = 1, .reusable = true}, SHIFT(1587),
  [4811] = {.count = 1, .reusable = true}, SHIFT(2078),
  [4813] = {.count = 1, .reusable = true}, SHIFT(1589),
  [4815] = {.count = 1, .reusable = true}, SHIFT(1591),
  [4817] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(2079),
  [4820] = {.count = 1, .reusable = false}, SHIFT(1656),
  [4822] = {.count = 1, .reusable = true}, SHIFT(1657),
  [4824] = {.count = 1, .reusable = true}, SHIFT(2099),
  [4826] = {.count = 1, .reusable = false}, SHIFT(1595),
  [4828] = {.count = 1, .reusable = false}, SHIFT(1764),
  [4830] = {.count = 1, .reusable = false}, SHIFT(1765),
  [4832] = {.count = 1, .reusable = false}, SHIFT(1766),
  [4834] = {.count = 1, .reusable = false}, SHIFT(1767),
  [4836] = {.count = 1, .reusable = false}, SHIFT(1768),
  [4838] = {.count = 1, .reusable = true}, SHIFT(1487),
  [4840] = {.count = 1, .reusable = false}, SHIFT(1769),
  [4842] = {.count = 1, .reusable = false}, SHIFT(1770),
  [4844] = {.count = 1, .reusable = false}, SHIFT(1771),
  [4846] = {.count = 1, .reusable = false}, SHIFT(1772),
  [4848] = {.count = 1, .reusable = false}, SHIFT(1773),
  [4850] = {.count = 1, .reusable = false}, SHIFT(1774),
  [4852] = {.count = 1, .reusable = false}, SHIFT(1775),
  [4854] = {.count = 1, .reusable = true}, SHIFT(2103),
  [4856] = {.count = 1, .reusable = false}, SHIFT(1607),
  [4858] = {.count = 1, .reusable = true}, SHIFT(1609),
  [4860] = {.count = 1, .reusable = true}, SHIFT(1610),
  [4862] = {.count = 1, .reusable = true}, SHIFT(1611),
  [4864] = {.count = 1, .reusable = true}, SHIFT(2431),
  [4866] = {.count = 1, .reusable = true}, SHIFT(1616),
  [4868] = {.count = 1, .reusable = true}, SHIFT(1618),
  [4870] = {.count = 1, .reusable = true}, SHIFT(1619),
  [4872] = {.count = 1, .reusable = true}, SHIFT(1620),
  [4874] = {.count = 1, .reusable = true}, SHIFT(1624),
  [4876] = {.count = 1, .reusable = true}, SHIFT(2123),
  [4878] = {.count = 1, .reusable = true}, SHIFT(1629),
  [4880] = {.count = 1, .reusable = true}, SHIFT(1635),
  [4882] = {.count = 1, .reusable = true}, SHIFT(1637),
  [4884] = {.count = 1, .reusable = true}, SHIFT(1639),
  [4886] = {.count = 1, .reusable = true}, SHIFT(2135),
  [4888] = {.count = 1, .reusable = true}, SHIFT(1642),
  [4890] = {.count = 1, .reusable = true}, SHIFT(1643),
  [4892] = {.count = 1, .reusable = true}, SHIFT(1644),
  [4894] = {.count = 1, .reusable = true}, SHIFT(1645),
  [4896] = {.count = 1, .reusable = true}, SHIFT(1646),
  [4898] = {.count = 1, .reusable = true}, SHIFT(1649),
  [4900] = {.count = 1, .reusable = true}, SHIFT(2139),
  [4902] = {.count = 1, .reusable = true}, SHIFT(1650),
  [4904] = {.count = 1, .reusable = true}, SHIFT(1652),
  [4906] = {.count = 1, .reusable = true}, SHIFT(1659),
  [4908] = {.count = 1, .reusable = true}, SHIFT(1662),
  [4910] = {.count = 1, .reusable = true}, SHIFT(2144),
  [4912] = {.count = 1, .reusable = true}, SHIFT(1663),
  [4914] = {.count = 1, .reusable = true}, SHIFT(1664),
  [4916] = {.count = 1, .reusable = true}, SHIFT(1666),
  [4918] = {.count = 1, .reusable = true}, SHIFT(1667),
  [4920] = {.count = 1, .reusable = true}, SHIFT(1669),
  [4922] = {.count = 1, .reusable = true}, SHIFT(1672),
  [4924] = {.count = 1, .reusable = true}, SHIFT(2148),
  [4926] = {.count = 1, .reusable = true}, SHIFT(1674),
  [4928] = {.count = 1, .reusable = true}, SHIFT(1676),
  [4930] = {.count = 1, .reusable = false}, SHIFT(1990),
  [4932] = {.count = 1, .reusable = false}, SHIFT(2414),
  [4934] = {.count = 1, .reusable = true}, SHIFT(2153),
  [4936] = {.count = 1, .reusable = false}, SHIFT(1677),
  [4938] = {.count = 1, .reusable = true}, SHIFT(2155),
  [4940] = {.count = 1, .reusable = false}, SHIFT(1680),
  [4942] = {.count = 1, .reusable = true}, SHIFT(1681),
  [4944] = {.count = 1, .reusable = true}, SHIFT(1682),
  [4946] = {.count = 1, .reusable = true}, SHIFT(1689),
  [4948] = {.count = 1, .reusable = true}, SHIFT(1694),
  [4950] = {.count = 1, .reusable = true}, SHIFT(1695),
  [4952] = {.count = 1, .reusable = true}, SHIFT(1698),
  [4954] = {.count = 1, .reusable = true}, SHIFT(1699),
  [4956] = {.count = 1, .reusable = true}, SHIFT(1700),
  [4958] = {.count = 1, .reusable = true}, SHIFT(1421),
  [4960] = {.count = 1, .reusable = true}, SHIFT(1706),
  [4962] = {.count = 1, .reusable = true}, SHIFT(1447),
  [4964] = {.count = 1, .reusable = true}, SHIFT(1708),
  [4966] = {.count = 1, .reusable = true}, SHIFT(1711),
  [4968] = {.count = 1, .reusable = false}, SHIFT(1704),
  [4970] = {.count = 1, .reusable = true}, SHIFT(1705),
  [4972] = {.count = 1, .reusable = true}, SHIFT(1719),
  [4974] = {.count = 1, .reusable = true}, SHIFT(1720),
  [4976] = {.count = 1, .reusable = true}, SHIFT(1727),
  [4978] = {.count = 1, .reusable = true}, SHIFT(1728),
  [4980] = {.count = 1, .reusable = true}, SHIFT(1731),
  [4982] = {.count = 1, .reusable = true}, SHIFT(1732),
  [4984] = {.count = 1, .reusable = true}, SHIFT(1742),
  [4986] = {.count = 1, .reusable = false}, SHIFT(2218),
  [4988] = {.count = 1, .reusable = true}, SHIFT(1750),
  [4990] = {.count = 1, .reusable = true}, SHIFT(1751),
  [4992] = {.count = 1, .reusable = false}, SHIFT(1757),
  [4994] = {.count = 1, .reusable = true}, SHIFT(2229),
  [4996] = {.count = 1, .reusable = true}, SHIFT(2009),
  [4998] = {.count = 1, .reusable = false}, SHIFT(1797),
  [5000] = {.count = 1, .reusable = true}, SHIFT(2242),
  [5002] = {.count = 1, .reusable = true}, SHIFT(2426),
  [5004] = {.count = 1, .reusable = true}, SHIFT(1805),
  [5006] = {.count = 1, .reusable = false}, SHIFT(1807),
  [5008] = {.count = 1, .reusable = true}, SHIFT(1807),
  [5010] = {.count = 1, .reusable = true}, SHIFT(1808),
  [5012] = {.count = 1, .reusable = false}, SHIFT(1809),
  [5014] = {.count = 1, .reusable = true}, SHIFT(1809),
  [5016] = {.count = 1, .reusable = false}, SHIFT(1810),
  [5018] = {.count = 1, .reusable = true}, SHIFT(1810),
  [5020] = {.count = 1, .reusable = false}, SHIFT(1811),
  [5022] = {.count = 1, .reusable = true}, SHIFT(1811),
  [5024] = {.count = 1, .reusable = false}, SHIFT(1812),
  [5026] = {.count = 1, .reusable = true}, SHIFT(1812),
  [5028] = {.count = 1, .reusable = true}, SHIFT(1999),
  [5030] = {.count = 1, .reusable = false}, SHIFT(302),
  [5032] = {.count = 1, .reusable = false}, SHIFT(2467),
  [5034] = {.count = 1, .reusable = false}, SHIFT(2468),
  [5036] = {.count = 1, .reusable = true}, SHIFT(2262),
  [5038] = {.count = 1, .reusable = true}, SHIFT(2395),
  [5040] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(1804),
  [5043] = {.count = 1, .reusable = true}, SHIFT(1806),
  [5045] = {.count = 1, .reusable = true}, SHIFT(1818),
  [5047] = {.count = 1, .reusable = false}, SHIFT(1820),
  [5049] = {.count = 1, .reusable = true}, SHIFT(1820),
  [5051] = {.count = 1, .reusable = true}, SHIFT(1828),
  [5053] = {.count = 1, .reusable = true}, SHIFT(2266),
  [5055] = {.count = 1, .reusable = true}, SHIFT(2004),
  [5057] = {.count = 1, .reusable = true}, SHIFT(2269),
  [5059] = {.count = 1, .reusable = true}, SHIFT(2273),
  [5061] = {.count = 1, .reusable = true}, SHIFT(1848),
  [5063] = {.count = 1, .reusable = true}, SHIFT(2280),
  [5065] = {.count = 1, .reusable = false}, SHIFT(1860),
  [5067] = {.count = 1, .reusable = true}, SHIFT(1860),
  [5069] = {.count = 1, .reusable = false}, SHIFT(1861),
  [5071] = {.count = 1, .reusable = true}, SHIFT(1861),
  [5073] = {.count = 1, .reusable = false}, SHIFT(1862),
  [5075] = {.count = 1, .reusable = true}, SHIFT(1862),
  [5077] = {.count = 1, .reusable = false}, SHIFT(1863),
  [5079] = {.count = 1, .reusable = true}, SHIFT(1863),
  [5081] = {.count = 1, .reusable = false}, SHIFT(1864),
  [5083] = {.count = 1, .reusable = true}, SHIFT(1864),
  [5085] = {.count = 1, .reusable = false}, SHIFT(1865),
  [5087] = {.count = 1, .reusable = true}, SHIFT(1865),
  [5089] = {.count = 1, .reusable = false}, SHIFT(1868),
  [5091] = {.count = 1, .reusable = true}, SHIFT(1868),
  [5093] = {.count = 1, .reusable = false}, SHIFT(1869),
  [5095] = {.count = 1, .reusable = true}, SHIFT(2287),
  [5097] = {.count = 1, .reusable = true}, SHIFT(1874),
  [5099] = {.count = 1, .reusable = true}, SHIFT(1884),
  [5101] = {.count = 1, .reusable = true}, SHIFT(1885),
  [5103] = {.count = 1, .reusable = true}, SHIFT(1859),
  [5105] = {.count = 1, .reusable = true}, SHIFT(2056),
  [5107] = {.count = 1, .reusable = false}, SHIFT(1889),
  [5109] = {.count = 1, .reusable = true}, SHIFT(1889),
  [5111] = {.count = 1, .reusable = false}, SHIFT(1890),
  [5113] = {.count = 1, .reusable = true}, SHIFT(1890),
  [5115] = {.count = 1, .reusable = true}, SHIFT(1904),
  [5117] = {.count = 1, .reusable = false}, SHIFT(2295),
  [5119] = {.count = 1, .reusable = false}, SHIFT(2215),
  [5121] = {.count = 1, .reusable = false}, SHIFT(2245),
  [5123] = {.count = 1, .reusable = false}, SHIFT(2246),
  [5125] = {.count = 1, .reusable = false}, SHIFT(2247),
  [5127] = {.count = 1, .reusable = false}, SHIFT(2249),
  [5129] = {.count = 1, .reusable = false}, SHIFT(2248),
  [5131] = {.count = 1, .reusable = false}, SHIFT(1906),
  [5133] = {.count = 1, .reusable = true}, SHIFT(1906),
  [5135] = {.count = 1, .reusable = false}, SHIFT(2300),
  [5137] = {.count = 1, .reusable = true}, SHIFT(1914),
  [5139] = {.count = 1, .reusable = true}, SHIFT(2300),
  [5141] = {.count = 1, .reusable = true}, SHIFT(2308),
  [5143] = {.count = 1, .reusable = false}, SHIFT(1919),
  [5145] = {.count = 1, .reusable = true}, SHIFT(1919),
  [5147] = {.count = 1, .reusable = true}, SHIFT(2183),
  [5149] = {.count = 1, .reusable = true}, SHIFT(1923),
  [5151] = {.count = 1, .reusable = true}, SHIFT(1924),
  [5153] = {.count = 1, .reusable = true}, SHIFT(1925),
  [5155] = {.count = 1, .reusable = true}, SHIFT(1926),
  [5157] = {.count = 1, .reusable = true}, SHIFT(1927),
  [5159] = {.count = 1, .reusable = true}, SHIFT(1928),
  [5161] = {.count = 1, .reusable = true}, SHIFT(1929),
  [5163] = {.count = 1, .reusable = true}, SHIFT(2319),
  [5165] = {.count = 1, .reusable = true}, SHIFT(1932),
  [5167] = {.count = 1, .reusable = true}, SHIFT(1933),
  [5169] = {.count = 1, .reusable = true}, SHIFT(1934),
  [5171] = {.count = 1, .reusable = true}, SHIFT(1935),
  [5173] = {.count = 1, .reusable = true}, SHIFT(1936),
  [5175] = {.count = 1, .reusable = true}, SHIFT(1937),
  [5177] = {.count = 1, .reusable = true}, SHIFT(2324),
  [5179] = {.count = 1, .reusable = true}, SHIFT(1939),
  [5181] = {.count = 1, .reusable = true}, SHIFT(1940),
  [5183] = {.count = 1, .reusable = true}, SHIFT(1941),
  [5185] = {.count = 1, .reusable = true}, SHIFT(2326),
  [5187] = {.count = 1, .reusable = true}, SHIFT(2328),
  [5189] = {.count = 1, .reusable = true}, SHIFT(2414),
  [5191] = {.count = 1, .reusable = false}, SHIFT(1956),
  [5193] = {.count = 1, .reusable = true}, SHIFT(1956),
  [5195] = {.count = 1, .reusable = false}, SHIFT(1957),
  [5197] = {.count = 1, .reusable = true}, SHIFT(1957),
  [5199] = {.count = 1, .reusable = false}, SHIFT(2416),
  [5201] = {.count = 1, .reusable = true}, SHIFT(2416),
  [5203] = {.count = 1, .reusable = false}, SHIFT(2080),
  [5205] = {.count = 1, .reusable = true}, SHIFT(2080),
  [5207] = {.count = 1, .reusable = true}, SHIFT(1969),
  [5209] = {.count = 1, .reusable = false}, SHIFT(1970),
  [5211] = {.count = 1, .reusable = true}, SHIFT(1970),
  [5213] = {.count = 1, .reusable = false}, SHIFT(1971),
  [5215] = {.count = 1, .reusable = true}, SHIFT(1971),
  [5217] = {.count = 1, .reusable = false}, SHIFT(2084),
  [5219] = {.count = 1, .reusable = true}, SHIFT(2084),
  [5221] = {.count = 1, .reusable = false}, SHIFT(1973),
  [5223] = {.count = 1, .reusable = true}, SHIFT(1973),
  [5225] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(1966),
  [5228] = {.count = 1, .reusable = false}, SHIFT(1976),
  [5230] = {.count = 1, .reusable = true}, SHIFT(1976),
  [5232] = {.count = 1, .reusable = false}, SHIFT(1977),
  [5234] = {.count = 1, .reusable = true}, SHIFT(1977),
  [5236] = {.count = 1, .reusable = false}, SHIFT(1978),
  [5238] = {.count = 1, .reusable = true}, SHIFT(1978),
  [5240] = {.count = 1, .reusable = false}, SHIFT(1979),
  [5242] = {.count = 1, .reusable = true}, SHIFT(1979),
  [5244] = {.count = 1, .reusable = false}, SHIFT(1986),
  [5246] = {.count = 1, .reusable = true}, SHIFT(1986),
  [5248] = {.count = 1, .reusable = false}, SHIFT(2093),
  [5250] = {.count = 1, .reusable = true}, SHIFT(2093),
  [5252] = {.count = 1, .reusable = false}, SHIFT(2094),
  [5254] = {.count = 1, .reusable = true}, SHIFT(2094),
  [5256] = {.count = 1, .reusable = false}, SHIFT(2371),
  [5258] = {.count = 1, .reusable = false}, SHIFT(2349),
  [5260] = {.count = 1, .reusable = false}, SHIFT(2354),
  [5262] = {.count = 1, .reusable = false}, SHIFT(2355),
  [5264] = {.count = 1, .reusable = false}, SHIFT(2356),
  [5266] = {.count = 1, .reusable = false}, SHIFT(2358),
  [5268] = {.count = 1, .reusable = false}, SHIFT(2357),
  [5270] = {.count = 1, .reusable = true}, SHIFT(2309),
  [5272] = {.count = 1, .reusable = false}, SHIFT(1991),
  [5274] = {.count = 1, .reusable = true}, SHIFT(1991),
  [5276] = {.count = 1, .reusable = true}, SHIFT(2146),
  [5278] = {.count = 1, .reusable = true}, SHIFT(2320),
  [5280] = {.count = 1, .reusable = true}, SHIFT(2325),
  [5282] = {.count = 1, .reusable = true}, SHIFT(2364),
  [5284] = {.count = 1, .reusable = true}, SHIFT(2365),
  [5286] = {.count = 1, .reusable = true}, SHIFT(2370),
  [5288] = {.count = 1, .reusable = false}, SHIFT(2377),
  [5290] = {.count = 1, .reusable = false}, SHIFT(2021),
  [5292] = {.count = 1, .reusable = true}, SHIFT(2394),
  [5294] = {.count = 1, .reusable = true}, SHIFT(2400),
  [5296] = {.count = 1, .reusable = true}, SHIFT(2406),
  [5298] = {.count = 1, .reusable = false}, SHIFT(2382),
  [5300] = {.count = 1, .reusable = true}, SHIFT(2382),
  [5302] = {.count = 1, .reusable = true}, SHIFT(2060),
  [5304] = {.count = 1, .reusable = true}, SHIFT(2169),
  [5306] = {.count = 1, .reusable = true}, SHIFT(2413),
  [5308] = {.count = 1, .reusable = false}, SHIFT(2535),
  [5310] = {.count = 1, .reusable = false}, SHIFT(2581),
  [5312] = {.count = 1, .reusable = false}, SHIFT(2576),
  [5314] = {.count = 1, .reusable = false}, SHIFT(2409),
  [5316] = {.count = 1, .reusable = false}, SHIFT(2407),
  [5318] = {.count = 1, .reusable = false}, SHIFT(2408),
  [5320] = {.count = 1, .reusable = false}, SHIFT(2536),
  [5322] = {.count = 1, .reusable = true}, SHIFT(2410),
  [5324] = {.count = 1, .reusable = true}, SHIFT(2581),
  [5326] = {.count = 1, .reusable = false}, SHIFT(2411),
  [5328] = {.count = 1, .reusable = false}, SHIFT(2527),
  [5330] = {.count = 1, .reusable = false}, SHIFT(2577),
  [5332] = {.count = 1, .reusable = false}, SHIFT(2412),
  [5334] = {.count = 1, .reusable = true}, SHIFT(2534),
  [5336] = {.count = 1, .reusable = false}, SHIFT(2532),
  [5338] = {.count = 1, .reusable = false}, SHIFT(2582),
  [5340] = {.count = 1, .reusable = false}, SHIFT(2413),
  [5342] = {.count = 1, .reusable = false}, SHIFT(1746),
  [5344] = {.count = 1, .reusable = true}, SHIFT(2533),
  [5346] = {.count = 1, .reusable = true}, SHIFT(2582),
  [5348] = {.count = 1, .reusable = false}, SHIFT(2537),
  [5350] = {.count = 1, .reusable = true}, SHIFT(2537),
  [5352] = {.count = 1, .reusable = false}, SHIFT(2538),
  [5354] = {.count = 1, .reusable = true}, SHIFT(2538),
  [5356] = {.count = 1, .reusable = false}, SHIFT(2583),
  [5358] = {.count = 1, .reusable = true}, SHIFT(2583),
  [5360] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(2079),
  [5363] = {.count = 1, .reusable = true}, SHIFT(2425),
  [5365] = {.count = 1, .reusable = true}, SHIFT(2439),
  [5367] = {.count = 1, .reusable = true}, SHIFT(2428),
  [5369] = {.count = 1, .reusable = true}, SHIFT(2434),
  [5371] = {.count = 1, .reusable = false}, SHIFT(2054),
  [5373] = {.count = 1, .reusable = true}, SHIFT(2054),
  [5375] = {.count = 1, .reusable = true}, SHIFT(2163),
  [5377] = {.count = 1, .reusable = true}, SHIFT(2442),
  [5379] = {.count = 1, .reusable = false}, SHIFT(2211),
  [5381] = {.count = 1, .reusable = true}, SHIFT(2215),
  [5383] = {.count = 1, .reusable = false}, SHIFT(2222),
  [5385] = {.count = 1, .reusable = true}, SHIFT(2222),
  [5387] = {.count = 1, .reusable = true}, SHIFT(2223),
  [5389] = {.count = 1, .reusable = false}, SHIFT(2226),
  [5391] = {.count = 1, .reusable = true}, SHIFT(2226),
  [5393] = {.count = 1, .reusable = false}, SHIFT(2227),
  [5395] = {.count = 1, .reusable = true}, SHIFT(2227),
  [5397] = {.count = 1, .reusable = false}, SHIFT(2388),
  [5399] = {.count = 1, .reusable = true}, SHIFT(2438),
  [5401] = {.count = 1, .reusable = true}, SHIFT(2470),
  [5403] = {.count = 1, .reusable = true}, SHIFT(2264),
  [5405] = {.count = 1, .reusable = true}, SHIFT(2265),
  [5407] = {.count = 1, .reusable = false}, SHIFT(2592),
  [5409] = {.count = 1, .reusable = false}, SHIFT(2593),
  [5411] = {.count = 1, .reusable = true}, SHIFT(2593),
  [5413] = {.count = 1, .reusable = true}, SHIFT(2419),
  [5415] = {.count = 1, .reusable = true}, SHIFT(2462),
  [5417] = {.count = 1, .reusable = true}, SHIFT(2267),
  [5419] = {.count = 1, .reusable = true}, SHIFT(2271),
  [5421] = {.count = 1, .reusable = true}, SHIFT(2272),
  [5423] = {.count = 1, .reusable = true}, SHIFT(2440),
  [5425] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5427] = {.count = 1, .reusable = true}, SHIFT(2282),
  [5429] = {.count = 1, .reusable = false}, REDUCE(aux_sym_export_statement_repeat1, 2),
  [5431] = {.count = 2, .reusable = true}, REDUCE(aux_sym_export_statement_repeat1, 2), SHIFT_REPEAT(2444),
  [5434] = {.count = 1, .reusable = true}, SHIFT(2290),
  [5436] = {.count = 1, .reusable = true}, SHIFT(2294),
  [5438] = {.count = 1, .reusable = false}, SHIFT(2297),
  [5440] = {.count = 1, .reusable = true}, SHIFT(2297),
  [5442] = {.count = 1, .reusable = false}, SHIFT(2299),
  [5444] = {.count = 1, .reusable = true}, SHIFT(2299),
  [5446] = {.count = 1, .reusable = false}, SHIFT(2302),
  [5448] = {.count = 1, .reusable = true}, SHIFT(2302),
  [5450] = {.count = 1, .reusable = false}, SHIFT(2303),
  [5452] = {.count = 1, .reusable = true}, SHIFT(2303),
  [5454] = {.count = 1, .reusable = false}, SHIFT(2305),
  [5456] = {.count = 1, .reusable = true}, SHIFT(2305),
  [5458] = {.count = 1, .reusable = false}, SHIFT(2306),
  [5460] = {.count = 1, .reusable = true}, SHIFT(2306),
  [5462] = {.count = 1, .reusable = false}, SHIFT(2604),
  [5464] = {.count = 1, .reusable = true}, SHIFT(2604),
  [5466] = {.count = 1, .reusable = true}, SHIFT(2484),
  [5468] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 3),
  [5470] = {.count = 1, .reusable = false}, SHIFT(2372),
  [5472] = {.count = 1, .reusable = false}, SHIFT(2310),
  [5474] = {.count = 1, .reusable = true}, SHIFT(2310),
  [5476] = {.count = 1, .reusable = false}, SHIFT(2311),
  [5478] = {.count = 1, .reusable = true}, SHIFT(2311),
  [5480] = {.count = 1, .reusable = false}, SHIFT(2312),
  [5482] = {.count = 1, .reusable = true}, SHIFT(2312),
  [5484] = {.count = 1, .reusable = false}, SHIFT(2313),
  [5486] = {.count = 1, .reusable = true}, SHIFT(2313),
  [5488] = {.count = 1, .reusable = false}, SHIFT(2315),
  [5490] = {.count = 1, .reusable = true}, SHIFT(2315),
  [5492] = {.count = 1, .reusable = false}, SHIFT(2317),
  [5494] = {.count = 1, .reusable = true}, SHIFT(2317),
  [5496] = {.count = 2, .reusable = true}, REDUCE(aux_sym_extends_clause_repeat1, 2), SHIFT_REPEAT(2484),
  [5499] = {.count = 1, .reusable = false}, SHIFT(2506),
  [5501] = {.count = 1, .reusable = false}, SHIFT(2321),
  [5503] = {.count = 1, .reusable = true}, SHIFT(2321),
  [5505] = {.count = 1, .reusable = false}, SHIFT(2322),
  [5507] = {.count = 1, .reusable = true}, SHIFT(2322),
  [5509] = {.count = 1, .reusable = false}, SHIFT(2323),
  [5511] = {.count = 1, .reusable = true}, SHIFT(2323),
  [5513] = {.count = 1, .reusable = true}, SHIFT(2510),
  [5515] = {.count = 1, .reusable = false}, SHIFT(2509),
  [5517] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5519] = {.count = 1, .reusable = true}, SHIFT(2349),
  [5521] = {.count = 1, .reusable = false}, SHIFT(2351),
  [5523] = {.count = 1, .reusable = true}, SHIFT(2351),
  [5525] = {.count = 1, .reusable = false}, SHIFT(2352),
  [5527] = {.count = 1, .reusable = true}, SHIFT(2352),
  [5529] = {.count = 1, .reusable = false}, SHIFT(2353),
  [5531] = {.count = 1, .reusable = true}, SHIFT(2353),
  [5533] = {.count = 1, .reusable = false}, SHIFT(2539),
  [5535] = {.count = 1, .reusable = false}, SHIFT(2540),
  [5537] = {.count = 1, .reusable = false}, SHIFT(2605),
  [5539] = {.count = 1, .reusable = false}, SHIFT(2542),
  [5541] = {.count = 1, .reusable = false}, SHIFT(2541),
  [5543] = {.count = 1, .reusable = false}, SHIFT(2552),
  [5545] = {.count = 1, .reusable = false}, SHIFT(2553),
  [5547] = {.count = 1, .reusable = false}, SHIFT(2574),
  [5549] = {.count = 1, .reusable = false}, SHIFT(2575),
  [5551] = {.count = 1, .reusable = false}, SHIFT(2554),
  [5553] = {.count = 1, .reusable = false}, SHIFT(2564),
  [5555] = {.count = 1, .reusable = false}, SHIFT(2525),
  [5557] = {.count = 1, .reusable = false}, SHIFT(2548),
  [5559] = {.count = 1, .reusable = true}, SHIFT(2548),
  [5561] = {.count = 1, .reusable = true}, SHIFT(2564),
  [5563] = {.count = 1, .reusable = false}, SHIFT(2565),
  [5565] = {.count = 1, .reusable = true}, SHIFT(2565),
  [5567] = {.count = 1, .reusable = false}, SHIFT(2566),
  [5569] = {.count = 1, .reusable = true}, SHIFT(2566),
  [5571] = {.count = 1, .reusable = false}, SHIFT(2549),
  [5573] = {.count = 1, .reusable = true}, SHIFT(2549),
  [5575] = {.count = 1, .reusable = false}, SHIFT(2567),
  [5577] = {.count = 1, .reusable = true}, SHIFT(2567),
  [5579] = {.count = 1, .reusable = true}, SHIFT(2531),
  [5581] = {.count = 1, .reusable = true}, SHIFT(2529),
  [5583] = {.count = 1, .reusable = false}, SHIFT(2530),
  [5585] = {.count = 1, .reusable = false}, SHIFT(2560),
  [5587] = {.count = 1, .reusable = false}, SHIFT(2561),
  [5589] = {.count = 1, .reusable = true}, SHIFT(2530),
  [5591] = {.count = 1, .reusable = false}, SHIFT(2543),
  [5593] = {.count = 1, .reusable = true}, SHIFT(2544),
  [5595] = {.count = 1, .reusable = false}, SHIFT(2544),
  [5597] = {.count = 1, .reusable = false}, REDUCE(sym_yield_expression, 2),
  [5599] = {.count = 1, .reusable = true}, SHIFT(2546),
  [5601] = {.count = 1, .reusable = false}, SHIFT(2545),
  [5603] = {.count = 1, .reusable = false}, SHIFT(2546),
  [5605] = {.count = 1, .reusable = true}, SHIFT(2584),
  [5607] = {.count = 1, .reusable = true}, SHIFT(2543),
  [5609] = {.count = 1, .reusable = false}, SHIFT(2563),
  [5611] = {.count = 1, .reusable = true}, SHIFT(2547),
  [5613] = {.count = 1, .reusable = false}, REDUCE(sym_await_expression, 2),
  [5615] = {.count = 1, .reusable = false}, SHIFT(2568),
  [5617] = {.count = 1, .reusable = true}, SHIFT(2568),
  [5619] = {.count = 1, .reusable = false}, SHIFT(2569),
  [5621] = {.count = 1, .reusable = true}, SHIFT(2569),
  [5623] = {.count = 1, .reusable = false}, SHIFT(2570),
  [5625] = {.count = 1, .reusable = true}, SHIFT(2570),
  [5627] = {.count = 1, .reusable = false}, SHIFT(2571),
  [5629] = {.count = 1, .reusable = true}, SHIFT(2571),
  [5631] = {.count = 1, .reusable = false}, SHIFT(2572),
  [5633] = {.count = 1, .reusable = true}, SHIFT(2572),
  [5635] = {.count = 1, .reusable = false}, SHIFT(2555),
  [5637] = {.count = 1, .reusable = true}, SHIFT(2555),
  [5639] = {.count = 1, .reusable = false}, SHIFT(2556),
  [5641] = {.count = 1, .reusable = true}, SHIFT(2556),
  [5643] = {.count = 1, .reusable = false}, SHIFT(2526),
  [5645] = {.count = 1, .reusable = false}, SHIFT(2573),
  [5647] = {.count = 1, .reusable = true}, SHIFT(2573),
  [5649] = {.count = 1, .reusable = true}, SHIFT(2550),
  [5651] = {.count = 1, .reusable = true}, SHIFT(2551),
  [5653] = {.count = 1, .reusable = true}, SHIFT(2557),
  [5655] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3),
  [5657] = {.count = 1, .reusable = false}, REDUCE(sym__initializer, 2),
  [5659] = {.count = 1, .reusable = false}, REDUCE(sym_augmented_assignment_expression, 3, .production_id = 1),
  [5661] = {.count = 2, .reusable = false}, REDUCE(sym_binary_expression, 3), SHIFT(2563),
  [5664] = {.count = 1, .reusable = false}, REDUCE(sym_ternary_expression, 5),
  [5666] = {.count = 1, .reusable = false}, SHIFT(2558),
  [5668] = {.count = 2, .reusable = false}, REDUCE(sym_unary_expression, 2), SHIFT(2563),
  [5671] = {.count = 1, .reusable = false}, SHIFT(2562),
  [5673] = {.count = 1, .reusable = true}, SHIFT(2562),
  [5675] = {.count = 1, .reusable = true}, SHIFT(2469),
  [5677] = {.count = 1, .reusable = true}, SHIFT(2461),
  [5679] = {.count = 1, .reusable = false}, SHIFT(2589),
  [5681] = {.count = 1, .reusable = false}, SHIFT(2608),
  [5683] = {.count = 1, .reusable = false}, SHIFT(2609),
  [5685] = {.count = 1, .reusable = false}, SHIFT(2477),
  [5687] = {.count = 1, .reusable = true}, SHIFT(2477),
  [5689] = {.count = 1, .reusable = true}, SHIFT(2479),
  [5691] = {.count = 1, .reusable = false}, SHIFT(2478),
  [5693] = {.count = 1, .reusable = true}, SHIFT(2480),
  [5695] = {.count = 1, .reusable = false}, SHIFT(2481),
  [5697] = {.count = 1, .reusable = true}, SHIFT(2482),
  [5699] = {.count = 1, .reusable = false}, SHIFT(2483),
  [5701] = {.count = 1, .reusable = false}, REDUCE(sym__type_reference, 1, .production_id = 5),
  [5703] = {.count = 1, .reusable = false}, REDUCE(sym_extends_clause, 2),
  [5705] = {.count = 1, .reusable = true}, SHIFT(2493),
  [5707] = {.count = 1, .reusable = true}, SHIFT(2494),
  [5709] = {.count = 1, .reusable = true}, SHIFT(2495),
  [5711] = {.count = 1, .reusable = true}, SHIFT(2496),
  [5713] = {.count = 1, .reusable = true}, SHIFT(2497),
  [5715] = {.count = 1, .reusable = true}, SHIFT(2498),
  [5717] = {.count = 1, .reusable = true}, SHIFT(2503),
  [5719] = {.count = 1, .reusable = true}, SHIFT(2504),
  [5721] = {.count = 1, .reusable = true}, SHIFT(2505),
  [5723] = {.count = 1, .reusable = true}, SHIFT(2611),
  [5725] = {.count = 1, .reusable = true}, SHIFT(2587),
  [5727] = {.count = 1, .reusable = false}, SHIFT(2595),
  [5729] = {.count = 1, .reusable = false}, SHIFT(2610),
  [5731] = {.count = 1, .reusable = true}, SHIFT(2598),
  [5733] = {.count = 1, .reusable = true}, SHIFT(2601),
  [5735] = {.count = 1, .reusable = true}, SHIFT(2607),
};

void *tree_sitter_typescript_external_scanner_create(void);
void tree_sitter_typescript_external_scanner_destroy(void *);
bool tree_sitter_typescript_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_typescript_external_scanner_serialize(void *, char *);
void tree_sitter_typescript_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_typescript(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_typescript_external_scanner_create,
      tree_sitter_typescript_external_scanner_destroy,
      tree_sitter_typescript_external_scanner_scan,
      tree_sitter_typescript_external_scanner_serialize,
      tree_sitter_typescript_external_scanner_deserialize,
    },
  };
  return &language;
}
